/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var X=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/network","vs/base/common/async","electron","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/resources","vs/platform/files/common/files","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/errors","vs/base/common/strings","vs/base/common/buffer","fs","vs/base/node/pfs","vs/platform/product/common/productService","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","os","vs/base/common/uuid","vs/platform/workspaces/common/workspaces","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/base/parts/ipc/common/ipc","vs/base/common/arrays","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/node/state","vs/base/common/labels","vs/platform/request/common/request","vs/platform/update/common/update","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","child_process","vs/platform/environment/common/environment","vs/platform/configuration/common/configurationRegistry","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/node/argvHelper","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/remote/common/tunnel","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","vs/base/common/stream","crypto","net","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/environment/node/shellEnv","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/theme/electron-main/themeMainService","vs/platform/webview/common/resourceLoader","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/scanCode","vs/base/common/hash","vs/base/common/glob","vs/base/node/decoder","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/node/crypto","vs/base/node/macAddress","vs/base/node/extpath","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/mimeTypes","vs/platform/webview/common/webviewManagerService","vs/platform/webview/common/webviewPortMapping","vs/platform/webview/electron-main/webviewPortMappingProvider","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","stream","vs/code/electron-main/main"],Q=function($){for(var e=[],v=0,R=$.length;v<R;v++)e[v]=X[$[v]];return e};define(X[100],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(R,D){if(!R)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=v}),define(X[52],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function v(y){return(i,L,g)=>{let E=null,p=null;if(typeof g.value=="function"?(E="value",p=g.value):typeof g.get=="function"&&(E="get",p=g.get),!p)throw new Error("not supported");g[E]=y(p,L)}}e.createDecorator=v;let R=0;function D(){const y=`$memoize${R++}`;let i;const L=function(E,p,d){let m=null,b=null;if(typeof d.value=="function"?(m="value",b=d.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(m="get",b=d.get),!b)throw new Error("not supported");const w=`${y}:${p}`;d[m]=function(...l){return i=this,this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!0,enumerable:!1,writable:!0,value:b.apply(this,l)}),this[w]}};return L.clear=()=>{typeof i!="undefined"&&Object.getOwnPropertyNames(i).forEach(g=>{g.indexOf(y)===0&&delete i[g]})},L}e.createMemoizer=D;function S(y,i,L){return D()(y,i,L)}e.memoize=S;function k(y,i,L){return v((g,E)=>{const p=`$debounce$${E}`,d=`$debounce$result$${E}`;return function(...m){this[d]||(this[d]=L?L():void 0),clearTimeout(this[p]),i&&(this[d]=i(this[d],...m),m=[this[d]]),this[p]=setTimeout(()=>{g.apply(this,m),this[d]=L?L():void 0},y)}})}e.debounce=k;function n(y,i,L){return v((g,E)=>{const p=`$throttle$timer$${E}`,d=`$throttle$result$${E}`,m=`$throttle$lastRun$${E}`,b=`$throttle$pending$${E}`;return function(...w){if(this[d]||(this[d]=L?L():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),i&&(this[d]=i(this[d],...w)),!this[b]){const l=this[m]+y;l<=Date.now()?(this[m]=Date.now(),g.apply(this,[this[d]]),this[d]=L?L():void 0):(this[b]=!0,this[p]=setTimeout(()=>{this[b]=!1,this[m]=Date.now(),g.apply(this,[this[d]]),this[d]=L?L():void 0},l-Date.now()))}}})}e.throttle=n}),define(X[18],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function R(s){e.errorHandler.setUnexpectedErrorHandler(s)}e.setUnexpectedErrorHandler=R;function D(s){y(s)||e.errorHandler.onUnexpectedError(s)}e.onUnexpectedError=D;function S(s){y(s)||e.errorHandler.onUnexpectedExternalError(s)}e.onUnexpectedExternalError=S;function k(s){if(s instanceof Error){let{name:t,message:r}=s;const a=s.stacktrace||s.stack;return{$isError:!0,name:t,message:r,stack:a}}return s}e.transformErrorForSerialization=k;const n="Canceled";function y(s){return s instanceof Error&&s.name===n&&s.message===n}e.isPromiseCanceledError=y;class i extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=i;function L(){const s=new Error(n);return s.name=s.message,s}e.canceled=L;function g(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}e.illegalArgument=g;function E(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}e.illegalState=E;function p(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function d(s){const t=new Error(`${s} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function m(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}e.getErrorMessage=m;class b extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=b;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class l extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=l;function c(s){const t=s;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function o(s,t=Object.create(null)){const r=new Error(s);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=o}),define(X[34],Q([0,1,18]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(O,z=0){return O[O.length-(1+z)]}e.tail=R;function D(O){if(O.length===0)throw new Error("Invalid tail call");return[O.slice(0,O.length-1),O[O.length-1]]}e.tail2=D;function S(O,z,C=(I,M)=>I===M){if(O===z)return!0;if(!O||!z||O.length!==z.length)return!1;for(let I=0,M=O.length;I<M;I++)if(!C(O[I],z[I]))return!1;return!0}e.equals=S;function k(O,z,C){let I=0,M=O.length-1;for(;I<=M;){const _=(I+M)/2|0,T=C(O[_],z);if(T<0)I=_+1;else if(T>0)M=_-1;else return _}return-(I+1)}e.binarySearch=k;function n(O,z){let C=0,I=O.length;if(I===0)return 0;for(;C<I;){const M=Math.floor((C+I)/2);z(O[M])?I=M:C=M+1}return C}e.findFirstInSorted=n;function y(O,z,C){if(O=O|0,O>=z.length)throw new TypeError("invalid index");let I=z[Math.floor(z.length*Math.random())],M=[],_=[],T=[];for(let W of z){const B=C(W,I);B<0?M.push(W):B>0?_.push(W):T.push(W)}return O<M.length?y(O,M,C):O<M.length+T.length?T[0]:y(O-(M.length+T.length),_,C)}e.quickSelect=y;function i(O,z){const C=[];let I;for(const M of O.slice(0).sort(z))!I||z(I[0],M)!==0?(I=[M],C.push(I)):I.push(M);return C}e.groupBy=i;function L(O,z,C){const I=[];function M(W,B,H){if(!(B===0&&H.length===0)){const K=I[I.length-1];K&&K.start+K.deleteCount===W?(K.deleteCount+=B,K.toInsert.push(...H)):I.push({start:W,deleteCount:B,toInsert:H})}}let _=0,T=0;for(;;){if(_===O.length){M(_,0,z.slice(T));break}if(T===z.length){M(_,O.length-_,[]);break}const W=O[_],B=z[T],H=C(W,B);H===0?(_+=1,T+=1):H<0?(M(_,1,[]),_+=1):H>0&&(M(_,0,[B]),T+=1)}return I}e.sortedDiff=L;function g(O,z,C){const I=L(O,z,C),M=[],_=[];for(const T of I)M.push(...O.slice(T.start,T.start+T.deleteCount)),_.push(...T.toInsert);return{removed:M,added:_}}e.delta=g;function E(O,z,C){if(C===0)return[];const I=O.slice(0,C).sort(z);return d(O,z,I,C,O.length),I}e.top=E;function p(O,z,C,I,M){return C===0?Promise.resolve([]):new Promise((_,T)=>{(async()=>{const W=O.length,B=O.slice(0,C).sort(z);for(let H=C,K=Math.min(C+I,W);H<W;H=K,K=Math.min(K+I,W)){if(H>C&&await new Promise(J=>setTimeout(J)),M&&M.isCancellationRequested)throw(0,v.canceled)();d(O,z,B,H,K)}return B})().then(_,T)})}e.topAsync=p;function d(O,z,C,I,M){for(const _=C.length;I<M;I++){const T=O[I];if(z(T,C[_-1])<0){C.pop();const W=n(C,B=>z(T,B)<0);C.splice(W,0,T)}}}function m(O){return O.filter(z=>!!z)}e.coalesce=m;function b(O){let z=0;for(let C=0;C<O.length;C++)O[C]&&(O[z]=O[C],z+=1);O.length=z}e.coalesceInPlace=b;function w(O,z,C){O.splice(C,0,O.splice(z,1)[0])}e.move=w;function l(O){return!Array.isArray(O)||O.length===0}e.isFalsyOrEmpty=l;function c(O){return Array.isArray(O)&&O.length>0}e.isNonEmptyArray=c;function o(O,z){if(!z)return O.filter((I,M)=>O.indexOf(I)===M);const C=Object.create(null);return O.filter(I=>{const M=z(I);return C[M]?!1:(C[M]=!0,!0)})}e.distinct=o;function s(O){const z=new Set;return O.filter(C=>z.has(C)?!1:(z.add(C),!0))}e.distinctES6=s;function t(O){const z=Object.create(null);return C=>{const I=O(C);return z[I]?!1:(z[I]=!0,!0)}}e.uniqueFilter=t;function r(O,z){for(let C=O.length-1;C>=0;C--){const I=O[C];if(z(I))return C}return-1}e.lastIndex=r;function a(O,z){return O.length>0?O[0]:z}e.firstOrDefault=a;function u(O,z,C=(I,M)=>I===M){let I=0;for(let M=0,_=Math.min(O.length,z.length);M<_&&C(O[M],z[M]);M++)I++;return I}e.commonPrefixLength=u;function h(O){return[].concat(...O)}e.flatten=h;function f(O,z){let C=typeof z=="number"?O:0;typeof z=="number"?C=O:(C=0,z=O);const I=[];if(C<=z)for(let M=C;M<z;M++)I.push(M);else for(let M=C;M>z;M--)I.push(M);return I}e.range=f;function P(O,z,C){return O.reduce((I,M)=>(I[z(M)]=C?C(M):M,I),Object.create(null))}e.index=P;function A(O,z){return O.push(z),()=>F(O,z)}e.insert=A;function F(O,z){const C=O.indexOf(z);if(C>-1)return O.splice(C,1),z}e.remove=F;function N(O,z,C){const I=O.slice(0,z),M=O.slice(z);return I.concat(C,M)}e.arrayInsert=N;function j(O,z){let C;if(typeof z=="number"){let I=z;C=()=>{const M=Math.sin(I++)*179426549;return M-Math.floor(M)}}else C=Math.random;for(let I=O.length-1;I>0;I-=1){const M=Math.floor(C()*(I+1)),_=O[I];O[I]=O[M],O[M]=_}}e.shuffle=j;function G(O,z){const C=O.indexOf(z);C>-1&&(O.splice(C,1),O.unshift(z))}e.pushToStart=G;function ne(O,z){const C=O.indexOf(z);C>-1&&(O.splice(C,1),O.push(z))}e.pushToEnd=ne;function oe(O,z){return Array.isArray(O)?O.map(z):z(O)}e.mapArrayOrNot=oe;function V(O){return Array.isArray(O)?O:[O]}e.asArray=V;function Y(O){return O[Math.floor(Math.random()*O.length)]}e.getRandomElement=Y;function U(O,z){for(const C of O){const I=z(C);if(I!==void 0)return I}}e.mapFind=U}),define(X[43],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(R){const D=this;let S=!1,k;return function(){return S||(S=!0,k=R.apply(D,arguments)),k}}e.once=v}),define(X[64],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(R){function D(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}R.is=D;const S=Object.freeze([]);function k(){return S}R.empty=k;function*n(s){yield s}R.single=n;function y(s){return s||S}R.from=y;function i(s){return!s||s[Symbol.iterator]().next().done===!0}R.isEmpty=i;function L(s){return s[Symbol.iterator]().next().value}R.first=L;function g(s,t){for(const r of s)if(t(r))return!0;return!1}R.some=g;function E(s,t){for(const r of s)if(t(r))return r}R.find=E;function*p(s,t){for(const r of s)t(r)&&(yield r)}R.filter=p;function*d(s,t){for(const r of s)yield t(r)}R.map=d;function*m(...s){for(const t of s)for(const r of t)yield r}R.concat=m;function*b(s){for(const t of s)for(const r of t)yield r}R.concatNested=b;function w(s,t,r){let a=r;for(const u of s)a=t(a,u);return a}R.reduce=w;function*l(s,t,r=s.length){for(t<0&&(t+=s.length),r<0?r+=s.length:r>s.length&&(r=s.length);t<r;t++)yield s[t]}R.slice=l;function c(s,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,s];const a=s[Symbol.iterator]();for(let u=0;u<t;u++){const h=a.next();if(h.done)return[r,R.empty()];r.push(h.value)}return[r,{[Symbol.iterator](){return a}}]}R.consume=c;function o(s,t,r=(a,u)=>a===u){const a=s[Symbol.iterator](),u=t[Symbol.iterator]();for(;;){const h=a.next(),f=u.next();if(h.done!==f.done)return!1;if(h.done)return!0;if(!r(h.value,f.value))return!1}}R.equals=o})(v=e.Iterable||(e.Iterable={}))}),define(X[44],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function k(t,r=!1){let a=0,u=t.length,h="",f=0,P=16,A=0;function F(Y){let U=0,O=0;for(;U<Y;){const z=t.charCodeAt(a);if(z>=48&&z<=57)O=O*16+z-48;else if(z>=65&&z<=70)O=O*16+z-65+10;else if(z>=97&&z<=102)O=O*16+z-97+10;else break;a++,U++}return U<Y&&(O=-1),O}function N(Y){a=Y,h="",f=0,P=16,A=0}function j(){const Y=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&i(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&i(t.charCodeAt(a)))for(a++;a<t.length&&i(t.charCodeAt(a));)a++;else return A=3,t.substring(Y,a);let U=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&i(t.charCodeAt(a))){for(a++;a<t.length&&i(t.charCodeAt(a));)a++;U=a}else A=3;return t.substring(Y,U)}function G(){let Y="",U=a;for(;;){if(a>=u){Y+=t.substring(U,a),A=2;break}const O=t.charCodeAt(a);if(O===34){Y+=t.substring(U,a),a++;break}if(O===92){if(Y+=t.substring(U,a),a++,a>=u){A=2;break}switch(t.charCodeAt(a++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:const C=F(4);C>=0?Y+=String.fromCharCode(C):A=4;break;default:A=5}U=a;continue}if(O>=0&&O<=31)if(y(O)){Y+=t.substring(U,a),A=2;break}else A=6;a++}return Y}function ne(){if(h="",A=0,f=a,a>=u)return f=u,P=17;let Y=t.charCodeAt(a);if(n(Y)){do a++,h+=String.fromCharCode(Y),Y=t.charCodeAt(a);while(n(Y));return P=15}if(y(Y))return a++,h+=String.fromCharCode(Y),Y===13&&t.charCodeAt(a)===10&&(a++,h+=`
`),P=14;switch(Y){case 123:return a++,P=1;case 125:return a++,P=2;case 91:return a++,P=3;case 93:return a++,P=4;case 58:return a++,P=6;case 44:return a++,P=5;case 34:return a++,h=G(),P=10;case 47:const U=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<u&&!y(t.charCodeAt(a));)a++;return h=t.substring(U,a),P=12}if(t.charCodeAt(a+1)===42){a+=2;const O=u-1;let z=!1;for(;a<O;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,z=!0;break}a++}return z||(a++,A=1),h=t.substring(U,a),P=13}return h+=String.fromCharCode(Y),a++,P=16;case 45:if(h+=String.fromCharCode(Y),a++,a===u||!i(t.charCodeAt(a)))return P=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=j(),P=11;default:for(;a<u&&oe(Y);)a++,Y=t.charCodeAt(a);if(f!==a){switch(h=t.substring(f,a),h){case"true":return P=8;case"false":return P=9;case"null":return P=7}return P=16}return h+=String.fromCharCode(Y),a++,P=16}}function oe(Y){if(n(Y)||y(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let Y;do Y=ne();while(Y>=12&&Y<=15);return Y}return{setPosition:N,getPosition:()=>a,scan:r?V:ne,getToken:()=>P,getTokenValue:()=>h,getTokenOffset:()=>f,getTokenLength:()=>a-f,getTokenError:()=>A}}e.createScanner=k;function n(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function i(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function g(t,r){const a=[],u=new Object;let h;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let P=!1;function A(F,N,j,G){f.value=F,f.offset=N,f.length=j,f.type=G,f.colonOffset=void 0,h=f}try{c(t,{onObjectBegin:(F,N)=>{if(r<=F)throw u;h=void 0,P=r>F,a.push("")},onObjectProperty:(F,N,j)=>{if(r<N||(A(F,N,j,"property"),a[a.length-1]=F,r<=N+j))throw u},onObjectEnd:(F,N)=>{if(r<=F)throw u;h=void 0,a.pop()},onArrayBegin:(F,N)=>{if(r<=F)throw u;h=void 0,a.push(0)},onArrayEnd:(F,N)=>{if(r<=F)throw u;h=void 0,a.pop()},onLiteralValue:(F,N,j)=>{if(r<N||(A(F,N,j,s(F)),r<=N+j))throw u},onSeparator:(F,N,j)=>{if(r<=N)throw u;if(F===":"&&h&&h.type==="property")h.colonOffset=N,P=!1,h=void 0;else if(F===","){const G=a[a.length-1];typeof G=="number"?a[a.length-1]=G+1:(P=!0,a[a.length-1]=""),h=void 0}}})}catch(F){if(F!==u)throw F}return{path:a,previousNode:h,isAtPropertyKey:P,matches:F=>{let N=0;for(let j=0;N<F.length&&j<a.length;j++)if(F[N]===a[j]||F[N]==="*")N++;else if(F[N]!=="**")return!1;return N===F.length}}}e.getLocation=g;function E(t,r=[],a=S.DEFAULT){let u=null,h=[];const f=[];function P(F){Array.isArray(h)?h.push(F):u!==null&&(h[u]=F)}return c(t,{onObjectBegin:()=>{const F={};P(F),f.push(h),h=F,u=null},onObjectProperty:F=>{u=F},onObjectEnd:()=>{h=f.pop()},onArrayBegin:()=>{const F=[];P(F),f.push(h),h=F,u=null},onArrayEnd:()=>{h=f.pop()},onLiteralValue:P,onError:(F,N,j)=>{r.push({error:F,offset:N,length:j})}},a),h[0]}e.parse=E;function p(t,r=[],a=S.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(F){u.type==="property"&&(u.length=F-u.offset,u=u.parent)}function f(F){return u.children.push(F),F}c(t,{onObjectBegin:F=>{u=f({type:"object",offset:F,length:-1,parent:u,children:[]})},onObjectProperty:(F,N,j)=>{u=f({type:"property",offset:N,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:F,offset:N,length:j,parent:u})},onObjectEnd:(F,N)=>{u.length=F+N-u.offset,u=u.parent,h(F+N)},onArrayBegin:(F,N)=>{u=f({type:"array",offset:F,length:-1,parent:u,children:[]})},onArrayEnd:(F,N)=>{u.length=F+N-u.offset,u=u.parent,h(F+N)},onLiteralValue:(F,N,j)=>{f({type:s(F),offset:N,length:j,parent:u,value:F}),h(N+j)},onSeparator:(F,N,j)=>{u.type==="property"&&(F===":"?u.colonOffset=N:F===","&&h(N))},onError:(F,N,j)=>{r.push({error:F,offset:N,length:j})}},a);const A=u.children[0];return A&&delete A.parent,A}e.parseTree=p;function d(t,r){if(!!t){let a=t;for(let u of r)if(typeof u=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let h=!1;for(const f of a.children)if(Array.isArray(f.children)&&f.children[0].value===u){a=f.children[1],h=!0;break}if(!h)return}else{const h=u;if(a.type!=="array"||h<0||!Array.isArray(a.children)||h>=a.children.length)return;a=a.children[h]}return a}}e.findNodeAtLocation=d;function m(t){if(!t.parent||!t.parent.children)return[];const r=m(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;r.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&r.push(a)}return r}e.getNodePath=m;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":const r=Object.create(null);for(let a of t.children){const u=a.children[1];u&&(r[a.children[0].value]=b(u))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=b;function w(t,r,a=!1){return r>=t.offset&&r<t.offset+t.length||a&&r===t.offset+t.length}e.contains=w;function l(t,r,a=!1){if(w(t,r,a)){const u=t.children;if(Array.isArray(u))for(let h=0;h<u.length&&u[h].offset<=r;h++){const f=l(u[h],r,a);if(f)return f}return t}}e.findNodeAtOffset=l;function c(t,r,a=S.DEFAULT){const u=k(t,!1);function h(B){return B?()=>B(u.getTokenOffset(),u.getTokenLength()):()=>!0}function f(B){return B?H=>B(H,u.getTokenOffset(),u.getTokenLength()):()=>!0}const P=h(r.onObjectBegin),A=f(r.onObjectProperty),F=h(r.onObjectEnd),N=h(r.onArrayBegin),j=h(r.onArrayEnd),G=f(r.onLiteralValue),ne=f(r.onSeparator),oe=h(r.onComment),V=f(r.onError),Y=a&&a.disallowComments,U=a&&a.allowTrailingComma;function O(){for(;;){const B=u.scan();switch(u.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:Y||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(B){case 12:case 13:Y?z(10):oe();break;case 16:z(1);break;case 15:case 14:break;default:return B}}}function z(B,H=[],K=[]){if(V(B),H.length+K.length>0){let J=u.getToken();for(;J!==17;){if(H.indexOf(J)!==-1){O();break}else if(K.indexOf(J)!==-1)break;J=O()}}}function C(B){const H=u.getTokenValue();return B?G(H):A(H),O(),!0}function I(){switch(u.getToken()){case 11:let B=0;try{B=JSON.parse(u.getTokenValue()),typeof B!="number"&&(z(2),B=0)}catch(H){z(2)}G(B);break;case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return O(),!0}function M(){return u.getToken()!==10?(z(3,[],[2,5]),!1):(C(!1),u.getToken()===6?(ne(":"),O(),W()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function _(){P(),O();let B=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(B||z(4,[],[]),ne(","),O(),u.getToken()===2&&U)break}else B&&z(6,[],[]);M()||z(4,[],[2,5]),B=!0}return F(),u.getToken()!==2?z(7,[2],[]):O(),!0}function T(){N(),O();let B=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(B||z(4,[],[]),ne(","),O(),u.getToken()===4&&U)break}else B&&z(6,[],[]);W()||z(4,[],[4,5]),B=!0}return j(),u.getToken()!==4?z(8,[4],[]):O(),!0}function W(){switch(u.getToken()){case 3:return T();case 1:return _();case 10:return C(!0);default:return I()}}return O(),u.getToken()===17?a.allowEmptyContent?!0:(z(4,[],[]),!1):W()?(u.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=c;function o(t,r){let a=k(t),u=[],h,f=0,P;do switch(P=a.getPosition(),h=a.scan(),h){case 12:case 13:case 17:f!==P&&u.push(t.substring(f,P)),r!==void 0&&u.push(a.getTokenValue().replace(/[^\r\n]/g,r)),f=a.getPosition();break}while(h!==17);return u.join("")}e.stripComments=o;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),define(X[101],Q([0,1,44]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(y,i,L){let g,E,p,d,m;if(i){for(d=i.offset,m=d+i.length,p=d;p>0&&!n(y,p-1);)p--;let f=m;for(;f<y.length&&!n(y,f);)f++;E=y.substring(p,f),g=S(E,L)}else E=y,g=0,p=0,d=0,m=y.length;const b=k(L,y);let w=!1,l=0,c;L.insertSpaces?c=D(" ",L.tabSize||4):c="	";const o=(0,v.createScanner)(E,!1);let s=!1;function t(){return b+D(c,g+l)}function r(){let f=o.scan();for(w=!1;f===15||f===14;)w=w||f===14,f=o.scan();return s=f===16||o.getTokenError()!==0,f}const a=[];function u(f,P,A){!s&&P<m&&A>d&&y.substring(P,A)!==f&&a.push({offset:P,length:A-P,content:f})}let h=r();if(h!==17){const f=o.getTokenOffset()+p,P=D(c,g);u(P,p,f)}for(;h!==17;){let f=o.getTokenOffset()+o.getTokenLength()+p,P=r(),A="";for(;!w&&(P===12||P===13);){const N=o.getTokenOffset()+p;u(" ",f,N),f=o.getTokenOffset()+o.getTokenLength()+p,A=P===12?t():"",P=r()}if(P===2)h!==1&&(l--,A=t());else if(P===4)h!==3&&(l--,A=t());else{switch(h){case 3:case 1:l++,A=t();break;case 5:case 12:A=t();break;case 13:w?A=t():A=" ";break;case 6:A=" ";break;case 10:if(P===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?A=" ":P!==5&&P!==17&&(s=!0);break;case 16:s=!0;break}w&&(P===12||P===13)&&(A=t())}const F=o.getTokenOffset()+p;u(A,f,F),h=P}return a}e.format=R;function D(y,i){let L="";for(let g=0;g<i;g++)L+=y;return L}function S(y,i){let L=0,g=0;const E=i.tabSize||4;for(;L<y.length;){const p=y.charAt(L);if(p===" ")g++;else if(p==="	")g+=E;else break;L++}return Math.floor(g/E)}function k(y,i){for(let L=0;L<i.length;L++){const g=i.charAt(L);if(g==="\r")return L+1<i.length&&i.charAt(L+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=k;function n(y,i){return`\r
`.indexOf(y.charAt(i))!==-1}e.isEOL=n}),define(X[102],Q([0,1,44,101]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(i,L,g){return S(i,L,void 0,g)}e.removeProperty=D;function S(i,L,g,E,p){const d=L.slice(),m=[],b=(0,v.parseTree)(i,m);let w,l;for(;d.length>0&&(l=d.pop(),w=(0,v.findNodeAtLocation)(b,d),w===void 0&&g!==void 0);)typeof l=="string"?g={[l]:g}:g=[g];if(w)if(w.type==="object"&&typeof l=="string"&&Array.isArray(w.children)){const c=(0,v.findNodeAtLocation)(w,[l]);if(c!==void 0)if(g===void 0){if(!c.parent)throw new Error("Malformed AST");const o=w.children.indexOf(c.parent);let s,t=c.parent.offset+c.parent.length;if(o>0){const r=w.children[o-1];s=r.offset+r.length}else s=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return k(i,{offset:s,length:t-s,content:""},E)}else return k(i,{offset:c.offset,length:c.length,content:JSON.stringify(g)},E);else{if(g===void 0)return[];const o=`${JSON.stringify(l)}: ${JSON.stringify(g)}`,s=p?p(w.children.map(r=>r.children[0].value)):w.children.length;let t;if(s>0){const r=w.children[s-1];t={offset:r.offset+r.length,length:0,content:","+o}}else w.children.length===0?t={offset:w.offset+1,length:0,content:o}:t={offset:w.offset+1,length:0,content:o+","};return k(i,t,E)}}else if(w.type==="array"&&typeof l=="number"&&Array.isArray(w.children))if(g!==void 0){const c=`${JSON.stringify(g)}`;let o;if(w.children.length===0||l===0)o={offset:w.offset+1,length:0,content:w.children.length===0?c:c+","};else{const s=l===-1||l>w.children.length?w.children.length:l,t=w.children[s-1];o={offset:t.offset+t.length,length:0,content:","+c}}return k(i,o,E)}else{const c=l,o=w.children[c];let s;if(w.children.length===1)s={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===c){const t=w.children[c-1],r=t.offset+t.length,a=w.offset+w.length;s={offset:r,length:a-2-r,content:""}}else s={offset:o.offset,length:w.children[c+1].offset-o.offset,content:""};return k(i,s,E)}else throw new Error(`Can not add ${typeof l!="number"?"index":"property"} to parent of type ${w.type}`);else{if(g===void 0)throw new Error("Can not delete in empty document");return k(i,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(g)},E)}}e.setProperty=S;function k(i,L,g){let E=n(i,L),p=L.offset,d=L.offset+L.content.length;if(L.length===0||L.content.length===0){for(;p>0&&!(0,R.isEOL)(E,p-1);)p--;for(;d<E.length&&!(0,R.isEOL)(E,d);)d++}const m=(0,R.format)(E,{offset:p,length:d-p},g);for(let w=m.length-1;w>=0;w--){const l=m[w];E=n(E,l),p=Math.min(p,l.offset),d=Math.max(d,l.offset+l.length),d+=l.content.length-l.length}const b=i.length-(E.length-d)-p;return[{offset:p,length:b,content:E.substring(p,d)}]}e.withFormatting=k;function n(i,L){return i.substring(0,L.offset)+L.content+i.substring(L.offset+L.length)}e.applyEdit=n;function y(i,L){let g=L.slice(0).sort((p,d)=>{const m=p.offset-d.offset;return m===0?p.length-d.length:m}),E=i.length;for(let p=g.length-1;p>=0;p--){let d=g[p];if(d.offset+d.length<=E)i=n(i,d);else throw new Error("Overlapping edit");E=d.offset}return i}e.applyEdits=y}),define(X[58],Q([0,1,18]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var R;(function(l){l[l.DependsOnKbLayout=-1]="DependsOnKbLayout",l[l.Unknown=0]="Unknown",l[l.Backspace=1]="Backspace",l[l.Tab=2]="Tab",l[l.Enter=3]="Enter",l[l.Shift=4]="Shift",l[l.Ctrl=5]="Ctrl",l[l.Alt=6]="Alt",l[l.PauseBreak=7]="PauseBreak",l[l.CapsLock=8]="CapsLock",l[l.Escape=9]="Escape",l[l.Space=10]="Space",l[l.PageUp=11]="PageUp",l[l.PageDown=12]="PageDown",l[l.End=13]="End",l[l.Home=14]="Home",l[l.LeftArrow=15]="LeftArrow",l[l.UpArrow=16]="UpArrow",l[l.RightArrow=17]="RightArrow",l[l.DownArrow=18]="DownArrow",l[l.Insert=19]="Insert",l[l.Delete=20]="Delete",l[l.KEY_0=21]="KEY_0",l[l.KEY_1=22]="KEY_1",l[l.KEY_2=23]="KEY_2",l[l.KEY_3=24]="KEY_3",l[l.KEY_4=25]="KEY_4",l[l.KEY_5=26]="KEY_5",l[l.KEY_6=27]="KEY_6",l[l.KEY_7=28]="KEY_7",l[l.KEY_8=29]="KEY_8",l[l.KEY_9=30]="KEY_9",l[l.KEY_A=31]="KEY_A",l[l.KEY_B=32]="KEY_B",l[l.KEY_C=33]="KEY_C",l[l.KEY_D=34]="KEY_D",l[l.KEY_E=35]="KEY_E",l[l.KEY_F=36]="KEY_F",l[l.KEY_G=37]="KEY_G",l[l.KEY_H=38]="KEY_H",l[l.KEY_I=39]="KEY_I",l[l.KEY_J=40]="KEY_J",l[l.KEY_K=41]="KEY_K",l[l.KEY_L=42]="KEY_L",l[l.KEY_M=43]="KEY_M",l[l.KEY_N=44]="KEY_N",l[l.KEY_O=45]="KEY_O",l[l.KEY_P=46]="KEY_P",l[l.KEY_Q=47]="KEY_Q",l[l.KEY_R=48]="KEY_R",l[l.KEY_S=49]="KEY_S",l[l.KEY_T=50]="KEY_T",l[l.KEY_U=51]="KEY_U",l[l.KEY_V=52]="KEY_V",l[l.KEY_W=53]="KEY_W",l[l.KEY_X=54]="KEY_X",l[l.KEY_Y=55]="KEY_Y",l[l.KEY_Z=56]="KEY_Z",l[l.Meta=57]="Meta",l[l.ContextMenu=58]="ContextMenu",l[l.F1=59]="F1",l[l.F2=60]="F2",l[l.F3=61]="F3",l[l.F4=62]="F4",l[l.F5=63]="F5",l[l.F6=64]="F6",l[l.F7=65]="F7",l[l.F8=66]="F8",l[l.F9=67]="F9",l[l.F10=68]="F10",l[l.F11=69]="F11",l[l.F12=70]="F12",l[l.F13=71]="F13",l[l.F14=72]="F14",l[l.F15=73]="F15",l[l.F16=74]="F16",l[l.F17=75]="F17",l[l.F18=76]="F18",l[l.F19=77]="F19",l[l.NumLock=78]="NumLock",l[l.ScrollLock=79]="ScrollLock",l[l.US_SEMICOLON=80]="US_SEMICOLON",l[l.US_EQUAL=81]="US_EQUAL",l[l.US_COMMA=82]="US_COMMA",l[l.US_MINUS=83]="US_MINUS",l[l.US_DOT=84]="US_DOT",l[l.US_SLASH=85]="US_SLASH",l[l.US_BACKTICK=86]="US_BACKTICK",l[l.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",l[l.US_BACKSLASH=88]="US_BACKSLASH",l[l.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",l[l.US_QUOTE=90]="US_QUOTE",l[l.OEM_8=91]="OEM_8",l[l.OEM_102=92]="OEM_102",l[l.NUMPAD_0=93]="NUMPAD_0",l[l.NUMPAD_1=94]="NUMPAD_1",l[l.NUMPAD_2=95]="NUMPAD_2",l[l.NUMPAD_3=96]="NUMPAD_3",l[l.NUMPAD_4=97]="NUMPAD_4",l[l.NUMPAD_5=98]="NUMPAD_5",l[l.NUMPAD_6=99]="NUMPAD_6",l[l.NUMPAD_7=100]="NUMPAD_7",l[l.NUMPAD_8=101]="NUMPAD_8",l[l.NUMPAD_9=102]="NUMPAD_9",l[l.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",l[l.NUMPAD_ADD=104]="NUMPAD_ADD",l[l.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",l[l.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",l[l.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",l[l.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",l[l.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",l[l.ABNT_C1=110]="ABNT_C1",l[l.ABNT_C2=111]="ABNT_C2",l[l.MAX_VALUE=112]="MAX_VALUE"})(R=e.KeyCode||(e.KeyCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(c,o){this._keyCodeToStr[c]=o,this._strToKeyCode[o.toLowerCase()]=c}keyCodeToStr(c){return this._keyCodeToStr[c]}strToKeyCode(c){return this._strToKeyCode[c.toLowerCase()]||0}}const S=new D,k=new D,n=new D;(function(){function l(c,o,s=o,t=s){S.define(c,o),k.define(c,s),n.define(c,t)}l(0,"unknown"),l(1,"Backspace"),l(2,"Tab"),l(3,"Enter"),l(4,"Shift"),l(5,"Ctrl"),l(6,"Alt"),l(7,"PauseBreak"),l(8,"CapsLock"),l(9,"Escape"),l(10,"Space"),l(11,"PageUp"),l(12,"PageDown"),l(13,"End"),l(14,"Home"),l(15,"LeftArrow","Left"),l(16,"UpArrow","Up"),l(17,"RightArrow","Right"),l(18,"DownArrow","Down"),l(19,"Insert"),l(20,"Delete"),l(21,"0"),l(22,"1"),l(23,"2"),l(24,"3"),l(25,"4"),l(26,"5"),l(27,"6"),l(28,"7"),l(29,"8"),l(30,"9"),l(31,"A"),l(32,"B"),l(33,"C"),l(34,"D"),l(35,"E"),l(36,"F"),l(37,"G"),l(38,"H"),l(39,"I"),l(40,"J"),l(41,"K"),l(42,"L"),l(43,"M"),l(44,"N"),l(45,"O"),l(46,"P"),l(47,"Q"),l(48,"R"),l(49,"S"),l(50,"T"),l(51,"U"),l(52,"V"),l(53,"W"),l(54,"X"),l(55,"Y"),l(56,"Z"),l(57,"Meta"),l(58,"ContextMenu"),l(59,"F1"),l(60,"F2"),l(61,"F3"),l(62,"F4"),l(63,"F5"),l(64,"F6"),l(65,"F7"),l(66,"F8"),l(67,"F9"),l(68,"F10"),l(69,"F11"),l(70,"F12"),l(71,"F13"),l(72,"F14"),l(73,"F15"),l(74,"F16"),l(75,"F17"),l(76,"F18"),l(77,"F19"),l(78,"NumLock"),l(79,"ScrollLock"),l(80,";",";","OEM_1"),l(81,"=","=","OEM_PLUS"),l(82,",",",","OEM_COMMA"),l(83,"-","-","OEM_MINUS"),l(84,".",".","OEM_PERIOD"),l(85,"/","/","OEM_2"),l(86,"`","`","OEM_3"),l(110,"ABNT_C1"),l(111,"ABNT_C2"),l(87,"[","[","OEM_4"),l(88,"\\","\\","OEM_5"),l(89,"]","]","OEM_6"),l(90,"'","'","OEM_7"),l(91,"OEM_8"),l(92,"OEM_102"),l(93,"NumPad0"),l(94,"NumPad1"),l(95,"NumPad2"),l(96,"NumPad3"),l(97,"NumPad4"),l(98,"NumPad5"),l(99,"NumPad6"),l(100,"NumPad7"),l(101,"NumPad8"),l(102,"NumPad9"),l(103,"NumPad_Multiply"),l(104,"NumPad_Add"),l(105,"NumPad_Separator"),l(106,"NumPad_Subtract"),l(107,"NumPad_Decimal"),l(108,"NumPad_Divide")})();var y;(function(l){function c(a){return S.keyCodeToStr(a)}l.toString=c;function o(a){return S.strToKeyCode(a)}l.fromString=o;function s(a){return k.keyCodeToStr(a)}l.toUserSettingsUS=s;function t(a){return n.keyCodeToStr(a)}l.toUserSettingsGeneral=t;function r(a){return k.strToKeyCode(a)||n.strToKeyCode(a)}l.fromUserSettings=r})(y=e.KeyCodeUtils||(e.KeyCodeUtils={}));var i;(function(l){l[l.CtrlCmd=2048]="CtrlCmd",l[l.Shift=1024]="Shift",l[l.Alt=512]="Alt",l[l.WinCtrl=256]="WinCtrl",l[l.KeyCode=255]="KeyCode"})(i||(i={}));var L;(function(l){l[l.CtrlCmd=2048]="CtrlCmd",l[l.Shift=1024]="Shift",l[l.Alt=512]="Alt",l[l.WinCtrl=256]="WinCtrl"})(L=e.KeyMod||(e.KeyMod={}));function g(l,c){const o=(c&65535)<<16>>>0;return(l|o)>>>0}e.KeyChord=g;function E(l,c){if(l===0)return null;const o=(l&65535)>>>0,s=(l&4294901760)>>>16;return s!==0?new m([p(o,c),p(s,c)]):new m([p(o,c)])}e.createKeybinding=E;function p(l,c){const o=!!(l&2048),s=!!(l&256),t=c===2?s:o,r=!!(l&1024),a=!!(l&512),u=c===2?o:s,h=l&255;return new d(t,r,a,u,h)}e.createSimpleKeybinding=p;class d{constructor(c,o,s,t,r){this.ctrlKey=c,this.shiftKey=o,this.altKey=s,this.metaKey=t,this.keyCode=r}equals(c){return this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.keyCode===c.keyCode}getHashCode(){const c=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",s=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${c}${o}${s}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class m{constructor(c){if(c.length===0)throw(0,v.illegalArgument)("parts");this.parts=c}getHashCode(){let c="";for(let o=0,s=this.parts.length;o<s;o++)o!==0&&(c+=";"),c+=this.parts[o].getHashCode();return c}equals(c){if(c===null||this.parts.length!==c.parts.length)return!1;for(let o=0;o<this.parts.length;o++)if(!this.parts[o].equals(c.parts[o]))return!1;return!0}}e.ChordKeybinding=m;class b{constructor(c,o,s,t,r,a){this.ctrlKey=c,this.shiftKey=o,this.altKey=s,this.metaKey=t,this.keyLabel=r,this.keyAriaLabel=a}}e.ResolvedKeybindingPart=b;class w{}e.ResolvedKeybinding=w}),define(X[2],Q([0,1,43,64]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const D=!1;let S=null;function k(c){S=c}if(e.setDisposableTracker=k,D){const c="__is_disposable_tracked__";S=new class{trackDisposable(o){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[c]||console.log(s)},3e3)}markTracked(o){if(o&&o!==m.None)try{o[c]=!0}catch(s){}}}}function n(c){!S||S.markTracked(c)}function y(c){return S&&S.trackDisposable(c),c}e.trackDisposable=y;class i extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=i;function L(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=L;function g(c){if(R.Iterable.is(c)){let o=[];for(const s of c)if(s){n(s);try{s.dispose()}catch(t){o.push(t)}}if(o.length===1)throw o[0];if(o.length>1)throw new i(o);return Array.isArray(c)?[]:c}else if(c)return n(c),c.dispose(),c}e.dispose=g;function E(...c){return c.forEach(n),p(()=>g(c))}e.combinedDisposable=E;function p(c){const o=y({dispose:()=>{n(o),c()}});return o}e.toDisposable=p;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(n(this),this._isDisposed=!0,this.clear())}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return n(o),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new d,y(this)}dispose(){n(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class b{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){var s;this._isDisposed||o===this._value||((s=this._value)===null||s===void 0||s.dispose(),o&&n(o),this._value=o)}clear(){this.value=void 0}dispose(){var o;this._isDisposed=!0,n(this),(o=this._value)===null||o===void 0||o.dispose(),this._value=void 0}}e.MutableDisposable=b;class w{constructor(){this.references=new Map}acquire(o,...s){let t=this.references.get(o);t||(t={counter:0,object:this.createReferencedObject(o,...s)},this.references.set(o,t));const{object:r}=t,a=(0,v.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(o,t.object),this.references.delete(o))});return t.counter++,{object:r,dispose:a}}}e.ReferenceCollection=w;class l{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=l}),define(X[77],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(S){this.element=S,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class R{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,k){const n=new v(S);if(this._first===v.Undefined)this._first=n,this._last=n;else if(k){const i=this._last;this._last=n,n.prev=i,i.next=n}else{const i=this._first;this._first=n,n.next=i,i.prev=n}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(n))}}shift(){if(this._first!==v.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==v.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==v.Undefined&&S.next!==v.Undefined){const k=S.prev;k.next=S.next,S.next.prev=k}else S.prev===v.Undefined&&S.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):S.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):S.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==v.Undefined;)yield S.element,S=S.next}}e.LinkedList=R});"use strict";(function(){function $(D){const S=[];typeof D=="number"&&S.push("code/timeOrigin",D);function k(y){S.push(y,Date.now())}function n(){const y=[];for(let i=0;i<S.length;i+=2)y.push({name:S[i],startTime:S[i+1]});return y}return{mark:k,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const k of performance.getEntriesByType("mark"))S.push({name:k.name,startTime:Math.round(D+k.startTime)});return S}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function v(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=v(R))})(),define(X[3],Q([0,1]),function($,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let D=!1,S=!1,k=!1,n=!1,y=!1,i=!1,L=!1,g,E=R,p,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode!="undefined"?m=e.globals.vscode.process:typeof process!="undefined"&&(m=process);const b=typeof((v=m==null?void 0:m.versions)===null||v===void 0?void 0:v.electron)=="string"&&m.type==="renderer";if(e.isElectronSandboxed=b&&(m==null?void 0:m.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const u=m==null?void 0:m.env.VSCODE_BROWSER_CODE_LOADING;if(typeof u=="string")return u==="none"||u==="code"||u==="bypassHeatCheck"||u==="bypassHeatCheckAndEagerCompile"?u:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!b)d=navigator.userAgent,D=d.indexOf("Windows")>=0,S=d.indexOf("Macintosh")>=0,L=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=d.indexOf("Linux")>=0,i=!0,g=navigator.language,E=g;else if(typeof m=="object"){D=m.platform==="win32",S=m.platform==="darwin",k=m.platform==="linux",n=k&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,g=R,E=R;const u=m.env.VSCODE_NLS_CONFIG;if(u)try{const h=JSON.parse(u),f=h.availableLanguages["*"];g=h.locale,E=f||R,p=h._translationsConfigFile}catch(h){}y=!0}else console.error("Unable to resolve platform.");var w;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function l(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let c=0;S?c=1:D?c=3:k&&(c=2),e.isWindows=D,e.isMacintosh=S,e.isLinux=k,e.isLinuxSnap=n,e.isNative=y,e.isWeb=i,e.isIOS=L,e.platform=c,e.userAgent=d,e.language=E;var o;(function(u){function h(){return e.language}u.value=h;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}u.isDefaultVariant=f;function P(){return e.language==="en"}u.isDefault=P})(o=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=p,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",A=>{if(A.data&&A.data.vscodeSetImmediateId)for(let F=0,N=f.length;F<N;F++){const j=f[F];if(j.id===A.data.vscodeSetImmediateId){f.splice(F,1),j.callback();return}}});let P=0;return A=>{const F=++P;f.push({id:F,callback:A}),e.globals.postMessage({vscodeSetImmediateId:F},"*")}}if(typeof(m==null?void 0:m.nextTick)=="function")return m.nextTick.bind(m);const h=Promise.resolve();return f=>h.then(f)}();var s;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=S||L?2:D?1:3;let t=!0,r=!1;function a(){if(!r){r=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,t=new Uint16Array(u.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=a}),define(X[35],Q([0,1,3]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof v.globals.vscode!="undefined"){const D=v.globals.vscode.process;R={get platform(){return D.platform},get env(){return D.env},cwd(){return D.cwd()},nextTick(S){return(0,v.setImmediate)(S)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:R={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(D){return(0,v.setImmediate)(D)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(X[8],Q([0,1,35]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,D=97,S=90,k=122,n=46,y=47,i=92,L=58,g=63;class E extends Error{constructor(o,s,t){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const a=o.indexOf(".")!==-1?"property":"argument";let u=`The "${o}" ${a} ${r} of type ${s}`;u+=`. Received type ${typeof t}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function p(c,o){if(typeof c!="string")throw new E(o,"string",c)}function d(c){return c===y||c===i}function m(c){return c===y}function b(c){return c>=R&&c<=S||c>=D&&c<=k}function w(c,o,s,t){let r="",a=0,u=-1,h=0,f=0;for(let P=0;P<=c.length;++P){if(P<c.length)f=c.charCodeAt(P);else{if(t(f))break;f=y}if(t(f)){if(!(u===P-1||h===1))if(h===2){if(r.length<2||a!==2||r.charCodeAt(r.length-1)!==n||r.charCodeAt(r.length-2)!==n){if(r.length>2){const A=r.lastIndexOf(s);A===-1?(r="",a=0):(r=r.slice(0,A),a=r.length-1-r.lastIndexOf(s)),u=P,h=0;continue}else if(r.length!==0){r="",a=0,u=P,h=0;continue}}o&&(r+=r.length>0?`${s}..`:"..",a=2)}else r.length>0?r+=`${s}${c.slice(u+1,P)}`:r=c.slice(u+1,P),a=P-u-1;u=P,h=0}else f===n&&h!==-1?++h:h=-1}return r}function l(c,o){if(o===null||typeof o!="object")throw new E("pathObject","Object",o);const s=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${t}`:`${s}${c}${t}`:t}e.win32={resolve(...c){let o="",s="",t=!1;for(let r=c.length-1;r>=-1;r--){let a;if(r>=0){if(a=c[r],p(a,"path"),a.length===0)continue}else o.length===0?a=v.cwd():(a=v.env[`=${o}`]||v.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==o.toLowerCase()&&a.charCodeAt(2)===i)&&(a=`${o}\\`));const u=a.length;let h=0,f="",P=!1;const A=a.charCodeAt(0);if(u===1)d(A)&&(h=1,P=!0);else if(d(A))if(P=!0,d(a.charCodeAt(1))){let F=2,N=F;for(;F<u&&!d(a.charCodeAt(F));)F++;if(F<u&&F!==N){const j=a.slice(N,F);for(N=F;F<u&&d(a.charCodeAt(F));)F++;if(F<u&&F!==N){for(N=F;F<u&&!d(a.charCodeAt(F));)F++;(F===u||F!==N)&&(f=`\\\\${j}\\${a.slice(N,F)}`,h=F)}}}else h=1;else b(A)&&a.charCodeAt(1)===L&&(f=a.slice(0,2),h=2,u>2&&d(a.charCodeAt(2))&&(P=!0,h=3));if(f.length>0)if(o.length>0){if(f.toLowerCase()!==o.toLowerCase())continue}else o=f;if(t){if(o.length>0)break}else if(s=`${a.slice(h)}\\${s}`,t=P,P&&o.length>0)break}return s=w(s,!t,"\\",d),t?`${o}\\${s}`:`${o}${s}`||"."},normalize(c){p(c,"path");const o=c.length;if(o===0)return".";let s=0,t,r=!1;const a=c.charCodeAt(0);if(o===1)return m(a)?"\\":c;if(d(a))if(r=!0,d(c.charCodeAt(1))){let h=2,f=h;for(;h<o&&!d(c.charCodeAt(h));)h++;if(h<o&&h!==f){const P=c.slice(f,h);for(f=h;h<o&&d(c.charCodeAt(h));)h++;if(h<o&&h!==f){for(f=h;h<o&&!d(c.charCodeAt(h));)h++;if(h===o)return`\\\\${P}\\${c.slice(f)}\\`;h!==f&&(t=`\\\\${P}\\${c.slice(f,h)}`,s=h)}}}else s=1;else b(a)&&c.charCodeAt(1)===L&&(t=c.slice(0,2),s=2,o>2&&d(c.charCodeAt(2))&&(r=!0,s=3));let u=s<o?w(c.slice(s),!r,"\\",d):"";return u.length===0&&!r&&(u="."),u.length>0&&d(c.charCodeAt(o-1))&&(u+="\\"),t===void 0?r?`\\${u}`:u:r?`${t}\\${u}`:`${t}${u}`},isAbsolute(c){p(c,"path");const o=c.length;if(o===0)return!1;const s=c.charCodeAt(0);return d(s)||o>2&&b(s)&&c.charCodeAt(1)===L&&d(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let o,s;for(let a=0;a<c.length;++a){const u=c[a];p(u,"path"),u.length>0&&(o===void 0?o=s=u:o+=`\\${u}`)}if(o===void 0)return".";let t=!0,r=0;if(typeof s=="string"&&d(s.charCodeAt(0))){++r;const a=s.length;a>1&&d(s.charCodeAt(1))&&(++r,a>2&&(d(s.charCodeAt(2))?++r:t=!1))}if(t){for(;r<o.length&&d(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(c,o){if(p(c,"from"),p(o,"to"),c===o)return"";const s=e.win32.resolve(c),t=e.win32.resolve(o);if(s===t||(c=s.toLowerCase(),o=t.toLowerCase(),c===o))return"";let r=0;for(;r<c.length&&c.charCodeAt(r)===i;)r++;let a=c.length;for(;a-1>r&&c.charCodeAt(a-1)===i;)a--;const u=a-r;let h=0;for(;h<o.length&&o.charCodeAt(h)===i;)h++;let f=o.length;for(;f-1>h&&o.charCodeAt(f-1)===i;)f--;const P=f-h,A=u<P?u:P;let F=-1,N=0;for(;N<A;N++){const G=c.charCodeAt(r+N);if(G!==o.charCodeAt(h+N))break;G===i&&(F=N)}if(N!==A){if(F===-1)return t}else{if(P>A){if(o.charCodeAt(h+N)===i)return t.slice(h+N+1);if(N===2)return t.slice(h+N)}u>A&&(c.charCodeAt(r+N)===i?F=N:N===2&&(F=3)),F===-1&&(F=0)}let j="";for(N=r+F+1;N<=a;++N)(N===a||c.charCodeAt(N)===i)&&(j+=j.length===0?"..":"\\..");return h+=F,j.length>0?`${j}${t.slice(h,f)}`:(t.charCodeAt(h)===i&&++h,t.slice(h,f))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const o=e.win32.resolve(c);if(o.length<=2)return c;if(o.charCodeAt(0)===i){if(o.charCodeAt(1)===i){const s=o.charCodeAt(2);if(s!==g&&s!==n)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(b(o.charCodeAt(0))&&o.charCodeAt(1)===L&&o.charCodeAt(2)===i)return`\\\\?\\${o}`;return c},dirname(c){p(c,"path");const o=c.length;if(o===0)return".";let s=-1,t=0;const r=c.charCodeAt(0);if(o===1)return d(r)?c:".";if(d(r)){if(s=t=1,d(c.charCodeAt(1))){let h=2,f=h;for(;h<o&&!d(c.charCodeAt(h));)h++;if(h<o&&h!==f){for(f=h;h<o&&d(c.charCodeAt(h));)h++;if(h<o&&h!==f){for(f=h;h<o&&!d(c.charCodeAt(h));)h++;if(h===o)return c;h!==f&&(s=t=h+1)}}}}else b(r)&&c.charCodeAt(1)===L&&(s=o>2&&d(c.charCodeAt(2))?3:2,t=s);let a=-1,u=!0;for(let h=o-1;h>=t;--h)if(d(c.charCodeAt(h))){if(!u){a=h;break}}else u=!1;if(a===-1){if(s===-1)return".";a=s}return c.slice(0,a)},basename(c,o){o!==void 0&&p(o,"ext"),p(c,"path");let s=0,t=-1,r=!0,a;if(c.length>=2&&b(c.charCodeAt(0))&&c.charCodeAt(1)===L&&(s=2),o!==void 0&&o.length>0&&o.length<=c.length){if(o===c)return"";let u=o.length-1,h=-1;for(a=c.length-1;a>=s;--a){const f=c.charCodeAt(a);if(d(f)){if(!r){s=a+1;break}}else h===-1&&(r=!1,h=a+1),u>=0&&(f===o.charCodeAt(u)?--u==-1&&(t=a):(u=-1,t=h))}return s===t?t=h:t===-1&&(t=c.length),c.slice(s,t)}for(a=c.length-1;a>=s;--a)if(d(c.charCodeAt(a))){if(!r){s=a+1;break}}else t===-1&&(r=!1,t=a+1);return t===-1?"":c.slice(s,t)},extname(c){p(c,"path");let o=0,s=-1,t=0,r=-1,a=!0,u=0;c.length>=2&&c.charCodeAt(1)===L&&b(c.charCodeAt(0))&&(o=t=2);for(let h=c.length-1;h>=o;--h){const f=c.charCodeAt(h);if(d(f)){if(!a){t=h+1;break}continue}r===-1&&(a=!1,r=h+1),f===n?s===-1?s=h:u!==1&&(u=1):s!==-1&&(u=-1)}return s===-1||r===-1||u===0||u===1&&s===r-1&&s===t+1?"":c.slice(s,r)},format:l.bind(null,"\\"),parse(c){p(c,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return o;const s=c.length;let t=0,r=c.charCodeAt(0);if(s===1)return d(r)?(o.root=o.dir=c,o):(o.base=o.name=c,o);if(d(r)){if(t=1,d(c.charCodeAt(1))){let F=2,N=F;for(;F<s&&!d(c.charCodeAt(F));)F++;if(F<s&&F!==N){for(N=F;F<s&&d(c.charCodeAt(F));)F++;if(F<s&&F!==N){for(N=F;F<s&&!d(c.charCodeAt(F));)F++;F===s?t=F:F!==N&&(t=F+1)}}}}else if(b(r)&&c.charCodeAt(1)===L){if(s<=2)return o.root=o.dir=c,o;if(t=2,d(c.charCodeAt(2))){if(s===3)return o.root=o.dir=c,o;t=3}}t>0&&(o.root=c.slice(0,t));let a=-1,u=t,h=-1,f=!0,P=c.length-1,A=0;for(;P>=t;--P){if(r=c.charCodeAt(P),d(r)){if(!f){u=P+1;break}continue}h===-1&&(f=!1,h=P+1),r===n?a===-1?a=P:A!==1&&(A=1):a!==-1&&(A=-1)}return h!==-1&&(a===-1||A===0||A===1&&a===h-1&&a===u+1?o.base=o.name=c.slice(u,h):(o.name=c.slice(u,a),o.base=c.slice(u,h),o.ext=c.slice(a,h))),u>0&&u!==t?o.dir=c.slice(0,u-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let o="",s=!1;for(let t=c.length-1;t>=-1&&!s;t--){const r=t>=0?c[t]:v.cwd();p(r,"path"),r.length!==0&&(o=`${r}/${o}`,s=r.charCodeAt(0)===y)}return o=w(o,!s,"/",m),s?`/${o}`:o.length>0?o:"."},normalize(c){if(p(c,"path"),c.length===0)return".";const o=c.charCodeAt(0)===y,s=c.charCodeAt(c.length-1)===y;return c=w(c,!o,"/",m),c.length===0?o?"/":s?"./":".":(s&&(c+="/"),o?`/${c}`:c)},isAbsolute(c){return p(c,"path"),c.length>0&&c.charCodeAt(0)===y},join(...c){if(c.length===0)return".";let o;for(let s=0;s<c.length;++s){const t=c[s];p(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(c,o){if(p(c,"from"),p(o,"to"),c===o||(c=e.posix.resolve(c),o=e.posix.resolve(o),c===o))return"";const s=1,t=c.length,r=t-s,a=1,u=o.length-a,h=r<u?r:u;let f=-1,P=0;for(;P<h;P++){const F=c.charCodeAt(s+P);if(F!==o.charCodeAt(a+P))break;F===y&&(f=P)}if(P===h)if(u>h){if(o.charCodeAt(a+P)===y)return o.slice(a+P+1);if(P===0)return o.slice(a+P)}else r>h&&(c.charCodeAt(s+P)===y?f=P:P===0&&(f=0));let A="";for(P=s+f+1;P<=t;++P)(P===t||c.charCodeAt(P)===y)&&(A+=A.length===0?"..":"/..");return`${A}${o.slice(a+f)}`},toNamespacedPath(c){return c},dirname(c){if(p(c,"path"),c.length===0)return".";const o=c.charCodeAt(0)===y;let s=-1,t=!0;for(let r=c.length-1;r>=1;--r)if(c.charCodeAt(r)===y){if(!t){s=r;break}}else t=!1;return s===-1?o?"/":".":o&&s===1?"//":c.slice(0,s)},basename(c,o){o!==void 0&&p(o,"ext"),p(c,"path");let s=0,t=-1,r=!0,a;if(o!==void 0&&o.length>0&&o.length<=c.length){if(o===c)return"";let u=o.length-1,h=-1;for(a=c.length-1;a>=0;--a){const f=c.charCodeAt(a);if(f===y){if(!r){s=a+1;break}}else h===-1&&(r=!1,h=a+1),u>=0&&(f===o.charCodeAt(u)?--u==-1&&(t=a):(u=-1,t=h))}return s===t?t=h:t===-1&&(t=c.length),c.slice(s,t)}for(a=c.length-1;a>=0;--a)if(c.charCodeAt(a)===y){if(!r){s=a+1;break}}else t===-1&&(r=!1,t=a+1);return t===-1?"":c.slice(s,t)},extname(c){p(c,"path");let o=-1,s=0,t=-1,r=!0,a=0;for(let u=c.length-1;u>=0;--u){const h=c.charCodeAt(u);if(h===y){if(!r){s=u+1;break}continue}t===-1&&(r=!1,t=u+1),h===n?o===-1?o=u:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||t===-1||a===0||a===1&&o===t-1&&o===s+1?"":c.slice(o,t)},format:l.bind(null,"/"),parse(c){p(c,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return o;const s=c.charCodeAt(0)===y;let t;s?(o.root="/",t=1):t=0;let r=-1,a=0,u=-1,h=!0,f=c.length-1,P=0;for(;f>=t;--f){const A=c.charCodeAt(f);if(A===y){if(!h){a=f+1;break}continue}u===-1&&(h=!1,u=f+1),A===n?r===-1?r=f:P!==1&&(P=1):r!==-1&&(P=-1)}if(u!==-1){const A=a===0&&s?1:a;r===-1||P===0||P===1&&r===u-1&&r===a+1?o.base=o.name=c.slice(A,u):(o.name=c.slice(A,r),o.base=c.slice(A,u),o.ext=c.slice(r,u))}return a>0?o.dir=c.slice(0,a-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(X[78],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var v;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(v=e.ScanCode||(e.ScanCode={}));const R=[],D=Object.create(null),S=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>S[n]||0,toEnum:n=>D[n]||0,toString:n=>R[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class k{constructor(y,i,L,g,E){this.ctrlKey=y,this.shiftKey=i,this.altKey=L,this.metaKey=g,this.scanCode=E}equals(y){return this.ctrlKey===y.ctrlKey&&this.shiftKey===y.shiftKey&&this.altKey===y.altKey&&this.metaKey===y.metaKey&&this.scanCode===y.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=k,function(){function n(y,i){R[y]=i,D[i]=y,S[i.toLowerCase()]=y}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let y=0;y<=193;y++)e.IMMUTABLE_CODE_TO_KEY_CODE[y]=-1;for(let y=0;y<=112;y++)e.IMMUTABLE_KEY_CODE_TO_CODE[y]=-1;function n(y,i){e.IMMUTABLE_CODE_TO_KEY_CODE[y]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[i]=y)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(X[103],Q([0,1,58,78]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(k){k=k.toLowerCase().trim();let n=!1,y=!1,i=!1,L=!1,g;do g=!1,/^ctrl(\+|\-)/.test(k)&&(n=!0,k=k.substr("ctrl-".length),g=!0),/^shift(\+|\-)/.test(k)&&(y=!0,k=k.substr("shift-".length),g=!0),/^alt(\+|\-)/.test(k)&&(i=!0,k=k.substr("alt-".length),g=!0),/^meta(\+|\-)/.test(k)&&(L=!0,k=k.substr("meta-".length),g=!0),/^win(\+|\-)/.test(k)&&(L=!0,k=k.substr("win-".length),g=!0),/^cmd(\+|\-)/.test(k)&&(L=!0,k=k.substr("cmd-".length),g=!0);while(g);let E;const p=k.indexOf(" ");return p>0?(E=k.substring(0,p),k=k.substring(p)):(E=k,k=""),{remains:k,ctrl:n,shift:y,alt:i,meta:L,key:E}}static parseSimpleKeybinding(k){const n=this._readModifiers(k),y=v.KeyCodeUtils.fromUserSettings(n.key);return[new v.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,y),n.remains]}static parseKeybinding(k,n){if(!k)return null;const y=[];let i;do[i,k]=this.parseSimpleKeybinding(k),y.push(i);while(k.length>0);return new v.ChordKeybinding(y)}static parseSimpleUserBinding(k){const n=this._readModifiers(k),y=n.key.match(/^\[([^\]]+)\]$/);if(y){const L=y[1],g=R.ScanCodeUtils.lowerCaseToEnum(L);return[new R.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,g),n.remains]}const i=v.KeyCodeUtils.fromUserSettings(n.key);return[new v.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,i),n.remains]}static parseUserBinding(k){if(!k)return[];const n=[];let y;for(;k.length>0;)[y,k]=this.parseSimpleUserBinding(k),n.push(y);return n}}e.KeybindingParser=D}),define(X[104],Q([0,1,3]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=v.globals.performance&&typeof v.globals.performance.now=="function";class D{constructor(k){this._highResolution=R&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new D(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=D}),define(X[5],Q([0,1,18,43,2,77,104]),function($,e,v,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(w){w.None=()=>D.Disposable.None;function l(V){return(Y,U=null,O)=>{let z=!1,C;return C=V(I=>{if(!z)return C?C.dispose():z=!0,Y.call(U,I)},null,O),z&&C.dispose(),C}}w.once=l;function c(V,Y){return u((U,O=null,z)=>V(C=>U.call(O,Y(C)),null,z))}w.map=c;function o(V,Y){return u((U,O=null,z)=>V(C=>{Y(C),U.call(O,C)},null,z))}w.forEach=o;function s(V,Y){return u((U,O=null,z)=>V(C=>Y(C)&&U.call(O,C),null,z))}w.filter=s;function t(V){return V}w.signal=t;function r(...V){return(Y,U=null,O)=>(0,D.combinedDisposable)(...V.map(z=>z(C=>Y.call(U,C),null,O)))}w.any=r;function a(V,Y,U){let O=U;return c(V,z=>(O=Y(O,z),O))}w.reduce=a;function u(V){let Y;const U=new E({onFirstListenerAdd(){Y=V(U.fire,U)},onLastListenerRemove(){Y.dispose()}});return U.event}w.snapshot=u;function h(V,Y,U=100,O=!1,z){let C,I,M,_=0;const T=new E({leakWarningThreshold:z,onFirstListenerAdd(){C=V(W=>{_++,I=Y(I,W),O&&!M&&(T.fire(I),I=void 0),clearTimeout(M),M=setTimeout(()=>{const B=I;I=void 0,M=void 0,(!O||_>1)&&T.fire(B),_=0},U)})},onLastListenerRemove(){C.dispose()}});return T.event}w.debounce=h;function f(V){const Y=new Date().getTime();return c(l(V),U=>new Date().getTime()-Y)}w.stopwatch=f;function P(V){let Y=!0,U;return s(V,O=>{const z=Y||O!==U;return Y=!1,U=O,z})}w.latch=P;function A(V,Y=!1,U=[]){let O=U.slice(),z=V(M=>{O?O.push(M):I.fire(M)});const C=()=>{O&&O.forEach(M=>I.fire(M)),O=null},I=new E({onFirstListenerAdd(){z||(z=V(M=>I.fire(M)))},onFirstListenerDidAdd(){O&&(Y?setTimeout(C):C())},onLastListenerRemove(){z&&z.dispose(),z=null}});return I.event}w.buffer=A;class F{constructor(Y){this.event=Y}map(Y){return new F(c(this.event,Y))}forEach(Y){return new F(o(this.event,Y))}filter(Y){return new F(s(this.event,Y))}reduce(Y,U){return new F(a(this.event,Y,U))}latch(){return new F(P(this.event))}debounce(Y,U=100,O=!1,z){return new F(h(this.event,Y,U,O,z))}on(Y,U,O){return this.event(Y,U,O)}once(Y,U,O){return l(this.event)(Y,U,O)}}function N(V){return new F(V)}w.chain=N;function j(V,Y,U=O=>O){const O=(...M)=>I.fire(U(...M)),z=()=>V.on(Y,O),C=()=>V.removeListener(Y,O),I=new E({onFirstListenerAdd:z,onLastListenerRemove:C});return I.event}w.fromNodeEventEmitter=j;function G(V,Y,U=O=>O){const O=(...M)=>I.fire(U(...M)),z=()=>V.addEventListener(Y,O),C=()=>V.removeEventListener(Y,O),I=new E({onFirstListenerAdd:z,onLastListenerRemove:C});return I.event}w.fromDOMEventEmitter=G;function ne(V){const Y=new E;let U=!1;return V.then(void 0,()=>null).then(()=>{U?Y.fire(void 0):setTimeout(()=>Y.fire(void 0),0)}),U=!0,Y.event}w.fromPromise=ne;function oe(V){return new Promise(Y=>l(V)(Y))}w.toPromise=oe})(n=e.Event||(e.Event={}));class y{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${y._idPool++}`}start(l){this._stopWatch=new k.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let i=-1;function L(w){const l=i;return i=w,{dispose(){i=l}}}e.setGlobalLeakWarningThreshold=L;class g{constructor(l,c=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let c=i;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),!(c<=0||l<c)){this._stacks||(this._stacks=new Map);const o=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(o)||0;if(this._stacks.set(o,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let t,r=0;for(const[a,u]of this._stacks)(!t||r<u)&&(t=a,r=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(o)||0;this._stacks.set(o,t-1)}}}}class E{constructor(l){var c;this._disposed=!1,this._options=l,this._leakageMon=i>0?new g(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((c=this._options)===null||c===void 0?void 0:c._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(l,c,o)=>{var s;this._listeners||(this._listeners=new S.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(c?[l,c]:l);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,c);const a=(s=this._leakageMon)===null||s===void 0?void 0:s.check(this._listeners.size);let u;return u={dispose:()=>{a&&a(),u.dispose=E._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},o instanceof D.DisposableStore?o.add(u):Array.isArray(o)&&o.push(u),u}),this._event}fire(l){var c,o;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,l]);for((c=this._perfMon)===null||c===void 0||c.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,t]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,t):s[0].call(s[1],t)}catch(r){(0,v.onUnexpectedError)(r)}}(o=this._perfMon)===null||o===void 0||o.stop()}}dispose(){var l,c,o;(l=this._listeners)===null||l===void 0||l.clear(),(c=this._deliveryQueue)===null||c===void 0||c.clear(),(o=this._leakageMon)===null||o===void 0||o.dispose(),this._disposed=!0}}e.Emitter=E,E._noop=function(){};class p extends E{constructor(l){super(l);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=l==null?void 0:l.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=p;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const c={event:l,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const o=()=>{this.hasListeners&&this.unhook(c);const s=this.events.indexOf(c);this.events.splice(s,1)};return(0,D.toDisposable)((0,R.once)(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(c=>this.emitter.fire(c))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=d;class m{constructor(){this.buffers=[]}wrapEvent(l){return(c,o,s)=>l(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>c.call(o,t)):c.call(o,t)},void 0,s)}bufferEvents(l){const c=[];this.buffers.push(c);const o=l();return this.buffers.pop(),c.forEach(s=>s()),o}}e.EventBufferer=m;class b{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=D.Disposable.None,this.emitter=new E({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=b}),define(X[25],Q([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(n,y){const i=setTimeout(n.bind(y),0);return{dispose(){clearTimeout(i)}}});var D;(function(n){function y(i){return i===n.None||i===n.Cancelled||i instanceof S?!0:!i||typeof i!="object"?!1:typeof i.isCancellationRequested=="boolean"&&typeof i.onCancellationRequested=="function"}n.isCancellationToken=y,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(D=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=D.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=k}),define(X[105],Q([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(L){const g=this._icons.get(L.id);g?L.description?g.description=L.description:console.error(`Duplicate registration of codicon ${L.id}`):(this._icons.set(L.id,L),this._onDidRegister.fire(L))}get(L){return this._icons.get(L)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new R;e.iconRegistry=D;function S(i,L){return new k(i,L)}e.registerCodicon=S;class k{constructor(L,g,E){this.id=L,this.definition=g,this.description=E,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=k;function n(i,L){const g=["codicon","codicon-"+i];return L&&g.push("codicon-modifier-"+L),g}e.getClassNamesArray=n;var y;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const L=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function g(d){if(d instanceof k)return["codicon","codicon-"+d.id];const m=L.exec(d.id);if(!m)return g(k.error);let[,b,w]=m;const l=["codicon","codicon-"+b];return w&&l.push("codicon-modifier-"+w.substr(1)),l}i.asClassNameArray=g;function E(d){return g(d).join(" ")}i.asClassName=E;function p(d){return"."+g(d).join(".")}i.asCSSSelector=p})(y=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personAdd=new i("person-add",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(k=e.Codicon||(e.Codicon={}))}),define(X[59],Q([0,1,18,2]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(b){const w=b;return w&&[w.on,w.pause,w.resume,w.destroy].every(l=>typeof l=="function")}e.isReadableStream=D;function S(b){const w=b;return w&&D(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean"}e.isReadableBufferedStream=S;function k(b,w){return new n(b,w)}e.newWriteableStream=k;class n{constructor(w,l){this.reducer=w,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){var l;if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof((l=this.options)===null||l===void 0?void 0:l.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w!="undefined"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(l=>l(w))}emitError(w){this.listeners.error.length===0?(0,v.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(l=>l(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,l){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(w,l){if(!this.state.destroyed){let c;switch(w){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const o=c.indexOf(l);o>=0&&c.splice(o,1)}}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(b,w){const l=[];let c;for(;(c=b.read())!==null;)l.push(c);return w(l)}e.consumeReadable=y;function i(b,w,l){const c=[];let o;for(;(o=b.read())!==null&&c.length<l;)c.push(o);return o===null&&c.length>0?w(c):{read:()=>{if(c.length>0)return c.shift();if(typeof o!="undefined"){const s=o;return o=void 0,s}return b.read()}}}e.peekReadable=i;function L(b,w){return new Promise((l,c)=>{const o=[];g(b,{onData:s=>{w&&o.push(s)},onError:s=>{w?c(s):l(void 0)},onEnd:()=>{l(w?w(o):void 0)}})})}e.consumeStream=L;function g(b,w){b.on("error",l=>w.onError(l)),b.on("end",()=>w.onEnd()),b.on("data",l=>w.onData(l))}e.listenStream=g;function E(b,w){return new Promise((l,c)=>{const o=new R.DisposableStore,s=[],t=u=>{if(s.push(u),s.length>w)return o.dispose(),b.pause(),l({stream:b,buffer:s,ended:!1})},r=u=>c(u),a=()=>l({stream:b,buffer:s,ended:!0});o.add((0,R.toDisposable)(()=>b.removeListener("error",r))),b.on("error",r),o.add((0,R.toDisposable)(()=>b.removeListener("end",a))),b.on("end",a),o.add((0,R.toDisposable)(()=>b.removeListener("data",t))),b.on("data",t)})}e.peekStream=E;function p(b,w){const l=k(w);return l.end(b),l}e.toStream=p;function d(b){let w=!1;return{read:()=>w?null:(w=!0,b)}}e.toReadable=d;function m(b,w,l){const c=k(l);return g(b,{onData:o=>c.write(w.data(o)),onError:o=>c.error(w.error?w.error(o):o),onEnd:()=>c.end()}),c}e.transform=m}),define(X[19],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(q){return!q||typeof q!="string"?!0:q.trim().length===0}e.isFalsyOrWhitespace=v;const R=/{(\d+)}/g;function D(q,...te){return te.length===0?q:q.replace(R,function(se,le){const de=parseInt(le,10);return isNaN(de)||de<0||de>=te.length?se:te[de]})}e.format=D;function S(q){return q.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=S;function k(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function n(q,te){let se=0;const le=te.charCodeAt(0);for(let de=q.length-1;de>=0;de--)q.charCodeAt(de)===le&&se++;return se}e.count=n;function y(q,te,se="\u2026"){return q.length<=te?q:`${q.substr(0,te)}${se}`}e.truncate=y;function i(q,te=" "){const se=L(q,te);return g(se,te)}e.trim=i;function L(q,te){if(!q||!te)return q;const se=te.length;if(se===0||q.length===0)return q;let le=0;for(;q.indexOf(te,le)===le;)le=le+se;return q.substring(le)}e.ltrim=L;function g(q,te){if(!q||!te)return q;const se=te.length,le=q.length;if(se===0||le===0)return q;let de=le,ye=-1;for(;ye=q.lastIndexOf(te,de-1),!(ye===-1||ye+se!==de);){if(ye===0)return"";de=ye}return q.substring(0,de)}e.rtrim=g;function E(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=E;function p(q){return q.replace(/\*/g,"")}e.stripWildcards=p;function d(q,te,se={}){if(!q)throw new Error("Cannot create regex from empty string");te||(q=k(q)),se.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let le="";return se.global&&(le+="g"),se.matchCase||(le+="i"),se.multiline&&(le+="m"),se.unicode&&(le+="u"),new RegExp(q,le)}e.createRegExp=d;function m(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function b(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function w(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}e.regExpFlags=w;function l(q){return q.split(/\r\n|\r|\n/)}e.splitLines=l;function c(q){for(let te=0,se=q.length;te<se;te++){const le=q.charCodeAt(te);if(le!==32&&le!==9)return te}return-1}e.firstNonWhitespaceIndex=c;function o(q,te=0,se=q.length){for(let le=te;le<se;le++){const de=q.charCodeAt(le);if(de!==32&&de!==9)return q.substring(te,le)}return q.substring(te,se)}e.getLeadingWhitespace=o;function s(q,te=q.length-1){for(let se=te;se>=0;se--){const le=q.charCodeAt(se);if(le!==32&&le!==9)return se}return-1}e.lastNonWhitespaceIndex=s;function t(q,te){return q<te?-1:q>te?1:0}e.compare=t;function r(q,te,se=0,le=q.length,de=0,ye=te.length){for(;se<le&&de<ye;se++,de++){let Oe=q.charCodeAt(se),Ue=te.charCodeAt(de);if(Oe<Ue)return-1;if(Oe>Ue)return 1}const be=le-se,Te=ye-de;return be<Te?-1:be>Te?1:0}e.compareSubstring=r;function a(q,te){return u(q,te,0,q.length,0,te.length)}e.compareIgnoreCase=a;function u(q,te,se=0,le=q.length,de=0,ye=te.length){for(;se<le&&de<ye;se++,de++){let Oe=q.charCodeAt(se),Ue=te.charCodeAt(de);if(Oe!==Ue){const je=Oe-Ue;if(!(je===32&&f(Ue))&&!(je===-32&&f(Oe)))return h(Oe)&&h(Ue)?je:r(q.toLowerCase(),te.toLowerCase(),se,le,de,ye)}}const be=le-se,Te=ye-de;return be<Te?-1:be>Te?1:0}e.compareSubstringIgnoreCase=u;function h(q){return q>=97&&q<=122}e.isLowerAsciiLetter=h;function f(q){return q>=65&&q<=90}e.isUpperAsciiLetter=f;function P(q){return h(q)||f(q)}function A(q,te){return q.length===te.length&&F(q,te)}e.equalsIgnoreCase=A;function F(q,te,se=q.length){for(let le=0;le<se;le++){const de=q.charCodeAt(le),ye=te.charCodeAt(le);if(de!==ye){if(P(de)&&P(ye)){const be=Math.abs(de-ye);if(be!==0&&be!==32)return!1}else if(String.fromCharCode(de).toLowerCase()!==String.fromCharCode(ye).toLowerCase())return!1}}return!0}function N(q,te){const se=te.length;return te.length>q.length?!1:F(q,te,se)}e.startsWithIgnoreCase=N;function j(q,te){let se,le=Math.min(q.length,te.length);for(se=0;se<le;se++)if(q.charCodeAt(se)!==te.charCodeAt(se))return se;return le}e.commonPrefixLength=j;function G(q,te){let se,le=Math.min(q.length,te.length);const de=q.length-1,ye=te.length-1;for(se=0;se<le;se++)if(q.charCodeAt(de-se)!==te.charCodeAt(ye-se))return se;return le}e.commonSuffixLength=G;function ne(q){return 55296<=q&&q<=56319}e.isHighSurrogate=ne;function oe(q){return 56320<=q&&q<=57343}e.isLowSurrogate=oe;function V(q,te){return(q-55296<<10)+(te-56320)+65536}e.computeCodePoint=V;function Y(q,te,se){const le=q.charCodeAt(se);if(ne(le)&&se+1<te){const de=q.charCodeAt(se+1);if(oe(de))return V(le,de)}return le}e.getNextCodePoint=Y;function U(q,te){const se=q.charCodeAt(te-1);if(oe(se)&&te>1){const le=q.charCodeAt(te-2);if(ne(le))return V(le,se)}return se}function O(q,te){const se=Be.getInstance(),le=te,de=q.length,ye=Y(q,de,te);te+=ye>=65536?2:1;let be=se.getGraphemeBreakType(ye);for(;te<de;){const Te=Y(q,de,te),Oe=se.getGraphemeBreakType(Te);if(Ge(be,Oe))break;te+=Te>=65536?2:1,be=Oe}return te-le}e.nextCharLength=O;function z(q,te){const se=Be.getInstance(),le=te,de=U(q,te);te-=de>=65536?2:1;let ye=se.getGraphemeBreakType(de);for(;te>0;){const be=U(q,te),Te=se.getGraphemeBreakType(be);if(Ge(Te,ye))break;te-=be>=65536?2:1,ye=Te}return le-te}e.prevCharLength=z;function C(q,te){const se=Be.getInstance(),le=q.length,de=te,ye=Y(q,le,te),be=se.getGraphemeBreakType(ye);te+=ye>=65536?2:1;let Te=be;for(;te<le;){const Ue=Y(q,le,te),je=se.getGraphemeBreakType(Ue);if(Ge(Te,je))break;te+=Ue>=65536?2:1,Te=je}const Oe=te;for(te=de,Te=be;te>0;){const Ue=U(q,te),je=se.getGraphemeBreakType(Ue);if(Ge(je,Te))break;te-=Ue>=65536?2:1,Te=je}return[te,Oe]}function I(q,te){return te>0&&oe(q.charCodeAt(te))?C(q,te-1):C(q,te)}e.getCharContainingOffset=I;function M(q){const te=q.length;let se=0,le=0;for(;le<te;){const be=Y(q,te,le);le+=be>=65536?2:1,be<128?se+=1:be<2048?se+=2:be<65536?se+=3:se+=4}const de=new Uint8Array(se);le=0;let ye=0;for(;le<te;){const be=Y(q,te,le);le+=be>=65536?2:1,be<128?de[ye++]=be:be<2048?(de[ye++]=192|(be&1984)>>>6,de[ye++]=128|(be&63)>>>0):be<65536?(de[ye++]=224|(be&61440)>>>12,de[ye++]=128|(be&4032)>>>6,de[ye++]=128|(be&63)>>>0):(de[ye++]=240|(be&1835008)>>>18,de[ye++]=128|(be&258048)>>>12,de[ye++]=128|(be&4032)>>>6,de[ye++]=128|(be&63)>>>0)}return de}e.encodeUTF8=M;function _(q){const te=q.byteLength,se=[];let le=0;for(;le<te;){const de=q[le];let ye;if(de>=240&&le+3<te?ye=(q[le++]&7)<<18>>>0|(q[le++]&63)<<12>>>0|(q[le++]&63)<<6>>>0|(q[le++]&63)<<0>>>0:de>=224&&le+2<te?ye=(q[le++]&15)<<12>>>0|(q[le++]&63)<<6>>>0|(q[le++]&63)<<0>>>0:de>=192&&le+1<te?ye=(q[le++]&31)<<6>>>0|(q[le++]&63)<<0>>>0:ye=q[le++],ye>=0&&ye<=55295||ye>=57344&&ye<=65535)se.push(String.fromCharCode(ye));else if(ye>=65536&&ye<=1114111){const be=ye-65536,Te=55296+((be&1047552)>>>10),Oe=56320+((be&1023)>>>0);se.push(String.fromCharCode(Te)),se.push(String.fromCharCode(Oe))}else se.push(String.fromCharCode(65533))}return se.join("")}e.decodeUTF8=_;const T=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(q){return T.test(q)}e.containsRTL=W;const B=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function H(q){return B.test(q)}e.containsEmoji=H;const K=/^[\t\n\r\x20-\x7E]*$/;function J(q){return K.test(q)}e.isBasicASCII=J,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ee(q){return e.UNUSUAL_LINE_TERMINATORS.test(q)}e.containsUnusualLineTerminators=ee;function re(q){for(let te=0,se=q.length;te<se;te++)if(x(q.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=re;function x(q){return q=+q,q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}e.isFullWidthCharacter=x;function ie(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129003||q>=129280&&q<=129535||q>=129648&&q<=129750}e.isEmojiImprecise=ie;function ae(q,te){if(q.length<te)return q;const se=/\b/g;let le=0;for(;se.test(q)&&!(q.length-se.lastIndex<te);)le=se.lastIndex,se.lastIndex+=1;return q.substring(le).replace(/^\s/,"")}e.lcut=ae;const ue=/\x1B\x5B[12]?K/g,pe=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function fe(q){return q&&(q=q.replace(ue,""),q=q.replace(pe,""),q=q.replace(me,"")),q}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ve(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ve;function De(q){return ve(q)?q.substr(1):q}e.stripUTF8BOM=De;function Le(q,te){if(!q||!te||q.length<te.length)return!1;const se=te.length,le=q.toLowerCase();let de=0,ye=-1;for(;de<se;){const be=le.indexOf(te[de],ye+1);if(be<0)return!1;ye=be,de++}return!0}e.fuzzyContains=Le;function We(q,te=!1){return q?(te&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}e.containsUppercaseCharacter=We;function Ne(q){return q.charAt(0).toUpperCase()+q.slice(1)}e.uppercaseFirstLetter=Ne;function Ve(q,te=1){if(te===0)return"";let se=-1;do se=q.indexOf(`
`,se+1),te--;while(te>0&&se>=0);return se===-1?q:(q[se-1]==="\r"&&se--,q.substr(0,se))}e.getNLines=Ve;function xe(q){const te=90-65+1;return q=q%(2*te),q<te?String.fromCharCode(97+q):String.fromCharCode(65+q-te)}e.singleLetterHash=xe;function Xe(q){return Be.getInstance().getGraphemeBreakType(q)}e.getGraphemeBreakType=Xe;function Ge(q,te){return q===0?te!==5&&te!==7:q===2&&te===3?!1:q===4||q===2||q===3||te===4||te===2||te===3?!0:!(q===8&&(te===8||te===9||te===11||te===12)||(q===11||q===9)&&(te===9||te===10)||(q===12||q===10)&&te===10||te===5||te===13||te===7||q===1||q===13&&te===14||q===6&&te===6)}e.breakBetweenGraphemeBreakType=Ge;var st;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(st=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=it()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const se=this._data,le=se.length/3;let de=1;for(;de<=le;)if(te<se[3*de])de=2*de;else if(te>se[3*de+1])de=2*de+1;else return se[3*de+2];return 0}}Be._INSTANCE=null;function it(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(X[20],Q([0,1,19,59]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",k=typeof TextDecoder!="undefined";let n,y;class i{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return D?new i(Buffer.allocUnsafe(h)):new i(new Uint8Array(h))}static wrap(h){return D&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new i(h)}static fromString(h,f){return!((f==null?void 0:f.dontUseNodeBuffer)||!1)&&D?new i(Buffer.from(h)):S?(n||(n=new TextEncoder),new i(n.encode(h))):new i(v.encodeUTF8(h))}static concat(h,f){if(typeof f=="undefined"){f=0;for(let F=0,N=h.length;F<N;F++)f+=h[F].byteLength}const P=i.alloc(f);let A=0;for(let F=0,N=h.length;F<N;F++){const j=h[F];P.set(j,A),A+=j.byteLength}return P}toString(){return D?this.buffer.toString():k?(y||(y=new TextDecoder),y.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(h,f){return new i(this.buffer.subarray(h,f))}set(h,f){h instanceof i?this.buffer.set(h.buffer,f):this.buffer.set(h,f)}readUInt32BE(h){return E(this.buffer,h)}writeUInt32BE(h,f){p(this.buffer,h,f)}readUInt32LE(h){return d(this.buffer,h)}writeUInt32LE(h,f){m(this.buffer,h,f)}readUInt8(h){return b(this.buffer,h)}writeUInt8(h,f){w(this.buffer,h,f)}}e.VSBuffer=i;function L(u,h){return u[h+0]<<0>>>0|u[h+1]<<8>>>0}e.readUInt16LE=L;function g(u,h,f){u[f+0]=h&255,h=h>>>8,u[f+1]=h&255}e.writeUInt16LE=g;function E(u,h){return u[h]*2**24+u[h+1]*2**16+u[h+2]*2**8+u[h+3]}e.readUInt32BE=E;function p(u,h,f){u[f+3]=h,h=h>>>8,u[f+2]=h,h=h>>>8,u[f+1]=h,h=h>>>8,u[f]=h}e.writeUInt32BE=p;function d(u,h){return u[h+0]<<0>>>0|u[h+1]<<8>>>0|u[h+2]<<16>>>0|u[h+3]<<24>>>0}e.readUInt32LE=d;function m(u,h,f){u[f+0]=h&255,h=h>>>8,u[f+1]=h&255,h=h>>>8,u[f+2]=h&255,h=h>>>8,u[f+3]=h&255}e.writeUInt32LE=m;function b(u,h){return u[h]}e.readUInt8=b;function w(u,h,f){u[f]=h}e.writeUInt8=w;function l(u){return R.consumeReadable(u,h=>i.concat(h))}e.readableToBuffer=l;function c(u){return R.toReadable(u)}e.bufferToReadable=c;function o(u){return R.consumeStream(u,h=>i.concat(h))}e.streamToBuffer=o;async function s(u){return u.ended?i.concat(u.buffer):i.concat([...u.buffer,await o(u.stream)])}e.bufferedStreamToBuffer=s;function t(u){return R.toStream(u,h=>i.concat(h))}e.bufferToStream=t;function r(u){return R.transform(u,{data:h=>typeof h=="string"?i.fromString(h):i.wrap(h)},h=>i.concat(h))}e.streamToBufferReadableStream=r;function a(u){return R.newWriteableStream(h=>i.concat(h),u)}e.newWriteableBufferStream=a}),define(X[79],Q([0,1,19]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(w){return D(w,0)}e.hash=R;function D(w,l){switch(typeof w){case"object":return w===null?S(349,l):Array.isArray(w)?y(w,l):i(w,l);case"string":return n(w,l);case"boolean":return k(w,l);case"number":return S(w,l);case"undefined":return S(937,l);default:return S(617,l)}}e.doHash=D;function S(w,l){return(l<<5)-l+w|0}function k(w,l){return S(w?433:863,l)}function n(w,l){l=S(149417,l);for(let c=0,o=w.length;c<o;c++)l=S(w.charCodeAt(c),l);return l}e.stringHash=n;function y(w,l){return l=S(104579,l),w.reduce((c,o)=>D(o,c),l)}function i(w,l){return l=S(181387,l),Object.keys(w).sort().reduce((c,o)=>(c=n(o,c),D(w[o],c)),l)}class L{constructor(){this._value=0}get value(){return this._value}hash(l){return this._value=D(l,this._value),this._value}}e.Hasher=L;var g;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(g||(g={}));function E(w,l,c=32){const o=c-l,s=~((1<<o)-1);return(w<<l|(s&w)>>>o)>>>0}function p(w,l=0,c=w.byteLength,o=0){for(let s=0;s<c;s++)w[l+s]=o}function d(w,l,c="0"){for(;w.length<l;)w=c+w;return w}function m(w,l=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(c=>c.toString(16).padStart(2,"0")).join(""):d((w>>>0).toString(16),l/4)}e.toHexString=m;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(l){const c=l.length;if(c!==0){const o=this._buff;let s=this._buffLen,t=this._leftoverHighSurrogate,r,a;for(t!==0?(r=t,a=-1,t=0):(r=l.charCodeAt(0),a=0);;){let u=r;if(v.isHighSurrogate(r))if(a+1<c){const h=l.charCodeAt(a+1);v.isLowSurrogate(h)?(a++,u=v.computeCodePoint(r,h)):u=65533}else{t=r;break}else v.isLowSurrogate(r)&&(u=65533);if(s=this._push(o,s,u),a++,a<c)r=l.charCodeAt(a);else break}this._buffLen=s,this._leftoverHighSurrogate=t}}_push(l,c,o){return o<128?l[c++]=o:o<2048?(l[c++]=192|(o&1984)>>>6,l[c++]=128|(o&63)>>>0):o<65536?(l[c++]=224|(o&61440)>>>12,l[c++]=128|(o&4032)>>>6,l[c++]=128|(o&63)>>>0):(l[c++]=240|(o&1835008)>>>18,l[c++]=128|(o&258048)>>>12,l[c++]=128|(o&4032)>>>6,l[c++]=128|(o&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,l[0]=l[64+0],l[1]=l[64+1],l[2]=l[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const l=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(l/4294967296),!1),this._buffDV.setUint32(60,l%4294967296,!1),this._step()}_step(){const l=b._bigBlock32,c=this._buffDV;for(let P=0;P<64;P+=4)l.setUint32(P,c.getUint32(P,!1),!1);for(let P=64;P<320;P+=4)l.setUint32(P,E(l.getUint32(P-12,!1)^l.getUint32(P-32,!1)^l.getUint32(P-56,!1)^l.getUint32(P-64,!1),1),!1);let o=this._h0,s=this._h1,t=this._h2,r=this._h3,a=this._h4,u,h,f;for(let P=0;P<80;P++)P<20?(u=s&t|~s&r,h=1518500249):P<40?(u=s^t^r,h=1859775393):P<60?(u=s&t|s&r|t&r,h=2400959708):(u=s^t^r,h=3395469782),f=E(o,5)+u+a+h+l.getUint32(P*4,!1)&4294967295,a=r,r=t,t=E(s,30),s=o,o=f;this._h0=this._h0+o&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+a&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(X[13],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(f){return Array.isArray(f)}e.isArray=v;function R(f){return typeof f=="string"}e.isString=R;function D(f){return Array.isArray(f)&&f.every(P=>R(P))}e.isStringArray=D;function S(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=S;function k(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=k;function n(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=n;function y(f){return f===!0||f===!1}e.isBoolean=y;function i(f){return typeof f=="undefined"}e.isUndefined=i;function L(f){return!g(f)}e.isDefined=L;function g(f){return i(f)||f===null}e.isUndefinedOrNull=g;function E(f,P){if(!f)throw new Error(P?`Unexpected type, expected '${P}'`:"Unexpected type")}e.assertType=E;function p(f){if(g(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=p;function d(...f){const P=[];for(let A=0;A<f.length;A++){const F=f[A];if(g(F))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);P.push(F)}return P}e.assertAllDefined=d;const m=Object.prototype.hasOwnProperty;function b(f){if(!S(f))return!1;for(let P in f)if(m.call(f,P))return!1;return!0}e.isEmptyObject=b;function w(f){return typeof f=="function"}e.isFunction=w;function l(...f){return f.length>0&&f.every(w)}e.areFunctions=l;function c(f,P){const A=Math.min(f.length,P.length);for(let F=0;F<A;F++)o(f[F],P[F])}e.validateConstraints=c;function o(f,P){if(R(P)){if(typeof f!==P)throw new Error(`argument does not match constraint: typeof ${P}`)}else if(w(P)){try{if(f instanceof P)return}catch(A){}if(!g(f)&&f.constructor===P||P.length===1&&P.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function s(f){let P=[],A=Object.getPrototypeOf(f);for(;Object.prototype!==A;)P=P.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return P}e.getAllPropertyNames=s;function t(f){const P=[];for(const A of s(f))typeof f[A]=="function"&&P.push(A);return P}e.getAllMethodNames=t;function r(f,P){const A=N=>function(){const j=Array.prototype.slice.call(arguments,0);return P(N,j)};let F={};for(const N of f)F[N]=A(N);return F}e.createProxyObject=r;function a(f){return f===null?void 0:f}e.withNullAsUndefined=a;function u(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=u;function h(f){return class{constructor(){return new Proxy({},{get(P,A){if(P[A])return P[A];throw new Error(`Not Implemented: ${f}->${String(A)}`)}})}}}e.NotImplementedProxy=h}),define(X[30],Q([0,1,3,19,8,13]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function k(r){return r===47||r===92}e.isPathSeparator=k;function n(r){return r.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=n;function y(r,a=D.posix.sep){if(!r)return"";const u=r.length,h=r.charCodeAt(0);if(k(h)){if(k(r.charCodeAt(1))&&!k(r.charCodeAt(2))){let P=3;const A=P;for(;P<u&&!k(r.charCodeAt(P));P++);if(A!==P&&!k(r.charCodeAt(P+1))){for(P+=1;P<u;P++)if(k(r.charCodeAt(P)))return r.slice(0,P+1).replace(/[\\/]/g,a)}}return a}else if(b(h)&&r.charCodeAt(1)===58)return k(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<u;f++)if(k(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.getRoot=y;function i(r){if(!v.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let u=2;const h=u;for(;u<r.length&&(a=r.charCodeAt(u),a!==92);u++);return!(h===u||(a=r.charCodeAt(u+1),isNaN(a)||a===92))}e.isUNC=i;const L=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(r,a=v.isWindows){const u=a?L:g;return!(!r||r.length===0||/^\s+$/.test(r)||(u.lastIndex=0,u.test(r))||a&&E.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=p;function d(r,a,u){const h=r===a;return!u||h?h:!r||!a?!1:(0,R.equalsIgnoreCase)(r,a)}e.isEqual=d;function m(r,a,u,h=D.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(u){if(!(0,R.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let P=a.length;return a.charAt(a.length-1)===h&&P--,r.charAt(P)===h}return a.charAt(a.length-1)!==h&&(a+=h),r.indexOf(a)===0}e.isEqualOrParent=m;function b(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=b;function w(r,a){return v.isWindows&&r.endsWith(":")&&(r+=D.sep),(0,D.isAbsolute)(r)||(r=(0,D.join)(a,r)),r=(0,D.normalize)(r),v.isWindows?(r=(0,R.rtrim)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,R.rtrim)(r,D.sep),r||(r=D.sep)),r}e.sanitizeFilePath=w;function l(r){const a=(0,D.normalize)(r);return v.isWindows?r.length>3?!1:c(a)&&(r.length===2||a.charCodeAt(2)===92):a===D.posix.sep}e.isRootOrDriveLetter=l;function c(r){return v.isWindows?b(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function o(r){return c(r)?r[0]:void 0}e.getDriveLetter=o;function s(r,a,u){return a.length>r.length?-1:r===a?0:(u&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=s;function t(r){const a=r.split(":");let u,h,f;if(a.forEach(P=>{const A=Number(P);(0,S.isNumber)(A)?h===void 0?h=A:f===void 0&&(f=A):u=u?[u,P].join(":"):P}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:h!==void 0?h:void 0,column:f!==void 0?f:h!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(X[45],Q([0,1,13]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const m=Array.isArray(d)?[]:{};return Object.keys(d).forEach(b=>{d[b]&&typeof d[b]=="object"?m[b]=R(d[b]):m[b]=d[b]}),m}e.deepClone=R;function D(d){if(!d||typeof d!="object")return d;const m=[d];for(;m.length>0;){const b=m.shift();Object.freeze(b);for(const w in b)if(S.call(b,w)){const l=b[w];typeof l=="object"&&!Object.isFrozen(l)&&m.push(l)}}return d}e.deepFreeze=D;const S=Object.prototype.hasOwnProperty;function k(d,m){return n(d,m,new Set)}e.cloneAndChange=k;function n(d,m,b){if((0,v.isUndefinedOrNull)(d))return d;const w=m(d);if(typeof w!="undefined")return w;if((0,v.isArray)(d)){const l=[];for(const c of d)l.push(n(c,m,b));return l}if((0,v.isObject)(d)){if(b.has(d))throw new Error("Cannot clone recursive data-structure");b.add(d);const l={};for(let c in d)S.call(d,c)&&(l[c]=n(d[c],m,b));return b.delete(d),l}return d}function y(d,m,b=!0){return(0,v.isObject)(d)?((0,v.isObject)(m)&&Object.keys(m).forEach(w=>{w in d?b&&((0,v.isObject)(d[w])&&(0,v.isObject)(m[w])?y(d[w],m[w],b):d[w]=m[w]):d[w]=m[w]}),d):m}e.mixin=y;function i(d,m){if(d===m)return!0;if(d==null||m===null||m===void 0||typeof d!=typeof m||typeof d!="object"||Array.isArray(d)!==Array.isArray(m))return!1;let b,w;if(Array.isArray(d)){if(d.length!==m.length)return!1;for(b=0;b<d.length;b++)if(!i(d[b],m[b]))return!1}else{const l=[];for(w in d)l.push(w);l.sort();const c=[];for(w in m)c.push(w);if(c.sort(),!i(l,c))return!1;for(b=0;b<l.length;b++)if(!i(d[l[b]],m[l[b]]))return!1}return!0}e.equals=i;function L(d){const m=new Set;return JSON.stringify(d,(b,w)=>{if((0,v.isObject)(w)||Array.isArray(w)){if(m.has(w))return"[Circular]";m.add(w)}return w})}e.safeStringify=L;function g(d,m,b){const w=m(d);return typeof w=="undefined"?b:w}e.getOrDefault=g;function E(d,m){const b=Object.create(null);return!d||!m||Object.keys(m).forEach(l=>{const c=d[l],o=m[l];i(c,o)||(b[l]=o)}),b}e.distinct=E;function p(d,m){const b=m.toLowerCase(),w=Object.keys(d).find(l=>l.toLowerCase()===b);return w?d[w]:d[m]}e.getCaseInsensitive=p}),define(X[7],Q([0,1,3,8]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,S=/^\//,k=/^\/\//;function n(a,u){if(!a.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!D.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!S.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(a,u){return!a&&!u?"file":a}function i(a,u){switch(a){case"https":case"http":case"file":u?u[0]!==g&&(u=g+u):u=g;break}return u}const L="",g="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(u,h,f,P,A,F=!1){typeof u=="object"?(this.scheme=u.scheme||L,this.authority=u.authority||L,this.path=u.path||L,this.query=u.query||L,this.fragment=u.fragment||L):(this.scheme=y(u,F),this.authority=h||L,this.path=i(this.scheme,f||L),this.query=P||L,this.fragment=A||L,n(this,F))}static isUri(u){return u instanceof p?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}get fsPath(){return c(this,!1)}with(u){if(!u)return this;let{scheme:h,authority:f,path:P,query:A,fragment:F}=u;return h===void 0?h=this.scheme:h===null&&(h=L),f===void 0?f=this.authority:f===null&&(f=L),P===void 0?P=this.path:P===null&&(P=L),A===void 0?A=this.query:A===null&&(A=L),F===void 0?F=this.fragment:F===null&&(F=L),h===this.scheme&&f===this.authority&&P===this.path&&A===this.query&&F===this.fragment?this:new m(h,f,P,A,F)}static parse(u,h=!1){const f=E.exec(u);return f?new m(f[2]||L,r(f[4]||L),r(f[5]||L),r(f[7]||L),r(f[9]||L),h):new m(L,L,L,L,L)}static file(u){let h=L;if(v.isWindows&&(u=u.replace(/\\/g,g)),u[0]===g&&u[1]===g){const f=u.indexOf(g,2);f===-1?(h=u.substring(2),u=g):(h=u.substring(2,f),u=u.substring(f)||g)}return new m("file",h,u,L,L)}static from(u){return new m(u.scheme,u.authority,u.path,u.query,u.fragment)}static joinPath(u,...h){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return v.isWindows&&u.scheme==="file"?f=p.file(R.win32.join(c(u,!0),...h)).path:f=R.posix.join(u.path,...h),u.with({path:f})}toString(u=!1){return o(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof p)return u;{const h=new m(u);return h._formatted=u.external,h._fsPath=u._sep===d?u.fsPath:null,h}}else return u}}e.URI=p;const d=v.isWindows?1:void 0;class m extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(u=!1){return u?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=d),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(a,u){let h,f=-1;for(let P=0;P<a.length;P++){const A=a.charCodeAt(P);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||u&&A===47)f!==-1&&(h+=encodeURIComponent(a.substring(f,P)),f=-1),h!==void 0&&(h+=a.charAt(P));else{h===void 0&&(h=a.substr(0,P));const F=b[A];F!==void 0?(f!==-1&&(h+=encodeURIComponent(a.substring(f,P)),f=-1),h+=F):f===-1&&(f=P)}}return f!==-1&&(h+=encodeURIComponent(a.substring(f))),h!==void 0?h:a}function l(a){let u;for(let h=0;h<a.length;h++){const f=a.charCodeAt(h);f===35||f===63?(u===void 0&&(u=a.substr(0,h)),u+=b[f]):u!==void 0&&(u+=a[h])}return u!==void 0?u:a}function c(a,u){let h;return a.authority&&a.path.length>1&&a.scheme==="file"?h=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?u?h=a.path.substr(1):h=a.path[1].toLowerCase()+a.path.substr(2):h=a.path,v.isWindows&&(h=h.replace(/\//g,"\\")),h}e.uriToFsPath=c;function o(a,u){const h=u?l:w;let f="",{scheme:P,authority:A,path:F,query:N,fragment:j}=a;if(P&&(f+=P,f+=":"),(A||P==="file")&&(f+=g,f+=g),A){let G=A.indexOf("@");if(G!==-1){const ne=A.substr(0,G);A=A.substr(G+1),G=ne.indexOf(":"),G===-1?f+=h(ne,!1):(f+=h(ne.substr(0,G),!1),f+=":",f+=h(ne.substr(G+1),!1)),f+="@"}A=A.toLowerCase(),G=A.indexOf(":"),G===-1?f+=h(A,!1):(f+=h(A.substr(0,G),!1),f+=A.substr(G))}if(F){if(F.length>=3&&F.charCodeAt(0)===47&&F.charCodeAt(2)===58){const G=F.charCodeAt(1);G>=65&&G<=90&&(F=`/${String.fromCharCode(G+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===58){const G=F.charCodeAt(0);G>=65&&G<=90&&(F=`${String.fromCharCode(G+32)}:${F.substr(2)}`)}f+=h(F,!0)}return N&&(f+="?",f+=h(N,!1)),j&&(f+="#",f+=u?j:w(j,!1)),f}function s(a){try{return decodeURIComponent(a)}catch(u){return a.length>3?a.substr(0,3)+s(a.substr(3)):a}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(a){return a.match(t)?a.replace(t,u=>s(u)):a}}),define(X[106],Q([0,1,7]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(i){const L=i;return L&&typeof L.type=="string"&&typeof L.severity=="string"}e.isRemoteConsoleLog=R;function D(i){const L=[];let g;try{const E=JSON.parse(i.arguments),p=E[E.length-1];p&&p.__$stack&&(E.pop(),g=p.__$stack),L.push(...E)}catch(E){L.push("Unable to log remote console arguments",i.arguments)}return{args:L,stack:g}}e.parse=D;function S(i){if(typeof i!="string")return S(D(i).stack);const L=i;if(L){const g=k(L),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(g||"");if(E&&E.length===4)return{uri:v.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=S;function k(i){if(!i)return i;const L=i.indexOf(`
`);return L===-1?i:i.substring(0,L)}function n(i,L){const{args:g,stack:E}=D(i),p=typeof g[0]=="string"&&g.length===1;let d=k(E);d&&(d=`(${d.trim()})`);let m=[];if(typeof g[0]=="string"?d&&p?m=[`%c[${L}] %c${g[0]} %c${d}`,y("blue"),y(""),y("grey")]:m=[`%c[${L}] %c${g[0]}`,y("blue"),y(""),...g.slice(1)]:m=[`%c[${L}]%`,y("blue"),...g],d&&!p&&m.push(d),typeof console[i.severity]!="function")throw new Error("Unknown console method");console[i.severity].apply(console,m)}e.log=n;function y(i){return`color: ${i}`}}),define(X[36],Q([0,1,7,19]),function($,e,v,R){"use strict";var D,S;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(o,s,t){let r=o.get(s);return r===void 0&&(r=t,o.set(s,r)),r}e.getOrSet=k;function n(o){const s=[];return o.forEach((t,r)=>{s.push(`${r} => ${t}`)}),`Map(${o.size}) {${s.join(", ")}}`}e.mapToString=n;function y(o){const s=[];return o.forEach(t=>{s.push(t)}),`Set(${o.size}) {${s.join(", ")}}`}e.setToString=y;class i{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const t=s.charCodeAt(0),r=this._value.charCodeAt(this._pos);return t-r}value(){return this._value[this._pos]}}e.StringIterator=i;class L{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,R.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=L;class g{constructor(s=!0,t=!0){this._splitOnBackslash=s,this._caseSensitive=t}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,R.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var E;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(E||(E={}));class p{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,R.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class d{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class m{constructor(s){this._iter=s}static forUris(s=()=>!1){return new m(new p(s))}static forPaths(){return new m(new g)}static forStrings(){return new m(new i)}static forConfigKeys(){return new m(new L)}clear(){this._root=void 0}set(s,t){const r=this._iter.reset(s);let a;for(this._root||(this._root=new d,this._root.segment=r.value()),a=this._root;;){const h=r.cmp(a.segment);if(h>0)a.left||(a.left=new d,a.left.segment=r.value()),a=a.left;else if(h<0)a.right||(a.right=new d,a.right.segment=r.value()),a=a.right;else if(r.hasNext())r.next(),a.mid||(a.mid=new d,a.mid.segment=r.value()),a=a.mid;else break}const u=a.value;return a.value=t,a.key=s,u}get(s){var t;return(t=this._getNode(s))===null||t===void 0?void 0:t.value}_getNode(s){const t=this._iter.reset(s);let r=this._root;for(;r;){const a=t.cmp(r.segment);if(a>0)r=r.left;else if(a<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else break}return r}has(s){const t=this._getNode(s);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,t){const r=this._iter.reset(s),a=[];let u=this._root;for(;u;){const h=r.cmp(u.segment);if(h>0)a.push([1,u]),u=u.left;else if(h<0)a.push([-1,u]),u=u.right;else if(r.hasNext())r.next(),a.push([0,u]),u=u.mid;else{for(t?(u.left=void 0,u.mid=void 0,u.right=void 0):u.value=void 0;a.length>0&&u.isEmpty();){let[f,P]=a.pop();switch(f){case 1:P.left=void 0;break;case 0:P.mid=void 0;break;case-1:P.right=void 0;break}u=P}break}}}findSubstr(s){const t=this._iter.reset(s);let r=this._root,a;for(;r;){const u=t.cmp(r.segment);if(u>0)r=r.left;else if(u<0)r=r.right;else if(t.hasNext())t.next(),a=r.value||a,r=r.mid;else break}return r&&r.value||a}findSuperstr(s){const t=this._iter.reset(s);let r=this._root;for(;r;){const a=t.cmp(r.segment);if(a>0)r=r.left;else if(a<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(s){for(const[t,r]of this)s(r,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){s&&(yield*this._entries(s.left),s.value&&(yield[s.key,s.value]),yield*this._entries(s.mid),yield*this._entries(s.right))}}e.TernarySearchTree=m;class b{constructor(s,t){this[D]="ResourceMap",s instanceof b?(this.map=new Map(s.map),this.toKey=t!=null?t:b.defaultToKey):(this.map=new Map,this.toKey=s!=null?s:b.defaultToKey)}set(s,t){return this.map.set(this.toKey(s),t),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,t){typeof t!="undefined"&&(s=s.bind(t));for(let[r,a]of this.map)s(a,v.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield v.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[v.URI.parse(s[0]),s[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[v.URI.parse(s[0]),s[1]]}}e.ResourceMap=b,b.defaultToKey=o=>o.toString();var w;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class l{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var s;return(s=this._head)===null||s===void 0?void 0:s.value}get last(){var s;return(s=this._tail)===null||s===void 0?void 0:s.value}has(s){return this._map.has(s)}get(s,t=0){const r=this._map.get(s);if(!!r)return t!==0&&this.touch(r,t),r.value}set(s,t,r=0){let a=this._map.get(s);if(a)a.value=t,r!==0&&this.touch(a,r);else{switch(a={key:s,value:t,next:void 0,previous:void 0},r){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(s,a),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const t=this._map.get(s);if(!!t)return this._map.delete(s),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}}forEach(s,t){const r=this._state;let a=this._head;for(;a;){if(t?s.bind(t)(a.value,a.key,this):s(a.value,a.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const s=this,t=this._state;let r=this._head;const a={[Symbol.iterator](){return a},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const u={value:r.key,done:!1};return r=r.next,u}else return{value:void 0,done:!0}}};return a}values(){const s=this,t=this._state;let r=this._head;const a={[Symbol.iterator](){return a},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const u={value:r.value,done:!1};return r=r.next,u}else return{value:void 0,done:!0}}};return a}entries(){const s=this,t=this._state;let r=this._head;const a={[Symbol.iterator](){return a},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const u={value:[r.key,r.value],done:!1};return r=r.next,u}else return{value:void 0,done:!0}}};return a}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(!(s>=this.size)){if(s===0){this.clear();return}let t=this._head,r=this.size;for(;t&&r>s;)this._map.delete(t.key),t=t.next,r--;this._head=t,this._size=r,t&&(t.previous=void 0),this._state++}}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const t=s.next,r=s.previous;if(!t||!r)throw new Error("Invalid list");t.previous=r,r.next=t}s.next=void 0,s.previous=void 0,this._state++}touch(s,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(s===this._head)return;const r=s.next,a=s.previous;s===this._tail?(a.next=void 0,this._tail=a):(r.previous=a,a.next=r),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(t===2){if(s===this._tail)return;const r=s.next,a=s.previous;s===this._head?(r.previous=void 0,this._head=r):(r.previous=a,a.next=r),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((t,r)=>{s.push([r,t])}),s}fromJSON(s){this.clear();for(const[t,r]of s)this.set(t,r)}}e.LinkedMap=l;class c extends l{constructor(s,t=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,t=2){return super.get(s,t)}peek(s){return super.get(s,0)}set(s,t){return super.set(s,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c}),define(X[107],Q([0,1,20,19,7]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function S(i){return JSON.stringify(i,n)}e.stringify=S;function k(i){let L=JSON.parse(i);return L=y(L),L}e.parse=k;function n(i,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,R.regExpFlags)(L)}:L}function y(i,L=0){if(!i||L>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return D.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof v.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let g=0;g<i.length;++g)i[g]=y(i[g],L+1);else for(const g in i)Object.hasOwnProperty.call(i,g)&&(i[g]=y(i[g],L+1))}return i}e.revive=y}),define(X[9],Q([0,1,7,3]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.vscodeWebviewResource="vscode-webview-resource",n.extension="extension",n.vscodeFileResource="vscode-file"})(D=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,i,L){this._hosts[y]=i,this._ports[y]=L}setConnectionToken(y,i){this._connectionTokens[y]=i}rewrite(y){if(this._delegate)return this._delegate(y);const i=y.authority;let L=this._hosts[i];L&&L.indexOf(":")!==-1&&(L=`[${L}]`);const g=this._ports[i],E=this._connectionTokens[i];let p=`path=${encodeURIComponent(y.path)}`;return typeof E=="string"&&(p+=`&tkn=${encodeURIComponent(E)}`),v.URI.from({scheme:R.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${L}:${g}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new S;class k{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,i,L){const g=this.toUri(y,i);return g.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(g):R.isNative&&(L||R.isPreferringBrowserCodeLoad)&&g.scheme===D.file?g.with({scheme:D.vscodeFileResource,authority:g.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):g}asFileUri(y,i){const L=this.toUri(y,i);return L.scheme===D.vscodeFileResource?L.with({scheme:D.file,authority:L.authority!==this.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(y,i){return v.URI.isUri(y)?y:v.URI.parse(i.toUrl(y))}}e.FileAccess=new k}),define(X[65],Q([0,1,36]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new v.LRUCache(1e4);function D(i){return y(i,"NFC",R)}e.normalizeNFC=D;const S=new v.LRUCache(1e4);function k(i){return y(i,"NFD",S)}e.normalizeNFD=k;const n=/[^\u0000-\u0080]/;function y(i,L,g){if(!e.canNormalize||!i)return i;const E=g.get(i);if(E)return E;let p;return n.test(i)?p=i.normalize(L):p=i,g.set(i,p),p}e.removeAccents=function(){if(e.canNormalize){const i=/[\u0300-\u036f]/g;return function(L){return k(L).replace(i,"")}}else return function(i){return i}}()}),define(X[15],Q([0,1,30,8,7,19,9,3]),function($,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(p){return(0,D.uriToFsPath)(p,!0)}e.originalFSPath=y;class i{constructor(d){this._ignorePathCasing=d}compare(d,m,b=!1){return d===m?0:(0,S.compare)(this.getComparisonKey(d,b),this.getComparisonKey(m,b))}isEqual(d,m,b=!1){return d===m?!0:!d||!m?!1:this.getComparisonKey(d,b)===this.getComparisonKey(m,b)}getComparisonKey(d,m=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,m,b=!1){if(d.scheme===m.scheme){if(d.scheme===k.Schemas.file)return v.isEqualOrParent(y(d),y(m),this._ignorePathCasing(d))&&d.query===m.query&&(b||d.fragment===m.fragment);if((0,e.isEqualAuthority)(d.authority,m.authority))return v.isEqualOrParent(d.path,m.path,this._ignorePathCasing(d),"/")&&d.query===m.query&&(b||d.fragment===m.fragment)}return!1}joinPath(d,...m){return D.URI.joinPath(d,...m)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return R.posix.basename(d.path)}extname(d){return R.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let m;return d.scheme===k.Schemas.file?m=D.URI.file(R.dirname(y(d))).path:(m=R.posix.dirname(d.path),d.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),m="/")),d.with({path:m})}normalizePath(d){if(!d.path.length)return d;let m;return d.scheme===k.Schemas.file?m=D.URI.file(R.normalize(y(d))).path:m=R.posix.normalize(d.path),d.with({path:m})}relativePath(d,m){if(!(d.scheme!==m.scheme||!(0,e.isEqualAuthority)(d.authority,m.authority))){if(d.scheme===k.Schemas.file){const l=R.relative(y(d),y(m));return n.isWindows?v.toSlashes(l):l}let b=d.path||"/",w=m.path||"/";if(this._ignorePathCasing(d)){let l=0;for(const c=Math.min(b.length,w.length);l<c&&!(b.charCodeAt(l)!==w.charCodeAt(l)&&b.charAt(l).toLowerCase()!==w.charAt(l).toLowerCase());l++);b=w.substr(0,l)+b.substr(l)}return R.posix.relative(b,w)}}resolvePath(d,m){if(d.scheme===k.Schemas.file){const b=D.URI.file(R.resolve(y(d),m));return d.with({authority:b.authority,path:b.path})}return m.indexOf("/")===-1&&(m=v.toSlashes(m),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m)),d.with({path:R.posix.resolve(d.path,m)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,m){return d===m||(0,S.equalsIgnoreCase)(d,m)}hasTrailingPathSeparator(d,m=R.sep){if(d.scheme===k.Schemas.file){const b=y(d);return b.length>v.getRoot(b).length&&b[b.length-1]===m}else{const b=d.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,m=R.sep){return(0,e.hasTrailingPathSeparator)(d,m)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,m=R.sep){let b=!1;if(d.scheme===k.Schemas.file){const w=y(d);b=w!==void 0&&w.length===v.getRoot(w).length&&w[w.length-1]===m}else{m="/";const w=d.path;b=w.length===1&&w.charCodeAt(w.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(d,m)?d.with({path:d.path+"/"}):d}}e.ExtUri=i,e.extUri=new i(()=>!1),e.extUriBiasedIgnorePathCase=new i(p=>p.scheme===k.Schemas.file?!n.isLinux:!0),e.extUriIgnorePathCase=new i(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(p,d){const m=[];for(let b=0;b<p.length;b++){const w=d(p[b]);p.some((l,c)=>c===b?!1:(0,e.isEqualOrParent)(w,d(l)))||m.push(p[b])}return m}e.distinctParents=L;var g;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function d(m){const b=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(c=>{const[o,s]=c.split(":");o&&s&&b.set(o,s)});const l=m.path.substring(0,m.path.indexOf(";"));return l&&b.set(p.META_DATA_MIME,l),b}p.parseMetaData=d})(g=e.DataUri||(e.DataUri={}));function E(p,d,m){if(d){let b=p.path;return b&&b[0]!==R.posix.sep&&(b=R.posix.sep+b),p.with({scheme:m,authority:d,path:b})}return p.with({scheme:m})}e.toLocalResource=E}),define(X[10],Q([0,1,25,18,5,2,77,15]),function($,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(C){return!!C&&typeof C.then=="function"}e.isThenable=y;function i(C){const I=new v.CancellationTokenSource,M=C(I.token),_=new Promise((T,W)=>{I.token.onCancellationRequested(()=>{W((0,R.canceled)())}),Promise.resolve(M).then(B=>{I.dispose(),T(B)},B=>{I.dispose(),W(B)})});return new class{cancel(){I.cancel()}then(T,W){return _.then(T,W)}catch(T){return this.then(void 0,T)}finally(T){return _.finally(T)}}}e.createCancelablePromise=i;function L(C,I,M){return Promise.race([C,new Promise(_=>I.onCancellationRequested(()=>_(M)))])}e.raceCancellation=L;async function g(C){let I=-1;const M=C.map((T,W)=>T.then(B=>(I=W,B))),_=await Promise.race(M);return C.forEach((T,W)=>{W!==I&&T.cancel()}),_}e.raceCancellablePromises=g;function E(C,I,M){let _;const T=setTimeout(()=>{_==null||_(void 0),M==null||M()},I);return Promise.race([C.finally(()=>clearTimeout(T)),new Promise(W=>_=W)])}e.raceTimeout=E;function p(C){return new Promise((I,M)=>{const _=C();y(_)?_.then(I,M):I(_)})}e.asPromise=p;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(I){if(this.activePromise){if(this.queuedPromiseFactory=I,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(M,M).then(_)})}return new Promise((M,_)=>{this.queuedPromise.then(M,_)})}return this.activePromise=I(),new Promise((M,_)=>{this.activePromise.then(T=>{this.activePromise=null,M(T)},T=>{this.activePromise=null,_(T)})})}}e.Throttler=d;class m{constructor(){this.current=Promise.resolve(null)}queue(I){return this.current=this.current.then(()=>I(),()=>I())}}e.Sequencer=m;class b{constructor(){this.promiseMap=new Map}queue(I,M){var _;const W=((_=this.promiseMap.get(I))!==null&&_!==void 0?_:Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(I)===W&&this.promiseMap.delete(I)});return this.promiseMap.set(I,W),W}}e.SequencerByKey=b;class w{constructor(I){this.defaultDelay=I,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(I,M=this.defaultDelay){return this.task=I,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((_,T)=>{this.doResolve=_,this.doReject=T}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const _=this.task;return this.task=null,_()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},M),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=w;class l{constructor(I){this.delayer=new w(I),this.throttler=new d}trigger(I,M){return this.delayer.trigger(()=>this.throttler.queue(I),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class c{constructor(){this._isOpen=!1,this._promise=new Promise((I,M)=>{this._completePromise=I})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class o extends c{constructor(I){super();this._timeout=setTimeout(()=>this.open(),I)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function s(C,I){return I?new Promise((M,_)=>{const T=setTimeout(M,C);I.onCancellationRequested(()=>{clearTimeout(T),_((0,R.canceled)())})}):i(M=>s(C,M))}e.timeout=s;function t(C,I=0){const M=setTimeout(C,I);return(0,S.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=t;function r(C){return C.then(void 0,I=>{})}e.ignoreErrors=r;function a(C){const I=[];let M=0;const _=C.length;function T(){return M<_?C[M++]():null}function W(B){B!=null&&I.push(B);const H=T();return H?H.then(W):Promise.resolve(I)}return Promise.resolve(null).then(W)}e.sequence=a;function u(C,I=_=>!!_,M=null){let _=0;const T=C.length,W=()=>{if(_>=T)return Promise.resolve(M);const B=C[_++];return Promise.resolve(B()).then(K=>I(K)?Promise.resolve(K):W())};return W()}e.first=u;function h(C,I=_=>!!_,M=null){if(C.length===0)return Promise.resolve(M);let _=C.length;const T=()=>{var W,B;_=-1;for(const H of C)(B=(W=H).cancel)===null||B===void 0||B.call(W)};return new Promise((W,B)=>{for(const H of C)H.then(K=>{--_>=0&&I(K)?(T(),W(K)):_===0&&W(M)}).catch(K=>{--_>=0&&(T(),B(K))})})}e.firstParallel=h;class f{constructor(I){this._size=0,this.maxDegreeOfParalellism=I,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(I){return this._size++,new Promise((M,_)=>{this.outstandingPromises.push({factory:I,c:M,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const I=this.outstandingPromises.shift();this.runningPromises++;const M=I.factory();M.then(I.c,I.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class P extends f{constructor(){super(1)}}e.Queue=P;class A{constructor(){this.queues=new Map}queueFor(I,M=n.extUri){const _=M.getComparisonKey(I);let T=this.queues.get(_);return T||(T=new P,D.Event.once(T.onFinished)(()=>{T==null||T.dispose(),this.queues.delete(_)}),this.queues.set(_,T)),T}dispose(){this.queues.forEach(I=>I.dispose()),this.queues.clear()}}e.ResourceQueue=A;class F{constructor(I,M){this._token=-1,typeof I=="function"&&typeof M=="number"&&this.setIfNotSet(I,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(I,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,I()},M)}setIfNotSet(I,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,I()},M))}}e.TimeoutTimer=F;class N{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(I,M){this.cancel(),this._token=setInterval(()=>{I()},M)}}e.IntervalTimer=N;class j{constructor(I,M){this.timeoutToken=-1,this.runner=I,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(I=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,I)}get delay(){return this.timeout}set delay(I){this.timeout=I}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=j;class G extends j{constructor(I,M){super(I,M);this.units=[]}work(I){this.units.push(I),this.isScheduled()||this.schedule()}doRun(){const I=this.units;this.units=[],this.runner&&this.runner(I)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=G,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const C=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=I=>{const M=setTimeout(()=>I(C));let _=!1;return{dispose(){_||(_=!0,clearTimeout(M))}}}}else e.runWhenIdle=(C,I)=>{const M=requestIdleCallback(C,typeof I=="number"?{timeout:I}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(M))}}}}();class ne{constructor(I){this._didRun=!1,this._executor=()=>{try{this._value=I()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=ne;async function oe(C,I,M){let _;for(let T=0;T<M;T++)try{return await C()}catch(W){_=W,await s(I)}throw _}e.retry=oe;class V{hasPending(I){return this._pending?typeof I=="number"?this._pending.taskId===I:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var I;(I=this._pending)===null||I===void 0||I.cancel()}setPending(I,M,_){return this._pending={taskId:I,cancel:()=>_==null?void 0:_(),promise:M},M.then(()=>this.donePending(I),()=>this.donePending(I)),M}donePending(I){this._pending&&I===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const I=this._next;this._next=void 0,I.run().then(I.promiseResolve,I.promiseReject)}}setNext(I){if(this._next)this._next.run=I;else{let M,_;const T=new Promise((W,B)=>{M=W,_=B});this._next={run:I,promise:T,promiseResolve:M,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=V;class Y{constructor(I){this.interval=I,this.lastIncrementTime=0,this.value=0}increment(){const I=Date.now();return I-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=I,this.value=0),this.value++,this.value}}e.IntervalCounter=Y;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((I,M)=>{this.completeCallback=I,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(I){return new Promise(M=>{this.completeCallback(I),this.resolved=!0,M()})}error(I){return new Promise(M=>{this.errorCallback(I),this.rejected=!0,M()})}cancel(){new Promise(I=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,I()})}}e.DeferredPromise=U;class O extends D.Emitter{async fireAsync(I,M,_){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,I]);for(;this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[T,W]=this._asyncDeliveryQueue.shift(),B=[],H=Object.assign(Object.assign({},W),{waitUntil:K=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");_&&(K=_(K,typeof T=="function"?T:T[0])),B.push(K)}});try{typeof T=="function"?T.call(void 0,H):T[0].call(T[1],H)}catch(K){(0,R.onUnexpectedError)(K);continue}Object.freeze(B),await z.settled(B).catch(K=>(0,R.onUnexpectedError)(K))}}}}e.AsyncEmitter=O;var z;(function(C){async function I(W){return typeof Promise.allSettled=="function"?M(W):_(W)}C.allSettled=I;async function M(W){return Promise.allSettled(W)}async function _(W){return Promise.all(W.map(B=>B.then(H=>({status:"fulfilled",value:H}),H=>({status:"rejected",reason:H}))))}async function T(W){let B;const H=await Promise.all(W.map(K=>K.then(J=>J,J=>{B||(B=J)})));if(typeof B!="undefined")throw B;return H}C.settled=T})(z=e.Promises||(e.Promises={}))}),define(X[80],Q([0,1,19,30,8,36,10]),function($,e,v,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const y="**",i="/",L="[/\\\\]",g="[^/\\\\]",E=/\//g;function p(M){switch(M){case 0:return"";case 1:return`${g}*?`;default:return`(?:${L}|${g}+${L}|${L}${g}+)*?`}}function d(M,_){if(!M)return[];const T=[];let W=!1,B=!1,H="";for(const K of M){switch(K){case _:if(!W&&!B){T.push(H),H="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":B=!0;break;case"]":B=!1;break}H+=K}return H&&T.push(H),T}e.splitGlobAware=d;function m(M){if(!M)return"";let _="";const T=d(M,i);if(T.every(W=>W===y))_=".*";else{let W=!1;T.forEach((B,H)=>{if(B===y){W||(_+=p(2),W=!0);return}let K=!1,J="",ee=!1,re="";for(const x of B){if(x!=="}"&&K){J+=x;continue}if(ee&&(x!=="]"||!re)){let ie;x==="-"?ie=x:(x==="^"||x==="!")&&!re?ie="^":x===i?ie="":ie=v.escapeRegExpCharacters(x),re+=ie;continue}switch(x){case"{":K=!0;continue;case"[":ee=!0;continue;case"}":_+=`(?:${d(J,",").map(ue=>m(ue)).join("|")})`,K=!1,J="";break;case"]":_+="["+re+"]",ee=!1,re="";break;case"?":_+=g;continue;case"*":_+=p(1);continue;default:_+=v.escapeRegExpCharacters(x)}}H<T.length-1&&(T[H+1]!==y||H+2<T.length)&&(_+=L),W=!1})}return _}const b=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.LRUCache(1e4),r=function(){return!1},a=function(){return null};function u(M,_){if(!M)return a;let T;typeof M!="string"?T=M.pattern:T=M,T=T.trim();const W=`${T}_${!!_.trimForExclusions}`;let B=t.get(W);if(B)return h(B,M);let H;if(b.test(T)){const K=T.substr(4);B=function(J,ee){return typeof J=="string"&&J.endsWith(K)?T:null}}else(H=w.exec(f(T,_)))?B=P(H[1],T):(_.trimForExclusions?c:l).test(T)?B=A(T,_):(H=o.exec(f(T,_)))?B=F(H[1].substr(1),T,!0):(H=s.exec(f(T,_)))?B=F(H[1],T,!1):B=N(T);return t.set(W,B),h(B,M)}function h(M,_){return typeof _=="string"?M:function(T,W){return R.isEqualOrParent(T,_.base)?M(D.relative(_.base,T),W):null}}function f(M,_){return _.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function P(M,_){const T=`/${M}`,W=`\\${M}`,B=function(K,J){return typeof K!="string"?null:J?J===M?_:null:K===M||K.endsWith(T)||K.endsWith(W)?_:null},H=[M];return B.basenames=H,B.patterns=[_],B.allBasenames=H,B}function A(M,_){const T=I(M.slice(1,-1).split(",").map(J=>u(J,_)).filter(J=>J!==a),M),W=T.length;if(!W)return a;if(W===1)return T[0];const B=function(J,ee){for(let re=0,x=T.length;re<x;re++)if(T[re](J,ee))return M;return null},H=T.find(J=>!!J.allBasenames);H&&(B.allBasenames=H.allBasenames);const K=T.reduce((J,ee)=>ee.allPaths?J.concat(ee.allPaths):J,[]);return K.length&&(B.allPaths=K),B}function F(M,_,T){const W=D.sep===D.posix.sep,B=W?M:M.replace(E,D.sep),H=D.sep+B,K=D.posix.sep+M,J=T?function(ee,re){return typeof ee=="string"&&(ee===B||ee.endsWith(H)||!W&&(ee===M||ee.endsWith(K)))?_:null}:function(ee,re){return typeof ee=="string"&&(ee===B||!W&&ee===M)?_:null};return J.allPaths=[(T?"*/":"./")+M],J}function N(M){try{const _=new RegExp(`^${m(M)}$`);return function(T){return _.lastIndex=0,typeof T=="string"&&_.test(T)?M:null}}catch(_){return a}}function j(M,_,T){return!M||typeof _!="string"?!1:G(M)(_,void 0,T)}e.match=j;function G(M,_={}){if(!M)return r;if(typeof M=="string"||Y(M)){const T=u(M,_);if(T===a)return r;const W=function(B,H){return!!T(B,H)};return T.allBasenames&&(W.allBasenames=T.allBasenames),T.allPaths&&(W.allPaths=T.allPaths),W}return z(M,_)}e.parse=G;function ne(M){if(!!M){let _;return T=>(_||(_=(M()||Promise.resolve([])).then(W=>W?V(W):{})),_.then(W=>!!W[T]))}}e.hasSiblingPromiseFn=ne;function oe(M){if(!!M){let _;return T=>{if(!_){const W=M();_=W?V(W):{}}return!!_[T]}}}e.hasSiblingFn=oe;function V(M){const _={};for(const T of M)_[T]=!0;return _}function Y(M){const _=M;return _&&typeof _.base=="string"&&typeof _.pattern=="string"}e.isRelativePattern=Y;function U(M){return M.allBasenames||[]}e.getBasenameTerms=U;function O(M){return M.allPaths||[]}e.getPathTerms=O;function z(M,_){const T=I(Object.getOwnPropertyNames(M).map(J=>C(J,M[J],_)).filter(J=>J!==a)),W=T.length;if(!W)return a;if(!T.some(J=>!!J.requiresSiblings)){if(W===1)return T[0];const J=function(x,ie){for(let ae=0,ue=T.length;ae<ue;ae++){const pe=T[ae](x,ie);if(pe)return pe}return null},ee=T.find(x=>!!x.allBasenames);ee&&(J.allBasenames=ee.allBasenames);const re=T.reduce((x,ie)=>ie.allPaths?x.concat(ie.allPaths):x,[]);return re.length&&(J.allPaths=re),J}const B=function(J,ee,re){let x;for(let ie=0,ae=T.length;ie<ae;ie++){const ue=T[ie];ue.requiresSiblings&&re&&(ee||(ee=D.basename(J)),x||(x=ee.substr(0,ee.length-D.extname(J).length)));const pe=ue(J,ee,x,re);if(pe)return pe}return null},H=T.find(J=>!!J.allBasenames);H&&(B.allBasenames=H.allBasenames);const K=T.reduce((J,ee)=>ee.allPaths?J.concat(ee.allPaths):J,[]);return K.length&&(B.allPaths=K),B}function C(M,_,T){if(_===!1)return a;const W=u(M,T);if(W===a)return a;if(typeof _=="boolean")return W;if(_){const B=_.when;if(typeof B=="string"){const H=(K,J,ee,re)=>{if(!re||!W(K,J))return null;const x=B.replace("$(basename)",ee),ie=re(x);return(0,k.isThenable)(ie)?ie.then(ae=>ae?M:null):ie?M:null};return H.requiresSiblings=!0,H}}return W}function I(M,_){const T=M.filter(J=>!!J.basenames);if(T.length<2)return M;const W=T.reduce((J,ee)=>{const re=ee.basenames;return re?J.concat(re):J},[]);let B;if(_){B=[];for(let J=0,ee=W.length;J<ee;J++)B.push(_)}else B=T.reduce((J,ee)=>{const re=ee.patterns;return re?J.concat(re):J},[]);const H=function(J,ee){if(typeof J!="string")return null;if(!ee){let x;for(x=J.length;x>0;x--){const ie=J.charCodeAt(x-1);if(ie===47||ie===92)break}ee=J.substr(x)}const re=W.indexOf(ee);return re!==-1?B[re]:null};H.basenames=W,H.patterns=B,H.allBasenames=W;const K=M.filter(J=>!J.basenames);return K.push(H),K}}),define(X[39],Q([0,1,7,8,19,9,3,15,30]),function($,e,v,R,D,S,k,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function i(u,h,f){if(typeof u=="string"&&(u=v.URI.file(u)),f){const A=f.getWorkspaceFolder(u);if(A){const F=f.getWorkspace().folders.length>1;let N;if((0,n.isEqual)(A.uri,u)?N="":N=(0,n.relativePath)(A.uri,u),F){const j=A.name?A.name:(0,n.basename)(A.uri);N=N?j+" \u2022 "+N:j}return N}}if(u.scheme!==S.Schemas.file&&u.scheme!==S.Schemas.untitled)return u.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(u.fsPath))return(0,R.normalize)(g(u.fsPath));let P=(0,R.normalize)(u.fsPath);return!k.isWindows&&(h==null?void 0:h.userHome)&&(P=p(P,h.userHome.fsPath)),P}e.getPathLabel=i;function L(u){if(!!u){typeof u=="string"&&(u=v.URI.file(u));const h=(0,n.basename)(u)||(u.scheme===S.Schemas.file?u.fsPath:u.path);return k.isWindows&&(0,y.isRootOrDriveLetter)(h)?g(h):h}}e.getBaseLabel=L;function g(u){return(0,y.hasDriveLetter)(u)?u.charAt(0).toUpperCase()+u.slice(1):u}e.normalizeDriveLetter=g;let E=Object.create(null);function p(u,h){if(k.isWindows||!u||!h)return u;let f=E.original===h?E.normalized:void 0;return f||(f=`${(0,D.rtrim)(h,R.posix.sep)}${R.posix.sep}`,E={original:h,normalized:f}),(k.isLinux?u.startsWith(f):(0,D.startsWithIgnoreCase)(u,f))&&(u=`~/${u.substr(f.length)}`),u}e.tildify=p;function d(u,h){return u.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=d;const m="\u2026",b="\\\\",w="~";function l(u,h=R.sep){const f=new Array(u.length);let P=!1;for(let A=0;A<u.length;A++){let F=u[A];if(F===""){f[A]=`.${h}`;continue}if(!F){f[A]=F;continue}P=!0;let N="";F.indexOf(b)===0?(N=F.substr(0,F.indexOf(b)+b.length),F=F.substr(F.indexOf(b)+b.length)):F.indexOf(h)===0?(N=F.substr(0,F.indexOf(h)+h.length),F=F.substr(F.indexOf(h)+h.length)):F.indexOf(w)===0&&(N=F.substr(0,F.indexOf(w)+w.length),F=F.substr(F.indexOf(w)+w.length));const j=F.split(h);for(let G=1;P&&G<=j.length;G++)for(let ne=j.length-G;P&&ne>=0;ne--){P=!1;let oe=j.slice(ne,ne+G).join(h);for(let V=0;!P&&V<u.length;V++)if(V!==A&&u[V]&&u[V].indexOf(oe)>-1){const Y=ne+G===j.length,U=ne>0&&u[V].indexOf(h)>-1?h+oe:oe,O=u[V].endsWith(U);P=!Y||O}if(!P){let V="";(j[0].endsWith(":")||N!=="")&&(ne===1&&(ne=0,G++,oe=j[0]+h+oe),ne>0&&(V=j[0]+h),V=N+V),ne>0&&(V=V+m+h),V=V+oe,ne+G<j.length&&(V=V+h+m),f[A]=V}}P&&(f[A]=F)}return f}e.shorten=l;var c;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function o(u,h=Object.create(null)){const f=[];let P=!1,A="";for(const F of u)if(F==="$"||P&&F==="{")A&&f.push({value:A,type:c.TEXT}),A="",P=!0;else if(F==="}"&&P){const N=h[A];if(typeof N=="string")N.length&&f.push({value:N,type:c.VARIABLE});else if(N){const j=f[f.length-1];(!j||j.type!==c.SEPARATOR)&&f.push({value:N.label,type:c.SEPARATOR})}A="",P=!1}else A+=F;return A&&!P&&f.push({value:A,type:c.TEXT}),f.filter((F,N)=>{if(F.type===c.SEPARATOR){const j=f[N-1],G=f[N+1];return[j,G].every(ne=>ne&&(ne.type===c.VARIABLE||ne.type===c.TEXT)&&ne.value.length>0)}return!0}).map(F=>F.value).join("")}e.template=o;function s(u,h){return k.isMacintosh||h?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):u.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=s;function t(u,h){return k.isMacintosh||h?u.replace(/\(&&\w\)|&&/g,""):k.isWindows?u.replace(/&&|&/g,f=>f==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(u){return u.replace(/&/g,"&&")}e.unmnemonicLabel=r;function a(u){const h=u.indexOf("/")!==-1?R.posix:R.win32,f=h.basename(u),P=h.dirname(u);return f.length?{name:f,parentPath:P}:{name:P,parentPath:""}}e.splitName=a}),define(X[108],Q([0,1,8,19,80,9,15]),function($,e,v,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.MIME_UNKNOWN=e.MIME_BINARY=e.MIME_TEXT=void 0,e.MIME_TEXT="text/plain",e.MIME_BINARY="application/octet-stream",e.MIME_UNKNOWN="application/unknown";let n=[],y=[],i=[];function L(o,s=!1){const t=g(o);n.push(t),t.userConfigured?i.push(t):y.push(t),s&&!t.userConfigured&&n.forEach(r=>{r.mime===t.mime||r.userConfigured||(t.extension&&r.extension===t.extension&&console.warn(`Overwriting extension <<${t.extension}>> to now point to mime <<${t.mime}>>`),t.filename&&r.filename===t.filename&&console.warn(`Overwriting filename <<${t.filename}>> to now point to mime <<${t.mime}>>`),t.filepattern&&r.filepattern===t.filepattern&&console.warn(`Overwriting filepattern <<${t.filepattern}>> to now point to mime <<${t.mime}>>`),t.firstline&&r.firstline===t.firstline&&console.warn(`Overwriting firstline <<${t.firstline}>> to now point to mime <<${t.mime}>>`))})}e.registerTextMime=L;function g(o){return{id:o.id,mime:o.mime,filename:o.filename,extension:o.extension,filepattern:o.filepattern,firstline:o.firstline,userConfigured:o.userConfigured,filenameLowercase:o.filename?o.filename.toLowerCase():void 0,extensionLowercase:o.extension?o.extension.toLowerCase():void 0,filepatternLowercase:o.filepattern?o.filepattern.toLowerCase():void 0,filepatternOnPath:o.filepattern?o.filepattern.indexOf(v.posix.sep)>=0:!1}}function E(o){o?(n=n.filter(s=>!s.userConfigured),i=[]):(n=[],y=[],i=[])}e.clearTextMimes=E;function p(o,s){let t;if(o)switch(o.scheme){case S.Schemas.file:t=o.fsPath;break;case S.Schemas.data:t=k.DataUri.parseMetaData(o).get(k.DataUri.META_DATA_LABEL);break;default:t=o.path}if(!t)return[e.MIME_UNKNOWN];t=t.toLowerCase();const r=(0,v.basename)(t),a=d(t,r,i);if(a)return[a,e.MIME_TEXT];const u=d(t,r,y);if(u)return[u,e.MIME_TEXT];if(s){const h=m(s);if(h)return[h,e.MIME_TEXT]}return[e.MIME_UNKNOWN]}e.guessMimeTypes=p;function d(o,s,t){let r=null,a=null,u=null;for(let h=t.length-1;h>=0;h--){const f=t[h];if(s===f.filenameLowercase){r=f;break}if(f.filepattern&&(!a||f.filepattern.length>a.filepattern.length)){const P=f.filepatternOnPath?o:s;(0,D.match)(f.filepatternLowercase,P)&&(a=f)}f.extension&&(!u||f.extension.length>u.extension.length)&&s.endsWith(f.extensionLowercase)&&(u=f)}return r?r.mime:a?a.mime:u?u.mime:null}function m(o){if((0,R.startsWithUTF8BOM)(o)&&(o=o.substr(1)),o.length>0)for(let s=n.length-1;s>=0;s--){const t=n[s];if(!!t.firstline){const r=o.match(t.firstline);if(r&&r.length>0)return t.mime}}return null}function b(o){return o?typeof o=="string"?o===e.MIME_BINARY||o===e.MIME_TEXT||o===e.MIME_UNKNOWN:o.length===1&&b(o[0]):!0}e.isUnspecific=b;const w={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function l(o){const s=(0,v.extname)(o);return w[s.toLowerCase()]}e.getMediaMime=l;function c(o){for(const s in w)if(w[s]===o)return s}e.getExtensionForMimeType=c}),define(X[28],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(y){return v.test(y)}e.isUUID=R;const D=new Uint8Array(16),S=[];for(let y=0;y<256;y++)S.push(y.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(y){for(let i=0;i<y.length;i++)y[i]=Math.floor(Math.random()*256);return y};function n(){k(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let y=0,i="";return i+=S[D[y++]],i+=S[D[y++]],i+=S[D[y++]],i+=S[D[y++]],i+="-",i+=S[D[y++]],i+=S[D[y++]],i+="-",i+=S[D[y++]],i+=S[D[y++]],i+="-",i+=S[D[y++]],i+=S[D[y++]],i+="-",i+=S[D[y++]],i+=S[D[y++]],i+=S[D[y++]],i+=S[D[y++]],i+=S[D[y++]],i+=S[D[y++]],i}e.generateUuid=n}),define(X[109],Q([0,1,21,60,43]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function S(k,n){if(await new Promise((L,g)=>{const E=v.createReadStream(k),p=R.createHash("sha1");E.pipe(p);const d=(0,D.once)((m,b)=>{E.removeAllListeners(),p.removeAllListeners(),m?g(m):L(b)});E.once("error",d),E.once("end",d),p.once("error",d),p.once("data",m=>d(void 0,m.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=S}),define(X[81],Q([0,1,235]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(S="utf8"){this.stringDecoder=new v.StringDecoder(S),this.remaining=null}write(S){const k=[],n=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(n.length<1)return k;let y=0,i,L=y;for(;L<n.length;)if(i=n.charCodeAt(L),i===13||i===10){if(k.push(n.substring(y,L)),L++,L<n.length){const g=i;i=n.charCodeAt(L),(g===13&&i===10||g===10&&i===13)&&L++}y=L}else L++;return this.remaining=y<n.length?n.substr(y):null,k}end(){return this.remaining}}e.LineDecoder=R}),define(X[110],Q([0,1,27]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(n){const y=n.replace(/\-/g,":").toLowerCase();return!R.has(y)}function S(){return new Promise(async(n,y)=>{const i=setTimeout(()=>y("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await k())}catch(L){y(L)}finally{clearTimeout(i)}})}e.getMac=S;function k(){return new Promise((n,y)=>{try{const i=(0,v.networkInterfaces)();for(const[,L]of Object.entries(i))for(const g of L)if(D(g.mac))return n(g.mac);y("Unable to retrieve mac address (unexpected format)")}catch(i){y(i)}})}}),define(X[66],Q([0,1,18,28,27,36,110]),function($,e,v,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(L){return this._virtualMachineOUIs||(this._virtualMachineOUIs=S.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(L)}value(){if(this._value===void 0){let L=0,g=0;const E=(0,D.networkInterfaces)();for(let p in E)if(Object.prototype.hasOwnProperty.call(E,p))for(const{mac:d,internal:m}of E[p])m||(g+=1,this._isVirtualMachineMacAdress(d.toUpperCase())&&(L+=1));this._value=g>0?L/g:0}return this._value}};let n;async function y(){return n||(n=(async()=>await i()||R.generateUuid())()),n}e.getMachineId=y;async function i(){try{const L=await new Promise((E,p)=>{$(["crypto"],E,p)}),g=await(0,k.getMac)();return L.createHash("sha256").update(g,"utf8").digest("hex")}catch(L){v.onUnexpectedError(L);return}}}),define(X[22],Q([0,1,21,27,8,10,3,30,28,65,15,7]),function($,e,v,R,D,S,k,n,y,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var E;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function p(U,O=E.UNLINK){if((0,n.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return O===E.UNLINK?m(U):d(U)}e.rimraf=p;async function d(U){try{const O=(0,D.join)((0,R.tmpdir)(),(0,y.generateUuid)());try{await v.promises.rename(U,O)}catch(z){return m(U)}m(O).catch(z=>{})}catch(O){if(O.code!=="ENOENT")throw O}}async function m(U){return v.promises.rmdir(U,{recursive:!0,maxRetries:3})}function b(U){if((0,n.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(U,{recursive:!0})}e.rimrafSync=b;async function w(U,O){return o(await(O?l(U):v.promises.readdir(U)))}e.readdir=w;async function l(U){try{return await v.promises.readdir(U,{withFileTypes:!0})}catch(C){console.warn("[node.js fs] readdir with filetypes failed with error: ",C)}const O=[],z=await w(U);for(const C of z){let I=!1,M=!1,_=!1;try{const T=await v.promises.lstat((0,D.join)(U,C));I=T.isFile(),M=T.isDirectory(),_=T.isSymbolicLink()}catch(T){console.warn("[node.js fs] unexpected error from lstat after readdir: ",T)}O.push({name:C,isFile:()=>I,isDirectory:()=>M,isSymbolicLink:()=>_})}return O}function c(U){return o(v.readdirSync(U))}e.readdirSync=c;function o(U){return U.map(O=>typeof O=="string"?k.isMacintosh?(0,i.normalizeNFC)(O):O:(O.name=k.isMacintosh?(0,i.normalizeNFC)(O.name):O.name,O))}async function s(U){const O=await w(U),z=[];for(const C of O)await r.existsDirectory((0,D.join)(U,C))&&z.push(C);return z}e.readDirsInDir=s;function t(U,O=1e3){return new Promise(z=>{let C=!1;const I=setInterval(()=>{C||(C=!0,v.access(U,M=>{C=!1,M&&(clearInterval(I),z(void 0))}))},O)})}e.whenDeleted=t;var r;(function(U){async function O(I){let M;try{if(M=await v.promises.lstat(I),!M.isSymbolicLink())return{stat:M}}catch(_){}try{return{stat:await v.promises.stat(I),symbolicLink:(M==null?void 0:M.isSymbolicLink())?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(k.isWindows&&_.code==="EACCES")try{return{stat:await v.promises.stat(await v.promises.readlink(I)),symbolicLink:{dangling:!1}}}catch(T){if(T.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw T}throw _}}U.stat=O;async function z(I){try{const{stat:M,symbolicLink:_}=await U.stat(I);return M.isFile()&&(_==null?void 0:_.dangling)!==!0}catch(M){}return!1}U.existsFile=z;async function C(I){try{const{stat:M,symbolicLink:_}=await U.stat(I);return M.isDirectory()&&(_==null?void 0:_.dangling)!==!0}catch(M){}return!1}U.existsDirectory=C})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new S.ResourceQueue;function u(U,O,z){return a.queueFor(g.URI.file(U),L.extUriBiasedIgnorePathCase).queue(()=>{const C=A(z);return new Promise((I,M)=>f(U,O,C,_=>_?M(_):I()))})}e.writeFile=u;let h=!0;function f(U,O,z,C){if(!h)return v.writeFile(U,O,{mode:z.mode,flag:z.flag},C);v.open(U,z.flag,z.mode,(I,M)=>{if(I)return C(I);v.writeFile(M,O,_=>{if(_)return v.close(M,()=>C(_));v.fdatasync(M,T=>(T&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",T),h=!1),v.close(M,W=>C(W))))})})}function P(U,O,z){const C=A(z);if(!h)return v.writeFileSync(U,O,{mode:C.mode,flag:C.flag});const I=v.openSync(U,C.flag,C.mode);try{v.writeFileSync(I,O);try{v.fdatasyncSync(I)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),h=!1}}finally{v.closeSync(I)}}e.writeFileSync=P;function A(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function F(U,O){if(U!==O){async function z(C){try{const I=await v.promises.lstat(C);if(I.isDirectory()||I.isSymbolicLink())return;const M=await v.promises.open(C,"a");try{await M.utimes(I.atime,new Date)}finally{await M.close()}}catch(I){}}try{await v.promises.rename(U,O),await z(O)}catch(C){if(U.toLowerCase()!==O.toLowerCase()&&C.code==="EXDEV"||U.endsWith("."))await N(U,O,{preserveSymlinks:!1}),await p(U,E.MOVE),await z(O);else throw C}}}e.move=F;async function N(U,O,z){return G(U,O,{root:{source:U,target:O},options:z,handledSourcePaths:new Set})}e.copy=N;const j=511;async function G(U,O,z){if(!z.handledSourcePaths.has(U)){z.handledSourcePaths.add(U);const{stat:C,symbolicLink:I}=await r.stat(U);if(I){if(z.options.preserveSymlinks)try{return await V(U,O,z)}catch(M){console.warn("[node.js fs] copy of symlink failed: ",M)}if(I.dangling)return}return C.isDirectory()?ne(U,O,C.mode&j,z):oe(U,O,C.mode&j)}}async function ne(U,O,z,C){await v.promises.mkdir(O,{recursive:!0,mode:z});const I=await w(U);for(const M of I)await G((0,D.join)(U,M),(0,D.join)(O,M),C)}async function oe(U,O,z){await v.promises.copyFile(U,O),await v.promises.chmod(O,z)}async function V(U,O,z){let C=await v.promises.readlink(U);(0,n.isEqualOrParent)(C,z.root.source,!k.isLinux)&&(C=(0,D.join)(z.root.target,C.substr(z.root.source.length+1))),await v.promises.symlink(C,O)}async function Y(U){try{return await v.promises.access(U),!0}catch(O){return!1}}e.exists=Y}),define(X[111],Q([0,1,21,112,19,8,22]),function($,e,v,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function n(g){const E=(0,S.dirname)(g);if(g===E)return g;const p=((0,S.basename)(g)||g).toLowerCase();try{const m=(0,k.readdirSync)(E).filter(b=>b.toLowerCase()===p);if(m.length===1){const b=n(E);if(b)return(0,S.join)(b,m[0])}else if(m.length>1){const b=m.indexOf(p);if(b>=0){const w=n(E);if(w)return(0,S.join)(w,m[b])}}}catch(d){}return null}e.realcaseSync=n;async function y(g){try{return await(0,R.promisify)(v.realpath)(g)}catch(E){const p=L(g);return await v.promises.access(p,v.constants.R_OK),p}}e.realpath=y;function i(g){try{return v.realpathSync(g)}catch(E){const p=L(g);return v.accessSync(p,v.constants.R_OK),p}}e.realpathSync=i;function L(g){return(0,D.rtrim)((0,S.normalize)(g),S.sep)}}),define(X[113],Q([0,1,61]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=e.randomPort=void 0;function R(){const y=1025;return y+Math.floor((65535-y)*Math.random())}e.randomPort=R;function D(y,i,L){let g=!1;return new Promise(E=>{const p=setTimeout(()=>{if(!g)return g=!0,E(0)},L);S(y,i,d=>{if(!g)return g=!0,clearTimeout(p),E(d)})})}e.findFreePort=D;function S(y,i,L){if(i===0)return L(0);const g=new v.Socket;g.once("connect",()=>(n(g),S(y+1,i-1,L))),g.once("data",()=>{}),g.once("error",E=>(n(g),E.code!=="ECONNREFUSED"?S(y+1,i-1,L):L(y))),g.connect(y,"127.0.0.1")}function k(y,i,L){let g=!1,E,p=1;const d=v.createServer({pauseOnConnect:!0});function m(b,w){g||(g=!0,d.removeAllListeners(),d.close(),E&&clearTimeout(E),w(b))}return new Promise(b=>{E=setTimeout(()=>{m(0,b)},L),d.on("listening",()=>{m(y,b)}),d.on("error",w=>{w&&(w.code==="EADDRINUSE"||w.code==="EACCES")&&p<i?(y++,p++,d.listen(y,"127.0.0.1")):m(0,b)}),d.on("close",()=>{m(0,b)}),d.listen(y,"127.0.0.1")})}e.findFreePortFaster=k;function n(y){try{y.removeAllListeners("connect"),y.removeAllListeners("error"),y.end(),y.destroy(),y.unref()}catch(i){console.error(i)}}});var Ae=this&&this.__await||function($){return this instanceof Ae?(this.v=$,this):new Ae($)},dt=this&&this.__asyncGenerator||function($,e,v){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var R=v.apply($,e||[]),D,S=[];return D={},k("next"),k("throw"),k("return"),D[Symbol.asyncIterator]=function(){return this},D;function k(E){R[E]&&(D[E]=function(p){return new Promise(function(d,m){S.push([E,p,d,m])>1||n(E,p)})})}function n(E,p){try{y(R[E](p))}catch(d){g(S[0][3],d)}}function y(E){E.value instanceof Ae?Promise.resolve(E.value.v).then(i,L):g(S[0][2],E)}function i(E){n("next",E)}function L(E){n("throw",E)}function g(E,p){E(p),S.shift(),S.length&&n(S[0][0],S[0][1])}},ft=this&&this.__asyncValues||function($){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=$[Symbol.asyncIterator],v;return e?e.call($):($=typeof __values=="function"?__values($):$[Symbol.iterator](),v={},R("next"),R("throw"),R("return"),v[Symbol.asyncIterator]=function(){return this},v);function R(S){v[S]=$[S]&&function(k){return new Promise(function(n,y){k=$[S](k),D(n,y,k.done,k.value)})}}function D(S,k,n,y){Promise.resolve(y).then(function(i){S({value:i,done:n})},k)}};define(X[114],Q([0,1,22,27,8]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const S=/^\d+$/,k=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var y;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(y||(y={}));let i;switch(process.arch){case"ia32":case"x32":i=1;break;case"arm":case"arm64":i=2;break;default:i=0;break}let L;process.env.PROCESSOR_ARCHITEW6432?L=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?L=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?L=1:L=0;class g{constructor(s,t,r){this.exePath=s,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await v.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:o=!1}={}){return o?i===0?process.env["ProgramFiles(x86)"]||null:L===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:o=!1,findPreview:s=!1}={}){const t=E({useAlternateBitness:o});if(!t)return null;const r=D.join(t,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(r))return null;let a=-1,u=null;for(const P of await v.readdir(r)){let A=-1;if(s){const N=P.indexOf("-");if(N<0)continue;const j=P.substring(0,N);if(!S.test(j)||P.substring(N+1)!=="preview")continue;A=parseInt(j,10)}else{if(!S.test(P))continue;A=parseInt(P,10)}if(!(A<=a)){const F=D.join(r,P,"pwsh.exe");!await v.SymlinkSupport.existsFile(F)||(u=F,a=A)}}if(!u)return null;const h=t.includes("x86")?" (x86)":"",f=s?" Preview":"";return new g(u,`PowerShell${f}${h}`,!0)}async function d({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const s=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=o?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const a of await v.readdir(s))if(t.test(a)){const u=D.join(s,a,"pwsh.exe");return new g(u,r)}return null}function m(){const o=D.join(R.homedir(),".dotnet","tools","pwsh.exe");return new g(o,".NET Core PowerShell Global Tool")}function b(){const o=D.join(process.env.windir,i===1&&L!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new g(o,"Windows PowerShell",!0)}function w(){return dt(this,arguments,function*(){let s=yield Ae(p());s&&(yield yield Ae(s)),s=yield Ae(p({useAlternateBitness:!0})),s&&(yield yield Ae(s)),s=yield Ae(d()),s&&(yield yield Ae(s)),s=m(),s&&(yield yield Ae(s)),s=yield Ae(p({findPreview:!0})),s&&(yield yield Ae(s)),s=yield Ae(d({findPreview:!0})),s&&(yield yield Ae(s)),s=yield Ae(p({useAlternateBitness:!0,findPreview:!0})),s&&(yield yield Ae(s)),s=b(),s&&(yield yield Ae(s))})}function l(){return dt(this,arguments,function*(){var s,t;try{for(var r=ft(w()),a;a=yield Ae(r.next()),!a.done;){const u=a.value;(yield Ae(u.exists()))&&(yield yield Ae(u))}}catch(u){s={error:u}}finally{try{a&&!a.done&&(t=r.return)&&(yield Ae(t.call(r)))}finally{if(s)throw s.error}}})}e.enumeratePowerShellInstallations=l;async function c(){var o,s;try{for(var t=ft(l()),r;r=await t.next(),!r.done;)return r.value}catch(a){o={error:a}}finally{try{r&&!r.done&&(s=t.return)&&await s.call(t)}finally{if(o)throw o.error}}return null}e.getFirstAvailablePowerShellInstallation=c}),define(X[82],Q([0,1,46,9]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(k){return new Promise((n,y)=>{let i;const L=new Map;function g(d,m,b,w,l){const c=L.get(m);if(d===k||c){const o={name:E(b),cmd:b,pid:d,ppid:m,load:w,mem:l};L.set(d,o),d===k&&(i=o),c&&(c.children||(c.children=[]),c.children.push(o),c.children.length>1&&(c.children=c.children.sort((s,t)=>s.pid-t.pid)))}}function E(d){const m=/--disable-blink-features=Auxclick/,b=/\\watcher\\win32\\CodeHelper\.exe/,w=/--crashes-directory/,l=/\\pipe\\winpty-control/,c=/conhost\.exe/,o=/--type=([a-zA-Z-]+)/;if(b.exec(d))return"watcherService ";if(w.exec(d))return"electron-crash-reporter";if(l.exec(d))return"winpty-process";if(c.exec(d))return"console-window-host (Windows internal process)";let s=o.exec(d);if(s&&s.length===2)return s[1]==="renderer"?m.exec(d)?"shared-process":"window":s[1];const t=/[a-zA-Z-]+\.js/g;let r="";do s=t.exec(d),s&&(r+=s+" ");while(s);return r&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron_node ${r}`:d}if(process.platform==="win32"){const d=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substr(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substr(5):m;new Promise((m,b)=>{$(["windows-process-tree"],m,b)}).then(m=>{m.getProcessList(k,b=>{m.getProcessCpuUsage(b,w=>{const l=new Map;w.forEach(c=>{const o=d(c.commandLine||"");l.set(c.pid,{name:E(o),cmd:o,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),i=l.get(k),i?(l.forEach(c=>{const o=l.get(c.ppid);o&&(o.children||(o.children=[]),o.children.push(c))}),l.forEach(c=>{c.children&&(c.children=c.children.sort((o,s)=>o.pid-s.pid))}),n(i)):y(new Error(`Root process ${k} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{function p(){let d=[i];const m=[];for(;d.length;){const w=d.shift();w&&(m.push(w.pid),w.children&&(d=d.concat(w.children)))}let b=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",$).fsPath);b+=" "+m.join(" "),(0,v.exec)(b,{},(w,l,c)=>{if(w||c)y(w||new Error(c.toString()));else{const o=l.toString().split(`
`);for(let s=0;s<m.length;s++){const t=L.get(m[s]);t.load=parseFloat(o[s])}if(!i){y(new Error(`Root process ${k} not found`));return}n(i)}})}(0,v.exec)("which ps",{},(d,m,b)=>{if(d||b)if(process.platform!=="linux")y(d||new Error(b.toString()));else{const w=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/ps.sh",$).fsPath);(0,v.exec)(w,{},(l,c,o)=>{l||o?y(l||new Error(o.toString())):(S(c,g),p())})}else{const w=m.toString().trim(),l="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${w} ${l}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,o,s)=>{c||s&&!s.includes("screen size is bogus")?y(c||new Error(s.toString())):(S(o,g),process.platform==="linux"?p():i?n(i):y(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=D;function S(k,n){const y=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,i=k.toString().split(`
`);for(const L of i){const g=y.exec(L.trim());g&&g.length===6&&n(parseInt(g[1]),parseInt(g[2]),g[5],parseFloat(g[3]),parseFloat(g[4]))}}}),define(X[115],Q([0,1,8,21,3,65,2,22]),function($,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function y(g,E,p){return L({path:g,isDirectory:!1},E,p)}e.watchFile=y;function i(g,E,p){return L({path:g,isDirectory:!0},E,p)}e.watchFolder=i,e.CHANGE_BUFFER_DELAY=100;function L(g,E,p){const d=(0,v.basename)(g.path),m=new Map;let b=!1,w=[(0,k.toDisposable)(()=>{m.forEach(l=>(0,k.dispose)(l)),m.clear()})];try{const l=(0,R.watch)(g.path);w.push((0,k.toDisposable)(()=>{l.removeAllListeners(),l.close()}));const c=new Set;g.isDirectory&&(0,n.readdir)(g.path).then(o=>o.forEach(s=>c.add(s))),l.on("error",(o,s)=>{b||p(`Failed to watch ${g.path} for changes using fs.watch() (${o}, ${s})`)}),l.on("change",(o,s)=>{if(!b){let t="";if(s&&(t=s.toString(),D.isMacintosh&&(t=(0,S.normalizeNFC)(t))),!(!t||o!=="change"&&o!=="rename")){const r=g.isDirectory?(0,v.join)(g.path,t):g.path;if(g.isDirectory)if(o==="rename"){const a=m.get(r);a&&(0,k.dispose)(a);const u=setTimeout(async()=>{m.delete(r);const h=await(0,n.exists)(r);if(!b){let f;h?c.has(t)?f="changed":(f="added",c.add(t)):(c.delete(t),f="deleted"),E(f,r)}},e.CHANGE_BUFFER_DELAY);m.set(r,(0,k.toDisposable)(()=>clearTimeout(u)))}else{let a;c.has(t)?a="changed":(a="added",c.add(t)),E(a,r)}else if(o==="rename"||t!==d){const a=setTimeout(async()=>{const u=await(0,n.exists)(r);b||(u?(E("changed",r),w=[L(g,E,p)]):E("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(w),w=[(0,k.toDisposable)(()=>clearTimeout(a))]}else E("changed",r)}}})}catch(l){(0,n.exists)(g.path).then(c=>{c&&!b&&p(`Failed to watch ${g.path} for changes using fs.watch() (${l.toString()})`)})}return(0,k.toDisposable)(()=>{b=!0,w=(0,k.dispose)(w)})}}),define(X[116],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(X[117],Q([0,1,11,116,13]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function S(){v.ipcMain.on(R.CONTEXT_MENU_CHANNEL,(n,y,i,L,g)=>{const E=k(n,L,i);E.popup({window:(0,D.withNullAsUndefined)(v.BrowserWindow.fromWebContents(n.sender)),x:g?g.x:void 0,y:g?g.y:void 0,positioningItem:g?g.positioningItem:void 0,callback:()=>{E&&n.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,y)}})})}e.registerContextMenuListener=S;function k(n,y,i){const L=new v.Menu;return i.forEach(g=>{let E;g.type==="separator"?E=new v.MenuItem({type:g.type}):Array.isArray(g.submenu)?E=new v.MenuItem({submenu:k(n,y,g.submenu),label:g.label}):E=new v.MenuItem({label:g.label,type:g.type,accelerator:g.accelerator,checked:g.checked,enabled:g.enabled,visible:g.visible,click:(p,d,m)=>n.sender.send(y,g.id,m)}),L.append(E)}),L}}),define(X[33],Q([0,1,5,2,10,25,18,20,34,13,107,19]),function($,e,v,R,D,S,k,n,y,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(C){C[C.Promise=100]="Promise",C[C.PromiseCancel=101]="PromiseCancel",C[C.EventListen=102]="EventListen",C[C.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function p(C){switch(C){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(C){C[C.Initialize=200]="Initialize",C[C.PromiseSuccess=201]="PromiseSuccess",C[C.PromiseError=202]="PromiseError",C[C.PromiseErrorObj=203]="PromiseErrorObj",C[C.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function m(C){switch(C){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(C){C[C.Uninitialized=0]="Uninitialized",C[C.Idle=1]="Idle"})(b||(b={}));class w{constructor(I){this.buffer=I,this.pos=0}read(I){const M=this.buffer.slice(this.pos,this.pos+I);return this.pos+=M.byteLength,M}}class l{constructor(){this.buffers=[]}get buffer(){return n.VSBuffer.concat(this.buffers)}write(I){this.buffers.push(I)}}var c;(function(C){C[C.Undefined=0]="Undefined",C[C.String=1]="String",C[C.Buffer=2]="Buffer",C[C.VSBuffer=3]="VSBuffer",C[C.Array=4]="Array",C[C.Object=5]="Object"})(c||(c={}));function o(C){const I=n.VSBuffer.alloc(4);return I.writeUInt32BE(C,0),I}function s(C){return C.read(4).readUInt32BE(0)}function t(C){const I=n.VSBuffer.alloc(1);return I.writeUInt8(C,0),I}const r={Undefined:t(c.Undefined),String:t(c.String),Buffer:t(c.Buffer),VSBuffer:t(c.VSBuffer),Array:t(c.Array),Object:t(c.Object)},a=typeof Buffer!="undefined";function u(C,I){if(typeof I=="undefined")C.write(r.Undefined);else if(typeof I=="string"){const M=n.VSBuffer.fromString(I);C.write(r.String),C.write(o(M.byteLength)),C.write(M)}else if(a&&Buffer.isBuffer(I)){const M=n.VSBuffer.wrap(I);C.write(r.Buffer),C.write(o(M.byteLength)),C.write(M)}else if(I instanceof n.VSBuffer)C.write(r.VSBuffer),C.write(o(I.byteLength)),C.write(I);else if(Array.isArray(I)){C.write(r.Array),C.write(o(I.length));for(const M of I)u(C,M)}else{const M=n.VSBuffer.fromString(JSON.stringify(I));C.write(r.Object),C.write(o(M.byteLength)),C.write(M)}}function h(C){switch(C.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return C.read(s(C)).toString();case c.Buffer:return C.read(s(C)).buffer;case c.VSBuffer:return C.read(s(C));case c.Array:{const M=s(C),_=[];for(let T=0;T<M;T++)_.push(h(C));return _}case c.Object:return JSON.parse(C.read(s(C)).toString())}}class f{constructor(I,M,_=null,T=1e3){this.protocol=I,this.ctx=M,this.logger=_,this.timeoutDelay=T,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(I,M){this.channels.set(I,M),setTimeout(()=>this.flushPendingRequests(I),0)}sendResponse(I){switch(I.type){case 200:{const M=this.send([I.type]);this.logger&&this.logger.logOutgoing(M,0,1,m(I.type));return}case 201:case 202:case 204:case 203:{const M=this.send([I.type,I.id],I.data);this.logger&&this.logger.logOutgoing(M,I.id,1,m(I.type),I.data);return}}}send(I,M=void 0){const _=new l;return u(_,I),u(_,M),this.sendBuffer(_.buffer)}sendBuffer(I){try{return this.protocol.send(I),I.byteLength}catch(M){return 0}}onRawMessage(I){const M=new w(I),_=h(M),T=h(M),W=_[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(I.byteLength,_[1],1,`${p(W)}: ${_[2]}.${_[3]}`,T),this.onPromise({type:W,id:_[1],channelName:_[2],name:_[3],arg:T});case 102:return this.logger&&this.logger.logIncoming(I.byteLength,_[1],1,`${p(W)}: ${_[2]}.${_[3]}`,T),this.onEventListen({type:W,id:_[1],channelName:_[2],name:_[3],arg:T});case 101:return this.logger&&this.logger.logIncoming(I.byteLength,_[1],1,`${p(W)}`),this.disposeActiveRequest({type:W,id:_[1]});case 103:return this.logger&&this.logger.logIncoming(I.byteLength,_[1],1,`${p(W)}`),this.disposeActiveRequest({type:W,id:_[1]})}}onPromise(I){const M=this.channels.get(I.channelName);if(!M){this.collectPendingRequest(I);return}const _=new S.CancellationTokenSource;let T;try{T=M.call(this.ctx,I.name,I.arg,_.token)}catch(H){T=Promise.reject(H)}const W=I.id;T.then(H=>{this.sendResponse({id:W,data:H,type:201}),this.activeRequests.delete(I.id)},H=>{H instanceof Error?this.sendResponse({id:W,data:{message:H.message,name:H.name,stack:H.stack?H.stack.split?H.stack.split(`
`):H.stack:void 0},type:202}):this.sendResponse({id:W,data:H,type:203}),this.activeRequests.delete(I.id)});const B=(0,R.toDisposable)(()=>_.cancel());this.activeRequests.set(I.id,B)}onEventListen(I){const M=this.channels.get(I.channelName);if(!M){this.collectPendingRequest(I);return}const _=I.id,W=M.listen(this.ctx,I.name,I.arg)(B=>this.sendResponse({id:_,data:B,type:204}));this.activeRequests.set(I.id,W)}disposeActiveRequest(I){const M=this.activeRequests.get(I.id);M&&(M.dispose(),this.activeRequests.delete(I.id))}collectPendingRequest(I){let M=this.pendingRequests.get(I.channelName);M||(M=[],this.pendingRequests.set(I.channelName,M));const _=setTimeout(()=>{console.error(`Unknown channel: ${I.channelName}`),I.type===100&&this.sendResponse({id:I.id,data:{name:"Unknown channel",message:`Channel name '${I.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:I,timeoutTimer:_})}flushPendingRequests(I){const M=this.pendingRequests.get(I);if(M){for(const _ of M)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.onPromise(_.request);break;case 102:this.onEventListen(_.request);break}this.pendingRequests.delete(I)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(I=>I.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var P;(function(C){C[C.LocalSide=0]="LocalSide",C[C.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(I,M=null){this.protocol=I,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(_=>this.onBuffer(_)),this.logger=M}getChannel(I){const M=this;return{call(_,T,W){return M.isDisposed?Promise.reject(k.canceled()):M.requestPromise(I,_,T,W)},listen(_,T){return M.isDisposed?Promise.reject(k.canceled()):M.requestEvent(I,_,T)}}}requestPromise(I,M,_,T=S.CancellationToken.None){const W=this.lastRequestId++,H={id:W,type:100,channelName:I,name:M,arg:_};if(T.isCancellationRequested)return Promise.reject(k.canceled());let K;return new Promise((ee,re)=>{if(T.isCancellationRequested)return re(k.canceled());const x=()=>{const pe=me=>{switch(me.type){case 201:this.handlers.delete(W),ee(me.data);break;case 202:this.handlers.delete(W);const fe=new Error(me.data.message);fe.stack=me.data.stack,fe.name=me.data.name,re(fe);break;case 203:this.handlers.delete(W),re(me.data);break}};this.handlers.set(W,pe),this.sendRequest(H)};let ie=null;this.state===b.Idle?x():(ie=(0,D.createCancelablePromise)(pe=>this.whenInitialized()),ie.then(()=>{ie=null,x()}));const ae=()=>{ie?(ie.cancel(),ie=null):this.sendRequest({id:W,type:101}),re(k.canceled())},ue=T.onCancellationRequested(ae);K=(0,R.combinedDisposable)((0,R.toDisposable)(ae),ue),this.activeRequests.add(K)}).finally(()=>{this.activeRequests.delete(K)})}requestEvent(I,M,_){const T=this.lastRequestId++,B={id:T,type:102,channelName:I,name:M,arg:_};let H=null;const K=new v.Emitter({onFirstListenerAdd:()=>{H=(0,D.createCancelablePromise)(ee=>this.whenInitialized()),H.then(()=>{H=null,this.activeRequests.add(K),this.sendRequest(B)})},onLastListenerRemove:()=>{H?(H.cancel(),H=null):(this.activeRequests.delete(K),this.sendRequest({id:T,type:103}))}}),J=ee=>K.fire(ee.data);return this.handlers.set(T,J),K.event}sendRequest(I){switch(I.type){case 100:case 102:{const M=this.send([I.type,I.id,I.channelName,I.name],I.arg);this.logger&&this.logger.logOutgoing(M,I.id,0,`${p(I.type)}: ${I.channelName}.${I.name}`,I.arg);return}case 101:case 103:{const M=this.send([I.type,I.id]);this.logger&&this.logger.logOutgoing(M,I.id,0,p(I.type));return}}}send(I,M=void 0){const _=new l;return u(_,I),u(_,M),this.sendBuffer(_.buffer)}sendBuffer(I){try{return this.protocol.send(I),I.byteLength}catch(M){return 0}}onBuffer(I){const M=new w(I),_=h(M),T=h(M),W=_[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(I.byteLength,0,0,m(W)),this.onResponse({type:_[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(I.byteLength,_[1],0,m(W),T),this.onResponse({type:_[0],id:_[1],data:T})}}onResponse(I){if(I.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(I.id);M&&M(I)}whenInitialized(){return this.state===b.Idle?Promise.resolve():v.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(I=>I.dispose()),this.activeRequests.clear()}}e.ChannelClient=A;class F{constructor(I){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,I(({protocol:M,onDidClientDisconnect:_})=>{v.Event.once(M.onMessage)(W=>{const B=new w(W),H=h(B),K=new f(M,H),J=new A(M);this.channels.forEach((re,x)=>K.registerChannel(x,re));const ee={channelServer:K,channelClient:J,ctx:H};this._connections.add(ee),this._onDidAddConnection.fire(ee),_(()=>{K.dispose(),J.dispose(),this._connections.delete(ee),this._onDidRemoveConnection.fire(ee)})})})}get connections(){const I=[];return this._connections.forEach(M=>I.push(M)),I}getChannel(I,M){const _=this;return{call(T,W,B){let H;if((0,i.isFunction)(M)){let J=(0,y.getRandomElement)(_.connections.filter(M));H=J?Promise.resolve(J):v.Event.toPromise(v.Event.filter(_.onDidAddConnection,M))}else H=M.routeCall(_,T,W);const K=H.then(J=>J.channelClient.getChannel(I));return j(K).call(T,W,B)},listen(T,W){if((0,i.isFunction)(M))return _.getMulticastEvent(I,M,T,W);const B=M.routeEvent(_,T,W).then(H=>H.channelClient.getChannel(I));return j(B).listen(T,W)}}}getMulticastEvent(I,M,_,T){const W=this;let B=new R.DisposableStore;const H=new v.Emitter({onFirstListenerAdd:()=>{B=new R.DisposableStore;const K=new v.EventMultiplexer,J=new Map,ee=x=>{const ae=x.channelClient.getChannel(I).listen(_,T),ue=K.add(ae);J.set(x,ue)},re=x=>{const ie=J.get(x);!ie||(ie.dispose(),J.delete(x))};W.connections.filter(M).forEach(ee),v.Event.filter(W.onDidAddConnection,M)(ee,void 0,B),W.onDidRemoveConnection(re,void 0,B),K.event(H.fire,H,B),B.add(K)},onLastListenerRemove:()=>{B.dispose()}});return H.event}registerChannel(I,M){this.channels.set(I,M),this._connections.forEach(_=>{_.channelServer.registerChannel(I,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=F;class N{constructor(I,M,_=null){const T=new l;u(T,M),I.send(T.buffer),this.channelClient=new A(I,_),this.channelServer=new f(I,M,_)}getChannel(I){return this.channelClient.getChannel(I)}registerChannel(I,M){this.channelServer.registerChannel(I,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=N;function j(C){return{call(I,M,_){return C.then(T=>T.call(I,M,_))},listen(I,M){const _=new v.Relay;return C.then(T=>_.input=T.listen(I,M)),_.event}}}e.getDelayedChannel=j;function G(C){let I=!1;return{call(M,_,T){return I?C.call(M,_,T):(0,D.timeout)(0).then(()=>I=!0).then(()=>C.call(M,_,T))},listen(M,_){if(I)return C.listen(M,_);const T=new v.Relay;return(0,D.timeout)(0).then(()=>I=!0).then(()=>T.input=C.listen(M,_)),T.event}}}e.getNextTickChannel=G;class ne{constructor(I){this.fn=I}routeCall(I){return this.route(I)}routeEvent(I){return this.route(I)}async route(I){for(const M of I.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await v.Event.toPromise(I.onDidAddConnection),await this.route(I)}}e.StaticRouter=ne;var oe;(function(C){function I(T,W){const B=T,H=W&&W.disableMarshalling,K=new Map;for(const J in B)_(J)&&K.set(J,v.Event.buffer(B[J],!0));return new class{listen(J,ee){const re=K.get(ee);if(re)return re;throw new Error(`Event not found: ${ee}`)}call(J,ee,re){const x=B[ee];if(typeof x=="function"){if(!H&&Array.isArray(re))for(let ie=0;ie<re.length;ie++)re[ie]=(0,L.revive)(re[ie]);return x.apply(B,re)}throw new Error(`Method not found: ${ee}`)}}}C.fromService=I;function M(T,W){const B=W&&W.disableMarshalling;return new Proxy({},{get(H,K){var J;if(typeof K=="string")return((J=W==null?void 0:W.properties)===null||J===void 0?void 0:J.has(K))?W.properties.get(K):_(K)?T.listen(K):async function(...ee){let re;W&&!(0,i.isUndefinedOrNull)(W.context)?re=[W.context,...ee]:re=ee;const x=await T.call(K,re);return B?x:(0,L.revive)(x)};throw new Error(`Property not found: ${String(K)}`)}})}C.toService=M;function _(T){return T[0]==="o"&&T[1]==="n"&&g.isUpperAsciiLetter(T.charCodeAt(2))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Y(C){if(Array.isArray(C))return C;if(C&&typeof C=="object"&&typeof C.toString=="function"){let I=C.toString();if(I!=="[object Object]")return I}return C}function U(C){return Array.isArray(C)?C.map(Y):Y(C)}function O(C,I,M,_,T,W,B){B=U(B);const H=V[T],K=H[_%H.length];let J=[`%c[${C}]%c[${String(I).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${K}`];/\($/.test(W)?(J=J.concat(B),J.push(")")):J.push(B),console.log.apply(console,J)}e.logWithColors=O;class z{constructor(I,M){this._outgoingPrefix=I,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(I,M,_,T,W){this._totalOutgoing+=I,O(this._outgoingPrefix,this._totalOutgoing,I,M,_,T,W)}logIncoming(I,M,_,T,W){this._totalIncoming+=I,O(this._incomingPrefix,this._totalIncoming,I,M,_,T,W)}}e.IPCLogger=z}),define(X[118],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(D,S){this.sender=D,this.onMessage=S}send(D){try{this.sender.send("vscode:message",D.buffer)}catch(S){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(X[119],Q([0,1,5,33,20]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class S{constructor(y){this.port=y,this.onMessage=v.Event.fromDOMEventEmitter(this.port,"message",i=>D.VSBuffer.wrap(i.data)),y.start()}send(y){this.port.postMessage(y.buffer)}disconnect(){this.port.close()}}e.Protocol=S;class k extends R.IPCClient{constructor(y,i){const L=new S(y);super(L,i);this.protocol=L}dispose(){this.protocol.disconnect()}}e.Client=k}),define(X[83],Q([0,1,5,33,2,20,3,35]),function($,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let y=null;function i(){return y||(y=S.VSBuffer.alloc(0)),y}class L{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,u){if(a===0)return i();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const A=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=a),A}if(this._chunks[0].byteLength>a){const A=this._chunks[0].slice(0,a);return u&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),A}let h=S.VSBuffer.alloc(a),f=0,P=0;for(;a>0;){const A=this._chunks[P];if(A.byteLength>a){const F=A.slice(0,a);h.set(F,f),f+=a,u&&(this._chunks[P]=A.slice(a),this._totalLength-=a),a-=a}else h.set(A,f),f+=A.byteLength,u?(this._chunks.shift(),this._totalLength-=A.byteLength):P++,a-=A.byteLength}return h}}e.ChunkStream=L;var g;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(g||(g={}));var E;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(a,u,h,f){this.type=a,this.id=u,this.ack=h,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends D.Disposable{constructor(a){super();this._onMessage=this._register(new v.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new L,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5);else{const h=this._state.messageType,f=this._state.id,P=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new p(h,f,P,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(a){this._isDisposed=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(a){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(a){if(!this._isDisposed){a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=S.VSBuffer.alloc(13);u.writeUInt8(a.type,0),u.writeUInt32BE(a.id,1),u.writeUInt32BE(a.ack,5),u.writeUInt32BE(a.data.byteLength,9),this._writeSoon(u,a.data)}}_bufferAdd(a,u){const h=this._totalLength===0;return this._data.push(a,u),this._totalLength+=a.byteLength+u.byteLength,h}_bufferTake(){const a=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,u){this._bufferAdd(a,u)&&k.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class b extends D.Disposable{constructor(a){super();this._onMessage=new v.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new v.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new p(1,0,0,a))}}e.Protocol=b;class w extends R.IPCClient{constructor(a,u,h=null){super(a,u,h);this.protocol=a}static fromSocket(a,u){return new w(new b(a),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=w;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new v.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,n.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class c{constructor(a){this.data=a,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let a=[],u=0,h=this._first;for(;h;)a[u++]=h.data,h=h.next;return a}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const u=new c(a);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class s{constructor(){this.lastRuns=[];const a=Date.now();for(let u=0;u<s._HISTORY_LENGTH;u++)this.lastRuns[u]=a-1e3*u;setInterval(()=>{for(let u=s._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const a=Date.now(),u=(1+s._HISTORY_LENGTH)*1e3;let h=0;for(let f=0;f<s._HISTORY_LENGTH;f++)a-this.lastRuns[f]<=u&&h++;return 1-h/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class t{constructor(a,u=null){this._loadEstimator=s.getInstance(),this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=a,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),u&&this._socketReader.acceptChunk(u),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new p(5,0,0,i());this._socketWriter.write(a),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const a=Date.now()-this._socketWriter.lastWriteTime;if(a>=5e3){const u=new p(4,0,0,i());this._socketWriter.write(u),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-a+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const a=Date.now()-this._socketReader.lastReadTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-a,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,u){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=a,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1;const a=this._outgoingUnackMsg.toArray();for(let u=0,h=a.length;u<h;u++)this._socketWriter.write(a[u]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(a.type===1){if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new p(6,0,0,i())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data)}else if(a.type===2)this._onControlMessage.fire(a.data);else if(a.type===5)this._onDidDispose.fire();else if(a.type===6){const u=this._outgoingUnackMsg.toArray();for(let h=0,f=u.length;h<f;h++)this._socketWriter.write(u[h]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new p(1,u,this._incomingAckId,a);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(a){const u=new p(2,0,0,a);this._socketWriter.write(u)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const a=this._outgoingUnackMsg.peek(),u=Date.now()-a.writtenTime;if(u>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-u,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const a=new p(3,0,this._incomingAckId,i());this._socketWriter.write(a)}}}e.PersistentProtocol=t}),define(X[120],Q([0,1,11,5,33,118,2,20]),function($,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function y(L,g){const E=R.Event.fromNodeEventEmitter(v.ipcMain,g,(d,m)=>({event:d,message:m})),p=R.Event.filter(E,({event:d})=>d.sender.id===L);return R.Event.map(p,({message:d})=>d&&n.VSBuffer.wrap(d))}class i extends D.IPCServer{constructor(){super(i.getOnDidClientConnect())}static getOnDidClientConnect(){const g=R.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:E})=>E);return R.Event.map(g,E=>{const p=E.id,d=i.Clients.get(p);d&&d.dispose();const m=new R.Emitter;i.Clients.set(p,(0,k.toDisposable)(()=>m.fire()));const b=y(p,"vscode:message"),w=R.Event.any(R.Event.signal(y(p,"vscode:disconnect")),m.event);return{protocol:new S.Protocol(E,b),onDidClientDisconnect:w}})}}e.Server=i,i.Clients=new Map}),define(X[84],Q([0,1,11,5,28,119]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class k extends S.Client{constructor(i,L){super({addEventListener:(g,E)=>i.addListener(g,E),removeEventListener:(g,E)=>i.removeListener(g,E),postMessage:g=>i.postMessage(g),start:()=>i.start(),close:()=>i.close()},L)}}e.Client=k;async function n(y){if(y.isDestroyed()||y.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const i=(0,D.generateUuid)();y.webContents.send("vscode:createMessageChannel",i);const L=R.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(E,p)=>({nonce:p,port:E.ports[0]})),{port:g}=await R.Event.toPromise(R.Event.once(R.Event.filter(L,E=>E.nonce===i)));return g}e.connect=n}),define(X[85],Q([0,1,2,5,10,13]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var k;(function(L){L[L.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));var n;(function(L){L[L.None=0]="None",L[L.Initialized=1]="Initialized",L[L.Closed=2]="Closed"})(n||(n={}));class y extends v.Disposable{constructor(g,E=Object.create(null)){super();this.database=g,this.options=E,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=n.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(y.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){var E,p;(E=g.changed)===null||E===void 0||E.forEach((d,m)=>this.accept(m,d)),(p=g.deleted)===null||p===void 0||p.forEach(d=>this.accept(d,void 0))}accept(g,E){if(this.state!==n.Closed){let p=!1;(0,S.isUndefinedOrNull)(E)?p=this.cache.delete(g):this.cache.get(g)!==E&&(this.cache.set(g,E),p=!0),p&&this._onDidChangeStorage.fire(g)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===n.None&&(this.state=n.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,E){const p=this.cache.get(g);return(0,S.isUndefinedOrNull)(p)?E:p}getBoolean(g,E){const p=this.get(g);return(0,S.isUndefinedOrNull)(p)?E:p==="true"}getNumber(g,E){const p=this.get(g);return(0,S.isUndefinedOrNull)(p)?E:parseInt(p,10)}async set(g,E){if(this.state!==n.Closed){if((0,S.isUndefinedOrNull)(E))return this.delete(g);const p=String(E);if(this.cache.get(g)!==p)return this.cache.set(g,p),this.pendingInserts.set(g,p),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(g){if(this.state!==n.Closed&&!!this.cache.delete(g))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=n.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{var E;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(E=this.whenFlushedCallbacks.pop())===null||E===void 0||E()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=y,y.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((E,p)=>this.items.set(p,E)),g.delete&&g.delete.forEach(E=>this.items.delete(E))}async close(){}}e.InMemoryStorageDatabase=i}),define(X[121],Q([0,1,21,5,10,36,8,22]),function($,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class y{constructor(g,E=Object.create(null)){this.path=g,this.options=E,this.name=(0,k.basename)(this.path),this.logger=new i(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return R.Event.None}async getItems(){const g=await this.whenConnected,E=new Map;return(await this.all(g,"SELECT * FROM ItemTable")).forEach(d=>E.set(d.key,d.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${E.size} rows`),E}async updateItems(g){const E=await this.whenConnected;return this.doUpdateItems(E,g)}doUpdateItems(g,E){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${E.insert?(0,S.mapToString)(E.insert):"0"}), delete(${E.delete?(0,S.setToString)(E.delete):"0"})`),this.transaction(g,()=>{const p=E.insert,d=E.delete;if(p&&p.size>0){const m=[];m.push([]);let b=0;p.forEach((w,l)=>{let c=m[b];c.length>y.MAX_HOST_PARAMETERS&&(b++,c=[],m.push(c)),c.push(l,w)}),m.forEach(w=>{this.prepare(g,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,l=>l.run(w),()=>{const l=[];let c=0;return p.forEach((o,s)=>{l.push(s),c+=o.length}),`Keys: ${l.join(", ")} Length: ${c}`})})}if(d&&d.size){const m=[];m.push([]);let b=0;d.forEach(w=>{let l=m[b];l.length>y.MAX_HOST_PARAMETERS&&(b++,l=[],m.push(l)),l.push(w)}),m.forEach(w=>{this.prepare(g,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,l=>l.run(w),()=>{const l=[];return d.forEach(c=>{l.push(c)}),`Keys: ${l.join(", ")}`})})}})}async close(g){this.logger.trace(`[storage ${this.name}] close()`);const E=await this.whenConnected;return this.doClose(E,g)}doClose(g,E){return new Promise((p,d)=>{g.db.close(m=>(m&&this.handleSQLiteError(g,`[storage ${this.name}] close(): ${m}`),this.path===y.IN_MEMORY_PATH?p():!g.isErroneous&&!g.isInMemory?this.backup().then(p,b=>(this.logger.error(`[storage ${this.name}] backup(): ${b}`),p())):typeof E=="function"?v.promises.unlink(this.path).then(()=>this.doConnect(this.path).then(b=>{const w=()=>this.doClose(b,void 0);return this.doUpdateItems(b,{insert:E()}).then(()=>w(),l=>(w(),Promise.reject(l)))})).then(p,d):d(m||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const g=this.toBackupPath(this.path);return(0,n.copy)(this.path,g,{preserveSymlinks:!1})}toBackupPath(g){return`${g}.backup`}async checkIntegrity(g){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${g})`);const E=await this.whenConnected,p=await this.get(E,g?"PRAGMA integrity_check":"PRAGMA quick_check"),d=g?p.integrity_check:p.quick_check;return E.isErroneous?`${d} (last error: ${E.lastError})`:E.isInMemory?`${d} (in-memory!)`:d}async connect(g,E=!0){this.logger.trace(`[storage ${this.name}] open(${g}, retryOnBusy: ${E})`);try{return await this.doConnect(g)}catch(p){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&E)return await(0,D.timeout)(y.BUSY_OPEN_TIMEOUT),this.connect(g,!1);try{await v.promises.unlink(g);try{await v.promises.rename(this.toBackupPath(g),g)}catch(d){}return await this.doConnect(g)}catch(d){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${d}`),this.doConnect(y.IN_MEMORY_PATH)}}}handleSQLiteError(g,E){g.isErroneous=!0,g.lastError=E,this.logger.error(E)}doConnect(g){return new Promise((E,p)=>{new Promise((d,m)=>{$(["vscode-sqlite3"],d,m)}).then(d=>{const m={db:new(this.logger.isTracing?d.verbose().Database:d.Database)(g,b=>b?m.db?m.db.close(()=>p(b)):p(b):this.exec(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>E(m),w=>m.db.close(()=>p(w)))),isInMemory:g===y.IN_MEMORY_PATH};m.db.on("error",b=>this.handleSQLiteError(m,`[storage ${this.name}] Error (event): ${b}`)),this.logger.isTracing&&m.db.on("trace",b=>this.logger.trace(`[storage ${this.name}] Trace (event): ${b}`))},p)})}exec(g,E){return new Promise((p,d)=>{g.db.exec(E,m=>m?(this.handleSQLiteError(g,`[storage ${this.name}] exec(): ${m}`),d(m)):p())})}get(g,E){return new Promise((p,d)=>{g.db.get(E,(m,b)=>m?(this.handleSQLiteError(g,`[storage ${this.name}] get(): ${m}`),d(m)):p(b))})}all(g,E){return new Promise((p,d)=>{g.db.all(E,(m,b)=>m?(this.handleSQLiteError(g,`[storage ${this.name}] all(): ${m}`),d(m)):p(b))})}transaction(g,E){return new Promise((p,d)=>{g.db.serialize(()=>{g.db.run("BEGIN TRANSACTION"),E(),g.db.run("END TRANSACTION",m=>m?(this.handleSQLiteError(g,`[storage ${this.name}] transaction(): ${m}`),d(m)):p())})})}prepare(g,E,p,d){const m=g.db.prepare(E),b=w=>{this.handleSQLiteError(g,`[storage ${this.name}] prepare(): ${w} (${E}). Details: ${d()}`)};m.on("error",b),p(m),m.finalize(w=>{w&&b(w),m.removeListener("error",b)})}}e.SQLiteStorageDatabase=y,y.IN_MEMORY_PATH=":memory:",y.BUSY_OPEN_TIMEOUT=2e3,y.MAX_HOST_PARAMETERS=256;class i{constructor(g){g&&typeof g.logTrace=="function"&&process.env[i.VSCODE_TRACE_STORAGE]&&(this.logTrace=g.logTrace),g&&typeof g.logError=="function"&&(this.logError=g.logError)}get isTracing(){return!!this.logTrace}trace(g){this.logTrace&&this.logTrace(g)}error(g){this.logError&&this.logError(g)}}i.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(X[122],Q([14,12]),function($,e){return $.create("vs/base/common/date",e)}),define(X[123],Q([0,1,122]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,D=R*60,S=D*24,k=S*7,n=S*30,y=S*365;function i(g,E){typeof g!="number"&&(g=g.getTime());const p=Math.round((new Date().getTime()-g)/1e3);if(p<-30)return(0,v.localize)(0,null,i(new Date().getTime()+p*1e3,!1));if(p<30)return(0,v.localize)(1,null);let d;return p<R?(d=p,E?d===1?(0,v.localize)(2,null,d):(0,v.localize)(3,null,d):d===1?(0,v.localize)(4,null,d):(0,v.localize)(5,null,d)):p<D?(d=Math.floor(p/R),E?d===1?(0,v.localize)(6,null,d):(0,v.localize)(7,null,d):d===1?(0,v.localize)(8,null,d):(0,v.localize)(9,null,d)):p<S?(d=Math.floor(p/D),E?d===1?(0,v.localize)(10,null,d):(0,v.localize)(11,null,d):d===1?(0,v.localize)(12,null,d):(0,v.localize)(13,null,d)):p<k?(d=Math.floor(p/S),E?d===1?(0,v.localize)(14,null,d):(0,v.localize)(15,null,d):d===1?(0,v.localize)(16,null,d):(0,v.localize)(17,null,d)):p<n?(d=Math.floor(p/k),E?d===1?(0,v.localize)(18,null,d):(0,v.localize)(19,null,d):d===1?(0,v.localize)(20,null,d):(0,v.localize)(21,null,d)):p<y?(d=Math.floor(p/n),E?d===1?(0,v.localize)(22,null,d):(0,v.localize)(23,null,d):d===1?(0,v.localize)(24,null,d):(0,v.localize)(25,null,d)):(d=Math.floor(p/y),E?d===1?(0,v.localize)(26,null,d):(0,v.localize)(27,null,d):d===1?(0,v.localize)(28,null,d):(0,v.localize)(29,null,d))}e.fromNow=i;function L(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(X[124],Q([14,12]),function($,e){return $.create("vs/base/common/errorMessage",e)}),define(X[67],Q([0,1,124,13,34]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(i,L){return L&&(i.stack||i.stacktrace)?v.localize(0,null,n(i),k(i.stack)||k(i.stacktrace)):n(i)}function k(i){return Array.isArray(i)?i.join(`
`):i}function n(i){return typeof i.code=="string"&&typeof i.errno=="number"&&typeof i.syscall=="string"?v.localize(1,null,i.message):i.message||v.localize(2,null)}function y(i=null,L=!1){if(!i)return v.localize(3,null);if(Array.isArray(i)){const g=D.coalesce(i),E=y(g[0],L);return g.length>1?v.localize(4,null,E,g.length):E}if(R.isString(i))return i;if(i.detail){const g=i.detail;if(g.error)return S(g.error,L);if(g.exception)return S(g.exception,L)}return i.stack?S(i,L):i.message?i.message:v.localize(5,null)}e.toErrorMessage=y}),define(X[125],Q([14,12]),function($,e){return $.create("vs/base/common/keybindingLabels",e)}),define(X[126],Q([0,1,125]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class R{constructor(k,n,y=n){this.modifierLabels=[null],this.modifierLabels[2]=k,this.modifierLabels[1]=n,this.modifierLabels[3]=y}toLabel(k,n,y){if(n.length===0)return null;const i=[];for(let L=0,g=n.length;L<g;L++){const E=n[L],p=y(E);if(p===null)return null;i[L]=D(E,p,this.modifierLabels[k])}return i.join(" ")}}e.ModifierLabelProvider=R,e.UILabelProvider=new R({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new R({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new R({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new R({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(S,k,n){if(k===null)return"";const y=[];return S.ctrlKey&&y.push(n.ctrlKey),S.shiftKey&&y.push(n.shiftKey),S.altKey&&y.push(n.altKey),S.metaKey&&y.push(n.metaKey),k!==""&&y.push(k),y.join(n.separator)}}),define(X[127],Q([14,12]),function($,e){return $.create("vs/base/node/processes",e)}),define(X[86],Q([0,1,8,21,22,46,127,35,13,45,30,3,81,9]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function d(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(s,t){if(g.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};t&&(r.cwd=t);const a=S.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],r);return new Promise(u=>{a.once("error",h=>{u({success:!1,error:h})}),a.once("exit",(h,f)=>{u(h===0?{success:!0}:{success:!1,code:h!==null?h:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?d(r.status):1})}else if(g.isLinux||g.isMacintosh)try{const r=p.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(a=>{S.execFile(r,[s.pid.toString()],{encoding:"utf8",shell:!0},(u,h,f)=>{a(u?{success:!1,error:u}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function b(s=n.env){return s.comspec||"cmd.exe"}e.getWindowsShell=b;class w{constructor(t,r,a,u){if(r!==void 0&&a!==void 0&&u!==void 0)this.cmd=t,this.args=r,this.shell=a,this.options=u;else{const h=t;this.cmd=h.command,this.shell=h.isShellCommand,this.args=h.args.slice(0),this.options=h.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const h=Object.create(null);Object.keys(n.env).forEach(f=>{h[f]=n.env[f]}),Object.keys(this.options.env).forEach(f=>{h[f]=this.options.env[f]}),this.options.env=h}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const r=t.lastIndexOf(v.sep);return r!==-1&&(t=t.substring(r+1)),w.WellKnowCommands[t]?t:"other"}start(t){return g.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(n.cwd()))?Promise.reject(new Error(k.localize(0,null))):this.useExec().then(r=>{let a,u;const h=new Promise((f,P)=>{a=f,u=P});if(r){let f=this.cmd;this.args&&(f=f+" "+this.args.join(" ")),this.childProcess=S.exec(f,this.options,(P,A,F)=>{this.childProcess=null;const N=P;N&&N.killed?u({killed:this.terminateRequested,stdout:A.toString(),stderr:F.toString()}):this.handleExec(a,t,P,A,F)})}else{let f=null;const P=A=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(A,a,t,u);const F={terminated:this.terminateRequested};y.isNumber(A)&&(F.cmdCode=A),a(F)};if(this.shell&&g.isWindows){const A=i.deepClone(this.options);A.windowsVerbatimArguments=!0,A.detached=!1;let F=!1,N=!1;const j=[];let G=this.ensureQuotes(this.cmd);j.push(G.value),F=G.quoted,this.args&&this.args.forEach(oe=>{G=this.ensureQuotes(oe),j.push(G.value),N=N&&G.quoted});const ne=["/s","/c"];F?N?ne.push('"'+j.join(" ")+'"'):j.length>1?ne.push('"'+j[0]+'" '+j.slice(1).join(" ")):ne.push('"'+j[0]+'"'):ne.push(j.join(" ")),f=S.spawn(b(),ne,A)}else this.cmd&&(f=S.spawn(this.cmd,this.args,this.options));f&&(this.childProcess=f,this.childProcessPromise=Promise.resolve(f),this.pidResolve&&(this.pidResolve(y.isNumber(f.pid)?f.pid:-1),this.pidResolve=void 0),f.on("error",A=>{this.childProcess=null,u({terminated:this.terminateRequested,error:A})}),f.pid&&(this.childProcess.on("close",P),this.handleSpawn(f,a,t,u,!0)))}return h})}handleClose(t,r,a,u){}ensureQuotes(t){return w.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,m(t,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!g.isWindows)return t(!1);const r=S.spawn(b(),["/s","/c"]);r.on("error",a=>t(!0)),r.on("exit",a=>t(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class l extends w{constructor(t,r,a,u){super(t,r,a,u);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,r,a,u,h){[u,h].forEach((f,P)=>{const A=new E.LineDecoder;A.write(f).forEach(j=>{r({line:j,source:P===0?0:1})});const N=A.end();N&&r({line:N,source:P===0?0:1})}),t({terminated:this.terminateRequested,error:a})}handleSpawn(t,r,a,u,h){const f=new E.LineDecoder,P=new E.LineDecoder;t.stdout.on("data",A=>{f.write(A).forEach(N=>a({line:N,source:0}))}),t.stderr.on("data",A=>{P.write(A).forEach(N=>a({line:N,source:1}))}),this.stdoutLineDecoder=f,this.stderrLineDecoder=P}handleClose(t,r,a,u){const h=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;h&&a({line:h,source:0});const f=this.stderrLineDecoder?this.stderrLineDecoder.end():null;f&&a({line:f,source:1})}}e.LineProcess=l;function c(s){let t=[],r=!1;const a=function(u){if(r){t.push(u);return}(!s.send(u,f=>{if(f&&console.error(f),r=!1,t.length>0){const P=t.slice(0);t=[],P.forEach(A=>a(A))}})||g.isWindows)&&(r=!0)};return{send:a}}e.createQueuedSender=c;var o;(function(s){async function t(r,a,u){if(v.isAbsolute(r))return r;if(a===void 0&&(a=n.cwd()),v.dirname(r)!=="."||(u===void 0&&y.isString(n.env.PATH)&&(u=n.env.PATH.split(v.delimiter)),u===void 0||u.length===0))return v.join(a,r);async function f(P){return await D.exists(P)?!(await R.promises.stat(P)).isDirectory():!1}for(let P of u){let A;if(v.isAbsolute(P)?A=v.join(P,r):A=v.join(a,P,r),await f(A))return A;let F=A+".com";if(await f(F)||(F=A+".exe",await f(F)))return F}return v.join(a,r)}s.findExecutable=t})(o=e.win32||(e.win32={}))}),define(X[128],Q([0,1,27,3,114,86]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(p,d){return p===3?R.isWindows?g():S.getWindowsShell(d):i(p,d)}e.getSystemShell=k;function n(p,d){return p===3?R.isWindows?E(d):S.getWindowsShell(d):i(p,d)}e.getSystemShellSync=n;let y=null;function i(p,d){if(R.isLinux&&p===1||R.isMacintosh&&p===2)return"/bin/bash";if(!y){let m;if(R.isWindows)m="/bin/bash";else{if(m=d.SHELL,!m)try{m=v.userInfo().shell}catch(b){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}y=m}return y}let L=null;async function g(){return L||(L=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),L}function E(p){if(L)return L;const d=R.isWindows&&parseFloat(v.release())>=10,m=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${p.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?b:S.getWindowsShell(p)}}),define(X[87],Q([0,1,46,2,10,45,5,86,33,106,25,18,20,3]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends y.ChannelServer{constructor(w){super({send:l=>{try{process.send&&process.send(l.buffer.toString("base64"))}catch(c){}},onMessage:k.Event.fromNodeEventEmitter(process,"message",l=>E.VSBuffer.wrap(Buffer.from(l,"base64")))},w);process.once("disconnect",()=>this.dispose())}}e.Server=d;class m{constructor(w,l){this.modulePath=w,this.options=l,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new k.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=l&&l.timeout?l.timeout:6e4;this.disposeDelayer=new D.Delayer(c),this.child=null,this._client=null}getChannel(w){const l=this;return{call(c,o,s){return l.requestPromise(w,c,o,s)},listen(c,o){return l.requestEvent(w,c,o)}}}requestPromise(w,l,c,o=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(g.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(w),t=(0,D.createCancelablePromise)(u=>s.call(l,c,u)),r=o.onCancellationRequested(()=>t.cancel()),a=(0,R.toDisposable)(()=>t.cancel());return this.activeRequests.add(a),t.finally(()=>{r.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(w,l,c){if(!this.disposeDelayer)return k.Event.None;this.disposeDelayer.cancel();let o;const s=new k.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(w).listen(l,c)(s.fire,s),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const w=this.options&&this.options.args?this.options.args:[],l=Object.create(null);l.env=Object.assign(Object.assign({},(0,S.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(l.env=Object.assign(Object.assign({},l.env),this.options.env)),this.options&&this.options.freshExecArgv&&(l.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h))),p.isMacintosh&&l.env&&delete l.env.DYLD_LIBRARY_PATH,this.child=(0,v.fork)(this.modulePath,w,l);const c=new k.Emitter;k.Event.fromNodeEventEmitter(this.child,"message",h=>h)(h=>{if((0,i.isRemoteConsoleLog)(h)){(0,i.log)(h,`IPC Library: ${this.options.serverName}`);return}c.fire(E.VSBuffer.wrap(Buffer.from(h,"base64")))});const s=this.options.useQueue?(0,n.createQueuedSender)(this.child):this.child,t=h=>this.child&&this.child.connected&&s.send(h.buffer.toString("base64")),r=c.event,a={send:t,onMessage:r};this._client=new y.ChannelClient(a);const u=()=>this.disposeClient();process.once("exit",u),this.child.on("error",h=>console.warn('IPC "'+this.options.serverName+'" errored with '+h)),this.child.on("exit",(h,f)=>{process.removeListener("exit",u),this.activeRequests.forEach(P=>(0,R.dispose)(P)),this.activeRequests.clear(),h!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+h+" and signal "+f),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:h,signal:f})})}return this._client}getCachedChannel(w){let l=this.channels.get(w);return l||(l=this.client.getChannel(w),this.channels.set(w,l)),l}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=m}),define(X[129],Q([14,12]),function($,e){return $.create("vs/code/electron-main/app",e)}),define(X[130],Q([14,12]),function($,e){return $.create("vs/platform/configuration/common/configurationRegistry",e)}),define(X[131],Q([14,12]),function($,e){return $.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(X[132],Q([14,12]),function($,e){return $.create("vs/platform/environment/node/argv",e)}),define(X[133],Q([14,12]),function($,e){return $.create("vs/platform/environment/node/argvHelper",e)}),define(X[134],Q([14,12]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(X[135],Q([14,12]),function($,e){return $.create("vs/platform/extensions/common/extensionValidator",e)}),define(X[136],Q([14,12]),function($,e){return $.create("vs/platform/files/common/fileService",e)}),define(X[137],Q([14,12]),function($,e){return $.create("vs/platform/files/common/files",e)}),define(X[138],Q([14,12]),function($,e){return $.create("vs/platform/files/common/io",e)}),define(X[139],Q([14,12]),function($,e){return $.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(X[140],Q([14,12]),function($,e){return $.create("vs/platform/issue/electron-main/issueMainService",e)}),define(X[141],Q([14,12]),function($,e){return $.create("vs/platform/menubar/electron-main/menubar",e)}),define(X[142],Q([14,12]),function($,e){return $.create("vs/platform/request/common/request",e)}),define(X[143],Q([14,12]),function($,e){return $.create("vs/platform/telemetry/common/telemetryService",e)}),define(X[144],Q([14,12]),function($,e){return $.create("vs/platform/update/common/update.config.contribution",e)}),define(X[145],Q([14,12]),function($,e){return $.create("vs/platform/windows/electron-main/window",e)}),define(X[146],Q([14,12]),function($,e){return $.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(X[147],Q([14,12]),function($,e){return $.create("vs/platform/workspaces/common/workspaces",e)}),define(X[148],Q([14,12]),function($,e){return $.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(X[149],Q([14,12]),function($,e){return $.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(X[150],Q([0,1,5,2]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(n,y,i){switch(y){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:i[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:i[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:i[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:i[0],port:i[1],subId:i[2]}))}throw new Error("Method not implemented.")}listen(n,y,i){switch(y){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class S extends R.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,y,i){this.channel.call("attach",[n,y,i])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,y){this.channel.call("terminate",[n,y])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,y,i){return this.channel.call("openExtensionDevelopmentHostWindow",[n,y||{},i])}}e.ExtensionHostDebugChannelClient=S});var ce=this&&this.__decorate||function($,e,v,R){var D=arguments.length,S=D<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,v):R,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate($,e,v,R);else for(var n=$.length-1;n>=0;n--)(k=$[n])&&(S=(D<3?k(S):D>3?k(e,v,S):k(e,v))||S);return D>3&&S&&Object.defineProperty(e,v,S),S};define(X[151],Q([0,1,8,15,52,123,9,7,35]),function($,e,v,R,D,S,k,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class i{constructor(d,m,b){this._args=d,this.paths=m,this.productService=b}get appRoot(){return(0,v.dirname)(k.FileAccess.asFileUri("",$).fsPath)}get userHome(){return n.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return n.URI.file((0,v.join)(this.userDataPath,"User"))}get tmpDir(){return n.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,v.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return n.URI.file((0,v.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(n.URI.file((0,v.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return n.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return n.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=y.env.VSCODE_PORTABLE;return d?n.URI.file((0,v.join)(d,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return n.URI.file((0,v.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,v.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,v.resolve)(d):(0,v.normalize)((0,v.join)(k.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,v.resolve)(d):(0,v.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,v.resolve)(d);const m=y.env.VSCODE_EXTENSIONS;if(m)return m;const b=y.env.VSCODE_PORTABLE;return b?(0,v.join)(b,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(m=>/^[^:/?#]+?:\/\//.test(m)?n.URI.parse(m):n.URI.file((0,v.normalize)(m)))}get extensionDevelopmentKind(){var d;return(d=this.args.extensionDevelopmentKind)===null||d===void 0?void 0:d.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?n.URI.parse(d):n.URI.file((0,v.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return L(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!y.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(n.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return n.URI.file((0,v.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ce([D.memoize],i.prototype,"appRoot",null),ce([D.memoize],i.prototype,"userHome",null),ce([D.memoize],i.prototype,"userDataPath",null),ce([D.memoize],i.prototype,"appSettingsHome",null),ce([D.memoize],i.prototype,"tmpDir",null),ce([D.memoize],i.prototype,"userRoamingDataHome",null),ce([D.memoize],i.prototype,"settingsResource",null),ce([D.memoize],i.prototype,"userDataSyncHome",null),ce([D.memoize],i.prototype,"userDataSyncLogResource",null),ce([D.memoize],i.prototype,"sync",null),ce([D.memoize],i.prototype,"machineSettingsResource",null),ce([D.memoize],i.prototype,"globalStorageHome",null),ce([D.memoize],i.prototype,"workspaceStorageHome",null),ce([D.memoize],i.prototype,"keybindingsResource",null),ce([D.memoize],i.prototype,"keyboardLayoutResource",null),ce([D.memoize],i.prototype,"argvResource",null),ce([D.memoize],i.prototype,"snippetsHome",null),ce([D.memoize],i.prototype,"isExtensionDevelopment",null),ce([D.memoize],i.prototype,"untitledWorkspacesHome",null),ce([D.memoize],i.prototype,"installSourcePath",null),ce([D.memoize],i.prototype,"builtinExtensionsPath",null),ce([D.memoize],i.prototype,"extensionsPath",null),ce([D.memoize],i.prototype,"extensionDevelopmentLocationURI",null),ce([D.memoize],i.prototype,"extensionDevelopmentKind",null),ce([D.memoize],i.prototype,"extensionTestsLocationURI",null),ce([D.memoize],i.prototype,"debugExtensionHost",null),ce([D.memoize],i.prototype,"serviceMachineIdResource",null),ce([D.memoize],i.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=i;function L(p,d){return E(p["inspect-extensions"],p["inspect-brk-extensions"],5870,d,p.debugId)}e.parseExtensionHostPort=L;function g(p,d){return E(p["inspect-search"],p["inspect-brk-search"],5876,d)}e.parseSearchPort=g;function E(p,d,m,b,w){const c=Number(d||p)||(b?null:m),o=c?Boolean(!!d):!1;return{port:c,break:o,debugId:w}}}),define(X[88],Q([0,1,236,132,3]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const S={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null)},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null)},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(d,m,b=k){const w={},l=[],c=[];for(let r in m){const a=m[r];a.alias&&(w[r]=a.alias),a.type==="string"||a.type==="string[]"?(l.push(r),a.deprecates&&l.push(a.deprecates)):a.type==="boolean"&&(c.push(r),a.deprecates&&c.push(a.deprecates))}const o=v(d,{string:l,boolean:c,alias:w}),s={},t=o;s._=o._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in m){const a=m[r];a.alias&&delete t[a.alias];let u=t[r];a.deprecates&&t.hasOwnProperty(a.deprecates)&&(u||(u=t[a.deprecates]),delete t[a.deprecates]),typeof u!="undefined"&&(a.type==="string[]"?u&&!Array.isArray(u)&&(u=[u]):a.type==="string"&&Array.isArray(u)&&(u=u.pop(),b.onMultipleValues(r,u)),s[r]=u),delete t[r]}for(let r in t)b.onUnknownOption(r);return s}e.parseArgs=n;function y(d,m){let b="";return m.args&&(Array.isArray(m.args)?b=` <${m.args.join("> <")}>`:b=` <${m.args}>`),m.alias?`-${m.alias} --${d}${b}`:`--${d}${b}`}function i(d,m){let b=0,w=[];for(const s in d){const t=d[s],r=y(s,t);b=Math.max(b,r.length),w.push([r,t.description])}let l=b+2+1;if(m-l<25)return w.reduce((s,t)=>s.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let c=m-l-1,o=[];for(const s of w){let t=s[0],r=g(s[1],c),a=L(l-t.length-2);o.push("  "+t+a+r[0]);for(let u=1;u<r.length;u++)o.push(L(l)+r[u])}return o}e.formatOptions=i;function L(d){return" ".repeat(d)}function g(d,m){let b=[];for(;d.length;){let w=d.length<m?d.length:d.lastIndexOf(" ",m),l=d.slice(0,w).trim();d=d.slice(w),b.push(l)}return b}function E(d,m,b,w,l=!0){const c=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${d} ${b}`];o.push(""),o.push(`${(0,R.localize)(32,null)}: ${m} [${(0,R.localize)(33,null)}][${(0,R.localize)(34,null)}...]`),o.push(""),l&&(D.isWindows?o.push((0,R.localize)(35,null,m)):o.push((0,R.localize)(36,null,m)),o.push(""));const s={};for(const t in w){const r=w[t];if(r.description&&r.cat){let a=s[r.cat];a||(s[r.cat]=a={}),a[t]=r}}for(let t in s){const r=t;let a=s[r];a&&(o.push(S[r]),o.push(...i(a,c)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=E;function p(d,m){return`${d||(0,R.localize)(37,null)}
${m||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=p}),define(X[152],Q([0,1,88,61,150]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class S extends D.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,y,i){return y==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(i[0],i[1],i[2]):super.call(n,y,i)}async openExtensionDevelopmentHostWindow(n,y,i){const L=(0,v.parseArgs)(n,v.OPTIONS);L.debugRenderer=i;const g=L.extensionDevelopmentPath;if(!g)return{};let E;const p=Object.keys(y);for(let c of p){let o=y[c];o===null||(E||(E=Object.create(null)),E[c]=o)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(g,{context:5,cli:L,userEnv:E});if(!i)return{};const m=d.win;if(!m)return{};const b=m.webContents.debugger;let w=b.isAttached()?Infinity:0;const l=(0,R.createServer)(c=>{w++==0&&b.attach();let o=!1;const s=a=>{o||c.write(JSON.stringify(a)+"\0")},t=(a,u,h,f)=>s({method:u,params:h,sessionId:f});m.on("close",()=>{b.removeListener("message",t),c.end(),o=!0}),b.addListener("message",t);let r=Buffer.alloc(0);c.on("data",a=>{r=Buffer.concat([r,a]);for(let u=r.indexOf(0);u!==-1;u=r.indexOf(0)){let h;try{const f=r.slice(0,u).toString("utf8");r=r.slice(u+1),h=JSON.parse(f)}catch(f){console.error("error reading cdp line",f)}b.sendCommand(h.method,h.params,h.sessionId).then(f=>s({id:h.id,sessionId:h.sessionId,result:f})).catch(f=>s({id:h.id,sessionId:h.sessionId,error:{code:0,message:f.message}}))}}),c.on("error",a=>{console.error("error on cdp pipe:",a)}),c.on("close",()=>{o=!0,--w==0&&b.detach()})});return await new Promise(c=>l.listen(0,c)),m.on("close",()=>l.close()),{rendererDebugPort:l.address().port}}}e.ElectronExtensionHostDebugBroadcastChannel=S}),function(){"use strict";function $(e,v,R){function D(k){return e.resolve(S(k))}function S(k){const n=process.env.VSCODE_PORTABLE;if(n)return e.join(n,"user-data");const y=k["user-data-dir"];if(y)return y;let i=process.env.VSCODE_APPDATA;if(!i)switch(process.platform){case"win32":if(i=process.env.APPDATA,!i){const L=process.env.USERPROFILE;if(typeof L!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");i=e.join(L,"AppData","Roaming")}break;case"darwin":i=e.join(v.homedir(),"Library","Application Support");break;case"linux":i=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(i,R)}return{getUserDataPath:D}}if(typeof define=="function")define(X[153],Q([0,237,27,9,15]),function(e,v,R,D,S){const k=S.dirname(D.FileAccess.asFileUri("",e)),n=e.__$__nodeRequire(S.joinPath(k,"package.json").fsPath);return $(v,R,n.name)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),R=require("os");module.exports=$(v,R,e.name)}else throw new Error("Unknown context")}(),define(X[154],Q([0,1,27,153,151]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class S extends D.AbstractNativeEnvironmentService{constructor(n,y){super(n,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,R.getUserDataPath)(n)},y)}}e.NativeEnvironmentService=S}),define(X[155],Q([0,1,21,27,8]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function S(k){const n=(0,D.join)((0,R.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return v.writeFileSync(n,""),k&&console.log(`Marker file for --wait created: ${n}`),n}catch(y){k&&console.error(`Failed to create marker file for --wait: ${y}`);return}}e.createWaitMarkerFile=S}),define(X[156],Q([0,1,135]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function D(g){return g=g.trim(),g==="*"||R.test(g)}e.isValidVersionStr=D;function S(g){if(!D(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=g.match(R);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=S;function k(g){if(!g)return null;let E=g.majorBase,p=g.majorMustEqual,d=g.minorBase,m=g.minorMustEqual,b=g.patchBase,w=g.patchMustEqual;return g.hasCaret&&(E===0||(m=!1),w=!1),{majorBase:E,majorMustEqual:p,minorBase:d,minorMustEqual:m,patchBase:b,patchMustEqual:w,isMinimum:g.hasGreaterEquals}}e.normalizeVersion=k;function n(g,E){let p;typeof g=="string"?p=k(S(g)):p=g;let d;if(typeof E=="string"?d=k(S(E)):d=E,!p||!d)return!1;let m=p.majorBase,b=p.minorBase,w=p.patchBase,l=d.majorBase,c=d.minorBase,o=d.patchBase,s=d.majorMustEqual,t=d.minorMustEqual,r=d.patchMustEqual;return d.isMinimum?m>l?!0:m<l?!1:b>c?!0:b<c?!1:w>=o:(m===1&&l===0&&(!s||!t||!r)&&(l=1,c=0,o=0,s=!0,t=!1,r=!1),m<l?!1:m>l?!s:b<c?!1:b>c?!t:w<o?!1:w>o?!r:!0)}e.isValidVersion=n;function y(g,E,p){return E.isBuiltin||typeof E.main=="undefined"?!0:L(g,E.engines.vscode,p)}e.isValidExtensionVersion=y;function i(g,E){return g==="*"||L(E,g)}e.isEngineValid=i;function L(g,E,p=[]){let d=k(S(E));if(!d)return p.push(v.localize(0,null,E)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return p.push(v.localize(1,null,E)),!1}else if(!d.majorMustEqual)return p.push(v.localize(2,null,E)),!1;return n(g,d)?!0:(p.push(v.localize(3,null,g,E)),!1)}e.isVersionValid=L}),define(X[157],Q([0,1,33,87,2,9]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends D.Disposable{constructor(y,i,L,g){super();this.folders=y,this.onDidFilesChange=i,this.onLogMessage=L,this.verboseLogging=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const y=this._register(new R.Client(S.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(y.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(y.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(i=>!this.isDisposed&&this.onDidFilesChange(i))),this._register(this.service.onDidLogMessage(i=>this.onLogMessage(i))),this.setFolders(this.folders)}setVerboseLogging(y){this.verboseLogging=y,!this.isDisposed&&this.service&&this.service.setVerboseLogging(y)}error(y){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${y}`})}setFolders(y){this.folders=y,this.service&&this.service.setRoots(y)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(X[158],Q([0,1,33,87,2,9]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends D.Disposable{constructor(y,i,L,g,E={}){super();this.folders=y,this.onDidFilesChange=i,this.onLogMessage=L,this.verboseLogging=g,this.watcherOptions=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const y=this._register(new R.Client(S.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(y.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(y.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(i=>!this.isDisposed&&this.onDidFilesChange(i))),this._register(this.service.onDidLogMessage(i=>this.onLogMessage(i))),this.service.setRoots(this.folders)}error(y){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${y}`})}setVerboseLogging(y){this.verboseLogging=y,this.service&&this.service.setVerboseLogging(y)}setFolders(y){this.folders=y,this.service&&this.service.setRoots(y)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(X[159],Q([0,1,46,81,80,9]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class k{constructor(y,i,L,g,E){this.watchedFolder=y,this.eventCallback=L,this.logCallback=g,this.verboseLogging=E,this.restartCounter=0,Array.isArray(i)?this.ignored=i.map(p=>D.parse(p)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${y}`),this.startWatcher()}startWatcher(){const y=[this.watchedFolder];this.verboseLogging&&y.push("-verbose"),this.handle=v.spawn(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,y);const i=new R.LineDecoder;this.handle.stdout.on("data",L=>{const g=[];i.write(L).forEach(E=>{const p=E.split("|");if(p.length===2){const d=Number(p[0]),m=p[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(b=>b(m))){this.verboseLogging&&this.log(m);return}g.push({type:k.changeTypeMap[d],path:m})}else this.log(p[1])}}),g.length>0&&this.eventCallback(g)}),this.handle.on("error",L=>this.onError(L)),this.handle.stderr.on("data",L=>this.onError(L)),this.handle.on("exit",(L,g)=>this.onExit(L,g))}onError(y){this.error("process error: "+y.toString())}onExit(y,i){this.handle&&(this.error(`terminated unexpectedly (code: ${y}, signal: ${i})`),this.restartCounter<=k.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(y){this.logCallback({type:"error",message:`[File Watcher (C#)] ${y}`})}log(y){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${y}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=k,k.MAX_RESTARTS=5,k.changeTypeMap=[0,1,2]}),define(X[160],Q([0,1,159,8,19]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class S{constructor(n,y,i,L){this.onDidFilesChange=y,this.onLogMessage=i,this.verboseLogging=L,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(R.posix.sep)&&(this.folder.path=(0,D.rtrim)(this.folder.path,R.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new v.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=S}),define(X[68],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(S,k=[],n=!1){this.ctor=S,this.staticArguments=k,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=v;const R=(D,...S)=>new v(D,S);e.createSyncDescriptor=R}),define(X[161],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=v;class R{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let k of this._nodes.values())k.outgoing.size===0&&S.push(k);return S}insertEdge(S,k){const n=this.lookupOrInsertNode(S),y=this.lookupOrInsertNode(k);n.outgoing.set(this._hashFn(k),y),y.incoming.set(this._hashFn(S),n)}removeNode(S){const k=this._hashFn(S);this._nodes.delete(k);for(let n of this._nodes.values())n.outgoing.delete(k),n.incoming.delete(k)}lookupOrInsertNode(S){const k=this._hashFn(S);let n=this._nodes.get(k);return n||(n=new v(S),this._nodes.set(k,n)),n}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[k,n]of this._nodes)S.push(`${k}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return S.join(`
`)}}e.Graph=R}),define(X[4],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function y(i){return i[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=y})(v=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function R(n,y,i,L){y[v.DI_TARGET]===y?y[v.DI_DEPENDENCIES].push({id:n,index:i,optional:L}):(y[v.DI_DEPENDENCIES]=[{id:n,index:i,optional:L}],y[v.DI_TARGET]=y)}function D(n){if(v.serviceIds.has(n))return v.serviceIds.get(n);const y=function(i,L,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(y,i,g,!1)};return y.toString=()=>n,v.serviceIds.set(n,y),y}e.createDecorator=D;function S(n){return n}e.refineServiceDecorator=S;function k(n){return function(y,i,L){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(n,y,L,!0)}}e.optional=k}),define(X[69],Q([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function R(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=R}),define(X[89],Q([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService");class R{constructor(S){this.machineId=S}encryption(){return new Promise((S,k)=>$(["vscode-encrypt"],S,k))}async encrypt(S){try{return(await this.encryption()).encrypt(this.machineId,S)}catch(k){return S}}async decrypt(S){try{return(await this.encryption()).decrypt(this.machineId,S)}catch(k){return S}}}e.EncryptionMainService=R}),define(X[47],Q([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(X[162],Q([0,1,134,4,9]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function S(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=S;var k;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=5]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var n;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(n=e.SortOrder||(e.SortOrder={}));var y;(function(g){g.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var i;(function(g){g[g.None=0]="None",g[g.Install=1]="Install",g[g.Update=2]="Update"})(i=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class L extends Error{constructor(E,p){super(E);this.code=p}}e.ExtensionManagementError=L,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(X[163],Q([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(X[164],Q([0,1,19,4]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.getExtensionWorkspaceTrustRequirement=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function D(L){return L&&typeof L=="object"&&typeof L.id=="string"&&(!L.uuid||typeof L.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(L){L[L.System=0]="System",L[L.User=1]="User"})(S=e.ExtensionType||(e.ExtensionType={}));class k{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,E){if(typeof g=="undefined"||g===null)return typeof E=="undefined"||E===null;if(typeof E=="undefined"||E===null)return!1;if(typeof g=="string"||typeof E=="string"){let p=typeof g=="string"?g:g.value,d=typeof E=="string"?E:E.value;return v.equalsIgnoreCase(p,d)}return g._lower===E._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=k;function n(L){return L.contributes&&L.contributes.localizations?L.contributes.localizations.length>0:!1}e.isLanguagePackExtension=n;function y(L){return L.contributes&&L.contributes.authentication?L.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y;function i(L){var g;return((g=L.workspaceTrust)===null||g===void 0?void 0:g.required)!==void 0?L.workspaceTrust.required:L.main?"onStart":!1}e.getExtensionWorkspaceTrustRequirement=i,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(X[165],Q([0,1,19,164]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(p,d){return p.uuid&&d.uuid?p.uuid===d.uuid:p.id===d.id?!0:(0,v.compareIgnoreCase)(p.id,d.id)===0}e.areSameExtensions=D;class S{constructor(d,m){this.version=m,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof S?D(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=S;function k(p,d){return`${p}.${d}`}e.getExtensionId=k;function n(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function y(p,d){return n(k(p,d))}e.getGalleryExtensionId=y;function i(p,d){const m=[],b=w=>{for(const l of m)if(l.some(c=>D(d(c),d(w))))return l;return null};for(const w of p){const l=b(w);l?l.push(w):m.push([w])}return m}e.groupByExtension=i;function L(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=L;function g(p){return Object.assign({id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0)},p.telemetryData)}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function E(p){const d=new Set;for(const m of p)m.malicious&&d.add(m.id.id);return d}e.getMaliciousExtensionsSet=E}),define(X[16],Q([0,1,137,8,7,4,19,13,36]),function($,e,v,R,D,S,k,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function i(V){return V.create===!0}e.isFileOpenForWriteOptions=i;var L;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var g;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=E;function p(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=p;function d(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function m(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=m;var b;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(Y,U){super(Y);this.code=U}}e.FileSystemProviderError=w;function l(V,Y){const U=new w(V.toString(),Y);return o(U,Y),U}e.createFileSystemProviderError=l;function c(V){return V||l((0,v.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=c;function o(V,Y){return V.name=Y?`${Y} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=o;function s(V){if(!V)return b.Unknown;if(V instanceof w)return V.code;const Y=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!Y)return b.Unknown;switch(Y[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=s;function t(V){if(V instanceof P)return V.fileOperationResult;switch(s(V)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var r;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class a{constructor(Y,U,O){this.resource=Y,this.operation=U,this.target=O}isOperation(Y){return this.operation===Y}}e.FileOperationEvent=a;var u;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class h{constructor(Y,U){this.ignorePathCasing=U,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=Y;for(const O of Y)switch(O.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(O.resource,O);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(O.resource,O);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(O.resource,O);break}}contains(Y,...U){return this.doContains(Y,{includeChildren:!1},...U)}affects(Y,...U){return this.doContains(Y,{includeChildren:!0},...U)}doContains(Y,U,...O){var z,C,I,M,_,T;if(!Y)return!1;const W=O.length>0;return!!((!W||O.includes(1))&&(((z=this.added)===null||z===void 0?void 0:z.get(Y))||U.includeChildren&&((C=this.added)===null||C===void 0?void 0:C.findSuperstr(Y)))||(!W||O.includes(0))&&(((I=this.updated)===null||I===void 0?void 0:I.get(Y))||U.includeChildren&&((M=this.updated)===null||M===void 0?void 0:M.findSuperstr(Y)))||(!W||O.includes(2))&&(((_=this.deleted)===null||_===void 0?void 0:_.findSubstr(Y))||U.includeChildren&&((T=this.deleted)===null||T===void 0?void 0:T.findSuperstr(Y))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(Y){const U=[],O=Y===1?this.added:Y===0?this.updated:this.deleted;if(O)for(const[,z]of O)U.push(z);return U}filter(Y){return new h(this.changes.filter(U=>Y(U)),this.ignorePathCasing)}}e.FileChangesEvent=h;function f(V,Y,U){return!V||!Y||V===Y||Y.length>V.length?!1:(Y.charAt(Y.length-1)!==R.sep&&(Y+=R.sep),U?(0,k.startsWithIgnoreCase)(V,Y):V.indexOf(Y)===0)}e.isParent=f;class P extends Error{constructor(Y,U,O){super(Y);this.fileOperationResult=U,this.options=O}static isFileOperationError(Y){return Y instanceof Error&&!(0,n.isUndefinedOrNull)(Y.fileOperationResult)}}e.FileOperationError=P;var A;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=N;async function j(V,Y){if(!Y.canHandleResource(D.URI.from({scheme:V.scheme})))return new Promise(U=>{const O=Y.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===V.scheme&&z.added&&(O.dispose(),U())})})}e.whenProviderRegistered=j,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class G{static formatSize(Y){return(0,n.isNumber)(Y)||(Y=0),Y<G.KB?(0,v.localize)(1,null,Y.toFixed(0)):Y<G.MB?(0,v.localize)(2,null,(Y/G.KB).toFixed(2)):Y<G.GB?(0,v.localize)(3,null,(Y/G.MB).toFixed(2)):Y<G.TB?(0,v.localize)(4,null,(Y/G.GB).toFixed(2)):(0,v.localize)(5,null,(Y/G.TB).toFixed(2))}}e.ByteSize=G,G.KB=1024,G.MB=G.KB*G.KB,G.GB=G.MB*G.KB,G.TB=G.GB*G.KB;var ne;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(ne=e.Arch||(e.Arch={}));function oe(V){return{maxFileSize:V===0?300*G.MB:16*G.GB,maxHeapSize:V===0?700*G.MB:2*700*G.MB}}e.getPlatformLimits=oe}),define(X[53],Q([0,1,238,133,16,88]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(E,p){const d={onUnknownOption:b=>{console.warn((0,R.localize)(0,null,b))},onMultipleValues:(b,w)=>{console.warn((0,R.localize)(1,null,b,w))}},m=(0,S.parseArgs)(E,S.OPTIONS,p?d:void 0);return m.goto&&m._.forEach(b=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,R.localize)(2,null))),m["max-memory"]&&v(parseInt(m["max-memory"])>=D.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${D.MIN_MAX_MEMORY_SIZE_MB} MB.`),m}function n(E){const p=E.findIndex(d=>!/^-/.test(d));if(p>-1)return[...E.slice(0,p),...E.slice(p+1)]}function y(E){let[,...p]=E;process.env.VSCODE_DEV&&(p=n(p)||[]);const d=!g(process.env);return k(p,d)}e.parseMainProcessArgv=y;function i(E){const[,,...p]=E;return k(p,!0)}e.parseCLIProcessArgv=i;function L(E,...p){const d=E.indexOf("--");return d===-1?E.push(...p):E.splice(d,0,...p),E}e.addArg=L;function g(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=g}),define(X[70],Q([0,1,46,28,3,53,67,128]),function($,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function y(g,E,p){return E["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):D.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.isLaunchedFromCli)(p)&&!E["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.isLaunchedFromCli)(p)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),i||(i=L(g)),i)}e.resolveShellEnv=y;let i;async function L(g){const E=new Promise(async(p,d)=>{const m=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",m);const b=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",b);const w=(0,R.generateUuid)().replace(/-/g,"").substr(0,12),l=new RegExp(w+"(.*)"+w),c=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"}),o=`'${process.execPath}' -p '"${w}" + JSON.stringify(process.env) + "${w}"'`;g.trace("getUnixShellEnvironment#env",c),g.trace("getUnixShellEnvironment#spawn",o);const s=await(0,n.getSystemShell)(D.platform,c);g.trace("getUnixShellEnvironment#shell",s);const t=(0,v.spawn)(s,["-ilc",o],{detached:!0,stdio:["ignore","pipe",process.stderr],env:c}),r=[];t.on("error",()=>p({})),t.stdout.on("data",a=>r.push(a)),t.on("close",a=>{if(a!==0)return d(new Error("Failed to get environment"));const u=Buffer.concat(r).toString("utf8");g.trace("getUnixShellEnvironment#raw",u);const h=l.exec(u),f=h?h[1]:"{}";try{const P=JSON.parse(f);m?P.ELECTRON_RUN_AS_NODE=m:delete P.ELECTRON_RUN_AS_NODE,b?P.ELECTRON_NO_ATTACH_CONSOLE=b:delete P.ELECTRON_NO_ATTACH_CONSOLE,delete P.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",P),p(P)}catch(P){g.error("getUnixShellEnvironment#error",P),d(P)}})});try{return await E}catch(p){return g.error("getUnixShellEnvironment#error",(0,k.toErrorMessage)(p)),{}}}}),define(X[90],Q([0,1,138,20,16,18]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(L,g,E,p,d,m){let b;try{await n(L,g,E,p,d,m)}catch(w){b=w}finally{b&&d.errorTransformer&&(b=d.errorTransformer(b)),typeof b!="undefined"&&E.error(b),E.end()}}e.readFileIntoStream=k;async function n(L,g,E,p,d,m){y(m);const b=await L.open(g,{create:!1});try{y(m);let w=0,l=0,c=d&&typeof d.length=="number"?d.length:void 0,o=R.VSBuffer.alloc(Math.min(d.bufferSize,typeof c=="number"?c:d.bufferSize)),s=d&&typeof d.position=="number"?d.position:0,t=0;do l=await L.read(b,s,o.buffer,t,o.byteLength-t),s+=l,t+=l,w+=l,typeof c=="number"&&(c-=l),t===o.byteLength&&(await E.write(p(o)),o=R.VSBuffer.alloc(Math.min(d.bufferSize,typeof c=="number"?c:d.bufferSize)),t=0);while(l>0&&(typeof c!="number"||c>0)&&y(m)&&i(w,d));if(t>0){let r=t;typeof c=="number"&&(r=Math.min(t,c)),E.write(p(o.slice(0,r)))}}catch(w){throw(0,D.ensureFileSystemProviderError)(w)}finally{await L.close(b)}}function y(L){if(L.isCancellationRequested)throw(0,S.canceled)();return!0}function i(L,g){if(g==null?void 0:g.limits){if(typeof g.limits.memory=="number"&&L>g.limits.memory)throw(0,D.createFileSystemProviderError)((0,v.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof g.limits.size=="number"&&L>g.limits.size)throw(0,D.createFileSystemProviderError)((0,v.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(X[91],Q([0,1,7,16,3]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function S(y){return y.map(i=>({type:i.type,resource:v.URI.file(i.path)}))}e.toFileChanges=S;function k(y){const i=new n;for(const L of y)i.processEvent(L);return i.normalize()}e.normalizeFileChanges=k;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(i){const L=this.mapPathToChange.get(i.path);if(L){const g=L.type,E=i.type;g===1&&E===2?(this.mapPathToChange.delete(i.path),this.normalized.splice(this.normalized.indexOf(L),1)):g===2&&E===1?L.type=0:g===1&&E===0||(L.type=E)}else this.normalized.push(i),this.mapPathToChange.set(i.path,i)}normalize(){const i=[],L=[];return this.normalized.filter(g=>g.type!==2?(i.push(g),!1):!0).sort((g,E)=>g.path.length-E.path.length).filter(g=>L.some(E=>(0,R.isParent)(g.path,E,!D.isLinux))?!1:(L.push(g.path),!0)).concat(i)}}}),define(X[166],Q([0,1,91,2,22,111,115,10,8]),function($,e,v,R,D,S,k,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class i extends R.Disposable{constructor(g,E,p,d){super();this.path=g,this.onDidFilesChange=E,this.onLogMessage=p,this.verboseLogging=d,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(k.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(g){this.verboseLogging=g}async startWatching(){try{const{stat:g,symbolicLink:E}=await D.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(E)try{p=await(0,S.realpath)(p)}catch(d){if(this.onError(d),E.dangling)return}g.isDirectory()?this._register((0,k.watchFolder)(p,(d,m)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,y.join)(this.path,(0,y.basename)(m))})},d=>this.onError(d))):this._register((0,k.watchFile)(p,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(g){g.code!=="ENOENT"&&this.onError(g)}}onFileChange(g){this.fileChangesBuffer.push(g),this.verboseLogging&&this.onVerbose(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),this.fileChangesDelayer.trigger(async()=>{const E=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,v.normalizeFileChanges)(E);this.verboseLogging&&p.forEach(d=>{this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`)}),p.length>0&&this.onDidFilesChange(p)})}onError(g){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${g}`})}onVerbose(g){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=i}),define(X[71],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...D){this._entries=new Map;for(let[S,k]of D)this.set(S,k)}set(D,S){const k=this._entries.get(D);return this._entries.set(D,S),k}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=v}),define(X[167],Q([0,1,18,161,68,4,71,10]),function($,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class i extends Error{constructor(d){super("cyclic dependency between services");this.message=d.toString()}}class L{constructor(d=new k.ServiceCollection,m=!1,b){this._activeInstantiations=new Set,this._services=d,this._strict=m,this._parent=b,this._services.set(S.IInstantiationService,this)}createChild(d){return new L(d,this._strict,this)}invokeFunction(d,...m){let b=E.traceInvocation(d),w=!1;try{return d({get:(c,o)=>{if(w)throw(0,v.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(c,b);if(!s&&o!==S.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return s}},...m)}finally{w=!0,b.stop()}}createInstance(d,...m){let b,w;return d instanceof D.SyncDescriptor?(b=E.traceCreation(d.ctor),w=this._createInstance(d.ctor,d.staticArguments.concat(m),b)):(b=E.traceCreation(d),w=this._createInstance(d,m,b)),b.stop(),w}_createInstance(d,m=[],b){let w=S._util.getServiceDependencies(d).sort((o,s)=>o.index-s.index),l=[];for(const o of w){let s=this._getOrCreateServiceInstance(o.id,b);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${o.id}.`);l.push(s)}let c=w.length>0?w[0].index:m.length;if(m.length!==c){console.warn(`[createInstance] First service dependency of ${d.name} at position ${c+1} conflicts with ${m.length} static arguments`);let o=c-m.length;o>0?m=m.concat(new Array(o)):m=m.slice(0,c)}return new d(...[...m,...l])}_setServiceInstance(d,m){if(this._services.get(d)instanceof D.SyncDescriptor)this._services.set(d,m);else if(this._parent)this._parent._setServiceInstance(d,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let m=this._services.get(d);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):m}_getOrCreateServiceInstance(d,m){let b=this._getServiceInstanceOrDescriptor(d);return b instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,b,m.branch(d,!0)):(m.branch(d,!1),b)}_safeCreateAndCacheServiceInstance(d,m,b){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,m,b)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,m,b){const w=new R.Graph(o=>o.id.toString());let l=0;const c=[{id:d,desc:m,_trace:b}];for(;c.length;){const o=c.pop();if(w.lookupOrInsertNode(o),l++>1e3)throw new i(w);for(let s of S._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(s.id);if(!t&&!s.optional&&console.warn(`[createInstance] ${d} depends on ${s.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const r={id:s.id,desc:t,_trace:o._trace.branch(s.id,!0)};w.insertEdge(o,r),c.push(r)}}}for(;;){const o=w.roots();if(o.length===0){if(!w.isEmpty())throw new i(w);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof D.SyncDescriptor){const r=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,r)}w.removeNode(s)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,m,b=[],w,l){if(this._services.get(d)instanceof D.SyncDescriptor)return this._createServiceInstance(m,b,w,l);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,m,b,w,l);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(d,m=[],b,w){if(b){const l=new n.IdleValue(()=>this._createInstance(d,m,w));return new Proxy(Object.create(null),{get(c,o){if(o in c)return c[o];let s=l.value,t=s[o];return typeof t!="function"||(t=t.bind(s),c[o]=t),t},set(c,o,s){return l.value[o]=s,!0}})}else return this._createInstance(d,m,w)}}e.InstantiationService=L;var g;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(g||(g={}));class E{constructor(d,m){this.type=d,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return y?new E(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(d){return y?new E(0,d.name):E._None}branch(d,m){let b=new E(2,d.toString());return this._dep.push([d,m,b]),b}stop(){let d=Date.now()-this._start;E._totals+=d;let m=!1;function b(l,c){let o=[],s=new Array(l+1).join("	");for(const[t,r,a]of c._dep)if(r&&a){m=!0,o.push(`${s}CREATES -> ${t}`);let u=b(l+1,a);u&&o.push(u)}else o.push(`${s}uses -> ${t}`);return o.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(d>2||m)&&console.log(w.join(`
`))}}E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(X[168],Q([0,1,18,126,58]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class S extends D.ResolvedKeybinding{constructor(n,y){super();if(y.length===0)throw(0,v.illegalArgument)("parts");this._os=n,this._parts=y}getLabel(){return R.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return R.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:R.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return R.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new D.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=S}),define(X[169],Q([0,1,58,168]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class D extends R.BaseResolvedKeybinding{constructor(k,n){super(n,k.parts)}_keyCodeToUILabel(k){if(this._os===2)switch(k){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(k)}_getLabel(k){return k.isDuplicateModifierCase()?"":this._keyCodeToUILabel(k.keyCode)}_getAriaLabel(k){return k.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(k.keyCode)}_keyCodeToElectronAccelerator(k){if(k>=93&&k<=108)return null;switch(k){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return v.KeyCodeUtils.toString(k)}_getElectronAccelerator(k){return k.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(k.keyCode)}_getUserSettingsLabel(k){if(k.isDuplicateModifierCase())return"";const n=v.KeyCodeUtils.toUserSettingsUS(k.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(k){return D.getDispatchStr(k)}static getDispatchStr(k){if(k.isModifierKey())return null;let n="";return k.ctrlKey&&(n+="ctrl+"),k.shiftKey&&(n+="shift+"),k.altKey&&(n+="alt+"),k.metaKey&&(n+="meta+"),n+=v.KeyCodeUtils.toString(k.keyCode),n}_getSingleModifierDispatchPart(k){return k.keyCode===5&&!k.shiftKey&&!k.altKey&&!k.metaKey?"ctrl":k.keyCode===4&&!k.ctrlKey&&!k.altKey&&!k.metaKey?"shift":k.keyCode===6&&!k.ctrlKey&&!k.shiftKey&&!k.metaKey?"alt":k.keyCode===57&&!k.ctrlKey&&!k.shiftKey&&!k.altKey?"meta":null}}e.USLayoutResolvedKeybinding=D}),define(X[170],Q([0,1,10]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function R(D,S){if(D.length===0)return Promise.resolve(!1);const k=[];let n=!1;for(let y of D){if(y===!0)return Promise.resolve(!0);(0,v.isThenable)(y)&&k.push(y.then(i=>{i&&(n=!0)},i=>{S(i),n=!0}))}return v.Promises.settled(k).then(()=>n)}e.handleVetos=R}),define(X[6],Q([0,1,4,2,3,5,67]),function($,e,v,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function n(){return new Date().toISOString()}var y;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class i extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=i;class L extends i{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...t){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([s,...t]))}debug(s,...t){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([s,...t]))}info(s,...t){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([s,...t]))}warn(s,...t){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([s,...t]))}error(s,...t){if(this.checkLogLevel(y.Error))if(s instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=s.stack,this.log(y.Error,this.format(r))}else this.log(y.Error,this.format([s,...t]))}critical(s,...t){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([s,...t]))}flush(){}format(s){let t="";for(let r=0;r<s.length;r++){let a=s[r];if(typeof a=="object")try{a=JSON.stringify(a)}catch(u){}t+=(r>0?" ":"")+a}return t}}e.AbstractMessageLogger=L;class g extends i{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!D.isWindows}trace(s,...t){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,s,...t):console.log(`[main ${n()}]`,s,...t))}debug(s,...t){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,s,...t):console.log(`[main ${n()}]`,s,...t))}info(s,...t){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,s,...t):console.log(`[main ${n()}]`,s,...t))}warn(s,...t){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,s,...t):console.warn(`[main ${n()}]`,s,...t))}error(s,...t){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,s,...t):console.error(`[main ${n()}]`,s,...t))}critical(s,...t){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,s,...t):console.error(`[main ${n()}]`,s,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class E extends i{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...t){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",s,...t)}debug(s,...t){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...t)}info(s,...t){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",s,...t)}warn(s,...t){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",s,...t)}error(s,...t){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",s,...t)}critical(s,...t){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...t)}dispose(){}flush(){}}e.ConsoleLogger=E;class p extends i{constructor(s,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(t)}trace(s,...t){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(s),...t])}debug(s,...t){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(s),...t])}info(s,...t){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(s),...t])}warn(s,...t){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(s),...t])}error(s,...t){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(s),...t])}critical(s,...t){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(s),...t])}extractMessage(s){return typeof s=="string"?s:(0,k.toErrorMessage)(s,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class d extends i{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const t of this.logServices)t.setLevel(s);super.setLevel(s)}trace(s,...t){for(const r of this.logServices)r.trace(s,...t)}debug(s,...t){for(const r of this.logServices)r.debug(s,...t)}info(s,...t){for(const r of this.logServices)r.info(s,...t)}warn(s,...t){for(const r of this.logServices)r.warn(s,...t)}error(s,...t){for(const r of this.logServices)r.error(s,...t)}critical(s,...t){for(const r of this.logServices)r.critical(s,...t)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=d;class m extends R.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...t){this.logger.trace(s,...t)}debug(s,...t){this.logger.debug(s,...t)}info(s,...t){this.logger.info(s,...t)}warn(s,...t){this.logger.warn(s,...t)}error(s,...t){this.logger.error(s,...t)}critical(s,...t){this.logger.critical(s,...t)}flush(){this.logger.flush()}}e.LogService=m;class b{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(s){}getLevel(){return y.Info}trace(s,...t){}debug(s,...t){}info(s,...t){}warn(s,...t){}error(s,...t){}critical(s,...t){}dispose(){}flush(){}}e.NullLogService=b;function w(o){if(o.verbose)return y.Trace;if(typeof o.logLevel=="string"){const s=l(o.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=w;function l(o){switch(o){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=l;function c(o){switch(o){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=c});var Z=this&&this.__param||function($,e){return function(v,R){e(v,R,$)}};define(X[171],Q([0,1,136,172,2,16,5,15,36,34,6,20,59,10,25,9,90,64]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d,m,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let l=class extends D.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new p.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,R.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const t=new D.DisposableStore;return t.add(s.onDidChangeFile(r=>this._onDidFilesChange.fire(new S.FileChangesEvent(r,!this.isPathCaseSensitive(s))))),t.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&t.add(s.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,D.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,D.dispose)(t)})}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){s.push(t)}}),!this.provider.has(o)&&await p.Promises.settled(s)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,s){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return w.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,n.isAbsolutePath)(o))throw new S.FileOperationError((0,v.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const t=new Error;throw t.name="ENOPRO",t.message=(0,v.localize)(1,null,o.toString()),t}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasReadWriteCapability)(s)||(0,S.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(t){throw(0,S.toFileSystemProviderErrorCode)(t)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,v.localize)(2,null,this.resourceForError(o)),1):(0,S.ensureFileSystemProviderError)(t)}}async doResolveFile(o,s){const t=await this.withProvider(o),r=this.isPathCaseSensitive(t),a=s==null?void 0:s.resolveTo,u=s==null?void 0:s.resolveSingleChildDescendants,h=s==null?void 0:s.resolveMetadata,f=await t.stat(o);let P;return this.toFileStat(t,o,f,void 0,!!h,(A,F)=>(P||(P=y.TernarySearchTree.forUris(()=>!r),P.set(o,!0),(0,i.isNonEmptyArray)(a)&&a.forEach(N=>P.set(N,!0))),Boolean(P.findSuperstr(A.resource)||P.get(A.resource))?!0:A.isDirectory&&u?F===1:!1))}async toFileStat(o,s,t,r,a,u){const{providerExtUri:h}=this.getExtUri(o),f={resource:s,name:h.basename(s),isFile:(t.type&S.FileType.File)!=0,isDirectory:(t.type&S.FileType.Directory)!=0,isSymbolicLink:(t.type&S.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,S.etag)({mtime:t.mtime,size:t.size})};if(f.isDirectory&&u(f,r)){try{const P=await o.readdir(s),A=await p.Promises.settled(P.map(async([F,N])=>{try{const j=h.joinPath(s,F),G=a?await o.stat(j):{type:N};return await this.toFileStat(o,j,G,P.length,a,u)}catch(j){return this.logService.trace(j),null}}));f.children=(0,i.coalesce)(A)}catch(P){this.logService.trace(P),f.children=[]}return f}return f}async resolveAll(o){return p.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(t){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(t){return t}return!0}async doValidateCreateFile(o,s){if(!(s==null?void 0:s.overwrite)&&await this.exists(o))throw new S.FileOperationError((0,v.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=g.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const r=await this.writeFile(o,s);return this._onDidRunOperation.fire(new S.FileOperationEvent(o,0,r)),r}async writeFile(o,s,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:a}=this.getExtUri(r);try{await this.validateWriteFile(r,o,t)||await this.mkdirp(r,a.dirname(o));let h;if((0,S.hasReadWriteCapability)(r)&&!(s instanceof g.VSBuffer))if((0,E.isReadableStream)(s)){const f=await(0,E.peekStream)(s,3);f.ended?h=g.VSBuffer.concat(f.buffer):h=f}else h=(0,E.peekReadable)(s,f=>g.VSBuffer.concat(f),3);else h=s;!(0,S.hasOpenReadWriteCloseCapability)(r)||(0,S.hasReadWriteCapability)(r)&&h instanceof g.VSBuffer?await this.doWriteUnbuffered(r,o,t,h):await this.doWriteBuffered(r,o,t,h instanceof g.VSBuffer?(0,g.bufferToReadable)(h):h)}catch(u){throw new S.FileOperationError((0,v.localize)(4,null,this.resourceForError(o),(0,S.ensureFileSystemProviderError)(u).toString()),(0,S.toFileOperationResult)(u),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,t){if(!!(t==null?void 0:t.unlock)&&!(o.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(s)));let a;try{a=await o.stat(s)}catch(u){return}if((a.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,v.localize)(6,null,this.resourceForError(s)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&t.mtime<a.mtime&&t.etag!==(0,S.etag)({mtime:t.mtime,size:a.size}))throw new S.FileOperationError((0,v.localize)(7,null),3,t);return a}async readFile(o,s){const t=await this.withReadProvider(o);return(s==null?void 0:s.atomic)?this.doReadFileAtomic(t,o,s):this.doReadFile(t,o,s)}async doReadFileAtomic(o,s,t){return new Promise((r,a)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const u=await this.doReadFile(o,s,t);r(u)}catch(u){a(u)}})})}async doReadFile(o,s,t){const r=await this.doReadFileStream(o,s,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await(0,g.streamToBuffer)(r.value)})}async readFileStream(o,s){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,s)}async doReadFileStream(o,s,t){const r=new d.CancellationTokenSource,a=this.validateReadFile(s,t).then(h=>h,h=>{throw r.cancel(),h});let u;try{t&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&await a,!((0,S.hasOpenReadWriteCloseCapability)(o)||(0,S.hasFileReadStreamCapability)(o))||(0,S.hasReadWriteCapability)(o)&&(t==null?void 0:t.preferUnbuffered)?u=this.readFileUnbuffered(o,s,t):(0,S.hasFileReadStreamCapability)(o)?u=this.readFileStreamed(o,s,r.token,t):u=this.readFileBuffered(o,s,r.token,t);const h=await a;return Object.assign(Object.assign({},h),{value:u})}catch(h){throw u&&await(0,E.consumeStream)(u),new S.FileOperationError((0,v.localize)(8,null,this.resourceForError(s),(0,S.ensureFileSystemProviderError)(h).toString()),(0,S.toFileOperationResult)(h),t)}}readFileStreamed(o,s,t,r=Object.create(null)){const a=o.readFileStream(s,r,t);return(0,E.transform)(a,{data:u=>u instanceof g.VSBuffer?u:g.VSBuffer.wrap(u),error:u=>new S.FileOperationError((0,v.localize)(9,null,this.resourceForError(s),(0,S.ensureFileSystemProviderError)(u).toString()),(0,S.toFileOperationResult)(u),r)},u=>g.VSBuffer.concat(u))}readFileBuffered(o,s,t,r=Object.create(null)){const a=(0,g.newWriteableBufferStream)();return(0,b.readFileIntoStream)(o,s,a,u=>u,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:u=>new S.FileOperationError((0,v.localize)(10,null,this.resourceForError(s),(0,S.ensureFileSystemProviderError)(u).toString()),(0,S.toFileOperationResult)(u),r)}),t),a}readFileUnbuffered(o,s,t){const r=(0,E.newWriteableStream)(a=>g.VSBuffer.concat(a));return(async()=>{try{let a=await o.readFile(s);t&&typeof t.position=="number"&&(a=a.slice(t.position)),t&&typeof t.length=="number"&&(a=a.slice(0,t.length)),this.validateReadFileLimits(s,a.byteLength,t),r.end(g.VSBuffer.wrap(a))}catch(a){r.error(a),r.end()}})(),r}async validateReadFile(o,s){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new S.FileOperationError((0,v.localize)(11,null,this.resourceForError(o)),0,s);if(s&&typeof s.etag=="string"&&s.etag!==S.ETAG_DISABLED&&s.etag===t.etag)throw new S.FileOperationError((0,v.localize)(12,null),2,s);return this.validateReadFileLimits(o,t.size,s),t}validateReadFileLimits(o,s,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&s>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&s>t.limits.size&&(r=7),typeof r=="number")throw new S.FileOperationError((0,v.localize)(13,null,this.resourceForError(o)),r)}}async canMove(o,s,t){return this.doCanMoveCopy(o,s,"move",t)}async canCopy(o,s,t){return this.doCanMoveCopy(o,s,"copy",t)}async doCanMoveCopy(o,s,t,r){if(o.toString()!==s.toString())try{const a=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(a,o,u,s,t,r)}catch(a){return a}return!0}async move(o,s,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),u=await this.doMoveCopy(r,o,a,s,"move",!!t),h=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,u==="move"?2:3,h)),h}async copy(o,s,t){const r=await this.withReadProvider(o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),u=await this.doMoveCopy(r,o,a,s,"copy",!!t),h=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,u==="copy"?3:2,h)),h}async doMoveCopy(o,s,t,r,a,u){if(s.toString()===r.toString())return a;const{exists:h,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(o,s,t,r,a,u);if(h&&!f&&u&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),a==="copy"){if(o===t&&(0,S.hasFileFolderCopyCapability)(o))await o.copy(s,r,{overwrite:u});else{const P=await this.resolve(s);P.isDirectory?await this.doCopyFolder(o,P,t,r):await this.doCopyFile(o,s,t,r)}return a}else return o===t?(await o.rename(s,r,{overwrite:u}),a):(await this.doMoveCopy(o,s,t,r,"copy",u),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,t,r){if((0,S.hasOpenReadWriteCloseCapability)(o)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,s,t,r);if((0,S.hasOpenReadWriteCloseCapability)(o)&&(0,S.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,s,t,r);if((0,S.hasReadWriteCapability)(o)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,s,t,r);if((0,S.hasReadWriteCapability)(o)&&(0,S.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,s,t,r)}async doCopyFolder(o,s,t,r){await t.mkdir(r),Array.isArray(s.children)&&await p.Promises.settled(s.children.map(async a=>{const u=this.getExtUri(t).providerExtUri.joinPath(r,a.name);return a.isDirectory?this.doCopyFolder(o,await this.resolve(a.resource),t,u):this.doCopyFile(o,a.resource,t,u)}))}async doValidateMoveCopy(o,s,t,r,a,u){let h=!1;if(o===t){const{providerExtUri:P,isPathCaseSensitive:A}=this.getExtUri(o);if(A||(h=P.isEqual(s,r)),h&&a==="copy")throw new Error((0,v.localize)(14,null,this.resourceForError(s),this.resourceForError(r)));if(!h&&P.isEqualOrParent(r,s))throw new Error((0,v.localize)(15,null,this.resourceForError(s),this.resourceForError(r)))}const f=await this.exists(r);if(f&&!h){if(!u)throw new S.FileOperationError((0,v.localize)(16,null,this.resourceForError(s),this.resourceForError(r)),4);if(o===t){const{providerExtUri:P}=this.getExtUri(o);if(P.isEqualOrParent(s,r))throw new Error((0,v.localize)(17,null,this.resourceForError(s),this.resourceForError(r)))}}return{exists:f,isSameResourceWithDifferentPathCase:h}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?n.extUri:n.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,0,t)),t}async mkdirp(o,s){const t=[],{providerExtUri:r}=this.getExtUri(o);for(;!r.isEqual(s,r.dirname(s));)try{if(((await o.stat(s)).type&S.FileType.Directory)==0)throw new Error((0,v.localize)(18,null,this.resourceForError(s)));break}catch(a){if((0,S.toFileSystemProviderErrorCode)(a)!==S.FileSystemProviderErrorCode.FileNotFound)throw a;t.push(r.basename(s)),s=r.dirname(s)}for(let a=t.length-1;a>=0;a--){s=r.joinPath(s,t[a]);try{await o.mkdir(s)}catch(u){if((0,S.toFileSystemProviderErrorCode)(u)!==S.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(t){return t}return!0}async doValidateDelete(o,s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(s==null?void 0:s.useTrash)&&!(t.capabilities&4096))throw new Error((0,v.localize)(19,null,this.resourceForError(o)));const a=await this.exists(o);if(!a)throw new S.FileOperationError((0,v.localize)(20,null,this.resourceForError(o)),1);if(!!!(s==null?void 0:s.recursive)&&a){const h=await this.resolve(o);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error((0,v.localize)(21,null,this.resourceForError(o)))}return t}async del(o,s){const t=await this.doValidateDelete(o,s),r=!!(s==null?void 0:s.useTrash),a=!!(s==null?void 0:s.recursive);await t.delete(o,{recursive:a,useTrash:r}),this._onDidRunOperation.fire(new S.FileOperationEvent(o,1))}watch(o,s={recursive:!1,excludes:[]}){let t=!1,r=()=>{t=!0};return this.doWatch(o,s).then(a=>{t?(0,D.dispose)(a):r=()=>(0,D.dispose)(a)},a=>this.logService.error(a)),(0,D.toDisposable)(()=>r())}async doWatch(o,s){const t=await this.withProvider(o),r=this.toWatchKey(t,o,s),a=this.activeWatchers.get(r)||{count:0,disposable:t.watch(o,s)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,a),a.count+=1,(0,D.toDisposable)(()=>{a.count--,a.count===0&&((0,D.dispose)(a.disposable),this.activeWatchers.delete(r))})}toWatchKey(o,s,t){const{providerExtUri:r}=this.getExtUri(o);return[r.getComparisonKey(s),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>(0,D.dispose)(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,s,t,r){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{var a;const u=await o.open(s,{create:!0,unlock:(a=t==null?void 0:t.unlock)!==null&&a!==void 0?a:!1});try{(0,E.isReadableStream)(r)||(0,E.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(o,u,r):await this.doWriteReadableBufferedQueued(o,u,r)}catch(h){throw(0,S.ensureFileSystemProviderError)(h)}finally{await o.close(u)}})}async doWriteStreamBufferedQueued(o,s,t){let r=0,a;if((0,E.isReadableBufferedStream)(t)){if(t.buffer.length>0){const u=g.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,s,u,u.byteLength,r,0),r+=u.byteLength}if(t.ended)return;a=t.stream}else a=t;return new Promise(async(u,h)=>{(0,E.listenStream)(a,{onData:async f=>{a.pause();try{await this.doWriteBuffer(o,s,f,f.byteLength,r,0)}catch(P){return h(P)}r+=f.byteLength,setTimeout(()=>a.resume())},onError:f=>h(f),onEnd:()=>u()})})}async doWriteReadableBufferedQueued(o,s,t){let r=0,a;for(;(a=t.read())!==null;)await this.doWriteBuffer(o,s,a,a.byteLength,r,0),r+=a.byteLength}async doWriteBuffer(o,s,t,r,a,u){let h=0;for(;h<r;)h+=await o.write(s,a+h,t.buffer,u+h,r-h)}async doWriteUnbuffered(o,s,t,r){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,t,r))}async doWriteUnbufferedQueued(o,s,t,r){var a;let u;r instanceof g.VSBuffer?u=r:(0,E.isReadableStream)(r)?u=await(0,g.streamToBuffer)(r):(0,E.isReadableBufferedStream)(r)?u=await(0,g.bufferedStreamToBuffer)(r):u=(0,g.readableToBuffer)(r),await o.writeFile(s,u.buffer,{create:!0,overwrite:!0,unlock:(a=t==null?void 0:t.unlock)!==null&&a!==void 0?a:!1})}async doPipeBuffered(o,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,t,r))}async doPipeBufferedQueued(o,s,t,r){let a,u;try{a=await o.open(s,{create:!1}),u=await t.open(r,{create:!0,unlock:!1});const h=g.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,P=0,A=0;do A=await o.read(a,f,h.buffer,P,h.byteLength-P),await this.doWriteBuffer(t,u,h,A,f,P),f+=A,P+=A,P===h.byteLength&&(P=0);while(A>0)}catch(h){throw(0,S.ensureFileSystemProviderError)(h)}finally{await p.Promises.settled([typeof a=="number"?o.close(a):Promise.resolve(),typeof u=="number"?t.close(u):Promise.resolve()])}}async doPipeUnbuffered(o,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,t,r))}async doPipeUnbufferedQueued(o,s,t,r){return t.writeFile(r,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,t,r))}async doPipeUnbufferedToBufferedQueued(o,s,t,r){const a=await t.open(r,{create:!0,unlock:!1});try{const u=await o.readFile(s);await this.doWriteBuffer(t,a,g.VSBuffer.wrap(u),u.byteLength,0,0)}catch(u){throw(0,S.ensureFileSystemProviderError)(u)}finally{await t.close(a)}}async doPipeBufferedToUnbuffered(o,s,t,r){const a=await(0,g.streamToBuffer)(this.readFileBuffered(o,s,d.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,a)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new S.FileOperationError((0,v.localize)(22,null,this.resourceForError(s)),6);return o}resourceForError(o){return o.scheme===m.Schemas.file?o.fsPath:o.toString(!0)}};l=ce([Z(0,L.ILogService)],l),e.FileService=l}),define(X[173],Q([0,1,21,112,2,16,5,3,22,8,15,30,10,6,139,91,158,160,157,166,59,90,34,20]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d,m,b,w,l,c,o,s,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class a extends D.Disposable{constructor(h,f){var P;super();this.logService=h,this.options=f,this.BUFFER_SIZE=((P=this.options)===null||P===void 0?void 0:P.bufferSize)||64*1024,this.onDidChangeCapabilities=k.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new E.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,n.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(h){try{const{stat:f,symbolicLink:P}=await y.SymlinkSupport.stat(this.toFilePath(h));return{type:this.toType(f,P),ctime:f.birthtime.getTime(),mtime:f.mtime.getTime(),size:f.size}}catch(f){throw this.toFileSystemProviderError(f)}}async readdir(h){try{const f=await(0,y.readdir)(this.toFilePath(h),{withFileTypes:!0}),P=[];return await Promise.all(f.map(async A=>{try{let F;A.isSymbolicLink()?F=(await this.stat((0,L.joinPath)(h,A.name))).type:F=this.toType(A),P.push([A.name,F])}catch(F){this.logService.trace(F)}})),P}catch(f){throw this.toFileSystemProviderError(f)}}toType(h,f){let P;return(f==null?void 0:f.dangling)?P=S.FileType.Unknown:h.isFile()?P=S.FileType.File:h.isDirectory()?P=S.FileType.Directory:P=S.FileType.Unknown,f&&(P|=S.FileType.SymbolicLink),P}async readFile(h){try{const f=this.toFilePath(h);return await v.promises.readFile(f)}catch(f){throw this.toFileSystemProviderError(f)}}readFileStream(h,f,P){const A=(0,o.newWriteableStream)(F=>r.VSBuffer.concat(F.map(N=>r.VSBuffer.wrap(N))).buffer);return(0,s.readFileIntoStream)(this,h,A,F=>F.buffer,Object.assign(Object.assign({},f),{bufferSize:this.BUFFER_SIZE}),P),A}async writeFile(h,f,P){let A;try{const F=this.toFilePath(h);if(!P.create||!P.overwrite){if(await(0,y.exists)(F)){if(!P.overwrite)throw(0,S.createFileSystemProviderError)((0,d.localize)(0,null),S.FileSystemProviderErrorCode.FileExists)}else if(!P.create)throw(0,S.createFileSystemProviderError)((0,d.localize)(1,null),S.FileSystemProviderErrorCode.FileNotFound)}A=await this.open(h,{create:!0,unlock:P.unlock}),await this.write(A,0,f,0,f.byteLength)}catch(F){throw await this.toFileSystemProviderWriteError(h,F)}finally{typeof A=="number"&&await this.close(A)}}async open(h,f){try{const P=this.toFilePath(h);if((0,S.isFileOpenForWriteOptions)(f)&&f.unlock)try{const{stat:N}=await y.SymlinkSupport.stat(P);N.mode&128||await v.promises.chmod(P,N.mode|128)}catch(N){this.logService.trace(N)}let A;if((0,S.isFileOpenForWriteOptions)(f)){if(n.isWindows)try{await v.promises.truncate(P,0),A="r+"}catch(N){N.code!=="ENOENT"&&this.logService.trace(N)}A||(A="w")}else A="r";const F=await(0,R.promisify)(v.open)(P,A);return this.mapHandleToPos.set(F,0),(0,S.isFileOpenForWriteOptions)(f)&&this.writeHandles.set(F,h),F}catch(P){throw(0,S.isFileOpenForWriteOptions)(f)?await this.toFileSystemProviderWriteError(h,P):this.toFileSystemProviderError(P)}}async close(h){try{if(this.mapHandleToPos.delete(h),this.writeHandles.delete(h)&&this.canFlush)try{await(0,R.promisify)(v.fdatasync)(h)}catch(f){this.canFlush=!1,this.logService.error(f)}return await(0,R.promisify)(v.close)(h)}catch(f){throw this.toFileSystemProviderError(f)}}async read(h,f,P,A,F){const N=this.normalizePos(h,f);let j=null;try{const G=await(0,R.promisify)(v.read)(h,P,A,F,N);return typeof G=="number"?j=G:j=G.bytesRead,j}catch(G){throw this.toFileSystemProviderError(G)}finally{this.updatePos(h,N,j)}}normalizePos(h,f){return f===this.mapHandleToPos.get(h)?null:f}updatePos(h,f,P){const A=this.mapHandleToPos.get(h);typeof A=="number"&&(typeof f=="number"||(typeof P=="number"?this.mapHandleToPos.set(h,A+P):this.mapHandleToPos.delete(h)))}async write(h,f,P,A,F){return(0,E.retry)(()=>this.doWrite(h,f,P,A,F),100,3)}async doWrite(h,f,P,A,F){const N=this.normalizePos(h,f);let j=null;try{const G=await(0,R.promisify)(v.write)(h,P,A,F,N);return typeof G=="number"?j=G:j=G.bytesWritten,j}catch(G){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(h),G)}finally{this.updatePos(h,N,j)}}async mkdir(h){try{await v.promises.mkdir(this.toFilePath(h))}catch(f){throw this.toFileSystemProviderError(f)}}async delete(h,f){try{const P=this.toFilePath(h);await this.doDelete(P,f)}catch(P){throw this.toFileSystemProviderError(P)}}async doDelete(h,f){f.recursive?await(0,y.rimraf)(h,y.RimRafMode.MOVE):await v.promises.unlink(h)}async rename(h,f,P){const A=this.toFilePath(h),F=this.toFilePath(f);if(A!==F)try{await this.validateTargetDeleted(h,f,"move",P.overwrite),await(0,y.move)(A,F)}catch(N){throw(N.code==="EINVAL"||N.code==="EBUSY"||N.code==="ENAMETOOLONG")&&(N=new Error((0,d.localize)(2,null,(0,i.basename)(A),(0,i.basename)((0,i.dirname)(F)),N.toString()))),this.toFileSystemProviderError(N)}}async copy(h,f,P){const A=this.toFilePath(h),F=this.toFilePath(f);if(A!==F)try{await this.validateTargetDeleted(h,f,"copy",P.overwrite),await(0,y.copy)(A,F,{preserveSymlinks:!0})}catch(N){throw(N.code==="EINVAL"||N.code==="EBUSY"||N.code==="ENAMETOOLONG")&&(N=new Error((0,d.localize)(3,null,(0,i.basename)(A),(0,i.basename)((0,i.dirname)(F)),N.toString()))),this.toFileSystemProviderError(N)}}async validateTargetDeleted(h,f,P,A){const F=this.toFilePath(h),N=this.toFilePath(f);let j=!1;if(!!(this.capabilities&1024)||(j=(0,g.isEqual)(F,N,!0)),j&&P==="copy")throw(0,S.createFileSystemProviderError)((0,d.localize)(4,null),S.FileSystemProviderErrorCode.FileExists);if(!j&&await(0,y.exists)(N)){if(!A)throw(0,S.createFileSystemProviderError)((0,d.localize)(5,null),S.FileSystemProviderErrorCode.FileExists);await this.delete(f,{recursive:!0,useTrash:!1})}}watch(h,f){return f.recursive?this.watchRecursive(h,f.excludes):this.watchNonRecursive(h)}watchRecursive(h,f){const P={path:this.toFilePath(h),excludes:f},A=(0,t.insert)(this.recursiveFoldersToWatch,P);return this.refreshRecursiveWatchers(),(0,D.toDisposable)(()=>{A(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var h,f,P;if(this.recursiveWatcher instanceof l.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,D.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let A,F;((f=(h=this.options)===null||h===void 0?void 0:h.watcher)===null||f===void 0?void 0:f.usePolling)?(A=b.FileWatcher,F=(P=this.options)===null||P===void 0?void 0:P.watcher):this.recursiveFoldersToWatch.length===1?n.isWindows?A=w.FileWatcher:A=b.FileWatcher:A=l.FileWatcher,this.recursiveWatcher=new A(this.recursiveFoldersToWatch,N=>this._onDidChangeFile.fire((0,m.toFileChanges)(N)),N=>{N.type==="error"&&this._onDidWatchErrorOccur.fire(N.message),this.logService[N.type](N.message)},this.logService.getLevel()===p.LogLevel.Trace,F),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)}))}}watchNonRecursive(h){const f=new c.FileWatcher(this.toFilePath(h),A=>this._onDidChangeFile.fire((0,m.toFileChanges)(A)),A=>{A.type==="error"&&this._onDidWatchErrorOccur.fire(A.message),this.logService[A.type](A.message)},this.logService.getLevel()===p.LogLevel.Trace),P=this.logService.onDidChangeLogLevel(()=>{f.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)});return(0,D.combinedDisposable)(f,P)}toFilePath(h){return(0,i.normalize)(h.fsPath)}toFileSystemProviderError(h){if(h instanceof S.FileSystemProviderError)return h;let f;switch(h.code){case"ENOENT":f=S.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":f=S.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":f=S.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":f=S.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":f=S.FileSystemProviderErrorCode.NoPermissions;break;default:f=S.FileSystemProviderErrorCode.Unknown}return(0,S.createFileSystemProviderError)(h,f)}async toFileSystemProviderWriteError(h,f){let P=this.toFileSystemProviderError(f);if(h&&P.code===S.FileSystemProviderErrorCode.NoPermissions)try{const{stat:A}=await y.SymlinkSupport.stat(this.toFilePath(h));A.mode&128||(P=(0,S.createFileSystemProviderError)(f,S.FileSystemProviderErrorCode.FileWriteLocked))}catch(A){this.logService.trace(A)}return P}dispose(){super.dispose(),(0,D.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,D.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=a}),define(X[92],Q([0,1,6]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function R(S,k){switch(k){case v.LogLevel.Trace:return S.trace;case v.LogLevel.Debug:return S.debug;case v.LogLevel.Info:return S.info;case v.LogLevel.Warning:return S.warn;case v.LogLevel.Error:return S.error;case v.LogLevel.Critical:return S.critical;default:throw new Error("Invalid log level")}}class D extends v.AbstractLogger{constructor(k=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(k),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(k){this._logger=k;for(const{level:n,args:y}of this.buffer)R(k,n).apply(k,y);this.buffer=[]}_log(k,...n){this._logger?R(this._logger,k).apply(this._logger,n):this.getLevel()<=k&&this.buffer.push({level:k,args:n})}trace(k,...n){this._log(v.LogLevel.Trace,k,...n)}debug(k,...n){this._log(v.LogLevel.Debug,k,...n)}info(k,...n){this._log(v.LogLevel.Info,k,...n)}warn(k,...n){this._log(v.LogLevel.Warning,k,...n)}error(k,...n){this._log(v.LogLevel.Error,k,...n)}critical(k,...n){this._log(v.LogLevel.Critical,k,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(X[174],Q([0,1,6,16,10,20,15,2,4,92]),function($,e,v,R,D,S,k,n,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const L=5*R.ByteSize.MB;let g=class extends v.AbstractLogger{constructor(d,m,b,w){super();this.name=d,this.resource=m,this.fileService=w,this.backupIndex=1,this.setLevel(b),this.queue=this._register(new D.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=v.LogLevel.Trace&&this._log(v.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=v.LogLevel.Debug&&this._log(v.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=v.LogLevel.Info&&this._log(v.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=v.LogLevel.Warning&&this._log(v.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=v.LogLevel.Error){const d=arguments[0];if(d instanceof Error){const m=Array.prototype.slice.call(arguments);m[0]=d.stack,this._log(v.LogLevel.Error,this.format(m))}else this._log(v.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=v.LogLevel.Critical&&this._log(v.LogLevel.Critical,this.format(arguments))}flush(){}log(d,m){this._log(d,this.format(m))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(d){if(d.fileOperationResult!==3)throw d}}_log(d,m){this.queue.queue(async()=>{await this.initializePromise;let b=await this.loadContent();b.length>L&&(await this.fileService.writeFile(this.getBackupResource(),S.VSBuffer.fromString(b)),b=""),b+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(d)}] ${m}
`,await this.fileService.writeFile(this.resource,S.VSBuffer.fromString(b))})}getCurrentTimestamp(){const d=w=>w<10?`0${w}`:w,m=w=>w<10?`00${w}`:w<100?`0${w}`:w,b=new Date;return`${b.getFullYear()}-${d(b.getMonth()+1)}-${d(b.getDate())} ${d(b.getHours())}:${d(b.getMinutes())}:${d(b.getSeconds())}.${m(b.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(d){return""}}stringifyLogLevel(d){switch(d){case v.LogLevel.Critical:return"critical";case v.LogLevel.Debug:return"debug";case v.LogLevel.Error:return"error";case v.LogLevel.Info:return"info";case v.LogLevel.Trace:return"trace";case v.LogLevel.Warning:return"warning"}return""}format(d){let m="";for(let b=0;b<d.length;b++){let w=d[b];if(typeof w=="object")try{w=JSON.stringify(w)}catch(l){}m+=(b>0?" ":"")+w}return m}};g=ce([Z(3,R.IFileService)],g),e.FileLogger=g;let E=class extends n.Disposable{constructor(d,m,b){super();this.logService=d,this.instantiationService=m,this.fileService=b,this.loggers=new Map,this._register(d.onDidChangeLogLevel(w=>this.loggers.forEach(l=>l.setLevel(w))))}createLogger(d){let m=this.loggers.get(d.toString());return m||(m=new i.BufferLogService(this.logService.getLevel()),this.loggers.set(d.toString(),m),(0,R.whenProviderRegistered)(d,this.fileService).then(()=>m.logger=this.instantiationService.createInstance(g,(0,k.basename)(d),d,this.logService.getLevel()))),m}dispose(){this.loggers.forEach(d=>d.dispose()),this.loggers.clear(),super.dispose()}};E=ce([Z(0,v.ILogService),Z(1,y.IInstantiationService),Z(2,R.IFileService)],E),e.FileLoggerService=E}),define(X[175],Q([0,1,6,5,7]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class S{constructor(E){this.service=E,this.onDidChangeLogLevel=R.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(E,p,d){switch(p){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=S;class k{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E){k.setLevel(this.channel,E)}static setLevel(E,p){return E.call("setLevel",p)}}e.LogLevelChannelClient=k;class n{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,p){throw new Error(`Event not found: ${p}`)}async call(E,p,d){switch(p){case"createLogger":this.createLogger(D.URI.revive(d[0]),d[1]);return;case"log":return this.log(D.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${p}`)}createLogger(E,p){this.loggers.set(E.toString(),this.loggerService.createLogger(E,p))}consoleLog(E,p){let d=console.log;switch(E){case v.LogLevel.Error:d=console.error;break;case v.LogLevel.Warning:d=console.warn;break;case v.LogLevel.Info:d=console.info;break}d.call(console,...p)}log(E,p){const d=this.loggers.get(E.toString());if(!d)throw new Error("Create the logger before logging");for(const[m,b]of p)switch(m){case v.LogLevel.Trace:d.trace(b);break;case v.LogLevel.Debug:d.debug(b);break;case v.LogLevel.Info:d.info(b);break;case v.LogLevel.Warning:d.warn(b);break;case v.LogLevel.Error:d.error(b);break;case v.LogLevel.Critical:d.critical(b);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class y{constructor(E){this.channel=E}createConsoleMainLogger(){return new v.AdapterLogger({log:(E,p)=>{this.channel.call("consoleLog",[E,p])}})}createLogger(E,p){return new i(this.channel,E,p)}}e.LoggerChannelClient=y;class i extends v.AbstractMessageLogger{constructor(E,p,d){super(d==null?void 0:d.always);this.channel=E,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.channel.call("createLogger",[p,d]).then(()=>{this._log(this.buffer),this.isLoggerCreated=!0})}log(E,p){this._log([[E,p]])}_log(E){this.isLoggerCreated?this.channel.call("log",[this.file,E]):this.buffer.push(...E)}}class L extends v.LogService{constructor(E,p){super(p);this.parent=E,this._register(E.onDidChangeLogLevel(d=>p.setLevel(d)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=L}),define(X[93],Q([0,1,6,16]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function D(y,i,L,g){try{const E=await new Promise((p,d)=>{$(["spdlog"],p,d)});return E.setAsyncMode(8192,500),E.createRotatingLoggerAsync(y,i,L,g)}catch(E){console.error(E)}return null}function S(y,i,L,g){return $.__$__nodeRequire("spdlog").createRotatingLogger(y,i,L,g)}e.createRotatingLogger=S;function k(y,i,L){switch(i){case v.LogLevel.Trace:y.trace(L);break;case v.LogLevel.Debug:y.debug(L);break;case v.LogLevel.Info:y.info(L);break;case v.LogLevel.Warning:y.warn(L);break;case v.LogLevel.Error:y.error(L);break;case v.LogLevel.Critical:y.critical(L);break;default:throw new Error("Invalid log level")}}class n extends v.AbstractMessageLogger{constructor(i,L,g,E){super();this.name=i,this.filepath=L,this.rotating=g,this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const i=this.rotating?6:1,L=30/i*R.ByteSize.MB;return D(this.name,this.filepath,L,i).then(g=>{if(g){this._logger=g,this._logger.setLevel(this.getLevel());for(const{level:E,message:p}of this.buffer)k(this._logger,E,p);this.buffer=[]}})}log(i,L){this._logger?k(this._logger,i,L):this.getLevel()<=i&&this.buffer.push({level:i,message:L})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(X[176],Q([0,1,6,2,15,9,174,93,16,28]),function($,e,v,R,D,S,k,n,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let L=class extends R.Disposable{constructor(E,p){super();this.logService=E,this.fileService=p,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(E.onDidChangeLogLevel(d=>this.logLevelChangeableLoggers.forEach(m=>m.setLevel(d))))}createLogger(E,p){var d;let m=this.loggers.get(E.toString());return m||(E.scheme===S.Schemas.file?(m=new n.SpdLogLogger((p==null?void 0:p.name)||(0,i.generateUuid)(),E.fsPath,!(p==null?void 0:p.donotRotate),this.logService.getLevel()),(p==null?void 0:p.donotUseFormatters)&&m.clearFormatters()):m=new k.FileLogger((d=p==null?void 0:p.name)!==null&&d!==void 0?d:(0,D.basename)(E),E,this.logService.getLevel(),this.fileService),this.loggers.set(E.toString(),m),(p==null?void 0:p.always)?m.setLevel(v.LogLevel.Trace):this.logLevelChangeableLoggers.push(m)),m}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(E=>E.dispose()),this.loggers.clear(),super.dispose()}};L=ce([Z(0,v.ILogService),Z(1,y.IFileService)],L),e.LoggerService=L}),define(X[177],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(k){return k.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function R(k){return k.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=R;function D(k){return k.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function S(k){return!v(k)&&!R(k)&&!D(k)}e.isMenubarMenuItemAction=S}),define(X[54],Q([0,1,9,3,35,15]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof R.globals.vscode!="undefined"){const n=R.globals.vscode.context.configuration();if(n)k=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof($==null?void 0:$.__$__nodeRequire)=="function"){const n=(0,S.dirname)(v.FileAccess.asFileUri("",$));k=$.__$__nodeRequire((0,S.joinPath)(n,"product.json").fsPath);const y=$.__$__nodeRequire((0,S.joinPath)(n,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:y.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.56.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=k}),define(X[23],Q([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService")}),define(X[178],Q([0,1,60,6,23]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let S=class{constructor(n,y){this.productService=n,this.logService=y,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,y){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const i=/^(.*)#([^#]+)$/.exec(y);if(!i)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",y),!1;const[,L,g]=i;let E=this.trustedExtensionUrlPublicKeys.get(n);if(!E){if(E=this.productService.trustedExtensionUrlPublicKeys[n],!E||E.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...E])}const p=Buffer.from(decodeURIComponent(g),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",y),!1;const d=p.slice(0,6),m=p.readUIntBE(0,6),b=Date.now()-m;if(b<0||b>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",y),!1;const w=p.slice(6),l=v.createVerify("SHA256");l.write(d),l.write(Buffer.from(L)),l.end();for(let c=0;c<E.length;c++){let o=E[c];if(o!==null){if(typeof o=="string")try{o=v.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),E[c]=o}catch(s){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${c+1} for ${n}:`,s),E[c]=null;continue}if(l.verify(o,w))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",y),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",y),!1}};S=ce([Z(0,D.IProductService),Z(1,R.ILogService)],S),e.ExtensionUrlTrustService=S}),define(X[55],Q([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(X[179],Q([0,1,2,9,7,47,11,6,36,3,15,28]),function($,e,v,R,D,S,k,n,y,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let E=class extends v.Disposable{constructor(d,m){super();this.logService=m,this.validRoots=y.TernarySearchTree.forUris(()=>!i.isLinux),this.validExtensions=new Set([".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(D.URI.file(d.appRoot)),this.addValidFileRoot(D.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=k.session;d.protocol.registerFileProtocol(R.Schemas.vscodeFileResource,(m,b)=>this.handleResourceRequest(m,b)),d.protocol.interceptFileProtocol(R.Schemas.file,(m,b)=>this.handleFileRequest(m,b)),this._register((0,v.toDisposable)(()=>{d.protocol.unregisterProtocol(R.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(R.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?v.Disposable.None:(this.validRoots.set(d,!0),(0,v.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,m){const b=D.URI.parse(d.url);return i.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${b.fsPath} from ${R.Schemas.file}: protocol (original URL: ${d.url})`),m({error:-3})):this.validRoots.findSubstr(b)?m({path:b.fsPath}):this.validExtensions.has((0,L.extname)(b))?m({path:b.fsPath}):(this.logService.error(`${R.Schemas.file}: Refused to load resource ${b.fsPath} from ${R.Schemas.file}: protocol (original URL: ${d.url})`),m({error:-3}))}handleResourceRequest(d,m){const b=D.URI.parse(d.url),w=R.FileAccess.asFileUri(b);return this.validRoots.findSubstr(w)?m({path:w.fsPath}):this.validExtensions.has((0,L.extname)(w))?m({path:w.fsPath}):(this.logService.error(`${R.Schemas.vscodeFileResource}: Refused to load resource ${w.fsPath} from ${R.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),m({error:-3}))}createIPCObjectUrl(d){const m=D.URI.from({scheme:"vscode",path:(0,g.generateUuid)()}),b=m.toString(),w=async()=>d;return k.ipcMain.handle(b,w),this.logService.trace(`IPC Object URL: Registered new channel ${b}.`),{resource:m,update:l=>d=l,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${b}.`),k.ipcMain.removeHandler(b)}}}};E=ce([Z(0,S.INativeEnvironmentService),Z(1,n.ILogService)],E),e.ProtocolMainService=E}),define(X[37],Q([0,1,13,100]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(k,n){R.ok(v.isString(k)),R.ok(v.isObject(n)),R.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,n)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new D}),define(X[180],Q([0,1,37,5]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class S{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,i){this.schemasById[D(y)]=i,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new S;v.Registry.add(e.Extensions.JSONContribution,k)}),define(X[48],Q([0,1,130,5,37,13,180]),function($,e,v,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var n;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(n=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=D.Registry.as(k.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,l=!0){this.registerConfigurations([w],l)}registerConfigurations(w,l=!0){const c=[];w.forEach(o=>{c.push(...this.validateAndRegisterProperties(o,l)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(w){const l=[],c=o=>{if(o.properties)for(const s in o.properties)l.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,o.properties[s]);o.allOf&&o.allOf.forEach(s=>c(s))};for(const o of w){c(o);const s=this.configurationContributors.indexOf(o);s!==-1&&this.configurationContributors.splice(s,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}registerDefaultConfigurations(w){const l=[],c=[];for(const o of w)for(const s in o)if(l.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]=Object.assign(Object.assign({},this.defaultValues[s]||{}),o[s]);const t={type:"object",default:this.defaultValues[s],description:v.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};c.push(g(s)),this.configurationProperties[s]=t,this.defaultLanguageConfigurationOverridesNode.properties[s]=t}else{this.defaultValues[s]=o[s];const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterDefaultConfigurations(w){const l=[];for(const c of w)for(const o in c)if(l.push(o),delete this.defaultValues[o],e.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const s=this.configurationProperties[o];s&&(this.updatePropertyDefaultValue(o,s),this.updateSchema(o,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const l of w)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,l=!0,c=3){c=S.isUndefinedOrNull(w.scope)?c:w.scope;let o=[],s=w.properties;if(s)for(let r in s){if(l&&d(r)){delete s[r];continue}const a=s[r];if(this.updatePropertyDefaultValue(r,a),e.OVERRIDE_PROPERTY_PATTERN.test(r)?a.scope=void 0:a.scope=S.isUndefinedOrNull(a.scope)?c:a.scope,s[r].hasOwnProperty("included")&&!s[r].included){this.excludedConfigurationProperties[r]=s[r],delete s[r];continue}else this.configurationProperties[r]=s[r];!s[r].deprecationMessage&&s[r].markdownDeprecationMessage&&(s[r].deprecationMessage=s[r].markdownDeprecationMessage),o.push(r)}let t=w.allOf;if(t)for(let r of t)o.push(...this.validateAndRegisterProperties(r,l,c));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const l=c=>{let o=c.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);let s=c.allOf;s&&s.forEach(l)};l(w)}updateSchema(w,l){switch(e.allSettings.properties[w]=l,l.scope){case 1:e.applicationSettings.properties[w]=l;break;case 2:e.machineSettings.properties[w]=l;break;case 6:e.machineOverridableSettings.properties[w]=l;break;case 3:e.windowSettings.properties[w]=l;break;case 4:e.resourceSettings.properties[w]=l;break;case 5:e.resourceSettings.properties[w]=l,this.resourceLanguageSettingsSchema.properties[w]=l;break}}removeFromSchema(w,l){switch(delete e.allSettings.properties[w],l.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const l=`[${w}]`,c={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,c),e.allSettings.properties[l]=c,e.applicationSettings.properties[l]=c,e.machineSettings.properties[l]=c,e.machineOverridableSettings.properties[l]=c,e.windowSettings.properties[l]=c,e.resourceSettings.properties[l]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,l){let c=this.defaultValues[w];S.isUndefined(c)&&(c=l.default),S.isUndefined(c)&&(c=E(l.type)),l.default=c}}const L="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(L);function g(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=g;function E(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=E;const p=new i;D.Registry.add(e.Extensions.Configuration,p);function d(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?v.localize(5,null,b):p.getConfigurationProperties()[b]!==void 0?v.localize(6,null,b):null:v.localize(4,null)}e.validateProperty=d;function m(){const b=[],w=p.getConfigurationProperties();for(const l of Object.keys(w))b.push([l,w[l].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=m}),define(X[24],Q([0,1,45,13,7,37,4,48]),function($,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function y(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof D.URI)}e.isConfigurationOverrides=y;var i;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(i=e.ConfigurationTarget||(e.ConfigurationTarget={}));function L(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=L;function g(r,a){const u=a?r?a.keys.filter(j=>r.keys.indexOf(j)===-1):[...a.keys]:[],h=r?a?r.keys.filter(j=>a.keys.indexOf(j)===-1):[...r.keys]:[],f=[];if(a&&r){for(const j of r.keys)if(a.keys.indexOf(j)!==-1){const G=w(r.contents,j),ne=w(a.contents,j);v.equals(G,ne)||f.push(j)}}const P=[],A=j=>{const G={};for(const ne of j)for(const oe of ne.identifiers)G[s(oe)]=ne;return G},F=a?A(a.overrides):{},N=r?A(r.overrides):{};if(Object.keys(F).length)for(const j of u){const G=F[j];G&&P.push([(0,n.overrideIdentifierFromKey)(j),G.keys])}if(Object.keys(N).length)for(const j of h){const G=N[j];G&&P.push([(0,n.overrideIdentifierFromKey)(j),G.keys])}if(Object.keys(F).length&&Object.keys(N).length)for(const j of f){const G=N[j],ne=F[j];if(G&&ne){const oe=g({contents:G.contents,keys:G.keys,overrides:[]},{contents:ne.contents,keys:ne.keys,overrides:[]});P.push([(0,n.overrideIdentifierFromKey)(j),[...oe.added,...oe.removed,...oe.updated]])}}return{added:u,removed:h,updated:f,overrides:P}}e.compare=g;function E(r,a){const u=[];for(const h of Object.keys(r))if(n.OVERRIDE_PROPERTY_PATTERN.test(h)){const f={};for(const P in r[h])f[P]=r[h][P];u.push({identifiers:[(0,n.overrideIdentifierFromKey)(h).trim()],keys:Object.keys(f),contents:p(f,a)})}return u}e.toOverrides=E;function p(r,a){const u=Object.create(null);for(let h in r)d(u,h,r[h],a);return u}e.toValuesTree=p;function d(r,a,u,h){const f=a.split("."),P=f.pop();let A=r;for(let F=0;F<f.length;F++){let N=f[F],j=A[N];switch(typeof j){case"undefined":j=A[N]=Object.create(null);break;case"object":break;default:h(`Ignoring ${a} as ${f.slice(0,F+1).join(".")} is ${JSON.stringify(j)}`);return}A=j}if(typeof A=="object"&&A!==null)try{A[P]=u}catch(F){h(`Ignoring ${a} as ${f.join(".")} is ${JSON.stringify(A)}`)}else h(`Ignoring ${a} as ${f.join(".")} is ${JSON.stringify(A)}`)}e.addToValueTree=d;function m(r,a){const u=a.split(".");b(r,u)}e.removeFromValueTree=m;function b(r,a){const u=a.shift();if(a.length===0){delete r[u];return}if(Object.keys(r).indexOf(u)!==-1){const h=r[u];typeof h=="object"&&!Array.isArray(h)&&(b(h,a),Object.keys(h).length===0&&delete r[u])}}function w(r,a,u){function h(A,F){let N=A;for(const j of F){if(typeof N!="object"||N===null)return;N=N[j]}return N}const f=a.split("."),P=h(r,f);return typeof P=="undefined"?u:P}e.getConfigurationValue=w;function l(r,a,u){Object.keys(a).forEach(h=>{h!=="__proto__"&&(h in r?R.isObject(r[h])&&R.isObject(a[h])?l(r[h],a[h],u):u&&(r[h]=a[h]):r[h]=a[h])})}e.merge=l;function c(){const r=S.Registry.as(n.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=c;function o(){const r=Object.create(null),a=S.Registry.as(n.Extensions.Configuration).getConfigurationProperties();for(let u in a){let h=a[u].default;d(r,u,h,f=>console.error(`Conflict in default settings: ${f}`))}return r}e.getDefaultValues=o;function s(r){return`[${r}]`}e.keyFromOverrideIdentifier=s;function t(r,a,u){const h=r.inspect(a),f=r.inspect(u);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:h.defaultValue}e.getMigratedSettingValue=t}),define(X[181],Q([0,1,44,36,34,13,45,7,48,24,37,2,5]),function($,e,v,R,D,S,k,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(t={},r=[],a=[]){this._contents=t,this._keys=r,this._overrides=a,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const a=this.getContentsForOverrideIdentifer(r);return a?t?(0,i.getConfigurationValue)(a,t):a:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let a={};for(const u of D.distinct([...Object.keys(this.contents),...Object.keys(r)])){let h=this.contents[u],f=r[u];f&&(typeof h=="object"&&typeof f=="object"?(h=k.deepClone(h),this.mergeContents(h,f)):h=f),a[u]=h}return new p(a,this.keys,this.overrides)}merge(...t){const r=k.deepClone(this.contents),a=k.deepClone(this.overrides),u=[...this.keys];for(const h of t){this.mergeContents(r,h.contents);for(const f of h.overrides){const[P]=a.filter(A=>D.equals(A.identifiers,f.identifiers));P?this.mergeContents(P.contents,f.contents):a.push(k.deepClone(f))}for(const f of h.keys)u.indexOf(f)===-1&&u.push(f)}return new p(r,u,a)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const a of Object.keys(r)){if(a in t&&S.isObject(t[a])&&S.isObject(r[a])){this.mergeContents(t[a],r[a]);continue}t[a]=k.deepClone(r[a])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?k.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,i.addToValueTree)(this.contents,t,r,a=>{throw new Error(a)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let a=0;a<r;a++)t.indexOf(this.keys[a])===0&&(r=a);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=p;class d extends p{constructor(){const t=(0,i.getDefaultValues)(),r=(0,i.getConfigurationKeys)(),a=[];for(const u of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(u)&&a.push({identifiers:[(0,y.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(t[u]),contents:(0,i.toValuesTree)(t[u],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,r,a)}}e.DefaultConfigurationModel=d;class m{constructor(t,r){this._name=t,this._scopes=r,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get errors(){return this._parseErrors}parseContent(t){if(!S.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r)}}parseRaw(t){this._raw=t;const r=this.doParseRaw(t);this._configurationModel=new p(r.contents,r.keys,r.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let r={},a=null,u=[],h=[],f=[];function P(F){Array.isArray(u)?u.push(F):a&&(u[a]=F)}let A={onObjectBegin:()=>{let F={};P(F),h.push(u),u=F,a=null},onObjectProperty:F=>{a=F},onObjectEnd:()=>{u=h.pop()},onArrayBegin:()=>{let F=[];P(F),h.push(u),u=F,a=null},onArrayEnd:()=>{u=h.pop()},onLiteralValue:P,onError:(F,N,j)=>{f.push({error:F,offset:N,length:j})}};if(t)try{v.visit(t,A),r=u[0]||{}}catch(F){console.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return r}doParseRaw(t){if(this._scopes){const h=L.Registry.as(y.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,h,!0,this._scopes)}const r=(0,i.toValuesTree)(t,h=>console.error(`Conflict in settings file ${this._name}: ${h}`)),a=Object.keys(t),u=(0,i.toOverrides)(t,h=>console.error(`Conflict in settings file ${this._name}: ${h}`));return{contents:r,keys:a,overrides:u}}filterByScope(t,r,a,u){const h={};for(let f in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(f)&&a)h[f]=this.filterByScope(t[f],r,!1,u);else{const P=this.getScope(f,r);(P===void 0||u.indexOf(P)!==-1)&&(h[f]=t[f])}return h}getScope(t,r){const a=r[t];return a?typeof a.scope!="undefined"?a.scope:3:void 0}}e.ConfigurationModelParser=m;class b extends g.Disposable{constructor(t,r,a,u){super();this.userSettingsResource=t,this.scopes=r,this.fileService=u,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(E.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new p}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=b;class w{constructor(t,r,a=new p,u=new p,h=new R.ResourceMap,f=new p,P=new R.ResourceMap,A=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=a,this._workspaceConfiguration=u,this._folderConfigurations=h,this._memoryConfiguration=f,this._memoryConfigurationByResource=P,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,r,a){return this.getConsolidateConfigurationModel(r,a).getValue(t)}updateValue(t,r,a={}){let u;a.resource?(u=this._memoryConfigurationByResource.get(a.resource),u||(u=new p,this._memoryConfigurationByResource.set(a.resource,u))):u=this._memoryConfiguration,r===void 0?u.removeValue(t):u.setValue(t,r),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,a){const u=this.getConsolidateConfigurationModel(r,a),h=this.getFolderConfigurationModelForResource(r.resource,a),f=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,P=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),A=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),F=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),N=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),j=a?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,G=h?r.overrideIdentifier?h.freeze().override(r.overrideIdentifier).getValue(t):h.freeze().getValue(t):void 0,ne=r.overrideIdentifier?f.override(r.overrideIdentifier).getValue(t):f.getValue(t),oe=u.getValue(t),V=D.distinct(D.flatten(u.overrides.map(Y=>Y.identifiers))).filter(Y=>u.getOverrideValue(t,Y)!==void 0);return{defaultValue:P,userValue:A,userLocalValue:F,userRemoteValue:N,workspaceValue:j,workspaceFolderValue:G,memoryValue:ne,value:oe,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:N!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:j!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:G!==void 0?{value:h==null?void 0:h.freeze().getValue(t),override:r.overrideIdentifier?h==null?void 0:h.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:ne!==void 0?{value:f.getValue(t),override:r.overrideIdentifier?f.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const a=r.filter(u=>y.OVERRIDE_PROPERTY_PATTERN.test(u)).map(u=>{const h=(0,y.overrideIdentifierFromKey)(u),f=this._defaultConfiguration.getKeysForOverrideIdentifier(h),P=t.getKeysForOverrideIdentifier(h),A=[...P.filter(F=>f.indexOf(F)===-1),...f.filter(F=>P.indexOf(F)===-1),...f.filter(F=>!k.equals(this._defaultConfiguration.override(h).getValue(F),t.override(h).getValue(F)))];return[h,A]});return this.updateDefaultConfiguration(t),{keys:r,overrides:a}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:a,removed:u,overrides:h}=(0,i.compare)(this.localUserConfiguration,t),f=[...r,...a,...u];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:a,removed:u,overrides:h}=(0,i.compare)(this.remoteUserConfiguration,t);let f=[...r,...a,...u];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:a,removed:u,overrides:h}=(0,i.compare)(this.workspaceConfiguration,t);let f=[...r,...a,...u];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:h}}compareAndUpdateFolderConfiguration(t,r){const a=this.folderConfigurations.get(t),{added:u,updated:h,removed:f,overrides:P}=(0,i.compare)(a,r);let A=[...u,...h,...f];return(A.length||!a)&&this.updateFolderConfiguration(t,r),{keys:A,overrides:P}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:a,updated:u,removed:h,overrides:f}=(0,i.compare)(r,void 0);return{keys:[...a,...u,...h],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let a=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?a.override(t.overrideIdentifier):a}getConsolidatedConfigurationModelForResource({resource:t},r){let a=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const u=r.getFolder(t);u&&(a=this.getFolderConsolidatedConfiguration(u.uri)||a);const h=this._memoryConfigurationByResource.get(t);h&&(a=a.merge(h))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const a=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(t);u?(r=a.merge(u),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=a}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const a=r.getFolder(t);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:a,overrides:u,keys:h}=this._folderConfigurations.get(r);return t.push([r,{contents:a,overrides:u,keys:h}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(a=>t.add(a))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(t).forEach(u=>r.add(u))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),a=this.parseConfigurationModel(t.user),u=this.parseConfigurationModel(t.workspace),h=t.folders.reduce((f,P)=>(f.set(n.URI.revive(P[0]),this.parseConfigurationModel(P[1])),f),new R.ResourceMap);return new w(r,a,new p,u,h,new p,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new p(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function l(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,r=new Map;for(const u of s)u.keys.forEach(h=>t.add(h)),u.overrides.forEach(([h,f])=>{const P=(0,R.getOrSet)(r,h,new Set);f.forEach(A=>P.add(A))});const a=[];return r.forEach((u,h)=>a.push([h,[...u.values()]])),{keys:[...t.values()],overrides:a}}e.mergeChanges=l;class c{constructor(t,r,a,u){this.change=t,this.previous=r,this.currentConfiguraiton=a,this.currentWorkspace=u,this._previousConfiguration=void 0;const h=new Set;t.keys.forEach(P=>h.add(P)),t.overrides.forEach(([,P])=>P.forEach(A=>h.add(A))),this.affectedKeys=[...h.values()];const f=new p;this.affectedKeys.forEach(P=>f.setValue(P,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var a;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const u=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(a=this.previous)===null||a===void 0?void 0:a.workspace):void 0,h=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!k.equals(u,h)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let a=(0,i.toValuesTree)({[r]:!0},()=>{}),u;for(;typeof a=="object"&&(u=Object.keys(a)[0]);){if(t=t[u],!t)return!1;a=a[u]}return!0}}e.ConfigurationChangeEvent=c;class o extends c{constructor(t,r,a,u){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=a,this.sourceConfig=u}}e.AllKeysConfigurationChangeEvent=o}),define(X[182],Q([0,1,37,48,2,24,181,5,10,15]),function($,e,v,R,D,S,k,n,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class L extends D.Disposable{constructor(E,p){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new k.UserSettings(this.settingsResource,void 0,i.extUriBiasedIgnorePathCase,p)),this.configuration=new k.Configuration(new k.DefaultConfigurationModel,new k.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new y.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(R.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new k.Configuration(new k.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,p){const d=typeof E=="string"?E:void 0,m=(0,S.isConfigurationOverrides)(E)?E:(0,S.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(d,m,void 0)}updateValue(E,p,d,m){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const p=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(d,p,1)}onDidDefaultConfigurationChange(E){const p=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new k.DefaultConfigurationModel,E);this.trigger(d,p,6)}trigger(E,p,d){const m=new k.ConfigurationChangeEvent(E,{data:p},this.configuration);m.source=d,m.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=L}),define(X[183],Q([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var R;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(k,n=R.Unknown,y){super(k);this._message=k,this._code=n,this._detail=y,this.isHandled=n===R.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===R.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===R.NoResolverFound}static isHandled(k){return k instanceof D&&k.isHandled}}e.RemoteAuthorityResolverError=D}),define(X[184],Q([0,1,83,28,2,20,5,183,18,10,25]),function($,e,v,R,D,S,k,n,y,i,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const g=30*1e3;var E;(function(T){T[T.Management=1]="Management",T[T.ExtensionHost=2]="ExtensionHost",T[T.Tunnel=3]="Tunnel"})(E=e.ConnectionType||(e.ConnectionType={}));function p(T){switch(T){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(T){const W=new L.CancellationTokenSource;return setTimeout(()=>W.cancel(),T),W.token}function m(T,W){if(T.isCancellationRequested||W.isCancellationRequested)return L.CancellationToken.Cancelled;const B=new L.CancellationTokenSource;return T.onCancellationRequested(()=>B.cancel()),W.onCancellationRequested(()=>B.cancel()),B.token}class b{constructor(W){this._state="pending",this._disposables=new D.DisposableStore,this.promise=new Promise((B,H)=>{this._resolvePromise=B,this._rejectPromise=H}),W.isCancellationRequested?this._timeout():this._disposables.add(W.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(W){this._state==="pending"?this._disposables.add(W):W.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(W))}reject(W){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(W))}}function w(T,W){const B=new b(W);return B.registerDisposable(T.onControlMessage(H=>{const K=JSON.parse(H.toString()),J=z(K);J?B.reject(J):B.resolve(K)})),B.promise}function l(T,W,B,H,K,J){const ee=new b(J);return W.connect(B,H,K,(re,x)=>{ee.didTimeout?(re&&T.error(re),x==null||x.dispose()):re||!x?ee.reject(re):ee.resolve(x)}),ee.promise}function c(T,W){const B=new b(W);return T.then(H=>{B.didTimeout||B.resolve(H)},H=>{B.didTimeout||B.reject(H)}),B.promise}async function o(T,W,B,H){const K=M(T,W);T.logService.trace(`${K} 1/6. invoking socketFactory.connect().`);let J;try{J=await l(T.logService,T.socketFactory,T.host,T.port,`reconnectionToken=${T.reconnectionToken}&reconnection=${T.reconnectionProtocol?"true":"false"}`,H)}catch(ie){throw T.logService.error(`${K} socketFactory.connect() failed or timed out. Error:`),T.logService.error(ie),ie}T.logService.trace(`${K} 2/6. socketFactory.connect() was successful.`);let ee,re;T.reconnectionProtocol?(T.reconnectionProtocol.beginAcceptReconnection(J,null),ee=T.reconnectionProtocol,re=!1):(ee=new v.PersistentProtocol(J,null),re=!0),T.logService.trace(`${K} 3/6. sending AuthRequest control message.`);const x={type:"auth",auth:T.connectionToken||"00000000000000000000"};ee.sendControl(S.VSBuffer.fromString(JSON.stringify(x)));try{const ie=await w(ee,m(H,d(1e4)));if(ie.type!=="sign"||typeof ie.data!="string"){const pe=new Error("Unexpected handshake message");throw pe.code="VSCODE_CONNECTION_ERROR",pe}T.logService.trace(`${K} 4/6. received SignRequest control message.`);const ae=await c(T.signService.sign(ie.data),H),ue={type:"connectionType",commit:T.commit,signedData:ae,desiredConnectionType:W};return B&&(ue.args=B),T.logService.trace(`${K} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(S.VSBuffer.fromString(JSON.stringify(ue))),{protocol:ee,ownsProtocol:re}}catch(ie){throw ie&&ie.code==="ETIMEDOUT"&&(T.logService.error(`${K} the handshake timed out. Error:`),T.logService.error(ie)),ie&&ie.code==="VSCODE_CONNECTION_ERROR"&&(T.logService.error(`${K} received error control message when negotiating connection. Error:`),T.logService.error(ie)),re&&O(ee),ie}}async function s(T,W,B,H){const K=Date.now(),J=M(T,W),{protocol:ee,ownsProtocol:re}=await o(T,W,B,H),x=new b(H);return x.registerDisposable(ee.onControlMessage(ie=>{const ae=JSON.parse(ie.toString()),ue=z(ae);ue?(T.logService.error(`${J} received error control message when negotiating connection. Error:`),T.logService.error(ue),re&&O(ee),x.reject(ue)):(T.reconnectionProtocol&&T.reconnectionProtocol.endAcceptReconnection(),T.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${_(K)}!`),x.resolve({protocol:ee,firstMessage:ae}))})),x.promise}async function t(T,W){const{protocol:B}=await s(T,1,void 0,W);return{protocol:B}}async function r(T,W,B){const{protocol:H,firstMessage:K}=await s(T,2,W,B),J=K&&K.debugPort;return{protocol:H,debugPort:J}}async function a(T,W,B){const H=Date.now(),K=M(T,3),{protocol:J}=await o(T,3,W,B);return T.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${_(H)}!`),J}async function u(T,W,B){const{host:H,port:K,connectionToken:J}=await T.addressProvider.getAddress();return{commit:T.commit,host:H,port:K,connectionToken:J,reconnectionToken:W,reconnectionProtocol:B,socketFactory:T.socketFactory,signService:T.signService,logService:T.logService}}async function h(T,W,B){try{const H=(0,R.generateUuid)(),K=await u(T,H,null),{protocol:J}=await t(K,L.CancellationToken.None);return new Y(T,W,B,H,J)}catch(H){throw T.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),T.logService.error(H),V.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(H)),H}}e.connectRemoteAgentManagement=h;async function f(T,W){try{const B=(0,R.generateUuid)(),H=await u(T,B,null),{protocol:K,debugPort:J}=await r(H,W,L.CancellationToken.None);return new U(T,W,B,K,J)}catch(B){throw T.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),T.logService.error(B),V.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentExtensionHost=f;async function P(T,W){const B=await u(T,(0,R.generateUuid)(),null);return await a(B,{port:W},L.CancellationToken.None)}e.connectRemoteAgentTunnel=P;function A(T){return(0,i.createCancelablePromise)(W=>new Promise((B,H)=>{const K=setTimeout(B,T*1e3);W.onCancellationRequested(()=>{clearTimeout(K),B()})}))}var F;(function(T){T[T.ConnectionLost=0]="ConnectionLost",T[T.ReconnectionWait=1]="ReconnectionWait",T[T.ReconnectionRunning=2]="ReconnectionRunning",T[T.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",T[T.ConnectionGain=4]="ConnectionGain"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class N{constructor(W,B){this.reconnectionToken=W,this.millisSinceLastIncomingData=B,this.type=0}}e.ConnectionLostEvent=N;class j{constructor(W,B,H,K){this.reconnectionToken=W,this.millisSinceLastIncomingData=B,this.durationSeconds=H,this.cancellableTimer=K,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=j;class G{constructor(W,B,H){this.reconnectionToken=W,this.millisSinceLastIncomingData=B,this.attempt=H,this.type=2}}e.ReconnectionRunningEvent=G;class ne{constructor(W,B,H){this.reconnectionToken=W,this.millisSinceLastIncomingData=B,this.attempt=H,this.type=4}}e.ConnectionGainEvent=ne;class oe{constructor(W,B,H,K){this.reconnectionToken=W,this.millisSinceLastIncomingData=B,this.attempt=H,this.handled=K,this.type=3}}e.ReconnectionPermanentFailureEvent=oe;class V extends D.Disposable{constructor(W,B,H,K){super();this._connectionType=W,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=B,this.reconnectionToken=H,this.protocol=K,this._isReconnecting=!1,this._onDidStateChange.fire(new ne(this.reconnectionToken,0,0)),this._register(K.onSocketClose(()=>this._beginReconnecting())),this._register(K.onSocketTimeout(()=>this._beginReconnecting())),V._instances.push(this),V._permanentFailure&&this._gotoPermanentFailure(V._permanentFailureMillisSinceLastIncomingData,V._permanentFailureAttempt,V._permanentFailureHandled)}static triggerPermanentFailure(W,B,H){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=W,this._permanentFailureAttempt=B,this._permanentFailureHandled=H,this._instances.forEach(K=>K._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(!V._permanentFailure){const W=I(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30],H=Date.now();let K=-1;do{K++;const J=K<B.length?B[K]:B[B.length-1];try{if(J>0){const re=A(J);this._onDidStateChange.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J,re)),this._options.logService.info(`${W} waiting for ${J} seconds before reconnecting...`);try{await re}catch(x){}}if(V._permanentFailure){this._options.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K+1)),this._options.logService.info(`${W} resolving connection...`);const ee=await u(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${W} connecting to ${ee.host}:${ee.port}...`),await this._reconnect(ee,d(g)),this._options.logService.info(`${W} reconnected!`),this._onDidStateChange.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K+1));break}catch(ee){if(ee.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(ee),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),K+1,!1);break}if(Date.now()-H>108e5){this._options.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(ee),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),K+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(ee)){this._options.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((ee.code==="ETIMEDOUT"||ee.code==="ENETUNREACH"||ee.code==="ECONNREFUSED"||ee.code==="ECONNRESET")&&ee.syscall==="connect"){this._options.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((0,y.isPromiseCanceledError)(ee)){this._options.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if(ee instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(ee),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),K+1,n.RemoteAuthorityResolverError.isHandled(ee));break}this._options.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(ee),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),K+1,!1);break}}while(!V._permanentFailure)}}_gotoPermanentFailure(W,B,H){this._onDidStateChange.fire(new oe(this.reconnectionToken,W,B,H)),O(this.protocol)}}V._permanentFailure=!1,V._permanentFailureMillisSinceLastIncomingData=0,V._permanentFailureAttempt=0,V._permanentFailureHandled=!1,V._instances=[];class Y extends V{constructor(W,B,H,K,J){super(1,W,K,J);this.client=this._register(new v.Client(J,{remoteAuthority:B,clientId:H},W.ipcLogger))}async _reconnect(W,B){await t(W,B)}}e.ManagementPersistentConnection=Y;class U extends V{constructor(W,B,H,K,J){super(2,W,H,K);this._startArguments=B,this.debugPort=J}async _reconnect(W,B){await r(W,this._startArguments,B)}}e.ExtensionHostPersistentConnection=U;function O(T){try{T.acceptDisconnect();const W=T.getSocket();T.dispose(),W.dispose()}catch(W){(0,y.onUnexpectedError)(W)}}function z(T){if(T&&T.type==="error"){const W=new Error(`Connection error: ${T.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function C(T,W){for(;T.length<W;)T+=" ";return T}function I(T,W,B){return`[remote-connection][${C(p(T),13)}][${W.substr(0,5)}\u2026][${B?"reconnect":"initial"}]`}function M(T,W){return`${I(W,T.reconnectionToken,!!T.reconnectionProtocol)}[${T.host}:${T.port}]`}function _(T){return`${Date.now()-T} ms`}}),define(X[72],Q([0,1,9]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function R(S){return S.scheme===v.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=R;function D(S){if(!!S){const k=S.indexOf("+");return k<0?S:S.substr(0,k)}}e.getRemoteName=D}),define(X[56],Q([0,1,5,3,4,6]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService");var k;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore"})(k=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function n(E){if(!(E.scheme!=="http"&&E.scheme!=="https")){const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!p)return{address:p[1],port:+p[2]}}}e.extractLocalHostUriMetaDataForPortMapping=n,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=y,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=i;function L(E,p){return p?p!==1&&E<1024:!R.isWindows&&E<1024}e.isPortPrivileged=L;let g=class{constructor(p){this.logService=p,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}setTunnelProvider(p,d){return this._tunnelProvider=p,p?(this._canElevate=d.elevation,this._canMakePublic=d.public,{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async p=>{const d=[],m=Array.from(this._tunnels.values());for(let b of m){const w=Array.from(b.values());for(let l of w){const c=await l.value;c&&d.push(c)}}p(d)})}async dispose(){for(const p of this._tunnels.values()){for(const{value:d}of p.values())await d.then(m=>m==null?void 0:m.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,d,m,b,w=!1,l=!1){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${m} on local port ${b}.`),!!p){d||(d="localhost");const c=this.retainOrCreateTunnel(p,d,m,b,w,l);return c?c.then(o=>{if(!o){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(o);return(o.tunnelRemoteHost!==d||o.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,public:p.public,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemotePort} `);const d=this._tunnels.get(p.tunnelRemoteHost);if(d){const m=d.get(p.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,m))}}}}async tryDisposeTunnel(p,d,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${d}.`);const b=m.value.then(async w=>{w&&(await w.dispose(!0),this._onTunnelClosed.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(d),b}}async closeTunnel(p,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d} `);const m=this._tunnels.get(p);if(m&&m.has(d)){const b=m.get(d);b.refcount=0,await this.tryDisposeTunnel(p,d,b)}}addTunnelToMap(p,d,m){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(d,{refcount:1,value:m})}async removeEmptyTunnelFromMap(p,d){const m=this._tunnels.get(p);m&&(await m.get(d)||m.delete(d),m.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,d){let m=[p];y(p)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):i(p)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const b=m.map(w=>this._tunnels.get(w));for(const w of b){const l=w==null?void 0:w.get(d);if(l)return l}}canTunnel(p){return!!n(p)}createWithProvider(p,d,m,b,w,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${m} on local port ${b}.`);const o={elevationRequired:w?L(b===void 0?m:b):!1},s={remoteAddress:{host:d,port:m},localAddressPort:b,public:l},t=p.forwardPort(s,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(d,m,t),t}};g=ce([Z(0,S.ILogService)],g),e.AbstractTunnelService=g}),define(X[40],Q([0,1,142,4,48,37,20]),function($,e,v,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function n(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=n;function y(g){return g.res.statusCode===204}async function i(g){if(!n(g))throw new Error("Server returned "+g.res.statusCode);return y(g)?null:(await(0,k.streamToBuffer)(g.stream)).toString()}e.asText=i;async function L(g){if(!n(g))throw new Error("Server returned "+g.res.statusCode);if(y(g))return null;const p=(await(0,k.streamToBuffer)(g.stream)).toString();try{return JSON.parse(p)}catch(d){throw d.message+=`:
`+p,d}}e.asJson=L,S.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:(0,v.localize)(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,v.localize)(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,v.localize)(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,v.localize)(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[(0,v.localize)(4,null),(0,v.localize)(5,null),(0,v.localize)(6,null)],default:"override",description:(0,v.localize)(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:(0,v.localize)(8,null)}}})}),define(X[185],Q([0,1,186,13]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(k,n){return k.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:k.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function S(k,n,y={}){const i=(0,v.parse)(k),L=y.proxyUrl||D(i,n);if(!L)return null;const g=(0,v.parse)(L);if(!/^https?:$/.test(g.protocol||""))return null;const E={host:g.hostname||"",port:g.port||(g.protocol==="https"?"443":"80"),auth:g.auth,rejectUnauthorized:(0,R.isBoolean)(y.strictSSL)?y.strictSSL:!0};return i.protocol==="http:"?new(await new Promise((p,d)=>{$(["http-proxy-agent"],p,d)}))(E):new(await new Promise((p,d)=>{$(["https-proxy-agent"],p,d)}))(E)}e.getProxyAgent=S}),define(X[187],Q([0,1,28,20]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(S,k,n){let y=n&&n.get("storage.serviceMachineId",0)||null;if(y)return y;try{const L=(await k.readFile(S.serviceMachineIdResource)).value.toString();y=(0,v.isUUID)(L)?L:null}catch(i){y=null}if(!y){y=(0,v.generateUuid)();try{await k.writeFile(S.serviceMachineIdResource,R.VSBuffer.fromString(y))}catch(i){}}return n&&n.store("storage.serviceMachineId",y,0,1),y}e.getServiceMachineId=D}),define(X[73],Q([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(X[188],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{vsda(){return new Promise((D,S)=>$(["vsda"],D,S))}async sign(D){try{const S=await this.vsda(),k=new S.signer;if(k)return k.sign(D)}catch(S){}return D}}e.SignService=v}),define(X[38],Q([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,v.createDecorator)("stateService")}),define(X[17],Q([0,1,11,6,38,5,4,170,3,2,10,13,35]),function($,e,v,R,D,S,k,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,k.createDecorator)("lifecycleMainService");var p;(function(b){b[b.CLOSE=1]="CLOSE",b[b.QUIT=2]="QUIT",b[b.RELOAD=3]="RELOAD",b[b.LOAD=4]="LOAD"})(p=e.UnloadReason||(e.UnloadReason={}));var d;(function(b){b[b.Starting=1]="Starting",b[b.Ready=2]="Ready",b[b.AfterWindowOpen=3]="AfterWindowOpen"})(d=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let m=class tt extends i.Disposable{constructor(w,l){super();this.logService=w,this.stateService=l,this._onBeforeShutdown=this._register(new S.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new S.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new S.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new S.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new S.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=null,this.pendingQuitPromiseResolve=null,this.pendingWillShutdownPromise=null,this.phaseWhen=new Map,this.handleRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}handleRestarted(){this._wasRestarted=!!this.stateService.getItem(tt.QUIT_FROM_RESTART_MARKER),this._wasRestarted&&this.stateService.removeItem(tt.QUIT_FROM_RESTART_MARKER)}registerListeners(){const w=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),y.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};v.app.addListener("before-quit",w);const l=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!y.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",l),v.app.once("will-quit",c=>{this.logService.trace("Lifecycle#app.on(will-quit)"),c.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",w),v.app.removeListener("window-all-closed",l),v.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const w=[];return this._onWillShutdown.fire({join(l){w.push(l)}}),this.pendingWillShutdownPromise=L.Promises.settled(w).then(()=>{},l=>this.logService.error(l)),this.pendingWillShutdownPromise}set phase(w){if(w<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase!==w){this.logService.trace(`lifecycle (main): phase changed (value: ${w})`),this._phase=w;const l=this.phaseWhen.get(this._phase);l&&(l.open(),this.phaseWhen.delete(this._phase))}}async when(w){if(!(w<=this._phase)){let l=this.phaseWhen.get(w);l||(l=new L.Barrier,this.phaseWhen.set(w,l)),await l.wait()}}registerWindow(w){const l=new i.DisposableStore;this.windowCounter++,l.add(w.onWillLoad(o=>this._onWillLoadWindow.fire({window:w,workspace:o.workspace})));const c=(0,g.assertIsDefined)(w.win);c.on("close",o=>{const s=w.id;if(this.windowToCloseRequest.has(s)){this.windowToCloseRequest.delete(s);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${w.id}`),o.preventDefault(),this.unload(w,1).then(t=>{if(t){this.windowToCloseRequest.delete(s);return}this.windowToCloseRequest.add(s),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${s}`),this._onBeforeCloseWindow.fire(w),w.close()})}),c.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${w.id}`),this.windowCounter--,l.dispose(),this.windowCounter===0&&(!y.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(w,l){await this.unload(w,3)||w.reload(l)}async unload(w,l){if(!w.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${w.id}`);const c=this._quitRequested?2:l;let o=await this.onBeforeUnloadWindowInRenderer(w,c);return o?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${w.id})`),this.handleWindowUnloadVeto(o)):(o=await this.onBeforeUnloadWindowInMain(w,c),o?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${w.id})`),this.handleWindowUnloadVeto(o)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${w.id})`),await this.onWillUnloadWindowInRenderer(w,c),!1))}handleWindowUnloadVeto(w){return w?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(w){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(w),this.pendingQuitPromiseResolve=null,this.pendingQuitPromise=null)}onBeforeUnloadWindowInRenderer(w,l){return new Promise(c=>{const o=this.oneTimeListenerTokenGenerator++,s=`vscode:ok${o}`,t=`vscode:cancel${o}`;v.ipcMain.once(s,()=>{c(!1)}),v.ipcMain.once(t,()=>{c(!0)}),w.send("vscode:onBeforeUnload",{okChannel:s,cancelChannel:t,reason:l})})}onBeforeUnloadWindowInMain(w,l){const c=[];return this._onBeforeUnloadWindow.fire({reason:l,window:w,veto(o){c.push(o)}}),(0,n.handleVetos)(c,o=>this.logService.error(o))}onWillUnloadWindowInRenderer(w,l){return new Promise(c=>{const s=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(s,()=>c()),w.send("vscode:onWillUnload",{replyChannel:s,reason:l})})}quit(w){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - from update: ${w}`),w&&this.stateService.setItem(tt.QUIT_FROM_RESTART_MARKER,!0),this.pendingQuitPromise=new Promise(l=>{this.pendingQuitPromiseResolve=l,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}relaunch(w){this.logService.trace("Lifecycle#relaunch()");const l=process.argv.slice(1);if((w==null?void 0:w.addArgs)&&l.push(...w.addArgs),w==null?void 0:w.removeArgs)for(const o of w.removeArgs){const s=l.indexOf(o);s>=0&&l.splice(s,1)}let c=!1;v.app.once("quit",()=>{if(!c){this.stateService.setItem(tt.QUIT_FROM_RESTART_MARKER,!0);try{if(y.isWindows){const o=(0,E.cwd)();o!==process.cwd()&&process.chdir(o)}}catch(o){this.logService.error(o)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:l})}}),this.quit().then(o=>c=o)}async kill(w){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const l of v.BrowserWindow.getAllWindows())if(l&&!l.isDestroyed()){let c;l.webContents&&!l.webContents.isDestroyed()?c=new Promise(o=>l.once("closed",o)):c=Promise.resolve(),l.destroy(),await c}})()]),v.app.exit(w)}};m.QUIT_FROM_RESTART_MARKER="quit.from.restart",m=ce([Z(0,R.ILogService),Z(1,D.IStateService)],m),e.LifecycleMainService=m}),define(X[189],Q([0,1,4,5,2,17]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,v.createDecorator)("keyboardLayoutMainService");let k=class extends D.Disposable{constructor(i){super();this._onDidChangeKeyboardLayout=this._register(new R.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,i.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const i=await new Promise((L,g)=>{$(["native-keymap"],L,g)});this._keyboardLayoutData=n(i),i.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(i),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};k=ce([Z(0,S.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function n(y){const i=y.getKeyMap(),L=y.getCurrentKeyboardLayout();return{keyboardMapping:i,keyboardLayoutInfo:L}}}),define(X[190],Q([0,1,8,21,47,22,13,6]),function($,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class y{constructor(g,E){this.dbPath=g,this.onError=E,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const g=await this.loadAsync();this._database||(this._database=g)}}loadSync(){try{return this.lastFlushedSerializedDatabase=R.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(g){return g.code!=="ENOENT"&&this.onError(g),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await R.promises.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(g){return g.code!=="ENOENT"&&this.onError(g),{}}}getItem(g,E){const p=this.database[g];return(0,k.isUndefinedOrNull)(p)?E:p}setItem(g,E){if((0,k.isUndefinedOrNull)(E))return this.removeItem(g);(typeof E=="string"||typeof E=="number"||typeof E=="boolean")&&this.database[g]===E||(this.database[g]=E,this.saveSync())}removeItem(g){(0,k.isUndefined)(this.database[g])||(this.database[g]=void 0,this.saveSync())}saveSync(){const g=JSON.stringify(this.database,null,4);if(g!==this.lastFlushedSerializedDatabase)try{(0,S.writeFileSync)(this.dbPath,g),this.lastFlushedSerializedDatabase=g}catch(E){this.onError(E)}}}e.FileStorage=y;let i=class vt{constructor(g,E){this.fileStorage=new y(v.join(g.userDataPath,vt.STATE_FILE),p=>E.error(p))}init(){return this.fileStorage.init()}getItem(g,E){return this.fileStorage.getItem(g,E)}setItem(g,E){this.fileStorage.setItem(g,E)}removeItem(g){this.fileStorage.removeItem(g)}};i.STATE_FILE="storage.json",i=ce([Z(0,D.INativeEnvironmentService),Z(1,n.ILogService)],i),e.StateService=i}),define(X[94],Q([0,1,4,5,2,13,85,10]),function($,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const y="__$__targetStorageMarker";e.IStorageService=(0,v.createDecorator)("storageService");var i;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(i=e.WillSaveStateReason||(e.WillSaveStateReason={}));var L;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(L=e.StorageScope||(e.StorageScope={}));var g;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class E extends D.Disposable{constructor(b={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new n.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,n.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,w){w===y?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:w,target:this.getKeyTargets(b)[w]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,w,l){var c;return(c=this.getStorage(w))===null||c===void 0?void 0:c.get(b,l)}getBoolean(b,w,l){var c;return(c=this.getStorage(w))===null||c===void 0?void 0:c.getBoolean(b,l)}getNumber(b,w,l){var c;return(c=this.getStorage(w))===null||c===void 0?void 0:c.getNumber(b,l)}store(b,w,l,c){if((0,S.isUndefinedOrNull)(w)){this.remove(b,l);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(b,l,c),(o=this.getStorage(l))===null||o===void 0||o.set(b,w)})}remove(b,w){this.withPausedEmitters(()=>{var l;this.updateKeyTarget(b,w,void 0),(l=this.getStorage(w))===null||l===void 0||l.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,w){const l=[],c=this.getKeyTargets(b);for(const o of Object.keys(c))c[o]===w&&l.push(o);return l}updateKeyTarget(b,w,l){var c,o;const s=this.getKeyTargets(w);typeof l=="number"?s[b]!==l&&(s[b]=l,(c=this.getStorage(w))===null||c===void 0||c.set(y,JSON.stringify(s))):typeof s[b]=="number"&&(delete s[b],(o=this.getStorage(w))===null||o===void 0||o.set(y,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const w=this.get(y,b);if(w)try{return JSON.parse(w)}catch(l){}return Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(){var b,w,l,c;this._onWillSaveState.fire({reason:i.NONE}),await n.Promises.settled([(w=(b=this.getStorage(0))===null||b===void 0?void 0:b.whenFlushed())!==null&&w!==void 0?w:Promise.resolve(),(c=(l=this.getStorage(1))===null||l===void 0?void 0:l.whenFlushed())!==null&&c!==void 0?c:Promise.resolve()])}async logStorage(){var b,w,l,c,o,s;const t=(w=(b=this.getStorage(0))===null||b===void 0?void 0:b.items)!==null&&w!==void 0?w:new Map,r=(c=(l=this.getStorage(1))===null||l===void 0?void 0:l.items)!==null&&c!==void 0?c:new Map;return d(t,r,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(s=this.getLogDetails(1))!==null&&s!==void 0?s:"")}}e.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class p extends E{constructor(){super();this.globalStorage=new k.Storage(new k.InMemoryStorageDatabase),this.workspaceStorage=new k.Storage(new k.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}e.InMemoryStorageService=p;async function d(m,b,w,l){const c=h=>{try{return JSON.parse(h)}catch(f){return h}},o=new Map,s=new Map;m.forEach((h,f)=>{o.set(f,h),s.set(f,c(h))});const t=new Map,r=new Map;b.forEach((h,f)=>{t.set(f,h),r.set(f,c(h))}),console.group(`Storage: Global (path: ${w})`);let a=[];o.forEach((h,f)=>{a.push({key:f,value:h})}),console.table(a),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${l})`);let u=[];t.forEach((h,f)=>{u.push({key:f,value:h})}),console.table(u),console.groupEnd(),console.log(r)}e.logStorage=d}),define(X[191],Q([0,1,3,35,28,7]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;async function k(y,i,L,g,E,p,d,m,b){const w=Object.create(null);w["common.machineId"]=p,w.sessionID=(0,D.generateUuid)()+Date.now(),w.commitHash=g,w.version=E,w["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,v.PlatformToString)(v.platform),w["common.nodePlatform"]=R.platform,w["common.nodeArch"]=L,w["common.product"]=b||"desktop";const l=n(d||[]);l&&(w["common.msftInternal"]=l);let c=0;const o=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),v.isLinuxSnap&&(w["common.snap"]="true");try{const s=await y.readFile(S.URI.file(m));w["common.source"]=s.value.toString().slice(0,30)}catch(s){}return w}e.resolveCommonProperties=k;function n(y){const i=R.env.USERDNSDOMAIN;if(!i)return!1;const L=i.toLowerCase();return y.some(g=>L===g)}}),define(X[31],Q([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(X[192],Q([0,1,27,66,69,21,8,44,82,23,3,7,31,64,9,16,22]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function w(t,r){const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],u=new Map,h=new Map,f=2e4;function P(N,j,G,ne){const oe=j.substring(N.length+1);return new Promise(async V=>{var Y,U,O;let z;try{z=await(0,b.readdir)(j,{withFileTypes:!0})}catch(M){V();return}if(ne.count>=f){ne.count+=z.length,ne.maxReached=!0,V();return}let C=z.length;if(C===0){V();return}let I=z;ne.count+z.length>f&&(ne.maxReached=!0,C=f-ne.count,I=z.slice(0,C)),ne.count+=z.length;for(const M of I)if(M.isDirectory()){if(G.includes(M.name)||await P(N,(0,k.join)(j,M.name),G,ne),--C==0){V();return}}else{const _=M.name.lastIndexOf(".");if(_>=0){const T=M.name.substring(_+1);T&&u.set(T,((Y=u.get(T))!==null&&Y!==void 0?Y:0)+1)}for(const T of a)((U=T.relativePathPattern)===null||U===void 0?void 0:U.test(oe))!==!1&&T.filePattern.test(M.name)&&h.set(T.tag,((O=h.get(T.tag))!==null&&O!==void 0?O:0)+1);if(--C==0){V();return}}})}const A={count:0,maxReached:!1};await P(t,t,r,A);const F=await o(t);return{configFiles:l(h),fileTypes:l(u),fileCount:A.count,maxFilesReached:A.maxReached,launchConfigFiles:F}}e.collectWorkspaceStats=w;function l(t){return[...p.Iterable.map(t.entries(),([r,a])=>({name:r,count:a}))].sort((r,a)=>a.count-r.count)}function c(){const t={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(R.virtualMachineHint.value()*100)}%`},r=v.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}e.getMachineInfo=c;function o(t){let r=new Map,a=(0,k.join)(t,".vscode","launch.json");return new Promise((u,h)=>{(0,S.exists)(a,f=>{if(f)(0,S.readFile)(a,(P,A)=>{if(P)return u([]);const F=[],N=(0,n.parse)(A.toString(),F);if(F.length)return console.log(`Unable to parse ${a}`),u([]);if((0,n.getNodeType)(N)==="object"&&N.configurations)for(const j of N.configurations){const G=j.type;G&&(r.has(G)?r.set(G,r.get(G)+1):r.set(G,1))}return u(l(r))});else return u([])})})}e.collectLaunchConfigs=o;let s=class{constructor(r,a){this.telemetryService=r,this.productService=a}formatMachineInfo(r){const a=[];return a.push(`OS Version:       ${r.os}`),a.push(`CPUs:             ${r.cpus}`),a.push(`Memory (System):  ${r.memory}`),a.push(`VM:               ${r.vmHint}`),a.join(`
`)}formatEnvironment(r){const a=[];a.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),a.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const u=v.cpus();return u&&u.length>0&&a.push(`CPUs:             ${u[0].model} (${u.length} x ${u[0].speed})`),a.push(`Memory (System):  ${(v.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`),L.isWindows||a.push(`Load (avg):       ${v.loadavg().map(h=>Math.round(h)).join(", ")}`),a.push(`VM:               ${Math.round(R.virtualMachineHint.value()*100)}%`),a.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${r.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(r,a){return Promise.all([(0,y.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async u=>{let[h,f]=u,P=this.formatProcessList(r,h);return a.forEach(A=>{if((0,D.isRemoteDiagnosticError)(A))P+=`
${A.errorMessage}`,f+=`
${A.errorMessage}`;else if(P+=`

Remote: ${A.hostName}`,A.processes&&(P+=`
${this.formatProcessList(r,A.processes)}`),A.workspaceMetadata){f+=`
|  Remote: ${A.hostName}`;for(const F of Object.keys(A.workspaceMetadata)){const N=A.workspaceMetadata[F];let j=`${N.fileCount} files`;N.maxFilesReached&&(j=`more than ${j}`),f+=`|    Folder (${F}): ${j}`,f+=this.formatWorkspaceStats(N)}}}),{processInfo:P,workspaceInfo:f}})}async getSystemInfo(r,a){const{memory:u,vmHint:h,os:f,cpus:P}=c(),A={os:f,memory:u,cpus:P,vmHint:h,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:a};return L.isWindows||(A.load=`${v.loadavg().map(F=>Math.round(F)).join(", ")}`),L.isLinux&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(r,a){const u=[];return(0,y.listProcesses)(r.mainPID).then(async h=>(u.push(""),u.push(this.formatEnvironment(r)),u.push(""),u.push(this.formatProcessList(r,h)),r.windows.some(f=>f.folderURIs&&f.folderURIs.length>0&&!f.remoteAuthority)&&(u.push(""),u.push("Workspace Stats: "),u.push(await this.formatWorkspaceMetadata(r))),a.forEach(f=>{if((0,D.isRemoteDiagnosticError)(f))u.push(`
${f.errorMessage}`);else if(u.push(`

`),u.push(`Remote:           ${f.hostName}`),u.push(this.formatMachineInfo(f.machineInfo)),f.processes&&u.push(this.formatProcessList(r,f.processes)),f.workspaceMetadata)for(const P of Object.keys(f.workspaceMetadata)){const A=f.workspaceMetadata[P];let F=`${A.fileCount} files`;A.maxFilesReached&&(F=`more than ${F}`),u.push(`Folder (${P}): ${F}`),u.push(this.formatWorkspaceStats(A))}}),u.push(""),u.push(""),u.join(`
`)))}formatWorkspaceStats(r){const a=[],u=60;let h=0;const f=(N,j)=>{const G=` ${N}(${j})`;h+G.length>u?(a.push(P),P="|                 ",h=P.length):h+=G.length,P+=G};let P="|      File types:";const A=10;let F=r.fileTypes.length>A?A:r.fileTypes.length;for(let N=0;N<F;N++){const j=r.fileTypes[N];f(j.name,j.count)}if(a.push(P),r.configFiles.length>=0&&(P="|      Conf files:",h=0,r.configFiles.forEach(N=>{f(N.name,N.count)}),a.push(P)),r.launchConfigFiles.length>0){let N="|      Launch Configs:";r.launchConfigFiles.forEach(j=>{N+=j.count>1?` ${j.name}(${j.count})`:` ${j.name}`}),a.push(N)}return a.join(`
`)}expandGPUFeatures(r){const a=Math.max(...Object.keys(r).map(u=>u.length));return Object.keys(r).map(u=>`${u}:  ${" ".repeat(a-u.length)}  ${r[u]}`).join(`
                  `)}formatWorkspaceMetadata(r){const a=[],u=[];return r.windows.forEach(h=>{h.folderURIs.length===0||!!h.remoteAuthority||(a.push(`|  Window (${h.title})`),h.folderURIs.forEach(f=>{const P=g.URI.revive(f);if(P.scheme===d.Schemas.file){const A=P.fsPath;u.push(w(A,["node_modules",".git"]).then(F=>{let N=`${F.fileCount} files`;F.maxFilesReached&&(N=`more than ${N}`),a.push(`|    Folder (${(0,k.basename)(A)}): ${N}`),a.push(this.formatWorkspaceStats(F))}).catch(F=>{a.push(`|      Error: Unable to collect workspace stats for folder ${A} (${F.toString()})`)}))}else a.push(`|    Folder (${P.toString()}): Workspace stats not available.`)}))}),Promise.all(u).then(h=>a.join(`
`)).catch(h=>`Unable to collect workspace stats: ${h}`)}formatProcessList(r,a){const u=new Map;r.windows.forEach(f=>u.set(f.pid,f.title));const h=[];return h.push("CPU %	Mem MB	   PID	Process"),a&&this.formatProcessItem(r.mainPID,u,h,a,0),h.join(`
`)}formatProcessItem(r,a,u,h,f){const P=f===0;let A;P?A=h.pid===r?`${this.productService.applicationName} main`:"remote agent":(A=`${"  ".repeat(f)} ${h.name}`,h.name==="window"&&(A=`${A} (${a.get(h.pid)})`));const F=process.platform==="win32"?h.mem:v.totalmem()*(h.mem/100);u.push(`${h.load.toFixed(0).padStart(5," ")}	${(F/m.ByteSize.MB).toFixed(0).padStart(6," ")}	${h.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(h.children)&&h.children.forEach(N=>this.formatProcessItem(r,a,u,N,f+1))}async reportWorkspaceStats(r){for(const{uri:a}of r.folders){const u=g.URI.revive(a);if(u.scheme===d.Schemas.file){const h=u.fsPath;try{const f=await w(h,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),f.fileTypes.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:P.name,count:P.count})}),f.launchConfigFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:P.name,count:P.count})}),f.configFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:P.name,count:P.count})})}catch(f){}}}}};s=ce([Z(0,E.ITelemetryService),Z(1,i.IProductService)],s),e.DiagnosticsService=s}),define(X[193],Q([0,1,18,162,165,45,31,40,156,47,25,6,16,7,23,94,187,4,15]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d,m,b,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var c;(function(I){I[I.None=0]="None",I[I.IncludeVersions=1]="IncludeVersions",I[I.IncludeFiles=2]="IncludeFiles",I[I.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",I[I.IncludeSharedAccounts=8]="IncludeSharedAccounts",I[I.IncludeVersionProperties=16]="IncludeVersionProperties",I[I.ExcludeNonValidated=32]="ExcludeNonValidated",I[I.IncludeInstallationTargets=64]="IncludeInstallationTargets",I[I.IncludeAssetUri=128]="IncludeAssetUri",I[I.IncludeStatistics=256]="IncludeStatistics",I[I.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",I[I.Unpublished=4096]="Unpublished"})(c||(c={}));function o(...I){return String(I.reduce((M,_)=>M|_,0))}var s;(function(I){I[I.Tag=1]="Tag",I[I.ExtensionId=4]="ExtensionId",I[I.Category=5]="Category",I[I.ExtensionName=7]="ExtensionName",I[I.Target=8]="Target",I[I.Featured=9]="Featured",I[I.SearchText=10]="SearchText",I[I.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},u={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:c.None,criteria:[],assetTypes:[]};class h{constructor(M=u){this.state=M}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(M,_=this.state.pageSize){return new h(Object.assign(Object.assign({},this.state),{pageNumber:M,pageSize:_}))}withFilter(M,..._){const T=[...this.state.criteria,..._.length?_.map(W=>({filterType:M,value:W})):[{filterType:M}]];return new h(Object.assign(Object.assign({},this.state),{criteria:T}))}withSortBy(M){return new h(Object.assign(Object.assign({},this.state),{sortBy:M}))}withSortOrder(M){return new h(Object.assign(Object.assign({},this.state),{sortOrder:M}))}withFlags(...M){return new h(Object.assign(Object.assign({},this.state),{flags:M.reduce((_,T)=>_|T,0)}))}withAssetTypes(...M){return new h(Object.assign(Object.assign({},this.state),{assetTypes:M}))}get raw(){const{criteria:M,pageNumber:_,pageSize:T,sortBy:W,sortOrder:B,flags:H,assetTypes:K}=this.state;return{filters:[{criteria:M,pageNumber:_,pageSize:T,sortBy:W,sortOrder:B}],assetTypes:K,flags:H}}get searchText(){const M=this.state.criteria.filter(_=>_.filterType===s.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(M=>String(M.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function f(I,M){const _=(I||[]).filter(T=>T.statisticName===M)[0];return _?_.value:0}function P(I){const M="Microsoft.VisualStudio.Code.Translation.";return I.files.filter(T=>T.assetType.indexOf(M)===0).reduce((T,W)=>{const B=j(I,W.assetType);return B&&T.push([W.assetType.substring(M.length),B]),T},[])}function A(I){if(I.properties){const M=I.properties.filter(W=>W.key===t.Repository),_=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),T=M.filter(W=>_.test(W.value))[0];return T?{uri:T.value,fallbackUri:T.value}:null}return j(I,t.Repository)}function F(I){return{uri:`${I.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${I.fallbackAssetUri}/${t.VSIX}`}}function N(I){const M=j(I,t.Icon);if(M)return M;const _=R.DefaultIconPath;return{uri:_,fallbackUri:_}}function j(I,M){return I.files.filter(T=>T.assetType===M)[0]?{uri:`${I.assetUri}/${M}`,fallbackUri:`${I.fallbackAssetUri}/${M}`}:null}function G(I,M){const _=I.properties?I.properties.filter(W=>W.key===M):[],T=_.length>0&&_[0].value;return T?T.split(",").map(W=>(0,D.adoptToGalleryExtensionId)(W)):[]}function ne(I){const M=I.properties?I.properties.filter(_=>_.key===r.Engine):[];return M.length>0&&M[0].value||""}function oe(I){const M=I.properties?I.properties.filter(T=>T.key===r.LocalizedLanguages):[],_=M.length>0&&M[0].value||"";return _?_.split(","):[]}function V(I){return I.indexOf("preview")!==-1}function Y(I){const M=I.properties?I.properties.find(_=>_.key===r.WebExtension):void 0;return!!M&&M.value==="true"}function U(I){return I.files.some(M=>M.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,l.joinPath)(p.URI.parse(I.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function O(I,M,_,T,W){const B={manifest:j(M,t.Manifest),readme:j(M,t.Details),changelog:j(M,t.Changelog),license:j(M,t.License),repository:A(M),download:F(M),icon:N(M),coreTranslations:P(M)};return{identifier:{id:(0,D.getGalleryExtensionId)(I.publisher.publisherName,I.extensionName),uuid:I.extensionId},name:I.extensionName,version:M.version,date:M.lastUpdated,displayName:I.displayName,publisherId:I.publisher.publisherId,publisher:I.publisher.publisherName,publisherDisplayName:I.publisher.displayName,description:I.shortDescription||"",installCount:f(I.statistics,"install"),rating:f(I.statistics,"averagerating"),ratingCount:f(I.statistics,"ratingcount"),assetUri:p.URI.parse(M.assetUri),webResource:U(M),assetTypes:M.files.map(({assetType:H})=>H),assets:B,properties:{dependencies:G(M,r.Dependency),extensionPack:G(M,r.ExtensionPack),engine:ne(M),localizedLanguages:oe(M),webExtension:Y(M)},telemetryData:{index:(T.pageNumber-1)*T.pageSize+_,searchText:T.searchText,querySource:W},preview:V(I.flags)}}let z=class{constructor(M,_,T,W,B,H,K){this.requestService=M,this.logService=_,this.environmentService=T,this.telemetryService=W,this.fileService=B,this.productService=H;const J=H.extensionsGallery;this.extensionsGalleryUrl=J&&J.serviceUrl,this.extensionsControlUrl=J&&J.controlUrl,this.commonHeadersPromise=C(H.version,this.environmentService,this.fileService,K)}api(M=""){return`${this.extensionsGalleryUrl}${M}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(M,_){const T=[];let{total:W,firstPage:B,getPage:H}=await this.query({names:M,pageSize:M.length},_);T.push(...B);for(let K=1;T.length<W&&(B=await H(K,_),B.length);K++)T.push(...B);return T}async getCompatibleExtension(M,_){const T=await this.getCompatibleExtensionByEngine(M,_);return(T==null?void 0:T.properties.webExtension)?T.webResource?T:null:T}async getCompatibleExtensionByEngine(M,_){const T=(0,R.isIExtensionIdentifier)(M)?null:M;if(T&&T.properties.engine&&(0,y.isEngineValid)(T.properties.engine,this.productService.version))return T;const{id:W,uuid:B}=T?T.identifier:M;let H=new h().withFlags(c.IncludeAssetUri,c.IncludeStatistics,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");B?H=H.withFilter(s.ExtensionId,B):H=H.withFilter(s.ExtensionName,W);const{galleryExtensions:K}=await this.queryGallery(H,L.CancellationToken.None),[J]=K;if(!J||!J.versions.length)return null;if(_){const re=J.versions.filter(x=>x.version===_)[0];if(re){const x=O(J,re,0,H);if(x.properties.engine&&(0,y.isEngineValid)(x.properties.engine,this.productService.version))return x}return null}const ee=await this.getLastValidExtensionVersion(J,J.versions);return ee?O(J,ee,0,H):null}async query(M,_){const T=L.CancellationToken.isCancellationToken(M)?{}:M,W=L.CancellationToken.isCancellationToken(M)?M:_;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=T.text||"";const H=(0,S.getOrDefault)(T,ie=>ie.pageSize,50);let K=new h().withFlags(c.IncludeLatestVersionOnly,c.IncludeAssetUri,c.IncludeStatistics,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,H).withFilter(s.Target,"Microsoft.VisualStudio.Code");B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,ae,ue)=>(K=K.withFilter(s.Category,ue||ae),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,ae,ue)=>(K=K.withFilter(s.Tag,ue||ae),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(s.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),K=K.withFilter(s.SearchText,B)),K=K.withSortBy(0)):T.ids?K=K.withFilter(s.ExtensionId,...T.ids):T.names?K=K.withFilter(s.ExtensionName,...T.names):K=K.withSortBy(4),typeof T.sortBy=="number"&&(K=K.withSortBy(T.sortBy)),typeof T.sortOrder=="number"&&(K=K.withSortOrder(T.sortOrder));const{galleryExtensions:J,total:ee}=await this.queryGallery(K,W),re=J.map((ie,ae)=>O(ie,ie.versions[0],ae,K,T.source)),x=async(ie,ae)=>{if(ae.isCancellationRequested)throw(0,v.canceled)();const ue=K.withPage(ie+1),{galleryExtensions:pe}=await this.queryGallery(ue,ae);return pe.map((me,fe)=>O(me,me.versions[0],fe,ue,T.source))};return{firstPage:re,total:ee,pageSize:K.pageSize,getPage:x}}async queryGallery(M,_){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,c.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,o(c.Unpublished));const T=await this.commonHeadersPromise,W=JSON.stringify(M.raw),B=Object.assign(Object.assign({},T),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)}),H=new Date().getTime();let K,J,ee=0;try{if(K=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:W,headers:B},_),K.res.statusCode&&K.res.statusCode>=400&&K.res.statusCode<500)return{galleryExtensions:[],total:ee};const re=await(0,n.asJson)(K);if(re){const x=re.results[0],ie=x.extensions,ae=x.resultMetadata&&x.resultMetadata.filter(ue=>ue.metadataType==="ResultCount")[0];return ee=ae&&ae.metadataItems.filter(ue=>ue.name==="TotalCount")[0].count||0,{galleryExtensions:ie,total:ee}}return{galleryExtensions:[],total:ee}}catch(re){throw J=re,re}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},M.telemetryData),{requestBodySize:String(W.length),duration:new Date().getTime()-H,success:!!K&&(0,n.isSuccess)(K),responseBodySize:K==null?void 0:K.res.headers["Content-Length"],statusCode:K?String(K.res.statusCode):void 0,errorCode:J?(0,v.isPromiseCanceledError)(J)?"canceled":(0,v.getErrorMessage)(J).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ee)}))}}async reportStatistic(M,_,T,W){if(!!this.isEnabled()){const B=await this.commonHeadersPromise,H=Object.assign(Object.assign({},B),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${M}/extensions/${_}/${T}/stats?statType=${W}`),headers:H},L.CancellationToken.None)}catch(K){}}}async download(M,_,T){this.logService.trace("ExtensionGalleryService#download",M.identifier.id);const W=(0,D.getGalleryExtensionTelemetryData)(M),B=new Date().getTime(),H=re=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},W),{duration:re})),K=T===1?"install":T===2?"update":"",J=K?{uri:`${M.assets.download.uri}&${K}=true`,fallbackUri:`${M.assets.download.fallbackUri}?${K}=true`}:M.assets.download,ee=await this.getAsset(J);await this.fileService.writeFile(_,ee.stream),H(new Date().getTime()-B)}async getReadme(M,_){if(M.assets.readme){const T=await this.getAsset(M.assets.readme,{},_);return await(0,n.asText)(T)||""}return""}async getManifest(M,_){if(M.assets.manifest){const T=await this.getAsset(M.assets.manifest,{},_),W=await(0,n.asText)(T);return W?JSON.parse(W):null}return null}async getCoreTranslation(M,_){const T=M.assets.coreTranslations.filter(W=>W[0]===_.toUpperCase())[0];if(T){const W=await this.getAsset(T[1]),B=await(0,n.asText)(W);return B?JSON.parse(B):null}return null}async getChangelog(M,_){if(M.assets.changelog){const T=await this.getAsset(M.assets.changelog,{},_);return await(0,n.asText)(T)||""}return""}async getAllVersions(M,_){let T=new h().withFlags(c.IncludeVersions,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");M.identifier.uuid?T=T.withFilter(s.ExtensionId,M.identifier.uuid):T=T.withFilter(s.ExtensionName,M.identifier.id);const W=[],{galleryExtensions:B}=await this.queryGallery(T,L.CancellationToken.None);return B.length&&(_?await Promise.all(B[0].versions.map(async H=>{let K;try{K=await this.getEngine(H)}catch(J){}K&&(0,y.isEngineValid)(K,this.productService.version)&&W.push({version:H.version,date:H.lastUpdated})})):W.push(...B[0].versions.map(H=>({version:H.version,date:H.lastUpdated})))),W}async getAsset(M,_={},T=L.CancellationToken.None){const W=await this.commonHeadersPromise,B={type:"GET"},H=Object.assign(Object.assign({},W),_.headers||{});_=Object.assign(Object.assign(Object.assign({},_),B),{headers:H});const K=M.uri,J=M.fallbackUri,ee=Object.assign(Object.assign({},_),{url:K});try{const re=await this.requestService.request(ee,T);if(re.res.statusCode===200)return re;const x=await(0,n.asText)(re);throw new Error(`Expected 200, got back ${re.res.statusCode} instead.

${x}`)}catch(re){if((0,v.isPromiseCanceledError)(re))throw re;const x=(0,v.getErrorMessage)(re);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:K,message:x});const ie=Object.assign(Object.assign({},_),{url:J});return this.requestService.request(ie,T)}}async getLastValidExtensionVersion(M,_){const T=this.getLastValidExtensionVersionFromProperties(M,_);return T||this.getLastValidExtensionVersionRecursively(M,_)}getLastValidExtensionVersionFromProperties(M,_){for(const T of _){const W=ne(T);if(!W)return null;if((0,y.isEngineValid)(W,this.productService.version))return T}return null}async getEngine(M){const _=ne(M);if(_)return _;const T=j(M,t.Manifest);if(!T)throw new Error("Manifest was not found");const W={"Accept-Encoding":"gzip"},B=await this.getAsset(T,{headers:W}),H=await(0,n.asJson)(B);if(H)return H.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(M,_){if(!_.length)return null;const T=_[0],W=await this.getEngine(T);return(0,y.isEngineValid)(W,this.productService.version)?(T.properties=T.properties||[],T.properties.push({key:r.Engine,value:W}),T):this.getLastValidExtensionVersionRecursively(M,_.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const M=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const _=await(0,n.asJson)(M),T=new Map;if(_)for(const W of _.malicious){const B=T.get(W)||{id:{id:W},malicious:!0,slow:!1};B.malicious=!0,T.set(W,B)}return[...T.values()]}};z=ce([Z(0,n.IRequestService),Z(1,g.ILogService),Z(2,i.IEnvironmentService),Z(3,k.ITelemetryService),Z(4,E.IFileService),Z(5,d.IProductService),Z(6,(0,w.optional)(m.IStorageService))],z),e.ExtensionGalleryService=z;async function C(I,M,_,T){const W={"X-Market-Client-Id":`VSCode ${I}`,"User-Agent":`VSCode ${I}`},B=await(0,b.getServiceMachineId)(M,_,T);return W["X-Market-User-Id"]=B,W}e.resolveMarketplaceHeaders=C}),define(X[194],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(S){this.appender=S}listen(S,k){throw new Error(`Event not found: ${k}`)}call(S,k,{eventName:n,data:y}){return this.appender.log(n,y),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class R{constructor(S){this.channel=S}log(S,k){return this.channel.call("log",{eventName:S,data:k}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=R}),define(X[195],Q([0,1,54,143,19,4,24,48,2,45,37]),function($,e,v,R,D,S,k,n,y,i,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{constructor(d,m){this._configurationService=m,this._experimentProperties={},this._disposables=new y.DisposableStore,this._cleanupPatterns=[],this._appender=d.appender,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let b of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(b),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(b=>{const w=/^[a-f0-9]+$/i.test(b["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!w})}))}setExperimentProperty(d,m){this._experimentProperties[d]=m}setEnabled(d){this._enabled=d}_updateUserOptIn(){var d;const m=(d=this._configurationService)===null||d===void 0?void 0:d.getValue(E);this._userOptIn=m?m.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const d=await this._commonProperties;let m=d.sessionID,b=d["common.instanceId"],w=d["common.machineId"],l=d["common.firstSessionDate"],c=d["common.msftInternal"];return{sessionId:m,instanceId:b,machineId:w,firstSessionDate:l,msftInternal:c}}dispose(){this._disposables.dispose()}publicLog(d,m,b){return this.isOptedIn?this._commonProperties.then(w=>{m=(0,i.mixin)(m,w),m=(0,i.mixin)(m,this._experimentProperties),m=(0,i.cloneAndChange)(m,l=>{if(typeof l=="string")return this._cleanupInfo(l,b)}),this._appender.log(d,m)},w=>{console.error(w)}):Promise.resolve(void 0)}publicLog2(d,m,b){return this.publicLog(d,m,b)}publicLogError(d,m){return this.sendErrorTelemetry?this.publicLog(d,m,!0):Promise.resolve(void 0)}publicLogError2(d,m){return this.publicLogError(d,m)}_cleanupInfo(d,m){let b=d;if(m){const w=[];for(let s of this._cleanupPatterns)for(;;){const t=s.exec(d);if(!t)break;w.push([t.index,s.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(b="";;){const s=c.exec(d);if(!s)break;!l.test(s[0])&&w.every(([t,r])=>s.index<t||s.index>=r)&&(b+=d.substring(o,s.index)+"<REDACTED: user-file-path>",o=c.lastIndex)}o<d.length&&(b+=d.substr(o))}for(let w of this._cleanupPatterns)b=b.replace(w,"");return b}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=ce([Z(1,(0,S.optional)(k.IConfigurationService))],g),e.TelemetryService=g;const E="telemetry";L.Registry.as(n.Extensions.Configuration).registerConfiguration({id:E,order:110,type:"object",title:(0,R.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,R.localize)(2,null,v.default.privacyStatementUrl):(0,R.localize)(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(X[95],Q([0,1,24,45,13,10]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(d,m){return Promise.resolve(void 0)}publicLog2(d,m){return this.publicLog(d,m)}publicLogError(d,m){return Promise.resolve(void 0)}publicLogError2(d,m){return this.publicLogError(d,m)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class k{async publicLog(m,b,w){}async publicLogError(m,b,w){}}e.NullEndpointTelemetryService=k;function n(...d){return{log:(m,b)=>d.forEach(w=>w.log(m,b)),flush:()=>S.Promises.settled(d.map(m=>m.flush()))}}e.combinedAppender=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(d,m){return m.onDidChangeConfiguration(b=>{b.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,v.ConfigurationTargetToString)(b.source),configurationKeys:E(b.sourceConfig)})})}e.configurationTelemetry=y;function i(d){const m=Object.create(null),b=Object.create(null),w=Object.create(null);g(d,w);for(let l in w){l=l.length>150?l.substr(l.length-149):l;const c=w[l];typeof c=="number"?b[l]=c:typeof c=="boolean"?b[l]=c?1:0:typeof c=="string"?m[l]=c.substring(0,1023):typeof c!="undefined"&&c!==null&&(m[l]=c)}return{properties:m,measurements:b}}e.validateTelemetryData=i;function L(d){if(!d)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(w=>{d.indexOf(`${w}+`)===0&&(m=w)}),m}e.cleanRemoteAuthority=L;function g(d,m,b=0,w){if(!!d)for(let l of Object.getOwnPropertyNames(d)){const c=d[l],o=w?w+l:l;Array.isArray(c)?m[o]=(0,R.safeStringify)(c):c instanceof Date?m[o]=c.toISOString():(0,D.isObject)(c)?b<2?g(c,m,b+1,o+"."):m[o]=(0,R.safeStringify)(c):m[o]=c}}function E(d){if(!d)return[];const m=[];return p(m,"",d),m}function p(d,m,b){b&&typeof b=="object"&&!Array.isArray(b)?Object.keys(b).forEach(w=>p(d,m?`${m}.${w}`:w,b[w])):d.push(m)}}),define(X[196],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(X[197],Q([0,1,4,2,37,5,196,105]),function($,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,v.createDecorator)("themeService");var y;(function(b){function w(l){return l&&typeof l=="object"&&typeof l.id=="string"}b.isThemeColor=w})(y=e.ThemeColor||(e.ThemeColor={}));function i(b){return{id:b}}e.themeColorFromId=i;var L;(function(b){function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}b.isThemeIcon=w;const l=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function c(t){const r=l.exec(t);if(!!r){let[,a]=r;return{id:a}}}b.fromString=c;function o(t,r){let a=t.id;const u=a.lastIndexOf("~");return u!==-1&&(a=a.substring(0,u)),r&&(a=`${a}~${r}`),{id:a}}b.modify=o;function s(t,r){var a,u;return t.id===r.id&&((a=t.color)===null||a===void 0?void 0:a.id)===((u=r.color)===null||u===void 0?void 0:u.id)}b.isEqual=s,b.asClassNameArray=n.CSSIcon.asClassNameArray,b.asClassName=n.CSSIcon.asClassName,b.asCSSSelector=n.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function g(b){switch(b){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=g,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new S.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,R.toDisposable)(()=>{const l=this.themingParticipants.indexOf(w);this.themingParticipants.splice(l,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new E;D.Registry.add(e.Extensions.ThemingContribution,p);function d(b){return p.onColorThemeChange(b)}e.registerThemingParticipant=d;class m extends R.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(l=>this.onThemeChange(l)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,l){let c=this.theme.getColor(w);return c&&l&&(c=l(c,this.theme)),c?c.toString():null}}e.Themable=m}),define(X[74],Q([0,1,3,11,38,4]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const k="#FFFFFF",n="#1E1E1E",y="#000000",i="theme",L="themeBackground";e.IThemeMainService=(0,S.createDecorator)("themeMainService");let g=class{constructor(p){this.stateService=p,R.ipcMain.on("vscode:changeColorTheme",(d,m,b)=>{typeof b=="string"&&this.storeBackgroundColor(JSON.parse(b))})}storeBackgroundColor(p){this.stateService.setItem(i,p.baseTheme),this.stateService.setItem(L,p.background)}getBackgroundColor(){if((v.isWindows||v.isMacintosh)&&R.nativeTheme.shouldUseInvertedColorScheme)return y;let p=this.stateService.getItem(L,null);if(!p){let d;(v.isWindows||v.isMacintosh)&&R.nativeTheme.shouldUseInvertedColorScheme?d="hc-black":d=this.stateService.getItem(i,"vs-dark").split(" ")[0],p=d==="hc-black"?y:d==="vs"?k:n}return v.isMacintosh&&p.toUpperCase()===n&&(p="#171717"),p}};g=ce([Z(0,D.IStateService)],g),e.ThemeMainService=g}),define(X[41],Q([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var R;(function(S){S.Uninitialized="uninitialized",S.Idle="idle",S.CheckingForUpdates="checking for updates",S.AvailableForDownload="available for download",S.Downloading="downloading",S.Downloaded="downloaded",S.Updating="updating",S.Ready="ready"})(R=e.StateType||(e.StateType={}));var D;(function(S){S[S.Setup=0]="Setup",S[S.Archive=1]="Archive",S[S.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(S,k)=>({type:"idle",updateType:S,error:k}),CheckingForUpdates:S=>({type:"checking for updates",context:S}),AvailableForDownload:S=>({type:"available for download",update:S}),Downloading:S=>({type:"downloading",update:S}),Downloaded:S=>({type:"downloaded",update:S}),Updating:S=>({type:"updating",update:S}),Ready:S=>({type:"ready",update:S})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(X[198],Q([0,1,37,48,144,3]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v.Registry.as(R.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,D.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,D.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,D.localize)(2,null),(0,D.localize)(3,null),(0,D.localize)(4,null),(0,D.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,D.localize)(6,null),deprecationMessage:(0,D.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,D.localize)(8,null),description:(0,D.localize)(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,D.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(X[199],Q([0,1,5,41]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(n){this.service=n}listen(n,y){switch(y){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${y}`)}call(n,y,i){switch(y){case"checkForUpdates":return this.service.checkForUpdates(i);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${y}`)}}e.UpdateChannel=D;class S{constructor(n){this.channel=n,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=R.State.Uninitialized,this.channel.listen("onStateChange")(y=>this.state=y),this.channel.call("_getInitialState").then(y=>this.state=y)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=S}),define(X[96],Q([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(X[200],Q([0,1,7]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class R{constructor(n){this.handler=n}listen(n,y){throw new Error(`Event not found: ${y}`)}call(n,y,i){switch(y){case"handleURL":return this.handler.handleURL(v.URI.revive(i[0]),i[1])}throw new Error(`Call not found: ${y}`)}}e.URLHandlerChannel=R;class D{constructor(n){this.channel=n}handleURL(n,y){return this.channel.call("handleURL",[n.toJSON(),y])}}e.URLHandlerChannelClient=D;class S{constructor(n){this.next=n}async routeCall(n,y,i,L){if(y!=="handleURL")throw new Error(`Call not found: ${y}`);if(i){const g=v.URI.revive(i);if(g&&g.query){const E=/\bwindowId=(\d+)/.exec(g.query);if(E){const p=E[1],d=new RegExp(`window:${p}`),m=n.connections.find(b=>d.test(b.ctx));if(m)return m}}}return this.next.routeCall(n,y,i,L)}routeEvent(n,y){throw new Error(`Event not found: ${y}`)}}e.URLHandlerRouter=S}),define(X[201],Q([0,1,7,10,2,23]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class k extends D.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(i,L){const g=[...this.handlers.values()];return(0,R.first)(g.map(E=>()=>E.handleURL(i,L)),void 0,!1).then(E=>E||!1)}registerHandler(i){return this.handlers.add(i),(0,D.toDisposable)(()=>this.handlers.delete(i))}}e.AbstractURLService=k;let n=class extends k{constructor(i){super();this.productService=i}create(i){let{authority:L,path:g,query:E,fragment:p}=i||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return L&&g&&g.indexOf("/")!==0&&(g=`/${g}`),v.URI.from({scheme:this.productService.urlProtocol,authority:L,path:g,query:E,fragment:p})}};n=ce([Z(0,S.IProductService)],n),e.NativeURLService=n}),define(X[202],Q([0,1,5,11,7,2,3,10]),function($,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function y(L){try{return D.URI.parse(L)}catch(g){return null}}class i{constructor(g,E,p,d,m){if(this.urlService=E,this.uris=[],this.retryCount=0,this.flushDisposable=S.Disposable.None,this.disposables=new S.DisposableStore,this.uris=g,k.isWindows){const l=d.isBuilt?[]:[`"${d.appRoot}"`];l.push("--open-url","--"),R.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,l)}const b=v.Event.map(v.Event.fromNodeEventEmitter(R.app,"open-url",(l,c)=>({event:l,url:c})),({event:l,url:c})=>(l.preventDefault(),c));this.disposables.add(b(l=>{const c=y(l);!c||this.urlService.open(c,{originalUrl:l})})),p.getWindows().filter(l=>l.isReady).length>0?this.flush():v.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(!(this.retryCount++>10)){const g=[];for(const E of this.uris)await this.urlService.open(E.uri,{originalUrl:E.url})||g.push(E);g.length!==0&&(this.uris=g,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=i}),define(X[203],Q([0,1,108,8]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWebviewContentMimeType=void 0;const D=new Map([[".svg","image/svg+xml"],[".txt","text/plain"],[".css","text/css"],[".js","application/javascript"],[".json","application/json"],[".html","text/html"],[".htm","text/html"],[".xhtml","application/xhtml+xml"],[".oft","font/otf"],[".xml","application/xml"]]);function S(k){const n=(0,R.extname)(k.fsPath).toLowerCase();return D.get(n)||(0,v.getMediaMime)(k.fsPath)||v.MIME_UNKNOWN}e.getWebviewContentMimeType=S}),define(X[75],Q([0,1,30,9,8,7,16,203]),function($,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.loadLocalResource=e.readFileStream=e.WebviewFileReadResponse=e.WebviewResourceResponse=e.webviewPartitionId=void 0,e.webviewPartitionId="webview";var y;(function(m){let b;(function(c){c[c.Success=0]="Success",c[c.Failed=1]="Failed",c[c.AccessDenied=2]="AccessDenied",c[c.NotModified=3]="NotModified"})(b=m.Type||(m.Type={}));class w{constructor(o,s,t){this.stream=o,this.etag=s,this.mimeType=t,this.type=b.Success}}m.StreamSuccess=w,m.Failed={type:b.Failed},m.AccessDenied={type:b.AccessDenied};class l{constructor(o){this.mimeType=o,this.type=b.NotModified}}m.NotModified=l})(y=e.WebviewResourceResponse||(e.WebviewResourceResponse={}));var i;(function(m){let b;(function(l){l[l.Success=0]="Success",l[l.NotModified=1]="NotModified"})(b=m.Type||(m.Type={}));class w{constructor(c,o){this.stream=c,this.etag=o,this.type=b.Success}}m.StreamSuccess=w,m.NotModified={type:b.NotModified}})(i=e.WebviewFileReadResponse||(e.WebviewFileReadResponse={}));async function L(m,b,w){try{const l=await m.readFileStream(b,{etag:w});return new i.StreamSuccess(l.value,l.etag)}catch(l){if(l instanceof k.FileOperationError&&l.fileOperationResult===2)return i.NotModified;throw l}}e.readFileStream=L;async function g(m,b,w,l,c,o,s){o.debug(`loadLocalResource - being. requestUri=${m}`);let t=E(m,w.roots);if(o.debug(`loadLocalResource - found resource to load. requestUri=${m}, resourceToLoad=${t}`),!t)return y.AccessDenied;const r=(0,n.getWebviewContentMimeType)(m);if(w.rewriteUri&&(t=w.rewriteUri(t)),t.scheme===R.Schemas.http||t.scheme===R.Schemas.https){const a={};b&&(a["If-None-Match"]=b);const u=await c.request({url:t.toString(!0),headers:a},s);switch(o.debug(`loadLocalResource - Loaded over http(s). requestUri=${m}, response=${u.res.statusCode}`),u.res.statusCode){case 200:return new y.StreamSuccess(u.stream,u.res.headers.etag,r);case 304:return new y.NotModified(r);default:return y.Failed}}try{const a=await l.readFileStream(t,b);switch(o.debug(`loadLocalResource - Loaded using fileReader. requestUri=${m}`),a.type){case i.Type.Success:return new y.StreamSuccess(a.stream,a.etag,r);case i.Type.NotModified:return new y.NotModified(r);default:return o.error("loadLocalResource - Unknown file read response"),y.Failed}}catch(a){return o.debug(`loadLocalResource - Error using fileReader. requestUri=${m}`),console.log(a),y.Failed}}e.loadLocalResource=g;function E(m,b){const w=p(m);for(const l of b)if(d(l,w))return w}function p(m){return m.scheme===R.Schemas.vscodeWebviewResource?S.URI.parse(encodeURIComponent(m.path).replace(/%2F/gi,"/").replace(/^\/([a-z0-9\-]+)(\/{1,2})/i,(w,l,c)=>c.length===1?`${l}:///`:`${l}://`)).with({query:m.query,fragment:m.fragment}):m}function d(m,b){let w=m.fsPath+(m.fsPath.endsWith(D.sep)?"":D.sep),l=b.fsPath;return(0,v.isUNC)(m.fsPath)&&(0,v.isUNC)(b.fsPath)&&(w=w.toLowerCase(),l=l.toLowerCase()),l.startsWith(w)}}),define(X[204],Q([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(X[205],Q([0,1,9,7,56]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewPortMappingManager=void 0;class S{constructor(n,y,i){this._getExtensionLocation=n,this._getMappings=y,this.tunnelService=i,this._tunnels=new Map}async getRedirect(n,y){const i=R.URI.parse(y),L=(0,D.extractLocalHostUriMetaDataForPortMapping)(i);if(!!L){for(const g of this._getMappings())if(g.webviewPort===L.port){const E=this._getExtensionLocation();if(E&&E.scheme===v.Schemas.vscodeRemote){const p=n&&await this.getOrCreateTunnel(n,g.extensionHostPort);if(p)return p.tunnelLocalPort===g.webviewPort?void 0:encodeURI(i.with({authority:`127.0.0.1:${p.tunnelLocalPort}`}).toString(!0))}if(g.webviewPort!==g.extensionHostPort)return encodeURI(i.with({authority:`${L.address}:${g.extensionHostPort}`}).toString(!0))}}}async dispose(){for(const n of this._tunnels.values())await n.dispose();this._tunnels.clear()}async getOrCreateTunnel(n,y){const i=this._tunnels.get(y);if(i)return i;const L=await this.tunnelService.openTunnel({getAddress:async()=>n},void 0,y);return L&&this._tunnels.set(y,L),L}}e.WebviewPortMappingManager=S}),define(X[206],Q([0,1,11,2,9,7,56,75,205]),function($,e,v,R,D,S,k,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewPortMappingProvider=void 0;let i=class extends R.Disposable{constructor(g){super();this._tunnelService=g,this._webviewData=new Map,v.session.fromPartition(n.webviewPartitionId).webRequest.onBeforeRequest({urls:["*://localhost:*/*","*://127.0.0.1:*/*","*://0.0.0.0:*/*"]},async(p,d)=>{let m;try{if(p.lastCommittedOrigin)m=S.URI.parse(p.lastCommittedOrigin).authority;else if(typeof p.webContentsId=="number"){const l=v.webContents.fromId(p.webContentsId),c=S.URI.parse(l.getURL());c.scheme===D.Schemas.vscodeWebview&&(m=c.authority)}}catch(l){return d({})}if(!m)return d({});const b=this._webviewData.get(m);if(!b)return d({});const w=await b.manager.getRedirect(b.metadata.resolvedAuthority,p.url);return d(w?{redirectURL:w}:{})})}async registerWebview(g,E){const p=new y.WebviewPortMappingManager(()=>{var d;return(d=this._webviewData.get(g))===null||d===void 0?void 0:d.metadata.extensionLocation},()=>{var d;return((d=this._webviewData.get(g))===null||d===void 0?void 0:d.metadata.mappings)||[]},this._tunnelService);this._webviewData.set(g,{metadata:E,manager:p})}unregisterWebview(g){const E=this._webviewData.get(g);E&&(E.manager.dispose(),this._webviewData.delete(g))}async updateWebviewMetadata(g,E){const p=this._webviewData.get(g);p&&this._webviewData.set(g,Object.assign(Object.assign({},p),E))}};i=ce([Z(0,k.ITunnelService)],i),e.WebviewPortMappingProvider=i}),define(X[62],Q([0,1,3]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(i){return!!i.workspaceUri}e.isWorkspaceToOpen=R;function D(i){return!!i.folderUri}e.isFolderToOpen=D;function S(i){return!!i.fileUri}e.isFileToOpen=S;function k(i){const L=n(i),g=i.getValue("window.menuBarVisibility");return g==="default"||L==="native"&&g==="compact"||v.isMacintosh&&v.isNative?"classic":g}e.getMenuBarVisibility=k;function n(i){if(v.isWeb)return"custom";const L=i.getValue("window");if(L){if(v.isMacintosh&&L.nativeTabs===!0||v.isMacintosh&&L.nativeFullScreen===!1)return"native";const p=L.titleBarStyle;if(p==="native"||p==="custom")return p}return v.isLinux?"native":"custom"}e.getTitleBarStyle=n;function y(i=0){return Math.pow(1.2,i)}e.zoomLevelToZoomFactor=y}),define(X[32],Q([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var R;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(R=e.OpenContext||(e.OpenContext={}));const D=function(n=1){return{width:1024,height:768,mode:n}};e.defaultWindowState=D;var S;(function(n){n[n.Maximized=0]="Maximized",n[n.Normal=1]="Normal",n[n.Minimized=2]="Minimized",n[n.Fullscreen=3]="Fullscreen"})(S=e.WindowMode||(e.WindowMode={}));var k;(function(n){n[n.UNRESPONSIVE=1]="UNRESPONSIVE",n[n.CRASHED=2]="CRASHED",n[n.LOAD=3]="LOAD"})(k=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,v.createDecorator)("windowsMainService")}),define(X[207],Q([0,1,11,239,20,25,2,9,59,7,16,6,40,75,32]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;let m=class wt extends k.Disposable{constructor(w,l,c,o){super();this.fileService=w,this.logService=l,this.requestService=c,this.windowsMainService=o,this.webviewMetadata=new Map,this.requestIdPool=1,this.pendingResourceReads=new Map;const s=v.session.fromPartition(p.webviewPartitionId),t=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(n.Schemas.vscodeWebview,t),s.protocol.registerFileProtocol(n.Schemas.vscodeWebview,t);const r=this.handleWebviewResourceRequest.bind(this);v.protocol.registerStreamProtocol(n.Schemas.vscodeWebviewResource,r),s.protocol.registerStreamProtocol(n.Schemas.vscodeWebviewResource,r),this._register((0,k.toDisposable)(()=>{v.protocol.unregisterProtocol(n.Schemas.vscodeWebviewResource),s.protocol.unregisterProtocol(n.Schemas.vscodeWebviewResource),v.protocol.unregisterProtocol(n.Schemas.vscodeWebview),s.protocol.unregisterProtocol(n.Schemas.vscodeWebview)}))}streamToNodeReadable(w){return new class extends R.Readable{constructor(){super(...arguments);this.listening=!1}_read(l){this.listening||(this.listening=!0,(0,y.listenStream)(w,{onData:c=>{try{this.push(c.buffer)||w.pause()}catch(o){this.emit(o)}},onError:c=>{this.emit("error",c)},onEnd:()=>{try{this.push(null)}catch(c){this.emit(c)}}})),w.resume()}_destroy(l,c){w.destroy(),c(null)}}}async registerWebview(w,l){this.webviewMetadata.set(w,l)}unregisterWebview(w){this.webviewMetadata.delete(w)}async updateWebviewMetadata(w,l){const c=this.webviewMetadata.get(w);c&&this.webviewMetadata.set(w,Object.assign(Object.assign({},c),l))}async handleWebviewRequest(w,l){try{const c=i.URI.parse(w.url),o=wt.validWebviewFilePaths.get(c.path);if(typeof o=="string"){const s=c.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${o}`:`vs/workbench/contrib/webview/browser/pre/${o}`,t=n.FileAccess.asFileUri(s,$);return l(decodeURIComponent(t.fsPath))}}catch(c){}l({error:-10})}async handleWebviewResourceRequest(w,l){try{const c=i.URI.parse(w.url),o=w.headers["If-None-Match"],s=c.authority,t=this.webviewMetadata.get(s);if(t){let r;t.remoteConnectionData&&(r=h=>{var f;if(t.remoteConnectionData&&(h.scheme===n.Schemas.vscodeRemote||((f=t.extensionLocation)===null||f===void 0?void 0:f.scheme)===n.Schemas.vscodeRemote)){let P=t.remoteConnectionData.host;return P&&P.indexOf(":")!==-1&&(P=`[${P}]`),i.URI.parse(`http://${P}:${t.remoteConnectionData.port}`).with({path:"/vscode-remote-resource",query:`tkn=${t.remoteConnectionData.connectionToken}&path=${encodeURIComponent(h.path)}`})}return h});const a={readFileStream:async(h,f)=>{var P;if(h.scheme===n.Schemas.file)return(0,p.readFileStream)(this.fileService,h,f);const A=this.windowsMainService.getWindowById(t.windowId);if(!A)throw new L.FileOperationError("Could not find window for resource",1);const F=this.requestIdPool++,N=new Promise(G=>{this.pendingResourceReads.set(F,{resolve:G})});A.send(`vscode:loadWebviewResource-${s}`,F,c,f);const j=await N;switch(j.response){case"access-denied":throw new L.FileOperationError("Could not read file",6);case"not-found":throw new L.FileOperationError("Could not read file",1);case"not-modified":return p.WebviewFileReadResponse.NotModified;default:return new p.WebviewFileReadResponse.StreamSuccess((0,D.bufferToStream)(j.response),(P=j.responseDetails)===null||P===void 0?void 0:P.etag)}}},u=await(0,p.loadLocalResource)(c,o,{extensionLocation:t.extensionLocation,roots:t.localResourceRoots,remoteConnectionData:t.remoteConnectionData,rewriteUri:r},a,this.requestService,this.logService,S.CancellationToken.None);switch(u.type){case p.WebviewResourceResponse.Type.Success:{const h=u.etag?{ETag:u.etag,"Cache-Control":"no-cache"}:{},f=w.headers["If-None-Match"];return f&&u.etag===f?l({statusCode:304,data:void 0,headers:Object.assign({"Content-Type":u.mimeType,"Access-Control-Allow-Origin":"*"},h)}):l({statusCode:200,data:this.streamToNodeReadable(u.stream),headers:Object.assign({"Content-Type":u.mimeType,"Access-Control-Allow-Origin":"*"},h)})}case p.WebviewResourceResponse.Type.NotModified:return l({statusCode:304,data:void 0,headers:{"Content-Type":u.mimeType,"Access-Control-Allow-Origin":"*"}});case p.WebviewResourceResponse.Type.AccessDenied:return console.error("Webview: Cannot load resource outside of protocol root"),l({data:void 0,statusCode:401})}}}catch(c){}return l({data:void 0,statusCode:404})}didLoadResource(w,l,c){const o=this.pendingResourceReads.get(w);if(!o)throw new Error("Unknown request");this.pendingResourceReads.delete(w),o.resolve({response:l,responseDetails:c})}};m.validWebviewFilePaths=new Map([["/index.html","index.html"],["/electron-browser/index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"]]),m=ce([Z(0,L.IFileService),Z(1,g.ILogService),Z(2,E.IRequestService),Z(3,d.IWindowsMainService)],m),e.WebviewProtocolProvider=m}),define(X[208],Q([0,1,11,2,7,16,6,56,40,75,206,207,32]),function($,e,v,R,D,S,k,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let p=class extends R.Disposable{constructor(m,b,w,l,c){super();this.windowsMainService=c,this.protocolProvider=this._register(new g.WebviewProtocolProvider(m,b,w,c)),this.portMappingProvider=this._register(new L.WebviewPortMappingProvider(l));const o=v.session.fromPartition(i.webviewPartitionId);o.setPermissionRequestHandler((s,t,r)=>r(t==="clipboard-read")),o.setPermissionCheckHandler((s,t)=>t==="clipboard-read")}async registerWebview(m,b,w){const l=w.extensionLocation?D.URI.from(w.extensionLocation):void 0;this.protocolProvider.registerWebview(m,Object.assign(Object.assign({},w),{windowId:b,extensionLocation:l,localResourceRoots:w.localResourceRoots.map(c=>D.URI.from(c))})),this.portMappingProvider.registerWebview(m,{extensionLocation:l,mappings:w.portMappings,resolvedAuthority:w.remoteConnectionData})}async unregisterWebview(m){this.protocolProvider.unregisterWebview(m),this.portMappingProvider.unregisterWebview(m)}async updateWebviewMetadata(m,b){var w;const l=b.extensionLocation?D.URI.from(b.extensionLocation):void 0;this.protocolProvider.updateWebviewMetadata(m,Object.assign(Object.assign({},b),{extensionLocation:l,localResourceRoots:(w=b.localResourceRoots)===null||w===void 0?void 0:w.map(c=>D.URI.from(c))})),this.portMappingProvider.updateWebviewMetadata(m,Object.assign(Object.assign({},b),{extensionLocation:l}))}async setIgnoreMenuShortcuts(m,b){let w;if(typeof m.windowId=="number"){const{windowId:l}=m,c=this.windowsMainService.getWindowById(l);if(!(c==null?void 0:c.win))throw new Error(`Invalid windowId: ${l}`);w=c.win.webContents}else{const{webContentsId:l}=m;if(w=v.webContents.fromId(l),!w)throw new Error(`Invalid webContentsId: ${l}`)}w.isDestroyed()||w.setIgnoreMenuShortcuts(b)}async didLoadResource(m,b,w){this.protocolProvider.didLoadResource(m,b,w)}};p=ce([Z(0,S.IFileService),Z(1,k.ILogService),Z(2,y.IRequestService),Z(3,n.ITunnelService),Z(4,E.IWindowsMainService)],p),e.WebviewMainService=p}),define(X[209],Q([0,1,5,2,10]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class S extends R.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:y,getActiveWindowId:i}){super();this.disposables=this._register(new R.DisposableStore),v.Event.latch(v.Event.any(n,y))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>i()),(async()=>{try{const g=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:g}catch(g){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=S}),define(X[210],Q([0,1,7,15,4,36]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var k;(function(E){E[E.EMPTY=1]="EMPTY",E[E.FOLDER=2]="FOLDER",E[E.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function n(E){const p=E;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=n;function y(E){const p=E;return!!(p&&typeof p=="object"&&v.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=y;class i{constructor(p,d,m,b){this._id=p,this._configuration=m,this._ignorePathCasing=b,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(p){this._id=p.id,this._configuration=p.configuration,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=i;class L{constructor(p,d){this.raw=d,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,R.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=L;function g(E){return new L({uri:E,index:0,name:(0,R.basenameOrAuthority)(E)},{uri:E.toString()})}e.toWorkspaceFolder=g}),define(X[29],Q([0,1,4,147,210,7,3,8,15,102,44,9,39,30,72]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(U){return(typeof U=="string"?(0,n.extname)(U):(0,y.extname)(U))===m}e.hasWorkspaceFileExtension=b,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function w(U){return U.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function l(U){return U.hasOwnProperty("folderUri")}e.isRecentFolder=l;function c(U){return U.hasOwnProperty("fileUri")}e.isRecentFile=c;function o(U){const O=U;return typeof(O==null?void 0:O.id)=="string"&&S.URI.isUri(O.uri)}e.isSingleFolderWorkspaceIdentifier=o;function s(U){if(U.configuration)return{id:U.id,configPath:U.configuration};if(U.folders.length===1)return{id:U.id,uri:U.folders[0].uri}}e.toWorkspaceIdentifier=s;function t(U){const O=U;return typeof(O==null?void 0:O.id)=="string"&&S.URI.isUri(O.configPath)}e.isWorkspaceIdentifier=t;function r(U){const O=U;if(O==null?void 0:O.uri)return{id:O.id,uri:S.URI.revive(O.uri)};const z=U;if(z==null?void 0:z.configPath)return{id:z.id,configPath:S.URI.revive(z.configPath)};if(U==null?void 0:U.id)return{id:U.id}}e.reviveIdentifier=r;function a(U,O){return y.extUriBiasedIgnorePathCase.isEqualOrParent(U,O.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function u(U){return h(U)||f(U)}e.isStoredWorkspaceFolder=u;function h(U){const O=U;return typeof(O==null?void 0:O.path)=="string"&&(!O.name||typeof O.name=="string")}e.isRawFileWorkspaceFolder=h;function f(U){const O=U;return typeof(O==null?void 0:O.uri)=="string"&&(!O.name||typeof O.name=="string")}e.isRawUriWorkspaceFolder=f;function P(U,O,z,C,I=!k.isWindows,M){if(U.scheme!==C.scheme)return{name:z,uri:U.toString(!0)};let _=O?void 0:M.relativePath(C,U);if(_!==void 0)_.length===0?_=".":k.isWindows&&U.scheme===g.Schemas.file&&!I&&(_=_.replace(/\//g,"\\"));else if(U.scheme===g.Schemas.file)_=U.fsPath,k.isWindows&&(_=(0,E.normalizeDriveLetter)(_),I&&(_=(0,p.toSlashes)(_)));else{if(!M.isEqualAuthority(U.authority,C.authority))return{name:z,uri:U.toString(!0)};_=U.path}return{name:z,path:_}}e.getStoredWorkspaceFolder=P;function A(U,O,z){let C=[],I=new Set;const M=z.dirname(O);for(let _ of U){let T=null;if(h(_))_.path&&(T=z.resolvePath(M,_.path));else if(f(_))try{T=S.URI.parse(_.uri),T.path[0]!=="/"&&(T=T.with({path:"/"+T.path}))}catch(W){console.warn(W)}if(T){let W=z.getComparisonKey(T);if(!I.has(W)){I.add(W);const B=_.name||z.basenameOrAuthority(T);C.push(new D.WorkspaceFolder({uri:T,name:B,index:C.length},_))}}}return C}e.toWorkspaceFolders=A;function F(U,O,z,C,I){let M=N(O,U);const _=I.dirname(O),T=I.dirname(C),W=[],B=j(M.folders);for(const ee of M.folders){const re=h(ee)?I.resolvePath(_,ee.path):S.URI.parse(ee.uri);let x;z?x=!1:x=!h(ee)||(0,n.isAbsolute)(ee.path),W.push(P(re,x,ee.name,T,B,I))}const H={insertSpaces:!1,tabSize:4,eol:k.isLinux||k.isMacintosh?`
`:`\r
`},K=i.setProperty(U,["folders"],W,H);let J=i.applyEdits(U,K);return M.remoteAuthority===(0,d.getRemoteAuthority)(C)&&(J=i.applyEdits(J,i.removeProperty(J,["remoteAuthority"],H))),J}e.rewriteWorkspaceFileForNewLocation=F;function N(U,O){let z=L.parse(O);if(z&&Array.isArray(z.folders))z.folders=z.folders.filter(C=>u(C));else throw new Error(`${U} looks like an invalid workspace file.`);return z}function j(U){return k.isWindows?U.some(O=>h(O)&&O.path.indexOf("/")>=0):!0}e.useSlashForPath=j;function G(U){return U.workspace&&typeof U.workspace=="object"&&typeof U.workspace.id=="string"&&typeof U.workspace.configPath=="string"}function ne(U){return typeof U.folderUri=="string"}function oe(U){return typeof U.fileUri=="string"}function V(U,O){const z={workspaces:[],files:[]};if(U){const C=function(M,_){for(let T=0;T<M.length;T++)try{_(M[T],T)}catch(W){O.warn(`Error restoring recent entry ${JSON.stringify(M[T])}: ${W.toString()}. Skip entry.`)}},I=U;if(Array.isArray(I.entries))C(I.entries,M=>{const _=M.label,T=M.remoteAuthority;G(M)?z.workspaces.push({label:_,remoteAuthority:T,workspace:{id:M.workspace.id,configPath:S.URI.parse(M.workspace.configPath)}}):ne(M)?z.workspaces.push({label:_,remoteAuthority:T,folderUri:S.URI.parse(M.folderUri)}):oe(M)&&z.files.push({label:_,remoteAuthority:T,fileUri:S.URI.parse(M.fileUri)})});else{const M=U;Array.isArray(M.workspaces3)&&C(M.workspaces3,(_,T)=>{const W=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[T]||void 0;typeof _=="object"&&typeof _.id=="string"&&typeof _.configURIPath=="string"?z.workspaces.push({label:W,workspace:{id:_.id,configPath:S.URI.parse(_.configURIPath)}}):typeof _=="string"&&z.workspaces.push({label:W,folderUri:S.URI.parse(_)})}),Array.isArray(M.files2)&&C(M.files2,(_,T)=>{const W=Array.isArray(M.fileLabels)&&M.fileLabels[T]||void 0;typeof _=="string"&&z.files.push({label:W,fileUri:S.URI.parse(_)})})}}return z}e.restoreRecentlyOpened=V;function Y(U){const O={entries:[]};for(const z of U.workspaces)l(z)?O.entries.push({folderUri:z.folderUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority}):O.entries.push({workspace:{id:z.workspace.id,configPath:z.workspace.configPath.toString()},label:z.label,remoteAuthority:z.remoteAuthority});for(const z of U.files)O.entries.push({fileUri:z.fileUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority});return O}e.toStoreData=Y}),define(X[49],Q([0,1,4,29]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService");function D(S){const k=S;return k&&(0,R.isWorkspaceIdentifier)(k.workspace)}e.isWorkspaceBackupInfo=D}),define(X[50],Q([0,1,4,11,10,38,3,8,65,22,13,131,29,39,2,79]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,v.createDecorator)("dialogMainService");let b=class ct{constructor(l){this.stateService=l,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new D.Queue}pickFileFolder(l,c){return this.doPick(Object.assign(Object.assign({},l),{pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)}),c)}pickFolder(l,c){return this.doPick(Object.assign(Object.assign({},l),{pickFolders:!0,title:(0,g.localize)(1,null)}),c)}pickFile(l,c){return this.doPick(Object.assign(Object.assign({},l),{pickFiles:!0,title:(0,g.localize)(2,null)}),c)}pickWorkspace(l,c){const o=(0,g.localize)(3,null),s=(0,p.mnemonicButtonLabel)((0,g.localize)(4,null)),t=E.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},l),{pickFiles:!0,title:o,filters:t,buttonLabel:s}),c)}async doPick(l,c){const o={title:l.title,buttonLabel:l.buttonLabel,filters:l.filters};o.defaultPath=l.defaultPath||this.stateService.getItem(ct.workingDirPickerStorageKey),(typeof l.pickFiles=="boolean"||typeof l.pickFolders=="boolean")&&(o.properties=void 0,l.pickFiles&&l.pickFolders&&(o.properties=["multiSelections","openDirectory","openFile","createDirectory"])),o.properties||(o.properties=["multiSelections",l.pickFolders?"openDirectory":"openFile","createDirectory"]),k.isMacintosh&&o.properties.push("treatPackageAsDirectory");const s=c||R.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(o,(0,L.withNullAsUndefined)(s));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateService.setItem(ct.workingDirPickerStorageKey,(0,n.dirname)(t.filePaths[0])),t.filePaths}getWindowDialogQueue(l){if(l){let c=this.windowDialogQueues.get(l.id);return c||(c=new D.Queue,this.windowDialogQueues.set(l.id,c)),c}else return this.noWindowDialogueQueue}showMessageBox(l,c){return this.getWindowDialogQueue(c).queue(async()=>c?R.dialog.showMessageBox(c,l):R.dialog.showMessageBox(l))}async showSaveDialog(l,c){const o=this.acquireFileDialogLock(l,c);if(!o)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(c).queue(async()=>{let s;return c?s=await R.dialog.showSaveDialog(c,l):s=await R.dialog.showSaveDialog(l),s.filePath=this.normalizePath(s.filePath),s})}finally{(0,d.dispose)(o)}}normalizePath(l){return l&&k.isMacintosh&&(l=(0,y.normalizeNFC)(l)),l}normalizePaths(l){return l.map(c=>this.normalizePath(c))}async showOpenDialog(l,c){l.defaultPath&&(await(0,i.exists)(l.defaultPath)||(l.defaultPath=void 0));const o=this.acquireFileDialogLock(l,c);if(!o)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(c).queue(async()=>{let s;return c?s=await R.dialog.showOpenDialog(c,l):s=await R.dialog.showOpenDialog(l),s.filePaths=this.normalizePaths(s.filePaths),s})}finally{(0,d.dispose)(o)}}acquireFileDialogLock(l,c){if(!c)return d.Disposable.None;let o=this.windowFileDialogLocks.get(c.id);o||(o=new Set,this.windowFileDialogLocks.set(c.id,o));const s=(0,m.hash)(l);if(!o.has(s))return o.add(s),(0,d.toDisposable)(()=>{o==null||o.delete(s),(o==null?void 0:o.size)===0&&this.windowFileDialogLocks.delete(c.id)})}};b.workingDirPickerStorageKey="pickerWorkingDir",b=ce([Z(0,S.IStateService)],b),e.DialogMainService=b}),define(X[211],Q([0,1,5,2,29]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class S extends R.Disposable{constructor(n,y){super();this.logService=n,this.storageMainService=y,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,y)=>(n?n.push(y):n=[y],n),S.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const y=new Map,i=new Set;return n.forEach(L=>{const g=this.storageMainService.globalStorage.get(L.key);typeof g=="string"?y.set(L.key,g):i.add(L.key)}),{changed:Array.from(y.entries()),deleted:Array.from(i.values())}}listen(n,y){switch(y){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${y}`)}async call(n,y,i){const L=(0,D.reviveIdentifier)(i.workspace),g=await this.withStorageInitialized(L);switch(y){case"getItems":return Array.from(g.items.entries());case"updateItems":{const E=i;if(E.insert)for(const[p,d]of E.insert)g.set(p,d);E.delete&&E.delete.forEach(p=>g.delete(p));break}case"close":{if(L)return g.close();break}default:throw new Error(`Call not found: ${y}`)}}async withStorageInitialized(n){const y=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await y.init()}catch(i){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${i}`)}return y}}e.StorageDatabaseChannel=S,S.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(X[212],Q([0,1,21,22,5,2,6,121,85,8,94,31,28,29]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class d extends S.Disposable{constructor(l){super();this.logService=l,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new D.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new y.Storage(new y.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const l=await this.doCreate();this.storage.dispose(),this.storage=l,this._register(l.onDidChangeStorage(o=>this._onDidChangeStorage.fire({key:o}))),await this.doInit(l);const c=l.getBoolean(L.IS_NEW_KEY);c===void 0?l.set(L.IS_NEW_KEY,!0):c&&l.set(L.IS_NEW_KEY,!1)}catch(l){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${l}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===k.LogLevel.Trace?l=>this.logService.trace(l):void 0,logError:l=>this.logService.error(l)}}doInit(l){return l.init()}get items(){return this.storage.items}get(l,c){return this.storage.get(l,c)}set(l,c){return this.storage.set(l,c)}delete(l){return this.storage.delete(l)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class m extends d{constructor(l,c,o){super(c);this.options=l,this.environmentService=o}async doCreate(){let l;return this.options.useInMemoryStorage?l=n.SQLiteStorageDatabase.IN_MEMORY_PATH:l=(0,i.join)(this.environmentService.globalStorageHome.fsPath,m.STORAGE_NAME),new y.Storage(new n.SQLiteStorageDatabase(l,{logging:this.createLogginOptions()}))}async doInit(l){await super.doInit(l),this.updateTelemetryState(l)}updateTelemetryState(l){l.get(g.instanceStorageKey,void 0)===void 0&&l.set(g.instanceStorageKey,(0,E.generateUuid)()),l.get(g.firstSessionDateStorageKey,void 0)===void 0&&l.set(g.firstSessionDateStorageKey,new Date().toUTCString());const s=l.get(g.currentSessionDateStorageKey,void 0),t=new Date().toUTCString();l.set(g.lastSessionDateStorageKey,typeof s=="undefined"?null:s),l.set(g.currentSessionDateStorageKey,t)}}e.GlobalStorageMain=m,m.STORAGE_NAME="state.vscdb";class b extends d{constructor(l,c,o,s){super(o);this.workspace=l,this.options=c,this.environmentService=s}async doCreate(){const{storageFilePath:l,wasCreated:c}=await this.prepareWorkspaceStorageFolder();return new y.Storage(new n.SQLiteStorageDatabase(l,{logging:this.createLogginOptions()}),{hint:c?y.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:n.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const l=(0,i.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),c=(0,i.join)(l,b.WORKSPACE_STORAGE_NAME);return await(0,R.exists)(l)?{storageFilePath:c,wasCreated:!1}:(await v.promises.mkdir(l,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(l),{storageFilePath:c,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(l){let c;if((0,p.isSingleFolderWorkspaceIdentifier)(this.workspace)?c={folder:this.workspace.uri.toString()}:(0,p.isWorkspaceIdentifier)(this.workspace)&&(c={workspace:this.workspace.configPath.toString()}),c)try{const o=(0,i.join)(l,b.WORKSPACE_META_NAME);await(0,R.exists)(o)||await(0,R.writeFile)(o,JSON.stringify(c,void 0,2))}catch(o){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${o}`)}}}e.WorkspaceStorageMain=b,b.WORKSPACE_STORAGE_NAME="state.vscdb",b.WORKSPACE_META_NAME="workspace.json"}),define(X[97],Q([0,1,43,2,47,4,17,6,212]),function($,e,v,R,D,S,k,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,S.createDecorator)("storageMainService");let i=class extends R.Disposable{constructor(g,E,p){super();this.logService=g,this.environmentService=E,this.lifecycleMainService=p,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async g=>{g.workspace&&this.workspaceStorage(g.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(g=>{g.join(this.globalStorage.close());for(const[,E]of this.mapWorkspaceToStorage)g.join(E.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const g=new y.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,v.once)(g.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),g}createWorkspaceStorage(g){return new y.WorkspaceStorageMain(g,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(g){let E=this.mapWorkspaceToStorage.get(g.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${g.id})`),E=this.createWorkspaceStorage(g),this.mapWorkspaceToStorage.set(g.id,E),(0,v.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${g.id})`),this.mapWorkspaceToStorage.delete(g.id)})),E}};i=ce([Z(0,n.ILogService),Z(1,D.IEnvironmentService),Z(2,k.ILifecycleMainService)],i),e.StorageMainService=i}),define(X[98],Q([0,1,7,29,15]),function($,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function S(y,i,L){for(const E of y){const p=E.openedWorkspace;if((0,R.isWorkspaceIdentifier)(p)){const d=L(p);if(d){if(d.folders.some(m=>D.extUriBiasedIgnorePathCase.isEqualOrParent(i,m.uri)))return E}else if(D.extUriBiasedIgnorePathCase.isEqualOrParent(i,p.configPath))return E}}const g=y.filter(E=>(0,R.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqualOrParent(i,E.openedWorkspace.uri));if(g.length)return g.sort((E,p)=>-(E.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=S;function k(y,i){for(const L of y)if((0,R.isWorkspaceIdentifier)(L.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqual(L.openedWorkspace.configPath,i)||(0,R.isSingleFolderWorkspaceIdentifier)(L.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqual(L.openedWorkspace.uri,i))return L}e.findWindowOnWorkspaceOrFolder=k;function n(y,i){var L,g;const E=p=>i.some(d=>D.extUriBiasedIgnorePathCase.isEqual(v.URI.file(d),v.URI.file(p)));for(const p of y)if((g=(L=p.config)===null||L===void 0?void 0:L.extensionDevelopmentPath)===null||g===void 0?void 0:g.some(d=>E(d)))return p}e.findWindowOnExtensionDevelopmentPath=n}),define(X[213],Q([0,1,11,2,3,15,7,24,17,6,38,32,29]),function($,e,v,R,D,S,k,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class ut extends R.Disposable{constructor(c,o,s,t,r){super();this.windowsMainService=c,this.stateService=o,this.lifecycleMainService=s,this.logService=t,this.configurationService=r,this._state=d(this.stateService.getItem(ut.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(c=>this.onBeforeCloseWindow(c)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(c=>this.onBeforeCloseWindow(c))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),t&&(c.lastActiveWindow=this.toWindowState(t))}const o=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);o&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const s=b(c);this.stateService.setItem(ut.windowsStateStorageKey,s),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",s)}onBeforeCloseWindow(c){if(!this.lifecycleMainService.quitRequested){const o=this.toWindowState(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this._state.openedWindows.forEach(s=>{var t;const r=(0,E.isWorkspaceIdentifier)(c.openedWorkspace)&&((t=s.workspace)===null||t===void 0?void 0:t.id)===c.openedWorkspace.id,a=(0,E.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)&&s.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(s.folderUri,c.openedWorkspace.uri);(r||a)&&(s.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}}toWindowState(c){return{workspace:(0,E.isWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,E.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const o=this.doGetNewWindowState(c),s=this.configurationService.getValue("window");let t;return o.hasDefaultState?t=!!((s==null?void 0:s.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(s.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||(s==null?void 0:s.restoreFullscreen)),t&&D.isMacintosh&&this.windowsMainService.getWindows().some(r=>r.isFullScreen)&&(t=!1)),o.mode===3&&!t&&(o.mode=1),o}doGetNewWindowState(c){const o=this.windowsMainService.getLastActiveWindow();if(!c.extensionTestsPath){if(!!c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const h=c.workspace;if((0,E.isWorkspaceIdentifier)(h)){const P=this.state.openedWindows.filter(A=>A.workspace&&A.workspace.id===h.id).map(A=>A.uiState);if(P.length)return P[0]}if((0,E.isSingleFolderWorkspaceIdentifier)(h)){const P=this.state.openedWindows.filter(A=>A.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(A.folderUri,h.uri)).map(A=>A.uiState);if(P.length)return P[0]}else if(c.backupPath){const P=this.state.openedWindows.filter(A=>A.backupPath===c.backupPath).map(A=>A.uiState);if(P.length)return P[0]}const f=this.lastClosedState||this.state.lastActiveWindow;if(!o&&f)return f.uiState}let s;const t=v.screen.getAllDisplays();if(t.length===1)s=t[0];else{if(D.isMacintosh){const h=v.screen.getCursorScreenPoint();s=v.screen.getDisplayNearestPoint(h)}!s&&o&&(s=v.screen.getDisplayMatching(o.getBounds())),s||(s=v.screen.getPrimaryDisplay()||t[0])}let r=(0,g.defaultWindowState)();r.x=Math.round(s.bounds.x+s.bounds.width/2-r.width/2),r.y=Math.round(s.bounds.y+s.bounds.height/2-r.height/2);const a=this.configurationService.getValue("window");let u=!0;if(a==null?void 0:a.newWindowDimensions){if(a.newWindowDimensions==="maximized")r.mode=0,u=!1;else if(a.newWindowDimensions==="fullscreen")r.mode=3,u=!1;else if((a.newWindowDimensions==="inherit"||a.newWindowDimensions==="offset")&&o){const h=o.serializeWindowState();h.mode===3?r.mode=3:r=h,u=r.mode!==3&&a.newWindowDimensions==="offset"}}return u&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(c){if(this.windowsMainService.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const o=this.windowsMainService.getWindows().map(s=>s.getBounds());for(;o.some(s=>s.x===c.x||s.y===c.y);)c.x+=30,c.y+=30;return c}};p.windowsStateStorageKey="windowsState",p=ce([Z(0,g.IWindowsMainService),Z(1,L.IStateService),Z(2,y.ILifecycleMainService),Z(3,i.ILogService),Z(4,n.IConfigurationService)],p),e.WindowsStateHandler=p;function d(l){const c={openedWindows:[]},o=l||{openedWindows:[]};return o.lastActiveWindow&&(c.lastActiveWindow=m(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=m(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(c.openedWindows=o.openedWindows.map(s=>m(s))),c}e.restoreWindowsState=d;function m(l){const c={uiState:l.uiState};return l.backupPath&&(c.backupPath=l.backupPath),l.remoteAuthority&&(c.remoteAuthority=l.remoteAuthority),l.folder&&(c.folderUri=k.URI.parse(l.folder)),l.workspaceIdentifier&&(c.workspace={id:l.workspaceIdentifier.id,configPath:k.URI.parse(l.workspaceIdentifier.configURIPath)}),c}function b(l){return{lastActiveWindow:l.lastActiveWindow&&w(l.lastActiveWindow),lastPluginDevelopmentHostWindow:l.lastPluginDevelopmentHostWindow&&w(l.lastPluginDevelopmentHostWindow),openedWindows:l.openedWindows.map(c=>w(c))}}e.getWindowsStateStoreData=b;function w(l){return{workspaceIdentifier:l.workspace&&{id:l.workspace.id,configURIPath:l.workspace.configPath.toString()},folder:l.folderUri&&l.folderUri.toString(),backupPath:l.backupPath,remoteAuthority:l.remoteAuthority,uiState:l.uiState}}}),define(X[57],Q([0,1,60,61,214,5,33,8,27,28,2,20,83,18,3]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(P){this.socket=P,this._errorListener=A=>{if(A){if(A.code==="EPIPE")return;(0,p.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(P){const A=F=>P(g.VSBuffer.wrap(F));return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(P){return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(P){return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(P){if(!this.socket.destroyed)try{this.socket.write(P.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,p.onUnexpectedError)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,p.onUnexpectedError)(A)}}end(){this.socket.end()}drain(){return new Promise((P,A)=>{if(this.socket.bufferSize===0){P();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),P()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.NodeSocket=m;var b;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(b||(b={}));var w;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(w||(w={}));class l extends L.Disposable{constructor(P,A,F,N){super();this._onDidZlibFlush=this._register(new S.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=P,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=A,this._recordInflateBytes=N,A?(this._zlibInflate=D.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",j=>{console.error(j),(0,p.onUnexpectedError)(j),this._onClose.fire()}),this._zlibInflate.on("data",j=>{this._pendingInflateData.push(j)}),F&&(this._zlibInflate.write(F.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=D.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",j=>{console.error(j),(0,p.onUnexpectedError)(j),this._onClose.fire()}),this._zlibDeflate.on("data",j=>{this._pendingDeflateData.push(j)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new E.ChunkStream,this._register(this.socket.onData(j=>this._acceptChunk(j))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?g.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):g.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(P){return this._onData.event(P)}onClose(P){return this._onClose.event(P)}onEnd(P){return this.socket.onEnd(P)}write(P){this._totalOutgoingDataBytes+=P.byteLength,this._zlibDeflate?(this._zlibDeflate.write(P.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let A=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,A=A.slice(0,A.length-4),this._isEnded||this._write(g.VSBuffer.wrap(A),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(P,!1)}_write(P,A){let F=2;P.byteLength<126?F+=0:P.byteLength<2**16?F+=2:F+=8;const N=g.VSBuffer.alloc(F);if(A?N.writeUInt8(194,0):N.writeUInt8(130,0),P.byteLength<126)N.writeUInt8(P.byteLength,1);else if(P.byteLength<2**16){N.writeUInt8(126,1);let j=1;N.writeUInt8(P.byteLength>>>8&255,++j),N.writeUInt8(P.byteLength>>>0&255,++j)}else{N.writeUInt8(127,1);let j=1;N.writeUInt8(0,++j),N.writeUInt8(0,++j),N.writeUInt8(0,++j),N.writeUInt8(0,++j),N.writeUInt8(P.byteLength>>>24&255,++j),N.writeUInt8(P.byteLength>>>16&255,++j),N.writeUInt8(P.byteLength>>>8&255,++j),N.writeUInt8(P.byteLength>>>0&255,++j)}this._totalOutgoingWireBytes+=N.byteLength+P.byteLength,this.socket.write(g.VSBuffer.concat([N,P]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(P){if(P.byteLength!==0){for(this._totalIncomingWireBytes+=P.byteLength,this._incomingData.acceptChunk(P);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const A=this._incomingData.peek(this._state.readLen),N=(A.readUInt8(0)&128)>>>7,j=A.readUInt8(1),G=(j&128)>>>7,ne=j&127;this._state.state=2,this._state.readLen=2+(G?4:0)+(ne===126?2:0)+(ne===127?8:0),this._state.fin=N,this._state.mask=0}else if(this._state.state===2){const A=this._incomingData.read(this._state.readLen),F=A.readUInt8(1),N=(F&128)>>>7;let j=F&127,G=1;j===126?j=A.readUInt8(++G)*2**8+A.readUInt8(++G):j===127&&(j=A.readUInt8(++G)*0+A.readUInt8(++G)*0+A.readUInt8(++G)*0+A.readUInt8(++G)*0+A.readUInt8(++G)*2**24+A.readUInt8(++G)*2**16+A.readUInt8(++G)*2**8+A.readUInt8(++G));let ne=0;N&&(ne=A.readUInt8(++G)*2**24+A.readUInt8(++G)*2**16+A.readUInt8(++G)*2**8+A.readUInt8(++G)),this._state.state=3,this._state.readLen=j,this._state.mask=ne}else if(this._state.state===3){const A=this._incomingData.read(this._state.readLen);c(A,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(A.buffer)),this._zlibInflate.write(A.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const F=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=F.length,this._onData.fire(g.VSBuffer.wrap(F))})):(this._totalIncomingDataBytes+=A.byteLength,this._onData.fire(A))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await S.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=l;function c(f,P){if(P!==0){let A=f.byteLength>>>2;for(let oe=0;oe<A;oe++){const V=f.readUInt32BE(oe*4);f.writeUInt32BE(V^P,oe*4)}let F=A*4,N=f.byteLength-F;const j=P>>>24&255,G=P>>>16&255,ne=P>>>8&255;N>=1&&f.writeUInt8(f.readUInt8(F)^j,F),N>=2&&f.writeUInt8(f.readUInt8(F+1)^G,F+1),N>=3&&f.writeUInt8(f.readUInt8(F+2)^ne,F+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function s(){const f=(0,i.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let P;return e.XDG_RUNTIME_DIR?P=(0,n.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):P=(0,n.join)((0,y.tmpdir)(),`vscode-ipc-${f}.sock`),r(P),P}e.createRandomIPCHandle=s;function t(f,P,A){const F=(0,v.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${A}-${P}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,n.join)(e.XDG_RUNTIME_DIR,`vscode-${F.substr(0,8)}-${A}-${P}.sock`):N=(0,n.join)(f,`${A}-${P}.sock`),r(N),N}e.createStaticIPCHandle=t;function r(f){const P=o[d.platform];typeof P=="number"&&f.length>=P&&console.warn(`WARNING: IPC handle "${f}" is longer than ${P} chars, try a shorter --user-data-dir`)}class a extends k.IPCServer{constructor(P){super(a.toClientConnectionEvent(P));this.server=P}static toClientConnectionEvent(P){const A=S.Event.fromNodeEventEmitter(P,"connection");return S.Event.map(A,F=>({protocol:new E.Protocol(new m(F)),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(F,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=a;function u(f){return new Promise((P,A)=>{const F=(0,R.createServer)();F.on("error",A),F.listen(f,()=>{F.removeListener("error",A),P(new a(F))})})}e.serve=u;function h(f,P){return new Promise((A,F)=>{const N=(0,R.createConnection)(f,()=>{N.removeListener("error",F),A(E.Client.fromSocket(new m(N),P))});N.once("error",F)})}e.connect=h}),define(X[215],Q([0,1,57]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverChannelClient=e.WindowDriverChannel=e.WindowDriverRegistryChannelClient=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class R{constructor(g){this.driver=g}listen(g,E){throw new Error("No event found")}call(g,E,p){switch(E){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(p);case"reloadWindow":return this.driver.reloadWindow(p);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(p[0],p[1]);case"click":return this.driver.click(p[0],p[1],p[2],p[3]);case"doubleClick":return this.driver.doubleClick(p[0],p[1]);case"setValue":return this.driver.setValue(p[0],p[1],p[2]);case"getTitle":return this.driver.getTitle(p[0]);case"isActiveElement":return this.driver.isActiveElement(p[0],p[1]);case"getElements":return this.driver.getElements(p[0],p[1],p[2]);case"getElementXY":return this.driver.getElementXY(p[0],p[1],p[2]);case"typeInEditor":return this.driver.typeInEditor(p[0],p[1],p[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(p[0],p[1]);case"writeInTerminal":return this.driver.writeInTerminal(p[0],p[1],p[2])}throw new Error(`Call not found: ${E}`)}}e.DriverChannel=R;class D{constructor(g){this.channel=g}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(g){return this.channel.call("capturePage",g)}reloadWindow(g){return this.channel.call("reloadWindow",g)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(g,E){return this.channel.call("dispatchKeybinding",[g,E])}click(g,E,p,d){return this.channel.call("click",[g,E,p,d])}doubleClick(g,E){return this.channel.call("doubleClick",[g,E])}setValue(g,E,p){return this.channel.call("setValue",[g,E,p])}getTitle(g){return this.channel.call("getTitle",[g])}isActiveElement(g,E){return this.channel.call("isActiveElement",[g,E])}getElements(g,E,p){return this.channel.call("getElements",[g,E,p])}getElementXY(g,E,p,d){return this.channel.call("getElementXY",[g,E,p,d])}typeInEditor(g,E,p){return this.channel.call("typeInEditor",[g,E,p])}getTerminalBuffer(g,E){return this.channel.call("getTerminalBuffer",[g,E])}writeInTerminal(g,E,p){return this.channel.call("writeInTerminal",[g,E,p])}}e.DriverChannelClient=D;class S{constructor(g){this.registry=g}listen(g,E){throw new Error(`Event not found: ${E}`)}call(g,E,p){switch(E){case"registerWindowDriver":return this.registry.registerWindowDriver(p);case"reloadWindowDriver":return this.registry.reloadWindowDriver(p)}throw new Error(`Call not found: ${E}`)}}e.WindowDriverRegistryChannel=S;class k{constructor(g){this.channel=g}registerWindowDriver(g){return this.channel.call("registerWindowDriver",g)}reloadWindowDriver(g){return this.channel.call("reloadWindowDriver",g)}}e.WindowDriverRegistryChannelClient=k;class n{constructor(g){this.driver=g}listen(g,E){throw new Error(`No event found: ${E}`)}call(g,E,p){switch(E){case"click":return this.driver.click(p[0],p[1],p[2]);case"doubleClick":return this.driver.doubleClick(p);case"setValue":return this.driver.setValue(p[0],p[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(p);case"getElements":return this.driver.getElements(p[0],p[1]);case"getElementXY":return this.driver.getElementXY(p[0],p[1],p[2]);case"typeInEditor":return this.driver.typeInEditor(p[0],p[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(p);case"writeInTerminal":return this.driver.writeInTerminal(p[0],p[1])}throw new Error(`Call not found: ${E}`)}}e.WindowDriverChannel=n;class y{constructor(g){this.channel=g}click(g,E,p){return this.channel.call("click",[g,E,p])}doubleClick(g){return this.channel.call("doubleClick",g)}setValue(g,E){return this.channel.call("setValue",[g,E])}getTitle(){return this.channel.call("getTitle")}isActiveElement(g){return this.channel.call("isActiveElement",g)}getElements(g,E){return this.channel.call("getElements",[g,E])}getElementXY(g,E,p){return this.channel.call("getElementXY",[g,E,p])}typeInEditor(g,E){return this.channel.call("typeInEditor",[g,E])}getTerminalBuffer(g){return this.channel.call("getTerminalBuffer",g)}writeInTerminal(g,E){return this.channel.call("writeInTerminal",[g,E])}}e.WindowDriverChannelClient=y;async function i(L){const g=await(0,v.connect)(L,"driverClient"),E=g.getChannel("driver"),p=new D(E);return{client:g,driver:p}}e.connect=i}),define(X[26],Q([0,1,8,52,4,47,154,57]),function($,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,D.refineServiceDecorator)(S.IEnvironmentService);class y extends k.NativeEnvironmentService{get cachedLanguagesPath(){return(0,v.join)(this.userDataPath,"clp")}get backupHome(){return(0,v.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,v.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,n.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get nodeCachedDataDir(){return process.env.VSCODE_NODE_CACHED_DATA_DIR||void 0}}ce([R.memoize],y.prototype,"cachedLanguagesPath",null),ce([R.memoize],y.prototype,"backupHome",null),ce([R.memoize],y.prototype,"backupWorkspacesPath",null),ce([R.memoize],y.prototype,"mainIPCHandle",null),ce([R.memoize],y.prototype,"sandbox",null),ce([R.memoize],y.prototype,"driverVerbose",null),ce([R.memoize],y.prototype,"disableUpdates",null),ce([R.memoize],y.prototype,"disableKeytar",null),ce([R.memoize],y.prototype,"nodeCachedDataDir",null),e.EnvironmentMainService=y}),define(X[216],Q([0,1,21,60,8,3,22,49,26,24,16,6,29,7,30,9,15]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let w=class{constructor(c,o,s){this.configurationService=o,this.logService=s,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=b.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,r)=>(0,d.isEqual)(t,r,!S.isLinux)},this.backupHome=c.backupHome,this.workspacesJsonPath=c.backupWorkspacesPath}async initialize(){let c;try{c=JSON.parse(await v.promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){c=Object.create(null)}c.emptyWorkspaceInfos&&(this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWorkspaceInfos));let o=[];try{Array.isArray(c.rootURIWorkspaces)&&(o=c.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:p.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(o);let s=[];try{Array.isArray(c.folderURIWorkspaces)&&(s=c.folderURIWorkspaces.map(t=>p.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(s),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==L.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===L.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var c;const o=this.configurationService.getValue();return((c=o==null?void 0:o.files)===null||c===void 0?void 0:c.hotExit)||L.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(c,o){this.workspaces.some(t=>c.workspace.id===t.workspace.id)||(this.workspaces.push(c),this.saveSync());const s=this.getBackupPath(c.workspace.id);return o&&this.moveBackupFolderSync(s,o),s}moveBackupFolderSync(c,o){if(v.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),v.existsSync(o))try{v.renameSync(o,c)}catch(s){this.logService.error(`Backup: Could not move backup folder to new location: ${s.toString()}`)}}unregisterWorkspaceBackupSync(c){const o=c.id,s=this.workspaces.findIndex(t=>t.workspace.id===o);s!==-1&&(this.workspaces.splice(s,1),this.saveSync())}registerFolderBackupSync(c){return this.folders.some(o=>this.backupUriComparer.isEqual(c,o))||(this.folders.push(c),this.saveSync()),this.getBackupPath(this.getFolderHash(c))}unregisterFolderBackupSync(c){const o=this.folders.findIndex(s=>this.backupUriComparer.isEqual(c,s));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(c,o){const s=c||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,s))||(this.emptyWindows.push({backupFolder:s,remoteAuthority:o}),this.saveSync()),this.getBackupPath(s)}unregisterEmptyWindowBackupSync(c){const o=this.emptyWindows.findIndex(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,c));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(c){return(0,D.join)(this.backupHome,c)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const o=new Set,s=[];for(let t of c){const r=t.workspace;if(!(0,E.isWorkspaceIdentifier)(r))return[];if(!o.has(r.id)){o.add(r.id);const a=this.getBackupPath(r.id);await this.doHasBackups(a)?r.configPath.scheme!==m.Schemas.file||await(0,k.exists)(r.configPath.fsPath)?s.push(t):await this.convertToEmptyWindowBackup(a):await this.deleteStaleBackup(a)}}return s}async validateFolders(c){if(!Array.isArray(c))return[];const o=[],s=new Set;for(let t of c){const r=this.backupUriComparer.getComparisonKey(t);if(!s.has(r)){s.add(r);const a=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(a)?t.scheme!==m.Schemas.file||await(0,k.exists)(t.fsPath)?o.push(t):await this.convertToEmptyWindowBackup(a):await this.deleteStaleBackup(a)}}return o}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const o=[],s=new Set;for(let t of c){const r=t.backupFolder;if(typeof r!="string")return[];if(!s.has(r)){s.add(r);const a=this.getBackupPath(r);await this.doHasBackups(a)?o.push(t):await this.deleteStaleBackup(a)}}return o}async deleteStaleBackup(c){try{await(0,k.exists)(c)&&await(0,k.rimraf)(c,k.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(c){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const s=this.getBackupPath(o);try{await v.promises.rename(c,s)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(c){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const s=this.getBackupPath(o);try{v.renameSync(c,s)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const c=[];for(const o of this.workspaces)await this.hasBackups(o)&&c.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&c.push(o);return c}hasBackups(c){let o;return p.URI.isUri(c)?o=this.getBackupPath(this.getFolderHash(c)):(0,n.isWorkspaceBackupInfo)(c)?o=this.getBackupPath(c.workspace.id):o=c.backupFolder,this.doHasBackups(o)}async doHasBackups(c){try{const o=await(0,k.readdir)(c);for(const s of o)try{if((await(0,k.readdir)((0,D.join)(c,s))).length>0)return!0}catch(t){}}catch(o){}return!1}saveSync(){try{(0,k.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}async save(){try{await(0,k.writeFile)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(c=>({id:c.workspace.id,configURIPath:c.workspace.configPath.toString(),remoteAuthority:c.remoteAuthority})),folderURIWorkspaces:this.folders.map(c=>c.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(c){let o;return c.scheme===m.Schemas.file?o=S.isLinux?c.fsPath:c.fsPath.toLowerCase():o=c.toString().toLowerCase(),(0,R.createHash)("md5").update(o).digest("hex")}};w=ce([Z(0,y.IEnvironmentMainService),Z(1,i.IConfigurationService),Z(2,g.ILogService)],w),e.BackupMainService=w}),define(X[42],Q([0,1,5,32,11,17,3,26,50,22,7,31,4,27,66,6,8,23,52,2]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d,m,b,w,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,E.createDecorator)("nativeHostMainService");let o=class rt extends c.Disposable{constructor(t,r,a,u,h,f,P,A){super();this.sharedProcess=t,this.windowsMainService=r,this.dialogMainService=a,this.lifecycleMainService=u,this.environmentMainService=h,this.telemetryService=f,this.logService=P,this.productService=A,this.onDidOpenWindow=v.Event.map(this.windowsMainService.onDidOpenWindow,F=>F.id),this.onDidMaximizeWindow=v.Event.filter(v.Event.fromNodeEventEmitter(D.app,"browser-window-maximize",(F,N)=>N.id),F=>!!this.windowsMainService.getWindowById(F)),this.onDidUnmaximizeWindow=v.Event.filter(v.Event.fromNodeEventEmitter(D.app,"browser-window-unmaximize",(F,N)=>N.id),F=>!!this.windowsMainService.getWindowById(F)),this.onDidBlurWindow=v.Event.filter(v.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(F,N)=>N.id),F=>!!this.windowsMainService.getWindowById(F)),this.onDidFocusWindow=v.Event.any(v.Event.map(v.Event.filter(v.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),F=>!!F),F=>F.id),v.Event.filter(v.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(F,N)=>N.id),F=>!!this.windowsMainService.getWindowById(F))),this.onDidResumeOS=v.Event.fromNodeEventEmitter(D.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new v.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new v.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=v.Event.debounce(v.Event.any(v.Event.filter(v.Event.fromNodeEventEmitter(D.screen,"display-metrics-changed",(F,N,j)=>j),F=>!(Array.isArray(F)&&F.length===1&&F[0]==="workArea")),v.Event.fromNodeEventEmitter(D.screen,"display-added"),v.Event.fromNodeEventEmitter(D.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){D.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:D.nativeTheme.shouldUseInvertedColorScheme||D.nativeTheme.shouldUseHighContrastColors,dark:D.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(r=>{var a,u;return{id:r.id,workspace:r.openedWorkspace,title:(u=(a=r.win)===null||a===void 0?void 0:a.getTitle())!==null&&u!==void 0?u:"",filename:r.getRepresentedFilename(),dirty:r.isDocumentEdited()}})}async getWindowCount(t){return this.windowsMainService.getWindowCount()}async getActiveWindowId(t){const r=D.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(r)return r.id}openWindow(t,r,a){return Array.isArray(r)?this.doOpenWindow(t,r,a):this.doOpenEmptyWindow(t,r)}async doOpenWindow(t,r,a=Object.create(null)){r.length>0&&this.windowsMainService.open({context:5,contextWindowId:t,urisToOpen:r,cli:this.environmentMainService.args,forceNewWindow:a.forceNewWindow,forceReuseWindow:a.forceReuseWindow,preferNewWindow:a.preferNewWindow,diffMode:a.diffMode,addMode:a.addMode,gotoLineMode:a.gotoLineMode,noRecentEntry:a.noRecentEntry,waitMarkerFileURI:a.waitMarkerFileURI,remoteAuthority:a.remoteAuthority||void 0})}async doOpenEmptyWindow(t,r){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:t},r)}async toggleFullScreen(t){const r=this.windowById(t);r&&r.toggleFullScreen()}async handleTitleDoubleClick(t){const r=this.windowById(t);r&&r.handleTitleDoubleClick()}async isMaximized(t){const r=this.windowById(t);return(r==null?void 0:r.win)?r.win.isMaximized():!1}async maximizeWindow(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.maximize()}async unmaximizeWindow(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.unmaximize()}async minimizeWindow(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.minimize()}async focusWindow(t,r){var a;r&&typeof r.windowId=="number"&&(t=r.windowId);const u=this.windowById(t);u&&u.focus({force:(a=r==null?void 0:r.force)!==null&&a!==void 0?a:!1})}async setMinimumSize(t,r,a){const u=this.windowById(t);if(u==null?void 0:u.win){const[h,f]=u.win.getSize(),[P,A]=u.win.getMinimumSize(),[F,N]=[r!=null?r:P,a!=null?a:A],[j,G]=[Math.max(h,F),Math.max(f,N)];(P!==F||A!==N)&&u.win.setMinimumSize(F,N),(h!==j||f!==G)&&u.win.setSize(j,G)}}async showMessageBox(t,r){return this.dialogMainService.showMessageBox(r,this.toBrowserWindow(t))}async showSaveDialog(t,r){return this.dialogMainService.showSaveDialog(r,this.toBrowserWindow(t))}async showOpenDialog(t,r){return this.dialogMainService.showOpenDialog(r,this.toBrowserWindow(t))}toBrowserWindow(t){const r=this.windowById(t);if(r==null?void 0:r.win)return r.win}async pickFileFolderAndOpen(t,r){const a=await this.dialogMainService.pickFileFolder(r);a&&(this.sendPickerTelemetry(a,r.telemetryEventName||"openFileFolder",r.telemetryExtraData),this.doOpenPicked(await Promise.all(a.map(async u=>await i.SymlinkSupport.existsDirectory(u)?{folderUri:L.URI.file(u)}:{fileUri:L.URI.file(u)})),r,t))}async pickFolderAndOpen(t,r){const a=await this.dialogMainService.pickFolder(r);a&&(this.sendPickerTelemetry(a,r.telemetryEventName||"openFolder",r.telemetryExtraData),this.doOpenPicked(a.map(u=>({folderUri:L.URI.file(u)})),r,t))}async pickFileAndOpen(t,r){const a=await this.dialogMainService.pickFile(r);a&&(this.sendPickerTelemetry(a,r.telemetryEventName||"openFile",r.telemetryExtraData),this.doOpenPicked(a.map(u=>({fileUri:L.URI.file(u)})),r,t))}async pickWorkspaceAndOpen(t,r){const a=await this.dialogMainService.pickWorkspace(r);a&&(this.sendPickerTelemetry(a,r.telemetryEventName||"openWorkspace",r.telemetryExtraData),this.doOpenPicked(a.map(u=>({workspaceUri:L.URI.file(u)})),r,t))}doOpenPicked(t,r,a){this.windowsMainService.open({context:3,contextWindowId:a,cli:this.environmentMainService.args,urisToOpen:t,forceNewWindow:r.forceNewWindow})}sendPickerTelemetry(t,r,a){const u=t?t.length:0;this.telemetryService.publicLog(r,Object.assign(Object.assign({},a),{outcome:u?"success":"canceled",numberOfPaths:u}))}async showItemInFolder(t,r){D.shell.showItemInFolder(r)}async setRepresentedFilename(t,r){const a=this.windowById(t);a&&a.setRepresentedFilename(r)}async setDocumentEdited(t,r){const a=this.windowById(t);a&&a.setDocumentEdited(r)}async openExternal(t,r){return k.isLinuxSnap?this.safeSnapOpenExternal(r):D.shell.openExternal(r),!0}safeSnapOpenExternal(t){const r=process.env.GDK_PIXBUF_MODULE_FILE,a=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,D.shell.openExternal(t),process.env.GDK_PIXBUF_MODULE_FILE=r,process.env.GDK_PIXBUF_MODULEDIR=a}async moveItemToTrash(t,r){return D.shell.moveItemToTrash(r)}async isAdmin(){let t;return k.isWindows?t=(await new Promise((r,a)=>{$(["native-is-elevated"],r,a)}))():t=process.getuid()===0,t}async writeElevated(t,r,a,u){const h=await new Promise((f,P)=>{$(["sudo-prompt"],f,P)});return new Promise((f,P)=>{const A=[`"${this.cliPath}"`];(u==null?void 0:u.unlock)&&A.push("--file-chmod"),A.push("--file-write",`"${r.fsPath}"`,`"${a.fsPath}"`);const F={name:this.productService.nameLong.replace("-",""),icns:k.isMacintosh&&this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};h.exec(A.join(" "),F,(N,j,G)=>{j&&this.logService.trace(`[sudo-prompt] received stdout: ${j}`),G&&this.logService.trace(`[sudo-prompt] received stderr: ${G}`),N?P(N):f(void 0)})})}get cliPath(){return k.isWindows?this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):k.isLinux?this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,b.join)(this.environmentMainService.appRoot,"bin","code"):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,p.totalmem)(),freemem:(0,p.freemem)(),loadavg:(0,p.loadavg)()}}async getOSProperties(){return{arch:(0,p.arch)(),platform:(0,p.platform)(),release:(0,p.release)(),type:(0,p.type)(),cpus:(0,p.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}async killProcess(t,r,a){process.kill(r,a)}async readClipboardText(t,r){return D.clipboard.readText(r)}async writeClipboardText(t,r,a){return D.clipboard.writeText(r,a)}async readClipboardFindText(t){return D.clipboard.readFindText()}async writeClipboardFindText(t,r){return D.clipboard.writeFindText(r)}async writeClipboardBuffer(t,r,a,u){return D.clipboard.writeBuffer(r,Buffer.from(a),u)}async readClipboardBuffer(t,r){return D.clipboard.readBuffer(r)}async hasClipboard(t,r,a){return D.clipboard.has(r,a)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){D.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){D.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){D.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){D.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){D.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(t,r){const a=this.windowById(t);a&&a.updateTouchBar(r)}async notifyReady(t){const r=this.windowById(t);r&&r.setReady()}async relaunch(t,r){return this.lifecycleMainService.relaunch(r)}async reload(t,r){const a=this.windowById(t);if(a)return this.lifecycleMainService.reload(a,(r==null?void 0:r.disableExtensions)!==void 0?{_:[],"disable-extensions":r==null?void 0:r.disableExtensions}:void 0)}async closeWindow(t){this.closeWindowById(t,t)}async closeWindowById(t,r){const a=this.windowById(r);if(a==null?void 0:a.win)return a.win.close()}async quit(t){const r=this.windowsMainService.getLastActiveWindow();(r==null?void 0:r.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1&&r.win?r.win.close():setTimeout(()=>{this.lifecycleMainService.quit()},10)}async exit(t,r){await this.lifecycleMainService.kill(r)}async resolveProxy(t,r){var a,u;const h=this.windowById(t),f=(u=(a=h==null?void 0:h.win)===null||a===void 0?void 0:a.webContents)===null||u===void 0?void 0:u.session;if(f)return f.resolveProxy(r)}async openDevTools(t,r){const a=this.windowById(t);(a==null?void 0:a.win)&&a.win.webContents.openDevTools(r)}async toggleDevTools(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.webContents.toggleDevTools()}async sendInputEvent(t,r){const a=this.windowById(t);(a==null?void 0:a.win)&&(r.type==="mouseDown"||r.type==="mouseUp")&&a.win.webContents.sendInputEvent(r)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(t,r,a,u){if(!!k.isWindows){const h=await new Promise((f,P)=>{$(["vscode-windows-registry"],f,P)});try{return h.GetStringRegKey(r,a,u)}catch(f){return}}}async getPassword(t,r,a){const u=await this.withKeytar(),h=await u.getPassword(r,a);if(h)try{let{content:f,hasNextChunk:P}=JSON.parse(h);if(!f||!P)return h;let A=1;for(;P;){const F=await u.getPassword(r,`${a}-${A}`),N=JSON.parse(F);f+=N.content,P=N.hasNextChunk}return f}catch(f){return h}return h}async setPassword(t,r,a,u){const h=await this.withKeytar();if(k.isWindows&&u.length>rt.MAX_PASSWORD_LENGTH){let f=0,P=0,A=!0;for(;A;){const F=u.substring(f,f+rt.PASSWORD_CHUNK_SIZE);f+=rt.PASSWORD_CHUNK_SIZE,A=u.length-f>0;const N={content:F,hasNextChunk:A};await h.setPassword(r,P?`${a}-${P}`:a,JSON.stringify(N)),P++}}else await h.setPassword(r,a,u);this._onDidChangePassword.fire({service:r,account:a})}async deletePassword(t,r,a){const h=await(await this.withKeytar()).deletePassword(r,a);return h&&this._onDidChangePassword.fire({service:r,account:a}),h}async findPassword(t,r){return(await this.withKeytar()).findPassword(r)}async findCredentials(t,r){return(await this.withKeytar()).findCredentials(r)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((t,r)=>{$(["keytar"],t,r)})}windowById(t){if(typeof t=="number")return this.windowsMainService.getWindowById(t)}};o.MAX_PASSWORD_LENGTH=2500,o.PASSWORD_CHUNK_SIZE=o.MAX_PASSWORD_LENGTH-100,ce([l.memoize],o.prototype,"cliPath",null),o=ce([Z(1,R.IWindowsMainService),Z(2,y.IDialogMainService),Z(3,S.ILifecycleMainService),Z(4,n.IEnvironmentMainService),Z(5,g.ITelemetryService),Z(6,m.ILogService),Z(7,w.IProductService)],o),e.NativeHostMainService=o}),define(X[217],Q([0,1,2,5,79,11,6,32,42,89,28,23,25]),function($,e,v,R,D,S,k,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let d=class extends v.Disposable{constructor(b,w,l,c,o){super();this.logService=b,this.windowsMainService=w,this.nativeHostMainService=l,this.encryptionMainService=c,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const b=R.Event.fromNodeEventEmitter(S.app,"login",(w,l,c,o,s)=>({event:w,webContents:l,req:c,authInfo:o,callback:s}));this._register(b(this.onLogin,this))}async onLogin({event:b,authInfo:w,req:l,callback:c}){if(!!w.isProxy){if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&l.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(w);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}c(o==null?void 0:o.username,o==null?void 0:o.password)}}async resolveProxyCredentials(b){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.doResolveProxyCredentials(b);if(w)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(b){var w,l,c,o;this.logService.trace("auth#doResolveProxyCredentials - enter",b);const s=String((0,D.hash)({scheme:b.scheme,host:b.host,port:b.port}));let t,r;try{const f=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,s);if(f){const P=JSON.parse(await this.encryptionMainService.decrypt(f));t=P.username,r=P.password}}catch(f){this.logService.error(f)}if(this.state!==p.StoredCredentialsUsed&&typeof t=="string"&&typeof r=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:t,password:r};const a=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const u={authInfo:b,username:(l=(w=this.sessionCredentials)===null||w===void 0?void 0:w.username)!==null&&l!==void 0?l:t,password:(o=(c=this.sessionCredentials)===null||c===void 0?void 0:c.password)!==null&&o!==void 0?o:r,replyChannel:`vscode:proxyAuthResponse:${(0,L.generateUuid)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",E.CancellationToken.None,u),this.state=p.LoginDialogShown;const h=await new Promise(f=>{var P;const A=async(F,N,j)=>{var G;if(N===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),(G=a.win)===null||G===void 0||G.webContents.off("ipc-message",A),j){const ne={username:j.username,password:j.password};try{if(j.remember){const oe=await this.encryptionMainService.encrypt(JSON.stringify(ne));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,s,oe)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,s)}catch(oe){this.logService.error(oe)}f({username:ne.username,password:ne.password})}else f(void 0)};(P=a.win)===null||P===void 0||P.webContents.on("ipc-message",A)});return this.sessionCredentials=h,h}};d=ce([Z(0,k.ILogService),Z(1,n.IWindowsMainService),Z(2,y.INativeHostMainService),Z(3,i.IEncryptionMainService),Z(4,g.IProductService)],d),e.ProxyAuthHandler=d}),define(X[218],Q([0,1,215,32,57,2,33,58,169,3,5,78,103,10,17,42]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function b(c){return c<21}let w=class{constructor(o,s,t,r,a){this.windowServer=o,this.options=s,this.windowsMainService=t,this.lifecycleMainService=r,this.nativeHostMainService=a,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(o){return this.registeredWindowIds.add(o),this.reloadingWindowIds.delete(o),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(o){this.reloadingWindowIds.add(o)}async getWindowIds(){return this.windowsMainService.getWindows().map(o=>o.id).filter(o=>this.registeredWindowIds.has(o)&&!this.reloadingWindowIds.has(o))}async capturePage(o){await this.whenUnfrozen(o);const s=this.windowsMainService.getWindowById(o);if(!(s==null?void 0:s.win))throw new Error("Invalid window");return(await s.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(o){await this.whenUnfrozen(o);const s=this.windowsMainService.getWindowById(o);if(!s)throw new Error("Invalid window");this.reloadingWindowIds.add(o),this.lifecycleMainService.reload(s)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(o,s){await this.whenUnfrozen(o);const t=E.KeybindingParser.parseUserBinding(s);for(let r of t)await this._dispatchKeybinding(o,r)}async _dispatchKeybinding(o,s){if(s instanceof g.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const t=this.windowsMainService.getWindowById(o);if(!(t==null?void 0:t.win))throw new Error("Invalid window");const r=t.win.webContents,a=new n.SimpleKeybinding(!1,!1,!1,!1,s.keyCode),h=new y.USLayoutResolvedKeybinding(a.toChord(),i.OS).getElectronAccelerator(),f=[];s.ctrlKey&&f.push("ctrl"),s.metaKey&&f.push("meta"),s.shiftKey&&f.push("shift"),s.altKey&&f.push("alt"),r.sendInputEvent({type:"keyDown",keyCode:h,modifiers:f}),b(s.keyCode)||r.sendInputEvent({type:"char",keyCode:h,modifiers:f}),r.sendInputEvent({type:"keyUp",keyCode:h,modifiers:f}),await(0,p.timeout)(100)}async click(o,s,t,r){await(await this.getWindowDriver(o)).click(s,t,r)}async doubleClick(o,s){await(await this.getWindowDriver(o)).doubleClick(s)}async setValue(o,s,t){await(await this.getWindowDriver(o)).setValue(s,t)}async getTitle(o){return await(await this.getWindowDriver(o)).getTitle()}async isActiveElement(o,s){return await(await this.getWindowDriver(o)).isActiveElement(s)}async getElements(o,s,t){return await(await this.getWindowDriver(o)).getElements(s,t)}async getElementXY(o,s,t,r){return await(await this.getWindowDriver(o)).getElementXY(s,t,r)}async typeInEditor(o,s,t){await(await this.getWindowDriver(o)).typeInEditor(s,t)}async getTerminalBuffer(o,s){return await(await this.getWindowDriver(o)).getTerminalBuffer(s)}async writeInTerminal(o,s,t){await(await this.getWindowDriver(o)).writeInTerminal(s,t)}async getWindowDriver(o){await this.whenUnfrozen(o);const s=`window:${o}`,t=new k.StaticRouter(a=>a===s),r=this.windowServer.getChannel("windowDriver",t);return new v.WindowDriverChannelClient(r)}async whenUnfrozen(o){for(;this.reloadingWindowIds.has(o);)await L.Event.toPromise(this.onDidReloadingChange.event)}};w=ce([Z(2,R.IWindowsMainService),Z(3,d.ILifecycleMainService),Z(4,m.INativeHostMainService)],w),e.Driver=w;async function l(c,o,s,t){const r=s.driverVerbose,a=t.createInstance(w,c,{verbose:r}),u=new v.WindowDriverRegistryChannel(a);c.registerChannel("windowDriverRegistry",u);const h=await(0,D.serve)(o),f=new v.DriverChannel(a);return h.registerChannel("driver",f),(0,S.combinedDisposable)(h,c)}e.serve=l}),define(X[219],Q([0,1,61,57]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,S,k,n){const y=L=>n(L,void 0),i=v.createConnection({host:D,port:S},()=>{i.removeListener("error",y);const L=Buffer.alloc(16);for(let d=0;d<16;d++)L[d]=Math.round(Math.random()*256);const g=L.toString("base64");let E=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${S}/?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];i.write(E.join(`\r
`)+`\r
\r
`);const p=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(i.off("data",p),n(void 0,new R.NodeSocket(i)))};i.on("data",p)});i.once("error",y)}}}),define(X[220],Q([0,1,61,10,2,113,6,23,184,56,219,73]),function($,e,v,R,D,S,k,n,y,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function E(b,w,l,c){return new p(b,w,l,c).waitForReady()}class p extends D.Disposable{constructor(w,l,c,o){super();this.suggestedLocalPort=o,this.public=!1,this._socketsDispose=new Map,this._options=w,this._server=v.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(l=>{l()})}async waitForReady(){var w;let l=await(0,S.findFreePortFaster)((w=this.suggestedLocalPort)!==null&&w!==void 0?w:this.tunnelRemotePort,2,1e3),c=null;return c=this._server.listen(l).address(),c||(l=0,c=this._server.listen(l).address()),this.tunnelLocalPort=c.port,await this._barrier.wait(),this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(w){w.pause();const l=await(0,y.connectRemoteAgentTunnel)(this._options,this.tunnelRemotePort),c=l.getSocket().socket,o=l.readEntireBuffer();l.dispose(),o.byteLength>0&&w.write(o.buffer),w.on("end",()=>{this._socketsDispose.delete(w.localAddress),c.end()}),w.on("close",()=>c.end()),w.on("error",()=>{this._socketsDispose.delete(w.localAddress),c.destroy()}),c.on("end",()=>w.end()),c.on("close",()=>w.end()),c.on("error",()=>{w.destroy()}),w.pipe(c),c.pipe(w),this._socketsDispose.set(w.localAddress,()=>{w.end(),c.end()})}}let d=class extends i.AbstractTunnelService{constructor(w,l,c,o){super(l);this.socketFactory=w,this.signService=c,this.productService=o}retainOrCreateTunnel(w,l,c,o,s,t){const r=this.getTunnelFromMap(l,c);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,l,c,o,s,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${l}:${c} on local port ${o}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:w,signService:this.signService,logService:this.logService,ipcLogger:null},u=E(a,l,c,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(l,c,u),u}}};d=ce([Z(1,k.ILogService),Z(2,g.ISignService),Z(3,n.IProductService)],d),e.BaseTunnelService=d;let m=class extends d{constructor(w,l,c){super(L.nodeSocketFactory,w,l,c)}};m=ce([Z(0,k.ILogService),Z(1,g.ISignService),Z(2,n.IProductService)],m),e.TunnelService=m}),define(X[221],Q([0,1,214,186,2,13,18,185,24,6,20,47,70]),function($,e,v,R,D,S,k,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let p=class extends D.Disposable{constructor(m,b,w){super();this.environmentService=b,this.logService=w,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,b){this.logService.trace("RequestService#request",m.url);const{proxyUrl:w,strictSSL:l}=this,c=m.agent?m.agent:await(0,n.getProxyAgent)(m.url||"",await(0,E.resolveShellEnv)(this.logService,this.environmentService.args,process.env),{proxyUrl:w,strictSSL:l});return m.agent=c,m.strictSSL=l,this.authorization&&(m.headers=Object.assign(Object.assign({},m.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(m,b)}async getNodeRequest(m){return((0,R.parse)(m.url).protocol==="https:"?await new Promise((l,c)=>{$(["https"],l,c)}):await new Promise((l,c)=>{$(["http"],l,c)})).request}_request(m,b){return new Promise(async(w,l)=>{let c;const o=(0,R.parse)(m.url),s=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),t={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,S.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(t.auth=m.user+":"+m.password),c=s(t,r=>{const a=(0,S.isNumber)(m.followRedirects)?m.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&a>0&&r.headers.location)this._request(Object.assign(Object.assign({},m),{url:r.headers.location,followRedirects:a-1}),b).then(w,l);else{let u=r;r.headers["content-encoding"]==="gzip"&&(u=r.pipe((0,v.createGunzip)())),w({res:r,stream:(0,L.streamToBufferReadableStream)(u)})}}),c.on("error",l),m.timeout&&c.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&c.write(m.data),c.end(),b.onCancellationRequested(()=>{c.abort(),l((0,k.canceled)())})})}async resolveProxy(m){}};p=ce([Z(0,y.IConfigurationService),Z(1,g.INativeEnvironmentService),Z(2,i.ILogService)],p),e.RequestService=p}),define(X[222],Q([0,1,221,11]),function($,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(k){return R.net.request}class S extends v.RequestService{request(n,y){return super.request(Object.assign(Object.assign({},n||{}),{getRawRequest:D}),y)}}e.RequestMainService=S}),define(X[223],Q([0,1,54,11,26,10,6,17,74,9,3,2,84,13,5,70,55]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let w=class extends g.Disposable{constructor(c,o,s,t,r,a,u){super();this.machineId=c,this.userEnv=o,this.environmentMainService=s,this.lifecycleMainService=t,this.logService=r,this.themeMainService=a,this.protocolMainService=u,this.firstWindowConnectionBarrier=new S.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new d.Emitter),this.onDidError=d.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),R.ipcMain.on("vscode:createSharedProcessMessageChannel",async(c,o)=>this.onWindowConnection(c,o))}async onWindowConnection(c,o){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const s=await this.connect();if(c.sender.isDestroyed())return s.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",o,[s])}onWillShutdown(){const c=this.window;!c||(!c.isDestroyed()&&!c.webContents.isDestroyed()&&c.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch(o){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>R.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.userEnv=Object.assign(Object.assign({},this.userEnv),await(0,m.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env)),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>R.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new R.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:i.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`],v8CacheOptions:L.browserCodeLoadingCacheStrategy,nodeIntegration:!0,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:v.default}),this.window.loadURL(i.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",$).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{var o;this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),((o=this.window)===null||o===void 0?void 0:o.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,o)=>this._onDidError.fire({type:2,details:o})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1,details:"SharedProcess: detected unresponsive window"})),this.window.webContents.on("did-fail-load",(c,o,s)=>this._onDidError.fire({type:3,details:`SharedProcess: failed to load: ${s}`})))}async connect(){await this.whenIpcReady;const c=(0,p.assertIsDefined)(this.window);return(0,E.connect)(c)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){var c,o;return(o=(c=this.window)===null||c===void 0?void 0:c.isVisible())!==null&&o!==void 0?o:!1}};w=ce([Z(2,D.IEnvironmentMainService),Z(3,n.ILifecycleMainService),Z(4,k.ILogService),Z(5,y.IThemeMainService),Z(6,b.IProtocolMainService)],w),e.SharedProcess=w}),define(X[76],Q([0,1,5,10,24,17,23,41,26,6,40,25]),function($,e,v,R,D,S,k,n,y,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(d,m,b){return`${b.updateUrl}/api/update/${d}/${m}/${b.commit}`}e.createUpdateURL=E;let p=class{constructor(m,b,w,l,c,o){this.lifecycleMainService=m,this.configurationService=b,this.environmentMainService=w,this.requestService=l,this.logService=c,this.productService=o,this._state=n.State.Uninitialized,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}initialize(){if(!!this.environmentMainService.isBuilt){if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const m=(0,D.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),b=this.getProductQuality(m);if(!b){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(b),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(n.State.Idle(this.getUpdateType())),m==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(null),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,w=>this.logService.error(w))}}getProductQuality(m){return m==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(m=60*60*1e3){return(0,R.timeout)(m).then(()=>this.checkForUpdates(null)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(m){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},g.CancellationToken.None).then(m=>m.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};p=ce([Z(0,S.ILifecycleMainService),Z(1,D.IConfigurationService),Z(2,y.IEnvironmentMainService),Z(3,L.IRequestService),Z(4,i.ILogService),Z(5,k.IProductService)],p),e.AbstractUpdateService=p}),define(X[224],Q([0,1,11,2,5,52,24,17,41,31,26,6,76,40,23]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let m=class extends E.AbstractUpdateService{constructor(w,l,c,o,s,t,r){super(w,l,o,s,t,r);this.telemetryService=c,this.disposables=new R.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"error",(w,l)=>l)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(w,l,c)=>({url:l,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(w,l,c,o)=>({releaseNotes:l,version:c,productVersion:c,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(w){this.logService.error("UpdateService error:",w);const c=(this.state.type==="checking for updates"?!!this.state.context:!0)?w:void 0;this.setState(y.State.Idle(1,c))}buildUpdateFeedUrl(w){let l;this.productService.darwinUniversalAssetId?l=this.productService.darwinUniversalAssetId:l=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,E.createUpdateURL)(l,w,this.productService);try{v.autoUpdater.setFeedURL({url:c})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return c}doCheckForUpdates(w){this.setState(y.State.CheckingForUpdates(w)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(w){this.state.type==="checking for updates"&&this.setState(y.State.Downloading(w))}onUpdateDownloaded(w){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:w.version}),this.setState(y.State.Ready(w)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!this.state.context}),this.setState(y.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ce([S.memoize],m.prototype,"onRawError",null),ce([S.memoize],m.prototype,"onRawUpdateNotAvailable",null),ce([S.memoize],m.prototype,"onRawUpdateAvailable",null),ce([S.memoize],m.prototype,"onRawUpdateDownloaded",null),m=ce([Z(0,n.ILifecycleMainService),Z(1,k.IConfigurationService),Z(2,i.ITelemetryService),Z(3,L.IEnvironmentMainService),Z(4,p.IRequestService),Z(5,g.ILogService),Z(6,d.IProductService)],m),e.DarwinUpdateService=m}),define(X[225],Q([0,1,23,24,17,41,31,26,6,76,40,25,42]),function($,e,v,R,D,S,k,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends i.AbstractUpdateService{constructor(m,b,w,l,c,o,s,t){super(m,b,l,c,o,t);this.telemetryService=w,this.nativeHostMainService=s}buildUpdateFeedUrl(m){return(0,i.createUpdateURL)(`linux-${process.arch}`,m,this.productService)}doCheckForUpdates(m){!this.url||(this.setState(S.State.CheckingForUpdates(m)),this.requestService.request({url:this.url},g.CancellationToken.None).then(L.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(S.State.Idle(1))):this.setState(S.State.AvailableForDownload(b))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m});const w=m?b.message||b:void 0;this.setState(S.State.Idle(1,w))}))}async doDownloadUpdate(m){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):m.update.url&&this.nativeHostMainService.openExternal(void 0,m.update.url),this.setState(S.State.Idle(1))}};p=ce([Z(0,D.ILifecycleMainService),Z(1,R.IConfigurationService),Z(2,k.ITelemetryService),Z(3,n.IEnvironmentMainService),Z(4,L.IRequestService),Z(5,y.ILogService),Z(6,E.INativeHostMainService),Z(7,v.IProductService)],p),e.LinuxUpdateService=p}),define(X[226],Q([0,1,5,10,17,41,26,6,8,21,46,31]),function($,e,v,R,D,S,k,n,y,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{constructor(m,b,w){if(this.lifecycleMainService=m,this.logService=w,this._state=S.State.Uninitialized,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,b.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(S.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,l=>this.logService.error(l))}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}scheduleCheckForUpdates(m=60*60*1e3){return(0,R.timeout)(m).then(()=>this.checkForUpdates(null)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(m){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};E=ce([Z(0,D.ILifecycleMainService),Z(1,k.IEnvironmentMainService),Z(2,n.ILogService)],E);let p=class extends E{constructor(m,b,w,l,c,o){super(w,l,c);this.snap=m,this.snapRevision=b,this.telemetryService=o;const s=(0,i.watch)(y.dirname(this.snap)),t=v.Event.fromNodeEventEmitter(s,"change",(h,f)=>f),r=v.Event.filter(t,h=>h==="current"),u=v.Event.debounce(r,(h,f)=>f,2e3)(this.checkForUpdates,this);w.onWillShutdown(()=>{u.dispose(),s.close()})}doCheckForUpdates(m){this.setState(S.State.CheckingForUpdates(m)),this.isUpdateAvailable().then(b=>{b?this.setState(S.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(S.State.Idle(2)))},b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(S.State.Idle(2,b.message||b))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,L.spawn)("sleep 3 && "+y.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const m=await new Promise((w,l)=>(0,i.realpath)(`${y.dirname(this.snap)}/current`,(c,o)=>c?l(c):w(o))),b=y.basename(m);return this.snapRevision!==b}isLatestVersion(){return this.isUpdateAvailable().then(void 0,m=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=ce([Z(2,D.ILifecycleMainService),Z(3,k.IEnvironmentMainService),Z(4,n.ILogService),Z(5,g.ITelemetryService)],p),e.SnapUpdateService=p}),define(X[227],Q([0,1,21,8,22,52,24,17,23,41,31,26,6,76,40,109,27,46,25,10,16,7,42]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d,m,b,w,l,c,o,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(f,P=1e3){for(;!f();)await(0,c.timeout)(P)}let a;function u(){return typeof a=="undefined"&&(a=v.existsSync(R.join(R.dirname(process.execPath),"unins000.exe"))?0:1),a}let h=class extends p.AbstractUpdateService{constructor(P,A,F,N,j,G,ne,oe,V){super(P,A,N,j,G,V);this.telemetryService=F,this.fileService=ne,this.nativeHostMainService=oe}get cachePath(){const P=R.join((0,b.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return v.promises.mkdir(P,{recursive:!0}).then(()=>P)}initialize(){super.initialize(),u()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(P){let A="win32";return process.arch!=="ia32"&&(A+=`-${process.arch}`),u()===1?A+="-archive":this.productService.target==="user"&&(A+="-user"),(0,p.createUpdateURL)(A,P,this.productService)}doCheckForUpdates(P){!this.url||(this.setState(i.State.CheckingForUpdates(P)),this.requestService.request({url:this.url},l.CancellationToken.None).then(d.asJson).then(A=>{const F=u();return!A||!A.url||!A.version||!A.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!P}),this.setState(i.State.Idle(F)),Promise.resolve(null)):F===1?(this.setState(i.State.AvailableForDownload(A)),Promise.resolve(null)):(this.setState(i.State.Downloading(A)),this.cleanup(A.version).then(()=>this.getUpdatePackagePath(A.version).then(N=>D.exists(N).then(j=>{if(j)return Promise.resolve(N);const G=A.url,ne=A.hash,oe=`${N}.tmp`;return this.requestService.request({url:G},l.CancellationToken.None).then(V=>this.fileService.writeFile(s.URI.file(oe),V.stream)).then(ne?()=>(0,m.checksum)(oe,A.hash):()=>{}).then(()=>v.promises.rename(oe,N)).then(()=>N)})).then(N=>{const j=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:N},j&&A.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(i.State.Downloaded(A)):this.setState(i.State.Ready(A))})))}).then(void 0,A=>{this.logService.error(A),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!P});const F=P?A.message||A:void 0;this.setState(i.State.Idle(u(),F))}))}async doDownloadUpdate(P){P.update.url&&this.nativeHostMainService.openExternal(void 0,P.update.url),this.setState(i.State.Idle(u()))}async getUpdatePackagePath(P){const A=await this.cachePath;return R.join(A,`CodeSetup-${this.productService.quality}-${P}.exe`)}async cleanup(P=null){const A=P?G=>!new RegExp(`${this.productService.quality}-${P}\\.exe$`).test(G):()=>!0,F=await this.cachePath,j=(await D.readdir(F)).filter(A).map(async G=>{try{await v.promises.unlink(R.join(F,G))}catch(ne){}});await Promise.all(j)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const P=this.state.update;this.setState(i.State.Updating(P));const A=await this.cachePath;this.availableUpdate.updateFilePath=R.join(A,`CodeSetup-${this.productService.quality}-${P.version}.flag`),await D.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,w.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(i.State.Idle(u()))});const N=`${this.productService.win32MutexName}-ready`,j=await new Promise((G,ne)=>{$(["windows-mutex"],G,ne)});r(()=>j.isActive(N)).then(()=>this.setState(i.State.Ready(P)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?v.unlinkSync(this.availableUpdate.updateFilePath):(0,w.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return u()}};ce([S.memoize],h.prototype,"cachePath",null),h=ce([Z(0,n.ILifecycleMainService),Z(1,k.IConfigurationService),Z(2,L.ITelemetryService),Z(3,g.IEnvironmentMainService),Z(4,d.IRequestService),Z(5,E.ILogService),Z(6,o.IFileService),Z(7,t.INativeHostMainService),Z(8,y.IProductService)],h),e.Win32UpdateService=h}),define(X[51],Q([0,1,29,26,8,22,21,3,5,6,60,44,9,2,15,4,149,23,11,13,49,50,98]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d,m,b,w,l,c,o,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,m.createDecorator)("workspacesManagementMainService");let r=class extends p.Disposable{constructor(f,P,A,F,N){super();this.environmentMainService=f,this.logService=P,this.backupMainService=A,this.dialogMainService=F,this.productService=N,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new y.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new y.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(f){if(!this.isWorkspacePath(f)||f.scheme!==E.Schemas.file)return null;let P;try{P=(0,k.readFileSync)(f.fsPath,"utf8")}catch(A){return null}return this.doResolveWorkspace(f,P)}isWorkspacePath(f){return(0,v.isUntitledWorkspace)(f,this.environmentMainService)||(0,v.hasWorkspaceFileExtension)(f)}doResolveWorkspace(f,P){try{const A=this.doParseStoredWorkspace(f,P),F=a(f);return{id:F.id,configPath:F.configPath,folders:(0,v.toWorkspaceFolders)(A.folders,F.configPath,d.extUriBiasedIgnorePathCase),remoteAuthority:A.remoteAuthority}}catch(A){this.logService.warn(A.toString())}return null}doParseStoredWorkspace(f,P){const A=(0,g.parse)(P);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(F=>(0,v.isStoredWorkspaceFolder)(F));else throw new Error(`${f.toString(!0)} looks like an invalid workspace file.`);return A}async createUntitledWorkspace(f,P){const{workspace:A,storedWorkspace:F}=this.newUntitledWorkspace(f,P),N=A.configPath.fsPath;return await k.promises.mkdir((0,D.dirname)(N),{recursive:!0}),await(0,S.writeFile)(N,JSON.stringify(F,null,"	")),A}createUntitledWorkspaceSync(f,P){const{workspace:A,storedWorkspace:F}=this.newUntitledWorkspace(f,P),N=A.configPath.fsPath;return(0,k.mkdirSync)((0,D.dirname)(N),{recursive:!0}),(0,S.writeFileSync)(N,JSON.stringify(F,null,"	")),A}newUntitledWorkspace(f=[],P){const A=(Date.now()+Math.round(Math.random()*1e3)).toString(),F=(0,d.joinPath)(this.untitledWorkspacesHome,A),N=(0,d.joinPath)(F,v.UNTITLED_WORKSPACE_NAME),j=[];for(const G of f)j.push((0,v.getStoredWorkspaceFolder)(G.uri,!0,G.name,F,!n.isWindows,d.extUriBiasedIgnorePathCase));return{workspace:a(N),storedWorkspace:{folders:j,remoteAuthority:P}}}async getWorkspaceIdentifier(f){return a(f)}isUntitledWorkspace(f){return(0,v.isUntitledWorkspace)(f.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(f){!this.isUntitledWorkspace(f)||(this.doDeleteUntitledWorkspaceSync(f),this._onDidDeleteUntitledWorkspace.fire(f))}async deleteUntitledWorkspace(f){this.deleteUntitledWorkspaceSync(f)}doDeleteUntitledWorkspaceSync(f){const P=(0,d.originalFSPath)(f.configPath);try{(0,S.rimrafSync)((0,D.dirname)(P));const A=(0,D.join)(this.environmentMainService.workspaceStorageHome.fsPath,f.id);(0,k.existsSync)(A)&&(0,S.writeFileSync)((0,D.join)(A,"obsolete"),"")}catch(A){this.logService.warn(`Unable to delete untitled workspace ${P} (${A}).`)}}getUntitledWorkspacesSync(){const f=[];try{const P=(0,S.readdirSync)(this.untitledWorkspacesHome.fsPath).map(A=>(0,d.joinPath)(this.untitledWorkspacesHome,A,v.UNTITLED_WORKSPACE_NAME));for(const A of P){const F=a(A),N=this.resolveLocalWorkspaceSync(A);N?f.push({workspace:F,remoteAuthority:N.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(F)}}catch(P){P.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${P}).`)}return f}async enterWorkspace(f,P,A){if(!f||!f.win||!f.isReady||!await this.isValidTargetWorkspacePath(f,P,A))return null;const N=this.doEnterWorkspace(f,a(A));return N?(this._onDidEnterWorkspace.fire({window:f,workspace:N.workspace}),N):null}async isValidTargetWorkspacePath(f,P,A){if(!A)return!0;if((0,v.isWorkspaceIdentifier)(f.openedWorkspace)&&d.extUriBiasedIgnorePathCase.isEqual(f.openedWorkspace.configPath,A))return!1;if((0,t.findWindowOnWorkspaceOrFolder)(P,A)){const F={title:this.productService.nameLong,type:"info",buttons:[(0,b.localize)(0,null)],message:(0,b.localize)(1,null,(0,d.basename)(A)),detail:(0,b.localize)(2,null),noLink:!0};return await this.dialogMainService.showMessageBox(F,(0,c.withNullAsUndefined)(l.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(f,P){if(!f.config)return null;f.focus();let A;return f.config.extensionDevelopmentPath||(A=this.backupMainService.registerWorkspaceBackupSync({workspace:P,remoteAuthority:f.remoteAuthority},f.config.backupPath)),(0,v.isWorkspaceIdentifier)(f.openedWorkspace)&&this.isUntitledWorkspace(f.openedWorkspace)&&this.deleteUntitledWorkspaceSync(f.openedWorkspace),f.config.workspace=P,f.config.backupPath=A,{workspace:P,backupPath:A}}};r=ce([Z(0,R.IEnvironmentMainService),Z(1,i.ILogService),Z(2,o.IBackupMainService),Z(3,s.IDialogMainService),Z(4,w.IProductService)],r),e.WorkspacesManagementMainService=r;function a(h){function f(){let P=h.scheme===E.Schemas.file?(0,d.originalFSPath)(h):h.toString();return n.isLinux||(P=P.toLowerCase()),(0,L.createHash)("md5").update(P).digest("hex")}return{id:f(),configPath:h}}e.getWorkspaceIdentifier=a;function u(h,f){function P(){if(h.scheme!==E.Schemas.file)return(0,L.createHash)("md5").update(h.toString()).digest("hex");if(!f)try{f=(0,k.statSync)(h.fsPath)}catch(N){return}let F;return n.isLinux?F=f.ino:n.isMacintosh?F=f.birthtime.getTime():n.isWindows&&(typeof f.birthtimeMs=="number"?F=Math.floor(f.birthtimeMs):F=f.birthtime.getTime()),(0,L.createHash)("md5").update(h.fsPath).update(F?String(F):"").digest("hex")}const A=P();if(typeof A=="string")return{id:A,uri:h}}e.getSingleFolderWorkspaceIdentifier=u}),define(X[99],Q([0,1,6,96,3,4,32,22,51,24,7,11,34,53,25,29,13]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,S.createDecorator)(e.ID);let w=class{constructor(c,o,s,t,r){this.logService=c,this.windowsMainService=o,this.urlService=s,this.workspacesManagementMainService=t,this.configurationService=r}async start(c,o){this.logService.trace("Received data from other instance: ",c,o),D.isMacintosh&&g.app.focus({steal:!0});const s=this.parseOpenUrl(c);if(s.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:r,url:a}of s)this.urlService.open(r,{originalUrl:a})})}else return this.startOpenWindow(c,o)}parseOpenUrl(c){return c["open-url"]&&c._urls&&c._urls.length>0?(0,E.coalesce)(c._urls.map(o=>{try{return{uri:L.URI.parse(o),url:o}}catch(s){return null}})):[]}async startOpenWindow(c,o){const s=(0,p.isLaunchedFromCli)(o)?0:4;let t=[];const r=c.wait&&c.waitMarkerFilePath?L.URI.file(c.waitMarkerFilePath):void 0,a=c.remote||void 0;if(c.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(c.extensionDevelopmentPath,{context:s,cli:c,userEnv:o,waitMarkerFileURI:r,remoteAuthority:a});else if(!c._.length&&!c["folder-uri"]&&!c["file-uri"]){let u=!1;if(c["new-window"]||c["unity-launch"])u=!0;else if(c["reuse-window"])u=!1;else{const h=this.configurationService.getValue("window");switch((h==null?void 0:h.openWithoutArgumentsInNewWindow)||"default"){case"on":u=!0;break;case"off":u=!1;break;default:u=!D.isMacintosh}}if(u)t=this.windowsMainService.open({context:s,cli:c,userEnv:o,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:r,remoteAuthority:a});else{const h=this.windowsMainService.getLastActiveWindow();h?(h.focus(),t=[h]):t=this.windowsMainService.open({context:s,cli:c,forceEmpty:!0,remoteAuthority:a})}}else t=this.windowsMainService.open({context:s,cli:c,userEnv:o,forceNewWindow:c["new-window"],preferNewWindow:!c["reuse-window"]&&!c.wait,forceReuseWindow:c["reuse-window"],diffMode:c.diff,addMode:c.add,noRecentEntry:!!c["skip-add-to-recently-opened"],waitMarkerFileURI:r,gotoLineMode:c.goto,remoteAuthority:a});if(r&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,(0,n.whenDeleted)(r.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const c=[];return g.BrowserWindow.getAllWindows().forEach(o=>{const s=this.windowsMainService.getWindowById(o.id);s?c.push(this.codeWindowToInfo(s)):c.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:c,screenReader:!!g.app.accessibilitySupportEnabled,gpuFeatureStatus:g.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(c){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(t=>new Promise(r=>{const a=t.remoteAuthority;if(a){const u=`vscode:getDiagnosticInfoResponse${t.id}`,h={includeProcesses:c.includeProcesses,folders:c.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",d.CancellationToken.None,{replyChannel:u,args:h}),g.ipcMain.once(u,(f,P)=>{P||r({hostName:a,errorMessage:`Unable to resolve connection to '${a}'.`}),r(P)}),setTimeout(()=>{r({hostName:a,errorMessage:`Fetching remote diagnostics for '${a}' timed out.`})},5e3)}else r(void 0)})))).filter(t=>!!t)}getFolderURIs(c){const o=[],s=c.openedWorkspace;if((0,m.isSingleFolderWorkspaceIdentifier)(s))o.push(s.uri);else if((0,m.isWorkspaceIdentifier)(s)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(s.configPath);t&&t.folders.forEach(a=>{o.push(a.uri)})}return o}codeWindowToInfo(c){const o=this.getFolderURIs(c),s=(0,b.assertIsDefined)(c.win);return this.browserWindowToInfo(s,o,c.remoteAuthority)}browserWindowToInfo(c,o=[],s){return{pid:c.webContents.getOSProcessId(),title:c.getTitle(),folderURIs:o,remoteAuthority:s}}};w=ce([Z(0,v.ILogService),Z(1,k.IWindowsMainService),Z(2,R.IURLService),Z(3,y.IWorkspacesManagementMainService),Z(4,i.IConfigurationService)],w),e.LaunchMainService=w}),define(X[228],Q([0,1,140,27,54,11,99,69,26,3,6,82,50,4,62,9,42,55,2]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d,m,b,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,p.createDecorator)("issueMainService");let c=class pt{constructor(s,t,r,a,u,h,f,P){this.userEnv=s,this.environmentMainService=t,this.launchMainService=r,this.logService=a,this.diagnosticsService=u,this.dialogMainService=h,this.nativeHostMainService=f,this.protocolMainService=P,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){S.ipcMain.on("vscode:issueSystemInfoRequest",async s=>{const[t,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),a=await this.diagnosticsService.getSystemInfo(t,r);this.safeSend(s,"vscode:issueSystemInfoResponse",a)}),S.ipcMain.on("vscode:listProcesses",async s=>{const t=[];try{const r=await this.launchMainService.getMainProcessId();t.push({name:(0,v.localize)(0,null),rootProcess:await(0,g.listProcesses)(r)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(u=>{(0,n.isRemoteDiagnosticError)(u)?t.push({name:u.hostName,rootProcess:u}):u.processes&&t.push({name:u.hostName,rootProcess:u.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(s,"vscode:listProcessesResponse",t)}),S.ipcMain.on("vscode:issueReporterClipboard",async s=>{const t={message:(0,v.localize)(1,null),type:"warning",buttons:[(0,v.localize)(2,null),(0,v.localize)(3,null)]};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(t,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",r.response===0)}}),S.ipcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const t=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",t)}),S.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={message:(0,v.localize)(4,null),type:"warning",buttons:[(0,v.localize)(5,null),(0,v.localize)(6,null)]};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),S.ipcMain.on("vscode:workbenchCommand",(s,t)=>{const{id:r,from:a,args:u}=t;let h;switch(a){case"issueReporter":h=this.issueReporterParentWindow;break;case"processExplorer":h=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${a}`)}h&&h.webContents.send("vscode:runAction",{id:r,from:a,args:u})}),S.ipcMain.on("vscode:openExternal",(s,t)=>{this.nativeHostMainService.openExternal(void 0,t)}),S.ipcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),S.ipcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),S.ipcMain.on("vscode:windowsInfoRequest",async s=>{const t=await this.launchMainService.getMainProcessInfo();this.safeSend(s,"vscode:windowsInfoResponse",t.windows)})}safeSend(s,t,...r){s.sender.isDestroyed()||s.sender.send(t,...r)}async openReporter(s){var t;if(!this.issueReporterWindow&&(this.issueReporterParentWindow=S.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new l.DisposableStore,a=r.add(this.protocolMainService.createIPCObjectUrl()),u=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(u,a,s.styles.backgroundColor,(0,v.localize)(7,null),s.zoomLevel),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,R.type)(),arch:(0,R.arch)(),release:(0,R.release)()},product:D.default}),this.issueReporterWindow.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",$,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}(t=this.issueReporterWindow)===null||t===void 0||t.focus()}async openProcessExplorer(s){var t;if(!this.processExplorerWindow&&(this.processExplorerParentWindow=S.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new l.DisposableStore,a=r.add(this.protocolMainService.createIPCObjectUrl()),u=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(u,a,s.styles.backgroundColor,(0,v.localize)(8,null),s.zoomLevel),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:D.default}),this.processExplorerWindow.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",$,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}(t=this.processExplorerWindow)===null||t===void 0||t.focus()}createBrowserWindow(s,t,r,a,u){const h=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:a,backgroundColor:r||pt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`],v8CacheOptions:"bypassHeatCheck",enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,d.zoomLevelToZoomFactor)(u),sandbox:!0,contextIsolation:!0}});return h.setMenuBarVisibility(!1),h}async getSystemStatus(){const[s,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,t)}getWindowPosition(s,t,r){let a;const u=S.screen.getAllDisplays();if(u.length===1)a=u[0];else{if(i.isMacintosh){const P=S.screen.getCursorScreenPoint();a=S.screen.getDisplayNearestPoint(P)}!a&&s&&(a=S.screen.getDisplayMatching(s.getBounds())),a||(a=S.screen.getPrimaryDisplay()||u[0])}const h={width:t,height:r},f=a.bounds;return h.x=f.x+f.width/2-h.width/2,h.y=f.y+f.height/2-h.height/2,f.width>0&&f.height>0&&(h.x<f.x&&(h.x=f.x),h.y<f.y&&(h.y=f.y),h.x>f.x+f.width&&(h.x=f.x),h.y>f.y+f.height&&(h.y=f.y),h.width>f.width&&(h.width=f.width),h.height>f.height&&(h.height=f.height)),h}async getPerformanceInfo(){try{const[s,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,t)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}};c.DEFAULT_BACKGROUND_COLOR="#1E1E1E",c=ce([Z(1,y.IEnvironmentMainService),Z(2,k.ILaunchMainService),Z(3,L.ILogService),Z(4,n.IDiagnosticsService),Z(5,E.IDialogMainService),Z(6,b.INativeHostMainService),Z(7,w.IProtocolMainService)],c),e.IssueMainService=c}),define(X[229],Q([0,1,27,54,8,145,172,5,7,11,26,6,24,23,62,2,3,32,29,51,49,193,74,31,50,39,197,17,97,16,9,53,25,42,55]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d,m,b,w,l,c,o,s,t,r,a,u,h,f,P,A,F,N,j,G,ne){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var oe;(function(Y){Y[Y.NONE=0]="NONE",Y[Y.LOADING=1]="LOADING",Y[Y.NAVIGATING=2]="NAVIGATING",Y[Y.READY=3]="READY"})(oe||(oe={}));let V=class extends m.Disposable{constructor(U,O,z,C,I,M,_,T,W,B,H,K,J,ee,re){super();this.logService=O,this.environmentMainService=z,this.fileService=C,this.configurationService=M,this.themeMainService=_,this.workspacesManagementMainService=T,this.backupMainService=W,this.telemetryService=B,this.dialogMainService=H,this.lifecycleMainService=K,this.nativeHostMainService=J,this.productService=ee,this.protocolMainService=re,this._onWillLoad=this._register(new n.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new n.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new n.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new n.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this._lastFocusTime=-1,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.readyState=0;{const[x,ie]=this.restoreWindowState(U.state);this.windowState=x,this.logService.trace("window#ctor: using window state",x);const ae=this.windowState.mode===0||this.windowState.mode===3,ue=this.configurationService.getValue("window"),pe={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:d.WindowMinimumSize.WIDTH,minHeight:d.WindowMinimumSize.HEIGHT,show:!ae,title:this.productService.nameLong,webPreferences:Object.assign({preload:F.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:b.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:(0,d.zoomLevelToZoomFactor)(ue==null?void 0:ue.zoomLevel)},this.environmentMainService.sandbox?{sandbox:!0,contextIsolation:!0}:{nodeIntegration:!0})};b.browserCodeLoadingCacheStrategy?this.logService.trace(`window#ctor: using vscode-file:// protocol and V8 cache options: ${b.browserCodeLoadingCacheStrategy}`):this.logService.info("window#ctor: vscode-file:// protocol is explicitly disabled"),b.isLinux?pe.icon=(0,D.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):b.isWindows&&!this.environmentMainService.isBuilt&&(pe.icon=(0,D.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),b.isMacintosh&&!this.useNativeFullScreen()&&(pe.fullscreenable=!1),b.isMacintosh&&(pe.acceptFirstMouse=!0,(ue==null?void 0:ue.clickThroughInactive)===!1&&(pe.acceptFirstMouse=!1));const me=b.isMacintosh&&(ue==null?void 0:ue.nativeTabs)===!0;me&&(pe.tabbingIdentifier=this.productService.nameShort);const fe=(0,d.getTitleBarStyle)(this.configurationService)==="custom";if(fe&&(pe.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,b.isMacintosh||(pe.frame=!1)),this._win=new i.BrowserWindow(pe),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),b.isMacintosh&&fe&&this._win.setSheetOffset(22),b.isMacintosh&&ie&&(!me||i.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ve=>typeof ve=="number")){const ve=this.windowState;this._win.setBounds({width:ve.width,height:ve.height,x:ve.x,y:ve.y})}ae&&(this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show()),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,s.resolveMarketplaceHeaders)(this.productService.version,this.environmentMainService,this.fileService,{get:x=>I.globalStorage.get(x),store:(x,ie)=>I.globalStorage.set(x,ie)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var U;return(U=this.currentConfig)===null||U===void 0?void 0:U.backupPath}get openedWorkspace(){var U;return(U=this.currentConfig)===null||U===void 0?void 0:U.workspace}get remoteAuthority(){var U;return(U=this.currentConfig)===null||U===void 0?void 0:U.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var U;return!!((U=this.currentConfig)===null||U===void 0?void 0:U.extensionDevelopmentPath)}get isExtensionTestHost(){var U;return!!((U=this.currentConfig)===null||U===void 0?void 0:U.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var U;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((U=this.currentConfig)===null||U===void 0?void 0:U.debugId)}setRepresentedFilename(U){b.isMacintosh?this._win.setRepresentedFilename(U):this.representedFilename=U}getRepresentedFilename(){return b.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(U){b.isMacintosh&&this._win.setDocumentEdited(U),this.documentEdited=U}isDocumentEdited(){return b.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(U){b.isMacintosh&&(U==null?void 0:U.force)&&i.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(U=>{if(this.isReady)return U(this);this.whenReadyCallbacks.push(U)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(U=>{function O(){z.dispose(),C.dispose(),U()}const z=this.onDidClose(()=>O()),C=this.onWillLoad(()=>O())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(z,C)=>this.onWindowError(2,C)),this._win.webContents.on("did-fail-load",(z,C,I)=>this.onWindowError(3,I)),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const U=new Set([F.Schemas.file,F.Schemas.vscodeFileResource,F.Schemas.vscodeRemoteResource,F.Schemas.vscodeWebviewResource,"devtools"]);this._win.webContents.session.webRequest.onBeforeRequest((z,C)=>{const I=y.URI.parse(z.url);return I.path.endsWith(".svg")&&!(U.has(I.scheme)||I.path.includes(F.Schemas.vscodeRemoteResource))?C({cancel:!0}):C({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((z,C)=>{const I=z.responseHeaders,M=I["content-type"]||I["Content-Type"];if(M&&Array.isArray(M)){const _=y.URI.parse(z.url);if(_.path.endsWith(".svg")&&U.has(_.scheme))return I["Content-Type"]=["image/svg+xml"],C({cancel:!1,responseHeaders:I});if(!_.path.includes(F.Schemas.vscodeRemoteResource)&&M.some(T=>T.toLowerCase().includes("image/svg")))return C({cancel:!0})}return C({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),b.isMacintosh&&this._register(this.nativeHostMainService.onDidChangeDisplay(()=>{!this._win||!this.useNativeFullScreen()&&this.isFullScreen&&(this.setFullScreen(!1),this.setFullScreen(!0))})),this._win.on("maximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!0),i.app.emit("browser-window-maximize",z,this._win)}),this._win.on("unmaximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!1),i.app.emit("browser-window-unmaximize",z,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",j.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",j.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(z=>this.onDidDeleteUntitledWorkspace(z)));const O=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:O},async(z,C)=>{const I=await this.marketplaceHeadersPromise;C({cancel:!1,requestHeaders:Object.assign(z.requestHeaders,I)})})}async onWindowError(U,O){switch(U){case 2:this.logService.error(`CodeWindow: renderer process crashed (detail: ${typeof O=="string"?O:O==null?void 0:O.reason})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load workbench window: ${typeof O=="string"?O:O==null?void 0:O.reason}`);break}if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.telemetryService.publicLog2("windowerror",{type:U,reason:typeof O!="string"?O==null?void 0:O.reason:void 0}),U===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,u.mnemonicButtonLabel)((0,S.localize)(0,null)),(0,u.mnemonicButtonLabel)((0,S.localize)(1,null)),(0,u.mnemonicButtonLabel)((0,S.localize)(2,null))],message:(0,S.localize)(3,null),detail:(0,S.localize)(4,null),noLink:!0},this._win);if(!this._win)return;z.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):z.response===2&&this.destroyWindow()}else if(U===2){let z;typeof O=="string"||!O?z=(0,S.localize)(5,null):z=(0,S.localize)(6,null,O.reason);const C=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,u.mnemonicButtonLabel)((0,S.localize)(7,null)),(0,u.mnemonicButtonLabel)((0,S.localize)(8,null))],message:z,detail:(0,S.localize)(9,null),noLink:!0},this._win);if(!this._win)return;C.response===0?this.reload():C.response===1&&this.destroyWindow()}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(U){var O;((O=this.openedWorkspace)===null||O===void 0?void 0:O.id)===U.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const U=this.getMenuBarVisibility();U!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=U,this.setMenuBarVisibility(U));let O=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;(O==null?void 0:O.endsWith("/"))&&(O=O.substr(0,O.length-1));const z=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((O||"").indexOf("@")===-1&&(O!==this.currentHttpProxy||z!==this.currentNoProxy)){this.currentHttpProxy=O,this.currentNoProxy=z;const C=O||"",I=z?`${z},<local>`:"<local>";this.logService.trace(`Setting proxy to '${C}', bypassing '${I}'`),this._win.webContents.session.setProxy({proxyRules:C,proxyBypassRules:I,pacScript:""})}}addTabbedWindow(U){b.isMacintosh&&U.win&&this._win.addTabbedWindow(U.win)}load(U,O=Object.create(null)){var z,C;const I=(C=(z=this.currentConfig)!==null&&z!==void 0?z:this.pendingLoadConfig)===null||C===void 0?void 0:C.userEnv;I&&(0,N.isLaunchedFromCli)(I)&&!(0,N.isLaunchedFromCli)(U.userEnv)&&(U.userEnv=Object.assign(Object.assign({},I),U.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(U.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),this.readyState===0?this.currentConfig=U:(this.pendingLoadConfig=U,this.readyState=2),this.isDocumentEdited()&&(!O.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),O.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfigObjectUrl(U,O),(0,k.mark)("code/willOpenNewWindow"),this._win.loadURL(F.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",$).toString(!0)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:U.workspace})}async reload(U){const O=Object.assign({},this.currentConfig);O.workspace=await this.validateWorkspace(O),delete O.filesToOpenOrCreate,delete O.filesToDiff,delete O.filesToWait,this.isExtensionDevelopmentHost&&U&&(O.verbose=U.verbose,O.debugId=U.debugId,O["inspect-extensions"]=U["inspect-extensions"],O["inspect-brk-extensions"]=U["inspect-brk-extensions"],O["extensions-dir"]=U["extensions-dir"]),O.isInitialStartup=!1,this.load(O,{isReload:!0,disableExtensions:U==null?void 0:U["disable-extensions"]})}async validateWorkspace(U){if((0,l.isWorkspaceIdentifier)(U.workspace)){const O=U.workspace.configPath;if(O.scheme===F.Schemas.file&&!await this.fileService.exists(O))return}else if((0,l.isSingleFolderWorkspaceIdentifier)(U.workspace)){const O=U.workspace.uri;if(O.scheme===F.Schemas.file&&!await this.fileService.exists(O))return}return U.workspace}updateConfigObjectUrl(U,O){var z;const C=Object.assign(Object.assign({},this.environmentMainService.args),U);O.disableExtensions!==void 0&&(C["disable-extensions"]=O.disableExtensions),C.windowId=this._win.id,C.sessionId=`window:${this._win.id}`,C.logLevel=this.logService.getLevel(),C.logsPath=this.environmentMainService.logsPath;const I=this.configurationService.getValue("window"),M=I==null?void 0:I.zoomLevel;typeof M=="number"&&(C.zoomLevel=M),C.fullscreen=this.isFullScreen,C.autoDetectHighContrast=(z=I==null?void 0:I.autoDetectHighContrast)!==null&&z!==void 0?z:!0,C.accessibilitySupport=i.app.accessibilitySupportEnabled,C.colorScheme={dark:i.nativeTheme.shouldUseDarkColors,highContrast:i.nativeTheme.shouldUseInvertedColorScheme||i.nativeTheme.shouldUseHighContrastColors},C.maximized=this._win.isMaximized(),C.perfMarks=(0,k.getMarks)(),C.partsSplashPath=(0,D.join)(this.environmentMainService.userDataPath,"rapid_render.json"),C.os={release:(0,v.release)()},C.product=R.default,this.configObjectUrl.update(C)}serializeWindowState(){if(!this._win)return(0,w.defaultWindowState)();if(this.isFullScreen){let z;try{z=i.screen.getDisplayMatching(this.getBounds())}catch(M){}const C=(0,w.defaultWindowState)();return{mode:3,display:z?z.id:void 0,width:this.windowState.width||C.width,height:this.windowState.height||C.height,x:this.windowState.x||0,y:this.windowState.y||0}}const U=Object.create(null);let O;if(!b.isMacintosh&&this._win.isMaximized()?O=0:O=1,O===0?U.mode=0:U.mode=1,O===1||O===0){let z;O===1?z=this.getBounds():z=this._win.getNormalBounds(),U.x=z.x,U.y=z.y,U.width=z.width,U.height=z.height}return U}restoreWindowState(U){let O=!1;if(U)try{const z=i.screen.getAllDisplays();O=z.length>1,U=this.validateWindowState(U,z)}catch(z){this.logService.warn(`Unexpected error validating window state: ${z}
${z.stack}`)}return[U||(0,w.defaultWindowState)(),O]}validateWindowState(U,O){var z,C;if(this.logService.trace(`window#validateWindowState: validating window state on ${O.length} display(s)`,U),typeof U.x!="number"||typeof U.y!="number"||typeof U.width!="number"||typeof U.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(U.width<=0||U.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(O.length===1){const T=this.getWorkingArea(O[0]);if(T){this.logService.trace("window#validateWindowState: 1 monitor working area",T);function I(){!U||typeof U.x!="number"||typeof U.y!="number"||!T||(U.x<T.x&&(U.x=T.x),U.y<T.y&&(U.y=T.y))}I(),U.width>T.width&&(U.width=T.width),U.height>T.height&&(U.height=T.height),U.x>T.x+T.width-128&&(U.x=T.x+T.width-U.width),U.y>T.y+T.height-128&&(U.y=T.y+T.height-U.height),I()}return U}if(U.display&&U.mode===3){const T=O.find(W=>W.id===U.display);if(T&&typeof((z=T.bounds)===null||z===void 0?void 0:z.x)=="number"&&typeof((C=T.bounds)===null||C===void 0?void 0:C.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const W=(0,w.defaultWindowState)(3);return W.x=T.bounds.x,W.y=T.bounds.y,W}}let M,_;try{M=i.screen.getDisplayMatching({x:U.x,y:U.y,width:U.width,height:U.height}),_=this.getWorkingArea(M)}catch(T){}if(M&&_&&U.x+U.width>_.x&&U.y+U.height>_.y&&U.x<_.x+_.width&&U.y<_.y+_.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",_),U}getWorkingArea(U){if(U.workArea.width>0&&U.workArea.height>0)return U.workArea;if(U.bounds.width>0&&U.bounds.height>0)return U.bounds}getBounds(){const[U,O]=this._win.getPosition(),[z,C]=this._win.getSize();return{x:U,y:O,width:z,height:C}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(U){this.useNativeFullScreen()?this.setNativeFullScreen(U):this.setSimpleFullScreen(U),this.sendWhenReady(U?"vscode:enterFullScreen":"vscode:leaveFullScreen",j.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(U){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(U)}setSimpleFullScreen(U){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(U),this._win.webContents.focus()}useNativeFullScreen(){const U=this.configurationService.getValue("window");return!U||typeof U.nativeFullScreen!="boolean"||U.nativeTabs?!0:U.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let U=(0,d.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(U)<0&&(U="classic"),U}setMenuBarVisibility(U,O=!0){b.isMacintosh||(U==="toggle"&&O&&this.send("vscode:showInfoMessage",(0,S.localize)(10,null)),U==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(U)}):this.doSetMenuBarVisibility(U))}doSetMenuBarVisibility(U){const O=this.isFullScreen;switch(U){case"classic":this._win.setMenuBarVisibility(!O),this._win.autoHideMenuBar=O;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(b.isMacintosh)switch(i.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(U,O,...z){this.isReady?this.send(U,...z):this.ready().then(()=>{O.isCancellationRequested||this.send(U,...z)})}send(U,...O){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${U} for window that is destroyed`);return}this._win.webContents.send(U,...O)}}updateTouchBar(U){!b.isMacintosh||this.touchBarGroups.forEach((O,z)=>{const C=U[z];O.segments=this.createTouchBarGroupSegments(C)})}createTouchBar(){if(!!b.isMacintosh){for(let U=0;U<10;U++){const O=this.createTouchBarGroup();this.touchBarGroups.push(O)}this._win.setTouchBar(new i.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(U=[]){const O=this.createTouchBarGroupSegments(U),z=new i.TouchBar.TouchBarSegmentedControl({segments:O,mode:"buttons",segmentStyle:"automatic",change:C=>{this.sendWhenReady("vscode:runAction",j.CancellationToken.None,{id:z.segments[C].id,from:"touchbar"})}});return z}createTouchBarGroupSegments(U=[]){return U.map(z=>{var C,I;let M;z.icon&&!h.ThemeIcon.isThemeIcon(z.icon)&&((I=(C=z.icon)===null||C===void 0?void 0:C.dark)===null||I===void 0?void 0:I.scheme)===F.Schemas.file&&(M=i.nativeImage.createFromPath(y.URI.revive(z.icon.dark).fsPath),M.isEmpty()&&(M=void 0));let _;return typeof z.title=="string"?_=z.title:_=z.title.value,{id:z.id,label:M?void 0:_,icon:M}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};V=ce([Z(1,g.ILogService),Z(2,L.IEnvironmentMainService),Z(3,A.IFileService),Z(4,P.IStorageMainService),Z(5,E.IConfigurationService),Z(6,t.IThemeMainService),Z(7,c.IWorkspacesManagementMainService),Z(8,o.IBackupMainService),Z(9,r.ITelemetryService),Z(10,a.IDialogMainService),Z(11,f.ILifecycleMainService),Z(12,G.INativeHostMainService),Z(13,p.IProductService),Z(14,ne.IProtocolMainService)],V),e.CodeWindow=V}),define(X[63],Q([0,1,148,34,38,11,6,39,5,3,29,51,10,15,7,9,22,17,4,2]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d,m,b,w,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,l.createDecorator)("workspacesHistoryMainService");let o=class He extends c.Disposable{constructor(f,P,A,F){super();this.stateService=f,this.logService=P,this.workspacesManagementMainService=A,this.lifecycleMainService=F,this._onDidChangeRecentlyOpened=this._register(new y.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new E.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(f=>this.addRecentlyOpened([{workspace:f.workspace}])))}handleWindowsJumpList(){!i.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(f){const P=[],A=[];for(let F of f)if((0,L.isRecentWorkspace)(F))!this.workspacesManagementMainService.isUntitledWorkspace(F.workspace)&&r(P,F.workspace)===-1&&P.push(F);else if((0,L.isRecentFolder)(F))a(P,F.folderUri)===-1&&P.push(F);else{const N=u(A,F.fileUri)>=0,j=F.fileUri.scheme===m.Schemas.file&&He.COMMON_FILES_FILTER.indexOf((0,p.basename)(F.fileUri))>=0;!N&&!j&&(A.push(F),i.isWindows&&F.fileUri.scheme===m.Schemas.file&&S.app.addRecentDocument(F.fileUri.fsPath))}this.addEntriesFromStorage(P,A),P.length>He.MAX_TOTAL_RECENT_ENTRIES&&(P.length=He.MAX_TOTAL_RECENT_ENTRIES),A.length>He.MAX_TOTAL_RECENT_ENTRIES&&(A.length=He.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:P,files:A}),this._onDidChangeRecentlyOpened.fire(),i.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(f){const P=j=>{const G=t(j);for(const ne of f)if(p.extUriBiasedIgnorePathCase.isEqual(ne,G))return!1;return!0},A=this.getRecentlyOpened(),F=A.workspaces.filter(P),N=A.files.filter(P);(F.length!==A.workspaces.length||N.length!==A.files.length)&&(this.saveRecentlyOpened({files:N,workspaces:F}),this._onDidChangeRecentlyOpened.fire(),i.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!!i.isMacintosh){S.app.clearRecentDocuments();const f=this.getRecentlyOpened(),P=[];let A=0;for(let N=0;N<f.workspaces.length&&A<He.MAX_MACOS_DOCK_RECENT_WORKSPACES;N++){const j=t(f.workspaces[N]);if(j.scheme===m.Schemas.file){const G=(0,p.originalFSPath)(j);await(0,b.exists)(G)&&(P.push(G),A++)}}const F=[];for(let N=0;N<f.files.length&&A<He.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;N++){const j=t(f.files[N]);if(j.scheme===m.Schemas.file){const G=(0,p.originalFSPath)(j);if(He.COMMON_FILES_FILTER.includes((0,p.basename)(j))||P.includes(G))continue;await(0,b.exists)(G)&&(F.push(G),A++)}}F.reverse().forEach(N=>S.app.addRecentDocument(N)),P.reverse().forEach(N=>S.app.addRecentDocument(N))}}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(f){var P,A;const F=[],N=[],j=(P=f==null?void 0:f.config)===null||P===void 0?void 0:P.workspace;(0,L.isWorkspaceIdentifier)(j)&&!this.workspacesManagementMainService.isUntitledWorkspace(j)?F.push({workspace:j}):(0,L.isSingleFolderWorkspaceIdentifier)(j)&&F.push({folderUri:j.uri});const G=(A=f==null?void 0:f.config)===null||A===void 0?void 0:A.filesToOpenOrCreate;if(G)for(let ne of G){const oe=ne.fileUri;oe&&u(N,oe)===-1&&N.push({fileUri:oe})}return this.addEntriesFromStorage(F,N),{workspaces:F,files:N}}addEntriesFromStorage(f,P){let A=this.getRecentlyOpenedFromStorage();for(let F of A.workspaces){let N=(0,L.isRecentFolder)(F)?a(f,F.folderUri):r(f,F.workspace);N>=0?f[N].label=f[N].label||F.label:f.push(F)}for(let F of A.files){let N=u(P,F.fileUri);N>=0?P[N].label=P[N].label||F.label:P.push(F)}}getRecentlyOpenedFromStorage(){const f=this.stateService.getItem(He.recentlyOpenedStorageKey);return(0,L.restoreRecentlyOpened)(f,this.logService)}saveRecentlyOpened(f){const P=(0,L.toStoreData)(f);this.stateService.setItem(He.recentlyOpenedStorageKey,P)}updateWindowsJumpList(){if(!!i.isWindows){const f=[];if(f.push({type:"tasks",items:[{type:"task",title:(0,v.localize)(0,null),description:(0,v.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let P=[];for(let N of S.app.getJumpListSettings().removedItems){const j=N.args;if(j){const G=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(j);G&&P.push(d.URI.parse(G[2]))}}this.removeRecentlyOpened(P);let A=!1;const F=(0,R.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(N=>{const j=(0,L.isRecentWorkspace)(N)?N.workspace:N.folderUri,{title:G,description:ne}=this.getWindowsJumpListLabel(j,N.label);let oe;return d.URI.isUri(j)?oe=`--folder-uri "${j.toString()}"`:(A=!0,oe=`--file-uri "${j.configPath.toString()}"`),{type:"task",title:G.substr(0,255),description:ne.substr(0,255),program:process.execPath,args:oe,iconPath:"explorer.exe",iconIndex:0}}));F.length>0&&f.push({type:"custom",name:A?(0,v.localize)(2,null):(0,v.localize)(3,null),items:F})}f.push({type:"recent"});try{S.app.setJumpList(f)}catch(P){this.logService.warn("updateWindowsJumpList#setJumpList",P)}}}getWindowsJumpListLabel(f,P){if(P)return{title:(0,n.splitName)(P).name,description:P};if(d.URI.isUri(f))return{title:(0,p.basename)(f),description:s(f)};if(this.workspacesManagementMainService.isUntitledWorkspace(f))return{title:(0,v.localize)(4,null),description:""};let A=(0,p.basename)(f.configPath);return A.endsWith(L.WORKSPACE_EXTENSION)&&(A=A.substr(0,A.length-L.WORKSPACE_EXTENSION.length-1)),{title:(0,v.localize)(5,null,A),description:s(f.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=ce([Z(0,D.IStateService),Z(1,k.ILogService),Z(2,g.IWorkspacesManagementMainService),Z(3,w.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function s(h){return h.scheme==="file"?(0,n.normalizeDriveLetter)(h.fsPath):h.toString()}function t(h){return(0,L.isRecentFolder)(h)?h.folderUri:(0,L.isRecentFile)(h)?h.fileUri:h.workspace.configPath}function r(h,f){return h.findIndex(P=>(0,L.isRecentWorkspace)(P)&&P.workspace.id===f.id)}function a(h,f){return h.findIndex(P=>(0,L.isRecentFolder)(P)&&p.extUriBiasedIgnorePathCase.isEqual(P.folderUri,f))}function u(h,f){return h.findIndex(P=>p.extUriBiasedIgnorePathCase.isEqual(P.fileUri,f))}}),define(X[230],Q([0,1,141,3,26,11,62,24,31,41,23,10,6,39,32,63,177,7,38,17,42,25]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d,m,b,w,l,c,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let r=class ht{constructor(h,f,P,A,F,N,j,G,ne,oe,V){this.updateService=h,this.configurationService=f,this.windowsMainService=P,this.environmentMainService=A,this.telemetryService=F,this.workspacesHistoryMainService=N,this.stateService=j,this.lifecycleMainService=G,this.logService=ne,this.nativeHostMainService=oe,this.productService=V,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new g.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new g.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(R.isMacintosh||(0,k.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const h=this.stateService.getItem(ht.lastKnownMenubarStorageKey);h&&(h.menus&&(this.menubarMenus=h.menus),h.keybindings&&(this.keybindings=h.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(N,j,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:j==null?void 0:j.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(N,j,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:j==null?void 0:j.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(N,j,G)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(N,j,G)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const h=this.productService.twitterUrl;h&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(h,"openTwitterUrl"));const f=this.productService.requestFeatureUrl;f&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(f,"openUserVoiceUrl"));const P=this.productService.reportIssueUrl;P&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(P,"openReportIssues"));const A=this.productService.licenseUrl;A&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(R.language){const N=A.indexOf("?")>0?"&":"?";this.openUrl(`${A}${N}lang=${R.language}`,"openLicenseUrl")}else this.openUrl(A,"openLicenseUrl")});const F=this.productService.privacyStatementUrl;F&&A&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(R.language){const N=A.indexOf("?")>0?"&":"?";this.openUrl(`${F}${N}lang=${R.language}`,"openPrivacyStatement")}else this.openUrl(F,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(h=>this.onDidChangeWindowsCount(h)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let h=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof h!="boolean"&&(h=!0),h}get currentEnableNativeTabs(){if(!R.isMacintosh)return!1;let h=this.configurationService.getValue("window.nativeTabs");return typeof h!="boolean"&&(h=!1),h}updateMenu(h,f){this.menubarMenus=h.menus,this.keybindings=h.keybindings,this.stateService.setItem(ht.lastKnownMenubarStorageKey,h),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(h){!R.isMacintosh||(h.oldCount===0&&h.newCount>0||h.oldCount>0&&h.newCount===0)&&(this.closedLastWindow=h.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!R.isMacintosh||(this.noActiveWindow=!S.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const h=S.Menu.getApplicationMenu();if(h&&this.oldMenus.push(h),Object.keys(this.menubarMenus).length===0){S.Menu.setApplicationMenu(R.isMacintosh?new S.Menu:null);return}const f=new S.Menu;let P;if(R.isMacintosh){const W=new S.Menu;P=new S.MenuItem({label:this.productService.nameShort,submenu:W}),this.setMacApplicationMenu(W),f.append(P)}if(R.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const W=new S.Menu;W.append(new S.MenuItem({label:this.mnemonicLabel(v.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),S.app.dock.setMenu(W)}const A=new S.Menu,F=new S.MenuItem({label:this.mnemonicLabel(v.localize(1,null)),submenu:A});this.setMenuById(A,"File"),f.append(F);const N=new S.Menu,j=new S.MenuItem({label:this.mnemonicLabel(v.localize(2,null)),submenu:N});this.setMenuById(N,"Edit"),f.append(j);const G=new S.Menu,ne=new S.MenuItem({label:this.mnemonicLabel(v.localize(3,null)),submenu:G});this.setMenuById(G,"Selection"),f.append(ne);const oe=new S.Menu,V=new S.MenuItem({label:this.mnemonicLabel(v.localize(4,null)),submenu:oe});this.setMenuById(oe,"View"),f.append(V);const Y=new S.Menu,U=new S.MenuItem({label:this.mnemonicLabel(v.localize(5,null)),submenu:Y});this.setMenuById(Y,"Go"),f.append(U);const O=new S.Menu,z=new S.MenuItem({label:this.mnemonicLabel(v.localize(6,null)),submenu:O});this.setMenuById(O,"Run"),f.append(z);const C=new S.Menu,I=new S.MenuItem({label:this.mnemonicLabel(v.localize(7,null)),submenu:C});this.setMenuById(C,"Terminal"),f.append(I);let M;if(this.shouldDrawMenu("Window")){const W=new S.Menu;M=new S.MenuItem({label:this.mnemonicLabel(v.localize(8,null)),submenu:W,role:"window"}),this.setMacWindowMenu(W)}M&&f.append(M);const _=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(v.localize(9,null)),submenu:_,role:"help"});this.setMenuById(_,"Help"),f.append(T),f.items&&f.items.length>0?S.Menu.setApplicationMenu(f):S.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(h){const f=this.createMenuItem(v.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),P=this.getUpdateMenuItems();let A;if(this.shouldDrawMenu("Preferences")){const Y=new S.Menu;this.setMenuById(Y,"Preferences"),A=new S.MenuItem({label:this.mnemonicLabel(v.localize(11,null)),submenu:Y})}const F=new S.Menu,N=new S.MenuItem({label:v.localize(12,null),role:"services",submenu:F}),j=new S.MenuItem({label:v.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),G=new S.MenuItem({label:v.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ne=new S.MenuItem({label:v.localize(15,null),role:"unhide"}),oe=new S.MenuItem(this.likeAction("workbench.action.quit",{label:v.localize(16,null,this.productService.nameLong),click:()=>{const Y=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||(Y==null?void 0:Y.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),V=[f];V.push(...P),A&&V.push(a(),A),V.push(a(),N,a(),j,G,ne,a(),oe),V.forEach(Y=>h.append(Y))}shouldDrawMenu(h){if(!R.isMacintosh&&(0,k.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(h){case"File":case"Help":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[h];case"Window":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[h]}}setMenu(h,f){f.forEach(P=>{if((0,b.isMenubarMenuItemSeparator)(P))h.append(a());else if((0,b.isMenubarMenuItemSubmenu)(P)){const A=new S.Menu,F=new S.MenuItem({label:this.mnemonicLabel(P.label),submenu:A});this.setMenu(A,P.submenu.items),h.append(F)}else(0,b.isMenubarMenuItemRecentAction)(P)?h.append(this.createOpenRecentMenuItem(P)):(0,b.isMenubarMenuItemAction)(P)&&(P.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(h),R.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[P.id]?h.append(new S.MenuItem(this.likeAction(P.id,{label:this.mnemonicLabel(P.label),click:this.fallbackMenuHandlers[P.id]}))):h.append(this.createMenuItem(P.label,P.id,!1,P.checked)):h.append(this.createMenuItem(P.label,P.id,P.enabled!==!1,!!P.checked)):h.append(this.createMenuItem(P.label,P.id,P.enabled!==!1,!!P.checked)))})}setMenuById(h,f){this.menubarMenus&&this.menubarMenus[f]&&this.setMenu(h,this.menubarMenus[f].items)}insertCheckForUpdatesItems(h){const f=this.getUpdateMenuItems();f.length&&(f.forEach(P=>h.append(P)),h.append(a()))}createOpenRecentMenuItem(h){const f=w.URI.revive(h.uri),P=h.id,A=P==="openRecentFile"?{fileUri:f}:P==="openRecentWorkspace"?{workspaceUri:f}:{folderUri:f};return new S.MenuItem(this.likeAction(P,{label:h.label,click:(F,N,j)=>{const G=this.isOptionClick(j);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[A],forceNewWindow:G,gotoLineMode:!1,remoteAuthority:h.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([f])}},!1))}isOptionClick(h){return!!(h&&(!R.isMacintosh&&(h.ctrlKey||h.shiftKey)||R.isMacintosh&&(h.metaKey||h.altKey)))}createRoleMenuItem(h,f,P){const A={label:this.mnemonicLabel(h),role:P,enabled:!0};return new S.MenuItem(this.withKeybinding(f,A))}setMacWindowMenu(h){const f=new S.MenuItem({label:v.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),P=new S.MenuItem({label:v.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),A=new S.MenuItem({label:v.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),F=this.createMenuItem(v.localize(20,null),"workbench.action.switchWindow"),N=[];this.currentEnableNativeTabs&&(N.push(a()),N.push(this.createMenuItem(v.localize(21,null),"workbench.action.newWindowTab")),N.push(this.createRoleMenuItem(v.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),N.push(this.createRoleMenuItem(v.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),N.push(this.createRoleMenuItem(v.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),N.push(this.createRoleMenuItem(v.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[f,P,a(),F,...N,a(),A].forEach(j=>h.append(j))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate");const f=this.windowsMainService.getLastActiveWindow(),P=f&&`window:${f.id}`;this.updateService.checkForUpdates(P)},0)})];case"checking for updates":return[new S.MenuItem({label:v.localize(27,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:v.localize(29,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new S.MenuItem({label:v.localize(31,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(h,f,P,A){const F=this.mnemonicLabel(h),N=typeof f=="function"?f:(V,Y,U)=>{const O=V?V.userSettingsLabel:null;let z=f;Array.isArray(f)&&(z=this.isOptionClick(U)?f[1]:f[0]),O&&U.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:O}):this.runActionInRenderer({type:"commandId",commandId:z})},j=typeof P=="boolean"?P:this.windowsMainService.getWindowCount()>0,G=typeof A=="boolean"?A:!1,ne={label:F,click:N,enabled:j};G&&(ne.type="checkbox",ne.checked=G);let oe;return typeof f=="string"?oe=f:Array.isArray(f)&&(oe=f[0]),R.isMacintosh&&(oe==="editor.action.clipboardCutAction"?ne.role="cut":oe==="editor.action.clipboardCopyAction"?ne.role="copy":oe==="editor.action.clipboardPasteAction"&&(ne.role="paste"),oe==="undo"?ne.click=this.makeContextAwareClickHandler(N,{inDevTools:V=>V.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):oe==="redo"?ne.click=this.makeContextAwareClickHandler(N,{inDevTools:V=>V.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):oe==="editor.action.selectAll"&&(ne.click=this.makeContextAwareClickHandler(N,{inDevTools:V=>V.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.withKeybinding(oe,ne))}makeContextAwareClickHandler(h,f){return(P,A,F)=>{const N=S.BrowserWindow.getFocusedWindow();if(!N)return f.inNoWindow();if(N.webContents.isDevToolsFocused()&&N.webContents.devToolsWebContents)return f.inDevTools(N.webContents.devToolsWebContents);h(P,A||N,F)}}runActionInRenderer(h){let f=S.BrowserWindow.getFocusedWindow();if(!f){const A=this.windowsMainService.getLastActiveWindow();(A==null?void 0:A.isMinimized())&&(f=A.win)}const P=f?this.windowsMainService.getWindowById(f.id):void 0;if(P){if(this.logService.trace("menubar#runActionInRenderer",h),R.isMacintosh&&!this.environmentMainService.isBuilt&&!P.isReady&&(h.type==="commandId"&&h.commandId==="workbench.action.toggleDevTools"||h.type!=="commandId"&&h.userSettingsLabel==="alt+cmd+i"))return;if(h.type==="commandId"){const A={id:h.commandId,from:"menu"};P.sendWhenReady("vscode:runAction",s.CancellationToken.None,A)}else{const A={userSettingsLabel:h.userSettingsLabel};P.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,A)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",h)}withKeybinding(h,f){const P=typeof h=="string"?this.keybindings[h]:void 0;if(P==null?void 0:P.label){if(P.isNative!==!1)f.accelerator=P.label,f.userSettingsLabel=P.userSettingsLabel;else if(typeof f.label=="string"){const A=f.label.indexOf("[");A>=0?f.label=`${f.label.substr(0,A)} [${P.label}]`:f.label=`${f.label} [${P.label}]`}}else f.accelerator=void 0;return f}likeAction(h,f,P=!f.accelerator){P&&(f=this.withKeybinding(h,f));const A=f.click;return f.click=(F,N,j)=>{this.reportMenuActionTelemetry(h),A&&A(F,N,j)},f}openUrl(h,f){this.nativeHostMainService.openExternal(void 0,h),this.reportMenuActionTelemetry(f)}reportMenuActionTelemetry(h){this.telemetryService.publicLog2("workbenchActionExecuted",{id:h,from:t})}mnemonicLabel(h){return(0,p.mnemonicMenuLabel)(h,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=ce([Z(0,i.IUpdateService),Z(1,n.IConfigurationService),Z(2,d.IWindowsMainService),Z(3,D.IEnvironmentMainService),Z(4,y.ITelemetryService),Z(5,m.IWorkspacesHistoryMainService),Z(6,l.IStateService),Z(7,c.ILifecycleMainService),Z(8,E.ILogService),Z(9,o.INativeHostMainService),Z(10,L.IProductService)],r),e.Menubar=r;function a(){return new S.MenuItem({type:"separator"})}}),define(X[231],Q([0,1,230,6,4,17]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,D.createDecorator)("menubarMainService");let k=class{constructor(y,i,L){this.instantiationService=y,this.lifecycleMainService=i,this.logService=L,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(v.Menubar)}async updateMenubar(y,i){this.logService.trace("menubarService#updateMenubar",y),(await this.menubar).updateMenu(i,y)}};k=ce([Z(0,D.IInstantiationService),Z(1,S.ILifecycleMainService),Z(2,R.ILogService)],k),e.MenubarMainService=k}),define(X[232],Q([0,1,21,8,146,34,49,26,38,229,11,17,24,6,62,98,5,23,63,3,29,4,9,7,15,72,213,51,43,2,50,13,30,39,25,16,35,55]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d,m,b,w,l,c,o,s,t,r,a,u,h,f,P,A,F,N,j,G,ne,oe,V,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function U(C){return(0,o.isWorkspaceIdentifier)(C==null?void 0:C.workspace)}function O(C){return(0,o.isSingleFolderWorkspaceIdentifier)(C==null?void 0:C.workspace)}let z=class Ze extends A.Disposable{constructor(I,M,_,T,W,B,H,K,J,ee,re,x,ie,ae,ue){super();this.machineId=I,this.initialUserEnv=M,this.logService=_,this.stateService=T,this.environmentMainService=W,this.lifecycleMainService=B,this.backupMainService=H,this.configurationService=K,this.workspacesHistoryMainService=J,this.workspacesManagementMainService=ee,this.instantiationService=re,this.dialogMainService=x,this.fileService=ie,this.productService=ae,this.protocolMainService=ue,this._onDidOpenWindow=this._register(new b.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new b.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new b.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new b.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new h.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(I=>this._onDidSignalReadyWindow.fire(I.window))),this._register(this.onDidSignalReadyWindow(I=>{var M,_;if(((M=I.config)===null||M===void 0?void 0:M.extensionDevelopmentPath)||((_=I.config)===null||_===void 0?void 0:_.extensionTestsPath)){const T=new A.DisposableStore;if(T.add(b.Event.any(I.onDidClose,I.onDidDestroy)(()=>T.dispose())),I.config.extensionDevelopmentPath)for(const W of I.config.extensionDevelopmentPath)T.add(this.protocolMainService.addValidFileRoot(r.URI.file(W)));I.config.extensionTestsPath&&T.add(this.protocolMainService.addValidFileRoot(r.URI.file(I.config.extensionTestsPath)))}}))}openEmptyWindow(I,M){let _=this.environmentMainService.args;const T=(M==null?void 0:M.remoteAuthority)||void 0,W=!0,B=M==null?void 0:M.forceReuseWindow,H=!B;return this.open(Object.assign(Object.assign({},I),{cli:_,forceEmpty:W,forceNewWindow:H,forceReuseWindow:B,remoteAuthority:T}))}open(I){this.logService.trace("windowsManager#open"),I.addMode&&(I.initialStartup||!this.getLastActiveWindow())&&(I.addMode=!1);const M=[],_=[],T=[],W=[],B=[];let H,K=0;const J=this.getPathsToOpen(I);this.logService.trace("windowsManager#open pathsToOpen",J);for(const ae of J)O(ae)?I.addMode?M.push(ae):_.push(ae):U(ae)?T.push(ae):ae.fileUri?(H||(H={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ae.remoteAuthority}),H.filesToOpenOrCreate.push(ae)):ae.backupPath?B.push({backupFolder:(0,R.basename)(ae.backupPath),remoteAuthority:ae.remoteAuthority}):K++;I.diffMode&&(H==null?void 0:H.filesToOpenOrCreate.length)===2&&(H.filesToDiff=H.filesToOpenOrCreate,H.filesToOpenOrCreate=[]),H&&I.waitMarkerFileURI&&(H.filesToWait={paths:[...H.filesToDiff,...H.filesToOpenOrCreate],waitMarkerFileUri:I.waitMarkerFileURI}),I.initialStartup?(W.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),T.push(...W),B.push(...this.backupMainService.getEmptyWindowBackupPaths())):B.length=0;const{windows:ee,filesOpenedInWindow:re}=this.doOpen(I,T,_,B,K,H,M);if(this.logService.trace(`windowsManager#open used window count ${ee.length} (workspacesToOpen: ${T.length}, foldersToOpen: ${_.length}, emptyToRestore: ${B.length}, emptyToOpen: ${K})`),ee.length>1)if(re)re.focus();else{const ae=this.windowsStateHandler.state.lastActiveWindow&&!I.forceEmpty&&!I.cli._.length&&!I.cli["file-uri"]&&!I.cli["folder-uri"]&&!(I.urisToOpen&&I.urisToOpen.length);let ue=!0,pe=!0;if(ae){const me=ee.filter(fe=>this.windowsStateHandler.state.lastActiveWindow&&fe.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);me.length&&(me[0].focus(),ue=!1,pe=!1)}if(ue)for(let me=ee.length-1;me>=0;me--){const fe=ee[me];if(!(fe.openedWorkspace&&W.some(ve=>fe.openedWorkspace&&ve.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&B.some(ve=>fe.backupPath&&ve.backupFolder===(0,R.basename)(fe.backupPath)))){fe.focus(),pe=!1;break}}pe&&ee[ee.length-1].focus()}const x=H&&H.filesToDiff.length>0;if(!ee.some(ae=>ae.isExtensionDevelopmentHost)&&!x&&!I.noRecentEntry){const ae=[];for(const ue of J)U(ue)?ae.push({label:ue.label,workspace:ue.workspace,remoteAuthority:ue.remoteAuthority}):O(ue)?ae.push({label:ue.label,folderUri:ue.workspace.uri,remoteAuthority:ue.remoteAuthority}):ue.fileUri&&ae.push({label:ue.label,fileUri:ue.fileUri,remoteAuthority:ue.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ae)}const ie=I.waitMarkerFileURI;return I.context===0&&ie&&ee.length===1&&ee[0]&&ee[0].whenClosedOrLoaded.then(()=>this.fileService.del(ie),()=>{}),ee}doOpen(I,M,_,T,W,B,H){const K=[];let J;function ee(me,fe){K.push(me),fe&&(J=me,B=void 0)}let{openFolderInNewWindow:re,openFilesInNewWindow:x}=this.shouldOpenNewWindow(I);if(!I.initialStartup&&H.length>0){const me=H[0].remoteAuthority,fe=this.getLastActiveWindowForAuthority(me);fe&&ee(this.doAddFoldersToExistingWindow(fe,H.map(ve=>ve.workspace.uri)))}const ie=_.length+M.length+T.length;if(B&&ie===0){const me=B.filesToOpenOrCreate[0]||B.filesToDiff[0],fe=this.getWindows().filter(De=>B&&De.remoteAuthority===B.remoteAuthority);let ve;(me==null?void 0:me.fileUri)&&!x&&((I.context===4||I.context===0||I.context===1)&&(ve=(0,m.findWindowOnFile)(fe,me.fileUri,De=>De.configPath.scheme===t.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(De.configPath):null)),ve||(ve=this.doGetLastActiveWindow(fe))),ve?(0,o.isWorkspaceIdentifier)(ve.openedWorkspace)?M.push({workspace:ve.openedWorkspace,remoteAuthority:ve.remoteAuthority}):(0,o.isSingleFolderWorkspaceIdentifier)(ve.openedWorkspace)?_.push({workspace:ve.openedWorkspace,remoteAuthority:ve.remoteAuthority}):ee(this.doOpenFilesInExistingWindow(I,ve,B),!0):ee(this.openInBrowserWindow({userEnv:I.userEnv,cli:I.cli,initialStartup:I.initialStartup,filesToOpen:B,forceNewWindow:!0,remoteAuthority:B.remoteAuthority,forceNewTabbedWindow:I.forceNewTabbedWindow}),!0)}const ae=(0,S.distinct)(M,me=>me.workspace.id);if(ae.length>0){const me=(0,S.coalesce)(ae.map(fe=>(0,m.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe.workspace.configPath)));if(me.length>0){const fe=me[0],ve=(B==null?void 0:B.remoteAuthority)===fe.remoteAuthority?B:void 0;ee(this.doOpenFilesInExistingWindow(I,fe,ve),!!ve),re=!0}ae.forEach(fe=>{if(!me.some(Le=>Le.openedWorkspace&&Le.openedWorkspace.id===fe.workspace.id)){const ve=fe.remoteAuthority,De=(B==null?void 0:B.remoteAuthority)===ve?B:void 0;ee(this.doOpenFolderOrWorkspace(I,fe,re,De),!!De),re=!0}})}const ue=(0,S.distinct)(_,me=>a.extUriBiasedIgnorePathCase.getComparisonKey(me.workspace.uri));if(ue.length>0){const me=(0,S.coalesce)(ue.map(fe=>(0,m.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe.workspace.uri)));if(me.length>0){const fe=me[0],ve=(B==null?void 0:B.remoteAuthority)===fe.remoteAuthority?B:void 0;ee(this.doOpenFilesInExistingWindow(I,fe,ve),!!ve),re=!0}ue.forEach(fe=>{if(!me.some(Le=>(0,o.isSingleFolderWorkspaceIdentifier)(Le.openedWorkspace)&&a.extUriBiasedIgnorePathCase.isEqual(Le.openedWorkspace.uri,fe.workspace.uri))){const ve=fe.remoteAuthority,De=(B==null?void 0:B.remoteAuthority)===ve?B:void 0;ee(this.doOpenFolderOrWorkspace(I,fe,re,De),!!De),re=!0}})}const pe=(0,S.distinct)(T,me=>me.backupFolder);if(pe.length>0&&pe.forEach(me=>{const fe=me.remoteAuthority,ve=(B==null?void 0:B.remoteAuthority)===fe?B:void 0;ee(this.openInBrowserWindow({userEnv:I.userEnv,cli:I.cli,initialStartup:I.initialStartup,filesToOpen:ve,remoteAuthority:fe,forceNewWindow:!0,forceNewTabbedWindow:I.forceNewTabbedWindow,emptyWindowBackupInfo:me}),!!ve),re=!0}),K.length===0||B){B&&!W&&W++;const me=B?B.remoteAuthority:I.remoteAuthority;for(let fe=0;fe<W;fe++)ee(this.doOpenEmpty(I,re,me,B),!!B),re=!0}return{windows:(0,S.distinct)(K),filesOpenedInWindow:J}}doOpenFilesInExistingWindow(I,M,_){var T;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),M.focus();const W={filesToOpenOrCreate:_==null?void 0:_.filesToOpenOrCreate,filesToDiff:_==null?void 0:_.filesToDiff,filesToWait:_==null?void 0:_.filesToWait,termProgram:(T=I==null?void 0:I.userEnv)===null||T===void 0?void 0:T.TERM_PROGRAM};return M.sendWhenReady("vscode:openFiles",ne.CancellationToken.None,W),M}doAddFoldersToExistingWindow(I,M){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),I.focus();const _={foldersToAdd:M};return I.sendWhenReady("vscode:addFolders",ne.CancellationToken.None,_),I}doOpenEmpty(I,M,_,T,W){return!M&&!W&&typeof I.contextWindowId=="number"&&(W=this.getWindowById(I.contextWindowId)),this.openInBrowserWindow({userEnv:I.userEnv,cli:I.cli,initialStartup:I.initialStartup,remoteAuthority:_,forceNewWindow:M,forceNewTabbedWindow:I.forceNewTabbedWindow,filesToOpen:T,windowToUse:W})}doOpenFolderOrWorkspace(I,M,_,T,W){return!_&&!W&&typeof I.contextWindowId=="number"&&(W=this.getWindowById(I.contextWindowId)),this.openInBrowserWindow({workspace:M.workspace,userEnv:I.userEnv,cli:I.cli,initialStartup:I.initialStartup,remoteAuthority:M.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:I.forceNewTabbedWindow,filesToOpen:T,windowToUse:W})}getPathsToOpen(I){var M;let _,T=!1,W=!1;if(I.urisToOpen&&I.urisToOpen.length>0?(_=this.doExtractPathsFromAPI(I),T=!0):I.forceEmpty?_=[Object.create(null)]:I.cli._.length||I.cli["folder-uri"]||I.cli["file-uri"]?(_=this.doExtractPathsFromCLI(I.cli),_.length===0&&_.push(Object.create(null)),T=!0):(_=this.doGetPathsFromLastSession(),_.length===0&&_.push(Object.create(null)),W=!0),!I.addMode&&T){const B=_.filter(H=>O(H));if(B.length>1){const H=B[0].remoteAuthority;if(B.every(K=>K.remoteAuthority===H)){const K=this.workspacesManagementMainService.createUntitledWorkspaceSync(B.map(J=>({uri:J.workspace.uri})));_.push({workspace:K,remoteAuthority:H}),_=_.filter(J=>!O(J))}}}return I.initialStartup&&!W&&((M=this.configurationService.getValue("window"))===null||M===void 0?void 0:M.restoreWindows)==="preserve"&&_.unshift(...this.doGetPathsFromLastSession().filter(B=>U(B)||O(B)||B.backupPath)),_}doExtractPathsFromAPI(I){const M=[],_={gotoLineMode:I.gotoLineMode,remoteAuthority:I.remoteAuthority};for(const T of(0,S.coalesce)(I.urisToOpen||[])){const W=this.resolveOpenable(T,_);if(W)W.label=T.label,M.push(W);else{const B=this.resourceFromOpenable(T),H={title:this.productService.nameLong,type:"info",buttons:[(0,D.localize)(0,null)],message:B.scheme===t.Schemas.file?(0,D.localize)(1,null):(0,D.localize)(2,null),detail:B.scheme===t.Schemas.file?(0,D.localize)(3,null,(0,G.getPathLabel)(B.fsPath,this.environmentMainService)):(0,D.localize)(4,null,B.toString()),noLink:!0};this.dialogMainService.showMessageBox(H,(0,N.withNullAsUndefined)(L.BrowserWindow.getFocusedWindow()))}}return M}doExtractPathsFromCLI(I){const M=[],_={ignoreFileNotFound:!0,gotoLineMode:I.goto,remoteAuthority:I.remote||void 0,forceOpenWorkspaceAsFile:!1},T=I["folder-uri"];if(T)for(const H of T){const K=this.cliArgToUri(H);if(K){const J=this.resolveOpenable({folderUri:K},_);J&&M.push(J)}}const W=I["file-uri"];if(W)for(const H of W){const K=this.cliArgToUri(H);if(K){const J=this.resolveOpenable((0,o.hasWorkspaceFileExtension)(H)?{workspaceUri:K}:{fileUri:K},_);J&&M.push(J)}}const B=I._;for(const H of B){const K=I.remote?this.doResolvePathRemote(H,I.remote):this.doResolveFilePath(H,_);K&&M.push(K)}return M}cliArgToUri(I){try{const M=r.URI.parse(I);if(!M.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${I}`);return}return M}catch(M){this.logService.error(`Invalid URI input string: ${I}, ${M.message}`)}}doGetPathsFromLastSession(){const I=this.getRestoreWindowsSetting();switch(I){case"none":return[];case"one":case"all":case"preserve":case"folders":const M=[];I!=="one"&&M.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&M.push(this.windowsStateHandler.state.lastActiveWindow);const _=[];for(const T of M)if(T.workspace){const W=this.resolveOpenable({workspaceUri:T.workspace.configPath},{remoteAuthority:T.remoteAuthority});U(W)&&_.push(W)}else if(T.folderUri){const W=this.resolveOpenable({folderUri:T.folderUri},{remoteAuthority:T.remoteAuthority});O(W)&&_.push(W)}else I!=="folders"&&T.backupPath&&_.push({backupPath:T.backupPath,remoteAuthority:T.remoteAuthority});return _}}getRestoreWindowsSetting(){let I;if(this.lifecycleMainService.wasRestarted)I="all";else{const M=this.configurationService.getValue("window");I=(M==null?void 0:M.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(I)||(I="all")}return I}resolveOpenable(I,M={}){let _=this.resourceFromOpenable(I);return _.scheme===t.Schemas.file?((0,d.isFileToOpen)(I)&&(M=Object.assign(Object.assign({},M),{forceOpenWorkspaceAsFile:!0})),this.doResolveFilePath(_.fsPath,M)):this.doResolveRemoteOpenable(I,M)}doResolveRemoteOpenable(I,M){let _=this.resourceFromOpenable(I);const T=(0,u.getRemoteAuthority)(_)||M.remoteAuthority;if(_=(0,a.removeTrailingPathSeparator)((0,a.normalizePath)(_)),(0,d.isFileToOpen)(I)){if(M.gotoLineMode){const{path:W,line:B,column:H}=(0,j.parseLineAndColumnAware)(_.path);return{fileUri:_.with({path:W}),lineNumber:B,columnNumber:H,remoteAuthority:T}}return{fileUri:_,remoteAuthority:T}}else if((0,d.isWorkspaceToOpen)(I))return{workspace:(0,f.getWorkspaceIdentifier)(_),remoteAuthority:T};return{workspace:(0,f.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:T}}resourceFromOpenable(I){return(0,d.isWorkspaceToOpen)(I)?I.workspaceUri:(0,d.isFolderToOpen)(I)?I.folderUri:I.fileUri}doResolveFilePath(I,M){let _,T;if(M.gotoLineMode){const W=(0,j.parseLineAndColumnAware)(I);_=W.line,T=W.column,I=W.path}I=(0,j.sanitizeFilePath)((0,R.normalize)(I),(0,V.cwd)());try{const W=(0,v.statSync)(I);if(W.isFile()){if(!M.forceOpenWorkspaceAsFile){const B=this.workspacesManagementMainService.resolveLocalWorkspaceSync(r.URI.file(I));if(B)return{workspace:{id:B.id,configPath:B.configPath},remoteAuthority:B.remoteAuthority,exists:!0}}return{fileUri:r.URI.file(I),lineNumber:_,columnNumber:T,exists:!0}}else if(W.isDirectory())return{workspace:(0,f.getSingleFolderWorkspaceIdentifier)(r.URI.file(I),W),exists:!0}}catch(W){const B=r.URI.file(I);if(this.workspacesHistoryMainService.removeRecentlyOpened([B]),M.ignoreFileNotFound)return{fileUri:B,exists:!1}}}doResolvePathRemote(I,M,_){const T=I.charCodeAt(0);T!==47&&((0,j.isWindowsDriveLetter)(T)&&I.charCodeAt(I.charCodeAt(1))===58&&(I=(0,j.toSlashes)(I)),I=`/${I}`);const W=r.URI.from({scheme:t.Schemas.vscodeRemote,authority:M,path:I});if(I.charCodeAt(I.length-1)!==47){if((0,o.hasWorkspaceFileExtension)(I))return _?{fileUri:W,remoteAuthority:M}:{workspace:(0,f.getWorkspaceIdentifier)(W),remoteAuthority:M};if(R.posix.basename(I).indexOf(".")!==-1)return{fileUri:W,remoteAuthority:M}}return{workspace:(0,f.getSingleFolderWorkspaceIdentifier)(W),remoteAuthority:M}}shouldOpenNewWindow(I){const M=this.configurationService.getValue("window"),_=(M==null?void 0:M.openFoldersInNewWindow)||"default",T=(M==null?void 0:M.openFilesInNewWindow)||"off";let W=(I.preferNewWindow||I.forceNewWindow)&&!I.forceReuseWindow;!I.forceNewWindow&&!I.forceReuseWindow&&(_==="on"||_==="off")&&(W=_==="on");let B=!1;return I.forceNewWindow||I.forceReuseWindow?B=!!I.forceNewWindow&&!I.forceReuseWindow:(c.isMacintosh?I.context===1&&(B=!0):I.context!==3&&I.context!==2&&!(I.userEnv&&I.userEnv.TERM_PROGRAM==="vscode")&&(B=!0),!I.cli.extensionDevelopmentPath&&(T==="on"||T==="off")&&(B=T==="on")),{openFolderInNewWindow:!!W,openFilesInNewWindow:B}}openExtensionDevelopmentHostWindow(I,M){const _=(0,m.findWindowOnExtensionDevelopmentPath)(this.getWindows(),I);if(_)return this.lifecycleMainService.reload(_,M.cli),_.focus(),[_];let T=M.cli["folder-uri"]||[],W=M.cli["file-uri"]||[],B=M.cli._;if(!B.length&&!T.length&&!W.length&&!M.cli.extensionTestsPath){const ee=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,re=ee&&(ee.workspace||ee.folderUri);re&&(r.URI.isUri(re)?re.scheme===t.Schemas.file?B=[re.fsPath]:T=[re.toString()]:re.configPath.scheme===t.Schemas.file?B=[(0,a.originalFSPath)(re.configPath)]:W=[re.configPath.toString()])}let H=M.remoteAuthority;for(const ee of I)if(ee.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const re=r.URI.parse(ee),x=(0,u.getRemoteAuthority)(re);x&&(H?x!==H&&this.logService.error("more than one extension development path authority"):H=x)}B=B.filter(ee=>{const re=r.URI.file(ee);return(0,m.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:(0,u.getRemoteAuthority)(re)===H}),T=T.filter(ee=>{const re=this.cliArgToUri(ee);return re&&!!(0,m.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,u.getRemoteAuthority)(re)===H:!1}),W=W.filter(ee=>{const re=this.cliArgToUri(ee);return re&&!!(0,m.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,u.getRemoteAuthority)(re)===H:!1}),M.cli._=B,M.cli["folder-uri"]=T,M.cli["file-uri"]=W;const K=!B.length&&!T.length&&!W.length,J={context:M.context,cli:M.cli,forceNewWindow:!0,forceEmpty:K,userEnv:M.userEnv,noRecentEntry:!0,waitMarkerFileURI:M.waitMarkerFileURI,remoteAuthority:H};return this.open(J)}openInBrowserWindow(I){var M;const _=Object.assign({},I.cli);_.appRoot=this.environmentMainService.appRoot,_.machineId=this.machineId,_.nodeCachedDataDir=this.environmentMainService.nodeCachedDataDir,_.mainPid=process.pid,_.execPath=process.execPath,_.userEnv=Object.assign(Object.assign({},this.initialUserEnv),I.userEnv),_.isInitialStartup=I.initialStartup,_.workspace=I.workspace,_.remoteAuthority=I.remoteAuthority;const T=I.filesToOpen;T&&(_.filesToOpenOrCreate=T.filesToOpenOrCreate,_.filesToDiff=T.filesToDiff,_.filesToWait=T.filesToWait),I.emptyWindowBackupInfo&&(_.backupPath=(0,R.join)(this.environmentMainService.backupHome,I.emptyWindowBackupInfo.backupFolder));let W;if(!I.forceNewWindow&&!I.forceNewTabbedWindow&&(W=I.windowToUse||this.getLastActiveWindow(),W&&W.focus()),W){const B=W.config;!_.extensionDevelopmentPath&&B&&!!B.extensionDevelopmentPath&&(_.extensionDevelopmentPath=B.extensionDevelopmentPath,_.verbose=B.verbose,_["inspect-brk-extensions"]=B["inspect-brk-extensions"],_.debugId=B.debugId,_["inspect-extensions"]=B["inspect-extensions"],_["extensions-dir"]=B["extensions-dir"])}else{const B=this.windowsStateHandler.getNewWindowState(_),H=W=this.instantiationService.createInstance(i.CodeWindow,{state:B,extensionDevelopmentPath:_.extensionDevelopmentPath,isExtensionTestHost:!!_.extensionTestsPath});if(I.forceNewTabbedWindow){const J=this.getLastActiveWindow();J&&J.addTabbedWindow(H)}Ze.WINDOWS.push(H),this._onDidOpenWindow.fire(H),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,P.once)(H.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(H)),(0,P.once)(H.onDidClose)(()=>this.onWindowClosed(H)),(0,P.once)(H.onDidDestroy)(()=>this._onDidDestroyWindow.fire(H));const K=(0,N.assertIsDefined)((M=H.win)===null||M===void 0?void 0:M.webContents);K.removeAllListeners("devtools-reload-page"),K.on("devtools-reload-page",()=>this.lifecycleMainService.reload(H)),this.lifecycleMainService.registerWindow(H)}return W.isReady?this.lifecycleMainService.unload(W,4).then(B=>{B||this.doOpenInBrowserWindow(W,_,I)}):this.doOpenInBrowserWindow(W,_,I),W}doOpenInBrowserWindow(I,M,_){if(!M.extensionDevelopmentPath)if((0,o.isWorkspaceIdentifier)(M.workspace))M.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:M.workspace,remoteAuthority:M.remoteAuthority});else if((0,o.isSingleFolderWorkspaceIdentifier)(M.workspace))M.backupPath=this.backupMainService.registerFolderBackupSync(M.workspace.uri);else{const T=_.emptyWindowBackupInfo&&_.emptyWindowBackupInfo.backupFolder;M.backupPath=this.backupMainService.registerEmptyWindowBackupSync(T,M.remoteAuthority)}I.load(M)}onWindowClosed(I){const M=Ze.WINDOWS.indexOf(I);Ze.WINDOWS.splice(M,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const I=L.BrowserWindow.getFocusedWindow();if(I)return this.getWindowById(I.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(I){return this.doGetLastActiveWindow(this.getWindows().filter(M=>M.remoteAuthority===I))}doGetLastActiveWindow(I){const M=Math.max.apply(Math,I.map(_=>_.lastFocusTime));return I.find(_=>_.lastFocusTime===M)}sendToFocused(I,...M){const _=this.getFocusedWindow()||this.getLastActiveWindow();_&&_.sendWhenReady(I,ne.CancellationToken.None,...M)}sendToAll(I,M,_){for(const T of this.getWindows())_&&_.indexOf(T.id)>=0||T.sendWhenReady(I,ne.CancellationToken.None,M)}getWindows(){return Ze.WINDOWS}getWindowCount(){return Ze.WINDOWS.length}getWindowById(I){const M=this.getWindows().filter(_=>_.id===I);return(0,S.firstOrDefault)(M)}getWindowByWebContents(I){const M=L.BrowserWindow.fromWebContents(I);if(!!M)return this.getWindowById(M.id)}};z.WINDOWS=[],z=ce([Z(2,p.ILogService),Z(3,y.IStateService),Z(4,n.IEnvironmentMainService),Z(5,g.ILifecycleMainService),Z(6,k.IBackupMainService),Z(7,E.IConfigurationService),Z(8,l.IWorkspacesHistoryMainService),Z(9,f.IWorkspacesManagementMainService),Z(10,s.IInstantiationService),Z(11,F.IDialogMainService),Z(12,oe.IFileService),Z(13,w.IProductService),Z(14,Y.IProtocolMainService)],z),e.WindowsMainService=z}),define(X[233],Q([0,1,51,32,63,49]),function($,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let k=class{constructor(y,i,L,g){this.workspacesManagementMainService=y,this.windowsMainService=i,this.workspacesHistoryMainService=L,this.backupMainService=g,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(y,i){const L=this.windowsMainService.getWindowById(y);return L?this.workspacesManagementMainService.enterWorkspace(L,this.windowsMainService.getWindows(),i):null}createUntitledWorkspace(y,i,L){return this.workspacesManagementMainService.createUntitledWorkspace(i,L)}deleteUntitledWorkspace(y,i){return this.workspacesManagementMainService.deleteUntitledWorkspace(i)}getWorkspaceIdentifier(y,i){return this.workspacesManagementMainService.getWorkspaceIdentifier(i)}async getRecentlyOpened(y){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(y))}async addRecentlyOpened(y,i){return this.workspacesHistoryMainService.addRecentlyOpened(i)}async removeRecentlyOpened(y,i){return this.workspacesHistoryMainService.removeRecentlyOpened(i)}async clearRecentlyOpened(y){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};k=ce([Z(0,v.IWorkspacesManagementMainService),Z(1,R.IWindowsMainService),Z(2,D.IWorkspacesHistoryMainService),Z(3,S.IBackupMainService)],k),e.WorkspacesMainService=k}),define(X[234],Q([0,1,27,21,11,3,232,17,70,41,199,33,120,84,223,99,4,71,68,6,38,26,24,96,200,31,95,194,195,191,23,217,2,32,7,29,233,66,227,225,224,228,175,18,202,218,231,117,8,15,129,9,226,97,211,216,49,63,201,51,69,152,42,50,13,39,208,204,16,44,28,20,89,209,189,53,30,25,163,178,43,72,73]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d,m,b,w,l,c,o,s,t,r,a,u,h,f,P,A,F,N,j,G,ne,oe,V,Y,U,O,z,C,I,M,_,T,W,B,H,K,J,ee,re,x,ie,ae,ue,pe,me,fe,ve,De,Le,We,Ne,Ve,xe,Xe,Ge,st,Be,it,q,te,se,le,de,ye,be,Te,Oe,Ue,je){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let ot=class extends j.Disposable{constructor(ge,we,Me,he,Ee,Se,Ie,Pe,ke,_e){super();this.mainProcessNodeIpcServer=ge,this.userEnv=we,this.mainInstantiationService=Me,this.logService=he,this.environmentMainService=Ee,this.lifecycleMainService=Se,this.configurationService=Ie,this.stateService=Pe,this.fileService=ke,this.productService=_e,this.registerListeners()}registerListeners(){(0,M.setUnexpectedErrorHandler)(he=>this.onUnexpectedError(he)),process.on("uncaughtException",he=>this.onUnexpectedError(he)),process.on("unhandledRejection",he=>(0,M.onUnexpectedError)(he)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,B.registerContextMenuListener)(),D.app.on("accessibility-support-changed",(he,Ee)=>{var Se;(Se=this.windowsMainService)===null||Se===void 0||Se.sendToAll("vscode:accessibilitySupportChanged",Ee)}),D.app.on("activate",(he,Ee)=>{var Se;this.logService.trace("app#activate"),Ee||(Se=this.windowsMainService)===null||Se===void 0||Se.openEmptyWindow({context:1})}),D.app.on("remote-require",(he,Ee,Se)=>{this.logService.trace("app#on(remote-require): prevented"),he.preventDefault()}),D.app.on("remote-get-global",(he,Ee,Se)=>{this.logService.trace(`app#on(remote-get-global): prevented on ${Se}`),he.preventDefault()}),D.app.on("remote-get-builtin",(he,Ee,Se)=>{this.logService.trace(`app#on(remote-get-builtin): prevented on ${Se}`),Se!=="clipboard"&&he.preventDefault()}),D.app.on("remote-get-current-window",he=>{this.logService.trace("app#on(remote-get-current-window): prevented"),he.preventDefault()}),D.app.on("remote-get-current-web-contents",he=>{this.environmentMainService.args.driver||(this.logService.trace("app#on(remote-get-current-web-contents): prevented"),he.preventDefault())}),D.app.on("web-contents-created",(he,Ee)=>{Ee.on("will-attach-webview",(Ie,Pe,ke)=>{const _e=Fe=>{if(!Fe)return!1;const ze=ne.URI.parse(Fe);if(ze.scheme===ee.Schemas.vscodeWebview)return ze.path==="/index.html"||ze.path==="/electron-browser/index.html";const Ke=ze.fsPath.toLowerCase(),Re=ne.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return Ke.startsWith(Re+H.sep)};delete Pe.preload,Pe.nodeIntegration=!1,!(_e(ke.src)&&_e(Pe.preloadURL))&&(delete Pe.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),Ie.preventDefault())}),Ee.on("will-navigate",Ie=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ie.preventDefault()}),Ee.on("new-window",(Ie,Pe)=>{var ke;Ie.preventDefault(),(ke=this.nativeHostMainService)===null||ke===void 0||ke.openExternal(void 0,Pe)});const Se="about:blank?webviewFrame";D.session.defaultSession.setPermissionRequestHandler((Ie,Pe,ke,_e)=>_e.requestingUrl===Se?ke(Pe==="clipboard-read"):ke(!1)),D.session.defaultSession.setPermissionCheckHandler((Ie,Pe,ke,_e)=>_e.requestingUrl===Se?Pe==="clipboard-read":!1)});let ge=[],we=null;D.app.on("open-file",(he,Ee)=>{this.logService.trace("app#open-file: ",Ee),he.preventDefault(),ge.push(this.getWindowOpenableFromPathSync(Ee)),we!==null&&(clearTimeout(we),we=null),we=setTimeout(()=>{var Se;(Se=this.windowsMainService)===null||Se===void 0||Se.open({context:1,cli:this.environmentMainService.args,urisToOpen:ge,gotoLineMode:!1,preferNewWindow:!0}),ge=[],we=null},100)}),D.app.on("new-window-for-tab",()=>{var he;(he=this.windowsMainService)===null||he===void 0||he.openEmptyWindow({context:4})});let Me=!1;D.ipcMain.on("vscode:fetchShellEnv",async he=>{var Ee;const Se=he.sender;let Ie=!1;function Pe($e){clearTimeout(_e),clearTimeout(ze),Ie||(Ie=!0,Se.isDestroyed()||Se.send("vscode:acceptShellEnv",$e))}const ke=new ye.CancellationTokenSource,_e=setTimeout(()=>{var $e;Me||(($e=this.windowsMainService)===null||$e===void 0||$e.sendToFocused("vscode:showShellEnvSlowWarning",ke.token),Me=!0)},3e3),Fe=(Ee=this.windowsMainService)===null||Ee===void 0?void 0:Ee.getWindowByWebContents(he.sender),ze=setTimeout(()=>{ke.dispose(!0),Fe==null||Fe.sendWhenReady("vscode:showShellEnvTimeoutError",ye.CancellationToken.None),Pe({})},1e4);let Ke,Re;(Fe==null?void 0:Fe.config)?(Ke=Fe.config,Re=Object.assign(Object.assign({},process.env),Fe.config.userEnv)):(Ke=this.environmentMainService.args,Re=process.env);const Qe=await(0,y.resolveShellEnv)(this.logService,Ke,Re);Pe(Qe)}),D.ipcMain.handle("vscode:writeNlsFile",async(he,Ee,Se)=>{const Ie=this.validateNlsPath([Ee]);if(!Ie||typeof Se!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Ie,it.VSBuffer.fromString(Se))}),D.ipcMain.handle("vscode:readNlsFile",async(he,...Ee)=>{const Se=this.validateNlsPath(Ee);if(!Se)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Se)).value.toString()}),D.ipcMain.on("vscode:toggleDevTools",he=>he.sender.toggleDevTools()),D.ipcMain.on("vscode:openDevTools",he=>he.sender.openDevTools()),D.ipcMain.on("vscode:reloadWindow",he=>he.sender.reload())}validateNlsPath(ge){let we;for(const Me of ge)typeof Me=="string"&&(typeof we!="string"?we=Me:we=(0,H.join)(we,Me));if(!(typeof we!="string"||!(0,H.isAbsolute)(we)||!(0,de.isEqualOrParent)(we,this.environmentMainService.cachedLanguagesPath,!S.isLinux)))return ne.URI.file(we)}onUnexpectedError(ge){var we;if(ge){const Me={message:`[uncaught exception in main]: ${ge.message}`,stack:ge.stack};(we=this.windowsMainService)===null||we===void 0||we.sendToFocused("vscode:reportError",JSON.stringify(Me))}this.logService.error(`[uncaught exception in main]: ${ge}`),ge.stack&&this.logService.error(ge.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const ge=this.productService.win32AppUserModelId;S.isWindows&&ge&&D.app.setAppUserModelId(ge);try{S.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!D.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&D.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ke){this.logService.error(ke)}const we=new E.Server;this.logService.trace("Resolving machine identifier...");const Me=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Me}`);const{sharedProcess:he,sharedProcessReady:Ee,sharedProcessClient:Se}=this.setupSharedProcess(Me),Ie=await this.initServices(Me,he,Ee);if(this.environmentMainService.driverHandle){const ke=await(0,T.serve)(we,this.environmentMainService.driverHandle,this.environmentMainService,Ie);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(ke)}this._register(Ie.createInstance(N.ProxyAuthHandler)),Ie.invokeFunction(ke=>this.initChannels(ke,we,Se));const Pe=Ie.invokeFunction(ke=>this.openFirstWindow(ke,we));Ie.invokeFunction(ke=>this.afterWindowOpen(ke,he)),this.environmentMainService.args.trace&&Ie.invokeFunction(ke=>this.stopTracingEventually(ke,Pe))}async resolveMachineId(){let ge=this.stateService.getItem(u.machineIdKey);return(!ge||S.isMacintosh&&ge==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(ge=await(0,Y.getMachineId)(),this.stateService.setItem(u.machineIdKey,ge)),ge}setupSharedProcess(ge){const we=this._register(this.mainInstantiationService.createInstance(d.SharedProcess,ge,this.userEnv)),Me=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ee=await we.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new p.Client(Ee,"main")})(),he=(async()=>(await we.whenReady(),Me))();return{sharedProcess:we,sharedProcessReady:he,sharedProcessClient:Me}}async initServices(ge,we,Me){const he=new w.ServiceCollection;switch(process.platform){case"win32":he.set(i.IUpdateService,new l.SyncDescriptor(U.Win32UpdateService));break;case"linux":S.isLinuxSnap?he.set(i.IUpdateService,new l.SyncDescriptor(re.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):he.set(i.IUpdateService,new l.SyncDescriptor(O.LinuxUpdateService));break;case"darwin":he.set(i.IUpdateService,new l.SyncDescriptor(z.DarwinUpdateService));break}he.set(G.IWindowsMainService,new l.SyncDescriptor(k.WindowsMainService,[ge,this.userEnv])),he.set(We.IDialogMainService,new l.SyncDescriptor(We.DialogMainService)),he.set(m.ILaunchMainService,new l.SyncDescriptor(m.LaunchMainService)),he.set(ve.IDiagnosticsService,g.ProxyChannel.toService((0,g.getDelayedChannel)(Me.then(Se=>Se.getChannel("diagnostics"))))),he.set(C.IIssueMainService,new l.SyncDescriptor(C.IssueMainService,[this.userEnv])),he.set(q.IEncryptionMainService,new l.SyncDescriptor(q.EncryptionMainService,[ge])),he.set(se.IKeyboardLayoutMainService,new l.SyncDescriptor(se.KeyboardLayoutMainService)),he.set(Le.INativeHostMainService,new l.SyncDescriptor(Le.NativeHostMainService,[we])),he.set(Xe.IWebviewManagerService,new l.SyncDescriptor(xe.WebviewMainService)),he.set(oe.IWorkspacesService,new l.SyncDescriptor(V.WorkspacesMainService)),he.set(fe.IWorkspacesManagementMainService,new l.SyncDescriptor(fe.WorkspacesManagementMainService)),he.set(pe.IWorkspacesHistoryMainService,new l.SyncDescriptor(pe.WorkspacesHistoryMainService)),he.set(W.IMenubarMainService,new l.SyncDescriptor(W.MenubarMainService)),he.set(be.IExtensionUrlTrustService,new l.SyncDescriptor(Te.ExtensionUrlTrustService)),he.set(x.IStorageMainService,new l.SyncDescriptor(x.StorageMainService));const Ee=new ae.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(he.set(ue.IBackupMainService,Ee),he.set(r.IURLService,new l.SyncDescriptor(me.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const Se=(0,g.getDelayedChannel)(Me.then(Fe=>Fe.getChannel("telemetryAppender"))),Ie=new f.TelemetryAppenderClient(Se),Pe=(0,A.resolveCommonProperties)(this.fileService,(0,v.release)(),process.arch,this.productService.commit,this.productService.version,ge,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),ke=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],_e={appender:Ie,commonProperties:Pe,piiPaths:ke,sendErrorTelemetry:!0};he.set(u.ITelemetryService,new l.SyncDescriptor(P.TelemetryService,[_e]))}else he.set(u.ITelemetryService,h.NullTelemetryService);return await Ee.initialize(),this.mainInstantiationService.createChild(he)}initChannels(ge,we,Me){const he=g.ProxyChannel.fromService(ge.get(m.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",he);const Ee=new L.UpdateChannel(ge.get(i.IUpdateService));we.registerChannel("update",Ee);const Se=g.ProxyChannel.fromService(ge.get(C.IIssueMainService));we.registerChannel("issue",Se);const Ie=g.ProxyChannel.fromService(ge.get(q.IEncryptionMainService));we.registerChannel("encryption",Ie);const Pe=g.ProxyChannel.fromService(ge.get(je.ISignService));we.registerChannel("sign",Pe);const ke=g.ProxyChannel.fromService(ge.get(se.IKeyboardLayoutMainService));we.registerChannel("keyboardLayout",ke),this.nativeHostMainService=ge.get(Le.INativeHostMainService);const _e=g.ProxyChannel.fromService(this.nativeHostMainService);we.registerChannel("nativeHost",_e),Me.then(qe=>qe.registerChannel("nativeHost",_e));const Fe=g.ProxyChannel.fromService(ge.get(oe.IWorkspacesService));we.registerChannel("workspaces",Fe);const ze=g.ProxyChannel.fromService(ge.get(W.IMenubarMainService));we.registerChannel("menubar",ze);const Ke=g.ProxyChannel.fromService(ge.get(r.IURLService));we.registerChannel("url",Ke);const Re=g.ProxyChannel.fromService(ge.get(be.IExtensionUrlTrustService));we.registerChannel("extensionUrlTrust",Re);const Qe=g.ProxyChannel.fromService(ge.get(Xe.IWebviewManagerService));we.registerChannel("webview",Qe);const $e=this._register(new ie.StorageDatabaseChannel(this.logService,ge.get(x.IStorageMainService)));we.registerChannel("storage",$e),Me.then(qe=>qe.registerChannel("storage",$e));const Je=new I.LogLevelChannel(ge.get(c.ILogService));we.registerChannel("logLevel",Je),Me.then(qe=>qe.registerChannel("logLevel",Je));const et=new I.LoggerChannel(ge.get(c.ILoggerService));we.registerChannel("logger",et),Me.then(qe=>qe.registerChannel("logger",et));const nt=new De.ElectronExtensionHostDebugBroadcastChannel(ge.get(G.IWindowsMainService));we.registerChannel("extensionhostdebugservice",nt)}openFirstWindow(ge,we){const Me=this.windowsMainService=ge.get(G.IWindowsMainService),he=ge.get(r.IURLService),Ee=ge.get(Le.INativeHostMainService);this.lifecycleMainService.phase=2;const Se=[],Ie=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ce=>{try{return{uri:ne.URI.parse(Ce),url:Ce}}catch(Ye){return null}}).filter(Ce=>{if(!Ce||this.shouldBlockURI(Ce.uri))return!1;const Ye=this.getWindowOpenableFromProtocolLink(Ce.uri);return Ye?(Se.push(Ye),!1):!0}),Pe=this,ke=this.environmentMainService;he.registerHandler({async handleURL(Ce,Ye){if(Pe.shouldBlockURI(Ce))return!0;const mt=Pe.getWindowOpenableFromProtocolLink(Ce);if(mt){const[lt]=Me.open({context:5,cli:Object.assign({},ke.args),urisToOpen:[mt],gotoLineMode:!0});return lt.focus(),!0}if(S.isMacintosh&&Me.getWindowCount()===0){const[lt]=Me.open({context:5,cli:Object.assign({},ke.args),forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ue.getRemoteAuthority)(Ce)});return await lt.ready(),he.open(Ce,Ye)}return!1}});const _e=this._register(new te.ActiveWindowManager({onDidOpenWindow:Ee.onDidOpenWindow,onDidFocusWindow:Ee.onDidFocusWindow,getActiveWindowId:()=>Ee.getActiveWindowId(-1)})),Fe=new g.StaticRouter(Ce=>_e.getActiveClientId().then(Ye=>Ce===Ye)),ze=new a.URLHandlerRouter(Fe),Ke=we.getChannel("urlHandler",ze);he.registerHandler(new a.URLHandlerChannelClient(Ke)),this._register(new _.ElectronURLListener(Ie,he,Me,this.environmentMainService,this.productService));const Re=this.environmentMainService.args,Qe=global.macOpenFiles,$e=(0,le.isLaunchedFromCli)(process.env)?0:4,Je=Re._.length,et=!!Re["folder-uri"],nt=!!Re["file-uri"],qe=Re["skip-add-to-recently-opened"]===!0,at=Re.wait&&Re.waitMarkerFilePath?ne.URI.file(Re.waitMarkerFilePath):void 0,gt=Re.remote||void 0;return Se.length>0?Me.open({context:$e,cli:Re,urisToOpen:Se,gotoLineMode:!0,initialStartup:!0}):Re["new-window"]&&!Je&&!et&&!nt?Me.open({context:$e,cli:Re,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:qe,waitMarkerFileURI:at,initialStartup:!0,remoteAuthority:gt}):Qe.length&&!Je&&!et&&!nt?Me.open({context:1,cli:Re,urisToOpen:Qe.map(Ce=>this.getWindowOpenableFromPathSync(Ce)),noRecentEntry:qe,waitMarkerFileURI:at,initialStartup:!0}):Me.open({context:$e,cli:Re,forceNewWindow:Re["new-window"]||!Je&&Re["unity-launch"],diffMode:Re.diff,noRecentEntry:qe,waitMarkerFileURI:at,gotoLineMode:Re.goto,initialStartup:!0,remoteAuthority:gt})}shouldBlockURI(ge){return!!(ge.authority===ee.Schemas.file&&S.isWindows&&D.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,Ve.mnemonicButtonLabel)((0,J.localize)(0,null)),(0,Ve.mnemonicButtonLabel)((0,J.localize)(1,null))],cancelId:1,message:(0,J.localize)(2,null,(0,Ve.getPathLabel)(ge.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,J.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(ge){if(!!ge.path){if(ge.authority===ee.Schemas.file)return{fileUri:ne.URI.file(ge.fsPath)};if(ge.authority===ee.Schemas.vscodeRemote){const we=ge.path.indexOf(H.posix.sep,1);if(we!==-1){const Me=ge.path.substring(1,we),he=ge.path.substring(we),Ee=ne.URI.from({scheme:ee.Schemas.vscodeRemote,authority:Me,path:he,query:ge.query,fragment:ge.fragment});return(0,oe.hasWorkspaceFileExtension)(he)?{workspaceUri:Ee}:{folderUri:Ee}}}}}getWindowOpenableFromPathSync(ge){try{if((0,R.statSync)(ge).isDirectory())return{folderUri:ne.URI.file(ge)};if((0,oe.hasWorkspaceFileExtension)(ge))return{workspaceUri:ne.URI.file(ge)}}catch(we){}return{fileUri:ne.URI.file(ge)}}async afterWindowOpen(ge,we){var Me;this.lifecycleMainService.phase=3;const he=ge.get(u.ITelemetryService);this._register(we.onDidError(({type:Ie,details:Pe})=>{let ke;typeof Pe=="string"?ke=Pe:ke=`SharedProcess: crashed (detail: ${Pe.reason})`,(0,M.onUnexpectedError)(new Error(ke)),he.publicLog2("sharedprocesserror",{type:Ie,reason:typeof Pe!="string"?Pe==null?void 0:Pe.reason:void 0,visible:we.isVisible()})}));const Ee=this.productService.win32MutexName;if(S.isWindows&&Ee)try{const Ie=$.__$__nodeRequire("windows-mutex").Mutex,Pe=new Ie(Ee);(0,Oe.once)(this.lifecycleMainService.onWillShutdown)(()=>Pe.release())}catch(Ie){this.logService.error(Ie)}D.protocol.registerHttpProtocol(ee.Schemas.vscodeRemoteResource,(Ie,Pe)=>{Pe({url:Ie.url.replace(/^vscode-remote-resource:/,"http:"),method:Ie.method})});const Se=ge.get(i.IUpdateService);(Se instanceof U.Win32UpdateService||Se instanceof O.LinuxUpdateService||Se instanceof z.DarwinUpdateService)&&Se.initialize(),(0,y.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,st.stripComments)(Pe))["enable-crash-reporter"]===void 0){const _e=(Me=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&Me!==void 0?Me:!0,Fe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${_e},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,Be.generateUuid)()}"`,"}"],ze=Pe.substring(0,Pe.length-2).concat(`,
`,Fe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,it.VSBuffer.fromString(ze))}}catch(Ie){this.logService.error(Ie)}}stopTracingEventually(ge,we){this.logService.info("Tracing: waiting for windows to get ready...");const Me=ge.get(We.IDialogMainService);let he=!1;const Ee=async Ie=>{if(!he){he=!0;const Pe=await D.contentTracing.stopRecording((0,K.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Ie?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Pe}`):Me.showMessageBox({type:"info",message:(0,J.localize)(4,null),detail:(0,J.localize)(5,null,Pe),buttons:[(0,J.localize)(6,null)]},(0,Ne.withNullAsUndefined)(D.BrowserWindow.getFocusedWindow()))}},Se=setTimeout(()=>Ee(!0),3e4);Promise.all(we.map(Ie=>Ie.ready())).then(()=>{clearTimeout(Se),Ee(!1)})}};ot=ce([Z(2,b.IInstantiationService),Z(3,c.ILogService),Z(4,s.IEnvironmentMainService),Z(5,n.ILifecycleMainService),Z(6,t.IConfigurationService),Z(7,o.IStateService),Z(8,Ge.IFileService),Z(9,F.IProductService)],ot),e.CodeApplication=ot}),define(X[240],Q([0,1,11,21,12,3,54,53,155,17,33,57,167,71,68,6,190,38,24,182,40,222,234,39,93,92,18,74,43,73,188,192,171,173,9,16,56,220,23,30,19,8,34,26,67,95,176,35,55,179,198]),function($,e,v,R,D,S,k,n,y,i,L,g,E,p,d,m,b,w,l,c,o,s,t,r,a,u,h,f,P,A,F,N,j,G,ne,oe,V,Y,U,O,z,C,I,M,_,T,W,B,H,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class J{main(){try{this.startup()}catch(x){console.error(x.message),v.app.exit(1)}}async startup(){(0,h.setUnexpectedErrorHandler)(ve=>console.error(ve));const[x,ie,ae,ue,pe,me,fe]=this.createServices();try{try{await this.initServices(ae,ue,pe)}catch(ve){throw this.handleStartupDataDirError(ae,fe.nameLong,ve),ve}await x.invokeFunction(async ve=>{const De=ve.get(m.ILogService),Le=ve.get(i.ILifecycleMainService),We=ve.get(oe.IFileService),Ne=await this.doStartup(De,ae,Le,x,fe,!0);return me.logger=new a.SpdLogLogger("main",(0,C.join)(ae.logsPath,"main.log"),!0,me.getLevel()),(0,P.once)(Le.onWillShutdown)(()=>{We.dispose(),ue.dispose()}),x.createInstance(t.CodeApplication,Ne,ie).startup()})}catch(ve){x.invokeFunction(this.quit,ve)}}createServices(){const x=new p.ServiceCollection,ie=Object.assign({_serviceBrand:void 0},k.default);x.set(U.IProductService,ie);const ae=new M.EnvironmentMainService(this.resolveArgs(),ie),ue=this.patchEnvironment(ae);x.set(M.IEnvironmentMainService,ae);const pe=new u.BufferLogService,me=new m.MultiplexLogService([new m.ConsoleMainLogger((0,m.getLogLevel)(ae)),pe]);process.once("exit",()=>me.dispose()),x.set(m.ILogService,me);const fe=new j.FileService(me);x.set(oe.IFileService,fe);const ve=new G.DiskFileSystemProvider(me);fe.registerProvider(ne.Schemas.file,ve),x.set(m.ILoggerService,new W.LoggerService(me,fe));const De=new c.ConfigurationService(ae.settingsResource,fe);x.set(l.IConfigurationService,De),x.set(i.ILifecycleMainService,new d.SyncDescriptor(i.LifecycleMainService));const Le=new b.StateService(ae,me);return x.set(w.IStateService,Le),x.set(o.IRequestService,new d.SyncDescriptor(s.RequestMainService)),x.set(f.IThemeMainService,new d.SyncDescriptor(f.ThemeMainService)),x.set(A.ISignService,new d.SyncDescriptor(F.SignService)),x.set(V.ITunnelService,new d.SyncDescriptor(Y.TunnelService)),x.set(H.IProtocolMainService,new d.SyncDescriptor(K.ProtocolMainService)),[new E.InstantiationService(x,!0),ue,ae,De,Le,pe,ie]}patchEnvironment(x){const ie={VSCODE_IPC_HOOK:x.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ae=>{const ue=process.env[ae];typeof ue=="string"&&(ie[ae]=ue)}),Object.assign(process.env,ie),ie}initServices(x,ie,ae){const ue=Promise.all([x.extensionsPath,x.nodeCachedDataDir,x.logsPath,x.globalStorageHome.fsPath,x.workspaceStorageHome.fsPath,x.backupHome].map(fe=>fe?R.promises.mkdir(fe,{recursive:!0}):void 0)),pe=ie.initialize(),me=ae.init();return Promise.all([ue,pe,me])}async doStartup(x,ie,ae,ue,pe,me){let fe;try{fe=await(0,g.serve)(ie.mainIPCHandle),(0,P.once)(ae.onWillShutdown)(()=>fe.dispose())}catch(ve){if(ve.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ie,pe.nameLong,ve),ve;let De;try{De=await(0,g.connect)(ie.mainIPCHandle,"main")}catch(Ne){if(!me||S.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,D.localize)(0,null,pe.nameShort),(0,D.localize)(1,null),pe.nameLong),Ne;try{(0,R.unlinkSync)(ie.mainIPCHandle)}catch(Ve){throw x.warn("Could not delete obsolete instance handle",Ve),Ve}return this.doStartup(x,ie,ae,ue,pe,!1)}if(ie.extensionTestsLocationURI&&!ie.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw x.error(Ne),De.dispose(),new Error(Ne)}let Le;!ie.args.wait&&!ie.args.status&&(Le=setTimeout(()=>{this.showStartupWarningDialog((0,D.localize)(2,null,pe.nameShort),(0,D.localize)(3,null),pe.nameLong)},1e4));const We=L.ProxyChannel.toService(De.getChannel("launch"),{disableMarshalling:!0});if(ie.args.status)return ue.invokeFunction(async()=>{const Ne=new N.DiagnosticsService(T.NullTelemetryService,pe),Ve=await We.getMainProcessInfo(),xe=await We.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Xe=await Ne.getDiagnostics(Ve,xe);throw console.log(Xe),new h.ExpectedError});throw S.isWindows&&await this.windowsAllowSetForegroundWindow(We,x),x.trace("Sending env to running instance..."),await We.start(ie.args,process.env),De.dispose(),Le&&clearTimeout(Le),new h.ExpectedError("Sent env to running instance. Terminating...")}if(ie.args.status)throw x.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new h.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),fe}handleStartupDataDirError(x,ie,ae){if(ae.code==="EACCES"||ae.code==="EPERM"){const ue=(0,I.coalesce)([x.userDataPath,x.extensionsPath,g.XDG_RUNTIME_DIR]).map(pe=>(0,r.getPathLabel)(pe,x));this.showStartupWarningDialog((0,D.localize)(4,null),(0,D.localize)(5,null,(0,_.toErrorMessage)(ae),ue.join(`
`)),ie)}}showStartupWarningDialog(x,ie,ae){v.dialog.showMessageBoxSync({title:ae,type:"warning",buttons:[(0,r.mnemonicButtonLabel)((0,D.localize)(6,null))],message:x,detail:ie,noLink:!0})}async windowsAllowSetForegroundWindow(x,ie){if(S.isWindows){const ae=await x.getMainProcessId();ie.trace("Sending some foreground love to the running instance:",ae);try{(await new Promise((ue,pe)=>{$(["windows-foreground-love"],ue,pe)})).allowSetForegroundWindow(ae)}catch(ue){ie.error(ue)}}}quit(x,ie){const ae=x.get(m.ILogService),ue=x.get(i.ILifecycleMainService);let pe=0;ie&&(ie.isExpected?ie.message&&ae.trace(ie.message):(pe=1,ie.stack?ae.error(ie.stack):ae.error(`Startup error: ${ie.toString()}`))),ue.kill(pe)}resolveArgs(){const x=this.validatePaths((0,n.parseMainProcessArgv)(process.argv));if(x.wait&&!x.waitMarkerFilePath){const ie=(0,y.createWaitMarkerFile)(x.verbose);ie&&((0,n.addArg)(process.argv,"--waitMarkerFilePath",ie),x.waitMarkerFilePath=ie)}return x}validatePaths(x){if(x["open-url"]&&(x._urls=x._,x._=[]),!x.remote){const ie=this.doValidatePaths(x._,x.goto);x._=ie}return x}doValidatePaths(x,ie){const ae=(0,B.cwd)(),ue=x.map(fe=>{let ve=String(fe),De;ie&&(De=(0,O.parseLineAndColumnAware)(ve),ve=De.path),ve&&(ve=this.preparePath(ae,ve));const Le=(0,O.sanitizeFilePath)(ve,ae),We=(0,C.basename)(Le);return We&&!(0,O.isValidBasename)(We)?null:ie&&De?(De.path=Le,this.toPath(De)):Le}),pe=S.isWindows||S.isMacintosh,me=(0,I.distinct)(ue,fe=>fe&&pe?fe.toLowerCase():fe||"");return(0,I.coalesce)(me)}preparePath(x,ie){return S.isWindows&&(ie=(0,z.rtrim)(ie,'"')),ie=(0,z.trim)((0,z.trim)(ie," "),"	"),S.isWindows&&(ie=(0,C.resolve)(x,ie),ie=(0,z.rtrim)(ie,".")),ie}toPath(x){const ie=[x.path];return typeof x.line=="number"&&ie.push(String(x.line)),typeof x.column=="number"&&ie.push(String(x.column)),ie.join(":")}}new J().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/58186680eb97fe979e1d986bcfa983ab0a6228e4/core/vs/code/electron-main/main.js.map
