/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/platform","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/types","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/errors","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/base/common/resources","vs/base/node/pfs","vs/workbench/api/common/extHostInitDataService","vs/base/common/uuid","vs/platform/extensions/common/extensions","vs/base/common/process","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","fs","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","vs/base/common/codicons","os","vs/editor/common/core/position","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/externalTerminal/node/externalTerminal","vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProfiles","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ve=function(Q){for(var e=[],_=0,I=Q.length;_<I;_++)e[_]=ge[Q[_]];return e};define(ge[52],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function _(I,T){if(!I)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=_}),define(ge[53],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const _=Object.prototype.hasOwnProperty;function I(R){const D=[];for(let b in R)_.call(R,b)&&D.push(R[b]);return D}e.values=I;function T(R,D){for(let b in R)if(_.call(R,b)&&D({key:b,value:R[b]},function(){delete R[b]})===!1)return}e.forEach=T;function P(R,D){const b=Object.create(null);for(const g of R){const s=D(g);let d=b[s];d||(d=b[s]=[]),d.push(g)}return b}e.groupBy=P;function C(R){const D=Object.create(null);return R&&R.forEach((b,g)=>{D[g]=b}),D}e.fromMap=C;function A(R,D){const b=[],g=[];for(let s of R)D.has(s)||b.push(s);for(let s of D)R.has(s)||g.push(s);return{removed:b,added:g}}e.diffSets=A;function y(R,D){const b=[],g=[];for(let[s,d]of R)D.has(s)||b.push(d);for(let[s,d]of D)R.has(s)||g.push(d);return{removed:b,added:g}}e.diffMaps=y;class n{constructor(){this.map=new Map}add(D,b){let g=this.map.get(D);g||(g=new Set,this.map.set(D,g)),g.add(b)}delete(D,b){const g=this.map.get(D);!g||(g.delete(b),g.size===0&&this.map.delete(D))}forEach(D,b){const g=this.map.get(D);!g||g.forEach(b)}}e.SetMap=n}),define(ge[68],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function _(y){return(n,R,D)=>{let b=null,g=null;if(typeof D.value=="function"?(b="value",g=D.value):typeof D.get=="function"&&(b="get",g=D.get),!g)throw new Error("not supported");D[b]=y(g,R)}}e.createDecorator=_;let I=0;function T(){const y=`$memoize${I++}`;let n;const R=function(b,g,s){let d=null,S=null;if(typeof s.value=="function"?(d="value",S=s.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof s.get=="function"&&(d="get",S=s.get),!S)throw new Error("not supported");const v=`${y}:${g}`;s[d]=function(...E){return n=this,this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!0,enumerable:!1,writable:!0,value:S.apply(this,E)}),this[v]}};return R.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(D=>{D.indexOf(y)===0&&delete n[D]})},R}e.createMemoizer=T;function P(y,n,R){return T()(y,n,R)}e.memoize=P;function C(y,n,R){return _((D,b)=>{const g=`$debounce$${b}`,s=`$debounce$result$${b}`;return function(...d){this[s]||(this[s]=R?R():void 0),clearTimeout(this[g]),n&&(this[s]=n(this[s],...d),d=[this[s]]),this[g]=setTimeout(()=>{D.apply(this,d),this[s]=R?R():void 0},y)}})}e.debounce=C;function A(y,n,R){return _((D,b)=>{const g=`$throttle$timer$${b}`,s=`$throttle$result$${b}`,d=`$throttle$lastRun$${b}`,S=`$throttle$pending$${b}`;return function(...v){if(this[s]||(this[s]=R?R():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),n&&(this[s]=n(this[s],...v)),!this[S]){const E=this[d]+y;E<=Date.now()?(this[d]=Date.now(),D.apply(this,[this[s]]),this[s]=R?R():void 0):(this[S]=!0,this[g]=setTimeout(()=>{this[S]=!1,this[d]=Date.now(),D.apply(this,[this[s]]),this[s]=R?R():void 0},E-Date.now()))}}})}e.throttle=A}),define(ge[18],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class _{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=_,e.errorHandler=new _;function I(o){e.errorHandler.setUnexpectedErrorHandler(o)}e.setUnexpectedErrorHandler=I;function T(o){y(o)||e.errorHandler.onUnexpectedError(o)}e.onUnexpectedError=T;function P(o){y(o)||e.errorHandler.onUnexpectedExternalError(o)}e.onUnexpectedExternalError=P;function C(o){if(o instanceof Error){let{name:t,message:i}=o;const a=o.stacktrace||o.stack;return{$isError:!0,name:t,message:i,stack:a}}return o}e.transformErrorForSerialization=C;const A="Canceled";function y(o){return o instanceof Error&&o.name===A&&o.message===A}e.isPromiseCanceledError=y;class n extends Error{constructor(){super(A);this.name=this.message}}e.CancellationError=n;function R(){const o=new Error(A);return o.name=o.message,o}e.canceled=R;function D(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}e.illegalArgument=D;function b(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}e.illegalState=b;function g(o){return o?new Error(`readonly property '${o} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function s(o){const t=new Error(`${o} has been disposed`);return t.name="DISPOSED",t}e.disposed=s;function d(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}e.getErrorMessage=d;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class v extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=v;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function m(o){const t=o;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=m;function l(o,t=Object.create(null)){const i=new Error(o);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=l}),define(ge[14],ve([0,1,18]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function I(F,U=0){return F[F.length-(1+U)]}e.tail=I;function T(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=T;function P(F,U,M=(N,O)=>N===O){if(F===U)return!0;if(!F||!U||F.length!==U.length)return!1;for(let N=0,O=F.length;N<O;N++)if(!M(F[N],U[N]))return!1;return!0}e.equals=P;function C(F,U,M){let N=0,O=F.length-1;for(;N<=O;){const j=(N+O)/2|0,q=M(F[j],U);if(q<0)N=j+1;else if(q>0)O=j-1;else return j}return-(N+1)}e.binarySearch=C;function A(F,U){let M=0,N=F.length;if(N===0)return 0;for(;M<N;){const O=Math.floor((M+N)/2);U(F[O])?N=O:M=O+1}return M}e.findFirstInSorted=A;function y(F,U,M){if(F=F|0,F>=U.length)throw new TypeError("invalid index");let N=U[Math.floor(U.length*Math.random())],O=[],j=[],q=[];for(let X of U){const me=M(X,N);me<0?O.push(X):me>0?j.push(X):q.push(X)}return F<O.length?y(F,O,M):F<O.length+q.length?q[0]:y(F-(O.length+q.length),j,M)}e.quickSelect=y;function n(F,U){const M=[];let N;for(const O of F.slice(0).sort(U))!N||U(N[0],O)!==0?(N=[O],M.push(N)):N.push(O);return M}e.groupBy=n;function R(F,U,M){const N=[];function O(X,me,we){if(!(me===0&&we.length===0)){const Ae=N[N.length-1];Ae&&Ae.start+Ae.deleteCount===X?(Ae.deleteCount+=me,Ae.toInsert.push(...we)):N.push({start:X,deleteCount:me,toInsert:we})}}let j=0,q=0;for(;;){if(j===F.length){O(j,0,U.slice(q));break}if(q===U.length){O(j,F.length-j,[]);break}const X=F[j],me=U[q],we=M(X,me);we===0?(j+=1,q+=1):we<0?(O(j,1,[]),j+=1):we>0&&(O(j,0,[me]),q+=1)}return N}e.sortedDiff=R;function D(F,U,M){const N=R(F,U,M),O=[],j=[];for(const q of N)O.push(...F.slice(q.start,q.start+q.deleteCount)),j.push(...q.toInsert);return{removed:O,added:j}}e.delta=D;function b(F,U,M){if(M===0)return[];const N=F.slice(0,M).sort(U);return s(F,U,N,M,F.length),N}e.top=b;function g(F,U,M,N,O){return M===0?Promise.resolve([]):new Promise((j,q)=>{(async()=>{const X=F.length,me=F.slice(0,M).sort(U);for(let we=M,Ae=Math.min(M+N,X);we<X;we=Ae,Ae=Math.min(Ae+N,X)){if(we>M&&await new Promise(Ie=>setTimeout(Ie)),O&&O.isCancellationRequested)throw(0,_.canceled)();s(F,U,me,we,Ae)}return me})().then(j,q)})}e.topAsync=g;function s(F,U,M,N,O){for(const j=M.length;N<O;N++){const q=F[N];if(U(q,M[j-1])<0){M.pop();const X=A(M,me=>U(q,me)<0);M.splice(X,0,q)}}}function d(F){return F.filter(U=>!!U)}e.coalesce=d;function S(F){let U=0;for(let M=0;M<F.length;M++)F[M]&&(F[U]=F[M],U+=1);F.length=U}e.coalesceInPlace=S;function v(F,U,M){F.splice(M,0,F.splice(U,1)[0])}e.move=v;function E(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=E;function m(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=m;function l(F,U){if(!U)return F.filter((N,O)=>F.indexOf(N)===O);const M=Object.create(null);return F.filter(N=>{const O=U(N);return M[O]?!1:(M[O]=!0,!0)})}e.distinct=l;function o(F){const U=new Set;return F.filter(M=>U.has(M)?!1:(U.add(M),!0))}e.distinctES6=o;function t(F){const U=Object.create(null);return M=>{const N=F(M);return U[N]?!1:(U[N]=!0,!0)}}e.uniqueFilter=t;function i(F,U){for(let M=F.length-1;M>=0;M--){const N=F[M];if(U(N))return M}return-1}e.lastIndex=i;function a(F,U){return F.length>0?F[0]:U}e.firstOrDefault=a;function r(F,U,M=(N,O)=>N===O){let N=0;for(let O=0,j=Math.min(F.length,U.length);O<j&&M(F[O],U[O]);O++)N++;return N}e.commonPrefixLength=r;function c(F){return[].concat(...F)}e.flatten=c;function h(F,U){let M=typeof U=="number"?F:0;typeof U=="number"?M=F:(M=0,U=F);const N=[];if(M<=U)for(let O=M;O<U;O++)N.push(O);else for(let O=M;O>U;O--)N.push(O);return N}e.range=h;function p(F,U,M){return F.reduce((N,O)=>(N[U(O)]=M?M(O):O,N),Object.create(null))}e.index=p;function w(F,U){return F.push(U),()=>u(F,U)}e.insert=w;function u(F,U){const M=F.indexOf(U);if(M>-1)return F.splice(M,1),U}e.remove=u;function f(F,U,M){const N=F.slice(0,U),O=F.slice(U);return N.concat(M,O)}e.arrayInsert=f;function k(F,U){let M;if(typeof U=="number"){let N=U;M=()=>{const O=Math.sin(N++)*179426549;return O-Math.floor(O)}}else M=Math.random;for(let N=F.length-1;N>0;N-=1){const O=Math.floor(M()*(N+1)),j=F[N];F[N]=F[O],F[O]=j}}e.shuffle=k;function L(F,U){const M=F.indexOf(U);M>-1&&(F.splice(M,1),F.unshift(U))}e.pushToStart=L;function $(F,U){const M=F.indexOf(U);M>-1&&(F.splice(M,1),F.push(U))}e.pushToEnd=$;function te(F,U){return Array.isArray(F)?F.map(U):U(F)}e.mapArrayOrNot=te;function H(F){return Array.isArray(F)?F:[F]}e.asArray=H;function x(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=x;function B(F,U){for(const M of F){const N=U(M);if(N!==void 0)return N}}e.mapFind=B}),define(ge[69],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function _(I){const T=this;let P=!1,C;return function(){return P||(P=!0,C=I.apply(T,arguments)),C}}e.once=_}),define(ge[70],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class _{constructor(T){this._prefix=T,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=_,e.defaultGenerator=new _("id#")}),define(ge[71],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(I){function T(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}I.is=T;const P=Object.freeze([]);function C(){return P}I.empty=C;function*A(o){yield o}I.single=A;function y(o){return o||P}I.from=y;function n(o){return!o||o[Symbol.iterator]().next().done===!0}I.isEmpty=n;function R(o){return o[Symbol.iterator]().next().value}I.first=R;function D(o,t){for(const i of o)if(t(i))return!0;return!1}I.some=D;function b(o,t){for(const i of o)if(t(i))return i}I.find=b;function*g(o,t){for(const i of o)t(i)&&(yield i)}I.filter=g;function*s(o,t){for(const i of o)yield t(i)}I.map=s;function*d(...o){for(const t of o)for(const i of t)yield i}I.concat=d;function*S(o){for(const t of o)for(const i of t)yield i}I.concatNested=S;function v(o,t,i){let a=i;for(const r of o)a=t(a,r);return a}I.reduce=v;function*E(o,t,i=o.length){for(t<0&&(t+=o.length),i<0?i+=o.length:i>o.length&&(i=o.length);t<i;t++)yield o[t]}I.slice=E;function m(o,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,o];const a=o[Symbol.iterator]();for(let r=0;r<t;r++){const c=a.next();if(c.done)return[i,I.empty()];i.push(c.value)}return[i,{[Symbol.iterator](){return a}}]}I.consume=m;function l(o,t,i=(a,r)=>a===r){const a=o[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const c=a.next(),h=r.next();if(c.done!==h.done)return!1;if(c.done)return!0;if(!i(c.value,h.value))return!1}}I.equals=l})(_=e.Iterable||(e.Iterable={}))}),define(ge[54],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var _;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(_=e.ScanError||(e.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function C(t,i=!1){let a=0,r=t.length,c="",h=0,p=16,w=0;function u(x){let B=0,F=0;for(;B<x;){const U=t.charCodeAt(a);if(U>=48&&U<=57)F=F*16+U-48;else if(U>=65&&U<=70)F=F*16+U-65+10;else if(U>=97&&U<=102)F=F*16+U-97+10;else break;a++,B++}return B<x&&(F=-1),F}function f(x){a=x,c="",h=0,p=16,w=0}function k(){const x=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&n(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&n(t.charCodeAt(a)))for(a++;a<t.length&&n(t.charCodeAt(a));)a++;else return w=3,t.substring(x,a);let B=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&n(t.charCodeAt(a))){for(a++;a<t.length&&n(t.charCodeAt(a));)a++;B=a}else w=3;return t.substring(x,B)}function L(){let x="",B=a;for(;;){if(a>=r){x+=t.substring(B,a),w=2;break}const F=t.charCodeAt(a);if(F===34){x+=t.substring(B,a),a++;break}if(F===92){if(x+=t.substring(B,a),a++,a>=r){w=2;break}switch(t.charCodeAt(a++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const M=u(4);M>=0?x+=String.fromCharCode(M):w=4;break;default:w=5}B=a;continue}if(F>=0&&F<=31)if(y(F)){x+=t.substring(B,a),w=2;break}else w=6;a++}return x}function $(){if(c="",w=0,h=a,a>=r)return h=r,p=17;let x=t.charCodeAt(a);if(A(x)){do a++,c+=String.fromCharCode(x),x=t.charCodeAt(a);while(A(x));return p=15}if(y(x))return a++,c+=String.fromCharCode(x),x===13&&t.charCodeAt(a)===10&&(a++,c+=`
`),p=14;switch(x){case 123:return a++,p=1;case 125:return a++,p=2;case 91:return a++,p=3;case 93:return a++,p=4;case 58:return a++,p=6;case 44:return a++,p=5;case 34:return a++,c=L(),p=10;case 47:const B=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<r&&!y(t.charCodeAt(a));)a++;return c=t.substring(B,a),p=12}if(t.charCodeAt(a+1)===42){a+=2;const F=r-1;let U=!1;for(;a<F;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,U=!0;break}a++}return U||(a++,w=1),c=t.substring(B,a),p=13}return c+=String.fromCharCode(x),a++,p=16;case 45:if(c+=String.fromCharCode(x),a++,a===r||!n(t.charCodeAt(a)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=k(),p=11;default:for(;a<r&&te(x);)a++,x=t.charCodeAt(a);if(h!==a){switch(c=t.substring(h,a),c){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return c+=String.fromCharCode(x),a++,p=16}}function te(x){if(A(x)||y(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let x;do x=$();while(x>=12&&x<=15);return x}return{setPosition:f,getPosition:()=>a,scan:i?H:$,getToken:()=>p,getTokenValue:()=>c,getTokenOffset:()=>h,getTokenLength:()=>a-h,getTokenError:()=>w}}e.createScanner=C;function A(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function D(t,i){const a=[],r=new Object;let c;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function w(u,f,k,L){h.value=u,h.offset=f,h.length=k,h.type=L,h.colonOffset=void 0,c=h}try{m(t,{onObjectBegin:(u,f)=>{if(i<=u)throw r;c=void 0,p=i>u,a.push("")},onObjectProperty:(u,f,k)=>{if(i<f||(w(u,f,k,"property"),a[a.length-1]=u,i<=f+k))throw r},onObjectEnd:(u,f)=>{if(i<=u)throw r;c=void 0,a.pop()},onArrayBegin:(u,f)=>{if(i<=u)throw r;c=void 0,a.push(0)},onArrayEnd:(u,f)=>{if(i<=u)throw r;c=void 0,a.pop()},onLiteralValue:(u,f,k)=>{if(i<f||(w(u,f,k,o(u)),i<=f+k))throw r},onSeparator:(u,f,k)=>{if(i<=f)throw r;if(u===":"&&c&&c.type==="property")c.colonOffset=f,p=!1,c=void 0;else if(u===","){const L=a[a.length-1];typeof L=="number"?a[a.length-1]=L+1:(p=!0,a[a.length-1]=""),c=void 0}}})}catch(u){if(u!==r)throw u}return{path:a,previousNode:c,isAtPropertyKey:p,matches:u=>{let f=0;for(let k=0;f<u.length&&k<a.length;k++)if(u[f]===a[k]||u[f]==="*")f++;else if(u[f]!=="**")return!1;return f===u.length}}}e.getLocation=D;function b(t,i=[],a=P.DEFAULT){let r=null,c=[];const h=[];function p(u){Array.isArray(c)?c.push(u):r!==null&&(c[r]=u)}return m(t,{onObjectBegin:()=>{const u={};p(u),h.push(c),c=u,r=null},onObjectProperty:u=>{r=u},onObjectEnd:()=>{c=h.pop()},onArrayBegin:()=>{const u=[];p(u),h.push(c),c=u,r=null},onArrayEnd:()=>{c=h.pop()},onLiteralValue:p,onError:(u,f,k)=>{i.push({error:u,offset:f,length:k})}},a),c[0]}e.parse=b;function g(t,i=[],a=P.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(u){r.type==="property"&&(r.length=u-r.offset,r=r.parent)}function h(u){return r.children.push(u),u}m(t,{onObjectBegin:u=>{r=h({type:"object",offset:u,length:-1,parent:r,children:[]})},onObjectProperty:(u,f,k)=>{r=h({type:"property",offset:f,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:u,offset:f,length:k,parent:r})},onObjectEnd:(u,f)=>{r.length=u+f-r.offset,r=r.parent,c(u+f)},onArrayBegin:(u,f)=>{r=h({type:"array",offset:u,length:-1,parent:r,children:[]})},onArrayEnd:(u,f)=>{r.length=u+f-r.offset,r=r.parent,c(u+f)},onLiteralValue:(u,f,k)=>{h({type:o(u),offset:f,length:k,parent:r,value:u}),c(f+k)},onSeparator:(u,f,k)=>{r.type==="property"&&(u===":"?r.colonOffset=f:u===","&&c(f))},onError:(u,f,k)=>{i.push({error:u,offset:f,length:k})}},a);const w=r.children[0];return w&&delete w.parent,w}e.parseTree=g;function s(t,i){if(!!t){let a=t;for(let r of i)if(typeof r=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let c=!1;for(const h of a.children)if(Array.isArray(h.children)&&h.children[0].value===r){a=h.children[1],c=!0;break}if(!c)return}else{const c=r;if(a.type!=="array"||c<0||!Array.isArray(a.children)||c>=a.children.length)return;a=a.children[c]}return a}}e.findNodeAtLocation=s;function d(t){if(!t.parent||!t.parent.children)return[];const i=d(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;i.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&i.push(a)}return i}e.getNodePath=d;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const i=Object.create(null);for(let a of t.children){const r=a.children[1];r&&(i[a.children[0].value]=S(r))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function v(t,i,a=!1){return i>=t.offset&&i<t.offset+t.length||a&&i===t.offset+t.length}e.contains=v;function E(t,i,a=!1){if(v(t,i,a)){const r=t.children;if(Array.isArray(r))for(let c=0;c<r.length&&r[c].offset<=i;c++){const h=E(r[c],i,a);if(h)return h}return t}}e.findNodeAtOffset=E;function m(t,i,a=P.DEFAULT){const r=C(t,!1);function c(me){return me?()=>me(r.getTokenOffset(),r.getTokenLength()):()=>!0}function h(me){return me?we=>me(we,r.getTokenOffset(),r.getTokenLength()):()=>!0}const p=c(i.onObjectBegin),w=h(i.onObjectProperty),u=c(i.onObjectEnd),f=c(i.onArrayBegin),k=c(i.onArrayEnd),L=h(i.onLiteralValue),$=h(i.onSeparator),te=c(i.onComment),H=h(i.onError),x=a&&a.disallowComments,B=a&&a.allowTrailingComma;function F(){for(;;){const me=r.scan();switch(r.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:x||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(me){case 12:case 13:x?U(10):te();break;case 16:U(1);break;case 15:case 14:break;default:return me}}}function U(me,we=[],Ae=[]){if(H(me),we.length+Ae.length>0){let Ie=r.getToken();for(;Ie!==17;){if(we.indexOf(Ie)!==-1){F();break}else if(Ae.indexOf(Ie)!==-1)break;Ie=F()}}}function M(me){const we=r.getTokenValue();return me?L(we):w(we),F(),!0}function N(){switch(r.getToken()){case 11:let me=0;try{me=JSON.parse(r.getTokenValue()),typeof me!="number"&&(U(2),me=0)}catch(we){U(2)}L(me);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return F(),!0}function O(){return r.getToken()!==10?(U(3,[],[2,5]),!1):(M(!1),r.getToken()===6?($(":"),F(),X()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function j(){p(),F();let me=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(me||U(4,[],[]),$(","),F(),r.getToken()===2&&B)break}else me&&U(6,[],[]);O()||U(4,[],[2,5]),me=!0}return u(),r.getToken()!==2?U(7,[2],[]):F(),!0}function q(){f(),F();let me=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(me||U(4,[],[]),$(","),F(),r.getToken()===4&&B)break}else me&&U(6,[],[]);X()||U(4,[],[4,5]),me=!0}return k(),r.getToken()!==4?U(8,[4],[]):F(),!0}function X(){switch(r.getToken()){case 3:return q();case 1:return j();case 10:return M(!0);default:return N()}}return F(),r.getToken()===17?a.allowEmptyContent?!0:(U(4,[],[]),!1):X()?(r.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=m;function l(t,i){let a=C(t),r=[],c,h=0,p;do switch(p=a.getPosition(),c=a.scan(),c){case 12:case 13:case 17:h!==p&&r.push(t.substring(h,p)),i!==void 0&&r.push(a.getTokenValue().replace(/[^\r\n]/g,i)),h=a.getPosition();break}while(c!==17);return r.join("")}e.stripComments=l;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=o}),define(ge[131],ve([0,1,54]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function I(y,n,R){let D,b,g,s,d;if(n){for(s=n.offset,d=s+n.length,g=s;g>0&&!A(y,g-1);)g--;let h=d;for(;h<y.length&&!A(y,h);)h++;b=y.substring(g,h),D=P(b,R)}else b=y,D=0,g=0,s=0,d=y.length;const S=C(R,y);let v=!1,E=0,m;R.insertSpaces?m=T(" ",R.tabSize||4):m="	";const l=(0,_.createScanner)(b,!1);let o=!1;function t(){return S+T(m,D+E)}function i(){let h=l.scan();for(v=!1;h===15||h===14;)v=v||h===14,h=l.scan();return o=h===16||l.getTokenError()!==0,h}const a=[];function r(h,p,w){!o&&p<d&&w>s&&y.substring(p,w)!==h&&a.push({offset:p,length:w-p,content:h})}let c=i();if(c!==17){const h=l.getTokenOffset()+g,p=T(m,D);r(p,g,h)}for(;c!==17;){let h=l.getTokenOffset()+l.getTokenLength()+g,p=i(),w="";for(;!v&&(p===12||p===13);){const f=l.getTokenOffset()+g;r(" ",h,f),h=l.getTokenOffset()+l.getTokenLength()+g,w=p===12?t():"",p=i()}if(p===2)c!==1&&(E--,w=t());else if(p===4)c!==3&&(E--,w=t());else{switch(c){case 3:case 1:E++,w=t();break;case 5:case 12:w=t();break;case 13:v?w=t():w=" ";break;case 6:w=" ";break;case 10:if(p===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:p===12||p===13?w=" ":p!==5&&p!==17&&(o=!0);break;case 16:o=!0;break}v&&(p===12||p===13)&&(w=t())}const u=l.getTokenOffset()+g;r(w,h,u),c=p}return a}e.format=I;function T(y,n){let R="";for(let D=0;D<n;D++)R+=y;return R}function P(y,n){let R=0,D=0;const b=n.tabSize||4;for(;R<y.length;){const g=y.charAt(R);if(g===" ")D++;else if(g==="	")D+=b;else break;R++}return Math.floor(D/b)}function C(y,n){for(let R=0;R<n.length;R++){const D=n.charAt(R);if(D==="\r")return R+1<n.length&&n.charAt(R+1)===`
`?`\r
`:"\r";if(D===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=C;function A(y,n){return`\r
`.indexOf(y.charAt(n))!==-1}e.isEOL=A}),define(ge[132],ve([0,1,54,131]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(n,R,D){return P(n,R,void 0,D)}e.removeProperty=T;function P(n,R,D,b,g){const s=R.slice(),d=[],S=(0,_.parseTree)(n,d);let v,E;for(;s.length>0&&(E=s.pop(),v=(0,_.findNodeAtLocation)(S,s),v===void 0&&D!==void 0);)typeof E=="string"?D={[E]:D}:D=[D];if(v)if(v.type==="object"&&typeof E=="string"&&Array.isArray(v.children)){const m=(0,_.findNodeAtLocation)(v,[E]);if(m!==void 0)if(D===void 0){if(!m.parent)throw new Error("Malformed AST");const l=v.children.indexOf(m.parent);let o,t=m.parent.offset+m.parent.length;if(l>0){const i=v.children[l-1];o=i.offset+i.length}else o=v.offset+1,v.children.length>1&&(t=v.children[1].offset);return C(n,{offset:o,length:t-o,content:""},b)}else return C(n,{offset:m.offset,length:m.length,content:JSON.stringify(D)},b);else{if(D===void 0)return[];const l=`${JSON.stringify(E)}: ${JSON.stringify(D)}`,o=g?g(v.children.map(i=>i.children[0].value)):v.children.length;let t;if(o>0){const i=v.children[o-1];t={offset:i.offset+i.length,length:0,content:","+l}}else v.children.length===0?t={offset:v.offset+1,length:0,content:l}:t={offset:v.offset+1,length:0,content:l+","};return C(n,t,b)}}else if(v.type==="array"&&typeof E=="number"&&Array.isArray(v.children))if(D!==void 0){const m=`${JSON.stringify(D)}`;let l;if(v.children.length===0||E===0)l={offset:v.offset+1,length:0,content:v.children.length===0?m:m+","};else{const o=E===-1||E>v.children.length?v.children.length:E,t=v.children[o-1];l={offset:t.offset+t.length,length:0,content:","+m}}return C(n,l,b)}else{const m=E,l=v.children[m];let o;if(v.children.length===1)o={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===m){const t=v.children[m-1],i=t.offset+t.length,a=v.offset+v.length;o={offset:i,length:a-2-i,content:""}}else o={offset:l.offset,length:v.children[m+1].offset-l.offset,content:""};return C(n,o,b)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${v.type}`);else{if(D===void 0)throw new Error("Can not delete in empty document");return C(n,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(D)},b)}}e.setProperty=P;function C(n,R,D){let b=A(n,R),g=R.offset,s=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;g>0&&!(0,I.isEOL)(b,g-1);)g--;for(;s<b.length&&!(0,I.isEOL)(b,s);)s++}const d=(0,I.format)(b,{offset:g,length:s-g},D);for(let v=d.length-1;v>=0;v--){const E=d[v];b=A(b,E),g=Math.min(g,E.offset),s=Math.max(s,E.offset+E.length),s+=E.content.length-E.length}const S=n.length-(b.length-s)-g;return[{offset:g,length:S,content:b.substring(g,s)}]}e.withFormatting=C;function A(n,R){return n.substring(0,R.offset)+R.content+n.substring(R.offset+R.length)}e.applyEdit=A;function y(n,R){let D=R.slice(0).sort((g,s)=>{const d=g.offset-s.offset;return d===0?g.length-s.length:d}),b=n.length;for(let g=D.length-1;g>=0;g--){let s=D[g];if(s.offset+s.length<=b)n=A(n,s);else throw new Error("Overlapping edit");b=s.offset}return n}e.applyEdits=y}),define(ge[133],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class _{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new _(()=>T(this.getValue()))}}e.Lazy=_}),define(ge[6],ve([0,1,69,71]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const T=!1;let P=null;function C(m){P=m}if(e.setDisposableTracker=C,T){const m="__is_disposable_tracked__";P=new class{trackDisposable(l){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[m]||console.log(o)},3e3)}markTracked(l){if(l&&l!==d.None)try{l[m]=!0}catch(o){}}}}function A(m){!P||P.markTracked(m)}function y(m){return P&&P.trackDisposable(m),m}e.trackDisposable=y;class n extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=n;function R(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.isDisposable=R;function D(m){if(I.Iterable.is(m)){let l=[];for(const o of m)if(o){A(o);try{o.dispose()}catch(t){l.push(t)}}if(l.length===1)throw l[0];if(l.length>1)throw new n(l);return Array.isArray(m)?[]:m}else if(m)return A(m),m.dispose(),m}e.dispose=D;function b(...m){return m.forEach(A),g(()=>D(m))}e.combinedDisposable=b;function g(m){const l=y({dispose:()=>{A(l),m()}});return l}e.toDisposable=g;class s{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(A(this),this._isDisposed=!0,this.clear())}clear(){try{D(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return A(l),this._isDisposed?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=s,s.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this._store=new s,y(this)}dispose(){A(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var o;this._isDisposed||l===this._value||((o=this._value)===null||o===void 0||o.dispose(),l&&A(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,A(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=S;class v{constructor(){this.references=new Map}acquire(l,...o){let t=this.references.get(l);t||(t={counter:0,object:this.createReferencedObject(l,...o)},this.references.set(l,t));const{object:i}=t,a=(0,_.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(l,t.object),this.references.delete(l))});return t.counter++,{object:i,dispose:a}}}e.ReferenceCollection=v;class E{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=E}),define(ge[55],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class _{constructor(P){this.element=P,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class I{constructor(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===_.Undefined}clear(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,C){const A=new _(P);if(this._first===_.Undefined)this._first=A,this._last=A;else if(C){const n=this._last;this._last=A,A.prev=n,n.next=A}else{const n=this._first;this._first=A,A.next=n,n.prev=A}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(A))}}shift(){if(this._first!==_.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==_.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==_.Undefined&&P.next!==_.Undefined){const C=P.prev;C.next=P.next,P.next.prev=C}else P.prev===_.Undefined&&P.next===_.Undefined?(this._first=_.Undefined,this._last=_.Undefined):P.next===_.Undefined?(this._last=this._last.prev,this._last.next=_.Undefined):P.prev===_.Undefined&&(this._first=this._first.next,this._first.prev=_.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==_.Undefined;)yield P.element,P=P.next}}e.LinkedList=I}),function(Q,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Q=typeof globalThis!="undefined"?globalThis:Q||self,Q.marked=e())}(this,function(){"use strict";function Q(K,oe){for(var he=0;he<oe.length;he++){var Z=oe[he];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(K,Z.key,Z)}}function e(K,oe,he){return oe&&Q(K.prototype,oe),he&&Q(K,he),K}function _(K,oe){if(!!K){if(typeof K=="string")return I(K,oe);var he=Object.prototype.toString.call(K).slice(8,-1);if(he==="Object"&&K.constructor&&(he=K.constructor.name),he==="Map"||he==="Set")return Array.from(K);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return I(K,oe)}}function I(K,oe){(oe==null||oe>K.length)&&(oe=K.length);for(var he=0,Z=new Array(oe);he<oe;he++)Z[he]=K[he];return Z}function T(K,oe){var he;if(typeof Symbol=="undefined"||K[Symbol.iterator]==null){if(Array.isArray(K)||(he=_(K))||oe&&K&&typeof K.length=="number"){he&&(K=he);var Z=0;return function(){return Z>=K.length?{done:!0}:{done:!1,value:K[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return he=K[Symbol.iterator](),he.next.bind(he)}function P(K){var oe={exports:{}};return K(oe,oe.exports),oe.exports}var C=P(function(K){function oe(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function he(Z){K.exports.defaults=Z}K.exports={defaults:oe(),getDefaults:oe,changeDefaults:he}}),A=/[&<>"']/,y=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,R=/[<>"']|&(?!#?\w+;)/g,D={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(oe){return D[oe]};function g(K,oe){if(oe){if(A.test(K))return K.replace(y,b)}else if(n.test(K))return K.replace(R,b);return K}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(K){return K.replace(s,function(oe,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var S=/(^|[^\[])\^/g;function v(K,oe){K=K.source||K,oe=oe||"";var he={replace:function(ne,le){return le=le.source||le,le=le.replace(S,"$1"),K=K.replace(ne,le),he},getRegex:function(){return new RegExp(K,oe)}};return he}var E=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(K,oe,he){if(K){var Z;try{Z=decodeURIComponent(d(he)).replace(E,"").toLowerCase()}catch(ne){return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}oe&&!m.test(he)&&(he=r(oe,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch(ne){return null}return he}var o={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(K,oe){o[" "+K]||(t.test(K)?o[" "+K]=K+"/":o[" "+K]=w(K,"/",!0)),K=o[" "+K];var he=K.indexOf(":")===-1;return oe.substring(0,2)==="//"?he?oe:K.replace(i,"$1")+oe:oe.charAt(0)==="/"?he?oe:K.replace(a,"$1")+oe:K+oe}var c={exec:function(){}};function h(K){for(var oe=1,he,Z;oe<arguments.length;oe++){he=arguments[oe];for(Z in he)Object.prototype.hasOwnProperty.call(he,Z)&&(K[Z]=he[Z])}return K}function p(K,oe){var he=K.replace(/\|/g,function(le,pe,_e){for(var He=!1,We=pe;--We>=0&&_e[We]==="\\";)He=!He;return He?"|":" |"}),Z=he.split(/ \|/),ne=0;if(Z.length>oe)Z.splice(oe);else for(;Z.length<oe;)Z.push("");for(;ne<Z.length;ne++)Z[ne]=Z[ne].trim().replace(/\\\|/g,"|");return Z}function w(K,oe,he){var Z=K.length;if(Z===0)return"";for(var ne=0;ne<Z;){var le=K.charAt(Z-ne-1);if(le===oe&&!he)ne++;else if(le!==oe&&he)ne++;else break}return K.substr(0,Z-ne)}function u(K,oe){if(K.indexOf(oe[1])===-1)return-1;for(var he=K.length,Z=0,ne=0;ne<he;ne++)if(K[ne]==="\\")ne++;else if(K[ne]===oe[0])Z++;else if(K[ne]===oe[1]&&(Z--,Z<0))return ne;return-1}function f(K){K&&K.sanitize&&!K.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function k(K,oe){if(oe<1)return"";for(var he="";oe>1;)oe&1&&(he+=K),oe>>=1,K+=K;return he+K}var L={escape:g,unescape:d,edit:v,cleanUrl:l,resolveUrl:r,noopTest:c,merge:h,splitCells:p,rtrim:w,findClosingBracket:u,checkSanitizeDeprecation:f,repeatString:k},$=C.defaults,te=L.rtrim,H=L.splitCells,x=L.escape,B=L.findClosingBracket;function F(K,oe,he){var Z=oe.href,ne=oe.title?x(oe.title):null,le=K[1].replace(/\\([\[\]])/g,"$1");return K[0].charAt(0)!=="!"?{type:"link",raw:he,href:Z,title:ne,text:le}:{type:"image",raw:he,href:Z,title:ne,text:x(le)}}function U(K,oe){var he=K.match(/^(\s+)(?:```)/);if(he===null)return oe;var Z=he[1];return oe.split(`
`).map(function(ne){var le=ne.match(/^\s+/);if(le===null)return ne;var pe=le[0];return pe.length>=Z.length?ne.slice(Z.length):ne}).join(`
`)}var M=function(){function K(he){this.options=he||$}var oe=K.prototype;return oe.space=function(Z){var ne=this.rules.block.newline.exec(Z);if(ne)return ne[0].length>1?{type:"space",raw:ne[0]}:{raw:`
`}},oe.code=function(Z){var ne=this.rules.block.code.exec(Z);if(ne){var le=ne[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ne[0],codeBlockStyle:"indented",text:this.options.pedantic?le:te(le,`
`)}}},oe.fences=function(Z){var ne=this.rules.block.fences.exec(Z);if(ne){var le=ne[0],pe=U(le,ne[3]||"");return{type:"code",raw:le,lang:ne[2]?ne[2].trim():ne[2],text:pe}}},oe.heading=function(Z){var ne=this.rules.block.heading.exec(Z);if(ne){var le=ne[2].trim();if(/#$/.test(le)){var pe=te(le,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(le=pe.trim())}return{type:"heading",raw:ne[0],depth:ne[1].length,text:le}}},oe.nptable=function(Z){var ne=this.rules.block.nptable.exec(Z);if(ne){var le={type:"table",header:H(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[],raw:ne[0]};if(le.header.length===le.align.length){var pe=le.align.length,_e;for(_e=0;_e<pe;_e++)/^ *-+: *$/.test(le.align[_e])?le.align[_e]="right":/^ *:-+: *$/.test(le.align[_e])?le.align[_e]="center":/^ *:-+ *$/.test(le.align[_e])?le.align[_e]="left":le.align[_e]=null;for(pe=le.cells.length,_e=0;_e<pe;_e++)le.cells[_e]=H(le.cells[_e],le.header.length);return le}}},oe.hr=function(Z){var ne=this.rules.block.hr.exec(Z);if(ne)return{type:"hr",raw:ne[0]}},oe.blockquote=function(Z){var ne=this.rules.block.blockquote.exec(Z);if(ne){var le=ne[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ne[0],text:le}}},oe.list=function(Z){var ne=this.rules.block.list.exec(Z);if(ne){var le=ne[0],pe=ne[2],_e=pe.length>1,He={type:"list",raw:le,ordered:_e,start:_e?+pe.slice(0,-1):"",loose:!1,items:[]},We=ne[0].match(this.rules.block.item),qe=!1,Ye,Ze,ut,ot,nt,ue,Ce,ce,J=We.length;ut=this.rules.block.listItemStart.exec(We[0]);for(var Re=0;Re<J;Re++){if(Ye=We[Re],le=Ye,Re!==J-1){if(ot=this.rules.block.listItemStart.exec(We[Re+1]),this.options.pedantic?ot[1].length>ut[1].length:ot[1].length>ut[0].length||ot[1].length>3){We.splice(Re,2,We[Re]+`
`+We[Re+1]),Re--,J--;continue}else(!this.options.pedantic||this.options.smartLists?ot[2][ot[2].length-1]!==pe[pe.length-1]:_e===(ot[2].length===1))&&(nt=We.slice(Re+1).join(`
`),He.raw=He.raw.substring(0,He.raw.length-nt.length),Re=J-1);ut=ot}Ze=Ye.length,Ye=Ye.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ye.indexOf(`
 `)&&(Ze-=Ye.length,Ye=this.options.pedantic?Ye.replace(/^ {1,4}/gm,""):Ye.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),ue=qe||/\n\n(?!\s*$)/.test(Ye),Re!==J-1&&(qe=Ye.charAt(Ye.length-1)===`
`,ue||(ue=qe)),ue&&(He.loose=!0),this.options.gfm&&(Ce=/^\[[ xX]\] /.test(Ye),ce=void 0,Ce&&(ce=Ye[1]!==" ",Ye=Ye.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:le,task:Ce,checked:ce,loose:ue,text:Ye})}return He}},oe.html=function(Z){var ne=this.rules.block.html.exec(Z);if(ne)return{type:this.options.sanitize?"paragraph":"html",raw:ne[0],pre:!this.options.sanitizer&&(ne[1]==="pre"||ne[1]==="script"||ne[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):x(ne[0]):ne[0]}},oe.def=function(Z){var ne=this.rules.block.def.exec(Z);if(ne){ne[3]&&(ne[3]=ne[3].substring(1,ne[3].length-1));var le=ne[1].toLowerCase().replace(/\s+/g," ");return{tag:le,raw:ne[0],href:ne[2],title:ne[3]}}},oe.table=function(Z){var ne=this.rules.block.table.exec(Z);if(ne){var le={type:"table",header:H(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=ne[0];var pe=le.align.length,_e;for(_e=0;_e<pe;_e++)/^ *-+: *$/.test(le.align[_e])?le.align[_e]="right":/^ *:-+: *$/.test(le.align[_e])?le.align[_e]="center":/^ *:-+ *$/.test(le.align[_e])?le.align[_e]="left":le.align[_e]=null;for(pe=le.cells.length,_e=0;_e<pe;_e++)le.cells[_e]=H(le.cells[_e].replace(/^ *\| *| *\| *$/g,""),le.header.length);return le}}},oe.lheading=function(Z){var ne=this.rules.block.lheading.exec(Z);if(ne)return{type:"heading",raw:ne[0],depth:ne[2].charAt(0)==="="?1:2,text:ne[1]}},oe.paragraph=function(Z){var ne=this.rules.block.paragraph.exec(Z);if(ne)return{type:"paragraph",raw:ne[0],text:ne[1].charAt(ne[1].length-1)===`
`?ne[1].slice(0,-1):ne[1]}},oe.text=function(Z){var ne=this.rules.block.text.exec(Z);if(ne)return{type:"text",raw:ne[0],text:ne[0]}},oe.escape=function(Z){var ne=this.rules.inline.escape.exec(Z);if(ne)return{type:"escape",raw:ne[0],text:x(ne[1])}},oe.tag=function(Z,ne,le){var pe=this.rules.inline.tag.exec(Z);if(pe)return!ne&&/^<a /i.test(pe[0])?ne=!0:ne&&/^<\/a>/i.test(pe[0])&&(ne=!1),!le&&/^<(pre|code|kbd|script)(\s|>)/i.test(pe[0])?le=!0:le&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(pe[0])&&(le=!1),{type:this.options.sanitize?"text":"html",raw:pe[0],inLink:ne,inRawBlock:le,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):x(pe[0]):pe[0]}},oe.link=function(Z){var ne=this.rules.inline.link.exec(Z);if(ne){var le=ne[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var pe=te(le.slice(0,-1),"\\");if((le.length-pe.length)%2==0)return}else{var _e=B(ne[2],"()");if(_e>-1){var He=ne[0].indexOf("!")===0?5:4,We=He+ne[1].length+_e;ne[2]=ne[2].substring(0,_e),ne[0]=ne[0].substring(0,We).trim(),ne[3]=""}}var qe=ne[2],Ye="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(qe);Ze&&(qe=Ze[1],Ye=Ze[3])}else Ye=ne[3]?ne[3].slice(1,-1):"";return qe=qe.trim(),/^</.test(qe)&&(this.options.pedantic&&!/>$/.test(le)?qe=qe.slice(1):qe=qe.slice(1,-1)),F(ne,{href:qe&&qe.replace(this.rules.inline._escapes,"$1"),title:Ye&&Ye.replace(this.rules.inline._escapes,"$1")},ne[0])}},oe.reflink=function(Z,ne){var le;if((le=this.rules.inline.reflink.exec(Z))||(le=this.rules.inline.nolink.exec(Z))){var pe=(le[2]||le[1]).replace(/\s+/g," ");if(pe=ne[pe.toLowerCase()],!pe||!pe.href){var _e=le[0].charAt(0);return{type:"text",raw:_e,text:_e}}return F(le,pe,le[0])}},oe.emStrong=function(Z,ne,le){le===void 0&&(le="");var pe=this.rules.inline.emStrong.lDelim.exec(Z);if(!!pe&&!(pe[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var _e=pe[1]||pe[2]||"";if(!_e||_e&&(le===""||this.rules.inline.punctuation.exec(le))){var He=pe[0].length-1,We,qe,Ye=He,Ze=0,ut=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ut.lastIndex=0,ne=ne.slice(-1*Z.length+He);(pe=ut.exec(ne))!=null;)if(We=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!We){if(qe=We.length,pe[3]||pe[4]){Ye+=qe;continue}else if((pe[5]||pe[6])&&He%3&&!((He+qe)%3)){Ze+=qe;continue}if(Ye-=qe,!(Ye>0)){if(Ye+Ze-qe<=0&&!ne.slice(ut.lastIndex).match(ut)&&(qe=Math.min(qe,qe+Ye+Ze)),Math.min(He,qe)%2)return{type:"em",raw:Z.slice(0,He+pe.index+qe+1),text:Z.slice(1,He+pe.index+qe)};if(Math.min(He,qe)%2==0)return{type:"strong",raw:Z.slice(0,He+pe.index+qe+1),text:Z.slice(2,He+pe.index+qe-1)}}}}}},oe.codespan=function(Z){var ne=this.rules.inline.code.exec(Z);if(ne){var le=ne[2].replace(/\n/g," "),pe=/[^ ]/.test(le),_e=/^ /.test(le)&&/ $/.test(le);return pe&&_e&&(le=le.substring(1,le.length-1)),le=x(le,!0),{type:"codespan",raw:ne[0],text:le}}},oe.br=function(Z){var ne=this.rules.inline.br.exec(Z);if(ne)return{type:"br",raw:ne[0]}},oe.del=function(Z){var ne=this.rules.inline.del.exec(Z);if(ne)return{type:"del",raw:ne[0],text:ne[2]}},oe.autolink=function(Z,ne){var le=this.rules.inline.autolink.exec(Z);if(le){var pe,_e;return le[2]==="@"?(pe=x(this.options.mangle?ne(le[1]):le[1]),_e="mailto:"+pe):(pe=x(le[1]),_e=pe),{type:"link",raw:le[0],text:pe,href:_e,tokens:[{type:"text",raw:pe,text:pe}]}}},oe.url=function(Z,ne){var le;if(le=this.rules.inline.url.exec(Z)){var pe,_e;if(le[2]==="@")pe=x(this.options.mangle?ne(le[0]):le[0]),_e="mailto:"+pe;else{var He;do He=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(He!==le[0]);pe=x(le[0]),le[1]==="www."?_e="http://"+pe:_e=pe}return{type:"link",raw:le[0],text:pe,href:_e,tokens:[{type:"text",raw:pe,text:pe}]}}},oe.inlineText=function(Z,ne,le){var pe=this.rules.inline.text.exec(Z);if(pe){var _e;return ne?_e=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):x(pe[0]):pe[0]:_e=x(this.options.smartypants?le(pe[0]):pe[0]),{type:"text",raw:pe[0],text:_e}}},K}(),N=L.noopTest,O=L.edit,j=L.merge,q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:N,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=O(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,q.item=O(q.item,"gm").replace(/bull/g,q.bullet).getRegex(),q.listItemStart=O(/^( *)(bull)/).replace("bull",q.bullet).getRegex(),q.list=O(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=O(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=O(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.blockquote=O(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=j({},q),q.gfm=j({},q.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.nptable=O(q.gfm.nptable).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.gfm.table=O(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.pedantic=j({},q.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:O(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var X={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};X._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",X.punctuation=O(X.punctuation).replace(/punctuation/g,X._punctuation).getRegex(),X.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,X.escapedEmSt=/\\\*|\\_/g,X._comment=O(q._comment).replace("(?:-->|$)","-->").getRegex(),X.emStrong.lDelim=O(X.emStrong.lDelim).replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimAst=O(X.emStrong.rDelimAst,"g").replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimUnd=O(X.emStrong.rDelimUnd,"g").replace(/punct/g,X._punctuation).getRegex(),X._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,X._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,X._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,X.autolink=O(X.autolink).replace("scheme",X._scheme).replace("email",X._email).getRegex(),X._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,X.tag=O(X.tag).replace("comment",X._comment).replace("attribute",X._attribute).getRegex(),X._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,X._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,X._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,X.link=O(X.link).replace("label",X._label).replace("href",X._href).replace("title",X._title).getRegex(),X.reflink=O(X.reflink).replace("label",X._label).getRegex(),X.reflinkSearch=O(X.reflinkSearch,"g").replace("reflink",X.reflink).replace("nolink",X.nolink).getRegex(),X.normal=j({},X),X.pedantic=j({},X.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",X._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",X._label).getRegex()}),X.gfm=j({},X.normal,{escape:O(X.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),X.gfm.url=O(X.gfm.url,"i").replace("email",X.gfm._extended_email).getRegex(),X.breaks=j({},X.gfm,{br:O(X.br).replace("{2,}","*").getRegex(),text:O(X.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var me={block:q,inline:X},we=C.defaults,Ae=me.block,Ie=me.inline,Me=L.repeatString;function V(K){return K.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Y(K){var oe="",he,Z,ne=K.length;for(he=0;he<ne;he++)Z=K.charCodeAt(he),Math.random()>.5&&(Z="x"+Z.toString(16)),oe+="&#"+Z+";";return oe}var ee=function(){function K(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||we,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var Z={block:Ae.normal,inline:Ie.normal};this.options.pedantic?(Z.block=Ae.pedantic,Z.inline=Ie.pedantic):this.options.gfm&&(Z.block=Ae.gfm,this.options.breaks?Z.inline=Ie.breaks:Z.inline=Ie.gfm),this.tokenizer.rules=Z}K.lex=function(Z,ne){var le=new K(ne);return le.lex(Z)},K.lexInline=function(Z,ne){var le=new K(ne);return le.inlineTokens(Z)};var oe=K.prototype;return oe.lex=function(Z){return Z=Z.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Z,this.tokens,!0),this.inline(this.tokens),this.tokens},oe.blockTokens=function(Z,ne,le){ne===void 0&&(ne=[]),le===void 0&&(le=!0),this.options.pedantic&&(Z=Z.replace(/^ +$/gm,""));for(var pe,_e,He,We;Z;){if(pe=this.tokenizer.space(Z)){Z=Z.substring(pe.raw.length),pe.type&&ne.push(pe);continue}if(pe=this.tokenizer.code(Z)){Z=Z.substring(pe.raw.length),We=ne[ne.length-1],We&&We.type==="paragraph"?(We.raw+=`
`+pe.raw,We.text+=`
`+pe.text):ne.push(pe);continue}if(pe=this.tokenizer.fences(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.heading(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.nptable(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.hr(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.blockquote(Z)){Z=Z.substring(pe.raw.length),pe.tokens=this.blockTokens(pe.text,[],le),ne.push(pe);continue}if(pe=this.tokenizer.list(Z)){for(Z=Z.substring(pe.raw.length),He=pe.items.length,_e=0;_e<He;_e++)pe.items[_e].tokens=this.blockTokens(pe.items[_e].text,[],!1);ne.push(pe);continue}if(pe=this.tokenizer.html(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(le&&(pe=this.tokenizer.def(Z))){Z=Z.substring(pe.raw.length),this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.lheading(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(le&&(pe=this.tokenizer.paragraph(Z))){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.text(Z)){Z=Z.substring(pe.raw.length),We=ne[ne.length-1],We&&We.type==="text"?(We.raw+=`
`+pe.raw,We.text+=`
`+pe.text):ne.push(pe);continue}if(Z){var qe="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(qe);break}else throw new Error(qe)}}return ne},oe.inline=function(Z){var ne,le,pe,_e,He,We,qe=Z.length;for(ne=0;ne<qe;ne++)switch(We=Z[ne],We.type){case"paragraph":case"text":case"heading":{We.tokens=[],this.inlineTokens(We.text,We.tokens);break}case"table":{for(We.tokens={header:[],cells:[]},_e=We.header.length,le=0;le<_e;le++)We.tokens.header[le]=[],this.inlineTokens(We.header[le],We.tokens.header[le]);for(_e=We.cells.length,le=0;le<_e;le++)for(He=We.cells[le],We.tokens.cells[le]=[],pe=0;pe<He.length;pe++)We.tokens.cells[le][pe]=[],this.inlineTokens(He[pe],We.tokens.cells[le][pe]);break}case"blockquote":{this.inline(We.tokens);break}case"list":{for(_e=We.items.length,le=0;le<_e;le++)this.inline(We.items[le].tokens);break}}return Z},oe.inlineTokens=function(Z,ne,le,pe){ne===void 0&&(ne=[]),le===void 0&&(le=!1),pe===void 0&&(pe=!1);var _e,He,We=Z,qe,Ye,Ze;if(this.tokens.links){var ut=Object.keys(this.tokens.links);if(ut.length>0)for(;(qe=this.tokenizer.rules.inline.reflinkSearch.exec(We))!=null;)ut.includes(qe[0].slice(qe[0].lastIndexOf("[")+1,-1))&&(We=We.slice(0,qe.index)+"["+Me("a",qe[0].length-2)+"]"+We.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(qe=this.tokenizer.rules.inline.blockSkip.exec(We))!=null;)We=We.slice(0,qe.index)+"["+Me("a",qe[0].length-2)+"]"+We.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(qe=this.tokenizer.rules.inline.escapedEmSt.exec(We))!=null;)We=We.slice(0,qe.index)+"++"+We.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;){if(Ye||(Ze=""),Ye=!1,_e=this.tokenizer.escape(Z)){Z=Z.substring(_e.raw.length),ne.push(_e);continue}if(_e=this.tokenizer.tag(Z,le,pe)){Z=Z.substring(_e.raw.length),le=_e.inLink,pe=_e.inRawBlock;var ot=ne[ne.length-1];ot&&_e.type==="text"&&ot.type==="text"?(ot.raw+=_e.raw,ot.text+=_e.text):ne.push(_e);continue}if(_e=this.tokenizer.link(Z)){Z=Z.substring(_e.raw.length),_e.type==="link"&&(_e.tokens=this.inlineTokens(_e.text,[],!0,pe)),ne.push(_e);continue}if(_e=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(_e.raw.length);var nt=ne[ne.length-1];_e.type==="link"?(_e.tokens=this.inlineTokens(_e.text,[],!0,pe),ne.push(_e)):nt&&_e.type==="text"&&nt.type==="text"?(nt.raw+=_e.raw,nt.text+=_e.text):ne.push(_e);continue}if(_e=this.tokenizer.emStrong(Z,We,Ze)){Z=Z.substring(_e.raw.length),_e.tokens=this.inlineTokens(_e.text,[],le,pe),ne.push(_e);continue}if(_e=this.tokenizer.codespan(Z)){Z=Z.substring(_e.raw.length),ne.push(_e);continue}if(_e=this.tokenizer.br(Z)){Z=Z.substring(_e.raw.length),ne.push(_e);continue}if(_e=this.tokenizer.del(Z)){Z=Z.substring(_e.raw.length),_e.tokens=this.inlineTokens(_e.text,[],le,pe),ne.push(_e);continue}if(_e=this.tokenizer.autolink(Z,Y)){Z=Z.substring(_e.raw.length),ne.push(_e);continue}if(!le&&(_e=this.tokenizer.url(Z,Y))){Z=Z.substring(_e.raw.length),ne.push(_e);continue}if(_e=this.tokenizer.inlineText(Z,pe,V)){Z=Z.substring(_e.raw.length),_e.raw.slice(-1)!=="_"&&(Ze=_e.raw.slice(-1)),Ye=!0,He=ne[ne.length-1],He&&He.type==="text"?(He.raw+=_e.raw,He.text+=_e.text):ne.push(_e);continue}if(Z){var ue="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(ue);break}else throw new Error(ue)}}return ne},e(K,null,[{key:"rules",get:function(){return{block:Ae,inline:Ie}}}]),K}(),ae=C.defaults,fe=L.cleanUrl,De=L.escape,Oe=function(){function K(he){this.options=he||ae}var oe=K.prototype;return oe.code=function(Z,ne,le){var pe=(ne||"").match(/\S*/)[0];if(this.options.highlight){var _e=this.options.highlight(Z,pe);_e!=null&&_e!==Z&&(le=!0,Z=_e)}return Z=Z.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+De(pe,!0)+'">'+(le?Z:De(Z,!0))+`</code></pre>
`:"<pre><code>"+(le?Z:De(Z,!0))+`</code></pre>
`},oe.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},oe.html=function(Z){return Z},oe.heading=function(Z,ne,le,pe){return this.options.headerIds?"<h"+ne+' id="'+this.options.headerPrefix+pe.slug(le)+'">'+Z+"</h"+ne+`>
`:"<h"+ne+">"+Z+"</h"+ne+`>
`},oe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},oe.list=function(Z,ne,le){var pe=ne?"ol":"ul",_e=ne&&le!==1?' start="'+le+'"':"";return"<"+pe+_e+`>
`+Z+"</"+pe+`>
`},oe.listitem=function(Z){return"<li>"+Z+`</li>
`},oe.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},oe.paragraph=function(Z){return"<p>"+Z+`</p>
`},oe.table=function(Z,ne){return ne&&(ne="<tbody>"+ne+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ne+`</table>
`},oe.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},oe.tablecell=function(Z,ne){var le=ne.header?"th":"td",pe=ne.align?"<"+le+' align="'+ne.align+'">':"<"+le+">";return pe+Z+"</"+le+`>
`},oe.strong=function(Z){return"<strong>"+Z+"</strong>"},oe.em=function(Z){return"<em>"+Z+"</em>"},oe.codespan=function(Z){return"<code>"+Z+"</code>"},oe.br=function(){return this.options.xhtml?"<br/>":"<br>"},oe.del=function(Z){return"<del>"+Z+"</del>"},oe.link=function(Z,ne,le){if(Z=fe(this.options.sanitize,this.options.baseUrl,Z),Z===null)return le;var pe='<a href="'+De(Z)+'"';return ne&&(pe+=' title="'+ne+'"'),pe+=">"+le+"</a>",pe},oe.image=function(Z,ne,le){if(Z=fe(this.options.sanitize,this.options.baseUrl,Z),Z===null)return le;var pe='<img src="'+Z+'" alt="'+le+'"';return ne&&(pe+=' title="'+ne+'"'),pe+=this.options.xhtml?"/>":">",pe},oe.text=function(Z){return Z},K}(),be=function(){function K(){}var oe=K.prototype;return oe.strong=function(Z){return Z},oe.em=function(Z){return Z},oe.codespan=function(Z){return Z},oe.del=function(Z){return Z},oe.html=function(Z){return Z},oe.text=function(Z){return Z},oe.link=function(Z,ne,le){return""+le},oe.image=function(Z,ne,le){return""+le},oe.br=function(){return""},K}(),ke=function(){function K(){this.seen={}}var oe=K.prototype;return oe.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},oe.getNextSafeSlug=function(Z,ne){var le=Z,pe=0;if(this.seen.hasOwnProperty(le)){pe=this.seen[Z];do pe++,le=Z+"-"+pe;while(this.seen.hasOwnProperty(le))}return ne||(this.seen[Z]=pe,this.seen[le]=0),le},oe.slug=function(Z,ne){ne===void 0&&(ne={});var le=this.serialize(Z);return this.getNextSafeSlug(le,ne.dryrun)},K}(),Te=C.defaults,xe=L.unescape,Se=function(){function K(he){this.options=he||Te,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new be,this.slugger=new ke}K.parse=function(Z,ne){var le=new K(ne);return le.parse(Z)},K.parseInline=function(Z,ne){var le=new K(ne);return le.parseInline(Z)};var oe=K.prototype;return oe.parse=function(Z,ne){ne===void 0&&(ne=!0);var le="",pe,_e,He,We,qe,Ye,Ze,ut,ot,nt,ue,Ce,ce,J,Re,Le,Je,Ge,rt=Z.length;for(pe=0;pe<rt;pe++)switch(nt=Z[pe],nt.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(nt.tokens),nt.depth,xe(this.parseInline(nt.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(nt.text,nt.lang,nt.escaped);continue}case"table":{for(ut="",Ze="",We=nt.header.length,_e=0;_e<We;_e++)Ze+=this.renderer.tablecell(this.parseInline(nt.tokens.header[_e]),{header:!0,align:nt.align[_e]});for(ut+=this.renderer.tablerow(Ze),ot="",We=nt.cells.length,_e=0;_e<We;_e++){for(Ye=nt.tokens.cells[_e],Ze="",qe=Ye.length,He=0;He<qe;He++)Ze+=this.renderer.tablecell(this.parseInline(Ye[He]),{header:!1,align:nt.align[He]});ot+=this.renderer.tablerow(Ze)}le+=this.renderer.table(ut,ot);continue}case"blockquote":{ot=this.parse(nt.tokens),le+=this.renderer.blockquote(ot);continue}case"list":{for(ue=nt.ordered,Ce=nt.start,ce=nt.loose,We=nt.items.length,ot="",_e=0;_e<We;_e++)Re=nt.items[_e],Le=Re.checked,Je=Re.task,J="",Re.task&&(Ge=this.renderer.checkbox(Le),ce?Re.tokens.length>0&&Re.tokens[0].type==="text"?(Re.tokens[0].text=Ge+" "+Re.tokens[0].text,Re.tokens[0].tokens&&Re.tokens[0].tokens.length>0&&Re.tokens[0].tokens[0].type==="text"&&(Re.tokens[0].tokens[0].text=Ge+" "+Re.tokens[0].tokens[0].text)):Re.tokens.unshift({type:"text",text:Ge}):J+=Ge),J+=this.parse(Re.tokens,ce),ot+=this.renderer.listitem(J,Je,Le);le+=this.renderer.list(ot,ue,Ce);continue}case"html":{le+=this.renderer.html(nt.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(nt.tokens));continue}case"text":{for(ot=nt.tokens?this.parseInline(nt.tokens):nt.text;pe+1<rt&&Z[pe+1].type==="text";)nt=Z[++pe],ot+=`
`+(nt.tokens?this.parseInline(nt.tokens):nt.text);le+=ne?this.renderer.paragraph(ot):ot;continue}default:{var at='Token with "'+nt.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}return le},oe.parseInline=function(Z,ne){ne=ne||this.renderer;var le="",pe,_e,He=Z.length;for(pe=0;pe<He;pe++)switch(_e=Z[pe],_e.type){case"escape":{le+=ne.text(_e.text);break}case"html":{le+=ne.html(_e.text);break}case"link":{le+=ne.link(_e.href,_e.title,this.parseInline(_e.tokens,ne));break}case"image":{le+=ne.image(_e.href,_e.title,_e.text);break}case"strong":{le+=ne.strong(this.parseInline(_e.tokens,ne));break}case"em":{le+=ne.em(this.parseInline(_e.tokens,ne));break}case"codespan":{le+=ne.codespan(_e.text);break}case"br":{le+=ne.br();break}case"del":{le+=ne.del(this.parseInline(_e.tokens,ne));break}case"text":{le+=ne.text(_e.text);break}default:{var We='Token with "'+_e.type+'" type was not found.';if(this.options.silent){console.error(We);return}else throw new Error(We)}}return le},K}(),Ke=L.merge,G=L.checkSanitizeDeprecation,re=L.escape,Ee=C.getDefaults,Ne=C.changeDefaults,Ve=C.defaults;function Be(K,oe,he){if(typeof K=="undefined"||K===null)throw new Error("marked(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");if(typeof oe=="function"&&(he=oe,oe=null),oe=Ke({},Be.defaults,oe||{}),G(oe),he){var Z=oe.highlight,ne;try{ne=ee.lex(K,oe)}catch(He){return he(He)}var le=function(We){var qe;if(!We)try{qe=Se.parse(ne,oe)}catch(Ye){We=Ye}return oe.highlight=Z,We?he(We):he(null,qe)};if(!Z||Z.length<3||(delete oe.highlight,!ne.length))return le();var pe=0;Be.walkTokens(ne,function(He){He.type==="code"&&(pe++,setTimeout(function(){Z(He.text,He.lang,function(We,qe){if(We)return le(We);qe!=null&&qe!==He.text&&(He.text=qe,He.escaped=!0),pe--,pe===0&&le()})},0))}),pe===0&&le();return}try{var _e=ee.lex(K,oe);return oe.walkTokens&&Be.walkTokens(_e,oe.walkTokens),Se.parse(_e,oe)}catch(He){if(He.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+re(He.message+"",!0)+"</pre>";throw He}}Be.options=Be.setOptions=function(K){return Ke(Be.defaults,K),Ne(Be.defaults),Be},Be.getDefaults=Ee,Be.defaults=Ve,Be.use=function(K){var oe=Ke({},K);if(K.renderer&&function(){var Z=Be.defaults.renderer||new Oe,ne=function(_e){var He=Z[_e];Z[_e]=function(){for(var We=arguments.length,qe=new Array(We),Ye=0;Ye<We;Ye++)qe[Ye]=arguments[Ye];var Ze=K.renderer[_e].apply(Z,qe);return Ze===!1&&(Ze=He.apply(Z,qe)),Ze}};for(var le in K.renderer)ne(le);oe.renderer=Z}(),K.tokenizer&&function(){var Z=Be.defaults.tokenizer||new M,ne=function(_e){var He=Z[_e];Z[_e]=function(){for(var We=arguments.length,qe=new Array(We),Ye=0;Ye<We;Ye++)qe[Ye]=arguments[Ye];var Ze=K.tokenizer[_e].apply(Z,qe);return Ze===!1&&(Ze=He.apply(Z,qe)),Ze}};for(var le in K.tokenizer)ne(le);oe.tokenizer=Z}(),K.walkTokens){var he=Be.defaults.walkTokens;oe.walkTokens=function(Z){K.walkTokens(Z),he&&he(Z)}}Be.setOptions(oe)},Be.walkTokens=function(K,oe){for(var he=T(K),Z;!(Z=he()).done;){var ne=Z.value;switch(oe(ne),ne.type){case"table":{for(var le=T(ne.tokens.header),pe;!(pe=le()).done;){var _e=pe.value;Be.walkTokens(_e,oe)}for(var He=T(ne.tokens.cells),We;!(We=He()).done;)for(var qe=We.value,Ye=T(qe),Ze;!(Ze=Ye()).done;){var ut=Ze.value;Be.walkTokens(ut,oe)}break}case"list":{Be.walkTokens(ne.items,oe);break}default:ne.tokens&&Be.walkTokens(ne.tokens,oe)}}},Be.parseInline=function(K,oe){if(typeof K=="undefined"||K===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");oe=Ke({},Be.defaults,oe||{}),G(oe);try{var he=ee.lexInline(K,oe);return oe.walkTokens&&Be.walkTokens(he,oe.walkTokens),Se.parseInline(he,oe)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+re(Z.message+"",!0)+"</pre>";throw Z}},Be.Parser=Se,Be.parser=Se.parse,Be.Renderer=Oe,Be.TextRenderer=be,Be.Lexer=ee,Be.lexer=ee.lex,Be.Tokenizer=M,Be.Slugger=ke,Be.parse=Be;var et=Be;return et}),define(ge[72],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function _(C,A,y){return Math.min(Math.max(C,A),y)}e.clamp=_;function I(C,A){return(A+C%A)%A}e.rot=I;class T{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=T;class P{constructor(){this._n=1,this._val=0}update(A){return this._val=this._val+(A-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=P});"use strict";(function(){function Q(T){const P=[];typeof T=="number"&&P.push("code/timeOrigin",T);function C(y){P.push(y,Date.now())}function A(){const y=[];for(let n=0;n<P.length;n+=2)y.push({name:P[n],startTime:P[n+1]});return y}return{mark:C,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const C of performance.getEntriesByType("mark"))P.push({name:C.name,startTime:Math.round(T+C.startTime)});return P}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function _(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return _(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=_(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=_(I))})(),define(ge[9],ve([0,1]),function(Q,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const I="en";let T=!1,P=!1,C=!1,A=!1,y=!1,n=!1,R=!1,D,b=I,g,s;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const S=typeof((_=d==null?void 0:d.versions)===null||_===void 0?void 0:_.electron)=="string"&&d.type==="renderer";if(e.isElectronSandboxed=S&&(d==null?void 0:d.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=d==null?void 0:d.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!S)s=navigator.userAgent,T=s.indexOf("Windows")>=0,P=s.indexOf("Macintosh")>=0,R=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=s.indexOf("Linux")>=0,n=!0,D=navigator.language,b=D;else if(typeof d=="object"){T=d.platform==="win32",P=d.platform==="darwin",C=d.platform==="linux",A=C&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,D=I,b=I;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const c=JSON.parse(r),h=c.availableLanguages["*"];D=c.locale,b=h||I,g=c._translationsConfigFile}catch(c){}y=!0}else console.error("Unable to resolve platform.");var v;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function E(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let m=0;P?m=1:T?m=3:C&&(m=2),e.isWindows=T,e.isMacintosh=P,e.isLinux=C,e.isLinuxSnap=A,e.isNative=y,e.isWeb=n,e.isIOS=R,e.platform=m,e.userAgent=s,e.language=b;var l;(function(r){function c(){return e.language}r.value=c;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=h;function p(){return e.language==="en"}r.isDefault=p})(l=e.Language||(e.Language={})),e.locale=D,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let h=[];e.globals.addEventListener("message",w=>{if(w.data&&w.data.vscodeSetImmediateId)for(let u=0,f=h.length;u<f;u++){const k=h[u];if(k.id===w.data.vscodeSetImmediateId){h.splice(u,1),k.callback();return}}});let p=0;return w=>{const u=++p;h.push({id:u,callback:w}),e.globals.postMessage({vscodeSetImmediateId:u},"*")}}if(typeof(d==null?void 0:d.nextTick)=="function")return d.nextTick.bind(d);const c=Promise.resolve();return h=>c.then(h)}();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||R?2:T?1:3;let t=!0,i=!1;function a(){if(!i){i=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=a}),define(ge[30],ve([0,1,9]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let I;if(typeof _.globals.vscode!="undefined"){const T=_.globals.vscode.process;I={get platform(){return T.platform},get env(){return T.env},cwd(){return T.cwd()},nextTick(P){return(0,_.setImmediate)(P)}}}else typeof process!="undefined"?I={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(T){return process.nextTick(T)}}:I={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},nextTick(T){return(0,_.setImmediate)(T)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=I.cwd,e.env=I.env,e.platform=I.platform,e.nextTick=I.nextTick}),define(ge[8],ve([0,1,30]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const I=65,T=97,P=90,C=122,A=46,y=47,n=92,R=58,D=63;class b extends Error{constructor(l,o,t){let i;typeof o=="string"&&o.indexOf("not ")===0?(i="must not be",o=o.replace(/^not /,"")):i="must be";const a=l.indexOf(".")!==-1?"property":"argument";let r=`The "${l}" ${a} ${i} of type ${o}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function g(m,l){if(typeof m!="string")throw new b(l,"string",m)}function s(m){return m===y||m===n}function d(m){return m===y}function S(m){return m>=I&&m<=P||m>=T&&m<=C}function v(m,l,o,t){let i="",a=0,r=-1,c=0,h=0;for(let p=0;p<=m.length;++p){if(p<m.length)h=m.charCodeAt(p);else{if(t(h))break;h=y}if(t(h)){if(!(r===p-1||c===1))if(c===2){if(i.length<2||a!==2||i.charCodeAt(i.length-1)!==A||i.charCodeAt(i.length-2)!==A){if(i.length>2){const w=i.lastIndexOf(o);w===-1?(i="",a=0):(i=i.slice(0,w),a=i.length-1-i.lastIndexOf(o)),r=p,c=0;continue}else if(i.length!==0){i="",a=0,r=p,c=0;continue}}l&&(i+=i.length>0?`${o}..`:"..",a=2)}else i.length>0?i+=`${o}${m.slice(r+1,p)}`:i=m.slice(r+1,p),a=p-r-1;r=p,c=0}else h===A&&c!==-1?++c:c=-1}return i}function E(m,l){if(l===null||typeof l!="object")throw new b("pathObject","Object",l);const o=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return o?o===l.root?`${o}${t}`:`${o}${m}${t}`:t}e.win32={resolve(...m){let l="",o="",t=!1;for(let i=m.length-1;i>=-1;i--){let a;if(i>=0){if(a=m[i],g(a,"path"),a.length===0)continue}else l.length===0?a=_.cwd():(a=_.env[`=${l}`]||_.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==l.toLowerCase()&&a.charCodeAt(2)===n)&&(a=`${l}\\`));const r=a.length;let c=0,h="",p=!1;const w=a.charCodeAt(0);if(r===1)s(w)&&(c=1,p=!0);else if(s(w))if(p=!0,s(a.charCodeAt(1))){let u=2,f=u;for(;u<r&&!s(a.charCodeAt(u));)u++;if(u<r&&u!==f){const k=a.slice(f,u);for(f=u;u<r&&s(a.charCodeAt(u));)u++;if(u<r&&u!==f){for(f=u;u<r&&!s(a.charCodeAt(u));)u++;(u===r||u!==f)&&(h=`\\\\${k}\\${a.slice(f,u)}`,c=u)}}}else c=1;else S(w)&&a.charCodeAt(1)===R&&(h=a.slice(0,2),c=2,r>2&&s(a.charCodeAt(2))&&(p=!0,c=3));if(h.length>0)if(l.length>0){if(h.toLowerCase()!==l.toLowerCase())continue}else l=h;if(t){if(l.length>0)break}else if(o=`${a.slice(c)}\\${o}`,t=p,p&&l.length>0)break}return o=v(o,!t,"\\",s),t?`${l}\\${o}`:`${l}${o}`||"."},normalize(m){g(m,"path");const l=m.length;if(l===0)return".";let o=0,t,i=!1;const a=m.charCodeAt(0);if(l===1)return d(a)?"\\":m;if(s(a))if(i=!0,s(m.charCodeAt(1))){let c=2,h=c;for(;c<l&&!s(m.charCodeAt(c));)c++;if(c<l&&c!==h){const p=m.slice(h,c);for(h=c;c<l&&s(m.charCodeAt(c));)c++;if(c<l&&c!==h){for(h=c;c<l&&!s(m.charCodeAt(c));)c++;if(c===l)return`\\\\${p}\\${m.slice(h)}\\`;c!==h&&(t=`\\\\${p}\\${m.slice(h,c)}`,o=c)}}}else o=1;else S(a)&&m.charCodeAt(1)===R&&(t=m.slice(0,2),o=2,l>2&&s(m.charCodeAt(2))&&(i=!0,o=3));let r=o<l?v(m.slice(o),!i,"\\",s):"";return r.length===0&&!i&&(r="."),r.length>0&&s(m.charCodeAt(l-1))&&(r+="\\"),t===void 0?i?`\\${r}`:r:i?`${t}\\${r}`:`${t}${r}`},isAbsolute(m){g(m,"path");const l=m.length;if(l===0)return!1;const o=m.charCodeAt(0);return s(o)||l>2&&S(o)&&m.charCodeAt(1)===R&&s(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let l,o;for(let a=0;a<m.length;++a){const r=m[a];g(r,"path"),r.length>0&&(l===void 0?l=o=r:l+=`\\${r}`)}if(l===void 0)return".";let t=!0,i=0;if(typeof o=="string"&&s(o.charCodeAt(0))){++i;const a=o.length;a>1&&s(o.charCodeAt(1))&&(++i,a>2&&(s(o.charCodeAt(2))?++i:t=!1))}if(t){for(;i<l.length&&s(l.charCodeAt(i));)i++;i>=2&&(l=`\\${l.slice(i)}`)}return e.win32.normalize(l)},relative(m,l){if(g(m,"from"),g(l,"to"),m===l)return"";const o=e.win32.resolve(m),t=e.win32.resolve(l);if(o===t||(m=o.toLowerCase(),l=t.toLowerCase(),m===l))return"";let i=0;for(;i<m.length&&m.charCodeAt(i)===n;)i++;let a=m.length;for(;a-1>i&&m.charCodeAt(a-1)===n;)a--;const r=a-i;let c=0;for(;c<l.length&&l.charCodeAt(c)===n;)c++;let h=l.length;for(;h-1>c&&l.charCodeAt(h-1)===n;)h--;const p=h-c,w=r<p?r:p;let u=-1,f=0;for(;f<w;f++){const L=m.charCodeAt(i+f);if(L!==l.charCodeAt(c+f))break;L===n&&(u=f)}if(f!==w){if(u===-1)return t}else{if(p>w){if(l.charCodeAt(c+f)===n)return t.slice(c+f+1);if(f===2)return t.slice(c+f)}r>w&&(m.charCodeAt(i+f)===n?u=f:f===2&&(u=3)),u===-1&&(u=0)}let k="";for(f=i+u+1;f<=a;++f)(f===a||m.charCodeAt(f)===n)&&(k+=k.length===0?"..":"\\..");return c+=u,k.length>0?`${k}${t.slice(c,h)}`:(t.charCodeAt(c)===n&&++c,t.slice(c,h))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const l=e.win32.resolve(m);if(l.length<=2)return m;if(l.charCodeAt(0)===n){if(l.charCodeAt(1)===n){const o=l.charCodeAt(2);if(o!==D&&o!==A)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(S(l.charCodeAt(0))&&l.charCodeAt(1)===R&&l.charCodeAt(2)===n)return`\\\\?\\${l}`;return m},dirname(m){g(m,"path");const l=m.length;if(l===0)return".";let o=-1,t=0;const i=m.charCodeAt(0);if(l===1)return s(i)?m:".";if(s(i)){if(o=t=1,s(m.charCodeAt(1))){let c=2,h=c;for(;c<l&&!s(m.charCodeAt(c));)c++;if(c<l&&c!==h){for(h=c;c<l&&s(m.charCodeAt(c));)c++;if(c<l&&c!==h){for(h=c;c<l&&!s(m.charCodeAt(c));)c++;if(c===l)return m;c!==h&&(o=t=c+1)}}}}else S(i)&&m.charCodeAt(1)===R&&(o=l>2&&s(m.charCodeAt(2))?3:2,t=o);let a=-1,r=!0;for(let c=l-1;c>=t;--c)if(s(m.charCodeAt(c))){if(!r){a=c;break}}else r=!1;if(a===-1){if(o===-1)return".";a=o}return m.slice(0,a)},basename(m,l){l!==void 0&&g(l,"ext"),g(m,"path");let o=0,t=-1,i=!0,a;if(m.length>=2&&S(m.charCodeAt(0))&&m.charCodeAt(1)===R&&(o=2),l!==void 0&&l.length>0&&l.length<=m.length){if(l===m)return"";let r=l.length-1,c=-1;for(a=m.length-1;a>=o;--a){const h=m.charCodeAt(a);if(s(h)){if(!i){o=a+1;break}}else c===-1&&(i=!1,c=a+1),r>=0&&(h===l.charCodeAt(r)?--r==-1&&(t=a):(r=-1,t=c))}return o===t?t=c:t===-1&&(t=m.length),m.slice(o,t)}for(a=m.length-1;a>=o;--a)if(s(m.charCodeAt(a))){if(!i){o=a+1;break}}else t===-1&&(i=!1,t=a+1);return t===-1?"":m.slice(o,t)},extname(m){g(m,"path");let l=0,o=-1,t=0,i=-1,a=!0,r=0;m.length>=2&&m.charCodeAt(1)===R&&S(m.charCodeAt(0))&&(l=t=2);for(let c=m.length-1;c>=l;--c){const h=m.charCodeAt(c);if(s(h)){if(!a){t=c+1;break}continue}i===-1&&(a=!1,i=c+1),h===A?o===-1?o=c:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||i===-1||r===0||r===1&&o===i-1&&o===t+1?"":m.slice(o,i)},format:E.bind(null,"\\"),parse(m){g(m,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return l;const o=m.length;let t=0,i=m.charCodeAt(0);if(o===1)return s(i)?(l.root=l.dir=m,l):(l.base=l.name=m,l);if(s(i)){if(t=1,s(m.charCodeAt(1))){let u=2,f=u;for(;u<o&&!s(m.charCodeAt(u));)u++;if(u<o&&u!==f){for(f=u;u<o&&s(m.charCodeAt(u));)u++;if(u<o&&u!==f){for(f=u;u<o&&!s(m.charCodeAt(u));)u++;u===o?t=u:u!==f&&(t=u+1)}}}}else if(S(i)&&m.charCodeAt(1)===R){if(o<=2)return l.root=l.dir=m,l;if(t=2,s(m.charCodeAt(2))){if(o===3)return l.root=l.dir=m,l;t=3}}t>0&&(l.root=m.slice(0,t));let a=-1,r=t,c=-1,h=!0,p=m.length-1,w=0;for(;p>=t;--p){if(i=m.charCodeAt(p),s(i)){if(!h){r=p+1;break}continue}c===-1&&(h=!1,c=p+1),i===A?a===-1?a=p:w!==1&&(w=1):a!==-1&&(w=-1)}return c!==-1&&(a===-1||w===0||w===1&&a===c-1&&a===r+1?l.base=l.name=m.slice(r,c):(l.name=m.slice(r,a),l.base=m.slice(r,c),l.ext=m.slice(a,c))),r>0&&r!==t?l.dir=m.slice(0,r-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let l="",o=!1;for(let t=m.length-1;t>=-1&&!o;t--){const i=t>=0?m[t]:_.cwd();g(i,"path"),i.length!==0&&(l=`${i}/${l}`,o=i.charCodeAt(0)===y)}return l=v(l,!o,"/",d),o?`/${l}`:l.length>0?l:"."},normalize(m){if(g(m,"path"),m.length===0)return".";const l=m.charCodeAt(0)===y,o=m.charCodeAt(m.length-1)===y;return m=v(m,!l,"/",d),m.length===0?l?"/":o?"./":".":(o&&(m+="/"),l?`/${m}`:m)},isAbsolute(m){return g(m,"path"),m.length>0&&m.charCodeAt(0)===y},join(...m){if(m.length===0)return".";let l;for(let o=0;o<m.length;++o){const t=m[o];g(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(m,l){if(g(m,"from"),g(l,"to"),m===l||(m=e.posix.resolve(m),l=e.posix.resolve(l),m===l))return"";const o=1,t=m.length,i=t-o,a=1,r=l.length-a,c=i<r?i:r;let h=-1,p=0;for(;p<c;p++){const u=m.charCodeAt(o+p);if(u!==l.charCodeAt(a+p))break;u===y&&(h=p)}if(p===c)if(r>c){if(l.charCodeAt(a+p)===y)return l.slice(a+p+1);if(p===0)return l.slice(a+p)}else i>c&&(m.charCodeAt(o+p)===y?h=p:p===0&&(h=0));let w="";for(p=o+h+1;p<=t;++p)(p===t||m.charCodeAt(p)===y)&&(w+=w.length===0?"..":"/..");return`${w}${l.slice(a+h)}`},toNamespacedPath(m){return m},dirname(m){if(g(m,"path"),m.length===0)return".";const l=m.charCodeAt(0)===y;let o=-1,t=!0;for(let i=m.length-1;i>=1;--i)if(m.charCodeAt(i)===y){if(!t){o=i;break}}else t=!1;return o===-1?l?"/":".":l&&o===1?"//":m.slice(0,o)},basename(m,l){l!==void 0&&g(l,"ext"),g(m,"path");let o=0,t=-1,i=!0,a;if(l!==void 0&&l.length>0&&l.length<=m.length){if(l===m)return"";let r=l.length-1,c=-1;for(a=m.length-1;a>=0;--a){const h=m.charCodeAt(a);if(h===y){if(!i){o=a+1;break}}else c===-1&&(i=!1,c=a+1),r>=0&&(h===l.charCodeAt(r)?--r==-1&&(t=a):(r=-1,t=c))}return o===t?t=c:t===-1&&(t=m.length),m.slice(o,t)}for(a=m.length-1;a>=0;--a)if(m.charCodeAt(a)===y){if(!i){o=a+1;break}}else t===-1&&(i=!1,t=a+1);return t===-1?"":m.slice(o,t)},extname(m){g(m,"path");let l=-1,o=0,t=-1,i=!0,a=0;for(let r=m.length-1;r>=0;--r){const c=m.charCodeAt(r);if(c===y){if(!i){o=r+1;break}continue}t===-1&&(i=!1,t=r+1),c===A?l===-1?l=r:a!==1&&(a=1):l!==-1&&(a=-1)}return l===-1||t===-1||a===0||a===1&&l===t-1&&l===o+1?"":m.slice(l,t)},format:E.bind(null,"/"),parse(m){g(m,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return l;const o=m.charCodeAt(0)===y;let t;o?(l.root="/",t=1):t=0;let i=-1,a=0,r=-1,c=!0,h=m.length-1,p=0;for(;h>=t;--h){const w=m.charCodeAt(h);if(w===y){if(!c){a=h+1;break}continue}r===-1&&(c=!1,r=h+1),w===A?i===-1?i=h:p!==1&&(p=1):i!==-1&&(p=-1)}if(r!==-1){const w=a===0&&o?1:a;i===-1||p===0||p===1&&i===r-1&&i===a+1?l.base=l.name=m.slice(w,r):(l.name=m.slice(w,i),l.base=m.slice(w,r),l.ext=m.slice(i,r))}return a>0?l.dir=m.slice(0,a-1):o&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=_.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=_.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=_.platform==="win32"?e.win32.join:e.posix.join,e.resolve=_.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=_.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=_.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=_.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=_.platform==="win32"?e.win32.extname:e.posix.extname,e.format=_.platform==="win32"?e.win32.format:e.posix.format,e.parse=_.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=_.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=_.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=_.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[134],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var _;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(_=e.Source||(e.Source={}));var I;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(P,...C){const A=C.reduce((R,D)=>(R[D]=!0,R),{}),y=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(R=>!A[R]).forEach(R=>{for(let D=0;D<y.length;D++)if(R.search(y[D])!==-1){delete P[R];break}})}e.sanitizeProcessEnvironment=T}),define(ge[46],ve([0,1,9]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=_.globals.performance&&typeof _.globals.performance.now=="function";class T{constructor(C){this._highResolution=I&&C,this._startTime=this._now(),this._stopTime=-1}static create(C=!0){return new T(C)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?_.globals.performance.now():Date.now()}}e.StopWatch=T}),define(ge[3],ve([0,1,18,69,6,55,46]),function(Q,e,_,I,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var A;(function(v){v.None=()=>T.Disposable.None;function E(H){return(x,B=null,F)=>{let U=!1,M;return M=H(N=>{if(!U)return M?M.dispose():U=!0,x.call(B,N)},null,F),U&&M.dispose(),M}}v.once=E;function m(H,x){return r((B,F=null,U)=>H(M=>B.call(F,x(M)),null,U))}v.map=m;function l(H,x){return r((B,F=null,U)=>H(M=>{x(M),B.call(F,M)},null,U))}v.forEach=l;function o(H,x){return r((B,F=null,U)=>H(M=>x(M)&&B.call(F,M),null,U))}v.filter=o;function t(H){return H}v.signal=t;function i(...H){return(x,B=null,F)=>(0,T.combinedDisposable)(...H.map(U=>U(M=>x.call(B,M),null,F)))}v.any=i;function a(H,x,B){let F=B;return m(H,U=>(F=x(F,U),F))}v.reduce=a;function r(H){let x;const B=new b({onFirstListenerAdd(){x=H(B.fire,B)},onLastListenerRemove(){x.dispose()}});return B.event}v.snapshot=r;function c(H,x,B=100,F=!1,U){let M,N,O,j=0;const q=new b({leakWarningThreshold:U,onFirstListenerAdd(){M=H(X=>{j++,N=x(N,X),F&&!O&&(q.fire(N),N=void 0),clearTimeout(O),O=setTimeout(()=>{const me=N;N=void 0,O=void 0,(!F||j>1)&&q.fire(me),j=0},B)})},onLastListenerRemove(){M.dispose()}});return q.event}v.debounce=c;function h(H){const x=new Date().getTime();return m(E(H),B=>new Date().getTime()-x)}v.stopwatch=h;function p(H){let x=!0,B;return o(H,F=>{const U=x||F!==B;return x=!1,B=F,U})}v.latch=p;function w(H,x=!1,B=[]){let F=B.slice(),U=H(O=>{F?F.push(O):N.fire(O)});const M=()=>{F&&F.forEach(O=>N.fire(O)),F=null},N=new b({onFirstListenerAdd(){U||(U=H(O=>N.fire(O)))},onFirstListenerDidAdd(){F&&(x?setTimeout(M):M())},onLastListenerRemove(){U&&U.dispose(),U=null}});return N.event}v.buffer=w;class u{constructor(x){this.event=x}map(x){return new u(m(this.event,x))}forEach(x){return new u(l(this.event,x))}filter(x){return new u(o(this.event,x))}reduce(x,B){return new u(a(this.event,x,B))}latch(){return new u(p(this.event))}debounce(x,B=100,F=!1,U){return new u(c(this.event,x,B,F,U))}on(x,B,F){return this.event(x,B,F)}once(x,B,F){return E(this.event)(x,B,F)}}function f(H){return new u(H)}v.chain=f;function k(H,x,B=F=>F){const F=(...O)=>N.fire(B(...O)),U=()=>H.on(x,F),M=()=>H.removeListener(x,F),N=new b({onFirstListenerAdd:U,onLastListenerRemove:M});return N.event}v.fromNodeEventEmitter=k;function L(H,x,B=F=>F){const F=(...O)=>N.fire(B(...O)),U=()=>H.addEventListener(x,F),M=()=>H.removeEventListener(x,F),N=new b({onFirstListenerAdd:U,onLastListenerRemove:M});return N.event}v.fromDOMEventEmitter=L;function $(H){const x=new b;let B=!1;return H.then(void 0,()=>null).then(()=>{B?x.fire(void 0):setTimeout(()=>x.fire(void 0),0)}),B=!0,x.event}v.fromPromise=$;function te(H){return new Promise(x=>E(H)(x))}v.toPromise=te})(A=e.Event||(e.Event={}));class y{constructor(E){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${E}_${y._idPool++}`}start(E){this._stopWatch=new C.StopWatch(!0),this._listenerCount=E}stop(){if(this._stopWatch){const E=this._stopWatch.elapsed();this._elapsedOverall+=E,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${E.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let n=-1;function R(v){const E=n;return n=v,{dispose(){n=E}}}e.setGlobalLeakWarningThreshold=R;class D{constructor(E,m=Math.random().toString(18).slice(2,5)){this.customThreshold=E,this.name=m,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(E){let m=n;if(typeof this.customThreshold=="number"&&(m=this.customThreshold),!(m<=0||E<m)){this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),o=this._stacks.get(l)||0;if(this._stacks.set(l,o+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=m*.5;let t,i=0;for(const[a,r]of this._stacks)(!t||i<r)&&(t=a,i=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(l)||0;this._stacks.set(l,t-1)}}}}class b{constructor(E){var m;this._disposed=!1,this._options=E,this._leakageMon=n>0?new D(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((m=this._options)===null||m===void 0?void 0:m._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(E,m,l)=>{var o;this._listeners||(this._listeners=new P.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(m?[E,m]:E);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,E,m);const a=(o=this._leakageMon)===null||o===void 0?void 0:o.check(this._listeners.size);let r;return r={dispose:()=>{a&&a(),r.dispose=b._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof T.DisposableStore?l.add(r):Array.isArray(l)&&l.push(r),r}),this._event}fire(E){var m,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new P.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,E]);for((m=this._perfMon)===null||m===void 0||m.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,t]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,t):o[0].call(o[1],t)}catch(i){(0,_.onUnexpectedError)(i)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var E,m,l;(E=this._listeners)===null||E===void 0||E.clear(),(m=this._deliveryQueue)===null||m===void 0||m.clear(),(l=this._leakageMon)===null||l===void 0||l.dispose(),this._disposed=!0}}e.Emitter=b,b._noop=function(){};class g extends b{constructor(E){super(E);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=E==null?void 0:E.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const E=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(E))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(E){this._listeners&&(this._isPaused!==0?this._eventQueue.push(E):super.fire(E))}}e.PauseableEmitter=g;class s{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(E){const m={event:E,listener:null};this.events.push(m),this.hasListeners&&this.hook(m);const l=()=>{this.hasListeners&&this.unhook(m);const o=this.events.indexOf(m);this.events.splice(o,1)};return(0,T.toDisposable)((0,I.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(E=>this.hook(E))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(E=>this.unhook(E))}hook(E){E.listener=E.event(m=>this.emitter.fire(m))}unhook(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=s;class d{constructor(){this.buffers=[]}wrapEvent(E){return(m,l,o)=>E(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>m.call(l,t)):m.call(l,t)},void 0,o)}bufferEvents(E){const m=[];this.buffers.push(m);const l=E();return this.buffers.pop(),m.forEach(o=>o()),l}}e.EventBufferer=d;class S{constructor(){this.listening=!1,this.inputEvent=A.None,this.inputEventListener=T.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(E){this.inputEvent=E,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=E(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S}),define(ge[21],ve([0,1,3]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const I=Object.freeze(function(A,y){const n=setTimeout(A.bind(y),0);return{dispose(){clearTimeout(n)}}});var T;(function(A){function y(n){return n===A.None||n===A.Cancelled||n instanceof P?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}A.isCancellationToken=y,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:I})})(T=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?I:(this._emitter||(this._emitter=new _.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=T.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=C}),define(ge[47],ve([0,1,3]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class I{constructor(){this._icons=new Map,this._onDidRegister=new _.Emitter}add(R){const D=this._icons.get(R.id);D?R.description?D.description=R.description:console.error(`Duplicate registration of codicon ${R.id}`):(this._icons.set(R.id,R),this._onDidRegister.fire(R))}get(R){return this._icons.get(R)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const T=new I;e.iconRegistry=T;function P(n,R){return new C(n,R)}e.registerCodicon=P;class C{constructor(R,D,b){this.id=R,this.definition=D,this.description=b,T.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function A(n,R){const D=["codicon","codicon-"+n];return R&&D.push("codicon-modifier-"+R),D}e.getClassNamesArray=A;var y;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const R=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function D(s){if(s instanceof C)return["codicon","codicon-"+s.id];const d=R.exec(s.id);if(!d)return D(C.error);let[,S,v]=d;const E=["codicon","codicon-"+S];return v&&E.push("codicon-modifier-"+v.substr(1)),E}n.asClassNameArray=D;function b(s){return D(s).join(" ")}n.asClassName=b;function g(s){return"."+D(s).join(".")}n.asCSSSelector=g})(y=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personAdd=new n("person-add",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(ge[91],ve([0,1,18,6]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function T(S){const v=S;return v&&[v.on,v.pause,v.resume,v.destroy].every(E=>typeof E=="function")}e.isReadableStream=T;function P(S){const v=S;return v&&T(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean"}e.isReadableBufferedStream=P;function C(S,v){return new A(S,v)}e.newWriteableStream=C;class A{constructor(v,E){this.reducer=v,this.options=E,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(v){var E;if(!this.state.destroyed){if(this.state.flowing)this.emitData(v);else if(this.buffer.data.push(v),typeof((E=this.options)===null||E===void 0?void 0:E.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(m=>this.pendingWritePromises.push(m))}}error(v){this.state.destroyed||(this.state.flowing?this.emitError(v):this.buffer.error.push(v))}end(v){this.state.destroyed||(typeof v!="undefined"&&this.write(v),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(v){this.listeners.data.slice(0).forEach(E=>E(v))}emitError(v){this.listeners.error.length===0?(0,_.onUnexpectedError)(v):this.listeners.error.slice(0).forEach(E=>E(v))}emitEnd(){this.listeners.end.slice(0).forEach(v=>v())}on(v,E){if(!this.state.destroyed)switch(v){case"data":this.listeners.data.push(E),this.resume();break;case"end":this.listeners.end.push(E),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(E),this.state.flowing&&this.flowErrors();break}}removeListener(v,E){if(!this.state.destroyed){let m;switch(v){case"data":m=this.listeners.data;break;case"end":m=this.listeners.end;break;case"error":m=this.listeners.error;break}if(m){const l=m.indexOf(E);l>=0&&m.splice(l,1)}}}flowData(){if(this.buffer.data.length>0){const v=this.reducer(this.buffer.data);this.emitData(v),this.buffer.data.length=0;const E=[...this.pendingWritePromises];this.pendingWritePromises.length=0,E.forEach(m=>m())}}flowErrors(){if(this.listeners.error.length>0){for(const v of this.buffer.error)this.emitError(v);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(S,v){const E=[];let m;for(;(m=S.read())!==null;)E.push(m);return v(E)}e.consumeReadable=y;function n(S,v,E){const m=[];let l;for(;(l=S.read())!==null&&m.length<E;)m.push(l);return l===null&&m.length>0?v(m):{read:()=>{if(m.length>0)return m.shift();if(typeof l!="undefined"){const o=l;return l=void 0,o}return S.read()}}}e.peekReadable=n;function R(S,v){return new Promise((E,m)=>{const l=[];D(S,{onData:o=>{v&&l.push(o)},onError:o=>{v?m(o):E(void 0)},onEnd:()=>{E(v?v(l):void 0)}})})}e.consumeStream=R;function D(S,v){S.on("error",E=>v.onError(E)),S.on("end",()=>v.onEnd()),S.on("data",E=>v.onData(E))}e.listenStream=D;function b(S,v){return new Promise((E,m)=>{const l=new I.DisposableStore,o=[],t=r=>{if(o.push(r),o.length>v)return l.dispose(),S.pause(),E({stream:S,buffer:o,ended:!1})},i=r=>m(r),a=()=>E({stream:S,buffer:o,ended:!0});l.add((0,I.toDisposable)(()=>S.removeListener("error",i))),S.on("error",i),l.add((0,I.toDisposable)(()=>S.removeListener("end",a))),S.on("end",a),l.add((0,I.toDisposable)(()=>S.removeListener("data",t))),S.on("data",t)})}e.peekStream=b;function g(S,v){const E=C(v);return E.end(S),E}e.toStream=g;function s(S){let v=!1;return{read:()=>v?null:(v=!0,S)}}e.toReadable=s;function d(S,v,E){const m=C(E);return D(S,{onData:l=>m.write(v.data(l)),onError:l=>m.error(v.error?v.error(l):l),onEnd:()=>m.end()}),m}e.transform=d}),define(ge[10],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function _(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=_;const I=/{(\d+)}/g;function T(K,...oe){return oe.length===0?K:K.replace(I,function(he,Z){const ne=parseInt(Z,10);return isNaN(ne)||ne<0||ne>=oe.length?he:oe[ne]})}e.format=T;function P(K){return K.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=P;function C(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function A(K,oe){let he=0;const Z=oe.charCodeAt(0);for(let ne=K.length-1;ne>=0;ne--)K.charCodeAt(ne)===Z&&he++;return he}e.count=A;function y(K,oe,he="\u2026"){return K.length<=oe?K:`${K.substr(0,oe)}${he}`}e.truncate=y;function n(K,oe=" "){const he=R(K,oe);return D(he,oe)}e.trim=n;function R(K,oe){if(!K||!oe)return K;const he=oe.length;if(he===0||K.length===0)return K;let Z=0;for(;K.indexOf(oe,Z)===Z;)Z=Z+he;return K.substring(Z)}e.ltrim=R;function D(K,oe){if(!K||!oe)return K;const he=oe.length,Z=K.length;if(he===0||Z===0)return K;let ne=Z,le=-1;for(;le=K.lastIndexOf(oe,ne-1),!(le===-1||le+he!==ne);){if(le===0)return"";ne=le}return K.substring(0,ne)}e.rtrim=D;function b(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=b;function g(K){return K.replace(/\*/g,"")}e.stripWildcards=g;function s(K,oe,he={}){if(!K)throw new Error("Cannot create regex from empty string");oe||(K=C(K)),he.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let Z="";return he.global&&(Z+="g"),he.matchCase||(Z+="i"),he.multiline&&(Z+="m"),he.unicode&&(Z+="u"),new RegExp(K,Z)}e.createRegExp=s;function d(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function S(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function v(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=v;function E(K){return K.split(/\r\n|\r|\n/)}e.splitLines=E;function m(K){for(let oe=0,he=K.length;oe<he;oe++){const Z=K.charCodeAt(oe);if(Z!==32&&Z!==9)return oe}return-1}e.firstNonWhitespaceIndex=m;function l(K,oe=0,he=K.length){for(let Z=oe;Z<he;Z++){const ne=K.charCodeAt(Z);if(ne!==32&&ne!==9)return K.substring(oe,Z)}return K.substring(oe,he)}e.getLeadingWhitespace=l;function o(K,oe=K.length-1){for(let he=oe;he>=0;he--){const Z=K.charCodeAt(he);if(Z!==32&&Z!==9)return he}return-1}e.lastNonWhitespaceIndex=o;function t(K,oe){return K<oe?-1:K>oe?1:0}e.compare=t;function i(K,oe,he=0,Z=K.length,ne=0,le=oe.length){for(;he<Z&&ne<le;he++,ne++){let He=K.charCodeAt(he),We=oe.charCodeAt(ne);if(He<We)return-1;if(He>We)return 1}const pe=Z-he,_e=le-ne;return pe<_e?-1:pe>_e?1:0}e.compareSubstring=i;function a(K,oe){return r(K,oe,0,K.length,0,oe.length)}e.compareIgnoreCase=a;function r(K,oe,he=0,Z=K.length,ne=0,le=oe.length){for(;he<Z&&ne<le;he++,ne++){let He=K.charCodeAt(he),We=oe.charCodeAt(ne);if(He!==We){const qe=He-We;if(!(qe===32&&h(We))&&!(qe===-32&&h(He)))return c(He)&&c(We)?qe:i(K.toLowerCase(),oe.toLowerCase(),he,Z,ne,le)}}const pe=Z-he,_e=le-ne;return pe<_e?-1:pe>_e?1:0}e.compareSubstringIgnoreCase=r;function c(K){return K>=97&&K<=122}e.isLowerAsciiLetter=c;function h(K){return K>=65&&K<=90}e.isUpperAsciiLetter=h;function p(K){return c(K)||h(K)}function w(K,oe){return K.length===oe.length&&u(K,oe)}e.equalsIgnoreCase=w;function u(K,oe,he=K.length){for(let Z=0;Z<he;Z++){const ne=K.charCodeAt(Z),le=oe.charCodeAt(Z);if(ne!==le){if(p(ne)&&p(le)){const pe=Math.abs(ne-le);if(pe!==0&&pe!==32)return!1}else if(String.fromCharCode(ne).toLowerCase()!==String.fromCharCode(le).toLowerCase())return!1}}return!0}function f(K,oe){const he=oe.length;return oe.length>K.length?!1:u(K,oe,he)}e.startsWithIgnoreCase=f;function k(K,oe){let he,Z=Math.min(K.length,oe.length);for(he=0;he<Z;he++)if(K.charCodeAt(he)!==oe.charCodeAt(he))return he;return Z}e.commonPrefixLength=k;function L(K,oe){let he,Z=Math.min(K.length,oe.length);const ne=K.length-1,le=oe.length-1;for(he=0;he<Z;he++)if(K.charCodeAt(ne-he)!==oe.charCodeAt(le-he))return he;return Z}e.commonSuffixLength=L;function $(K){return 55296<=K&&K<=56319}e.isHighSurrogate=$;function te(K){return 56320<=K&&K<=57343}e.isLowSurrogate=te;function H(K,oe){return(K-55296<<10)+(oe-56320)+65536}e.computeCodePoint=H;function x(K,oe,he){const Z=K.charCodeAt(he);if($(Z)&&he+1<oe){const ne=K.charCodeAt(he+1);if(te(ne))return H(Z,ne)}return Z}e.getNextCodePoint=x;function B(K,oe){const he=K.charCodeAt(oe-1);if(te(he)&&oe>1){const Z=K.charCodeAt(oe-2);if($(Z))return H(Z,he)}return he}function F(K,oe){const he=Be.getInstance(),Z=oe,ne=K.length,le=x(K,ne,oe);oe+=le>=65536?2:1;let pe=he.getGraphemeBreakType(le);for(;oe<ne;){const _e=x(K,ne,oe),He=he.getGraphemeBreakType(_e);if(Ne(pe,He))break;oe+=_e>=65536?2:1,pe=He}return oe-Z}e.nextCharLength=F;function U(K,oe){const he=Be.getInstance(),Z=oe,ne=B(K,oe);oe-=ne>=65536?2:1;let le=he.getGraphemeBreakType(ne);for(;oe>0;){const pe=B(K,oe),_e=he.getGraphemeBreakType(pe);if(Ne(_e,le))break;oe-=pe>=65536?2:1,le=_e}return Z-oe}e.prevCharLength=U;function M(K,oe){const he=Be.getInstance(),Z=K.length,ne=oe,le=x(K,Z,oe),pe=he.getGraphemeBreakType(le);oe+=le>=65536?2:1;let _e=pe;for(;oe<Z;){const We=x(K,Z,oe),qe=he.getGraphemeBreakType(We);if(Ne(_e,qe))break;oe+=We>=65536?2:1,_e=qe}const He=oe;for(oe=ne,_e=pe;oe>0;){const We=B(K,oe),qe=he.getGraphemeBreakType(We);if(Ne(qe,_e))break;oe-=We>=65536?2:1,_e=qe}return[oe,He]}function N(K,oe){return oe>0&&te(K.charCodeAt(oe))?M(K,oe-1):M(K,oe)}e.getCharContainingOffset=N;function O(K){const oe=K.length;let he=0,Z=0;for(;Z<oe;){const pe=x(K,oe,Z);Z+=pe>=65536?2:1,pe<128?he+=1:pe<2048?he+=2:pe<65536?he+=3:he+=4}const ne=new Uint8Array(he);Z=0;let le=0;for(;Z<oe;){const pe=x(K,oe,Z);Z+=pe>=65536?2:1,pe<128?ne[le++]=pe:pe<2048?(ne[le++]=192|(pe&1984)>>>6,ne[le++]=128|(pe&63)>>>0):pe<65536?(ne[le++]=224|(pe&61440)>>>12,ne[le++]=128|(pe&4032)>>>6,ne[le++]=128|(pe&63)>>>0):(ne[le++]=240|(pe&1835008)>>>18,ne[le++]=128|(pe&258048)>>>12,ne[le++]=128|(pe&4032)>>>6,ne[le++]=128|(pe&63)>>>0)}return ne}e.encodeUTF8=O;function j(K){const oe=K.byteLength,he=[];let Z=0;for(;Z<oe;){const ne=K[Z];let le;if(ne>=240&&Z+3<oe?le=(K[Z++]&7)<<18>>>0|(K[Z++]&63)<<12>>>0|(K[Z++]&63)<<6>>>0|(K[Z++]&63)<<0>>>0:ne>=224&&Z+2<oe?le=(K[Z++]&15)<<12>>>0|(K[Z++]&63)<<6>>>0|(K[Z++]&63)<<0>>>0:ne>=192&&Z+1<oe?le=(K[Z++]&31)<<6>>>0|(K[Z++]&63)<<0>>>0:le=K[Z++],le>=0&&le<=55295||le>=57344&&le<=65535)he.push(String.fromCharCode(le));else if(le>=65536&&le<=1114111){const pe=le-65536,_e=55296+((pe&1047552)>>>10),He=56320+((pe&1023)>>>0);he.push(String.fromCharCode(_e)),he.push(String.fromCharCode(He))}else he.push(String.fromCharCode(65533))}return he.join("")}e.decodeUTF8=j;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(K){return q.test(K)}e.containsRTL=X;const me=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function we(K){return me.test(K)}e.containsEmoji=we;const Ae=/^[\t\n\r\x20-\x7E]*$/;function Ie(K){return Ae.test(K)}e.isBasicASCII=Ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Me(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Me;function V(K){for(let oe=0,he=K.length;oe<he;oe++)if(Y(K.charCodeAt(oe)))return!0;return!1}e.containsFullWidthCharacter=V;function Y(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=Y;function ee(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=ee;function ae(K,oe){if(K.length<oe)return K;const he=/\b/g;let Z=0;for(;he.test(K)&&!(K.length-he.lastIndex<oe);)Z=he.lastIndex,he.lastIndex+=1;return K.substring(Z).replace(/^\s/,"")}e.lcut=ae;const fe=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function be(K){return K&&(K=K.replace(fe,""),K=K.replace(De,""),K=K.replace(Oe,"")),K}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Te(K){return ke(K)?K.substr(1):K}e.stripUTF8BOM=Te;function xe(K,oe){if(!K||!oe||K.length<oe.length)return!1;const he=oe.length,Z=K.toLowerCase();let ne=0,le=-1;for(;ne<he;){const pe=Z.indexOf(oe[ne],le+1);if(pe<0)return!1;le=pe,ne++}return!0}e.fuzzyContains=xe;function Se(K,oe=!1){return K?(oe&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Se;function Ke(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Ke;function G(K,oe=1){if(oe===0)return"";let he=-1;do he=K.indexOf(`
`,he+1),oe--;while(oe>0&&he>=0);return he===-1?K:(K[he-1]==="\r"&&he--,K.substr(0,he))}e.getNLines=G;function re(K){const oe=90-65+1;return K=K%(2*oe),K<oe?String.fromCharCode(97+K):String.fromCharCode(65+K-oe)}e.singleLetterHash=re;function Ee(K){return Be.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=Ee;function Ne(K,oe){return K===0?oe!==5&&oe!==7:K===2&&oe===3?!1:K===4||K===2||K===3||oe===4||oe===2||oe===3?!0:!(K===8&&(oe===8||oe===9||oe===11||oe===12)||(K===11||K===9)&&(oe===9||oe===10)||(K===12||K===10)&&oe===10||oe===5||oe===13||oe===7||K===1||K===13&&oe===14||K===6&&oe===6)}e.breakBetweenGraphemeBreakType=Ne;var Ve;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Ve=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=et()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const he=this._data,Z=he.length/3;let ne=1;for(;ne<=Z;)if(oe<he[3*ne])ne=2*ne;else if(oe>he[3*ne+1])ne=2*ne+1;else return he[3*ne+2];return 0}}Be._INSTANCE=null;function et(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(ge[22],ve([0,1,10,91]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined",P=typeof TextEncoder!="undefined",C=typeof TextDecoder!="undefined";let A,y;class n{constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}static alloc(c){return T?new n(Buffer.allocUnsafe(c)):new n(new Uint8Array(c))}static wrap(c){return T&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new n(c)}static fromString(c,h){return!((h==null?void 0:h.dontUseNodeBuffer)||!1)&&T?new n(Buffer.from(c)):P?(A||(A=new TextEncoder),new n(A.encode(c))):new n(_.encodeUTF8(c))}static concat(c,h){if(typeof h=="undefined"){h=0;for(let u=0,f=c.length;u<f;u++)h+=c[u].byteLength}const p=n.alloc(h);let w=0;for(let u=0,f=c.length;u<f;u++){const k=c[u];p.set(k,w),w+=k.byteLength}return p}toString(){return T?this.buffer.toString():C?(y||(y=new TextDecoder),y.decode(this.buffer)):_.decodeUTF8(this.buffer)}slice(c,h){return new n(this.buffer.subarray(c,h))}set(c,h){c instanceof n?this.buffer.set(c.buffer,h):this.buffer.set(c,h)}readUInt32BE(c){return b(this.buffer,c)}writeUInt32BE(c,h){g(this.buffer,c,h)}readUInt32LE(c){return s(this.buffer,c)}writeUInt32LE(c,h){d(this.buffer,c,h)}readUInt8(c){return S(this.buffer,c)}writeUInt8(c,h){v(this.buffer,c,h)}}e.VSBuffer=n;function R(r,c){return r[c+0]<<0>>>0|r[c+1]<<8>>>0}e.readUInt16LE=R;function D(r,c,h){r[h+0]=c&255,c=c>>>8,r[h+1]=c&255}e.writeUInt16LE=D;function b(r,c){return r[c]*2**24+r[c+1]*2**16+r[c+2]*2**8+r[c+3]}e.readUInt32BE=b;function g(r,c,h){r[h+3]=c,c=c>>>8,r[h+2]=c,c=c>>>8,r[h+1]=c,c=c>>>8,r[h]=c}e.writeUInt32BE=g;function s(r,c){return r[c+0]<<0>>>0|r[c+1]<<8>>>0|r[c+2]<<16>>>0|r[c+3]<<24>>>0}e.readUInt32LE=s;function d(r,c,h){r[h+0]=c&255,c=c>>>8,r[h+1]=c&255,c=c>>>8,r[h+2]=c&255,c=c>>>8,r[h+3]=c&255}e.writeUInt32LE=d;function S(r,c){return r[c]}e.readUInt8=S;function v(r,c,h){r[h]=c}e.writeUInt8=v;function E(r){return I.consumeReadable(r,c=>n.concat(c))}e.readableToBuffer=E;function m(r){return I.toReadable(r)}e.bufferToReadable=m;function l(r){return I.consumeStream(r,c=>n.concat(c))}e.streamToBuffer=l;async function o(r){return r.ended?n.concat(r.buffer):n.concat([...r.buffer,await l(r.stream)])}e.bufferedStreamToBuffer=o;function t(r){return I.toStream(r,c=>n.concat(c))}e.bufferToStream=t;function i(r){return I.transform(r,{data:c=>typeof c=="string"?n.fromString(c):n.wrap(c)},c=>n.concat(c))}e.streamToBufferReadableStream=i;function a(r){return I.newWriteableStream(c=>n.concat(c),r)}e.newWriteableBufferStream=a}),define(ge[73],ve([0,1,10]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function I(v){return T(v,0)}e.hash=I;function T(v,E){switch(typeof v){case"object":return v===null?P(349,E):Array.isArray(v)?y(v,E):n(v,E);case"string":return A(v,E);case"boolean":return C(v,E);case"number":return P(v,E);case"undefined":return P(937,E);default:return P(617,E)}}e.doHash=T;function P(v,E){return(E<<5)-E+v|0}function C(v,E){return P(v?433:863,E)}function A(v,E){E=P(149417,E);for(let m=0,l=v.length;m<l;m++)E=P(v.charCodeAt(m),E);return E}e.stringHash=A;function y(v,E){return E=P(104579,E),v.reduce((m,l)=>T(l,m),E)}function n(v,E){return E=P(181387,E),Object.keys(v).sort().reduce((m,l)=>(m=A(l,m),T(v[l],m)),E)}class R{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=T(E,this._value),this._value}}e.Hasher=R;var D;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(D||(D={}));function b(v,E,m=32){const l=m-E,o=~((1<<l)-1);return(v<<E|(o&v)>>>l)>>>0}function g(v,E=0,m=v.byteLength,l=0){for(let o=0;o<m;o++)v[E+o]=l}function s(v,E,m="0"){for(;v.length<E;)v=m+v;return v}function d(v,E=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(m=>m.toString(16).padStart(2,"0")).join(""):s((v>>>0).toString(16),E/4)}e.toHexString=d;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const m=E.length;if(m!==0){const l=this._buff;let o=this._buffLen,t=this._leftoverHighSurrogate,i,a;for(t!==0?(i=t,a=-1,t=0):(i=E.charCodeAt(0),a=0);;){let r=i;if(_.isHighSurrogate(i))if(a+1<m){const c=E.charCodeAt(a+1);_.isLowSurrogate(c)?(a++,r=_.computeCodePoint(i,c)):r=65533}else{t=i;break}else _.isLowSurrogate(i)&&(r=65533);if(o=this._push(l,o,r),a++,a<m)i=E.charCodeAt(a);else break}this._buffLen=o,this._leftoverHighSurrogate=t}}_push(E,m,l){return l<128?E[m++]=l:l<2048?(E[m++]=192|(l&1984)>>>6,E[m++]=128|(l&63)>>>0):l<65536?(E[m++]=224|(l&61440)>>>12,E[m++]=128|(l&4032)>>>6,E[m++]=128|(l&63)>>>0):(E[m++]=240|(l&1835008)>>>18,E[m++]=128|(l&258048)>>>12,E[m++]=128|(l&4032)>>>6,E[m++]=128|(l&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=S._bigBlock32,m=this._buffDV;for(let p=0;p<64;p+=4)E.setUint32(p,m.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)E.setUint32(p,b(E.getUint32(p-12,!1)^E.getUint32(p-32,!1)^E.getUint32(p-56,!1)^E.getUint32(p-64,!1),1),!1);let l=this._h0,o=this._h1,t=this._h2,i=this._h3,a=this._h4,r,c,h;for(let p=0;p<80;p++)p<20?(r=o&t|~o&i,c=1518500249):p<40?(r=o^t^i,c=1859775393):p<60?(r=o&t|o&i|t&i,c=2400959708):(r=o^t^i,c=3395469782),h=b(l,5)+r+a+c+E.getUint32(p*4,!1)&4294967295,a=i,i=t,t=b(o,30),o=l,l=h;this._h0=this._h0+l&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+a&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[56],ve([0,1,10]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(I||(I={})),function(T){const P="error",C="warning",A="warn",y="info";function n(R){return R?_.equalsIgnoreCase(P,R)?T.Error:_.equalsIgnoreCase(C,R)||_.equalsIgnoreCase(A,R)?T.Warning:_.equalsIgnoreCase(y,R)?T.Info:T.Ignore:T.Ignore}T.fromValue=n}(I||(I={})),e.default=I}),define(ge[15],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function _(h){return Array.isArray(h)}e.isArray=_;function I(h){return typeof h=="string"}e.isString=I;function T(h){return Array.isArray(h)&&h.every(p=>I(p))}e.isStringArray=T;function P(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=P;function C(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=C;function A(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=A;function y(h){return h===!0||h===!1}e.isBoolean=y;function n(h){return typeof h=="undefined"}e.isUndefined=n;function R(h){return!D(h)}e.isDefined=R;function D(h){return n(h)||h===null}e.isUndefinedOrNull=D;function b(h,p){if(!h)throw new Error(p?`Unexpected type, expected '${p}'`:"Unexpected type")}e.assertType=b;function g(h){if(D(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=g;function s(...h){const p=[];for(let w=0;w<h.length;w++){const u=h[w];if(D(u))throw new Error(`Assertion Failed: argument at index ${w} is undefined or null`);p.push(u)}return p}e.assertAllDefined=s;const d=Object.prototype.hasOwnProperty;function S(h){if(!P(h))return!1;for(let p in h)if(d.call(h,p))return!1;return!0}e.isEmptyObject=S;function v(h){return typeof h=="function"}e.isFunction=v;function E(...h){return h.length>0&&h.every(v)}e.areFunctions=E;function m(h,p){const w=Math.min(h.length,p.length);for(let u=0;u<w;u++)l(h[u],p[u])}e.validateConstraints=m;function l(h,p){if(I(p)){if(typeof h!==p)throw new Error(`argument does not match constraint: typeof ${p}`)}else if(v(p)){try{if(h instanceof p)return}catch(w){}if(!D(h)&&h.constructor===p||p.length===1&&p.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function o(h){let p=[],w=Object.getPrototypeOf(h);for(;Object.prototype!==w;)p=p.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return p}e.getAllPropertyNames=o;function t(h){const p=[];for(const w of o(h))typeof h[w]=="function"&&p.push(w);return p}e.getAllMethodNames=t;function i(h,p){const w=f=>function(){const k=Array.prototype.slice.call(arguments,0);return p(f,k)};let u={};for(const f of h)u[f]=w(f);return u}e.createProxyObject=i;function a(h){return h===null?void 0:h}e.withNullAsUndefined=a;function r(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=r;function c(h){return class{constructor(){return new Proxy({},{get(p,w){if(p[w])return p[w];throw new Error(`Not Implemented: ${h}->${String(w)}`)}})}}}e.NotImplementedProxy=c}),define(ge[31],ve([0,1,9,10,8,15]),function(Q,e,_,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function C(i){return i===47||i===92}e.isPathSeparator=C;function A(i){return i.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=A;function y(i,a=T.posix.sep){if(!i)return"";const r=i.length,c=i.charCodeAt(0);if(C(c)){if(C(i.charCodeAt(1))&&!C(i.charCodeAt(2))){let p=3;const w=p;for(;p<r&&!C(i.charCodeAt(p));p++);if(w!==p&&!C(i.charCodeAt(p+1))){for(p+=1;p<r;p++)if(C(i.charCodeAt(p)))return i.slice(0,p+1).replace(/[\\/]/g,a)}}return a}else if(S(c)&&i.charCodeAt(1)===58)return C(i.charCodeAt(2))?i.slice(0,2)+a:i.slice(0,2);let h=i.indexOf("://");if(h!==-1){for(h+=3;h<r;h++)if(C(i.charCodeAt(h)))return i.slice(0,h+1)}return""}e.getRoot=y;function n(i){if(!_.isWindows||!i||i.length<5)return!1;let a=i.charCodeAt(0);if(a!==92||(a=i.charCodeAt(1),a!==92))return!1;let r=2;const c=r;for(;r<i.length&&(a=i.charCodeAt(r),a!==92);r++);return!(c===r||(a=i.charCodeAt(r+1),isNaN(a)||a===92))}e.isUNC=n;const R=/[\\/:\*\?"<>\|]/g,D=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(i,a=_.isWindows){const r=a?R:D;return!(!i||i.length===0||/^\s+$/.test(i)||(r.lastIndex=0,r.test(i))||a&&b.test(i)||i==="."||i===".."||a&&i[i.length-1]==="."||a&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=g;function s(i,a,r){const c=i===a;return!r||c?c:!i||!a?!1:(0,I.equalsIgnoreCase)(i,a)}e.isEqual=s;function d(i,a,r,c=T.sep){if(i===a)return!0;if(!i||!a||a.length>i.length)return!1;if(r){if(!(0,I.startsWithIgnoreCase)(i,a))return!1;if(a.length===i.length)return!0;let p=a.length;return a.charAt(a.length-1)===c&&p--,i.charAt(p)===c}return a.charAt(a.length-1)!==c&&(a+=c),i.indexOf(a)===0}e.isEqualOrParent=d;function S(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=S;function v(i,a){return _.isWindows&&i.endsWith(":")&&(i+=T.sep),(0,T.isAbsolute)(i)||(i=(0,T.join)(a,i)),i=(0,T.normalize)(i),_.isWindows?(i=(0,I.rtrim)(i,T.sep),i.endsWith(":")&&(i+=T.sep)):(i=(0,I.rtrim)(i,T.sep),i||(i=T.sep)),i}e.sanitizeFilePath=v;function E(i){const a=(0,T.normalize)(i);return _.isWindows?i.length>3?!1:m(a)&&(i.length===2||a.charCodeAt(2)===92):a===T.posix.sep}e.isRootOrDriveLetter=E;function m(i){return _.isWindows?S(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function l(i){return m(i)?i[0]:void 0}e.getDriveLetter=l;function o(i,a,r){return a.length>i.length?-1:i===a?0:(r&&(i=i.toLowerCase(),a=a.toLowerCase()),i.indexOf(a))}e.indexOfPath=o;function t(i){const a=i.split(":");let r,c,h;if(a.forEach(p=>{const w=Number(p);(0,P.isNumber)(w)?c===void 0?c=w:h===void 0&&(h=w):r=r?[r,p].join(":"):p}),!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:c!==void 0?c:void 0,column:h!==void 0?h:c!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ge[23],ve([0,1,15]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function I(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const d=Array.isArray(s)?[]:{};return Object.keys(s).forEach(S=>{s[S]&&typeof s[S]=="object"?d[S]=I(s[S]):d[S]=s[S]}),d}e.deepClone=I;function T(s){if(!s||typeof s!="object")return s;const d=[s];for(;d.length>0;){const S=d.shift();Object.freeze(S);for(const v in S)if(P.call(S,v)){const E=S[v];typeof E=="object"&&!Object.isFrozen(E)&&d.push(E)}}return s}e.deepFreeze=T;const P=Object.prototype.hasOwnProperty;function C(s,d){return A(s,d,new Set)}e.cloneAndChange=C;function A(s,d,S){if((0,_.isUndefinedOrNull)(s))return s;const v=d(s);if(typeof v!="undefined")return v;if((0,_.isArray)(s)){const E=[];for(const m of s)E.push(A(m,d,S));return E}if((0,_.isObject)(s)){if(S.has(s))throw new Error("Cannot clone recursive data-structure");S.add(s);const E={};for(let m in s)P.call(s,m)&&(E[m]=A(s[m],d,S));return S.delete(s),E}return s}function y(s,d,S=!0){return(0,_.isObject)(s)?((0,_.isObject)(d)&&Object.keys(d).forEach(v=>{v in s?S&&((0,_.isObject)(s[v])&&(0,_.isObject)(d[v])?y(s[v],d[v],S):s[v]=d[v]):s[v]=d[v]}),s):d}e.mixin=y;function n(s,d){if(s===d)return!0;if(s==null||d===null||d===void 0||typeof s!=typeof d||typeof s!="object"||Array.isArray(s)!==Array.isArray(d))return!1;let S,v;if(Array.isArray(s)){if(s.length!==d.length)return!1;for(S=0;S<s.length;S++)if(!n(s[S],d[S]))return!1}else{const E=[];for(v in s)E.push(v);E.sort();const m=[];for(v in d)m.push(v);if(m.sort(),!n(E,m))return!1;for(S=0;S<E.length;S++)if(!n(s[E[S]],d[E[S]]))return!1}return!0}e.equals=n;function R(s){const d=new Set;return JSON.stringify(s,(S,v)=>{if((0,_.isObject)(v)||Array.isArray(v)){if(d.has(v))return"[Circular]";d.add(v)}return v})}e.safeStringify=R;function D(s,d,S){const v=d(s);return typeof v=="undefined"?S:v}e.getOrDefault=D;function b(s,d){const S=Object.create(null);return!s||!d||Object.keys(d).forEach(E=>{const m=s[E],l=d[E];n(m,l)||(S[E]=l)}),S}e.distinct=b;function g(s,d){const S=d.toLowerCase(),v=Object.keys(s).find(E=>E.toLowerCase()===S);return v?s[v]:s[d]}e.getCaseInsensitive=g}),define(ge[92],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var _;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_=e.Constants||(e.Constants={}));function I(P){return P<0?0:P>255?255:P|0}e.toUint8=I;function T(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=T}),define(ge[2],ve([0,1,9,8]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,P=/^\//,C=/^\/\//;function A(a,r){if(!a.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!T.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!P.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(a,r){return!a&&!r?"file":a}function n(a,r){switch(a){case"https":case"http":case"file":r?r[0]!==D&&(r=D+r):r=D;break}return r}const R="",D="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(r,c,h,p,w,u=!1){typeof r=="object"?(this.scheme=r.scheme||R,this.authority=r.authority||R,this.path=r.path||R,this.query=r.query||R,this.fragment=r.fragment||R):(this.scheme=y(r,u),this.authority=c||R,this.path=n(this.scheme,h||R),this.query=p||R,this.fragment=w||R,A(this,u))}static isUri(r){return r instanceof g?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return m(this,!1)}with(r){if(!r)return this;let{scheme:c,authority:h,path:p,query:w,fragment:u}=r;return c===void 0?c=this.scheme:c===null&&(c=R),h===void 0?h=this.authority:h===null&&(h=R),p===void 0?p=this.path:p===null&&(p=R),w===void 0?w=this.query:w===null&&(w=R),u===void 0?u=this.fragment:u===null&&(u=R),c===this.scheme&&h===this.authority&&p===this.path&&w===this.query&&u===this.fragment?this:new d(c,h,p,w,u)}static parse(r,c=!1){const h=b.exec(r);return h?new d(h[2]||R,i(h[4]||R),i(h[5]||R),i(h[7]||R),i(h[9]||R),c):new d(R,R,R,R,R)}static file(r){let c=R;if(_.isWindows&&(r=r.replace(/\\/g,D)),r[0]===D&&r[1]===D){const h=r.indexOf(D,2);h===-1?(c=r.substring(2),r=D):(c=r.substring(2,h),r=r.substring(h)||D)}return new d("file",c,r,R,R)}static from(r){return new d(r.scheme,r.authority,r.path,r.query,r.fragment)}static joinPath(r,...c){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return _.isWindows&&r.scheme==="file"?h=g.file(I.win32.join(m(r,!0),...c)).path:h=I.posix.join(r.path,...c),r.with({path:h})}toString(r=!1){return l(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof g)return r;{const c=new d(r);return c._formatted=r.external,c._fsPath=r._sep===s?r.fsPath:null,c}}else return r}}e.URI=g;const s=_.isWindows?1:void 0;class d extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(r=!1){return r?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=s),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(a,r){let c,h=-1;for(let p=0;p<a.length;p++){const w=a.charCodeAt(p);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||r&&w===47)h!==-1&&(c+=encodeURIComponent(a.substring(h,p)),h=-1),c!==void 0&&(c+=a.charAt(p));else{c===void 0&&(c=a.substr(0,p));const u=S[w];u!==void 0?(h!==-1&&(c+=encodeURIComponent(a.substring(h,p)),h=-1),c+=u):h===-1&&(h=p)}}return h!==-1&&(c+=encodeURIComponent(a.substring(h))),c!==void 0?c:a}function E(a){let r;for(let c=0;c<a.length;c++){const h=a.charCodeAt(c);h===35||h===63?(r===void 0&&(r=a.substr(0,c)),r+=S[h]):r!==void 0&&(r+=a[c])}return r!==void 0?r:a}function m(a,r){let c;return a.authority&&a.path.length>1&&a.scheme==="file"?c=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?r?c=a.path.substr(1):c=a.path[1].toLowerCase()+a.path.substr(2):c=a.path,_.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=m;function l(a,r){const c=r?E:v;let h="",{scheme:p,authority:w,path:u,query:f,fragment:k}=a;if(p&&(h+=p,h+=":"),(w||p==="file")&&(h+=D,h+=D),w){let L=w.indexOf("@");if(L!==-1){const $=w.substr(0,L);w=w.substr(L+1),L=$.indexOf(":"),L===-1?h+=c($,!1):(h+=c($.substr(0,L),!1),h+=":",h+=c($.substr(L+1),!1)),h+="@"}w=w.toLowerCase(),L=w.indexOf(":"),L===-1?h+=c(w,!1):(h+=c(w.substr(0,L),!1),h+=w.substr(L))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const L=u.charCodeAt(1);L>=65&&L<=90&&(u=`/${String.fromCharCode(L+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const L=u.charCodeAt(0);L>=65&&L<=90&&(u=`${String.fromCharCode(L+32)}:${u.substr(2)}`)}h+=c(u,!0)}return f&&(h+="?",h+=c(f,!1)),k&&(h+="#",h+=r?k:v(k,!1)),h}function o(a){try{return decodeURIComponent(a)}catch(r){return a.length>3?a.substr(0,3)+o(a.substr(3)):a}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(a){return a.match(t)?a.replace(t,r=>o(r)):a}}),define(ge[24],ve([0,1,2,10]),function(Q,e,_,I){"use strict";var T,P;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(l,o,t){let i=l.get(o);return i===void 0&&(i=t,l.set(o,i)),i}e.getOrSet=C;function A(l){const o=[];return l.forEach((t,i)=>{o.push(`${i} => ${t}`)}),`Map(${l.size}) {${o.join(", ")}}`}e.mapToString=A;function y(l){const o=[];return l.forEach(t=>{o.push(t)}),`Set(${l.size}) {${o.join(", ")}}`}e.setToString=y;class n{constructor(){this._value="",this._pos=0}reset(o){return this._value=o,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(o){const t=o.charCodeAt(0),i=this._value.charCodeAt(this._pos);return t-i}value(){return this._value[this._pos]}}e.StringIterator=n;class R{constructor(o=!0){this._caseSensitive=o}reset(o){return this._value=o,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(o)this._from++;else break;else o=!1;return this}cmp(o){return this._caseSensitive?(0,I.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class D{constructor(o=!0,t=!0){this._splitOnBackslash=o,this._caseSensitive=t}reset(o){return this._value=o.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(o)this._from++;else break;else o=!1}return this}cmp(o){return this._caseSensitive?(0,I.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=D;var b;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(b||(b={}));class g{constructor(o){this._ignorePathCasing=o,this._states=[],this._stateIdx=0}reset(o){return this._value=o,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new D(!1,!this._ignorePathCasing(o)),this._pathIterator.reset(o.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(o){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(o,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(o,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(o);if(this._states[this._stateIdx]===4)return(0,I.compare)(o,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(o,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class s{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class d{constructor(o){this._iter=o}static forUris(o=()=>!1){return new d(new g(o))}static forPaths(){return new d(new D)}static forStrings(){return new d(new n)}static forConfigKeys(){return new d(new R)}clear(){this._root=void 0}set(o,t){const i=this._iter.reset(o);let a;for(this._root||(this._root=new s,this._root.segment=i.value()),a=this._root;;){const c=i.cmp(a.segment);if(c>0)a.left||(a.left=new s,a.left.segment=i.value()),a=a.left;else if(c<0)a.right||(a.right=new s,a.right.segment=i.value()),a=a.right;else if(i.hasNext())i.next(),a.mid||(a.mid=new s,a.mid.segment=i.value()),a=a.mid;else break}const r=a.value;return a.value=t,a.key=o,r}get(o){var t;return(t=this._getNode(o))===null||t===void 0?void 0:t.value}_getNode(o){const t=this._iter.reset(o);let i=this._root;for(;i;){const a=t.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else break}return i}has(o){const t=this._getNode(o);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(o){return this._delete(o,!1)}deleteSuperstr(o){return this._delete(o,!0)}_delete(o,t){const i=this._iter.reset(o),a=[];let r=this._root;for(;r;){const c=i.cmp(r.segment);if(c>0)a.push([1,r]),r=r.left;else if(c<0)a.push([-1,r]),r=r.right;else if(i.hasNext())i.next(),a.push([0,r]),r=r.mid;else{for(t?(r.left=void 0,r.mid=void 0,r.right=void 0):r.value=void 0;a.length>0&&r.isEmpty();){let[h,p]=a.pop();switch(h){case 1:p.left=void 0;break;case 0:p.mid=void 0;break;case-1:p.right=void 0;break}r=p}break}}}findSubstr(o){const t=this._iter.reset(o);let i=this._root,a;for(;i;){const r=t.cmp(i.segment);if(r>0)i=i.left;else if(r<0)i=i.right;else if(t.hasNext())t.next(),a=i.value||a,i=i.mid;else break}return i&&i.value||a}findSuperstr(o){const t=this._iter.reset(o);let i=this._root;for(;i;){const a=t.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(o){for(const[t,i]of this)o(i,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(o){o&&(yield*this._entries(o.left),o.value&&(yield[o.key,o.value]),yield*this._entries(o.mid),yield*this._entries(o.right))}}e.TernarySearchTree=d;class S{constructor(o,t){this[T]="ResourceMap",o instanceof S?(this.map=new Map(o.map),this.toKey=t!=null?t:S.defaultToKey):(this.map=new Map,this.toKey=o!=null?o:S.defaultToKey)}set(o,t){return this.map.set(this.toKey(o),t),this}get(o){return this.map.get(this.toKey(o))}has(o){return this.map.has(this.toKey(o))}get size(){return this.map.size}clear(){this.map.clear()}delete(o){return this.map.delete(this.toKey(o))}forEach(o,t){typeof t!="undefined"&&(o=o.bind(t));for(let[i,a]of this.map)o(a,_.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let o of this.map.keys())yield _.URI.parse(o)}*entries(){for(let o of this.map.entries())yield[_.URI.parse(o[0]),o[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let o of this.map)yield[_.URI.parse(o[0]),o[1]]}}e.ResourceMap=S,S.defaultToKey=l=>l.toString();var v;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class E{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var o;return(o=this._head)===null||o===void 0?void 0:o.value}get last(){var o;return(o=this._tail)===null||o===void 0?void 0:o.value}has(o){return this._map.has(o)}get(o,t=0){const i=this._map.get(o);if(!!i)return t!==0&&this.touch(i,t),i.value}set(o,t,i=0){let a=this._map.get(o);if(a)a.value=t,i!==0&&this.touch(a,i);else{switch(a={key:o,value:t,next:void 0,previous:void 0},i){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(o,a),this._size++}return this}delete(o){return!!this.remove(o)}remove(o){const t=this._map.get(o);if(!!t)return this._map.delete(o),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const o=this._head;return this._map.delete(o.key),this.removeItem(o),this._size--,o.value}}forEach(o,t){const i=this._state;let a=this._head;for(;a;){if(t?o.bind(t)(a.value,a.key,this):o(a.value,a.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const o=this,t=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(o._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const r={value:i.key,done:!1};return i=i.next,r}else return{value:void 0,done:!0}}};return a}values(){const o=this,t=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(o._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const r={value:i.value,done:!1};return i=i.next,r}else return{value:void 0,done:!0}}};return a}entries(){const o=this,t=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(o._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const r={value:[i.key,i.value],done:!1};return i=i.next,r}else return{value:void 0,done:!0}}};return a}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(o){if(!(o>=this.size)){if(o===0){this.clear();return}let t=this._head,i=this.size;for(;t&&i>o;)this._map.delete(t.key),t=t.next,i--;this._head=t,this._size=i,t&&(t.previous=void 0),this._state++}}addItemFirst(o){if(!this._head&&!this._tail)this._tail=o;else if(this._head)o.next=this._head,this._head.previous=o;else throw new Error("Invalid list");this._head=o,this._state++}addItemLast(o){if(!this._head&&!this._tail)this._head=o;else if(this._tail)o.previous=this._tail,this._tail.next=o;else throw new Error("Invalid list");this._tail=o,this._state++}removeItem(o){if(o===this._head&&o===this._tail)this._head=void 0,this._tail=void 0;else if(o===this._head){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this._head=o.next}else if(o===this._tail){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this._tail=o.previous}else{const t=o.next,i=o.previous;if(!t||!i)throw new Error("Invalid list");t.previous=i,i.next=t}o.next=void 0,o.previous=void 0,this._state++}touch(o,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(o===this._head)return;const i=o.next,a=o.previous;o===this._tail?(a.next=void 0,this._tail=a):(i.previous=a,a.next=i),o.previous=void 0,o.next=this._head,this._head.previous=o,this._head=o,this._state++}else if(t===2){if(o===this._tail)return;const i=o.next,a=o.previous;o===this._head?(i.previous=void 0,this._head=i):(i.previous=a,a.next=i),o.next=void 0,o.previous=this._tail,this._tail.next=o,this._tail=o,this._state++}}}toJSON(){const o=[];return this.forEach((t,i)=>{o.push([i,t])}),o}fromJSON(o){this.clear();for(const[t,i]of o)this.set(t,i)}}e.LinkedMap=E;class m extends E{constructor(o,t=1){super();this._limit=o,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(o){this._limit=o,this.checkTrim()}get ratio(){return this._ratio}set ratio(o){this._ratio=Math.min(Math.max(0,o),1),this.checkTrim()}get(o,t=2){return super.get(o,t)}peek(o){return super.get(o,0)}set(o,t){return super.set(o,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=m}),define(ge[93],ve([0,1,24,10]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function T(...be){return function(ke,Te){for(let xe=0,Se=be.length;xe<Se;xe++){const Ke=be[xe](ke,Te);if(Ke)return Ke}return null}}e.or=T,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(be,ke,Te){if(!Te||Te.length<ke.length)return null;let xe;return be?xe=I.startsWithIgnoreCase(Te,ke):xe=Te.indexOf(ke)===0,xe?ke.length>0?[{start:0,end:ke.length}]:[]:null}function C(be,ke){const Te=ke.toLowerCase().indexOf(be.toLowerCase());return Te===-1?null:[{start:Te,end:Te+be.length}]}e.matchesContiguousSubString=C;function A(be,ke){return y(be.toLowerCase(),ke.toLowerCase(),0,0)}e.matchesSubString=A;function y(be,ke,Te,xe){if(Te===be.length)return[];if(xe===ke.length)return null;if(be[Te]===ke[xe]){let Se=null;return(Se=y(be,ke,Te+1,xe+1))?v({start:xe,end:xe+1},Se):null}return y(be,ke,Te,xe+1)}function n(be){return 97<=be&&be<=122}function R(be){return 65<=be&&be<=90}e.isUpper=R;function D(be){return 48<=be&&be<=57}function b(be){return be===32||be===9||be===10||be===13}const g=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(be=>g.add(be.charCodeAt(0)));function s(be){return b(be)||g.has(be)}function d(be,ke){return be===ke||s(be)&&s(ke)}function S(be){return n(be)||R(be)||D(be)}function v(be,ke){return ke.length===0?ke=[be]:be.end===ke[0].start?ke[0].start=be.start:ke.unshift(be),ke}function E(be,ke){for(let Te=ke;Te<be.length;Te++){const xe=be.charCodeAt(Te);if(R(xe)||D(xe)||Te>0&&!S(be.charCodeAt(Te-1)))return Te}return be.length}function m(be,ke,Te,xe){if(Te===be.length)return[];if(xe===ke.length)return null;if(be[Te]!==ke[xe].toLowerCase())return null;{let Se=null,Ke=xe+1;for(Se=m(be,ke,Te+1,xe+1);!Se&&(Ke=E(ke,Ke))<ke.length;)Se=m(be,ke,Te+1,Ke),Ke++;return Se===null?null:v({start:xe,end:xe+1},Se)}}function l(be){let ke=0,Te=0,xe=0,Se=0,Ke=0;for(let Ve=0;Ve<be.length;Ve++)Ke=be.charCodeAt(Ve),R(Ke)&&ke++,n(Ke)&&Te++,S(Ke)&&xe++,D(Ke)&&Se++;const G=ke/be.length,re=Te/be.length,Ee=xe/be.length,Ne=Se/be.length;return{upperPercent:G,lowerPercent:re,alphaPercent:Ee,numericPercent:Ne}}function o(be){const{upperPercent:ke,lowerPercent:Te}=be;return Te===0&&ke>.6}function t(be){const{upperPercent:ke,lowerPercent:Te,alphaPercent:xe,numericPercent:Se}=be;return Te>.2&&ke<.8&&xe>.6&&Se<.2}function i(be){let ke=0,Te=0,xe=0,Se=0;for(let Ke=0;Ke<be.length;Ke++)xe=be.charCodeAt(Ke),R(xe)&&ke++,n(xe)&&Te++,b(xe)&&Se++;return(ke===0||Te===0)&&Se===0?be.length<=30:ke<=5}function a(be,ke){if(!ke||(ke=ke.trim(),ke.length===0)||!i(be)||ke.length>60)return null;const Te=l(ke);if(!t(Te)){if(!o(Te))return null;ke=ke.toLowerCase()}let xe=null,Se=0;for(be=be.toLowerCase();Se<ke.length&&(xe=m(be,ke,0,Se))===null;)Se=E(ke,Se+1);return xe}e.matchesCamelCase=a;function r(be,ke,Te=!1){if(!ke||ke.length===0)return null;let xe=null,Se=0;for(be=be.toLowerCase(),ke=ke.toLowerCase();Se<ke.length&&(xe=c(be,ke,0,Se,Te))===null;)Se=h(ke,Se+1);return xe}e.matchesWords=r;function c(be,ke,Te,xe,Se){if(Te===be.length)return[];if(xe===ke.length)return null;if(d(be.charCodeAt(Te),ke.charCodeAt(xe))){let Ke=null,G=xe+1;if(Ke=c(be,ke,Te+1,xe+1,Se),!Se)for(;!Ke&&(G=h(ke,G))<ke.length;)Ke=c(be,ke,Te+1,G,Se),G++;return Ke===null?null:v({start:xe,end:xe+1},Ke)}else return null}function h(be,ke){for(let Te=ke;Te<be.length;Te++)if(s(be.charCodeAt(Te))||Te>0&&s(be.charCodeAt(Te-1)))return Te;return be.length}const p=T(e.matchesPrefix,a,C),w=T(e.matchesPrefix,a,A),u=new _.LRUCache(1e4);function f(be,ke,Te=!1){if(typeof be!="string"||typeof ke!="string")return null;let xe=u.get(be);xe||(xe=new RegExp(I.convertSimple2RegExpPattern(be),"i"),u.set(be,xe));const Se=xe.exec(ke);return Se?[{start:Se.index,end:Se.index+Se[0].length}]:Te?w(be,ke):p(be,ke)}e.matchesFuzzy=f;function k(be,ke){const Te=V(be,be.toLowerCase(),0,ke,ke.toLowerCase(),0,!0);return Te?$(Te):null}e.matchesFuzzy2=k;function L(be,ke,Te,xe,Se,Ke){const G=Math.min(13,be.length);for(;Te<G;Te++){const re=V(be,ke,Te,xe,Se,Ke,!1);if(re)return re}return[0,Ke]}e.anyScore=L;function $(be){if(typeof be=="undefined")return[];const ke=[],Te=be[1];for(let xe=be.length-1;xe>1;xe--){const Se=be[xe]+Te,Ke=ke[ke.length-1];Ke&&Ke.end===Se?Ke.end=Se+1:ke.push({start:Se,end:Se+1})}return ke}e.createMatches=$;const te=128;function H(){const be=[],ke=[];for(let Te=0;Te<=te;Te++)ke[Te]=0;for(let Te=0;Te<=te;Te++)be.push(ke.slice(0));return be}function x(be){const ke=[];for(let Te=0;Te<=be;Te++)ke[Te]=0;return ke}const B=x(2*te),F=x(2*te),U=H(),M=H(),N=H(),O=!1;function j(be,ke,Te,xe,Se){function Ke(re,Ee,Ne=" "){for(;re.length<Ee;)re=Ne+re;return re}let G=` |   |${xe.split("").map(re=>Ke(re,3)).join("|")}
`;for(let re=0;re<=Te;re++)re===0?G+=" |":G+=`${ke[re-1]}|`,G+=be[re].slice(0,Se+1).map(Ee=>Ke(Ee.toString(),3)).join("|")+`
`;return G}function q(be,ke,Te,xe){be=be.substr(ke),Te=Te.substr(xe),console.log(j(M,be,be.length,Te,Te.length)),console.log(j(N,be,be.length,Te,Te.length)),console.log(j(U,be,be.length,Te,Te.length))}function X(be,ke){if(ke<0||ke>=be.length)return!1;const Te=be.codePointAt(ke);switch(Te){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(Te)}}function me(be,ke){if(ke<0||ke>=be.length)return!1;switch(be.charCodeAt(ke)){case 32:case 9:return!0;default:return!1}}function we(be,ke,Te){return ke[be]!==Te[be]}function Ae(be,ke,Te,xe,Se,Ke,G=!1){for(;ke<Te&&Se<Ke;)be[ke]===xe[Se]&&(G&&(B[ke]=Se),ke+=1),Se+=1;return ke===Te}e.isPatternInWord=Ae;var Ie;(function(be){be[be.Diag=1]="Diag",be[be.Left=2]="Left",be[be.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Me;(function(be){be.Default=[-100,0];function ke(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}be.isDefault=ke})(Me=e.FuzzyScore||(e.FuzzyScore={}));function V(be,ke,Te,xe,Se,Ke,G){const re=be.length>te?te:be.length,Ee=xe.length>te?te:xe.length;if(!(Te>=re||Ke>=Ee||re-Te>Ee-Ke)&&!!Ae(ke,Te,re,Se,Ke,Ee,!0)){Y(re,Ee,Te,Ke,ke,Se);let Ne=1,Ve=1,Be=Te,et=Ke;const K=[!1];for(Ne=1,Be=Te;Be<re;Ne++,Be++){const le=B[Be],pe=F[Be],_e=Be+1<re?F[Be+1]:Ee;for(Ve=le-Ke+1,et=le;et<_e;Ve++,et++){let He=Number.MIN_SAFE_INTEGER,We=!1;et<=pe&&(He=ee(be,ke,Be,Te,xe,Se,et,Ee,Ke,U[Ne-1][Ve-1]===0,K));let qe=0;He!==Number.MAX_SAFE_INTEGER&&(We=!0,qe=He+M[Ne-1][Ve-1]);const Ye=et>le,Ze=Ye?M[Ne][Ve-1]+(U[Ne][Ve-1]>0?-5:0):0,ut=et>le+1&&U[Ne][Ve-1]>0,ot=ut?M[Ne][Ve-2]+(U[Ne][Ve-2]>0?-5:0):0;if(ut&&(!Ye||ot>=Ze)&&(!We||ot>=qe))M[Ne][Ve]=ot,N[Ne][Ve]=3,U[Ne][Ve]=0;else if(Ye&&(!We||Ze>=qe))M[Ne][Ve]=Ze,N[Ne][Ve]=2,U[Ne][Ve]=0;else if(We)M[Ne][Ve]=qe,N[Ne][Ve]=1,U[Ne][Ve]=U[Ne-1][Ve-1]+1;else throw new Error("not possible")}}if(O&&q(be,Te,xe,Ke),!(!K[0]&&!G)){Ne--,Ve--;const oe=[M[Ne][Ve],Ke];let he=0,Z=0;for(;Ne>=1;){let le=Ve;do{const pe=N[Ne][le];if(pe===3)le=le-2;else if(pe===2)le=le-1;else break}while(le>=1);he>1&&ke[Te+Ne-1]===Se[Ke+Ve-1]&&!we(le+Ke-1,xe,Se)&&he+1>U[Ne][le]&&(le=Ve),le===Ve?he++:he=1,Z||(Z=le),Ne--,Ve=le-1,oe.push(Ve)}Ee===re&&(oe[0]+=2);const ne=Z-re;return oe[0]-=ne,oe}}}e.fuzzyScore=V;function Y(be,ke,Te,xe,Se,Ke){let G=be-1,re=ke-1;for(;G>=Te&&re>=xe;)Se[G]===Ke[re]&&(F[G]=re,G--),re--}function ee(be,ke,Te,xe,Se,Ke,G,re,Ee,Ne,Ve){if(ke[Te]!==Ke[G])return Number.MIN_SAFE_INTEGER;let Be=1,et=!1;return G===Te-xe?Be=be[Te]===Se[G]?7:5:we(G,Se,Ke)&&(G===0||!we(G-1,Se,Ke))?(Be=be[Te]===Se[G]?7:5,et=!0):X(Ke,G)&&(G===0||!X(Ke,G-1))?Be=5:(X(Ke,G-1)||me(Ke,G-1))&&(Be=5,et=!0),Be>1&&Te===xe&&(Ve[0]=!0),et||(et=we(G,Se,Ke)||X(Ke,G-1)||me(Ke,G-1)),Te===xe?G>Ee&&(Be-=et?3:5):Ne?Be+=et?2:0:Be+=et?0:1,G+1===re&&(Be-=et?3:5),Be}function ae(be,ke,Te,xe,Se,Ke,G){return De(be,ke,Te,xe,Se,Ke,!0,G)}e.fuzzyScoreGracefulAggressive=ae;function fe(be,ke,Te,xe,Se,Ke,G){return De(be,ke,Te,xe,Se,Ke,!1,G)}e.fuzzyScoreGraceful=fe;function De(be,ke,Te,xe,Se,Ke,G,re){let Ee=V(be,ke,Te,xe,Se,Ke,re);if(Ee&&!G)return Ee;if(be.length>=3){const Ne=Math.min(7,be.length-1);for(let Ve=Te+1;Ve<Ne;Ve++){const Be=Oe(be,Ve);if(Be){const et=V(Be,Be.toLowerCase(),Te,xe,Se,Ke,re);et&&(et[0]-=3,(!Ee||et[0]>Ee[0])&&(Ee=et))}}}return Ee}function Oe(be,ke){if(!(ke+1>=be.length)){const Te=be[ke],xe=be[ke+1];if(Te!==xe)return be.slice(0,ke)+xe+Te+be.slice(ke+2)}}}),define(ge[135],ve([0,1,47,93,10]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(`(\\\\)?${P.source}`,"g");function A(d){return d.replace(C,(S,v)=>v?S:`\\${S}`)}e.escapeIcons=A;const y=new RegExp(`\\\\${P.source}`,"g");function n(d){return d.replace(y,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=n;const R=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function D(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(R,(S,v,E,m)=>E?S:v||m||"")}e.stripIcons=D;function b(d){const S=d.indexOf(e.iconStartMarker);return S===-1?{text:d}:g(d,S)}e.parseLabelWithIcons=b;function g(d,S){const v=[];let E="";function m(h){if(h){E+=h;for(const p of h)v.push(t)}}let l=-1,o="",t=0,i,a,r=S;const c=d.length;for(m(d.substr(0,S));r<c;)i=d[r],a=d[r+1],i===e.iconStartMarker[0]&&a===e.iconStartMarker[1]?(l=r,m(o),o=e.iconStartMarker,r++):i===")"&&l!==-1?(t+=r-l+1,l=-1,o=""):l!==-1?/^[a-z0-9\-]$/i.test(i)?o+=i:(m(o),l=-1,o=""):m(i),r++;return m(o),{text:E,iconOffsets:v}}function s(d,S,v=!1){const{text:E,iconOffsets:m}=S;if(!m||m.length===0)return(0,I.matchesFuzzy)(d,E,v);const l=(0,T.ltrim)(E," "),o=E.length-l.length,t=(0,I.matchesFuzzy)(d,l,v);if(t)for(const i of t){const a=m[i.start+o]+o;i.start+=a,i.end+=a}return t}e.matchesFuzzyIconAware=s}),define(ge[94],ve([0,1,14,135,18]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(d="",S=!1){var v,E;if(this.value=d,typeof this.value!="string")throw(0,T.illegalArgument)("value");typeof S=="boolean"?(this.isTrusted=S,this.supportThemeIcons=!1):(this.isTrusted=(v=S.isTrusted)!==null&&v!==void 0?v:void 0,this.supportThemeIcons=(E=S.supportThemeIcons)!==null&&E!==void 0?E:!1)}appendText(d,S=0){return this.value+=D(this.supportThemeIcons?(0,I.escapeIcons)(d):d).replace(/([ \t]+)/g,(v,E)=>"&nbsp;".repeat(E.length)).replace(/^>/gm,"\\>").replace(/\n/g,S===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,S){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=S,this.value+="\n```\n",this}}e.MarkdownString=C;function A(s){return y(s)?!s.value:Array.isArray(s)?s.every(A):!0}e.isEmptyMarkdownString=A;function y(s){return s instanceof C?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function n(s,d){return!s&&!d?!0:!s||!d?!1:Array.isArray(s)&&Array.isArray(d)?(0,_.equals)(s,d,R):y(s)&&y(d)?R(s,d):!1}e.markedStringsEquals=n;function R(s,d){return s===d?!0:!s||!d?!1:s.value===d.value&&s.isTrusted===d.isTrusted&&s.supportThemeIcons===d.supportThemeIcons}function D(s){return s.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=D;function b(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=b;function g(s){const d=[],S=s.split("|").map(E=>E.trim());s=S[0];const v=S[1];if(v){const E=/height=(\d+)/.exec(v),m=/width=(\d+)/.exec(v),l=E?E[1]:"",o=m?m[1]:"",t=isFinite(parseInt(o)),i=isFinite(parseInt(l));t&&d.push(`width="${o}"`),i&&d.push(`height="${l}"`)}return{href:s,dimensions:d}}e.parseHrefAndDimensions=g}),define(ge[57],ve([0,1,22,10,2]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(n){return JSON.stringify(n,A)}e.stringify=P;function C(n){let R=JSON.parse(n);return R=y(R),R}e.parse=C;function A(n,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,I.regExpFlags)(R)}:R}function y(n,R=0){if(!n||R>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return T.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof _.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let D=0;D<n.length;++D)n[D]=y(n[D],R+1);else for(const D in n)Object.hasOwnProperty.call(n,D)&&(n[D]=y(n[D],R+1))}return n}e.revive=y}),define(ge[11],ve([0,1,2,9]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var T;(function(A){A.inMemory="inmemory",A.vscode="vscode",A.internal="private",A.walkThrough="walkThrough",A.walkThroughSnippet="walkThroughSnippet",A.http="http",A.https="https",A.file="file",A.mailto="mailto",A.untitled="untitled",A.data="data",A.command="command",A.vscodeRemote="vscode-remote",A.vscodeRemoteResource="vscode-remote-resource",A.userData="vscode-userdata",A.vscodeCustomEditor="vscode-custom-editor",A.vscodeNotebook="vscode-notebook",A.vscodeNotebookCell="vscode-notebook-cell",A.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",A.vscodeSettings="vscode-settings",A.vscodeWorkspaceTrust="vscode-workspace-trust",A.webviewPanel="webview-panel",A.vscodeWebview="vscode-webview",A.vscodeWebviewResource="vscode-webview-resource",A.extension="extension",A.vscodeFileResource="vscode-file"})(T=e.Schemas||(e.Schemas={}));class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,n,R){this._hosts[y]=n,this._ports[y]=R}setConnectionToken(y,n){this._connectionTokens[y]=n}rewrite(y){if(this._delegate)return this._delegate(y);const n=y.authority;let R=this._hosts[n];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const D=this._ports[n],b=this._connectionTokens[n];let g=`path=${encodeURIComponent(y.path)}`;return typeof b=="string"&&(g+=`&tkn=${encodeURIComponent(b)}`),_.URI.from({scheme:I.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${R}:${D}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new P;class C{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,n,R){const D=this.toUri(y,n);return D.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(D):I.isNative&&(R||I.isPreferringBrowserCodeLoad)&&D.scheme===T.file?D.with({scheme:T.vscodeFileResource,authority:D.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):D}asFileUri(y,n){const R=this.toUri(y,n);return R.scheme===T.vscodeFileResource?R.with({scheme:T.file,authority:R.authority!==this.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(y,n){return _.URI.isUri(y)?y:_.URI.parse(n.toUrl(y))}}e.FileAccess=new C}),define(ge[74],ve([0,1,24]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const I=new _.LRUCache(1e4);function T(n){return y(n,"NFC",I)}e.normalizeNFC=T;const P=new _.LRUCache(1e4);function C(n){return y(n,"NFD",P)}e.normalizeNFD=C;const A=/[^\u0000-\u0080]/;function y(n,R,D){if(!e.canNormalize||!n)return n;const b=D.get(n);if(b)return b;let g;return A.test(n)?g=n.normalize(R):g=n,D.set(n,g),g}e.removeAccents=function(){if(e.canNormalize){const n=/[\u0300-\u036f]/g;return function(R){return C(R).replace(n,"")}}else return function(n){return n}}()}),define(ge[25],ve([0,1,31,8,2,10,11,9]),function(Q,e,_,I,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(g){return(0,T.uriToFsPath)(g,!0)}e.originalFSPath=y;class n{constructor(s){this._ignorePathCasing=s}compare(s,d,S=!1){return s===d?0:(0,P.compare)(this.getComparisonKey(s,S),this.getComparisonKey(d,S))}isEqual(s,d,S=!1){return s===d?!0:!s||!d?!1:this.getComparisonKey(s,S)===this.getComparisonKey(d,S)}getComparisonKey(s,d=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,d,S=!1){if(s.scheme===d.scheme){if(s.scheme===C.Schemas.file)return _.isEqualOrParent(y(s),y(d),this._ignorePathCasing(s))&&s.query===d.query&&(S||s.fragment===d.fragment);if((0,e.isEqualAuthority)(s.authority,d.authority))return _.isEqualOrParent(s.path,d.path,this._ignorePathCasing(s),"/")&&s.query===d.query&&(S||s.fragment===d.fragment)}return!1}joinPath(s,...d){return T.URI.joinPath(s,...d)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return I.posix.basename(s.path)}extname(s){return I.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let d;return s.scheme===C.Schemas.file?d=T.URI.file(I.dirname(y(s))).path:(d=I.posix.dirname(s.path),s.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),d="/")),s.with({path:d})}normalizePath(s){if(!s.path.length)return s;let d;return s.scheme===C.Schemas.file?d=T.URI.file(I.normalize(y(s))).path:d=I.posix.normalize(s.path),s.with({path:d})}relativePath(s,d){if(!(s.scheme!==d.scheme||!(0,e.isEqualAuthority)(s.authority,d.authority))){if(s.scheme===C.Schemas.file){const E=I.relative(y(s),y(d));return A.isWindows?_.toSlashes(E):E}let S=s.path||"/",v=d.path||"/";if(this._ignorePathCasing(s)){let E=0;for(const m=Math.min(S.length,v.length);E<m&&!(S.charCodeAt(E)!==v.charCodeAt(E)&&S.charAt(E).toLowerCase()!==v.charAt(E).toLowerCase());E++);S=v.substr(0,E)+S.substr(E)}return I.posix.relative(S,v)}}resolvePath(s,d){if(s.scheme===C.Schemas.file){const S=T.URI.file(I.resolve(y(s),d));return s.with({authority:S.authority,path:S.path})}return d.indexOf("/")===-1&&(d=_.toSlashes(d),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d)),s.with({path:I.posix.resolve(s.path,d)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,d){return s===d||(0,P.equalsIgnoreCase)(s,d)}hasTrailingPathSeparator(s,d=I.sep){if(s.scheme===C.Schemas.file){const S=y(s);return S.length>_.getRoot(S).length&&S[S.length-1]===d}else{const S=s.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,d=I.sep){return(0,e.hasTrailingPathSeparator)(s,d)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,d=I.sep){let S=!1;if(s.scheme===C.Schemas.file){const v=y(s);S=v!==void 0&&v.length===_.getRoot(v).length&&v[v.length-1]===d}else{d="/";const v=s.path;S=v.length===1&&v.charCodeAt(v.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(s,d)?s.with({path:s.path+"/"}):s}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(g=>g.scheme===C.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new n(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(g,s){const d=[];for(let S=0;S<g.length;S++){const v=s(g[S]);g.some((E,m)=>m===S?!1:(0,e.isEqualOrParent)(v,s(E)))||d.push(g[S])}return d}e.distinctParents=R;var D;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function s(d){const S=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(m=>{const[l,o]=m.split(":");l&&o&&S.set(l,o)});const E=d.path.substring(0,d.path.indexOf(";"));return E&&S.set(g.META_DATA_MIME,E),S}g.parseMetaData=s})(D=e.DataUri||(e.DataUri={}));function b(g,s,d){if(s){let S=g.path;return S&&S[0]!==I.posix.sep&&(S=I.posix.sep+S),g.with({scheme:d,authority:s,path:S})}return g.with({scheme:d})}e.toLocalResource=b}),define(ge[19],ve([0,1,21,18,3,6,55,25]),function(Q,e,_,I,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(M){return!!M&&typeof M.then=="function"}e.isThenable=y;function n(M){const N=new _.CancellationTokenSource,O=M(N.token),j=new Promise((q,X)=>{N.token.onCancellationRequested(()=>{X((0,I.canceled)())}),Promise.resolve(O).then(me=>{N.dispose(),q(me)},me=>{N.dispose(),X(me)})});return new class{cancel(){N.cancel()}then(q,X){return j.then(q,X)}catch(q){return this.then(void 0,q)}finally(q){return j.finally(q)}}}e.createCancelablePromise=n;function R(M,N,O){return Promise.race([M,new Promise(j=>N.onCancellationRequested(()=>j(O)))])}e.raceCancellation=R;async function D(M){let N=-1;const O=M.map((q,X)=>q.then(me=>(N=X,me))),j=await Promise.race(O);return M.forEach((q,X)=>{X!==N&&q.cancel()}),j}e.raceCancellablePromises=D;function b(M,N,O){let j;const q=setTimeout(()=>{j==null||j(void 0),O==null||O()},N);return Promise.race([M.finally(()=>clearTimeout(q)),new Promise(X=>j=X)])}e.raceTimeout=b;function g(M){return new Promise((N,O)=>{const j=M();y(j)?j.then(N,O):N(j)})}e.asPromise=g;class s{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(O,O).then(j)})}return new Promise((O,j)=>{this.queuedPromise.then(O,j)})}return this.activePromise=N(),new Promise((O,j)=>{this.activePromise.then(q=>{this.activePromise=null,O(q)},q=>{this.activePromise=null,j(q)})})}}e.Throttler=s;class d{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=d;class S{constructor(){this.promiseMap=new Map}queue(N,O){var j;const X=((j=this.promiseMap.get(N))!==null&&j!==void 0?j:Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(N)===X&&this.promiseMap.delete(N)});return this.promiseMap.set(N,X),X}}e.SequencerByKey=S;class v{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,O=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,q)=>{this.doResolve=j,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,I.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=v;class E{constructor(N){this.delayer=new v(N),this.throttler=new s}trigger(N,O){return this.delayer.trigger(()=>this.throttler.queue(N),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class m{constructor(){this._isOpen=!1,this._promise=new Promise((N,O)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=m;class l extends m{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function o(M,N){return N?new Promise((O,j)=>{const q=setTimeout(O,M);N.onCancellationRequested(()=>{clearTimeout(q),j((0,I.canceled)())})}):n(O=>o(M,O))}e.timeout=o;function t(M,N=0){const O=setTimeout(M,N);return(0,P.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=t;function i(M){return M.then(void 0,N=>{})}e.ignoreErrors=i;function a(M){const N=[];let O=0;const j=M.length;function q(){return O<j?M[O++]():null}function X(me){me!=null&&N.push(me);const we=q();return we?we.then(X):Promise.resolve(N)}return Promise.resolve(null).then(X)}e.sequence=a;function r(M,N=j=>!!j,O=null){let j=0;const q=M.length,X=()=>{if(j>=q)return Promise.resolve(O);const me=M[j++];return Promise.resolve(me()).then(Ae=>N(Ae)?Promise.resolve(Ae):X())};return X()}e.first=r;function c(M,N=j=>!!j,O=null){if(M.length===0)return Promise.resolve(O);let j=M.length;const q=()=>{var X,me;j=-1;for(const we of M)(me=(X=we).cancel)===null||me===void 0||me.call(X)};return new Promise((X,me)=>{for(const we of M)we.then(Ae=>{--j>=0&&N(Ae)?(q(),X(Ae)):j===0&&X(O)}).catch(Ae=>{--j>=0&&(q(),me(Ae))})})}e.firstParallel=c;class h{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new T.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((O,j)=>{this.outstandingPromises.push({factory:N,c:O,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const O=N.factory();O.then(N.c,N.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=h;class p extends h{constructor(){super(1)}}e.Queue=p;class w{constructor(){this.queues=new Map}queueFor(N,O=A.extUri){const j=O.getComparisonKey(N);let q=this.queues.get(j);return q||(q=new p,T.Event.once(q.onFinished)(()=>{q==null||q.dispose(),this.queues.delete(j)}),this.queues.set(j,q)),q}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=w;class u{constructor(N,O){this._token=-1,typeof N=="function"&&typeof O=="number"&&this.setIfNotSet(N,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},O)}setIfNotSet(N,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},O))}}e.TimeoutTimer=u;class f{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,O){this.cancel(),this._token=setInterval(()=>{N()},O)}}e.IntervalTimer=f;class k{constructor(N,O){this.timeoutToken=-1,this.runner=N,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=k;class L extends k{constructor(N,O){super(N,O);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const M=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=N=>{const O=setTimeout(()=>N(M));let j=!1;return{dispose(){j||(j=!0,clearTimeout(O))}}}}else e.runWhenIdle=(M,N)=>{const O=requestIdleCallback(M,typeof N=="number"?{timeout:N}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(O))}}}}();class ${constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=$;async function te(M,N,O){let j;for(let q=0;q<O;q++)try{return await M()}catch(X){j=X,await o(N)}throw j}e.retry=te;class H{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var N;(N=this._pending)===null||N===void 0||N.cancel()}setPending(N,O,j){return this._pending={taskId:N,cancel:()=>j==null?void 0:j(),promise:O},O.then(()=>this.donePending(N),()=>this.donePending(N)),O}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let O,j;const q=new Promise((X,me)=>{O=X,j=me});this._next={run:N,promise:q,promiseResolve:O,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=H;class x{constructor(N){this.interval=N,this.lastIncrementTime=0,this.value=0}increment(){const N=Date.now();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,O)=>{this.completeCallback=N,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(O=>{this.completeCallback(N),this.resolved=!0,O()})}error(N){return new Promise(O=>{this.errorCallback(N),this.rejected=!0,O()})}cancel(){new Promise(N=>{this.errorCallback((0,I.canceled)()),this.rejected=!0,N()})}}e.DeferredPromise=B;class F extends T.Emitter{async fireAsync(N,O,j){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,N]);for(;this._asyncDeliveryQueue.size>0&&!O.isCancellationRequested;){const[q,X]=this._asyncDeliveryQueue.shift(),me=[],we=Object.assign(Object.assign({},X),{waitUntil:Ae=>{if(Object.isFrozen(me))throw new Error("waitUntil can NOT be called asynchronous");j&&(Ae=j(Ae,typeof q=="function"?q:q[0])),me.push(Ae)}});try{typeof q=="function"?q.call(void 0,we):q[0].call(q[1],we)}catch(Ae){(0,I.onUnexpectedError)(Ae);continue}Object.freeze(me),await U.settled(me).catch(Ae=>(0,I.onUnexpectedError)(Ae))}}}}e.AsyncEmitter=F;var U;(function(M){async function N(X){return typeof Promise.allSettled=="function"?O(X):j(X)}M.allSettled=N;async function O(X){return Promise.allSettled(X)}async function j(X){return Promise.all(X.map(me=>me.then(we=>({status:"fulfilled",value:we}),we=>({status:"rejected",reason:we}))))}async function q(X){let me;const we=await Promise.all(X.map(Ae=>Ae.then(Ie=>Ie,Ie=>{me||(me=Ie)})));if(typeof me!="undefined")throw me;return we}M.settled=q})(U=e.Promises||(e.Promises={}))}),define(ge[95],ve([0,1,8,19]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const T=new I.IdleValue(()=>{const l=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:l,collatorIsNumeric:l.resolvedOptions().numeric}}),P=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(l,o,t=!1){const i=l||"",a=o||"",r=T.value.collator.compare(i,a);return T.value.collatorIsNumeric&&r===0&&i!==a?i<a?-1:1:r}e.compareFileNames=A;function y(l,o){const t=P.value.collator;return l=l||"",o=o||"",d(t,l,o)}e.compareFileNamesDefault=y;function n(l,o,t=!1){t||(l=l&&l.toLowerCase(),o=o&&o.toLowerCase());const[i,a]=g(l),[r,c]=g(o);return i!==r?i<r?-1:1:a===c?0:a<c?-1:1}e.noIntlCompareFileNames=n;function R(l,o){const[t,i]=g(l),[a,r]=g(o);let c=T.value.collator.compare(i,r);if(c===0){if(T.value.collatorIsNumeric&&i!==r)return i<r?-1:1;if(c=T.value.collator.compare(t,a),T.value.collatorIsNumeric&&c===0&&t!==a)return t<a?-1:1}return c}e.compareFileExtensions=R;function D(l,o){l=l||"",o=o||"";const t=s(l),i=s(o),a=P.value.collator,r=C.value.collator;let c;return c=d(r,t,i),c!==0?c:d(a,l,o)}e.compareFileExtensionsDefault=D;const b=/^(.*?)(\.([^.]*))?$/;function g(l,o=!1){const t=l?b.exec(l):[];let i=[t&&t[1]||"",t&&t[3]||""];return o&&(!i[0]&&i[1]||i[0]&&i[0].charAt(0)===".")&&(i=[i[0]+"."+i[1],""]),i}function s(l){const o=l?b.exec(l):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function d(l,o,t){let i=l.compare(o,t);return i!==0?i:o.length!==t.length?o.length<t.length?-1:1:0}function S(l,o,t=!1){return t||(l=l&&l.toLowerCase(),o=o&&o.toLowerCase()),l===o?0:l<o?-1:1}function v(l,o,t=!1){const i=l.split(_.sep),a=o.split(_.sep),r=i.length-1,c=a.length-1;let h,p;for(let w=0;;w++){if(h=r===w,p=c===w,h&&p)return A(i[w],a[w],t);if(h)return-1;if(p)return 1;const u=S(i[w],a[w],t);if(u!==0)return u}}e.comparePaths=v;function E(l,o,t){const i=l.toLowerCase(),a=o.toLowerCase(),r=m(l,o,t);if(r)return r;const c=i.endsWith(t),h=a.endsWith(t);if(c!==h)return c?-1:1;const p=A(i,a);return p!==0?p:i.localeCompare(a)}e.compareAnything=E;function m(l,o,t){const i=l.toLowerCase(),a=o.toLowerCase(),r=i.startsWith(t),c=a.startsWith(t);if(r!==c)return r?-1:1;if(r&&c){if(i.length<a.length)return-1;if(i.length>a.length)return 1}return 0}e.compareByPrefix=m}),define(ge[96],ve([0,1,95,93,8,9,10]),function(Q,e,_,I,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const A=0,y=[A,[]];function n(x,B,F,U){if(!x||!B)return y;const M=x.length,N=B.length;if(M<N)return y;const O=x.toLowerCase();return!U&&!O.includes(F)?y:R(B,F,N,x,O,M)}e.scoreFuzzy=n;function R(x,B,F,U,M,N){const O=[],j=[];for(let we=0;we<F;we++){const Ae=we*N,Ie=Ae-N,Me=we>0,V=x[we],Y=B[we];for(let ee=0;ee<N;ee++){const ae=ee>0,fe=Ae+ee,De=fe-1,Oe=Ie+ee-1,be=ae?O[De]:0,ke=Me&&ae?O[Oe]:0,Te=Me&&ae?j[Oe]:0;let xe;!ke&&Me?xe=0:xe=D(V,Y,U,M,ee,Te),xe&&ke+xe>=be?(j[fe]=Te+1,O[fe]=ke+xe):(j[fe]=A,O[fe]=be)}}const q=[];let X=F-1,me=N-1;for(;X>=0&&me>=0;){const we=X*N+me;j[we]===A||(q.push(me),X--),me--}return[O[F*N-1],q.reverse()]}function D(x,B,F,U,M,N){let O=0;if(!b(B,U[M]))return O;if(O+=1,N>0&&(O+=N*5),x===F[M]&&(O+=1),M===0)O+=8;else{const j=g(F.charCodeAt(M-1));j?O+=j:(0,I.isUpper)(F.charCodeAt(M))&&(O+=2)}return O}function b(x,B){return x===B?!0:x==="/"||x==="\\"?B==="/"||B==="\\":!1}function g(x){switch(x){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const s=[void 0,[]];function d(x,B,F=0,U=0){const M=B;return M.values&&M.values.length>1?S(x,M.values,F,U):v(x,B,F,U)}e.scoreFuzzy2=d;function S(x,B,F,U){let M=0;const N=[];for(const O of B){const[j,q]=v(x,O,F,U);if(typeof j!="number")return s;M+=j,N.push(...q)}return[M,h(N)]}function v(x,B,F,U){const M=(0,I.fuzzyScore)(B.original,B.originalLowercase,F,x,x.toLowerCase(),U,!0);return M?[M[0],(0,I.createMatches)(M)]:s}const E=Object.freeze({score:0}),m=1<<18,l=1<<17,o=1<<16;function t(x,B,F,U,M){if(!x||!B.normalized)return E;const N=U.getItemLabel(x);if(!N)return E;const O=U.getItemDescription(x);let j;O?j=`${N}${O}${B.normalized}${Array.isArray(B.values)?B.values.length:""}${F}`:j=`${N}${B.normalized}${Array.isArray(B.values)?B.values.length:""}${F}`;const q=M[j];if(q)return q;const X=i(N,O,U.getItemPath(x),B,F);return M[j]=X,X}e.scoreItemFuzzy=t;function i(x,B,F,U,M){const N=!F||!U.containsPathSeparator;return F&&(P.isLinux?U.pathNormalized===F:(0,C.equalsIgnoreCase)(U.pathNormalized,F))?{score:m,labelMatch:[{start:0,end:x.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:U.values&&U.values.length>1?a(x,B,F,U.values,N,M):r(x,B,F,U,N,M)}function a(x,B,F,U,M,N){let O=0;const j=[],q=[];for(const X of U){const{score:me,labelMatch:we,descriptionMatch:Ae}=r(x,B,F,X,M,N);if(me===A)return E;O+=me,we&&j.push(...we),Ae&&q.push(...Ae)}return{score:O,labelMatch:h(j),descriptionMatch:h(q)}}function r(x,B,F,U,M,N){if(M||!B){const[O,j]=n(x,U.normalized,U.normalizedLowercase,N);if(O){const q=(0,I.matchesPrefix)(U.normalized,x);let X;return q?(X=l,X+=Math.round(U.normalized.length/x.length*100)):X=o,{score:X+O,labelMatch:q||c(j)}}}if(B){let O=B;F&&(O=`${B}${T.sep}`);const j=O.length,q=`${O}${x}`,[X,me]=n(q,U.normalized,U.normalizedLowercase,N);if(X){const we=c(me),Ae=[],Ie=[];return we.forEach(Me=>{Me.start<j&&Me.end>j?(Ae.push({start:0,end:Me.end-j}),Ie.push({start:Me.start,end:j})):Me.start>=j?Ae.push({start:Me.start-j,end:Me.end-j}):Ie.push(Me)}),{score:X,labelMatch:Ae,descriptionMatch:Ie}}}return E}function c(x){const B=[];if(!x)return B;let F;for(const U of x)F&&F.end===U?F.end+=1:(F={start:U,end:U+1},B.push(F));return B}function h(x){const B=x.sort((M,N)=>M.start-N.start),F=[];let U;for(const M of B)!U||!p(U,M)?(U=M,F.push(M)):(U.start=Math.min(U.start,M.start),U.end=Math.max(U.end,M.end));return F}function p(x,B){return!(x.end<B.start||B.end<x.start)}function w(x,B,F,U,M,N){const O=t(x,F,U,M,N),j=t(B,F,U,M,N),q=O.score,X=j.score;if((q===m||X===m)&&q!==X)return q===m?-1:1;if(q>o||X>o){if(q!==X)return q>X?-1:1;if(q<l&&X<l){const Y=f(O.labelMatch,j.labelMatch);if(Y!==0)return Y}const Me=M.getItemLabel(x)||"",V=M.getItemLabel(B)||"";if(Me.length!==V.length)return Me.length-V.length}if(q!==X)return q>X?-1:1;const me=Array.isArray(O.labelMatch)&&O.labelMatch.length>0,we=Array.isArray(j.labelMatch)&&j.labelMatch.length>0;if(me&&!we)return-1;if(we&&!me)return 1;const Ae=u(x,O,M),Ie=u(B,j,M);return Ae&&Ie&&Ae!==Ie?Ie>Ae?-1:1:k(x,B,F,M)}e.compareItemsByFuzzyScore=w;function u(x,B,F){let U=-1,M=-1;if(B.descriptionMatch&&B.descriptionMatch.length?U=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(U=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(M=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const N=F.getItemDescription(x);N&&(M+=N.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(M=B.descriptionMatch[B.descriptionMatch.length-1].end);return M-U}function f(x,B){if(!x&&!B||(!x||!x.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!x||!x.length)return 1;const F=x[0].start,M=x[x.length-1].end-F,N=B[0].start,j=B[B.length-1].end-N;return M===j?0:j<M?1:-1}function k(x,B,F,U){const M=U.getItemLabel(x)||"",N=U.getItemLabel(B)||"",O=U.getItemDescription(x),j=U.getItemDescription(B),q=M.length+(O?O.length:0),X=N.length+(j?j.length:0);if(q!==X)return q-X;const me=U.getItemPath(x),we=U.getItemPath(B);return me&&we&&me.length!==we.length?me.length-we.length:M!==N?(0,_.compareAnything)(M,N,F.normalized):O&&j&&O!==j?(0,_.compareAnything)(O,j,F.normalized):me&&we&&me!==we?(0,_.compareAnything)(me,we,F.normalized):0}const L=" ";function $(x){typeof x!="string"&&(x="");const B=x.toLowerCase(),{pathNormalized:F,normalized:U,normalizedLowercase:M}=te(x),N=F.indexOf(T.sep)>=0;let O;const j=x.split(L);if(j.length>1)for(const q of j){const{pathNormalized:X,normalized:me,normalizedLowercase:we}=te(q);me&&(O||(O=[]),O.push({original:q,originalLowercase:q.toLowerCase(),pathNormalized:X,normalized:me,normalizedLowercase:we}))}return{original:x,originalLowercase:B,pathNormalized:F,normalized:U,normalizedLowercase:M,values:O,containsPathSeparator:N}}e.prepareQuery=$;function te(x){let B;P.isWindows?B=x.replace(/\//g,T.sep):B=x.replace(/\\/g,T.sep);const F=(0,C.stripWildcards)(B).replace(/\s/g,"");return{pathNormalized:B,normalized:F,normalizedLowercase:F.toLowerCase()}}function H(x){return Array.isArray(x)?$(x.map(B=>B.original).join(L)):$(x.original)}e.pieceToQuery=H}),define(ge[34],ve([0,1,10,31,8,24,19]),function(Q,e,_,I,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function A(){return Object.create(null)}e.getEmptyExpression=A;const y="**",n="/",R="[/\\\\]",D="[^/\\\\]",b=/\//g;function g(O){switch(O){case 0:return"";case 1:return`${D}*?`;default:return`(?:${R}|${D}+${R}|${R}${D}+)*?`}}function s(O,j){if(!O)return[];const q=[];let X=!1,me=!1,we="";for(const Ae of O){switch(Ae){case j:if(!X&&!me){q.push(we),we="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":me=!0;break;case"]":me=!1;break}we+=Ae}return we&&q.push(we),q}e.splitGlobAware=s;function d(O){if(!O)return"";let j="";const q=s(O,n);if(q.every(X=>X===y))j=".*";else{let X=!1;q.forEach((me,we)=>{if(me===y){X||(j+=g(2),X=!0);return}let Ae=!1,Ie="",Me=!1,V="";for(const Y of me){if(Y!=="}"&&Ae){Ie+=Y;continue}if(Me&&(Y!=="]"||!V)){let ee;Y==="-"?ee=Y:(Y==="^"||Y==="!")&&!V?ee="^":Y===n?ee="":ee=_.escapeRegExpCharacters(Y),V+=ee;continue}switch(Y){case"{":Ae=!0;continue;case"[":Me=!0;continue;case"}":j+=`(?:${s(Ie,",").map(fe=>d(fe)).join("|")})`,Ae=!1,Ie="";break;case"]":j+="["+V+"]",Me=!1,V="";break;case"?":j+=D;continue;case"*":j+=g(1);continue;default:j+=_.escapeRegExpCharacters(Y)}}we<q.length-1&&(q[we+1]!==y||we+2<q.length)&&(j+=R),X=!1})}return j}const S=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,m=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.LRUCache(1e4),i=function(){return!1},a=function(){return null};function r(O,j){if(!O)return a;let q;typeof O!="string"?q=O.pattern:q=O,q=q.trim();const X=`${q}_${!!j.trimForExclusions}`;let me=t.get(X);if(me)return c(me,O);let we;if(S.test(q)){const Ae=q.substr(4);me=function(Ie,Me){return typeof Ie=="string"&&Ie.endsWith(Ae)?q:null}}else(we=v.exec(h(q,j)))?me=p(we[1],q):(j.trimForExclusions?m:E).test(q)?me=w(q,j):(we=l.exec(h(q,j)))?me=u(we[1].substr(1),q,!0):(we=o.exec(h(q,j)))?me=u(we[1],q,!1):me=f(q);return t.set(X,me),c(me,O)}function c(O,j){return typeof j=="string"?O:function(q,X){return I.isEqualOrParent(q,j.base)?O(T.relative(j.base,q),X):null}}function h(O,j){return j.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function p(O,j){const q=`/${O}`,X=`\\${O}`,me=function(Ae,Ie){return typeof Ae!="string"?null:Ie?Ie===O?j:null:Ae===O||Ae.endsWith(q)||Ae.endsWith(X)?j:null},we=[O];return me.basenames=we,me.patterns=[j],me.allBasenames=we,me}function w(O,j){const q=N(O.slice(1,-1).split(",").map(Ie=>r(Ie,j)).filter(Ie=>Ie!==a),O),X=q.length;if(!X)return a;if(X===1)return q[0];const me=function(Ie,Me){for(let V=0,Y=q.length;V<Y;V++)if(q[V](Ie,Me))return O;return null},we=q.find(Ie=>!!Ie.allBasenames);we&&(me.allBasenames=we.allBasenames);const Ae=q.reduce((Ie,Me)=>Me.allPaths?Ie.concat(Me.allPaths):Ie,[]);return Ae.length&&(me.allPaths=Ae),me}function u(O,j,q){const X=T.sep===T.posix.sep,me=X?O:O.replace(b,T.sep),we=T.sep+me,Ae=T.posix.sep+O,Ie=q?function(Me,V){return typeof Me=="string"&&(Me===me||Me.endsWith(we)||!X&&(Me===O||Me.endsWith(Ae)))?j:null}:function(Me,V){return typeof Me=="string"&&(Me===me||!X&&Me===O)?j:null};return Ie.allPaths=[(q?"*/":"./")+O],Ie}function f(O){try{const j=new RegExp(`^${d(O)}$`);return function(q){return j.lastIndex=0,typeof q=="string"&&j.test(q)?O:null}}catch(j){return a}}function k(O,j,q){return!O||typeof j!="string"?!1:L(O)(j,void 0,q)}e.match=k;function L(O,j={}){if(!O)return i;if(typeof O=="string"||x(O)){const q=r(O,j);if(q===a)return i;const X=function(me,we){return!!q(me,we)};return q.allBasenames&&(X.allBasenames=q.allBasenames),q.allPaths&&(X.allPaths=q.allPaths),X}return U(O,j)}e.parse=L;function $(O){if(!!O){let j;return q=>(j||(j=(O()||Promise.resolve([])).then(X=>X?H(X):{})),j.then(X=>!!X[q]))}}e.hasSiblingPromiseFn=$;function te(O){if(!!O){let j;return q=>{if(!j){const X=O();j=X?H(X):{}}return!!j[q]}}}e.hasSiblingFn=te;function H(O){const j={};for(const q of O)j[q]=!0;return j}function x(O){const j=O;return j&&typeof j.base=="string"&&typeof j.pattern=="string"}e.isRelativePattern=x;function B(O){return O.allBasenames||[]}e.getBasenameTerms=B;function F(O){return O.allPaths||[]}e.getPathTerms=F;function U(O,j){const q=N(Object.getOwnPropertyNames(O).map(Ie=>M(Ie,O[Ie],j)).filter(Ie=>Ie!==a)),X=q.length;if(!X)return a;if(!q.some(Ie=>!!Ie.requiresSiblings)){if(X===1)return q[0];const Ie=function(Y,ee){for(let ae=0,fe=q.length;ae<fe;ae++){const De=q[ae](Y,ee);if(De)return De}return null},Me=q.find(Y=>!!Y.allBasenames);Me&&(Ie.allBasenames=Me.allBasenames);const V=q.reduce((Y,ee)=>ee.allPaths?Y.concat(ee.allPaths):Y,[]);return V.length&&(Ie.allPaths=V),Ie}const me=function(Ie,Me,V){let Y;for(let ee=0,ae=q.length;ee<ae;ee++){const fe=q[ee];fe.requiresSiblings&&V&&(Me||(Me=T.basename(Ie)),Y||(Y=Me.substr(0,Me.length-T.extname(Ie).length)));const De=fe(Ie,Me,Y,V);if(De)return De}return null},we=q.find(Ie=>!!Ie.allBasenames);we&&(me.allBasenames=we.allBasenames);const Ae=q.reduce((Ie,Me)=>Me.allPaths?Ie.concat(Me.allPaths):Ie,[]);return Ae.length&&(me.allPaths=Ae),me}function M(O,j,q){if(j===!1)return a;const X=r(O,q);if(X===a)return a;if(typeof j=="boolean")return X;if(j){const me=j.when;if(typeof me=="string"){const we=(Ae,Ie,Me,V)=>{if(!V||!X(Ae,Ie))return null;const Y=me.replace("$(basename)",Me),ee=V(Y);return(0,C.isThenable)(ee)?ee.then(ae=>ae?O:null):ee?O:null};return we.requiresSiblings=!0,we}}return X}function N(O,j){const q=O.filter(Ie=>!!Ie.basenames);if(q.length<2)return O;const X=q.reduce((Ie,Me)=>{const V=Me.basenames;return V?Ie.concat(V):Ie},[]);let me;if(j){me=[];for(let Ie=0,Me=X.length;Ie<Me;Ie++)me.push(j)}else me=q.reduce((Ie,Me)=>{const V=Me.patterns;return V?Ie.concat(V):Ie},[]);const we=function(Ie,Me){if(typeof Ie!="string")return null;if(!Me){let Y;for(Y=Ie.length;Y>0;Y--){const ee=Ie.charCodeAt(Y-1);if(ee===47||ee===92)break}Me=Ie.substr(Y)}const V=X.indexOf(Me);return V!==-1?me[V]:null};we.basenames=X,we.patterns=me,we.allBasenames=X;const Ae=O.filter(Ie=>!Ie.basenames);return Ae.push(we),Ae}}),define(ge[75],ve([0,1,2,8,10,11,9,25,31]),function(Q,e,_,I,T,P,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(r,c,h){if(typeof r=="string"&&(r=_.URI.file(r)),h){const w=h.getWorkspaceFolder(r);if(w){const u=h.getWorkspace().folders.length>1;let f;if((0,A.isEqual)(w.uri,r)?f="":f=(0,A.relativePath)(w.uri,r),u){const k=w.name?w.name:(0,A.basename)(w.uri);f=f?k+" \u2022 "+f:k}return f}}if(r.scheme!==P.Schemas.file&&r.scheme!==P.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(r.fsPath))return(0,I.normalize)(D(r.fsPath));let p=(0,I.normalize)(r.fsPath);return!C.isWindows&&(c==null?void 0:c.userHome)&&(p=g(p,c.userHome.fsPath)),p}e.getPathLabel=n;function R(r){if(!!r){typeof r=="string"&&(r=_.URI.file(r));const c=(0,A.basename)(r)||(r.scheme===P.Schemas.file?r.fsPath:r.path);return C.isWindows&&(0,y.isRootOrDriveLetter)(c)?D(c):c}}e.getBaseLabel=R;function D(r){return(0,y.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=D;let b=Object.create(null);function g(r,c){if(C.isWindows||!r||!c)return r;let h=b.original===c?b.normalized:void 0;return h||(h=`${(0,T.rtrim)(c,I.posix.sep)}${I.posix.sep}`,b={original:c,normalized:h}),(C.isLinux?r.startsWith(h):(0,T.startsWithIgnoreCase)(r,h))&&(r=`~/${r.substr(h.length)}`),r}e.tildify=g;function s(r,c){return r.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=s;const d="\u2026",S="\\\\",v="~";function E(r,c=I.sep){const h=new Array(r.length);let p=!1;for(let w=0;w<r.length;w++){let u=r[w];if(u===""){h[w]=`.${c}`;continue}if(!u){h[w]=u;continue}p=!0;let f="";u.indexOf(S)===0?(f=u.substr(0,u.indexOf(S)+S.length),u=u.substr(u.indexOf(S)+S.length)):u.indexOf(c)===0?(f=u.substr(0,u.indexOf(c)+c.length),u=u.substr(u.indexOf(c)+c.length)):u.indexOf(v)===0&&(f=u.substr(0,u.indexOf(v)+v.length),u=u.substr(u.indexOf(v)+v.length));const k=u.split(c);for(let L=1;p&&L<=k.length;L++)for(let $=k.length-L;p&&$>=0;$--){p=!1;let te=k.slice($,$+L).join(c);for(let H=0;!p&&H<r.length;H++)if(H!==w&&r[H]&&r[H].indexOf(te)>-1){const x=$+L===k.length,B=$>0&&r[H].indexOf(c)>-1?c+te:te,F=r[H].endsWith(B);p=!x||F}if(!p){let H="";(k[0].endsWith(":")||f!=="")&&($===1&&($=0,L++,te=k[0]+c+te),$>0&&(H=k[0]+c),H=f+H),$>0&&(H=H+d+c),H=H+te,$+L<k.length&&(H=H+c+d),h[w]=H}}p&&(h[w]=u)}return h}e.shorten=E;var m;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function l(r,c=Object.create(null)){const h=[];let p=!1,w="";for(const u of r)if(u==="$"||p&&u==="{")w&&h.push({value:w,type:m.TEXT}),w="",p=!0;else if(u==="}"&&p){const f=c[w];if(typeof f=="string")f.length&&h.push({value:f,type:m.VARIABLE});else if(f){const k=h[h.length-1];(!k||k.type!==m.SEPARATOR)&&h.push({value:f.label,type:m.SEPARATOR})}w="",p=!1}else w+=u;return w&&!p&&h.push({value:w,type:m.TEXT}),h.filter((u,f)=>{if(u.type===m.SEPARATOR){const k=h[f-1],L=h[f+1];return[k,L].every($=>$&&($.type===m.VARIABLE||$.type===m.TEXT)&&$.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=l;function o(r,c){return C.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):r.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=o;function t(r,c){return C.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,""):C.isWindows?r.replace(/&&|&/g,h=>h==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function a(r){const c=r.indexOf("/")!==-1?I.posix:I.win32,h=c.basename(r),p=c.dirname(r);return h.length?{name:h,parentPath:p}:{name:p,parentPath:""}}e.splitName=a}),define(ge[97],ve([0,1,2]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(R){return R.toJSON()}class T{constructor(D){this._uriTransformer=D}transformIncoming(D){const b=this._uriTransformer.transformIncoming(D);return b===D?D:I(_.URI.from(b))}transformOutgoing(D){const b=this._uriTransformer.transformOutgoing(D);return b===D?D:I(_.URI.from(b))}transformOutgoingURI(D){const b=this._uriTransformer.transformOutgoing(D);return b===D?D:_.URI.from(b)}transformOutgoingScheme(D){return this._uriTransformer.transformOutgoingScheme(D)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function P(R,D,b){if(!R||b>200)return null;if(typeof R=="object"){if(R instanceof _.URI)return D.transformOutgoing(R);for(let g in R)if(Object.hasOwnProperty.call(R,g)){const s=P(R[g],D,b+1);s!==null&&(R[g]=s)}}return null}function C(R,D){const b=P(R,D,0);return b===null?R:b}e.transformOutgoingURIs=C;function A(R,D,b,g){if(!R||g>200)return null;if(typeof R=="object"){if(R.$mid===1)return b?_.URI.revive(D.transformIncoming(R)):D.transformIncoming(R);for(let s in R)if(Object.hasOwnProperty.call(R,s)){const d=A(R[s],D,b,g+1);d!==null&&(R[s]=d)}}return null}function y(R,D){const b=A(R,D,!1,0);return b===null?R:b}e.transformIncomingURIs=y;function n(R,D){const b=A(R,D,!0,0);return b===null?R:b}e.transformAndReviveIncomingURIs=n}),define(ge[28],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const _=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(y){return _.test(y)}e.isUUID=I;const T=new Uint8Array(16),P=[];for(let y=0;y<256;y++)P.push(y.toString(16).padStart(2,"0"));let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(y){for(let n=0;n<y.length;n++)y[n]=Math.floor(Math.random()*256);return y};function A(){C(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let y=0,n="";return n+=P[T[y++]],n+=P[T[y++]],n+=P[T[y++]],n+=P[T[y++]],n+="-",n+=P[T[y++]],n+=P[T[y++]],n+="-",n+=P[T[y++]],n+=P[T[y++]],n+="-",n+=P[T[y++]],n+=P[T[y++]],n+="-",n+=P[T[y++]],n+=P[T[y++]],n+=P[T[y++]],n+=P[T[y++]],n+=P[T[y++]],n+=P[T[y++]],n}e.generateUuid=A}),define(ge[136],ve([0,1,98]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class I{constructor(P="utf8"){this.stringDecoder=new _.StringDecoder(P),this.remaining=null}write(P){const C=[],A=this.remaining?this.remaining+this.stringDecoder.write(P):this.stringDecoder.write(P);if(A.length<1)return C;let y=0,n,R=y;for(;R<A.length;)if(n=A.charCodeAt(R),n===13||n===10){if(C.push(A.substring(y,R)),R++,R<A.length){const D=n;n=A.charCodeAt(R),(D===13&&n===10||D===10&&n===13)&&R++}y=R}else R++;return this.remaining=y<A.length?A.substr(y):null,C}end(){return this.remaining}}e.LineDecoder=I}),define(ge[26],ve([0,1,37,48,8,19,9,31,28,74,25,2]),function(Q,e,_,I,T,P,C,A,y,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var b;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function g(B,F=b.UNLINK){if((0,A.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return F===b.UNLINK?d(B):s(B)}e.rimraf=g;async function s(B){try{const F=(0,T.join)((0,I.tmpdir)(),(0,y.generateUuid)());try{await _.promises.rename(B,F)}catch(U){return d(B)}d(F).catch(U=>{})}catch(F){if(F.code!=="ENOENT")throw F}}async function d(B){return _.promises.rmdir(B,{recursive:!0,maxRetries:3})}function S(B){if((0,A.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");_.rmdirSync(B,{recursive:!0})}e.rimrafSync=S;async function v(B,F){return l(await(F?E(B):_.promises.readdir(B)))}e.readdir=v;async function E(B){try{return await _.promises.readdir(B,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const F=[],U=await v(B);for(const M of U){let N=!1,O=!1,j=!1;try{const q=await _.promises.lstat((0,T.join)(B,M));N=q.isFile(),O=q.isDirectory(),j=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}F.push({name:M,isFile:()=>N,isDirectory:()=>O,isSymbolicLink:()=>j})}return F}function m(B){return l(_.readdirSync(B))}e.readdirSync=m;function l(B){return B.map(F=>typeof F=="string"?C.isMacintosh?(0,n.normalizeNFC)(F):F:(F.name=C.isMacintosh?(0,n.normalizeNFC)(F.name):F.name,F))}async function o(B){const F=await v(B),U=[];for(const M of F)await i.existsDirectory((0,T.join)(B,M))&&U.push(M);return U}e.readDirsInDir=o;function t(B,F=1e3){return new Promise(U=>{let M=!1;const N=setInterval(()=>{M||(M=!0,_.access(B,O=>{M=!1,O&&(clearInterval(N),U(void 0))}))},F)})}e.whenDeleted=t;var i;(function(B){async function F(N){let O;try{if(O=await _.promises.lstat(N),!O.isSymbolicLink())return{stat:O}}catch(j){}try{return{stat:await _.promises.stat(N),symbolicLink:(O==null?void 0:O.isSymbolicLink())?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(C.isWindows&&j.code==="EACCES")try{return{stat:await _.promises.stat(await _.promises.readlink(N)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw q}throw j}}B.stat=F;async function U(N){try{const{stat:O,symbolicLink:j}=await B.stat(N);return O.isFile()&&(j==null?void 0:j.dangling)!==!0}catch(O){}return!1}B.existsFile=U;async function M(N){try{const{stat:O,symbolicLink:j}=await B.stat(N);return O.isDirectory()&&(j==null?void 0:j.dangling)!==!0}catch(O){}return!1}B.existsDirectory=M})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new P.ResourceQueue;function r(B,F,U){return a.queueFor(D.URI.file(B),R.extUriBiasedIgnorePathCase).queue(()=>{const M=w(U);return new Promise((N,O)=>h(B,F,M,j=>j?O(j):N()))})}e.writeFile=r;let c=!0;function h(B,F,U,M){if(!c)return _.writeFile(B,F,{mode:U.mode,flag:U.flag},M);_.open(B,U.flag,U.mode,(N,O)=>{if(N)return M(N);_.writeFile(O,F,j=>{if(j)return _.close(O,()=>M(j));_.fdatasync(O,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),c=!1),_.close(O,X=>M(X))))})})}function p(B,F,U){const M=w(U);if(!c)return _.writeFileSync(B,F,{mode:M.mode,flag:M.flag});const N=_.openSync(B,M.flag,M.mode);try{_.writeFileSync(N,F);try{_.fdatasyncSync(N)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),c=!1}}finally{_.closeSync(N)}}e.writeFileSync=p;function w(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function u(B,F){if(B!==F){async function U(M){try{const N=await _.promises.lstat(M);if(N.isDirectory()||N.isSymbolicLink())return;const O=await _.promises.open(M,"a");try{await O.utimes(N.atime,new Date)}finally{await O.close()}}catch(N){}}try{await _.promises.rename(B,F),await U(F)}catch(M){if(B.toLowerCase()!==F.toLowerCase()&&M.code==="EXDEV"||B.endsWith("."))await f(B,F,{preserveSymlinks:!1}),await g(B,b.MOVE),await U(F);else throw M}}}e.move=u;async function f(B,F,U){return L(B,F,{root:{source:B,target:F},options:U,handledSourcePaths:new Set})}e.copy=f;const k=511;async function L(B,F,U){if(!U.handledSourcePaths.has(B)){U.handledSourcePaths.add(B);const{stat:M,symbolicLink:N}=await i.stat(B);if(N){if(U.options.preserveSymlinks)try{return await H(B,F,U)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(N.dangling)return}return M.isDirectory()?$(B,F,M.mode&k,U):te(B,F,M.mode&k)}}async function $(B,F,U,M){await _.promises.mkdir(F,{recursive:!0,mode:U});const N=await v(B);for(const O of N)await L((0,T.join)(B,O),(0,T.join)(F,O),M)}async function te(B,F,U){await _.promises.copyFile(B,F),await _.promises.chmod(F,U)}async function H(B,F,U){let M=await _.promises.readlink(B);(0,A.isEqualOrParent)(M,U.root.source,!C.isLinux)&&(M=(0,T.join)(U.root.target,M.substr(U.root.source.length+1))),await _.promises.symlink(M,F)}async function x(B){try{return await _.promises.access(B),!0}catch(F){return!1}}e.exists=x}),define(ge[99],ve([0,1,37,283,10,8,26]),function(Q,e,_,I,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(D){const b=(0,P.dirname)(D);if(D===b)return D;const g=((0,P.basename)(D)||D).toLowerCase();try{const d=(0,C.readdirSync)(b).filter(S=>S.toLowerCase()===g);if(d.length===1){const S=A(b);if(S)return(0,P.join)(S,d[0])}else if(d.length>1){const S=d.indexOf(g);if(S>=0){const v=A(b);if(v)return(0,P.join)(v,d[S])}}}catch(s){}return null}e.realcaseSync=A;async function y(D){try{return await(0,I.promisify)(_.realpath)(D)}catch(b){const g=R(D);return await _.promises.access(g,_.constants.R_OK),g}}e.realpath=y;function n(D){try{return _.realpathSync(D)}catch(b){const g=R(D);return _.accessSync(g,_.constants.R_OK),g}}e.realpathSync=n;function R(D){return(0,T.rtrim)((0,P.normalize)(D),P.sep)}});var vt=this&&this.__await||function(Q){return this instanceof vt?(this.v=Q,this):new vt(Q)},An=this&&this.__asyncGenerator||function(Q,e,_){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var I=_.apply(Q,e||[]),T,P=[];return T={},C("next"),C("throw"),C("return"),T[Symbol.asyncIterator]=function(){return this},T;function C(b){I[b]&&(T[b]=function(g){return new Promise(function(s,d){P.push([b,g,s,d])>1||A(b,g)})})}function A(b,g){try{y(I[b](g))}catch(s){D(P[0][3],s)}}function y(b){b.value instanceof vt?Promise.resolve(b.value.v).then(n,R):D(P[0][2],b)}function n(b){A("next",b)}function R(b){A("throw",b)}function D(b,g){b(g),P.shift(),P.length&&A(P[0][0],P[0][1])}},rn=this&&this.__asyncValues||function(Q){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Q[Symbol.asyncIterator],_;return e?e.call(Q):(Q=typeof __values=="function"?__values(Q):Q[Symbol.iterator](),_={},I("next"),I("throw"),I("return"),_[Symbol.asyncIterator]=function(){return this},_);function I(P){_[P]=Q[P]&&function(C){return new Promise(function(A,y){C=Q[P](C),T(A,y,C.done,C.value)})}}function T(P,C,A,y){Promise.resolve(y).then(function(n){P({value:n,done:A})},C)}};define(ge[100],ve([0,1,26,48,8]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const P=/^\d+$/,C=/^Microsoft.PowerShell_.*/,A=/^Microsoft.PowerShellPreview_.*/;var y;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(y||(y={}));let n;switch(process.arch){case"ia32":case"x32":n=1;break;case"arm":case"arm64":n=2;break;default:n=0;break}let R;process.env.PROCESSOR_ARCHITEW6432?R=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?R=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?R=1:R=0;class D{constructor(o,t,i){this.exePath=o,this.displayName=t,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await _.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:l=!1}={}){return l?n===0?process.env["ProgramFiles(x86)"]||null:R===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:l=!1,findPreview:o=!1}={}){const t=b({useAlternateBitness:l});if(!t)return null;const i=T.join(t,"PowerShell");if(!await _.SymlinkSupport.existsDirectory(i))return null;let a=-1,r=null;for(const p of await _.readdir(i)){let w=-1;if(o){const f=p.indexOf("-");if(f<0)continue;const k=p.substring(0,f);if(!P.test(k)||p.substring(f+1)!=="preview")continue;w=parseInt(k,10)}else{if(!P.test(p))continue;w=parseInt(p,10)}if(!(w<=a)){const u=T.join(i,p,"pwsh.exe");!await _.SymlinkSupport.existsFile(u)||(r=u,a=w)}}if(!r)return null;const c=t.includes("x86")?" (x86)":"",h=o?" Preview":"";return new D(r,`PowerShell${h}${c}`,!0)}async function s({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const o=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await _.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:t,pwshMsixName:i}=l?{pwshMsixDirRegex:A,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const a of await _.readdir(o))if(t.test(a)){const r=T.join(o,a,"pwsh.exe");return new D(r,i)}return null}function d(){const l=T.join(I.homedir(),".dotnet","tools","pwsh.exe");return new D(l,".NET Core PowerShell Global Tool")}function S(){const l=T.join(process.env.windir,n===1&&R!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new D(l,"Windows PowerShell",!0)}function v(){return An(this,arguments,function*(){let o=yield vt(g());o&&(yield yield vt(o)),o=yield vt(g({useAlternateBitness:!0})),o&&(yield yield vt(o)),o=yield vt(s()),o&&(yield yield vt(o)),o=d(),o&&(yield yield vt(o)),o=yield vt(g({findPreview:!0})),o&&(yield yield vt(o)),o=yield vt(s({findPreview:!0})),o&&(yield yield vt(o)),o=yield vt(g({useAlternateBitness:!0,findPreview:!0})),o&&(yield yield vt(o)),o=S(),o&&(yield yield vt(o))})}function E(){return An(this,arguments,function*(){var o,t;try{for(var i=rn(v()),a;a=yield vt(i.next()),!a.done;){const r=a.value;(yield vt(r.exists()))&&(yield yield vt(r))}}catch(r){o={error:r}}finally{try{a&&!a.done&&(t=i.return)&&(yield vt(t.call(i)))}finally{if(o)throw o.error}}})}e.enumeratePowerShellInstallations=E;async function m(){var l,o;try{for(var t=rn(E()),i;i=await t.next(),!i.done;)return i.value}catch(a){l={error:a}}finally{try{i&&!i.done&&(o=t.return)&&await o.call(t)}finally{if(l)throw l.error}}return null}e.getFirstAvailablePowerShellInstallation=m}),define(ge[101],ve([0,1,3,6,19,21,18,22,14,15,57,10]),function(Q,e,_,I,T,P,C,A,y,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function g(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(s=e.ResponseType||(e.ResponseType={}));function d(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(S||(S={}));class v{constructor(N){this.buffer=N,this.pos=0}read(N){const O=this.buffer.slice(this.pos,this.pos+N);return this.pos+=O.byteLength,O}}class E{constructor(){this.buffers=[]}get buffer(){return A.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var m;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(m||(m={}));function l(M){const N=A.VSBuffer.alloc(4);return N.writeUInt32BE(M,0),N}function o(M){return M.read(4).readUInt32BE(0)}function t(M){const N=A.VSBuffer.alloc(1);return N.writeUInt8(M,0),N}const i={Undefined:t(m.Undefined),String:t(m.String),Buffer:t(m.Buffer),VSBuffer:t(m.VSBuffer),Array:t(m.Array),Object:t(m.Object)},a=typeof Buffer!="undefined";function r(M,N){if(typeof N=="undefined")M.write(i.Undefined);else if(typeof N=="string"){const O=A.VSBuffer.fromString(N);M.write(i.String),M.write(l(O.byteLength)),M.write(O)}else if(a&&Buffer.isBuffer(N)){const O=A.VSBuffer.wrap(N);M.write(i.Buffer),M.write(l(O.byteLength)),M.write(O)}else if(N instanceof A.VSBuffer)M.write(i.VSBuffer),M.write(l(N.byteLength)),M.write(N);else if(Array.isArray(N)){M.write(i.Array),M.write(l(N.length));for(const O of N)r(M,O)}else{const O=A.VSBuffer.fromString(JSON.stringify(N));M.write(i.Object),M.write(l(O.byteLength)),M.write(O)}}function c(M){switch(M.read(1).readUInt8(0)){case m.Undefined:return;case m.String:return M.read(o(M)).toString();case m.Buffer:return M.read(o(M)).buffer;case m.VSBuffer:return M.read(o(M));case m.Array:{const O=o(M),j=[];for(let q=0;q<O;q++)j.push(c(M));return j}case m.Object:return JSON.parse(M.read(o(M)).toString())}}class h{constructor(N,O,j=null,q=1e3){this.protocol=N,this.ctx=O,this.logger=j,this.timeoutDelay=q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(N,O){this.channels.set(N,O),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const O=this.send([N.type]);this.logger&&this.logger.logOutgoing(O,0,1,d(N.type));return}case 201:case 202:case 204:case 203:{const O=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(O,N.id,1,d(N.type),N.data);return}}}send(N,O=void 0){const j=new E;return r(j,N),r(j,O),this.sendBuffer(j.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(O){return 0}}onRawMessage(N){const O=new v(N),j=c(O),q=c(O),X=j[0];switch(X){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,j[1],1,`${g(X)}: ${j[2]}.${j[3]}`,q),this.onPromise({type:X,id:j[1],channelName:j[2],name:j[3],arg:q});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,j[1],1,`${g(X)}: ${j[2]}.${j[3]}`,q),this.onEventListen({type:X,id:j[1],channelName:j[2],name:j[3],arg:q});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,j[1],1,`${g(X)}`),this.disposeActiveRequest({type:X,id:j[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,j[1],1,`${g(X)}`),this.disposeActiveRequest({type:X,id:j[1]})}}onPromise(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const j=new P.CancellationTokenSource;let q;try{q=O.call(this.ctx,N.name,N.arg,j.token)}catch(we){q=Promise.reject(we)}const X=N.id;q.then(we=>{this.sendResponse({id:X,data:we,type:201}),this.activeRequests.delete(N.id)},we=>{we instanceof Error?this.sendResponse({id:X,data:{message:we.message,name:we.name,stack:we.stack?we.stack.split?we.stack.split(`
`):we.stack:void 0},type:202}):this.sendResponse({id:X,data:we,type:203}),this.activeRequests.delete(N.id)});const me=(0,I.toDisposable)(()=>j.cancel());this.activeRequests.set(N.id,me)}onEventListen(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const j=N.id,X=O.listen(this.ctx,N.name,N.arg)(me=>this.sendResponse({id:j,data:me,type:204}));this.activeRequests.set(N.id,X)}disposeActiveRequest(N){const O=this.activeRequests.get(N.id);O&&(O.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let O=this.pendingRequests.get(N.channelName);O||(O=[],this.pendingRequests.set(N.channelName,O));const j=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:N,timeoutTimer:j})}flushPendingRequests(N){const O=this.pendingRequests.get(N);if(O){for(const j of O)switch(clearTimeout(j.timeoutTimer),j.request.type){case 100:this.onPromise(j.request);break;case 102:this.onEventListen(j.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var p;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(N,O=null){this.protocol=N,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(j=>this.onBuffer(j)),this.logger=O}getChannel(N){const O=this;return{call(j,q,X){return O.isDisposed?Promise.reject(C.canceled()):O.requestPromise(N,j,q,X)},listen(j,q){return O.isDisposed?Promise.reject(C.canceled()):O.requestEvent(N,j,q)}}}requestPromise(N,O,j,q=P.CancellationToken.None){const X=this.lastRequestId++,we={id:X,type:100,channelName:N,name:O,arg:j};if(q.isCancellationRequested)return Promise.reject(C.canceled());let Ae;return new Promise((Me,V)=>{if(q.isCancellationRequested)return V(C.canceled());const Y=()=>{const De=Oe=>{switch(Oe.type){case 201:this.handlers.delete(X),Me(Oe.data);break;case 202:this.handlers.delete(X);const be=new Error(Oe.data.message);be.stack=Oe.data.stack,be.name=Oe.data.name,V(be);break;case 203:this.handlers.delete(X),V(Oe.data);break}};this.handlers.set(X,De),this.sendRequest(we)};let ee=null;this.state===S.Idle?Y():(ee=(0,T.createCancelablePromise)(De=>this.whenInitialized()),ee.then(()=>{ee=null,Y()}));const ae=()=>{ee?(ee.cancel(),ee=null):this.sendRequest({id:X,type:101}),V(C.canceled())},fe=q.onCancellationRequested(ae);Ae=(0,I.combinedDisposable)((0,I.toDisposable)(ae),fe),this.activeRequests.add(Ae)}).finally(()=>{this.activeRequests.delete(Ae)})}requestEvent(N,O,j){const q=this.lastRequestId++,me={id:q,type:102,channelName:N,name:O,arg:j};let we=null;const Ae=new _.Emitter({onFirstListenerAdd:()=>{we=(0,T.createCancelablePromise)(Me=>this.whenInitialized()),we.then(()=>{we=null,this.activeRequests.add(Ae),this.sendRequest(me)})},onLastListenerRemove:()=>{we?(we.cancel(),we=null):(this.activeRequests.delete(Ae),this.sendRequest({id:q,type:103}))}}),Ie=Me=>Ae.fire(Me.data);return this.handlers.set(q,Ie),Ae.event}sendRequest(N){switch(N.type){case 100:case 102:{const O=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(O,N.id,0,`${g(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const O=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(O,N.id,0,g(N.type));return}}}send(N,O=void 0){const j=new E;return r(j,N),r(j,O),this.sendBuffer(j.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(O){return 0}}onBuffer(N){const O=new v(N),j=c(O),q=c(O),X=j[0];switch(X){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,d(X)),this.onResponse({type:j[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,j[1],0,d(X),q),this.onResponse({type:j[0],id:j[1],data:q})}}onResponse(N){if(N.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(N.id);O&&O(N)}whenInitialized(){return this.state===S.Idle?Promise.resolve():_.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelClient=w;class u{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:O,onDidClientDisconnect:j})=>{_.Event.once(O.onMessage)(X=>{const me=new v(X),we=c(me),Ae=new h(O,we),Ie=new w(O);this.channels.forEach((V,Y)=>Ae.registerChannel(Y,V));const Me={channelServer:Ae,channelClient:Ie,ctx:we};this._connections.add(Me),this._onDidAddConnection.fire(Me),j(()=>{Ae.dispose(),Ie.dispose(),this._connections.delete(Me),this._onDidRemoveConnection.fire(Me)})})})}get connections(){const N=[];return this._connections.forEach(O=>N.push(O)),N}getChannel(N,O){const j=this;return{call(q,X,me){let we;if((0,n.isFunction)(O)){let Ie=(0,y.getRandomElement)(j.connections.filter(O));we=Ie?Promise.resolve(Ie):_.Event.toPromise(_.Event.filter(j.onDidAddConnection,O))}else we=O.routeCall(j,q,X);const Ae=we.then(Ie=>Ie.channelClient.getChannel(N));return k(Ae).call(q,X,me)},listen(q,X){if((0,n.isFunction)(O))return j.getMulticastEvent(N,O,q,X);const me=O.routeEvent(j,q,X).then(we=>we.channelClient.getChannel(N));return k(me).listen(q,X)}}}getMulticastEvent(N,O,j,q){const X=this;let me=new I.DisposableStore;const we=new _.Emitter({onFirstListenerAdd:()=>{me=new I.DisposableStore;const Ae=new _.EventMultiplexer,Ie=new Map,Me=Y=>{const ae=Y.channelClient.getChannel(N).listen(j,q),fe=Ae.add(ae);Ie.set(Y,fe)},V=Y=>{const ee=Ie.get(Y);!ee||(ee.dispose(),Ie.delete(Y))};X.connections.filter(O).forEach(Me),_.Event.filter(X.onDidAddConnection,O)(Me,void 0,me),X.onDidRemoveConnection(V,void 0,me),Ae.event(we.fire,we,me),me.add(Ae)},onLastListenerRemove:()=>{me.dispose()}});return we.event}registerChannel(N,O){this.channels.set(N,O),this._connections.forEach(j=>{j.channelServer.registerChannel(N,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=u;class f{constructor(N,O,j=null){const q=new E;r(q,O),N.send(q.buffer),this.channelClient=new w(N,j),this.channelServer=new h(N,O,j)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,O){this.channelServer.registerChannel(N,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=f;function k(M){return{call(N,O,j){return M.then(q=>q.call(N,O,j))},listen(N,O){const j=new _.Relay;return M.then(q=>j.input=q.listen(N,O)),j.event}}}e.getDelayedChannel=k;function L(M){let N=!1;return{call(O,j,q){return N?M.call(O,j,q):(0,T.timeout)(0).then(()=>N=!0).then(()=>M.call(O,j,q))},listen(O,j){if(N)return M.listen(O,j);const q=new _.Relay;return(0,T.timeout)(0).then(()=>N=!0).then(()=>q.input=M.listen(O,j)),q.event}}}e.getNextTickChannel=L;class ${constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const O of N.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await _.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=$;var te;(function(M){function N(q,X){const me=q,we=X&&X.disableMarshalling,Ae=new Map;for(const Ie in me)j(Ie)&&Ae.set(Ie,_.Event.buffer(me[Ie],!0));return new class{listen(Ie,Me){const V=Ae.get(Me);if(V)return V;throw new Error(`Event not found: ${Me}`)}call(Ie,Me,V){const Y=me[Me];if(typeof Y=="function"){if(!we&&Array.isArray(V))for(let ee=0;ee<V.length;ee++)V[ee]=(0,R.revive)(V[ee]);return Y.apply(me,V)}throw new Error(`Method not found: ${Me}`)}}}M.fromService=N;function O(q,X){const me=X&&X.disableMarshalling;return new Proxy({},{get(we,Ae){var Ie;if(typeof Ae=="string")return((Ie=X==null?void 0:X.properties)===null||Ie===void 0?void 0:Ie.has(Ae))?X.properties.get(Ae):j(Ae)?q.listen(Ae):async function(...Me){let V;X&&!(0,n.isUndefinedOrNull)(X.context)?V=[X.context,...Me]:V=Me;const Y=await q.call(Ae,V);return me?Y:(0,R.revive)(Y)};throw new Error(`Property not found: ${String(Ae)}`)}})}M.toService=O;function j(q){return q[0]==="o"&&q[1]==="n"&&D.isUpperAsciiLetter(q.charCodeAt(2))}})(te=e.ProxyChannel||(e.ProxyChannel={}));const H=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let N=M.toString();if(N!=="[object Object]")return N}return M}function B(M){return Array.isArray(M)?M.map(x):x(M)}function F(M,N,O,j,q,X,me){me=B(me);const we=H[q],Ae=we[j%we.length];let Ie=[`%c[${M}]%c[${String(N).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(j).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${Ae}`];/\($/.test(X)?(Ie=Ie.concat(me),Ie.push(")")):Ie.push(me),console.log.apply(console,Ie)}e.logWithColors=F;class U{constructor(N,O){this._outgoingPrefix=N,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,O,j,q,X){this._totalOutgoing+=N,F(this._outgoingPrefix,this._totalOutgoing,N,O,j,q,X)}logIncoming(N,O,j,q,X){this._totalIncoming+=N,F(this._incomingPrefix,this._totalIncoming,N,O,j,q,X)}}e.IPCLogger=U}),define(ge[102],ve([0,1,3,101,6,22,9,30]),function(Q,e,_,I,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let y=null;function n(){return y||(y=P.VSBuffer.alloc(0)),y}class R{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,r){if(a===0)return n();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const w=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=a),w}if(this._chunks[0].byteLength>a){const w=this._chunks[0].slice(0,a);return r&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),w}let c=P.VSBuffer.alloc(a),h=0,p=0;for(;a>0;){const w=this._chunks[p];if(w.byteLength>a){const u=w.slice(0,a);c.set(u,h),h+=a,r&&(this._chunks[p]=w.slice(a),this._totalLength-=a),a-=a}else c.set(w,h),h+=w.byteLength,r?(this._chunks.shift(),this._totalLength-=w.byteLength):p++,a-=w.byteLength}return c}}e.ChunkStream=R;var D;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(D||(D={}));var b;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(b=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(a,r,c,h){this.type=a,this.id=r,this.ack=c,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class s extends T.Disposable{constructor(a){super();this._onMessage=this._register(new _.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new R,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5);else{const c=this._state.messageType,h=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new g(c,h,p,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(a){this._isDisposed=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(a){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(a){if(!this._isDisposed){a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=P.VSBuffer.alloc(13);r.writeUInt8(a.type,0),r.writeUInt32BE(a.id,1),r.writeUInt32BE(a.ack,5),r.writeUInt32BE(a.data.byteLength,9),this._writeSoon(r,a.data)}}_bufferAdd(a,r){const c=this._totalLength===0;return this._data.push(a,r),this._totalLength+=a.byteLength+r.byteLength,c}_bufferTake(){const a=P.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,r){this._bufferAdd(a,r)&&C.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends T.Disposable{constructor(a){super();this._onMessage=new _.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new s(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new g(1,0,0,a))}}e.Protocol=S;class v extends I.IPCClient{constructor(a,r,c=null){super(a,r,c);this.protocol=a}static fromSocket(a,r){return new v(new S(a),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=v;class E{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new _.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,A.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=E;class m{constructor(a){this.data=a,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let a=[],r=0,c=this._first;for(;c;)a[r++]=c.data,c=c.next;return a}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const r=new m(a);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class o{constructor(){this.lastRuns=[];const a=Date.now();for(let r=0;r<o._HISTORY_LENGTH;r++)this.lastRuns[r]=a-1e3*r;setInterval(()=>{for(let r=o._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}load(){const a=Date.now(),r=(1+o._HISTORY_LENGTH)*1e3;let c=0;for(let h=0;h<o._HISTORY_LENGTH;h++)a-this.lastRuns[h]<=r&&c++;return 1-c/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class t{constructor(a,r=null){this._loadEstimator=o.getInstance(),this._onControlMessage=new E,this.onControlMessage=this._onControlMessage.event,this._onMessage=new E,this.onMessage=this._onMessage.event,this._onDidDispose=new E,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new E,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new E,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=a,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new s(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),r&&this._socketReader.acceptChunk(r),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,T.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new g(5,0,0,n());this._socketWriter.write(a),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const a=Date.now()-this._socketWriter.lastWriteTime;if(a>=5e3){const r=new g(4,0,0,n());this._socketWriter.write(r),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-a+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const a=Date.now()-this._socketReader.lastReadTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-a,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,r){this._isReconnecting=!0,this._socketDisposables=(0,T.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=a,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new s(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1;const a=this._outgoingUnackMsg.toArray();for(let r=0,c=a.length;r<c;r++)this._socketWriter.write(a[r]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(a.type===1){if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new g(6,0,0,n())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data)}else if(a.type===2)this._onControlMessage.fire(a.data);else if(a.type===5)this._onDidDispose.fire();else if(a.type===6){const r=this._outgoingUnackMsg.toArray();for(let c=0,h=r.length;c<h;c++)this._socketWriter.write(r[c]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new g(1,r,this._incomingAckId,a);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(a){const r=new g(2,0,0,a);this._socketWriter.write(r)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const a=this._outgoingUnackMsg.peek(),r=Date.now()-a.writtenTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-r,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const a=new g(3,0,this._incomingAckId,n());this._socketWriter.write(a)}}}e.PersistentProtocol=t}),define(ge[103],ve([0,1,92]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class I{constructor(A){let y=(0,_.toUint8)(A);this._defaultValue=y,this._asciiMap=I._createAsciiMap(y),this._map=new Map}static _createAsciiMap(A){let y=new Uint8Array(256);for(let n=0;n<256;n++)y[n]=A;return y}set(A,y){let n=(0,_.toUint8)(y);A>=0&&A<256?this._asciiMap[A]=n:this._map.set(A,n)}get(A){return A>=0&&A<256?this._asciiMap[A]:this._map.get(A)||this._defaultValue}}e.CharacterClassifier=I;var T;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(T||(T={}));class P{constructor(){this._actual=new I(0)}add(A){this._actual.set(A,1)}has(A){return this._actual.get(A)===1}}e.CharacterSet=P}),define(ge[137],ve([0,1,103]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var I;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(I=e.WordCharacterClass||(e.WordCharacterClass={}));class T extends _.CharacterClassifier{constructor(A){super(0);for(let y=0,n=A.length;y<n;y++)this.set(A.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=T;function P(C){let A={};return y=>(A.hasOwnProperty(y)||(A[y]=C(y)),A[y])}e.getMapForWordSeparators=P(C=>new T(C))}),define(ge[49],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class _{constructor(T,P){this.lineNumber=T,this.column=P}with(T=this.lineNumber,P=this.column){return T===this.lineNumber&&P===this.column?this:new _(T,P)}delta(T=0,P=0){return this.with(this.lineNumber+T,this.column+P)}equals(T){return _.equals(this,T)}static equals(T,P){return!T&&!P?!0:!!T&&!!P&&T.lineNumber===P.lineNumber&&T.column===P.column}isBefore(T){return _.isBefore(this,T)}static isBefore(T,P){return T.lineNumber<P.lineNumber?!0:P.lineNumber<T.lineNumber?!1:T.column<P.column}isBeforeOrEqual(T){return _.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,P){return T.lineNumber<P.lineNumber?!0:P.lineNumber<T.lineNumber?!1:T.column<=P.column}static compare(T,P){let C=T.lineNumber|0,A=P.lineNumber|0;if(C===A){let y=T.column|0,n=P.column|0;return y-n}return C-A}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new _(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}}e.Position=_}),define(ge[43],ve([0,1,49]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class I{constructor(P,C,A,y){P>A||P===A&&C>y?(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=P,this.endColumn=C):(this.startLineNumber=P,this.startColumn=C,this.endLineNumber=A,this.endColumn=y)}isEmpty(){return I.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return I.containsPosition(this,P)}static containsPosition(P,C){return!(C.lineNumber<P.startLineNumber||C.lineNumber>P.endLineNumber||C.lineNumber===P.startLineNumber&&C.column<P.startColumn||C.lineNumber===P.endLineNumber&&C.column>P.endColumn)}containsRange(P){return I.containsRange(this,P)}static containsRange(P,C){return!(C.startLineNumber<P.startLineNumber||C.endLineNumber<P.startLineNumber||C.startLineNumber>P.endLineNumber||C.endLineNumber>P.endLineNumber||C.startLineNumber===P.startLineNumber&&C.startColumn<P.startColumn||C.endLineNumber===P.endLineNumber&&C.endColumn>P.endColumn)}strictContainsRange(P){return I.strictContainsRange(this,P)}static strictContainsRange(P,C){return!(C.startLineNumber<P.startLineNumber||C.endLineNumber<P.startLineNumber||C.startLineNumber>P.endLineNumber||C.endLineNumber>P.endLineNumber||C.startLineNumber===P.startLineNumber&&C.startColumn<=P.startColumn||C.endLineNumber===P.endLineNumber&&C.endColumn>=P.endColumn)}plusRange(P){return I.plusRange(this,P)}static plusRange(P,C){let A,y,n,R;return C.startLineNumber<P.startLineNumber?(A=C.startLineNumber,y=C.startColumn):C.startLineNumber===P.startLineNumber?(A=C.startLineNumber,y=Math.min(C.startColumn,P.startColumn)):(A=P.startLineNumber,y=P.startColumn),C.endLineNumber>P.endLineNumber?(n=C.endLineNumber,R=C.endColumn):C.endLineNumber===P.endLineNumber?(n=C.endLineNumber,R=Math.max(C.endColumn,P.endColumn)):(n=P.endLineNumber,R=P.endColumn),new I(A,y,n,R)}intersectRanges(P){return I.intersectRanges(this,P)}static intersectRanges(P,C){let A=P.startLineNumber,y=P.startColumn,n=P.endLineNumber,R=P.endColumn,D=C.startLineNumber,b=C.startColumn,g=C.endLineNumber,s=C.endColumn;return A<D?(A=D,y=b):A===D&&(y=Math.max(y,b)),n>g?(n=g,R=s):n===g&&(R=Math.min(R,s)),A>n||A===n&&y>R?null:new I(A,y,n,R)}equalsRange(P){return I.equalsRange(this,P)}static equalsRange(P,C){return!!P&&!!C&&P.startLineNumber===C.startLineNumber&&P.startColumn===C.startColumn&&P.endLineNumber===C.endLineNumber&&P.endColumn===C.endColumn}getEndPosition(){return I.getEndPosition(this)}static getEndPosition(P){return new _.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return I.getStartPosition(this)}static getStartPosition(P){return new _.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,C){return new I(this.startLineNumber,this.startColumn,P,C)}setStartPosition(P,C){return new I(P,C,this.endLineNumber,this.endColumn)}collapseToStart(){return I.collapseToStart(this)}static collapseToStart(P){return new I(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,C=P){return new I(P.lineNumber,P.column,C.lineNumber,C.column)}static lift(P){return P?new I(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,C){return!(P.endLineNumber<C.startLineNumber||P.endLineNumber===C.startLineNumber&&P.endColumn<C.startColumn||C.endLineNumber<P.startLineNumber||C.endLineNumber===P.startLineNumber&&C.endColumn<P.startColumn)}static areIntersecting(P,C){return!(P.endLineNumber<C.startLineNumber||P.endLineNumber===C.startLineNumber&&P.endColumn<=C.startColumn||C.endLineNumber<P.startLineNumber||C.endLineNumber===P.startLineNumber&&C.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,C){if(P&&C){const n=P.startLineNumber|0,R=C.startLineNumber|0;if(n===R){const D=P.startColumn|0,b=C.startColumn|0;if(D===b){const g=P.endLineNumber|0,s=C.endLineNumber|0;if(g===s){const d=P.endColumn|0,S=C.endColumn|0;return d-S}return g-s}return D-b}return n-R}return(P?1:0)-(C?1:0)}static compareRangesUsingEnds(P,C){return P.endLineNumber===C.endLineNumber?P.endColumn===C.endColumn?P.startLineNumber===C.startLineNumber?P.startColumn-C.startColumn:P.startLineNumber-C.startLineNumber:P.endColumn-C.endColumn:P.endLineNumber-C.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}}e.Range=I}),define(ge[138],ve([0,1,49,43]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(T=e.SelectionDirection||(e.SelectionDirection={}));class P extends I.Range{constructor(A,y,n,R){super(A,y,n,R);this.selectionStartLineNumber=A,this.selectionStartColumn=y,this.positionLineNumber=n,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(A){return P.selectionsEqual(this,A)}static selectionsEqual(A,y){return A.selectionStartLineNumber===y.selectionStartLineNumber&&A.selectionStartColumn===y.selectionStartColumn&&A.positionLineNumber===y.positionLineNumber&&A.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(A,y){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,A,y):new P(A,y,this.startLineNumber,this.startColumn)}getPosition(){return new _.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(A,y){return this.getDirection()===0?new P(A,y,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,A,y)}static fromPositions(A,y=A){return new P(A.lineNumber,A.column,y.lineNumber,y.column)}static liftSelection(A){return new P(A.selectionStartLineNumber,A.selectionStartColumn,A.positionLineNumber,A.positionColumn)}static selectionsArrEqual(A,y){if(A&&!y||!A&&y)return!1;if(!A&&!y)return!0;if(A.length!==y.length)return!1;for(let n=0,R=A.length;n<R;n++)if(!this.selectionsEqual(A[n],y[n]))return!1;return!0}static isISelection(A){return A&&typeof A.selectionStartLineNumber=="number"&&typeof A.selectionStartColumn=="number"&&typeof A.positionLineNumber=="number"&&typeof A.positionColumn=="number"}static createWithDirection(A,y,n,R,D){return D===0?new P(A,y,n,R):new P(n,R,A,y)}}e.Selection=P}),define(ge[104],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var _;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(_=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class A{constructor(s){this.tabSize=Math.max(1,s.tabSize|0),this.indentSize=s.tabSize|0,this.insertSpaces=Boolean(s.insertSpaces),this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=Boolean(s.trimAutoWhitespace)}equals(s){return this.tabSize===s.tabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}e.TextModelResolvedOptions=A;class y{constructor(s,d){this.range=s,this.matches=d}}e.FindMatch=y;var n;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var R;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(R=e.ModelConstants||(e.ModelConstants={}));class D{constructor(s,d,S,v,E,m){this.identifier=s,this.range=d,this.text=S,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=E,this._isTracked=m}}e.ValidAnnotatedEditOperation=D;class b{constructor(s,d,S){this.reverseEdits=s,this.changes=d,this.trimAutoWhitespaceLineNumbers=S}}e.ApplyEditsResult=b}),define(ge[139],ve([0,1,10,137,49,43,104]),function(Q,e,_,I,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const A=999;class y{constructor(m,l,o,t){this.searchString=m,this.isRegex=l,this.matchCase=o,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let m;this.isRegex?m=n(this.searchString):m=this.searchString.indexOf(`
`)>=0;let l=null;try{l=_.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:m,global:!0,unicode:!0})}catch(t){return null}if(!l)return null;let o=!this.isRegex&&!m;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new R(l,this.wordSeparators?(0,I.getMapForWordSeparators)(this.wordSeparators):null,o?this.searchString:null)}}e.SearchParams=y;function n(E){if(!E||E.length===0)return!1;for(let m=0,l=E.length;m<l;m++)if(E.charCodeAt(m)===92){if(m++,m>=l)break;const t=E.charCodeAt(m);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=n;class R{constructor(m,l,o){this.regex=m,this.wordSeparators=l,this.simpleSearch=o}}e.SearchData=R;function D(E,m,l){if(!l)return new C.FindMatch(E,null);let o=[];for(let t=0,i=m.length;t<i;t++)o[t]=m[t];return new C.FindMatch(E,o)}e.createFindMatch=D;class b{constructor(m){let l=[],o=0;for(let t=0,i=m.length;t<i;t++)m.charCodeAt(t)===10&&(l[o++]=t);this._lineFeedsOffsets=l}findLineFeedCountBeforeOffset(m){const l=this._lineFeedsOffsets;let o=0,t=l.length-1;if(t===-1||m<=l[0])return 0;for(;o<t;){const i=o+((t-o)/2>>0);l[i]>=m?t=i-1:l[i+1]>=m?(o=i,t=i):o=i+1}return o+1}}class g{static findMatches(m,l,o,t,i){const a=l.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(m,o,new v(a.wordSeparators,a.regex),t,i):this._doFindMatchesLineByLine(m,o,a,t,i):[]}static _getMultilineMatchRange(m,l,o,t,i,a){let r,c=0;t?(c=t.findLineFeedCountBeforeOffset(i),r=l+i+c):r=l+i;let h;if(t){let f=t.findLineFeedCountBeforeOffset(i+a.length)-c;h=r+a.length+f}else h=r+a.length;const p=m.getPositionAt(r),w=m.getPositionAt(h);return new P.Range(p.lineNumber,p.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(m,l,o,t,i){const a=m.getOffsetAt(l.getStartPosition()),r=m.getValueInRange(l,1),c=m.getEOL()===`\r
`?new b(r):null,h=[];let p=0,w;for(o.reset(0);w=o.next(r);)if(h[p++]=D(this._getMultilineMatchRange(m,a,r,c,w.index,w[0]),w,t),p>=i)return h;return h}static _doFindMatchesLineByLine(m,l,o,t,i){const a=[];let r=0;if(l.startLineNumber===l.endLineNumber){const h=m.getLineContent(l.startLineNumber).substring(l.startColumn-1,l.endColumn-1);return r=this._findMatchesInLine(o,h,l.startLineNumber,l.startColumn-1,r,a,t,i),a}const c=m.getLineContent(l.startLineNumber).substring(l.startColumn-1);r=this._findMatchesInLine(o,c,l.startLineNumber,l.startColumn-1,r,a,t,i);for(let h=l.startLineNumber+1;h<l.endLineNumber&&r<i;h++)r=this._findMatchesInLine(o,m.getLineContent(h),h,0,r,a,t,i);if(r<i){const h=m.getLineContent(l.endLineNumber).substring(0,l.endColumn-1);r=this._findMatchesInLine(o,h,l.endLineNumber,0,r,a,t,i)}return a}static _findMatchesInLine(m,l,o,t,i,a,r,c){const h=m.wordSeparators;if(!r&&m.simpleSearch){const u=m.simpleSearch,f=u.length,k=l.length;let L=-f;for(;(L=l.indexOf(u,L+f))!==-1;)if((!h||S(h,l,k,L,f))&&(a[i++]=new C.FindMatch(new P.Range(o,L+1+t,o,L+1+f+t),null),i>=c))return i;return i}const p=new v(m.wordSeparators,m.regex);let w;p.reset(0);do if(w=p.next(l),w&&(a[i++]=D(new P.Range(o,w.index+1+t,o,w.index+1+w[0].length+t),w,r),i>=c))return i;while(w);return i}static findNextMatch(m,l,o,t){const i=l.parseSearchRequest();if(!i)return null;const a=new v(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(m,o,a,t):this._doFindNextMatchLineByLine(m,o,a,t)}static _doFindNextMatchMultiline(m,l,o,t){const i=new T.Position(l.lineNumber,1),a=m.getOffsetAt(i),r=m.getLineCount(),c=m.getValueInRange(new P.Range(i.lineNumber,i.column,r,m.getLineMaxColumn(r)),1),h=m.getEOL()===`\r
`?new b(c):null;o.reset(l.column-1);let p=o.next(c);return p?D(this._getMultilineMatchRange(m,a,c,h,p.index,p[0]),p,t):l.lineNumber!==1||l.column!==1?this._doFindNextMatchMultiline(m,new T.Position(1,1),o,t):null}static _doFindNextMatchLineByLine(m,l,o,t){const i=m.getLineCount(),a=l.lineNumber,r=m.getLineContent(a),c=this._findFirstMatchInLine(o,r,a,l.column,t);if(c)return c;for(let h=1;h<=i;h++){const p=(a+h-1)%i,w=m.getLineContent(p+1),u=this._findFirstMatchInLine(o,w,p+1,1,t);if(u)return u}return null}static _findFirstMatchInLine(m,l,o,t,i){m.reset(t-1);const a=m.next(l);return a?D(new P.Range(o,a.index+1,o,a.index+1+a[0].length),a,i):null}static findPreviousMatch(m,l,o,t){const i=l.parseSearchRequest();if(!i)return null;const a=new v(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(m,o,a,t):this._doFindPreviousMatchLineByLine(m,o,a,t)}static _doFindPreviousMatchMultiline(m,l,o,t){const i=this._doFindMatchesMultiline(m,new P.Range(1,1,l.lineNumber,l.column),o,t,10*A);if(i.length>0)return i[i.length-1];const a=m.getLineCount();return l.lineNumber!==a||l.column!==m.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(m,new T.Position(a,m.getLineMaxColumn(a)),o,t):null}static _doFindPreviousMatchLineByLine(m,l,o,t){const i=m.getLineCount(),a=l.lineNumber,r=m.getLineContent(a).substring(0,l.column-1),c=this._findLastMatchInLine(o,r,a,t);if(c)return c;for(let h=1;h<=i;h++){const p=(i+a-h-1)%i,w=m.getLineContent(p+1),u=this._findLastMatchInLine(o,w,p+1,t);if(u)return u}return null}static _findLastMatchInLine(m,l,o,t){let i=null,a;for(m.reset(0);a=m.next(l);)i=D(new P.Range(o,a.index+1,o,a.index+1+a[0].length),a,t);return i}}e.TextModelSearch=g;function s(E,m,l,o,t){if(o===0)return!0;const i=m.charCodeAt(o-1);if(E.get(i)!==0||i===13||i===10)return!0;if(t>0){const a=m.charCodeAt(o);if(E.get(a)!==0)return!0}return!1}function d(E,m,l,o,t){if(o+t===l)return!0;const i=m.charCodeAt(o+t);if(E.get(i)!==0||i===13||i===10)return!0;if(t>0){const a=m.charCodeAt(o+t-1);if(E.get(a)!==0)return!0}return!1}function S(E,m,l,o,t){return s(E,m,l,o,t)&&d(E,m,l,o,t)}e.isValidMatch=S;class v{constructor(m,l){this._wordSeparators=m,this._searchRegex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(m){this._searchRegex.lastIndex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(m){const l=m.length;let o;do{if(this._prevMatchStartIndex+this._prevMatchLength===l||(o=this._searchRegex.exec(m),!o))return null;const t=o.index,i=o[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){_.getNextCodePoint(m,l,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||S(this._wordSeparators,m,l,t,i))return o}while(o);return null}}e.Searcher=v}),define(ge[105],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function _(A=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const n of e.USUAL_WORD_SEPARATORS)A.indexOf(n)>=0||(y+="\\"+n);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=_();function I(A){let y=e.DEFAULT_WORD_REGEXP;if(A&&A instanceof RegExp)if(A.global)y=A;else{let n="g";A.ignoreCase&&(n+="i"),A.multiline&&(n+="m"),A.unicode&&(n+="u"),y=new RegExp(A.source,n)}return y.lastIndex=0,y}e.ensureValidWordDefinition=I;const T={maxLen:1e3,windowSize:15,timeBudget:150};function P(A,y,n,R,D=T){if(n.length>D.maxLen){let S=A-D.maxLen/2;return S<0?S=0:R+=S,n=n.substring(S,A+D.maxLen/2),P(A,y,n,R,D)}const b=Date.now(),g=A-1-R;let s=-1,d=null;for(let S=1;!(Date.now()-b>=D.timeBudget);S++){const v=g-D.windowSize*S;y.lastIndex=Math.max(0,v);const E=C(y,n,g,s);if(!E&&d||(d=E,v<=0))break;s=v}if(d){let S={word:d[0],startColumn:R+1+d.index,endColumn:R+1+d.index+d[0].length};return y.lastIndex=0,S}return null}e.getWordAtText=P;function C(A,y,n,R){let D;for(;D=A.exec(y);){const b=D.index||0;if(b<=n&&A.lastIndex>=n)return D;if(R>0&&b>R)return null}return null}}),define(ge[140],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var _;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(_=e.IndentAction||(e.IndentAction={}));class I{constructor(A){if(this.open=A.open,this.close=A.close,this._standardTokenMask=0,Array.isArray(A.notIn))for(let y=0,n=A.notIn.length;y<n;y++)switch(A.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(A){return(this._standardTokenMask&A)==0}}e.StandardAutoClosingPairConditional=I;class T{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)P(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),P(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),P(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),P(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&P(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=T;function P(C,A,y){C.has(A)?C.get(A).push(y):C.set(A,[y])}}),define(ge[76],ve([0,1,34,8]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function T(P,C,A,y){if(Array.isArray(P)){let n=0;for(const R of P){const D=T(R,C,A,y);if(D===10)return D;D>n&&(n=D)}return n}else{if(typeof P=="string")return y?P==="*"?5:P===A?10:0:0;if(P){const{language:n,pattern:R,scheme:D,hasAccessToAllModels:b}=P;if(!y&&!b)return 0;let g=0;if(D)if(D===C.scheme)g=10;else if(D==="*")g=5;else return 0;if(n)if(n===A)g=10;else if(n==="*")g=Math.max(g,5);else return 0;if(R){let s;if(typeof R=="string"?s=R:s=Object.assign(Object.assign({},R),{base:(0,I.normalize)(R.base)}),s===C.fsPath||(0,_.match)(s,C.fsPath))g=10;else return 0}return g}else return 0}}e.score=T}),define(ge[141],ve([0,1,103]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var I;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(I=e.State||(e.State={}));class T{constructor(s,d,S){const v=new Uint8Array(s*d);for(let E=0,m=s*d;E<m;E++)v[E]=S;this._data=v,this.rows=s,this.cols=d}get(s,d){return this._data[s*this.cols+d]}set(s,d,S){this._data[s*this.cols+d]=S}}e.Uint8Matrix=T;class P{constructor(s){let d=0,S=0;for(let E=0,m=s.length;E<m;E++){let[l,o,t]=s[E];o>d&&(d=o),l>S&&(S=l),t>S&&(S=t)}d++,S++;let v=new T(S,d,0);for(let E=0,m=s.length;E<m;E++){let[l,o,t]=s[E];v.set(l,o,t)}this._states=v,this._maxCharCode=d}nextState(s,d){return d<0||d>=this._maxCharCode?0:this._states.get(s,d)}}e.StateMachine=P;let C=null;function A(){return C===null&&(C=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var y;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let n=null;function R(){if(n===null){n=new _.CharacterClassifier(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<g.length;d++)n.set(g.charCodeAt(d),1);const s=".,;";for(let d=0;d<s.length;d++)n.set(s.charCodeAt(d),2)}return n}class D{static _createLink(s,d,S,v,E){let m=E-1;do{const l=d.charCodeAt(m);if(s.get(l)!==2)break;m--}while(m>v);if(v>0){const l=d.charCodeAt(v-1),o=d.charCodeAt(m);(l===40&&o===41||l===91&&o===93||l===123&&o===125)&&m--}return{range:{startLineNumber:S,startColumn:v+1,endLineNumber:S,endColumn:m+2},url:d.substring(v,m+1)}}static computeLinks(s,d=A()){const S=R();let v=[];for(let E=1,m=s.getLineCount();E<=m;E++){const l=s.getLineContent(E),o=l.length;let t=0,i=0,a=0,r=1,c=!1,h=!1,p=!1,w=!1;for(;t<o;){let u=!1;const f=l.charCodeAt(t);if(r===13){let k;switch(f){case 40:c=!0,k=0;break;case 41:k=c?0:1;break;case 91:p=!0,h=!0,k=0;break;case 93:p=!1,k=h?0:1;break;case 123:w=!0,k=0;break;case 125:k=w?0:1;break;case 39:k=a===34||a===96?0:1;break;case 34:k=a===39||a===96?0:1;break;case 96:k=a===39||a===34?0:1;break;case 42:k=a===42?1:0;break;case 124:k=a===124?1:0;break;case 32:k=p?0:1;break;default:k=S.get(f)}k===1&&(v.push(D._createLink(S,l,E,i,t)),u=!0)}else if(r===12){let k;f===91?(h=!0,k=0):k=S.get(f),k===1?u=!0:r=13}else r=d.nextState(r,f),r===0&&(u=!0);u&&(r=1,c=!1,h=!1,w=!1,i=t+1,a=f),t++}r===13&&v.push(D._createLink(S,l,E,i,o))}return v}}e.LinkComputer=D;function b(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:D.computeLinks(g)}e.computeLinks=b}),define(ge[142],ve([0,1,3,6]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class T{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(C){this._onDidChange.fire({changedLanguages:C,changedColorMap:!1})}register(C,A){return this._map.set(C,A),this.fire([C]),(0,I.toDisposable)(()=>{this._map.get(C)===A&&(this._map.delete(C),this.fire([C]))})}registerPromise(C,A){let y=null,n=!1;return this._promises.set(C,A.then(R=>{this._promises.delete(C),!(n||!R)&&(y=this.register(C,R))})),(0,I.toDisposable)(()=>{n=!0,y&&y.dispose()})}getPromise(C){const A=this.get(C);if(A)return Promise.resolve(A);const y=this._promises.get(C);return y?y.then(n=>this.get(C)):null}get(C){return this._map.get(C)||null}setColorMap(C){this._colorMap=C,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=T}),define(ge[106],ve([0,1,22,9]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var T;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(T||(T={}));function P(D){for(let b=0,g=D.length;b<g;b+=4){const s=D[b+0],d=D[b+1],S=D[b+2],v=D[b+3];D[b+0]=v,D[b+1]=S,D[b+2]=d,D[b+3]=s}}function C(D){const b=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return I.isLittleEndian()||P(b),_.VSBuffer.wrap(b)}function A(D){const b=D.buffer;if(I.isLittleEndian()||P(b),b.byteOffset%4==0)return new Uint32Array(b.buffer,b.byteOffset,b.length/4);{const g=new Uint8Array(b.byteLength);return g.set(b),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function y(D){const b=new Uint32Array(n(D));let g=0;if(b[g++]=D.id,D.type==="full")b[g++]=1,b[g++]=D.data.length,b.set(D.data,g),g+=D.data.length;else{b[g++]=2,b[g++]=D.deltas.length;for(const s of D.deltas)b[g++]=s.start,b[g++]=s.deleteCount,s.data?(b[g++]=s.data.length,b.set(s.data,g),g+=s.data.length):b[g++]=0}return C(b)}e.encodeSemanticTokensDto=y;function n(D){let b=0;if(b+=1+1,D.type==="full")b+=1+D.data.length;else{b+=1,b+=(1+1+1)*D.deltas.length;for(const g of D.deltas)g.data&&(b+=g.data.length)}return b}function R(D){const b=A(D);let g=0;const s=b[g++];if(b[g++]===1){const E=b[g++],m=b.subarray(g,g+E);return g+=E,{id:s,type:"full",data:m}}const S=b[g++];let v=[];for(let E=0;E<S;E++){const m=b[g++],l=b[g++],o=b[g++];let t;o>0&&(t=b.subarray(g,g+o),g+=o),v[E]={start:m,deleteCount:l,data:t}}return{id:s,type:"delta",deltas:v}}e.decodeSemanticTokensDto=R}),define(ge[107],ve([0,1,92]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class I{constructor(C,A){this.index=C,this.remainder=A}}e.PrefixSumIndexOfResult=I;class T{constructor(C){this.values=C,this.prefixSum=new Uint32Array(C.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(C,A){C=(0,_.toUint32)(C);const y=this.values,n=this.prefixSum,R=A.length;return R===0?!1:(this.values=new Uint32Array(y.length+R),this.values.set(y.subarray(0,C),0),this.values.set(y.subarray(C),C+R),this.values.set(A,C),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(C,A){return C=(0,_.toUint32)(C),A=(0,_.toUint32)(A),this.values[C]===A?!1:(this.values[C]=A,C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),!0)}removeValues(C,A){C=(0,_.toUint32)(C),A=(0,_.toUint32)(A);const y=this.values,n=this.prefixSum;if(C>=y.length)return!1;let R=y.length-C;return A>=R&&(A=R),A===0?!1:(this.values=new Uint32Array(y.length-A),this.values.set(y.subarray(0,C),0),this.values.set(y.subarray(C+A),C),this.prefixSum=new Uint32Array(this.values.length),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(C){return C<0?0:(C=(0,_.toUint32)(C),this._getAccumulatedValue(C))}_getAccumulatedValue(C){if(C<=this.prefixSumValidIndex[0])return this.prefixSum[C];let A=this.prefixSumValidIndex[0]+1;A===0&&(this.prefixSum[0]=this.values[0],A++),C>=this.values.length&&(C=this.values.length-1);for(let y=A;y<=C;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],C),this.prefixSum[C]}getIndexOf(C){C=Math.floor(C),this.getTotalValue();let A=0,y=this.values.length-1,n=0,R=0,D=0;for(;A<=y;)if(n=A+(y-A)/2|0,R=this.prefixSum[n],D=R-this.values[n],C<D)y=n-1;else if(C>=R)A=n+1;else break;return new I(n,C-D)}}e.PrefixSumComputer=T}),define(ge[143],ve([0,1,10,49,107]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(A,y,n,R){this._uri=A,this._lines=y,this._eol=n,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(A){A.eol&&A.eol!==this._eol&&(this._eol=A.eol,this._lineStarts=null);const y=A.changes;for(const n of y)this._acceptDeleteRange(n.range),this._acceptInsertText(new I.Position(n.range.startLineNumber,n.range.startColumn),n.text);this._versionId=A.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const A=this._eol.length,y=this._lines.length,n=new Uint32Array(y);for(let R=0;R<y;R++)n[R]=this._lines[R].length+A;this._lineStarts=new T.PrefixSumComputer(n)}}_setLineText(A,y){this._lines[A]=y,this._lineStarts&&this._lineStarts.changeValue(A,this._lines[A].length+this._eol.length)}_acceptDeleteRange(A){if(A.startLineNumber===A.endLineNumber){if(A.startColumn===A.endColumn)return;this._setLineText(A.startLineNumber-1,this._lines[A.startLineNumber-1].substring(0,A.startColumn-1)+this._lines[A.startLineNumber-1].substring(A.endColumn-1));return}this._setLineText(A.startLineNumber-1,this._lines[A.startLineNumber-1].substring(0,A.startColumn-1)+this._lines[A.endLineNumber-1].substring(A.endColumn-1)),this._lines.splice(A.startLineNumber,A.endLineNumber-A.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(A.startLineNumber,A.endLineNumber-A.startLineNumber)}_acceptInsertText(A,y){if(y.length!==0){let n=(0,_.splitLines)(y);if(n.length===1){this._setLineText(A.lineNumber-1,this._lines[A.lineNumber-1].substring(0,A.column-1)+n[0]+this._lines[A.lineNumber-1].substring(A.column-1));return}n[n.length-1]+=this._lines[A.lineNumber-1].substring(A.column-1),this._setLineText(A.lineNumber-1,this._lines[A.lineNumber-1].substring(0,A.column-1)+n[0]);let R=new Uint32Array(n.length-1);for(let D=1;D<n.length;D++)this._lines.splice(A.lineNumber+D-1,0,n[D]),R[D-1]=n[D].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(A.lineNumber,R)}}}e.MirrorTextModel=P}),define(ge[144],ve([16,17]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ge[145],ve([0,1,144]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,T=I*60,P=T*24,C=P*7,A=P*30,y=P*365;function n(D,b){typeof D!="number"&&(D=D.getTime());const g=Math.round((new Date().getTime()-D)/1e3);if(g<-30)return(0,_.localize)(0,null,n(new Date().getTime()+g*1e3,!1));if(g<30)return(0,_.localize)(1,null);let s;return g<I?(s=g,b?s===1?(0,_.localize)(2,null,s):(0,_.localize)(3,null,s):s===1?(0,_.localize)(4,null,s):(0,_.localize)(5,null,s)):g<T?(s=Math.floor(g/I),b?s===1?(0,_.localize)(6,null,s):(0,_.localize)(7,null,s):s===1?(0,_.localize)(8,null,s):(0,_.localize)(9,null,s)):g<P?(s=Math.floor(g/T),b?s===1?(0,_.localize)(10,null,s):(0,_.localize)(11,null,s):s===1?(0,_.localize)(12,null,s):(0,_.localize)(13,null,s)):g<C?(s=Math.floor(g/P),b?s===1?(0,_.localize)(14,null,s):(0,_.localize)(15,null,s):s===1?(0,_.localize)(16,null,s):(0,_.localize)(17,null,s)):g<A?(s=Math.floor(g/C),b?s===1?(0,_.localize)(18,null,s):(0,_.localize)(19,null,s):s===1?(0,_.localize)(20,null,s):(0,_.localize)(21,null,s)):g<y?(s=Math.floor(g/A),b?s===1?(0,_.localize)(22,null,s):(0,_.localize)(23,null,s):s===1?(0,_.localize)(24,null,s):(0,_.localize)(25,null,s)):(s=Math.floor(g/y),b?s===1?(0,_.localize)(26,null,s):(0,_.localize)(27,null,s):s===1?(0,_.localize)(28,null,s):(0,_.localize)(29,null,s))}e.fromNow=n;function R(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(ge[146],ve([16,17]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ge[58],ve([0,1,146,15,14]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(n,R){return R&&(n.stack||n.stacktrace)?_.localize(0,null,A(n),C(n.stack)||C(n.stacktrace)):A(n)}function C(n){return Array.isArray(n)?n.join(`
`):n}function A(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?_.localize(1,null,n.message):n.message||_.localize(2,null)}function y(n=null,R=!1){if(!n)return _.localize(3,null);if(Array.isArray(n)){const D=T.coalesce(n),b=y(D[0],R);return D.length>1?_.localize(4,null,b,D.length):b}if(I.isString(n))return n;if(n.detail){const D=n.detail;if(D.error)return P(D.error,R);if(D.exception)return P(D.exception,R)}return n.stack?P(n,R):n.message?n.message:_.localize(5,null)}e.toErrorMessage=y}),define(ge[147],ve([16,17]),function(Q,e){return Q.create("vs/base/node/processes",e)}),define(ge[77],ve([0,1,8,37,26,38,147,30,15,23,31,9,136,11]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function s(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(o,t){if(D.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};t&&(i.cwd=t);const a=P.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],i);return new Promise(r=>{a.once("error",c=>{r({success:!1,error:c})}),a.once("exit",(c,h)=>{r(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?s(i.status):1})}else if(D.isLinux||D.isMacintosh)try{const i=g.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Q).fsPath;return new Promise(a=>{P.execFile(i,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,c,h)=>{a(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function S(o=A.env){return o.comspec||"cmd.exe"}e.getWindowsShell=S;class v{constructor(t,i,a,r){if(i!==void 0&&a!==void 0&&r!==void 0)this.cmd=t,this.args=i,this.shell=a,this.options=r;else{const c=t;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(A.env).forEach(h=>{c[h]=A.env[h]}),Object.keys(this.options.env).forEach(h=>{c[h]=this.options.env[h]}),this.options.env=c}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const i=t.lastIndexOf(_.sep);return i!==-1&&(t=t.substring(i+1)),v.WellKnowCommands[t]?t:"other"}start(t){return D.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(A.cwd()))?Promise.reject(new Error(C.localize(0,null))):this.useExec().then(i=>{let a,r;const c=new Promise((h,p)=>{a=h,r=p});if(i){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=P.exec(h,this.options,(p,w,u)=>{this.childProcess=null;const f=p;f&&f.killed?r({killed:this.terminateRequested,stdout:w.toString(),stderr:u.toString()}):this.handleExec(a,t,p,w,u)})}else{let h=null;const p=w=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(w,a,t,r);const u={terminated:this.terminateRequested};y.isNumber(w)&&(u.cmdCode=w),a(u)};if(this.shell&&D.isWindows){const w=n.deepClone(this.options);w.windowsVerbatimArguments=!0,w.detached=!1;let u=!1,f=!1;const k=[];let L=this.ensureQuotes(this.cmd);k.push(L.value),u=L.quoted,this.args&&this.args.forEach(te=>{L=this.ensureQuotes(te),k.push(L.value),f=f&&L.quoted});const $=["/s","/c"];u?f?$.push('"'+k.join(" ")+'"'):k.length>1?$.push('"'+k[0]+'" '+k.slice(1).join(" ")):$.push('"'+k[0]+'"'):$.push(k.join(" ")),h=P.spawn(S(),$,w)}else this.cmd&&(h=P.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(y.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",w=>{this.childProcess=null,r({terminated:this.terminateRequested,error:w})}),h.pid&&(this.childProcess.on("close",p),this.handleSpawn(h,a,t,r,!0)))}return c})}handleClose(t,i,a,r){}ensureQuotes(t){return v.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,d(t,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!D.isWindows)return t(!1);const i=P.spawn(S(),["/s","/c"]);i.on("error",a=>t(!0)),i.on("exit",a=>t(!1))})}}e.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class E extends v{constructor(t,i,a,r){super(t,i,a,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,i,a,r,c){[r,c].forEach((h,p)=>{const w=new b.LineDecoder;w.write(h).forEach(k=>{i({line:k,source:p===0?0:1})});const f=w.end();f&&i({line:f,source:p===0?0:1})}),t({terminated:this.terminateRequested,error:a})}handleSpawn(t,i,a,r,c){const h=new b.LineDecoder,p=new b.LineDecoder;t.stdout.on("data",w=>{h.write(w).forEach(f=>a({line:f,source:0}))}),t.stderr.on("data",w=>{p.write(w).forEach(f=>a({line:f,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=p}handleClose(t,i,a,r){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&a({line:c,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&a({line:h,source:1})}}e.LineProcess=E;function m(o){let t=[],i=!1;const a=function(r){if(i){t.push(r);return}(!o.send(r,h=>{if(h&&console.error(h),i=!1,t.length>0){const p=t.slice(0);t=[],p.forEach(w=>a(w))}})||D.isWindows)&&(i=!0)};return{send:a}}e.createQueuedSender=m;var l;(function(o){async function t(i,a,r){if(_.isAbsolute(i))return i;if(a===void 0&&(a=A.cwd()),_.dirname(i)!=="."||(r===void 0&&y.isString(A.env.PATH)&&(r=A.env.PATH.split(_.delimiter)),r===void 0||r.length===0))return _.join(a,i);async function h(p){return await T.exists(p)?!(await I.promises.stat(p)).isDirectory():!1}for(let p of r){let w;if(_.isAbsolute(p)?w=_.join(p,i):w=_.join(a,p,i),await h(w))return w;let u=w+".com";if(await h(u)||(u=w+".exe",await h(u)))return u}return _.join(a,i)}o.findExecutable=t})(l=e.win32||(e.win32={}))}),define(ge[148],ve([0,1,48,9,100,77]),function(Q,e,_,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function C(g,s){return g===3?I.isWindows?D():P.getWindowsShell(s):n(g,s)}e.getSystemShell=C;function A(g,s){return g===3?I.isWindows?b(s):P.getWindowsShell(s):n(g,s)}e.getSystemShellSync=A;let y=null;function n(g,s){if(I.isLinux&&g===1||I.isMacintosh&&g===2)return"/bin/bash";if(!y){let d;if(I.isWindows)d="/bin/bash";else{if(d=s.SHELL,!d)try{d=_.userInfo().shell}catch(S){}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}y=d}return y}let R=null;async function D(){return R||(R=(await(0,T.getFirstAvailablePowerShellInstallation)()).exePath),R}function b(g){if(R)return R;const s=I.isWindows&&parseFloat(_.release())>=10,d=g.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${g.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return s?S:P.getWindowsShell(g)}}),define(ge[149],ve([16,17]),function(Q,e){return Q.create("vs/editor/common/config/editorOptions",e)}),define(ge[150],ve([0,1,149,9,105]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var P;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(P=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(re){this._values=re}hasChanged(re){return this._values[re]}}e.ConfigurationChangedEvent=C;class A{constructor(){this._values=[]}_read(re){return this._values[re]}get(re){return this._values[re]}_write(re,Ee){this._values[re]=Ee}}e.ValidatedEditorOptions=A;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class n{constructor(re,Ee,Ne,Ve){this.id=re,this.name=Ee,this.defaultValue=Ne,this.schema=Ve}compute(re,Ee,Ne){return Ne}}class R{constructor(re,Ee=null){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0,this.deps=Ee}validate(re){return this.defaultValue}}class D{constructor(re,Ee,Ne,Ve){this.id=re,this.name=Ee,this.defaultValue=Ne,this.schema=Ve}validate(re){return typeof re=="undefined"?this.defaultValue:re}compute(re,Ee,Ne){return Ne}}function b(G,re){return typeof G=="undefined"?re:G==="false"?!1:Boolean(G)}e.boolean=b;class g extends D{constructor(re,Ee,Ne,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="boolean",Ve.default=Ne),super(re,Ee,Ne,Ve)}validate(re){return b(re,this.defaultValue)}}class s extends D{constructor(re,Ee,Ne,Ve,Be,et=void 0){typeof et!="undefined"&&(et.type="integer",et.default=Ne,et.minimum=Ve,et.maximum=Be),super(re,Ee,Ne,et),this.minimum=Ve,this.maximum=Be}static clampedInt(re,Ee,Ne,Ve){if(typeof re=="undefined")return Ee;let Be=parseInt(re,10);return isNaN(Be)?Ee:(Be=Math.max(Ne,Be),Be=Math.min(Ve,Be),Be|0)}validate(re){return s.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}class d extends D{constructor(re,Ee,Ne,Ve,Be){typeof Be!="undefined"&&(Be.type="number",Be.default=Ne),super(re,Ee,Ne,Be),this.validationFn=Ve}static clamp(re,Ee,Ne){return re<Ee?Ee:re>Ne?Ne:re}static float(re,Ee){if(typeof re=="number")return re;if(typeof re=="undefined")return Ee;const Ne=parseFloat(re);return isNaN(Ne)?Ee:Ne}validate(re){return this.validationFn(d.float(re,this.defaultValue))}}class S extends D{static string(re,Ee){return typeof re!="string"?Ee:re}constructor(re,Ee,Ne,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.default=Ne),super(re,Ee,Ne,Ve)}validate(re){return S.string(re,this.defaultValue)}}function v(G,re,Ee){return typeof G!="string"||Ee.indexOf(G)===-1?re:G}e.stringSet=v;class E extends D{constructor(re,Ee,Ne,Ve,Be=void 0){typeof Be!="undefined"&&(Be.type="string",Be.enum=Ve,Be.default=Ne),super(re,Ee,Ne,Be),this._allowedValues=Ve}validate(re){return v(re,this.defaultValue,this._allowedValues)}}class m extends n{constructor(re,Ee,Ne,Ve,Be,et,K=void 0){typeof K!="undefined"&&(K.type="string",K.enum=Be,K.default=Ve),super(re,Ee,Ne,K),this._allowedValues=Be,this._convert=et}validate(re){return typeof re!="string"?this.defaultValue:this._allowedValues.indexOf(re)===-1?this.defaultValue:this._convert(re)}}function l(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[_.localize(0,null),_.localize(1,null),_.localize(2,null)],default:"auto",description:_.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,Ee,Ne){return Ne===0?re.accessibilitySupport:Ne}}class t extends n{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:_.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:_.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ee=re;return{insertSpace:b(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:b(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function a(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function c(G){switch(G){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=c;function h(G){switch(G){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class p extends R{constructor(){super(123,[62,31])}compute(re,Ee,Ne){const Ve=["monaco-editor"];return Ee.get(31)&&Ve.push(Ee.get(31)),re.extraEditorClassName&&Ve.push(re.extraEditorClassName),Ee.get(62)==="default"?Ve.push("mouse-default"):Ee.get(62)==="copy"&&Ve.push("mouse-copy"),Ee.get(97)&&Ve.push("showUnused"),Ee.get(121)&&Ve.push("showDeprecated"),Ve.join(" ")}}class w extends g{constructor(){super(30,"emptySelectionClipboard",!0,{description:_.localize(6,null)})}compute(re,Ee,Ne){return Ne&&re.emptySelectionClipboard}}class u extends n{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:_.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:re.seedSearchStringFromSelection,description:_.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[_.localize(9,null),_.localize(10,null),_.localize(11,null)],description:_.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:_.localize(13,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:_.localize(14,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:_.localize(15,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ee=re;return{cursorMoveOnType:b(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:b(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":v(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:b(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:b(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:b(Ee.loop,this.defaultValue.loop)}}}class f extends n{constructor(){super(41,"fontLigatures",f.OFF,{anyOf:[{type:"boolean",description:_.localize(16,null)},{type:"string",description:_.localize(17,null)}],description:_.localize(18,null),default:!1})}validate(re){return typeof re=="undefined"?this.defaultValue:typeof re=="string"?re==="false"?f.OFF:re==="true"?f.ON:re:Boolean(re)?f.ON:f.OFF}}e.EditorFontLigatures=f,f.OFF='"liga" off, "calt" off',f.ON='"liga" on, "calt" on';class k extends R{constructor(){super(40)}compute(re,Ee,Ne){return re.fontInfo}}class L extends D{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:_.localize(19,null)})}validate(re){let Ee=d.float(re,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(Ee,6,100)}compute(re,Ee,Ne){return re.fontInfo.fontSize}}class $ extends n{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.MINIMUM_VALUE,maximum:$.MAXIMUM_VALUE,errorMessage:_.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:_.localize(21,null)})}validate(re){return re==="normal"||re==="bold"?re:String(s.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,$.MINIMUM_VALUE,$.MAXIMUM_VALUE))}}$.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],$.MINIMUM_VALUE=1,$.MAXIMUM_VALUE=1e3;class te extends n{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[_.localize(22,null),_.localize(23,null),_.localize(24,null)]};super(47,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:_.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:_.localize(26,null)},Ee),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:_.localize(27,null)},Ee),"editor.gotoLocation.multipleDeclarations":Object.assign({description:_.localize(28,null)},Ee),"editor.gotoLocation.multipleImplementations":Object.assign({description:_.localize(29,null)},Ee),"editor.gotoLocation.multipleReferences":Object.assign({description:_.localize(30,null)},Ee),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,description:_.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,description:_.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,description:_.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,description:_.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,description:_.localize(35,null)}})}validate(re){var Ee,Ne,Ve,Be,et;if(!re||typeof re!="object")return this.defaultValue;const K=re;return{multiple:v(K.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(Ee=K.multipleDefinitions)!==null&&Ee!==void 0?Ee:v(K.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ne=K.multipleTypeDefinitions)!==null&&Ne!==void 0?Ne:v(K.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Ve=K.multipleDeclarations)!==null&&Ve!==void 0?Ve:v(K.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Be=K.multipleImplementations)!==null&&Be!==void 0?Be:v(K.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(et=K.multipleReferences)!==null&&et!==void 0?et:v(K.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(K.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(K.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(K.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(K.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(K.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class H extends n{constructor(){const re={enabled:!0,delay:300,sticky:!0};super(50,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:_.localize(36,null)},"editor.hover.delay":{type:"number",default:re.delay,description:_.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:_.localize(38,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ee=re;return{enabled:b(Ee.enabled,this.defaultValue.enabled),delay:s.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:b(Ee.sticky,this.defaultValue.sticky)}}}var x;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class B extends R{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(re,Ee,Ne){return B.computeLayout(Ee,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio})}static computeContainedMinimapLineCount(re){const Ee=re.height/re.lineHeight,Ne=re.scrollBeyondLastLine?Ee-1:0,Ve=(re.viewLineCount+Ne)/(re.pixelRatio*re.height),Be=Math.floor(re.viewLineCount/Ve);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:Ne,desiredRatio:Ve,minimapLineCount:Be}}static _computeMinimapLayout(re,Ee){const Ne=re.outerWidth,Ve=re.outerHeight,Be=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Be*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const et=Ee.stableMinimapLayoutInput,K=et&&re.outerHeight===et.outerHeight&&re.lineHeight===et.lineHeight&&re.typicalHalfwidthCharacterWidth===et.typicalHalfwidthCharacterWidth&&re.pixelRatio===et.pixelRatio&&re.scrollBeyondLastLine===et.scrollBeyondLastLine&&re.minimap.enabled===et.minimap.enabled&&re.minimap.side===et.minimap.side&&re.minimap.size===et.minimap.size&&re.minimap.showSlider===et.minimap.showSlider&&re.minimap.renderCharacters===et.minimap.renderCharacters&&re.minimap.maxColumn===et.minimap.maxColumn&&re.minimap.scale===et.minimap.scale&&re.verticalScrollbarWidth===et.verticalScrollbarWidth&&re.isViewportWrapping===et.isViewportWrapping,oe=re.lineHeight,he=re.typicalHalfwidthCharacterWidth,Z=re.scrollBeyondLastLine,ne=re.minimap.renderCharacters;let le=Be>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const pe=re.minimap.maxColumn,_e=re.minimap.size,He=re.minimap.side,We=re.verticalScrollbarWidth,qe=re.viewLineCount,Ye=re.remainingWidth,Ze=re.isViewportWrapping,ut=ne?2:3;let ot=Math.floor(Be*Ve);const nt=ot/Be;let ue=!1,Ce=!1,ce=ut*le,J=le/Be,Re=1;if(_e==="fill"||_e==="fit"){const{typicalViewportLineCount:ct,extraLinesBeyondLastLine:st,desiredRatio:gt,minimapLineCount:Et}=B.computeContainedMinimapLineCount({viewLineCount:qe,scrollBeyondLastLine:Z,height:Ve,lineHeight:oe,pixelRatio:Be});if(qe/Et>1)ue=!0,Ce=!0,le=1,ce=1,J=le/Be;else{let wt=!1,St=le+1;if(_e==="fit"){const pt=Math.ceil((qe+st)*ce);Ze&&K&&Ye<=Ee.stableFitRemainingWidth?(wt=!0,St=Ee.stableFitMaxMinimapScale):(wt=pt>ot,Ze&&wt?(Ee.stableMinimapLayoutInput=re,Ee.stableFitRemainingWidth=Ye):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0))}if(_e==="fill"||wt){ue=!0;const pt=le;ce=Math.min(oe*Be,Math.max(1,Math.floor(1/gt))),le=Math.min(St,Math.max(1,Math.floor(ce/ut))),le>pt&&(Re=Math.min(2,le/pt)),J=le/Be/Re,ot=Math.ceil(Math.max(ct,qe+st)*ce),Ze&&wt&&(Ee.stableFitMaxMinimapScale=le)}}}const Le=Math.floor(pe*J),Je=Math.min(Le,Math.max(0,Math.floor((Ye-We-2)*J/(he+J)))+e.MINIMAP_GUTTER_WIDTH);let Ge=Math.floor(Be*Je);const rt=Ge/Be;Ge=Math.floor(Ge*Re);const at=ne?1:2,Qe=He==="left"?0:Ne-Je-We;return{renderMinimap:at,minimapLeft:Qe,minimapWidth:Je,minimapHeightIsEditorHeight:ue,minimapIsSampling:Ce,minimapScale:le,minimapLineHeight:ce,minimapCanvasInnerWidth:Ge,minimapCanvasInnerHeight:ot,minimapCanvasOuterWidth:rt,minimapCanvasOuterHeight:nt}}static computeLayout(re,Ee){const Ne=Ee.outerWidth|0,Ve=Ee.outerHeight|0,Be=Ee.lineHeight|0,et=Ee.lineNumbersDigitCount|0,K=Ee.typicalHalfwidthCharacterWidth,oe=Ee.maxDigitWidth,he=Ee.pixelRatio,Z=Ee.viewLineCount,ne=re.get(118),le=ne==="inherit"?re.get(117):ne,pe=le==="inherit"?re.get(113):le,_e=re.get(116),He=re.get(2),We=Ee.isDominatedByLongLines,qe=re.get(46),Ye=re.get(56).renderType!==0,Ze=re.get(57),ut=re.get(91),ot=re.get(61),nt=re.get(89),ue=nt.verticalScrollbarSize,Ce=nt.verticalHasArrows,ce=nt.arrowSize,J=nt.horizontalScrollbarSize,Re=re.get(54),Le=re.get(35);let Je;if(typeof Re=="string"&&/^\d+(\.\d+)?ch$/.test(Re)){const ft=parseFloat(Re.substr(0,Re.length-2));Je=s.clampedInt(ft*K,0,0,1e3)}else Je=s.clampedInt(Re,0,0,1e3);Le&&(Je+=16);let Ge=0;if(Ye){const ft=Math.max(et,Ze);Ge=Math.round(ft*oe)}let rt=0;qe&&(rt=Be);let at=0,Qe=at+rt,ct=Qe+Ge,st=ct+Je;const gt=Ne-rt-Ge-Je;let Et=!1,Dt=!1,wt=-1;He!==2&&(le==="inherit"&&We?(Et=!0,Dt=!0):pe==="on"||pe==="bounded"?Dt=!0:pe==="wordWrapColumn"&&(wt=_e));const St=B._computeMinimapLayout({outerWidth:Ne,outerHeight:Ve,lineHeight:Be,typicalHalfwidthCharacterWidth:K,pixelRatio:he,scrollBeyondLastLine:ut,minimap:ot,verticalScrollbarWidth:ue,viewLineCount:Z,remainingWidth:gt,isViewportWrapping:Dt},Ee.memory||new y);St.renderMinimap!==0&&St.minimapLeft===0&&(at+=St.minimapWidth,Qe+=St.minimapWidth,ct+=St.minimapWidth,st+=St.minimapWidth);const pt=gt-St.minimapWidth,Lt=Math.max(1,Math.floor((pt-ue-2)/K)),Ft=Ce?ce:0;return Dt&&(wt=Math.max(1,Lt),pe==="bounded"&&(wt=Math.min(wt,_e))),{width:Ne,height:Ve,glyphMarginLeft:at,glyphMarginWidth:rt,lineNumbersLeft:Qe,lineNumbersWidth:Ge,decorationsLeft:ct,decorationsWidth:Je,contentLeft:st,contentWidth:pt,minimap:St,viewportColumn:Lt,isWordWrapMinified:Et,isViewportWrapping:Dt,wrappingColumn:wt,verticalScrollbarWidth:ue,horizontalScrollbarHeight:J,overviewRuler:{top:Ft,width:ue,height:Ve-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=B;class F extends n{constructor(){const re={enabled:!0};super(53,"lightbulb",re,{"editor.lightbulb.enabled":{type:"boolean",default:re.enabled,description:_.localize(39,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:b(re.enabled,this.defaultValue.enabled)}}}class U extends n{constructor(){const re={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",re,{"editor.inlineHints.enabled":{type:"boolean",default:re.enabled,description:_.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:re.fontSize,description:_.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:re.fontFamily,description:_.localize(42,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ee=re;return{enabled:b(Ee.enabled,this.defaultValue.enabled),fontSize:s.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class M extends s{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:_.localize(43,null)})}compute(re,Ee,Ne){return re.fontInfo.lineHeight}}class N extends n{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:_.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[_.localize(45,null),_.localize(46,null),_.localize(47,null)],default:re.size,description:_.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:_.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:_.localize(50,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:_.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:_.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:_.localize(53,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ee=re;return{enabled:b(Ee.enabled,this.defaultValue.enabled),size:v(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(Ee.side,this.defaultValue.side,["right","left"]),showSlider:v(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:b(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:s.clampedInt(Ee.scale,1,1,3),maxColumn:s.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(G){return G==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class j extends n{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(55,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ee=re;return{top:s.clampedInt(Ee.top,0,0,1e3),bottom:s.clampedInt(Ee.bottom,0,0,1e3)}}}class q extends n{constructor(){const re={enabled:!0,cycle:!1};super(72,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:_.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:_.localize(57,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ee=re;return{enabled:b(Ee.enabled,this.defaultValue.enabled),cycle:b(Ee.cycle,this.defaultValue.cycle)}}}class X extends R{constructor(){super(124)}compute(re,Ee,Ne){return re.pixelRatio}}class me extends n{constructor(){const re={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",re,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:re.strings,description:_.localize(58,null)},comments:{type:"boolean",default:re.comments,description:_.localize(59,null)},other:{type:"boolean",default:re.other,description:_.localize(60,null)}}}],default:re,description:_.localize(61,null)});this.defaultValue=re}validate(re){if(typeof re=="boolean")return re;if(re&&typeof re=="object"){const Ee=re,Ne={other:b(Ee.other,this.defaultValue.other),comments:b(Ee.comments,this.defaultValue.comments),strings:b(Ee.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var we;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(we=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ae extends n{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[_.localize(62,null),_.localize(63,null),_.localize(64,null),_.localize(65,null)],default:"on",description:_.localize(66,null)})}validate(re){let Ee=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof re!="undefined"&&(typeof re=="function"?(Ee=4,Ne=re):re==="interval"?Ee=3:re==="relative"?Ee=2:re==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Ne}}}function Ie(G){const re=G.get(84);return re==="editable"?G.get(77):re!=="on"}e.filterValidationDecorations=Ie;class Me extends n{constructor(){const re=[],Ee={type:"number",description:_.localize(67,null)};super(88,"rulers",re,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:_.localize(68,null),format:"color-hex"}}}]},default:re,description:_.localize(69,null)})}validate(re){if(Array.isArray(re)){let Ee=[];for(let Ne of re)if(typeof Ne=="number")Ee.push({column:s.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const Ve=Ne;Ee.push({column:s.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return Ee.sort((Ne,Ve)=>Ne.column-Ve.column),Ee}return this.defaultValue}}function V(G,re){if(typeof G!="string")return re;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class Y extends n{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ee=re,Ne=s.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=s.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:s.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:V(Ee.vertical,this.defaultValue.vertical),horizontal:V(Ee.horizontal,this.defaultValue.horizontal),useShadows:b(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:b(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:b(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:b(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:b(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:s.clampedInt(Ee.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:s.clampedInt(Ee.verticalSliderSize,Ve,0,1e3),scrollByPage:b(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}class ee extends n{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[_.localize(70,null),_.localize(71,null)],default:re.insertMode,description:_.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:_.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:_.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:_.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:_.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:_.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:_.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:_.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:_.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:_.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:_.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:_.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:_.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:_.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:_.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:_.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:_.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:_.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:_.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:_.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:_.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:_.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:_.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:_.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:_.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:_.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:_.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:_.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:_.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:_.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:_.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:_.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:_.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:_.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:_.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:_.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:_.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:_.localize(109,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Ee=re;return{insertMode:v(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:b(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:b(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:b(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:b(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:b(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:b(Ee.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:b(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:b(Ee.showMethods,this.defaultValue.showMethods),showFunctions:b(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:b(Ee.showConstructors,this.defaultValue.showConstructors),showFields:b(Ee.showFields,this.defaultValue.showFields),showVariables:b(Ee.showVariables,this.defaultValue.showVariables),showClasses:b(Ee.showClasses,this.defaultValue.showClasses),showStructs:b(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:b(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:b(Ee.showModules,this.defaultValue.showModules),showProperties:b(Ee.showProperties,this.defaultValue.showProperties),showEvents:b(Ee.showEvents,this.defaultValue.showEvents),showOperators:b(Ee.showOperators,this.defaultValue.showOperators),showUnits:b(Ee.showUnits,this.defaultValue.showUnits),showValues:b(Ee.showValues,this.defaultValue.showValues),showConstants:b(Ee.showConstants,this.defaultValue.showConstants),showEnums:b(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:b(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:b(Ee.showKeywords,this.defaultValue.showKeywords),showWords:b(Ee.showWords,this.defaultValue.showWords),showColors:b(Ee.showColors,this.defaultValue.showColors),showFiles:b(Ee.showFiles,this.defaultValue.showFiles),showReferences:b(Ee.showReferences,this.defaultValue.showReferences),showFolders:b(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:b(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:b(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:b(Ee.showUsers,this.defaultValue.showUsers),showIssues:b(Ee.showIssues,this.defaultValue.showIssues)}}}class ae extends n{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:_.localize(110,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:b(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class fe extends R{constructor(){super(125,[77])}compute(re,Ee,Ne){return Ee.get(77)?!0:re.tabFocusMode}}var De;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Oe(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class be extends R{constructor(){super(127,[126])}compute(re,Ee,Ne){const Ve=Ee.get(126);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}const ke="Consolas, 'Courier New', monospace",Te="Menlo, Monaco, 'Courier New', monospace",xe="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Te:I.isLinux?xe:ke,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Se(G){return e.editorOptionsRegistry[G.id]=G,G}var Ke;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.codeLens=12]="codeLens",G[G.codeLensFontFamily=13]="codeLensFontFamily",G[G.codeLensFontSize=14]="codeLensFontSize",G[G.colorDecorators=15]="colorDecorators",G[G.columnSelection=16]="columnSelection",G[G.comments=17]="comments",G[G.contextmenu=18]="contextmenu",G[G.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",G[G.cursorBlinking=20]="cursorBlinking",G[G.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",G[G.cursorStyle=22]="cursorStyle",G[G.cursorSurroundingLines=23]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",G[G.cursorWidth=25]="cursorWidth",G[G.disableLayerHinting=26]="disableLayerHinting",G[G.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",G[G.domReadOnly=28]="domReadOnly",G[G.dragAndDrop=29]="dragAndDrop",G[G.emptySelectionClipboard=30]="emptySelectionClipboard",G[G.extraEditorClassName=31]="extraEditorClassName",G[G.fastScrollSensitivity=32]="fastScrollSensitivity",G[G.find=33]="find",G[G.fixedOverflowWidgets=34]="fixedOverflowWidgets",G[G.folding=35]="folding",G[G.foldingStrategy=36]="foldingStrategy",G[G.foldingHighlight=37]="foldingHighlight",G[G.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=39]="fontFamily",G[G.fontInfo=40]="fontInfo",G[G.fontLigatures=41]="fontLigatures",G[G.fontSize=42]="fontSize",G[G.fontWeight=43]="fontWeight",G[G.formatOnPaste=44]="formatOnPaste",G[G.formatOnType=45]="formatOnType",G[G.glyphMargin=46]="glyphMargin",G[G.gotoLocation=47]="gotoLocation",G[G.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",G[G.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",G[G.hover=50]="hover",G[G.inDiffEditor=51]="inDiffEditor",G[G.letterSpacing=52]="letterSpacing",G[G.lightbulb=53]="lightbulb",G[G.lineDecorationsWidth=54]="lineDecorationsWidth",G[G.lineHeight=55]="lineHeight",G[G.lineNumbers=56]="lineNumbers",G[G.lineNumbersMinChars=57]="lineNumbersMinChars",G[G.linkedEditing=58]="linkedEditing",G[G.links=59]="links",G[G.matchBrackets=60]="matchBrackets",G[G.minimap=61]="minimap",G[G.mouseStyle=62]="mouseStyle",G[G.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=64]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",G[G.multiCursorModifier=66]="multiCursorModifier",G[G.multiCursorPaste=67]="multiCursorPaste",G[G.occurrencesHighlight=68]="occurrencesHighlight",G[G.overviewRulerBorder=69]="overviewRulerBorder",G[G.overviewRulerLanes=70]="overviewRulerLanes",G[G.padding=71]="padding",G[G.parameterHints=72]="parameterHints",G[G.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",G[G.quickSuggestions=75]="quickSuggestions",G[G.quickSuggestionsDelay=76]="quickSuggestionsDelay",G[G.readOnly=77]="readOnly",G[G.renameOnType=78]="renameOnType",G[G.renderControlCharacters=79]="renderControlCharacters",G[G.renderIndentGuides=80]="renderIndentGuides",G[G.renderFinalNewline=81]="renderFinalNewline",G[G.renderLineHighlight=82]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=84]="renderValidationDecorations",G[G.renderWhitespace=85]="renderWhitespace",G[G.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",G[G.roundedSelection=87]="roundedSelection",G[G.rulers=88]="rulers",G[G.scrollbar=89]="scrollbar",G[G.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=91]="scrollBeyondLastLine",G[G.scrollPredominantAxis=92]="scrollPredominantAxis",G[G.selectionClipboard=93]="selectionClipboard",G[G.selectionHighlight=94]="selectionHighlight",G[G.selectOnLineNumbers=95]="selectOnLineNumbers",G[G.showFoldingControls=96]="showFoldingControls",G[G.showUnused=97]="showUnused",G[G.snippetSuggestions=98]="snippetSuggestions",G[G.smartSelect=99]="smartSelect",G[G.smoothScrolling=100]="smoothScrolling",G[G.stickyTabStops=101]="stickyTabStops",G[G.stopRenderingLineAfter=102]="stopRenderingLineAfter",G[G.suggest=103]="suggest",G[G.suggestFontSize=104]="suggestFontSize",G[G.suggestLineHeight=105]="suggestLineHeight",G[G.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",G[G.suggestSelection=107]="suggestSelection",G[G.tabCompletion=108]="tabCompletion",G[G.tabIndex=109]="tabIndex",G[G.unusualLineTerminators=110]="unusualLineTerminators",G[G.useTabStops=111]="useTabStops",G[G.wordSeparators=112]="wordSeparators",G[G.wordWrap=113]="wordWrap",G[G.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=116]="wordWrapColumn",G[G.wordWrapOverride1=117]="wordWrapOverride1",G[G.wordWrapOverride2=118]="wordWrapOverride2",G[G.wrappingIndent=119]="wrappingIndent",G[G.wrappingStrategy=120]="wrappingStrategy",G[G.showDeprecated=121]="showDeprecated",G[G.inlineHints=122]="inlineHints",G[G.editorClassName=123]="editorClassName",G[G.pixelRatio=124]="pixelRatio",G[G.tabFocusMode=125]="tabFocusMode",G[G.layoutInfo=126]="layoutInfo",G[G.wrappingInfo=127]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Se(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:_.localize(111,null)})),acceptSuggestionOnEnter:Se(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",_.localize(112,null),""],markdownDescription:_.localize(113,null)})),accessibilitySupport:Se(new o),accessibilityPageSize:Se(new s(3,"accessibilityPageSize",10,1,1073741824,{description:_.localize(114,null),deprecationMessage:_.localize(115,null)})),ariaLabel:Se(new S(4,"ariaLabel",_.localize(116,null))),autoClosingBrackets:Se(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(117,null),_.localize(118,null),""],description:_.localize(119,null)})),autoClosingDelete:Se(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",_.localize(120,null),""],description:_.localize(121,null)})),autoClosingOvertype:Se(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",_.localize(122,null),""],description:_.localize(123,null)})),autoClosingQuotes:Se(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(124,null),_.localize(125,null),""],description:_.localize(126,null)})),autoIndent:Se(new m(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[_.localize(127,null),_.localize(128,null),_.localize(129,null),_.localize(130,null),_.localize(131,null)],description:_.localize(132,null)})),automaticLayout:Se(new g(10,"automaticLayout",!1)),autoSurround:Se(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[_.localize(133,null),_.localize(134,null),_.localize(135,null),""],description:_.localize(136,null)})),stickyTabStops:Se(new g(101,"stickyTabStops",!1,{description:_.localize(137,null)})),codeLens:Se(new g(12,"codeLens",!0,{description:_.localize(138,null)})),codeLensFontFamily:Se(new S(13,"codeLensFontFamily","",{description:_.localize(139,null)})),codeLensFontSize:Se(new s(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:_.localize(140,null)})),colorDecorators:Se(new g(15,"colorDecorators",!0,{description:_.localize(141,null)})),columnSelection:Se(new g(16,"columnSelection",!1,{description:_.localize(142,null)})),comments:Se(new t),contextmenu:Se(new g(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Se(new g(19,"copyWithSyntaxHighlighting",!0,{description:_.localize(143,null)})),cursorBlinking:Se(new m(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],a,{description:_.localize(144,null)})),cursorSmoothCaretAnimation:Se(new g(21,"cursorSmoothCaretAnimation",!1,{description:_.localize(145,null)})),cursorStyle:Se(new m(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],h,{description:_.localize(146,null)})),cursorSurroundingLines:Se(new s(23,"cursorSurroundingLines",0,0,1073741824,{description:_.localize(147,null)})),cursorSurroundingLinesStyle:Se(new E(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[_.localize(148,null),_.localize(149,null)],description:_.localize(150,null)})),cursorWidth:Se(new s(25,"cursorWidth",0,0,1073741824,{markdownDescription:_.localize(151,null)})),disableLayerHinting:Se(new g(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Se(new g(27,"disableMonospaceOptimizations",!1)),domReadOnly:Se(new g(28,"domReadOnly",!1)),dragAndDrop:Se(new g(29,"dragAndDrop",!0,{description:_.localize(152,null)})),emptySelectionClipboard:Se(new w),extraEditorClassName:Se(new S(31,"extraEditorClassName","")),fastScrollSensitivity:Se(new d(32,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:_.localize(153,null)})),find:Se(new u),fixedOverflowWidgets:Se(new g(34,"fixedOverflowWidgets",!1)),folding:Se(new g(35,"folding",!0,{description:_.localize(154,null)})),foldingStrategy:Se(new E(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[_.localize(155,null),_.localize(156,null)],description:_.localize(157,null)})),foldingHighlight:Se(new g(37,"foldingHighlight",!0,{description:_.localize(158,null)})),unfoldOnClickAfterEndOfLine:Se(new g(38,"unfoldOnClickAfterEndOfLine",!1,{description:_.localize(159,null)})),fontFamily:Se(new S(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:_.localize(160,null)})),fontInfo:Se(new k),fontLigatures2:Se(new f),fontSize:Se(new L),fontWeight:Se(new $),formatOnPaste:Se(new g(44,"formatOnPaste",!1,{description:_.localize(161,null)})),formatOnType:Se(new g(45,"formatOnType",!1,{description:_.localize(162,null)})),glyphMargin:Se(new g(46,"glyphMargin",!0,{description:_.localize(163,null)})),gotoLocation:Se(new te),hideCursorInOverviewRuler:Se(new g(48,"hideCursorInOverviewRuler",!1,{description:_.localize(164,null)})),highlightActiveIndentGuide:Se(new g(49,"highlightActiveIndentGuide",!0,{description:_.localize(165,null)})),hover:Se(new H),inDiffEditor:Se(new g(51,"inDiffEditor",!1)),letterSpacing:Se(new d(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>d.clamp(G,-5,20),{description:_.localize(166,null)})),lightbulb:Se(new F),lineDecorationsWidth:Se(new D(54,"lineDecorationsWidth",10)),lineHeight:Se(new M),lineNumbers:Se(new Ae),lineNumbersMinChars:Se(new s(57,"lineNumbersMinChars",5,1,300)),linkedEditing:Se(new g(58,"linkedEditing",!1,{description:_.localize(167,null)})),links:Se(new g(59,"links",!0,{description:_.localize(168,null)})),matchBrackets:Se(new E(60,"matchBrackets","always",["always","near","never"],{description:_.localize(169,null)})),minimap:Se(new N),mouseStyle:Se(new E(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Se(new d(63,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:_.localize(170,null)})),mouseWheelZoom:Se(new g(64,"mouseWheelZoom",!1,{markdownDescription:_.localize(171,null)})),multiCursorMergeOverlapping:Se(new g(65,"multiCursorMergeOverlapping",!0,{description:_.localize(172,null)})),multiCursorModifier:Se(new m(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[_.localize(173,null),_.localize(174,null)],markdownDescription:_.localize(175,null)})),multiCursorPaste:Se(new E(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[_.localize(176,null),_.localize(177,null)],markdownDescription:_.localize(178,null)})),occurrencesHighlight:Se(new g(68,"occurrencesHighlight",!0,{description:_.localize(179,null)})),overviewRulerBorder:Se(new g(69,"overviewRulerBorder",!0,{description:_.localize(180,null)})),overviewRulerLanes:Se(new s(70,"overviewRulerLanes",3,0,3)),padding:Se(new j),parameterHints:Se(new q),peekWidgetDefaultFocus:Se(new E(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[_.localize(181,null),_.localize(182,null)],description:_.localize(183,null)})),definitionLinkOpensInPeek:Se(new g(74,"definitionLinkOpensInPeek",!1,{description:_.localize(184,null)})),quickSuggestions:Se(new me),quickSuggestionsDelay:Se(new s(76,"quickSuggestionsDelay",10,0,1073741824,{description:_.localize(185,null)})),readOnly:Se(new g(77,"readOnly",!1)),renameOnType:Se(new g(78,"renameOnType",!1,{description:_.localize(186,null),markdownDeprecationMessage:_.localize(187,null)})),renderControlCharacters:Se(new g(79,"renderControlCharacters",!1,{description:_.localize(188,null)})),renderIndentGuides:Se(new g(80,"renderIndentGuides",!0,{description:_.localize(189,null)})),renderFinalNewline:Se(new g(81,"renderFinalNewline",!0,{description:_.localize(190,null)})),renderLineHighlight:Se(new E(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",_.localize(191,null)],description:_.localize(192,null)})),renderLineHighlightOnlyWhenFocus:Se(new g(83,"renderLineHighlightOnlyWhenFocus",!1,{description:_.localize(193,null)})),renderValidationDecorations:Se(new E(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Se(new E(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",_.localize(194,null),_.localize(195,null),_.localize(196,null),""],description:_.localize(197,null)})),revealHorizontalRightPadding:Se(new s(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Se(new g(87,"roundedSelection",!0,{description:_.localize(198,null)})),rulers:Se(new Me),scrollbar:Se(new Y),scrollBeyondLastColumn:Se(new s(90,"scrollBeyondLastColumn",5,0,1073741824,{description:_.localize(199,null)})),scrollBeyondLastLine:Se(new g(91,"scrollBeyondLastLine",!0,{description:_.localize(200,null)})),scrollPredominantAxis:Se(new g(92,"scrollPredominantAxis",!0,{description:_.localize(201,null)})),selectionClipboard:Se(new g(93,"selectionClipboard",!0,{description:_.localize(202,null),included:I.isLinux})),selectionHighlight:Se(new g(94,"selectionHighlight",!0,{description:_.localize(203,null)})),selectOnLineNumbers:Se(new g(95,"selectOnLineNumbers",!0)),showFoldingControls:Se(new E(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[_.localize(204,null),_.localize(205,null)],description:_.localize(206,null)})),showUnused:Se(new g(97,"showUnused",!0,{description:_.localize(207,null)})),showDeprecated:Se(new g(121,"showDeprecated",!0,{description:_.localize(208,null)})),inlineHints:Se(new U),snippetSuggestions:Se(new E(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[_.localize(209,null),_.localize(210,null),_.localize(211,null),_.localize(212,null)],description:_.localize(213,null)})),smartSelect:Se(new ae),smoothScrolling:Se(new g(100,"smoothScrolling",!1,{description:_.localize(214,null)})),stopRenderingLineAfter:Se(new s(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Se(new ee),suggestFontSize:Se(new s(104,"suggestFontSize",0,0,1e3,{markdownDescription:_.localize(215,null)})),suggestLineHeight:Se(new s(105,"suggestLineHeight",0,0,1e3,{markdownDescription:_.localize(216,null)})),suggestOnTriggerCharacters:Se(new g(106,"suggestOnTriggerCharacters",!0,{description:_.localize(217,null)})),suggestSelection:Se(new E(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[_.localize(218,null),_.localize(219,null),_.localize(220,null)],description:_.localize(221,null)})),tabCompletion:Se(new E(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[_.localize(222,null),_.localize(223,null),_.localize(224,null)],description:_.localize(225,null)})),tabIndex:Se(new s(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Se(new E(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[_.localize(226,null),_.localize(227,null),_.localize(228,null)],description:_.localize(229,null)})),useTabStops:Se(new g(111,"useTabStops",!0,{description:_.localize(230,null)})),wordSeparators:Se(new S(112,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:_.localize(231,null)})),wordWrap:Se(new E(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[_.localize(232,null),_.localize(233,null),_.localize(234,null),_.localize(235,null)],description:_.localize(236,null)})),wordWrapBreakAfterCharacters:Se(new S(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Se(new S(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Se(new s(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:_.localize(237,null)})),wordWrapOverride1:Se(new E(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Se(new E(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Se(new m(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[_.localize(238,null),_.localize(239,null),_.localize(240,null),_.localize(241,null)],description:_.localize(242,null)})),wrappingStrategy:Se(new E(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[_.localize(243,null),_.localize(244,null)],description:_.localize(245,null)})),editorClassName:Se(new p),pixelRatio:Se(new X),tabFocusMode:Se(new fe),layoutInfo:Se(new B),wrappingInfo:Se(new be)}}),define(ge[151],ve([16,17]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[152],ve([16,17]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[153],ve([16,17]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ge[154],ve([16,17]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ge[155],ve([16,17]),function(Q,e){return Q.create("vs/platform/markers/common/markers",e)}),define(ge[156],ve([16,17]),function(Q,e){return Q.create("vs/platform/theme/common/iconRegistry",e)}),define(ge[157],ve([16,17]),function(Q,e){return Q.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[158],ve([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHost.api.impl",e)}),define(ge[159],ve([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[160],ve([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(ge[161],ve([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[162],ve([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[163],ve([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[164],ve([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[165],ve([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[166],ve([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[167],ve([16,17]),function(Q,e){return Q.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[168],ve([16,17]),function(Q,e){return Q.create("vs/workbench/common/views",e)}),define(ge[169],ve([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[170],ve([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[171],ve([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/externalTerminal/node/externalTerminalService",e)}),define(ge[172],ve([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[173],ve([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[174],ve([16,17]),function(Q,e){return Q.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[175],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var _;(function(C){C[C.ACTIVATE=0]="ACTIVATE",C[C.RESTORE=1]="RESTORE",C[C.PRESERVE=2]="PRESERVE"})(_=e.EditorActivation||(e.EditorActivation={}));var I;(function(C){C[C.PICK=1]="PICK",C[C.DISABLED=2]="DISABLED"})(I=e.EditorOverride||(e.EditorOverride={}));var T;(function(C){C[C.API=0]="API",C[C.USER=1]="USER"})(T=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(C){C[C.Center=0]="Center",C[C.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",C[C.NearTop=2]="NearTop",C[C.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[176],ve([0,1,153]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function T(D){return D=D.trim(),D==="*"||I.test(D)}e.isValidVersionStr=T;function P(D){if(!T(D))return null;if(D=D.trim(),D==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=D.match(I);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=P;function C(D){if(!D)return null;let b=D.majorBase,g=D.majorMustEqual,s=D.minorBase,d=D.minorMustEqual,S=D.patchBase,v=D.patchMustEqual;return D.hasCaret&&(b===0||(d=!1),v=!1),{majorBase:b,majorMustEqual:g,minorBase:s,minorMustEqual:d,patchBase:S,patchMustEqual:v,isMinimum:D.hasGreaterEquals}}e.normalizeVersion=C;function A(D,b){let g;typeof D=="string"?g=C(P(D)):g=D;let s;if(typeof b=="string"?s=C(P(b)):s=b,!g||!s)return!1;let d=g.majorBase,S=g.minorBase,v=g.patchBase,E=s.majorBase,m=s.minorBase,l=s.patchBase,o=s.majorMustEqual,t=s.minorMustEqual,i=s.patchMustEqual;return s.isMinimum?d>E?!0:d<E?!1:S>m?!0:S<m?!1:v>=l:(d===1&&E===0&&(!o||!t||!i)&&(E=1,m=0,l=0,o=!0,t=!1,i=!1),d<E?!1:d>E?!o:S<m?!1:S>m?!t:v<l?!1:v>l?!i:!0)}e.isValidVersion=A;function y(D,b,g){return b.isBuiltin||typeof b.main=="undefined"?!0:R(D,b.engines.vscode,g)}e.isValidExtensionVersion=y;function n(D,b){return D==="*"||R(b,D)}e.isEngineValid=n;function R(D,b,g=[]){let s=C(P(b));if(!s)return g.push(_.localize(0,null,b)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return g.push(_.localize(1,null,b)),!1}else if(!s.majorMustEqual)return g.push(_.localize(2,null,b)),!1;return A(D,s)?!0:(g.push(_.localize(3,null,D,b)),!1)}e.isVersionValid=R}),define(ge[108],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class _{constructor(P,C=[],A=!1){this.ctor=P,this.staticArguments=C,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=_;const I=(T,...P)=>new _(T,P);e.createSyncDescriptor=I}),define(ge[78],ve([0,1,108]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function T(C,A,y){A instanceof _.SyncDescriptor||(A=new _.SyncDescriptor(A,[],y)),I.push([C,A])}e.registerSingleton=T;function P(){return I}e.getSingletonServiceDescriptors=P}),define(ge[177],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class _{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=_;class I{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let C of this._nodes.values())C.outgoing.size===0&&P.push(C);return P}insertEdge(P,C){const A=this.lookupOrInsertNode(P),y=this.lookupOrInsertNode(C);A.outgoing.set(this._hashFn(C),y),y.incoming.set(this._hashFn(P),A)}removeNode(P){const C=this._hashFn(P);this._nodes.delete(C);for(let A of this._nodes.values())A.outgoing.delete(C),A.incoming.delete(C)}lookupOrInsertNode(P){const C=this._hashFn(P);let A=this._nodes.get(C);return A||(A=new _(P),this._nodes.set(C,A)),A}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[C,A]of this._nodes)P.push(`${C}, (incoming)[${[...A.incoming.keys()].join(", ")}], (outgoing)[${[...A.outgoing.keys()].join(",")}]`);return P.join(`
`)}}e.Graph=I}),define(ge[4],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var _;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function y(n){return n[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=y})(_=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function I(A,y,n,R){y[_.DI_TARGET]===y?y[_.DI_DEPENDENCIES].push({id:A,index:n,optional:R}):(y[_.DI_DEPENDENCIES]=[{id:A,index:n,optional:R}],y[_.DI_TARGET]=y)}function T(A){if(_.serviceIds.has(A))return _.serviceIds.get(A);const y=function(n,R,D){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(y,n,D,!1)};return y.toString=()=>A,_.serviceIds.set(A,y),y}e.createDecorator=T;function P(A){return A}e.refineServiceDecorator=P;function C(A){return function(y,n,R){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");I(A,y,R,!0)}}e.optional=C}),define(ge[178],ve([0,1,4]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,_.createDecorator)("modelService");function I(T){return!T.isTooLargeForSyncing()&&!T.isForSimpleWidget}e.shouldSynchronizeModel=I}),define(ge[179],ve([0,1,3,73,6,24,72,76,178]),function(Q,e,_,I,T,P,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(b){return typeof b=="string"?!1:Array.isArray(b)?b.every(n):!!b.exclusive}class R{constructor(){this._clock=0,this._entries=[],this._onDidChange=new _.Emitter}get onDidChange(){return this._onDidChange.event}register(g,s){let d={selector:g,provider:s,_score:-1,_time:this._clock++};return this._entries.push(d),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,T.toDisposable)(()=>{if(d){let S=this._entries.indexOf(d);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),d=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const s=[];for(let d of this._entries)d._score>0&&s.push(d.provider);return s}ordered(g){const s=[];return this._orderedForEach(g,d=>s.push(d.provider)),s}orderedGroups(g){const s=[];let d,S;return this._orderedForEach(g,v=>{d&&S===v._score?d.push(v.provider):(S=v._score,d=[v.provider],s.push(d))}),s}_orderedForEach(g,s){if(!!g){this._updateScores(g);for(const d of this._entries)d._score>0&&s(d)}}_updateScores(g){let s={uri:g.uri.toString(),language:g.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===s.language&&this._lastCandidate.uri===s.uri)){this._lastCandidate=s;for(let d of this._entries)if(d._score=(0,A.score)(d.selector,g.uri,g.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(g)),n(d.selector)&&d._score>0){for(let S of this._entries)S._score=0;d._score=1e3;break}this._entries.sort(R._compareByScoreAndTime)}}static _compareByScoreAndTime(g,s){return g._score<s._score?1:g._score>s._score?-1:g._time<s._time?1:g._time>s._time?-1:0}}e.LanguageFeatureRegistry=R;class D{constructor(g,s,d=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=s,this.max=d,this._cache=new P.LRUCache(50,.7)}_key(g){return g.id+(0,I.hash)(this._registry.all(g))}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const s=this._key(g),d=this._cache.get(s);return this._clamp(d==null?void 0:d.value)}update(g,s){const d=this._key(g);let S=this._cache.get(d);return S||(S=new C.MovingAverage,this._cache.set(d,S)),S.update(s),this.get(g)}}e.LanguageFeatureRequestDelays=D}),define(ge[79],ve([0,1,2,43,179,142,47]),function(Q,e,_,I,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var A;(function(u){u[u.Null=0]="Null",u[u.PlainText=1]="PlainText"})(A=e.LanguageId||(e.LanguageId={}));class y{constructor(f,k){this.language=f,this.id=k}}e.LanguageIdentifier=y;var n;(function(u){u[u.NotSet=-1]="NotSet",u[u.None=0]="None",u[u.Italic=1]="Italic",u[u.Bold=2]="Bold",u[u.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var R;(function(u){u[u.None=0]="None",u[u.DefaultForeground=1]="DefaultForeground",u[u.DefaultBackground=2]="DefaultBackground"})(R=e.ColorId||(e.ColorId={}));var D;(function(u){u[u.Other=0]="Other",u[u.Comment=1]="Comment",u[u.String=2]="String",u[u.RegEx=4]="RegEx"})(D=e.StandardTokenType||(e.StandardTokenType={}));var b;(function(u){u[u.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",u[u.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",u[u.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",u[u.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",u[u.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",u[u.ITALIC_MASK=2048]="ITALIC_MASK",u[u.BOLD_MASK=4096]="BOLD_MASK",u[u.UNDERLINE_MASK=8192]="UNDERLINE_MASK",u[u.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",u[u.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",u[u.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",u[u.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",u[u.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",u[u.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",u[u.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",u[u.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",u[u.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",u[u.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(b=e.MetadataConsts||(e.MetadataConsts={}));class g{static getLanguageId(f){return(f&255)>>>0}static getTokenType(f){return(f&1792)>>>8}static getFontStyle(f){return(f&14336)>>>11}static getForeground(f){return(f&8372224)>>>14}static getBackground(f){return(f&4286578688)>>>23}static getClassNameFromMetadata(f){let k=this.getForeground(f),L="mtk"+k,$=this.getFontStyle(f);return $&1&&(L+=" mtki"),$&2&&(L+=" mtkb"),$&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(f,k){const L=this.getForeground(f),$=this.getFontStyle(f);let te=`color: ${k[L]};`;return $&1&&(te+="font-style: italic;"),$&2&&(te+="font-weight: bold;"),$&4&&(te+="text-decoration: underline;"),te}}e.TokenMetadata=g;var s;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(s=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let u=Object.create(null);return u[0]="symbol-method",u[1]="symbol-function",u[2]="symbol-constructor",u[3]="symbol-field",u[4]="symbol-variable",u[5]="symbol-class",u[6]="symbol-struct",u[7]="symbol-interface",u[8]="symbol-module",u[9]="symbol-property",u[10]="symbol-event",u[11]="symbol-operator",u[12]="symbol-unit",u[13]="symbol-value",u[14]="symbol-constant",u[15]="symbol-enum",u[16]="symbol-enum-member",u[17]="symbol-keyword",u[27]="symbol-snippet",u[18]="symbol-text",u[19]="symbol-color",u[20]="symbol-file",u[21]="symbol-reference",u[22]="symbol-customcolor",u[23]="symbol-folder",u[24]="symbol-type-parameter",u[25]="account",u[26]="issues",function(f){const k=u[f];let L=k&&C.iconRegistry.get(k);return L||(console.info("No codicon found for CompletionItemKind "+f),L=C.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let u=Object.create(null);return u.method=0,u.function=1,u.constructor=2,u.field=3,u.variable=4,u.class=5,u.struct=6,u.interface=7,u.module=8,u.property=9,u.event=10,u.operator=11,u.unit=12,u.value=13,u.constant=14,u.enum=15,u["enum-member"]=16,u.enumMember=16,u.keyword=17,u.snippet=27,u.text=18,u.color=19,u.file=20,u.reference=21,u.customcolor=22,u.folder=23,u["type-parameter"]=24,u.typeParameter=24,u.account=25,u.issue=26,function(f,k){let L=u[f];return typeof L=="undefined"&&!k&&(L=9),L}}();var d;(function(u){u[u.Deprecated=1]="Deprecated"})(d=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var v;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(E=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var m;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(m=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var l;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(l=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function o(u){return u&&_.URI.isUri(u.uri)&&I.Range.isIRange(u.range)&&(I.Range.isIRange(u.originSelectionRange)||I.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=o;var t;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var i;(function(u){u[u.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var a;(function(u){const f=new Map;f.set("file",0),f.set("module",1),f.set("namespace",2),f.set("package",3),f.set("class",4),f.set("method",5),f.set("property",6),f.set("field",7),f.set("constructor",8),f.set("enum",9),f.set("interface",10),f.set("function",11),f.set("variable",12),f.set("constant",13),f.set("string",14),f.set("number",15),f.set("boolean",16),f.set("array",17),f.set("object",18),f.set("key",19),f.set("null",20),f.set("enum-member",21),f.set("struct",22),f.set("event",23),f.set("operator",24),f.set("type-parameter",25);const k=new Map;k.set(0,"file"),k.set(1,"module"),k.set(2,"namespace"),k.set(3,"package"),k.set(4,"class"),k.set(5,"method"),k.set(6,"property"),k.set(7,"field"),k.set(8,"constructor"),k.set(9,"enum"),k.set(10,"interface"),k.set(11,"function"),k.set(12,"variable"),k.set(13,"constant"),k.set(14,"string"),k.set(15,"number"),k.set(16,"boolean"),k.set(17,"array"),k.set(18,"object"),k.set(19,"key"),k.set(20,"null"),k.set(21,"enum-member"),k.set(22,"struct"),k.set(23,"event"),k.set(24,"operator"),k.set(25,"type-parameter");function L(H){return f.get(H)}u.fromString=L;function $(H){return k.get(H)}u.toString=$;function te(H,x){const B=k.get(H);let F=B&&C.iconRegistry.get("symbol-"+B);return F||(console.info("No codicon found for SymbolKind "+H),F=C.Codicon.symbolProperty),`${x?"inline":"block"} ${F.classNames}`}u.toCssClassName=te})(a=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(f){this.value=f}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var c;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(c=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var h;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(h=e.CommentMode||(e.CommentMode={}));var p;(function(u){u[u.Other=0]="Other",u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(p=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new T.LanguageFeatureRegistry,e.RenameProviderRegistry=new T.LanguageFeatureRegistry,e.CompletionProviderRegistry=new T.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new T.LanguageFeatureRegistry,e.HoverProviderRegistry=new T.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new T.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new T.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new T.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new T.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new T.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new T.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.LinkProviderRegistry=new T.LanguageFeatureRegistry,e.ColorProviderRegistry=new T.LanguageFeatureRegistry,e.SelectionRangeRegistry=new T.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.TokenizationRegistry=new P.TokenizationRegistryImpl;var w;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(w=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[180],ve([0,1,6,15,4,3,55,71]),function(Q,e,_,I,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,T.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new P.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,n){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!n)throw new Error("invalid command");return this.registerCommand({id:y,handler:n})}if(y.description){const s=[];for(let S of y.description.args)s.push(S.constraint);const d=y.handler;y.handler=function(S,...v){return(0,I.validateConstraints)(v,s),d(S,...v)}}const{id:R}=y;let D=this._commands.get(R);D||(D=new C.LinkedList,this._commands.set(R,D));let b=D.unshift(y),g=(0,_.toDisposable)(()=>{b();const s=this._commands.get(R);(s==null?void 0:s.isEmpty())&&this._commands.delete(R)});return this._onDidRegisterCommand.fire(R),g}registerCommandAlias(y,n){return e.CommandsRegistry.registerCommand(y,(R,...D)=>R.get(e.ICommandService).executeCommand(n,...D))}getCommand(y){const n=this._commands.get(y);if(!(!n||n.isEmpty()))return A.Iterable.first(n)}getCommands(){const y=new Map;for(const n of this._commands.keys()){const R=this.getCommand(n);R&&y.set(n,R)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>_.Disposable.None,onDidExecuteCommand:()=>_.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(ge[80],ve([0,1,10,4,9]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let P=T.userAgent||"";const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",T.isMacintosh),C.set("isLinux",T.isLinux),C.set("isWindows",T.isWindows),C.set("isWeb",T.isWeb),C.set("isMacNative",T.isMacintosh&&!T.isWeb),C.set("isEdge",P.indexOf("Edg/")>=0),C.set("isFirefox",P.indexOf("Firefox")>=0),C.set("isChrome",P.indexOf("Chrome")>=0),C.set("isSafari",P.indexOf("Safari")>=0),C.set("isIPad",P.indexOf("iPad")>=0);const A=Object.prototype.hasOwnProperty;var y;(function(u){u[u.False=0]="False",u[u.True=1]="True",u[u.Defined=2]="Defined",u[u.Not=3]="Not",u[u.Equals=4]="Equals",u[u.NotEquals=5]="NotEquals",u[u.And=6]="And",u[u.Regex=7]="Regex",u[u.NotRegex=8]="NotRegex",u[u.Or=9]="Or",u[u.In=10]="In",u[u.NotIn=11]="NotIn",u[u.Greater=12]="Greater",u[u.GreaterEquals=13]="GreaterEquals",u[u.Smaller=14]="Smaller",u[u.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return D.INSTANCE}static true(){return b.INSTANCE}static has(f){return g.create(f)}static equals(f,k){return s.create(f,k)}static notEquals(f,k){return v.create(f,k)}static regex(f,k){return i.create(f,k)}static in(f,k){return d.create(f,k)}static not(f){return E.create(f)}static and(...f){return r.create(f)}static or(...f){return c.create(f)}static greater(f,k){return m.create(f,k)}static less(f,k){return o.create(f,k)}static deserialize(f,k=!1){if(!!f)return this._deserializeOrExpression(f,k)}static _deserializeOrExpression(f,k){let L=f.split("||");return c.create(L.map($=>this._deserializeAndExpression($,k)))}static _deserializeAndExpression(f,k){let L=f.split("&&");return r.create(L.map($=>this._deserializeOne($,k)))}static _deserializeOne(f,k){if(f=f.trim(),f.indexOf("!=")>=0){let L=f.split("!=");return v.create(L[0].trim(),this._deserializeValue(L[1],k))}if(f.indexOf("==")>=0){let L=f.split("==");return s.create(L[0].trim(),this._deserializeValue(L[1],k))}if(f.indexOf("=~")>=0){let L=f.split("=~");return i.create(L[0].trim(),this._deserializeRegexValue(L[1],k))}if(f.indexOf(" in ")>=0){let L=f.split(" in ");return d.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(f)){const L=f.split(">=");return l.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(f)){const L=f.split(">");return m.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(f)){const L=f.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(f)){const L=f.split("<");return o.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(f)?E.create(f.substr(1).trim()):g.create(f)}static _deserializeValue(f,k){if(f=f.trim(),f==="true")return!0;if(f==="false")return!1;let L=/^'([^']*)'$/.exec(f);return L?L[1].trim():f}static _deserializeRegexValue(f,k){if((0,_.isFalsyOrWhitespace)(f)){if(k)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=f.indexOf("/"),$=f.lastIndexOf("/");if(L===$||L<0){if(k)throw new Error(`bad regexp-value '${f}', missing /-enclosure`);return console.warn(`bad regexp-value '${f}', missing /-enclosure`),null}let te=f.slice(L+1,$),H=f[$+1]==="i"?"i":"";try{return new RegExp(te,H)}catch(x){if(k)throw new Error(`bad regexp-value '${f}', parse error: ${x}`);return console.warn(`bad regexp-value '${f}', parse error: ${x}`),null}}}e.ContextKeyExpr=n;function R(u,f){return u.cmp(f)}class D{constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return b.INSTANCE}}e.ContextKeyFalseExpr=D,D.INSTANCE=new D;class b{constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return D.INSTANCE}}e.ContextKeyTrueExpr=b,b.INSTANCE=new b;class g{constructor(f){this.key=f,this.type=2}static create(f){const k=C.get(f);return typeof k=="boolean"?k?b.INSTANCE:D.INSTANCE:new g(f)}cmp(f){return f.type!==this.type?this.type-f.type:p(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=g;class s{constructor(f,k){this.key=f,this.value=k,this.type=4}static create(f,k){if(typeof k=="boolean")return k?g.create(f):E.create(f);const L=C.get(f);return typeof L=="boolean"?k===(L?"true":"false")?b.INSTANCE:D.INSTANCE:new s(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:w(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(f){return f.mapEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyEqualsExpr=s;class d{constructor(f,k){this.key=f,this.valueKey=k,this.type=10}static create(f,k){return new d(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:w(this.key,this.valueKey,f.key,f.valueKey)}equals(f){return f.type===this.type?this.key===f.key&&this.valueKey===f.valueKey:!1}evaluate(f){const k=f.getValue(this.valueKey),L=f.getValue(this.key);return Array.isArray(k)?k.indexOf(L)>=0:typeof L=="string"&&typeof k=="object"&&k!==null?A.call(k,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(f){return f.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=d;class S{constructor(f){this._actual=f,this.type=11}static create(f){return new S(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new S(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class v{constructor(f,k){this.key=f,this.value=k,this.type=5}static create(f,k){if(typeof k=="boolean")return k?E.create(f):g.create(f);const L=C.get(f);return typeof L=="boolean"?k===(L?"true":"false")?D.INSTANCE:b.INSTANCE:new v(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:w(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(f){return f.mapNotEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=v;class E{constructor(f){this.key=f,this.type=3}static create(f){const k=C.get(f);return typeof k=="boolean"?k?D.INSTANCE:b.INSTANCE:new E(f)}cmp(f){return f.type!==this.type?this.type-f.type:p(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!f.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(f){return f.mapNot(this.key)}negate(){return g.create(this.key)}}e.ContextKeyNotExpr=E;class m{constructor(f,k){this.key=f,this.value=k,this.type=12}static create(f,k){return new m(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:w(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=m;class l{constructor(f,k){this.key=f,this.value=k,this.type=13}static create(f,k){return new l(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:w(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreaterEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=l;class o{constructor(f,k){this.key=f,this.value=k,this.type=14}static create(f,k){return new o(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:w(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmaller(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerExpr=o;class t{constructor(f,k){this.key=f,this.value=k,this.type=15}static create(f,k){return new t(f,k)}cmp(f){return f.type!==this.type?this.type-f.type:w(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmallerEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(f,k){this.key=f,this.regexp=k,this.type=7}static create(f,k){return new i(f,k)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.key<f.key)return-1;if(this.key>f.key)return 1;const k=this.regexp?this.regexp.source:"",L=f.regexp?f.regexp.source:"";return k<L?-1:k>L?1:0}equals(f){if(f.type===this.type){const k=this.regexp?this.regexp.source:"",L=f.regexp?f.regexp.source:"";return this.key===f.key&&k===L}return!1}evaluate(f){let k=f.getValue(this.key);return this.regexp?this.regexp.test(k):!1}serialize(){const f=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${f}`}keys(){return[this.key]}map(f){return f.mapRegex(this.key,this.regexp)}negate(){return a.create(this)}}e.ContextKeyRegexExpr=i;class a{constructor(f){this._actual=f,this.type=8}static create(f){return new a(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new a(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=a;class r{constructor(f){this.expr=f,this.type=6}static create(f){return r._normalizeArr(f)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let k=0,L=this.expr.length;k<L;k++){const $=R(this.expr[k],f.expr[k]);if($!==0)return $}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let k=0,L=this.expr.length;k<L;k++)if(!this.expr[k].equals(f.expr[k]))return!1;return!0}return!1}evaluate(f){for(let k=0,L=this.expr.length;k<L;k++)if(!this.expr[k].evaluate(f))return!1;return!0}static _normalizeArr(f){const k=[];let L=!1;for(const $ of f)if(!!$){if($.type===1){L=!0;continue}if($.type===0)return D.INSTANCE;if($.type===6){k.push(...$.expr);continue}k.push($)}if(k.length===0&&L)return b.INSTANCE;if(k.length!==0){if(k.length===1)return k[0];for(k.sort(R);k.length>1;){const $=k[k.length-1];if($.type!==9)break;k.pop();const te=k.pop(),H=c.create($.expr.map(x=>r.create([x,te])));H&&(k.push(H),k.sort(R))}return k.length===1?k[0]:new r(k)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(let k of this.expr)f.push(...k.keys());return f}map(f){return new r(this.expr.map(k=>k.map(f)))}negate(){let f=[];for(let k of this.expr)f.push(k.negate());return c.create(f)}}e.ContextKeyAndExpr=r;class c{constructor(f){this.expr=f,this.type=9}static create(f){const k=c._normalizeArr(f);if(k.length!==0)return k.length===1?k[0]:new c(k)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let k=0,L=this.expr.length;k<L;k++){const $=R(this.expr[k],f.expr[k]);if($!==0)return $}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let k=0,L=this.expr.length;k<L;k++)if(!this.expr[k].equals(f.expr[k]))return!1;return!0}return!1}evaluate(f){for(let k=0,L=this.expr.length;k<L;k++)if(this.expr[k].evaluate(f))return!0;return!1}static _normalizeArr(f){let k=[],L=!1;if(f){for(let $=0,te=f.length;$<te;$++){const H=f[$];if(!!H){if(H.type===0){L=!0;continue}if(H.type===1)return[b.INSTANCE];if(H.type===9){k=k.concat(H.expr);continue}k.push(H)}}if(k.length===0&&L)return[D.INSTANCE];k.sort(R)}return k}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(let k of this.expr)f.push(...k.keys());return f}map(f){return new c(this.expr.map(k=>k.map(f)))}negate(){let f=[];for(let L of this.expr)f.push(L.negate());const k=L=>L.type===9?L.expr:[L];for(;f.length>1;){const L=f.shift(),$=f.shift(),te=[];for(const H of k(L))for(const x of k($))te.push(n.and(H,x));f.unshift(n.or(...te))}return f[0]}}e.ContextKeyOrExpr=c;class h extends g{constructor(f,k,L){super(f);this.key=f,this._defaultValue=k,typeof L=="object"?h._info.push(Object.assign(Object.assign({},L),{key:f})):L!==!0&&h._info.push({key:f,description:L,type:k!=null?typeof k:void 0})}static all(){return h._info.values()}bindTo(f){return f.createKey(this.key,this._defaultValue)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(f){return n.equals(this.key,f)}notEqualsTo(f){return n.notEquals(this.key,f)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(u,f){return u<f?-1:u>f?1:0}function w(u,f,k,L){return u<k?-1:u>k?1:f<L?-1:f>L?1:0}}),define(ge[181],ve([0,1,4]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,_.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,_.refineServiceDecorator)(e.IEnvironmentService)}),define(ge[182],ve([0,1,152,4,11]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function P(D){return D&&typeof D=="object"&&typeof D.id=="string"&&(!D.uuid||typeof D.uuid=="string")}e.isIExtensionIdentifier=P;var C;(function(D){D[D.NoneOrRelevance=0]="NoneOrRelevance",D[D.LastUpdatedDate=1]="LastUpdatedDate",D[D.Title=2]="Title",D[D.PublisherName=3]="PublisherName",D[D.InstallCount=4]="InstallCount",D[D.PublishedDate=5]="PublishedDate",D[D.AverageRating=6]="AverageRating",D[D.WeightedRating=12]="WeightedRating"})(C=e.SortBy||(e.SortBy={}));var A;(function(D){D[D.Default=0]="Default",D[D.Ascending=1]="Ascending",D[D.Descending=2]="Descending"})(A=e.SortOrder||(e.SortOrder={}));var y;(function(D){D.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var n;(function(D){D[D.None=0]="None",D[D.Install=1]="Install",D[D.Update=2]="Update"})(n=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class R extends Error{constructor(b,g){super(b);this.code=g}}e.ExtensionManagementError=R,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",Q).toString(!0),e.ExtensionsLabel=(0,_.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,_.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(ge[29],ve([0,1,10,4]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.getExtensionWorkspaceTrustRequirement=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function T(R){return R&&typeof R=="object"&&typeof R.id=="string"&&(!R.uuid||typeof R.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(R){R[R.System=0]="System",R[R.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class C{constructor(D){this.value=D,this._lower=D.toLowerCase()}static equals(D,b){if(typeof D=="undefined"||D===null)return typeof b=="undefined"||b===null;if(typeof b=="undefined"||b===null)return!1;if(typeof D=="string"||typeof b=="string"){let g=typeof D=="string"?D:D.value,s=typeof b=="string"?b:b.value;return _.equalsIgnoreCase(g,s)}return D._lower===b._lower}static toKey(D){return typeof D=="string"?D.toLowerCase():D._lower}}e.ExtensionIdentifier=C;function A(R){return R.contributes&&R.contributes.localizations?R.contributes.localizations.length>0:!1}e.isLanguagePackExtension=A;function y(R){return R.contributes&&R.contributes.authentication?R.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y;function n(R){var D;return((D=R.workspaceTrust)===null||D===void 0?void 0:D.required)!==void 0?R.workspaceTrust.required:R.main?"onStart":!1}e.getExtensionWorkspaceTrustRequirement=n,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(ge[183],ve([0,1,10,29]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function T(g,s){return g.uuid&&s.uuid?g.uuid===s.uuid:g.id===s.id?!0:(0,_.compareIgnoreCase)(g.id,s.id)===0}e.areSameExtensions=T;class P{constructor(s,d){this.version=d,this.id=s.id,this.uuid=s.uuid}key(){return`${this.id}-${this.version}`}equals(s){return s instanceof P?T(this,s)&&this.version===s.version:!1}}e.ExtensionIdentifierWithVersion=P;function C(g,s){return`${g}.${s}`}e.getExtensionId=C;function A(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=A;function y(g,s){return A(C(g,s))}e.getGalleryExtensionId=y;function n(g,s){const d=[],S=v=>{for(const E of d)if(E.some(m=>T(s(m),s(v))))return E;return null};for(const v of g){const E=S(v);E?E.push(v):d.push([v])}return d}e.groupByExtension=n;function R(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function D(g){return Object.assign({id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0)},g.telemetryData)}e.getGalleryExtensionTelemetryData=D,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function b(g){const s=new Set;for(const d of g)d.malicious&&s.add(d.id.id);return s}e.getMaliciousExtensionsSet=b}),define(ge[44],ve([0,1,154,8,2,4,10,15,24]),function(Q,e,_,I,T,P,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function n(H){return H.create===!0}e.isFileOpenForWriteOptions=n;var R;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var D;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock"})(D=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=b;function g(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=g;function s(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=s;function d(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=d;var S;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(x,B){super(x);this.code=B}}e.FileSystemProviderError=v;function E(H,x){const B=new v(H.toString(),x);return l(B,x),B}e.createFileSystemProviderError=E;function m(H){return H||E((0,_.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=m;function l(H,x){return H.name=x?`${x} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=l;function o(H){if(!H)return S.Unknown;if(H instanceof v)return H.code;const x=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!x)return S.Unknown;switch(x[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=o;function t(H){if(H instanceof p)return H.fileOperationResult;switch(o(H)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class a{constructor(x,B,F){this.resource=x,this.operation=B,this.target=F}isOperation(x){return this.operation===x}}e.FileOperationEvent=a;var r;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class c{constructor(x,B){this.ignorePathCasing=B,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=x;for(const F of x)switch(F.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(F.resource,F);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(F.resource,F);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(F.resource,F);break}}contains(x,...B){return this.doContains(x,{includeChildren:!1},...B)}affects(x,...B){return this.doContains(x,{includeChildren:!0},...B)}doContains(x,B,...F){var U,M,N,O,j,q;if(!x)return!1;const X=F.length>0;return!!((!X||F.includes(1))&&(((U=this.added)===null||U===void 0?void 0:U.get(x))||B.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(x)))||(!X||F.includes(0))&&(((N=this.updated)===null||N===void 0?void 0:N.get(x))||B.includeChildren&&((O=this.updated)===null||O===void 0?void 0:O.findSuperstr(x)))||(!X||F.includes(2))&&(((j=this.deleted)===null||j===void 0?void 0:j.findSubstr(x))||B.includeChildren&&((q=this.deleted)===null||q===void 0?void 0:q.findSuperstr(x))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(x){const B=[],F=x===1?this.added:x===0?this.updated:this.deleted;if(F)for(const[,U]of F)B.push(U);return B}filter(x){return new c(this.changes.filter(B=>x(B)),this.ignorePathCasing)}}e.FileChangesEvent=c;function h(H,x,B){return!H||!x||H===x||x.length>H.length?!1:(x.charAt(x.length-1)!==I.sep&&(x+=I.sep),B?(0,C.startsWithIgnoreCase)(H,x):H.indexOf(x)===0)}e.isParent=h;class p extends Error{constructor(x,B,F){super(x);this.fileOperationResult=B,this.options=F}static isFileOperationError(x){return x instanceof Error&&!(0,A.isUndefinedOrNull)(x.fileOperationResult)}}e.FileOperationError=p;var w;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(w=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var u;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(u=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function f(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=f;async function k(H,x){if(!x.canHandleResource(T.URI.from({scheme:H.scheme})))return new Promise(B=>{const F=x.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===H.scheme&&U.added&&(F.dispose(),B())})})}e.whenProviderRegistered=k,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(x){return(0,A.isNumber)(x)||(x=0),x<L.KB?(0,_.localize)(1,null,x.toFixed(0)):x<L.MB?(0,_.localize)(2,null,(x/L.KB).toFixed(2)):x<L.GB?(0,_.localize)(3,null,(x/L.MB).toFixed(2)):x<L.TB?(0,_.localize)(4,null,(x/L.GB).toFixed(2)):(0,_.localize)(5,null,(x/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var $;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})($=e.Arch||(e.Arch={}));function te(H){return{maxFileSize:H===0?300*L.MB:16*L.GB,maxHeapSize:H===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=te}),define(ge[81],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class _{constructor(...T){this._entries=new Map;for(let[P,C]of T)this.set(P,C)}set(T,P){const C=this._entries.get(T);return this._entries.set(T,P),C}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=_}),define(ge[184],ve([0,1,18,177,108,4,81,19]),function(Q,e,_,I,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class n extends Error{constructor(s){super("cyclic dependency between services");this.message=s.toString()}}class R{constructor(s=new C.ServiceCollection,d=!1,S){this._activeInstantiations=new Set,this._services=s,this._strict=d,this._parent=S,this._services.set(P.IInstantiationService,this)}createChild(s){return new R(s,this._strict,this)}invokeFunction(s,...d){let S=b.traceInvocation(s),v=!1;try{return s({get:(m,l)=>{if(v)throw(0,_.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(m,S);if(!o&&l!==P.optional)throw new Error(`[invokeFunction] unknown service '${m}'`);return o}},...d)}finally{v=!0,S.stop()}}createInstance(s,...d){let S,v;return s instanceof T.SyncDescriptor?(S=b.traceCreation(s.ctor),v=this._createInstance(s.ctor,s.staticArguments.concat(d),S)):(S=b.traceCreation(s),v=this._createInstance(s,d,S)),S.stop(),v}_createInstance(s,d=[],S){let v=P._util.getServiceDependencies(s).sort((l,o)=>l.index-o.index),E=[];for(const l of v){let o=this._getOrCreateServiceInstance(l.id,S);if(!o&&this._strict&&!l.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${l.id}.`);E.push(o)}let m=v.length>0?v[0].index:d.length;if(d.length!==m){console.warn(`[createInstance] First service dependency of ${s.name} at position ${m+1} conflicts with ${d.length} static arguments`);let l=m-d.length;l>0?d=d.concat(new Array(l)):d=d.slice(0,m)}return new s(...[...d,...E])}_setServiceInstance(s,d){if(this._services.get(s)instanceof T.SyncDescriptor)this._services.set(s,d);else if(this._parent)this._parent._setServiceInstance(s,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let d=this._services.get(s);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):d}_getOrCreateServiceInstance(s,d){let S=this._getServiceInstanceOrDescriptor(s);return S instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,S,d.branch(s,!0)):(d.branch(s,!1),S)}_safeCreateAndCacheServiceInstance(s,d,S){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,d,S)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,d,S){const v=new I.Graph(l=>l.id.toString());let E=0;const m=[{id:s,desc:d,_trace:S}];for(;m.length;){const l=m.pop();if(v.lookupOrInsertNode(l),E++>1e3)throw new n(v);for(let o of P._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(o.id);if(!t&&!o.optional&&console.warn(`[createInstance] ${s} depends on ${o.id} which is NOT registered.`),t instanceof T.SyncDescriptor){const i={id:o.id,desc:t,_trace:l._trace.branch(o.id,!0)};v.insertEdge(l,i),m.push(i)}}}for(;;){const l=v.roots();if(l.length===0){if(!v.isEmpty())throw new n(v);break}for(const{data:o}of l){if(this._getServiceInstanceOrDescriptor(o.id)instanceof T.SyncDescriptor){const i=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,i)}v.removeNode(o)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,d,S=[],v,E){if(this._services.get(s)instanceof T.SyncDescriptor)return this._createServiceInstance(d,S,v,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,d,S,v,E);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(s,d=[],S,v){if(S){const E=new A.IdleValue(()=>this._createInstance(s,d,v));return new Proxy(Object.create(null),{get(m,l){if(l in m)return m[l];let o=E.value,t=o[l];return typeof t!="function"||(t=t.bind(o),m[l]=t),t},set(m,l,o){return E.value[l]=o,!0}})}else return this._createInstance(s,d,v)}}e.InstantiationService=R;var D;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(D||(D={}));class b{constructor(s,d){this.type=s,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return y?new b(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(s){return y?new b(0,s.name):b._None}branch(s,d){let S=new b(2,s.toString());return this._dep.push([s,d,S]),S}stop(){let s=Date.now()-this._start;b._totals+=s;let d=!1;function S(E,m){let l=[],o=new Array(E+1).join("	");for(const[t,i,a]of m._dep)if(i&&a){d=!0,l.push(`${o}CREATES -> ${t}`);let r=S(E+1,a);r&&l.push(r)}else l.push(`${o}uses -> ${t}`);return l.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(s>2||d)&&console.log(v.join(`
`))}}b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(ge[12],ve([0,1,4,6,9,3,58]),function(Q,e,_,I,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function A(){return new Date().toISOString()}var y;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class n extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=n;class R extends n{constructor(o){super();this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...t){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([o,...t]))}debug(o,...t){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([o,...t]))}info(o,...t){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([o,...t]))}warn(o,...t){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([o,...t]))}error(o,...t){if(this.checkLogLevel(y.Error))if(o instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=o.stack,this.log(y.Error,this.format(i))}else this.log(y.Error,this.format([o,...t]))}critical(o,...t){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([o,...t]))}flush(){}format(o){let t="";for(let i=0;i<o.length;i++){let a=o[i];if(typeof a=="object")try{a=JSON.stringify(a)}catch(r){}t+=(i>0?" ":"")+a}return t}}e.AbstractMessageLogger=R;class D extends n{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o),this.useColors=!T.isWindows}trace(o,...t){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${A()}][0m`,o,...t):console.log(`[main ${A()}]`,o,...t))}debug(o,...t){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${A()}][0m`,o,...t):console.log(`[main ${A()}]`,o,...t))}info(o,...t){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${A()}][0m`,o,...t):console.log(`[main ${A()}]`,o,...t))}warn(o,...t){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${A()}][0m`,o,...t):console.warn(`[main ${A()}]`,o,...t))}error(o,...t){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${A()}][0m`,o,...t):console.error(`[main ${A()}]`,o,...t))}critical(o,...t){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${A()}][0m`,o,...t):console.error(`[main ${A()}]`,o,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=D;class b extends n{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o)}trace(o,...t){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",o,...t)}debug(o,...t){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...t)}info(o,...t){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",o,...t)}warn(o,...t){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",o,...t)}error(o,...t){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",o,...t)}critical(o,...t){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...t)}dispose(){}flush(){}}e.ConsoleLogger=b;class g extends n{constructor(o,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=o,this.setLevel(t)}trace(o,...t){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(o),...t])}debug(o,...t){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(o),...t])}info(o,...t){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(o),...t])}warn(o,...t){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(o),...t])}error(o,...t){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(o),...t])}critical(o,...t){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(o),...t])}extractMessage(o){return typeof o=="string"?o:(0,C.toErrorMessage)(o,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class s extends n{constructor(o){super();this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const t of this.logServices)t.setLevel(o);super.setLevel(o)}trace(o,...t){for(const i of this.logServices)i.trace(o,...t)}debug(o,...t){for(const i of this.logServices)i.debug(o,...t)}info(o,...t){for(const i of this.logServices)i.info(o,...t)}warn(o,...t){for(const i of this.logServices)i.warn(o,...t)}error(o,...t){for(const i of this.logServices)i.error(o,...t)}critical(o,...t){for(const i of this.logServices)i.critical(o,...t)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=s;class d extends I.Disposable{constructor(o){super();this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...t){this.logger.trace(o,...t)}debug(o,...t){this.logger.debug(o,...t)}info(o,...t){this.logger.info(o,...t)}warn(o,...t){this.logger.warn(o,...t)}error(o,...t){this.logger.error(o,...t)}critical(o,...t){this.logger.critical(o,...t)}flush(){this.logger.flush()}}e.LogService=d;class S{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(o){}getLevel(){return y.Info}trace(o,...t){}debug(o,...t){}info(o,...t){}warn(o,...t){}error(o,...t){}critical(o,...t){}dispose(){}flush(){}}e.NullLogService=S;function v(l){if(l.verbose)return y.Trace;if(typeof l.logLevel=="string"){const o=E(l.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=v;function E(l){switch(l){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=E;function m(l){switch(l){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=m}),define(ge[109],ve([0,1,12,44]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function T(y,n,R,D){try{const b=await new Promise((g,s)=>{Q(["spdlog"],g,s)});return b.setAsyncMode(8192,500),b.createRotatingLoggerAsync(y,n,R,D)}catch(b){console.error(b)}return null}function P(y,n,R,D){return Q.__$__nodeRequire("spdlog").createRotatingLogger(y,n,R,D)}e.createRotatingLogger=P;function C(y,n,R){switch(n){case _.LogLevel.Trace:y.trace(R);break;case _.LogLevel.Debug:y.debug(R);break;case _.LogLevel.Info:y.info(R);break;case _.LogLevel.Warning:y.warn(R);break;case _.LogLevel.Error:y.error(R);break;case _.LogLevel.Critical:y.critical(R);break;default:throw new Error("Invalid log level")}}class A extends _.AbstractMessageLogger{constructor(n,R,D,b){super();this.name=n,this.filepath=R,this.rotating=D,this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(g=>{this._logger&&this._logger.setLevel(g)}))}_createSpdLogLogger(){const n=this.rotating?6:1,R=30/n*I.ByteSize.MB;return T(this.name,this.filepath,R,n).then(D=>{if(D){this._logger=D,this._logger.setLevel(this.getLevel());for(const{level:b,message:g}of this.buffer)C(this._logger,b,g);this.buffer=[]}})}log(n,R){this._logger?C(this._logger,n,R):this.getLevel()<=n&&this.buffer.push({level:n,message:R})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=A}),define(ge[110],ve([0,1,4,155,56]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var C;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function n(s,d){return d-s}y.compare=n;const R=Object.create(null);R[y.Error]=(0,I.localize)(0,null),R[y.Warning]=(0,I.localize)(1,null),R[y.Info]=(0,I.localize)(2,null);function D(s){return R[s]||""}y.toString=D;function b(s){switch(s){case T.default.Error:return y.Error;case T.default.Warning:return y.Warning;case T.default.Info:return y.Info;case T.default.Ignore:return y.Hint}}y.fromSeverity=b;function g(s){switch(s){case y.Error:return T.default.Error;case y.Warning:return T.default.Warning;case y.Info:return T.default.Info;case y.Hint:return T.default.Ignore}}y.toSeverity=g}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const n="";function R(b){return D(b,!0)}y.makeKey=R;function D(b,g){let s=[n];return b.source?s.push(b.source.replace("\xA6","\\\xA6")):s.push(n),b.code?typeof b.code=="string"?s.push(b.code.replace("\xA6","\\\xA6")):s.push(b.code.value.replace("\xA6","\\\xA6")):s.push(n),b.severity!==void 0&&b.severity!==null?s.push(C.toString(b.severity)):s.push(n),b.message&&g?s.push(b.message.replace("\xA6","\\\xA6")):s.push(n),b.startLineNumber!==void 0&&b.startLineNumber!==null?s.push(b.startLineNumber.toString()):s.push(n),b.startColumn!==void 0&&b.startColumn!==null?s.push(b.startColumn.toString()):s.push(n),b.endLineNumber!==void 0&&b.endLineNumber!==null?s.push(b.endLineNumber.toString()):s.push(n),b.endColumn!==void 0&&b.endColumn!==null?s.push(b.endColumn.toString()):s.push(n),s.push(n),s.join("\xA6")}y.makeKeyOptionalMessage=D})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(ge[185],ve([0,1,56,4,3]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=_.default,e.INotificationService=(0,I.createDecorator)("notificationService");var P;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=T.Event.None,this.onDidChangeVisibility=T.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=y}),define(ge[186],ve([0,1,11,9,30,25]),function(Q,e,_,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(typeof I.globals.vscode!="undefined"){const A=I.globals.vscode.context.configuration();if(A)C=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(Q==null?void 0:Q.__$__nodeRequire)=="function"){const A=(0,P.dirname)(_.FileAccess.asFileUri("",Q));C=Q.__$__nodeRequire((0,P.joinPath)(A,"product.json").fsPath);const y=Q.__$__nodeRequire((0,P.joinPath)(A,"package.json").fsPath);T.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`}),Object.assign(C,{version:y.version})}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.56.0-dev",nameShort:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=C});var je=this&&this.__decorate||function(Q,e,_,I){var T=arguments.length,P=T<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,_):I,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(Q,e,_,I);else for(var A=Q.length-1;A>=0;A--)(C=Q[A])&&(P=(T<3?C(P):T>3?C(e,_,P):C(e,_))||P);return T>3&&P&&Object.defineProperty(e,_,P),P},Ue=this&&this.__param||function(Q,e){return function(_,I){e(_,I,Q)}};define(ge[111],ve([0,1,4,21,6,19]),function(Q,e,_,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,_.createDecorator)("progressService");var C;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{constructor(D){this.callback=D}get value(){return this._value}report(D){this._value=D,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=class extends T.Disposable{constructor(D,b){super();this.deferred=new P.DeferredPromise,b.withProgress(D,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,T.toDisposable)(()=>this.deferred.complete()))}report(D){this.reporter?this.reporter.report(D):this.lastStep=D}};y=je([Ue(1,e.IProgressService)],y),e.UnmanagedProgress=y;class n extends T.Disposable{constructor(D){super();this.progressIndicator=D,this.currentOperationId=0,this.currentOperationDisposables=this._register(new T.DisposableStore)}start(D){this.stop();const b=++this.currentOperationId,g=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{b===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},D),this.currentOperationDisposables.add((0,T.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,T.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,T.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:b,token:g.token,stop:()=>this.doStop(b),isCurrent:()=>this.currentOperationId===b}}stop(){this.doStop(this.currentOperationId)}doStop(D){this.currentOperationId===D&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=n,e.IEditorProgressService=(0,_.createDecorator)("editorProgressService")}),define(ge[40],ve([0,1,15,52]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(C,A){I.ok(_.isString(C)),I.ok(_.isObject(A)),I.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,A)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new T}),define(ge[112],ve([0,1,40,3]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class P{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,n){this.schemasById[T(y)]=n,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new P;_.Registry.add(e.Extensions.JSONContribution,C)}),define(ge[82],ve([0,1,151,3,40,15,112]),function(Q,e,_,I,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=T.Registry.as(C.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(v,E=!0){this.registerConfigurations([v],E)}registerConfigurations(v,E=!0){const m=[];v.forEach(l=>{m.push(...this.validateAndRegisterProperties(l,E)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterConfigurations(v){const E=[],m=l=>{if(l.properties)for(const o in l.properties)E.push(o),delete this.configurationProperties[o],this.removeFromSchema(o,l.properties[o]);l.allOf&&l.allOf.forEach(o=>m(o))};for(const l of v){m(l);const o=this.configurationContributors.indexOf(l);o!==-1&&this.configurationContributors.splice(o,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}registerDefaultConfigurations(v){const E=[],m=[];for(const l of v)for(const o in l)if(E.push(o),e.OVERRIDE_PROPERTY_PATTERN.test(o)){this.defaultValues[o]=Object.assign(Object.assign({},this.defaultValues[o]||{}),l[o]);const t={type:"object",default:this.defaultValues[o],description:_.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId};m.push(D(o)),this.configurationProperties[o]=t,this.defaultLanguageConfigurationOverridesNode.properties[o]=t}else{this.defaultValues[o]=l[o];const t=this.configurationProperties[o];t&&(this.updatePropertyDefaultValue(o,t),this.updateSchema(o,t))}this.registerOverrideIdentifiers(m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}deregisterDefaultConfigurations(v){const E=[];for(const m of v)for(const l in m)if(E.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const o=this.configurationProperties[l];o&&(this.updatePropertyDefaultValue(l,o),this.updateSchema(l,o))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}notifyConfigurationSchemaUpdated(...v){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(v){for(const E of v)this.overrideIdentifiers.add(E);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(v,E=!0,m=3){m=P.isUndefinedOrNull(v.scope)?m:v.scope;let l=[],o=v.properties;if(o)for(let i in o){if(E&&s(i)){delete o[i];continue}const a=o[i];if(this.updatePropertyDefaultValue(i,a),e.OVERRIDE_PROPERTY_PATTERN.test(i)?a.scope=void 0:a.scope=P.isUndefinedOrNull(a.scope)?m:a.scope,o[i].hasOwnProperty("included")&&!o[i].included){this.excludedConfigurationProperties[i]=o[i],delete o[i];continue}else this.configurationProperties[i]=o[i];!o[i].deprecationMessage&&o[i].markdownDeprecationMessage&&(o[i].deprecationMessage=o[i].markdownDeprecationMessage),l.push(i)}let t=v.allOf;if(t)for(let i of t)l.push(...this.validateAndRegisterProperties(i,E,m));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(v){const E=m=>{let l=m.properties;if(l)for(const t in l)this.updateSchema(t,l[t]);let o=m.allOf;o&&o.forEach(E)};E(v)}updateSchema(v,E){switch(e.allSettings.properties[v]=E,E.scope){case 1:e.applicationSettings.properties[v]=E;break;case 2:e.machineSettings.properties[v]=E;break;case 6:e.machineOverridableSettings.properties[v]=E;break;case 3:e.windowSettings.properties[v]=E;break;case 4:e.resourceSettings.properties[v]=E;break;case 5:e.resourceSettings.properties[v]=E,this.resourceLanguageSettingsSchema.properties[v]=E;break}}removeFromSchema(v,E){switch(delete e.allSettings.properties[v],E.scope){case 1:delete e.applicationSettings.properties[v];break;case 2:delete e.machineSettings.properties[v];break;case 6:delete e.machineOverridableSettings.properties[v];break;case 3:delete e.windowSettings.properties[v];break;case 4:case 5:delete e.resourceSettings.properties[v];break}}updateOverridePropertyPatternKey(){for(const v of this.overrideIdentifiers.values()){const E=`[${v}]`,m={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(E,m),e.allSettings.properties[E]=m,e.applicationSettings.properties[E]=m,e.machineSettings.properties[E]=m,e.machineOverridableSettings.properties[E]=m,e.windowSettings.properties[E]=m,e.resourceSettings.properties[E]=m}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(v,E){let m=this.defaultValues[v];P.isUndefined(m)&&(m=E.default),P.isUndefined(m)&&(m=b(E.type)),E.default=m}}const R="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(R);function D(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=D;function b(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=b;const g=new n;T.Registry.add(e.Extensions.Configuration,g);function s(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?_.localize(5,null,S):g.getConfigurationProperties()[S]!==void 0?_.localize(6,null,S):null:_.localize(4,null)}e.validateProperty=s;function d(){const S=[],v=g.getConfigurationProperties();for(const E of Object.keys(v))S.push([E,v[E].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=d}),define(ge[83],ve([0,1,23,15,2,40,4,82]),function(Q,e,_,I,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function y(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof T.URI)}e.isConfigurationOverrides=y;var n;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function R(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=R;function D(i,a){const r=a?i?a.keys.filter(k=>i.keys.indexOf(k)===-1):[...a.keys]:[],c=i?a?i.keys.filter(k=>a.keys.indexOf(k)===-1):[...i.keys]:[],h=[];if(a&&i){for(const k of i.keys)if(a.keys.indexOf(k)!==-1){const L=v(i.contents,k),$=v(a.contents,k);_.equals(L,$)||h.push(k)}}const p=[],w=k=>{const L={};for(const $ of k)for(const te of $.identifiers)L[o(te)]=$;return L},u=a?w(a.overrides):{},f=i?w(i.overrides):{};if(Object.keys(u).length)for(const k of r){const L=u[k];L&&p.push([(0,A.overrideIdentifierFromKey)(k),L.keys])}if(Object.keys(f).length)for(const k of c){const L=f[k];L&&p.push([(0,A.overrideIdentifierFromKey)(k),L.keys])}if(Object.keys(u).length&&Object.keys(f).length)for(const k of h){const L=f[k],$=u[k];if(L&&$){const te=D({contents:L.contents,keys:L.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});p.push([(0,A.overrideIdentifierFromKey)(k),[...te.added,...te.removed,...te.updated]])}}return{added:r,removed:c,updated:h,overrides:p}}e.compare=D;function b(i,a){const r=[];for(const c of Object.keys(i))if(A.OVERRIDE_PROPERTY_PATTERN.test(c)){const h={};for(const p in i[c])h[p]=i[c][p];r.push({identifiers:[(0,A.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(h),contents:g(h,a)})}return r}e.toOverrides=b;function g(i,a){const r=Object.create(null);for(let c in i)s(r,c,i[c],a);return r}e.toValuesTree=g;function s(i,a,r,c){const h=a.split("."),p=h.pop();let w=i;for(let u=0;u<h.length;u++){let f=h[u],k=w[f];switch(typeof k){case"undefined":k=w[f]=Object.create(null);break;case"object":break;default:c(`Ignoring ${a} as ${h.slice(0,u+1).join(".")} is ${JSON.stringify(k)}`);return}w=k}if(typeof w=="object"&&w!==null)try{w[p]=r}catch(u){c(`Ignoring ${a} as ${h.join(".")} is ${JSON.stringify(w)}`)}else c(`Ignoring ${a} as ${h.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=s;function d(i,a){const r=a.split(".");S(i,r)}e.removeFromValueTree=d;function S(i,a){const r=a.shift();if(a.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const c=i[r];typeof c=="object"&&!Array.isArray(c)&&(S(c,a),Object.keys(c).length===0&&delete i[r])}}function v(i,a,r){function c(w,u){let f=w;for(const k of u){if(typeof f!="object"||f===null)return;f=f[k]}return f}const h=a.split("."),p=c(i,h);return typeof p=="undefined"?r:p}e.getConfigurationValue=v;function E(i,a,r){Object.keys(a).forEach(c=>{c!=="__proto__"&&(c in i?I.isObject(i[c])&&I.isObject(a[c])?E(i[c],a[c],r):r&&(i[c]=a[c]):i[c]=a[c])})}e.merge=E;function m(){const i=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=m;function l(){const i=Object.create(null),a=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let r in a){let c=a[r].default;s(i,r,c,h=>console.error(`Conflict in default settings: ${h}`))}return i}e.getDefaultValues=l;function o(i){return`[${i}]`}e.keyFromOverrideIdentifier=o;function t(i,a,r){const c=i.inspect(a),h=i.inspect(r);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:c.defaultValue}e.getMigratedSettingValue=t}),define(ge[187],ve([0,1,54,24,14,15,23,2,82,83,40,6,3]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},i=[],a=[]){this._contents=t,this._keys=i,this._overrides=a,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const a=this.getContentsForOverrideIdentifer(i);return a?t?(0,n.getConfigurationValue)(a,t):a:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let a={};for(const r of T.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[r],h=i[r];h&&(typeof c=="object"&&typeof h=="object"?(c=C.deepClone(c),this.mergeContents(c,h)):c=h),a[r]=c}return new g(a,this.keys,this.overrides)}merge(...t){const i=C.deepClone(this.contents),a=C.deepClone(this.overrides),r=[...this.keys];for(const c of t){this.mergeContents(i,c.contents);for(const h of c.overrides){const[p]=a.filter(w=>T.equals(w.identifiers,h.identifiers));p?this.mergeContents(p.contents,h.contents):a.push(C.deepClone(h))}for(const h of c.keys)r.indexOf(h)===-1&&r.push(h)}return new g(i,r,a)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const a of Object.keys(i)){if(a in t&&P.isObject(t[a])&&P.isObject(i[a])){this.mergeContents(t[a],i[a]);continue}t[a]=C.deepClone(i[a])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?C.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,n.addToValueTree)(this.contents,t,i,a=>{throw new Error(a)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let a=0;a<i;a++)t.indexOf(this.keys[a])===0&&(i=a);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=g;class s extends g{constructor(){const t=(0,n.getDefaultValues)(),i=(0,n.getConfigurationKeys)(),a=[];for(const r of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(r)&&a.push({identifiers:[(0,y.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,n.toValuesTree)(t[r],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,i,a)}}e.DefaultConfigurationModel=s;class d{constructor(t,i){this._name=t,this._scopes=i,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get errors(){return this._parseErrors}parseContent(t){if(!P.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i)}}parseRaw(t){this._raw=t;const i=this.doParseRaw(t);this._configurationModel=new g(i.contents,i.keys,i.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let i={},a=null,r=[],c=[],h=[];function p(u){Array.isArray(r)?r.push(u):a&&(r[a]=u)}let w={onObjectBegin:()=>{let u={};p(u),c.push(r),r=u,a=null},onObjectProperty:u=>{a=u},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{let u=[];p(u),c.push(r),r=u,a=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:p,onError:(u,f,k)=>{h.push({error:u,offset:f,length:k})}};if(t)try{_.visit(t,w),i=r[0]||{}}catch(u){console.error(`Error while parsing settings file ${this._name}: ${u}`),this._parseErrors=[u]}return i}doParseRaw(t){if(this._scopes){const c=R.Registry.as(y.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,c,!0,this._scopes)}const i=(0,n.toValuesTree)(t,c=>console.error(`Conflict in settings file ${this._name}: ${c}`)),a=Object.keys(t),r=(0,n.toOverrides)(t,c=>console.error(`Conflict in settings file ${this._name}: ${c}`));return{contents:i,keys:a,overrides:r}}filterByScope(t,i,a,r){const c={};for(let h in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(h)&&a)c[h]=this.filterByScope(t[h],i,!1,r);else{const p=this.getScope(h,i);(p===void 0||r.indexOf(p)!==-1)&&(c[h]=t[h])}return c}getScope(t,i){const a=i[t];return a?typeof a.scope!="undefined"?a.scope:3:void 0}}e.ConfigurationModelParser=d;class S extends D.Disposable{constructor(t,i,a,r){super();this.userSettingsResource=t,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(b.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new g}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=S;class v{constructor(t,i,a=new g,r=new g,c=new I.ResourceMap,h=new g,p=new I.ResourceMap,w=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=a,this._workspaceConfiguration=r,this._folderConfigurations=c,this._memoryConfiguration=h,this._memoryConfigurationByResource=p,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(t,i,a){return this.getConsolidateConfigurationModel(i,a).getValue(t)}updateValue(t,i,a={}){let r;a.resource?(r=this._memoryConfigurationByResource.get(a.resource),r||(r=new g,this._memoryConfigurationByResource.set(a.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(t):r.setValue(t,i),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,a){const r=this.getConsolidateConfigurationModel(i,a),c=this.getFolderConfigurationModelForResource(i.resource,a),h=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,p=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),w=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),u=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),f=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),k=a?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=c?i.overrideIdentifier?c.freeze().override(i.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,$=i.overrideIdentifier?h.override(i.overrideIdentifier).getValue(t):h.getValue(t),te=r.getValue(t),H=T.distinct(T.flatten(r.overrides.map(x=>x.identifiers))).filter(x=>r.getOverrideValue(t,x)!==void 0);return{defaultValue:p,userValue:w,userLocalValue:u,userRemoteValue:f,workspaceValue:k,workspaceFolderValue:L,memoryValue:$,value:te,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:u!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:f!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:k!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:c==null?void 0:c.freeze().getValue(t),override:i.overrideIdentifier?c==null?void 0:c.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:h.getValue(t),override:i.overrideIdentifier?h.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const a=i.filter(r=>y.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const c=(0,y.overrideIdentifierFromKey)(r),h=this._defaultConfiguration.getKeysForOverrideIdentifier(c),p=t.getKeysForOverrideIdentifier(c),w=[...p.filter(u=>h.indexOf(u)===-1),...h.filter(u=>p.indexOf(u)===-1),...h.filter(u=>!C.equals(this._defaultConfiguration.override(c).getValue(u),t.override(c).getValue(u)))];return[c,w]});return this.updateDefaultConfiguration(t),{keys:i,overrides:a}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:a,removed:r,overrides:c}=(0,n.compare)(this.localUserConfiguration,t),h=[...i,...a,...r];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:a,removed:r,overrides:c}=(0,n.compare)(this.remoteUserConfiguration,t);let h=[...i,...a,...r];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:a,removed:r,overrides:c}=(0,n.compare)(this.workspaceConfiguration,t);let h=[...i,...a,...r];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:c}}compareAndUpdateFolderConfiguration(t,i){const a=this.folderConfigurations.get(t),{added:r,updated:c,removed:h,overrides:p}=(0,n.compare)(a,i);let w=[...r,...c,...h];return(w.length||!a)&&this.updateFolderConfiguration(t,i),{keys:w,overrides:p}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:a,updated:r,removed:c,overrides:h}=(0,n.compare)(i,void 0);return{keys:[...a,...r,...c],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let a=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?a.override(t.overrideIdentifier):a}getConsolidatedConfigurationModelForResource({resource:t},i){let a=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const r=i.getFolder(t);r&&(a=this.getFolderConsolidatedConfiguration(r.uri)||a);const c=this._memoryConfigurationByResource.get(t);c&&(a=a.merge(c))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const a=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(i=a.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=a}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const a=i.getFolder(t);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:a,overrides:r,keys:c}=this._folderConfigurations.get(i);return t.push([i,{contents:a,overrides:r,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(a=>t.add(a))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>i.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>i.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>i.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),a=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((h,p)=>(h.set(A.URI.revive(p[0]),this.parseConfigurationModel(p[1])),h),new I.ResourceMap);return new v(i,a,new g,r,c,new g,new I.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=v;function E(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,i=new Map;for(const r of o)r.keys.forEach(c=>t.add(c)),r.overrides.forEach(([c,h])=>{const p=(0,I.getOrSet)(i,c,new Set);h.forEach(w=>p.add(w))});const a=[];return i.forEach((r,c)=>a.push([c,[...r.values()]])),{keys:[...t.values()],overrides:a}}e.mergeChanges=E;class m{constructor(t,i,a,r){this.change=t,this.previous=i,this.currentConfiguraiton=a,this.currentWorkspace=r,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(p=>c.add(p)),t.overrides.forEach(([,p])=>p.forEach(w=>c.add(w))),this.affectedKeys=[...c.values()];const h=new g;this.affectedKeys.forEach(p=>h.setValue(p,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var a;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(a=this.previous)===null||a===void 0?void 0:a.workspace):void 0,c=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!C.equals(r,c)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let a=(0,n.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof a=="object"&&(r=Object.keys(a)[0]);){if(t=t[r],!t)return!1;a=a[r]}return!0}}e.ConfigurationChangeEvent=m;class l extends m{constructor(t,i,a,r){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=a,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=l}),define(ge[113],ve([0,1,4]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,_.createDecorator)("remoteAuthorityResolverService");var I;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(C,A=I.Unknown,y){super(C);this._message=C,this._code=A,this._detail=y,this.isHandled=A===I.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(C){return C instanceof T&&C._code===I.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof T&&C._code===I.NoResolverFound}static isHandled(C){return C instanceof T&&C.isHandled}}e.RemoteAuthorityResolverError=T}),define(ge[114],ve([0,1,11]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function I(P){return P.scheme===_.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=I;function T(P){if(!!P){const C=P.indexOf("+");return C<0?P:P.substr(0,C)}}e.getRemoteName=T}),define(ge[188],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class _{vsda(){return new Promise((T,P)=>Q(["vsda"],T,P))}async sign(T){try{const P=await this.vsda(),C=new P.signer;if(C)return C.sign(T)}catch(P){}return T}}e.SignService=_}),define(ge[189],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class _{constructor(T){this._callback=T,this._terminalBufferMap=new Map}dispose(){for(const T of this._terminalBufferMap.values())T.dispose()}startBuffering(T,P,C=5){let A;return A=P(y=>{const n=typeof y=="string"?y:y.data;let R=this._terminalBufferMap.get(T);if(R){R.data.push(n);return}const D=setTimeout(()=>this.flushBuffer(T),C);R={data:[n],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(T),A.dispose()}},this._terminalBufferMap.set(T,R)}),A}stopBuffering(T){const P=this._terminalBufferMap.get(T);P&&P.dispose()}flushBuffer(T){const P=this._terminalBufferMap.get(T);P&&(this._terminalBufferMap.delete(T),this._callback(T,P.data.join("")))}}e.TerminalDataBufferer=_}),define(ge[190],ve([0,1,48,8,30,26,15,23,9]),function(Q,e,_,I,T,P,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function n(){const D=/(\d+)\.(\d+)\.(\d+)/g.exec(_.release());let b=0;return D&&D.length===4&&(b=parseInt(D[3])),b}e.getWindowsBuildNumber=n;async function R(D,b,g,s=T.env,d=P.exists){if(I.isAbsolute(D))return await d(D)?D:void 0;if(b===void 0&&(b=T.cwd()),I.dirname(D)!=="."){const m=I.join(b,D);return await d(m)?m:void 0}const v=(0,A.getCaseInsensitive)(s,"PATH");if(g===void 0&&(0,C.isString)(v)&&(g=v.split(I.delimiter)),g===void 0||g.length===0){const m=I.join(b,D);return await d(m)?m:void 0}for(let m of g){let l;if(I.isAbsolute(m)?l=I.join(m,D):l=I.join(b,m,D),await d(l))return l;if(y.isWindows){let o=l+".com";if(await d(o)||(o=l+".exe",await d(o)))return o}}const E=I.join(b,D);return await d(E)?E:void 0}e.findExecutable=R}),define(ge[191],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var _;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(_=e.ColorScheme||(e.ColorScheme={}))}),define(ge[192],ve([0,1,4,6,40,3,191,47]),function(Q,e,_,I,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var y;(function(S){function v(E){return E&&typeof E=="object"&&typeof E.id=="string"}S.isThemeColor=v})(y=e.ThemeColor||(e.ThemeColor={}));function n(S){return{id:S}}e.themeColorFromId=n;var R;(function(S){function v(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}S.isThemeIcon=v;const E=new RegExp(`^\\$\\((${A.CSSIcon.iconNameExpression}(?:${A.CSSIcon.iconModifierExpression})?)\\)$`);function m(t){const i=E.exec(t);if(!!i){let[,a]=i;return{id:a}}}S.fromString=m;function l(t,i){let a=t.id;const r=a.lastIndexOf("~");return r!==-1&&(a=a.substring(0,r)),i&&(a=`${a}~${i}`),{id:a}}S.modify=l;function o(t,i){var a,r;return t.id===i.id&&((a=t.color)===null||a===void 0?void 0:a.id)===((r=i.color)===null||r===void 0?void 0:r.id)}S.isEqual=o,S.asClassNameArray=A.CSSIcon.asClassNameArray,S.asClassName=A.CSSIcon.asClassName,S.asCSSSelector=A.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=A.Codicon.file,e.FolderThemeIcon=A.Codicon.folder;function D(S){switch(S){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=D,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new P.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,I.toDisposable)(()=>{const E=this.themingParticipants.indexOf(v);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new b;T.Registry.add(e.Extensions.ThemingContribution,g);function s(S){return g.onColorThemeChange(S)}e.registerThemingParticipant=s;class d extends I.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,E){let m=this.theme.getColor(v);return m&&E&&(m=E(m,this.theme)),m?m.toString():null}}e.Themable=d}),define(ge[193],ve([0,1,40,192,3,156,112,19,47]),function(Q,e,_,I,T,P,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class n{constructor(){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,P.localize)(0,null)},fontCharacter:{type:"string",description:(0,P.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(v,E,m,l){const o=this.iconsById[v];if(o){if(m&&!o.description){o.description=m,this.iconSchema.properties[v].markdownDescription=`${m} $(${v})`;const a=this.iconReferenceSchema.enum.indexOf(v);a!==-1&&(this.iconReferenceSchema.enumDescriptions[a]=m),this._onDidChange.fire()}return o}let t={id:v,description:m,defaults:E,deprecationMessage:l};this.iconsById[v]=t;let i={$ref:"#/definitions/icons"};return l&&(i.deprecationMessage=l),m&&(i.markdownDescription=`${m}: $(${v})`),this.iconSchema.properties[v]=i,this.iconReferenceSchema.enum.push(v),this.iconReferenceSchema.enumDescriptions.push(m||""),this._onDidChange.fire(),{id:v}}deregisterIcon(v){delete this.iconsById[v],delete this.iconSchema.properties[v];const E=this.iconReferenceSchema.enum.indexOf(v);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(v=>this.iconsById[v])}getIcon(v){return this.iconsById[v]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(v,E){const m=this.iconFontsById[v];if(m)return m;let l={id:v,definition:E};return this.iconFontsById[v]=l,this._onDidChange.fire(),l}deregisterIconFont(v){delete this.iconFontsById[v]}getIconFonts(){return Object.keys(this.iconFontsById).map(v=>this.iconFontsById[v])}getIconFont(v){return this.iconFontsById[v]}toString(){const v=(o,t)=>o.id.localeCompare(t.id),E=o=>{for(;I.ThemeIcon.isThemeIcon(o.defaults);)o=this.iconsById[o.defaults.id];return`codicon codicon-${o?o.id:""}`};let m=[];m.push("| preview     | identifier                        | default codicon ID                | description"),m.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.iconsById).map(o=>this.iconsById[o]);for(const o of l.filter(t=>!!t.description).sort(v))m.push(`|<i class="${E(o)}"></i>|${o.id}|${I.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);m.push("| preview     | identifier                        "),m.push("| ----------- | --------------------------------- |");for(const o of l.filter(t=>!I.ThemeIcon.isThemeIcon(t.defaults)).sort(v))m.push(`|<i class="${E(o)}"></i>|${o.id}|`);return m.join(`
`)}}const R=new n;_.Registry.add(e.Extensions.IconContribution,R);function D(S,v,E,m){return R.registerIcon(S,v,E,m)}e.registerIcon=D;function b(){return R}e.getIconRegistry=b;function g(){for(const S of y.iconRegistry.all)R.registerIcon(S.id,S.definition,S.description);y.iconRegistry.onDidRegister(S=>R.registerIcon(S.id,S.definition,S.description))}g(),e.iconsSchemaId="vscode://schemas/icons";let s=_.Registry.as(C.Extensions.JSONContribution);s.registerSchema(e.iconsSchemaId,R.getIconSchema());const d=new A.RunOnceScheduler(()=>s.notifySchemaChanged(e.iconsSchemaId),200);R.onDidChange(()=>{d.isScheduled()||d.schedule()}),e.widgetClose=D("widget-close",y.Codicon.close,(0,P.localize)(2,null)),e.gotoPreviousLocation=D("goto-previous-location",y.Codicon.arrowUp,(0,P.localize)(3,null)),e.gotoNextLocation=D("goto-next-location",y.Codicon.arrowDown,(0,P.localize)(4,null)),e.syncing=I.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(ge[59],ve([0,1,2,25,4,24]),function(Q,e,_,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var C;(function(b){b[b.EMPTY=1]="EMPTY",b[b.FOLDER=2]="FOLDER",b[b.WORKSPACE=3]="WORKSPACE"})(C=e.WorkbenchState||(e.WorkbenchState={}));function A(b){const g=b;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=A;function y(b){const g=b;return!!(g&&typeof g=="object"&&_.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=y;class n{constructor(g,s,d,S){this._id=g,this._configuration=d,this._ignorePathCasing=S,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(g){this._id=g.id,this._configuration=g.configuration,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class R{constructor(g,s){this.raw=s,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,I.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function D(b){return new R({uri:b,index:0,name:(0,I.basenameOrAuthority)(b)},{uri:b.toString()})}e.toWorkspaceFolder=D}),define(ge[115],ve([0,1,4,157,59,2,9,8,25,132,54,11,75,31,114]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(B){return(typeof B=="string"?(0,A.extname)(B):(0,y.extname)(B))===d}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,_.createDecorator)("workspacesService");function v(B){return B.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function E(B){return B.hasOwnProperty("folderUri")}e.isRecentFolder=E;function m(B){return B.hasOwnProperty("fileUri")}e.isRecentFile=m;function l(B){const F=B;return typeof(F==null?void 0:F.id)=="string"&&P.URI.isUri(F.uri)}e.isSingleFolderWorkspaceIdentifier=l;function o(B){if(B.configuration)return{id:B.id,configPath:B.configuration};if(B.folders.length===1)return{id:B.id,uri:B.folders[0].uri}}e.toWorkspaceIdentifier=o;function t(B){const F=B;return typeof(F==null?void 0:F.id)=="string"&&P.URI.isUri(F.configPath)}e.isWorkspaceIdentifier=t;function i(B){const F=B;if(F==null?void 0:F.uri)return{id:F.id,uri:P.URI.revive(F.uri)};const U=B;if(U==null?void 0:U.configPath)return{id:U.id,configPath:P.URI.revive(U.configPath)};if(B==null?void 0:B.id)return{id:B.id}}e.reviveIdentifier=i;function a(B,F){return y.extUriBiasedIgnorePathCase.isEqualOrParent(B,F.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function r(B){return c(B)||h(B)}e.isStoredWorkspaceFolder=r;function c(B){const F=B;return typeof(F==null?void 0:F.path)=="string"&&(!F.name||typeof F.name=="string")}e.isRawFileWorkspaceFolder=c;function h(B){const F=B;return typeof(F==null?void 0:F.uri)=="string"&&(!F.name||typeof F.name=="string")}e.isRawUriWorkspaceFolder=h;function p(B,F,U,M,N=!C.isWindows,O){if(B.scheme!==M.scheme)return{name:U,uri:B.toString(!0)};let j=F?void 0:O.relativePath(M,B);if(j!==void 0)j.length===0?j=".":C.isWindows&&B.scheme===D.Schemas.file&&!N&&(j=j.replace(/\//g,"\\"));else if(B.scheme===D.Schemas.file)j=B.fsPath,C.isWindows&&(j=(0,b.normalizeDriveLetter)(j),N&&(j=(0,g.toSlashes)(j)));else{if(!O.isEqualAuthority(B.authority,M.authority))return{name:U,uri:B.toString(!0)};j=B.path}return{name:U,path:j}}e.getStoredWorkspaceFolder=p;function w(B,F,U){let M=[],N=new Set;const O=U.dirname(F);for(let j of B){let q=null;if(c(j))j.path&&(q=U.resolvePath(O,j.path));else if(h(j))try{q=P.URI.parse(j.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(X){console.warn(X)}if(q){let X=U.getComparisonKey(q);if(!N.has(X)){N.add(X);const me=j.name||U.basenameOrAuthority(q);M.push(new T.WorkspaceFolder({uri:q,name:me,index:M.length},j))}}}return M}e.toWorkspaceFolders=w;function u(B,F,U,M,N){let O=f(F,B);const j=N.dirname(F),q=N.dirname(M),X=[],me=k(O.folders);for(const Me of O.folders){const V=c(Me)?N.resolvePath(j,Me.path):P.URI.parse(Me.uri);let Y;U?Y=!1:Y=!c(Me)||(0,A.isAbsolute)(Me.path),X.push(p(V,Y,Me.name,q,me,N))}const we={insertSpaces:!1,tabSize:4,eol:C.isLinux||C.isMacintosh?`
`:`\r
`},Ae=n.setProperty(B,["folders"],X,we);let Ie=n.applyEdits(B,Ae);return O.remoteAuthority===(0,s.getRemoteAuthority)(M)&&(Ie=n.applyEdits(Ie,n.removeProperty(Ie,["remoteAuthority"],we))),Ie}e.rewriteWorkspaceFileForNewLocation=u;function f(B,F){let U=R.parse(F);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(M=>r(M));else throw new Error(`${B} looks like an invalid workspace file.`);return U}function k(B){return C.isWindows?B.some(F=>c(F)&&F.path.indexOf("/")>=0):!0}e.useSlashForPath=k;function L(B){return B.workspace&&typeof B.workspace=="object"&&typeof B.workspace.id=="string"&&typeof B.workspace.configPath=="string"}function $(B){return typeof B.folderUri=="string"}function te(B){return typeof B.fileUri=="string"}function H(B,F){const U={workspaces:[],files:[]};if(B){const M=function(O,j){for(let q=0;q<O.length;q++)try{j(O[q],q)}catch(X){F.warn(`Error restoring recent entry ${JSON.stringify(O[q])}: ${X.toString()}. Skip entry.`)}},N=B;if(Array.isArray(N.entries))M(N.entries,O=>{const j=O.label,q=O.remoteAuthority;L(O)?U.workspaces.push({label:j,remoteAuthority:q,workspace:{id:O.workspace.id,configPath:P.URI.parse(O.workspace.configPath)}}):$(O)?U.workspaces.push({label:j,remoteAuthority:q,folderUri:P.URI.parse(O.folderUri)}):te(O)&&U.files.push({label:j,remoteAuthority:q,fileUri:P.URI.parse(O.fileUri)})});else{const O=B;Array.isArray(O.workspaces3)&&M(O.workspaces3,(j,q)=>{const X=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[q]||void 0;typeof j=="object"&&typeof j.id=="string"&&typeof j.configURIPath=="string"?U.workspaces.push({label:X,workspace:{id:j.id,configPath:P.URI.parse(j.configURIPath)}}):typeof j=="string"&&U.workspaces.push({label:X,folderUri:P.URI.parse(j)})}),Array.isArray(O.files2)&&M(O.files2,(j,q)=>{const X=Array.isArray(O.fileLabels)&&O.fileLabels[q]||void 0;typeof j=="string"&&U.files.push({label:X,fileUri:P.URI.parse(j)})})}}return U}e.restoreRecentlyOpened=H;function x(B){const F={entries:[]};for(const U of B.workspaces)E(U)?F.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):F.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of B.files)F.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return F}e.toStoreData=x}),define(ge[116],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class _{constructor(T){this.id=T,this._data=new Map,this._idPool=1}add(T){const P=this._idPool++;return this._data.set(P,T),this.logDebugInfo(),P}get(T,P){return this._data.has(T)?this._data.get(T)[P]:void 0}delete(T){this._data.delete(T),this.logDebugInfo()}logDebugInfo(){!_.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=_,_.enableDebugLogging=!1}),define(ge[194],ve([0,1,2,3]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class T{constructor(){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(C){this._tabs=C.map(A=>({name:A.name,group:A.group,resource:_.URI.revive(A.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(ge[60],ve([0,1,11,4]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(_.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(C,A){A===null?this._providerInfo.delete(C):this._providerInfo.set(C,A)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(ge[27],ve([0,1,4]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,_.createDecorator)("IExtHostInitDataService")}),define(ge[195],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class _{constructor(P,C,A){this._id=P,this._shared=C,this._storage=A,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)})}get whenReady(){return this._init}get(P,C){let A=this._value[P];return typeof A=="undefined"&&(A=C),A}update(P,C){return this._value[P]=C,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=_;class I extends _{constructor(P,C){super(P.identifier.value,!0,C);this._extension=P}setKeysForSync(P){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},P)}}e.ExtensionGlobalMemento=I}),define(ge[13],ve([0,1,4]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,_.createDecorator)("IExtHostRpcService");class I{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=I});var tt=this&&this.__classPrivateFieldSet||function(Q,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(Q,_):T?T.value=_:e.set(Q,_),_},$e=this&&this.__classPrivateFieldGet||function(Q,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(Q):I?I.value:e.get(Q)};define(ge[196],ve([0,1,29,3]),function(Q,e,_,I){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(A,y){T.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=_.ExtensionIdentifier.toKey(A.identifier),tt(this,T,y,"f"),$e(this,T,"f").onDidChangePassword(n=>{n.extensionId===this._id&&this._onDidChange.fire({key:n.key})})}get(A){return $e(this,T,"f").get(this._id,A)}store(A,y){return $e(this,T,"f").store(this._id,A,y)}delete(A){return $e(this,T,"f").delete(this._id,A)}}e.ExtensionSecrets=P,T=new WeakMap}),define(ge[117],ve([0,1,4,3]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class T{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(C){this._enabled=C}$onDidChangeTelemetryEnabled(C){this._enabled=C,this._onDidChangeTelemetryEnabled.fire(C)}}e.ExtHostTelemetry=T,e.IExtHostTelemetry=(0,_.createDecorator)("IExtHostTelemetry")}),define(ge[50],ve([0,1,4,3,13]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var P;(function(A){function y(R){return{remoteAddress:R.remoteAddress,localAddress:R.localAddress,public:!!R.public}}A.fromApiTunnel=y;function n(R){return{remoteAddress:{host:R.tunnelRemoteHost,port:R.tunnelRemotePort},localAddress:R.localAddress,public:R.public}}A.fromServiceTunnel=n})(P=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,_.createDecorator)("IExtHostTunnelService");let C=class{constructor(y){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,n){return{dispose:()=>{}}}async $providePortAttributes(y,n,R,D,b){return[]}async $forwardPort(y,n){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};C=je([Ue(0,T.IExtHostRpcService)],C),e.ExtHostTunnelService=C});var tt=this&&this.__classPrivateFieldSet||function(Q,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(Q,_):T?T.value=_:e.set(Q,_),_},$e=this&&this.__classPrivateFieldGet||function(Q,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(Q):I?I.value:e.get(Q)};define(ge[7],ve([0,1,14,18,94,24,15,2,28,44,113]),function(Q,e,_,I,T,P,C,A,y,n,R){"use strict";var D,b,g,s,d,S,v,E,m,l,o,t,i,a,r,c,h,p;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItem=e.TestChildrenCollection=e.TestItemHookProperty=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function w(z){function W(){return Reflect.construct(z,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(z,"name")),Object.setPrototypeOf(W,z),Object.setPrototypeOf(W.prototype,z.prototype),W}let u=d=class{constructor(W){D.set(this,void 0),tt(this,D,W,"f")}static from(...W){let se=W;return new d(function(){if(se){for(const ye of se)ye&&typeof ye.dispose=="function"&&ye.dispose();se=void 0}})}dispose(){typeof $e(this,D,"f")=="function"&&($e(this,D,"f").call(this),tt(this,D,void 0,"f"))}};D=new WeakMap,u=d=je([w],u),e.Disposable=u;let f=S=class{constructor(W,se){if(W<0)throw(0,I.illegalArgument)("line must be non-negative");if(se<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=W,this._character=se}static Min(...W){if(W.length===0)throw new TypeError;let se=W[0];for(let ye=1;ye<W.length;ye++){const ze=W[ye];ze.isBefore(se)&&(se=ze)}return se}static Max(...W){if(W.length===0)throw new TypeError;let se=W[0];for(let ye=1;ye<W.length;ye++){const ze=W[ye];ze.isAfter(se)&&(se=ze)}return se}static isPosition(W){if(!W)return!1;if(W instanceof S)return!0;let{line:se,character:ye}=W;return typeof se=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,se=0){if(W===null||se===null)throw(0,I.illegalArgument)();let ye;return typeof W=="undefined"?ye=0:typeof W=="number"?ye=W:(ye=typeof W.lineDelta=="number"?W.lineDelta:0,se=typeof W.characterDelta=="number"?W.characterDelta:0),ye===0&&se===0?this:new S(this.line+ye,this.character+se)}with(W,se=this.character){if(W===null||se===null)throw(0,I.illegalArgument)();let ye;return typeof W=="undefined"?ye=this.line:typeof W=="number"?ye=W:(ye=typeof W.line=="number"?W.line:this.line,se=typeof W.character=="number"?W.character:this.character),ye===this.line&&se===this.character?this:new S(ye,se)}toJSON(){return{line:this.line,character:this.character}}};f=S=je([w],f),e.Position=f;let k=v=class{constructor(W,se,ye,ze){let Xe,it;if(typeof W=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof ze=="number"?(Xe=new f(W,se),it=new f(ye,ze)):W instanceof f&&se instanceof f&&(Xe=W,it=se),!Xe||!it)throw new Error("Invalid arguments");Xe.isBefore(it)?(this._start=Xe,this._end=it):(this._start=it,this._end=Xe)}static isRange(W){return W instanceof v?!0:W?f.isPosition(W.start)&&f.isPosition(W.end):!1}get start(){return this._start}get end(){return this._end}contains(W){return W instanceof v?this.contains(W._start)&&this.contains(W._end):W instanceof f?!(W.isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const se=f.Max(W.start,this._start),ye=f.Min(W.end,this._end);if(!se.isAfter(ye))return new v(se,ye)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const se=f.Min(W.start,this._start),ye=f.Max(W.end,this.end);return new v(se,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,se=this.end){if(W===null||se===null)throw(0,I.illegalArgument)();let ye;return W?f.isPosition(W)?ye=W:(ye=W.start||this.start,se=W.end||this.end):ye=this.start,ye.isEqual(this._start)&&se.isEqual(this.end)?this:new v(ye,se)}toJSON(){return[this.start,this.end]}};k=v=je([w],k),e.Range=k;let L=E=class extends k{constructor(W,se,ye,ze){let Xe,it;if(typeof W=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof ze=="number"?(Xe=new f(W,se),it=new f(ye,ze)):W instanceof f&&se instanceof f&&(Xe=W,it=se),!Xe||!it)throw new Error("Invalid arguments");super(Xe,it);this._anchor=Xe,this._active=it}static isSelection(W){return W instanceof E?!0:W?k.isRange(W)&&f.isPosition(W.anchor)&&f.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};L=E=je([w],L),e.Selection=L;class ${constructor(W,se,ye){if(typeof W!="string"||W.length===0)throw(0,I.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,I.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,I.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(se),this.connectionToken=ye}}e.ResolvedAuthority=$;class te extends Error{constructor(W,se=R.RemoteAuthorityResolverErrorCode.Unknown,ye){super(W);this._message=W,this._code=se,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,te.prototype)}static NotAvailable(W,se){return new te(W,R.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(W){return new te(W,R.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=te;var H;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var x;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=m=class{constructor(W,se){this._range=W,this._newText=se}static isTextEdit(W){return W instanceof m?!0:W?k.isRange(W)&&typeof W.newText=="string":!1}static replace(W,se){return new m(W,se)}static insert(W,se){return m.replace(new k(W,W),se)}static delete(W){return m.replace(W,"")}static setEndOfLine(W){const se=new m(new k(new f(0,0),new f(0,0)),"");return se.newEol=W,se}get range(){return this._range}set range(W){if(W&&!k.isRange(W))throw(0,I.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,I.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,I.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=m=je([w],B),e.TextEdit=B;var F;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellOutput=4]="CellOutput",z[z.CellReplace=5]="CellReplace",z[z.CellOutputItem=6]="CellOutputItem"})(F=e.FileEditType||(e.FileEditType={}));let U=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,se,ye,ze){this._edits.push({_type:1,from:W,to:se,options:ye,metadata:ze})}createFile(W,se,ye){this._edits.push({_type:1,from:void 0,to:W,options:se,metadata:ye})}deleteFile(W,se,ye){this._edits.push({_type:1,from:W,to:void 0,options:se,metadata:ye})}replaceNotebookMetadata(W,se,ye){this._edits.push({_type:3,metadata:ye,uri:W,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(W,se,ye,ze,Xe){(se!==ye||ze.length>0)&&this._edits.push({_type:5,uri:W,index:se,count:ye-se,cells:ze,metadata:Xe})}replaceNotebookCellOutput(W,se,ye,ze){this._editNotebookCellOutput(W,se,!1,ye,ze)}appendNotebookCellOutput(W,se,ye,ze){this._editNotebookCellOutput(W,se,!0,ye,ze)}replaceNotebookCellOutputItems(W,se,ye,ze,Xe){this._editNotebookCellOutputItems(W,se,ye,!1,ze,Xe)}appendNotebookCellOutputItems(W,se,ye,ze,Xe){this._editNotebookCellOutputItems(W,se,ye,!0,ze,Xe)}_editNotebookCellOutputItems(W,se,ye,ze,Xe,it){this._edits.push({_type:6,metadata:it,uri:W,index:se,outputId:ye,append:ze,newOutputItems:Xe})}_editNotebookCellOutput(W,se,ye,ze,Xe){this._edits.push({_type:4,metadata:Xe,uri:W,index:se,append:ye,newOutputs:ze,newMetadata:void 0})}replaceNotebookCellMetadata(W,se,ye,ze){this._edits.push({_type:3,metadata:ze,uri:W,edit:{editType:11,index:se,metadata:ye}})}replace(W,se,ye,ze){this._edits.push({_type:2,uri:W,edit:new B(se,ye),metadata:ze})}insert(W,se,ye,ze){this.replace(W,new k(se,se),ye,ze)}delete(W,se,ye){this.replace(W,se,"",ye)}has(W){return this._edits.some(se=>se._type===2&&se.uri.toString()===W.toString())}set(W,se){if(se)for(const ye of se)ye&&this._edits.push({_type:2,uri:W,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const ze=this._edits[ye];ze._type===2&&ze.uri.toString()===W.toString()&&(this._edits[ye]=void 0)}(0,_.coalesceInPlace)(this._edits)}}get(W){const se=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===W.toString()&&se.push(ye.edit);return se}entries(){const W=new P.ResourceMap;for(let se of this._edits)if(se._type===2){let ye=W.get(se.uri);ye||(ye=[se.uri,[]],W.set(se.uri,ye)),ye[1].push(se.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};U=je([w],U),e.WorkspaceEdit=U;let M=l=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof l?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=l._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,se=this._tabstop++){if(typeof W=="function"){const ye=new l;ye._tabstop=this._tabstop,W(ye),this._tabstop=ye._tabstop,W=ye.value}else W=l._escape(W);return this.value+="${",this.value+=se,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,se=this._tabstop++){const ye=W.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(W,se){if(typeof se=="function"){const ye=new l;ye._tabstop=this._tabstop,se(ye),this._tabstop=ye._tabstop,se=ye.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,se&&(this.value+=":",this.value+=se),this.value+="}",this}};M=l=je([w],M),e.SnippetString=M;var N;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(N=e.DiagnosticTag||(e.DiagnosticTag={}));var O;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(O=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let j=o=class{constructor(W,se){if(this.uri=W,se)if(se instanceof k)this.range=se;else if(se instanceof f)this.range=new k(se,se);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof o?!0:W?k.isRange(W.range)&&A.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};j=o=je([w],j),e.Location=j;let q=class{constructor(W,se){this.location=W,this.message=se}static is(W){return W?typeof W.message=="string"&&W.location&&k.isRange(W.location.range)&&A.URI.isUri(W.location.uri):!1}static isEqual(W,se){return W===se?!0:!W||!se?!1:W.message===se.message&&W.location.range.isEqual(se.location.range)&&W.location.uri.toString()===se.location.uri.toString()}};q=je([w],q),e.DiagnosticRelatedInformation=q;let X=class{constructor(W,se,ye=O.Error){if(!k.isRange(W))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=W,this.message=se,this.severity=ye}toJSON(){return{severity:O[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,se){return W===se?!0:!W||!se?!1:W.message===se.message&&W.severity===se.severity&&W.code===se.code&&W.severity===se.severity&&W.source===se.source&&W.range.isEqual(se.range)&&(0,_.equals)(W.tags,se.tags)&&(0,_.equals)(W.relatedInformation,se.relatedInformation,q.isEqual)}};X=je([w],X),e.Diagnostic=X;let me=class{constructor(W,se){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:(0,T.isMarkdownString)(W)?this.contents=[W]:this.contents=[W],this.range=se}};me=je([w],me),e.Hover=me;var we;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(we=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ae=class{constructor(W,se=we.Text){this.range=W,this.kind=se}toJSON(){return{range:this.range,kind:we[this.kind]}}};Ae=je([w],Ae),e.DocumentHighlight=Ae;var Ie;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(Ie=e.SymbolKind||(e.SymbolKind={}));var Me;(function(z){z[z.Deprecated=1]="Deprecated"})(Me=e.SymbolTag||(e.SymbolTag={}));let V=t=class{constructor(W,se,ye,ze,Xe){this.name=W,this.kind=se,this.containerName=Xe,typeof ye=="string"&&(this.containerName=ye),ze instanceof j?this.location=ze:ye instanceof k&&(this.location=new j(ze,ye)),t.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ie[this.kind],location:this.location,containerName:this.containerName}}};V=t=je([w],V),e.SymbolInformation=V;let Y=i=class{constructor(W,se,ye,ze,Xe){this.name=W,this.detail=se,this.kind=ye,this.range=ze,this.selectionRange=Xe,this.children=[],i.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children&&W.children.forEach(i.validate)}};Y=i=je([w],Y),e.DocumentSymbol=Y;var ee;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(W,se){this.title=W,this.kind=se}};ae=je([w],ae),e.CodeAction=ae;let fe=a=class{constructor(W){this.value=W}append(W){return new a(this.value?this.value+a.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+a.sep)}};fe.sep=".",fe=a=je([w],fe),e.CodeActionKind=fe,fe.Empty=new fe(""),fe.QuickFix=fe.Empty.append("quickfix"),fe.Refactor=fe.Empty.append("refactor"),fe.RefactorExtract=fe.Refactor.append("extract"),fe.RefactorInline=fe.Refactor.append("inline"),fe.RefactorRewrite=fe.Refactor.append("rewrite"),fe.Source=fe.Empty.append("source"),fe.SourceOrganizeImports=fe.Source.append("organizeImports"),fe.SourceFixAll=fe.Source.append("fixAll");let De=class{constructor(W,se){if(this.range=W,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};De=je([w],De),e.SelectionRange=De;class Oe{constructor(W,se,ye,ze,Xe,it){this.kind=W,this.name=se,this.detail=ye,this.uri=ze,this.range=Xe,this.selectionRange=it}}e.CallHierarchyItem=Oe;class be{constructor(W,se){this.fromRanges=se,this.from=W}}e.CallHierarchyIncomingCall=be;class ke{constructor(W,se){this.fromRanges=se,this.to=W}}e.CallHierarchyOutgoingCall=ke;let Te=class{constructor(W,se){this.range=W,this.command=se}get isResolved(){return!!this.command}};Te=je([w],Te),e.CodeLens=Te;let xe=r=class{constructor(W,se=!1){b.set(this,void 0),tt(this,b,new T.MarkdownString(W,{supportThemeIcons:se}),"f")}static isMarkdownString(W){return W instanceof r?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return $e(this,b,"f").value}set value(W){$e(this,b,"f").value=W}get isTrusted(){return $e(this,b,"f").isTrusted}set isTrusted(W){$e(this,b,"f").isTrusted=W}get supportThemeIcons(){return $e(this,b,"f").supportThemeIcons}appendText(W){return $e(this,b,"f").appendText(W),this}appendMarkdown(W){return $e(this,b,"f").appendMarkdown(W),this}appendCodeblock(W,se){return $e(this,b,"f").appendCodeblock(se!=null?se:"",W),this}};b=new WeakMap,xe=r=je([w],xe),e.MarkdownString=xe;let Se=class{constructor(W,se){this.label=W,this.documentation=se}};Se=je([w],Se),e.ParameterInformation=Se;let Ke=class{constructor(W,se){this.label=W,this.documentation=se,this.parameters=[]}};Ke=je([w],Ke),e.SignatureInformation=Ke;let G=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};G=je([w],G),e.SignatureHelp=G;var re;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(re=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ee;(function(z){z[z.Other=0]="Other",z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Ee=e.InlineHintKind||(e.InlineHintKind={}));let Ne=class{constructor(W,se,ye){this.text=W,this.range=se,this.kind=ye}};Ne=je([w],Ne),e.InlineHint=Ne;var Ve;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Be=e.CompletionItemKind||(e.CompletionItemKind={}));var et;(function(z){z[z.Deprecated=1]="Deprecated"})(et=e.CompletionItemTag||(e.CompletionItemTag={}));let K=class{constructor(W,se){this.label=W,this.kind=se}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};K=je([w],K),e.CompletionItem=K;let oe=class{constructor(W=[],se=!1){this.items=W,this.isIncomplete=se}};oe=je([w],oe),e.CompletionList=oe;var he;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(he=e.ViewColumn||(e.ViewColumn={}));var Z;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Z=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ne;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(ne=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var le;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(le=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var pe;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(pe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var _e;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(_e=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var He;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(He=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function W(se){switch(se){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=W}(_e=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let We=class{constructor(W,se){if(se&&!A.URI.isUri(se))throw(0,I.illegalArgument)("target");if(!k.isRange(W)||W.isEmpty)throw(0,I.illegalArgument)("range");this.range=W,this.target=se}};We=je([w],We),e.DocumentLink=We;let qe=class{constructor(W,se,ye,ze){this.red=W,this.green=se,this.blue=ye,this.alpha=ze}};qe=je([w],qe),e.Color=qe;let Ye=class{constructor(W,se){if(se&&!(se instanceof qe))throw(0,I.illegalArgument)("color");if(!k.isRange(W)||W.isEmpty)throw(0,I.illegalArgument)("range");this.range=W,this.color=se}};Ye=je([w],Ye),e.ColorInformation=Ye;let Ze=class{constructor(W){if(!W||typeof W!="string")throw(0,I.illegalArgument)("label");this.label=W}};Ze=je([w],Ze),e.ColorPresentation=Ze;var ut;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(ut=e.ColorFormat||(e.ColorFormat={}));var ot;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(ot=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var nt;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(nt=e.TaskRevealKind||(e.TaskRevealKind={}));var ue;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(ue=e.TaskPanelKind||(e.TaskPanelKind={}));let Ce=c=class{constructor(W,se){if(typeof W!="string"||typeof se!="string")throw(0,I.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};Ce.Clean=new c("clean","Clean"),Ce.Build=new c("build","Build"),Ce.Rebuild=new c("rebuild","Rebuild"),Ce.Test=new c("test","Test"),Ce=c=je([w],Ce),e.TaskGroup=Ce;function ce(z){let W="";for(let se=0;se<z.length;se++)W+=z[se].replace(/,/g,",,")+",";return W}let J=class{constructor(W,se,ye){if(typeof W!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=W,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=ye):this._options=se)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,I.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(let se of this._args)W.push(se);return ce(W)}};J=je([w],J),e.ProcessExecution=J;let Re=class{constructor(W,se,ye){if(this._args=[],Array.isArray(se)){if(!W)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,I.illegalArgument)("command");this._command=W,this._args=se,this._options=ye}else{if(typeof W!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=W,this._options=se}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,I.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)W.push(typeof se=="string"?se:se.value);return ce(W)}};Re=je([w],Re),e.ShellExecution=Re;var Le;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(Le=e.ShellQuoting||(e.ShellQuoting={}));var Je;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(Je=e.TaskScope||(e.TaskScope={}));class Ge{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,y.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=Ge;let rt=h=class{constructor(W,se,ye,ze,Xe,it){this.__deprecated=!1,this._definition=this.definition=W;let dt;typeof se=="string"?(this._name=this.name=se,this._source=this.source=ye,this.execution=ze,dt=Xe,this.__deprecated=!0):se===Je.Global||se===Je.Workspace?(this.target=se,this._name=this.name=ye,this._source=this.source=ze,this.execution=Xe,dt=it):(this.target=se,this._name=this.name=ye,this._source=this.source=ze,this.execution=Xe,dt=it),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof J?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof Re?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof Ge?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,y.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const se=this._definition.type;(h.EmptyType===se||h.ProcessType===se||h.ShellType===se||h.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};rt.ExtensionCallbackType="customExecution",rt.ProcessType="process",rt.ShellType="shell",rt.EmptyType="$empty",rt=h=je([w],rt),e.Task=rt;var at;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(at=e.ProgressLocation||(e.ProgressLocation={}));let Qe=class{constructor(W,se=ct.None){this.collapsibleState=se,A.URI.isUri(W)?this.resourceUri=W:this.label=W}};Qe=je([w],Qe),e.TreeItem=Qe;var ct;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let st=class{constructor(W,se){this.id=W,this.color=se}};st=je([w],st),e.ThemeIcon=st,st.File=new st("file"),st.Folder=new st("folder");let gt=class{constructor(W){this.id=W}};gt=je([w],gt),e.ThemeColor=gt;var Et;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Et=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Dt=class{constructor(W,se){if(typeof W!="string"&&(!W||!A.URI.isUri(W)&&!A.URI.isUri(W.uri)))throw(0,I.illegalArgument)("base");if(typeof se!="string")throw(0,I.illegalArgument)("pattern");typeof W=="string"?(this.baseFolder=A.URI.file(W),this.base=W):A.URI.isUri(W)?(this.baseFolder=W,this.base=W.fsPath):(this.baseFolder=W.uri,this.base=W.uri.fsPath),this.pattern=se}};Dt=je([w],Dt),e.RelativePattern=Dt;let wt=class{constructor(W,se,ye,ze){this.enabled=typeof W=="boolean"?W:!0,typeof se=="string"&&(this.condition=se),typeof ye=="string"&&(this.hitCondition=ye),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,y.generateUuid)()),this._id}};wt=je([w],wt),e.Breakpoint=wt;let St=class extends wt{constructor(W,se,ye,ze,Xe){super(se,ye,ze,Xe);if(W===null)throw(0,I.illegalArgument)("location");this.location=W}};St=je([w],St),e.SourceBreakpoint=St;let pt=class extends wt{constructor(W,se,ye,ze,Xe){super(se,ye,ze,Xe);this.functionName=W}};pt=je([w],pt),e.FunctionBreakpoint=pt;let Lt=class extends wt{constructor(W,se,ye,ze,Xe,it,dt){super(ze,Xe,it,dt);if(!se)throw(0,I.illegalArgument)("dataId");this.label=W,this.dataId=se,this.canPersist=ye}};Lt=je([w],Lt),e.DataBreakpoint=Lt;let Ft=class{constructor(W,se,ye){this.command=W,this.args=se||[],this.options=ye}};Ft=je([w],Ft),e.DebugAdapterExecutable=Ft;let ft=class{constructor(W,se){this.port=W,this.host=se}};ft=je([w],ft),e.DebugAdapterServer=ft;let yt=class{constructor(W){this.path=W}};yt=je([w],yt),e.DebugAdapterNamedPipeServer=yt;let Vt=class{constructor(W){this.implementation=W}};Vt=je([w],Vt),e.DebugAdapterInlineImplementation=Vt;let Qt=class{constructor(W,se){this.range=W,this.expression=se}};Qt=je([w],Qt),e.EvaluatableExpression=Qt;let Mt=class{constructor(W,se){this.range=W,this.text=se}};Mt=je([w],Mt),e.InlineValueText=Mt;let ht=class{constructor(W,se,ye=!0){this.range=W,this.variableName=se,this.caseSensitiveLookup=ye}};ht=je([w],ht),e.InlineValueVariableLookup=ht;let Xt=class{constructor(W,se){this.range=W,this.expression=se}};Xt=je([w],Xt),e.InlineValueEvaluatableExpression=Xt;let kt=class{constructor(W,se){this.frameId=W,this.stoppedLocation=se}};kt=je([w],kt),e.InlineValueContext=kt;var Nt;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Nt=e.FileChangeType||(e.FileChangeType={}));let jt=p=class extends Error{constructor(W,se=n.FileSystemProviderErrorCode.Unknown,ye){var ze;super(A.URI.isUri(W)?W.toString(!0):W);this.code=(ze=ye==null?void 0:ye.name)!==null&&ze!==void 0?ze:"Unknown",(0,n.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(W){return new p(W,n.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(W){return new p(W,n.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(W){return new p(W,n.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(W){return new p(W,n.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(W){return new p(W,n.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(W){return new p(W,n.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}};jt=p=je([w],jt),e.FileSystemError=jt;let Jt=class{constructor(W,se,ye){this.start=W,this.end=se,this.kind=ye}};Jt=je([w],Jt),e.FoldingRange=Jt;var sn;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(sn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var gn;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(gn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var on;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(on=e.CommentMode||(e.CommentMode={}));class Ot{constructor(W,se=[]){this.tokenTypes=W,this.tokenModifiers=se}}e.SemanticTokensLegend=Ot;function pn(z){return typeof z=="undefined"||(0,C.isStringArray)(z)}class Ut{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let se=0,ye=W.tokenTypes.length;se<ye;se++)this._tokenTypeStrToInt.set(W.tokenTypes[se],se);for(let se=0,ye=W.tokenModifiers.length;se<ye;se++)this._tokenModifierStrToInt.set(W.tokenModifiers[se],se)}}push(W,se,ye,ze,Xe){if(typeof W=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof ze=="number"&&(typeof Xe=="number"||typeof Xe=="undefined"))return typeof Xe=="undefined"&&(Xe=0),this._pushEncoded(W,se,ye,ze,Xe);if(k.isRange(W)&&typeof se=="string"&&pn(ye))return this._push(W,se,ye);throw(0,I.illegalArgument)()}_push(W,se,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const ze=W.start.line,Xe=W.start.character,it=W.end.character-W.start.character,dt=this._tokenTypeStrToInt.get(se);let _t=0;if(ye)for(const Ct of ye){if(!this._tokenModifierStrToInt.has(Ct))throw new Error("`tokenModifier` is not in the provided legend");const It=this._tokenModifierStrToInt.get(Ct);_t|=1<<It>>>0}this._pushEncoded(ze,Xe,it,dt,_t)}_pushEncoded(W,se,ye,ze,Xe){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const _t=this._data.length/5|0;let Ct=0,It=0;for(let Pt=0;Pt<_t;Pt++){let Tt=this._data[5*Pt],tn=this._data[5*Pt+1];Tt===0?(Tt=Ct,tn+=It):Tt+=Ct,this._data[5*Pt]=Tt,this._data[5*Pt+1]=tn,Ct=Tt,It=tn}}let it=W,dt=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(it-=this._prevLine,it===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=it,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=Xe,this._prevLine=W,this._prevChar=se}static _sortAndDeltaEncode(W){let se=[];const ye=W.length/5|0;for(let dt=0;dt<ye;dt++)se[dt]=dt;se.sort((dt,_t)=>{const Ct=W[5*dt],It=W[5*_t];if(Ct===It){const Pt=W[5*dt+1],Tt=W[5*_t+1];return Pt-Tt}return Ct-It});const ze=new Uint32Array(W.length);let Xe=0,it=0;for(let dt=0;dt<ye;dt++){const _t=5*se[dt],Ct=W[_t+0],It=W[_t+1],Pt=W[_t+2],Tt=W[_t+3],tn=W[_t+4],Tn=Ct-Xe,On=Tn===0?It-it:It,nn=5*dt;ze[nn+0]=Tn,ze[nn+1]=On,ze[nn+2]=Pt,ze[nn+3]=Tt,ze[nn+4]=tn,Xe=Ct,it=It}return ze}build(W){return this._dataIsSortedAndDeltaEncoded?new xt(new Uint32Array(this._data),W):new xt(Ut._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=Ut;class xt{constructor(W,se){this.resultId=se,this.data=W}}e.SemanticTokens=xt;class vn{constructor(W,se,ye){this.start=W,this.deleteCount=se,this.data=ye}}e.SemanticTokensEdit=vn;class wn{constructor(W,se){this.resultId=se,this.edits=W}}e.SemanticTokensEdits=wn;var At;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(At=e.DebugConsoleMode||(e.DebugConsoleMode={}));var bn;(function(z){z[z.Initial=1]="Initial",z[z.Dynamic=2]="Dynamic"})(bn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let qt=class{constructor(){}};qt.Back={iconPath:new st("arrow-left")},qt=je([w],qt),e.QuickInputButtons=qt;var _n;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(_n=e.ExtensionKind||(e.ExtensionKind={}));class En{constructor(W,se,ye){this.badge=W,this.tooltip=se,this.color=ye}static validate(W){if(W.badge&&W.badge.length!==1&&W.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=En;let Bt=class{constructor(W){this.kind=W}};Bt=je([w],Bt),e.ColorTheme=Bt;var an;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast"})(an=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{constructor(W,se){if(W<0)throw(0,I.illegalArgument)("start must be positive");if(se<W)throw(0,I.illegalArgument)("end cannot be smaller than start");this._start=W,this._end=se}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(W){let se=this._start,ye=this._end;return W.start!==void 0&&(se=W.start),W.end!==void 0&&(ye=W.end),se===this._start&&ye===this._end?this:new Kt(se,ye)}}e.NotebookCellRange=Kt;class Wt{constructor(W,se,ye,ze,Xe,it,dt){this.editable=W,this.breakpointMargin=se,this.hasExecutionOrder=ye,this.statusMessage=ze,this.inputCollapsed=Xe,this.outputCollapsed=it,this.custom=dt}with(W){let{editable:se,breakpointMargin:ye,hasExecutionOrder:ze,statusMessage:Xe,inputCollapsed:it,outputCollapsed:dt,custom:_t}=W;return se===void 0?se=this.editable:se===null&&(se=void 0),ye===void 0?ye=this.breakpointMargin:ye===null&&(ye=void 0),ze===void 0?ze=this.hasExecutionOrder:ze===null&&(ze=void 0),Xe===void 0?Xe=this.statusMessage:Xe===null&&(Xe=void 0),it===void 0?it=this.inputCollapsed:it===null&&(it=void 0),dt===void 0?dt=this.outputCollapsed:dt===null&&(dt=void 0),_t===void 0?_t=this.custom:_t===null&&(_t=void 0),se===this.editable&&ye===this.breakpointMargin&&ze===this.hasExecutionOrder&&Xe===this.statusMessage&&it===this.inputCollapsed&&dt===this.outputCollapsed&&_t===this.custom?this:new Wt(se,ye,ze,Xe,it,dt,_t)}}e.NotebookCellMetadata=Wt;class Fe{constructor(W=!0,se=!0,ye=!0,ze={},Xe=!0){this.editable=W,this.cellEditable=se,this.cellHasExecutionOrder=ye,this.custom=ze,this.trusted=Xe}with(W){let{editable:se,cellEditable:ye,cellHasExecutionOrder:ze,custom:Xe,trusted:it}=W;return se===void 0?se=this.editable:se===null&&(se=void 0),ye===void 0?ye=this.cellEditable:ye===null&&(ye=void 0),ze===void 0?ze=this.cellHasExecutionOrder:ze===null&&(ze=void 0),Xe===void 0?Xe=this.custom:Xe===null&&(Xe=void 0),it===void 0?it=this.trusted:it===null&&(it=void 0),se===this.editable&&ye===this.cellEditable&&ze===this.cellHasExecutionOrder&&Xe===this.custom&&it===this.trusted?this:new Fe(se,ye,ze,Xe,it)}}e.NotebookDocumentMetadata=Fe;class Yt{constructor(W,se,ye,ze,Xe,it){this.kind=W,this.source=se,this.language=ye,this.outputs=ze!=null?ze:[],this.metadata=Xe,this.latestExecutionSummary=it}}e.NotebookCellData=Yt;class Zt{constructor(W,se){this.cells=W,this.metadata=se!=null?se:new Fe}}e.NotebookData=Zt;class mt{constructor(W,se,ye){this.mime=W,this.value=se,this.metadata=ye}static isNotebookCellOutputItem(W){return W instanceof mt}}e.NotebookCellOutputItem=mt;class Sn{constructor(W,se,ye){this.outputs=W,typeof se=="string"?(this.id=se,this.metadata=ye):(this.id=(0,y.generateUuid)(),this.metadata=se!=null?se:ye)}}e.NotebookCellOutput=Sn;var yn;(function(z){z[z.Markdown=1]="Markdown",z[z.Code=2]="Code"})(yn=e.NotebookCellKind||(e.NotebookCellKind={}));var ln;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(ln=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var cn;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(cn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Dn;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Dn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let en=class{constructor(W,se){this.label=W,this.timestamp=se}};en=je([w],en),e.TimelineItem=en;var Cn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(Cn=e.ExtensionMode||(e.ExtensionMode={}));var kn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(kn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var un;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=4]="RegEx"})(un=e.StandardTokenType||(e.StandardTokenType={}));class In{constructor(W,se){this.ranges=W,this.wordPattern=se}}e.LinkedEditingRanges=In;var Pn;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(Pn=e.TestResultState||(e.TestResultState={}));var dn;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information",z[z.Hint=3]="Hint"})(dn=e.TestMessageSeverity||(e.TestMessageSeverity={})),e.TestItemHookProperty=Symbol("TestItemHookProperty");const Gt=(z,W,se)=>{let ye=se;return{enumerable:!0,configurable:!1,get(){return ye},set(ze){var Xe;(Xe=z[e.TestItemHookProperty])===null||Xe===void 0||Xe.setProp(W,ze),ye=ze}}};class hn{constructor(W){g.set(this,new Map),s.set(this,void 0),tt(this,s,W,"f")}get size(){return $e(this,g,"f").size}add(W){const se=$e(this,g,"f"),ye=$e(this,s,"f").call(this),ze=se.get(W.id);ze!==W&&(ze&&(ye==null||ye.delete(W.id)),se.set(W.id,W),ye==null||ye.created(W))}get(W){return $e(this,g,"f").get(W)}clear(){for(const W of $e(this,g,"f").keys())this.delete(W)}delete(W){var se;const ye=typeof W=="string"?W:W.id;$e(this,g,"f").has(ye)&&($e(this,g,"f").delete(ye),(se=$e(this,s,"f").call(this))===null||se===void 0||se.delete(ye))}toJSON(){return[...$e(this,g,"f").values()]}[(g=new WeakMap,s=new WeakMap,Symbol.iterator)](){return $e(this,g,"f").values()}}e.TestChildrenCollection=hn;class ie{constructor(W,se,ye,ze){this.label=se,this.expandable=ze,Object.defineProperties(this,{id:{value:W,enumerable:!0,writable:!1},uri:{value:ye,enumerable:!0,writable:!1},children:{value:new hn(()=>this[e.TestItemHookProperty]),enumerable:!0,writable:!1},[e.TestItemHookProperty]:{enumerable:!1,writable:!0,configurable:!1},range:Gt(this,"range",void 0),description:Gt(this,"description",void 0),runnable:Gt(this,"runnable",!0),debuggable:Gt(this,"debuggable",!0)})}invalidate(){var W;(W=this[e.TestItemHookProperty])===null||W===void 0||W.invalidate(this.id)}discoverChildren(W,se){W.report({busy:!1})}}e.TestItem=ie;class de{constructor(W){this.message=W,this.severity=dn.Error}static diff(W,se,ye){const ze=new de(W);return ze.expectedOutput=se,ze.actualOutput=ye,ze}}e.TestMessage=de;var Pe;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(Pe=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var lt;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(lt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var bt;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore"})(bt=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ge[118],ve([0,1,52,11,10,143,105,7,14]),function(Q,e,_,I,T,P,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const n=new Map;function R(s,d){d?n.set(s,d):n.delete(s)}e.setWordDefinitionFor=R;function D(s){return n.get(s)}e.getWordDefinitionFor=D;class b extends P.MirrorTextModel{constructor(d,S,v,E,m,l,o,t){super(S,v,E,m);this._proxy=d,this._languageId=l,this._isDirty=o,this._notebook=t,this._isDisposed=!1}dispose(){(0,_.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,y.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===I.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(S){return S?d._getTextInRange(S):d.getText()},get eol(){return d._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(S){return d._lineAt(S)},offsetAt(S){return d._offsetAt(S)},positionAt(S){return d._positionAt(S)},validateRange(S){return d._validateRange(S)},validatePosition(S){return d._validatePosition(S)},getWordRangeAtPosition(S,v){return d._getWordRangeAtPosition(S,v)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,_.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,_.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const S=this._validateRange(d);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const v=this._eol,E=S.start.line,m=S.end.line,l=[];l.push(this._lines[E].substring(S.start.character));for(let o=E+1;o<m;o++)l.push(this._lines[o]);return l.push(this._lines[m].substring(0,S.end.character)),l.join(v)}_lineAt(d){let S;if(d instanceof A.Position?S=d.line:typeof d=="number"&&(S=d),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new g(S,this._lines[S],S===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(d),v=this._lines[S.index].length;return new A.Position(S.index,Math.min(S.remainder,v))}_validateRange(d){if(!(d instanceof A.Range))throw new Error("Invalid argument");const S=this._validatePosition(d.start),v=this._validatePosition(d.end);return S===d.start&&v===d.end?d:new A.Range(S.line,S.character,v.line,v.character)}_validatePosition(d){if(!(d instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:S,character:v}=d,E=!1;if(S<0)S=0,v=0,E=!0;else if(S>=this._lines.length)S=this._lines.length-1,v=this._lines[S].length,E=!0;else{const m=this._lines[S].length;v<0?(v=0,E=!0):v>m&&(v=m,E=!0)}return E?new A.Position(S,v):d}_getWordRangeAtPosition(d,S){const v=this._validatePosition(d);if(!S)S=D(this._languageId);else if((0,T.regExpLeadsToEndlessLoop)(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const E=(0,C.getWordAtText)(v.character+1,(0,C.ensureValidWordDefinition)(S),this._lines[v.line],0);if(E)return new A.Range(v.line,E.startColumn-1,v.line,E.endColumn-1)}}e.ExtHostDocumentData=b;class g{constructor(d,S,v){this._line=d,this._text=S,this._isLastLine=v}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(ge[197],ve([0,1,7,3,107,6,76,24,2,28]),function(Q,e,_,I,T,P,C,A,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(b,g,s,d){this._notebook=s,this._selector=d,this._disposables=new P.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,n.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(v=>{const E=this._cellUris.get(v.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=v=>{v===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(b.onDidChangeNotebookCells(v=>S(v.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new A.ResourceMap;const b=[],g=[];for(const s of this._notebook.cells)s.kind===_.NotebookCellKind.Code&&(!this._selector||(0,C.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),b.push(s.document.getText().length+1),g.push(s.document.lineCount));this._cellLengths=new T.PrefixSumComputer(new Uint32Array(b)),this._cellLines=new T.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(b){var g,s;if(!b){let m="";for(const l of this._cells)m+=l.document.getText()+`
`;return m=m.slice(0,-1),m}if(b.isEmpty)return"";const d=this.locationAt(b.start),S=this.locationAt(b.end),v=this._cells[(g=this._cellUris.get(d.uri))!==null&&g!==void 0?g:-1],E=this._cells[(s=this._cellUris.get(S.uri))!==null&&s!==void 0?s:-1];if(!v||!E)return"";if(v===E)return v.document.getText(new _.Range(d.range.start,S.range.end));{const m=v.document.getText(new _.Range(d.range.start,new _.Position(v.document.lineCount,0))),l=E.document.getText(new _.Range(new _.Position(0,0),S.range.end));return m+`
`+l}}offsetAt(b){const g=this._cellLines.getIndexOf(b.line),s=this._cellLengths.getAccumulatedValue(g.index-1),d=this._cells[g.index].document.offsetAt(b.with(g.remainder));return s+d}positionAt(b){if(typeof b=="number"){const s=this._cellLengths.getIndexOf(b),d=this._cellLines.getAccumulatedValue(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(d)}const g=this._cellUris.get(b.uri);if(g!==void 0){const s=this._cellLines.getAccumulatedValue(g-1);return new _.Position(s+b.range.start.line,b.range.start.character)}return new _.Position(0,0)}locationAt(b){_.Range.isRange(b)||(b=new _.Range(b,b));const g=this._cellLines.getIndexOf(b.start.line);let s=g;b.isEmpty||(s=this._cellLines.getIndexOf(b.end.line));const d=new _.Position(g.remainder,b.start.character),S=new _.Position(s.remainder,b.end.character),v=new _.Range(d,S),E=this._cells[g.index];return new _.Location(E.document.uri,E.document.validateRange(v))}contains(b){return this._cellUris.has(b)}validateRange(b){const g=this.validatePosition(b.start),s=this.validatePosition(b.end);return b.with(g,s)}validatePosition(b){const g=this._cellLines.getIndexOf(b.line),s=new _.Position(g.remainder,b.character),d=this._cells[g.index].document.validatePosition(s),S=this._cellLines.getAccumulatedValue(g.index-1);return new _.Position(S+d.line,d.character)}}e.ExtHostNotebookConcatDocument=R}),define(ge[198],ve([0,1,7,13,3]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(A){this._actual=new _.ColorTheme(_.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new T.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let y=A==="light"?_.ColorThemeKind.Light:A==="dark"?_.ColorThemeKind.Dark:_.ColorThemeKind.HighContrast;this._actual=new _.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=je([Ue(0,I.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(ge[61],ve([0,1,4]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,_.createDecorator)("IURITransformerService");class I{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=I}),define(ge[199],ve([0,1,22]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(y){let n=this.buffers.indexOf(y);return n<0&&(n=this.buffers.length,this.buffers.push(y)),n}}function T(A,y){if(y){const n=new I,R=(g,s)=>{if(s instanceof ArrayBuffer){const d=n.add(s);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(s)){const d=P(s);if(d){const S=n.add(s.buffer);return{$$vscode_array_buffer_reference$$:!0,index:S,view:{type:d,byteLength:s.byteLength,byteOffset:s.byteOffset}}}}return s},D=JSON.stringify(A,R),b=n.buffers.map(g=>{const s=new Uint8Array(g);return _.VSBuffer.wrap(s)});return{message:D,buffers:b}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=T;function P(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(A,y){const n=y.map(b=>{const g=new ArrayBuffer(b.byteLength);return new Uint8Array(g).set(b.buffer),g}),R=y.length?(b,g)=>{if(typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const s=g,{index:d}=s,S=n[d];if(s.view)switch(s.view.type){case 1:return new Int8Array(S,s.view.byteOffset,s.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(S,s.view.byteOffset,s.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(S,s.view.byteOffset,s.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(S,s.view.byteOffset,s.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(S,s.view.byteOffset,s.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(S,s.view.byteOffset,s.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(S,s.view.byteOffset,s.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(S,s.view.byteOffset,s.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(S,s.view.byteOffset,s.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(S,s.view.byteOffset,s.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(S,s.view.byteOffset,s.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return S}return g}:void 0;return{message:JSON.parse(A,R),arrayBuffers:n}}e.deserializeWebviewMessage=C}),define(ge[84],ve([0,1,2]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function I(P,C,A){const y=P.webviewResourceRoot.replace("{{resource}}",A.scheme+T(A)).replace("{{uuid}}",C);return _.URI.parse(y)}e.asWebviewUri=I;function T(P){return P.toString().replace(/^\S+?:/,"")}}),define(ge[200],ve([0,1,3,6,84,28]),function(Q,e,_,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(y,n,R){this._proxy=y,this._editors=n,this._initData=R,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(n.onDidChangeVisibleTextEditors(()=>{const D=n.getVisibleTextEditors();for(const b of this._insets.values())D.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,n,R,D,b){let g;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===y){g=l;break}if(!g)throw new Error("not a visible editor");const s=this,d=this._handlePool++,S=new _.Emitter,v=new _.Emitter,E=new class{constructor(){this._uuid=(0,P.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,T.asWebviewUri)(s._initData,this._uuid,l)}get cspSource(){return s._initData.webviewCspSource}set options(l){this._options=l,s._proxy.$setOptions(d,l)}get options(){return this._options}set html(l){this._html=l,s._proxy.$setHtml(d,l)}get html(){return this._html}get onDidReceiveMessage(){return S.event}postMessage(l){return s._proxy.$postMessage(d,l)}},m=new class{constructor(){this.editor=y,this.line=n,this.height=R,this.webview=E,this.onDidDispose=v.event}dispose(){s._insets.has(d)&&(s._insets.delete(d),s._proxy.$disposeEditorInset(d),v.fire(),v.dispose(),S.dispose())}};return this._proxy.$createEditorInset(d,g.id,g.value.document.uri,n+1,R,D||{},b.identifier,b.extensionLocation),this._insets.set(d,{editor:y,inset:m,onDidReceiveMessage:S}),m}$onDidDispose(y){const n=this._insets.get(y);n&&n.inset.dispose()}$onDidReceiveMessage(y,n){const R=this._insets.get(y);R&&R.onDidReceiveMessage.fire(n)}}e.ExtHostEditorInsets=C}),define(ge[201],ve([0,1,3,80,168,4,6,24,40,14,53,23,47,193]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,g.registerIcon)("default-view-icon",b.Codicon.window,(0,T.localize)(0,null));var s;(function(c){c.ViewContainersRegistry="workbench.registry.view.containers",c.ViewsRegistry="workbench.registry.view"})(s=e.Extensions||(e.Extensions={}));var d;(function(c){c[c.Sidebar=0]="Sidebar",c[c.Panel=1]="Panel"})(d=e.ViewContainerLocation||(e.ViewContainerLocation={}));function S(c){switch(c){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=S;function v(c){return`viewContainer.${c}.enabled`}e.getEnabledViewContainerContextKey=v;class E extends C.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new _.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new _.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,n.flatten)([...this.viewContainers.values()])}registerViewContainer(h,p,w){var u;const f=this.get(h.id);if(f)return f;const k=h;return k.openCommandActionDescriptor=(w==null?void 0:w.donotRegisterOpenCommand)?void 0:(u=k.openCommandActionDescriptor)!==null&&u!==void 0?u:{id:k.id},(0,A.getOrSet)(this.viewContainers,p,[]).push(k),(w==null?void 0:w.isDefault)&&this.defaultViewContainers.push(k),this._onDidRegister.fire({viewContainer:k,viewContainerLocation:p}),k}deregisterViewContainer(h){for(const p of this.viewContainers.keys()){const w=this.viewContainers.get(p),u=w==null?void 0:w.indexOf(h);if(u!==-1){w==null||w.splice(u,1),w.length===0&&this.viewContainers.delete(p),this._onDidDeregister.fire({viewContainer:h,viewContainerLocation:p});return}}}get(h){return this.all.filter(p=>p.id===h)[0]}getViewContainers(h){return[...this.viewContainers.get(h)||[]]}getViewContainerLocation(h){return[...this.viewContainers.keys()].filter(p=>this.getViewContainers(p).filter(w=>(w==null?void 0:w.id)===h.id).length>0)[0]}getDefaultViewContainer(h){return this.defaultViewContainers.find(p=>this.getViewContainerLocation(p)===h)}}y.Registry.add(s.ViewContainersRegistry,new E);var m;(function(c){c.Open="2_open",c.Debug="4_debug",c.SCM="5_scm",c.More="9_more"})(m=e.ViewContentGroups||(e.ViewContentGroups={}));function l(c,h){var p,w,u,f;const k=(p=c.group)!==null&&p!==void 0?p:m.More,L=(w=h.group)!==null&&w!==void 0?w:m.More;return k!==L?k.localeCompare(L):((u=c.order)!==null&&u!==void 0?u:5)-((f=h.order)!==null&&f!==void 0?f:5)}class o extends C.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new _.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new _.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new _.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new _.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new R.SetMap}registerViews(h,p){this.registerViews2([{views:h,viewContainer:p}])}registerViews2(h){h.forEach(({views:p,viewContainer:w})=>this.addViews(p,w)),this._onViewsRegistered.fire(h)}deregisterViews(h,p){const w=this.removeViews(h,p);w.length&&this._onViewsDeregistered.fire({views:w,viewContainer:p})}moveViews(h,p){for(const w of this._views.keys())if(w!==p){const u=this.removeViews(h,w);u.length&&(this.addViews(u,p),this._onDidChangeContainer.fire({views:u,from:w,to:p}))}}getViews(h){return this._views.get(h)||[]}getView(h){for(const p of this._viewContainers){const w=(this._views.get(p)||[]).filter(u=>u.id===h)[0];if(w)return w}return null}getViewContainer(h){for(const p of this._viewContainers)if((this._views.get(p)||[]).filter(u=>u.id===h)[0])return p;return null}registerViewWelcomeContent(h,p){return this._viewWelcomeContents.add(h,p),this._onDidChangeViewWelcomeContent.fire(h),(0,C.toDisposable)(()=>{this._viewWelcomeContents.delete(h,p),this._onDidChangeViewWelcomeContent.fire(h)})}registerViewWelcomeContent2(h,p){const w=new Map;for(const[u,f]of p)this._viewWelcomeContents.add(h,f),w.set(u,(0,C.toDisposable)(()=>{this._viewWelcomeContents.delete(h,f),this._onDidChangeViewWelcomeContent.fire(h)}));return this._onDidChangeViewWelcomeContent.fire(h),w}getViewWelcomeContent(h){const p=[];return this._viewWelcomeContents.forEach(h,w=>p.push(w)),p.sort(l)}addViews(h,p){let w=this._views.get(p);w||(w=[],this._views.set(p,w),this._viewContainers.push(p));for(const u of h){if(this.getView(u.id)!==null)throw new Error((0,T.localize)(1,null,u.id));w.push(u)}}removeViews(h,p){const w=this._views.get(p);if(!w)return[];const u=[],f=[];for(const k of w)h.includes(k)?u.push(k):f.push(k);return u.length&&(f.length?this._views.set(p,f):(this._views.delete(p),this._viewContainers.splice(this._viewContainers.indexOf(p),1))),u}}y.Registry.add(s.ViewsRegistry,new o),e.IViewsService=(0,P.createDecorator)("viewsService"),e.FocusedViewContext=new I.RawContextKey("focusedView","",(0,T.localize)(2,null));function t(c){return`view.${c}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,P.createDecorator)("viewDescriptorService");var i;(function(c){c[c.Default=0]="Default",c[c.Expand=1]="Expand"})(i=e.ViewVisibilityState||(e.ViewVisibilityState={}));var a;(function(c){c[c.None=0]="None",c[c.Collapsed=1]="Collapsed",c[c.Expanded=2]="Expanded"})(a=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(h,p){this.resolved=!1,this._hasResolve=!1,(0,D.mixin)(this,h),this._hasResolve=!!p,this.resolve=async w=>{var u,f;if(p&&!this.resolved){const k=await p(w);k&&(this.tooltip=(u=this.tooltip)!==null&&u!==void 0?u:k.tooltip,this.command=(f=this.command)!==null&&f!==void 0?f:k.command)}w.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r}),define(ge[202],ve([0,1,2,180,115,12,181,201]),function(Q,e,_,I,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(d){return(S,...v)=>d(S.get(I.ICommandService),...v)}class n{static execute(S,v){const E={forceReuseWindow:v&&v.reuseWindow,remoteAuthority:v&&v.remoteAuthority};return S.executeCommand("_files.newWindow",E)}}e.NewWindowAPICommand=n,n.ID="vscode.newWindow",I.CommandsRegistry.registerCommand({id:n.ID,handler:y(n.execute),description:{description:"Opens an new window",args:[]}}),I.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(d,S){return d.get(T.IWorkspacesService).removeRecentlyOpened([S])});class R{static execute(S,v){return typeof v=="string"?v=v.match(/^[^:/?#]+:\/\//)?_.URI.parse(v):_.URI.file(v):v=_.URI.revive(v),S.executeCommand("_workbench.removeFromRecentlyOpened",v)}}e.RemoveFromRecentlyOpenedAPICommand=R,R.ID="vscode.removeFromRecentlyOpened",I.CommandsRegistry.registerCommand(R.ID,y(R.execute));class D{static execute(S,v){const E=typeof v=="string"?{extensionId:v}:v;return S.executeCommand("workbench.action.openIssueReporter",E)}}e.OpenIssueReporter=D,D.ID="vscode.openIssueReporter",I.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(d,S){const v=d.get(T.IWorkspacesService);let E;const m=S.uri,l=S.label,o=S.remoteAuthority;return S.type==="workspace"?E={workspace:await v.getWorkspaceIdentifier(m),label:l,remoteAuthority:o}:S.type==="folder"?E={folderUri:m,label:l,remoteAuthority:o}:E={fileUri:m,label:l,remoteAuthority:o},v.addRecentlyOpened([E])}),I.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(d){return d.get(T.IWorkspacesService).getRecentlyOpened()}),I.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(d,S){const v=d.get(P.ILogService),E=d.get(C.IEnvironmentService);E.isExtensionDevelopment&&!!E.extensionTestsLocationURI&&v.setLevel(S)}),I.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(d){return d.get(P.ILogService).getLevel()}),I.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(d,S){const v=d.get(A.IViewDescriptorService),E=v.getViewContainerById(S.destinationId);if(!!E){for(const m of S.viewIds){const l=v.getViewDescriptorById(m);(l==null?void 0:l.canMoveView)&&v.moveViewsToContainer([l],E,A.ViewVisibilityState.Default)}await d.get(A.IViewsService).openViewContainer(E.id,!0)}});class b{static execute(S,v){return!Array.isArray(v==null?void 0:v.viewIds)||typeof(v==null?void 0:v.destinationId)!="string"?Promise.reject("Invalid arguments"):S.executeCommand("_workbench.action.moveViews",v)}}e.MoveViewsAPICommand=b,b.ID="vscode.moveViews",I.CommandsRegistry.registerCommand({id:b.ID,handler:y(b.execute),description:{description:"Move Views",args:[]}});class g{static execute(S,v){return S.executeCommand("_workbench.open",v)}}g.ID="vscode.open",I.CommandsRegistry.registerCommand(g.ID,y(g.execute));class s{static execute(S,v,E,m,l){return S.executeCommand("_workbench.diff",[v,E,m])}}s.ID="vscode.diff",I.CommandsRegistry.registerCommand(s.ID,y(s.execute))}),define(ge[119],ve([0,1,3,19,169]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new _.Emitter,this._onExit=new _.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,y,n,R){const D={command:A};if(y&&Object.keys(y).length>0&&(D.arguments=y),this.internalSend("request",D),typeof R=="number"){const b=setTimeout(()=>{clearTimeout(b);const g=this.pendingRequests.get(D.seq);if(g){this.pendingRequests.delete(D.seq);const s={type:"response",seq:0,request_seq:D.seq,success:!1,command:A,message:(0,T.localize)(0,null,R,A)};g(s)}},R)}return n&&this.pendingRequests.set(D.seq,n),D.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,y){return A.type!=="event"||y.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,I.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback&&this.eventCallback(A);break;case"request":this.requestCallback&&this.requestCallback(A);break;case"response":const y=A,n=this.pendingRequests.get(y.request_seq);n&&(this.pendingRequests.delete(y.request_seq),n(y));break}}}internalSend(A,y){y.type=A,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((y,n)=>A.set(n,y)),await(0,I.timeout)(500),A.forEach((y,n)=>{y({type:"response",seq:0,request_seq:n,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(n)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(ge[203],ve([0,1,10,2,8,23,11]),function(Q,e,_,I,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function y(i,a,r){return i.replace(A,function(c,h){return a&&h.length>0&&h[0]!=="_"?c:r&&r.hasOwnProperty(h)?r[h]:c})}e.formatPII=y;function n(i){const a={};for(const r of Object.keys(i))r.startsWith("!")||(a[r]=i[r]);return a}e.filterExceptionsFromTelemetry=n;function R(i){return i.configuration.request==="attach"&&!D(i)}e.isSessionAttach=R;function D(i){let a=i.configuration.type;if(!!a)return a==="vslsShare"&&(a=i.configuration.adapterProxy.configuration.type),(0,_.equalsIgnoreCase)(a,"extensionhost")||(0,_.equalsIgnoreCase)(a,"pwa-extensionhost")?i:i.parentSession?D(i.parentSession):void 0}e.getExtensionHostDebugSession=D;function b(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=b;function g(i,a,r){let c,h=0,p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,w=null;for(;w=p.exec(i);){let u=w.index+1,f=u+w[0].length;if(u<=a&&f>=r){c=w[0],h=u;break}}if(c){let u=/\w+/g,f=null;for(;(f=u.exec(c))&&!(f.index+1+h+f[0].length>=r););f&&(c=c.substring(0,u.lastIndex))}return c?{start:h,end:h+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(i){return!!(i&&i.match(s))}e.isUri=d;function S(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(d(i.path))return I.URI.parse(i.path);if((0,T.isAbsolute)(i.path))return I.URI.file(i.path)}return i.path}function v(i){if(typeof i.path=="object"){const a=I.URI.revive(i.path);if(a)return a.scheme===C.Schemas.file?a.fsPath:a.toString()}return i.path}function E(i,a){const r=a?S:v,c=(0,P.deepClone)(i);return l(c,(h,p)=>{h&&p&&(p.path=r(p))}),c}e.convertToDAPaths=E;function m(i,a){const r=a?S:v,c=(0,P.deepClone)(i);return l(c,(h,p)=>{!h&&p&&(p.path=r(p))}),c}e.convertToVSCPaths=m;function l(i,a){switch(i.type){case"event":const r=i;switch(r.event){case"output":a(!1,r.body.source);break;case"loadedSource":a(!1,r.body.source);break;case"breakpoint":a(!1,r.body.breakpoint.source);break;default:break}break;case"request":const c=i;switch(c.command){case"setBreakpoints":a(!0,c.arguments.source);break;case"breakpointLocations":a(!0,c.arguments.source);break;case"source":a(!0,c.arguments.source);break;case"gotoTargets":a(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(p=>a(!1,p));break;default:break}break;case"response":const h=i;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(p=>a(!1,p.source));break;case"loadedSources":h.body.sources.forEach(p=>a(!1,p));break;case"scopes":h.body.scopes.forEach(p=>a(!1,p.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(p=>a(!1,p.source));break;case"setBreakpoints":h.body.breakpoints.forEach(p=>a(!1,p.source));break;default:break}break}}function o(i){return i.filter(a=>{var r;return!((r=a.presentation)===null||r===void 0?void 0:r.hidden)}).sort((a,r)=>a.presentation?r.presentation?a.presentation.group?r.presentation.group?a.presentation.group!==r.presentation.group?a.presentation.group.localeCompare(r.presentation.group):t(a.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(a.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=o;function t(i,a){return typeof i!="number"?typeof a!="number"?0:1:typeof a!="number"?-1:i-a}}),define(ge[204],ve([0,1,26,38,170,120,8,10,23,9,182,119]),function(Q,e,_,I,T,P,C,A,y,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class b extends D.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(E,m){this.outputStream=m,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,E.on("data",l=>this.handleData(l))}sendMessage(E){if(this.outputStream){const m=JSON.stringify(E);this.outputStream.write(`Content-Length: ${Buffer.byteLength(m,"utf8")}${b.TWO_CRLF}${m}`,"utf8")}}handleData(E){for(this.rawData=Buffer.concat([this.rawData,E]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const m=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,m.length>0)try{this.acceptMessage(JSON.parse(m))}catch(l){this._onError.fire(new Error((l.message||l)+`
`+m))}continue}}else{const m=this.rawData.indexOf(b.TWO_CRLF);if(m!==-1){const o=this.rawData.toString("utf8",0,m).split(b.HEADER_LINESEPARATOR);for(const t of o){const i=t.split(b.HEADER_FIELDSEPARATOR);i[0]==="Content-Length"&&(this.contentLength=Number(i[1]))}this.rawData=this.rawData.slice(m+b.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=b,b.TWO_CRLF=`\r
\r
`,b.HEADER_LINESEPARATOR=/\r?\n/,b.HEADER_FIELDSEPARATOR=/: */;class g extends b{startSession(){return new Promise((E,m)=>{let l=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),E(),l=!0}),this.socket.on("close",()=>{l?this._onError.fire(new Error("connection closed")):m(new Error("connection closed"))}),this.socket.on("error",o=>{l?this._onError.fire(o):m(o)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=g;class s extends g{constructor(E){super();this.adapterServer=E}createConnection(E){return P.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",E)}}e.SocketDebugAdapter=s;class d extends g{constructor(E){super();this.adapterServer=E}createConnection(E){return P.createConnection(this.adapterServer.path,E)}}e.NamedPipeDebugAdapter=d;class S extends b{constructor(E,m,l){super();this.adapterExecutable=E,this.debugType=m,this.outputService=l}async startSession(){const E=this.adapterExecutable.command,m=this.adapterExecutable.args,l=this.adapterExecutable.options||{};try{if(E)if(C.isAbsolute(E)){if(!await(0,_.exists)(E))throw new Error(T.localize(0,null,E))}else E.indexOf("/")<0&&E.indexOf("\\")<0;else throw new Error(T.localize(1,null,this.debugType));let o=process.env;if(l.env&&Object.keys(l.env).length>0&&(o=y.mixin(y.deepClone(process.env),l.env)),E==="node")if(Array.isArray(m)&&m.length>0){const i=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,a={env:o,execArgv:i?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};l.cwd&&(a.cwd=l.cwd);const r=I.fork(m[0],m.slice(1),a);if(!r.pid)throw new Error(T.localize(2,null,m[0]));this.serverProcess=r}else throw new Error(T.localize(3,null));else{const i={env:o};l.cwd&&(i.cwd=l.cwd),this.serverProcess=I.spawn(E,m,i)}this.serverProcess.on("error",i=>{this._onError.fire(i)}),this.serverProcess.on("exit",(i,a)=>{this._onExit.fire(i)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",i=>{this._onError.fire(i)}),this.serverProcess.stdin.on("error",i=>{this._onError.fire(i)});const t=this.outputService;if(t){const i=a=>a.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",a=>{const r=t.getChannel(R.ExtensionsChannelId);r&&r.append(i(a))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(o){this._onError.fire(o)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),n.isWindows?new Promise((E,m)=>{const l=I.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(o,t,i){if(o)return m(o)});l.on("exit",E),l.on("error",m)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(E,m){if(!!E){const l=Object.create(null);E.runtime&&(E.runtime.indexOf("./")===0?l.runtime=C.join(m,E.runtime):l.runtime=E.runtime),E.runtimeArgs&&(l.runtimeArgs=E.runtimeArgs),E.program&&(C.isAbsolute(E.program)?l.program=E.program:l.program=C.join(m,E.program)),E.args&&(l.args=E.args);const o=E;return o.win&&(l.win=S.extract(o.win,m)),o.winx86&&(l.winx86=S.extract(o.winx86,m)),o.windows&&(l.windows=S.extract(o.windows,m)),o.osx&&(l.osx=S.extract(o.osx,m)),o.linux&&(l.linux=S.extract(o.linux,m)),l}}static platformAdapterExecutable(E,m){let l=Object.create(null);m=m.toLowerCase();for(const c of E)if(c.contributes){const h=c.contributes.debuggers;h&&h.length>0&&h.filter(p=>typeof p.type=="string"&&A.equalsIgnoreCase(p.type,m)).forEach(p=>{const w=S.extract(p,c.extensionLocation.fsPath);l=y.mixin(l,w,c.isBuiltin)})}let o;n.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=l.winx86||l.win||l.windows:n.isWindows?o=l.win||l.windows:n.isMacintosh?o=l.osx:n.isLinux&&(o=l.linux),o=o||l;let t=o.program||l.program;const i=o.args||l.args;let a=o.runtime||l.runtime;const r=o.runtimeArgs||l.runtimeArgs;if(a)return{type:"executable",command:a,args:(r||[]).concat(typeof t=="string"?[t]:[]).concat(i||[])};if(t)return{type:"executable",command:t,args:i||[]}}}e.ExecutableDebugAdapter=S}),define(ge[205],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=void 0,e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(ge[206],ve([0,1,38,8,77,171,26,9,83,4,205,11]),function(Q,e,_,I,T,P,C,A,y,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const b=P.localize(0,null);let g=class $t{constructor(m){this._configurationService=m}openTerminal(m){if(this._configurationService){const l=this._configurationService.getValue();this.spawnTerminal(_,l,T.getWindowsShell(),m)}}runInTerminal(m,l,o,t,i){const a=i.windowsExec||$t.getDefaultTerminalWindows();return new Promise((r,c)=>{const h=`"${l} - ${b}"`,p=`""${o.join('" "')}" & pause"`,w=["/c","start",h,"/wait",a,"/c",p],u=Object.assign({},process.env,t);Object.keys(u).filter(L=>u[L]===null).forEach(L=>delete u[L]);const f={cwd:l,env:u,windowsVerbatimArguments:!0};_.spawn($t.CMD,w,f).on("error",L=>{c(S(L))}),r(void 0)})}spawnTerminal(m,l,o,t){const a=l.terminal.external.windowsExec||$t.getDefaultTerminalWindows();t&&t[1]===":"&&(t=t[0].toUpperCase()+t.substr(1));const r=I.basename(a).toLowerCase();if(r==="cmder"||r==="cmder.exe")return m.spawn(a,t?[t]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return a.indexOf(" ")>=0&&c.push('""'),c.push(a),(r==="wt"||r==="wt.exe")&&c.push("-d ."),new Promise((h,p)=>{const w=t?{cwd:t}:void 0,u=m.spawn(o,c,w);u.on("error",p),u.on("exit",()=>h())})}static getDefaultTerminalWindows(){if(!$t._DEFAULT_TERMINAL_WINDOWS){const m=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");$t._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${m?"Sysnative":"System32"}\\cmd.exe`}return $t._DEFAULT_TERMINAL_WINDOWS}};g.CMD="cmd.exe",g=je([Ue(0,(0,n.optional)(y.IConfigurationService))],g),e.WindowsExternalTerminalService=g;let s=class Rn{constructor(m){this._configurationService=m}openTerminal(m){if(this._configurationService){const l=this._configurationService.getValue();this.spawnTerminal(_,l,m)}}runInTerminal(m,l,o,t,i){const a=i.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((r,c)=>{if(a===R.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const h=a===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",w=[D.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${h}.scpt`,Q).fsPath,"-t",m||b,"-w",l];for(let k of o)w.push("-a"),w.push(k);if(t)for(let k in t){const L=t[k];L===null?(w.push("-u"),w.push(k)):(w.push("-e"),w.push(`${k}=${L}`))}let u="";const f=_.spawn(Rn.OSASCRIPT,w);f.on("error",k=>{c(S(k))}),f.stderr.on("data",k=>{u+=k.toString()}),f.on("exit",k=>{if(k===0)r(void 0);else if(u){const L=u.split(`
`,1);c(new Error(L[0]))}else c(new Error(P.localize(1,null,h,k)))})}else c(new Error(P.localize(2,null,a)))})}spawnTerminal(m,l,o){const i=l.terminal.external.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((a,r)=>{const c=["-a",i];o&&c.push(o);const h=m.spawn("/usr/bin/open",c);h.on("error",r),h.on("exit",()=>a())})}};s.OSASCRIPT="/usr/bin/osascript",s=je([Ue(0,(0,n.optional)(y.IConfigurationService))],s),e.MacExternalTerminalService=s;let d=class Ht{constructor(m){this._configurationService=m}openTerminal(m){if(this._configurationService){const l=this._configurationService.getValue();this.spawnTerminal(_,l,m)}}runInTerminal(m,l,o,t,i){const a=i.linuxExec?Promise.resolve(i.linuxExec):Ht.getDefaultTerminalLinuxReady();return new Promise((r,c)=>{let h=[];a.then(p=>{p.indexOf("gnome-terminal")>=0?h.push("-x"):h.push("-e"),h.push("bash"),h.push("-c");const w=`${v(o)}; echo; read -p "${Ht.WAIT_MESSAGE}" -n1;`;h.push(`''${w}''`);const u=Object.assign({},process.env,t);Object.keys(u).filter($=>u[$]===null).forEach($=>delete u[$]);const f={cwd:l,env:u};let k="";const L=_.spawn(p,h,f);L.on("error",$=>{c(S($))}),L.stderr.on("data",$=>{k+=$.toString()}),L.on("exit",$=>{if($===0)r(void 0);else if(k){const te=k.split(`
`,1);c(new Error(te[0]))}else c(new Error(P.localize(4,null,p,$)))})})})}spawnTerminal(m,l,o){const t=l.terminal.external,i=t.linuxExec?Promise.resolve(t.linuxExec):Ht.getDefaultTerminalLinuxReady();return new Promise((a,r)=>{i.then(c=>{const h=o?{cwd:o}:void 0,p=m.spawn(c,[],h);p.on("error",r),p.on("exit",()=>a())})})}static async getDefaultTerminalLinuxReady(){return Ht._DEFAULT_TERMINAL_LINUX_READY||(Ht._DEFAULT_TERMINAL_LINUX_READY=new Promise(async m=>{A.isLinux?await C.exists("/etc/debian_version")?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm"):m("xterm")})),Ht._DEFAULT_TERMINAL_LINUX_READY}};d.WAIT_MESSAGE=P.localize(3,null),d=je([Ue(0,(0,n.optional)(y.IConfigurationService))],d),e.LinuxExternalTerminalService=d;function S(E){return"errno"in E&&E.errno==="ENOENT"&&"path"in E&&typeof E.path=="string"?new Error(P.localize(5,null,E.path)):E}function v(E){let m="";for(let l of E)l.indexOf(" ")>=0?m+='"'+l+'"':m+=l,m+=" ";return m}}),define(ge[207],ve([0,1,38,9,206,31]),function(Q,e,_,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;let C;function A(b,g){if(!C)if(I.isWindows)C=new T.WindowsExternalTerminalService(void 0);else if(I.isMacintosh)C=new T.MacExternalTerminalService(void 0);else if(I.isLinux)C=new T.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const s=g.getConfiguration("terminal");return C.runInTerminal(b.title,b.cwd,b.args,b.env||{},s.external||{})}e.runInExternalTerminal=A;function y(b,g){return new Promise((s,d)=>{let S="";const v=_.spawn(b,g);v.pid&&v.stdout.on("data",E=>{S+=E.toString()}),v.on("error",E=>{d(E)}),v.on("close",E=>{s(S)})})}function n(b){return b?I.isWindows?y("wmic",["process","get","ParentProcessId"]).then(g=>g.split(`\r
`).some(d=>parseInt(d)===b),g=>!0):y("/usr/bin/pgrep",["-lP",String(b)]).then(g=>{const s=g.trim();return!(s.length===0||s.indexOf(" tmux")>=0)},g=>!0):Promise.resolve(!0)}e.hasChildProcesses=n;var R;(function(b){b[b.cmd=0]="cmd",b[b.powershell=1]="powershell",b[b.bash=2]="bash"})(R||(R={}));function D(b,g,s,d){b=b.trim().toLowerCase();let S;b.indexOf("powershell")>=0||b.indexOf("pwsh")>=0?S=1:b.indexOf("cmd.exe")>=0?S=0:b.indexOf("bash")>=0?S=2:I.isWindows?S=0:S=2;let v,E=" ";switch(S){case 1:if(v=l=>(l=l.replace(/\'/g,"''"),l.length>0&&l.charAt(l.length-1)==="\\"?`'${l}\\'`:`'${l}'`),s){const l=(0,P.getDriveLetter)(s);l&&(E+=`${l}:; `),E+=`cd ${v(s)}; `}if(d)for(let l in d){const o=d[l];o===null?E+=`Remove-Item env:${l}; `:E+=`\${env:${l}}='${o}'; `}if(g.length>0){const l=v(g.shift());E+=l[0]==="'"?`& ${l} `:`${l} `;for(let o of g)E+=`${v(o)} `}break;case 0:if(v=l=>(l=l.replace(/\"/g,'""'),l.indexOf(" ")>=0||l.indexOf('"')>=0||l.length===0?`"${l}"`:l),s){const l=(0,P.getDriveLetter)(s);l&&(E+=`${l}: && `),E+=`cd ${v(s)} && `}if(d){E+='cmd /C "';for(let l in d){let o=d[l];o===null?E+=`set "${l}=" && `:(o=o.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),E+=`set "${l}=${o}" && `)}}for(let l of g)E+=`${v(l)} `;d&&(E+='"');break;case 2:v=l=>(l=l.replace(/(["'\\\$])/g,"\\$1"),l.indexOf(" ")>=0||l.indexOf(";")>=0||l.length===0?`"${l}"`:l);const m=l=>/[^\w@%\/+=,.:^-]/.test(l)?`'${l.replace(/'/g,"'\\''")}'`:l;if(s&&(E+=`cd ${v(s)} ; `),d){E+="/usr/bin/env";for(let l in d){const o=d[l];o===null?E+=` -u ${m(l)}`:E+=` ${m(`${l}=${o}`)}`}E+=" "}for(let l of g)E+=`${v(l)} `;break}return E}e.prepareCommand=D}),define(ge[85],ve([0,1,34,11,8,9,80]),function(Q,e,_,I,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var A;(function(k){k[k.Markdown=1]="Markdown",k[k.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(k){k[k.Running=1]="Running",k[k.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,cellEditable:!0,cellHasExecutionOrder:!0,custom:{},trusted:!0};var n;(function(k){k[k.Idle=1]="Idle",k[k.Pending=2]="Pending",k[k.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var R;(function(k){k[k.ModelChange=1]="ModelChange",k[k.Move=2]="Move",k[k.CellClearOutput=3]="CellClearOutput",k[k.CellsClearOutput=4]="CellsClearOutput",k[k.ChangeLanguage=5]="ChangeLanguage",k[k.Initialize=6]="Initialize",k[k.ChangeCellMetadata=7]="ChangeCellMetadata",k[k.Output=8]="Output",k[k.OutputItem=9]="OutputItem",k[k.ChangeCellContent=10]="ChangeCellContent",k[k.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",k[k.Unknown=12]="Unknown"})(R=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var D;(function(k){k[k.Handle=0]="Handle",k[k.Index=1]="Index"})(D=e.SelectionStateType||(e.SelectionStateType={}));var b;(function(k){k[k.Replace=1]="Replace",k[k.Output=2]="Output",k[k.Metadata=3]="Metadata",k[k.CellLanguage=4]="CellLanguage",k[k.DocumentMetadata=5]="DocumentMetadata",k[k.OutputsSplice=6]="OutputsSplice",k[k.Move=7]="Move",k[k.Unknown=8]="Unknown",k[k.CellContent=9]="CellContent",k[k.OutputItems=10]="OutputItems",k[k.PartialMetadata=11]="PartialMetadata"})(b=e.CellEditType||(e.CellEditType={}));function g(k){const L=s.parse(k);return L?L.notebook.toString():k.toString()}e.getCellUndoRedoComparisonKey=g;var s;(function(k){k.scheme=I.Schemas.vscodeNotebookCell;const L=/^ch(\d{7,})/;function $(B,F){return B.with({scheme:k.scheme,fragment:`ch${F.toString().padStart(7,"0")}${B.scheme!==I.Schemas.file?B.scheme:""}`})}k.generate=$;function te(B){if(B.scheme===k.scheme){const F=L.exec(B.fragment);if(!!F)return{handle:Number(F[1]),notebook:B.with({scheme:B.fragment.substr(F[0].length)||I.Schemas.file,fragment:null})}}}k.parse=te;function H(B,F){return B.with({scheme:I.Schemas.vscodeNotebookCellMetadata,fragment:`ch${F.toString().padStart(7,"0")}${B.scheme!==I.Schemas.file?B.scheme:""}`})}k.generateCellMetadataUri=H;function x(B){if(B.scheme===I.Schemas.vscodeNotebookCellMetadata){const F=L.exec(B.fragment);if(!!F)return{handle:Number(F[1]),notebook:B.with({scheme:B.fragment.substr(F[0].length)||I.Schemas.file,fragment:null})}}}k.parseCellMetadataUri=x})(s=e.CellUri||(e.CellUri={}));const d=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function S(k){var L,$;return($=(L=d.get(k))===null||L===void 0?void 0:L.alwaysSecure)!==null&&$!==void 0?$:!1}e.mimeTypeIsAlwaysSecure=S;function v(k){var L,$;return($=(L=d.get(k))===null||L===void 0?void 0:L.supportedByCore)!==null&&$!==void 0?$:!1}e.mimeTypeSupportedByCore=v;function E(k){var L,$;return($=(L=d.get(k))===null||L===void 0?void 0:L.mergeable)!==null&&$!==void 0?$:!1}e.mimeTypeIsMergeable=E;function m(k,L){return P.isWindows&&(k=k.replace(/\//g,"\\"),L=L.replace(/\//g,"\\")),_.match(k,L)}function l(k,L,$){let te=0;for(let H=0;H<L.length;H++){if(m(L[H],k))return te;te++}for(let H=0;H<$.length;H++){if(m($[H],k))return te;te++}return te}function o(k,L,$){return k.sort((te,H)=>l(te,L,$)-l(H,L,$))}e.sortMimeTypes=o;function t(k,L,$,te=(H,x)=>H===x){const H=[];function x(U,M,N){if(!(M===0&&N.length===0)){const O=H[H.length-1];O&&O.start+O.deleteCount===U?(O.deleteCount+=M,O.toInsert.push(...N)):H.push({start:U,deleteCount:M,toInsert:N})}}let B=0,F=0;for(;;){if(B===k.length){x(B,0,L.slice(F));break}if(F===L.length){x(B,k.length-B,[]);break}const U=k[B],M=L[F];if(te(U,M)){B+=1,F+=1;continue}$(M)?(x(B,1,[]),B+=1):(x(B,0,[M]),F+=1)}return H}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=new C.RawContextKey("notebookEditorCursorAtEditorBeginEnd",!1);var i;(function(k){k.default="default",k.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(k){const L=k;return!!((typeof L.include=="string"||_.isRelativePattern(L.include))&&(typeof L.exclude=="string"||_.isRelativePattern(L.exclude)))}e.isDocumentExcludePattern=a;function r(k,L,$){if(Array.isArray(k.viewType)&&k.viewType.indexOf(L)>=0||k.viewType===L)return!0;if(k.filenamePattern){let te=a(k.filenamePattern)?k.filenamePattern.include:k.filenamePattern,H=a(k.filenamePattern)?k.filenamePattern.exclude:void 0;if(_.match(te,(0,T.basename)($.fsPath).toLowerCase()))return!(H&&_.match(H,(0,T.basename)($.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r;class c{constructor(L){this.textModel=L}getElements(){const L=new Int32Array(this.textModel.cells.length);for(let $=0;$<this.textModel.cells.length;$++)L[$]=this.textModel.cells[$].getHashValue();return L}}e.CellSequence=c,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var h;(function(k){k[k.LEFT=0]="LEFT",k[k.RIGHT=1]="RIGHT"})(h=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function p(k){k.sort(($,te)=>$-te);const L=k.shift();return L===void 0?[]:k.reduce(function($,te){return te<=$[0][1]?$[0][1]=te+1:$.unshift([te,te+1]),$},[[L,L+1]]).reverse().map($=>({start:$[0],end:$[1]}))}e.cellIndexesToRanges=p;function w(k){return k.reduce(($,te)=>{for(let H=te.start;H<te.end;H++)$.push(H);return $},[])}e.cellRangesToIndexes=w;function u(k){const L=k.sort((te,H)=>te.start-H.start),$=L[0];return $?L.reduce((te,H)=>{const x=te[te.length-1];return x.end>=H.start?x.end=Math.max(x.end,H.end):te.push(H),te},[$]):[]}e.reduceRanges=u;function f(k,L){return L.start>=k.start&&L.end<=k.end}e.cellRangeContains=f}),define(ge[208],ve([0,1,173,4,80]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new T.RawContextKey("customExecutionSupported",!0,_.localize(0,null)),e.ShellExecutionSupportedContext=new T.RawContextKey("shellExecutionSupported",!1,_.localize(1,null)),e.ProcessExecutionSupportedContext=new T.RawContextKey("processExecutionSupported",!1,_.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[209],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function _(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=_;function I(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=I}),define(ge[210],ve([0,1,8,9,134]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function P(o,t){if(!!t)if(I.isWindows)for(const i in t){let a=i;for(const c in o)if(i.toLowerCase()===c.toLowerCase()){a=c;break}const r=t[i];r!==void 0&&C(o,a,r)}else Object.keys(t).forEach(i=>{const a=t[i];a!==void 0&&C(o,i,a)})}e.mergeEnvironments=P;function C(o,t,i){typeof i=="string"?o[t]=i:delete o[t]}function A(o,t,i,a){o.TERM_PROGRAM="vscode",t&&(o.TERM_PROGRAM_VERSION=t),R(o,a)&&(o.LANG=D(i)),o.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=A;function y(o,t){if(!!t)for(const i of Object.keys(t)){const a=t[i];a&&(o[i]=a)}}function n(o,t){return Object.keys(t).forEach(i=>{const a=t[i];if(typeof a=="string")try{t[i]=o(a)}catch(r){t[i]=a}}),t}function R(o,t){if(t==="on")return!0;if(t==="auto"){const i=o.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=R;function D(o){const t=o?o.split("-"):[],i=t.length;if(i===0)return"en_US.UTF-8";if(i===1){const a={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in a&&t.push(a[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=D;function b(o,t,i,a,r,c){if(o.cwd){const p=typeof o.cwd=="object"?o.cwd.fsPath:o.cwd,w=g(p,i);return s(w||p)}let h;return!o.ignoreConfigurationCwd&&r&&(i&&(r=g(r,i,c)),r&&(_.isAbsolute(r)?h=r:a&&(h=_.join(a.fsPath,r)))),h||(h=a?a.fsPath:t||""),s(h)}e.getCwd=b;function g(o,t,i){if(t)try{return t(o)}catch(a){i==null||i.error("Could not resolve terminal cwd",a);return}return o}function s(o){return I.platform===3&&o&&o[1]===":"?o[0].toUpperCase()+o.substr(1):o}function d(o){let t=o;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\"));const i=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(i,""),`'${t}'`}e.escapeNonWindowsPath=d;function S(o,t){if(!!t)return i=>t.resolve(o,i)}e.createVariableResolver=S;function v(o,t,i,a,r,c,h,p,w=I.platform){let u=null;p&&(u=m(o,t,"automationShell",w)),u||(u=m(o,t,"shell",w));let f=u||i;if(w===3&&!a&&r){const k=_.join(r,"Sysnative").replace(/\//g,"\\").toLowerCase();f&&f.toLowerCase().indexOf(k)===0&&(f=_.join(r,"System32",f.substr(k.length+1)))}if(f&&w===3&&(f=f.replace(/\//g,"\\")),c)try{f=c(f)}catch(k){h.error("Could not resolve shell",k)}return f}e.getDefaultShell=v;function E(o,t,i,a,r,c=I.platform){if(i&&m(o,t,"automationShell",c))return[];const h=c===3?"windows":c===1?"osx":"linux",p=o(`terminal.integrated.shellArgs.${h}`);let w=(t?p.value:p.userValue)||p.defaultValue;if(!w)return[];if(typeof w=="string"&&c===3)return a?a(w):w;if(a){const u=[];for(const f of w)try{u.push(a(f))}catch(k){r.error(`Could not resolve terminal.integrated.shellArgs.${h}`,k),u.push(f)}w=u}return w}e.getDefaultShellArgs=E;function m(o,t,i,a=I.platform){const c=o(`terminal.integrated.${i}.${a===3?"windows":a===1?"osx":"linux"}`);return(t?c.value:c.userValue)||c.defaultValue}function l(o,t,i,a,r,c,h){let p={};if(o.strictEnv)y(p,o.env);else{y(p,h);const w=Object.assign({},a?t.value:t.userValue);i&&(w&&n(i,w),o.env&&n(i,o.env)),(0,T.sanitizeProcessEnvironment)(p,"VSCODE_IPC_HOOK_CLI"),P(p,w),P(p,o.env),A(p,r,I.locale,c)}return p}e.createTerminalEnvironment=l});var rn=this&&this.__asyncValues||function(Q){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Q[Symbol.asyncIterator],_;return e?e.call(Q):(Q=typeof __values=="function"?__values(Q):Q[Symbol.iterator](),_={},I("next"),I("throw"),I("return"),_[Symbol.asyncIterator]=function(){return this},_);function I(P){_[P]=Q[P]&&function(C){return new Promise(function(A,y){C=Q[P](C),T(A,y,C.done,C.value)})}}function T(P,C,A,y){Promise.resolve(y).then(function(n){P({value:n,done:A})},C)}};define(ge[211],ve([0,1,37,9,8,100,190,38,26]),function(Q,e,_,I,T,P,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function R(m,l,o,t,i,a,r){return l=l||{existsFile:y.SymlinkSupport.existsFile,readFile:_.promises.readFile},I.isWindows?D(m,l,o,t==null?void 0:t.useWslProfiles,t==null?void 0:t.profiles.windows,i,a):S(l,o,m,I.isMacintosh?t==null?void 0:t.profiles.osx:t==null?void 0:t.profiles.linux,r,i,a)}e.detectAvailableProfiles=R;async function D(m,l,o,t,i,a,r){const c=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),h=`${process.env.windir}\\${c?"Sysnative":"System32"}`;let p=!1;(0,C.getWindowsBuildNumber)()>=16299&&(p=!0),await g();const w=new Map;m||(w.set("PowerShell",{source:"PowerShell",isAutoDetected:!0}),w.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),w.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),w.set("Command Prompt",{path:[`${h}\\cmd.exe`],isAutoDetected:!0})),v(i,w);const u=await b(w.entries(),l,o,a,r);if(!m||m&&t)try{const f=await d(`${h}\\${p?"wsl.exe":"bash.exe"}`,t);f&&u.push(...f)}catch(f){o==null||o.info("WSL is not installed, so could not detect WSL profiles")}return u}async function b(m,l,o,t,i){const a=[];for(const[r,c]of m)if(c!==null){let h,p,w;if("source"in c){const k=n==null?void 0:n.get(c.source);if(!k)continue;h=k.paths,p=c.args||k.args,w=c.icon||k.icon}else h=Array.isArray(c.path)?c.path:[c.path],p=I.isWindows||Array.isArray(c.args)?c.args:void 0,w=c.icon;const u=h.slice();for(let k=0;k<u.length;k++)u[k]=await(t==null?void 0:t.resolveAsync(i,u[k]))||u[k];const f=await E(r,u,l,p,c.overrideName,c.isAutoDetected,o);f?(f.isAutoDetected=c.isAutoDetected,f.icon=w,a.push(f)):o==null||o.trace("profile not validated",r,h)}return a}async function g(){n||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`],args:["--login"]}),n.set("Cygwin",{profileName:"Cygwin",paths:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:await s(),icon:"plug"}))}async function s(){var m,l;const o=[];try{for(var t=rn((0,P.enumeratePowerShellInstallations)()),i;i=await t.next(),!i.done;){const a=i.value;o.push(a.exePath)}}catch(a){m={error:a}}finally{try{i&&!i.done&&(l=t.return)&&await l.call(t)}finally{if(m)throw m.error}}return o}async function d(m,l){const o=[];if(l){const t=await new Promise((i,a)=>{A.exec("wsl.exe -l",{encoding:"utf16le"},(r,c)=>{if(r)return a("Problem occurred when getting wsl distros");i(c)})});if(t){const i=new RegExp(/[\r?\n]/),a=t.split(i).filter(r=>r.trim().length>0&&r!=="");a.shift();for(let r of a)if(r=r.replace(/ \(Default\)$/,""),r!==""&&!r.startsWith("docker-desktop")){const c={profileName:`${r} (WSL)`,path:m,args:["-d",`${r}`]};r.includes("Ubuntu")&&(c.icon="ruby"),r.includes("Debian")&&(c.icon="star-full"),o.push(c)}return o}}return[]}async function S(m,l,o,t,i,a,r){const c=new Map;if(!o){const h=await m.readFile("/etc/shells","utf8"),p=i||h.split(`
`).filter(u=>u.trim().indexOf("#")!==0&&u.trim().length>0),w=new Map;for(const u of p){let f=(0,T.basename)(u),k=w.get(f)||0;k++,k>1&&(f=`${f} (${k})`),w.set(f,k),c.set(f,{path:u,isAutoDetected:!0})}}return v(t,c),await b(c.entries(),m,l,a,r)}function v(m,l){if(!!m)for(const[o,t]of Object.entries(m))t===null||!("path"in t)&&!("source"in t)?l.delete(o):l.set(o,t)}async function E(m,l,o,t,i,a,r){if(l.length===0)return Promise.resolve(void 0);const c=l.shift();if(c==="")return E(m,l,o,t,i,a);const h={profileName:m,path:c,args:t,overrideName:i,isAutoDetected:a};if((0,T.basename)(c)===c){const w=process.env.PATH?process.env.PATH.split(T.delimiter):void 0;return await(0,C.findExecutable)(c,void 0,w,void 0,o.existsFile)?h:E(m,l,o,t)}return await o.existsFile((0,T.normalize)(c))?h:E(m,l,o,t,i,a)}}),define(ge[121],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var _;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(_=e.TestItemExpandState||(e.TestItemExpandState={}));const I=(y,n)=>{n.expand!==void 0&&(y.expand=n.expand),n.item!==void 0&&Object.assign(y.item,n.item)};e.applyTestItemUpdate=I;var T;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.DeltaRootsComplete=3]="DeltaRootsComplete",y[y.Retire=4]="Retire"})(T=e.TestDiffOpType||(e.TestDiffOpType={}));const P=(y,n)=>`${y}:${n.toString()}`;e.getTestSubscriptionKey=P;class C{add(n){}update(n){}remove(n,R){}complete(){}}e.IncrementalChangeCollector=C;class A{constructor(){this.items=new Map,this.roots=new Set,this.busyProviderCount=0,this.pendingRootCount=0}apply(n){const R=this.createChangeCollector();for(const D of n)switch(D[0]){case 0:{const b=D[1];if(b.parent){if(this.items.has(b.parent)){const g=this.items.get(b.parent);g.children.add(b.item.extId);const s=this.createItem(b,g);this.items.set(b.item.extId,s),R.add(s)}}else{this.roots.add(b.item.extId);const g=this.createItem(b);this.items.set(b.item.extId,g),R.add(g)}b.expand===2&&this.updateBusyProviders(1);break}case 1:{const b=D[1],g=this.items.get(b.extId);if(!g)break;(0,e.applyTestItemUpdate)(g,b),R.update(g),b.expand!==void 0&&g.expand===2&&b.expand!==2&&this.updateBusyProviders(-1);break}case 2:{const b=this.items.get(D[1]);if(!b)break;b.parent?this.items.get(b.parent).children.delete(b.item.extId):this.roots.delete(b.item.extId);const g=[[D[1]]];for(;g.length;)for(const s of g.pop()){const d=this.items.get(s);d&&(g.push(d.children),this.items.delete(s),R.remove(d,d!==b),d.expand===2&&this.updateBusyProviders(-1))}break}case 4:this.retireTest(D[1]);break;case 3:this.updatePendingRoots(D[1]);break}R.complete()}retireTest(n){}updateBusyProviders(n){this.busyProviderCount+=n}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new C}}e.AbstractIncrementalTestCollection=A}),define(ge[212],ve([0,1,8,30,15,23,9,75,174]),function(Q,e,_,I,T,P,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(D,b,g,s){if(this._contributedVariables=new Map,this._context=D,this._labelService=b,g)if(C.isWindows){const d=Object.create(null);this._envVariables=d,Object.keys(g).forEach(S=>{d[S.toLowerCase()]=g[S]})}else this._envVariables=g}async resolveAsync(D,b){return this.recursiveResolve(D?D.uri:void 0,b)}resolve(D,b){return this.recursiveResolve(D?D.uri:void 0,b)}resolveAnyBase(D,b,g,s){const d=P.deepClone(b);return C.isWindows&&d.windows?Object.keys(d.windows).forEach(S=>d[S]=d.windows[S]):C.isMacintosh&&d.osx?Object.keys(d.osx).forEach(S=>d[S]=d.osx[S]):C.isLinux&&d.linux&&Object.keys(d.linux).forEach(S=>d[S]=d.linux[S]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(D?D.uri:void 0,d,g,s)}resolveAny(D,b,g){return this.resolveAnyBase(D,b,g)}async resolveAnyAsync(D,b,g){return this.resolveAnyBase(D,b,g)}resolveAnyMap(D,b,g){const s=new Map;return{newConfig:this.resolveAnyBase(D,b,g,s),resolvedVariables:s}}resolveWithInteractionReplace(D,b,g,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,b,g,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,b){if(this._contributedVariables.has(D))throw new Error("Variable "+D+" is contributed twice.");this._contributedVariables.set(D,b)}recursiveResolve(D,b,g,s){if(T.isString(b))return this.resolveString(D,b,g,s);if(T.isArray(b))return b.map(d=>this.recursiveResolve(D,d,g,s));if(T.isObject(b)){let d=Object.create(null);return Object.keys(b).forEach(S=>{const v=this.resolveString(D,S,g,s);d[v]=this.recursiveResolve(D,b[S],g,s)}),d}return b}resolveString(D,b,g,s){return b.replace(n.VARIABLE_REGEXP,(S,v)=>{if(v.includes(n.VARIABLE_LHS))return S;let E=this.evaluateSingleVariable(S,v,D,g);return s&&s.set(v,E),E})}fsPath(D){return this._labelService?this._labelService.getUriLabel(D,{noPrefix:!0}):D.fsPath}evaluateSingleVariable(D,b,g,s){let d;const S=b.split(":");S.length>1&&(b=S[0],d=S[1]);const v=()=>{const l=this._context.getFilePath();if(l)return l;throw new Error((0,y.localize)(0,null,D))},E=()=>{const l=v();if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return o}throw new Error((0,y.localize)(1,null,D,_.basename(l)))},m=()=>{if(d){const l=this._context.getFolderUri(d);if(l)return l;throw new Error((0,y.localize)(2,null,D,d))}if(g)return g;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,D)):new Error((0,y.localize)(4,null,D))};switch(b){case"env":if(d){if(this._envVariables){const l=this._envVariables[C.isWindows?d.toLowerCase():d];if(T.isString(l))return l}return""}throw new Error((0,y.localize)(5,null,D));case"config":if(d){const l=this._context.getConfigurationValue(g,d);if(T.isUndefinedOrNull(l))throw new Error((0,y.localize)(6,null,D,d));if(T.isObject(l))throw new Error((0,y.localize)(7,null,D,d));return l}throw new Error((0,y.localize)(8,null,D));case"command":return this.resolveFromMap(D,d,s,"command");case"input":return this.resolveFromMap(D,d,s,"input");default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(m()));case"cwd":return g||d?(0,A.normalizeDriveLetter)(this.fsPath(m())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return _.basename(this.fsPath(m()));case"lineNumber":const l=this._context.getLineNumber();if(l)return l;throw new Error((0,y.localize)(9,null,D));case"selectedText":const o=this._context.getSelectedText();if(o)return o;throw new Error((0,y.localize)(10,null,D));case"file":return v();case"fileWorkspaceFolder":return E();case"relativeFile":return g||d?_.relative(this.fsPath(m()),v()):v();case"relativeFileDirname":const t=_.dirname(v());if(g||d){const c=_.relative(this.fsPath(m()),t);return c.length===0?".":c}return t;case"fileDirname":return _.dirname(v());case"fileExtname":return _.extname(v());case"fileBasename":return _.basename(v());case"fileBasenameNoExtension":const i=_.basename(v());return i.slice(0,i.length-_.extname(i).length);case"fileDirnameBasename":return _.basename(_.dirname(v()));case"execPath":const a=this._context.getExecPath();return a||D;case"execInstallFolder":const r=this._context.getAppRoot();return r||D;case"pathSeparator":return _.sep;default:try{const c=d?`${b}:${d}`:b;return this.resolveFromMap(D,c,s,void 0)}catch(c){return D}}}}resolveFromMap(D,b,g,s){if(b&&g){const d=s===void 0?g[b]:g[s+":"+b];if(typeof d=="string")return d;throw new Error((0,y.localize)(11,null,D))}return D}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[213],ve([0,1,4]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,_.createDecorator)("editorGroupsService");var I;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var T;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var C;(function(b){b[b.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",b[b.EVEN=1]="EVEN",b[b.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var A;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(A=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var n;(function(b){b[b.GROUP_ACTIVE=0]="GROUP_ACTIVE",b[b.GROUP_INDEX=1]="GROUP_INDEX",b[b.EDITOR_OPEN=2]="EDITOR_OPEN",b[b.EDITOR_CLOSE=3]="EDITOR_CLOSE",b[b.EDITOR_MOVE=4]="EDITOR_MOVE",b[b.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",b[b.EDITOR_LABEL=6]="EDITOR_LABEL",b[b.EDITOR_PIN=7]="EDITOR_PIN",b[b.EDITOR_STICKY=8]="EDITOR_STICKY",b[b.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(n=e.GroupChangeKind||(e.GroupChangeKind={}));var R;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(R=e.OpenEditorContext||(e.OpenEditorContext={}));function D(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=D}),define(ge[214],ve([0,1,4]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,_.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ge[20],ve([0,1,14,94,284,57,23,15,2,43,79,175,110,85,214,7]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookDocumentContentOptions=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var S;(function(ue){function Ce(J){const{selectionStartLineNumber:Re,selectionStartColumn:Le,positionLineNumber:Je,positionColumn:Ge}=J,rt=new d.Position(Re-1,Le-1),at=new d.Position(Je-1,Ge-1);return new d.Selection(rt,at)}ue.to=Ce;function ce(J){const{anchor:Re,active:Le}=J;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ue.from=ce})(S=e.Selection||(e.Selection={}));var v;(function(ue){function Ce(J){if(!!J){const{start:Re,end:Le}=J;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}}ue.from=Ce;function ce(J){if(!!J){const{startLineNumber:Re,startColumn:Le,endLineNumber:Je,endColumn:Ge}=J;return new d.Range(Re-1,Le-1,Je-1,Ge-1)}}ue.to=ce})(v=e.Range||(e.Range={}));var E;(function(ue){function Ce(ce){switch(ce){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 4:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}ue.to=Ce})(E=e.TokenType||(e.TokenType={}));var m;(function(ue){function Ce(J){return new d.Position(J.lineNumber-1,J.column-1)}ue.to=Ce;function ce(J){return{lineNumber:J.line+1,column:J.character+1}}ue.from=ce})(m=e.Position||(e.Position={}));var l;(function(ue){function Ce(J){switch(J){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}ue.from=Ce;function ce(J){switch(J){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}ue.to=ce})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(ue){function Ce(J){let Re;return J.code&&((0,A.isString)(J.code)||(0,A.isNumber)(J.code)?Re=String(J.code):Re={value:String(J.code.value),target:J.code.target}),Object.assign(Object.assign({},v.from(J.range)),{message:J.message,source:J.source,code:Re,severity:i.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(t.from),tags:Array.isArray(J.tags)?(0,_.coalesce)(J.tags.map(l.from)):void 0})}ue.from=Ce;function ce(J){var Re;const Le=new d.Diagnostic(v.to(J),J.message,i.to(J.severity));return Le.source=J.source,Le.code=(0,A.isString)(J.code)?J.code:(Re=J.code)===null||Re===void 0?void 0:Re.value,Le.relatedInformation=J.relatedInformation&&J.relatedInformation.map(t.to),Le.tags=J.tags&&(0,_.coalesce)(J.tags.map(l.to)),Le}ue.to=ce})(o=e.Diagnostic||(e.Diagnostic={}));var t;(function(ue){function Ce(J){return Object.assign(Object.assign({},v.from(J.location.range)),{message:J.message,resource:J.location.uri})}ue.from=Ce;function ce(J){return new d.DiagnosticRelatedInformation(new d.Location(J.resource,v.to(J)),J.message)}ue.to=ce})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(ue){function Ce(J){switch(J){case d.DiagnosticSeverity.Error:return b.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return b.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return b.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return b.MarkerSeverity.Hint}return b.MarkerSeverity.Error}ue.from=Ce;function ce(J){switch(J){case b.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case b.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case b.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case b.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}ue.to=ce})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var a;(function(ue){function Ce(J){return typeof J=="number"&&J>=d.ViewColumn.One?J-1:J===d.ViewColumn.Beside?s.SIDE_GROUP:s.ACTIVE_GROUP}ue.from=Ce;function ce(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}ue.to=ce})(a=e.ViewColumn||(e.ViewColumn={}));function r(ue){return typeof ue.range!="undefined"}function c(ue){return ue.length===0?!0:!!r(ue[0])}e.isDecorationOptionsArr=c;var h;(function(ue){function Ce(Ge){return Ge.map(ue.from)}ue.fromMany=Ce;function ce(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function J(Ge){let rt;if(ce(Ge)){const{language:st,value:gt}=Ge;rt={value:"```"+st+`
`+gt+"\n```\n"}}else d.MarkdownString.isMarkdownString(Ge)?rt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons}:typeof Ge=="string"?rt={value:Ge}:rt={value:""};const at=Object.create(null);rt.uris=at;const Qe=st=>{try{let gt=y.URI.parse(st,!0);gt=gt.with({query:Re(gt.query,at)}),at[st]=gt}catch(gt){}return""},ct=new T.Renderer;return ct.link=Qe,ct.image=st=>Qe(I.parseHrefAndDimensions(st).href),T(rt.value,{renderer:ct}),rt}ue.from=J;function Re(Ge,rt){if(!Ge)return Ge;let at;try{at=(0,P.parse)(Ge)}catch(ct){}if(!at)return Ge;let Qe=!1;return at=(0,C.cloneAndChange)(at,ct=>{if(y.URI.isUri(ct)){const st=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[st]=ct,Qe=!0,st}else return}),Qe?JSON.stringify(at):Ge}function Le(Ge){const rt=new d.MarkdownString(Ge.value,Ge.supportThemeIcons);return rt.isTrusted=Ge.isTrusted,rt}ue.to=Le;function Je(Ge){if(!!Ge)return typeof Ge=="string"?Ge:ue.from(Ge)}ue.fromStrict=Je})(h=e.MarkdownString||(e.MarkdownString={}));function p(ue){return c(ue)?ue.map(Ce=>({range:v.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?h.fromMany(Ce.hoverMessage):Ce.hoverMessage?h.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):ue.map(Ce=>({range:v.from(Ce)}))}e.fromRangeOrRangeWithMessage=p;function w(ue){return typeof ue=="undefined"?ue:typeof ue=="string"?y.URI.file(ue):ue}e.pathOrURIToURI=w;var u;(function(ue){function Ce(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?w(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}ue.from=Ce})(u=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var f;(function(ue){function Ce(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?w(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?u.from(ce.before):void 0,after:ce.after?u.from(ce.after):void 0}}ue.from=Ce})(f=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var k;(function(ue){function Ce(ce){if(typeof ce=="undefined")return ce;switch(ce){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}ue.from=Ce})(k=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(ue){function Ce(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?k.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?f.from(ce.light):void 0,dark:ce.dark?f.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?w(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?u.from(ce.before):void 0,after:ce.after?u.from(ce.after):void 0}}ue.from=Ce})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var $;(function(ue){function Ce(J){return{text:J.newText,eol:J.newEol&&re.from(J.newEol),range:v.from(J.range)}}ue.from=Ce;function ce(J){const Re=new d.TextEdit(v.to(J.range),J.text);return Re.newEol=typeof J.eol=="undefined"?void 0:re.to(J.eol),Re}ue.to=ce})($=e.TextEdit||(e.TextEdit={}));var te;(function(ue){function Ce(J,Re,Le){var Je,Ge,rt;const at={edits:[]};if(J instanceof d.WorkspaceEdit)for(let Qe of J._allEntries())if(Qe._type===1)at.edits.push({_type:1,oldUri:Qe.from,newUri:Qe.to,options:Qe.options,metadata:Qe.metadata});else if(Qe._type===2){const ct=Re==null?void 0:Re.getDocument(Qe.uri);at.edits.push({_type:2,resource:Qe.uri,edit:$.from(Qe.edit),modelVersionId:ct==null?void 0:ct.version,metadata:Qe.metadata})}else Qe._type===3?at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:(Je=Le==null?void 0:Le.lookupNotebookDocument(Qe.uri))===null||Je===void 0?void 0:Je.notebookDocument.version}):Qe._type===4?(Qe.newOutputs&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:2,index:Qe.index,append:Qe.append,outputs:Qe.newOutputs.map(He.from)}}),Qe.newMetadata&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:11,index:Qe.index,metadata:Qe.newMetadata}})):Qe._type===5?at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:(Ge=Le==null?void 0:Le.lookupNotebookDocument(Qe.uri))===null||Ge===void 0?void 0:Ge.notebookDocument.version,edit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(pe.from)}}):Qe._type===6&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:10,outputId:Qe.outputId,items:((rt=Qe.newOutputItems)===null||rt===void 0?void 0:rt.map(_e.from))||[],append:Qe.append}});return at}ue.from=Ce;function ce(J){const Re=new d.WorkspaceEdit;for(const Le of J.edits)Le.edit?Re.replace(y.URI.revive(Le.resource),v.to(Le.edit.range),Le.edit.text):Re.renameFile(y.URI.revive(Le.oldUri),y.URI.revive(Le.newUri),Le.options);return Re}ue.to=ce})(te=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(ue){const Ce=Object.create(null);Ce[d.SymbolKind.File]=0,Ce[d.SymbolKind.Module]=1,Ce[d.SymbolKind.Namespace]=2,Ce[d.SymbolKind.Package]=3,Ce[d.SymbolKind.Class]=4,Ce[d.SymbolKind.Method]=5,Ce[d.SymbolKind.Property]=6,Ce[d.SymbolKind.Field]=7,Ce[d.SymbolKind.Constructor]=8,Ce[d.SymbolKind.Enum]=9,Ce[d.SymbolKind.Interface]=10,Ce[d.SymbolKind.Function]=11,Ce[d.SymbolKind.Variable]=12,Ce[d.SymbolKind.Constant]=13,Ce[d.SymbolKind.String]=14,Ce[d.SymbolKind.Number]=15,Ce[d.SymbolKind.Boolean]=16,Ce[d.SymbolKind.Array]=17,Ce[d.SymbolKind.Object]=18,Ce[d.SymbolKind.Key]=19,Ce[d.SymbolKind.Null]=20,Ce[d.SymbolKind.EnumMember]=21,Ce[d.SymbolKind.Struct]=22,Ce[d.SymbolKind.Event]=23,Ce[d.SymbolKind.Operator]=24,Ce[d.SymbolKind.TypeParameter]=25;function ce(Re){return typeof Ce[Re]=="number"?Ce[Re]:6}ue.from=ce;function J(Re){for(const Le in Ce)if(Ce[Le]===Re)return Number(Le);return d.SymbolKind.Property}ue.to=J})(H=e.SymbolKind||(e.SymbolKind={}));var x;(function(ue){function Ce(J){switch(J){case d.SymbolTag.Deprecated:return 1}}ue.from=Ce;function ce(J){switch(J){case 1:return d.SymbolTag.Deprecated}}ue.to=ce})(x=e.SymbolTag||(e.SymbolTag={}));var B;(function(ue){function Ce(J){return{name:J.name,kind:H.from(J.kind),tags:J.tags&&J.tags.map(x.from),containerName:J.containerName,location:O.from(J.location)}}ue.from=Ce;function ce(J){const Re=new d.SymbolInformation(J.name,H.to(J.kind),J.containerName,O.to(J.location));return Re.tags=J.tags&&J.tags.map(x.to),Re}ue.to=ce})(B=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var F;(function(ue){function Ce(J){var Re,Le;const Je={name:J.name||"!!MISSING: name!!",detail:J.detail,range:v.from(J.range),selectionRange:v.from(J.selectionRange),kind:H.from(J.kind),tags:(Le=(Re=J.tags)===null||Re===void 0?void 0:Re.map(x.from))!==null&&Le!==void 0?Le:[]};return J.children&&(Je.children=J.children.map(Ce)),Je}ue.from=Ce;function ce(J){const Re=new d.DocumentSymbol(J.name,J.detail,H.to(J.kind),v.to(J.range),v.to(J.selectionRange));return(0,_.isNonEmptyArray)(J.tags)&&(Re.tags=J.tags.map(x.to)),J.children&&(Re.children=J.children.map(ce)),Re}ue.to=ce})(F=e.DocumentSymbol||(e.DocumentSymbol={}));var U;(function(ue){function Ce(ce){const J=new d.CallHierarchyItem(H.to(ce.kind),ce.name,ce.detail||"",y.URI.revive(ce.uri),v.to(ce.range),v.to(ce.selectionRange));return J._sessionId=ce._sessionId,J._itemId=ce._itemId,J}ue.to=Ce})(U=e.CallHierarchyItem||(e.CallHierarchyItem={}));var M;(function(ue){function Ce(ce){return new d.CallHierarchyIncomingCall(U.to(ce.from),ce.fromRanges.map(J=>v.to(J)))}ue.to=Ce})(M=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var N;(function(ue){function Ce(ce){return new d.CallHierarchyOutgoingCall(U.to(ce.to),ce.fromRanges.map(J=>v.to(J)))}ue.to=Ce})(N=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var O;(function(ue){function Ce(J){return{range:J.range&&v.from(J.range),uri:J.uri}}ue.from=Ce;function ce(J){return new d.Location(y.URI.revive(J.uri),v.to(J.range))}ue.to=ce})(O=e.location||(e.location={}));var j;(function(ue){function Ce(J){const Re=J,Le=J;return{originSelectionRange:Re.originSelectionRange?v.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Le.uri,range:v.from(Re.targetRange?Re.targetRange:Le.range),targetSelectionRange:Re.targetSelectionRange?v.from(Re.targetSelectionRange):void 0}}ue.from=Ce;function ce(J){return{targetUri:y.URI.revive(J.uri),targetRange:v.to(J.range),targetSelectionRange:J.targetSelectionRange?v.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?v.to(J.originSelectionRange):void 0}}ue.to=ce})(j=e.DefinitionLink||(e.DefinitionLink={}));var q;(function(ue){function Ce(J){return{range:v.from(J.range),contents:h.fromMany(J.contents)}}ue.from=Ce;function ce(J){return new d.Hover(J.contents.map(h.to),v.to(J.range))}ue.to=ce})(q=e.Hover||(e.Hover={}));var X;(function(ue){function Ce(J){return{range:v.from(J.range),expression:J.expression}}ue.from=Ce;function ce(J){return new d.EvaluatableExpression(v.to(J.range),J.expression)}ue.to=ce})(X=e.EvaluatableExpression||(e.EvaluatableExpression={}));var me;(function(ue){function Ce(J){if(J instanceof d.InlineValueText)return{type:"text",range:v.from(J.range),text:J.text};if(J instanceof d.InlineValueVariableLookup)return{type:"variable",range:v.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:v.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}ue.from=Ce;function ce(J){switch(J.type){case"text":return{range:v.to(J.range),text:J.text};case"variable":return{range:v.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:v.to(J.range),expression:J.expression}}}ue.to=ce})(me=e.InlineValue||(e.InlineValue={}));var we;(function(ue){function Ce(J){return{frameId:J.frameId,stoppedLocation:v.from(J.stoppedLocation)}}ue.from=Ce;function ce(J){return new d.InlineValueContext(J.frameId,v.to(J.stoppedLocation))}ue.to=ce})(we=e.InlineValueContext||(e.InlineValueContext={}));var Ae;(function(ue){function Ce(J){return{range:v.from(J.range),kind:J.kind}}ue.from=Ce;function ce(J){return new d.DocumentHighlight(v.to(J.range),J.kind)}ue.to=ce})(Ae=e.DocumentHighlight||(e.DocumentHighlight={}));var Ie;(function(ue){function Ce(ce){switch(ce){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}ue.to=Ce})(Ie=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Me;(function(ue){function Ce(ce){return{triggerKind:Ie.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}ue.to=Ce})(Me=e.CompletionContext||(e.CompletionContext={}));var V;(function(ue){function Ce(J){switch(J){case d.CompletionItemTag.Deprecated:return 1}}ue.from=Ce;function ce(J){switch(J){case 1:return d.CompletionItemTag.Deprecated}}ue.to=ce})(V=e.CompletionItemTag||(e.CompletionItemTag={}));var Y;(function(ue){const Ce=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function ce(Le){var Je;return(Je=Ce.get(Le))!==null&&Je!==void 0?Je:9}ue.from=ce;const J=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Re(Le){var Je;return(Je=J.get(Le))!==null&&Je!==void 0?Je:d.CompletionItemKind.Property}ue.to=Re})(Y=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(ue){function Ce(ce,J){var Re;const Le=new d.CompletionItem(typeof ce.label=="string"?ce.label:ce.label.name);return typeof ce.label!="string"&&(Le.label2=ce.label),Le.insertText=ce.insertText,Le.kind=Y.to(ce.kind),Le.tags=(Re=ce.tags)===null||Re===void 0?void 0:Re.map(V.to),Le.detail=ce.detail,Le.documentation=I.isMarkdownString(ce.documentation)?h.to(ce.documentation):ce.documentation,Le.sortText=ce.sortText,Le.filterText=ce.filterText,Le.preselect=ce.preselect,Le.commitCharacters=ce.commitCharacters,n.Range.isIRange(ce.range)?Le.range=v.to(ce.range):typeof ce.range=="object"&&(Le.range={inserting:v.to(ce.range.insert),replacing:v.to(ce.range.replace)}),Le.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Le.insertText=new d.SnippetString(ce.insertText):(Le.insertText=ce.insertText,Le.textEdit=Le.range instanceof d.Range?new d.TextEdit(Le.range,Le.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Le.additionalTextEdits=ce.additionalTextEdits.map(Je=>$.to(Je))),Le.command=J&&ce.command?J.fromInternal(ce.command):void 0,Le}ue.to=Ce})(ee=e.CompletionItem||(e.CompletionItem={}));var ae;(function(ue){function Ce(J){return{label:J.label,documentation:J.documentation?h.fromStrict(J.documentation):void 0}}ue.from=Ce;function ce(J){return{label:J.label,documentation:I.isMarkdownString(J.documentation)?h.to(J.documentation):J.documentation}}ue.to=ce})(ae=e.ParameterInformation||(e.ParameterInformation={}));var fe;(function(ue){function Ce(J){return{label:J.label,documentation:J.documentation?h.fromStrict(J.documentation):void 0,parameters:Array.isArray(J.parameters)?J.parameters.map(ae.from):[],activeParameter:J.activeParameter}}ue.from=Ce;function ce(J){return{label:J.label,documentation:I.isMarkdownString(J.documentation)?h.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(ae.to):[],activeParameter:J.activeParameter}}ue.to=ce})(fe=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(ue){function Ce(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(fe.from):[]}}ue.from=Ce;function ce(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(fe.to):[]}}ue.to=ce})(De=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(ue){function Ce(J){var Re;return{text:J.text,range:v.from(J.range),kind:be.from((Re=J.kind)!==null&&Re!==void 0?Re:d.InlineHintKind.Other),description:J.description&&h.fromStrict(J.description),whitespaceBefore:J.whitespaceBefore,whitespaceAfter:J.whitespaceAfter}}ue.from=Ce;function ce(J){const Re=new d.InlineHint(J.text,v.to(J.range),be.to(J.kind));return Re.whitespaceAfter=J.whitespaceAfter,Re.whitespaceBefore=J.whitespaceBefore,Re.description=I.isMarkdownString(J.description)?h.to(J.description):J.description,Re}ue.to=ce})(Oe=e.InlineHint||(e.InlineHint={}));var be;(function(ue){function Ce(J){return J}ue.from=Ce;function ce(J){return J}ue.to=ce})(be=e.InlineHintKind||(e.InlineHintKind={}));var ke;(function(ue){function Ce(J){return{range:v.from(J.range),url:J.target,tooltip:J.tooltip}}ue.from=Ce;function ce(J){let Re;if(J.url)try{Re=typeof J.url=="string"?y.URI.parse(J.url,!0):y.URI.revive(J.url)}catch(Le){}return new d.DocumentLink(v.to(J.range),Re)}ue.to=ce})(ke=e.DocumentLink||(e.DocumentLink={}));var Te;(function(ue){function Ce(J){const Re=new d.ColorPresentation(J.label);return J.textEdit&&(Re.textEdit=$.to(J.textEdit)),J.additionalTextEdits&&(Re.additionalTextEdits=J.additionalTextEdits.map(Le=>$.to(Le))),Re}ue.to=Ce;function ce(J){return{label:J.label,textEdit:J.textEdit?$.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Re=>$.from(Re)):void 0}}ue.from=ce})(Te=e.ColorPresentation||(e.ColorPresentation={}));var xe;(function(ue){function Ce(J){return new d.Color(J[0],J[1],J[2],J[3])}ue.to=Ce;function ce(J){return[J.red,J.green,J.blue,J.alpha]}ue.from=ce})(xe=e.Color||(e.Color={}));var Se;(function(ue){function Ce(J){return{range:v.from(J.range)}}ue.from=Ce;function ce(J){return new d.SelectionRange(v.to(J.range))}ue.to=ce})(Se=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(ue){function Ce(ce){switch(ce){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}ue.to=Ce})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var G;(function(ue){function Ce(J){switch(J){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}ue.from=Ce;function ce(J){switch(J){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}ue.to=ce})(G=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var re;(function(ue){function Ce(J){if(J===d.EndOfLine.CRLF)return 1;if(J===d.EndOfLine.LF)return 0}ue.from=Ce;function ce(J){if(J===1)return d.EndOfLine.CRLF;if(J===0)return d.EndOfLine.LF}ue.to=ce})(re=e.EndOfLine||(e.EndOfLine={}));var Ee;(function(ue){function Ce(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ue.from=Ce})(Ee=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(ue){function Ce(ce){const J={start:ce.start+1,end:ce.end+1};return ce.kind&&(J.kind=Ve.from(ce.kind)),J}ue.from=Ce})(Ne=e.FoldingRange||(e.FoldingRange={}));var Ve;(function(ue){function Ce(ce){if(ce)switch(ce){case d.FoldingRangeKind.Comment:return R.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return R.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return R.FoldingRangeKind.Region}}ue.from=Ce})(Ve=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Be;(function(ue){function Ce(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?v.from(ce.selection):void 0,override:typeof ce.override=="boolean"?D.EditorOverride.DISABLED:void 0}}ue.from=Ce})(Be=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var et;(function(ue){function Ce(J){return J instanceof d.RelativePattern||typeof J=="string"?J:ce(J)?new d.RelativePattern(J.base,J.pattern):J}ue.from=Ce;function ce(J){const Re=J;return Re&&typeof Re.base=="string"&&typeof Re.pattern=="string"}})(et=e.GlobPattern||(e.GlobPattern={}));var K;(function(ue){function Ce(ce){if(ce){if(Array.isArray(ce))return ce.map(Ce);if(typeof ce=="string")return ce;{const J=ce;return{language:J.language,scheme:J.scheme,pattern:typeof J.pattern=="undefined"?void 0:et.from(J.pattern),exclusive:J.exclusive}}}else return}ue.from=Ce})(K=e.LanguageSelector||(e.LanguageSelector={}));var oe;(function(ue){function Ce(J){return{start:J.start,end:J.end}}ue.from=Ce;function ce(J){return new d.NotebookCellRange(J.start,J.end)}ue.to=ce})(oe=e.NotebookCellRange||(e.NotebookCellRange={}));var he;(function(ue){function Ce(ce){return new d.NotebookCellMetadata(ce.editable,ce.breakpointMargin,ce.hasExecutionOrder,ce.statusMessage,ce.inputCollapsed,ce.outputCollapsed,ce.custom)}ue.to=Ce})(he=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var Z;(function(ue){function Ce(J){return J}ue.from=Ce;function ce(J){return new d.NotebookDocumentMetadata(J.editable,J.cellEditable,J.cellHasExecutionOrder,J.custom,J.trusted)}ue.to=ce})(Z=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ne;(function(ue){function Ce(J){return{duration:J.lastRunDuration,executionOrder:J.executionOrder,success:J.lastRunSuccess}}ue.to=Ce;function ce(J){return{lastRunSuccess:J.success,lastRunDuration:J.duration,executionOrder:J.executionOrder}}ue.from=ce})(ne=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var le;(function(ue){function Ce(J){switch(J){case d.NotebookCellKind.Markdown:return g.CellKind.Markdown;case d.NotebookCellKind.Code:default:return g.CellKind.Code}}ue.from=Ce;function ce(J){switch(J){case g.CellKind.Markdown:return d.NotebookCellKind.Markdown;case g.CellKind.Code:default:return d.NotebookCellKind.Code}}ue.to=ce})(le=e.NotebookCellKind||(e.NotebookCellKind={}));var pe;(function(ue){function Ce(J){var Re;return{cellKind:le.from(J.kind),language:J.language,source:J.source,metadata:Object.assign(Object.assign({},J.metadata),ne.from((Re=J.latestExecutionSummary)!==null&&Re!==void 0?Re:{})),outputs:J.outputs?J.outputs.map(He.from):[]}}ue.from=Ce;function ce(J){return new d.NotebookCellData(le.to(J.cellKind),J.source,J.language,J.outputs?J.outputs.map(He.to):void 0,J.metadata?he.to(J.metadata):void 0)}ue.to=ce})(pe=e.NotebookCellData||(e.NotebookCellData={}));var _e;(function(ue){function Ce(J){return{mime:J.mime,value:J.value,metadata:J.metadata}}ue.from=Ce;function ce(J){return new d.NotebookCellOutputItem(J.mime,J.value,J.metadata)}ue.to=ce})(_e=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var He;(function(ue){function Ce(J){return{outputId:J.id,outputs:J.outputs.map(_e.from),metadata:J.metadata}}ue.from=Ce;function ce(J){const Re=J.outputs.map(_e.to);return new d.NotebookCellOutput(Re,J.outputId,J.metadata)}ue.to=ce})(He=e.NotebookCellOutput||(e.NotebookCellOutput={}));var We;(function(ue){function Ce(Le){if(Le!=null){if(Le instanceof d.RelativePattern||typeof Le=="string")return Le;if(Re(Le))return new d.RelativePattern(Le.base,Le.pattern);if(J(Le))return{include:et.from(Le.include)||void 0,exclude:et.from(Le.exclude)||void 0}}}ue.from=Ce;function ce(Le){return typeof Le=="string"?Le:Re(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}ue.to=ce;function J(Le){const Je=Le,Ge=et.from(Je.include);if(!(Ge&&Ge instanceof d.RelativePattern||typeof Ge=="string"))return!1;const rt=et.from(Je.exclude);return!!(rt&&rt instanceof d.RelativePattern||typeof rt=="string")}function Re(Le){const Je=Le;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(We=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var qe;(function(ue){function Ce(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?u.from(ce.top):void 0}}ue.from=Ce})(qe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ye;(function(ue){function Ce(ce){var J;return{transientOutputs:ce?ce.transientOutputs:!1,transientMetadata:Object.assign(Object.assign({},(J=ce==null?void 0:ce.transientMetadata)!==null&&J!==void 0?J:{}),{executionOrder:!0,lastRunDuration:!0,runState:!0,runStartTime:!0,lastRunSuccess:!0})}}ue.from=Ce})(Ye=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ze;(function(ue){function Ce(J){return{message:h.fromStrict(J.message)||"",severity:J.severity,expectedOutput:J.expectedOutput,actualOutput:J.actualOutput,location:J.location?O.from(J.location):void 0}}ue.from=Ce;function ce(J){const Re=new d.TestMessage(typeof J.message=="string"?J.message:h.to(J.message));return Re.severity=J.severity,Re.actualOutput=J.actualOutput,Re.expectedOutput=J.expectedOutput,Re}ue.to=ce})(Ze=e.TestMessage||(e.TestMessage={}));var ut;(function(ue){function Ce(Le){var Je,Ge;return{extId:Le.id,label:Le.label,uri:Le.uri,range:v.from(Le.range),debuggable:(Je=Le.debuggable)!==null&&Je!==void 0?Je:!1,description:Le.description,runnable:(Ge=Le.runnable)!==null&&Ge!==void 0?Ge:!0,expandable:Le.expandable}}ue.from=Ce;function ce(Le){return{extId:Le.id,label:Le.label,uri:Le.uri,range:v.from(Le.range),debuggable:!1,description:Le.description,runnable:!0,expandable:!0}}ue.fromResultSnapshot=ce;function J(Le){return{id:Le.extId,label:Le.label,uri:y.URI.revive(Le.uri),range:v.to(Le.range),expandable:Le.expandable,debuggable:Le.debuggable,description:Le.description,runnable:Le.runnable}}ue.toPlain=J;function Re(Le){const Je=new d.TestItem(Le.extId,Le.label,y.URI.revive(Le.uri),Le.expandable);return Je.range=v.to(Le.range),Je.debuggable=Le.debuggable,Je.description=Le.description,Je.runnable=Le.runnable,Je}ue.to=Re})(ut=e.TestItem||(e.TestItem={}));var ot;(function(ue){function Ce(Re,Le){var Je,Ge,rt;const at={completedAt:Le.completedAt,id:Re,items:[]},Qe=[[null,Le.results]];for(;Qe.length;){const[ct,st]=Qe.pop();for(const gt of st){const Et={children:(Ge=(Je=gt.children)===null||Je===void 0?void 0:Je.map(Dt=>Dt.id))!==null&&Ge!==void 0?Ge:[],computedState:gt.state,item:ut.fromResultSnapshot(gt),state:{state:gt.state,duration:gt.duration,messages:gt.messages.map(Ze.from)},retired:void 0,expand:3,parent:(rt=ct==null?void 0:ct.item.extId)!==null&&rt!==void 0?rt:null,src:{provider:"",tree:-1},direct:!ct};at.items.push(Et),gt.children&&Qe.push([Et,gt.children])}}return at}ue.from=Ce;const ce=(Re,Le)=>Object.assign(Object.assign({},ut.toPlain(Re.item)),{state:Re.state.state,duration:Re.state.duration,messages:Re.state.messages.map(Ze.to),children:Re.children.map(Je=>Le.get(Je)).filter(A.isDefined).map(Je=>ce(Je,Le))});function J(Re){const Le=[],Je=new Map;for(const Ge of Re.items)Je.set(Ge.item.extId,Ge),Ge.direct&&Le.push(Ge);return{completedAt:Re.completedAt,results:Le.map(Ge=>ce(Ge,Je))}}ue.to=J})(ot=e.TestResults||(e.TestResults={}));var nt;(function(ue){function Ce(ce){switch(ce){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}ue.to=Ce})(nt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ge[215],ve([0,1,2,18,7,20,55]),function(Q,e,_,I,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(n,R,D,b={timeout:1500,errors:3}){this._logService=n,this._documents=R,this._mainThreadBulkEdits=D,this._thresholds=b,this._callbacks=new C.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(n){return(R,D,b)=>{const s={dispose:this._callbacks.push([R,D,n])};return Array.isArray(b)&&b.push(s),s}}async $participateInSave(n,R){const D=_.URI.revive(n);let b=!1;const g=setTimeout(()=>b=!0,this._thresholds.timeout),s=[];try{for(let d of[...this._callbacks]){if(b)break;const S=this._documents.getDocument(D),v=await this._deliverEventAsyncAndBlameBadListeners(d,{document:S,reason:P.TextDocumentSaveReason.to(R)});s.push(v)}}finally{clearTimeout(g)}return s}_deliverEventAsyncAndBlameBadListeners([n,R,D],b){const g=this._badListeners.get(n);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(D,n,R,b).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const d=this._badListeners.get(n);this._badListeners.set(n,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(n,R,D,b){const g=[],s=Date.now(),{document:d,reason:S}=b,{version:v}=d,E=Object.freeze({document:d,reason:S,waitUntil(m){if(Object.isFrozen(g))throw(0,I.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(m))}});try{R.apply(D,[E])}catch(m){return Promise.reject(m)}return Object.freeze(g),new Promise((m,l)=>{const o=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${n.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(o),m(t)}).catch(t=>{clearTimeout(o),l(t)})}).then(m=>{const l={edits:[]};for(const o of m)if(Array.isArray(o)&&o.every(t=>t instanceof T.TextEdit))for(const{newText:t,newEol:i,range:a}of o)l.edits.push({_type:2,resource:d.uri,edit:{range:a&&P.Range.from(a),text:t,eol:i&&P.EndOfLine.from(i)}});if(l.edits.length!==0)return v===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(ge[216],ve([0,1,3,19,34,2,20,7]),function(Q,e,_,I,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(D,b,g,s,d){this._onDidCreate=new _.Emitter,this._onDidChange=new _.Emitter,this._onDidDelete=new _.Emitter,this._config=0,g&&(this._config+=1),s&&(this._config+=2),d&&(this._config+=4);const S=(0,T.parse)(b),v=D(E=>{if(!g)for(let m of E.created){const l=P.URI.revive(m);S(l.fsPath)&&this._onDidCreate.fire(l)}if(!s)for(let m of E.changed){const l=P.URI.revive(m);S(l.fsPath)&&this._onDidChange.fire(l)}if(!d)for(let m of E.deleted){const l=P.URI.revive(m);S(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=A.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class n{constructor(D,b,g){this._logService=b,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new _.Emitter,this._onDidRenameFile=new _.Emitter,this._onDidCreateFile=new _.Emitter,this._onDidDeleteFile=new _.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(D,b,g,s){return new y(this._onFileSystemEvent.event,D,b,g,s)}$onFileEvent(D){this._onFileSystemEvent.fire(D)}$onDidRunFileOperation(D,b){switch(D){case 2:this._onDidRenameFile.fire(Object.freeze({files:b.map(g=>({oldUri:P.URI.revive(g.source),newUri:P.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:b.map(g=>P.URI.revive(g.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:b.map(g=>P.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(D){return this._createWillExecuteEvent(D,this._onWillRenameFile)}getOnWillCreateFileEvent(D){return this._createWillExecuteEvent(D,this._onWillCreateFile)}getOnWillDeleteFileEvent(D){return this._createWillExecuteEvent(D,this._onWillDeleteFile)}_createWillExecuteEvent(D,b){return(g,s,d)=>{const S=function(E){g.call(s,E)};return S.extension=D,b.event(S,void 0,d)}}async $onWillRunFileOperation(D,b,g,s){switch(D){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:b.map(d=>({oldUri:P.URI.revive(d.source),newUri:P.URI.revive(d.target)}))},g,s);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:b.map(d=>P.URI.revive(d.target))},g,s);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:b.map(d=>P.URI.revive(d.target))},g,s)}}async _fireWillEvent(D,b,g,s){const d=new Set,S=[];if(await D.fireAsync(b,s,async(E,m)=>{var l;const o=Date.now(),t=await Promise.resolve(E);t instanceof A.WorkspaceEdit&&(S.push(t),d.add((l=m.extension.displayName)!==null&&l!==void 0?l:m.extension.identifier.value)),Date.now()-o>g&&this._logService.warn("SLOW file-participant",m.extension.identifier)}),!s.isCancellationRequested&&S.length!==0){const v={edits:[]};for(let E of S){let{edits:m}=C.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(m)}return{edit:v,extensionNames:Array.from(d)}}}}e.ExtHostFileSystemEventService=n}),define(ge[217],ve([0,1,3,6,11,23,2,20,7,85]),function(Q,e,_,I,T,P,C,A,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(s,d,S,v){this.start=s,this.deletedCount=d,this.deletedItems=S,this.items=v}static asApiEvents(s){return s.map(d=>({start:d.start,deletedCount:d.deletedCount,deletedItems:d.deletedItems,items:d.items.map(S=>S.cell)}))}}class D{constructor(s,d,S){var v;this._notebook=s,this._extHostDocument=d,this._cellData=S,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this.handle=S.handle,this.uri=C.URI.revive(S.uri),this.cellKind=S.cellKind,this._outputs=S.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=(v=S.metadata)!==null&&v!==void 0?v:{},this._metadata=A.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=A.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(s,d){return{EOL:d.eol,lines:d.source,modeId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:s}}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const s=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return s._notebook.getCellIndex(s)},notebook:s._notebook.notebookDocument,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get outputs(){return s._outputs.slice(0)},get metadata(){return s._metadata},get latestExecutionSummary(){return s._previousResult}})}return this._cell}setOutputs(s){this._outputs=s.map(A.NotebookCellOutput.to)}setOutputItems(s,d,S){const v=S.map(A.NotebookCellOutputItem.to),E=this._outputs.find(m=>m.id===s);E&&(d||(E.outputs.length=0),E.outputs.push(...v))}setMetadata(s){this._internalMetadata=s,this._metadata=A.NotebookCellMetadata.to(s),this._previousResult=A.NotebookCellPreviousExecutionResult.to(s)}}e.ExtHostCell=D;class b extends I.Disposable{constructor(s,d,S,v,E,m,l){super();this._proxy=s,this._textDocumentsAndEditors=d,this._textDocuments=S,this._emitter=v,this._viewType=E,this._metadata=m,this.uri=l,this.handle=b._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0,super.dispose(),(0,I.dispose)(this._cellDisposableMapping.values())}get notebookDocument(){if(!this._notebook){const s=this;this._notebook=Object.freeze({get uri(){return s.uri},get version(){return s._versionId},get fileName(){return s.uri.fsPath},get viewType(){return s._viewType},get isDirty(){return s._isDirty},get isUntitled(){return s.uri.scheme===T.Schemas.untitled},get isClosed(){return s._disposed},get metadata(){return s._metadata},get cells(){return s._cells.map(d=>d.cell)},get cellCount(){return s._cells.length},cellAt(d){return d=s._validateIndex(d),s._cells[d].cell},getCells(d){return(d?s._getCells(d):s._cells).map(v=>v.cell)},save(){return s._save()}})}return this._notebook}updateBackup(s){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=s}disposeBackup(){var s;(s=this._backup)===null||s===void 0||s.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(s){s.metadata&&(this._metadata=this._metadata.with(s.metadata))}acceptModelChanged(s,d){this._versionId=s.versionId,this._isDirty=d;for(const S of s.rawEvents)S.kind===n.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(S.changes,!0),S.kind===n.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(S.changes,!1):S.kind===n.NotebookCellsChangeType.Move?this._moveCell(S.index,S.newIdx):S.kind===n.NotebookCellsChangeType.Output?this._setCellOutputs(S.index,S.outputs):S.kind===n.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(S.index,S.outputId,S.append,S.outputItems):S.kind===n.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(S.index,S.language):S.kind===n.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(S.index,S.metadata)}_validateIndex(s){return s<0?0:s>=this._cells.length?this._cells.length-1:s}_validateRange(s){return s.start<0&&(s=s.with({start:0})),s.end>this._cells.length&&(s=s.with({end:this._cells.length})),s}_getCells(s){s=this._validateRange(s);const d=[];for(let S=s.start;S<s.end;S++)d.push(this._cells[S]);return d}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(s,d){if(!this._disposed){const S=[],v=[],E=[];s.reverse().forEach(m=>{var l;const t=m[2].map(r=>{const c=new D(this,this._textDocumentsAndEditors,r);if(d||v.push(D.asModelAddData(this.notebookDocument,r)),!this._cellDisposableMapping.has(c.handle)){const h=new I.DisposableStore;h.add(c),this._cellDisposableMapping.set(c.handle,h)}return c});for(let r=m[0];r<m[0]+m[1];r++)(l=this._cellDisposableMapping.get(this._cells[r].handle))===null||l===void 0||l.dispose(),this._cellDisposableMapping.delete(this._cells[r].handle);const i=new R(m[0],m[1],[],t),a=this._cells.splice(m[0],m[1],...t);for(let r of a)E.push(r.uri),i.deletedItems.push(r.cell);S.push(i)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:E}),d||this._emitter.emitModelChange((0,P.deepFreeze)({document:this.notebookDocument,changes:R.asApiEvents(S)}))}}_moveCell(s,d){const S=this._cells.splice(s,1);this._cells.splice(d,0,...S);const v=[new R(s,1,S.map(E=>E.cell),[]),new R(d,0,[],S)];this._emitter.emitModelChange((0,P.deepFreeze)({document:this.notebookDocument,changes:R.asApiEvents(v)}))}_setCellOutputs(s,d){const S=this._cells[s];S.setOutputs(d),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.notebookDocument,cells:[S.cell]}))}_setCellOutputItems(s,d,S,v){const E=this._cells[s];E.setOutputItems(d,S,v),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.notebookDocument,cells:[E.cell]}))}_changeCellLanguage(s,d){const S=this._cells[s];S.cell.document.languageId!==d&&this._textDocuments.$acceptModelModeChanged(S.uri,d)}_changeCellMetadata(s,d){var S;const v=this._cells[s],E=v.internalMetadata,m=v.cell.metadata;v.setMetadata(d);const l=v.cell.metadata;if((0,P.equals)(m,l)||this._emitter.emitCellMetadataChange((0,P.deepFreeze)({document:this.notebookDocument,cell:v.cell})),E.runState!==d.runState){const o=(S=d.runState)!==null&&S!==void 0?S:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,P.deepFreeze)({document:this.notebookDocument,cell:v.cell,executionState:o}))}}getCellFromIndex(s){return this._cells[s]}getCell(s){return this._cells.find(d=>d.handle===s)}getCellIndex(s){return this._cells.indexOf(s)}}e.ExtHostNotebookDocument=b,b._handlePool=0}),define(ge[218],ve([0,1,3,7,20]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,n){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:y,metadata:n})}replaceCellOutput(y,n){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:y,outputs:n.map(R=>T.NotebookCellOutput.from(R))})}replaceCells(y,n,R){this._throwIfFinalized(),!(y===n&&R.length===0)&&this._collectedEdits.push({editType:1,index:y,count:n-y,cells:R.map(T.NotebookCellData.from)})}}class C{constructor(y,n,R,D,b,g){this.id=y,this._proxy=n,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._selections=b,this._visibleRanges=D,this._viewColumn=g}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get editor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.notebookDocument},get selection(){var n;const R=y._selections[0];return R&&((n=y.notebookData.getCellFromIndex(R.start))===null||n===void 0?void 0:n.cell)},get selections(){return y._selections},get visibleRanges(){return y._visibleRanges},revealRange(n,R){y._proxy.$tryRevealRange(y.id,T.NotebookCellRange.from(n),R!=null?R:I.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},get onDidDispose(){return y.onDidDispose},edit(n){const R=new P(this.document.version);return n(R),y._applyEdit(R.finalize())},get kernel(){return y._kernel},setDecorations(n,R){return y.setDecorations(n,R)}}}return this._editor}_acceptKernel(y){this._kernel=y}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const n=[];let R=-1;for(let D=0;D<y.cellEdits.length;D++){if(R<0){n.push(y.cellEdits[D]),R++;continue}const g=n[R],s=y.cellEdits[D];if(g.editType===1&&s.editType===1&&g.index===s.index){g.cells.push(...y.cellEdits[D].cells),g.count+=y.cellEdits[D].count;continue}n.push(y.cellEdits[D]),R++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,n)}setDecorations(y,n){if(!(n.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return n.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,T.NotebookCellRange.from(n),y.key)}}e.ExtHostNotebookEditor=C}),define(ge[219],ve([0,1,20,111,162,21,68]),function(Q,e,_,I,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class A{constructor(D){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=D}withProgress(D,b,g){const s=this._handles++,{title:d,location:S,cancellable:v}=b,E={label:(0,T.localize)(0,null,D.displayName||D.name),id:D.identifier.value};return this._proxy.$startProgress(s,{location:_.ProgressLocation.from(S),title:d,source:E,cancellable:v},D),this._withProgress(s,g,!!v)}_withProgress(D,b,g){let s;g&&(s=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(D,s));const d=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),s&&s.dispose()};let S;try{S=b(new n(this._proxy,D),g&&s?s.token:P.CancellationToken.None)}catch(v){throw d(D),v}return S.then(v=>d(D),v=>d(D)),S}$acceptProgressCanceled(D){const b=this._mapHandleToCancellationSource.get(D);b&&(b.cancel(),this._mapHandleToCancellationSource.delete(D))}}e.ExtHostProgress=A;function y(R,D){return R.message=D.message,typeof D.increment=="number"&&(typeof R.increment=="number"?R.increment+=D.increment:R.increment=D.increment),R}class n extends I.Progress{constructor(D,b){super(g=>this.throttledReport(g));this._proxy=D,this._handle=b}throttledReport(D){this._proxy.$progressReport(this._handle,D)}}je([(0,C.throttle)(100,(R,D)=>y(R,D),()=>Object.create(null))],n.prototype,"throttledReport",null)}),define(ge[122],ve([0,1,52,18,70,20,7]),function(Q,e,_,I,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(b,g){const s=A._Keys.nextId();b.$registerTextEditorDecorationType(s,P.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:s,dispose(){b.$removeTextEditorDecorationType(s)}})}}e.TextEditorDecorationType=A,A._Keys=new T.IdGenerator("TextEditorDecorationType");class y{constructor(b,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=b,this._documentVersionId=b.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(b,g){this._throwIfFinalized();let s=null;if(b instanceof C.Position)s=new C.Range(b,b);else if(b instanceof C.Range)s=b;else throw new Error("Unrecognized location");this._pushEdit(s,g,!1)}insert(b,g){this._throwIfFinalized(),this._pushEdit(new C.Range(b,b),g,!0)}delete(b){this._throwIfFinalized();let g=null;if(b instanceof C.Range)g=b;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(b,g,s){const d=this._document.validateRange(b);this._collectedEdits.push({range:d,text:g,forceMoveMarkers:s})}setEndOfLine(b){if(this._throwIfFinalized(),b!==C.EndOfLine.LF&&b!==C.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=b}}e.TextEditorEdit=y;class n{constructor(b,g,s,d){this._proxy=b,this._id=g,this._accept(s),this._logService=d;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(v){S._setTabSize(v)},get insertSpaces(){return S._insertSpaces},set insertSpaces(v){S._setInsertSpaces(v)},get cursorStyle(){return S._cursorStyle},set cursorStyle(v){S._setCursorStyle(v)},get lineNumbers(){return S._lineNumbers},set lineNumbers(v){S._setLineNumbers(v)}}}_accept(b){this._tabSize=b.tabSize,this._insertSpaces=b.insertSpaces,this._cursorStyle=b.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(b.lineNumbers)}_validateTabSize(b){if(b==="auto")return"auto";if(typeof b=="number"){const g=Math.floor(b);return g>0?g:null}if(typeof b=="string"){const g=parseInt(b,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(b){const g=this._validateTabSize(b);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(b){return b==="auto"?"auto":b==="false"?!1:Boolean(b)}_setInsertSpaces(b){const g=this._validateInsertSpaces(b);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(b){this._cursorStyle!==b&&(this._cursorStyle=b,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:b})))}_setLineNumbers(b){this._lineNumbers!==b&&(this._lineNumbers=b,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(b)})))}assign(b){const g={};let s=!1;if(typeof b.tabSize!="undefined"){const d=this._validateTabSize(b.tabSize);d==="auto"?(s=!0,g.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,s=!0,g.tabSize=d)}if(typeof b.insertSpaces!="undefined"){const d=this._validateInsertSpaces(b.insertSpaces);d==="auto"?(s=!0,g.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,s=!0,g.insertSpaces=d)}typeof b.cursorStyle!="undefined"&&this._cursorStyle!==b.cursorStyle&&(this._cursorStyle=b.cursorStyle,s=!0,g.cursorStyle=b.cursorStyle),typeof b.lineNumbers!="undefined"&&this._lineNumbers!==b.lineNumbers&&(this._lineNumbers=b.lineNumbers,s=!0,g.lineNumbers=P.TextEditorLineNumbersStyle.from(b.lineNumbers)),s&&this._warnOnError(this._proxy.$trySetOptions(this._id,g))}_warnOnError(b){b.catch(g=>this._logService.warn(g))}}e.ExtHostTextEditorOptions=n;class R{constructor(b,g,s,d,S,v,E,m){this.id=b,this._proxy=g,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new n(this._proxy,this.id,v,s),this._visibleRanges=E,this._viewColumn=m;const l=this;this.value=Object.freeze({get document(){return d.getValue()},set document(o){throw(0,I.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(o){if(!(o instanceof C.Selection))throw(0,I.illegalArgument)("selection");l._selections=[o],l._trySetSelection()},get selections(){return l._selections},set selections(o){if(!Array.isArray(o)||o.some(t=>!(t instanceof C.Selection)))throw(0,I.illegalArgument)("selections");l._selections=o,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(o){throw(0,I.readonly)("visibleRanges")},get options(){return l._options.value},set options(o){l._disposed||l._options.assign(o)},get viewColumn(){return l._viewColumn},set viewColumn(o){throw(0,I.readonly)("viewColumn")},edit(o,t={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new y(d.getValue(),t);return o(i),l._applyEdit(i)},insertSnippet(o,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=l._selections.map(r=>P.Range.from(r));else if(t instanceof C.Position){const{lineNumber:r,column:c}=P.Position.from(t);a=[{startLineNumber:r,startColumn:c,endLineNumber:r,endColumn:c}]}else if(t instanceof C.Range)a=[P.Range.from(t)];else{a=[];for(const r of t)if(r instanceof C.Range)a.push(P.Range.from(r));else{const{lineNumber:c,column:h}=P.Position.from(r);a.push({startLineNumber:c,startColumn:h,endLineNumber:c,endColumn:h})}}return g.$tryInsertSnippet(b,o.value,a,i)},setDecorations(o,t){const i=t.length===0;i&&!l._hasDecorationsForKey.has(o.key)||(i?l._hasDecorationsForKey.delete(o.key):l._hasDecorationsForKey.add(o.key),l._runOnProxy(()=>{if(P.isDecorationOptionsArr(t))return g.$trySetDecorations(b,o.key,P.fromRangeOrRangeWithMessage(t));{const a=new Array(4*t.length);for(let r=0,c=t.length;r<c;r++){const h=t[r];a[4*r]=h.start.line+1,a[4*r+1]=h.start.character+1,a[4*r+2]=h.end.line+1,a[4*r+3]=h.end.character+1}return g.$trySetDecorationsFast(b,o.key,a)}}))},revealRange(o,t){l._runOnProxy(()=>g.$tryRevealRange(b,P.Range.from(o),t||C.TextEditorRevealType.Default))},show(o){g.$tryShowEditor(b,P.ViewColumn.from(o))},hide(){g.$tryHideEditor(b)}})}dispose(){(0,_.ok)(!this._disposed),this._disposed=!0}_acceptOptions(b){(0,_.ok)(!this._disposed),this._options._accept(b)}_acceptVisibleRanges(b){(0,_.ok)(!this._disposed),this._visibleRanges=b}_acceptViewColumn(b){(0,_.ok)(!this._disposed),this._viewColumn=b}_acceptSelections(b){(0,_.ok)(!this._disposed),this._selections=b}async _trySetSelection(){const b=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,b)),this.value}_applyEdit(b){const g=b.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const s=g.edits.map(S=>S.range);s.sort((S,v)=>S.end.line===v.end.line?S.end.character===v.end.character?S.start.line===v.start.line?S.start.character-v.start.character:S.start.line-v.start.line:S.end.character-v.end.character:S.end.line-v.end.line);for(let S=0,v=s.length-1;S<v;S++){const E=s[S].end;if(s[S+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=g.edits.map(S=>({range:P.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,d,{setEndOfLine:typeof g.setEndOfLine=="number"?P.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(b){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):b().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=R}),define(ge[220],ve([0,1,165,25,2,3,6,19,7,15,14,20,21]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(S,v){if((0,n.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let E;return Array.isArray(S.highlights)&&(E=S.highlights.filter(m=>m.length===2&&typeof m[0]=="number"&&typeof m[1]=="number"),E=E.length?E:void 0),{label:S.label,highlights:E}}}class s{constructor(v,E,m){this._proxy=v,this.commands=E,this.logService=m,this.treeViews=new Map;function l(o){return o&&o.$treeViewId&&o.$treeItemHandle}E.registerArgumentProcessor({processArgument:o=>l(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(t=>l(t)?this.convertArgument(t):t):o})}registerTreeDataProvider(v,E,m){const l=this.createTreeView(v,{treeDataProvider:E},m);return{dispose:()=>l.dispose()}}createTreeView(v,E,m){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=this._proxy.$registerTreeViewDataProvider(v,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany}),o=this.createExtHostTreeView(v,E,m);return{get onDidCollapseElement(){return o.onDidCollapseElement},get onDidExpandElement(){return o.onDidExpandElement},get selection(){return o.selectedElements},get onDidChangeSelection(){return o.onDidChangeSelection},get visible(){return o.visible},get onDidChangeVisibility(){return o.onDidChangeVisibility},get message(){return o.message},set message(t){o.message=t},get title(){return o.title},set title(t){o.title=t},get description(){return o.description},set description(t){o.description=t},reveal:(t,i)=>o.reveal(t,i),dispose:async()=>{await l,this.treeViews.delete(v),o.dispose()}}}$getChildren(v,E){const m=this.treeViews.get(v);return m?m.getChildren(E):Promise.reject(new Error((0,_.localize)(0,null,v)))}async $hasResolve(v){const E=this.treeViews.get(v);if(!E)throw new Error((0,_.localize)(1,null,v));return E.hasResolve}$resolve(v,E,m){const l=this.treeViews.get(v);if(!l)throw new Error((0,_.localize)(2,null,v));return l.resolveTreeItem(E,m)}$setExpanded(v,E,m){const l=this.treeViews.get(v);if(!l)throw new Error((0,_.localize)(3,null,v));l.setExpanded(E,m)}$setSelection(v,E){const m=this.treeViews.get(v);if(!m)throw new Error((0,_.localize)(4,null,v));m.setSelection(E)}$setVisible(v,E){const m=this.treeViews.get(v);if(!m)throw new Error((0,_.localize)(5,null,v));m.setVisible(E)}createExtHostTreeView(v,E,m){const l=new d(v,E,this._proxy,this.commands.converter,this.logService,m);return this.treeViews.set(v,l),l}convertArgument(v){const E=this.treeViews.get(v.$treeViewId);return E?E.getExtensionElement(v.$treeItemHandle):null}}e.ExtHostTreeViews=s;class d extends C.Disposable{constructor(v,E,m,l,o,t){super();if(this.viewId=v,this.proxy=m,this.commands=l,this.logService=o,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new P.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new P.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new P.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new P.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new b.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const c of t.contributes.views[r])c.id===v&&(this._title=c.name);this.dataProvider=E.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let i,a;this._register(P.Event.debounce(this._onDidChangeData.event,(r,c)=>(r||(r={message:!1,elements:[]}),c.element!==!1&&(i||(i=new Promise(h=>a=h),this.refreshPromise=this.refreshPromise.then(()=>i)),r.elements.push(c.element)),c.message&&(r.message=!0),r),200,!0)(({message:r,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=a;return i=null,this.refresh(c).then(()=>h())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(v=>this.getExtensionElement(v)).filter(v=>!(0,n.isUndefinedOrNull)(v))}getChildren(v){const E=v?this.getExtensionElement(v):void 0;if(v&&!E)return this.logService.error(`No tree item with id '${v}' found.`),Promise.resolve([]);const m=this.getChildrenNodes(v);return(m?Promise.resolve(m):this.fetchChildrenNodes(E)).then(l=>l.map(o=>o.item))}getExtensionElement(v){return this.elements.get(v)}reveal(v,E){E=E||{select:!0,focus:!1};const m=(0,n.isUndefinedOrNull)(E.select)?!0:E.select,l=(0,n.isUndefinedOrNull)(E.focus)?!1:E.focus,o=(0,n.isUndefinedOrNull)(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.refreshPromise.then(()=>this.resolveUnknownParentChain(v)).then(t=>this.resolveTreeNode(v,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(a=>a.item)},{select:m,focus:l,expand:o})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:m,focus:l,expand:o})}get message(){return this._message}set message(v){this._message=v,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(v){this._title=v,this.proxy.$setTitle(this.viewId,v,this._description)}get description(){return this._description}set description(v){this._description=v,this.proxy.$setTitle(this.viewId,this._title,v)}setExpanded(v,E){const m=this.getExtensionElement(v);m&&(E?this._onDidExpandElement.fire(Object.freeze({element:m})):this._onDidCollapseElement.fire(Object.freeze({element:m})))}setSelection(v){(0,R.equals)(this._selectedHandles,v)||(this._selectedHandles=v,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(v){v!==this._visible&&(this._visible=v,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(v,E){var m;if(!!this.dataProvider.resolveTreeItem){const l=this.elements.get(v);if(l){const o=this.nodes.get(l);if(o){const t=(m=await this.dataProvider.resolveTreeItem(o.extensionItem,l,E))!==null&&m!==void 0?m:o.extensionItem;return o.item.tooltip=this.getTooltip(t.tooltip),o.item.command=this.getCommand(o.disposableStore,t.command),o.item}}}}resolveUnknownParentChain(v){return this.resolveParent(v).then(E=>E?this.resolveUnknownParentChain(E).then(m=>this.resolveTreeNode(E,m[m.length-1]).then(l=>(m.push(l),m))):Promise.resolve([]))}resolveParent(v){const E=this.nodes.get(v);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):(0,A.asPromise)(()=>this.dataProvider.getParent(v))}resolveTreeNode(v,E){const m=this.nodes.get(v);return m?Promise.resolve(m):(0,A.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(l=>this.createHandle(v,l,E,!0)).then(l=>this.getChildren(E?E.item.handle:void 0).then(()=>{const o=this.getExtensionElement(l);if(o){const t=this.nodes.get(o);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${l}`)}))}getChildrenNodes(v){if(v){let E;if(typeof v=="string"){const m=this.getExtensionElement(v);E=m?this.nodes.get(m):void 0}else E=v;return E&&E.children||null}return this.roots}async fetchChildrenNodes(v){this.clearChildren(v);const E=new b.CancellationTokenSource(this._refreshCancellationSource.token);try{const m=v?this.nodes.get(v):void 0,l=await this.dataProvider.getChildren(v);if(E.token.isCancellationRequested)return[];const o=await Promise.all((0,R.coalesce)(l||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,m):null}));return E.token.isCancellationRequested?[]:(0,R.coalesce)(o)}finally{E.dispose()}}refresh(v){if(v.some(m=>!m))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new b.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const m=this.getHandlesToRefresh(v);if(m.length)return this.refreshHandles(m)}return Promise.resolve(void 0)}getHandlesToRefresh(v){const E=new Set,m=v.map(o=>this.nodes.get(o));for(const o of m)if(o&&!E.has(o.item.handle)){let t=o;for(;t&&t.parent&&m.findIndex(i=>t&&t.parent&&i&&i.item.handle===t.parent.item.handle)===-1;){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&E.add(o.item.handle)}const l=[];return E.forEach(o=>{const t=this.elements.get(o);if(t){const i=this.nodes.get(t);i&&(!i.parent||!E.has(i.parent.item.handle))&&l.push(o)}}),l}refreshHandles(v){const E={};return Promise.all(v.map(m=>this.refreshNode(m).then(l=>{l&&(E[m]=l.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(v){const E=this.getExtensionElement(v);if(E){const m=this.nodes.get(E);if(m)return this.clearChildren(E),(0,A.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(l=>{if(l){const o=this.createTreeNode(E,l,m.parent);return this.updateNodeCache(E,o,m,m.parent),m.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(v,E,m){const l=this.createTreeNode(v,E,m);if(E.id&&this.elements.has(l.item.handle))throw new Error((0,_.localize)(6,null,E.id));return this.addNodeToCache(v,l),this.addNodeToParentCache(l,m),l}getTooltip(v){return y.MarkdownString.isMarkdownString(v)?D.MarkdownString.from(v):v}getCommand(v,E){return E?this.commands.toInternal(E,v):void 0}createTreeNode(v,E,m){const l=new C.DisposableStore,o=this.createHandle(v,E,m),t=this.getLightIconPath(E);return{item:{handle:o,parentHandle:m?m.item.handle:void 0,label:g(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(l,E.command),contextValue:E.contextValue,icon:t,iconDark:this.getDarkIconPath(E)||t,themeIcon:this.getThemeIcon(E),collapsibleState:(0,n.isUndefinedOrNull)(E.collapsibleState)?y.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:m,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(v){return v.iconPath instanceof y.ThemeIcon?v.iconPath:void 0}createHandle(v,{id:E,label:m,resourceUri:l},o,t){if(E)return`${d.ID_HANDLE_PREFIX}/${E}`;const i=g(m,this.extension),a=o?o.item.handle:d.LABEL_HANDLE_PREFIX;let r=i?i.label:l?(0,I.basename)(l):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const c=this.nodes.has(v)?this.nodes.get(v).item.handle:void 0,h=this.getChildrenNodes(o)||[];let p,w=0;do{if(p=`${a}/${w}:${r}`,t||!this.elements.has(p)||c===p)break;w++}while(w<=h.length);return p}getLightIconPath(v){if(v.iconPath&&!(v.iconPath instanceof y.ThemeIcon))return typeof v.iconPath=="string"||T.URI.isUri(v.iconPath)?this.getIconPath(v.iconPath):this.getIconPath(v.iconPath.light)}getDarkIconPath(v){if(v.iconPath&&!(v.iconPath instanceof y.ThemeIcon)&&v.iconPath.dark)return this.getIconPath(v.iconPath.dark)}getIconPath(v){return T.URI.isUri(v)?v:T.URI.file(v)}addNodeToCache(v,E){this.elements.set(E.item.handle,v),this.nodes.set(v,E)}updateNodeCache(v,E,m,l){this.elements.delete(E.item.handle),this.nodes.delete(v),E.item.handle!==m.item.handle&&this.elements.delete(m.item.handle),this.addNodeToCache(v,E);const o=this.getChildrenNodes(l)||[],t=o.filter(i=>i.item.handle===m.item.handle)[0];t&&o.splice(o.indexOf(t),1,E)}addNodeToParentCache(v,E){E?(E.children||(E.children=[]),E.children.push(v)):(this.roots||(this.roots=[]),this.roots.push(v))}clearChildren(v){if(v){const E=this.nodes.get(v);if(E){if(E.children)for(const m of E.children){const l=this.elements.get(m.item.handle);l&&this.clear(l)}E.children=void 0}}else this.clearAll()}clear(v){const E=this.nodes.get(v);if(E){if(E.children)for(const m of E.children){const l=this.elements.get(m.item.handle);l&&this.clear(l)}this.nodes.delete(v),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(v=>v.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}d.LABEL_HANDLE_PREFIX="0",d.ID_HANDLE_PREFIX="1"}),define(ge[221],ve([0,1,14,19,21,20,7,121]),function(Q,e,_,I,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class y{constructor(){this.testIdsToInternal=new Map}getTestById(s,d){if(d!==void 0){const S=this.testIdsToInternal.get(d),v=S==null?void 0:S.get(s);if(v)return[S,v]}return(0,_.mapFind)(this.testIdsToInternal.values(),S=>{const v=S.get(s);return v&&[S,v]})}createForHierarchy(s=()=>{}){return new b(this.createIdMap(R++),s)}createIdMap(s){const d=new D(s);return this.testIdsToInternal.set(d.id,d),{object:d,dispose:()=>this.testIdsToInternal.delete(d.id)}}}e.OwnedTestCollection=y;var n;(function(g){g[g.Disconnected=0]="Disconnected",g[g.IsChild=1]="IsChild",g[g.IsParent=2]="IsParent",g[g.IsSame=3]="IsSame"})(n=e.TestPosition||(e.TestPosition={}));let R=0;class D{constructor(s){this.id=s,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(s){if(this.map.has(s.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${s.item.extId}`);this.map.set(s.item.extId,s),s.parent||this._roots.add(s)}has(s){return this.map.has(s)}delete(s){const d=this.map.get(s);return d?(this.map.delete(s),this._roots.delete(d),!0):!1}get(s){return this.map.get(s)}comparePositions(s,d){const S=typeof s=="string"?this.map.get(s):s,v=typeof d=="string"?this.map.get(d):d;if(!S||!v)return 0;if(S===v)return 3;for(let E=this.map.get(v.parent);E;E=this.map.get(E.parent))if(E===S)return 1;for(let E=this.map.get(S.parent);E;E=this.map.get(E.parent))if(E===v)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=D;class b{constructor(s,d){this.testIdToInternal=s,this.publishDiff=d,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new I.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(s,d){this.addItem(s,d,null)}getTestByReference(s){return this.testItemToInternal.get(s)}collectDiff(){const s=this.diff;return this.diff=[],s}pushDiff(s){const d=this.diff[this.diff.length-1];if(d&&s[0]===1){if(d[0]===1&&d[1].extId===s[1].extId){(0,A.applyTestItemUpdate)(d[1],s[1]);return}if(d[0]===0&&d[1].item.extId===s[1].extId){(0,A.applyTestItemUpdate)(d[1],s[1]);return}}this.diff.push(s),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(s,d){var S;const v=this.testIdToInternal.object.get(s);if(!!v){if((v.expandLevels===void 0||d>v.expandLevels)&&(v.expandLevels=d),v.expand===1){const E=this.refreshChildren(v);return E.isSettled?this.expandChildren(v,d-1):E.p.then(()=>this.expandChildren(v,d-1))}else if(v.expand===3)return((S=v.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?v.initialExpand.p.then(()=>this.expandChildren(v,d-1)):this.expandChildren(v,d-1)}}dispose(){var s;for(const d of this.testItemToInternal.values())(s=d.discoverCts)===null||s===void 0||s.dispose(!0),d.actual[C.TestItemHookProperty]=void 0;this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}addItem(s,d,S){if(!(s instanceof C.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${s.id} did not`);if(this.testItemToInternal.has(s))throw new Error(`Attempted to add a single TestItem ${s.id} multiple times to the tree`);if(this.testIdToInternal.object.has(s.id))throw new Error(`Attempted to insert a duplicate test item ID ${s.id}`);const v=S?S.item.extId:null,E=s.expandable?1:0,m=S==null?void 0:S.expandLevels,l={provider:d,tree:this.testIdToInternal.object.id},o={actual:s,parent:v,item:P.TestItem.from(s),expandLevels:m&&E===1?m-1:void 0,expand:E,src:l};this.testIdToInternal.object.add(o),this.testItemToInternal.set(s,o),this.pushDiff([0,{parent:v,src:l,expand:E,item:o.item}]),s[C.TestItemHookProperty]={created:t=>this.addItem(t,d,o),delete:t=>this.removeItembyId(t),invalidate:t=>this.pushDiff([4,t]),setProp:(t,i)=>this.pushDiff([1,{extId:s.id,item:{[t]:t==="range"?P.Range.from(i):i}}])};for(const t of s.children)this.addItem(t,d,o)}expandChildren(s,d){if(!(d<0)){const S=[...s.actual.children].map(v=>this.expand(v.id,d-1)).filter(I.isThenable);if(S.length)return Promise.all(S).then(()=>{})}}refreshChildren(s){s.discoverCts&&s.discoverCts.dispose(!0),s.expand=2,s.discoverCts=new T.CancellationTokenSource,this.pushExpandStateUpdate(s);const d=new I.DeferredPromise;return s.initialExpand=d,s.actual.discoverChildren({report:S=>{S.busy?(s.expand=2,this.pushExpandStateUpdate(s)):(s.expand=3,d.isSettled||d.complete(),this.pushExpandStateUpdate(s))}},s.discoverCts.token),d}pushExpandStateUpdate(s){this.pushDiff([1,{extId:s.actual.id,expand:s.expand}])}removeItembyId(s){var d;this.pushDiff([2,s]);const S=[this.testIdToInternal.object.get(s)];for(;S.length;){const v=S.pop();if(!!v){(d=v.discoverCts)===null||d===void 0||d.dispose(!0),this.testIdToInternal.object.delete(v.item.extId),this.testItemToInternal.delete(v.actual);for(const E of v.actual.children)S.push(this.testIdToInternal.object.get(E.id))}}}flushDiff(){const s=this.collectDiff();s.length&&this.publishDiff(s)}}e.SingleUseTestCollection=b}),define(ge[222],ve([0,1,29,3,8]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=P;class C{constructor(R){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(_.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(_.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let D of R.activationEvents)D==="onUri"&&(D=`onUri:${_.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(D)||this._activationMap.set(D,[]),this._activationMap.get(D).push(R)}}keepOnly(R){const D=new Set;R.forEach(b=>D.add(_.ExtensionIdentifier.toKey(b))),this._extensionDescriptions=this._extensionDescriptions.filter(b=>D.has(_.ExtensionIdentifier.toKey(b.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,D){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const b=C._findLoopingExtensions(this._extensionDescriptions);if(D=D.concat(b.map(g=>g.identifier)),D.length>0){const g=new Set;D.forEach(s=>g.add(_.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!g.has(_.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new P(b)}static _findLoopingExtensions(R){const D=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,v){this.addNode(S),this.addNode(v),this._arcs.has(S)?this._arcs.get(S).push(v):this._arcs.set(S,[v])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,v){const E=D.getArcs(S);for(let m=0;m<E.length;m++)if(!v.has(E[m]))return!1;return!0}getNodes(){return this._nodesArr}};let b=new Map;for(let S of R){const v=_.ExtensionIdentifier.toKey(S.identifier);if(b.set(v,S),S.extensionDependencies)for(let E of S.extensionDependencies){const m=_.ExtensionIdentifier.toKey(E);D.addArc(v,m)}}let g=new Set;D.getNodes().filter(S=>D.getArcs(S).length===0).forEach(S=>g.add(S));let s=D.getNodes().filter(S=>!g.has(S)),d;do{d=!1;for(let S=0;S<s.length;S++){const v=s[S];D.hasOnlyGoodArcs(v,g)&&(s.splice(S,1),S--,g.add(v),d=!0)}}while(d);return s.map(S=>b.get(S))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(_.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const D=this._activationMap.get(R);return D?D.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const D=this._extensionsMap.get(_.ExtensionIdentifier.toKey(R));return D||void 0}}e.ExtensionDescriptionRegistry=C;var A;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(A||(A={}));function y(n,R){const D=n.isBuiltin?0:n.isUnderDevelopment?2:1,b=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(D!==b)return D-b;const g=T.posix.basename(n.extensionLocation.path),s=T.posix.basename(R.extensionLocation.path);return g<s?-1:g>s?1:0}}),define(ge[223],ve([0,1,22]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var I;(function(A){A[A.VersionMismatch=55]="VersionMismatch",A[A.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(A){A[A.Initialized=0]="Initialized",A[A.Ready=1]="Ready",A[A.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function P(A){const y=_.VSBuffer.alloc(1);switch(A){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=P;function C(A,y){if(A.byteLength!==1)return!1;switch(A.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=C}),define(ge[41],ve([0,1,3,2,4,29,183]),function(Q,e,_,I,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class A{constructor(E){this.dependency=E}}e.MissingDependencyError=A;var y;(function(v){v[v.LocalProcess=0]="LocalProcess",v[v.LocalWebWorker=1]="LocalWebWorker",v[v.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(E,m,l,o){this.codeLoadingTime=E,this.activateCallTime=m,this.activateResolvedTime=l,this.activationReason=o}}e.ActivationTimes=n;class R{constructor(E,m){this.description=E,this.value=m}}e.ExtensionPointContribution=R,e.ExtensionHostLogFileName="exthost";var D;(function(v){v[v.Normal=0]="Normal",v[v.Immediate=1]="Immediate"})(D=e.ActivationKind||(e.ActivationKind={}));function b(v){v.enableProposedApi||g(v)}e.checkProposedApiEnabled=b;function g(v){throw new Error(`[${v.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`)}e.throwProposedApiError=g;function s(v){return{type:v.isBuiltin?0:1,isBuiltin:v.isBuiltin||v.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(v.publisher,v.name),uuid:v.uuid},manifest:v,location:v.extensionLocation}}e.toExtension=s;function d(v){return Object.assign(Object.assign({identifier:new P.ExtensionIdentifier(v.identifier.id),isBuiltin:v.type===0,isUserBuiltin:v.type===1&&v.isBuiltin,isUnderDevelopment:!1,extensionLocation:v.location},v.manifest),{uuid:v.identifier.uuid})}e.toExtensionDescription=d;class S{constructor(){this.onDidRegisterExtensions=_.Event.None,this.onDidChangeExtensionsStatus=_.Event.None,this.onDidChangeExtensions=_.Event.None,this.onWillActivateByEvent=_.Event.None,this.onDidChangeResponsiveChange=_.Event.None}activateByEvent(E){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(E){return Promise.resolve(0)}restartExtensionHost(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(E,m){}_activateById(E,m){return Promise.resolve()}_onWillActivateExtension(E){}_onDidActivateExtension(E,m,l,o,t){}_onExtensionRuntimeError(E,m){}_onExtensionHostExit(E){}}e.NullExtensionService=S}),define(ge[224],ve([0,1,160,29,41,12]),function(Q,e,_,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class A{constructor(d,S,v,E){this.startup=d,this.codeLoadingTime=S,this.activateCallTime=v,this.activateResolvedTime=E}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class y{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,S){return d===-1||S===-1?-1:S-d}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class n{constructor(d,S,v,E,m,l){this.activationFailed=d,this.activationFailedError=S,this.activationTimes=v,this.module=E,this.exports=m,this.subscriptions=l}}e.ActivatedExtension=n;class R extends n{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class D extends n{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=D;class b extends n{constructor(d){super(!0,d,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=b;let g=class{constructor(d,S,v,E,m){this._logService=m,this._registry=d,this._resolvedExtensionsSet=new Set,S.forEach(l=>this._resolvedExtensionsSet.add(I.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,v.forEach(l=>this._hostExtensionsMap.set(I.ExtensionIdentifier.toKey(l),l)),this._host=E,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(d){const S=I.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(S)}getActivatedExtension(d){const S=I.ExtensionIdentifier.toKey(d),v=this._activatedExtensions.get(S);if(!v)throw new Error("Extension `"+d.value+"` is not known or not activated");return v}activateByEvent(d,S){if(this._alreadyActivatedEvents[d])return C;const v=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(v.map(E=>({id:E.identifier,reason:{startup:S,extensionId:E.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,S){const v=this._registry.getExtensionDescription(d);if(!v)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:v.identifier,reason:S}])}_handleActivateRequest(d,S,v){if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(d.id))){S[I.ExtensionIdentifier.toKey(d.id)]=d;return}const E=this._registry.getExtensionDescription(d.id);if(!E){this._host.onExtensionActivationError(d.id,new T.MissingDependencyError(d.id.value));const o=new Error(`Unknown dependency '${d.id.value}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(d.id),new b(o));return}const m=typeof E.extensionDependencies=="undefined"?[]:E.extensionDependencies;let l=!0;for(let o=0,t=m.length;o<t;o++){const i=m[o];if(!this._resolvedExtensionsSet.has(I.ExtensionIdentifier.toKey(i))){const a=this._activatedExtensions.get(I.ExtensionIdentifier.toKey(i));if(!(a&&!a.activationFailed)){if(a&&a.activationFailed){this._host.onExtensionActivationError(E.identifier,_.localize(0,null,E.displayName||E.identifier.value,i));const h=new Error(`Dependency ${i} failed to activate`);h.detail=a.activationFailedError,this._activatedExtensions.set(I.ExtensionIdentifier.toKey(E.identifier),new b(h));return}if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(i))){l=!1,S[I.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(I.ExtensionIdentifier.toKey(i)),reason:d.reason};continue}const r=this._registry.getExtensionDescription(i);if(r){l=!1,S[I.ExtensionIdentifier.toKey(i)]={id:r.identifier,reason:d.reason};continue}this._host.onExtensionActivationError(E.identifier,new T.MissingDependencyError(i));const c=new Error(`Unknown dependency '${i}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(E.identifier),new b(c));return}}}l?S[I.ExtensionIdentifier.toKey(E.identifier)]=d:v.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(m=>!this._activatedExtensions.has(I.ExtensionIdentifier.toKey(m.id))),d.length===0))return Promise.resolve(void 0);const S=Object.create(null),v=[];for(let m=0,l=d.length;m<l;m++)this._handleActivateRequest(d[m],S,v);for(let m=0,l=v.length;m<l;m++){const o=I.ExtensionIdentifier.toKey(v[m].id);S[o]&&delete S[o]}const E=Object.keys(S).map(m=>S[m]);return v.length===0?Promise.all(E.map(m=>this._activateExtension(m.id,m.reason))).then(m=>{}):this._activateExtensions(E).then(m=>this._activateExtensions(v))}_activateExtension(d,S){const v=I.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(v))return Promise.resolve(void 0);const E=this._activatingExtensions.get(v);if(E)return E;const m=this._host.actualActivateExtension(d,S).then(void 0,l=>(this._host.onExtensionActivationError(d,_.localize(1,null,d.value,l.message)),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(l),new b(l))).then(l=>{this._activatedExtensions.set(v,l),this._activatingExtensions.delete(v)});return this._activatingExtensions.set(v,m),m}};g=je([Ue(4,P.ILogService)],g),e.ExtensionsActivator=g}),define(ge[225],ve([0,1,12,41,27,11,109]),function(Q,e,_,I,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends _.LogService{constructor(n){if(n.logFile.scheme!==P.Schemas.file)throw new Error("Only file-logging supported");super(new C.SpdLogLogger(I.ExtensionHostLogFileName,n.logFile.fsPath,!0,n.logLevel))}$setLevel(n){this.setLevel(n)}};A=je([Ue(0,T.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(ge[226],ve([0,1,18]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((P,C)=>{this._actualOk=P,this._actualErr=C,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(P){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=P,this._actual&&this._actualOk(P))}resolveErr(P){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=P,this._actual?this._actualErr(P):(0,_.onUnexpectedError)(P))}then(P,C){return this._ensureActual().then(P,C)}catch(P){return this._ensureActual().then(void 0,P)}finally(P){return this._ensureActual().finally(P)}}e.LazyPromise=I}),define(ge[123],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class _{constructor(y,n){this.isMain=y,this.sid=n,this.nid=++_.count}}e.ProxyIdentifier=_,_.count=0;const I=[];function T(A){const y=new _(!0,A);return I[y.nid]=y,y}e.createMainContextProxyIdentifier=T;function P(A){const y=new _(!1,A);return I[y.nid]=y,y}e.createExtHostContextProxyIdentifier=P;function C(A){return I[A].sid}e.getStringIdentifierForProxy=C}),define(ge[5],ve([0,1,2,123,57]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var P;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var C;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var A;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(A=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var n;(function(l){l[l.Markdown=1]="Markdown",l[l.Code=2]="Code"})(n=e.CellKind||(e.CellKind={}));var R;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(R=e.CellOutputKind||(e.CellOutputKind={}));var D;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(D=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var b;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(b=e.CandidatePortSource||(e.CandidatePortSource={}));var g;(function(l){l.name="$ident";function o(i,a){return Object.defineProperty(i,l.name,{value:a,enumerable:!0}),i}l.mixin=o;function t(i){return i[l.name]}l.of=t})(g=e.ObjectIdentifier||(e.ObjectIdentifier={}));class s{static mixin(o){return o._id=s._n++,o}}e.IdObject=s,s._n=0;var d;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n",l.label2="o"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var S;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(S=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function E(l){if(l&&l.edits)for(const o of l.edits)typeof o.resource=="object"?o.resource=_.URI.revive(o.resource):(o.newUri=_.URI.revive(o.newUri),o.oldUri=_.URI.revive(o.oldUri)),o.metadata&&o.metadata.iconPath&&(o.metadata=(0,T.revive)(o.metadata));return l}e.reviveWorkspaceEditDto=E;var m;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ge[86],ve([0,1,5,3,4]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(A){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(_.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,y){return this._proxy.$getPassword(A,y)}store(A,y,n){return this._proxy.$setPassword(A,y,n)}delete(A,y){return this._proxy.$deletePassword(A,y)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")}),define(ge[62],ve([0,1,4,12,5,13]),function(Q,e,_,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,_.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(y,n){this._extHostLogService=n,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(T.MainContext.MainThreadTelemetry)}report(y,n,R){const D=this.getUsageKey(y,n);this._reportedUsages.has(D)||(this._reportedUsages.add(D),n.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:n.identifier.value,apiId:y}))}getUsageKey(y,n){return`${y}-${n.identifier.value}`}};C=je([Ue(0,P.IExtHostRpcService),Ue(1,I.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,n){}})}),define(ge[227],ve([0,1,3,5,7,29]),function(Q,e,_,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new _.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new _.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,n,R,D={}){const b=P.ExtensionIdentifier.toKey(y.identifier),g=this._inFlightRequests.get(b)||[],s=R.sort().join(" ");let d=g.find(S=>S.scopes===s);if(d)return d.result;{const S=this._getSession(y,b,n,R,D);d={scopes:s,result:S},g.push(d),this._inFlightRequests.set(b,g);try{await S}finally{const v=g.findIndex(E=>E.scopes===s);v>-1&&(g.splice(v),this._inFlightRequests.set(b,g))}return S}}async _getSession(y,n,R,D,b={}){await this._proxy.$ensureProvider(R);const g=y.displayName||y.name;return this._proxy.$getSession(R,D,n,g,b)}async removeSession(y,n){const R=this._authenticationProviders.get(y);return R?R.provider.removeSession(n):this._proxy.$removeSession(y,n)}registerAuthenticationProvider(y,n,R,D){var b;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:n,provider:R,options:D!=null?D:{supportsMultipleAccounts:!1}}),this._providers.find(s=>s.id===y)||this._providers.push({id:y,label:n});const g=R.onDidChangeSessions(s=>{var d,S,v;this._proxy.$sendDidChangeSessions(y,{added:(d=s.added)!==null&&d!==void 0?d:[],changed:(S=s.changed)!==null&&S!==void 0?S:[],removed:(v=s.removed)!==null&&v!==void 0?v:[]})});return this._proxy.$registerAuthenticationProvider(y,n,(b=D==null?void 0:D.supportsMultipleAccounts)!==null&&b!==void 0?b:!1),new T.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(y);const s=this._providers.findIndex(d=>d.id===y);s>-1&&this._providers.splice(s),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,n){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.createSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,n){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.removeSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,n){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.getSessions(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,n){return this._onDidChangeSessions.fire({provider:{id:y,label:n}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,n){return y.forEach(R=>{this._providers.some(D=>D.id===R.id)||this._providers.push(R)}),n.forEach(R=>{const D=this._providers.findIndex(b=>b.id===R.id);D>-1&&this._providers.splice(D)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:n}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(ge[228],ve([0,1,5,13,20]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(A,y){this._extHostDocumentsAndEditors=y,this._proxy=A.getProxy(_.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(A){const y=T.WorkspaceEdit.from(A,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};P=je([Ue(0,I.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(ge[229],ve([0,1,5]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(P){const C=P.getProxy(_.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(A){return C.$writeText(A)}})}}e.ExtHostClipboard=I}),define(ge[51],ve([0,1,15,7,20,23,5,14,12,57,43,49,2,6,4,13]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(C.MainContext.MainThreadCommands),this._logService=i,this.converter=new v(this,a=>{const r=this._apiCommands.get(a);return(r==null?void 0:r.result)===m.Void?r:void 0},i),this._argumentProcessors=[{processArgument(a){return(0,n.revive)(a)}},{processArgument(a){return(0,P.cloneAndChange)(a,function(r){if(R.Range.isIRange(r))return T.Range.to(r);if(D.Position.isIPosition(r))return T.Position.to(r);if(R.Range.isIRange(r.range)&&b.URI.isUri(r.uri))return T.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...a)=>{const r=t.args.map((h,p)=>{if(!h.validate(a[p]))throw new Error(`Invalid argument '${h.name}' when running '${t.id}', received: ${a[p]}`);return h.convert(a[p])}),c=await this.executeCommand(t.internalId,...r);return t.result.convert(c,a,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new I.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,a,r,c){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:a,thisArg:r,description:c}),t&&this._proxy.$registerCommand(i),new I.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,a){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const r=(0,P.cloneAndChange)(i,function(c){if(c instanceof I.Position)return T.Position.from(c);if(c instanceof I.Range)return T.Range.from(c);if(c instanceof I.Location)return T.location.from(c);if(!Array.isArray(c))return c});try{const c=await this._proxy.$executeCommand(t,r,a);return(0,n.revive)(c)}catch(c){if(c instanceof Error&&c.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw c}}}async _executeContributedCommand(t,i){const a=this._commands.get(t);if(!a)throw new Error("Unknown command");let{callback:r,thisArg:c,description:h}=a;if(h)for(let p=0;p<h.args.length;p++)try{(0,_.validateConstraint)(i[p],h.args[p].constraint)}catch(w){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${h.args[p].name}' - ${h.args[p].description}`)}try{return await r.apply(c,i)}catch(p){if(t===this.converter.delegatingCommandId){const w=this.converter.getActualCommand(...i);w&&(t=w.command)}throw this._logService.error(p,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(a=>this._argumentProcessors.reduce((r,c)=>c.processArgument(r),a)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(a=>a[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,a]of this._commands){let{description:r}=a;r&&(t[i]=r)}return Promise.resolve(t)}};S=je([Ue(0,d.IExtHostRpcService),Ue(1,y.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class v{constructor(t,i,a){this._commands=t,this._lookupApiCommand=i,this._logService=a,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!!t){const a={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return a;const r=this._lookupApiCommand(t.command);if(r)a.id=r.internalId,a.arguments=r.args.map((c,h)=>c.convert(t.arguments&&t.arguments[h]));else if((0,A.isNonEmptyArray)(t.arguments)){const c=++this._cachIdPool;this._cache.set(c,t),i.add((0,g.toDisposable)(()=>{this._cache.delete(c),this._logService.trace("CommandsConverter#DISPOSE",c)})),a.$ident=c,a.id=this.delegatingCommandId,a.arguments=[c],this._logService.trace("CommandsConverter#CREATE",t.command,c)}return a}}fromInternal(t){const i=C.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class E{constructor(t,i,a,r){this.name=t,this.description=i,this.validate=a,this.convert=r}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new E(t!=null?t:this.name,i!=null?i:this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",o=>b.URI.isUri(o),o=>o),E.Position=new E("position","A position in a text document",o=>I.Position.isPosition(o),T.Position.from),E.Range=new E("range","A range in a text document",o=>I.Range.isRange(o),T.Range.from),E.Selection=new E("selection","A selection in a text document",o=>I.Selection.isSelection(o),T.Selection.from),E.Number=new E("number","",o=>typeof o=="number",o=>o),E.String=new E("string","",o=>typeof o=="string",o=>o),E.CallHierarchyItem=new E("item","A call hierarchy item",o=>o instanceof I.CallHierarchyItem,T.CallHierarchyItem.to);class m{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=m,m.Void=new m("no result",o=>o);class l{constructor(t,i,a,r,c){this.id=t,this.internalId=i,this.description=a,this.args=r,this.result=c}}e.ApiCommand=l}),define(ge[230],ve([0,1,6,20,7,79,51,202,14,106]),function(Q,e,_,I,T,P,C,A,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const R=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",b(I.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(s,d)=>{if(!(0,y.isFalsyOrEmpty)(s)){class S extends T.SymbolInformation{static to(E){const m=new S(E.name,I.SymbolKind.to(E.kind),E.containerName||"",new T.Location(d[0],I.Range.to(E.range)));return m.detail=E.detail,m.range=m.location.range,m.selectionRange=I.Range.to(E.selectionRange),m.children=E.children?E.children.map(S.to):[],m}}return s.map(S.to)}})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(I.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(I.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",s=>typeof s=="string",s=>s),new C.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(I.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(I.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(I.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",s=>Array.isArray(s)&&s.every(d=>T.Position.isPosition(d)),s=>s.map(I.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",s=>s.map(d=>{let S;for(const v of d.reverse())S=new T.SelectionRange(I.Range.to(v),S);return S}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",s=>{const d=[];if(Array.isArray(s))for(let S of s)d.push(...S[1].map(I.WorkspaceSymbol.to));return d})),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(I.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(I.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(I.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",s=>{if(!!s){if(s.rejectReason)throw new Error(s.rejectReason);return I.WorkspaceEdit.to(s)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(I.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new T.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!!s){const d=(0,n.decodeSemanticTokensDto)(s);if(d.type==="full")return new T.SemanticTokens(d.data,void 0)}})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new T.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!!s){const d=(0,n.decodeSemanticTokensDto)(s);if(d.type==="full")return new T.SemanticTokens(d.data,void 0)}})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(s,d,S)=>{if(!s)return new T.CompletionList([]);const v=s.suggestions.map(E=>I.CompletionItem.to(E,S));return new T.CompletionList(v,s.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",s=>{if(s)return I.SignatureHelp.to(s)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(s,d,S)=>b(v=>new T.CodeLens(I.Range.to(v.range),v.command&&S.fromInternal(v.command)))(s))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>T.Range.isRange(s),s=>T.Selection.isSelection(s)?I.Selection.from(s):I.Range.from(s)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(s,d,S)=>b(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return S.fromInternal(v.command)}else{const E=new T.CodeAction(v.title,v.kind?new T.CodeActionKind(v.kind):void 0);return v.edit&&(E.edit=I.WorkspaceEdit.to(v.edit)),v.command&&(E.command=S.fromInternal(v.command)),E.isPreferred=v.isPreferred,E}})(s))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(d=>new T.ColorInformation(I.Range.to(d.range),I.Color.to(d.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",s=>s instanceof T.Color,I.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:I.Range.from(s.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(I.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineHint objects",s=>s.map(I.InlineHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientMetadata:s.options.transientMetadata},filenamePattern:s.filenamePattern.map(d=>I.NotebookExclusiveDocumentPattern.to(d))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",s=>s.map(I.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[s,void 0]:[I.ViewColumn.from(s.viewColumn),I.TextEditorOpenOptions.from(s)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[s,void 0]:[I.ViewColumn.from(s.viewColumn),I.TextEditorOpenOptions.from(s)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[I.ViewColumn.from(s.viewColumn),I.TextEditorOpenOptions.from(s)]).optional()],C.ApiCommandResult.Void)];class D{constructor(d){this._disposables=new _.DisposableStore,this._commands=d}static register(d){return R.forEach(d.registerApiCommand,d),new D(d).registerCommands()}registerCommands(){const d=S=>(...v)=>S(this._commands,...v);this._register(A.RemoveFromRecentlyOpenedAPICommand.ID,d(A.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:S=>typeof S=="string"}]}),this._register(A.OpenIssueReporter.ID,d(A.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:S=>typeof S=="string"||typeof S=="object"&&typeof S.extensionId=="string"}]})}_register(d,S,v){const E=this._commands.registerCommand(!1,d,S,this,v);this._disposables.add(E)}}e.ExtHostApiCommands=D;function b(s){return d=>{if(Array.isArray(d))return d.map(s)}}function g(s){if(!!Array.isArray(s)){const d=[];for(const S of s)P.isLocationLink(S)?d.push(I.DefinitionLink.to(S)):d.push(I.location.to(S));return d}}}),define(ge[231],ve([0,1,19,68,3,6,2,79,29,20,7,5]),function(Q,e,_,I,T,P,C,A,y,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class b{constructor(l,o,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=l.getProxy(D.MainContext.MainThreadComments),o.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const a=this._commentControllers.get(i.handle);return a||i}else if(i&&i.$mid===7){const a=this._commentControllers.get(i.commentControlHandle);if(!a)return i;const r=a.getCommentThread(i.commentThreadHandle);return r||i}else if(i&&i.$mid===8){const a=this._commentControllers.get(i.thread.commentControlHandle);if(!a)return i;const r=a.getCommentThread(i.thread.commentThreadHandle);return r?{thread:r,text:i.text}:i}else if(i&&i.$mid===9){const a=this._commentControllers.get(i.thread.commentControlHandle);if(!a)return i;const r=a.getCommentThread(i.thread.commentThreadHandle);if(!r)return i;let c=i.commentUniqueId,h=r.getCommentByUniqueId(c);return h||i}else if(i&&i.$mid===10){const a=this._commentControllers.get(i.thread.commentControlHandle);if(!a)return i;const r=a.getCommentThread(i.thread.commentThreadHandle);if(!r)return i;let c=i.text,h=i.commentUniqueId,p=r.getCommentByUniqueId(h);return p?(p.body=c,p):i}return i}})}createCommentController(l,o,t){const i=b.handlePool++,a=new s(l,i,this._proxy,o,t);this._commentControllers.set(a.handle,a);const r=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(l.identifier))||[];return r.push(a),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(l.identifier),r),a}$createCommentThreadTemplate(l,o,t){const i=this._commentControllers.get(l);!i||i.$createCommentThreadTemplate(o,t)}async $updateCommentThreadTemplate(l,o,t){const i=this._commentControllers.get(l);!i||i.$updateCommentThreadTemplate(o,t)}$deleteCommentThread(l,o){const t=this._commentControllers.get(l);t&&t.$deleteCommentThread(o)}$provideCommentingRanges(l,o,t){const i=this._commentControllers.get(l);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const a=this._documents.getDocument(C.URI.revive(o));return(0,_.asPromise)(()=>i.commentingRangeProvider.provideCommentingRanges(a,t)).then(r=>r?r.map(c=>n.Range.from(c)):void 0)}$toggleReaction(l,o,t,i,a){const r=this._commentControllers.get(l);return!r||!r.reactionHandler?Promise.resolve(void 0):(0,_.asPromise)(()=>{const c=r.getCommentThread(o);if(c){const h=c.getCommentByUniqueId(i.uniqueIdInThread);if(r!==void 0&&h&&r.reactionHandler)return r.reactionHandler(h,v(a))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=b,b.handlePool=0;class g{constructor(l,o,t,i,a,r,c){this._proxy=l,this._commentController=o,this._id=t,this._uri=i,this._range=a,this._comments=r,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new T.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${o.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,n.Range.from(this._range),c),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(l){this._id=l}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(l){l.isEqual(this._range)||(this._range=l,this.modifications.range=l,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(l){this._canReply!==l&&(this._canReply=l,this.modifications.canReply=l,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(l){this._label=l,this.modifications.label=l,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(l){this._contextValue=l,this.modifications.contextValue=l,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(l){this._comments=l,this.modifications.comments=l,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(l){this._collapseState=l,this.modifications.collapsibleState=l,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const l=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),o={};l("range")&&(o.range=n.Range.from(this._range)),l("label")&&(o.label=this.label),l("contextValue")&&(o.contextValue=this.contextValue),l("comments")&&(o.comments=this._comments.map(t=>d(this,this._commentController,t,this._commentsMap))),l("collapsibleState")&&(o.collapseState=E(this._collapseState)),l("canReply")&&(o.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,o)}}getCommentByUniqueId(l){for(let o of this._commentsMap){let t=o[0],i=o[1];if(l===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(l=>l.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}g._handlePool=0,je([(0,I.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=g;class s{constructor(l,o,t,i,a){this._extension=l,this._handle=o,this._proxy=t,this._id=i,this._label=a,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,a)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(l){this._reactionHandler=l,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this._options}set options(l){this._options=l,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(l,o,t,i){if(typeof l=="string"){const a=new g(this._proxy,this,l,o,t,i,this._extension.identifier);return this._threads.set(a.handle,a),a}else{const a=new g(this._proxy,this,void 0,l,o,t,this._extension.identifier);return this._threads.set(a.handle,a),a}}$createCommentThreadTemplate(l,o){const t=new g(this._proxy,this,void 0,C.URI.revive(l),n.Range.to(o),[],this._extension.identifier);return t.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(l,o){let t=this._threads.get(l);t&&(t.range=n.Range.to(o))}$deleteCommentThread(l){let o=this._threads.get(l);o&&o.dispose(),this._threads.delete(l)}getCommentThread(l){return this._threads.get(l)}dispose(){this._threads.forEach(l=>{l.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function d(m,l,o,t){let i=t.get(o);i||(i=++m.commentHandle,t.set(o,i));const a=o.author&&o.author.iconPath?o.author.iconPath.toString():void 0;return{mode:o.mode,contextValue:o.contextValue,uniqueIdInThread:i,body:n.MarkdownString.from(o.body),userName:o.author.name,userIconPath:a,label:o.label,commentReactions:o.reactions?o.reactions.map(r=>S(r)):void 0}}function S(m){return{label:m.label,iconPath:m.iconPath?n.pathOrURIToURI(m.iconPath):void 0,count:m.count,hasReacted:m.authorHasReacted}}function v(m){return{label:m.label||"",count:m.count||0,iconPath:m.iconPath?C.URI.revive(m.iconPath):"",authorHasReacted:m.hasReacted||!1}}function E(m){if(m!==void 0)switch(m){case R.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}}),define(ge[124],ve([0,1,2,5,7,4,13,12,14,10,8]),function(Q,e,_,I,T,P,C,A,y,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let D=class fn{constructor(g,s){this._logService=s,this._provider=new Map,this._proxy=g.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,s){const d=fn._handlePool++;this._provider.set(d,{provider:g,extensionId:s}),this._proxy.$registerDecorationProvider(d,s.value);const S=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(v=>{if(!v){this._proxy.$onDidChange(d,null);return}let E=(0,y.asArray)(v);if(E.length<=fn._maxEventSize){this._proxy.$onDidChange(d,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,E.length);const m=E.map(t=>({uri:t,rank:(0,n.count)(t.path,"/")})),l=(0,y.groupBy)(m,(t,i)=>t.rank-i.rank||(0,n.compare)(t.uri.path,i.uri.path));let o=[];e:for(let t of l){let i;for(let a of t){let r=(0,R.dirname)(a.uri.path);if(i!==r&&(i=r,o.push(a.uri)>=fn._maxEventSize))break e}}this._proxy.$onDidChange(d,o)});return new T.Disposable(()=>{S==null||S.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(g,s,d){if(!this._provider.has(g))return Object.create(null);const S=Object.create(null),{provider:v,extensionId:E}=this._provider.get(g);return await Promise.all(s.map(async m=>{try{const{uri:l,id:o}=m,t=await Promise.resolve(v.provideFileDecoration(_.URI.revive(l),d));if(!t)return;try{T.FileDecoration.validate(t),S[o]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${E.value}': ${i}`)}}catch(l){this._logService.error(l)}})),S}};D._handlePool=0,D._maxEventSize=250,D=je([Ue(0,C.IExtHostRpcService),Ue(1,A.ILogService)],D),e.ExtHostDecorations=D,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")}),define(ge[232],ve([0,1,159,110,2,5,7,20,3,12,24]),function(Q,e,_,I,T,P,C,A,y,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class D{constructor(s,d,S,v,E){this._name=s,this._owner=d,this._maxDiagnosticsPerFile=S,this._proxy=v,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new R.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(s,d){if(!s){this.clear();return}this._checkDisposed();let S=[];if(T.URI.isUri(s)){if(!d){this.delete(s);return}this._data.set(s,d.slice()),S=[s]}else if(Array.isArray(s)){S=[];let E;s=[...s].sort(D._compareIndexedTuplesByUri);for(const m of s){const[l,o]=m;if((!E||l.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=l,S.push(l),this._data.set(l,[])),o){const t=this._data.get(l);t&&t.push(...o)}else{const t=this._data.get(l);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(S),!!this._proxy){const v=[];for(let E of S){let m=[];const l=this._data.get(E);if(l)if(l.length>this._maxDiagnosticsPerFile){m=[];const o=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of l)if(i.severity===o[t]&&m.push(A.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;m.push({severity:I.MarkerSeverity.Info,message:(0,_.localize)(0,null,l.length-this._maxDiagnosticsPerFile),startLineNumber:m[m.length-1].startLineNumber,startColumn:m[m.length-1].startColumn,endLineNumber:m[m.length-1].endLineNumber,endColumn:m[m.length-1].endColumn})}else m=l.map(o=>A.Diagnostic.from(o));v.push([E,m])}this._proxy.$changeMany(this._owner,v)}}delete(s){this._checkDisposed(),this._onDidChangeDiagnostics.fire([s]),this._data.delete(s),this._proxy&&this._proxy.$changeMany(this._owner,[[s,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(s,d){this._checkDisposed();for(let S of this._data.keys())s.apply(d,[S,this.get(S),this])}get(s){this._checkDisposed();const d=this._data.get(s);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(s){return this._checkDisposed(),Array.isArray(this._data.get(s))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(s,d){return s[0].toString()<d[0].toString()?-1:s[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=D;let b=class zt{constructor(s,d){this._logService=d,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,zt._debouncer,50),zt._mapper),this._proxy=s.getProxy(P.MainContext.MainThreadDiagnostics)}static _debouncer(s,d){return s?s.concat(d):d}static _mapper(s){const d=[],S=new Set;for(const v of s)typeof v=="string"?S.has(v)||(S.add(v),d.push(T.URI.parse(v))):S.has(v.toString())||(S.add(v.toString()),d.push(v));return Object.freeze(d),{uris:d}}createDiagnosticCollection(s,d){const{_collections:S,_proxy:v,_onDidChangeDiagnostics:E,_logService:m}=this,l=new class{$changeMany(i,a){v.$changeMany(i,a),m.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,i,a.length===0?"CLEARING":a)}$clear(i){v.$clear(i),m.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,i)}dispose(){v.dispose()}};let o;if(!d)d="_generated_diagnostic_collection_name_#"+zt._idPool++,o=d;else if(!S.has(d))o=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do o=d+zt._idPool++;while(S.has(o))}return new class extends D{constructor(){super(d,o,zt._maxDiagnosticsPerFile,l,E);S.set(o,this)}dispose(){super.dispose(),S.delete(o)}}}getDiagnostics(s){if(s)return this._getDiagnostics(s);{const d=new Map,S=[];for(const v of this._collections.values())v.forEach((E,m)=>{let l=d.get(E.toString());typeof l=="undefined"&&(l=S.length,d.set(E.toString(),l),S.push([E,[]])),S[l][1]=S[l][1].concat(...m)});return S}}_getDiagnostics(s){let d=[];for(let S of this._collections.values())S.has(s)&&(d=d.concat(S.get(s)));return d}$acceptMarkersChange(s){if(!this._mirrorCollection){const d="_generated_mirror",S=new D(d,d,zt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(d,S),this._mirrorCollection=S}for(const[d,S]of s)this._mirrorCollection.set(T.URI.revive(d),S.map(A.Diagnostic.to))}};b._idPool=0,b._maxDiagnosticsPerFile=1e3,b=je([Ue(1,n.ILogService)],b),e.ExtHostDiagnostics=b}),define(ge[233],ve([0,1,2,5]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(C){this._proxy=C.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(C){return this._proxy.$showOpenDialog(C).then(A=>A?A.map(y=>_.URI.revive(y)):void 0)}showSaveDialog(C){return this._proxy.$showSaveDialog(C).then(A=>A?_.URI.revive(A):void 0)}}e.ExtHostDialogs=T}),define(ge[234],ve([0,1,18,2,7,5,11,21,10]),function(Q,e,_,I,T,P,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class n{constructor(D,b,g){this._documentsAndEditors=b,this._logService=g,this._documentContentProviders=new Map,this._proxy=D.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,b){if(Object.keys(C.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const g=n._handlePool++;this._documentContentProviders.set(g,b),this._proxy.$registerTextContentProvider(g,D);let s;return typeof b.onDidChange=="function"&&(s=b.onDidChange(d=>{if(d.scheme!==D){this._logService.warn(`Provider for scheme '${D}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(g,d).then(S=>{if(!(!S&&typeof S!="string")){const v=this._documentsAndEditors.getDocument(d);if(!!v){const E=(0,y.splitLines)(S);if(!v.equalLines(E))return this._proxy.$onVirtualDocumentChange(d,S)}}},_.onUnexpectedError)})),new T.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(D,b){const g=this._documentContentProviders.get(D);return g?Promise.resolve(g.provideTextDocumentContent(I.URI.revive(b),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${b.scheme}`))}}e.ExtHostDocumentContentProvider=n,n._handlePool=0}),define(ge[235],ve([0,1,3,6,2,5,118,20,15,23]),function(Q,e,_,I,T,P,C,A,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class R{constructor(b,g){this._onDidAddDocument=new _.Emitter,this._onDidRemoveDocument=new _.Emitter,this._onDidChangeDocument=new _.Emitter,this._onDidSaveDocument=new _.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=b.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(s=>{for(const d of s)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(s=>{for(const d of s)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(b){if(!!b){const g=this._documentsAndEditors.getDocument(b);if(g)return g}}getDocument(b){const g=this.getDocumentData(b);if(!(g==null?void 0:g.document))throw new Error(`Unable to retrieve document from URI '${b}'`);return g.document}ensureDocumentData(b){const g=this._documentsAndEditors.getDocument(b);if(g)return Promise.resolve(g);let s=this._documentLoader.get(b.toString());return s||(s=this._proxy.$tryOpenDocument(b).then(d=>{this._documentLoader.delete(b.toString());const S=T.URI.revive(d);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(S))},d=>(this._documentLoader.delete(b.toString()),Promise.reject(d))),this._documentLoader.set(b.toString(),s)),s}createDocumentData(b){return this._proxy.$tryCreateDocument(b).then(g=>T.URI.revive(g))}$acceptModelModeChanged(b,g){const s=T.URI.revive(b),d=this._documentsAndEditors.getDocument(s);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(g),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(b){const g=T.URI.revive(b),s=this._documentsAndEditors.getDocument(g);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this._onDidSaveDocument.fire(s.document)}$acceptDirtyStateChanged(b,g){const s=T.URI.revive(b),d=this._documentsAndEditors.getDocument(s);if(!d)throw new Error("unknown document");d._acceptIsDirty(g),this._onDidChangeDocument.fire({document:d.document,contentChanges:[]})}$acceptModelChanged(b,g,s){const d=T.URI.revive(b),S=this._documentsAndEditors.getDocument(d);if(!S)throw new Error("unknown document");S._acceptIsDirty(s),S.onEvents(g),this._onDidChangeDocument.fire((0,n.deepFreeze)({document:S.document,contentChanges:g.changes.map(v=>({range:A.Range.to(v.range),rangeOffset:v.rangeOffset,rangeLength:v.rangeLength,text:v.text}))}))}setWordDefinitionFor(b,g){(0,C.setWordDefinitionFor)(b,g)}}e.ExtHostDocuments=R}),define(ge[39],ve([0,1,52,3,6,2,4,5,118,13,122,20,12,24,11,71,133]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class v{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(l,o){this._extHostRpc=l,this._logService=o,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const o=[],t=[],i=[];if(l.removedDocuments)for(const a of l.removedDocuments){const r=P.URI.revive(a),c=this._documents.get(r);(c==null?void 0:c.unref())&&(this._documents.delete(r),o.push(c.value))}if(l.addedDocuments)for(const a of l.addedDocuments){const r=P.URI.revive(a.uri);let c=this._documents.get(r);if(c&&r.scheme!==s.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);c||(c=new v(new y.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),r,a.lines,a.EOL,a.versionId,a.modeId,a.isDirty,a.notebook)),this._documents.set(r,c),t.push(c.value)),c.ref()}if(l.removedEditors)for(const a of l.removedEditors){const r=this._editors.get(a);this._editors.delete(a),r&&i.push(r)}if(l.addedEditors)for(const a of l.addedEditors){const r=P.URI.revive(a.documentUri);_.ok(this._documents.has(r),`document '${r}' does not exist`),_.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const c=this._documents.get(r).value,h=new R.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>c.document),a.selections.map(D.Selection.to),a.options,a.visibleRanges.map(p=>D.Range.to(p)),typeof a.editorPosition=="number"?D.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,h)}l.newActiveEditor!==void 0&&(_.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,T.dispose)(o),(0,T.dispose)(i),l.removedDocuments&&this._onDidRemoveDocuments.fire(o),l.addedDocuments&&this._onDidAddDocuments.fire(t),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){var o;return(o=this._documents.get(l))===null||o===void 0?void 0:o.value}allDocuments(){return d.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!!this._activeEditorId){const o=this._editors.get(this._activeEditorId);return l?o:o==null?void 0:o.value}}allEditors(){return[...this._editors.values()]}};E=je([Ue(0,n.IExtHostRpcService),Ue(1,b.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(ge[236],ve([0,1,2,5,6,7,20,141,10,22]),function(Q,e,_,I,T,P,C,A,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class R{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const s=this._schemes.indexOf(g);s>=0&&(this._schemes.splice(s,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),s=[];let d,S,v=14,E=14;for(const m of g){let l=d?(0,y.commonPrefixLength)(d,m):0;for(l===0?S=1:S=E;l<m.length;l++)l+1===m.length?(v=E,E=9):E+=1,s.push([S,m.toUpperCase().charCodeAt(l),E]),s.push([S,m.toLowerCase().charCodeAt(l),E]),S=E;d=m,E=v}s.push([9,58,10]),s.push([10,47,12]),this._stateMachine=new A.StateMachine(s)}}provideDocumentLinks(g){this._initStateMachine();const s=[],d=A.LinkComputer.computeLinks({getLineContent(S){return g.lineAt(S-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const S of d){const v=C.DocumentLink.to(S);v.target&&s.push(v)}return s}}class D{constructor(g,s){this._extHostLanguageFeatures=s,this._linkProvider=new R,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=g.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){var g;(g=this._linkProviderRegistration)===null||g===void 0||g.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(g,s,d,S={}){if(this._registeredSchemes.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const v=this._handlePool++;this._linkProvider.add(s),this._registeredSchemes.add(s),this._fsProvider.set(v,d);let E=2;S.isCaseSensitive&&(E+=1024),S.isReadonly&&(E+=2048),typeof d.copy=="function"&&(E+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&(E+=4),this._proxy.$registerFileSystemProvider(v,s,E).catch(l=>{console.error(`FAILED to register filesystem provider of ${g.value}-extension for the scheme ${s}`),console.error(l)});const m=d.onDidChangeFile(l=>{const o=[];for(const t of l){let{uri:i,type:a}=t;if(i.scheme===s){let r;switch(a){case P.FileChangeType.Changed:r=0;break;case P.FileChangeType.Created:r=1;break;case P.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:i,type:r})}}this._proxy.$onFileSystemChange(v,o)});return(0,T.toDisposable)(()=>{m.dispose(),this._linkProvider.delete(s),this._registeredSchemes.delete(s),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(g){const{type:s,ctime:d,mtime:S,size:v}=g;return{type:s,ctime:d,mtime:S,size:v}}$stat(g,s){return Promise.resolve(this._getFsProvider(g).stat(_.URI.revive(s))).then(D._asIStat)}$readdir(g,s){return Promise.resolve(this._getFsProvider(g).readDirectory(_.URI.revive(s)))}$readFile(g,s){return Promise.resolve(this._getFsProvider(g).readFile(_.URI.revive(s))).then(d=>n.VSBuffer.wrap(d))}$writeFile(g,s,d,S){return Promise.resolve(this._getFsProvider(g).writeFile(_.URI.revive(s),d.buffer,S))}$delete(g,s,d){return Promise.resolve(this._getFsProvider(g).delete(_.URI.revive(s),d))}$rename(g,s,d,S){return Promise.resolve(this._getFsProvider(g).rename(_.URI.revive(s),_.URI.revive(d),S))}$copy(g,s,d,S){const v=this._getFsProvider(g);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(_.URI.revive(s),_.URI.revive(d),S))}$mkdir(g,s){return Promise.resolve(this._getFsProvider(g).createDirectory(_.URI.revive(s)))}$watch(g,s,d,S){const v=this._getFsProvider(g).watch(_.URI.revive(d),S);this._watches.set(s,v)}$unwatch(g,s){const d=this._watches.get(s);d&&(d.dispose(),this._watches.delete(s))}$open(g,s,d){const S=this._getFsProvider(g);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(_.URI.revive(s),d))}$close(g,s){const d=this._getFsProvider(g);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(s))}$read(g,s,d,S){const v=this._getFsProvider(g);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const E=n.VSBuffer.alloc(S);return Promise.resolve(v.read(s,d,E.buffer,0,S)).then(m=>E.slice(0,m))}$write(g,s,d,S){const v=this._getFsProvider(g);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(s,d,S.buffer,0,S.byteLength))}_getFsProvider(g){const s=this._fsProvider.get(g);if(!s){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return s}}e.ExtHostFileSystem=D}),define(ge[87],ve([0,1,5,44,7,22,4,13,60]),function(Q,e,_,I,T,P,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let n=class Rt{constructor(D,b){const g=D.getProxy(_.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(s){return g.$stat(s).catch(Rt._handleError)},readDirectory(s){return g.$readdir(s).catch(Rt._handleError)},createDirectory(s){return g.$mkdir(s).catch(Rt._handleError)},async readFile(s){return g.$readFile(s).then(d=>d.buffer).catch(Rt._handleError)},writeFile(s,d){return g.$writeFile(s,P.VSBuffer.wrap(d)).catch(Rt._handleError)},delete(s,d){return g.$delete(s,Object.assign({recursive:!1,useTrash:!1},d)).catch(Rt._handleError)},rename(s,d,S){return g.$rename(s,d,Object.assign({overwrite:!1},S)).catch(Rt._handleError)},copy(s,d,S){return g.$copy(s,d,Object.assign({overwrite:!1},S)).catch(Rt._handleError)},isWritableFileSystem(s){const d=b.getCapabilities(s);if(typeof d=="number")return!(d&2048)}})}static _handleError(D){if(!(D instanceof Error))throw new T.FileSystemError(String(D));if(D.name==="ENOPRO")throw T.FileSystemError.Unavailable(D.message);switch(D.name){case I.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(D.message);case I.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(D.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(D.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(D.message);case I.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(D.message);case I.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(D.message);default:throw new T.FileSystemError(D.message,D.name)}}};n=je([Ue(0,A.IExtHostRpcService),Ue(1,y.IExtHostFileSystemInfo)],n),e.ExtHostConsumerFileSystem=n,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(ge[237],ve([0,1,6,5]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(C){this._handlePool=0,this._proxy=C.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,C),(0,_.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=T}),define(ge[238],ve([0,1,2,23,20,7,19,5,10,43,14,15,138,6,106,70,116,46,18]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d,S,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class m{constructor(V,Y){this._documents=V,this._provider=Y}provideDocumentSymbols(V,Y){const ee=this._documents.getDocument(V);return(0,C.asPromise)(()=>this._provider.provideDocumentSymbols(ee,Y)).then(ae=>{if(!(0,R.isFalsyOrEmpty)(ae))return ae[0]instanceof P.DocumentSymbol?ae.map(T.DocumentSymbol.from):m._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(V){var Y;V=V.slice(0).sort((fe,De)=>{let Oe=fe.location.range.start.compareTo(De.location.range.start);return Oe===0&&(Oe=De.location.range.end.compareTo(fe.location.range.end)),Oe});const ee=[],ae=[];for(const fe of V){const De={name:fe.name||"!!MISSING: name!!",kind:T.SymbolKind.from(fe.kind),tags:((Y=fe.tags)===null||Y===void 0?void 0:Y.map(T.SymbolTag.from))||[],detail:"",containerName:fe.containerName,range:T.Range.from(fe.location.range),selectionRange:T.Range.from(fe.location.range),children:[]};for(;;){if(ae.length===0){ae.push(De),ee.push(De);break}const Oe=ae[ae.length-1];if(n.Range.containsRange(Oe.range,De.range)&&!n.Range.equalsRange(Oe.range,De.range)){Oe.children&&Oe.children.push(De),ae.push(De);break}ae.pop()}}return ee}}class l{constructor(V,Y,ee){this._documents=V,this._commands=Y,this._provider=ee,this._cache=new S.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(V,Y){const ee=this._documents.getDocument(V),ae=await this._provider.provideCodeLenses(ee,Y);if(!(!ae||Y.isCancellationRequested)){const fe=this._cache.add(ae),De=new g.DisposableStore;this._disposables.set(fe,De);const Oe={cacheId:fe,lenses:[]};for(let be=0;be<ae.length;be++)Oe.lenses.push({cacheId:[fe,be],range:T.Range.from(ae[be].range),command:this._commands.toInternal(ae[be].command,De)});return Oe}}async resolveCodeLens(V,Y){var ee;const ae=V.cacheId&&this._cache.get(...V.cacheId);if(!!ae){let fe;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?fe=ae:fe=await this._provider.resolveCodeLens(ae,Y),fe||(fe=ae),!Y.isCancellationRequested){const De=V.cacheId&&this._disposables.get(V.cacheId[0]);if(!!De)return V.command=this._commands.toInternal((ee=fe.command)!==null&&ee!==void 0?ee:l._badCmd,De),V}}}releaseCodeLenses(V){var Y;(Y=this._disposables.get(V))===null||Y===void 0||Y.dispose(),this._disposables.delete(V),this._cache.delete(V)}}l._badCmd={command:"missing",title:"!!MISSING: command!!"};function o(Me){return Array.isArray(Me)?Me.map(T.DefinitionLink.from):Me?[T.DefinitionLink.from(Me)]:[]}class t{constructor(V,Y){this._documents=V,this._provider=Y}provideDefinition(V,Y,ee){const ae=this._documents.getDocument(V),fe=T.Position.to(Y);return(0,C.asPromise)(()=>this._provider.provideDefinition(ae,fe,ee)).then(o)}}class i{constructor(V,Y){this._documents=V,this._provider=Y}provideDeclaration(V,Y,ee){const ae=this._documents.getDocument(V),fe=T.Position.to(Y);return(0,C.asPromise)(()=>this._provider.provideDeclaration(ae,fe,ee)).then(o)}}class a{constructor(V,Y){this._documents=V,this._provider=Y}provideImplementation(V,Y,ee){const ae=this._documents.getDocument(V),fe=T.Position.to(Y);return(0,C.asPromise)(()=>this._provider.provideImplementation(ae,fe,ee)).then(o)}}class r{constructor(V,Y){this._documents=V,this._provider=Y}provideTypeDefinition(V,Y,ee){const ae=this._documents.getDocument(V),fe=T.Position.to(Y);return(0,C.asPromise)(()=>this._provider.provideTypeDefinition(ae,fe,ee)).then(o)}}class c{constructor(V,Y){this._documents=V,this._provider=Y}provideHover(V,Y,ee){const ae=this._documents.getDocument(V),fe=T.Position.to(Y);return(0,C.asPromise)(()=>this._provider.provideHover(ae,fe,ee)).then(De=>{if(!(!De||(0,R.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=ae.getWordRangeAtPosition(fe)),De.range||(De.range=new P.Range(fe,fe)),T.Hover.from(De)})}}class h{constructor(V,Y){this._documents=V,this._provider=Y}provideEvaluatableExpression(V,Y,ee){const ae=this._documents.getDocument(V),fe=T.Position.to(Y);return(0,C.asPromise)(()=>this._provider.provideEvaluatableExpression(ae,fe,ee)).then(De=>{if(De)return T.EvaluatableExpression.from(De)})}}class p{constructor(V,Y){this._documents=V,this._provider=Y}provideInlineValues(V,Y,ee,ae){const fe=this._documents.getDocument(V);return(0,C.asPromise)(()=>this._provider.provideInlineValues(fe,T.Range.to(Y),T.InlineValueContext.to(ee),ae)).then(De=>{if(Array.isArray(De))return De.map(Oe=>T.InlineValue.from(Oe))})}}class w{constructor(V,Y){this._documents=V,this._provider=Y}provideDocumentHighlights(V,Y,ee){const ae=this._documents.getDocument(V),fe=T.Position.to(Y);return(0,C.asPromise)(()=>this._provider.provideDocumentHighlights(ae,fe,ee)).then(De=>{if(Array.isArray(De))return De.map(T.DocumentHighlight.from)})}}class u{constructor(V,Y){this._documents=V,this._provider=Y}provideLinkedEditingRanges(V,Y,ee){const ae=this._documents.getDocument(V),fe=T.Position.to(Y);return(0,C.asPromise)(()=>this._provider.provideLinkedEditingRanges(ae,fe,ee)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,R.coalesce)(De.ranges.map(T.Range.from)),wordPattern:De.wordPattern}})}}class f{constructor(V,Y){this._documents=V,this._provider=Y}provideReferences(V,Y,ee,ae){const fe=this._documents.getDocument(V),De=T.Position.to(Y);return(0,C.asPromise)(()=>this._provider.provideReferences(fe,De,ee,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(T.location.from)})}}class k{constructor(V,Y,ee,ae,fe,De,Oe){this._documents=V,this._commands=Y,this._diagnostics=ee,this._provider=ae,this._logService=fe,this._extension=De,this._apiDeprecation=Oe,this._cache=new S.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(V,Y,ee,ae){const fe=this._documents.getDocument(V),De=b.Selection.isISelection(Y)?T.Selection.to(Y):T.Range.to(Y),Oe=[];for(const ke of this._diagnostics.getDiagnostics(V))if(De.intersection(ke.range)&&Oe.push(ke)>k._maxCodeActionsPerFile)break;const be={diagnostics:Oe,only:ee.only?new P.CodeActionKind(ee.only):void 0,triggerKind:T.CodeActionTriggerKind.to(ee.trigger)};return(0,C.asPromise)(()=>this._provider.provideCodeActions(fe,De,be,ae)).then(ke=>{var Te;if(!(!(0,R.isNonEmptyArray)(ke)||ae.isCancellationRequested)){const xe=this._cache.add(ke),Se=new g.DisposableStore;this._disposables.set(xe,Se);const Ke=[];for(let G=0;G<ke.length;G++){const re=ke[G];!re||(k._isCommand(re)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:re.title,command:this._commands.toInternal(re,Se)})):(be.only&&(re.kind?be.only.contains(re.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action is of kind '${re.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[xe,G],title:re.title,command:re.command&&this._commands.toInternal(re.command,Se),diagnostics:re.diagnostics&&re.diagnostics.map(T.Diagnostic.from),edit:re.edit&&T.WorkspaceEdit.from(re.edit),kind:re.kind&&re.kind.value,isPreferred:re.isPreferred,disabled:(Te=re.disabled)===null||Te===void 0?void 0:Te.reason})))}return{cacheId:xe,actions:Ke}}})}async resolveCodeAction(V,Y){var ee;const[ae,fe]=V,De=this._cache.get(ae,fe);if(!(!De||k._isCommand(De))&&!!this._provider.resolveCodeAction){const Oe=(ee=await this._provider.resolveCodeAction(De,Y))!==null&&ee!==void 0?ee:De;return(Oe==null?void 0:Oe.edit)?T.WorkspaceEdit.from(Oe.edit):void 0}}releaseCodeActions(V){var Y;(Y=this._disposables.get(V))===null||Y===void 0||Y.dispose(),this._disposables.delete(V),this._cache.delete(V)}static _isCommand(V){return typeof V.command=="string"&&typeof V.title=="string"}}k._maxCodeActionsPerFile=1e3;class L{constructor(V,Y){this._documents=V,this._provider=Y}provideDocumentFormattingEdits(V,Y,ee){const ae=this._documents.getDocument(V);return(0,C.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ae,Y,ee)).then(fe=>{if(Array.isArray(fe))return fe.map(T.TextEdit.from)})}}class ${constructor(V,Y){this._documents=V,this._provider=Y}provideDocumentRangeFormattingEdits(V,Y,ee,ae){const fe=this._documents.getDocument(V),De=T.Range.to(Y);return(0,C.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(fe,De,ee,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(T.TextEdit.from)})}}class te{constructor(V,Y){this._documents=V,this._provider=Y,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(V,Y,ee,ae,fe){const De=this._documents.getDocument(V),Oe=T.Position.to(Y);return(0,C.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Oe,ee,ae,fe)).then(be=>{if(Array.isArray(be))return be.map(T.TextEdit.from)})}}class H{constructor(V,Y){this._provider=V,this._logService=Y,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(V,Y){const ee=A.IdObject.mixin({symbols:[]});return(0,C.asPromise)(()=>this._provider.provideWorkspaceSymbols(V,Y)).then(ae=>{if((0,R.isNonEmptyArray)(ae)){for(const fe of ae)if(!!fe){if(!fe.name){this._logService.warn("INVALID SymbolInformation, lacks name",fe);continue}const De=A.IdObject.mixin(T.WorkspaceSymbol.from(fe));this._symbolCache.set(De._id,fe),ee.symbols.push(De)}}}).then(()=>(ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee))}async resolveWorkspaceSymbol(V,Y){if(typeof this._provider.resolveWorkspaceSymbol!="function")return V;const ee=this._symbolCache.get(V._id);if(ee){const ae=await(0,C.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ee,Y));return ae&&(0,I.mixin)(V,T.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(V){const Y=this._resultCache.get(V);if(Y){for(let[ee,ae]=Y;ee<=ae;ee++)this._symbolCache.delete(ee);this._resultCache.delete(V)}}}class x{constructor(V,Y,ee){this._documents=V,this._provider=Y,this._logService=ee}static supportsResolving(V){return typeof V.prepareRename=="function"}provideRenameEdits(V,Y,ee,ae){const fe=this._documents.getDocument(V),De=T.Position.to(Y);return(0,C.asPromise)(()=>this._provider.provideRenameEdits(fe,De,ee,ae)).then(Oe=>{if(!!Oe)return T.WorkspaceEdit.from(Oe)},Oe=>{const be=x._asMessage(Oe);return be?{rejectReason:be,edits:void 0}:Promise.reject(Oe)})}resolveRenameLocation(V,Y,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(V),fe=T.Position.to(Y);return(0,C.asPromise)(()=>this._provider.prepareRename(ae,fe,ee)).then(De=>{let Oe,be;if(P.Range.isRange(De)?(Oe=De,be=ae.getText(De)):(0,D.isObject)(De)&&(Oe=De.range,be=De.placeholder),!!Oe){if(Oe.start.line>fe.line||Oe.end.line<fe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:T.Range.from(Oe),text:be}}},De=>{const Oe=x._asMessage(De);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class B{constructor(V,Y){this.resultId=V,this.tokens=Y}}class F{constructor(V,Y){this._documents=V,this._provider=Y,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(V,Y,ee){const ae=this._documents.getDocument(V),fe=Y!==0?this._previousResults.get(Y):null;return(0,C.asPromise)(()=>fe&&typeof fe.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,fe.resultId,ee):this._provider.provideDocumentSemanticTokens(ae,ee)).then(De=>(fe&&this._previousResults.delete(Y),De?(De=F._fixProvidedSemanticTokens(De),this._send(F._convertToEdits(fe,De),De)):null))}async releaseDocumentSemanticColoring(V){this._previousResults.delete(V)}static _fixProvidedSemanticTokens(V){return F._isSemanticTokens(V)?F._isCorrectSemanticTokens(V)?V:new P.SemanticTokens(new Uint32Array(V.data),V.resultId):F._isSemanticTokensEdits(V)?F._isCorrectSemanticTokensEdits(V)?V:new P.SemanticTokensEdits(V.edits.map(Y=>new P.SemanticTokensEdit(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),V.resultId):V}static _isSemanticTokens(V){return V&&!!V.data}static _isCorrectSemanticTokens(V){return V.data instanceof Uint32Array}static _isSemanticTokensEdits(V){return V&&Array.isArray(V.edits)}static _isCorrectSemanticTokensEdits(V){for(const Y of V.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(V,Y){if(!F._isSemanticTokens(Y)||!V||!V.tokens)return Y;const ee=V.tokens,ae=ee.length,fe=Y.data,De=fe.length;let Oe=0;const be=Math.min(ae,De);for(;Oe<be&&ee[Oe]===fe[Oe];)Oe++;if(Oe===ae&&Oe===De)return new P.SemanticTokensEdits([],Y.resultId);let ke=0;const Te=be-Oe;for(;ke<Te&&ee[ae-ke-1]===fe[De-ke-1];)ke++;return new P.SemanticTokensEdits([{start:Oe,deleteCount:ae-Oe-ke,data:fe.subarray(Oe,De-ke)}],Y.resultId)}_send(V,Y){if(F._isSemanticTokens(V)){const ee=this._nextResultId++;return this._previousResults.set(ee,new B(V.resultId,V.data)),(0,s.encodeSemanticTokensDto)({id:ee,type:"full",data:V.data})}if(F._isSemanticTokensEdits(V)){const ee=this._nextResultId++;return F._isSemanticTokens(Y)?this._previousResults.set(ee,new B(Y.resultId,Y.data)):this._previousResults.set(ee,new B(V.resultId)),(0,s.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(V.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=F;class U{constructor(V,Y){this._documents=V,this._provider=Y}provideDocumentRangeSemanticTokens(V,Y,ee){const ae=this._documents.getDocument(V);return(0,C.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ae,T.Range.to(Y),ee)).then(fe=>fe?this._send(fe):null)}_send(V){return(0,s.encodeSemanticTokensDto)({id:0,type:"full",data:V.data})}}e.DocumentRangeSemanticTokensAdapter=U;class M{constructor(V,Y,ee,ae,fe){this._documents=V,this._commands=Y,this._provider=ee,this._apiDeprecation=ae,this._extension=fe,this._cache=new S.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}async provideCompletionItems(V,Y,ee,ae){const fe=this._documents.getDocument(V),De=T.Position.to(Y),Oe=fe.getWordRangeAtPosition(De)||new P.Range(De,De),be=Oe.with({end:De}),ke=new v.StopWatch(!0),Te=await(0,C.asPromise)(()=>this._provider.provideCompletionItems(fe,De,ae,T.CompletionContext.to(ee)));if(!!Te&&!ae.isCancellationRequested){const xe=Array.isArray(Te)?new P.CompletionList(Te):Te,Se=M.supportsResolving(this._provider)?this._cache.add(xe.items):this._cache.add([]),Ke=new g.DisposableStore;this._disposables.set(Se,Ke);const G=[],re={x:Se,b:G,a:{replace:T.Range.from(Oe),insert:T.Range.from(be)},c:xe.isIncomplete||void 0,d:ke.elapsed()};for(let Ee=0;Ee<xe.items.length;Ee++){const Ne=xe.items[Ee],Ve=this._convertCompletionItem(Ne,[Se,Ee],be,Oe);G.push(Ve)}return re}}async resolveCompletionItem(V,Y){if(typeof this._provider.resolveCompletionItem=="function"){const ee=this._cache.get(...V);if(!!ee){const ae=await(0,C.asPromise)(()=>this._provider.resolveCompletionItem(ee,Y));if(!!ae)return this._convertCompletionItem(ae,V)}}}releaseCompletionItems(V){var Y;(Y=this._disposables.get(V))===null||Y===void 0||Y.dispose(),this._disposables.delete(V),this._cache.delete(V)}_convertCompletionItem(V,Y,ee,ae){var fe;const De=this._disposables.get(Y[0]);if(!De)throw Error("DisposableStore is missing...");const Oe={x:Y,a:(fe=V.label)!==null&&fe!==void 0?fe:"",o:V.label2,b:V.kind!==void 0?T.CompletionItemKind.from(V.kind):void 0,n:V.tags&&V.tags.map(T.CompletionItemTag.from),c:V.detail,d:typeof V.documentation=="undefined"?void 0:T.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters,l:V.additionalTextEdits&&V.additionalTextEdits.map(T.TextEdit.from),m:this._commands.toInternal(V.command,De)};V.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=V.textEdit.newText):typeof V.insertText=="string"?Oe.h=V.insertText:V.insertText instanceof P.SnippetString&&(Oe.h=V.insertText.value,Oe.i|=4);let be;return V.textEdit?be=V.textEdit.range:V.range&&(be=V.range),P.Range.isRange(be)?Oe.j=T.Range.from(be):be&&(!(ee==null?void 0:ee.isEqual(be.inserting))||!(ae==null?void 0:ae.isEqual(be.replacing)))&&(Oe.j={insert:T.Range.from(be.inserting),replace:T.Range.from(be.replacing)}),Oe}}class N{constructor(V,Y){this._documents=V,this._provider=Y,this._cache=new S.Cache("SignatureHelp")}provideSignatureHelp(V,Y,ee,ae){const fe=this._documents.getDocument(V),De=T.Position.to(Y),Oe=this.reviveContext(ee);return(0,C.asPromise)(()=>this._provider.provideSignatureHelp(fe,De,ae,Oe)).then(be=>{if(be){const ke=this._cache.add([be]);return Object.assign(Object.assign({},T.SignatureHelp.from(be)),{id:ke})}})}reviveContext(V){let Y;if(V.activeSignatureHelp){const ee=T.SignatureHelp.to(V.activeSignatureHelp),ae=this._cache.get(V.activeSignatureHelp.id,0);ae?(Y=ae,Y.activeSignature=ee.activeSignature,Y.activeParameter=ee.activeParameter):Y=ee}return Object.assign(Object.assign({},V),{activeSignatureHelp:Y})}releaseSignatureHelp(V){this._cache.delete(V)}}class O{constructor(V,Y){this._documents=V,this._provider=Y}provideInlineHints(V,Y,ee){const ae=this._documents.getDocument(V);return(0,C.asPromise)(()=>this._provider.provideInlineHints(ae,T.Range.to(Y),ee)).then(fe=>fe?{hints:fe.map(T.InlineHint.from)}:void 0)}}class j{constructor(V,Y){this._documents=V,this._provider=Y,this._cache=new S.Cache("DocumentLink")}provideLinks(V,Y){const ee=this._documents.getDocument(V);return(0,C.asPromise)(()=>this._provider.provideDocumentLinks(ee,Y)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!Y.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(T.DocumentLink.from)};{const fe=this._cache.add(ae),De={links:[],id:fe};for(let Oe=0;Oe<ae.length;Oe++){const be=T.DocumentLink.from(ae[Oe]);be.cacheId=[fe,Oe],De.links.push(be)}return De}}})}resolveLink(V,Y){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ee=this._cache.get(...V);return ee?(0,C.asPromise)(()=>this._provider.resolveDocumentLink(ee,Y)).then(ae=>ae&&T.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(V){this._cache.delete(V)}}class q{constructor(V,Y){this._documents=V,this._provider=Y}provideColors(V,Y){const ee=this._documents.getDocument(V);return(0,C.asPromise)(()=>this._provider.provideDocumentColors(ee,Y)).then(ae=>Array.isArray(ae)?ae.map(De=>({color:T.Color.from(De.color),range:T.Range.from(De.range)})):[])}provideColorPresentations(V,Y,ee){const ae=this._documents.getDocument(V),fe=T.Range.to(Y.range),De=T.Color.to(Y.color);return(0,C.asPromise)(()=>this._provider.provideColorPresentations(De,{document:ae,range:fe},ee)).then(Oe=>{if(!!Array.isArray(Oe))return Oe.map(T.ColorPresentation.from)})}}class X{constructor(V,Y){this._documents=V,this._provider=Y}provideFoldingRanges(V,Y,ee){const ae=this._documents.getDocument(V);return(0,C.asPromise)(()=>this._provider.provideFoldingRanges(ae,Y,ee)).then(fe=>{if(!!Array.isArray(fe))return fe.map(T.FoldingRange.from)})}}class me{constructor(V,Y,ee){this._documents=V,this._provider=Y,this._logService=ee}provideSelectionRanges(V,Y,ee){const ae=this._documents.getDocument(V),fe=Y.map(T.Position.to);return(0,C.asPromise)(()=>this._provider.provideSelectionRanges(ae,fe,ee)).then(De=>{if(!(0,R.isNonEmptyArray)(De))return[];if(De.length!==fe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let be=0;be<fe.length;be++){const ke=[];Oe.push(ke);let Te=fe[be],xe=De[be];for(;;){if(!xe.range.contains(Te))throw new Error("INVALID selection range, must contain the previous range");if(ke.push(T.SelectionRange.from(xe)),!xe.parent)break;Te=xe.range,xe=xe.parent}}return Oe})}}class we{constructor(V,Y){this._documents=V,this._provider=Y,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(V,Y,ee){const ae=this._documents.getDocument(V),fe=T.Position.to(Y),De=await this._provider.prepareCallHierarchy(ae,fe,ee);if(!!De){const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(De)?De.map(be=>this._cacheAndConvertItem(Oe,be)):[this._cacheAndConvertItem(Oe,De)]}}async provideCallsTo(V,Y,ee){const ae=this._itemFromCache(V,Y);if(!ae)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyIncomingCalls(ae,ee);if(!!fe)return fe.map(De=>({from:this._cacheAndConvertItem(V,De.from),fromRanges:De.fromRanges.map(Oe=>T.Range.from(Oe))}))}async provideCallsFrom(V,Y,ee){const ae=this._itemFromCache(V,Y);if(!ae)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyOutgoingCalls(ae,ee);if(!!fe)return fe.map(De=>({to:this._cacheAndConvertItem(V,De.to),fromRanges:De.fromRanges.map(Oe=>T.Range.from(Oe))}))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,Y){var ee;const ae=this._cache.get(V),fe={_sessionId:V,_itemId:ae.size.toString(36),name:Y.name,detail:Y.detail,kind:T.SymbolKind.from(Y.kind),uri:Y.uri,range:T.Range.from(Y.range),selectionRange:T.Range.from(Y.selectionRange),tags:(ee=Y.tags)===null||ee===void 0?void 0:ee.map(T.SymbolTag.from)};return ae.set(fe._itemId,Y),fe}_itemFromCache(V,Y){const ee=this._cache.get(V);return ee==null?void 0:ee.get(Y)}}class Ae{constructor(V,Y){this.adapter=V,this.extension=Y}}class Ie{constructor(V,Y,ee,ae,fe,De,Oe){this._adapter=new Map,this._uriTransformer=Y,this._proxy=V.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=ae,this._diagnostics=fe,this._logService=De,this._apiDeprecation=Oe}_transformDocumentSelector(V){return(0,R.coalesce)((0,R.asArray)(V).map(Y=>this._doTransformDocumentSelector(Y)))}_doTransformDocumentSelector(V){if(typeof V=="string")return{$serialized:!0,language:V};if(V)return{$serialized:!0,language:V.language,scheme:this._transformScheme(V.scheme),pattern:typeof V.pattern=="undefined"?void 0:T.GlobPattern.from(V.pattern),exclusive:V.exclusive}}_transformScheme(V){return this._uriTransformer&&typeof V=="string"?this._uriTransformer.transformOutgoingScheme(V):V}_createDisposable(V){return new P.Disposable(()=>{this._adapter.delete(V),this._proxy.$unregister(V)})}_nextHandle(){return Ie._handlePool++}_withAdapter(V,Y,ee,ae,fe=!1){const De=this._adapter.get(V);if(!De)return Promise.resolve(ae);if(De.adapter instanceof Y){let Oe;De.extension&&(Oe=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${Y.name}'`));const be=ee(De.adapter,De.extension),ke=De.extension;return ke&&Promise.resolve(be).then(()=>this._logService.trace(`[${ke.identifier.value}] provider DONE after ${Date.now()-Oe}ms`),Te=>{fe&&Te instanceof E.CancellationError||(this._logService.error(`[${ke.identifier.value}] provider FAILED`),this._logService.error(Te))}),be}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(V,Y){const ee=this._nextHandle();return this._adapter.set(ee,new Ae(V,Y)),ee}static _extLabel(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,Y,ee,ae){const fe=this._addNewAdapter(new m(this._documents,ee),V),De=ae&&ae.label||Ie._extLabel(V);return this._proxy.$registerDocumentSymbolProvider(fe,this._transformDocumentSelector(Y),De),this._createDisposable(fe)}$provideDocumentSymbols(V,Y,ee){return this._withAdapter(V,m,ae=>ae.provideDocumentSymbols(_.URI.revive(Y),ee),void 0)}registerCodeLensProvider(V,Y,ee){const ae=this._nextHandle(),fe=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ae(new l(this._documents,this._commands.converter,ee),V)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Y),fe);let De=this._createDisposable(ae);if(fe!==void 0){const Oe=ee.onDidChangeCodeLenses(be=>this._proxy.$emitCodeLensEvent(fe));De=P.Disposable.from(De,Oe)}return De}$provideCodeLenses(V,Y,ee){return this._withAdapter(V,l,ae=>ae.provideCodeLenses(_.URI.revive(Y),ee),void 0)}$resolveCodeLens(V,Y,ee){return this._withAdapter(V,l,ae=>ae.resolveCodeLens(Y,ee),void 0)}$releaseCodeLenses(V,Y){this._withAdapter(V,l,ee=>Promise.resolve(ee.releaseCodeLenses(Y)),void 0)}registerDefinitionProvider(V,Y,ee){const ae=this._addNewAdapter(new t(this._documents,ee),V);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDefinition(V,Y,ee,ae){return this._withAdapter(V,t,fe=>fe.provideDefinition(_.URI.revive(Y),ee,ae),[])}registerDeclarationProvider(V,Y,ee){const ae=this._addNewAdapter(new i(this._documents,ee),V);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDeclaration(V,Y,ee,ae){return this._withAdapter(V,i,fe=>fe.provideDeclaration(_.URI.revive(Y),ee,ae),[])}registerImplementationProvider(V,Y,ee){const ae=this._addNewAdapter(new a(this._documents,ee),V);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideImplementation(V,Y,ee,ae){return this._withAdapter(V,a,fe=>fe.provideImplementation(_.URI.revive(Y),ee,ae),[])}registerTypeDefinitionProvider(V,Y,ee){const ae=this._addNewAdapter(new r(this._documents,ee),V);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideTypeDefinition(V,Y,ee,ae){return this._withAdapter(V,r,fe=>fe.provideTypeDefinition(_.URI.revive(Y),ee,ae),[])}registerHoverProvider(V,Y,ee,ae){const fe=this._addNewAdapter(new c(this._documents,ee),V);return this._proxy.$registerHoverProvider(fe,this._transformDocumentSelector(Y)),this._createDisposable(fe)}$provideHover(V,Y,ee,ae){return this._withAdapter(V,c,fe=>fe.provideHover(_.URI.revive(Y),ee,ae),void 0)}registerEvaluatableExpressionProvider(V,Y,ee,ae){const fe=this._addNewAdapter(new h(this._documents,ee),V);return this._proxy.$registerEvaluatableExpressionProvider(fe,this._transformDocumentSelector(Y)),this._createDisposable(fe)}$provideEvaluatableExpression(V,Y,ee,ae){return this._withAdapter(V,h,fe=>fe.provideEvaluatableExpression(_.URI.revive(Y),ee,ae),void 0)}registerInlineValuesProvider(V,Y,ee,ae){const fe=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new p(this._documents,ee),V);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(Y),fe);let Oe=this._createDisposable(De);if(fe!==void 0){const be=ee.onDidChangeInlineValues(ke=>this._proxy.$emitInlineValuesEvent(fe));Oe=P.Disposable.from(Oe,be)}return Oe}$provideInlineValues(V,Y,ee,ae,fe){return this._withAdapter(V,p,De=>De.provideInlineValues(_.URI.revive(Y),ee,ae,fe),void 0)}registerDocumentHighlightProvider(V,Y,ee){const ae=this._addNewAdapter(new w(this._documents,ee),V);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentHighlights(V,Y,ee,ae){return this._withAdapter(V,w,fe=>fe.provideDocumentHighlights(_.URI.revive(Y),ee,ae),void 0)}registerLinkedEditingRangeProvider(V,Y,ee){const ae=this._addNewAdapter(new u(this._documents,ee),V);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideLinkedEditingRanges(V,Y,ee,ae){return this._withAdapter(V,u,async fe=>{const De=await fe.provideLinkedEditingRanges(_.URI.revive(Y),ee,ae);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Ie._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider(V,Y,ee){const ae=this._addNewAdapter(new f(this._documents,ee),V);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideReferences(V,Y,ee,ae,fe){return this._withAdapter(V,f,De=>De.provideReferences(_.URI.revive(Y),ee,ae,fe),void 0)}registerCodeActionProvider(V,Y,ee,ae){var fe,De;const Oe=new g.DisposableStore,be=this._addNewAdapter(new k(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,V,this._apiDeprecation),V);return this._proxy.$registerQuickFixSupport(be,this._transformDocumentSelector(Y),{providedKinds:(fe=ae==null?void 0:ae.providedCodeActionKinds)===null||fe===void 0?void 0:fe.map(ke=>ke.value),documentation:(De=ae==null?void 0:ae.documentation)===null||De===void 0?void 0:De.map(ke=>({kind:ke.kind.value,command:this._commands.converter.toInternal(ke.command,Oe)}))},Ie._extLabel(V),Boolean(ee.resolveCodeAction)),Oe.add(this._createDisposable(be)),Oe}$provideCodeActions(V,Y,ee,ae,fe){return this._withAdapter(V,k,De=>De.provideCodeActions(_.URI.revive(Y),ee,ae,fe),void 0)}$resolveCodeAction(V,Y,ee){return this._withAdapter(V,k,ae=>ae.resolveCodeAction(Y,ee),void 0)}$releaseCodeActions(V,Y){this._withAdapter(V,k,ee=>Promise.resolve(ee.releaseCodeActions(Y)),void 0)}registerDocumentFormattingEditProvider(V,Y,ee){const ae=this._addNewAdapter(new L(this._documents,ee),V);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Y),V.identifier,V.displayName||V.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(V,Y,ee,ae){return this._withAdapter(V,L,fe=>fe.provideDocumentFormattingEdits(_.URI.revive(Y),ee,ae),void 0)}registerDocumentRangeFormattingEditProvider(V,Y,ee){const ae=this._addNewAdapter(new $(this._documents,ee),V);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Y),V.identifier,V.displayName||V.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(V,Y,ee,ae,fe){return this._withAdapter(V,$,De=>De.provideDocumentRangeFormattingEdits(_.URI.revive(Y),ee,ae,fe),void 0)}registerOnTypeFormattingEditProvider(V,Y,ee,ae){const fe=this._addNewAdapter(new te(this._documents,ee),V);return this._proxy.$registerOnTypeFormattingSupport(fe,this._transformDocumentSelector(Y),ae,V.identifier),this._createDisposable(fe)}$provideOnTypeFormattingEdits(V,Y,ee,ae,fe,De){return this._withAdapter(V,te,Oe=>Oe.provideOnTypeFormattingEdits(_.URI.revive(Y),ee,ae,fe,De),void 0)}registerWorkspaceSymbolProvider(V,Y){const ee=this._addNewAdapter(new H(Y,this._logService),V);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(V,Y,ee){return this._withAdapter(V,H,ae=>ae.provideWorkspaceSymbols(Y,ee),{symbols:[]})}$resolveWorkspaceSymbol(V,Y,ee){return this._withAdapter(V,H,ae=>ae.resolveWorkspaceSymbol(Y,ee),void 0)}$releaseWorkspaceSymbols(V,Y){this._withAdapter(V,H,ee=>ee.releaseWorkspaceSymbols(Y),void 0)}registerRenameProvider(V,Y,ee){const ae=this._addNewAdapter(new x(this._documents,ee,this._logService),V);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Y),x.supportsResolving(ee)),this._createDisposable(ae)}$provideRenameEdits(V,Y,ee,ae,fe){return this._withAdapter(V,x,De=>De.provideRenameEdits(_.URI.revive(Y),ee,ae,fe),void 0)}$resolveRenameLocation(V,Y,ee,ae){return this._withAdapter(V,x,fe=>fe.resolveRenameLocation(_.URI.revive(Y),ee,ae),void 0)}registerDocumentSemanticTokensProvider(V,Y,ee,ae){const fe=this._nextHandle(),De=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(fe,new Ae(new F(this._documents,ee),V)),this._proxy.$registerDocumentSemanticTokensProvider(fe,this._transformDocumentSelector(Y),ae,De);let Oe=this._createDisposable(fe);if(De){const be=ee.onDidChangeSemanticTokens(ke=>this._proxy.$emitDocumentSemanticTokensEvent(De));Oe=P.Disposable.from(Oe,be)}return Oe}$provideDocumentSemanticTokens(V,Y,ee,ae){return this._withAdapter(V,F,fe=>fe.provideDocumentSemanticTokens(_.URI.revive(Y),ee,ae),null,!0)}$releaseDocumentSemanticTokens(V,Y){this._withAdapter(V,F,ee=>ee.releaseDocumentSemanticColoring(Y),void 0)}registerDocumentRangeSemanticTokensProvider(V,Y,ee,ae){const fe=this._addNewAdapter(new U(this._documents,ee),V);return this._proxy.$registerDocumentRangeSemanticTokensProvider(fe,this._transformDocumentSelector(Y),ae),this._createDisposable(fe)}$provideDocumentRangeSemanticTokens(V,Y,ee,ae){return this._withAdapter(V,U,fe=>fe.provideDocumentRangeSemanticTokens(_.URI.revive(Y),ee,ae),null,!0)}registerCompletionItemProvider(V,Y,ee,ae){const fe=this._addNewAdapter(new M(this._documents,this._commands.converter,ee,this._apiDeprecation,V),V);return this._proxy.$registerSuggestSupport(fe,this._transformDocumentSelector(Y),ae,M.supportsResolving(ee),`${V.identifier.value}(${ae.join("")})`),this._createDisposable(fe)}$provideCompletionItems(V,Y,ee,ae,fe){return this._withAdapter(V,M,De=>De.provideCompletionItems(_.URI.revive(Y),ee,ae,fe),void 0)}$resolveCompletionItem(V,Y,ee){return this._withAdapter(V,M,ae=>ae.resolveCompletionItem(Y,ee),void 0)}$releaseCompletionItems(V,Y){this._withAdapter(V,M,ee=>ee.releaseCompletionItems(Y),void 0)}registerSignatureHelpProvider(V,Y,ee,ae){const fe=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,De=this._addNewAdapter(new N(this._documents,ee),V);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(Y),fe),this._createDisposable(De)}$provideSignatureHelp(V,Y,ee,ae,fe){return this._withAdapter(V,N,De=>De.provideSignatureHelp(_.URI.revive(Y),ee,ae,fe),void 0)}$releaseSignatureHelp(V,Y){this._withAdapter(V,N,ee=>ee.releaseSignatureHelp(Y),void 0)}registerInlineHintsProvider(V,Y,ee){const ae=typeof ee.onDidChangeInlineHints=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new O(this._documents,ee),V);this._proxy.$registerInlineHintsProvider(fe,this._transformDocumentSelector(Y),ae);let De=this._createDisposable(fe);if(ae!==void 0){const Oe=ee.onDidChangeInlineHints(be=>this._proxy.$emitInlineHintsEvent(ae));De=P.Disposable.from(De,Oe)}return De}$provideInlineHints(V,Y,ee,ae){return this._withAdapter(V,O,fe=>fe.provideInlineHints(_.URI.revive(Y),ee,ae),void 0)}registerDocumentLinkProvider(V,Y,ee){const ae=this._addNewAdapter(new j(this._documents,ee),V);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Y),typeof ee.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(V,Y,ee){return this._withAdapter(V,j,ae=>ae.provideLinks(_.URI.revive(Y),ee),void 0)}$resolveDocumentLink(V,Y,ee){return this._withAdapter(V,j,ae=>ae.resolveLink(Y,ee),void 0)}$releaseDocumentLinks(V,Y){this._withAdapter(V,j,ee=>ee.releaseLinks(Y),void 0)}registerColorProvider(V,Y,ee){const ae=this._addNewAdapter(new q(this._documents,ee),V);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentColors(V,Y,ee){return this._withAdapter(V,q,ae=>ae.provideColors(_.URI.revive(Y),ee),[])}$provideColorPresentations(V,Y,ee,ae){return this._withAdapter(V,q,fe=>fe.provideColorPresentations(_.URI.revive(Y),ee,ae),void 0)}registerFoldingRangeProvider(V,Y,ee){const ae=this._nextHandle(),fe=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ae(new X(this._documents,ee),V)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Y),fe);let De=this._createDisposable(ae);if(fe!==void 0){const Oe=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(fe));De=P.Disposable.from(De,Oe)}return De}$provideFoldingRanges(V,Y,ee,ae){return this._withAdapter(V,X,fe=>fe.provideFoldingRanges(_.URI.revive(Y),ee,ae),void 0)}registerSelectionRangeProvider(V,Y,ee){const ae=this._addNewAdapter(new me(this._documents,ee,this._logService),V);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideSelectionRanges(V,Y,ee,ae){return this._withAdapter(V,me,fe=>fe.provideSelectionRanges(_.URI.revive(Y),ee,ae),[])}registerCallHierarchyProvider(V,Y,ee){const ae=this._addNewAdapter(new we(this._documents,ee),V);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$prepareCallHierarchy(V,Y,ee,ae){return this._withAdapter(V,we,fe=>Promise.resolve(fe.prepareSession(_.URI.revive(Y),ee,ae)),void 0)}$provideCallHierarchyIncomingCalls(V,Y,ee,ae){return this._withAdapter(V,we,fe=>fe.provideCallsTo(Y,ee,ae),void 0)}$provideCallHierarchyOutgoingCalls(V,Y,ee,ae){return this._withAdapter(V,we,fe=>fe.provideCallsFrom(Y,ee,ae),void 0)}$releaseCallHierarchy(V,Y){this._withAdapter(V,we,ee=>Promise.resolve(ee.releaseSession(Y)),void 0)}static _serializeRegExp(V){return{pattern:V.source,flags:(0,y.regExpFlags)(V)}}static _serializeIndentationRule(V){return{decreaseIndentPattern:Ie._serializeRegExp(V.decreaseIndentPattern),increaseIndentPattern:Ie._serializeRegExp(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Ie._serializeRegExp(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Ie._serializeRegExp(V.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(V){return{beforeText:Ie._serializeRegExp(V.beforeText),afterText:V.afterText?Ie._serializeRegExp(V.afterText):void 0,previousLineText:V.previousLineText?Ie._serializeRegExp(V.previousLineText):void 0,action:V.action}}static _serializeOnEnterRules(V){return V.map(Ie._serializeOnEnterRule)}setLanguageConfiguration(V,Y,ee){let{wordPattern:ae}=ee;if(ae&&(0,y.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Y,ae):this._documents.setWordDefinitionFor(Y,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const fe=this._nextHandle(),De={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?Ie._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?Ie._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?Ie._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(fe,Y,De),this._createDisposable(fe)}$setWordDefinitions(V){for(const Y of V)this._documents.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.ExtHostLanguageFeatures=Ie,Ie._handlePool=0}),define(ge[239],ve([0,1,5,20,7]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class P{constructor(A,y){this._proxy=A.getProxy(_.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(A,y){await this._proxy.$changeLanguage(A,y);const n=this._documents.getDocumentData(A);if(!n)throw new Error(`document '${A.toString}' NOT found`);return n.document}async tokenAtPosition(A,y){var n;const R=A.version,D=I.Position.from(y),b=await this._proxy.$tokensAtPosition(A.uri,D),g={type:T.StandardTokenType.Other,range:(n=A.getWordRangeAtPosition(y))!==null&&n!==void 0?n:new T.Range(y.line,y.character,y.line,y.character)};if(!b)return g;const s={range:I.Range.to(b.range),type:I.TokenType.to(b.type)};return!s.range.contains(y)||R!==A.version?g:s}}e.ExtHostLanguages=P}),define(ge[240],ve([0,1,5,12,41]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(A){return A&&A.title}let C=class{constructor(y,n){this._logService=n,this._proxy=y.getProxy(_.MainContext.MainThreadMessageService)}showMessage(y,n,R,D,b){const g={extension:y};let s;typeof D=="string"||P(D)?s=[D,...b]:(g.modal=D&&D.modal,g.useCustom=D&&D.useCustom,s=b),g.useCustom&&(0,T.checkProposedApiEnabled)(y);const d=[];for(let S=0;S<s.length;S++){const v=s[S];if(typeof v=="string")d.push({title:v,handle:S,isCloseAffordance:!1});else if(typeof v=="object"){let{title:E,isCloseAffordance:m}=v;d.push({title:E,isCloseAffordance:!!m,handle:S})}else this._logService.warn("Invalid message item:",v)}return this._proxy.$showMessage(n,R,g,d).then(S=>{if(typeof S=="number")return s[S]})}};C=je([Ue(1,I.ILogService)],C),e.ExtHostMessageService=C}),define(ge[241],ve([0,1,21,3,6,2,28,5,20,7,84,85,24,217,218,70,15,22,73]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d,S,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookCellStatusBarItemInternal=e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class m extends T.Disposable{constructor(p,w,u,f,k){super();this._editorId=p,this.uri=w,this._proxy=u,this._webviewInitData=f,this.document=k,this._onDidReceiveDocumentMessage=new I.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:L=>this._proxy.$postMessage(this._editorId,void 0,L),asWebviewUri:L=>this._asWebviewUri(L)}}onDidReceiveMessage(p,w){var u;this._onDidReceiveDocumentMessage.fire(w),p!==void 0&&((u=this._rendererIdToEmitters.get(p))===null||u===void 0||u.fire(w))}getRendererComm(p){const w=new I.Emitter;return this._rendererIdToEmitters.set(p,w),{editorId:this._editorId,onDidReceiveMessage:w.event,postMessage:u=>this._proxy.$postMessage(this._editorId,p,u),asWebviewUri:u=>this._asWebviewUri(u)}}_asWebviewUri(p){return(0,R.asWebviewUri)(this._webviewInitData,this._editorId,p)}}class l extends T.Disposable{constructor(p,w,u,f){super();this._proxy=p,this._handle=w,this._extension=u,this._provider=f,this._kernelToFriendlyId=new b.ResourceMap,this._friendlyIdToKernel=new b.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(k=>{const L=k==null?void 0:k.uri;this._proxy.$onNotebookKernelChange(this._handle,L)}))}async provideKernels(p,w){const u=await this._provider.provideKernels(p.notebookDocument,w)||[],f=new Map;let k=0;const L=new Set,$=this._kernelToFriendlyId.get(p.uri),te=u.map(x=>{let B=$==null?void 0:$.get(x);return B===void 0&&(x.id&&L.has(x.id)?B=`${this._extension.identifier.value}_${x.id}_${k++}`:B=`${this._extension.identifier.value}_${x.id||C.generateUuid()}`),f.set(x,B),{id:x.id,friendlyId:B,label:x.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:x.description,detail:x.detail,isPreferred:x.isPreferred,preloads:x.preloads,supportedLanguages:x.supportedLanguages,implementsInterrupt:!!x.interrupt}});this._kernelToFriendlyId.set(p.uri,f);const H=new Map;return f.forEach((x,B)=>{H.set(x,B)}),this._friendlyIdToKernel.set(p.uri,H),te}getKernelByFriendlyId(p,w){var u;return(u=this._friendlyIdToKernel.get(p))===null||u===void 0?void 0:u.get(w)}async resolveNotebook(p,w,u,f){var k;const L=(k=this._friendlyIdToKernel.get(w.uri))===null||k===void 0?void 0:k.get(p);if(L&&this._provider.resolveKernel)return this._provider.resolveKernel(L,w.notebookDocument,u,f)}async executeNotebook(p,w,u){var f;const k=(f=this._friendlyIdToKernel.get(w.uri))===null||f===void 0?void 0:f.get(p);if(!!k){const L=u.map($=>y.NotebookCellRange.to($));return k.executeCellsRequest(w.notebookDocument,L)}}async interruptNotebookExecution(p,w){var u;const f=(u=this._friendlyIdToKernel.get(w.uri))===null||u===void 0?void 0:u.get(p);if(!(!f||!f.interrupt))return f.interrupt(w.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=l;class o{constructor(p,w){const u=o._Keys.nextId();p.$registerNotebookEditorDecorationType(u,y.NotebookDecorationRenderOptions.from(w)),this.value={key:u,dispose(){p.$removeNotebookEditorDecorationType(u)}}}}e.NotebookEditorDecorationType=o,o._Keys=new d.IdGenerator("NotebookEditorDecorationType");class t{constructor(p,w,u,f,k,L,$){this._textDocumentsAndEditors=u,this._textDocuments=f,this._webviewInitData=k,this.logService=L,this._extensionStoragePaths=$,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._documents=new b.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new I.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new I.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new I.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new I.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new I.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new I.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new I.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new I.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new I.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new I.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new I.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new I.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new I.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new b.ResourceMap,this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=p.getProxy(A.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=p.getProxy(A.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=p.getProxy(A.MainContext.MainThreadNotebookEditors),this._commandsConverter=w.converter,w.registerArgumentProcessor({processArgument:te=>{var H;if(te&&te.$mid===12){const x=(H=te.notebookEditor)===null||H===void 0?void 0:H.notebookUri,B=te.cell.handle,F=this._documents.get(x),U=F==null?void 0:F.getCell(B);if(U)return U.cell}return te}})}get activeNotebookEditor(){var p;return(p=this._activeNotebookEditor)===null||p===void 0?void 0:p.editor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(p=>p.editor)}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(p){return this._documents.get(p)}_getNotebookDocument(p){const w=this._documents.get(p);if(!w)throw new Error(`NO notebook document for '${p}'`);return w}_getProviderData(p){const w=this._notebookContentProviders.get(p);if(!w)throw new Error(`NO provider for '${p}'`);return w}registerNotebookContentProvider(p,w,u,f){var k,L,$;if(this._notebookContentProviders.has(w))throw new Error(`Notebook provider for '${w}' already registered`);this._notebookContentProviders.set(w,{extension:p,provider:u});let te;u.onDidChangeNotebookContentOptions&&(te=u.onDidChangeNotebookContentOptions(()=>{const B=y.NotebookDocumentContentOptions.from(u.options);this._notebookProxy.$updateNotebookProviderOptions(w,B)}));const H=(k=f==null?void 0:f.viewOptions)===null||k===void 0?void 0:k.filenamePattern.map(B=>y.NotebookExclusiveDocumentPattern.from(B)).filter(B=>B!==void 0);((L=f==null?void 0:f.viewOptions)===null||L===void 0?void 0:L.filenamePattern)&&!H&&console.warn(`Notebook content provider view options file name pattern is invalid ${($=f==null?void 0:f.viewOptions)===null||$===void 0?void 0:$.filenamePattern}`);const x=y.NotebookDocumentContentOptions.from(f);return this._notebookProxy.$registerNotebookProvider({id:p.identifier,location:p.extensionLocation,description:p.description},w,{transientOutputs:x.transientOutputs,transientMetadata:x.transientMetadata,viewOptions:(f==null?void 0:f.viewOptions)&&H?{displayName:f.viewOptions.displayName,filenamePattern:H,exclusive:f.viewOptions.exclusive||!1}:void 0}),new n.Disposable(()=>{te==null||te.dispose(),this._notebookContentProviders.delete(w),this._notebookProxy.$unregisterNotebookProvider(w)})}registerNotebookKernelProvider(p,w,u){const f=t._notebookKernelProviderHandlePool++,k=new l(this._notebookProxy,f,p,u);return this._notebookKernelProviders.set(f,k),this._notebookProxy.$registerNotebookKernelProvider({id:p.identifier,location:p.extensionLocation,description:p.description},f,{viewType:w.viewType,filenamePattern:w.filenamePattern?y.NotebookExclusiveDocumentPattern.from(w.filenamePattern):void 0}),new n.Disposable(()=>{k.dispose(),this._notebookKernelProviders.delete(f),this._notebookProxy.$unregisterNotebookKernelProvider(f)})}createNotebookEditorDecorationType(p){return new o(this._notebookEditorsProxy,p).value}async openNotebookDocument(p){const w=this._documents.get(p);if(w)return w.notebookDocument;const u=await this._notebookDocumentsProxy.$tryOpenDocument(p),f=this._documents.get(P.URI.revive(u));return(0,S.assertIsDefined)(f==null?void 0:f.notebookDocument)}_withAdapter(p,w,u){const f=this._documents.get(P.URI.revive(w));if(!f)return[];const k=this._notebookKernelProviders.get(p);return k?u(k,f):[]}async showNotebookDocument(p,w){var u;P.URI.isUri(p)&&(p=await this.openNotebookDocument(p));let f;typeof w=="object"?f={position:y.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:w.selection&&y.NotebookCellRange.from(w.selection),pinned:typeof w.preview=="boolean"?!w.preview:void 0}:f={preserveFocus:!1};const k=await this._notebookEditorsProxy.$tryShowNotebookDocument(p.uri,p.viewType,f),L=k&&((u=this._editors.get(k))===null||u===void 0?void 0:u.editor);if(L)return L.editor;throw k?new Error(`Could NOT open editor for "${p.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${p.toString()}".`)}async $provideNotebookKernels(p,w,u){return this._withAdapter(p,w,(f,k)=>f.provideKernels(k,u))}async $resolveNotebookKernel(p,w,u,f,k){await this._withAdapter(p,u,async(L,$)=>{const te=this._webviewComm.get(w);te&&await L.resolveNotebook(f,$,te.contentProviderComm,k)})}async $resolveNotebookEditor(p,w,u){const f=this._notebookContentProviders.get(p),k=P.URI.revive(w),L=this._documents.get(k);if(!(!L||!f)){let $=this._webviewComm.get(u);$||($=new m(u,k,this._notebookProxy,this._webviewInitData,L),this._webviewComm.set(u,$))}}async $executeNotebookKernelFromProvider(p,w,u,f){await this._withAdapter(p,w,async(k,L)=>k.executeNotebook(u,L,f))}registerNotebookSerializer(p,w,u,f){const k=this._handlePool++;this._notebookSerializer.set(k,u);const L=y.NotebookDocumentContentOptions.from(f);return this._notebookProxy.$registerNotebookSerializer(k,{id:p.identifier,location:p.extensionLocation,description:p.description},w,L),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(k)})}async $dataToNotebook(p,w){const u=this._notebookSerializer.get(p);if(!u)throw new Error("NO serializer found");const f=await u.dataToNotebook(w.buffer);return{metadata:y.NotebookDocumentMetadata.from(f.metadata),cells:f.cells.map(y.NotebookCellData.from)}}async $notebookToData(p,w){const u=this._notebookSerializer.get(p);if(!u)throw new Error("NO serializer found");const f=await u.notebookToData({metadata:y.NotebookDocumentMetadata.to(w.metadata),cells:w.cells.map(y.NotebookCellData.to)});return v.VSBuffer.wrap(f)}async $cancelNotebookCellExecution(p,w,u,f){await this._withAdapter(p,w,async(L,$)=>L.interruptNotebookExecution(u,$));const k=this._documents.get(P.URI.revive(w));if(!!k)for(let L of f)for(let $=L.start;$<L.end;$++){const te=k.getCellFromIndex($);te&&this.cancelOneNotebookCellExecution(te)}}cancelOneNotebookCellExecution(p){const w=this._activeExecutions.get(p.uri);w==null||w.cancel()}async $openNotebook(p,w,u,f,k){const{provider:L}=this._getProviderData(p),$=await L.openNotebook(P.URI.revive(w),{backupId:u,untitledDocumentData:f==null?void 0:f.buffer},k);return{metadata:y.NotebookDocumentMetadata.from($.metadata),cells:$.cells.map(y.NotebookCellData.from)}}async $saveNotebook(p,w,u){const f=this._getNotebookDocument(P.URI.revive(w)),{provider:k}=this._getProviderData(p);return await k.saveNotebook(f.notebookDocument,u),!0}async $saveNotebookAs(p,w,u,f){const k=this._getNotebookDocument(P.URI.revive(w)),{provider:L}=this._getProviderData(p);return await L.saveNotebookAs(P.URI.revive(u),k.notebookDocument,f),!0}async $backupNotebook(p,w,u){var f;const k=this._getNotebookDocument(P.URI.revive(w)),L=this._getProviderData(p),$=(f=this._extensionStoragePaths.workspaceValue(L.extension))!==null&&f!==void 0?f:this._extensionStoragePaths.globalValue(L.extension),te=String((0,E.hash)([k.uri.toString(),this._backupIdPool++])),H=P.URI.joinPath($,te),x=await L.provider.backupNotebook(k.notebookDocument,{destination:H},u);return k.updateBackup(x),x.id}$acceptNotebookActiveKernelChange(p){p.providerHandle!==void 0&&this._withAdapter(p.providerHandle,p.uri,async(w,u)=>{const f=p.kernelFriendlyId?w.getKernelByFriendlyId(P.URI.revive(p.uri),p.kernelFriendlyId):void 0;this._editors.forEach(k=>{k.editor.notebookData===u&&k.editor._acceptKernel(f)}),this._onDidChangeActiveNotebookKernel.fire({document:u.notebookDocument,kernel:f})})}$onDidReceiveMessage(p,w,u){var f;(f=this._webviewComm.get(p))===null||f===void 0||f.onDidReceiveMessage(w,u)}$acceptModelChanged(p,w,u){this._getNotebookDocument(P.URI.revive(p)).acceptModelChanged(w,u)}$acceptDirtyStateChanged(p,w){const u=this._getNotebookDocument(P.URI.revive(p));u.acceptModelChanged({rawEvents:[],versionId:u.notebookDocument.version},w)}$acceptModelSaved(p){const w=this._getNotebookDocument(P.URI.revive(p));this._onDidSaveNotebookDocument.fire(w.notebookDocument)}$acceptEditorPropertiesChanged(p,w){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,w);const u=this._editors.get(p);if(!u)throw new Error(`unknown text editor: ${p}. known editors: ${[...this._editors.keys()]} `);w.visibleRanges&&u.editor._acceptVisibleRanges(w.visibleRanges.ranges.map(y.NotebookCellRange.to)),w.selections&&u.editor._acceptSelections(w.selections.selections.map(y.NotebookCellRange.to)),w.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:u.editor.editor,visibleRanges:u.editor.editor.visibleRanges}),w.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:u.editor.editor,selections:u.editor.editor.selections}))}$acceptEditorViewColumns(p){for(const w in p){const u=this._editors.get(w);if(!u)throw new Error(`unknown text editor: ${w}. known editors: ${[...this._editors.keys()]} `);u.editor._acceptViewColumn(y.ViewColumn.to(p[w]))}}$acceptDocumentPropertiesChanged(p,w){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",p.path,w);const u=this._getNotebookDocument(P.URI.revive(p));u.acceptDocumentPropertiesChanged(w),w.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:u.notebookDocument})}_createExtHostEditor(p,w,u){var f;const k=p.uri;let L=this._webviewComm.get(w);L||(L=new m(w,k,this._notebookProxy,this._webviewInitData,p),this._webviewComm.set(w,L));const $=new s.ExtHostNotebookEditor(w,this._notebookEditorsProxy,p,u.visibleRanges.map(y.NotebookCellRange.to),u.selections.map(y.NotebookCellRange.to),typeof u.viewColumn=="number"?y.ViewColumn.to(u.viewColumn):void 0);(f=this._editors.get(w))===null||f===void 0||f.editor.dispose(),this._editors.set(w,{editor:$})}$acceptDocumentAndEditorsDelta(p){var w,u,f,k;let L=!1;if(p.removedDocuments)for(const te of p.removedDocuments){const H=P.URI.revive(te),x=this._documents.get(H);x&&(x.dispose(),this._documents.delete(H),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:x.notebookDocument.cells.map(B=>B.document.uri)}),this._onDidCloseNotebookDocument.fire(x.notebookDocument));for(const B of this._editors.values())B.editor.notebookData.uri.toString()===H.toString()&&(B.editor.dispose(),this._editors.delete(B.editor.id),L=!0)}if(p.addedDocuments){const te=[];for(const H of p.addedDocuments){const x=P.URI.revive(H.uri),B=H.viewType;if(this._documents.has(x))throw new Error(`adding EXISTING notebook ${x} `);const F=this,U=new g.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(M){F._onDidChangeNotebookCells.fire(M)},emitCellOutputsChange(M){F._onDidChangeCellOutputs.fire(M)},emitCellMetadataChange(M){F._onDidChangeCellMetadata.fire(M)},emitCellExecutionStateChange(M){F._onDidChangeCellExecutionState.fire(M)}},B,H.metadata?y.NotebookDocumentMetadata.to(H.metadata):new n.NotebookDocumentMetadata,x);U.acceptModelChanged({versionId:H.versionId,rawEvents:[{kind:D.NotebookCellsChangeType.Initialize,changes:[[0,0,H.cells]]}]},!1),te.push(...H.cells.map(M=>g.ExtHostCell.asModelAddData(U.notebookDocument,M))),(w=this._documents.get(x))===null||w===void 0||w.dispose(),this._documents.set(x,U),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:te}),this._onDidOpenNotebookDocument.fire(U.notebookDocument)}}if(p.addedEditors)for(const te of p.addedEditors){if(this._editors.has(te.id))return;const H=P.URI.revive(te.documentUri),x=this._documents.get(H);x&&(this._createExtHostEditor(x,te.id,te),L=!0)}const $=[];if(p.removedEditors)for(const te of p.removedEditors){const H=this._editors.get(te);H&&(L=!0,this._editors.delete(te),((u=this._activeNotebookEditor)===null||u===void 0?void 0:u.id)===H.editor.id&&(this._activeNotebookEditor=void 0),$.push(H))}if(L&&$.forEach(te=>{te.editor.dispose()}),p.visibleEditors){this._visibleNotebookEditors=p.visibleEditors.map(H=>this._editors.get(H).editor).filter(H=>!!H);const te=new Set;this._visibleNotebookEditors.forEach(H=>te.add(H.id));for(const H of this._editors.values()){const x=te.has(H.editor.id);H.editor._acceptVisibility(x)}this._visibleNotebookEditors=[...this._editors.values()].map(H=>H.editor).filter(H=>H.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}p.newActiveEditor===null?this._activeNotebookEditor=void 0:p.newActiveEditor&&(this._activeNotebookEditor=(f=this._editors.get(p.newActiveEditor))===null||f===void 0?void 0:f.editor),p.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((k=this._activeNotebookEditor)===null||k===void 0?void 0:k.editor)}createNotebookCellStatusBarItemInternal(p,w,u){const f=new i(this._notebookProxy,this._commandsConverter,p,w,u),k=D.CellUri.parse(p.document.uri);if(k){const L=this._documents.get(k.notebook);if(L){const $=L.getCell(k.handle);$&&I.Event.once($.onDidDispose)(()=>f.dispose())}}return f}createNotebookCellExecution(p,w,u){const f=this.lookupNotebookDocument(p);if(!f)throw new Error(`Invalid cell uri / index: ${p}, ${w} `);const k=f.getCellFromIndex(w);if(!k)throw new Error(`Invalid cell uri / index: ${p}, ${w} `);if(!this._activeExecutions.has(k.uri)){const L=new c(p,f,k,this._notebookDocumentsProxy);this._activeExecutions.set(k.uri,L);const $=L.onDidChangeState(()=>{L.state===r.Resolved&&(L.dispose(),$.dispose(),this._activeExecutions.delete(k.uri))});return L.asApiObject()}}}e.ExtHostNotebookController=t,t._notebookKernelProviderHandlePool=0;class i extends T.Disposable{constructor(p,w,u,f,k){super();this._proxy=p,this._commands=w,this._cell=u,this._priority=k,this._id=i.NEXT_ID++,this._isDisposed=!1,this._text="",this._visible=!1,this._internalCommandRegistration=this._register(new T.DisposableStore),this._alignment=f!=null?f:n.NotebookCellStatusBarAlignment.Left}get apiItem(){return this._apiItem||(this._apiItem=a(this)),this._apiItem}get cell(){return this._cell}get alignment(){return this._alignment}set alignment(p){this._alignment=p,this.update()}get priority(){return this._priority}set priority(p){this._priority=p,this.update()}get text(){return this._text}set text(p){this._text=p,this.update()}get tooltip(){return this._tooltip}set tooltip(p){this._tooltip=p,this.update()}get command(){var p;return(p=this._command)===null||p===void 0?void 0:p.fromApi}set command(p){var w;((w=this._command)===null||w===void 0?void 0:w.fromApi)!==p&&(this._internalCommandRegistration.clear(),typeof p=="string"?this._command={fromApi:p,internal:this._commands.toInternal({title:"",command:p},this._internalCommandRegistration)}:p?this._command={fromApi:p,internal:this._commands.toInternal(p,this._internalCommandRegistration)}:this._command=void 0,this.update())}get accessibilityInformation(){return this._accessibilityInformation}set accessibilityInformation(p){this._accessibilityInformation=p,this.update()}show(){this._visible=!0,this.update()}hide(){this._visible=!1,this.update()}dispose(){this.hide(),this._isDisposed=!0,this._internalCommandRegistration.dispose()}update(){var p;if(!this._isDisposed){const w={alignment:this.alignment===n.NotebookCellStatusBarAlignment.Left?0:1,cellResource:this.cell.document.uri,command:(p=this._command)===null||p===void 0?void 0:p.internal,text:this.text,tooltip:this.tooltip,accessibilityInformation:this.accessibilityInformation,priority:this.priority,visible:this._visible};this._proxy.$setStatusBarEntry(this._id,w)}}}e.NotebookCellStatusBarItemInternal=i,i.NEXT_ID=0;function a(h){return Object.freeze({cell:h.cell,get alignment(){return h.alignment},set alignment(p){h.alignment=p},get priority(){return h.priority},set priority(p){h.priority=p},get text(){return h.text},set text(p){h.text=p},get tooltip(){return h.tooltip},set tooltip(p){h.tooltip=p},get command(){return h.command},set command(p){h.command=p},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(p){h.accessibilityInformation=p},show(){h.show()},hide(){h.hide()},dispose(){h.dispose()}})}var r;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(r||(r={}));class c extends T.Disposable{constructor(p,w,u,f){super();this._uri=p,this._document=w,this._cell=u,this._proxy=f,this._onDidChangeState=new I.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new _.CancellationTokenSource),this._executionOrder=u.internalMetadata.executionOrder,this.mixinMetadata({runState:D.NotebookCellExecutionState.Pending,lastRunDuration:null,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(p){return this._proxy.$applyEdits(this._uri,p,!1)}verifyStateForOutput(){if(this._state===r.Init)throw new Error("Must call start before modifying cell output");if(this._state===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(p){const w=[{editType:11,handle:this._cell.handle,metadata:p}];this.applyEdits(w)}cellIndexToHandle(p){const w=typeof p=="number"?this._document.getCellFromIndex(p):this._cell;if(!!w)return w.handle}asApiObject(){const p=this;return Object.freeze({get document(){return p._document.notebookDocument},get cell(){return p._cell.cell},get executionOrder(){return p._executionOrder},set executionOrder(w){p._executionOrder=w,p.mixinMetadata({executionOrder:w})},start(w){if(p._state===r.Resolved||p._state===r.Started)throw new Error("Cannot call start again");p._state=r.Started,p._onDidChangeState.fire(),p.mixinMetadata({runState:D.NotebookCellExecutionState.Executing,runStartTime:w==null?void 0:w.startTime})},end(w){var u,f;if(p._state===r.Resolved)throw new Error("Cannot call resolve twice");p._state=r.Resolved,p._onDidChangeState.fire(),p.mixinMetadata({runState:D.NotebookCellExecutionState.Idle,lastRunSuccess:(u=w==null?void 0:w.success)!==null&&u!==void 0?u:null,lastRunDuration:(f=w==null?void 0:w.duration)!==null&&f!==void 0?f:null})},clearOutput(w){return p.verifyStateForOutput(),this.replaceOutput([],w)},async appendOutput(w,u){p.verifyStateForOutput();const f=p.cellIndexToHandle(u);if(typeof f=="number")return w=Array.isArray(w)?w:[w],p.applyEdits([{editType:2,handle:f,append:!0,outputs:w.map(y.NotebookCellOutput.from)}])},async replaceOutput(w,u){p.verifyStateForOutput();const f=p.cellIndexToHandle(u);if(typeof f=="number")return w=Array.isArray(w)?w:[w],p.applyEdits([{editType:2,handle:f,outputs:w.map(y.NotebookCellOutput.from)}])},async appendOutputItems(w,u){return p.verifyStateForOutput(),w=Array.isArray(w)?w:[w],p.applyEdits([{editType:10,append:!0,items:w.map(y.NotebookCellOutputItem.from),outputId:u}])},async replaceOutputItems(w,u){return p.verifyStateForOutput(),w=Array.isArray(w)?w:[w],p.applyEdits([{editType:10,items:w.map(y.NotebookCellOutputItem.from),outputId:u}])},token:p._tokenSource.token})}}}),define(ge[63],ve([0,1,5,3,6,22,4,13]),function(Q,e,_,I,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends T.Disposable{constructor(s,d,S,v){super();this._onDidAppend=this._register(new I.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=s,this._proxy=v,this._id=v.$register(this.name,d,S),this._disposed=!1,this._offset=0}get name(){return this._name}append(s){this.validate(),this._offset+=s?P.VSBuffer.fromString(s).byteLength:0}update(){this._id.then(s=>this._proxy.$update(s))}appendLine(s){this.validate(),this.append(s+`
`)}clear(){this.validate();const s=this._offset;this._id.then(d=>this._proxy.$clear(d,s))}show(s,d){this.validate(),this._id.then(S=>this._proxy.$reveal(S,!!(typeof s=="boolean"?s:d)))}hide(){this.validate(),this._id.then(s=>this._proxy.$close(s))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(s=>this._proxy.$dispose(s)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class n extends y{constructor(s,d){super(s,!1,void 0,d)}append(s){super.append(s),this._id.then(d=>this._proxy.$append(d,s)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=n;class R extends y{constructor(s,d,S){super(s,!0,d,S)}append(s){throw new Error("Not supported")}}class D{constructor(s,d){this.name=s,this._channel=d}append(s){this._channel.then(d=>d.append(s))}appendLine(s){this._channel.then(d=>d.appendLine(s))}clear(){this._channel.then(s=>s.clear())}show(s,d){this._channel.then(S=>S.show(s,d))}hide(){this._channel.then(s=>s.hide())}dispose(){this._channel.then(s=>s.dispose())}}e.LazyOutputChannel=D;let b=class{constructor(s){this._proxy=s.getProxy(_.MainContext.MainThreadOutputService)}$setVisibleChannel(s){}createOutputChannel(s){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");return new n(s,this._proxy)}createOutputChannelFromLogFile(s,d){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");if(!d)throw new Error("illegal argument `file`. must not be falsy");return new R(s,d,this._proxy)}};b=je([Ue(0,A.IExtHostRpcService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")}),define(ge[242],ve([0,1,19,21,3,6,5,2,7,18,14,56]),function(Q,e,_,I,T,P,C,A,y,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function b(g,s,d){const S=g.getProxy(C.MainContext.MainThreadQuickOpen);class v{constructor(r,c){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=c}showQuickPick(r,c,h,p=I.CancellationToken.None){this._onDidSelectItem=void 0;const w=Promise.resolve(r),u=++this._instances,f=S.$show(u,{title:h==null?void 0:h.title,placeHolder:h==null?void 0:h.placeHolder,matchOnDescription:h==null?void 0:h.matchOnDescription,matchOnDetail:h==null?void 0:h.matchOnDetail,ignoreFocusLost:h==null?void 0:h.ignoreFocusOut,canPickMany:h==null?void 0:h.canPickMany},p),k={},L=f.then(()=>k);return Promise.race([L,w]).then($=>{if($!==k)return w.then(te=>{const H=[];for(let x=0;x<te.length;x++){const B=te[x];let F,U,M,N,O;typeof B=="string"?F=B:(F=B.label,U=B.description,M=B.detail,N=B.picked,O=B.alwaysShow),H.push({label:F,description:U,handle:x,detail:M,picked:N,alwaysShow:O})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{h.onDidSelectItem(te[x])}),S.$setItems(u,H),f.then(x=>{if(typeof x=="number")return te[x];if(Array.isArray(x))return x.map(B=>te[B])})})}).then(void 0,$=>{if(!(0,n.isPromiseCanceledError)($))return S.$setError(u,$),Promise.reject($)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,c=I.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,S.$input(r,typeof this._validateInput=="function",c).then(void 0,h=>{if(!(0,n.isPromiseCanceledError)(h))return Promise.reject(h)})}$validateInput(r){return this._validateInput?(0,_.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,c=I.CancellationToken.None){const h=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!!h){const p=await this._workspace.getWorkspaceFolders2();if(!!p)return p.find(w=>w.uri.toString()===h.uri.toString())}}createQuickPick(r,c){const h=new t(r,c,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(r){const c=new i(r,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(r,c){const h=this._sessions.get(r);h&&h._fireDidChangeValue(c)}$onDidAccept(r){const c=this._sessions.get(r);c&&c._fireDidAccept()}$onDidChangeActive(r,c){const h=this._sessions.get(r);h instanceof t&&h._fireDidChangeActive(c)}$onDidChangeSelection(r,c){const h=this._sessions.get(r);h instanceof t&&h._fireDidChangeSelection(c)}$onDidTriggerButton(r,c){const h=this._sessions.get(r);h&&h._fireDidTriggerButton(c)}$onDidHide(r){const c=this._sessions.get(r);c&&c._fireDidHide()}}class E{constructor(r,c){this._extensionId=r,this._onDidDispose=c,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((c,h)=>{const p=c===y.QuickInputButtons.Back?-1:h;this._handlesToButtons.set(p,c)}),this.update({buttons:r.map((c,h)=>({iconPath:m(c.iconPath),tooltip:c.tooltip,handle:c===y.QuickInputButtons.Back?-1:h}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const c=this._handlesToButtons.get(r);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(r){if(!this._disposed){for(const c of Object.keys(r)){const h=r[c];this._pendingUpdate[c]=h===void 0?null:h}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function m(a){if(a instanceof y.ThemeIcon)return{id:a.id};const r=o(a),c=l(a);return{dark:typeof r=="string"?A.URI.file(r):r,light:typeof c=="string"?A.URI.file(c):c}}function l(a){return typeof a=="object"&&"light"in a?a.light:a}function o(a){return typeof a=="object"&&"dark"in a?a.dark:a}class t extends E{constructor(r,c,h){super(r,h);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((c,h)=>{this._handlesToItems.set(h,c),this._itemsToHandles.set(c,h)}),this.update({items:r.map((c,h)=>({label:c.label,description:c.description,handle:h,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(r){const c=(0,R.coalesce)(r.map(h=>this._handlesToItems.get(h)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(r){const c=(0,R.coalesce)(r.map(h=>this._handlesToItems.get(h)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}}class i extends E{constructor(r,c){super(r,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?D.default.Error:D.default.Ignore})}}return new v(s,d)}e.createExtHostQuickOpen=b}),define(ge[243],ve([0,1,2,3,68,6,19,5,14,95,12,29,41]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(r){if(r)return typeof r.iconPath=="string"?_.URI.file(r.iconPath):r.iconPath}function s(r,c){if(!r.iconPath&&!c.iconPath)return 0;if(r.iconPath){if(!c.iconPath)return 1}else return-1;const h=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,p=typeof c.iconPath=="string"?c.iconPath:c.iconPath.fsPath;return(0,n.comparePaths)(h,p)}function d(r,c){let h=0;if(r.strikeThrough!==c.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==c.faded)return r.faded?1:-1;if(r.tooltip!==c.tooltip)return(r.tooltip||"").localeCompare(c.tooltip||"");if(h=s(r,c),h!==0)return h;if(r.light&&c.light)h=s(r.light,c.light);else{if(r.light)return 1;if(c.light)return-1}if(h!==0)return h;if(r.dark&&c.dark)h=s(r.dark,c.dark);else{if(r.dark)return 1;if(c.dark)return-1}return h}function S(r,c){if(r.command!==c.command)return r.command<c.command?-1:1;if(r.title!==c.title)return r.title<c.title?-1:1;if(r.tooltip!==c.tooltip){if(r.tooltip!==void 0&&c.tooltip!==void 0)return r.tooltip<c.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(r.arguments===c.arguments)return 0;if(r.arguments)if(c.arguments){if(r.arguments.length!==c.arguments.length)return r.arguments.length-c.arguments.length}else return 1;else return-1;for(let h=0;h<r.arguments.length;h++){const p=r.arguments[h],w=c.arguments[h];if(p!==w)return p<w?-1:1}return 0}function v(r,c){let h=(0,n.comparePaths)(r.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(h!==0)return h;if(r.command&&c.command)h=S(r.command,c.command);else{if(r.command)return 1;if(c.command)return-1}if(h!==0)return h;if(r.decorations&&c.decorations)h=d(r.decorations,c.decorations);else{if(r.decorations)return 1;if(c.decorations)return-1}return h}function E(r,c){for(let h=0;h<r.length;h++)if(r[h]!==c[h])return!1;return!0}function m(r,c){return r.command===c.command&&r.title===c.title&&r.tooltip===c.tooltip&&(r.arguments&&c.arguments?E(r.arguments,c.arguments):r.arguments===c.arguments)}function l(r,c){return(0,y.equals)(r,c,m)}class o{constructor(c,h,p){this._extension=c,this._proxy=h,this._sourceControlHandle=p,this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(c){this._proxy.$setInputBoxValue(this._sourceControlHandle,c),this.updateValue(c)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(c){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,c),this._placeholder=c}get validateInput(){return(0,b.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(c){if((0,b.checkProposedApiEnabled)(this._extension),c&&typeof c!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=c,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!c)}get visible(){return this._visible}set visible(c){c=!!c,this._visible!==c&&(this._visible=c,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,c))}$onInputBoxValueChange(c){this.updateValue(c)}updateValue(c){this._value=c,this._onDidChange.fire(c)}}e.ExtHostSCMInputBox=o;class t{constructor(c,h,p,w,u){this._proxy=c,this._commands=h,this._sourceControlHandle=p,this._id=w,this._label=u,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(c){this._label=c,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,c)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(c){this._hideWhenEmpty=c,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(c){this._resourceStates=[...c],this._onDidUpdateResourceStates.fire()}getResourceState(c){return this._resourceStatesMap.get(c)}$executeResourceCommand(c,h){const p=this._resourceStatesCommandsMap.get(c);return p?(0,C.asPromise)(()=>this._commands.executeCommand(p.command,...p.arguments||[],h)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var c;const h=[...this._resourceStates].sort(v),w=(0,y.sortedDiff)(this._resourceSnapshot,h,v).map(k=>{const L=k.toInsert.map($=>{const te=this._resourceHandlePool++;this._resourceStatesMap.set(te,$);const H=$.resourceUri,x=g($.decorations),B=$.decorations&&g($.decorations.light)||x,F=$.decorations&&g($.decorations.dark)||x,U=[];let M;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const me=new P.DisposableStore;M=this._commands.converter.toInternal($.command,me),this._resourceStatesDisposablesMap.set(te,me)}else this._resourceStatesCommandsMap.set(te,$.command);B&&U.push(B),F&&F.toString()!==(B==null?void 0:B.toString())&&U.push(F);const N=$.decorations&&$.decorations.tooltip||"",O=$.decorations&&!!$.decorations.strikeThrough,j=$.decorations&&!!$.decorations.faded,q=$.contextValue||"";return{rawResource:[te,H,U,N,O,j,q,M],handle:te}});return{start:k.start,deleteCount:k.deleteCount,toInsert:L}}),u=w.map(({start:k,deleteCount:L,toInsert:$})=>[k,L,$.map(te=>te.rawResource)]),f=w.reverse();for(const{start:k,deleteCount:L,toInsert:$}of f){const te=$.map(x=>x.handle),H=this._handlesSnapshot.splice(k,L,...te);for(const x of H)this._resourceStatesMap.delete(x),this._resourceStatesCommandsMap.delete(x),(c=this._resourceStatesDisposablesMap.get(x))===null||c===void 0||c.dispose(),this._resourceStatesDisposablesMap.delete(x)}return this._resourceSnapshot=h,u}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(c,h,p,w,u,f){this._proxy=h,this._commands=p,this._id=w,this._label=u,this._rootUri=f,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new o(c,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,w,u,f)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(c){this._count!==c&&(this._count=c,this._proxy.$updateSourceControl(this.handle,{count:c}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(c){this._quickDiffProvider=c,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this._commitTemplate}set commitTemplate(c){c!==this._commitTemplate&&(this._commitTemplate=c,this._proxy.$updateSourceControl(this.handle,{commitTemplate:c}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(c){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=c;const h=this._commands.converter.toInternal(c,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:h})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(c){if(!(this._statusBarCommands&&c&&l(this._statusBarCommands,c))){this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=c;const h=(c||[]).map(p=>this._commands.converter.toInternal(p,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:h})}}get selected(){return this._selected}createResourceGroup(c,h){const p=new t(this._proxy,this._commands,this.handle,c,h),w=I.Event.once(p.onDidDispose)(()=>this.createdResourceGroups.delete(p));return this.createdResourceGroups.set(p,w),this.eventuallyAddResourceGroups(),p}eventuallyAddResourceGroups(){const c=[],h=[];for(const[p,w]of this.createdResourceGroups){w.dispose();const u=p.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(p),this.eventuallyUpdateResourceStates()});I.Event.once(p.onDidDispose)(()=>{this.updatedResourceGroups.delete(p),u.dispose(),this._groups.delete(p.handle),this._proxy.$unregisterGroup(this.handle,p.handle)}),c.push([p.handle,p.id,p.label,p.features]);const f=p._takeResourceStateSnapshot();f.length>0&&h.push([p.handle,f]),this._groups.set(p.handle,p)}this._proxy.$registerGroups(this.handle,c,h),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const c=[];this.updatedResourceGroups.forEach(h=>{const p=h._takeResourceStateSnapshot();p.length!==0&&c.push([h.handle,p])}),c.length>0&&this._proxy.$spliceResourceStates(this.handle,c),this.updatedResourceGroups.clear()}getResourceGroup(c){return this._groups.get(c)}setSelectionState(c){this._selected=c,this._onDidChangeSelection.fire(c)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(c=>c.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,je([(0,T.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),je([(0,T.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let a=class Ln{constructor(c,h,p){this._commands=h,this.logService=p,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=c.getProxy(A.MainContext.MainThreadSCM),this._telemetry=c.getProxy(A.MainContext.MainThreadTelemetry),h.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===3){const u=this._sourceControls.get(w.sourceControlHandle);if(!u)return w;const f=u.getResourceGroup(w.groupHandle);return f?f.getResourceState(w.handle):w}else if(w&&w.$mid===4){const u=this._sourceControls.get(w.sourceControlHandle);return u?u.getResourceGroup(w.groupHandle):w}else if(w&&w.$mid===5){const u=this._sourceControls.get(w.handle);return u||w}return w}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(c,h,p,w){this.logService.trace("ExtHostSCM#createSourceControl",c.identifier.value,h,p,w),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const u=Ln._handlePool++,f=new i(c,this._proxy,this._commands,h,p,w);this._sourceControls.set(u,f);const k=this._sourceControlsByExtension.get(D.ExtensionIdentifier.toKey(c.identifier))||[];return k.push(f),this._sourceControlsByExtension.set(D.ExtensionIdentifier.toKey(c.identifier),k),f}getLastInputBox(c){this.logService.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const h=this._sourceControlsByExtension.get(D.ExtensionIdentifier.toKey(c.identifier)),p=h&&h[h.length-1];return p&&p.inputBox}$provideOriginalResource(c,h,p){const w=_.URI.revive(h);this.logService.trace("ExtHostSCM#$provideOriginalResource",c,w.toString());const u=this._sourceControls.get(c);return!u||!u.quickDiffProvider||!u.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>u.quickDiffProvider.provideOriginalResource(w,p)).then(f=>f||null)}$onInputBoxValueChange(c,h){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",c);const p=this._sourceControls.get(c);return p&&p.inputBox.$onInputBoxValueChange(h),Promise.resolve(void 0)}$executeResourceCommand(c,h,p,w){this.logService.trace("ExtHostSCM#$executeResourceCommand",c,h,p);const u=this._sourceControls.get(c);if(!u)return Promise.resolve(void 0);const f=u.getResourceGroup(h);return f?f.$executeResourceCommand(p,w):Promise.resolve(void 0)}$validateInput(c,h,p){this.logService.trace("ExtHostSCM#$validateInput",c);const w=this._sourceControls.get(c);return!w||!w.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>w.inputBox.validateInput(h,p)).then(u=>u?Promise.resolve([u.message,u.type]):Promise.resolve(void 0))}$setSelectedSourceControl(c){var h,p;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&((h=this._sourceControls.get(c))===null||h===void 0||h.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((p=this._sourceControls.get(this._selectedSourceControlHandle))===null||p===void 0||p.setSelectionState(!1)),this._selectedSourceControlHandle=c,Promise.resolve(void 0)}};a._handlePool=0,a=je([Ue(2,R.ILogService)],a),e.ExtHostSCM=a});var tt=this&&this.__classPrivateFieldSet||function(Q,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(Q,_):T?T.value=_:e.set(Q,_),_},$e=this&&this.__classPrivateFieldGet||function(Q,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(Q):I?I.value:e.get(Q)};define(ge[244],ve([0,1,7,5,163,6]),function(Q,e,_,I,T,P){"use strict";var C,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(b,g,s,d,S=_.StatusBarAlignment.Left,v,E){C.set(this,void 0),A.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,C,b,"f"),tt(this,A,g,"f"),this._id=y.ID_GEN++,this._statusId=s,this._statusName=d,this._alignment=S,this._priority=v,this._accessibilityInformation=E}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var b;return(b=this._command)===null||b===void 0?void 0:b.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(b){this._text=b,this.update()}set tooltip(b){this._tooltip=b,this.update()}set color(b){this._color=b,this.update()}set backgroundColor(b){b&&!y.ALLOWED_BACKGROUND_COLORS.has(b.id)&&(b=void 0),this._backgroundColor=b,this.update()}set command(b){var g;((g=this._command)===null||g===void 0?void 0:g.fromApi)!==b&&(this._internalCommandRegistration.clear(),typeof b=="string"?this._command={fromApi:b,internal:$e(this,A,"f").toInternal({title:"",command:b},this._internalCommandRegistration)}:b?this._command={fromApi:b,internal:$e(this,A,"f").toInternal(b,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(b){this._accessibilityInformation=b,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,$e(this,C,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var b;this._timeoutHandle=void 0;let g=this._color;this._backgroundColor&&(g=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),$e(this,C,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(b=this._command)===null||b===void 0?void 0:b.internal,g,this._backgroundColor,this._alignment===_.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,C=new WeakMap,A=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new _.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(b){this._messages=[],this._item=b.createStatusBarEntry("status.extensionMessage",(0,T.localize)(0,null),_.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(b){const g={message:b};return this._messages.unshift(g),this._update(),new _.Disposable(()=>{const s=this._messages.indexOf(g);s>=0&&(this._messages.splice(s,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class R{constructor(b,g){this._proxy=b.getProxy(I.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new n(this)}createStatusBarEntry(b,g,s,d,S){return new y(this._proxy,this._commands,b,g,s,d,S)}setStatusBarMessage(b,g){const s=this._statusMessage.setMessage(b);let d;return typeof g=="number"?d=setTimeout(()=>s.dispose(),g):typeof g!="undefined"&&g.then(()=>s.dispose(),()=>s.dispose()),new _.Disposable(()=>{s.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=R}),define(ge[88],ve([0,1,5,3,4]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(A){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(_.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this._proxy.$registerExtensionStorageKeysToSync(A,y)}getValue(A,y,n){return this._proxy.$getValue(A,y).then(R=>R||n)}setValue(A,y,n){return this._proxy.$setValue(A,y,n)}$acceptValue(A,y,n){this._onDidChangeStorage.fire({shared:A,key:y,value:n})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(ge[89],ve([0,1,4,27,12,87,2]),function(Q,e,_,I,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,_.createDecorator)("IExtensionStoragePaths");let A=class{constructor(n,R,D){var b;this._logService=R,this._extHostFileSystem=D,this._workspace=(b=n.workspace)!==null&&b!==void 0?b:void 0,this._environment=n.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getOrCreateWorkspaceStoragePath(){var n;if(!this._workspace)return Promise.resolve(void 0);const R=this._workspace.id,D=C.URI.joinPath(this._environment.workspaceStorageHome,R);try{return await this._extHostFileSystem.value.stat(D),this._logService.trace("[ExtHostStorage] storage dir already exists",D),D}catch(b){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",D),await this._extHostFileSystem.value.createDirectory(D),await this._extHostFileSystem.value.writeFile(C.URI.joinPath(D,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(n=C.URI.revive(this._workspace.configuration))===null||n===void 0?void 0:n.toString(),name:this._workspace.name},void 0,2))),D}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(n){if(this._value)return C.URI.joinPath(this._value,n.identifier.value)}globalValue(n){return C.URI.joinPath(this._environment.globalStorageHome,n.identifier.value.toLowerCase())}};A=je([Ue(0,I.IExtHostInitDataService),Ue(1,T.ILogService),Ue(2,P.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(ge[35],ve([0,1,3,5,4,2,13,6,7,164,18,209,21,28,189]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class d{constructor(t,i,a,r){this._proxy=t,this._id=i,this._creationOptions=a,this._name=r,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(h=>this._pidPromiseComplete=h);const c=this;this.value={get name(){return c._name||""},get processId(){return c._pidPromise},get creationOptions(){return c._creationOptions},get exitStatus(){return c._exitStatus},sendText(h,p=!0){c._checkDisposed(),c._proxy.$sendText(c._id,h,p)},show(h){c._checkDisposed(),c._proxy.$show(c._id,h)},hide(){c._checkDisposed(),c._proxy.$hide(c._id)},dispose(){c._disposed||(c._disposed=!0,c._proxy.$dispose(c._id))},get dimensions(){if(!(c._cols===void 0||c._rows===void 0))return{columns:c._cols,rows:c._rows}}}}async create(t,i,a,r,c,h,p,w,u,f,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:i,cwd:a,env:r,icon:c,initialText:h,waitOnExit:p,strictEnv:w,hideFromUser:u,isFeatureTerminal:f,isExtensionOwnedTerminal:k})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,i){return t===this._cols&&i===this._rows||t===0||i===0?!1:(this._cols=t,this._rows=i,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=d;class S{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new _.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new _.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new _.Emitter,this._onProcessTitleChanged=new _.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new _.Emitter,this._onProcessShellTypeChanged=new _.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,i){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:i})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=S;let v=1,E=class extends A.Disposable{constructor(t,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new _.Emitter,this._onDidOpenTerminal=new _.Emitter,this._onDidChangeActiveTerminal=new _.Emitter,this._onDidChangeTerminalDimensions=new _.Emitter,this._proxy=i.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new _.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[a,r]of this._terminalProcesses)r.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const i=new d(this._proxy,(0,g.generateUuid)(),t,t.name),a=new S(t.pty);return i.createExtensionTerminal().then(r=>{const c=this._setupExtHostProcessListeners(r,a);this._terminalProcessDisposables[r]=c}),this._terminals.push(i),i.value}attachPtyToTerminal(t,i){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const r=new S(i),c=this._setupExtHostProcessListeners(t,r);this._terminalProcessDisposables[t]=c}async $acceptActiveTerminalChanged(t){const i=this._activeTerminal;if(t===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const a=this._getTerminalById(t);a&&(this._activeTerminal=a,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,i){const a=this._getTerminalById(t);a&&this._onDidWriteTerminalData.fire({terminal:a.value,data:i})}async $acceptTerminalDimensions(t,i,a){const r=this._getTerminalById(t);r&&r.setDimensions(i,a)&&this._onDidChangeTerminalDimensions.fire({terminal:r.value,dimensions:r.value.dimensions})}async $acceptTerminalMaximumDimensions(t,i,a){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(i,a)}async $acceptTerminalTitleChange(t,i){const a=this._getTerminalById(t);a&&(a.name=i)}async $acceptTerminalClosed(t,i){const a=this._getTerminalObjectIndexById(this._terminals,t);if(a!==null){const r=this._terminals.splice(a,1)[0];r.setExitCode(i),this._onDidCloseTerminal.fire(r.value)}}$acceptTerminalOpened(t,i,a,r){if(i){const p=this._getTerminalObjectIndexById(this._terminals,i);if(p!==null){this._terminals[p]._id=t,this._onDidOpenTerminal.fire(this.terminals[p]),this._terminals[p].isOpen=!0;return}}const c={name:r.name,shellPath:r.executable,shellArgs:r.args,cwd:typeof r.cwd=="string"?r.cwd:P.URI.revive(r.cwd),env:r.env,hideFromUser:r.hideFromUser},h=new d(this._proxy,t,c,a);this._terminals.push(h),this._onDidOpenTerminal.fire(h.value),h.isOpen=!0}async $acceptTerminalProcessId(t,i){const a=this._getTerminalById(t);a&&a._setProcessId(i)}async $startExtensionTerminal(t,i){const a=this._getTerminalById(t);if(!a)return{message:(0,n.localize)(0,null,t)};a.isOpen||await new Promise(c=>{const h=this.onDidOpenTerminal(async p=>{p===a.value&&(h.dispose(),c())})});const r=this._terminalProcesses.get(t);r?r.startSendingEvents(i):this._extensionTerminalAwaitingStart[t]={initialDimensions:i}}_setupExtHostProcessListeners(t,i){const a=new A.DisposableStore;a.add(i.onProcessReady(c=>this._proxy.$sendProcessReady(t,c.pid,c.cwd))),a.add(i.onProcessTitleChanged(c=>this._proxy.$sendProcessTitle(t,c))),this._bufferer.startBuffering(t,i.onProcessData),a.add(i.onProcessExit(c=>this._onProcessExit(t,c))),i.onProcessOverrideDimensions&&a.add(i.onProcessOverrideDimensions(c=>this._proxy.$sendOverrideDimensions(t,c))),this._terminalProcesses.set(t,i);const r=this._extensionTerminalAwaitingStart[t];return r&&i instanceof S&&(i.startSendingEvents(r.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),a}$acceptProcessAckDataEvent(t,i){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.acknowledgeDataEvent(i)}$acceptProcessInput(t,i){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.input(i)}$acceptProcessResize(t,i,a){var r;try{(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(i,a)}catch(c){if(c.code!=="EPIPE"&&c.code!=="ERR_IPC_CHANNEL_CLOSED")throw c}}$acceptProcessShutdown(t,i){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.shutdown(i)}$acceptProcessRequestInitialCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getInitialCwd().then(a=>this._proxy.$sendProcessInitialCwd(t,a))}$acceptProcessRequestCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getCwd().then(a=>this._proxy.$sendProcessCwd(t,a))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,i){const a=this._getTerminalById(t);if(!a)return[];this._terminalLinkCache.delete(t);const r=this._terminalLinkCancellationSource.get(t);r&&r.dispose(!0);const c=new b.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,c);const h=[],p={terminal:a.value,line:i},w=[];for(const k of this._linkProviders)w.push(new Promise(async L=>{c.token.onCancellationRequested(()=>L({provider:k,links:[]}));const $=await k.provideTerminalLinks(p,c.token)||[];c.token.isCancellationRequested||L({provider:k,links:$})}));const u=await Promise.all(w);if(c.token.isCancellationRequested)return[];const f=new Map;for(const k of u)k&&k.links.length>0&&h.push(...k.links.map(L=>{const $={id:v++,startIndex:L.startIndex,length:L.length,label:L.tooltip};return f.set($.id,{provider:k.provider,link:L}),$}));return this._terminalLinkCache.set(t,f),h}$activateLink(t,i){var a;const r=(a=this._terminalLinkCache.get(t))===null||a===void 0?void 0:a.get(i);!r||r.provider.handleTerminalLink(r.link)}_onProcessExit(t,i){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const a=this._terminalProcessDisposables[t];a&&(a.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,i)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,i){const a=this._getTerminalObjectIndexById(t,i);return a!==null?t[a]:null}_getTerminalObjectIndexById(t,i){let a=null;return t.some((r,c)=>r._id===i?(a=c,!0):!1),a}getEnvironmentVariableCollection(t){let i=this._environmentVariableCollections.get(t.identifier.value);return i||(i=new m,this._setEnvironmentVariableCollection(t.identifier.value,i)),i}_syncEnvironmentVariableCollection(t,i){const a=(0,D.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(t,i.persistent,a.length===0?void 0:a)}$initEnvironmentVariableCollections(t){t.forEach(i=>{const a=i[0],r=new m(i[1]);this._setEnvironmentVariableCollection(a,r)})}_setEnvironmentVariableCollection(t,i){this._environmentVariableCollections.set(t,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,i)})}};E=je([Ue(1,C.IExtHostRpcService)],E),e.BaseExtHostTerminalService=E;class m{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new _.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Replace})}append(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,i){const a=this.map.get(t);(!a||a.value!==i.value||a.type!==i.type)&&(this.map.set(t,i),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,i){this.map.forEach((a,r)=>t.call(i,r,a,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=m;let l=class extends E{constructor(t){super(!1,t)}createTerminal(t,i,a){throw new R.NotSupportedError}createTerminalFromOptions(t){throw new R.NotSupportedError}getDefaultShell(t,i){throw new R.NotSupportedError}getDefaultShellArgs(t,i){throw new R.NotSupportedError}$getAvailableProfiles(t){throw new R.NotSupportedError}async $getDefaultShellAndArgs(t){throw new R.NotSupportedError}$acceptWorkspacePermissionsChanged(t){throw new R.NotSupportedError}};l=je([Ue(0,C.IExtHostRpcService)],l),e.WorkerExtHostTerminalService=l}),define(ge[245],ve([0,1,3,14,5,122,20,7]),function(Q,e,_,I,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(R,D){this._extHostDocumentsAndEditors=D,this._onDidChangeTextEditorSelection=new _.Emitter,this._onDidChangeTextEditorOptions=new _.Emitter,this._onDidChangeTextEditorVisibleRanges=new _.Emitter,this._onDidChangeTextEditorViewColumn=new _.Emitter,this._onDidChangeActiveTextEditor=new _.Emitter,this._onDidChangeVisibleTextEditors=new _.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(T.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(b=>this._onDidChangeVisibleTextEditors.fire(b)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(b=>this._onDidChangeActiveTextEditor.fire(b))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const D=this._extHostDocumentsAndEditors.allEditors();return R?D:D.map(b=>b.value)}async showTextDocument(R,D,b){let g;typeof D=="number"?g={position:C.ViewColumn.from(D),preserveFocus:b}:typeof D=="object"?g={position:C.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?C.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:g={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(R.uri,g),d=s&&this._extHostDocumentsAndEditors.getEditor(s);if(d)return d.value;throw s?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R){return new P.TextEditorDecorationType(this._proxy,R).value}$acceptEditorPropertiesChanged(R,D){const b=this._extHostDocumentsAndEditors.getEditor(R);if(!b)throw new Error("unknown text editor");if(D.options&&b._acceptOptions(D.options),D.selections){const g=D.selections.selections.map(C.Selection.to);b._acceptSelections(g)}if(D.visibleRanges){const g=I.coalesce(D.visibleRanges.map(C.Range.to));b._acceptVisibleRanges(g)}if(D.options&&this._onDidChangeTextEditorOptions.fire({textEditor:b.value,options:Object.assign(Object.assign({},D.options),{lineNumbers:C.TextEditorLineNumbersStyle.to(D.options.lineNumbers)})}),D.selections){const g=A.TextEditorSelectionChangeKind.fromValue(D.selections.source),s=D.selections.selections.map(C.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:b.value,selections:s,kind:g})}if(D.visibleRanges){const g=I.coalesce(D.visibleRanges.map(C.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:b.value,visibleRanges:g})}}$acceptEditorPositionData(R){for(const D in R){const b=this._extHostDocumentsAndEditors.getEditor(D);if(!b)throw new Error("Unknown text editor");const g=C.ViewColumn.to(R[D]);b.value.viewColumn!==g&&(b._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:b.value,viewColumn:g}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=y});var mn=this&&this.__rest||function(Q,e){var _={};for(var I in Q)Object.prototype.hasOwnProperty.call(Q,I)&&e.indexOf(I)<0&&(_[I]=Q[I]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(Q);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(Q,I[T])&&(_[I[T]]=Q[I[T]]);return _};define(ge[246],ve([0,1,2,4,5,6,7]),function(Q,e,_,I,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class A{constructor(R,D){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(T.MainContext.MainThreadTimeline),D.registerArgumentProcessor({processArgument:b=>{var g,s;if(b&&b.$mid===11){const d=b.uri===void 0?void 0:_.URI.revive(b.uri);return(s=(g=this._itemsBySourceAndUriMap.get(b.source))===null||g===void 0?void 0:g.get(y(d)))===null||s===void 0?void 0:s.get(b.handle)}return b}})}async $getTimeline(R,D,b,g,s){const d=this._providers.get(R);return d==null?void 0:d.provideTimeline(_.URI.revive(D),b,g,s)}registerTimelineProvider(R,D,b,g){const s=new P.DisposableStore,d=this.convertTimelineItem(D.id,g,s).bind(this);let S;D.onDidChange&&(S=D.onDidChange(E=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},E),{id:D.id})),this));const v=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},D),{scheme:R,onDidChange:void 0,async provideTimeline(E,m,l,o){var t;(o==null?void 0:o.resetCache)&&(s.clear(),(t=v.get(D.id))===null||t===void 0||t.clear());const i=await D.provideTimeline(E,m,l);if(i!=null){const a=d(E,o);return Object.assign(Object.assign({},i),{source:D.id,items:i.items.map(a)})}},dispose(){var E;for(const m of v.values())(E=m.get(D.id))===null||E===void 0||E.clear();S==null||S.dispose(),s.dispose()}}))}convertTimelineItem(R,D,b){return(g,s)=>{let d;if(s==null?void 0:s.cacheResults){let S=this._itemsBySourceAndUriMap.get(R);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(R,S));const v=y(g);d=S.get(v),d===void 0&&(d=new Map,S.set(v,d))}return S=>{var v,E;const{iconPath:m}=S,l=mn(S,["iconPath"]),o=`${R}|${(v=S.id)!==null&&v!==void 0?v:S.timestamp}`;d==null||d.set(o,S);let t,i,a;return S.iconPath&&(m instanceof C.ThemeIcon?a={id:m.id}:_.URI.isUri(m)?(t=m,i=m):{light:t,dark:i}=m),Object.assign(Object.assign({},l),{id:(E=l.id)!==null&&E!==void 0?E:void 0,handle:o,source:R,command:S.command?D.toInternal(S.command,b):void 0,icon:t,iconDark:i,themeIcon:a,accessibilityInformation:S.accessibilityInformation})}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,P.toDisposable)(()=>{var b;for(const g of this._itemsBySourceAndUriMap.values())(b=g.get(R.id))===null||b===void 0||b.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=A;function y(n){return n==null?void 0:n.toString()}}),define(ge[247],ve([0,1,6,11,2,5]),function(Q,e,_,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(y){this._openers=new Map,this._proxy=y.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,n,R,D){if(this._openers.has(n))throw new Error(`Opener with id '${n}' already registered`);const b=D.schemes.find(g=>!C.supportedSchemes.has(g));if(b)throw new Error(`Scheme '${b}' is not supported. Only http and https are currently supported.`);return this._openers.set(n,R),this._proxy.$registerUriOpener(n,D.schemes,y,D.label),(0,_.toDisposable)(()=>{this._openers.delete(n),this._proxy.$unregisterUriOpener(n)})}async $canOpenUri(y,n,R){const D=this._openers.get(y);if(!D)throw new Error(`Unknown opener with id: ${y}`);const b=T.URI.revive(n);return D.canOpenExternalUri(b,R)}async $openUri(y,n,R){const D=this._openers.get(y);if(!D)throw new Error(`Unknown opener id: '${y}'`);return D.openExternalUri(T.URI.revive(n.resolvedUri),{sourceUri:T.URI.revive(n.sourceUri)},R)}}e.ExtHostUriOpeners=C,C.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(ge[248],ve([0,1,5,2,6,18,29]),function(Q,e,_,I,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(n){this.handles=new Set,this.handlers=new Map,this._proxy=n.getProxy(_.MainContext.MainThreadUrls)}registerUriHandler(n,R){if(this.handles.has(C.ExtensionIdentifier.toKey(n)))throw new Error(`Protocol handler already registered for extension ${n}`);const D=A.HandlePool++;return this.handles.add(C.ExtensionIdentifier.toKey(n)),this.handlers.set(D,R),this._proxy.$registerUriHandler(D,n),(0,T.toDisposable)(()=>{this.handles.delete(C.ExtensionIdentifier.toKey(n)),this.handlers.delete(D),this._proxy.$unregisterUriHandler(D)})}$handleExternalUri(n,R){const D=this.handlers.get(n);if(!D)return Promise.resolve(void 0);try{D.handleUri(I.URI.revive(R))}catch(b){(0,P.onUnexpectedError)(b)}return Promise.resolve(void 0)}async createAppUri(n){return I.URI.revive(await this._proxy.$createAppUri(n))}}e.ExtHostUrls=A,A.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(Q,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(Q,_):T?T.value=_:e.set(Q,_),_},$e=this&&this.__classPrivateFieldGet||function(Q,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(Q):I?I.value:e.get(Q)};define(ge[64],ve([0,1,22,3,2,176,199,84,5]),function(Q,e,_,I,T,P,C,A,y){"use strict";var n,R,D,b,g,s,d,S,v,E,m,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(u,f,k,L,$,te,H){n.set(this,void 0),R.set(this,void 0),D.set(this,void 0),b.set(this,void 0),g.set(this,void 0),s.set(this,void 0),d.set(this,""),S.set(this,void 0),v.set(this,!1),E.set(this,!1),m.set(this,!1),this._onMessageEmitter=new I.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new I.Emitter),this._onDidDispose=$e(this,l,"f").event,tt(this,n,u,"f"),tt(this,R,f,"f"),tt(this,S,k,"f"),tt(this,b,L,"f"),tt(this,g,$,"f"),tt(this,s,te,"f"),tt(this,m,t(te),"f"),tt(this,D,H,"f")}dispose(){tt(this,v,!0,"f"),$e(this,l,"f").fire(),$e(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(u){return tt(this,E,!0,"f"),(0,A.asWebviewUri)($e(this,b,"f"),$e(this,n,"f"),u)}get cspSource(){return $e(this,b,"f").webviewCspSource.replace("{{uuid}}",$e(this,n,"f"))}get html(){return this.assertNotDisposed(),$e(this,d,"f")}set html(u){this.assertNotDisposed(),$e(this,d,"f")!==u&&(tt(this,d,u,"f"),!$e(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(u)&&(tt(this,E,!0,"f"),$e(this,D,"f").report("Webview vscode-resource: uris",$e(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),$e(this,R,"f").$setHtml($e(this,n,"f"),u))}get options(){return this.assertNotDisposed(),$e(this,S,"f")}set options(u){this.assertNotDisposed(),$e(this,R,"f").$setOptions($e(this,n,"f"),c($e(this,s,"f"),$e(this,g,"f"),u)),tt(this,S,u,"f")}async postMessage(u){if($e(this,v,"f"))return!1;const f=i(u,{serializeBuffersForPostMessage:$e(this,m,"f")});return $e(this,R,"f").$postMessage($e(this,n,"f"),f.message,...f.buffers)}assertNotDisposed(){if($e(this,v,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=o,n=new WeakMap,R=new WeakMap,D=new WeakMap,b=new WeakMap,g=new WeakMap,s=new WeakMap,d=new WeakMap,S=new WeakMap,v=new WeakMap,E=new WeakMap,m=new WeakMap,l=new WeakMap;function t(w){if(!w.enableProposedApi)return!1;try{const u=(0,P.normalizeVersion)((0,P.parseVersion)(w.engines.vscode));return!!u&&u.majorBase>=1&&u.minorBase>=56}catch(u){return!1}}e.shouldSerializeBuffersForPostMessage=t;function i(w,u){if(u.serializeBuffersForPostMessage){const f=[],k=($,te)=>{if(te&&te instanceof ArrayBuffer){let H=f.findIndex(x=>x.original===te);if(H===-1){const x=new Uint8Array(te),B=_.VSBuffer.wrap(x);H=f.length,f.push({original:te,vsBuffer:B})}return{$$vscode_array_buffer_reference$$:!0,index:H}}return te};return{message:JSON.stringify(w,k),buffers:f.map($=>$.vsBuffer)}}else return{message:JSON.stringify(w),buffers:[]}}e.serializeMessage=i;class a{constructor(u,f,k,L,$){this.initData=f,this.workspace=k,this._logService=L,this._deprecationService=$,this._webviews=new Map,this._webviewProxy=u.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(u,f,...k){const L=this.getWebview(u);if(L){const{message:$}=(0,C.deserializeWebviewMessage)(f,k);L._onMessageEmitter.fire($)}}$onMissingCsp(u,f){this._logService.warn(`${f} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(u,f,k){const L=new o(u,this._webviewProxy,h(f),this.initData,this.workspace,k,this._deprecationService);return this._webviews.set(u,L),L._onDidDispose(()=>{this._webviews.delete(u)}),L}deleteWebview(u){this._webviews.delete(u)}getWebview(u){return this._webviews.get(u)}}e.ExtHostWebviews=a;function r(w){return{id:w.identifier,location:w.extensionLocation}}e.toExtensionData=r;function c(w,u,f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots||p(w,u)}}e.serializeWebviewOptions=c;function h(w){var u;return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,portMapping:w.portMapping,localResourceRoots:(u=w.localResourceRoots)===null||u===void 0?void 0:u.map(f=>T.URI.from(f))}}e.reviveOptions=h;function p(w,u){return[...((u==null?void 0:u.getWorkspaceFolders())||[]).map(f=>f.uri),w.extensionLocation]}}),define(ge[249],ve([0,1,21,73,6,11,25,2,20,64,116,5,7]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=l(this.document.uri)+this._backupCounter++;return(0,C.joinPath)(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class s{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,a){const r=this.key(t,i.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const c=new g(i,a);return this._documents.set(r,c),c}delete(t,i){const a=this.key(t,i.uri);this._documents.delete(a)}key(t,i){return`${t}@@@${i}`}}var d;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(d||(d={}));class S{constructor(){this._providers=new Map}addTextProvider(t,i,a){return this.add(0,t,i,a)}addCustomProvider(t,i,a){return this.add(1,t,i,a)}get(t){return this._providers.get(t)}add(t,i,a,r){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:a,provider:r}),new b.Disposable(()=>this._providers.delete(i))}}class v{constructor(t,i,a,r,c){this._extHostDocuments=i,this._extensionStoragePaths=a,this._extHostWebview=r,this._extHostWebviewPanels=c,this._editorProviders=new S,this._documents=new s,this._proxy=t.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,a,r){const c=new T.DisposableStore;return E(a)?(c.add(this._editorProviders.addTextProvider(i,t,a)),this._proxy.$registerTextEditorProvider((0,n.toExtensionData)(t),i,r.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,n.shouldSerializeBuffersForPostMessage)(t))):(c.add(this._editorProviders.addCustomProvider(i,t,a)),this.supportEditing(a)&&c.add(a.onDidChangeCustomDocument(h=>{const p=this.getCustomDocumentEntry(i,h.document.uri);if(m(h)){const w=p.addEdit(h);this._proxy.$onDidEdit(h.document.uri,i,w,h.label)}else this._proxy.$onContentChange(h.document.uri,i)})),this._proxy.$registerCustomEditorProvider((0,n.toExtensionData)(t),i,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,n.shouldSerializeBuffersForPostMessage)(t))),b.Disposable.from(c,new b.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,a,r,c){var h;const p=this._editorProviders.get(i);if(!p)throw new Error(`No provider found for '${i}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${i}'`);const w=A.URI.revive(t),u=await p.provider.openCustomDocument(w,{backupId:a,untitledDocumentData:r==null?void 0:r.buffer},c);let f;return this.supportEditing(p.provider)&&this._extensionStoragePaths&&(f=(h=this._extensionStoragePaths.workspaceValue(p.extension))!==null&&h!==void 0?h:this._extensionStoragePaths.globalValue(p.extension)),this._documents.add(i,u,f),{editable:this.supportEditing(p.provider)}}async $disposeCustomDocument(t,i){const a=this._editorProviders.get(i);if(!a)throw new Error(`No provider found for '${i}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${i}'`);const r=A.URI.revive(t),{document:c}=this.getCustomDocumentEntry(i,r);this._documents.delete(i,c),c.dispose()}async $resolveWebviewEditor(t,i,a,r,c,h){const p=this._editorProviders.get(a);if(!p)throw new Error(`No provider found for '${a}'`);const w=y.ViewColumn.to(c),u=this._extHostWebview.createNewWebview(i,r.webviewOptions,p.extension),f=this._extHostWebviewPanels.createNewWebviewPanel(i,a,r.title,w,r.panelOptions,u),k=A.URI.revive(t);switch(p.type){case 1:{const{document:L}=this.getCustomDocumentEntry(a,k);return p.provider.resolveCustomEditor(L,f,h)}case 0:{const L=this._extHostDocuments.getDocument(k);return p.provider.resolveCustomTextEditor(L,f,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,a){this.getCustomDocumentEntry(i,t).disposeEdits(a)}async $onMoveCustomEditor(t,i,a){const r=this._editorProviders.get(a);if(!r)throw new Error(`No provider found for '${a}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const c=this._extHostWebviewPanels.getWebviewPanel(t);if(!c)throw new Error("No webview found");const h=A.URI.revive(i),p=this._extHostDocuments.getDocument(h);await r.provider.moveCustomTextEditor(p,c,_.CancellationToken.None)}async $undo(t,i,a,r){return this.getCustomDocumentEntry(i,t).undo(a,r)}async $redo(t,i,a,r){return this.getCustomDocumentEntry(i,t).redo(a,r)}async $revert(t,i,a){const r=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(r.document,a),r.disposeBackup()}async $onSave(t,i,a){const r=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(r.document,a),r.disposeBackup()}async $onSaveAs(t,i,a,r){const c=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(c.document,A.URI.revive(a),r)}async $backup(t,i,a){const r=this.getCustomDocumentEntry(i,t),h=await this.getCustomEditorProvider(i).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},a);return r.updateBackup(h),h.id}getCustomDocumentEntry(t,i){const a=this._documents.get(t,A.URI.revive(i));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(t){const i=this._editorProviders.get(t),a=i==null?void 0:i.provider;if(!a||!this.supportEditing(a))throw new Error("Custom document is not editable");return a}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=v;function E(o){return typeof o.resolveCustomTextEditor=="function"}function m(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function l(o){const t=o.scheme===P.Schemas.file||o.scheme===P.Schemas.untitled?o.fsPath:o.toString();return(0,I.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(Q,_):T?T.value=_:e.set(Q,_),_},$e=this&&this.__classPrivateFieldGet||function(Q,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(Q):I?I.value:e.get(Q)};define(ge[250],ve([0,1,3,6,2,28,20,64,5,7]),function(Q,e,_,I,T,P,C,A,y,n){"use strict";var R,D,b,g,s,d,S,v,E,m,l,o,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends I.Disposable{constructor(h,p,w,u,f,k,L){super();R.set(this,void 0),D.set(this,void 0),b.set(this,void 0),g.set(this,void 0),s.set(this,void 0),d.set(this,void 0),S.set(this,void 0),v.set(this,void 0),E.set(this,!0),m.set(this,!0),l.set(this,!1),o.set(this,this._register(new _.Emitter)),this.onDidDispose=$e(this,o,"f").event,t.set(this,this._register(new _.Emitter)),this.onDidChangeViewState=$e(this,t,"f").event,tt(this,R,h,"f"),tt(this,D,p,"f"),tt(this,b,w,"f"),tt(this,s,k,"f"),tt(this,v,f,"f"),tt(this,d,u,"f"),tt(this,g,L,"f")}dispose(){$e(this,l,"f")||(tt(this,l,!0,"f"),$e(this,o,"f").fire(),$e(this,D,"f").$disposeWebview($e(this,R,"f")),$e(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),$e(this,g,"f")}get viewType(){return this.assertNotDisposed(),$e(this,b,"f")}get title(){return this.assertNotDisposed(),$e(this,d,"f")}set title(h){this.assertNotDisposed(),$e(this,d,"f")!==h&&(tt(this,d,h,"f"),$e(this,D,"f").$setTitle($e(this,R,"f"),h))}get iconPath(){return this.assertNotDisposed(),$e(this,S,"f")}set iconPath(h){this.assertNotDisposed(),$e(this,S,"f")!==h&&(tt(this,S,h,"f"),$e(this,D,"f").$setIconPath($e(this,R,"f"),T.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return $e(this,s,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof $e(this,v,"f")=="number"&&$e(this,v,"f")<0))return $e(this,v,"f")}get active(){return this.assertNotDisposed(),$e(this,m,"f")}get visible(){return this.assertNotDisposed(),$e(this,E,"f")}_updateViewState(h){$e(this,l,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(tt(this,m,h.active,"f"),tt(this,E,h.visible,"f"),tt(this,v,h.viewColumn,"f"),$e(this,t,"f").fire({webviewPanel:this}))}reveal(h,p){this.assertNotDisposed(),$e(this,D,"f").$reveal($e(this,R,"f"),{viewColumn:h?C.ViewColumn.from(h):void 0,preserveFocus:!!p})}assertNotDisposed(){if($e(this,l,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,D=new WeakMap,b=new WeakMap,g=new WeakMap,s=new WeakMap,d=new WeakMap,S=new WeakMap,v=new WeakMap,E=new WeakMap,m=new WeakMap,l=new WeakMap,o=new WeakMap,t=new WeakMap;class a{constructor(h,p,w){this.webviews=p,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(h,p,w,u,f={}){const k=typeof u=="object"?u.viewColumn:u,L={viewColumn:C.ViewColumn.from(k),preserveFocus:typeof u=="object"&&!!u.preserveFocus},$=(0,A.shouldSerializeBuffersForPostMessage)(h),te=a.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(h),te,p,{title:w,panelOptions:r(f),webviewOptions:(0,A.serializeWebviewOptions)(h,this.workspace,f),serializeBuffersForPostMessage:$},L);const H=this.webviews.createNewWebview(te,f,h);return this.createNewWebviewPanel(te,p,w,k,f,H)}$onDidChangeWebviewPanelViewStates(h){const p=Object.keys(h);p.sort((w,u)=>{const f=h[w],k=h[u];return f.active?1:k.active?-1:+f.visible-+k.visible});for(const w of p){const u=this.getWebviewPanel(w);if(!!u){const f=h[w];u._updateViewState({active:f.active,visible:f.visible,viewColumn:C.ViewColumn.to(f.position)})}}}async $onDidDisposeWebviewPanel(h){const p=this.getWebviewPanel(h);p==null||p.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,p,w){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:w,extension:h}),this._proxy.$registerSerializer(p,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(h)}),new n.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(h,p,w,u){const f=this._serializers.get(p);if(!f)throw new Error(`No serializer found for '${p}'`);const{serializer:k,extension:L}=f,$=this.webviews.createNewWebview(h,w.webviewOptions,L),te=this.createNewWebviewPanel(h,p,w.title,u,w.panelOptions,$);await k.deserializeWebviewPanel(te,w.state)}createNewWebviewPanel(h,p,w,u,f,k){const L=new i(h,this._proxy,p,w,u,f,k);return this._webviewPanels.set(h,L),L}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=a;function r(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(Q,_):T?T.value=_:e.set(Q,_),_},$e=this&&this.__classPrivateFieldGet||function(Q,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(Q):I?I.value:e.get(Q)};define(ge[251],ve([0,1,3,6,64,5,7]),function(Q,e,_,I,T,P,C){"use strict";var A,y,n,R,D,b,g,s,d,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class v extends I.Disposable{constructor(l,o,t,i,a,r){super();A.set(this,void 0),y.set(this,void 0),n.set(this,void 0),R.set(this,void 0),D.set(this,!1),b.set(this,void 0),g.set(this,void 0),s.set(this,void 0),d.set(this,this._register(new _.Emitter)),this.onDidChangeVisibility=$e(this,d,"f").event,S.set(this,this._register(new _.Emitter)),this.onDidDispose=$e(this,S,"f").event,tt(this,n,t,"f"),tt(this,g,i,"f"),tt(this,A,l,"f"),tt(this,y,o,"f"),tt(this,R,a,"f"),tt(this,b,r,"f")}dispose(){$e(this,D,"f")||(tt(this,D,!0,"f"),$e(this,S,"f").fire(),$e(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),$e(this,g,"f")}set title(l){this.assertNotDisposed(),$e(this,g,"f")!==l&&(tt(this,g,l,"f"),$e(this,y,"f").$setWebviewViewTitle($e(this,A,"f"),l))}get description(){return this.assertNotDisposed(),$e(this,s,"f")}set description(l){this.assertNotDisposed(),$e(this,s,"f")!==l&&(tt(this,s,l,"f"),$e(this,y,"f").$setWebviewViewDescription($e(this,A,"f"),l))}get visible(){return $e(this,b,"f")}get webview(){return $e(this,R,"f")}get viewType(){return $e(this,n,"f")}_setVisible(l){l===$e(this,b,"f")||$e(this,D,"f")||(tt(this,b,l,"f"),$e(this,d,"f").fire())}show(l){this.assertNotDisposed(),$e(this,y,"f").$show($e(this,A,"f"),!!l)}assertNotDisposed(){if($e(this,D,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,y=new WeakMap,n=new WeakMap,R=new WeakMap,D=new WeakMap,b=new WeakMap,g=new WeakMap,s=new WeakMap,d=new WeakMap,S=new WeakMap;class E{constructor(l,o){this._extHostWebview=o,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=l.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(l,o,t,i){if(this._viewProviders.has(o))throw new Error(`View provider for '${o}' already registered`);return this._viewProviders.set(o,{provider:t,extension:l}),this._proxy.$registerWebviewViewProvider((0,T.toExtensionData)(l),o,{retainContextWhenHidden:i==null?void 0:i.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new C.Disposable(()=>{this._viewProviders.delete(o),this._proxy.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(l,o,t,i,a){const r=this._viewProviders.get(o);if(!r)throw new Error(`No view provider found for '${o}'`);const{provider:c,extension:h}=r,p=this._extHostWebview.createNewWebview(l,{},h),w=new v(l,this._proxy,o,t,p,!0);this._webviewViews.set(l,w),await c.resolveWebviewView(w,{state:i},a)}async $onDidChangeWebviewViewVisibility(l,o){this.getWebviewView(l)._setVisible(o)}async $disposeWebviewView(l){const o=this.getWebviewView(l);this._webviewViews.delete(l),o.dispose(),this._extHostWebview.deleteWebview(l)}getWebviewView(l){const o=this._webviewViews.get(l);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=E}),define(ge[125],ve([0,1,3,5,2,11,10,4,13]),function(Q,e,_,I,T,P,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let n=class Fn{constructor(D){this._onDidChangeWindowState=new _.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Fn.InitialState,this._proxy=D.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(b=>this.$onDidChangeWindowFocus(b))}get state(){return this._state}$onDidChangeWindowFocus(D){D!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:D}),this._onDidChangeWindowState.fire(this._state))}openUri(D,b){let g;if(typeof D=="string"){g=D;try{D=T.URI.parse(D)}catch(s){return Promise.reject(`Invalid uri - '${D}'`)}}return(0,C.isFalsyOrWhitespace)(D.scheme)?Promise.reject("Invalid scheme - cannot be empty"):D.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${D.scheme}'`):this._proxy.$openUri(D,g,b)}async asExternalUri(D,b){if((0,C.isFalsyOrWhitespace)(D.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([P.Schemas.http,P.Schemas.https]).has(D.scheme))return Promise.reject(`Invalid scheme '${D.scheme}'`);const g=await this._proxy.$asExternalUri(D,b);return T.URI.from(g)}};n.InitialState={focused:!0},n=je([Ue(0,y.IExtHostRpcService)],n),e.ExtHostWindow=n,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(ge[252],ve([0,1,8,48,28,51,6,5,2,13]),function(Q,e,_,I,T,P,C,A,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends C.Disposable{constructor(b,g){super();const s=b.getProxy(A.MainContext.MainThreadDownloadService);g.registerCommand(!1,"_workbench.downloadResource",async d=>{const S=y.URI.file((0,_.join)((0,I.tmpdir)(),(0,T.generateUuid)()));return await s.$download(d,S),S})}};R=je([Ue(0,n.IExtHostRpcService),Ue(1,P.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(ge[253],ve([0,1,2,8,145,26,37,63,27,13,6,12,109,44]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class s{constructor(E,m){this.file=m,this.appender=(0,b.createRotatingLogger)(E,m,30*g.ByteSize.MB,1),this.appender.clearFormatters()}append(E){this.appender.critical(E)}flush(){this.appender.flush()}}class d extends A.AbstractExtHostOutputChannel{constructor(E,m,l){super(E,!1,_.URI.file(m.file),l);this._appender=m}append(E){super.append(E),this._appender.append(E),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(E,m){this._appender.flush(),super.show(E,m)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=d;let S=class extends A.ExtHostOutputService{constructor(E,m,l){super(E);this.logService=m,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new R.MutableDisposable,this._logsLocation=l.logsLocation}$setVisibleChannel(E){if(E){const m=this._channels.get(E);m&&(this._visibleChannelDisposable.value=m.onDidAppend(()=>m.update()))}}createOutputChannel(E){if(E=E.trim(),!E)throw new Error("illegal argument `name`. must not be falsy");const m=this._doCreateOutChannel(E);return m.then(l=>l._id.then(o=>this._channels.set(o,l))),new A.LazyOutputChannel(E,m)}async _doCreateOutChannel(E){try{const m=(0,I.join)(this._logsLocation.fsPath,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await P.SymlinkSupport.existsDirectory(m)||await C.promises.mkdir(m,{recursive:!0});const o=`${this._namePool++}-${E.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=_.URI.file((0,I.join)(m,`${o}.log`)),i=new s(o,t.fsPath);return new d(E,i,this._proxy)}catch(m){return this.logService.error(m),new A.ExtHostPushOutputChannel(E,this._proxy)}}};S=je([Ue(0,n.IExtHostRpcService),Ue(1,D.ILogService),Ue(2,y.IExtHostInitDataService)],S),e.ExtHostOutputService2=S}),define(ge[254],ve([0,1,5,13,6,27,2,38,25,37,26,7,9,50,3,72,12,14]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class E{constructor(w,u,f){this.remoteAddress=w,this.localAddress=u,this._dispose=f,this._onDispose=new s.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function m(p){const w=p.trim().split(`
`),u=[];return w.forEach(k=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(k);L&&L.length>=3&&u.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),u.reduce((k,L)=>(k[L.socket]=L,k),{})}e.getSockets=m;function l(...p){const w=[].concat(...p.map(t));return[...new Map(w.filter(u=>u.st==="0A").map(u=>{const f=u.local_address.split(":");return{socket:parseInt(u.inode,10),ip:o(f[0]),port:parseInt(f[1],16)}}).map(u=>[u.ip+":"+u.port,u])).values()]}e.loadListeningPorts=l;function o(p){let w="";if(p.length===8)for(let u=p.length-2;u>=0;u-=2)w+=parseInt(p.substr(u,2),16),u!==0&&(w+=".");else for(let u=p.length-4;u>=0;u-=4)w+=parseInt(p.substr(u,4),16).toString(16),u!==0&&(w+=":");return w}e.parseIpAddress=o;function t(p){const w=p.trim().split(`
`),u=w.shift().trim().split(/\s+/).filter(k=>k!=="rx_queue"&&k!=="tm->when");return w.map(k=>k.trim().split(/\s+/).reduce((L,$,te)=>(L[u[te]||te]=$,L),{}))}e.loadConnectionTable=t;function i(p){return!!p.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||p.indexOf("out/vs/server/main.js")!==-1||p.indexOf("_productName=VSCode")!==-1}function a(p){const w=p.trim().split(`
`),u=[];return w.forEach(f=>{const k=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(f);k&&k.length>=4&&u.push({pid:parseInt(k[1],10),ppid:parseInt(k[2]),cmd:k[3]})}),u}e.getRootProcesses=a;async function r(p,w,u){const f=u.reduce((L,$)=>(L[$.pid]=$,L),{}),k=[];return p.forEach(({socket:L,ip:$,port:te})=>{var H;const x=w[L]?w[L].pid:void 0,B=x?(H=f[x])===null||H===void 0?void 0:H.cmd:void 0;x&&B&&!i(B)&&k.push({host:$,port:te,detail:B,pid:x})}),k}e.findPorts=r;function c(p,w,u){const f=new Map,k=a(w);for(const L of p){const $=u.get(L.port);if($){f.set(L.port,$);continue}const te=k.find(H=>H.cmd.includes(`${L.port}`));if(te){let H=te,x;do x=k.find(B=>B.ppid===H.pid),x&&(H=x);while(x);f.set(L.port,{host:L.ip,port:L.port,pid:H.pid,detail:H.cmd,ppid:H.ppid})}else f.set(L.port,{host:L.ip,port:L.port,ppid:Number.MAX_VALUE})}return f}e.tryFindRootPorts=c;let h=class extends T.Disposable{constructor(w,u,f){super();this.logService=f,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new s.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=w.getProxy(_.MainContext.MainThreadTunnelService),b.isLinux&&u.remote.isRemote&&u.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(w,u){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${w.identifier} called openTunnel API for ${u.remoteAddress.port}.`);const f=await this._proxy.$openTunnel(u,w.displayName);if(f){const k=new E(f.remoteAddress,f.localAddress,()=>this._proxy.$closeTunnel(f.remoteAddress));return this._register(k),k}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(w){return Math.max(w*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(w,u){const f=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(f,{selector:w,provider:u}),this._proxy.$registerPortsAttributesProvider(w,f),new D.Disposable(()=>{this._portAttributesProviders.delete(f),this._proxy.$unregisterPortsAttributesProvider(f)})}async $providePortAttributes(w,u,f,k,L){const te=(await Promise.all(w.map(H=>{const x=this._portAttributesProviders.get(H);return x?x.provider.providePortAttributes(u,f,k,L):[]}))).filter(H=>!!H&&H.length>0);return te.length>0?(0,v.flatten)(te).map(H=>({autoForwardAction:H.autoForwardAction,port:H.port})):[]}async $registerCandidateFinder(w){if(!(w&&this._candidateFindingEnabled)){this._candidateFindingEnabled=w;let u=new d.MovingAverage,f;for(;this._candidateFindingEnabled;){const k=new Date().getTime(),L=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${L.map(te=>te.port).join(", ")}`);const $=new Date().getTime()-k;u.update($),(!f||JSON.stringify(f)!==JSON.stringify(L))&&(f=L,await this._proxy.$onFoundNewCandidates(f)),await new Promise(te=>setTimeout(()=>te(),this.calculateDelay(u.value)))}}}async setTunnelExtensionFunctions(w){var u;return w?(w.candidatePortSource!==void 0&&await this._proxy.$setCandidatePortSource(w.candidatePortSource),w.showCandidatePort&&(this._showCandidatePort=w.showCandidatePort,await this._proxy.$setCandidateFilter()),w.tunnelFactory&&(this._forwardPortProvider=w.tunnelFactory,await this._proxy.$setTunnelProvider((u=w.tunnelFeatures)!==null&&u!==void 0?u:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,T.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(w,u){if(this._extensionTunnels.has(w.host)){const f=this._extensionTunnels.get(w.host);f.has(w.port)&&(u&&f.get(w.port).disposeListener.dispose(),await f.get(w.port).tunnel.dispose(),f.delete(w.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(w,u){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const f=this._forwardPortProvider(w,u);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),f!==void 0){const k=await f;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(w.remoteAddress.host)||this._extensionTunnels.set(w.remoteAddress.host,new Map);const L=this._register(k.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(k.remoteAddress))));return this._extensionTunnels.get(w.remoteAddress.host).set(w.remoteAddress.port,{tunnel:k,disposeListener:L}),g.TunnelDto.fromApiTunnel(k)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(f){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(w){const u=await Promise.all(w.map(k=>{var L;return this._showCandidatePort(k.host,k.port,(L=k.detail)!==null&&L!==void 0?L:"")})),f=w.filter((k,L)=>u[L]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${w.map(k=>k.port).join(", ")} to ${f.map(k=>k.port).join(", ")}`),f}async findCandidatePorts(){let w="",u="";try{w=await n.promises.readFile("/proc/net/tcp","utf8"),u=await n.promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const f=l(w,u),k=await new Promise(U=>{(0,A.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(M,N,O)=>{U(N)})}),L=m(k),$=await R.readdir("/proc"),te=[];for(let U of $)try{const M=Number(U),N=y.joinPath(C.URI.file("/proc"),U);if((await n.promises.stat(N.fsPath)).isDirectory()&&!isNaN(M)){const j=await n.promises.readlink(y.joinPath(N,"cwd").fsPath),q=await n.promises.readFile(y.joinPath(N,"cmdline").fsPath,"utf8");te.push({pid:M,cwd:j,cmd:q})}}catch(M){}const H=[],x=f.filter(U=>{const M=L[U.socket];return M||H.push(U),M}),B=r(x,L,te);let F;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${H.length}`),H.length>0){const U=await new Promise(M=>{(0,A.exec)("ps -F -A -l | grep root",(N,O,j)=>{M(O)})});this._foundRootPorts=c(H,U,this._foundRootPorts),F=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${F.join(", ")}`)}return B.then(U=>F?U.concat(F):U)}};h=je([Ue(0,I.IExtHostRpcService),Ue(1,P.IExtHostInitDataService),Ue(2,S.ILogService)],h),e.ExtHostTunnelService=h}),define(ge[255],ve([0,1,19,21,18,3,6,97,226,123,22]),function(Q,e,_,I,T,P,C,A,y,n,R){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function b(r,c){try{return JSON.stringify(r,c)}catch(h){return"null"}}function g(r,c){return JSON.stringify(r,c)}function s(r){return r?(c,h)=>h&&h.$mid===1?r.transformOutgoing(h):h:null}var d;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const v=()=>{},E=Symbol.for("rpcProtocol"),m=Symbol.for("rpcProxy");class l extends C.Disposable{constructor(c,h=null,p=null){super();this[D]=!0,this._onDidChangeResponsiveState=this._register(new P.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=c,this._logger=h,this._uriTransformer=p,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let w=0,u=n.ProxyIdentifier.count;w<u;w++)this._locals[w]=null,this._proxies[w]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new _.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(w=>this._receiveOneMessage(w))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(c=>{this._pendingRPCReplies[c].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(c){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(c){this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(c){this._responsiveState!==c&&(this._responsiveState=c,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(c){return this._uriTransformer?(0,A.transformIncomingURIs)(c,this._uriTransformer):c}getProxy(c){const{nid:h,sid:p}=c;return this._proxies[h]||(this._proxies[h]=this._createProxy(h,p)),this._proxies[h]}_createProxy(c,h){let p={get:(w,u)=>(typeof u=="string"&&!w[u]&&u.charCodeAt(0)===36&&(w[u]=(...f)=>this._remoteCall(c,u,f)),u===m?h:w[u])};return new Proxy(Object.create(null),p)}set(c,h){return this._locals[c.nid]=h,h}assertRegistered(c){for(let h=0,p=c.length;h<p;h++){const w=c[h];if(!this._locals[w.nid])throw new Error(`Missing actor ${w.sid} (isMain: ${w.isMain})`)}}_receiveOneMessage(c){if(!this._isDisposed){const h=c.byteLength,p=o.read(c,0),w=p.readUInt8(),u=p.readUInt32();switch(w){case 1:case 2:{let{rpcId:f,method:k,args:L}=t.deserializeRequestJSONArgs(p);this._uriTransformer&&(L=(0,A.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(h,u,f,k,L,w===2);break}case 3:case 4:{let{rpcId:f,method:k,args:L}=t.deserializeRequestMixedArgs(p);this._uriTransformer&&(L=(0,A.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(h,u,f,k,L,w===4);break}case 5:{this._logger&&this._logger.logIncoming(h,u,0,"ack"),this._onDidReceiveAcknowledge(u);break}case 6:{this._receiveCancel(h,u);break}case 7:{this._receiveReply(h,u,void 0);break}case 9:{let f=t.deserializeReplyOKJSON(p);this._uriTransformer&&(f=(0,A.transformIncomingURIs)(f,this._uriTransformer)),this._receiveReply(h,u,f);break}case 8:{let f=t.deserializeReplyOKVSBuffer(p);this._receiveReply(h,u,f);break}case 10:{let f=t.deserializeReplyErrError(p);this._uriTransformer&&(f=(0,A.transformIncomingURIs)(f,this._uriTransformer)),this._receiveReplyErr(h,u,f);break}case 11:{this._receiveReplyErr(h,u,void 0);break}default:console.error("received unexpected message"),console.error(c)}}}_receiveRequest(c,h,p,w,u,f){this._logger&&this._logger.logIncoming(c,h,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(p)}.${w}(`,u);const k=String(h);let L,$;if(f){const H=new I.CancellationTokenSource;u.push(H.token),L=this._invokeHandler(p,w,u),$=()=>H.cancel()}else L=this._invokeHandler(p,w,u),$=v;this._cancelInvokedHandlers[k]=$;const te=t.serializeAcknowledged(h);this._logger&&this._logger.logOutgoing(te.byteLength,h,1,"ack"),this._protocol.send(te),L.then(H=>{delete this._cancelInvokedHandlers[k];const x=t.serializeReplyOK(h,H,this._uriReplacer);this._logger&&this._logger.logOutgoing(x.byteLength,h,1,"reply:",H),this._protocol.send(x)},H=>{delete this._cancelInvokedHandlers[k];const x=t.serializeReplyErr(h,H);this._logger&&this._logger.logOutgoing(x.byteLength,h,1,"replyErr:",H),this._protocol.send(x)})}_receiveCancel(c,h){this._logger&&this._logger.logIncoming(c,h,1,"receiveCancel");const p=String(h);this._cancelInvokedHandlers[p]&&this._cancelInvokedHandlers[p]()}_receiveReply(c,h,p){this._logger&&this._logger.logIncoming(c,h,0,"receiveReply:",p);const w=String(h);if(!!this._pendingRPCReplies.hasOwnProperty(w)){const u=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w],u.resolveOk(p)}}_receiveReplyErr(c,h,p){this._logger&&this._logger.logIncoming(c,h,0,"receiveReplyErr:",p);const w=String(h);if(!!this._pendingRPCReplies.hasOwnProperty(w)){const u=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w];let f;p&&(p.$isError?(f=new Error,f.name=p.name,f.message=p.message,f.stack=p.stack):f=p),u.resolveErr(f)}}_invokeHandler(c,h,p){try{return Promise.resolve(this._doInvokeHandler(c,h,p))}catch(w){return Promise.reject(w)}}_doInvokeHandler(c,h,p){const w=this._locals[c];if(!w)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(c));let u=w[h];if(typeof u!="function")throw new Error("Unknown method "+h+" on actor "+(0,n.getStringIdentifierForProxy)(c));return u.apply(w,p)}_remoteCall(c,h,p){if(this._isDisposed)return Promise.reject(T.canceled());let w=null;if(p.length>0&&I.CancellationToken.isCancellationToken(p[p.length-1])&&(w=p.pop()),w&&w.isCancellationRequested)return Promise.reject(T.canceled());const u=t.serializeRequestArguments(p,this._uriReplacer),f=++this._lastMessageId,k=String(f),L=new y.LazyPromise;w&&w.onCancellationRequested(()=>{const te=t.serializeCancel(f);this._logger&&this._logger.logOutgoing(te.byteLength,f,0,"cancel"),this._protocol.send(t.serializeCancel(f))}),this._pendingRPCReplies[k]=L,this._onWillSendRequest(f);const $=t.serializeRequest(f,c,h,u,!!w);return this._logger&&this._logger.logOutgoing($.byteLength,f,0,`request: ${(0,n.getStringIdentifierForProxy)(c)}.${h}(`,p),this._protocol.send($),L}}e.RPCProtocol=l,D=E,l.UNRESPONSIVE_TIME=3*1e3;class o{constructor(c,h){this._buff=c,this._offset=h}static alloc(c,h,p){let w=new o(R.VSBuffer.alloc(p+1+4),0);return w.writeUInt8(c),w.writeUInt32(h),w}static read(c,h){return new o(c,h)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(c){this._buff.writeUInt8(c,this._offset),this._offset+=1}readUInt8(){const c=this._buff.readUInt8(this._offset);return this._offset+=1,c}writeUInt32(c){this._buff.writeUInt32BE(c,this._offset),this._offset+=4}readUInt32(){const c=this._buff.readUInt32BE(this._offset);return this._offset+=4,c}static sizeShortString(c){return 1+c.byteLength}writeShortString(c){this._buff.writeUInt8(c.byteLength,this._offset),this._offset+=1,this._buff.set(c,this._offset),this._offset+=c.byteLength}readShortString(){const c=this._buff.readUInt8(this._offset);this._offset+=1;const p=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,p}static sizeLongString(c){return 4+c.byteLength}writeLongString(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readLongString(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,p}writeBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}static sizeVSBuffer(c){return 4+c.byteLength}writeVSBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readVSBuffer(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const h=this._buff.slice(this._offset,this._offset+c);return this._offset+=c,h}static sizeMixedArray(c,h){let p=0;p+=1;for(let w=0,u=c.length;w<u;w++){const f=c[w],k=h[w];switch(p+=1,k){case 1:p+=this.sizeLongString(f);break;case 2:p+=this.sizeVSBuffer(f);break;case 3:break}}return p}writeMixedArray(c,h){this._buff.writeUInt8(c.length,this._offset),this._offset+=1;for(let p=0,w=c.length;p<w;p++){const u=c[p];switch(h[p]){case 1:this.writeUInt8(1),this.writeLongString(u);break;case 2:this.writeUInt8(2),this.writeVSBuffer(u);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const c=this._buff.readUInt8(this._offset);this._offset+=1;let h=new Array(c);for(let p=0;p<c;p++)switch(this.readUInt8()){case 1:h[p]=this.readLongString();break;case 2:h[p]=this.readVSBuffer();break;case 3:h[p]=void 0;break}return h}}class t{static _arrayContainsBufferOrUndefined(c){for(let h=0,p=c.length;h<p;h++)if(c[h]instanceof R.VSBuffer||typeof c[h]=="undefined")return!0;return!1}static serializeRequestArguments(c,h){if(this._arrayContainsBufferOrUndefined(c)){let p=[],w=[];for(let u=0,f=c.length;u<f;u++){const k=c[u];k instanceof R.VSBuffer?(p[u]=k,w[u]=2):typeof k=="undefined"?(p[u]=R.VSBuffer.alloc(0),w[u]=3):(p[u]=R.VSBuffer.fromString(g(k,h)),w[u]=1)}return{type:"mixed",args:p,argsType:w}}return{type:"simple",args:g(c,h)}}static serializeRequest(c,h,p,w,u){return w.type==="mixed"?this._requestMixedArgs(c,h,p,w.args,w.argsType,u):this._requestJSONArgs(c,h,p,w.args,u)}static _requestJSONArgs(c,h,p,w,u){const f=R.VSBuffer.fromString(p),k=R.VSBuffer.fromString(w);let L=0;L+=o.sizeUInt8(),L+=o.sizeShortString(f),L+=o.sizeLongString(k);let $=o.alloc(u?2:1,c,L);return $.writeUInt8(h),$.writeShortString(f),$.writeLongString(k),$.buffer}static deserializeRequestJSONArgs(c){const h=c.readUInt8(),p=c.readShortString(),w=c.readLongString();return{rpcId:h,method:p,args:JSON.parse(w)}}static _requestMixedArgs(c,h,p,w,u,f){const k=R.VSBuffer.fromString(p);let L=0;L+=o.sizeUInt8(),L+=o.sizeShortString(k),L+=o.sizeMixedArray(w,u);let $=o.alloc(f?4:3,c,L);return $.writeUInt8(h),$.writeShortString(k),$.writeMixedArray(w,u),$.buffer}static deserializeRequestMixedArgs(c){const h=c.readUInt8(),p=c.readShortString(),w=c.readMixedArray(),u=new Array(w.length);for(let f=0,k=w.length;f<k;f++){const L=w[f];typeof L=="string"?u[f]=JSON.parse(L):u[f]=L}return{rpcId:h,method:p,args:u}}static serializeAcknowledged(c){return o.alloc(5,c,0).buffer}static serializeCancel(c){return o.alloc(6,c,0).buffer}static serializeReplyOK(c,h,p){return typeof h=="undefined"?this._serializeReplyOKEmpty(c):h instanceof R.VSBuffer?this._serializeReplyOKVSBuffer(c,h):this._serializeReplyOKJSON(c,b(h,p))}static _serializeReplyOKEmpty(c){return o.alloc(7,c,0).buffer}static _serializeReplyOKVSBuffer(c,h){let p=0;p+=o.sizeVSBuffer(h);let w=o.alloc(8,c,p);return w.writeVSBuffer(h),w.buffer}static deserializeReplyOKVSBuffer(c){return c.readVSBuffer()}static _serializeReplyOKJSON(c,h){const p=R.VSBuffer.fromString(h);let w=0;w+=o.sizeLongString(p);let u=o.alloc(9,c,w);return u.writeLongString(p),u.buffer}static deserializeReplyOKJSON(c){const h=c.readLongString();return JSON.parse(h)}static serializeReplyErr(c,h){return h?this._serializeReplyErrEror(c,h):this._serializeReplyErrEmpty(c)}static _serializeReplyErrEror(c,h){const p=R.VSBuffer.fromString(b(T.transformErrorForSerialization(h),null));let w=0;w+=o.sizeLongString(p);let u=o.alloc(10,c,w);return u.writeLongString(p),u.buffer}static deserializeReplyErrError(c){const h=c.readLongString();return JSON.parse(h)}static _serializeReplyErrEmpty(c){return o.alloc(11,c,0).buffer}}var i;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var a;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(a||(a={}))}),define(ge[256],ve([0,1,4]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,_.createDecorator)("remoteAgentService")}),define(ge[257],ve([0,1,11,8,9,2,4,256]),function(Q,e,_,I,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,C.createDecorator)("pathService");let y=class{constructor(R,D){this.localUserHome=R,this.remoteAgentService=D,this.resolveOS=(async()=>{const b=await this.remoteAgentService.getEnvironment();return(b==null?void 0:b.os)||T.OS})(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(b==null?void 0:b.userHome)||R})()}async userHome(R){return(R==null?void 0:R.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(R=>R===1?I.win32:I.posix)}async fileURI(R){let D="";if(await this.resolveOS===1&&(R=R.replace(/\\/g,"/")),R[0]==="/"&&R[1]==="/"){const g=R.indexOf("/",2);g===-1?(D=R.substring(2),R="/"):(D=R.substring(2,g),R=R.substring(g)||"/")}return P.URI.from({scheme:_.Schemas.file,authority:D,path:R,query:"",fragment:""})}};y=je([Ue(1,A.IRemoteAgentService)],y),e.AbstractPathService=y}),define(ge[32],ve([0,1,14,34,23,31,10,4,8,18]),function(Q,e,_,I,T,P,C,A,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const R="\u27EA ",D=" characters skipped \u27EB",b=(R.length+D.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var g;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(g=e.SearchProviderType||(e.SearchProviderType={}));var s;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(s=e.QueryType||(e.QueryType={}));function d(F){return!!F.preview}e.resultIsMatch=d;function S(F){return!!F.resource}e.isFileMatch=S;function v(F){return!!F.message}e.isProgressMessage=v;var E;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(E=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(U){this.resource=U,this.results=[]}}e.FileMatch=m;class l{constructor(U,M,N){this.ranges=M;const O=Array.isArray(M)?M:[M];if(N&&N.matchLines===1&&o(O)){U=(0,C.getNLines)(U,N.matchLines);let j="",q=0,X=0;const me=Math.floor(N.charsPerLine/5),we=[];for(const Ae of O){const Ie=Math.max(Ae.startColumn-me,0),Me=Ae.startColumn+N.charsPerLine;if(Ie>X+me+b){const V=R+(Ie-X)+D;j+=V+U.slice(Ie,Me),q+=Ie-(X+V.length)}else j+=U.slice(X,Me);we.push(new i(0,Ae.startColumn-q,Ae.endColumn-q)),X=Me}this.preview={text:j,matches:Array.isArray(this.ranges)?we:we[0]}}else{const j=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:U,matches:(0,_.mapArrayOrNot)(M,q=>new t(q.startLineNumber-j,q.startColumn,q.endLineNumber-j,q.endColumn))}}}}e.TextSearchMatch=l;function o(F){const U=F[0].startLineNumber;for(const M of F)if(M.startLineNumber!==U||M.endLineNumber!==U)return!1;return!0}class t{constructor(U,M,N,O){this.startLineNumber=U,this.startColumn=M,this.endLineNumber=N,this.endColumn=O}}e.SearchRange=t;class i extends t{constructor(U,M,N){super(U,M,U,N)}}e.OneLineRange=i;var a;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(a=e.SearchSortOrder||(e.SearchSortOrder={}));function r(F,U=!0){const M=F&&F.files&&F.files.exclude,N=U&&F&&F.search&&F.search.exclude;if(!(!M&&!N)){if(!M||!N)return M||N;let O=Object.create(null);return O=T.mixin(O,T.deepClone(M)),O=T.mixin(O,T.deepClone(N),!0),O}}e.getExcludes=r;function c(F,U){return F.excludePattern&&I.match(F.excludePattern,U)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&I.match(F.includePattern,U)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(M=>{const N=M.folder.fsPath;if(P.isEqualOrParent(U,N)){const O=y.relative(N,U);return!M.includePattern||!!I.match(M.includePattern,O)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var h;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class p extends Error{constructor(U,M){super(U);this.code=M}}e.SearchError=p;function w(F){const U=F.message;if((0,n.isPromiseCanceledError)(F))return new p(U,h.canceled);try{const M=JSON.parse(U);return new p(M.message,M.code)}catch(M){return new p(U,h.other)}}e.deserializeSearchError=w;function u(F){const U={message:F.message,code:F.code};return new Error(JSON.stringify(U))}e.serializeSearchError=u;function f(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=f;function k(F){return F.type==="success"}e.isSerializedSearchSuccess=k;function L(F){return!!F.path}e.isSerializedFileMatch=L;function $(F,U){const M=F.searchPath?F.searchPath:F.relativePath;return(0,C.fuzzyContains)(M,U)}e.isFilePatternMatch=$;class te{constructor(U){this.path=U,this.results=[]}addMatch(U){this.results.push(U)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=te;function H(F,U){const M=Object.assign(Object.assign({},F||{}),U||{});return Object.keys(M).filter(N=>{const O=M[N];return typeof O=="boolean"&&O})}e.resolvePatternsForProvider=H;class x{constructor(U,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},U.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=I.parse(this._excludeExpression);let N=U.includePattern;M.includePattern&&(N?N=Object.assign(Object.assign({},N),M.includePattern):N=M.includePattern),N&&(this._parsedIncludeExpression=I.parse(N))}includedInQuerySync(U,M,N){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(U,M,N)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(U,M,N))}includedInQuery(U,M,N){return Promise.resolve(this._parsedExcludeExpression(U,M,N)).then(j=>!!j).then(j=>j?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(U,M,N)).then(q=>!!q):Promise.resolve(!0)).then(j=>j)}hasSiblingExcludeClauses(){return B(this._excludeExpression)}}e.QueryGlobTester=x;function B(F){for(const U in F)if(typeof F[U]!="boolean")return!0;return!1}}),define(ge[33],ve([0,1,14,19,21,3,24,11,72,25,10,15,2,166,4,12,185,59,60,27,13,7,32,5]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d,S,v,E,m,l,o,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(k,L,$){return new n.ExtUri(te=>p(te,$)).isEqual(k,L)}function r(k,L,$){return a(k.uri,L.uri,$)?0:(0,R.compare)(k.uri.toString(),L.uri.toString())}function c(k,L,$){return k.index!==L.index?k.index<L.index?-1:1:a(k.uri,L.uri,$)?(0,R.compare)(k.name,L.name):(0,R.compare)(k.uri.toString(),L.uri.toString())}function h(k,L,$,te){const H=k.slice(0).sort((B,F)=>$(B,F,te)),x=L.slice(0).sort((B,F)=>$(B,F,te));return(0,_.delta)(H,x,(B,F)=>$(B,F,te))}function p(k,L){const $=L.getCapabilities(k.scheme);return!($&&$&1024)}class w extends v.Workspace{constructor(L,$,te,H,x,B){super(L,te.map(F=>new v.WorkspaceFolder(F)),H,B);this._name=$,this._isUntitled=x,this._workspaceFolders=[],this._structure=C.TernarySearchTree.forUris(B),te.forEach(F=>{this._workspaceFolders.push(F),this._structure.set(F.uri,F)})}static toExtHostWorkspace(L,$,te,H){if(!L)return{workspace:null,added:[],removed:[]};const{id:x,name:B,folders:F,configuration:U,isUntitled:M}=L,N=[],O=$;$?F.forEach((me,we)=>{const Ae=b.URI.revive(me.uri),Ie=w._findFolder(te||$,Ae,H);Ie?(Ie.name=me.name,Ie.index=me.index,N.push(Ie)):N.push({uri:Ae,name:me.name,index:we})}):N.push(...F.map(({uri:me,name:we,index:Ae})=>({uri:b.URI.revive(me),name:we,index:Ae}))),N.sort((me,we)=>me.index<we.index?-1:1);const j=new w(x,B,N,U?b.URI.revive(U):null,!!M,me=>p(me,H)),{added:q,removed:X}=h(O?O.workspaceFolders:[],j.workspaceFolders,r,H);return{workspace:j,added:q,removed:X}}static _findFolder(L,$,te){for(let H=0;H<L.folders.length;H++){const x=L.workspaceFolders[H];if(a(x.uri,$,te))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,$){return $&&this._structure.get(L)&&(L=(0,n.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let u=class{constructor(L,$,te,H){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidChangeWorkspaceTrustState=new P.Emitter,this.onDidChangeWorkspaceTrustState=this._onDidChangeWorkspaceTrustState.event,this._activeSearchCallbacks=[],this._workspaceTrustState=o.WorkspaceTrustState.Unspecified,this._logService=H,this._extHostFileSystemInfo=te,this._requestIdProvider=new y.Counter,this._barrier=new I.Barrier,this._proxy=L.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(i.MainContext.MainThreadMessageService);const x=$.workspace;this._confirmedWorkspace=x?new w(x.id,x.name,[],x.configuration?b.URI.revive(x.configuration):null,!!x.isUntitled,B=>p(B,te)):void 0}$initializeWorkspace(L,$){this._workspaceTrustState=$,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?b.URI.from({scheme:A.Schemas.untitled,path:(0,n.basename)((0,n.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,$,te,...H){const x=[];if(Array.isArray(H)&&H.forEach(N=>{b.URI.isUri(N.uri)&&!x.some(O=>a(O.uri,N.uri,this._extHostFileSystemInfo))&&x.push({uri:N.uri,name:N.name||(0,n.basenameOrAuthority)(N.uri)})}),this._unconfirmedWorkspace||[$,te].some(N=>typeof N!="number"||N<0)||te===0&&x.length===0)return!1;const B=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+te>B.length)return!1;const F=B.slice(0);F.splice($,te,...x.map(N=>({uri:N.uri,name:N.name||(0,n.basenameOrAuthority)(N.uri),index:void 0})));for(let N=0;N<F.length;N++){const O=F[N];if(F.some((j,q)=>q!==N&&a(O.uri,j.uri,this._extHostFileSystemInfo)))return!1}F.forEach((N,O)=>N.index=O);const{added:U,removed:M}=h(B,F,c,this._extHostFileSystemInfo);if(U.length===0&&M.length===0)return!1;if(this._proxy){const N=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(N,$,te,x).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,(0,g.localize)(0,null,N,O.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(F),!0}getWorkspaceFolder(L,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,$)}async getWorkspaceFolder2(L,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,$)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!!this._actualWorkspace){const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}}getRelativePath(L,$){let te,H="";if(typeof L=="string"?(te=b.URI.file(L),H=L):typeof L!="undefined"&&(te=L,H=L.fsPath),!te)return H;const x=this.getWorkspaceFolder(te,!0);if(!x)return H;typeof $=="undefined"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let B=(0,n.relativePath)(x.uri,te);return $&&x.name&&(B=`${x.name}/${B}`),B}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:$,added:te,removed:H}=w.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:te,removed:H}))}findFiles(L,$,te,H,x=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${H.value}, entryPoint: findFiles`);let B;if($===null?B=!1:$&&(typeof $=="string"?B=$:B=$.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:F,folder:U}=f(L);return this._proxy.$startFileSearch((0,D.withUndefinedAsNull)(F),(0,D.withUndefinedAsNull)(U),(0,D.withUndefinedAsNull)(B),(0,D.withUndefinedAsNull)(te),x).then(M=>Array.isArray(M)?M.map(N=>b.URI.revive(N)):[])}async findTextInFiles(L,$,te,H,x=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${H.value}, entryPoint: findTextInFiles`);const B=this._requestIdProvider.getNext(),F=typeof $.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:U,folder:M}=f($.include),N=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,O={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:F,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:U,excludePattern:N},j=!1;if(this._activeSearchCallbacks[B]=q=>{if(!j){const X=b.URI.revive(q.resource);q.results.forEach(me=>{(0,t.resultIsMatch)(me)?te({uri:X,preview:{text:me.preview.text,matches:(0,_.mapArrayOrNot)(me.preview.matches,we=>new o.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,_.mapArrayOrNot)(me.ranges,we=>new o.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):te({uri:X,text:me.text,lineNumber:me.lineNumber})})}},x.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(L,(0,D.withUndefinedAsNull)(M),O,B,x);return delete this._activeSearchCallbacks[B],q||{}}catch(q){throw delete this._activeSearchCallbacks[B],q}}$handleTextSearchResult(L,$){this._activeSearchCallbacks[$]&&this._activeSearchCallbacks[$](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trustState(){return this._workspaceTrustState}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidChangeWorkspaceTrustState(L){this._workspaceTrustState=L.currentTrustState,this._onDidChangeWorkspaceTrustState.fire(Object.freeze({newTrustState:L.currentTrustState}))}};u=je([Ue(0,l.IExtHostRpcService),Ue(1,m.IExtHostInitDataService),Ue(2,E.IExtHostFileSystemInfo),Ue(3,d.ILogService)],u),e.ExtHostWorkspace=u,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function f(k){let L,$;return k&&(typeof k=="string"?L=k:(L=k.pattern,$=k.baseFolder||b.URI.file(k.base))),{includePattern:L,folder:$}}}),define(ge[36],ve([0,1,23,3,33,5,7,187,82,15,19,4,13,12,2]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(i,a){if(a){const r=a.split(".");let c=i;for(let h=0;c&&h<r.length;h++)c=c[r[h]];return c}}function S(i){return i instanceof s.URI}function v(i){return i&&i.uri instanceof s.URI&&i.languageId&&typeof i.languageId=="string"}function E(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function m(i){return i&&i.uri instanceof s.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function l(i){if(S(i))return{resource:i};if(v(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(E(i))return{overrideIdentifier:i.languageId};if(m(i))return{resource:i.uri};if(i===null)return{resource:null}}let o=class{constructor(a,r,c){this._proxy=a.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=c,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new t(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,r){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(a,r))}};o=je([Ue(0,b.IExtHostRpcService),Ue(1,T.IExtHostWorkspace),Ue(2,g.ILogService)],o),e.ExtHostConfiguration=o;class t{constructor(a,r,c,h){this._onDidChangeConfiguration=new I.Emitter,this._proxy=a,this._logService=h,this._extHostWorkspace=r,this._configuration=A.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,r){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,c))}getConfiguration(a,r,c){const h=l(r)||{},p=this._toReadonlyValue(a?d(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,h,c==null?void 0:c.identifier);function w(f){if(f==null)return null;if(typeof f=="boolean")return f?1:4;switch(f){case C.ConfigurationTarget.Global:return 1;case C.ConfigurationTarget.Workspace:return 4;case C.ConfigurationTarget.WorkspaceFolder:return 5}}const u={has(f){return typeof d(p,f)!="undefined"},get:(f,k)=>{this._validateConfigurationAccess(a?`${a}.${f}`:f,h,c==null?void 0:c.identifier);let L=d(p,f);if(typeof L=="undefined")L=k;else{let $;const te=(H,x)=>{let B;const F=()=>{$=$||(0,_.deepClone)(p),B=B||d($,x)};return(0,n.isObject)(H)?new Proxy(H,{get:(U,M)=>{if(typeof M=="string"&&M.toLowerCase()==="tojson")return F(),()=>B;if($)return B=B||d($,x),B[M];const N=U[M];return typeof M=="string"?te(N,`${x}.${M}`):N},set:(U,M,N)=>(F(),B&&(B[M]=N),!0),deleteProperty:(U,M)=>(F(),B&&delete B[M],!0),defineProperty:(U,M,N)=>(F(),B&&Object.defineProperty(B,M,N),!0)}):H};L=te(L,f)}return L},update:(f,k,L,$)=>{f=a?`${a}.${f}`:f;const te=w(L);return k!==void 0?this._proxy.$updateConfigurationOption(te,f,k,h,$):this._proxy.$removeConfigurationOption(te,f,h,$)},inspect:f=>{var k,L,$,te,H,x,B,F;f=a?`${a}.${f}`:f;const U=(0,_.deepClone)(this._configuration.inspect(f,h,this._extHostWorkspace.workspace));if(U)return{key:f,defaultValue:(k=U.default)===null||k===void 0?void 0:k.value,globalValue:(L=U.user)===null||L===void 0?void 0:L.value,workspaceValue:($=U.workspace)===null||$===void 0?void 0:$.value,workspaceFolderValue:(te=U.workspaceFolder)===null||te===void 0?void 0:te.value,defaultLanguageValue:(H=U.default)===null||H===void 0?void 0:H.override,globalLanguageValue:(x=U.user)===null||x===void 0?void 0:x.override,workspaceLanguageValue:(B=U.workspace)===null||B===void 0?void 0:B.override,workspaceFolderLanguageValue:(F=U.workspaceFolder)===null||F===void 0?void 0:F.override,languageIds:U.overrideIdentifiers}}};return typeof p=="object"&&(0,_.mixin)(u,p,!1),Object.freeze(u)}_toReadonlyValue(a){const r=c=>(0,n.isObject)(c)?new Proxy(c,{get:(h,p)=>r(h[p]),set:(h,p,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(h,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(h,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return r(a)}_validateConfigurationAccess(a,r,c){const h=y.OVERRIDE_PROPERTY_PATTERN.test(a)?4:this._configurationScopes.get(a),p=c?`[${c.value}] `:"";if(h===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){(r==null?void 0:r.resource)&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,r){const c=new A.ConfigurationChangeEvent(a,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,p)=>c.affectsConfiguration(h,l(p))})}_toMap(a){return a.reduce((r,c)=>(r.set(c[0],c[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(Q,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(Q,_):T?T.value=_:e.set(Q,_),_},$e=this&&this.__classPrivateFieldGet||function(Q,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(Q):I?I.value:e.get(Q)};define(ge[65],ve([0,1,2,19,3,5,7,33,39,36,21,35,13,27,4,11,9,12,62,208,18]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d,S,v,E,m,l){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(H){function x(F){if(F!=null)return F}H.from=x;function B(F){if(F!=null)return F}H.to=B})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(H){function x(F){if(F!=null)return F}H.from=x;function B(F){if(F!=null)return F}H.to=B})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var a;(function(H){function x(F){if(F!=null)return F}H.from=x;function B(F){if(F!=null)return F}H.to=B})(a=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(H){function x(U){if(U){const M=U;return M&&!!M.process}else return!1}H.is=x;function B(U){if(U!=null){const M={process:U.process,args:U.args};return U.options&&(M.options=a.from(U.options)),M}}H.from=B;function F(U){if(U!=null)return new C.ProcessExecution(U.process,U.args,U.options)}H.to=F})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var c;(function(H){function x(F){if(F!=null)return F}H.from=x;function B(F){if(F!=null)return F}H.to=B})(c=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var h;(function(H){function x(U){if(U){const M=U;return M&&(!!M.commandLine||!!M.command)}else return!1}H.is=x;function B(U){if(U!=null){const M={};return U.commandLine!==void 0?M.commandLine=U.commandLine:(M.command=U.command,M.args=U.args),U.options&&(M.options=c.from(U.options)),M}}H.from=B;function F(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new C.ShellExecution(U.commandLine,U.options):new C.ShellExecution(U.command,U.args?U.args:[],U.options)}H.to=F})(h=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(H){function x(U){if(U){let M=U;return M&&M.customExecution==="customExecution"}else return!1}H.is=x;function B(U){return{customExecution:"customExecution"}}H.from=B;function F(U,M){return M.get(U)}H.to=F})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var w;(function(H){function x(B,F){let U;return B.scope!==void 0&&typeof B.scope!="number"?U=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===C.TaskScope.Workspace&&F&&F.workspaceFile?U=F.workspaceFile:U=m.USER_TASKS_GROUP_KEY),{id:B._id,workspaceFolder:U}}H.from=x})(w=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function(H){function x(U,M){if(U==null)return[];const N=[];for(let O of U){const j=B(O,M);j&&N.push(j)}return N}H.fromMany=x;function B(U,M){if(U!=null){let N;U.execution instanceof C.ProcessExecution?N=r.from(U.execution):U.execution instanceof C.ShellExecution?N=h.from(U.execution):U.execution&&U.execution instanceof C.CustomExecution&&(N=p.from(U.execution));const O=t.from(U.definition);let j;if(U.scope?typeof U.scope=="number"?j=U.scope:j=U.scope.uri:j=C.TaskScope.Workspace,!(!O||!j)){const q=U.group?U.group.id:void 0;return{_id:U._id,definition:O,name:U.name,source:{extensionId:M.identifier.value,label:U.source,scope:j},execution:N,isBackground:U.isBackground,group:q,presentationOptions:i.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}}}H.from=B;async function F(U,M,N){if(U!=null){let O;r.is(U.execution)?O=r.to(U.execution):h.is(U.execution)?O=h.to(U.execution):p.is(U.execution)&&(O=p.to(U._id,N));const j=t.to(U.definition);let q;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?q=U.source.scope:q=await M.resolveWorkspaceFolder(_.URI.revive(U.source.scope)):q=C.TaskScope.Workspace),!(!j||!q)){const X=new C.Task(j,q,U.name,U.source.label,O,U.problemMatchers);return U.isBackground!==void 0&&(X.isBackground=U.isBackground),U.group!==void 0&&(X.group=C.TaskGroup.from(U.group)),U.presentationOptions&&(X.presentationOptions=i.to(U.presentationOptions)),U._id&&(X._id=U._id),U.detail&&(X.detail=U.detail),X}}}H.to=F})(u=e.TaskDTO||(e.TaskDTO={}));var f;(function(H){function x(F){return F}H.from=x;function B(F){if(!!F)return Object.assign(Object.create(null),F)}H.to=B})(f=e.TaskFilterDTO||(e.TaskFilterDTO={}));class k{constructor(x,B,F){this._id=B,this._task=F,o.set(this,void 0),tt(this,o,x,"f")}get task(){return this._task}terminate(){$e(this,o,"f").terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}o=new WeakMap;var L;(function(H){function x(B){return{id:B._id,task:void 0}}H.from=x})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let $=class{constructor(x,B,F,U,M,N,O,j){this._onDidExecuteTask=new T.Emitter,this._onDidTerminateTask=new T.Emitter,this._onDidTaskProcessStarted=new T.Emitter,this._onDidTaskProcessEnded=new T.Emitter,this._proxy=x.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=F,this._editorService=U,this._configurationService=M,this._terminalService=N,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=O,this._deprecationService=j,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,B,F){if(!F)return new C.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:B,provider:F,extension:x}),this._proxy.$registerTaskProvider(U,B),new C.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(x,B){this._proxy.$registerTaskSystem(x,B)}fetchTasks(x){return this._proxy.$fetchTasks(f.from(x)).then(async B=>{const F=[];for(let U of B){const M=await u.to(U,this._workspaceProvider,this._providedCustomExecutions2);M&&F.push(M)}return F})}get taskExecutions(){const x=[];return this._taskExecutions.forEach(B=>x.push(B)),x}terminateTask(x){if(!(x instanceof k))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,B,F){const U=this._providedCustomExecutions2.get(x.id);if(U){if(this._activeCustomExecutions2.get(x.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(x.id,U),this._terminalService.attachPtyToTerminal(B,await U.callback(F))}this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const B=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:B})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const B=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:B,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const B=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:B,exitCode:x.exitCode})}$provideTasks(x,B){const F=this._handlers.get(x);if(!F)return Promise.reject(new Error("no handler found"));const U=[],M=(0,I.asPromise)(()=>F.provider.provideTasks(R.CancellationToken.None)).then(N=>this.provideTasksInternal(B,U,F,N));return new Promise(N=>{M.then(O=>{Promise.all(U).then(()=>{N(O)})})})}async $resolveTask(x,B){const F=this._handlers.get(x);if(!F)return Promise.reject(new Error("no handler found"));if(B.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${F.type}].`);const U=await u.to(B,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const M=await F.provider.resolveTask(U,R.CancellationToken.None);if(!!M){this.checkDeprecation(M,F);const N=u.from(M,F.extension);if(!N)throw new Error("Unexpected: Task cannot be resolved.");if(M.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(N.execution)&&await this.addCustomExecution(N,M,!0),await this.resolveTaskInternal(N)}}nextHandle(){return this._handleCounter++}async addCustomExecution(x,B,F){const U=await this._proxy.$createTaskId(x);!F&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,B.execution)}async getTaskExecution(x,B){if(typeof x=="string"){const M=this._taskExecutionPromises.get(x);if(!M)throw new Error("Unexpected: The specified task is missing an execution");return M}let F=this._taskExecutionPromises.get(x.id);if(F)return F;const U=new Promise(async(M,N)=>{const O=B||await u.to(x.task,this._workspaceProvider,this._providedCustomExecutions2);O?M(new k(this,x.id,O)):N("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(x.id,U),U.then(M=>(this._taskExecutions.set(x.id,M),M),M=>Promise.reject(M))}checkDeprecation(x,B){x._deprecated&&this._deprecationService.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));let F=this._notProvidedCustomExecutions.values(),U=F.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=F.next()}};$=je([Ue(0,b.IExtHostRpcService),Ue(1,g.IExtHostInitDataService),Ue(2,A.IExtHostWorkspace),Ue(3,y.IExtHostDocumentsAndEditors),Ue(4,n.IExtHostConfiguration),Ue(5,D.IExtHostTerminalService),Ue(6,v.ILogService),Ue(7,E.IExtHostApiDeprecationService)],$),e.ExtHostTaskBase=$;let te=class extends ${constructor(x,B,F,U,M,N,O,j){super(x,B,F,U,M,N,O,j);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(x,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const F=u.from(B,x);if(F===void 0)throw new Error("Task is not valid");if(p.is(F.execution))await this.addCustomExecution(F,B,!1);else throw new l.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(F),B);return this._proxy.$executeTask(F).catch(M=>{throw new Error(M)}),U}provideTasksInternal(x,B,F,U){const M=[];if(U)for(let N of U){this.checkDeprecation(N,F),(!N.definition||!x[N.definition.type])&&this._logService.warn(`The task [${N.source}, ${N.name}] uses an undefined task type. The task will be ignored in the future.`);const O=u.from(N,F.extension);O&&p.is(O.execution)?(M.push(O),B.push(this.addCustomExecution(O,N,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:M,extension:F.extension}}async resolveTaskInternal(x){if(p.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,B){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(x,B,F){}};te=je([Ue(0,b.IExtHostRpcService),Ue(1,g.IExtHostInitDataService),Ue(2,A.IExtHostWorkspace),Ue(3,y.IExtHostDocumentsAndEditors),Ue(4,n.IExtHostConfiguration),Ue(5,D.IExtHostTerminalService),Ue(6,v.ILogService),Ue(7,E.IExtHostApiDeprecationService)],te),e.WorkerExtHostTask=te,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")});var mn=this&&this.__rest||function(Q,e){var _={};for(var I in Q)Object.prototype.hasOwnProperty.call(Q,I)&&e.indexOf(I)<0&&(_[I]=Q[I]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(Q);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(Q,I[T])&&(_[I[T]]=Q[I[T]]);return _};define(ge[258],ve([0,1,14,19,21,3,69,6,23,15,2,28,5,39,13,20,7,33,221,121]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d,S,v,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const l=(w,u)=>`${w}:${u.toString()}`;let o=class{constructor(u,f,k){this.documents=f,this.workspace=k,this.resultsChangedEmitter=new P.Emitter,this.providers=new Map,this.ownedTests=new E.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=u.getProxy(b.MainContext.MainThreadTesting),this.workspaceObservers=new h(this.proxy),this.textDocumentObservers=new p(this.proxy,f)}registerTestProvider(u){const f=(0,D.generateUuid)();this.providers.set(f,u),this.proxy.$registerTestProvider(f);const k=[...this.testSubscriptions.keys()];return setTimeout(()=>{var L;for(const $ of k)(L=this.testSubscriptions.get($))===null||L===void 0||L.subscribeFn(f,u)},0),new S.Disposable(()=>{this.providers.delete(f),this.proxy.$unregisterTestProvider(f)})}createTextDocumentTestObserver(u){return this.textDocumentObservers.checkout(u.uri)}createWorkspaceTestObserver(u){return this.workspaceObservers.checkout(u.uri)}async runTests(u,f=T.CancellationToken.None){const k=L=>L.map(this.getInternalTestForReference,this).filter(n.isDefined).map($=>({src:$.src,testId:$.item.extId}));await this.proxy.$runTests({exclude:u.exclude?k(u.exclude).map(L=>L.testId):void 0,tests:k(u.tests),debug:u.debug},f)}publishExtensionProvidedResults(u,f){this.proxy.$publishExtensionProvidedResults(d.TestResults.from((0,D.generateUuid)(),u),f)}$publishTestResults(u){this.results=Object.freeze(u.map(f=>(0,y.deepFreeze)(d.TestResults.to(f))).concat(this.results).sort((f,k)=>k.completedAt-f.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(u,f){const k=R.URI.revive(f),L=l(u,k);if(!this.testSubscriptions.has(L)){const $=new T.CancellationTokenSource;let te;if(u===1){let F=this.documents.getDocument(k);if(!F){const U=new A.DisposableStore;F=await new Promise(M=>{U.add((0,I.disposableTimeout)(()=>M(void 0),5e3)),U.add(this.documents.onDidAddDocuments(N=>{const O=N.find(j=>j.document.uri.toString()===k.toString());O&&M(O)}))}).finally(()=>U.dispose())}if(F){const U=await this.workspace.getWorkspaceFolder2(k,!1);te=M=>M.provideDocumentTestRoot?M.provideDocumentTestRoot(F.document,$.token):(0,e.createDefaultDocumentTestRoot)(M,F.document,U,$.token)}}else{const F=await this.workspace.getWorkspaceFolder2(k,!1);F&&(te=U=>U.provideWorkspaceTestRoot(F,$.token))}if(!!te){const H=async(F,U)=>{try{const M=await te(U);M&&B.addRoot(M,F)}catch(M){console.error(M)}},x=new A.DisposableStore,B=x.add(this.ownedTests.createForHierarchy(F=>this.proxy.$publishDiff(u,f,F)));x.add((0,A.toDisposable)(()=>$.dispose(!0)));for(const[F,U]of this.providers)H(F,U);B.pushDiff([3,-1]),this.testSubscriptions.set(L,{store:x,collection:B,subscribeFn:H})}}}async $expandTest(u,f){const k=(0,_.mapFind)(this.testSubscriptions.values(),L=>L.collection.treeId===u.src.tree?L:void 0);await(k==null?void 0:k.collection.expand(u.testId,f<0?Infinity:f)),this.flushCollectionDiffs()}$unsubscribeFromTests(u,f){var k;const L=R.URI.revive(f),$=l(u,L);(k=this.testSubscriptions.get($))===null||k===void 0||k.store.dispose(),this.testSubscriptions.delete($)}$acceptDiff(u,f,k){u===1?this.textDocumentObservers.acceptDiff(R.URI.revive(f),k):this.workspaceObservers.acceptDiff(R.URI.revive(f),k)}async $runTestsForProvider(u,f){const k=this.providers.get(u.tests[0].src.provider);if(!!k){const L=u.tests.map(({testId:H,src:x})=>this.ownedTests.getTestById(H,x.tree)).filter(n.isDefined).map(([H,x])=>x),$=u.excludeExtIds.map(H=>this.ownedTests.getTestById(H)).filter(n.isDefined).filter(([H,x])=>L.some(B=>H.comparePositions(B,x)===1));if(!!L.length){const te=H=>{for(const[x,B]of $){const F=x.comparePositions(B,H.id);if(F===1||F===3)return!0}return!1};try{await k.runTests({appendOutput(){},appendMessage:(H,x)=>{te(H)||(this.flushCollectionDiffs(),this.proxy.$appendTestMessageInRun(u.runId,H.id,d.TestMessage.from(x)))},setState:(H,x,B)=>{te(H)||(this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(u.runId,H.id,x,B))},tests:L.map(H=>i.unwrap(H.actual)),exclude:$.map(([,H])=>i.unwrap(H.actual)),debug:u.debug},f);for(const{collection:H}of this.testSubscriptions.values())H.flushDiff();return}catch(H){throw console.error(H),H}}}}$lookupTest(u){const f=this.ownedTests.getTestById(u.testId);if(!f)return Promise.resolve(void 0);const k=f[1],{actual:L,discoverCts:$,expandLevels:te}=k,H=mn(k,["actual","discoverCts","expandLevels"]);return Promise.resolve(H)}flushCollectionDiffs(){for(const{collection:u}of this.testSubscriptions.values())u.flushDiff()}getInternalTestForReference(u){var f,k;return(k=(f=this.workspaceObservers.getMirroredTestDataByReference(u))!==null&&f!==void 0?f:(0,_.mapFind)(this.testSubscriptions.values(),L=>L.collection.getTestByReference(u)))!==null&&k!==void 0?k:this.textDocumentObservers.getMirroredTestDataByReference(u)}};o=je([Ue(0,s.IExtHostRpcService),Ue(1,g.IExtHostDocumentsAndEditors),Ue(2,v.IExtHostWorkspace)],o),e.ExtHostTesting=o;const t=async(w,u,f,k)=>{if(!!f){const L=await w.provideWorkspaceTestRoot(f,k);if(!!L)return k.onCancellationRequested(()=>{i.removeFilter(u)}),i.getWrapperForTestItem(L,u)}};e.createDefaultDocumentTestRoot=t;class i extends S.TestItem{constructor(u,f,k){super(u.id,u.label,u.uri,u.expandable);if(this.actual=u,this.filterDocument=f,this.parent=k,!(u instanceof S.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${u.id} did not`);u[S.TestItemHookProperty]={setProp:(L,$)=>this[L]=$,created:L=>i.getWrapperForTestItem(L,this.filterDocument,this).refreshMatch(),invalidate:()=>this.invalidate(),delete:L=>this.children.delete(L)}}static removeFilter(u){this.wrapperMap.delete(u)}static getWrapperForTestItem(u,f,k){let L=this.wrapperMap.get(f);if(L==null?void 0:L.has(u))return L.get(u);L||(L=new WeakMap,this.wrapperMap.set(f,L));const $=new i(u,f,k);return L.set(u,$),$}static unwrap(u){return u instanceof i?u.actual:u}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var u;const f=this._cachedMatchesFilter;for(const L of this.actual.children){const $=i.getWrapperForTestItem(L,this.filterDocument,this);$.hasNodeMatchingFilter?this.children.add($):this.children.delete($)}const k=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=k,k!==f&&((u=this.parent)===null||u===void 0||u.refreshMatch()),this._cachedMatchesFilter}}e.TestItemFilteredWrapper=i,i.wrapperMap=new WeakMap;class a extends m.IncrementalChangeCollector{constructor(u){super();this.emitter=u,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(u){this.added.add(u)}update(u){Object.assign(u.revived,d.TestItem.toPlain(u.item)),this.added.has(u)||this.updated.add(u)}remove(u){if(this.added.has(u)){this.added.delete(u);return}if(this.updated.delete(u),u.parent&&this.alreadyRemoved.has(u.parent)){this.alreadyRemoved.add(u.item.extId);return}this.removed.add(u)}getChangeEvent(){const{added:u,updated:f,removed:k}=this;return{get added(){return[...u].map(L=>L.revived)},get updated(){return[...f].map(L=>L.revived)},get removed(){return[...k].map(L=>L.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class r extends m.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(u){let f=[];for(const k of u){const L=this.items.get(k);L&&f.push(L.revived)}return f}getMirroredTestDataById(u){return this.items.get(u)}getMirroredTestDataByReference(u){return this.items.get(u.id)}createItem(u,f){return Object.assign(Object.assign({},u),{revived:d.TestItem.toPlain(u.item),depth:f?f.depth+1:0,children:new Set})}createChangeCollector(){return new a(this.changeEmitter)}}e.MirroredTestCollection=r;class c{constructor(){this.resources=new Map}checkout(u){var f,k;const L=u.toString(),$=(f=this.resources.get(L))!==null&&f!==void 0?f:this.createObserverData(u);return(k=$.pendingDeletion)===null||k===void 0||k.dispose(),$.observers++,{onDidChangeTest:$.tests.onDidChangeTests,onDidDiscoverInitialTests:new P.Emitter().event,get tests(){return $.tests.rootTestItems},dispose:(0,C.once)(()=>{--$.observers||($.pendingDeletion=this.eventuallyDispose(u))})}}getMirroredTestDataByReference(u){for(const{tests:f}of this.resources.values()){const k=f.getMirroredTestDataByReference(u);if(k)return k}}eventuallyDispose(u){return(0,I.disposableTimeout)(()=>this.unlisten(u),10*1e3)}createObserverData(u){const f=new r,k=this.listen(u,$=>f.apply($)),L={observers:0,tests:f,listener:k};return this.resources.set(u.toString(),L),L}unlisten(u){var f;const k=u.toString(),L=this.resources.get(k);L&&(L.observers=-1,(f=L.pendingDeletion)===null||f===void 0||f.dispose(),L.listener.dispose(),this.resources.delete(k))}}class h extends c{constructor(u){super();this.proxy=u,this.diffListeners=new Map}acceptDiff(u,f){var k;(k=this.diffListeners.get(u.toString()))===null||k===void 0||k(f)}listen(u,f){this.proxy.$subscribeToDiffs(0,u);const k=u.toString();return this.diffListeners.set(k,f),new S.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,u),this.diffListeners.delete(k)})}}class p extends c{constructor(u,f){super();this.proxy=u,this.documents=f,this.diffListeners=new Map}acceptDiff(u,f){var k;(k=this.diffListeners.get(u.toString()))===null||k===void 0||k(f)}listen(u,f){if(!this.documents.getDocument(u))return new S.Disposable(()=>{});const L=u.toString();return this.diffListeners.set(L,f),this.proxy.$subscribeToDiffs(1,u),new S.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,u),this.diffListeners.delete(L)})}}}),define(ge[259],ve([0,1,14,53,34,75,24,11,8,25,10,15,2,139,172,83,59,213,257,32]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d,S,v,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let l=class{constructor(w,u,f,k){this.configurationService=w,this.workspaceContextService=u,this.editorGroupsService=f,this.pathService=k}text(w,u,f={}){w=this.getContentPattern(w,f);const k=this.configurationService.getValue(),L=u&&u.some(te=>!this.configurationService.getValue({resource:te}).search.useRipgrep),$=this.commonQuery(u==null?void 0:u.map(S.toWorkspaceFolder),f);return Object.assign(Object.assign({},$),{type:2,contentPattern:w,previewOptions:f.previewOptions,maxFileSize:f.maxFileSize,usePCRE2:k.search.usePCRE2||L||!1,beforeContext:f.beforeContext,afterContext:f.afterContext,userDisabledExcludesAndIgnoreFiles:f.disregardExcludeSettings&&f.disregardIgnoreFiles})}getContentPattern(w,u){const f=this.configurationService.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const k=Object.assign(Object.assign({},w),{wordSeparators:f.editor.wordSeparators});return this.isCaseSensitive(w,u)&&(k.isCaseSensitive=!0),this.isMultiline(w)&&(k.isMultiline=!0),k}file(w,u={}){const f=this.commonQuery(w,u);return Object.assign(Object.assign({},f),{type:1,filePattern:u.filePattern?u.filePattern.trim():u.filePattern,exists:u.exists,sortByScore:u.sortByScore,cacheKey:u.cacheKey})}handleIncludeExclude(w,u){return w?(w=Array.isArray(w)?w.map(r):r(w),u?this.parseSearchPaths(w):{pattern:t(...Array.isArray(w)?w:[w])}):{}}commonQuery(w=[],u={}){const f=this.handleIncludeExclude(u.includePattern,u.expandPatterns),k=this.handleIncludeExclude(u.excludePattern,u.expandPatterns),L=w.length>1,$=(f.searchPaths&&f.searchPaths.length?f.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,u,k)):w.map(x=>this.getFolderQueryForRoot(x,u,k,L))).filter(x=>!!x),te={_reason:u._reason,folderQueries:$,usingSearchPaths:!!(f.searchPaths&&f.searchPaths.length),extraFileResources:u.extraFileResources,excludePattern:k.pattern,includePattern:f.pattern,onlyOpenEditors:u.onlyOpenEditors,maxResults:u.maxResults};if(u.onlyOpenEditors){const B=_.coalesce(_.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(M=>M.resource)))).filter(U=>(0,m.pathIncludedInQuery)(te,U.fsPath)),F=this.commonQueryFromFileList(B);return Object.assign(Object.assign({},te),F)}const H=u.extraFileResources&&u.extraFileResources.filter(x=>(0,m.pathIncludedInQuery)(te,x.fsPath));return te.extraFileResources=H&&H.length?H:void 0,te}commonQueryFromFileList(w){const u=[],f=new C.ResourceMap,k={};let L=!1;return w.forEach($=>{var te,H;if($.scheme!==A.Schemas.walkThrough)if((0,n.isAbsolutePath)($)){const B=(H=(te=this.workspaceContextService.getWorkspaceFolder($))===null||te===void 0?void 0:te.uri)!==null&&H!==void 0?H:$.with({path:y.dirname($.fsPath)});let F=f.get(B);F||(L=!0,F={folder:B,includePattern:{}},u.push(F),f.set(B,F));const U=y.relative(B.fsPath,$.fsPath);(0,D.assertIsDefined)(F.includePattern)[U.replace(/\\/g,"/")]=!0}else $.fsPath&&(L=!0,k[$.fsPath]=!0)}),{folderQueries:u,includePattern:k,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(w,u){if(u.isSmartCase){if(w.isRegExp){if(R.containsUppercaseCharacter(w.pattern,!0))return!0}else if(R.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}isMultiline(w){return w.isMultiline||w.isRegExp&&(0,g.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const u=F=>y.isAbsolute(F)||/^\.\.?([\/\\]|$)/.test(F),k=(Array.isArray(w)?w:i(w)).map(F=>{const U=this.pathService.resolvedUserHome;return U?(0,P.untildify)(F,U.scheme===A.Schemas.file?U.fsPath:U.path):F}),L=I.groupBy(k,F=>u(F)?"searchPaths":"exprSegments"),$=(L.exprSegments||[]).map(F=>R.rtrim(F,"/")).map(F=>R.rtrim(F,"\\")).map(F=>(F[0]==="."&&(F="*"+F),a(F))),te={},H=this.expandSearchPathPatterns(L.searchPaths||[]);H&&H.length&&(te.searchPaths=H);const x=_.flatten($),B=t(...x);return B&&(te.pattern=B),te}getExcludesForFolder(w,u){return u.disregardExcludeSettings?void 0:(0,m.getExcludes)(w,!u.disregardSearchExcludeSettings)}expandSearchPathPatterns(w){if(!w||!w.length)return[];const u=_.flatten(w.map(k=>{let{pathPortion:L,globPortion:$}=o(k);$&&($=c($));const te=this.expandOneSearchPath(L);return _.flatten(te.map(H=>this.resolveOneSearchPathPattern(H,$)))})),f=new Map;return u.forEach(k=>{const L=k.searchPath.toString(),$=f.get(L);$?k.pattern&&($.pattern=$.pattern||{},$.pattern[k.pattern]=!0):f.set(L,{searchPath:k.searchPath,pattern:k.pattern?t(k.pattern):void 0})}),Array.from(f.values())}expandOneSearchPath(w){if(y.isAbsolute(w)){const u=this.workspaceContextService.getWorkspace().folders;return u[0]&&u[0].uri.scheme!==A.Schemas.file?[{searchPath:u[0].uri.with({path:w})}]:[{searchPath:b.URI.file(y.normalize(w))}]}if(this.workspaceContextService.getWorkbenchState()===2){const u=this.workspaceContextService.getWorkspace().folders[0].uri;if(w=r(w),w.startsWith("../")||w===".."){const k=y.posix.resolve(u.path,w);return[{searchPath:u.with({path:k})}]}const f=c(w);return[{searchPath:u,pattern:f}]}else{if(w==="./"||w===".\\")return[];{const u=w.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(u){const f=u[1],k=this.workspaceContextService.getWorkspace().folders.filter(L=>L.name===f);if(k.length)return k.map(L=>{const $=u[2];return{searchPath:L.uri,pattern:$&&c($)}});{const L=s.localize(0,null,f);throw new Error(L)}}}}return[]}resolveOneSearchPathPattern(w,u){const f=w.pattern&&u?`${w.pattern}/${u}`:w.pattern||u,k=[{searchPath:w.searchPath,pattern:f}];return f&&!f.endsWith("**")&&k.push({searchPath:w.searchPath,pattern:f+"/**"}),k}getFolderQueryForSearchPath(w,u,f){const k=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(w.searchPath),u,f,!1);return k?Object.assign(Object.assign({},k),{includePattern:w.pattern}):null}getFolderQueryForRoot(w,u,f,k){let L;const $=b.URI.isUri(w)?w:w.uri;if(f.searchPaths){const F=f.searchPaths.filter(U=>(0,n.isEqual)(U.searchPath,$))[0];if(F&&!F.pattern)return null;F&&(L=F.pattern)}const te=this.configurationService.getValue({resource:$}),H=this.getExcludesForFolder(te,u),x=Object.assign(Object.assign({},H||{}),L||{}),B=b.URI.isUri(w)?(0,n.basename)(w):w.name;return{folder:$,folderName:k?B:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:te.files&&te.files.encoding,disregardIgnoreFiles:typeof u.disregardIgnoreFiles=="boolean"?u.disregardIgnoreFiles:!te.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof u.disregardGlobalIgnoreFiles=="boolean"?u.disregardGlobalIgnoreFiles:!te.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof u.ignoreSymlinks=="boolean"?u.ignoreSymlinks:!te.search.followSymlinks}}};l=je([Ue(0,d.IConfigurationService),Ue(1,S.IWorkspaceContextService),Ue(2,v.IEditorGroupsService),Ue(3,E.IPathService)],l),e.QueryBuilder=l;function o(p){const w=p.match(/[\*\{\}\(\)\[\]\?]/);if(w){const u=w.index,f=p.substr(0,u).match(/[/|\\][^/\\]*$/);if(f){let k=p.substr(0,f.index);return k.match(/[/\\]/)||(k+="/"),{pathPortion:k,globPortion:p.substr((f.index||0)+1)}}}return{pathPortion:p}}function t(...p){return p.length?p.reduce((w,u)=>(w[u]=!0,w),Object.create(null)):void 0}function i(p){return T.splitGlobAware(p,",").map(w=>w.trim()).filter(w=>!!w.length)}function a(p){return[`**/${p}/**`,`**/${p}`].map(u=>u.replace(/\*\*\/\*\*/g,"**"))}function r(p){return p.replace(/\\/g,"/")}function c(p){return r(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(p,w){p=_.distinct(p,k=>k.toString());const u=[],f=w.getWorkspace();return p&&p.forEach(k=>{let L;if(w.getWorkbenchState()===2)L=(0,n.relativePath)(f.folders[0].uri,k),L&&L!=="."&&(L="./"+L);else{const $=w.getWorkspaceFolder(k);if($){const te=$.name;if(f.folders.filter(x=>x.name===te).length===1){const x=(0,n.relativePath)($.uri,k);x===""?L=`./${$.name}`:L=`./${$.name}/${x}`}else L=k.fsPath}}L&&u.push(L)}),u}e.resolveResourcesForSearchIncludes=h}),define(ge[260],ve([0,1,25,2,21,18,4,259,32,59]),function(Q,e,_,I,T,P,C,A,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function D(d,S){const v=S.activationEvents;if(!v)return Promise.resolve(void 0);const E=[],m=[];for(const r of v)if(/^workspaceContains:/.test(r)){const c=r.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||d.forceUsingSearch?m.push(c):E.push(c)}if(E.length===0&&m.length===0)return Promise.resolve(void 0);let l;const o=new Promise((r,c)=>{l=r}),t=r=>l({activationEvent:r}),i=Promise.all(E.map(r=>b(d,r,t))).then(()=>{}),a=g(d,S.identifier,m,t);return Promise.all([i,a]).then(()=>{l(void 0)}),o}e.checkActivateWorkspaceContainsExtension=D;async function b(d,S,v){for(const E of d.folders)if(await d.exists(_.joinPath(I.URI.revive(E),S))){v(`workspaceContains:${S}`);return}}async function g(d,S,v,E){if(v.length===0)return Promise.resolve(void 0);const m=new T.CancellationTokenSource,l=d.checkExists(d.folders,v,m.token),o=setTimeout(async()=>{m.cancel(),E(`workspaceContainsTimeout:${v.join(",")}`)},R);let t=!1;try{t=await l}catch(i){P.isPromiseCanceledError(i)||P.onUnexpectedError(i)}m.dispose(),clearTimeout(o),t&&E(`workspaceContains:${v.join(",")}`)}function s(d,S,v,E){const m=d.get(C.IInstantiationService),l=d.get(y.ISearchService),t=m.createInstance(A.QueryBuilder).file(S.map(i=>(0,n.toWorkspaceFolder)(I.URI.revive(i))),{_reason:"checkExists",includePattern:v,exists:!0});return l.fileSearch(t,E).then(i=>!!i.limitHit,i=>P.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=s});var tt=this&&this.__classPrivateFieldSet||function(Q,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(Q,_):T?T.value=_:e.set(Q,_),_},$e=this&&this.__classPrivateFieldGet||function(Q,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(Q):I?I.value:e.get(Q)};define(ge[42],ve([0,1,161,8,66,25,19,6,24,2,12,5,36,224,88,33,41,222,18,29,11,22,195,7,113,4,27,89,13,81,50,35,3,260,86,196]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d,S,v,E,m,l,o,t,i,a,r,c,h,p,w,u,f,k,L,$,te){"use strict";var H,x,B;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let F=class Mn extends A.Disposable{constructor(O,j,q,X,me,we,Ae,Ie,Me,V){super();this._onDidChangeRemoteConnectionData=this._register(new k.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=j,this._extHostContext=q,this._initData=Ae,this._extHostWorkspace=X,this._extHostConfiguration=me,this._logService=we,this._extHostTunnelService=Me,this._extHostTerminalService=V,this._disposables=new A.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(D.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(D.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(D.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new C.Barrier,this._readyToStartExtensionHost=new C.Barrier,this._readyToRunExtensions=new C.Barrier,this._eagerExtensionsActivated=new C.Barrier,this._registry=new v.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new $.ExtHostSecretState(this._extHostContext),this._storagePath=Ie,this._instaService=O.createChild(new w.ServiceCollection([s.IExtHostStorage,this._storage],[$.IExtHostSecretState,this._secretState]));const Y=new Set;this._initData.hostExtensions.forEach(ee=>Y.add(m.ExtensionIdentifier.toKey(ee))),this._activator=new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ee,ae)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ee,ae)},actualActivateExtension:async(ee,ae)=>{if(Y.has(m.ExtensionIdentifier.toKey(ee)))return await this._mainThreadExtensionsProxy.$activateExtension(ee,ae),new g.HostExtension;const fe=this._registry.getExtensionDescription(ee);return this._activateExtension(fe,ae)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),T.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){E.onUnexpectedError(O)}}async deactivateAll(){let O=[];try{O=this._registry.getAllExtensionDescriptions().map(me=>me.identifier).filter(me=>this.isActivated(me)).map(me=>this._deactivate(me))}catch(j){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,j){return this._activator.activateByEvent(O,j)}_activateById(O,j){return this._activator.activateById(O,j)}activateByIdWithErrors(O,j){return this._activateById(O,j).then(()=>{const q=this._activator.getActivatedExtension(O);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=y.TernarySearchTree.forPaths(),j=this._registry.getAllExtensionDescriptions().map(q=>{if(!!this._getEntryPoint(q))return this._hostUtils.realpath(q.extensionLocation.fsPath).then(X=>O.set(n.URI.file(X).fsPath,q))});this._extensionPathIndex=Promise.all(j).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let j=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return j;const q=this._activator.getActivatedExtension(O);if(!q)return j;try{typeof q.module.deactivate=="function"&&(j=Promise.resolve(q.module.deactivate()).then(void 0,X=>Promise.resolve(void 0)))}catch(X){}try{(0,A.dispose)(q.subscriptions)}catch(X){}return j}async _activateExtension(O,j){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,j).then(q=>{const X=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,j),this._logExtensionActivationTimes(O,j,"success",X),q},q=>{throw this._logExtensionActivationTimes(O,j,"failure"),q})}_logExtensionActivationTimes(O,j,q,X){const me=U(O,j);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},me),X||{}),{outcome:q}))}_doActivateExtension(O,j){const q=U(O,j);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const X=this._getEntryPoint(O);if(!X)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(j)}`),this._logService.flush();const me=new g.ExtensionActivationTimesBuilder(j.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,P.joinPath)(O.extensionLocation,X),me),this._loadExtensionContext(O)]).then(we=>(T.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Mn._callActivate(this._logService,O.identifier,we[0],we[1],me))).then(we=>(T.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),we))}_loadExtensionContext(O){const j=new t.ExtensionGlobalMemento(O,this._storage),q=new t.ExtensionMemento(O.identifier.value,!1,this._storage),X=new te.ExtensionSecrets(O,this._secretState),me=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,we=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([j.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const Ae=this;let Ie;return Object.freeze({globalState:j,workspaceState:q,secrets:X,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Me){return I.join(O.extensionLocation.fsPath,Me)},get storagePath(){var Me;return(Me=Ae._storagePath.workspaceValue(O))===null||Me===void 0?void 0:Me.fsPath},get globalStoragePath(){return Ae._storagePath.globalValue(O).fsPath},get logPath(){return I.join(Ae._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return n.URI.joinPath(Ae._initData.logsLocation,O.identifier.value)},get storageUri(){return Ae._storagePath.workspaceValue(O)},get globalStorageUri(){return Ae._storagePath.globalValue(O)},get extensionMode(){return me},get extension(){return Ie===void 0&&(Ie=new M(Ae,O.identifier,O,we)),Ie},get extensionRuntime(){return(0,S.checkProposedApiEnabled)(O),Ae.extensionRuntime},get environmentVariableCollection(){return Ae._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,j,q,X,me){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,j,q,X,me).then(we=>new g.ActivatedExtension(!1,null,me.build(),q,we,X.subscriptions))}static _callActivateOptional(O,j,q,X,me){if(typeof q.activate=="function")try{me.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${j.value}`);const we=typeof global=="object"?global:self,Ae=q.activate.apply(we,[X]);return me.activateCallStop(),me.activateResolveStart(),Promise.resolve(Ae).then(Ie=>(me.activateResolveStop(),Ie))}catch(we){return Promise.reject(we)}else return Promise.resolve(q)}_activateOneStartupFinished(O,j){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:j}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(T.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const j of O.activationEvents)j==="onStartupFinished"&&this._activateOneStartupFinished(O,j)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,me=>{this._logService.error(me)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(me=>this._handleWorkspaceContainsEagerExtensions(me.added)));const j=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(j),X=Promise.all([O,q]).then(()=>{});return Promise.race([X,(0,C.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(j=>this._handleWorkspaceContainsEagerExtension(O,j))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,j){if(!this.isActivated(j.identifier)){const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={folders:O.map(we=>we.uri),forceUsingSearch:q,exists:we=>this._hostUtils.exists(we.fsPath),checkExists:(we,Ae,Ie)=>this._mainThreadWorkspaceProxy.$checkExists(we,Ae,Ie)},me=await(0,L.checkActivateWorkspaceContainsExtension)(X,j);if(!!me)return this._activateById(j.identifier,{startup:!0,extensionId:j.identifier,activationEvent:me.activationEvent}).then(void 0,we=>this._logService.error(we))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:j}=this._initData.environment;if(!O||!j||j.scheme!==l.Schemas.file)throw new Error(_.localize(0,null));const q=(0,P.originalFSPath)(j),X=await this._loadCommonJSModule(null,j,new g.ExtensionActivationTimesBuilder(!1));if(!X||typeof X.run!="function")throw new Error(_.localize(1,null,q));return new Promise((me,we)=>{const Ae=(Me,V)=>{Me?we(Me):me(typeof V=="number"&&V>0?1:0)},Ie=X.run(q,Ae);Ie&&Ie.then&&Ie.then(()=>{me(0)}).catch(Me=>{we(Me.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,j){return this._resolvers[O]=j,(0,A.toDisposable)(()=>{delete this._resolvers[O]})}async $resolveAuthority(O,j){const q=O.indexOf("+");if(q===-1)throw new Error("Not an authority that can be resolved!");const X=O.substr(0,q);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${X}`,!1);const me=this._resolvers[X];if(!me)return{type:"error",error:{code:a.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${X}.`,detail:void 0}};try{T.mark(`code/extHost/willResolveAuthority/${X}`);const we=await me.resolve(O,{resolveAttempt:j});T.mark(`code/extHost/didResolveAuthorityOK/${X}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(me));const Ae={authority:O,host:we.host,port:we.port,connectionToken:we.connectionToken},Ie={extensionHostEnv:we.extensionHostEnv};return{type:"ok",value:{authority:Ae,options:Ie,tunnelInformation:{environmentTunnels:we.environmentTunnels}}}}catch(we){if(T.mark(`code/extHost/didResolveAuthorityError/${X}`),we instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:we._code,message:we._message,detail:we._detail}};throw we}}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,j){return j===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(O,!1))}async $activate(O,j){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,j),!0):!1}async $deltaExtensions(O,j){O.forEach(X=>X.extensionLocation=n.URI.revive(X.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(j.map(async X=>{const me=this._registry.getExtensionDescription(X);if(!!me){const we=await this._hostUtils.realpath(me.extensionLocation.fsPath);q.delete(n.URI.file(we).fsPath)}})),await Promise.all(O.map(async X=>{const me=await this._hostUtils.realpath(X.extensionLocation.fsPath);q.set(n.URI.file(me).fsPath,X)})),this._registry.deltaExtensions(O,j),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let j=o.VSBuffer.alloc(O),q=Math.random()%256;for(let X=0;X<O;X++)j.writeUInt8(q,X);return j}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};F=je([Ue(0,r.IInstantiationService),Ue(1,e.IHostUtils),Ue(2,p.IExtHostRpcService),Ue(3,d.IExtHostWorkspace),Ue(4,b.IExtHostConfiguration),Ue(5,R.ILogService),Ue(6,c.IExtHostInitDataService),Ue(7,h.IExtensionStoragePaths),Ue(8,u.IExtHostTunnelService),Ue(9,f.IExtHostTerminalService)],F),e.AbstractExtHostExtensionService=F;function U(N,O){return{id:N.identifier.value,name:N.name,extensionVersion:N.version,publisherDisplayName:N.publisher,activationEvents:N.activationEvents?N.activationEvents.join(","):null,isBuiltin:N.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class M{constructor(O,j,q,X){H.set(this,void 0),x.set(this,void 0),B.set(this,void 0),tt(this,H,O,"f"),tt(this,x,j,"f"),tt(this,B,q.identifier,"f"),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=I.normalize((0,P.originalFSPath)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=X}get isActive(){return $e(this,H,"f").isActivated($e(this,B,"f"))}get exports(){if(this.packageJSON.api!=="none")return $e(this,H,"f").getExtensionExports($e(this,B,"f"))}activate(){return $e(this,H,"f").activateByIdWithErrors($e(this,B,"f"),{startup:!1,extensionId:$e(this,x,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=M,H=new WeakMap,x=new WeakMap,B=new WeakMap}),define(ge[45],ve([0,1,8,2,3,19,5,7,119,33,42,39,212,36,203,13,4,15,30]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d,S,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let m=class{constructor(h,p,w,u,f){this._workspaceService=p,this._extensionService=w,this._editorsService=u,this._configurationService=f,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new T.Emitter,this._onDidTerminateDebugSession=new T.Emitter,this._onDidChangeActiveDebugSession=new T.Emitter,this._onDidReceiveDebugSessionCustomEvent=new T.Emitter,this._debugServiceProxy=h.getProxy(C.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new T.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new o(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(k=>{k.onDidChange(L=>{this.registerAllDebugTypes(k)}),this.registerAllDebugTypes(k)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(h,p){const w=h;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let u=`debug:${encodeURIComponent(w.path||"")}`,f="?";return p&&(u+=`${f}session=${encodeURIComponent(p.id)}`,f="&"),u+=`${f}ref=${w.sourceReference}`,I.URI.parse(u)}else{if(w.path)return I.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(h){const p=[];for(const w of h.getAllExtensionDescriptions())if(w.contributes){const u=w.contributes.debuggers;if(u&&u.length>0)for(const f of u)(0,s.isDebuggerMainContribution)(f)&&p.push(f.type)}this._debugServiceProxy.$registerDebugTypes(p)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const h=[];return this._breakpoints.forEach(p=>h.push(p)),h}addBreakpoints(h){this.startBreakpoints();const p=h.filter(f=>{const k=f.id;return this._breakpoints.has(k)?!1:(this._breakpoints.set(k,f),!0)});this.fireBreakpointChanges(p,[],[]);const w=[],u=new Map;for(const f of p)if(f instanceof A.SourceBreakpoint){let k=u.get(f.location.uri.toString());k||(k={type:"sourceMulti",uri:f.location.uri,lines:[]},u.set(f.location.uri.toString(),k),w.push(k)),k.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof A.FunctionBreakpoint&&w.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this._debugServiceProxy.$registerBreakpoints(w)}removeBreakpoints(h){this.startBreakpoints();const p=h.filter(k=>this._breakpoints.delete(k.id));this.fireBreakpointChanges([],p,[]);const w=p.filter(k=>k instanceof A.SourceBreakpoint).map(k=>k.id),u=p.filter(k=>k instanceof A.FunctionBreakpoint).map(k=>k.id),f=p.filter(k=>k instanceof A.DataBreakpoint).map(k=>k.id);return this._debugServiceProxy.$unregisterBreakpoints(w,u,f)}startDebugging(h,p,w){return this._debugServiceProxy.$startDebugging(h?h.uri:void 0,p,{parentSessionID:w.parentSession?w.parentSession.id:void 0,repl:w.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact})}stopDebugging(h){return this._debugServiceProxy.$stopDebugging(h?h.id:void 0)}registerDebugConfigurationProvider(h,p,w){if(!p)return new A.Disposable(()=>{});const u=this._configProviderHandleCounter++;return this._configProviders.push({type:h,handle:u,provider:p}),this._debugServiceProxy.$registerDebugConfigurationProvider(h,w,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,u),new A.Disposable(()=>{this._configProviders=this._configProviders.filter(f=>f.provider!==p),this._debugServiceProxy.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(h,p,w){if(!w)return new A.Disposable(()=>{});if(!this.definesDebugType(h,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.getAdapterDescriptorFactoryByType(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:p,handle:u,factory:w}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(p,u),new A.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(f=>f.factory!==w),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(h,p){if(!p)return new A.Disposable(()=>{});const w=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:h,handle:w,factory:p}),new A.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(u=>u.factory!==p)})}async $runInTerminal(h,p){return Promise.resolve(void 0)}async $substituteVariables(h,p){if(!this._variableResolver){const[f,k]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(f||[],this._editorsService,k)}let w;const u=await this.getFolder(h);return u&&(w={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(w,p)}createDebugAdapter(h,p){if(h.type==="implementation")return new a(h.implementation)}createSignService(){}async $startDASession(h,p){const w=this,u=await this.getSession(p);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(u.type),u).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const k=this.convertToDto(f),L=this.createDebugAdapter(k,u);if(!L)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const $=L;return this._debugAdapters.set(h,$),this.getDebugAdapterTrackers(u).then(te=>(te&&this._debugAdaptersTrackers.set(h,te),$.onMessage(async H=>{if(H.type==="request"&&H.command==="handshake"){const x=H,B={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign(x.arguments.value);B.body={signature:F},$.sendResponse(B)}else throw new Error("no signer")}catch(F){B.success=!1,B.message=F.message,$.sendResponse(B)}}else te&&te.onDidSendMessage&&te.onDidSendMessage(H),H=(0,s.convertToVSCPaths)(H,!0),w._debugServiceProxy.$acceptDAMessage(h,H)}),$.onError(H=>{te&&te.onError&&te.onError(H),this._debugServiceProxy.$acceptDAError(h,H.name,H.message,H.stack)}),$.onExit(H=>{te&&te.onExit&&te.onExit((0,v.withNullAsUndefined)(H),void 0),this._debugServiceProxy.$acceptDAExit(h,(0,v.withNullAsUndefined)(H),void 0)}),te&&te.onWillStartSession&&te.onWillStartSession(),$.startSession()))})}$sendDAMessage(h,p){p=(0,s.convertToDAPaths)(p,!1);const w=this._debugAdaptersTrackers.get(h);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(p);const u=this._debugAdapters.get(h);u&&u.sendMessage(p)}$stopDASession(h){const p=this._debugAdaptersTrackers.get(h);this._debugAdaptersTrackers.delete(h),p&&p.onWillStopSession&&p.onWillStopSession();const w=this._debugAdapters.get(h);return this._debugAdapters.delete(h),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(h){const p=[],w=[],u=[];if(h.added)for(const f of h.added){const k=f.id;if(k&&!this._breakpoints.has(k)){let L;if(f.type==="function")L=new A.FunctionBreakpoint(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")L=new A.DataBreakpoint(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const $=I.URI.revive(f.uri);L=new A.SourceBreakpoint(new A.Location($,new A.Position(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}L._id=k,this._breakpoints.set(k,L),p.push(L)}}if(h.removed)for(const f of h.removed){const k=this._breakpoints.get(f);k&&(this._breakpoints.delete(f),w.push(k))}if(h.changed){for(const f of h.changed)if(f.id){const k=this._breakpoints.get(f.id);if(k){if(k instanceof A.FunctionBreakpoint&&f.type==="function"){const L=k;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.functionName=f.functionName}else if(k instanceof A.SourceBreakpoint&&f.type==="source"){const L=k;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.location=new A.Location(I.URI.revive(f.uri),new A.Position(f.line,f.character))}u.push(k)}}}this.fireBreakpointChanges(p,w,u)}$provideDebugConfigurations(h,p,w){return(0,P.asPromise)(async()=>{const u=this.getConfigProviderByHandle(h);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.getFolder(p);return u.provideDebugConfigurations(f,w)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(h,p,w,u){return(0,P.asPromise)(async()=>{const f=this.getConfigProviderByHandle(h);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.getFolder(p);return f.resolveDebugConfiguration(k,w,u)})}$resolveDebugConfigurationWithSubstitutedVariables(h,p,w,u){return(0,P.asPromise)(async()=>{const f=this.getConfigProviderByHandle(h);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.getFolder(p);return f.resolveDebugConfigurationWithSubstitutedVariables(k,w,u)})}async $provideDebugAdapter(h,p){const w=this.getAdapterDescriptorFactoryByHandle(h);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.getSession(p);return this.getAdapterDescriptor(w,u).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.convertToDto(f)})}async $acceptDebugSessionStarted(h){const p=await this.getSession(h);this._onDidStartDebugSession.fire(p)}async $acceptDebugSessionTerminated(h){const p=await this.getSession(h);p&&(this._onDidTerminateDebugSession.fire(p),this._debugSessions.delete(p.id))}async $acceptDebugSessionActiveChanged(h){this._activeDebugSession=h?await this.getSession(h):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(h,p){const w=await this.getSession(h);w&&w._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(h,p){const u={session:await this.getSession(h),event:p.event,body:p.body};this._onDidReceiveDebugSessionCustomEvent.fire(u)}convertToDto(h){if(h instanceof A.DebugAdapterExecutable)return{type:"executable",command:h.command,args:h.args,options:h.options};if(h instanceof A.DebugAdapterServer)return{type:"server",port:h.port,host:h.host};if(h instanceof A.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:h.path};if(h instanceof A.DebugAdapterInlineImplementation)return{type:"implementation",implementation:h.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(h){const p=this._adapterFactories.filter(w=>w.type===h);if(p.length>0)return p[0].factory}getAdapterDescriptorFactoryByHandle(h){const p=this._adapterFactories.filter(w=>w.handle===h);if(p.length>0)return p[0].factory}getConfigProviderByHandle(h){const p=this._configProviders.filter(w=>w.handle===h);if(p.length>0)return p[0].provider}definesDebugType(h,p){if(h.contributes){const w=h.contributes.debuggers;if(w&&w.length>0){for(const u of w)if(u.label&&u.type&&u.type===p)return!0}}return!1}getDebugAdapterTrackers(h){const w=h.configuration.type,u=this._trackerFactories.filter(f=>f.type===w||f.type==="*").map(f=>(0,P.asPromise)(()=>f.factory.createDebugAdapterTracker(h)).then(k=>k,k=>null));return Promise.race([Promise.all(u).then(f=>{const k=f.filter(L=>!!L);if(k.length>0)return new i(k)}),new Promise((f,k)=>{const L=setTimeout(()=>{clearTimeout(L),k(new Error("timeout"))},1e3)})]).catch(f=>{})}async getAdapterDescriptor(h,p){const w=p.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new A.DebugAdapterServer(w));if(h){const f=await this._extensionService.getExtensionRegistry();return(0,P.asPromise)(()=>h.createDebugAdapterDescriptor(p,this.daExecutableFromPackage(p,f))).then(k=>{if(k)return k})}const u=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(p,u))}daExecutableFromPackage(h,p){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(h,p,w){(h.length>0||p.length>0||w.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:h,removed:p,changed:w}))}async getSession(h){if(h)if(typeof h=="string"){const p=this._debugSessions.get(h);if(p)return p}else{let p=this._debugSessions.get(h.id);if(!p){const w=await this.getFolder(h.folderUri);p=new l(this._debugServiceProxy,h.id,h.type,h.name,w,h.configuration),this._debugSessions.set(p.id,p),this._debugServiceProxy.$sessionCached(p.id)}return p}throw new Error("cannot find session")}getFolder(h){if(h){const p=I.URI.revive(h);return this._workspaceService.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}};m=je([Ue(0,d.IExtHostRpcService),Ue(1,n.IExtHostWorkspace),Ue(2,R.IExtHostExtensionService),Ue(3,D.IExtHostDocumentsAndEditors),Ue(4,g.IExtHostConfiguration)],m),e.ExtHostDebugServiceBase=m;class l{constructor(h,p,w,u,f,k){this._debugServiceProxy=h,this._id=p,this._type=w,this._name=u,this._workspaceFolder=f,this._configuration=k}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(h){this._name=h,this._debugServiceProxy.$setDebugSessionName(this._id,h)}_acceptNameChanged(h){this._name=h}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(h,p){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,h,p)}getDebugProtocolBreakpoint(h){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,h.id)}}e.ExtHostDebugSession=l;class o{constructor(h){this.value=Object.freeze({append(p){h.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.ExtHostDebugConsole=o;class t extends b.AbstractVariableResolverService{constructor(h,p,w,u){super({getFolderUri:f=>{const k=h.filter(L=>L.name===f);if(k&&k.length>0)return k[0].uri},getWorkspaceFolderCount:()=>h.length,getConfigurationValue:(f,k)=>w.getConfiguration(void 0,f).get(k),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(p){const f=p.activeEditor();if(f)return _.normalize(f.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(p&&u){const f=p.activeEditor();if(f){const k=u.getWorkspaceFolder(f.document.uri);if(k)return _.normalize(k.uri.fsPath)}}},getSelectedText:()=>{if(p){const f=p.activeEditor();if(f&&!f.selection.isEmpty)return f.document.getText(f.selection)}},getLineNumber:()=>{if(p){const f=p.activeEditor();if(f)return String(f.selection.end.line+1)}}},void 0,E.env)}}e.ExtHostVariableResolverService=t;class i{constructor(h){this.trackers=h}onWillStartSession(){this.trackers.forEach(h=>h.onWillStartSession?h.onWillStartSession():void 0)}onWillReceiveMessage(h){this.trackers.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(h):void 0)}onDidSendMessage(h){this.trackers.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(h):void 0)}onWillStopSession(){this.trackers.forEach(h=>h.onWillStopSession?h.onWillStopSession():void 0)}onError(h){this.trackers.forEach(p=>p.onError?p.onError(h):void 0)}onExit(h,p){this.trackers.forEach(w=>w.onExit?w.onExit(h,p):void 0)}}class a extends y.AbstractDebugAdapter{constructor(h){super();this.implementation=h,h.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(h){this.implementation.handleMessage(h)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends m{constructor(h,p,w,u,f){super(h,p,w,u,f)}createVariableResolver(h,p,w){return new t(h,p,w)}};r=je([Ue(0,d.IExtHostRpcService),Ue(1,n.IExtHostWorkspace),Ue(2,R.IExtHostExtensionService),Ue(3,D.IExtHostDocumentsAndEditors),Ue(4,g.IExtHostConfiguration)],r),e.WorkerExtHostDebugService=r}),define(ge[261],ve([0,1,66,2,5,36,41,29,13,27,4,42,30,12]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(m,l,o,t,i,a,r){this._apiFactory=m,this._extensionRegistry=l,this._instaService=o,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=a,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),_.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();_.mark("code/extHost/didWaitForConfig");const l=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,l,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(S)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(v,l,this._initData.environment.appUriScheme))}register(m){if(Array.isArray(m.nodeModuleName))for(let l of m.nodeModuleName)this._factories.set(l,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(l=>m.alternativeModuleName(l))}};s=je([Ue(2,R.IInstantiationService),Ue(3,P.IExtHostConfiguration),Ue(4,D.IExtHostExtensionService),Ue(5,n.IExtHostInitDataService),Ue(6,g.ILogService)],s),e.RequireInterceptor=s;class d{constructor(m,l,o,t,i){this._apiFactory=m,this._extensionPaths=l,this._extensionRegistry=o,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,l){const o=this._extensionPaths.findSubstr(l.fsPath);if(o){let t=this._extApiImpl.get(A.ExtensionIdentifier.toKey(o.identifier));return t||(t=this._apiFactory(o,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(o.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,a)=>t+=`	${a} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${l.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(C.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(m,l){this.nodeModuleName="keytar";const{environment:o}=l,t=m.getProxy(T.MainContext.MainThreadKeytar);if(o.appRoot){let i=o.appRoot.fsPath;b.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,a)=>t.$getPassword(i,a),setPassword:(i,a,r)=>t.$setPassword(i,a,r),deletePassword:(i,a)=>t.$deletePassword(i,a),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(m,l){return this._impl}alternativeModuleName(m){const l=m.length;if(!(l<=7||!this.alternativeNames)){const o=l-7;if((m.charAt(o)==="/"||m.charAt(o)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}}};S=je([Ue(0,y.IExtHostRpcService),Ue(1,n.IExtHostInitDataService)],S);let v=class{constructor(m,l,o){this._extensionPaths=m,this._appUriScheme=l,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=o.getProxy(T.MainContext.MainThreadTelemetry);const t=o.getProxy(T.MainContext.MainThreadWindow);this._impl=(i,a)=>{const r=I.URI.parse(i);return a?this.callOriginal(i,a):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,i,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,i,{}):this.callOriginal(i,a)}}load(m,l,o){const t=this._extensionPaths.findSubstr(l.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=o(m),this._impl}callOriginal(m,l){return this.sendNoForwardTelemetry(),this._original(m,l)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};v=je([Ue(2,y.IExtHostRpcService)],v)}),define(ge[262],ve([0,1,167,9,7,204,33,42,39,36,35,13,45,188,207,19]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let S=class extends b.ExtHostDebugServiceBase{constructor(m,l,o,t,i,a){super(m,l,o,t,i);this._terminalService=a,this._integratedTerminalInstances=new v}createDebugAdapter(m,l){switch(m.type){case"server":return new P.SocketDebugAdapter(m);case"pipeServer":return new P.NamedPipeDebugAdapter(m);case"executable":return new P.ExecutableDebugAdapter(m,l.type)}return super.createDebugAdapter(m,l)}daExecutableFromPackage(m,l){const o=P.ExecutableDebugAdapter.platformAdapterExecutable(l.getAllExtensionDescriptions(),m.type);if(o)return new T.DebugAdapterExecutable(o.command,o.args,o.options)}createSignService(){return new g.SignService}async $runInTerminal(m,l){if(m.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(f=>{this._integratedTerminalInstances.onTerminalClosed(f)}));const o=await this._configurationService.getConfigProvider(),t=this._terminalService.getDefaultShell(!0,o),i=this._terminalService.getDefaultShellArgs(!0,o),a=JSON.stringify({shell:t,shellArgs:i});let r=await this._integratedTerminalInstances.checkout(a),c,h=!1;if(r)c=m.cwd;else{const f={shellPath:t,shellArgs:i,cwd:m.cwd,name:m.title||_.localize(0,null)};h=!0,r=this._terminalService.createTerminalFromOptions(f,!0),this._integratedTerminalInstances.insert(r,a)}r.show(!0);const p=await r.processId;h?await new Promise(f=>setTimeout(f,1e3)):o.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(t.indexOf("powershell")>=0||t.indexOf("pwsh")>=0||t.indexOf("cmd.exe")>=0?r.sendText("cls"):t.indexOf("bash")>=0?r.sendText("clear"):I.isWindows?r.sendText("cls"):r.sendText("clear"));const w=(0,s.prepareCommand)(t,m.args,c,m.env);r.sendText(w);const u=this.onDidTerminateDebugSession(f=>{f.id===l&&(this._integratedTerminalInstances.free(r),u.dispose())});return p}else if(m.kind==="external")return(0,s.runInExternalTerminal)(m,await this._configurationService.getConfigProvider());return super.$runInTerminal(m,l)}createVariableResolver(m,l,o){return new b.ExtHostVariableResolverService(m,l,o,this._workspaceService)}};S=je([Ue(0,D.IExtHostRpcService),Ue(1,C.IExtHostWorkspace),Ue(2,A.IExtHostExtensionService),Ue(3,y.IExtHostDocumentsAndEditors),Ue(4,n.IExtHostConfiguration),Ue(5,R.IExtHostTerminalService)],S),e.ExtHostDebugService=S;class v{constructor(){this._terminalInstances=new Map}async checkout(m){const o=[...this._terminalInstances.entries()].map(([t,i])=>(0,d.createCancelablePromise)(async a=>{if(i.lastUsedAt!==-1&&await(0,s.hasChildProcesses)(await t.processId))return null;const r=Date.now();return i.lastUsedAt+v.minUseDelay>r||a.isCancellationRequested||i.config!==m?null:(i.lastUsedAt=r,t)}));return await(0,d.firstParallel)(o,t=>!!t)}insert(m,l){this._terminalInstances.set(m,{lastUsedAt:Date.now(),config:l})}free(m){const l=this._terminalInstances.get(m);l&&(l.lastUsedAt=-1)}onTerminalClosed(m){this._terminalInstances.delete(m)}}v.minUseDelay=1e3}),define(ge[263],ve([0,1,8,2,77,33,45,39,36,35,13,27,65,11,12,62]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let S=class extends b.ExtHostTaskBase{constructor(E,m,l,o,t,i,a,r){super(E,m,l,o,t,i,a,r);this.workspaceService=l,m.remote.isRemote&&m.remote.authority?this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:m.remote.authority,platform:process.platform}):this.registerTaskSystem(g.Schemas.file,{scheme:g.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(E,m){const l=m;if(!m.execution&&l._id===void 0)throw new Error("Tasks to execute must include an execution");if(l._id!==void 0){const o=b.TaskHandleDTO.from(l,this.workspaceService),t=await this._proxy.$getTaskExecution(o);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const i=await this.getTaskExecution(t,m);return this._proxy.$executeTask(o).catch(()=>{}),i}else{const o=b.TaskDTO.from(m,E);if(o===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(o.execution)&&await this.addCustomExecution(o,m,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(o),m);return this._proxy.$executeTask(o).catch(()=>{}),t}}provideTasksInternal(E,m,l,o){const t=[];if(o)for(let i of o){this.checkDeprecation(i,l),(!i.definition||!E[i.definition.type])&&this._logService.warn(`The task [${i.source}, ${i.name}] uses an undefined task type. The task will be ignored in the future.`);const a=b.TaskDTO.from(i,l.extension);a&&(t.push(a),b.CustomExecutionDTO.is(a.execution)&&m.push(this.addCustomExecution(a,i,!0)))}return{tasks:t,extension:l.extension}}async resolveTaskInternal(E){return E}async getVariableResolver(E){if(this._variableResolver===void 0){const m=await this._configurationService.getConfigProvider();this._variableResolver=new C.ExtHostVariableResolverService(E,this._editorService,m,this.workspaceService)}return this._variableResolver}async $resolveVariables(E,m){const l=I.URI.revive(E),o={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(l),i=await this._workspaceProvider.getWorkspaceFolders2();if(!i||!t)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const a=await this.getVariableResolver(i),r={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}};for(let c of m.variables)o.variables[c]=await a.resolveAsync(r,c);if(m.process!==void 0){let c;if(m.process.path!==void 0){c=m.process.path.split(_.delimiter);for(let h=0;h<c.length;h++)c[h]=await a.resolveAsync(r,c[h])}o.process=await T.win32.findExecutable(await a.resolveAsync(r,m.process.name),m.process.cwd!==void 0?await a.resolveAsync(r,m.process.cwd):void 0,c)}return o}$getDefaultShellAndArgs(){return this._terminalService.$getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(E,m,l){return T.win32.findExecutable(E,m,l)}};S=je([Ue(0,R.IExtHostRpcService),Ue(1,D.IExtHostInitDataService),Ue(2,P.IExtHostWorkspace),Ue(3,A.IExtHostDocumentsAndEditors),Ue(4,y.IExtHostConfiguration),Ue(5,n.IExtHostTerminalService),Ue(6,s.ILogService),Ue(7,d.IExtHostApiDeprecationService)],S),e.ExtHostTask=S}),define(ge[264],ve([0,1,9,15,28,148,12,36,45,39,13,35,33,210,211]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let d=class extends D.BaseExtHostTerminalService{constructor(v,E,m,l,o){super(!0,v);this._extHostConfiguration=E,this._extHostWorkspace=m,this._extHostDocumentsAndEditors=l,this._logService=o,this._isWorkspaceShellAllowed=!1,(0,P.getSystemShell)(_.platform,process.env).then(t=>this._defaultShell=t),this._updateLastActiveWorkspace(),this._variableResolverPromise=this._updateVariableResolver(),this._registerListeners()}createTerminal(v,E,m){const l=new D.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),{name:v,shellPath:E,shellArgs:m},v);return this._terminals.push(l),l.create(E,m),l.value}createTerminalFromOptions(v,E){const m=new D.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),v,v.name);return this._terminals.push(m),m.create((0,I.withNullAsUndefined)(v.shellPath),(0,I.withNullAsUndefined)(v.shellArgs),(0,I.withNullAsUndefined)(v.cwd),(0,I.withNullAsUndefined)(v.env),(0,I.withNullAsUndefined)(v.icon),(0,I.withNullAsUndefined)(v.initialText),void 0,(0,I.withNullAsUndefined)(v.strictEnv),(0,I.withNullAsUndefined)(v.hideFromUser),(0,I.withNullAsUndefined)(E),!0),m.value}getDefaultShell(v,E){var m;const l=o=>{const t=E.getConfiguration(o.substr(0,o.lastIndexOf("."))).inspect(o.substr(o.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(t)};return g.getDefaultShell(l,this._isWorkspaceShellAllowed,(m=this._defaultShell)!==null&&m!==void 0?m:(0,P.getSystemShellSync)(_.platform,process.env),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,g.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService,v)}getDefaultShellArgs(v,E){const m=l=>{const o=E.getConfiguration(l.substr(0,l.lastIndexOf("."))).inspect(l.substr(l.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(o)};return g.getDefaultShellArgs(m,this._isWorkspaceShellAllowed,v,g.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService)}_apiInspectConfigToPlain(v){return{userValue:v?v.globalValue:void 0,value:v?v.workspaceValue:void 0,defaultValue:v?v.defaultValue:void 0}}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>{this._variableResolverPromise=this._updateVariableResolver()})}_updateLastActiveWorkspace(){const v=this._extHostDocumentsAndEditors.activeEditor();v&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(v.document.uri))}async _updateVariableResolver(){const v=await this._extHostConfiguration.getConfigProvider(),E=await this._extHostWorkspace.getWorkspaceFolders2();return this._variableResolver=new y.ExtHostVariableResolverService(E||[],this._extHostDocumentsAndEditors,v),this._variableResolver}async $getAvailableProfiles(v){const E=await(await this._extHostConfiguration.getConfigProvider()).getConfiguration().get("terminal.integrated");return(0,s.detectAvailableProfiles)(v,void 0,this._logService,E,await this._variableResolverPromise,this._lastActiveWorkspace)}async $getDefaultShellAndArgs(v){const E=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(v,E),args:this.getDefaultShellArgs(v,E)}}$acceptWorkspacePermissionsChanged(v){this._isWorkspaceShellAllowed=v}};d=je([Ue(0,R.IExtHostRpcService),Ue(1,A.IExtHostConfiguration),Ue(2,b.IExtHostWorkspace),Ue(3,n.IExtHostDocumentsAndEditors),Ue(4,C.ILogService)],d),e.ExtHostTerminalService=d}),define(ge[265],ve([0,1,19,18,66,6,2,5,255,12,78,81,27,184,13,61,42,35]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(l,o,t,i){this._disposables=new P.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const a=new y.RPCProtocol(l,null,i);o=E._transform(o,a);const r=new D.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());r.set(b.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},o)),r.set(s.IExtHostRpcService,new s.ExtHostRpcService(a)),r.set(d.IURITransformerService,new d.URITransformerService(i)),r.set(S.IHostUtils,t);const c=new g.InstantiationService(r,!0),h=c.invokeFunction(f=>f.get(v.IExtHostTerminalService));this._disposables.add(h),this._logService=c.invokeFunction(f=>f.get(n.ILogService)),T.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",o),this._extensionService=c.invokeFunction(f=>f.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(f=>{Error.prepareStackTrace=(k,L)=>{let $="",te,H;for(const x of L)$+=`
	at ${x.toString()}`,H=x.getFileName(),!te&&H&&(te=f.findSubstr(H));return p.set(k,te),`${k.name||"Error"}: ${k.message||""}${$}`}});const w=a.getProxy(A.MainContext.MainThreadExtensionService),u=a.getProxy(A.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(f=>{const k=I.transformErrorForSerialization(f),L=p.get(f);L?w.$onExtensionRuntimeError(L.identifier,k):u.$onUnexpectedError(k)})}terminate(l){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${l}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(t=>{});const o=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,_.timeout)(4e3),o]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(l,o){l.extensions.forEach(i=>i.extensionLocation=C.URI.revive(o.transformIncomingURIs(i.extensionLocation))),l.environment.appRoot=C.URI.revive(o.transformIncomingURIs(l.environment.appRoot));const t=l.environment.extensionDevelopmentLocationURI;return t&&(l.environment.extensionDevelopmentLocationURI=t.map(i=>C.URI.revive(o.transformIncomingURIs(i)))),l.environment.extensionTestsLocationURI=C.URI.revive(o.transformIncomingURIs(l.environment.extensionTestsLocationURI)),l.environment.globalStorageHome=C.URI.revive(o.transformIncomingURIs(l.environment.globalStorageHome)),l.environment.workspaceStorageHome=C.URI.revive(o.transformIncomingURIs(l.environment.workspaceStorageHome)),l.logsLocation=C.URI.revive(o.transformIncomingURIs(l.logsLocation)),l.logFile=C.URI.revive(o.transformIncomingURIs(l.logFile)),l.workspace=o.transformIncomingURIs(l.workspace),l}}e.ExtensionHostMain=E}),define(ge[266],ve([0,1,8,21,58,34,25,46,32,30]),function(Q,e,_,I,T,P,C,A,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class R{constructor(g,s,d){this.config=g,this.provider=s,this.sessionToken=d,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=g.filePattern,this.includePattern=g.includePattern&&P.parse(g.includePattern),this.maxResults=g.maxResults||void 0,this.exists=g.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=g.excludePattern&&P.parse(g.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(g=>g.cancel()),this.activeCancellationTokens=new Set}search(g){const s=this.config.folderQueries||[];return new Promise((d,S)=>{const v=E=>{this.resultCount++,g(E)};if(this.isCanceled)return d({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(E=>{const m=E.toString(),l=_.basename(m);this.globalExcludePattern&&this.globalExcludePattern(m,l)||this.matchFile(v,{base:E,basename:l})}),Promise.all(s.map(E=>this.searchInFolder(E,v))).then(E=>{d({limitHit:this.isLimitHit,stats:E[0]||void 0})},E=>{S(new Error((0,T.toErrorMessage)(E)))})})}searchInFolder(g,s){const d=new I.CancellationTokenSource;return new Promise((S,v)=>{const E=this.getSearchOptionsForFolder(g),m=this.initDirectoryTree(),l=new y.QueryGlobTester(this.config,g),o=!l.hasSiblingExcludeClauses();let t;new Promise(i=>(0,n.nextTick)(i)).then(()=>(this.activeCancellationTokens.add(d),t=A.StopWatch.create(),this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},E,d.token))).then(i=>{const a=t.elapsed(),r=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(i&&i.forEach(c=>{const h=_.posix.relative(g.folder.path,c.path);if(o){const p=_.basename(c.path);this.matchFile(s,{base:g.folder,relativePath:h,basename:p});return}this.addDirectoryEntries(m,g.folder,h,s)}),this.activeCancellationTokens.delete(d),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(m,l,s),{providerTime:a,postProcessTime:r.elapsed()})}).then(i=>{d.dispose(),S(i)},i=>{d.dispose(),v(i)})})}getSearchOptionsForFolder(g){const s=(0,y.resolvePatternsForProvider)(this.config.includePattern,g.includePattern),d=(0,y.resolvePatternsForProvider)(this.config.excludePattern,g.excludePattern);return{folder:g.folder,excludes:d,includes:s,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}addDirectoryEntries({pathToEntries:g},s,d,S){if(d===this.filePattern){const E=_.basename(this.filePattern);this.matchFile(S,{base:s,relativePath:this.filePattern,basename:E})}function v(E){const m=_.basename(E),l=_.dirname(E);let o=g[l];o||(o=g[l]=[],v(l)),o.push({base:s,relativePath:E,basename:m})}v(d)}matchDirectoryTree({rootEntries:g,pathToEntries:s},d,S){const v=this,E=this.filePattern;function m(l){const o=P.hasSiblingFn(()=>l.map(t=>t.basename));for(let t=0,i=l.length;t<i;t++){const a=l[t],{relativePath:r,basename:c}=a;if(!!d.includedInQuerySync(r,c,E!==c?o:void 0)){const h=s[r];if(h)m(h);else{if(r===E)continue;v.matchFile(S,a)}if(v.isLimitHit)break}}}m(g)}matchFile(g,s){(!this.includePattern||s.relativePath&&this.includePattern(s.relativePath,s.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||g(s))}}class D{constructor(){this.sessions=new Map}fileSearch(g,s,d,S){const v=this.getSessionTokenSource(g.cacheKey),E=new R(g,s,v&&v.token);let m=0;const l=o=>{m+=o.length,d(o.map(t=>this.rawMatchToSearchItem(t)))};return this.doSearch(E,D.BATCH_SIZE,l,S).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:m,detailStats:o.stats}}))}clearCache(g){const s=this.getSessionTokenSource(g);s&&s.cancel()}getSessionTokenSource(g){if(!!g)return this.sessions.has(g)||this.sessions.set(g,new I.CancellationTokenSource),this.sessions.get(g)}rawMatchToSearchItem(g){return g.relativePath?{resource:C.joinPath(g.base,g.relativePath)}:{resource:g.base}}doSearch(g,s,d,S){S.onCancellationRequested(()=>{g.cancel()});const v=m=>{m&&(E.push(m),s>0&&E.length>=s&&(d(E),E=[]))};let E=[];return g.search(v).then(m=>(E.length&&d(E),m),m=>(E.length&&d(E),Promise.reject(m)))}}e.FileSearchManager=D,D.BATCH_SIZE=512}),define(ge[126],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=e.Position=void 0;class _{constructor(P,C){this.line=P,this.character=C}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,C){return new _(0,0)}with(P){return new _(0,0)}}e.Position=_;class I{constructor(P,C,A,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new _(P,C),this.end=new _(A,y)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new I(0,0,0,0)}with(P){return new I(0,0,0,0)}}e.Range=I}),define(ge[127],ve([0,1,8,14,21,58,25,34,2,32,30,11]),function(Q,e,_,I,T,P,C,A,y,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class b{constructor(m,l,o){this.query=m,this.provider=l,this.fileUtils=o,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(m,l){const o=this.query.folderQueries||[],t=new T.CancellationTokenSource;return l.onCancellationRequested(()=>t.cancel()),new Promise((i,a)=>{this.collector=new s(m);let r=!1;const c=(h,p)=>{if(!r&&!this.isLimitHit){const w=this.resultSize(h);S(h)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,r=!0,t.cancel(),h=this.trimResultToSize(h,this.query.maxResults-this.resultCount));const u=this.resultSize(h);this.resultCount+=u,(u>0||!S(h))&&this.collector.add(h,p)}};Promise.all(o.map((h,p)=>this.searchInFolder(h,w=>c(w,p),t.token))).then(h=>{t.dispose(),this.collector.flush();const p=h.some(w=>!!w&&!!w.limitHit);i({limitHit:this.isLimitHit||p,stats:{type:"textSearchProvider"}})},h=>{t.dispose();const p=(0,P.toErrorMessage)(h);a(new Error(p))})})}resultSize(m){return S(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}trimResultToSize(m,l){const o=Array.isArray(m.ranges)?m.ranges:[m.ranges],t=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:o.slice(0,l),preview:{matches:t.slice(0,l),text:m.preview.text},uri:m.uri}}searchInFolder(m,l,o){const t=new n.QueryGlobTester(this.query,m),i=[],a={report:c=>{if(!!this.validateProviderResult(c)){const h=m.folder.scheme===D.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(c.uri))):void 0,p=C.relativePath(m.folder,c.uri);p&&i.push(t.includedInQuery(p,_.basename(p),h).then(w=>{w&&l(c)}))}}},r=this.getSearchOptionsForFolder(m);return new Promise(c=>(0,R.nextTick)(c)).then(()=>this.provider.provideTextSearchResults(g(this.query.contentPattern),r,a,o)).then(c=>Promise.all(i).then(()=>c))}validateProviderResult(m){if(S(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(m){const l=(0,n.resolvePatternsForProvider)(this.query.includePattern,m.includePattern),o=(0,n.resolvePatternsForProvider)(this.query.excludePattern,m.excludePattern),t={folder:y.URI.from(m.folder),excludes:o,includes:l,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.fileUtils.toCanonicalName(m.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=b;function g(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class s{constructor(m){this._onResult=m,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new v(512,l=>this.sendItems(l))}add(m,l){this._currentFileMatch&&(this._currentFolderIdx!==l||!C.isEqual(this._currentUri,m.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=l,this._currentFileMatch={resource:m.uri,results:[]}),this._currentFileMatch.results.push(d(m))}pushToCollector(){const m=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,m)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(m){this._onResult(m)}}e.TextSearchResultsCollector=s;function d(E){return S(E)?{preview:{matches:(0,I.mapArrayOrNot)(E.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:E.preview.text},ranges:(0,I.mapArrayOrNot)(E.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function S(E){return!!E.preview}e.extensionResultIsMatch=S;class v{constructor(m,l){this.maxBatchSize=m,this.cb=l,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(m,l){!m||this.addItemToBatch(m,l)}addItems(m,l){!m||this.addItemsToBatch(m,l)}addItemToBatch(m,l){this.batch.push(m),this.batchSize+=l,this.onUpdate()}addItemsToBatch(m,l){this.batch=this.batch.concat(m),this.batchSize+=l,this.onUpdate()}onUpdate(){this.totalNumberCompleted<v.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},v.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=v,v.TIMEOUT=4e3,v.START_BATCH_AFTER_COUNT=50}),define(ge[67],ve([0,1,6,5,4,266,13,61,12,2,127]),function(Q,e,_,I,T,P,C,A,y,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let D=class{constructor(d,S,v){this.extHostRpc=d,this._uriTransformer=S,this._logService=v,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,S){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const v=this._handlePool++;return this._textSearchProvider.set(v,S),this._proxy.$registerTextSearchProvider(v,this._transformScheme(d)),(0,_.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}registerFileSearchProvider(d,S){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const v=this._handlePool++;return this._fileSearchProvider.set(v,S),this._proxy.$registerFileSearchProvider(v,this._transformScheme(d)),(0,_.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}$provideFileSearchResults(d,S,v,E){const m=b(v),l=this._fileSearchProvider.get(d);if(l)return this._fileSearchManager.fileSearch(m,l,o=>{this._proxy.$handleFileMatch(d,S,o.map(t=>t.resource))},E);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,S,v,E){const m=this._textSearchProvider.get(d);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const l=b(v);return this.createTextSearchManager(l,m).search(t=>this._proxy.$handleTextMatch(d,S,t),E)}createTextSearchManager(d,S){return new R.TextSearchManager(d,S,{readdir:v=>Promise.resolve([]),toCanonicalName:v=>v})}};D=je([Ue(0,C.IExtHostRpcService),Ue(1,A.IURITransformerService),Ue(2,y.ILogService)],D),e.ExtHostSearch=D;function b(s){return Object.assign(Object.assign({},s),{folderQueries:s.folderQueries&&s.folderQueries.map(g),extraFileResources:s.extraFileResources&&s.extraFileResources.map(d=>n.URI.revive(d))})}e.reviveQuery=b;function g(s){return Object.assign(Object.assign({},s),{folder:n.URI.revive(s.folder)})}}),define(ge[267],ve([0,1,158,21,18,3,56,2,150,104,140,76,44,5,230,229,51,231,36,232,233,234,215,235,39,42,236,216,238,239,240,63,219,242,243,244,88,35,245,220,20,7,248,64,125,33,41,53,200,237,114,124,65,45,67,12,61,13,27,241,198,50,62,227,246,197,89,87,251,249,250,228,60,258,247,86,194,117]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d,S,v,E,m,l,o,t,i,a,r,c,h,p,w,u,f,k,L,$,te,H,x,B,F,U,M,N,O,j,q,X,me,we,Ae,Ie,Me,V,Y,ee,ae,fe,De,Oe,be,ke,Te,xe,Se,Ke,G,re,Ee,Ne,Ve,Be,et,K,oe,he,Z,ne,le){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function pe(_e){const He=_e.get(Oe.IExtHostInitDataService),We=_e.get(K.IExtHostFileSystemInfo),qe=_e.get(Ee.IExtHostConsumerFileSystem),Ye=_e.get(r.IExtHostExtensionService),Ze=_e.get(q.IExtHostWorkspace),ut=_e.get(le.IExtHostTelemetry),ot=_e.get(E.IExtHostConfiguration),nt=_e.get(fe.IURITransformerService),ue=_e.get(De.IExtHostRpcService),Ce=_e.get(H.IExtHostStorage),ce=_e.get(re.IExtensionStoragePaths),J=_e.get(ae.ILogService),Re=_e.get(Te.IExtHostTunnelService),Le=_e.get(xe.IExtHostApiDeprecationService),Je=_e.get(j.IExtHostWindow),Ge=_e.get(Z.IExtHostSecretState);ue.set(g.ExtHostContext.ExtHostFileSystemInfo,We),ue.set(g.ExtHostContext.ExtHostLogService,J),ue.set(g.ExtHostContext.ExtHostWorkspace,Ze),ue.set(g.ExtHostContext.ExtHostConfiguration,ot),ue.set(g.ExtHostContext.ExtHostExtensionService,Ye),ue.set(g.ExtHostContext.ExtHostStorage,Ce),ue.set(g.ExtHostContext.ExtHostTunnelService,Re),ue.set(g.ExtHostContext.ExtHostWindow,Je),ue.set(g.ExtHostContext.ExtHostSecretState,Ge),ue.set(g.ExtHostContext.ExtHostTelemetry,ut);const rt=ue.set(g.ExtHostContext.ExtHostDecorations,_e.get(Me.IExtHostDecorations)),at=ue.set(g.ExtHostContext.ExtHostDocumentsAndEditors,_e.get(a.IExtHostDocumentsAndEditors)),Qe=ue.set(g.ExtHostContext.ExtHostCommands,_e.get(S.IExtHostCommands)),ct=ue.set(g.ExtHostContext.ExtHostTerminalService,_e.get(x.IExtHostTerminalService)),st=ue.set(g.ExtHostContext.ExtHostDebugService,_e.get(Y.IExtHostDebugService)),gt=ue.set(g.ExtHostContext.ExtHostSearch,_e.get(ee.IExtHostSearch)),Et=ue.set(g.ExtHostContext.ExtHostTask,_e.get(V.IExtHostTask)),Dt=ue.set(g.ExtHostContext.ExtHostOutputService,_e.get(f.IExtHostOutputService)),wt=ue.set(g.ExtHostContext.ExtHostEditorTabs,new ne.ExtHostEditorTabs),St=ue.set(g.ExtHostContext.ExtHostUrls,new N.ExtHostUrls(ue)),pt=ue.set(g.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(ue,at)),Lt=ue.set(g.ExtHostContext.ExtHostDocumentContentProviders,new o.ExtHostDocumentContentProvider(ue,at,J)),Ft=ue.set(g.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(J,pt,ue.getProxy(g.MainContext.MainThreadBulkEdits))),ft=ue.set(g.ExtHostContext.ExtHostNotebook,new be.ExtHostNotebookController(ue,Qe,at,pt,He.environment,J,ce)),yt=ue.set(g.ExtHostContext.ExtHostEditors,new B.ExtHostEditors(ue,at)),Vt=ue.set(g.ExtHostContext.ExtHostTreeViews,new F.ExtHostTreeViews(ue.getProxy(g.MainContext.MainThreadTreeViews),Qe,J)),Qt=ue.set(g.ExtHostContext.ExtHostEditorInsets,new we.ExtHostEditorInsets(ue.getProxy(g.MainContext.MainThreadEditorInsets),yt,He.environment)),Mt=ue.set(g.ExtHostContext.ExtHostDiagnostics,new m.ExtHostDiagnostics(ue,J)),ht=ue.set(g.ExtHostContext.ExtHostLanguageFeatures,new p.ExtHostLanguageFeatures(ue,nt,pt,Qe,Mt,J,Le)),Xt=ue.set(g.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(ue,ht)),kt=ue.set(g.ExtHostContext.ExtHostFileSystemEventService,new h.ExtHostFileSystemEventService(ue,J,at)),Nt=ue.set(g.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(ue,Ze,Qe)),jt=ue.set(g.ExtHostContext.ExtHostSCM,new $.ExtHostSCM(ue,Qe,J)),Jt=ue.set(g.ExtHostContext.ExtHostComments,new v.ExtHostComments(ue,Qe,pt)),sn=ue.set(g.ExtHostContext.ExtHostProgress,new k.ExtHostProgress(ue.getProxy(g.MainContext.MainThreadProgress))),gn=ue.set(g.ExtHostContext.ExtHosLabelService,new Ae.ExtHostLabelService(ue)),on=ue.set(g.ExtHostContext.ExtHostTheming,new ke.ExtHostTheming(ue)),Ot=ue.set(g.ExtHostContext.ExtHostAuthentication,new Se.ExtHostAuthentication(ue)),pn=ue.set(g.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(ue,Qe)),Ut=ue.set(g.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(ue,He.environment,Ze,J,Le)),xt=ue.set(g.ExtHostContext.ExtHostWebviewPanels,new Be.ExtHostWebviewPanels(ue,Ut,Ze)),vn=ue.set(g.ExtHostContext.ExtHostCustomEditors,new Ve.ExtHostCustomEditors(ue,pt,ce,Ut,xt)),wn=ue.set(g.ExtHostContext.ExtHostWebviewViews,new Ne.ExtHostWebviewViews(ue,Ut)),At=ue.set(g.ExtHostContext.ExtHostTesting,new oe.ExtHostTesting(ue,at,Ze)),bn=ue.set(g.ExtHostContext.ExtHostUriOpeners,new he.ExtHostUriOpeners(ue)),qt=(0,me.values)(g.ExtHostContext);ue.assertRegistered(qt);const _n=new et.ExtHostBulkEdits(ue,at),En=new d.ExtHostClipboard(ue),Bt=new u.ExtHostMessageService(ue,J),an=new l.ExtHostDialogs(ue),Kt=new te.ExtHostStatusBar(ue,Qe.converter),Wt=new w.ExtHostLanguages(ue,pt);return s.ExtHostApiCommands.register(Qe),function(Fe,Yt,Zt){const mt=function(){let ie=!Fe.isUnderDevelopment;function de(Pe){ie||(J.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Pe(lt){if(Array.isArray(lt))lt.forEach(Pe);else if(typeof lt=="string")de(lt);else{const bt=lt;typeof bt.scheme=="undefined"&&de(lt),!Fe.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,X.throwProposedApiError)(Fe)}return lt}}(),Sn={getSession(ie,de,Pe){return Ot.getSession(Fe,ie,de,Pe)},get onDidChangeSessions(){return Ot.onDidChangeSessions},registerAuthenticationProvider(ie,de,Pe,lt){return Ot.registerAuthenticationProvider(ie,de,Pe,lt)},get onDidChangeAuthenticationProviders(){return(0,X.checkProposedApiEnabled)(Fe),Ot.onDidChangeAuthenticationProviders},get providers(){return(0,X.checkProposedApiEnabled)(Fe),Ot.providers},logout(ie,de){return(0,X.checkProposedApiEnabled)(Fe),Ot.removeSession(ie,de)}},yn={registerCommand(ie,de,Pe){return Qe.registerCommand(!0,ie,de,Pe)},registerTextEditorCommand(ie,de,Pe){return Qe.registerCommand(!0,ie,(...lt)=>{const bt=yt.getActiveTextEditor();if(!bt){J.warn("Cannot execute "+ie+" because there is no active text editor.");return}return bt.edit(z=>{de.apply(Pe,[bt,z,...lt])}).then(z=>{z||J.warn("Edits from command "+ie+" were not applied.")},z=>{J.warn("An error occurred while running command "+ie,z)})})},registerDiffInformationCommand:(ie,de,Pe)=>((0,X.checkProposedApiEnabled)(Fe),Qe.registerCommand(!0,ie,async(...lt)=>{const bt=at.activeEditor(!0);if(!bt){J.warn("Cannot execute "+ie+" because there is no active text editor.");return}const z=await yt.getDiffInformation(bt.id);de.apply(Pe,[z,...lt])})),executeCommand(ie,...de){return Qe.executeCommand(ie,...de)},getCommands(ie=!1){return Qe.getCommands(ie)}},ln={get machineId(){return He.telemetryInfo.machineId},get sessionId(){return He.telemetryInfo.sessionId},get language(){return He.environment.appLanguage},get appName(){return He.environment.appName},get appRoot(){var ie,de;return(de=(ie=He.environment.appRoot)===null||ie===void 0?void 0:ie.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return He.environment.appUriScheme},get clipboard(){return En.value},get shell(){return ct.getDefaultShell(!1,Zt)},get isTelemetryEnabled(){return ut.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ut.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ie=Date.now()-new Date(He.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,de){return Je.openUri(ie,{allowTunneling:!!He.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},asExternalUri(ie){return ie.scheme===He.environment.appUriScheme?St.createAppUri(ie):Je.asExternalUri(ie,{allowTunneling:!!He.remote.authority})},get remoteName(){return(0,Ie.getRemoteName)(He.remote.authority)},get uiKind(){return He.uiKind}};He.environment.extensionTestsLocationURI||Object.freeze(ln);const cn=He.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,Dn={registerTestProvider(ie){return(0,X.checkProposedApiEnabled)(Fe),At.registerTestProvider(ie)},createDocumentTestObserver(ie){return(0,X.checkProposedApiEnabled)(Fe),At.createTextDocumentTestObserver(ie)},createWorkspaceTestObserver(ie){return(0,X.checkProposedApiEnabled)(Fe),At.createWorkspaceTestObserver(ie)},runTests(ie){return(0,X.checkProposedApiEnabled)(Fe),At.runTests(ie)},publishTestResult(ie,de=!0){return(0,X.checkProposedApiEnabled)(Fe),At.publishExtensionProvidedResults(ie,de)},get onDidChangeTestResults(){return(0,X.checkProposedApiEnabled)(Fe),At.onResultsChanged},get testResults(){return(0,X.checkProposedApiEnabled)(Fe),At.results}},en={getExtension(ie){const de=Yt.getExtensionDescription(ie);if(de)return new r.Extension(Ye,Fe.identifier,de,cn)},get all(){return Yt.getAllExtensionDescriptions().map(ie=>new r.Extension(Ye,Fe.identifier,ie,cn))},get onDidChange(){return Yt.onDidChange}},Cn={createDiagnosticCollection(ie){return Mt.createDiagnosticCollection(Fe.identifier,ie)},get onDidChangeDiagnostics(){return Mt.onDidChangeDiagnostics},getDiagnostics:ie=>Mt.getDiagnostics(ie),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(ie,de){return Wt.changeLanguage(ie.uri,de)},match(ie,de){return(0,D.score)(U.LanguageSelector.from(ie),de.uri,de.languageId,!0)},registerCodeActionsProvider(ie,de,Pe){return ht.registerCodeActionProvider(Fe,mt(ie),de,Pe)},registerCodeLensProvider(ie,de){return ht.registerCodeLensProvider(Fe,mt(ie),de)},registerDefinitionProvider(ie,de){return ht.registerDefinitionProvider(Fe,mt(ie),de)},registerDeclarationProvider(ie,de){return ht.registerDeclarationProvider(Fe,mt(ie),de)},registerImplementationProvider(ie,de){return ht.registerImplementationProvider(Fe,mt(ie),de)},registerTypeDefinitionProvider(ie,de){return ht.registerTypeDefinitionProvider(Fe,mt(ie),de)},registerHoverProvider(ie,de){return ht.registerHoverProvider(Fe,mt(ie),de,Fe.identifier)},registerEvaluatableExpressionProvider(ie,de){return ht.registerEvaluatableExpressionProvider(Fe,mt(ie),de,Fe.identifier)},registerInlineValuesProvider(ie,de){return ht.registerInlineValuesProvider(Fe,mt(ie),de,Fe.identifier)},registerDocumentHighlightProvider(ie,de){return ht.registerDocumentHighlightProvider(Fe,mt(ie),de)},registerLinkedEditingRangeProvider(ie,de){return ht.registerLinkedEditingRangeProvider(Fe,mt(ie),de)},registerReferenceProvider(ie,de){return ht.registerReferenceProvider(Fe,mt(ie),de)},registerRenameProvider(ie,de){return ht.registerRenameProvider(Fe,mt(ie),de)},registerDocumentSymbolProvider(ie,de,Pe){return ht.registerDocumentSymbolProvider(Fe,mt(ie),de,Pe)},registerWorkspaceSymbolProvider(ie){return ht.registerWorkspaceSymbolProvider(Fe,ie)},registerDocumentFormattingEditProvider(ie,de){return ht.registerDocumentFormattingEditProvider(Fe,mt(ie),de)},registerDocumentRangeFormattingEditProvider(ie,de){return ht.registerDocumentRangeFormattingEditProvider(Fe,mt(ie),de)},registerOnTypeFormattingEditProvider(ie,de,Pe,...lt){return ht.registerOnTypeFormattingEditProvider(Fe,mt(ie),de,[Pe].concat(lt))},registerDocumentSemanticTokensProvider(ie,de,Pe){return ht.registerDocumentSemanticTokensProvider(Fe,mt(ie),de,Pe)},registerDocumentRangeSemanticTokensProvider(ie,de,Pe){return ht.registerDocumentRangeSemanticTokensProvider(Fe,mt(ie),de,Pe)},registerSignatureHelpProvider(ie,de,Pe,...lt){return typeof Pe=="object"?ht.registerSignatureHelpProvider(Fe,mt(ie),de,Pe):ht.registerSignatureHelpProvider(Fe,mt(ie),de,typeof Pe=="undefined"?[]:[Pe,...lt])},registerCompletionItemProvider(ie,de,...Pe){return ht.registerCompletionItemProvider(Fe,mt(ie),de,Pe)},registerDocumentLinkProvider(ie,de){return ht.registerDocumentLinkProvider(Fe,mt(ie),de)},registerColorProvider(ie,de){return ht.registerColorProvider(Fe,mt(ie),de)},registerFoldingRangeProvider(ie,de){return ht.registerFoldingRangeProvider(Fe,mt(ie),de)},registerSelectionRangeProvider(ie,de){return ht.registerSelectionRangeProvider(Fe,ie,de)},registerCallHierarchyProvider(ie,de){return ht.registerCallHierarchyProvider(Fe,ie,de)},setLanguageConfiguration:(ie,de)=>ht.setLanguageConfiguration(Fe,ie,de),getTokenInformationAtPosition(ie,de){return(0,X.checkProposedApiEnabled)(Fe),Wt.tokenAtPosition(ie,de)},registerInlineHintsProvider(ie,de){return(0,X.checkProposedApiEnabled)(Fe),ht.registerInlineHintsProvider(Fe,ie,de)}},kn={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return ct.activeTerminal},get terminals(){return ct.terminals},async showTextDocument(ie,de,Pe){const lt=await(A.URI.isUri(ie)?Promise.resolve(un.openTextDocument(ie)):Promise.resolve(ie));return yt.showTextDocument(lt,de,Pe)},createTextEditorDecorationType(ie){return yt.createTextEditorDecorationType(ie)},onDidChangeActiveTextEditor(ie,de,Pe){return yt.onDidChangeActiveTextEditor(ie,de,Pe)},onDidChangeVisibleTextEditors(ie,de,Pe){return yt.onDidChangeVisibleTextEditors(ie,de,Pe)},onDidChangeTextEditorSelection(ie,de,Pe){return yt.onDidChangeTextEditorSelection(ie,de,Pe)},onDidChangeTextEditorOptions(ie,de,Pe){return yt.onDidChangeTextEditorOptions(ie,de,Pe)},onDidChangeTextEditorVisibleRanges(ie,de,Pe){return yt.onDidChangeTextEditorVisibleRanges(ie,de,Pe)},onDidChangeTextEditorViewColumn(ie,de,Pe){return yt.onDidChangeTextEditorViewColumn(ie,de,Pe)},onDidCloseTerminal(ie,de,Pe){return ct.onDidCloseTerminal(ie,de,Pe)},onDidOpenTerminal(ie,de,Pe){return ct.onDidOpenTerminal(ie,de,Pe)},onDidChangeActiveTerminal(ie,de,Pe){return ct.onDidChangeActiveTerminal(ie,de,Pe)},onDidChangeTerminalDimensions(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ct.onDidChangeTerminalDimensions(ie,de,Pe)},onDidWriteTerminalData(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ct.onDidWriteTerminalData(ie,de,Pe)},get state(){return Je.state},onDidChangeWindowState(ie,de,Pe){return Je.onDidChangeWindowState(ie,de,Pe)},showInformationMessage(ie,...de){return Bt.showMessage(Fe,C.default.Info,ie,de[0],de.slice(1))},showWarningMessage(ie,...de){return Bt.showMessage(Fe,C.default.Warning,ie,de[0],de.slice(1))},showErrorMessage(ie,...de){return Bt.showMessage(Fe,C.default.Error,ie,de[0],de.slice(1))},showQuickPick(ie,de,Pe){return Nt.showQuickPick(ie,!!Fe.enableProposedApi,de,Pe)},showWorkspaceFolderPick(ie){return Nt.showWorkspaceFolderPick(ie)},showInputBox(ie,de){return Nt.showInput(ie,de)},showOpenDialog(ie){return an.showOpenDialog(ie)},showSaveDialog(ie){return an.showSaveDialog(ie)},createStatusBarItem(ie,de){let Pe,lt,bt,z;return ie&&typeof ie!="number"?(Pe=ie.id,lt=ie.name,bt=ie.alignment,de=ie.priority,z=ie.accessibilityInformation):(Pe=Fe.identifier.value,lt=_.localize(0,null,Fe.displayName||Fe.name),bt=ie),Kt.createStatusBarEntry(Pe,lt,bt,de,z)},setStatusBarMessage(ie,de){return Kt.setStatusBarMessage(ie,de)},withScmProgress(ie){return Le.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),sn.withProgress(Fe,{location:M.ProgressLocation.SourceControl},(de,Pe)=>ie({report(lt){}}))},withProgress(ie,de){return sn.withProgress(Fe,ie,de)},createOutputChannel(ie){return Dt.createOutputChannel(ie)},createWebviewPanel(ie,de,Pe,lt){return xt.createWebviewPanel(Fe,ie,de,Pe,lt)},createWebviewTextEditorInset(ie,de,Pe,lt){return(0,X.checkProposedApiEnabled)(Fe),Qt.createWebviewEditorInset(ie,de,Pe,lt,Fe)},createTerminal(ie,de,Pe){return typeof ie=="object"?"pty"in ie?ct.createExtensionTerminal(ie):(ie.initialText&&(0,X.checkProposedApiEnabled)(Fe),ie.icon&&(0,X.checkProposedApiEnabled)(Fe),ct.createTerminalFromOptions(ie)):ct.createTerminal(ie,de,Pe)},registerTerminalLinkProvider(ie){return ct.registerLinkProvider(ie)},registerTreeDataProvider(ie,de){return Vt.registerTreeDataProvider(ie,de,Fe)},createTreeView(ie,de){return Vt.createTreeView(ie,de,Fe)},registerWebviewPanelSerializer:(ie,de)=>xt.registerWebviewPanelSerializer(Fe,ie,de),registerCustomEditorProvider:(ie,de,Pe={})=>vn.registerCustomEditorProvider(Fe,ie,de,Pe),registerFileDecorationProvider(ie){return rt.registerFileDecorationProvider(ie,Fe.identifier)},registerUriHandler(ie){return St.registerUriHandler(Fe.identifier,ie)},createQuickPick(){return Nt.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Nt.createInputBox(Fe.identifier)},get activeColorTheme(){return on.activeColorTheme},onDidChangeActiveColorTheme(ie,de,Pe){return on.onDidChangeActiveColorTheme(ie,de,Pe)},registerWebviewViewProvider(ie,de,Pe){return wn.registerWebviewViewProvider(Fe,ie,de,Pe==null?void 0:Pe.webviewOptions)},get activeNotebookEditor(){return(0,X.checkProposedApiEnabled)(Fe),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeActiveNotebookEditor(ie,de,Pe)},get visibleNotebookEditors(){return(0,X.checkProposedApiEnabled)(Fe),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookEditorSelection(ie,de,Pe)},onDidChangeNotebookEditorVisibleRanges(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookEditorVisibleRanges(ie,de,Pe)},showNotebookDocument(ie,de){return(0,X.checkProposedApiEnabled)(Fe),ft.showNotebookDocument(ie,de)},registerExternalUriOpener(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),bn.registerExternalUriOpener(Fe.identifier,ie,de,Pe)},get openEditors(){return(0,X.checkProposedApiEnabled)(Fe),wt.tabs},get onDidChangeOpenEditors(){return(0,X.checkProposedApiEnabled)(Fe),wt.onDidChangeTabs}},un={get rootPath(){return Le.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ze.getPath()},set rootPath(ie){throw T.readonly()},getWorkspaceFolder(ie){return Ze.getWorkspaceFolder(ie)},get workspaceFolders(){return Ze.getWorkspaceFolders()},get name(){return Ze.name},set name(ie){throw T.readonly()},get workspaceFile(){return Ze.workspaceFile},set workspaceFile(ie){throw T.readonly()},updateWorkspaceFolders:(ie,de,...Pe)=>Ze.updateWorkspaceFolders(Fe,ie,de||0,...Pe),onDidChangeWorkspaceFolders:function(ie,de,Pe){return Ze.onDidChangeWorkspace(ie,de,Pe)},asRelativePath:(ie,de)=>Ze.getRelativePath(ie,de),findFiles:(ie,de,Pe,lt)=>Ze.findFiles(U.GlobPattern.from(ie),U.GlobPattern.from(de),Pe,Fe.identifier,lt),findTextInFiles:(ie,de,Pe,lt)=>{let bt,z;return typeof de=="object"?(bt=de,z=Pe):(bt={},z=de,lt=Pe),Ze.findTextInFiles(ie,bt||{},z,Fe.identifier,lt)},saveAll:ie=>Ze.saveAll(ie),applyEdit(ie){return _n.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,de,Pe,lt)=>kt.createFileSystemWatcher(U.GlobPattern.from(ie),de,Pe,lt),get textDocuments(){return pt.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw T.readonly()},openTextDocument(ie){let de;const Pe=ie;if(typeof ie=="string")de=Promise.resolve(A.URI.file(ie));else if(A.URI.isUri(ie))de=Promise.resolve(ie);else if(!Pe||typeof Pe=="object")de=pt.createDocumentData(Pe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(lt=>pt.ensureDocumentData(lt).then(bt=>bt.document))},onDidOpenTextDocument:(ie,de,Pe)=>pt.onDidAddDocument(ie,de,Pe),onDidCloseTextDocument:(ie,de,Pe)=>pt.onDidRemoveDocument(ie,de,Pe),onDidChangeTextDocument:(ie,de,Pe)=>pt.onDidChangeDocument(ie,de,Pe),onDidSaveTextDocument:(ie,de,Pe)=>pt.onDidSaveDocument(ie,de,Pe),onWillSaveTextDocument:(ie,de,Pe)=>Ft.getOnWillSaveTextDocumentEvent(Fe)(ie,de,Pe),onDidChangeConfiguration:(ie,de,Pe)=>Zt.onDidChangeConfiguration(ie,de,Pe),getConfiguration(ie,de){return de=arguments.length===1?void 0:de,Zt.getConfiguration(ie,de,Fe)},registerTextDocumentContentProvider(ie,de){return Lt.registerTextDocumentContentProvider(ie,de)},registerTaskProvider:(ie,de)=>(Le.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Fe,ie,de)),registerFileSystemProvider(ie,de,Pe){return Xt.registerFileSystemProvider(Fe.identifier,ie,de,Pe)},get fs(){return qe.value},registerFileSearchProvider:(ie,de)=>((0,X.checkProposedApiEnabled)(Fe),gt.registerFileSearchProvider(ie,de)),registerTextSearchProvider:(ie,de)=>((0,X.checkProposedApiEnabled)(Fe),gt.registerTextSearchProvider(ie,de)),registerRemoteAuthorityResolver:(ie,de)=>((0,X.checkProposedApiEnabled)(Fe),Ye.registerRemoteAuthorityResolver(ie,de)),registerResourceLabelFormatter:ie=>((0,X.checkProposedApiEnabled)(Fe),gn.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,de,Pe)=>kt.onDidCreateFile(ie,de,Pe),onDidDeleteFiles:(ie,de,Pe)=>kt.onDidDeleteFile(ie,de,Pe),onDidRenameFiles:(ie,de,Pe)=>kt.onDidRenameFile(ie,de,Pe),onWillCreateFiles:(ie,de,Pe)=>kt.getOnWillCreateFileEvent(Fe)(ie,de,Pe),onWillDeleteFiles:(ie,de,Pe)=>kt.getOnWillDeleteFileEvent(Fe)(ie,de,Pe),onWillRenameFiles:(ie,de,Pe)=>kt.getOnWillRenameFileEvent(Fe)(ie,de,Pe),openTunnel:ie=>((0,X.checkProposedApiEnabled)(Fe),Re.openTunnel(Fe,ie).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,X.checkProposedApiEnabled)(Fe),Re.getTunnels()},onDidChangeTunnels:(ie,de,Pe)=>((0,X.checkProposedApiEnabled)(Fe),Re.onDidChangeTunnels(ie,de,Pe)),registerPortAttributesProvider:(ie,de)=>((0,X.checkProposedApiEnabled)(Fe),Re.registerPortsAttributesProvider(ie,de)),registerTimelineProvider:(ie,de)=>((0,X.checkProposedApiEnabled)(Fe),pn.registerTimelineProvider(ie,de,Fe.identifier,Qe.converter)),get trustState(){return(0,X.checkProposedApiEnabled)(Fe),Ze.trustState},requestWorkspaceTrust:ie=>((0,X.checkProposedApiEnabled)(Fe),Ze.requestWorkspaceTrust(ie)),onDidChangeWorkspaceTrustState:(ie,de,Pe)=>Ze.onDidChangeWorkspaceTrustState(ie,de,Pe)},In={get inputBox(){return Le.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),jt.getLastInputBox(Fe)},createSourceControl(ie,de,Pe){return jt.createSourceControl(Fe,ie,de,Pe)}},Pn={createCommentController(ie,de){return Jt.createCommentController(Fe,ie,de)}},dn={get activeDebugSession(){return st.activeDebugSession},get activeDebugConsole(){return st.activeDebugConsole},get breakpoints(){return st.breakpoints},onDidStartDebugSession(ie,de,Pe){return st.onDidStartDebugSession(ie,de,Pe)},onDidTerminateDebugSession(ie,de,Pe){return st.onDidTerminateDebugSession(ie,de,Pe)},onDidChangeActiveDebugSession(ie,de,Pe){return st.onDidChangeActiveDebugSession(ie,de,Pe)},onDidReceiveDebugSessionCustomEvent(ie,de,Pe){return st.onDidReceiveDebugSessionCustomEvent(ie,de,Pe)},onDidChangeBreakpoints(ie,de,Pe){return st.onDidChangeBreakpoints(ie,de,Pe)},registerDebugConfigurationProvider(ie,de,Pe){return st.registerDebugConfigurationProvider(ie,de,Pe||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,de){return st.registerDebugAdapterDescriptorFactory(Fe,ie,de)},registerDebugAdapterTrackerFactory(ie,de){return st.registerDebugAdapterTrackerFactory(ie,de)},startDebugging(ie,de,Pe){return!Pe||typeof Pe=="object"&&"configuration"in Pe?st.startDebugging(ie,de,{parentSession:Pe}):st.startDebugging(ie,de,Pe||{})},stopDebugging(ie){return st.stopDebugging(ie)},addBreakpoints(ie){return st.addBreakpoints(ie)},removeBreakpoints(ie){return st.removeBreakpoints(ie)},asDebugSourceUri(ie,de){return st.asDebugSourceUri(ie,de)}},Gt={registerTaskProvider:(ie,de)=>Et.registerTaskProvider(Fe,ie,de),fetchTasks:ie=>Et.fetchTasks(ie),executeTask:ie=>Et.executeTask(Fe,ie),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(ie,de,Pe)=>Et.onDidStartTask(ie,de,Pe),onDidEndTask:(ie,de,Pe)=>Et.onDidEndTask(ie,de,Pe),onDidStartTaskProcess:(ie,de,Pe)=>Et.onDidStartTaskProcess(ie,de,Pe),onDidEndTaskProcess:(ie,de,Pe)=>Et.onDidEndTaskProcess(ie,de,Pe)},hn={openNotebookDocument:ie=>((0,X.checkProposedApiEnabled)(Fe),ft.openNotebookDocument(ie)),get onDidOpenNotebookDocument(){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidSaveNotebookDocument},get notebookDocuments(){return(0,X.checkProposedApiEnabled)(Fe),ft.notebookDocuments.map(ie=>ie.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeActiveNotebookKernel},registerNotebookSerializer(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.registerNotebookSerializer(Fe,ie,de,Pe)},registerNotebookContentProvider:(ie,de,Pe)=>((0,X.checkProposedApiEnabled)(Fe),ft.registerNotebookContentProvider(Fe,ie,de,Pe)),registerNotebookKernelProvider:(ie,de)=>((0,X.checkProposedApiEnabled)(Fe),ft.registerNotebookKernelProvider(Fe,ie,de)),createNotebookEditorDecorationType(ie){return(0,X.checkProposedApiEnabled)(Fe),ft.createNotebookEditorDecorationType(ie)},onDidChangeNotebookDocumentMetadata(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookDocumentMetadata(ie,de,Pe)},onDidChangeNotebookCells(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookCells(ie,de,Pe)},onDidChangeCellExecutionState(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookCellExecutionState(ie,de,Pe)},onDidChangeCellOutputs(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeCellOutputs(ie,de,Pe)},onDidChangeCellMetadata(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.onDidChangeCellMetadata(ie,de,Pe)},createConcatTextDocument(ie,de){return(0,X.checkProposedApiEnabled)(Fe),new G.ExtHostNotebookConcatDocument(ft,pt,ie,de)},createCellStatusBarItem(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.createNotebookCellStatusBarItemInternal(ie,de,Pe)},createNotebookCellExecutionTask(ie,de,Pe){return(0,X.checkProposedApiEnabled)(Fe),ft.createNotebookCellExecution(ie,de,Pe)}};return{version:He.version,authentication:Sn,commands:yn,comments:Pn,debug:dn,env:ln,extensions:en,languages:Cn,notebook:hn,scm:In,tasks:Gt,test:Dn,window:kn,workspace:un,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:g.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,EventEmitter:P.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:b.FileType,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,Hover:M.Hover,IndentAction:R.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:n.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,UIKind:g.UIKind,Uri:A.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlineHint:M.InlineHint,InlineHintKind:M.InlineHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookCellRange:M.NotebookCellRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookDocumentMetadata:M.NotebookDocumentMetadata,NotebookCellMetadata:M.NotebookCellMetadata,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,LinkedEditingRanges:M.LinkedEditingRanges,TestItem:M.TestItem,TestResultState:M.TestResultState,TestMessage:M.TestMessage,TestMessageSeverity:M.TestMessageSeverity,WorkspaceTrustState:M.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=pe}),define(ge[268],ve([0,1,78,63,33,124,36,51,39,35,65,45,67,89,88,50,62,125,87,60,86,117]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d,S,v,E,m,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(g.IExtensionStoragePaths,g.ExtensionStoragePaths),(0,_.registerSingleton)(S.IExtHostApiDeprecationService,S.ExtHostApiDeprecationService),(0,_.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands),(0,_.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration),(0,_.registerSingleton)(E.IExtHostConsumerFileSystem,E.ExtHostConsumerFileSystem),(0,_.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService),(0,_.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations),(0,_.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,_.registerSingleton)(m.IExtHostFileSystemInfo,m.ExtHostFileSystemInfo),(0,_.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,_.registerSingleton)(b.IExtHostSearch,b.ExtHostSearch),(0,_.registerSingleton)(s.IExtHostStorage,s.ExtHostStorage),(0,_.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,_.registerSingleton)(n.IExtHostTerminalService,n.WorkerExtHostTerminalService),(0,_.registerSingleton)(d.IExtHostTunnelService,d.ExtHostTunnelService),(0,_.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,_.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace),(0,_.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,_.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry)}),define(ge[90],ve([0,1,14,12,32,126]),function(Q,e,_,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function C(D){return D.startsWith("**")||D.startsWith("/")?D:`/${D}`}e.anchorGlob=C;function A(D,b,g,s){const d=(0,_.mapArrayOrNot)(g,y),S=new T.TextSearchMatch(b,d,s),v=S.preview.matches;return{ranges:(0,_.mapArrayOrNot)(d,n),uri:D,preview:{text:S.preview.text,matches:(0,_.mapArrayOrNot)(v,n)}}}e.createTextSearchResult=A;function y(D){return new T.SearchRange(D.start.line,D.start.character,D.end.line,D.end.character)}function n(D){return new P.Range(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn)}let R=class{constructor(b,g){this.prefix=b,this.logService=g}appendLine(b){this.logService.debug(`${this.prefix}#search`,b)}};R=je([Ue(1,I.ILogService)],R),e.OutputChannel=R}),define(ge[269],ve([0,1,91,22]),function(Q,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function T(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===t)}e.isUTFEncoding=T,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const P=512,C=512,A=512*8,y=512*128;class n{constructor(i){this.iconvLiteDecoder=i}static async create(i){let a;if(i!==e.UTF8)a=(await new Promise((c,h)=>{Q(["iconv-lite-umd"],c,h)})).getDecoder(g(i));else{const r=new TextDecoder;a={write(c){return r.decode(c,{stream:!0})},end(){return r.decode()}}}return new n(a)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function R(t,i){var a;const r=((a=i.minBytesRequiredForDetection)!==null&&a!==void 0?a:i.guessEncoding)?A:C;return new Promise((c,h)=>{const p=(0,_.newWriteableStream)(L=>L.join("")),w=[];let u=0,f;const k=async()=>{try{const L=await o({buffer:I.VSBuffer.concat(w),bytesRead:u},i.guessEncoding);L.encoding=await i.overwriteEncoding(L.encoding),f=await n.create(L.encoding);const $=f.write(I.VSBuffer.concat(w).buffer);p.write($),w.length=0,u=0,c({stream:p,detected:L})}catch(L){h(L)}};(0,_.listenStream)(t,{onData:async L=>{f?p.write(f.write(L.buffer)):(w.push(L),u+=L.byteLength,u>=r&&(t.pause(),await k(),setTimeout(()=>t.resume())))},onError:L=>p.error(L),onEnd:async()=>{f||await k(),p.end(f==null?void 0:f.end())}})})}e.toDecodeStream=R;async function D(t,i,a){const c=(await new Promise((w,u)=>{Q(["iconv-lite-umd"],w,u)})).getEncoder(g(i),a);let h=!1,p=!1;return{read(){if(p)return null;const w=t.read();if(typeof w!="string"){if(p=!0,!h&&(a==null?void 0:a.addBOM))switch(i){case e.UTF8:case e.UTF8_with_bom:return I.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const u=c.end();return u&&u.length>0?(h=!0,I.VSBuffer.wrap(u)):null}return h=!0,I.VSBuffer.wrap(c.write(w))}}}e.toEncodeReadable=D;async function b(t){return(await new Promise((a,r)=>{Q(["iconv-lite-umd"],a,r)})).encodingExists(g(t))}e.encodingExists=b;function g(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=g;function s(t,i){if(!t||i<e.UTF16be_BOM.length)return null;const a=t.readUInt8(0),r=t.readUInt8(1);if(a===e.UTF16be_BOM[0]&&r===e.UTF16be_BOM[1])return e.UTF16be;if(a===e.UTF16le_BOM[0]&&r===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const c=t.readUInt8(2);return a===e.UTF8_BOM[0]&&r===e.UTF8_BOM[1]&&c===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=s;const d=["ascii","utf-16","utf-32"];async function S(t){const i=await new Promise((p,w)=>{Q(["jschardet"],p,w)}),a=t.slice(0,y),r=m(a.buffer),c=i.detect(r);if(!c||!c.encoding)return null;const h=c.encoding.toLowerCase();return 0<=d.indexOf(h)?null:E(c.encoding)}const v={ibm866:"cp866",big5:"cp950"};function E(t){const i=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return v[i]||i}function m(t){let i="";for(let a=0;a<t.length;a++)i+=String.fromCharCode(t[a]);return i}function l(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const i=t.match(/windows(\d+)/);return i?"windows-"+i[1]:t}}e.toCanonicalName=l;function o({buffer:t,bytesRead:i},a){let r=s(t,i),c=!1;if(r!==e.UTF16be&&r!==e.UTF16le&&t){let h=!0,p=!0,w=!1;for(let u=0;u<i&&u<P;u++){const f=u%2==1,k=t.readUInt8(u)===0;if(k&&(w=!0),h&&(f&&!k||!f&&k)&&(h=!1),p&&(f&&k||!f&&!k)&&(p=!1),k&&!h&&!p)break}w&&(h?r=e.UTF16le:p?r=e.UTF16be:c=!0)}return a&&!c&&!r&&t?S(t.slice(0,i)).then(h=>({seemsBinary:!1,encoding:h})):{seemsBinary:c,encoding:r}}e.detectEncodingFromBuffer=o,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[128],ve([0,1,269,26,127]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends T.TextSearchManager{constructor(A,y,n=I){super(A,y,{readdir:R=>n.readdir(R.fsPath),toCanonicalName:R=>(0,_.toCanonicalName)(R)})}}e.NativeTextSearchManager=P}),define(ge[270],ve([0,1,271,285,286,2,287]),function(Q,e,_,I,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function A(D,b,g,s,d,S){const v=S.environment.useHostProxy,E=typeof v=="boolean"?v:!S.remote.isRemote,m=(0,C.createProxyResolver)({resolveProxy:o=>D.resolveProxy(o),getHttpProxySetting:()=>b.getConfiguration("http").get("proxy"),log:(o,t,...i)=>{switch(o){case C.LogLevel.Trace:s.trace(t,...i);break;case C.LogLevel.Debug:s.debug(t,...i);break;case C.LogLevel.Info:s.info(t,...i);break;case C.LogLevel.Warning:s.warn(t,...i);break;case C.LogLevel.Error:s.error(t,...i);break;case C.LogLevel.Critical:s.critical(t,...i);break;case C.LogLevel.Off:break;default:a(o,t,i);break}function a(r,c,...h){s.error("Unknown log level",r),s.error(c,...h)}},getLogLevel:()=>s.getLevel(),proxyResolveTelemetry:o=>{d.$publicLog2("resolveProxy",o)},useHostProxy:E,env:process.env}),l=y(b,m);return R(g,l)}e.connectProxyResolver=A;function y(D,b){const g={config:D.getConfiguration("http").get("proxySupport")||"off"};D.onDidChangeConfiguration(d=>{g.config=D.getConfiguration("http").get("proxySupport")||"off"});const s={config:!!D.getConfiguration("http").get("systemCertificates")};return D.onDidChangeConfiguration(d=>{s.config=!!D.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},_,(0,C.createHttpPatch)(_,b,{config:"off"},s,!0)),on:Object.assign({},_,(0,C.createHttpPatch)(_,b,{config:"on"},s,!0)),override:Object.assign({},_,(0,C.createHttpPatch)(_,b,{config:"override"},s,!0)),onRequest:Object.assign({},_,(0,C.createHttpPatch)(_,b,g,s,!0)),default:Object.assign(_,(0,C.createHttpPatch)(_,b,g,s,!1))},https:{off:Object.assign({},I,(0,C.createHttpPatch)(I,b,{config:"off"},s,!0)),on:Object.assign({},I,(0,C.createHttpPatch)(I,b,{config:"on"},s,!0)),override:Object.assign({},I,(0,C.createHttpPatch)(I,b,{config:"override"},s,!0)),onRequest:Object.assign({},I,(0,C.createHttpPatch)(I,b,g,s,!0)),default:Object.assign(I,(0,C.createHttpPatch)(I,b,g,s,!1))},tls:Object.assign(T,(0,C.createTlsPatch)(T))}}const n=new Map;function R(D,b){return D.getExtensionPathIndex().then(g=>{const s=Q.__$__nodeRequire("module"),d=s._load;s._load=function(v,E,m){if(v==="tls")return b.tls;if(v!=="http"&&v!=="https")return d.apply(this,arguments);const l=b[v],o=g.findSubstr(P.URI.file(E.filename).fsPath);let t=n.get(o);if(t||n.set(o,t={}),!t[v]){let i=l.default;o&&o.enableProposedApi&&(i=l[o.proxySupport]||l.onRequest),t[v]=Object.assign({},i)}return t[v]}})}}),define(ge[272],ve([0,1,38,8,74,31,9,10,90,273]),function(Q,e,_,I,T,P,C,A,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=n.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function D(m,l,o,t){const i=b(m,l,o,t),a=l.folder.fsPath;return{cmd:_.spawn(R,i.args,{cwd:a}),rgDiskPath:R,siblingClauses:i.siblingClauses,rgArgs:i,cwd:a}}e.spawnRipgrepCmd=D;function b(m,l,o,t){const i=["--files","--hidden","--case-sensitive"];s([l],o,!1).forEach(r=>{const c=(0,y.anchorGlob)(r);if(i.push("-g",c),C.isMacintosh){const h=(0,T.normalizeNFD)(c);h!==c&&i.push("-g",h)}});const a=g([l],t,void 0,!1);return a.globArgs.forEach(r=>{const c=`!${(0,y.anchorGlob)(r)}`;if(i.push("-g",c),C.isMacintosh){const h=(0,T.normalizeNFD)(c);h!==c&&i.push("-g",h)}}),l.disregardIgnoreFiles!==!1?i.push("--no-ignore"):i.push("--no-ignore-parent"),l.ignoreSymlinks||i.push("--follow"),m.exists&&i.push("--quiet"),i.push("--no-config"),l.disregardGlobalIgnoreFiles&&i.push("--no-ignore-global"),{args:i,siblingClauses:a.siblingClauses}}function g(m,l,o,t=!0){const i=[];let a={};return m.forEach(r=>{const c=Object.assign({},r.excludePattern||{},l||{}),h=d(c,t?r.folder.fsPath:void 0,o);i.push(...h.globArgs),h.siblingClauses&&(a=Object.assign(a,h.siblingClauses))}),{globArgs:i,siblingClauses:a}}e.foldersToRgExcludeGlobs=g;function s(m,l,o=!0){const t=[];return m.forEach(i=>{const a=Object.assign({},l||{},i.includePattern||{}),r=d(a,o?i.folder.fsPath:void 0);t.push(...r.globArgs)}),t}e.foldersToIncludeGlobs=s;function d(m,l,o){const t=[],i={};return Object.keys(m).forEach(a=>{if(!(o&&o.has(a))&&!!a){const r=m[a];a=v(l?S(l,a):a),a.startsWith("\\\\")?a="\\\\"+a.substr(2).replace(/\\/g,"/"):a=a.replace(/\\/g,"/"),typeof r=="boolean"&&r?(a.startsWith("\\\\")&&(a+="**"),t.push(E(a))):r&&r.when&&(i[a]=r)}}),{globArgs:t,siblingClauses:i}}function S(m,l){return I.isAbsolute(l)?l:I.join(m,l)}e.getAbsoluteGlob=S;function v(m){return m=A.rtrim(m,"\\"),A.rtrim(m,"/")}function E(m){return P.getRoot(m).toLowerCase()==="c:/"?m.replace(/^c:[/\\]/i,"/"):m}e.fixDriveC=E}),define(ge[274],ve([0,1,38,37,8,98,14,58,34,74,31,9,46,10,15,26,32,272,96]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d,S,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const m=new Set;process.on("exit",()=>{m.forEach(a=>a())});class l{constructor(r){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=r,this.filePattern=r.filePattern||"",this.includePattern=r.includePattern&&y.parse(r.includePattern),this.maxResults=r.maxResults||null,this.exists=!!r.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,E.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=r.excludePattern&&y.parse(r.excludePattern),this.folderExcludePatterns=new Map,r.folderQueries.forEach(c=>{const h=Object.assign({},c.excludePattern||{},this.config.excludePattern||{}),p=c.folder.fsPath;r.folderQueries.map(w=>w.folder.fsPath).filter(w=>w!==p).forEach(w=>{(0,R.isEqualOrParent)(w,p)&&(h[T.relative(p,w)]=!0)}),this.folderExcludePatterns.set(p,new t(h,p))})}cancel(){this.isCanceled=!0}walk(r,c,h,p,w){if(this.fileWalkSW=b.StopWatch.create(!1),this.isCanceled)return w(null,this.isLimitHit);c.forEach(u=>{const f=T.basename(u.fsPath);this.globalExcludePattern&&this.globalExcludePattern(u.fsPath,f)||this.matchFile(h,{relativePath:u.fsPath,searchPath:void 0})}),this.cmdSW=b.StopWatch.create(!1),this.parallel(r,(u,f)=>{this.call(this.cmdTraversal,this,u,h,p,k=>{if(k){const L=(0,A.toErrorMessage)(k);console.error(L),this.errors.push(L),f(k,void 0)}else f(null,void 0)})},(u,f)=>{this.fileWalkSW.stop();const k=u?C.coalesce(u)[0]:null;w(k,this.isLimitHit)})}parallel(r,c,h){const p=new Array(r.length),w=new Array(r.length);let u=!1,f=0;if(r.length===0)return h(null,[]);r.forEach((k,L)=>{c(k,($,te)=>{if($?(u=!0,p[L]=null,w[L]=$):(p[L]=te,w[L]=null),++f===r.length)return h(u?w:null,p)})})}call(r,c,...h){try{r.apply(c,h)}catch(p){h[h.length-1](p)}}cmdTraversal(r,c,h,p){const w=r.folder.fsPath,u=D.isMacintosh;let f;const k=()=>f&&f.kill();m.add(k);let L=U=>{m.delete(k),L=()=>{},p(U)},$="";const te=this.initDirectoryTree();let H;const x=(0,v.spawnRipgrepCmd)(this.config,r,this.config.includePattern,this.folderExcludePatterns.get(r.folder.fsPath).expression);f=x.cmd,H=!Object.keys(x.siblingClauses).length;const B=x.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let F=`${x.rgDiskPath} ${B}
 - cwd: ${x.cwd}`;x.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(x.rgArgs.siblingClauses)}`),h({message:F}),this.cmdResultCount=0,this.collectStdout(f,"utf8",h,(U,M,N)=>{if(U){L(U);return}if(this.isLimitHit){L();return}const j=($+(u?n.normalizeNFC(M||""):M)).split(`
`);if(N){const q=j.length;j[q-1]=j[q-1].trim(),j[q-1]||j.pop()}else $=j.pop()||"";if(j.length&&j[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=j.length,H){for(const q of j)if(this.matchFile(c,{base:w,relativePath:q,searchPath:this.getSearchPath(r,q)}),this.isLimitHit){k();break}(N||this.isLimitHit)&&L();return}this.addDirectoryEntries(r,te,w,j,c),N&&(this.matchDirectoryTree(te,w,c),L())})}spawnFindCmd(r){const c=this.folderExcludePatterns.get(r.folder.fsPath),h=c.getBasenameTerms(),p=c.getPathTerms(),w=["-L","."];if(h.length||p.length){w.push("-not","(","(");for(const u of h)w.push("-name",u),w.push("-o");for(const u of p)w.push("-path",u),w.push("-o");w.pop(),w.push(")","-prune",")")}return w.push("-type","f"),_.spawn("find",w,{cwd:r.folder.fsPath})}readStdout(r,c,h){let p="";this.collectStdout(r,c,()=>{},(w,u,f)=>{if(w){h(w);return}p+=u,f&&h(null,p)})}collectStdout(r,c,h,p){let w=(k,L,$)=>{(k||$)&&(w=()=>{},this.cmdSW&&this.cmdSW.stop()),p(k,L,$)},u=!1;r.stdout?(this.forwardData(r.stdout,c,w),r.stdout.once("data",()=>u=!0)):h({message:"stdout is null"});let f;r.stderr?f=this.collectData(r.stderr):h({message:"stderr is null"}),r.on("error",k=>{w(k)}),r.on("close",k=>{let L;!u&&(L=this.decodeData(f,c))&&i(L)?w(new Error(`command failed with error code ${k}: ${this.decodeData(f,c)}`)):(this.exists&&k===0&&(this.isLimitHit=!0),w(null,"",!0))})}forwardData(r,c,h){const p=new P.StringDecoder(c);return r.on("data",w=>{h(null,p.write(w))}),p}collectData(r){const c=[];return r.on("data",h=>{c.push(h)}),c}decodeData(r,c){const h=new P.StringDecoder(c);return r.map(p=>h.write(p)).join("")}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries(r,{pathToEntries:c},h,p,w){p.indexOf(this.filePattern)!==-1&&this.matchFile(w,{base:h,relativePath:this.filePattern,searchPath:this.getSearchPath(r,this.filePattern)});const u=f=>{const k=T.basename(f),L=T.dirname(f);let $=c[L];$||($=c[L]=[],u(L)),$.push({base:h,relativePath:f,basename:k,searchPath:this.getSearchPath(r,f)})};p.forEach(u)}matchDirectoryTree({rootEntries:r,pathToEntries:c},h,p){const w=this,u=this.folderExcludePatterns.get(h),f=this.filePattern;function k(L){w.directoriesWalked++;const $=y.hasSiblingFn(()=>L.map(te=>te.basename));for(let te=0,H=L.length;te<H;te++){const x=L[te],{relativePath:B,basename:F}=x;if(!u.test(B,F,f!==F?$:void 0)){const U=c[B];if(U)k(U);else{if(w.filesWalked++,B===f)continue;w.matchFile(p,x)}if(w.isLimitHit)break}}}k(r)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(r,c,h,p,w){const u=r.folder,f=y.hasSiblingFn(()=>h);this.parallel(h,(k,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const $=c?[c,k].join(T.sep):k;if(this.folderExcludePatterns.get(r.folder.fsPath).test($,k,this.config.filePattern!==k?f:void 0))return L(null);const te=[u.fsPath,$].join(T.sep);I.lstat(te,(H,x)=>{if(H||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(te,x,(B,F)=>B||this.isCanceled||this.isLimitHit?L(null):F.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(te,x,(U,M)=>U||this.isCanceled||this.isLimitHit||(M=M||"",this.walkedPaths[M])?L(null):(this.walkedPaths[M]=!0,(0,d.readdir)(te).then(N=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(r,$,N,p,O=>L(O||null))},N=>{L(null)})))):(this.filesWalked++,$===this.filePattern||this.maxFilesize&&s.isNumber(F.size)&&F.size>this.maxFilesize||this.matchFile(p,{base:u.fsPath,relativePath:$,searchPath:this.getSearchPath(r,$)}),L(null,void 0)))})},k=>{const L=k&&C.coalesce(k);return w(L&&L.length>0?L[0]:void 0)})}matchFile(r,c){this.isFileMatch(c)&&(!this.includePattern||this.includePattern(c.relativePath,T.basename(c.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||r(c))}isFileMatch(r){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,S.isFilePatternMatch)(r,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(r,c,h){return c.isSymbolicLink()?I.stat(r,h):h(null,c)}realPathIfNeeded(r,c,h){return c.isSymbolicLink()?I.realpath(r,(p,w)=>p?h(p):h(null,w)):h(null,r)}getSearchPath(r,c){return r.folderName?T.join(r.folderName,c):c}}e.FileWalker=l;class o{constructor(r){this.folderQueries=r.folderQueries,this.extraFiles=r.extraFileResources||[],this.walker=new l(r)}search(r,c,h){this.walker.walk(this.folderQueries,this.extraFiles,r,c,(p,w)=>{h(p,{limitHit:w,stats:this.walker.getStats()})})}cancel(){this.walker.cancel()}}e.Engine=o;class t{constructor(r,c){this.expression=r,this.root=c,this.init(r)}init(r){let c,h;Object.keys(r).filter(p=>r[p]).forEach(p=>{T.isAbsolute(p)?(c=c||y.getEmptyExpression(),c[p]=r[p]):(h=h||y.getEmptyExpression(),h[p]=r[p])}),this.absoluteParsedExpr=c&&y.parse(c,{trimForExclusions:!0}),this.relativeParsedExpr=h&&y.parse(h,{trimForExclusions:!0})}test(r,c,h){return this.relativeParsedExpr&&this.relativeParsedExpr(r,c,h)||this.absoluteParsedExpr&&this.absoluteParsedExpr(T.join(this.root,r),c,h)}getBasenameTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...y.getBasenameTerms(this.relativeParsedExpr)),r}getPathTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...y.getPathTerms(this.relativeParsedExpr)),r}}function i(a){const r=a.trim().split(`
`),c=r[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return g.uppercaseFirstLetter(r[r.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}e.rgErrorMsgForDisplay=i}),define(ge[129],ve([0,1,38,288,98,14,53,34,8,10,2,32,126,289,273,90]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=s.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class v{constructor(u){this.outputChannel=u}provideTextSearchResults(u,f,k,L){return this.outputChannel.appendLine(`provideTextSearchResults ${u.pattern}, ${JSON.stringify(Object.assign(Object.assign({},f),{folder:f.folder.toString()}))}`),new Promise(($,te)=>{L.onCancellationRequested(()=>O());const H=i(u,f),x=f.folder.fsPath,B=H.map(we=>we.match(/^-/)?we:`'${we}'`).join(" ");this.outputChannel.appendLine(`${S} ${B}
 - cwd: ${x}`);let F=_.spawn(S,H,{cwd:x});F.on("error",we=>{console.error(we),this.outputChannel.appendLine("Error: "+(we&&we.message)),te((0,D.serializeSearchError)(new D.SearchError(we&&we.message,D.SearchErrorCode.rgProcessError)))});let U=!1;const M=new l(f.maxResults,x,f.previewOptions);M.on("result",we=>{U=!0,q="",k.report(we)});let N=!1;const O=()=>{N=!0,F&&F.kill(),M&&M.cancel()};let j=!1;M.on("hitLimit",()=>{j=!0,O()});let q="";F.stdout.on("data",we=>{M.handleData(we),U||(q+=we)});let X=!1;F.stdout.once("data",()=>X=!0);let me="";F.stderr.on("data",we=>{const Ae=we.toString();this.outputChannel.appendLine(Ae),me+=Ae}),F.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),q&&this.outputChannel.appendLine(`Got data without result: ${q}`),this.outputChannel.appendLine(""),N)$({limitHit:j});else{M.flush(),F=null;let we;me&&!X&&(we=E(me))?te((0,D.serializeSearchError)(new D.SearchError(we.message,we.code))):$({limitHit:j})}})})}}e.RipgrepTextSearchEngine=v;function E(w){const u=w.split(`
`),f=u[0].trim();if(u.some(L=>L.startsWith("regex parse error")))return new D.SearchError(m(u),D.SearchErrorCode.regexParseError);const k=f.match(/grep config error: unknown encoding: (.*)/);if(k)return new D.SearchError(`Unknown encoding: ${k[1]}`,D.SearchErrorCode.unknownEncoding);if(f.startsWith("error parsing glob"))return new D.SearchError(f.charAt(0).toUpperCase()+f.substr(1),D.SearchErrorCode.globParseError);if(f.startsWith("the literal"))return new D.SearchError(f.charAt(0).toUpperCase()+f.substr(1),D.SearchErrorCode.invalidLiteral);if(f.startsWith("PCRE2: error compiling pattern"))return new D.SearchError(f,D.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=E;function m(w){const u=["Regex parse error"],f=w.filter(k=>k.startsWith("PCRE2:"));if(f.length>=1){const k=f[0].replace("PCRE2:","");if(k.indexOf(":")!==-1&&k.split(":").length>=2){const L=k.split(":")[1];u.push(":"+L)}}return u.join("")}e.buildRegexParseError=m;class l extends I.EventEmitter{constructor(u,f,k){super();this.maxResults=u,this.rootFolder=f,this.previewOptions=k,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new T.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(u,f){return super.on(u,f),this}handleData(u){if(!this.isDone){const f=typeof u=="string"?u:this.stringDecoder.write(u);this.handleDecodedData(f)}}handleDecodedData(u){let f=u.indexOf(`
`);const k=this.remainder+u;if(f>=0)f+=this.remainder.length;else{this.remainder=k;return}let L=0;for(;f>=0;)this.handleLine(k.substring(L,f).trim()),L=f+1,f=k.indexOf(`
`,L);this.remainder=k.substring(L)}handleLine(u){if(!(this.isDone||!u)){let f;try{f=JSON.parse(u)}catch(k){throw new Error(`malformed line from rg: ${u}`)}if(f.type==="match"){const k=o(f.data.path),L=R.URI.file(y.join(this.rootFolder,k)),$=this.createTextSearchMatch(f.data,L);this.onResult($),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(f.type==="context"){const k=o(f.data.path),L=R.URI.file(y.join(this.rootFolder,k));this.createTextSearchContext(f.data,L).forEach(te=>this.onResult(te))}}}createTextSearchMatch(u,f){const k=u.line_number-1;let L=!1,$=o(u.lines);k===0&&(0,n.startsWithUTF8BOM)($)&&(L=!0,$=(0,n.stripUTF8BOM)($));const te=Buffer.from($);let H=0,x=0,B=k;u.submatches.length===0&&u.submatches.push($.length?{start:0,end:1,match:{text:$[0]}}:{start:0,end:0,match:{text:""}});const F=(0,P.coalesce)(u.submatches.map((U,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let N=o(U.match);k===0&&M===0&&L&&(N=(0,n.stripUTF8BOM)(N),U.start=U.start<=3?0:U.start-3,U.end=U.end<=3?0:U.end-3);const O=te.slice(H,U.start).toString().length,j=x+O,q=t(N),X=B,me=q.numLines+X,we=q.numLines>0?q.lastLineLength:q.lastLineLength+j;return H=U.end,x=we,B=me,new b.Range(X,j,me,we)}));return(0,d.createTextSearchResult)(f,$,F,this.previewOptions)}createTextSearchContext(u,f){const k=o(u.lines),L=u.line_number;return k.replace(/\r?\n$/,"").split(`
`).map(($,te)=>({text:$,uri:f,lineNumber:L+te}))}onResult(u){this.emit("result",u)}}e.RipgrepParser=l;function o(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function t(w){const u=/\n/g;let f=0,k=-1,L;for(;L=u.exec(w);)f++,k=L.index;const $=k>=0?w.length-k-1:w.length;return{numLines:f,lastLineLength:$}}function i(w,u){const f=["--hidden"];f.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:k,otherIncludes:L}=(0,C.groupBy)(u.includes,te=>te.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const te=new Set;L.forEach(H=>{te.add(H)}),f.push("-g","!*"),te.forEach(H=>{a(H).map(d.anchorGlob).forEach(x=>{f.push("-g",x)})})}k&&k.length&&k.forEach(te=>{f.push("-g",te)}),u.excludes.map(d.anchorGlob).forEach(te=>f.push("-g",`!${te}`)),u.maxFileSize&&f.push("--max-filesize",u.maxFileSize+""),u.useIgnoreFiles?f.push("--no-ignore-parent"):f.push("--no-ignore"),u.followSymlinks&&f.push("--follow"),u.encoding&&u.encoding!=="utf8"&&f.push("--encoding",u.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,n.escapeRegExpCharacters)(w.pattern),w.isRegExp=!0),u.usePCRE2&&f.push("--pcre2"),f.push("--crlf"),w.isRegExp&&(w.pattern=r(w.pattern),f.push("--auto-hybrid-regex"));let $;if(w.isWordMatch){const H=(0,n.createRegExp)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");f.push("--regexp",H)}else if(w.isRegExp){let te=h(w.pattern);te=p(te),f.push("--regexp",te)}else $=w.pattern,f.push("--fixed-strings");return f.push("--no-config"),u.useGlobalIgnoreFiles||f.push("--no-ignore-global"),f.push("--json"),w.isMultiline&&f.push("--multiline"),u.beforeContext&&f.push("--before-context",u.beforeContext+""),u.afterContext&&f.push("--after-context",u.afterContext+""),f.push("--"),$&&f.push($),f.push("."),f}function a(w){const u=(0,A.splitGlobAware)(w,"/");return u.map((f,k)=>u.slice(0,k+1).join("/"))}e.spreadGlobComponents=a;function r(w){const u=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(u);)w=w.replace(u,"$1\\x{$2}");const f=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(f);)w=w.replace(f,"$1\\x{$2}");return w}e.unicodeEscapesToPCRE2=r;const c=w=>w.type==="Assertion"&&w.kind==="lookbehind";function h(w){let u;try{u=new g.RegExpParser().parsePattern(w)}catch(H){return w}let f="",k=0;const L=(H,x,B)=>{f+=w.slice(k,H)+B,k=x},$=[];return new g.RegExpVisitor({onCharacterEnter(H){if(H.raw==="\\n"){const x=$[0];if(!x)L(H.start,H.end,"\\r?\\n");else if(!$.some(c))if(x.type==="CharacterClass"){const B=w.slice(x.start+1,H.start)+w.slice(H.end,x.end-1);L(x.start,x.end,B===""?"\\r?\\n":`(?:[${B}]|\\r?\\n)`)}else x.type==="Quantifier"&&L(H.start,H.end,"(?:\\r?\\n)")}},onQuantifierEnter(H){$.unshift(H)},onQuantifierLeave(){$.shift()},onCharacterClassRangeEnter(H){$.unshift(H)},onCharacterClassRangeLeave(){$.shift()},onCharacterClassEnter(H){$.unshift(H)},onCharacterClassLeave(){$.shift()},onAssertionEnter(H){c(H)&&$.push(H)},onAssertionLeave(H){$[0]===H&&$.shift()}}).visit(u),f+=w.slice(k),f}e.fixRegexNewline=h;function p(w){return w.replace(/\n/g,"\\r?\\n")}e.fixNewline=p}),define(ge[275],ve([0,1,21,129,111,11]),function(Q,e,_,I,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class C{constructor(n){this.outputChannel=n,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(n,R,D,b){const g=new I.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===P.Schemas.userData){const s=Object.assign(Object.assign({},R),{folder:R.folder.with({scheme:P.Schemas.file})}),d=new T.Progress(S=>D.report(Object.assign(Object.assign({},S),{uri:S.uri.with({scheme:R.folder.scheme})})));return this.withToken(b,S=>g.provideTextSearchResults(n,s,d,S))}else return this.withToken(b,s=>g.provideTextSearchResults(n,R,D,s))}async withToken(n,R){const D=A(n);this.inProgress.add(D);const b=await R(D.token);return this.inProgress.delete(D),b}dispose(){this.inProgress.forEach(n=>n.cancel())}}e.RipgrepSearchProvider=C;function A(y){const n=new _.CancellationTokenSource;return y.onCancellationRequested(()=>n.cancel()),n}}),define(ge[276],ve([0,1,26,129,128]),function(Q,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(y){this.query=y}search(y,n,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const D={appendLine(g){R({message:g})}},b=new T.NativeTextSearchManager(this.query,new I.RipgrepTextSearchEngine(D),_);return new Promise((g,s)=>b.search(d=>{n(d.map(C))},y).then(d=>g({limitHit:d.limitHit,type:"success"}),s))}}e.TextSearchEngineAdapter=P;function C(A){return{path:A.resource&&A.resource.fsPath,results:A.results,numMatches:(A.results||[]).reduce((y,n)=>{if(n.ranges){const R=n;return y+(Array.isArray(R.ranges)?R.ranges.length:1)}else return y+1},0)}}}),define(ge[277],ve([0,1,37,290,14,19,18,3,96,8,46,2,44,32,274,276]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,I.gracefulify(_);class S{constructor(){this.caches=Object.create(null)}fileSearch(t){let i;const a=m(t),r=new A.Emitter({onFirstListenerDidAdd:()=>{i=(0,P.createCancelablePromise)(c=>this.doFileSearchWithEngine(s.Engine,a,h=>r.fire(h),c)),i.then(c=>r.fire(c),c=>r.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return r.event}textSearch(t){let i;const a=m(t),r=new A.Emitter({onFirstListenerDidAdd:()=>{i=(0,P.createCancelablePromise)(c=>this.ripgrepTextSearch(a,h=>r.fire(h),c)),i.then(c=>r.fire(c),c=>r.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return r.event}ripgrepTextSearch(t,i,a){return t.maxFileSize=(0,b.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new d.TextSearchEngineAdapter(t).search(a,i,i)}doFileSearch(t,i,a){return this.doFileSearchWithEngine(s.Engine,t,i,a)}doFileSearchWithEngine(t,i,a,r,c=S.BATCH_SIZE){let h=0;const p=u=>{Array.isArray(u)?(h+=u.length,a(u.map(f=>this.rawMatchToSearchItem(f)))):u.relativePath?(h++,a(this.rawMatchToSearchItem(u))):a(u)};if(i.sortByScore){let u=this.trySortedSearchFromCache(i,p,r);if(!u){const f=i.maxResults?Object.assign({},i,{maxResults:null}):i,k=new t(f);u=this.doSortedSearch(k,i,a,p,r)}return new Promise((f,k)=>{u.then(([L,$])=>{const te=$.map(H=>this.rawMatchToSearchItem(H));this.sendProgress(te,a,c),f(L)},k)})}const w=new t(i);return this.doSearch(w,p,c,r).then(u=>({limitHit:u.limitHit,type:"success",stats:{detailStats:u.stats,type:"searchProcess",fromCache:!1,resultCount:h,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,n.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,i,a,r,c){const h=new A.Emitter;let p=(0,P.createCancelablePromise)(u=>{let f=[];const k=L=>{Array.isArray(L)?f=L:(r(L),h.fire(L))};return this.doSearch(t,k,-1,u).then(L=>[L,f])}),w;if(i.cacheKey){w=this.getOrCreateCache(i.cacheKey);const u={promise:p,event:h.event,resolved:!1};w.resultsToSearchCache[i.filePattern||""]=u,p.then(()=>{u.resolved=!0},f=>{delete w.resultsToSearchCache[i.filePattern||""]}),p=this.preventCancellation(p)}return p.then(([u,f])=>{const k=w?w.scorerCache:Object.create(null),L=(typeof i.maxResults!="number"||i.maxResults>0)&&R.StopWatch.create(!1);return this.sortResults(i,f,k,c).then($=>{const te=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:u.stats,sortingTime:te,fromCache:!1,type:"searchProcess",workspaceFolderCount:i.folderQueries.length,resultCount:$.length},limitHit:u.limitHit||typeof i.maxResults=="number"&&f.length>i.maxResults},$]})})}getOrCreateCache(t){const i=this.caches[t];return i||(this.caches[t]=new v)}trySortedSearchFromCache(t,i,a){const r=t.cacheKey&&this.caches[t.cacheKey];if(!!r){const c=this.getResultsFromCache(r,t.filePattern||"",i,a);if(c)return c.then(([h,p,w])=>{const u=R.StopWatch.create(!1);return this.sortResults(t,p,r.scorerCache,a).then(f=>{const k=u.elapsed(),L={fromCache:!0,detailStats:w,type:"searchProcess",resultCount:p.length,sortingTime:k};return[{type:"success",limitHit:h.limitHit||typeof t.maxResults=="number"&&p.length>t.maxResults,stats:L},f]})})}}sortResults(t,i,a,r){const c=(0,y.prepareQuery)(t.filePattern||""),h=(w,u)=>(0,y.compareItemsByFuzzyScore)(w,u,c,!0,E,a),p=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return T.topAsync(i,h,p,1e4,r)}sendProgress(t,i,a){if(a&&a>0)for(let r=0;r<t.length;r+=a)i(t.slice(r,r+a));else i(t)}getResultsFromCache(t,i,a,r){const c=R.StopWatch.create(!1),h=i.indexOf(n.sep)>=0;let p;for(const k in t.resultsToSearchCache)if(i.startsWith(k)){if(h&&k.indexOf(n.sep)<0&&k!=="")continue;const L=t.resultsToSearchCache[k];p={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!p)return null;const w=c.elapsed(),u=R.StopWatch.create(!1),f=p.event(a);return r&&r.onCancellationRequested(()=>{f.dispose()}),p.promise.then(([k,L])=>{if(r&&r.isCancellationRequested)throw(0,C.canceled)();const $=[],te=(0,y.prepareQuery)(i).normalizedLowercase;for(const H of L)!(0,g.isFilePatternMatch)(H,te)||$.push(H);return[k,$,{cacheWasResolved:p.resolved,cacheLookupTime:w,cacheFilterTime:u.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,i,a,r){return new Promise((c,h)=>{let p=[];r&&r.onCancellationRequested(()=>t.cancel()),t.search(w=>{w&&(a?(p.push(w),a>0&&p.length>=a&&(i(p),p=[])):i(w))},w=>{i(w)},(w,u)=>{p.length&&i(p),w?h(w):c(u)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(i,a){return t.then(i,a)}catch(i){return this.then(void 0,i)}finally(i){return t.finally(i)}}}}e.SearchService=S,S.BATCH_SIZE=512;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(o){return(0,n.basename)(o.relativePath)}getItemDescription(o){return(0,n.dirname)(o.relativePath)}getItemPath(o){return o.relativePath}};function m(o){return Object.assign(Object.assign({},o),{folderQueries:o.folderQueries&&o.folderQueries.map(l),extraFileResources:o.extraFileResources&&o.extraFileResources.map(t=>D.URI.revive(t))})}function l(o){return Object.assign(Object.assign({},o),{folder:D.URI.revive(o.folder)})}}),define(ge[278],ve([0,1,6,2,26,12,32,277,275,90,13,61,27,67,11,128]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends g.ExtHostSearch{constructor(E,m,l,o){super(E,l,o);this._pfs=T,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new n.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(s.Schemas.userData,new y.RipgrepSearchProvider(t)),m.remote.isRemote&&m.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const E=new n.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(s.Schemas.file,new y.RipgrepSearchProvider(E)),this.registerInternalFileSearchProvider(s.Schemas.file,new A.SearchService)}registerInternalFileSearchProvider(E,m){const l=this._handlePool++;return this._internalFileSearchProvider=m,this._internalFileSearchHandle=l,this._proxy.$registerFileSearchProvider(l,this._transformScheme(E)),(0,_.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(l)})}$provideFileSearchResults(E,m,l,o){const t=(0,g.reviveQuery)(l);return E===this._internalFileSearchHandle?this.doInternalFileSearch(E,m,t,o):super.$provideFileSearchResults(E,m,l,o)}doInternalFileSearch(E,m,l,o){const t=i=>{if((0,C.isSerializedFileMatch)(i)&&(i=[i]),Array.isArray(i)){this._proxy.$handleFileMatch(E,m,i.map(a=>I.URI.file(a.path)));return}i.message&&this._logService.debug("ExtHostSearch",i.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(l,t,o)}$clearCache(E){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(E),super.$clearCache(E)}createTextSearchManager(E,m){return new d.NativeTextSearchManager(E,m)}};S=je([Ue(0,R.IExtHostRpcService),Ue(1,b.IExtHostInitDataService),Ue(2,D.IURITransformerService),Ue(3,P.ILogService)],S),e.NativeExtHostSearch=S}),define(ge[130],ve([0,1,291,120,292,3,101,8,48,28,6,22,102,18,9]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(p){this.socket=p,this._errorListener=w=>{if(w){if(w.code==="EPIPE")return;(0,g.onUnexpectedError)(w)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(p){const w=u=>p(D.VSBuffer.wrap(u));return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(p){return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(p){return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(p){if(!this.socket.destroyed)try{this.socket.write(p.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,g.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,g.onUnexpectedError)(w)}}end(){this.socket.end()}drain(){return new Promise((p,w)=>{if(this.socket.bufferSize===0){p();return}const u=()=>{this.socket.off("close",u),this.socket.off("end",u),this.socket.off("error",u),this.socket.off("timeout",u),this.socket.off("drain",u),p()};this.socket.on("close",u),this.socket.on("end",u),this.socket.on("error",u),this.socket.on("timeout",u),this.socket.on("drain",u)})}}e.NodeSocket=d;var S;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var v;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(v||(v={}));class E extends R.Disposable{constructor(p,w,u,f){super();this._onDidZlibFlush=this._register(new P.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=p,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=w,this._recordInflateBytes=f,w?(this._zlibInflate=T.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",k=>{console.error(k),(0,g.onUnexpectedError)(k),this._onClose.fire()}),this._zlibInflate.on("data",k=>{this._pendingInflateData.push(k)}),u&&(this._zlibInflate.write(u.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=T.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",k=>{console.error(k),(0,g.onUnexpectedError)(k),this._onClose.fire()}),this._zlibDeflate.on("data",k=>{this._pendingDeflateData.push(k)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new b.ChunkStream,this._register(this.socket.onData(k=>this._acceptChunk(k))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):D.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this._onData.event(p)}onClose(p){return this._onClose.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){this._totalOutgoingDataBytes+=p.byteLength,this._zlibDeflate?(this._zlibDeflate.write(p.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let w=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.length-4),this._isEnded||this._write(D.VSBuffer.wrap(w),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(p,!1)}_write(p,w){let u=2;p.byteLength<126?u+=0:p.byteLength<2**16?u+=2:u+=8;const f=D.VSBuffer.alloc(u);if(w?f.writeUInt8(194,0):f.writeUInt8(130,0),p.byteLength<126)f.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){f.writeUInt8(126,1);let k=1;f.writeUInt8(p.byteLength>>>8&255,++k),f.writeUInt8(p.byteLength>>>0&255,++k)}else{f.writeUInt8(127,1);let k=1;f.writeUInt8(0,++k),f.writeUInt8(0,++k),f.writeUInt8(0,++k),f.writeUInt8(0,++k),f.writeUInt8(p.byteLength>>>24&255,++k),f.writeUInt8(p.byteLength>>>16&255,++k),f.writeUInt8(p.byteLength>>>8&255,++k),f.writeUInt8(p.byteLength>>>0&255,++k)}this._totalOutgoingWireBytes+=f.byteLength+p.byteLength,this.socket.write(D.VSBuffer.concat([f,p]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(p){if(p.byteLength!==0){for(this._totalIncomingWireBytes+=p.byteLength,this._incomingData.acceptChunk(p);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const w=this._incomingData.peek(this._state.readLen),f=(w.readUInt8(0)&128)>>>7,k=w.readUInt8(1),L=(k&128)>>>7,$=k&127;this._state.state=2,this._state.readLen=2+(L?4:0)+($===126?2:0)+($===127?8:0),this._state.fin=f,this._state.mask=0}else if(this._state.state===2){const w=this._incomingData.read(this._state.readLen),u=w.readUInt8(1),f=(u&128)>>>7;let k=u&127,L=1;k===126?k=w.readUInt8(++L)*2**8+w.readUInt8(++L):k===127&&(k=w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*2**24+w.readUInt8(++L)*2**16+w.readUInt8(++L)*2**8+w.readUInt8(++L));let $=0;f&&($=w.readUInt8(++L)*2**24+w.readUInt8(++L)*2**16+w.readUInt8(++L)*2**8+w.readUInt8(++L)),this._state.state=3,this._state.readLen=k,this._state.mask=$}else if(this._state.state===3){const w=this._incomingData.read(this._state.readLen);m(w,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(w.buffer)),this._zlibInflate.write(w.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const u=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=u.length,this._onData.fire(D.VSBuffer.wrap(u))})):(this._totalIncomingDataBytes+=w.byteLength,this._onData.fire(w))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await P.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=E;function m(h,p){if(p!==0){let w=h.byteLength>>>2;for(let te=0;te<w;te++){const H=h.readUInt32BE(te*4);h.writeUInt32BE(H^p,te*4)}let u=w*4,f=h.byteLength-u;const k=p>>>24&255,L=p>>>16&255,$=p>>>8&255;f>=1&&h.writeUInt8(h.readUInt8(u)^k,u),f>=2&&h.writeUInt8(h.readUInt8(u+1)^L,u+1),f>=3&&h.writeUInt8(h.readUInt8(u+2)^$,u+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function o(){const h=(0,n.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let p;return e.XDG_RUNTIME_DIR?p=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):p=(0,A.join)((0,y.tmpdir)(),`vscode-ipc-${h}.sock`),i(p),p}e.createRandomIPCHandle=o;function t(h,p,w){const u=(0,_.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${u}-${w}-${p}-sock`;let f;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?f=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${u.substr(0,8)}-${w}-${p}.sock`):f=(0,A.join)(h,`${w}-${p}.sock`),i(f),f}e.createStaticIPCHandle=t;function i(h){const p=l[s.platform];typeof p=="number"&&h.length>=p&&console.warn(`WARNING: IPC handle "${h}" is longer than ${p} chars, try a shorter --user-data-dir`)}class a extends C.IPCServer{constructor(p){super(a.toClientConnectionEvent(p));this.server=p}static toClientConnectionEvent(p){const w=P.Event.fromNodeEventEmitter(p,"connection");return P.Event.map(w,u=>({protocol:new b.Protocol(new d(u)),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(u,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=a;function r(h){return new Promise((p,w)=>{const u=(0,I.createServer)();u.on("error",w),u.listen(h,()=>{u.removeListener("error",w),p(new a(u))})})}e.serve=r;function c(h,p){return new Promise((w,u)=>{const f=(0,I.createConnection)(h,()=>{f.removeListener("error",u),w(b.Client.fromSocket(new d(f),p))});f.once("error",u)})}e.connect=c}),define(ge[279],ve([0,1,130,271,37,51,2,115,12]),function(Q,e,_,I,T,P,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class n{constructor(b,g,s){this._commands=b,this.logService=g,this._ipcHandlePath=s,this._server=I.createServer((d,S)=>this.onRequest(d,S)),this.setup().catch(d=>(g.error(d),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",b=>this.logService.error(b))}catch(b){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(b,g){const s=[];b.setEncoding("utf8"),b.on("data",d=>s.push(d)),b.on("end",()=>{const d=JSON.parse(s.join(""));switch(d.type){case"open":this.open(d,g);break;case"openExternal":this.openExternal(d,g);break;case"status":this.getStatus(d,g);break;case"command":this.runCommand(d,g).catch(this.logService.error);break;case"extensionManagement":this.manageExtensions(d,g).catch(this.logService.error);break;default:g.writeHead(404),g.write(`Unknown message type: ${d.type}`,S=>{S&&this.logService.error(S)}),g.end();break}})}open(b,g){let{fileURIs:s,folderURIs:d,forceNewWindow:S,diffMode:v,addMode:E,forceReuseWindow:m,gotoLineMode:l,waitMarkerFilePath:o}=b;const t=[];if(Array.isArray(d))for(const i of d)try{t.push({folderUri:C.URI.parse(i)})}catch(a){}if(Array.isArray(s))for(const i of s)try{(0,A.hasWorkspaceFileExtension)(i)?t.push({workspaceUri:C.URI.parse(i)}):t.push({fileUri:C.URI.parse(i)})}catch(a){}if(t.length){const i=o?C.URI.file(o):void 0,r={forceNewWindow:S,diffMode:v,addMode:E,gotoLineMode:l,forceReuseWindow:m,preferNewWindow:!m&&!i&&!E,waitMarkerFileURI:i};this._commands.executeCommand("_files.windowOpen",t,r)}g.writeHead(200),g.end()}async openExternal(b,g){for(const s of b.uris){const d=C.URI.parse(s),S=d.scheme==="file"?d:s;await this._commands.executeCommand("_remoteCLI.openExternal",S)}g.writeHead(200),g.end()}async manageExtensions(b,g){try{const s=v=>v==null?void 0:v.map(E=>/\.vsix$/i.test(E)?C.URI.parse(E):E),d={list:b.list,install:s(b.install),uninstall:s(b.uninstall),force:b.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",d);g.writeHead(200),g.write(S)}catch(s){g.writeHead(500),g.write(String(s),d=>{d&&this.logService.error(d)})}g.end()}async getStatus(b,g){try{const s=await this._commands.executeCommand("_issues.getSystemStatus");g.writeHead(200),g.write(s),g.end()}catch(s){g.writeHead(500),g.write(String(s),d=>{d&&this.logService.error(d)}),g.end()}}async runCommand(b,g){try{const{command:s,args:d}=b,S=await this._commands.executeCommand(s,...d);g.writeHead(200),g.write(JSON.stringify(S),v=>{v&&this.logService.error(v)}),g.end()}catch(s){g.writeHead(500),g.write(String(s),d=>{d&&this.logService.error(d)}),g.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&T.existsSync(this._ipcHandlePath)&&T.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=n;let R=class extends n{constructor(b,g){super(b,g,(0,_.createRandomIPCHandle)())}};R=je([Ue(0,P.IExtHostCommands),Ue(1,y.ILogService)],R),e.CLIServer=R}),define(ge[280],ve([0,1,66,267,261,5,270,42,252,2,11,7,279,99]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class s extends T.RequireInterceptor{_installInterceptor(){const v=this,E=Q.__$__nodeRequire("module"),m=E._load;E._load=function(o,t,i){for(let a of v._alternatives){let r=a(o);if(r){o=r;break}}return v._factories.has(o)?v._factories.get(o).load(o,n.URI.file((0,g.realpathSync)(t.filename)),a=>m.apply(this,[a,t,i])):m.apply(this,arguments)}}}class d extends A.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=D.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const v=this._instaService.invokeFunction(I.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(b.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(s,v,this._registry).install(),_.mark("code/extHost/didInitAPI");const m=await this._extHostConfiguration.getConfigProvider();await(0,C.connectProxyResolver)(this._extHostWorkspace,m,this,this._logService,this._mainThreadTelemetryProxy,this._initData),_.mark("code/extHost/didInitProxyResolver");const l=process.send,o=this._extHostContext.getProxy(P.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?l.apply(process,t):(o.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(v){return v.main}_loadCommonJSModule(v,E,m){if(E.scheme!==R.Schemas.file)throw new Error(`Cannot load URI: '${E}', must be of file-scheme`);let l=null;m.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${E.toString(!0)}`),this._logService.flush();try{v&&_.mark(`code/extHost/willLoadExtensionCode/${v.value}`),l=Q.__$__nodeRequire(E.fsPath)}catch(o){return Promise.reject(o)}finally{v&&_.mark(`code/extHost/didLoadExtensionCode/${v.value}`),m.codeLoadingStop()}return Promise.resolve(l)}async $setRemoteEnvironment(v){if(!!this._initData.remote.isRemote)for(const E in v){const m=v[E];m===null?delete process.env[E]:process.env[E]=m}}}e.ExtHostExtensionService=d}),define(ge[281],ve([0,1,78,253,264,263,262,278,280,225,254,45,42,63,67,65,35,50,12]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d,S,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(b.IExtHostExtensionService,y.ExtHostExtensionService),(0,_.registerSingleton)(E.ILogService,n.ExtHostLogService),(0,_.registerSingleton)(D.IExtHostDebugService,C.ExtHostDebugService),(0,_.registerSingleton)(g.IExtHostOutputService,I.ExtHostOutputService2),(0,_.registerSingleton)(s.IExtHostSearch,A.NativeExtHostSearch),(0,_.registerSingleton)(d.IExtHostTask,P.ExtHostTask),(0,_.registerSingleton)(S.IExtHostTerminalService,T.ExtHostTerminalService),(0,_.registerSingleton)(v.IExtHostTunnelService,R.ExtHostTunnelService)}),define(ge[282],ve([0,1,120,293,66,18,102,130,186,223,265,22,97,26,99,19,268,281]),function(Q,e,_,I,T,P,C,A,y,n,R,D,b,g,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const S=I(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const a=Q.__$__nodeRequire("module"),r=a._load;a._load=function(c){if(c==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const v=process.exit.bind(process);function E(a){process.exit=function(r){if(a)v(r);else{const c=new Error("An extension called process.exit() and this was prevented.");console.warn(c.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let m=function(a){v()};function l(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((a,r)=>{let c=null,h=setTimeout(()=>{r(new Error("VSCODE_EXTHOST_IPC_SOCKET timeout"))},6e4);const p=108e5,w=3e5,u=new d.RunOnceScheduler(()=>m("renderer disconnected for too long (1)"),p),f=new d.RunOnceScheduler(()=>m("renderer disconnected for too long (2)"),w);process.on("message",(L,$)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){const te=D.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let H;if(L.skipWebSocketFrames)H=new A.NodeSocket($);else{const x=D.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));H=new A.WebSocketNodeSocket(new A.NodeSocket($),L.permessageDeflate,x,!1)}c?(u.cancel(),f.cancel(),c.beginAcceptReconnection(H,te),c.endAcceptReconnection()):(clearTimeout(h),c=new C.PersistentProtocol(H,te),c.onDidDispose(()=>m("renderer disconnected")),a(c),c.onSocketClose(()=>{u.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(f.isScheduled())return;u.isScheduled()&&f.schedule()}});const k={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(k)});{const a=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,c)=>{const h=_.createConnection(a,()=>{h.removeListener("error",c),r(new C.PersistentProtocol(new A.NodeSocket(h)))});h.once("error",c)})}}async function o(){const a=await l();return new class{constructor(){this._onMessage=new C.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,a.onMessage(r=>{(0,n.isMessageOfType)(r,2)?(this._terminating=!0,m("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||a.send(r)}drain(){return a.drain()}}}function t(a){return new Promise(r=>{const c=a.onMessage(h=>{c.dispose();const p=JSON.parse(h.toString()),w=p.commit,u=y.default.commit;w&&u&&w!==u&&v(55);const f=[];process.on("unhandledRejection",($,te)=>{f.push(te),setTimeout(()=>{const H=f.indexOf(te);H>=0&&te.catch(x=>{f.splice(H,1),console.warn(`rejected promise not handled within 1 second: ${x}`),x&&x.stack&&console.warn(`stack trace: ${x.stack}`),(0,P.onUnexpectedError)($)})},1e3)}),process.on("rejectionHandled",$=>{const te=f.indexOf($);te>=0&&f.splice(te,1)}),process.on("uncaughtException",function($){(0,P.onUnexpectedError)($)});let k=0;setInterval(function(){try{process.kill(p.parentPid,0),k=0}catch($){$&&$.code==="EPERM"?(k++,k>=3&&m(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${$.message} (code: ${$.code}) (errno: ${$.errno})`)):m(`parent process ${p.parentPid} does not exist anymore: ${$.message} (code: ${$.code}) (errno: ${$.errno})`)}},1e3);let L;try{L=Q.__$__nodeRequire("native-watchdog"),L.start(p.parentPid)}catch($){(0,P.onUnexpectedError)($)}a.send((0,n.createMessageOfType)(0)),r({protocol:a,initData:p})});a.send((0,n.createMessageOfType)(1))})}async function i(){T.mark("code/extHost/willConnectToRenderer");const a=await o();T.mark("code/extHost/didConnectToRenderer");const r=await t(a);T.mark("code/extHost/didWaitForInitData");const{initData:c}=r;E(!!c.environment.extensionTestsLocationURI),c.environment.useHostProxy=S.useHostProxy!==void 0?S.useHostProxy!=="false":void 0;const h=new class{exit(f){v(f)}exists(f){return(0,g.exists)(f)}realpath(f){return(0,s.realpath)(f)}};let p=null;if(c.remote.authority&&S.uriTransformerPath)try{const f=Q.__$__nodeRequire(S.uriTransformerPath)(c.remote.authority);p=new b.URITransformer(f)}catch(u){console.error(u)}const w=new R.ExtensionHostMain(r.protocol,c,h,p);m=u=>w.terminate(u)}e.startExtensionHostProcess=i}),define(ge[294],ve([0,1,282]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.startExtensionHostProcess)().catch(I=>console.log(I))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/58186680eb97fe979e1d986bcfa983ab0a6228e4/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
