/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/path","vs/base/common/types","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/network","vs/platform/log/common/log","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/process","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],we=function(ie){for(var e=[],w=0,k=ie.length;w<k;w++)e[w]=be[ie[w]];return e};define(be[43],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(k,A){if(!k)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=w}),define(be[50],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const w=Object.prototype.hasOwnProperty;function k(R){const C=[];for(let b in R)w.call(R,b)&&C.push(R[b]);return C}e.values=k;function A(R,C){for(let b in R)if(w.call(R,b)&&C({key:b,value:R[b]},function(){delete R[b]})===!1)return}e.forEach=A;function T(R,C){const b=Object.create(null);for(const f of R){const i=C(f);let s=b[i];s||(s=b[i]=[]),s.push(f)}return b}e.groupBy=T;function S(R){const C=Object.create(null);return R&&R.forEach((b,f)=>{C[f]=b}),C}e.fromMap=S;function I(R,C){const b=[],f=[];for(let i of R)C.has(i)||b.push(i);for(let i of C)R.has(i)||f.push(i);return{removed:b,added:f}}e.diffSets=I;function y(R,C){const b=[],f=[];for(let[i,s]of R)C.has(i)||b.push(s);for(let[i,s]of C)R.has(i)||f.push(s);return{removed:b,added:f}}e.diffMaps=y;class n{constructor(){this.map=new Map}add(C,b){let f=this.map.get(C);f||(f=new Set,this.map.set(C,f)),f.add(b)}delete(C,b){const f=this.map.get(C);!f||(f.delete(b),f.size===0&&this.map.delete(C))}forEach(C,b){const f=this.map.get(C);!f||f.forEach(b)}}e.SetMap=n}),define(be[51],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function w(y){return(n,R,C)=>{let b=null,f=null;if(typeof C.value=="function"?(b="value",f=C.value):typeof C.get=="function"&&(b="get",f=C.get),!f)throw new Error("not supported");C[b]=y(f,R)}}e.createDecorator=w;let k=0;function A(){const y=`$memoize${k++}`;let n;const R=function(b,f,i){let s=null,v=null;if(typeof i.value=="function"?(s="value",v=i.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof i.get=="function"&&(s="get",v=i.get),!v)throw new Error("not supported");const h=`${y}:${f}`;i[s]=function(...E){return n=this,this.hasOwnProperty(h)||Object.defineProperty(this,h,{configurable:!0,enumerable:!1,writable:!0,value:v.apply(this,E)}),this[h]}};return R.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(C=>{C.indexOf(y)===0&&delete n[C]})},R}e.createMemoizer=A;function T(y,n,R){return A()(y,n,R)}e.memoize=T;function S(y,n,R){return w((C,b)=>{const f=`$debounce$${b}`,i=`$debounce$result$${b}`;return function(...s){this[i]||(this[i]=R?R():void 0),clearTimeout(this[f]),n&&(this[i]=n(this[i],...s),s=[this[i]]),this[f]=setTimeout(()=>{C.apply(this,s),this[i]=R?R():void 0},y)}})}e.debounce=S;function I(y,n,R){return w((C,b)=>{const f=`$throttle$timer$${b}`,i=`$throttle$result$${b}`,s=`$throttle$lastRun$${b}`,v=`$throttle$pending$${b}`;return function(...h){if(this[i]||(this[i]=R?R():void 0),(this[s]===null||this[s]===void 0)&&(this[s]=-Number.MAX_VALUE),n&&(this[i]=n(this[i],...h)),!this[v]){const E=this[s]+y;E<=Date.now()?(this[s]=Date.now(),C.apply(this,[this[i]]),this[i]=R?R():void 0):(this[v]=!0,this[f]=setTimeout(()=>{this[v]=!1,this[s]=Date.now(),C.apply(this,[this[i]]),this[i]=R?R():void 0},E-Date.now()))}}})}e.throttle=I}),define(be[10],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=w,e.errorHandler=new w;function k(o){e.errorHandler.setUnexpectedErrorHandler(o)}e.setUnexpectedErrorHandler=k;function A(o){y(o)||e.errorHandler.onUnexpectedError(o)}e.onUnexpectedError=A;function T(o){y(o)||e.errorHandler.onUnexpectedExternalError(o)}e.onUnexpectedExternalError=T;function S(o){if(o instanceof Error){let{name:t,message:r}=o;const d=o.stacktrace||o.stack;return{$isError:!0,name:t,message:r,stack:d}}return o}e.transformErrorForSerialization=S;const I="Canceled";function y(o){return o instanceof Error&&o.name===I&&o.message===I}e.isPromiseCanceledError=y;class n extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=n;function R(){const o=new Error(I);return o.name=o.message,o}e.canceled=R;function C(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}e.illegalArgument=C;function b(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}e.illegalState=b;function f(o){return o?new Error(`readonly property '${o} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function i(o){const t=new Error(`${o} has been disposed`);return t.name="DISPOSED",t}e.disposed=i;function s(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}e.getErrorMessage=s;class v extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=v;class h extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=h;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function g(o){const t=o;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=g;function a(o,t=Object.create(null)){const r=new Error(o);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=a}),define(be[15],we([0,1,10]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k(M,U=0){return M[M.length-(1+U)]}e.tail=k;function A(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}e.tail2=A;function T(M,U,x=(Q,$)=>Q===$){if(M===U)return!0;if(!M||!U||M.length!==U.length)return!1;for(let Q=0,$=M.length;Q<$;Q++)if(!x(M[Q],U[Q]))return!1;return!0}e.equals=T;function S(M,U,x){let Q=0,$=M.length-1;for(;Q<=$;){const ee=(Q+$)/2|0,re=x(M[ee],U);if(re<0)Q=ee+1;else if(re>0)$=ee-1;else return ee}return-(Q+1)}e.binarySearch=S;function I(M,U){let x=0,Q=M.length;if(Q===0)return 0;for(;x<Q;){const $=Math.floor((x+Q)/2);U(M[$])?Q=$:x=$+1}return x}e.findFirstInSorted=I;function y(M,U,x){if(M=M|0,M>=U.length)throw new TypeError("invalid index");let Q=U[Math.floor(U.length*Math.random())],$=[],ee=[],re=[];for(let se of U){const ye=x(se,Q);ye<0?$.push(se):ye>0?ee.push(se):re.push(se)}return M<$.length?y(M,$,x):M<$.length+re.length?re[0]:y(M-($.length+re.length),ee,x)}e.quickSelect=y;function n(M,U){const x=[];let Q;for(const $ of M.slice(0).sort(U))!Q||U(Q[0],$)!==0?(Q=[$],x.push(Q)):Q.push($);return x}e.groupBy=n;function R(M,U,x){const Q=[];function $(se,ye,Ie){if(!(ye===0&&Ie.length===0)){const xe=Q[Q.length-1];xe&&xe.start+xe.deleteCount===se?(xe.deleteCount+=ye,xe.toInsert.push(...Ie)):Q.push({start:se,deleteCount:ye,toInsert:Ie})}}let ee=0,re=0;for(;;){if(ee===M.length){$(ee,0,U.slice(re));break}if(re===U.length){$(ee,M.length-ee,[]);break}const se=M[ee],ye=U[re],Ie=x(se,ye);Ie===0?(ee+=1,re+=1):Ie<0?($(ee,1,[]),ee+=1):Ie>0&&($(ee,0,[ye]),re+=1)}return Q}e.sortedDiff=R;function C(M,U,x){const Q=R(M,U,x),$=[],ee=[];for(const re of Q)$.push(...M.slice(re.start,re.start+re.deleteCount)),ee.push(...re.toInsert);return{removed:$,added:ee}}e.delta=C;function b(M,U,x){if(x===0)return[];const Q=M.slice(0,x).sort(U);return i(M,U,Q,x,M.length),Q}e.top=b;function f(M,U,x,Q,$){return x===0?Promise.resolve([]):new Promise((ee,re)=>{(async()=>{const se=M.length,ye=M.slice(0,x).sort(U);for(let Ie=x,xe=Math.min(x+Q,se);Ie<se;Ie=xe,xe=Math.min(xe+Q,se)){if(Ie>x&&await new Promise(Fe=>setTimeout(Fe)),$&&$.isCancellationRequested)throw(0,w.canceled)();i(M,U,ye,Ie,xe)}return ye})().then(ee,re)})}e.topAsync=f;function i(M,U,x,Q,$){for(const ee=x.length;Q<$;Q++){const re=M[Q];if(U(re,x[ee-1])<0){x.pop();const se=I(x,ye=>U(re,ye)<0);x.splice(se,0,re)}}}function s(M){return M.filter(U=>!!U)}e.coalesce=s;function v(M){let U=0;for(let x=0;x<M.length;x++)M[x]&&(M[U]=M[x],U+=1);M.length=U}e.coalesceInPlace=v;function h(M,U,x){M.splice(x,0,M.splice(U,1)[0])}e.move=h;function E(M){return!Array.isArray(M)||M.length===0}e.isFalsyOrEmpty=E;function g(M){return Array.isArray(M)&&M.length>0}e.isNonEmptyArray=g;function a(M,U){if(!U)return M.filter((Q,$)=>M.indexOf(Q)===$);const x=Object.create(null);return M.filter(Q=>{const $=U(Q);return x[$]?!1:(x[$]=!0,!0)})}e.distinct=a;function o(M){const U=new Set;return M.filter(x=>U.has(x)?!1:(U.add(x),!0))}e.distinctES6=o;function t(M){const U=Object.create(null);return x=>{const Q=M(x);return U[Q]?!1:(U[Q]=!0,!0)}}e.uniqueFilter=t;function r(M,U){for(let x=M.length-1;x>=0;x--){const Q=M[x];if(U(Q))return x}return-1}e.lastIndex=r;function d(M,U){return M.length>0?M[0]:U}e.firstOrDefault=d;function l(M,U,x=(Q,$)=>Q===$){let Q=0;for(let $=0,ee=Math.min(M.length,U.length);$<ee&&x(M[$],U[$]);$++)Q++;return Q}e.commonPrefixLength=l;function u(M){return[].concat(...M)}e.flatten=u;function m(M,U){let x=typeof U=="number"?M:0;typeof U=="number"?x=M:(x=0,U=M);const Q=[];if(x<=U)for(let $=x;$<U;$++)Q.push($);else for(let $=x;$>U;$--)Q.push($);return Q}e.range=m;function _(M,U,x){return M.reduce((Q,$)=>(Q[U($)]=x?x($):$,Q),Object.create(null))}e.index=_;function D(M,U){return M.push(U),()=>c(M,U)}e.insert=D;function c(M,U){const x=M.indexOf(U);if(x>-1)return M.splice(x,1),U}e.remove=c;function p(M,U,x){const Q=M.slice(0,U),$=M.slice(U);return Q.concat(x,$)}e.arrayInsert=p;function P(M,U){let x;if(typeof U=="number"){let Q=U;x=()=>{const $=Math.sin(Q++)*179426549;return $-Math.floor($)}}else x=Math.random;for(let Q=M.length-1;Q>0;Q-=1){const $=Math.floor(x()*(Q+1)),ee=M[Q];M[Q]=M[$],M[$]=ee}}e.shuffle=P;function F(M,U){const x=M.indexOf(U);x>-1&&(M.splice(x,1),M.unshift(U))}e.pushToStart=F;function z(M,U){const x=M.indexOf(U);x>-1&&(M.splice(x,1),M.push(U))}e.pushToEnd=z;function de(M,U){return Array.isArray(M)?M.map(U):U(M)}e.mapArrayOrNot=de;function B(M){return Array.isArray(M)?M:[M]}e.asArray=B;function W(M){return M[Math.floor(Math.random()*M.length)]}e.getRandomElement=W;function K(M,U){for(const x of M){const Q=U(x);if(Q!==void 0)return Q}}e.mapFind=K}),define(be[52],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(k){const A=this;let T=!1,S;return function(){return T||(T=!0,S=k.apply(A,arguments)),S}}e.once=w}),define(be[53],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class w{constructor(A){this._prefix=A,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=w,e.defaultGenerator=new w("id#")}),define(be[54],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(k){function A(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}k.is=A;const T=Object.freeze([]);function S(){return T}k.empty=S;function*I(o){yield o}k.single=I;function y(o){return o||T}k.from=y;function n(o){return!o||o[Symbol.iterator]().next().done===!0}k.isEmpty=n;function R(o){return o[Symbol.iterator]().next().value}k.first=R;function C(o,t){for(const r of o)if(t(r))return!0;return!1}k.some=C;function b(o,t){for(const r of o)if(t(r))return r}k.find=b;function*f(o,t){for(const r of o)t(r)&&(yield r)}k.filter=f;function*i(o,t){for(const r of o)yield t(r)}k.map=i;function*s(...o){for(const t of o)for(const r of t)yield r}k.concat=s;function*v(o){for(const t of o)for(const r of t)yield r}k.concatNested=v;function h(o,t,r){let d=r;for(const l of o)d=t(d,l);return d}k.reduce=h;function*E(o,t,r=o.length){for(t<0&&(t+=o.length),r<0?r+=o.length:r>o.length&&(r=o.length);t<r;t++)yield o[t]}k.slice=E;function g(o,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,o];const d=o[Symbol.iterator]();for(let l=0;l<t;l++){const u=d.next();if(u.done)return[r,k.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return d}}]}k.consume=g;function a(o,t,r=(d,l)=>d===l){const d=o[Symbol.iterator](),l=t[Symbol.iterator]();for(;;){const u=d.next(),m=l.next();if(u.done!==m.done)return!1;if(u.done)return!0;if(!r(u.value,m.value))return!1}}k.equals=a})(w=e.Iterable||(e.Iterable={}))}),define(be[44],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function S(t,r=!1){let d=0,l=t.length,u="",m=0,_=16,D=0;function c(W){let K=0,M=0;for(;K<W;){const U=t.charCodeAt(d);if(U>=48&&U<=57)M=M*16+U-48;else if(U>=65&&U<=70)M=M*16+U-65+10;else if(U>=97&&U<=102)M=M*16+U-97+10;else break;d++,K++}return K<W&&(M=-1),M}function p(W){d=W,u="",m=0,_=16,D=0}function P(){const W=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&n(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&n(t.charCodeAt(d)))for(d++;d<t.length&&n(t.charCodeAt(d));)d++;else return D=3,t.substring(W,d);let K=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&n(t.charCodeAt(d))){for(d++;d<t.length&&n(t.charCodeAt(d));)d++;K=d}else D=3;return t.substring(W,K)}function F(){let W="",K=d;for(;;){if(d>=l){W+=t.substring(K,d),D=2;break}const M=t.charCodeAt(d);if(M===34){W+=t.substring(K,d),d++;break}if(M===92){if(W+=t.substring(K,d),d++,d>=l){D=2;break}switch(t.charCodeAt(d++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:const x=c(4);x>=0?W+=String.fromCharCode(x):D=4;break;default:D=5}K=d;continue}if(M>=0&&M<=31)if(y(M)){W+=t.substring(K,d),D=2;break}else D=6;d++}return W}function z(){if(u="",D=0,m=d,d>=l)return m=l,_=17;let W=t.charCodeAt(d);if(I(W)){do d++,u+=String.fromCharCode(W),W=t.charCodeAt(d);while(I(W));return _=15}if(y(W))return d++,u+=String.fromCharCode(W),W===13&&t.charCodeAt(d)===10&&(d++,u+=`
`),_=14;switch(W){case 123:return d++,_=1;case 125:return d++,_=2;case 91:return d++,_=3;case 93:return d++,_=4;case 58:return d++,_=6;case 44:return d++,_=5;case 34:return d++,u=F(),_=10;case 47:const K=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<l&&!y(t.charCodeAt(d));)d++;return u=t.substring(K,d),_=12}if(t.charCodeAt(d+1)===42){d+=2;const M=l-1;let U=!1;for(;d<M;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,U=!0;break}d++}return U||(d++,D=1),u=t.substring(K,d),_=13}return u+=String.fromCharCode(W),d++,_=16;case 45:if(u+=String.fromCharCode(W),d++,d===l||!n(t.charCodeAt(d)))return _=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=P(),_=11;default:for(;d<l&&de(W);)d++,W=t.charCodeAt(d);if(m!==d){switch(u=t.substring(m,d),u){case"true":return _=8;case"false":return _=9;case"null":return _=7}return _=16}return u+=String.fromCharCode(W),d++,_=16}}function de(W){if(I(W)||y(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function B(){let W;do W=z();while(W>=12&&W<=15);return W}return{setPosition:p,getPosition:()=>d,scan:r?B:z,getToken:()=>_,getTokenValue:()=>u,getTokenOffset:()=>m,getTokenLength:()=>d-m,getTokenError:()=>D}}e.createScanner=S;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function C(t,r){const d=[],l=new Object;let u;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let _=!1;function D(c,p,P,F){m.value=c,m.offset=p,m.length=P,m.type=F,m.colonOffset=void 0,u=m}try{g(t,{onObjectBegin:(c,p)=>{if(r<=c)throw l;u=void 0,_=r>c,d.push("")},onObjectProperty:(c,p,P)=>{if(r<p||(D(c,p,P,"property"),d[d.length-1]=c,r<=p+P))throw l},onObjectEnd:(c,p)=>{if(r<=c)throw l;u=void 0,d.pop()},onArrayBegin:(c,p)=>{if(r<=c)throw l;u=void 0,d.push(0)},onArrayEnd:(c,p)=>{if(r<=c)throw l;u=void 0,d.pop()},onLiteralValue:(c,p,P)=>{if(r<p||(D(c,p,P,o(c)),r<=p+P))throw l},onSeparator:(c,p,P)=>{if(r<=p)throw l;if(c===":"&&u&&u.type==="property")u.colonOffset=p,_=!1,u=void 0;else if(c===","){const F=d[d.length-1];typeof F=="number"?d[d.length-1]=F+1:(_=!0,d[d.length-1]=""),u=void 0}}})}catch(c){if(c!==l)throw c}return{path:d,previousNode:u,isAtPropertyKey:_,matches:c=>{let p=0;for(let P=0;p<c.length&&P<d.length;P++)if(c[p]===d[P]||c[p]==="*")p++;else if(c[p]!=="**")return!1;return p===c.length}}}e.getLocation=C;function b(t,r=[],d=T.DEFAULT){let l=null,u=[];const m=[];function _(c){Array.isArray(u)?u.push(c):l!==null&&(u[l]=c)}return g(t,{onObjectBegin:()=>{const c={};_(c),m.push(u),u=c,l=null},onObjectProperty:c=>{l=c},onObjectEnd:()=>{u=m.pop()},onArrayBegin:()=>{const c=[];_(c),m.push(u),u=c,l=null},onArrayEnd:()=>{u=m.pop()},onLiteralValue:_,onError:(c,p,P)=>{r.push({error:c,offset:p,length:P})}},d),u[0]}e.parse=b;function f(t,r=[],d=T.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(c){l.type==="property"&&(l.length=c-l.offset,l=l.parent)}function m(c){return l.children.push(c),c}g(t,{onObjectBegin:c=>{l=m({type:"object",offset:c,length:-1,parent:l,children:[]})},onObjectProperty:(c,p,P)=>{l=m({type:"property",offset:p,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:c,offset:p,length:P,parent:l})},onObjectEnd:(c,p)=>{l.length=c+p-l.offset,l=l.parent,u(c+p)},onArrayBegin:(c,p)=>{l=m({type:"array",offset:c,length:-1,parent:l,children:[]})},onArrayEnd:(c,p)=>{l.length=c+p-l.offset,l=l.parent,u(c+p)},onLiteralValue:(c,p,P)=>{m({type:o(c),offset:p,length:P,parent:l,value:c}),u(p+P)},onSeparator:(c,p,P)=>{l.type==="property"&&(c===":"?l.colonOffset=p:c===","&&u(p))},onError:(c,p,P)=>{r.push({error:c,offset:p,length:P})}},d);const D=l.children[0];return D&&delete D.parent,D}e.parseTree=f;function i(t,r){if(!!t){let d=t;for(let l of r)if(typeof l=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let u=!1;for(const m of d.children)if(Array.isArray(m.children)&&m.children[0].value===l){d=m.children[1],u=!0;break}if(!u)return}else{const u=l;if(d.type!=="array"||u<0||!Array.isArray(d.children)||u>=d.children.length)return;d=d.children[u]}return d}}e.findNodeAtLocation=i;function s(t){if(!t.parent||!t.parent.children)return[];const r=s(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;r.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&r.push(d)}return r}e.getNodePath=s;function v(t){switch(t.type){case"array":return t.children.map(v);case"object":const r=Object.create(null);for(let d of t.children){const l=d.children[1];l&&(r[d.children[0].value]=v(l))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=v;function h(t,r,d=!1){return r>=t.offset&&r<t.offset+t.length||d&&r===t.offset+t.length}e.contains=h;function E(t,r,d=!1){if(h(t,r,d)){const l=t.children;if(Array.isArray(l))for(let u=0;u<l.length&&l[u].offset<=r;u++){const m=E(l[u],r,d);if(m)return m}return t}}e.findNodeAtOffset=E;function g(t,r,d=T.DEFAULT){const l=S(t,!1);function u(ye){return ye?()=>ye(l.getTokenOffset(),l.getTokenLength()):()=>!0}function m(ye){return ye?Ie=>ye(Ie,l.getTokenOffset(),l.getTokenLength()):()=>!0}const _=u(r.onObjectBegin),D=m(r.onObjectProperty),c=u(r.onObjectEnd),p=u(r.onArrayBegin),P=u(r.onArrayEnd),F=m(r.onLiteralValue),z=m(r.onSeparator),de=u(r.onComment),B=m(r.onError),W=d&&d.disallowComments,K=d&&d.allowTrailingComma;function M(){for(;;){const ye=l.scan();switch(l.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:W||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(ye){case 12:case 13:W?U(10):de();break;case 16:U(1);break;case 15:case 14:break;default:return ye}}}function U(ye,Ie=[],xe=[]){if(B(ye),Ie.length+xe.length>0){let Fe=l.getToken();for(;Fe!==17;){if(Ie.indexOf(Fe)!==-1){M();break}else if(xe.indexOf(Fe)!==-1)break;Fe=M()}}}function x(ye){const Ie=l.getTokenValue();return ye?F(Ie):D(Ie),M(),!0}function Q(){switch(l.getToken()){case 11:let ye=0;try{ye=JSON.parse(l.getTokenValue()),typeof ye!="number"&&(U(2),ye=0)}catch(Ie){U(2)}F(ye);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return M(),!0}function $(){return l.getToken()!==10?(U(3,[],[2,5]),!1):(x(!1),l.getToken()===6?(z(":"),M(),se()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function ee(){_(),M();let ye=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(ye||U(4,[],[]),z(","),M(),l.getToken()===2&&K)break}else ye&&U(6,[],[]);$()||U(4,[],[2,5]),ye=!0}return c(),l.getToken()!==2?U(7,[2],[]):M(),!0}function re(){p(),M();let ye=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(ye||U(4,[],[]),z(","),M(),l.getToken()===4&&K)break}else ye&&U(6,[],[]);se()||U(4,[],[4,5]),ye=!0}return P(),l.getToken()!==4?U(8,[4],[]):M(),!0}function se(){switch(l.getToken()){case 3:return re();case 1:return ee();case 10:return x(!0);default:return Q()}}return M(),l.getToken()===17?d.allowEmptyContent?!0:(U(4,[],[]),!1):se()?(l.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=g;function a(t,r){let d=S(t),l=[],u,m=0,_;do switch(_=d.getPosition(),u=d.scan(),u){case 12:case 13:case 17:m!==_&&l.push(t.substring(m,_)),r!==void 0&&l.push(d.getTokenValue().replace(/[^\r\n]/g,r)),m=d.getPosition();break}while(u!==17);return l.join("")}e.stripComments=a;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=o}),define(be[104],we([0,1,44]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(y,n,R){let C,b,f,i,s;if(n){for(i=n.offset,s=i+n.length,f=i;f>0&&!I(y,f-1);)f--;let m=s;for(;m<y.length&&!I(y,m);)m++;b=y.substring(f,m),C=T(b,R)}else b=y,C=0,f=0,i=0,s=y.length;const v=S(R,y);let h=!1,E=0,g;R.insertSpaces?g=A(" ",R.tabSize||4):g="	";const a=(0,w.createScanner)(b,!1);let o=!1;function t(){return v+A(g,C+E)}function r(){let m=a.scan();for(h=!1;m===15||m===14;)h=h||m===14,m=a.scan();return o=m===16||a.getTokenError()!==0,m}const d=[];function l(m,_,D){!o&&_<s&&D>i&&y.substring(_,D)!==m&&d.push({offset:_,length:D-_,content:m})}let u=r();if(u!==17){const m=a.getTokenOffset()+f,_=A(g,C);l(_,f,m)}for(;u!==17;){let m=a.getTokenOffset()+a.getTokenLength()+f,_=r(),D="";for(;!h&&(_===12||_===13);){const p=a.getTokenOffset()+f;l(" ",m,p),m=a.getTokenOffset()+a.getTokenLength()+f,D=_===12?t():"",_=r()}if(_===2)u!==1&&(E--,D=t());else if(_===4)u!==3&&(E--,D=t());else{switch(u){case 3:case 1:E++,D=t();break;case 5:case 12:D=t();break;case 13:h?D=t():D=" ";break;case 6:D=" ";break;case 10:if(_===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:_===12||_===13?D=" ":_!==5&&_!==17&&(o=!0);break;case 16:o=!0;break}h&&(_===12||_===13)&&(D=t())}const c=a.getTokenOffset()+f;l(D,m,c),u=_}return d}e.format=k;function A(y,n){let R="";for(let C=0;C<n;C++)R+=y;return R}function T(y,n){let R=0,C=0;const b=n.tabSize||4;for(;R<y.length;){const f=y.charAt(R);if(f===" ")C++;else if(f==="	")C+=b;else break;R++}return Math.floor(C/b)}function S(y,n){for(let R=0;R<n.length;R++){const C=n.charAt(R);if(C==="\r")return R+1<n.length&&n.charAt(R+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=S;function I(y,n){return`\r
`.indexOf(y.charAt(n))!==-1}e.isEOL=I}),define(be[105],we([0,1,44,104]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(n,R,C){return T(n,R,void 0,C)}e.removeProperty=A;function T(n,R,C,b,f){const i=R.slice(),s=[],v=(0,w.parseTree)(n,s);let h,E;for(;i.length>0&&(E=i.pop(),h=(0,w.findNodeAtLocation)(v,i),h===void 0&&C!==void 0);)typeof E=="string"?C={[E]:C}:C=[C];if(h)if(h.type==="object"&&typeof E=="string"&&Array.isArray(h.children)){const g=(0,w.findNodeAtLocation)(h,[E]);if(g!==void 0)if(C===void 0){if(!g.parent)throw new Error("Malformed AST");const a=h.children.indexOf(g.parent);let o,t=g.parent.offset+g.parent.length;if(a>0){const r=h.children[a-1];o=r.offset+r.length}else o=h.offset+1,h.children.length>1&&(t=h.children[1].offset);return S(n,{offset:o,length:t-o,content:""},b)}else return S(n,{offset:g.offset,length:g.length,content:JSON.stringify(C)},b);else{if(C===void 0)return[];const a=`${JSON.stringify(E)}: ${JSON.stringify(C)}`,o=f?f(h.children.map(r=>r.children[0].value)):h.children.length;let t;if(o>0){const r=h.children[o-1];t={offset:r.offset+r.length,length:0,content:","+a}}else h.children.length===0?t={offset:h.offset+1,length:0,content:a}:t={offset:h.offset+1,length:0,content:a+","};return S(n,t,b)}}else if(h.type==="array"&&typeof E=="number"&&Array.isArray(h.children))if(C!==void 0){const g=`${JSON.stringify(C)}`;let a;if(h.children.length===0||E===0)a={offset:h.offset+1,length:0,content:h.children.length===0?g:g+","};else{const o=E===-1||E>h.children.length?h.children.length:E,t=h.children[o-1];a={offset:t.offset+t.length,length:0,content:","+g}}return S(n,a,b)}else{const g=E,a=h.children[g];let o;if(h.children.length===1)o={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===g){const t=h.children[g-1],r=t.offset+t.length,d=h.offset+h.length;o={offset:r,length:d-2-r,content:""}}else o={offset:a.offset,length:h.children[g+1].offset-a.offset,content:""};return S(n,o,b)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${h.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return S(n,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(C)},b)}}e.setProperty=T;function S(n,R,C){let b=I(n,R),f=R.offset,i=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;f>0&&!(0,k.isEOL)(b,f-1);)f--;for(;i<b.length&&!(0,k.isEOL)(b,i);)i++}const s=(0,k.format)(b,{offset:f,length:i-f},C);for(let h=s.length-1;h>=0;h--){const E=s[h];b=I(b,E),f=Math.min(f,E.offset),i=Math.max(i,E.offset+E.length),i+=E.content.length-E.length}const v=n.length-(b.length-i)-f;return[{offset:f,length:v,content:b.substring(f,i)}]}e.withFormatting=S;function I(n,R){return n.substring(0,R.offset)+R.content+n.substring(R.offset+R.length)}e.applyEdit=I;function y(n,R){let C=R.slice(0).sort((f,i)=>{const s=f.offset-i.offset;return s===0?f.length-i.length:s}),b=n.length;for(let f=C.length-1;f>=0;f--){let i=C[f];if(i.offset+i.length<=b)n=I(n,i);else throw new Error("Overlapping edit");b=i.offset}return n}e.applyEdits=y}),define(be[106],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(A){this.executor=A,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(A){return new w(()=>A(this.getValue()))}}e.Lazy=w}),define(be[6],we([0,1,52,54]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let T=null;function S(g){T=g}if(e.setDisposableTracker=S,A){const g="__is_disposable_tracked__";T=new class{trackDisposable(a){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[g]||console.log(o)},3e3)}markTracked(a){if(a&&a!==s.None)try{a[g]=!0}catch(o){}}}}function I(g){!T||T.markTracked(g)}function y(g){return T&&T.trackDisposable(g),g}e.trackDisposable=y;class n extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=n;function R(g){return typeof g.dispose=="function"&&g.dispose.length===0}e.isDisposable=R;function C(g){if(k.Iterable.is(g)){let a=[];for(const o of g)if(o){I(o);try{o.dispose()}catch(t){a.push(t)}}if(a.length===1)throw a[0];if(a.length>1)throw new n(a);return Array.isArray(g)?[]:g}else if(g)return I(g),g.dispose(),g}e.dispose=C;function b(...g){return g.forEach(I),f(()=>C(g))}e.combinedDisposable=b;function f(g){const a=y({dispose:()=>{I(a),g()}});return a}e.toDisposable=f;class i{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(I(this),this._isDisposed=!0,this.clear())}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return I(a),this._isDisposed?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=i,i.DISABLE_DISPOSED_WARNING=!1;class s{constructor(){this._store=new i,y(this)}dispose(){I(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=s,s.None=Object.freeze({dispose(){}});class v{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){var o;this._isDisposed||a===this._value||((o=this._value)===null||o===void 0||o.dispose(),a&&I(a),this._value=a)}clear(){this.value=void 0}dispose(){var a;this._isDisposed=!0,I(this),(a=this._value)===null||a===void 0||a.dispose(),this._value=void 0}}e.MutableDisposable=v;class h{constructor(){this.references=new Map}acquire(a,...o){let t=this.references.get(a);t||(t={counter:0,object:this.createReferencedObject(a,...o)},this.references.set(a,t));const{object:r}=t,d=(0,w.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(a,t.object),this.references.delete(a))});return t.counter++,{object:r,dispose:d}}}e.ReferenceCollection=h;class E{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=E}),define(be[45],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(T){this.element=T,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class k{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,S){const I=new w(T);if(this._first===w.Undefined)this._first=I,this._last=I;else if(S){const n=this._last;this._last=I,I.prev=n,n.next=I}else{const n=this._first;this._first=I,I.next=n,n.prev=I}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(I))}}shift(){if(this._first!==w.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==w.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==w.Undefined&&T.next!==w.Undefined){const S=T.prev;S.next=T.next,T.next.prev=S}else T.prev===w.Undefined&&T.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):T.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):T.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==w.Undefined;)yield T.element,T=T.next}}e.LinkedList=k}),function(ie,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ie=typeof globalThis!="undefined"?globalThis:ie||self,ie.marked=e())}(this,function(){"use strict";function ie(H,ne){for(var he=0;he<ne.length;he++){var q=ne[he];q.enumerable=q.enumerable||!1,q.configurable=!0,"value"in q&&(q.writable=!0),Object.defineProperty(H,q.key,q)}}function e(H,ne,he){return ne&&ie(H.prototype,ne),he&&ie(H,he),H}function w(H,ne){if(!!H){if(typeof H=="string")return k(H,ne);var he=Object.prototype.toString.call(H).slice(8,-1);if(he==="Object"&&H.constructor&&(he=H.constructor.name),he==="Map"||he==="Set")return Array.from(H);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return k(H,ne)}}function k(H,ne){(ne==null||ne>H.length)&&(ne=H.length);for(var he=0,q=new Array(ne);he<ne;he++)q[he]=H[he];return q}function A(H,ne){var he;if(typeof Symbol=="undefined"||H[Symbol.iterator]==null){if(Array.isArray(H)||(he=w(H))||ne&&H&&typeof H.length=="number"){he&&(H=he);var q=0;return function(){return q>=H.length?{done:!0}:{done:!1,value:H[q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return he=H[Symbol.iterator](),he.next.bind(he)}function T(H){var ne={exports:{}};return H(ne,ne.exports),ne.exports}var S=T(function(H){function ne(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function he(q){H.exports.defaults=q}H.exports={defaults:ne(),getDefaults:ne,changeDefaults:he}}),I=/[&<>"']/,y=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,R=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(ne){return C[ne]};function f(H,ne){if(ne){if(I.test(H))return H.replace(y,b)}else if(n.test(H))return H.replace(R,b);return H}var i=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(H){return H.replace(i,function(ne,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var v=/(^|[^\[])\^/g;function h(H,ne){H=H.source||H,ne=ne||"";var he={replace:function(J,oe){return oe=oe.source||oe,oe=oe.replace(v,"$1"),H=H.replace(J,oe),he},getRegex:function(){return new RegExp(H,ne)}};return he}var E=/[^\w:]/g,g=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(H,ne,he){if(H){var q;try{q=decodeURIComponent(s(he)).replace(E,"").toLowerCase()}catch(J){return null}if(q.indexOf("javascript:")===0||q.indexOf("vbscript:")===0||q.indexOf("data:")===0)return null}ne&&!g.test(he)&&(he=l(ne,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch(J){return null}return he}var o={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(H,ne){o[" "+H]||(t.test(H)?o[" "+H]=H+"/":o[" "+H]=D(H,"/",!0)),H=o[" "+H];var he=H.indexOf(":")===-1;return ne.substring(0,2)==="//"?he?ne:H.replace(r,"$1")+ne:ne.charAt(0)==="/"?he?ne:H.replace(d,"$1")+ne:H+ne}var u={exec:function(){}};function m(H){for(var ne=1,he,q;ne<arguments.length;ne++){he=arguments[ne];for(q in he)Object.prototype.hasOwnProperty.call(he,q)&&(H[q]=he[q])}return H}function _(H,ne){var he=H.replace(/\|/g,function(oe,fe,pe){for(var Be=!1,Ne=fe;--Ne>=0&&pe[Ne]==="\\";)Be=!Be;return Be?"|":" |"}),q=he.split(/ \|/),J=0;if(q.length>ne)q.splice(ne);else for(;q.length<ne;)q.push("");for(;J<q.length;J++)q[J]=q[J].trim().replace(/\\\|/g,"|");return q}function D(H,ne,he){var q=H.length;if(q===0)return"";for(var J=0;J<q;){var oe=H.charAt(q-J-1);if(oe===ne&&!he)J++;else if(oe!==ne&&he)J++;else break}return H.substr(0,q-J)}function c(H,ne){if(H.indexOf(ne[1])===-1)return-1;for(var he=H.length,q=0,J=0;J<he;J++)if(H[J]==="\\")J++;else if(H[J]===ne[0])q++;else if(H[J]===ne[1]&&(q--,q<0))return J;return-1}function p(H){H&&H.sanitize&&!H.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(H,ne){if(ne<1)return"";for(var he="";ne>1;)ne&1&&(he+=H),ne>>=1,H+=H;return he+H}var F={escape:f,unescape:s,edit:h,cleanUrl:a,resolveUrl:l,noopTest:u,merge:m,splitCells:_,rtrim:D,findClosingBracket:c,checkSanitizeDeprecation:p,repeatString:P},z=S.defaults,de=F.rtrim,B=F.splitCells,W=F.escape,K=F.findClosingBracket;function M(H,ne,he){var q=ne.href,J=ne.title?W(ne.title):null,oe=H[1].replace(/\\([\[\]])/g,"$1");return H[0].charAt(0)!=="!"?{type:"link",raw:he,href:q,title:J,text:oe}:{type:"image",raw:he,href:q,title:J,text:W(oe)}}function U(H,ne){var he=H.match(/^(\s+)(?:```)/);if(he===null)return ne;var q=he[1];return ne.split(`
`).map(function(J){var oe=J.match(/^\s+/);if(oe===null)return J;var fe=oe[0];return fe.length>=q.length?J.slice(q.length):J}).join(`
`)}var x=function(){function H(he){this.options=he||z}var ne=H.prototype;return ne.space=function(q){var J=this.rules.block.newline.exec(q);if(J)return J[0].length>1?{type:"space",raw:J[0]}:{raw:`
`}},ne.code=function(q){var J=this.rules.block.code.exec(q);if(J){var oe=J[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:J[0],codeBlockStyle:"indented",text:this.options.pedantic?oe:de(oe,`
`)}}},ne.fences=function(q){var J=this.rules.block.fences.exec(q);if(J){var oe=J[0],fe=U(oe,J[3]||"");return{type:"code",raw:oe,lang:J[2]?J[2].trim():J[2],text:fe}}},ne.heading=function(q){var J=this.rules.block.heading.exec(q);if(J){var oe=J[2].trim();if(/#$/.test(oe)){var fe=de(oe,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(oe=fe.trim())}return{type:"heading",raw:J[0],depth:J[1].length,text:oe}}},ne.nptable=function(q){var J=this.rules.block.nptable.exec(q);if(J){var oe={type:"table",header:B(J[1].replace(/^ *| *\| *$/g,"")),align:J[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:J[3]?J[3].replace(/\n$/,"").split(`
`):[],raw:J[0]};if(oe.header.length===oe.align.length){var fe=oe.align.length,pe;for(pe=0;pe<fe;pe++)/^ *-+: *$/.test(oe.align[pe])?oe.align[pe]="right":/^ *:-+: *$/.test(oe.align[pe])?oe.align[pe]="center":/^ *:-+ *$/.test(oe.align[pe])?oe.align[pe]="left":oe.align[pe]=null;for(fe=oe.cells.length,pe=0;pe<fe;pe++)oe.cells[pe]=B(oe.cells[pe],oe.header.length);return oe}}},ne.hr=function(q){var J=this.rules.block.hr.exec(q);if(J)return{type:"hr",raw:J[0]}},ne.blockquote=function(q){var J=this.rules.block.blockquote.exec(q);if(J){var oe=J[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:J[0],text:oe}}},ne.list=function(q){var J=this.rules.block.list.exec(q);if(J){var oe=J[0],fe=J[2],pe=fe.length>1,Be={type:"list",raw:oe,ordered:pe,start:pe?+fe.slice(0,-1):"",loose:!1,items:[]},Ne=J[0].match(this.rules.block.item),Ve=!1,Xe,Ze,ct,ot,nt,ue,De,le,j=Ne.length;ct=this.rules.block.listItemStart.exec(Ne[0]);for(var Ae=0;Ae<j;Ae++){if(Xe=Ne[Ae],oe=Xe,Ae!==j-1){if(ot=this.rules.block.listItemStart.exec(Ne[Ae+1]),this.options.pedantic?ot[1].length>ct[1].length:ot[1].length>ct[0].length||ot[1].length>3){Ne.splice(Ae,2,Ne[Ae]+`
`+Ne[Ae+1]),Ae--,j--;continue}else(!this.options.pedantic||this.options.smartLists?ot[2][ot[2].length-1]!==fe[fe.length-1]:pe===(ot[2].length===1))&&(nt=Ne.slice(Ae+1).join(`
`),Be.raw=Be.raw.substring(0,Be.raw.length-nt.length),Ae=j-1);ct=ot}Ze=Xe.length,Xe=Xe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Xe.indexOf(`
 `)&&(Ze-=Xe.length,Xe=this.options.pedantic?Xe.replace(/^ {1,4}/gm,""):Xe.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),ue=Ve||/\n\n(?!\s*$)/.test(Xe),Ae!==j-1&&(Ve=Xe.charAt(Xe.length-1)===`
`,ue||(ue=Ve)),ue&&(Be.loose=!0),this.options.gfm&&(De=/^\[[ xX]\] /.test(Xe),le=void 0,De&&(le=Xe[1]!==" ",Xe=Xe.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:oe,task:De,checked:le,loose:ue,text:Xe})}return Be}},ne.html=function(q){var J=this.rules.block.html.exec(q);if(J)return{type:this.options.sanitize?"paragraph":"html",raw:J[0],pre:!this.options.sanitizer&&(J[1]==="pre"||J[1]==="script"||J[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):W(J[0]):J[0]}},ne.def=function(q){var J=this.rules.block.def.exec(q);if(J){J[3]&&(J[3]=J[3].substring(1,J[3].length-1));var oe=J[1].toLowerCase().replace(/\s+/g," ");return{tag:oe,raw:J[0],href:J[2],title:J[3]}}},ne.table=function(q){var J=this.rules.block.table.exec(q);if(J){var oe={type:"table",header:B(J[1].replace(/^ *| *\| *$/g,"")),align:J[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:J[3]?J[3].replace(/\n$/,"").split(`
`):[]};if(oe.header.length===oe.align.length){oe.raw=J[0];var fe=oe.align.length,pe;for(pe=0;pe<fe;pe++)/^ *-+: *$/.test(oe.align[pe])?oe.align[pe]="right":/^ *:-+: *$/.test(oe.align[pe])?oe.align[pe]="center":/^ *:-+ *$/.test(oe.align[pe])?oe.align[pe]="left":oe.align[pe]=null;for(fe=oe.cells.length,pe=0;pe<fe;pe++)oe.cells[pe]=B(oe.cells[pe].replace(/^ *\| *| *\| *$/g,""),oe.header.length);return oe}}},ne.lheading=function(q){var J=this.rules.block.lheading.exec(q);if(J)return{type:"heading",raw:J[0],depth:J[2].charAt(0)==="="?1:2,text:J[1]}},ne.paragraph=function(q){var J=this.rules.block.paragraph.exec(q);if(J)return{type:"paragraph",raw:J[0],text:J[1].charAt(J[1].length-1)===`
`?J[1].slice(0,-1):J[1]}},ne.text=function(q){var J=this.rules.block.text.exec(q);if(J)return{type:"text",raw:J[0],text:J[0]}},ne.escape=function(q){var J=this.rules.inline.escape.exec(q);if(J)return{type:"escape",raw:J[0],text:W(J[1])}},ne.tag=function(q,J,oe){var fe=this.rules.inline.tag.exec(q);if(fe)return!J&&/^<a /i.test(fe[0])?J=!0:J&&/^<\/a>/i.test(fe[0])&&(J=!1),!oe&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?oe=!0:oe&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(oe=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:J,inRawBlock:oe,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):W(fe[0]):fe[0]}},ne.link=function(q){var J=this.rules.inline.link.exec(q);if(J){var oe=J[2].trim();if(!this.options.pedantic&&/^</.test(oe)){if(!/>$/.test(oe))return;var fe=de(oe.slice(0,-1),"\\");if((oe.length-fe.length)%2==0)return}else{var pe=K(J[2],"()");if(pe>-1){var Be=J[0].indexOf("!")===0?5:4,Ne=Be+J[1].length+pe;J[2]=J[2].substring(0,pe),J[0]=J[0].substring(0,Ne).trim(),J[3]=""}}var Ve=J[2],Xe="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ve);Ze&&(Ve=Ze[1],Xe=Ze[3])}else Xe=J[3]?J[3].slice(1,-1):"";return Ve=Ve.trim(),/^</.test(Ve)&&(this.options.pedantic&&!/>$/.test(oe)?Ve=Ve.slice(1):Ve=Ve.slice(1,-1)),M(J,{href:Ve&&Ve.replace(this.rules.inline._escapes,"$1"),title:Xe&&Xe.replace(this.rules.inline._escapes,"$1")},J[0])}},ne.reflink=function(q,J){var oe;if((oe=this.rules.inline.reflink.exec(q))||(oe=this.rules.inline.nolink.exec(q))){var fe=(oe[2]||oe[1]).replace(/\s+/g," ");if(fe=J[fe.toLowerCase()],!fe||!fe.href){var pe=oe[0].charAt(0);return{type:"text",raw:pe,text:pe}}return M(oe,fe,oe[0])}},ne.emStrong=function(q,J,oe){oe===void 0&&(oe="");var fe=this.rules.inline.emStrong.lDelim.exec(q);if(!!fe&&!(fe[3]&&oe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var pe=fe[1]||fe[2]||"";if(!pe||pe&&(oe===""||this.rules.inline.punctuation.exec(oe))){var Be=fe[0].length-1,Ne,Ve,Xe=Be,Ze=0,ct=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ct.lastIndex=0,J=J.slice(-1*q.length+Be);(fe=ct.exec(J))!=null;)if(Ne=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Ne){if(Ve=Ne.length,fe[3]||fe[4]){Xe+=Ve;continue}else if((fe[5]||fe[6])&&Be%3&&!((Be+Ve)%3)){Ze+=Ve;continue}if(Xe-=Ve,!(Xe>0)){if(Xe+Ze-Ve<=0&&!J.slice(ct.lastIndex).match(ct)&&(Ve=Math.min(Ve,Ve+Xe+Ze)),Math.min(Be,Ve)%2)return{type:"em",raw:q.slice(0,Be+fe.index+Ve+1),text:q.slice(1,Be+fe.index+Ve)};if(Math.min(Be,Ve)%2==0)return{type:"strong",raw:q.slice(0,Be+fe.index+Ve+1),text:q.slice(2,Be+fe.index+Ve-1)}}}}}},ne.codespan=function(q){var J=this.rules.inline.code.exec(q);if(J){var oe=J[2].replace(/\n/g," "),fe=/[^ ]/.test(oe),pe=/^ /.test(oe)&&/ $/.test(oe);return fe&&pe&&(oe=oe.substring(1,oe.length-1)),oe=W(oe,!0),{type:"codespan",raw:J[0],text:oe}}},ne.br=function(q){var J=this.rules.inline.br.exec(q);if(J)return{type:"br",raw:J[0]}},ne.del=function(q){var J=this.rules.inline.del.exec(q);if(J)return{type:"del",raw:J[0],text:J[2]}},ne.autolink=function(q,J){var oe=this.rules.inline.autolink.exec(q);if(oe){var fe,pe;return oe[2]==="@"?(fe=W(this.options.mangle?J(oe[1]):oe[1]),pe="mailto:"+fe):(fe=W(oe[1]),pe=fe),{type:"link",raw:oe[0],text:fe,href:pe,tokens:[{type:"text",raw:fe,text:fe}]}}},ne.url=function(q,J){var oe;if(oe=this.rules.inline.url.exec(q)){var fe,pe;if(oe[2]==="@")fe=W(this.options.mangle?J(oe[0]):oe[0]),pe="mailto:"+fe;else{var Be;do Be=oe[0],oe[0]=this.rules.inline._backpedal.exec(oe[0])[0];while(Be!==oe[0]);fe=W(oe[0]),oe[1]==="www."?pe="http://"+fe:pe=fe}return{type:"link",raw:oe[0],text:fe,href:pe,tokens:[{type:"text",raw:fe,text:fe}]}}},ne.inlineText=function(q,J,oe){var fe=this.rules.inline.text.exec(q);if(fe){var pe;return J?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):W(fe[0]):fe[0]:pe=W(this.options.smartypants?oe(fe[0]):fe[0]),{type:"text",raw:fe[0],text:pe}}},H}(),Q=F.noopTest,$=F.edit,ee=F.merge,re={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:Q,table:Q,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};re._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,re._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,re.def=$(re.def).replace("label",re._label).replace("title",re._title).getRegex(),re.bullet=/(?:[*+-]|\d{1,9}[.)])/,re.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,re.item=$(re.item,"gm").replace(/bull/g,re.bullet).getRegex(),re.listItemStart=$(/^( *)(bull)/).replace("bull",re.bullet).getRegex(),re.list=$(re.list).replace(/bull/g,re.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+re.def.source+")").getRegex(),re._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",re._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,re.html=$(re.html,"i").replace("comment",re._comment).replace("tag",re._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),re.paragraph=$(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",re._tag).getRegex(),re.blockquote=$(re.blockquote).replace("paragraph",re.paragraph).getRegex(),re.normal=ee({},re),re.gfm=ee({},re.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),re.gfm.nptable=$(re.gfm.nptable).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",re._tag).getRegex(),re.gfm.table=$(re.gfm.table).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",re._tag).getRegex(),re.pedantic=ee({},re.normal,{html:$(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",re._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:Q,paragraph:$(re.normal._paragraph).replace("hr",re.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",re.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:Q,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:Q,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",se.punctuation=$(se.punctuation).replace(/punctuation/g,se._punctuation).getRegex(),se.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,se.escapedEmSt=/\\\*|\\_/g,se._comment=$(re._comment).replace("(?:-->|$)","-->").getRegex(),se.emStrong.lDelim=$(se.emStrong.lDelim).replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimAst=$(se.emStrong.rDelimAst,"g").replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimUnd=$(se.emStrong.rDelimUnd,"g").replace(/punct/g,se._punctuation).getRegex(),se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,se.autolink=$(se.autolink).replace("scheme",se._scheme).replace("email",se._email).getRegex(),se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,se.tag=$(se.tag).replace("comment",se._comment).replace("attribute",se._attribute).getRegex(),se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,se._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,se.link=$(se.link).replace("label",se._label).replace("href",se._href).replace("title",se._title).getRegex(),se.reflink=$(se.reflink).replace("label",se._label).getRegex(),se.reflinkSearch=$(se.reflinkSearch,"g").replace("reflink",se.reflink).replace("nolink",se.nolink).getRegex(),se.normal=ee({},se),se.pedantic=ee({},se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:$(/^!?\[(label)\]\((.*?)\)/).replace("label",se._label).getRegex(),reflink:$(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",se._label).getRegex()}),se.gfm=ee({},se.normal,{escape:$(se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),se.gfm.url=$(se.gfm.url,"i").replace("email",se.gfm._extended_email).getRegex(),se.breaks=ee({},se.gfm,{br:$(se.br).replace("{2,}","*").getRegex(),text:$(se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ye={block:re,inline:se},Ie=S.defaults,xe=ye.block,Fe=ye.inline,ze=F.repeatString;function N(H){return H.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(H){var ne="",he,q,J=H.length;for(he=0;he<J;he++)q=H.charCodeAt(he),Math.random()>.5&&(q="x"+q.toString(16)),ne+="&#"+q+";";return ne}var te=function(){function H(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||Ie,this.options.tokenizer=this.options.tokenizer||new x,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var q={block:xe.normal,inline:Fe.normal};this.options.pedantic?(q.block=xe.pedantic,q.inline=Fe.pedantic):this.options.gfm&&(q.block=xe.gfm,this.options.breaks?q.inline=Fe.breaks:q.inline=Fe.gfm),this.tokenizer.rules=q}H.lex=function(q,J){var oe=new H(J);return oe.lex(q)},H.lexInline=function(q,J){var oe=new H(J);return oe.inlineTokens(q)};var ne=H.prototype;return ne.lex=function(q){return q=q.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(q,this.tokens,!0),this.inline(this.tokens),this.tokens},ne.blockTokens=function(q,J,oe){J===void 0&&(J=[]),oe===void 0&&(oe=!0),this.options.pedantic&&(q=q.replace(/^ +$/gm,""));for(var fe,pe,Be,Ne;q;){if(fe=this.tokenizer.space(q)){q=q.substring(fe.raw.length),fe.type&&J.push(fe);continue}if(fe=this.tokenizer.code(q)){q=q.substring(fe.raw.length),Ne=J[J.length-1],Ne&&Ne.type==="paragraph"?(Ne.raw+=`
`+fe.raw,Ne.text+=`
`+fe.text):J.push(fe);continue}if(fe=this.tokenizer.fences(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(fe=this.tokenizer.heading(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(fe=this.tokenizer.nptable(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(fe=this.tokenizer.hr(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(fe=this.tokenizer.blockquote(q)){q=q.substring(fe.raw.length),fe.tokens=this.blockTokens(fe.text,[],oe),J.push(fe);continue}if(fe=this.tokenizer.list(q)){for(q=q.substring(fe.raw.length),Be=fe.items.length,pe=0;pe<Be;pe++)fe.items[pe].tokens=this.blockTokens(fe.items[pe].text,[],!1);J.push(fe);continue}if(fe=this.tokenizer.html(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(oe&&(fe=this.tokenizer.def(q))){q=q.substring(fe.raw.length),this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(fe=this.tokenizer.lheading(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(oe&&(fe=this.tokenizer.paragraph(q))){q=q.substring(fe.raw.length),J.push(fe);continue}if(fe=this.tokenizer.text(q)){q=q.substring(fe.raw.length),Ne=J[J.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+fe.raw,Ne.text+=`
`+fe.text):J.push(fe);continue}if(q){var Ve="Infinite loop on byte: "+q.charCodeAt(0);if(this.options.silent){console.error(Ve);break}else throw new Error(Ve)}}return J},ne.inline=function(q){var J,oe,fe,pe,Be,Ne,Ve=q.length;for(J=0;J<Ve;J++)switch(Ne=q[J],Ne.type){case"paragraph":case"text":case"heading":{Ne.tokens=[],this.inlineTokens(Ne.text,Ne.tokens);break}case"table":{for(Ne.tokens={header:[],cells:[]},pe=Ne.header.length,oe=0;oe<pe;oe++)Ne.tokens.header[oe]=[],this.inlineTokens(Ne.header[oe],Ne.tokens.header[oe]);for(pe=Ne.cells.length,oe=0;oe<pe;oe++)for(Be=Ne.cells[oe],Ne.tokens.cells[oe]=[],fe=0;fe<Be.length;fe++)Ne.tokens.cells[oe][fe]=[],this.inlineTokens(Be[fe],Ne.tokens.cells[oe][fe]);break}case"blockquote":{this.inline(Ne.tokens);break}case"list":{for(pe=Ne.items.length,oe=0;oe<pe;oe++)this.inline(Ne.items[oe].tokens);break}}return q},ne.inlineTokens=function(q,J,oe,fe){J===void 0&&(J=[]),oe===void 0&&(oe=!1),fe===void 0&&(fe=!1);var pe,Be,Ne=q,Ve,Xe,Ze;if(this.tokens.links){var ct=Object.keys(this.tokens.links);if(ct.length>0)for(;(Ve=this.tokenizer.rules.inline.reflinkSearch.exec(Ne))!=null;)ct.includes(Ve[0].slice(Ve[0].lastIndexOf("[")+1,-1))&&(Ne=Ne.slice(0,Ve.index)+"["+ze("a",Ve[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ve=this.tokenizer.rules.inline.blockSkip.exec(Ne))!=null;)Ne=Ne.slice(0,Ve.index)+"["+ze("a",Ve[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ve=this.tokenizer.rules.inline.escapedEmSt.exec(Ne))!=null;)Ne=Ne.slice(0,Ve.index)+"++"+Ne.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;q;){if(Xe||(Ze=""),Xe=!1,pe=this.tokenizer.escape(q)){q=q.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.tag(q,oe,fe)){q=q.substring(pe.raw.length),oe=pe.inLink,fe=pe.inRawBlock;var ot=J[J.length-1];ot&&pe.type==="text"&&ot.type==="text"?(ot.raw+=pe.raw,ot.text+=pe.text):J.push(pe);continue}if(pe=this.tokenizer.link(q)){q=q.substring(pe.raw.length),pe.type==="link"&&(pe.tokens=this.inlineTokens(pe.text,[],!0,fe)),J.push(pe);continue}if(pe=this.tokenizer.reflink(q,this.tokens.links)){q=q.substring(pe.raw.length);var nt=J[J.length-1];pe.type==="link"?(pe.tokens=this.inlineTokens(pe.text,[],!0,fe),J.push(pe)):nt&&pe.type==="text"&&nt.type==="text"?(nt.raw+=pe.raw,nt.text+=pe.text):J.push(pe);continue}if(pe=this.tokenizer.emStrong(q,Ne,Ze)){q=q.substring(pe.raw.length),pe.tokens=this.inlineTokens(pe.text,[],oe,fe),J.push(pe);continue}if(pe=this.tokenizer.codespan(q)){q=q.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.br(q)){q=q.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.del(q)){q=q.substring(pe.raw.length),pe.tokens=this.inlineTokens(pe.text,[],oe,fe),J.push(pe);continue}if(pe=this.tokenizer.autolink(q,G)){q=q.substring(pe.raw.length),J.push(pe);continue}if(!oe&&(pe=this.tokenizer.url(q,G))){q=q.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.inlineText(q,fe,N)){q=q.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(Ze=pe.raw.slice(-1)),Xe=!0,Be=J[J.length-1],Be&&Be.type==="text"?(Be.raw+=pe.raw,Be.text+=pe.text):J.push(pe);continue}if(q){var ue="Infinite loop on byte: "+q.charCodeAt(0);if(this.options.silent){console.error(ue);break}else throw new Error(ue)}}return J},e(H,null,[{key:"rules",get:function(){return{block:xe,inline:Fe}}}]),H}(),ae=S.defaults,me=F.cleanUrl,Se=F.escape,Le=function(){function H(he){this.options=he||ae}var ne=H.prototype;return ne.code=function(q,J,oe){var fe=(J||"").match(/\S*/)[0];if(this.options.highlight){var pe=this.options.highlight(q,fe);pe!=null&&pe!==q&&(oe=!0,q=pe)}return q=q.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+Se(fe,!0)+'">'+(oe?q:Se(q,!0))+`</code></pre>
`:"<pre><code>"+(oe?q:Se(q,!0))+`</code></pre>
`},ne.blockquote=function(q){return`<blockquote>
`+q+`</blockquote>
`},ne.html=function(q){return q},ne.heading=function(q,J,oe,fe){return this.options.headerIds?"<h"+J+' id="'+this.options.headerPrefix+fe.slug(oe)+'">'+q+"</h"+J+`>
`:"<h"+J+">"+q+"</h"+J+`>
`},ne.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ne.list=function(q,J,oe){var fe=J?"ol":"ul",pe=J&&oe!==1?' start="'+oe+'"':"";return"<"+fe+pe+`>
`+q+"</"+fe+`>
`},ne.listitem=function(q){return"<li>"+q+`</li>
`},ne.checkbox=function(q){return"<input "+(q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ne.paragraph=function(q){return"<p>"+q+`</p>
`},ne.table=function(q,J){return J&&(J="<tbody>"+J+"</tbody>"),`<table>
<thead>
`+q+`</thead>
`+J+`</table>
`},ne.tablerow=function(q){return`<tr>
`+q+`</tr>
`},ne.tablecell=function(q,J){var oe=J.header?"th":"td",fe=J.align?"<"+oe+' align="'+J.align+'">':"<"+oe+">";return fe+q+"</"+oe+`>
`},ne.strong=function(q){return"<strong>"+q+"</strong>"},ne.em=function(q){return"<em>"+q+"</em>"},ne.codespan=function(q){return"<code>"+q+"</code>"},ne.br=function(){return this.options.xhtml?"<br/>":"<br>"},ne.del=function(q){return"<del>"+q+"</del>"},ne.link=function(q,J,oe){if(q=me(this.options.sanitize,this.options.baseUrl,q),q===null)return oe;var fe='<a href="'+Se(q)+'"';return J&&(fe+=' title="'+J+'"'),fe+=">"+oe+"</a>",fe},ne.image=function(q,J,oe){if(q=me(this.options.sanitize,this.options.baseUrl,q),q===null)return oe;var fe='<img src="'+q+'" alt="'+oe+'"';return J&&(fe+=' title="'+J+'"'),fe+=this.options.xhtml?"/>":">",fe},ne.text=function(q){return q},H}(),ge=function(){function H(){}var ne=H.prototype;return ne.strong=function(q){return q},ne.em=function(q){return q},ne.codespan=function(q){return q},ne.del=function(q){return q},ne.html=function(q){return q},ne.text=function(q){return q},ne.link=function(q,J,oe){return""+oe},ne.image=function(q,J,oe){return""+oe},ne.br=function(){return""},H}(),Ce=function(){function H(){this.seen={}}var ne=H.prototype;return ne.serialize=function(q){return q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ne.getNextSafeSlug=function(q,J){var oe=q,fe=0;if(this.seen.hasOwnProperty(oe)){fe=this.seen[q];do fe++,oe=q+"-"+fe;while(this.seen.hasOwnProperty(oe))}return J||(this.seen[q]=fe,this.seen[oe]=0),oe},ne.slug=function(q,J){J===void 0&&(J={});var oe=this.serialize(q);return this.getNextSafeSlug(oe,J.dryrun)},H}(),Pe=S.defaults,$e=F.unescape,_e=function(){function H(he){this.options=he||Pe,this.options.renderer=this.options.renderer||new Le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ge,this.slugger=new Ce}H.parse=function(q,J){var oe=new H(J);return oe.parse(q)},H.parseInline=function(q,J){var oe=new H(J);return oe.parseInline(q)};var ne=H.prototype;return ne.parse=function(q,J){J===void 0&&(J=!0);var oe="",fe,pe,Be,Ne,Ve,Xe,Ze,ct,ot,nt,ue,De,le,j,Ae,Te,Ye,Ge,rt=q.length;for(fe=0;fe<rt;fe++)switch(nt=q[fe],nt.type){case"space":continue;case"hr":{oe+=this.renderer.hr();continue}case"heading":{oe+=this.renderer.heading(this.parseInline(nt.tokens),nt.depth,$e(this.parseInline(nt.tokens,this.textRenderer)),this.slugger);continue}case"code":{oe+=this.renderer.code(nt.text,nt.lang,nt.escaped);continue}case"table":{for(ct="",Ze="",Ne=nt.header.length,pe=0;pe<Ne;pe++)Ze+=this.renderer.tablecell(this.parseInline(nt.tokens.header[pe]),{header:!0,align:nt.align[pe]});for(ct+=this.renderer.tablerow(Ze),ot="",Ne=nt.cells.length,pe=0;pe<Ne;pe++){for(Xe=nt.tokens.cells[pe],Ze="",Ve=Xe.length,Be=0;Be<Ve;Be++)Ze+=this.renderer.tablecell(this.parseInline(Xe[Be]),{header:!1,align:nt.align[Be]});ot+=this.renderer.tablerow(Ze)}oe+=this.renderer.table(ct,ot);continue}case"blockquote":{ot=this.parse(nt.tokens),oe+=this.renderer.blockquote(ot);continue}case"list":{for(ue=nt.ordered,De=nt.start,le=nt.loose,Ne=nt.items.length,ot="",pe=0;pe<Ne;pe++)Ae=nt.items[pe],Te=Ae.checked,Ye=Ae.task,j="",Ae.task&&(Ge=this.renderer.checkbox(Te),le?Ae.tokens.length>0&&Ae.tokens[0].type==="text"?(Ae.tokens[0].text=Ge+" "+Ae.tokens[0].text,Ae.tokens[0].tokens&&Ae.tokens[0].tokens.length>0&&Ae.tokens[0].tokens[0].type==="text"&&(Ae.tokens[0].tokens[0].text=Ge+" "+Ae.tokens[0].tokens[0].text)):Ae.tokens.unshift({type:"text",text:Ge}):j+=Ge),j+=this.parse(Ae.tokens,le),ot+=this.renderer.listitem(j,Ye,Te);oe+=this.renderer.list(ot,ue,De);continue}case"html":{oe+=this.renderer.html(nt.text);continue}case"paragraph":{oe+=this.renderer.paragraph(this.parseInline(nt.tokens));continue}case"text":{for(ot=nt.tokens?this.parseInline(nt.tokens):nt.text;fe+1<rt&&q[fe+1].type==="text";)nt=q[++fe],ot+=`
`+(nt.tokens?this.parseInline(nt.tokens):nt.text);oe+=J?this.renderer.paragraph(ot):ot;continue}default:{var at='Token with "'+nt.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}return oe},ne.parseInline=function(q,J){J=J||this.renderer;var oe="",fe,pe,Be=q.length;for(fe=0;fe<Be;fe++)switch(pe=q[fe],pe.type){case"escape":{oe+=J.text(pe.text);break}case"html":{oe+=J.html(pe.text);break}case"link":{oe+=J.link(pe.href,pe.title,this.parseInline(pe.tokens,J));break}case"image":{oe+=J.image(pe.href,pe.title,pe.text);break}case"strong":{oe+=J.strong(this.parseInline(pe.tokens,J));break}case"em":{oe+=J.em(this.parseInline(pe.tokens,J));break}case"codespan":{oe+=J.codespan(pe.text);break}case"br":{oe+=J.br();break}case"del":{oe+=J.del(this.parseInline(pe.tokens,J));break}case"text":{oe+=J.text(pe.text);break}default:{var Ne='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}return oe},H}(),qe=F.merge,V=F.checkSanitizeDeprecation,X=F.escape,ve=S.getDefaults,Me=S.changeDefaults,He=S.defaults;function Oe(H,ne,he){if(typeof H=="undefined"||H===null)throw new Error("marked(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");if(typeof ne=="function"&&(he=ne,ne=null),ne=qe({},Oe.defaults,ne||{}),V(ne),he){var q=ne.highlight,J;try{J=te.lex(H,ne)}catch(Be){return he(Be)}var oe=function(Ne){var Ve;if(!Ne)try{Ve=_e.parse(J,ne)}catch(Xe){Ne=Xe}return ne.highlight=q,Ne?he(Ne):he(null,Ve)};if(!q||q.length<3||(delete ne.highlight,!J.length))return oe();var fe=0;Oe.walkTokens(J,function(Be){Be.type==="code"&&(fe++,setTimeout(function(){q(Be.text,Be.lang,function(Ne,Ve){if(Ne)return oe(Ne);Ve!=null&&Ve!==Be.text&&(Be.text=Ve,Be.escaped=!0),fe--,fe===0&&oe()})},0))}),fe===0&&oe();return}try{var pe=te.lex(H,ne);return ne.walkTokens&&Oe.walkTokens(pe,ne.walkTokens),_e.parse(pe,ne)}catch(Be){if(Be.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+X(Be.message+"",!0)+"</pre>";throw Be}}Oe.options=Oe.setOptions=function(H){return qe(Oe.defaults,H),Me(Oe.defaults),Oe},Oe.getDefaults=ve,Oe.defaults=He,Oe.use=function(H){var ne=qe({},H);if(H.renderer&&function(){var q=Oe.defaults.renderer||new Le,J=function(pe){var Be=q[pe];q[pe]=function(){for(var Ne=arguments.length,Ve=new Array(Ne),Xe=0;Xe<Ne;Xe++)Ve[Xe]=arguments[Xe];var Ze=H.renderer[pe].apply(q,Ve);return Ze===!1&&(Ze=Be.apply(q,Ve)),Ze}};for(var oe in H.renderer)J(oe);ne.renderer=q}(),H.tokenizer&&function(){var q=Oe.defaults.tokenizer||new x,J=function(pe){var Be=q[pe];q[pe]=function(){for(var Ne=arguments.length,Ve=new Array(Ne),Xe=0;Xe<Ne;Xe++)Ve[Xe]=arguments[Xe];var Ze=H.tokenizer[pe].apply(q,Ve);return Ze===!1&&(Ze=Be.apply(q,Ve)),Ze}};for(var oe in H.tokenizer)J(oe);ne.tokenizer=q}(),H.walkTokens){var he=Oe.defaults.walkTokens;ne.walkTokens=function(q){H.walkTokens(q),he&&he(q)}}Oe.setOptions(ne)},Oe.walkTokens=function(H,ne){for(var he=A(H),q;!(q=he()).done;){var J=q.value;switch(ne(J),J.type){case"table":{for(var oe=A(J.tokens.header),fe;!(fe=oe()).done;){var pe=fe.value;Oe.walkTokens(pe,ne)}for(var Be=A(J.tokens.cells),Ne;!(Ne=Be()).done;)for(var Ve=Ne.value,Xe=A(Ve),Ze;!(Ze=Xe()).done;){var ct=Ze.value;Oe.walkTokens(ct,ne)}break}case"list":{Oe.walkTokens(J.items,ne);break}default:J.tokens&&Oe.walkTokens(J.tokens,ne)}}},Oe.parseInline=function(H,ne){if(typeof H=="undefined"||H===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");ne=qe({},Oe.defaults,ne||{}),V(ne);try{var he=te.lexInline(H,ne);return ne.walkTokens&&Oe.walkTokens(he,ne.walkTokens),_e.parseInline(he,ne)}catch(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+X(q.message+"",!0)+"</pre>";throw q}},Oe.Parser=_e,Oe.parser=_e.parse,Oe.Renderer=Le,Oe.TextRenderer=ge,Oe.Lexer=te,Oe.lexer=te.lex,Oe.Tokenizer=x,Oe.Slugger=Ce,Oe.parse=Oe;var et=Oe;return et}),define(be[78],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function w(S,I,y){return Math.min(Math.max(S,I),y)}e.clamp=w;function k(S,I){return(I+S%I)%I}e.rot=k;class A{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=A;class T{constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T});"use strict";(function(){function ie(A){const T=[];typeof A=="number"&&T.push("code/timeOrigin",A);function S(y){T.push(y,Date.now())}function I(){const y=[];for(let n=0;n<T.length;n+=2)y.push({name:T[n],startTime:T[n+1]});return y}return{mark:S,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const S of performance.getEntriesByType("mark"))T.push({name:S.name,startTime:Math.round(A+S.startTime)});return T}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function w(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=w(k))})(),define(be[21],we([0,1]),function(ie,e){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const k="en";let A=!1,T=!1,S=!1,I=!1,y=!1,n=!1,R=!1,C,b=k,f,i;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let s;typeof e.globals.vscode!="undefined"?s=e.globals.vscode.process:typeof process!="undefined"&&(s=process);const v=typeof((w=s==null?void 0:s.versions)===null||w===void 0?void 0:w.electron)=="string"&&s.type==="renderer";if(e.isElectronSandboxed=v&&(s==null?void 0:s.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const l=s==null?void 0:s.env.VSCODE_BROWSER_CODE_LOADING;if(typeof l=="string")return l==="none"||l==="code"||l==="bypassHeatCheck"||l==="bypassHeatCheckAndEagerCompile"?l:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!v)i=navigator.userAgent,A=i.indexOf("Windows")>=0,T=i.indexOf("Macintosh")>=0,R=(i.indexOf("Macintosh")>=0||i.indexOf("iPad")>=0||i.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=i.indexOf("Linux")>=0,n=!0,C=navigator.language,b=C;else if(typeof s=="object"){A=s.platform==="win32",T=s.platform==="darwin",S=s.platform==="linux",I=S&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,C=k,b=k;const l=s.env.VSCODE_NLS_CONFIG;if(l)try{const u=JSON.parse(l),m=u.availableLanguages["*"];C=u.locale,b=m||k,f=u._translationsConfigFile}catch(u){}y=!0}else console.error("Unable to resolve platform.");var h;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function E(l){switch(l){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let g=0;T?g=1:A?g=3:S&&(g=2),e.isWindows=A,e.isMacintosh=T,e.isLinux=S,e.isLinuxSnap=I,e.isNative=y,e.isWeb=n,e.isIOS=R,e.platform=g,e.userAgent=i,e.language=b;var a;(function(l){function u(){return e.language}l.value=u;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}l.isDefaultVariant=m;function _(){return e.language==="en"}l.isDefault=_})(a=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let m=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeSetImmediateId)for(let c=0,p=m.length;c<p;c++){const P=m[c];if(P.id===D.data.vscodeSetImmediateId){m.splice(c,1),P.callback();return}}});let _=0;return D=>{const c=++_;m.push({id:c,callback:D}),e.globals.postMessage({vscodeSetImmediateId:c},"*")}}if(typeof(s==null?void 0:s.nextTick)=="function")return s.nextTick.bind(s);const u=Promise.resolve();return m=>u.then(m)}();var o;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||R?2:A?1:3;let t=!0,r=!1;function d(){if(!r){r=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,t=new Uint16Array(l.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=d}),define(be[32],we([0,1,21]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let k;if(typeof w.globals.vscode!="undefined"){const A=w.globals.vscode.process;k={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(T){return(0,w.setImmediate)(T)}}}else typeof process!="undefined"?k={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:k={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},nextTick(A){return(0,w.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.nextTick=k.nextTick}),define(be[11],we([0,1,32]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,A=97,T=90,S=122,I=46,y=47,n=92,R=58,C=63;class b extends Error{constructor(a,o,t){let r;typeof o=="string"&&o.indexOf("not ")===0?(r="must not be",o=o.replace(/^not /,"")):r="must be";const d=a.indexOf(".")!==-1?"property":"argument";let l=`The "${a}" ${d} ${r} of type ${o}`;l+=`. Received type ${typeof t}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function f(g,a){if(typeof g!="string")throw new b(a,"string",g)}function i(g){return g===y||g===n}function s(g){return g===y}function v(g){return g>=k&&g<=T||g>=A&&g<=S}function h(g,a,o,t){let r="",d=0,l=-1,u=0,m=0;for(let _=0;_<=g.length;++_){if(_<g.length)m=g.charCodeAt(_);else{if(t(m))break;m=y}if(t(m)){if(!(l===_-1||u===1))if(u===2){if(r.length<2||d!==2||r.charCodeAt(r.length-1)!==I||r.charCodeAt(r.length-2)!==I){if(r.length>2){const D=r.lastIndexOf(o);D===-1?(r="",d=0):(r=r.slice(0,D),d=r.length-1-r.lastIndexOf(o)),l=_,u=0;continue}else if(r.length!==0){r="",d=0,l=_,u=0;continue}}a&&(r+=r.length>0?`${o}..`:"..",d=2)}else r.length>0?r+=`${o}${g.slice(l+1,_)}`:r=g.slice(l+1,_),d=_-l-1;l=_,u=0}else m===I&&u!==-1?++u:u=-1}return r}function E(g,a){if(a===null||typeof a!="object")throw new b("pathObject","Object",a);const o=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return o?o===a.root?`${o}${t}`:`${o}${g}${t}`:t}e.win32={resolve(...g){let a="",o="",t=!1;for(let r=g.length-1;r>=-1;r--){let d;if(r>=0){if(d=g[r],f(d,"path"),d.length===0)continue}else a.length===0?d=w.cwd():(d=w.env[`=${a}`]||w.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==a.toLowerCase()&&d.charCodeAt(2)===n)&&(d=`${a}\\`));const l=d.length;let u=0,m="",_=!1;const D=d.charCodeAt(0);if(l===1)i(D)&&(u=1,_=!0);else if(i(D))if(_=!0,i(d.charCodeAt(1))){let c=2,p=c;for(;c<l&&!i(d.charCodeAt(c));)c++;if(c<l&&c!==p){const P=d.slice(p,c);for(p=c;c<l&&i(d.charCodeAt(c));)c++;if(c<l&&c!==p){for(p=c;c<l&&!i(d.charCodeAt(c));)c++;(c===l||c!==p)&&(m=`\\\\${P}\\${d.slice(p,c)}`,u=c)}}}else u=1;else v(D)&&d.charCodeAt(1)===R&&(m=d.slice(0,2),u=2,l>2&&i(d.charCodeAt(2))&&(_=!0,u=3));if(m.length>0)if(a.length>0){if(m.toLowerCase()!==a.toLowerCase())continue}else a=m;if(t){if(a.length>0)break}else if(o=`${d.slice(u)}\\${o}`,t=_,_&&a.length>0)break}return o=h(o,!t,"\\",i),t?`${a}\\${o}`:`${a}${o}`||"."},normalize(g){f(g,"path");const a=g.length;if(a===0)return".";let o=0,t,r=!1;const d=g.charCodeAt(0);if(a===1)return s(d)?"\\":g;if(i(d))if(r=!0,i(g.charCodeAt(1))){let u=2,m=u;for(;u<a&&!i(g.charCodeAt(u));)u++;if(u<a&&u!==m){const _=g.slice(m,u);for(m=u;u<a&&i(g.charCodeAt(u));)u++;if(u<a&&u!==m){for(m=u;u<a&&!i(g.charCodeAt(u));)u++;if(u===a)return`\\\\${_}\\${g.slice(m)}\\`;u!==m&&(t=`\\\\${_}\\${g.slice(m,u)}`,o=u)}}}else o=1;else v(d)&&g.charCodeAt(1)===R&&(t=g.slice(0,2),o=2,a>2&&i(g.charCodeAt(2))&&(r=!0,o=3));let l=o<a?h(g.slice(o),!r,"\\",i):"";return l.length===0&&!r&&(l="."),l.length>0&&i(g.charCodeAt(a-1))&&(l+="\\"),t===void 0?r?`\\${l}`:l:r?`${t}\\${l}`:`${t}${l}`},isAbsolute(g){f(g,"path");const a=g.length;if(a===0)return!1;const o=g.charCodeAt(0);return i(o)||a>2&&v(o)&&g.charCodeAt(1)===R&&i(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let a,o;for(let d=0;d<g.length;++d){const l=g[d];f(l,"path"),l.length>0&&(a===void 0?a=o=l:a+=`\\${l}`)}if(a===void 0)return".";let t=!0,r=0;if(typeof o=="string"&&i(o.charCodeAt(0))){++r;const d=o.length;d>1&&i(o.charCodeAt(1))&&(++r,d>2&&(i(o.charCodeAt(2))?++r:t=!1))}if(t){for(;r<a.length&&i(a.charCodeAt(r));)r++;r>=2&&(a=`\\${a.slice(r)}`)}return e.win32.normalize(a)},relative(g,a){if(f(g,"from"),f(a,"to"),g===a)return"";const o=e.win32.resolve(g),t=e.win32.resolve(a);if(o===t||(g=o.toLowerCase(),a=t.toLowerCase(),g===a))return"";let r=0;for(;r<g.length&&g.charCodeAt(r)===n;)r++;let d=g.length;for(;d-1>r&&g.charCodeAt(d-1)===n;)d--;const l=d-r;let u=0;for(;u<a.length&&a.charCodeAt(u)===n;)u++;let m=a.length;for(;m-1>u&&a.charCodeAt(m-1)===n;)m--;const _=m-u,D=l<_?l:_;let c=-1,p=0;for(;p<D;p++){const F=g.charCodeAt(r+p);if(F!==a.charCodeAt(u+p))break;F===n&&(c=p)}if(p!==D){if(c===-1)return t}else{if(_>D){if(a.charCodeAt(u+p)===n)return t.slice(u+p+1);if(p===2)return t.slice(u+p)}l>D&&(g.charCodeAt(r+p)===n?c=p:p===2&&(c=3)),c===-1&&(c=0)}let P="";for(p=r+c+1;p<=d;++p)(p===d||g.charCodeAt(p)===n)&&(P+=P.length===0?"..":"\\..");return u+=c,P.length>0?`${P}${t.slice(u,m)}`:(t.charCodeAt(u)===n&&++u,t.slice(u,m))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const a=e.win32.resolve(g);if(a.length<=2)return g;if(a.charCodeAt(0)===n){if(a.charCodeAt(1)===n){const o=a.charCodeAt(2);if(o!==C&&o!==I)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(v(a.charCodeAt(0))&&a.charCodeAt(1)===R&&a.charCodeAt(2)===n)return`\\\\?\\${a}`;return g},dirname(g){f(g,"path");const a=g.length;if(a===0)return".";let o=-1,t=0;const r=g.charCodeAt(0);if(a===1)return i(r)?g:".";if(i(r)){if(o=t=1,i(g.charCodeAt(1))){let u=2,m=u;for(;u<a&&!i(g.charCodeAt(u));)u++;if(u<a&&u!==m){for(m=u;u<a&&i(g.charCodeAt(u));)u++;if(u<a&&u!==m){for(m=u;u<a&&!i(g.charCodeAt(u));)u++;if(u===a)return g;u!==m&&(o=t=u+1)}}}}else v(r)&&g.charCodeAt(1)===R&&(o=a>2&&i(g.charCodeAt(2))?3:2,t=o);let d=-1,l=!0;for(let u=a-1;u>=t;--u)if(i(g.charCodeAt(u))){if(!l){d=u;break}}else l=!1;if(d===-1){if(o===-1)return".";d=o}return g.slice(0,d)},basename(g,a){a!==void 0&&f(a,"ext"),f(g,"path");let o=0,t=-1,r=!0,d;if(g.length>=2&&v(g.charCodeAt(0))&&g.charCodeAt(1)===R&&(o=2),a!==void 0&&a.length>0&&a.length<=g.length){if(a===g)return"";let l=a.length-1,u=-1;for(d=g.length-1;d>=o;--d){const m=g.charCodeAt(d);if(i(m)){if(!r){o=d+1;break}}else u===-1&&(r=!1,u=d+1),l>=0&&(m===a.charCodeAt(l)?--l==-1&&(t=d):(l=-1,t=u))}return o===t?t=u:t===-1&&(t=g.length),g.slice(o,t)}for(d=g.length-1;d>=o;--d)if(i(g.charCodeAt(d))){if(!r){o=d+1;break}}else t===-1&&(r=!1,t=d+1);return t===-1?"":g.slice(o,t)},extname(g){f(g,"path");let a=0,o=-1,t=0,r=-1,d=!0,l=0;g.length>=2&&g.charCodeAt(1)===R&&v(g.charCodeAt(0))&&(a=t=2);for(let u=g.length-1;u>=a;--u){const m=g.charCodeAt(u);if(i(m)){if(!d){t=u+1;break}continue}r===-1&&(d=!1,r=u+1),m===I?o===-1?o=u:l!==1&&(l=1):o!==-1&&(l=-1)}return o===-1||r===-1||l===0||l===1&&o===r-1&&o===t+1?"":g.slice(o,r)},format:E.bind(null,"\\"),parse(g){f(g,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return a;const o=g.length;let t=0,r=g.charCodeAt(0);if(o===1)return i(r)?(a.root=a.dir=g,a):(a.base=a.name=g,a);if(i(r)){if(t=1,i(g.charCodeAt(1))){let c=2,p=c;for(;c<o&&!i(g.charCodeAt(c));)c++;if(c<o&&c!==p){for(p=c;c<o&&i(g.charCodeAt(c));)c++;if(c<o&&c!==p){for(p=c;c<o&&!i(g.charCodeAt(c));)c++;c===o?t=c:c!==p&&(t=c+1)}}}}else if(v(r)&&g.charCodeAt(1)===R){if(o<=2)return a.root=a.dir=g,a;if(t=2,i(g.charCodeAt(2))){if(o===3)return a.root=a.dir=g,a;t=3}}t>0&&(a.root=g.slice(0,t));let d=-1,l=t,u=-1,m=!0,_=g.length-1,D=0;for(;_>=t;--_){if(r=g.charCodeAt(_),i(r)){if(!m){l=_+1;break}continue}u===-1&&(m=!1,u=_+1),r===I?d===-1?d=_:D!==1&&(D=1):d!==-1&&(D=-1)}return u!==-1&&(d===-1||D===0||D===1&&d===u-1&&d===l+1?a.base=a.name=g.slice(l,u):(a.name=g.slice(l,d),a.base=g.slice(l,u),a.ext=g.slice(d,u))),l>0&&l!==t?a.dir=g.slice(0,l-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let a="",o=!1;for(let t=g.length-1;t>=-1&&!o;t--){const r=t>=0?g[t]:w.cwd();f(r,"path"),r.length!==0&&(a=`${r}/${a}`,o=r.charCodeAt(0)===y)}return a=h(a,!o,"/",s),o?`/${a}`:a.length>0?a:"."},normalize(g){if(f(g,"path"),g.length===0)return".";const a=g.charCodeAt(0)===y,o=g.charCodeAt(g.length-1)===y;return g=h(g,!a,"/",s),g.length===0?a?"/":o?"./":".":(o&&(g+="/"),a?`/${g}`:g)},isAbsolute(g){return f(g,"path"),g.length>0&&g.charCodeAt(0)===y},join(...g){if(g.length===0)return".";let a;for(let o=0;o<g.length;++o){const t=g[o];f(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(g,a){if(f(g,"from"),f(a,"to"),g===a||(g=e.posix.resolve(g),a=e.posix.resolve(a),g===a))return"";const o=1,t=g.length,r=t-o,d=1,l=a.length-d,u=r<l?r:l;let m=-1,_=0;for(;_<u;_++){const c=g.charCodeAt(o+_);if(c!==a.charCodeAt(d+_))break;c===y&&(m=_)}if(_===u)if(l>u){if(a.charCodeAt(d+_)===y)return a.slice(d+_+1);if(_===0)return a.slice(d+_)}else r>u&&(g.charCodeAt(o+_)===y?m=_:_===0&&(m=0));let D="";for(_=o+m+1;_<=t;++_)(_===t||g.charCodeAt(_)===y)&&(D+=D.length===0?"..":"/..");return`${D}${a.slice(d+m)}`},toNamespacedPath(g){return g},dirname(g){if(f(g,"path"),g.length===0)return".";const a=g.charCodeAt(0)===y;let o=-1,t=!0;for(let r=g.length-1;r>=1;--r)if(g.charCodeAt(r)===y){if(!t){o=r;break}}else t=!1;return o===-1?a?"/":".":a&&o===1?"//":g.slice(0,o)},basename(g,a){a!==void 0&&f(a,"ext"),f(g,"path");let o=0,t=-1,r=!0,d;if(a!==void 0&&a.length>0&&a.length<=g.length){if(a===g)return"";let l=a.length-1,u=-1;for(d=g.length-1;d>=0;--d){const m=g.charCodeAt(d);if(m===y){if(!r){o=d+1;break}}else u===-1&&(r=!1,u=d+1),l>=0&&(m===a.charCodeAt(l)?--l==-1&&(t=d):(l=-1,t=u))}return o===t?t=u:t===-1&&(t=g.length),g.slice(o,t)}for(d=g.length-1;d>=0;--d)if(g.charCodeAt(d)===y){if(!r){o=d+1;break}}else t===-1&&(r=!1,t=d+1);return t===-1?"":g.slice(o,t)},extname(g){f(g,"path");let a=-1,o=0,t=-1,r=!0,d=0;for(let l=g.length-1;l>=0;--l){const u=g.charCodeAt(l);if(u===y){if(!r){o=l+1;break}continue}t===-1&&(r=!1,t=l+1),u===I?a===-1?a=l:d!==1&&(d=1):a!==-1&&(d=-1)}return a===-1||t===-1||d===0||d===1&&a===t-1&&a===o+1?"":g.slice(a,t)},format:E.bind(null,"/"),parse(g){f(g,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return a;const o=g.charCodeAt(0)===y;let t;o?(a.root="/",t=1):t=0;let r=-1,d=0,l=-1,u=!0,m=g.length-1,_=0;for(;m>=t;--m){const D=g.charCodeAt(m);if(D===y){if(!u){d=m+1;break}continue}l===-1&&(u=!1,l=m+1),D===I?r===-1?r=m:_!==1&&(_=1):r!==-1&&(_=-1)}if(l!==-1){const D=d===0&&o?1:d;r===-1||_===0||_===1&&r===l-1&&r===d+1?a.base=a.name=g.slice(D,l):(a.name=g.slice(D,r),a.base=g.slice(D,l),a.ext=g.slice(r,l))}return d>0?a.dir=g.slice(0,d-1):o&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(be[55],we([0,1,21]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=w.globals.performance&&typeof w.globals.performance.now=="function";class A{constructor(S){this._highResolution=k&&S,this._startTime=this._now(),this._stopTime=-1}static create(S=!0){return new A(S)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=A}),define(be[3],we([0,1,10,52,6,45,55]),function(ie,e,w,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(h){h.None=()=>A.Disposable.None;function E(B){return(W,K=null,M)=>{let U=!1,x;return x=B(Q=>{if(!U)return x?x.dispose():U=!0,W.call(K,Q)},null,M),U&&x.dispose(),x}}h.once=E;function g(B,W){return l((K,M=null,U)=>B(x=>K.call(M,W(x)),null,U))}h.map=g;function a(B,W){return l((K,M=null,U)=>B(x=>{W(x),K.call(M,x)},null,U))}h.forEach=a;function o(B,W){return l((K,M=null,U)=>B(x=>W(x)&&K.call(M,x),null,U))}h.filter=o;function t(B){return B}h.signal=t;function r(...B){return(W,K=null,M)=>(0,A.combinedDisposable)(...B.map(U=>U(x=>W.call(K,x),null,M)))}h.any=r;function d(B,W,K){let M=K;return g(B,U=>(M=W(M,U),M))}h.reduce=d;function l(B){let W;const K=new b({onFirstListenerAdd(){W=B(K.fire,K)},onLastListenerRemove(){W.dispose()}});return K.event}h.snapshot=l;function u(B,W,K=100,M=!1,U){let x,Q,$,ee=0;const re=new b({leakWarningThreshold:U,onFirstListenerAdd(){x=B(se=>{ee++,Q=W(Q,se),M&&!$&&(re.fire(Q),Q=void 0),clearTimeout($),$=setTimeout(()=>{const ye=Q;Q=void 0,$=void 0,(!M||ee>1)&&re.fire(ye),ee=0},K)})},onLastListenerRemove(){x.dispose()}});return re.event}h.debounce=u;function m(B){const W=new Date().getTime();return g(E(B),K=>new Date().getTime()-W)}h.stopwatch=m;function _(B){let W=!0,K;return o(B,M=>{const U=W||M!==K;return W=!1,K=M,U})}h.latch=_;function D(B,W=!1,K=[]){let M=K.slice(),U=B($=>{M?M.push($):Q.fire($)});const x=()=>{M&&M.forEach($=>Q.fire($)),M=null},Q=new b({onFirstListenerAdd(){U||(U=B($=>Q.fire($)))},onFirstListenerDidAdd(){M&&(W?setTimeout(x):x())},onLastListenerRemove(){U&&U.dispose(),U=null}});return Q.event}h.buffer=D;class c{constructor(W){this.event=W}map(W){return new c(g(this.event,W))}forEach(W){return new c(a(this.event,W))}filter(W){return new c(o(this.event,W))}reduce(W,K){return new c(d(this.event,W,K))}latch(){return new c(_(this.event))}debounce(W,K=100,M=!1,U){return new c(u(this.event,W,K,M,U))}on(W,K,M){return this.event(W,K,M)}once(W,K,M){return E(this.event)(W,K,M)}}function p(B){return new c(B)}h.chain=p;function P(B,W,K=M=>M){const M=(...$)=>Q.fire(K(...$)),U=()=>B.on(W,M),x=()=>B.removeListener(W,M),Q=new b({onFirstListenerAdd:U,onLastListenerRemove:x});return Q.event}h.fromNodeEventEmitter=P;function F(B,W,K=M=>M){const M=(...$)=>Q.fire(K(...$)),U=()=>B.addEventListener(W,M),x=()=>B.removeEventListener(W,M),Q=new b({onFirstListenerAdd:U,onLastListenerRemove:x});return Q.event}h.fromDOMEventEmitter=F;function z(B){const W=new b;let K=!1;return B.then(void 0,()=>null).then(()=>{K?W.fire(void 0):setTimeout(()=>W.fire(void 0),0)}),K=!0,W.event}h.fromPromise=z;function de(B){return new Promise(W=>E(B)(W))}h.toPromise=de})(I=e.Event||(e.Event={}));class y{constructor(E){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${E}_${y._idPool++}`}start(E){this._stopWatch=new S.StopWatch(!0),this._listenerCount=E}stop(){if(this._stopWatch){const E=this._stopWatch.elapsed();this._elapsedOverall+=E,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${E.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let n=-1;function R(h){const E=n;return n=h,{dispose(){n=E}}}e.setGlobalLeakWarningThreshold=R;class C{constructor(E,g=Math.random().toString(18).slice(2,5)){this.customThreshold=E,this.name=g,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(E){let g=n;if(typeof this.customThreshold=="number"&&(g=this.customThreshold),!(g<=0||E<g)){this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),o=this._stacks.get(a)||0;if(this._stacks.set(a,o+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=g*.5;let t,r=0;for(const[d,l]of this._stacks)(!t||r<l)&&(t=d,r=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}}class b{constructor(E){var g;this._disposed=!1,this._options=E,this._leakageMon=n>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((g=this._options)===null||g===void 0?void 0:g._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(E,g,a)=>{var o;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(g?[E,g]:E);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,E,g);const d=(o=this._leakageMon)===null||o===void 0?void 0:o.check(this._listeners.size);let l;return l={dispose:()=>{d&&d(),l.dispose=b._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},a instanceof A.DisposableStore?a.add(l):Array.isArray(a)&&a.push(l),l}),this._event}fire(E){var g,a;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,E]);for((g=this._perfMon)===null||g===void 0||g.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,t]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,t):o[0].call(o[1],t)}catch(r){(0,w.onUnexpectedError)(r)}}(a=this._perfMon)===null||a===void 0||a.stop()}}dispose(){var E,g,a;(E=this._listeners)===null||E===void 0||E.clear(),(g=this._deliveryQueue)===null||g===void 0||g.clear(),(a=this._leakageMon)===null||a===void 0||a.dispose(),this._disposed=!0}}e.Emitter=b,b._noop=function(){};class f extends b{constructor(E){super(E);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=E==null?void 0:E.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const E=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(E))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(E){this._listeners&&(this._isPaused!==0?this._eventQueue.push(E):super.fire(E))}}e.PauseableEmitter=f;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(E){const g={event:E,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const a=()=>{this.hasListeners&&this.unhook(g);const o=this.events.indexOf(g);this.events.splice(o,1)};return(0,A.toDisposable)((0,k.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(E=>this.hook(E))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(E=>this.unhook(E))}hook(E){E.listener=E.event(g=>this.emitter.fire(g))}unhook(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class s{constructor(){this.buffers=[]}wrapEvent(E){return(g,a,o)=>E(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>g.call(a,t)):g.call(a,t)},void 0,o)}bufferEvents(E){const g=[];this.buffers.push(g);const a=E();return this.buffers.pop(),g.forEach(o=>o()),a}}e.EventBufferer=s;class v{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=A.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(E){this.inputEvent=E,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=E(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=v}),define(be[20],we([0,1,3]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(I,y){const n=setTimeout(I.bind(y),0);return{dispose(){clearTimeout(n)}}});var A;(function(I){function y(n){return n===I.None||n===I.Cancelled||n instanceof T?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}I.isCancellationToken=y,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(A=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class S{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=A.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=S}),define(be[37],we([0,1,3]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class k{constructor(){this._icons=new Map,this._onDidRegister=new w.Emitter}add(R){const C=this._icons.get(R.id);C?R.description?C.description=R.description:console.error(`Duplicate registration of codicon ${R.id}`):(this._icons.set(R.id,R),this._onDidRegister.fire(R))}get(R){return this._icons.get(R)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const A=new k;e.iconRegistry=A;function T(n,R){return new S(n,R)}e.registerCodicon=T;class S{constructor(R,C,b){this.id=R,this.definition=C,this.description=b,A.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=S;function I(n,R){const C=["codicon","codicon-"+n];return R&&C.push("codicon-modifier-"+R),C}e.getClassNamesArray=I;var y;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const R=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function C(i){if(i instanceof S)return["codicon","codicon-"+i.id];const s=R.exec(i.id);if(!s)return C(S.error);let[,v,h]=s;const E=["codicon","codicon-"+v];return h&&E.push("codicon-modifier-"+h.substr(1)),E}n.asClassNameArray=C;function b(i){return C(i).join(" ")}n.asClassName=b;function f(i){return"."+C(i).join(".")}n.asCSSSelector=f})(y=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personAdd=new n("person-add",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(S=e.Codicon||(e.Codicon={}))}),define(be[107],we([0,1,10,6]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(v){const h=v;return h&&[h.on,h.pause,h.resume,h.destroy].every(E=>typeof E=="function")}e.isReadableStream=A;function T(v){const h=v;return h&&A(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean"}e.isReadableBufferedStream=T;function S(v,h){return new I(v,h)}e.newWriteableStream=S;class I{constructor(h,E){this.reducer=h,this.options=E,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){var E;if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof((E=this.options)===null||E===void 0?void 0:E.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(g=>this.pendingWritePromises.push(g))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(E=>E(h))}emitError(h){this.listeners.error.length===0?(0,w.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(E=>E(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,E){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(E),this.resume();break;case"end":this.listeners.end.push(E),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(E),this.state.flowing&&this.flowErrors();break}}removeListener(h,E){if(!this.state.destroyed){let g;switch(h){case"data":g=this.listeners.data;break;case"end":g=this.listeners.end;break;case"error":g=this.listeners.error;break}if(g){const a=g.indexOf(E);a>=0&&g.splice(a,1)}}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const E=[...this.pendingWritePromises];this.pendingWritePromises.length=0,E.forEach(g=>g())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(v,h){const E=[];let g;for(;(g=v.read())!==null;)E.push(g);return h(E)}e.consumeReadable=y;function n(v,h,E){const g=[];let a;for(;(a=v.read())!==null&&g.length<E;)g.push(a);return a===null&&g.length>0?h(g):{read:()=>{if(g.length>0)return g.shift();if(typeof a!="undefined"){const o=a;return a=void 0,o}return v.read()}}}e.peekReadable=n;function R(v,h){return new Promise((E,g)=>{const a=[];C(v,{onData:o=>{h&&a.push(o)},onError:o=>{h?g(o):E(void 0)},onEnd:()=>{E(h?h(a):void 0)}})})}e.consumeStream=R;function C(v,h){v.on("error",E=>h.onError(E)),v.on("end",()=>h.onEnd()),v.on("data",E=>h.onData(E))}e.listenStream=C;function b(v,h){return new Promise((E,g)=>{const a=new k.DisposableStore,o=[],t=l=>{if(o.push(l),o.length>h)return a.dispose(),v.pause(),E({stream:v,buffer:o,ended:!1})},r=l=>g(l),d=()=>E({stream:v,buffer:o,ended:!0});a.add((0,k.toDisposable)(()=>v.removeListener("error",r))),v.on("error",r),a.add((0,k.toDisposable)(()=>v.removeListener("end",d))),v.on("end",d),a.add((0,k.toDisposable)(()=>v.removeListener("data",t))),v.on("data",t)})}e.peekStream=b;function f(v,h){const E=S(h);return E.end(v),E}e.toStream=f;function i(v){let h=!1;return{read:()=>h?null:(h=!0,v)}}e.toReadable=i;function s(v,h,E){const g=S(E);return C(v,{onData:a=>g.write(h.data(a)),onError:a=>g.error(h.error?h.error(a):a),onEnd:()=>g.end()}),g}e.transform=s}),define(be[8],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function w(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=w;const k=/{(\d+)}/g;function A(H,...ne){return ne.length===0?H:H.replace(k,function(he,q){const J=parseInt(q,10);return isNaN(J)||J<0||J>=ne.length?he:ne[J]})}e.format=A;function T(H){return H.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}e.escape=T;function S(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function I(H,ne){let he=0;const q=ne.charCodeAt(0);for(let J=H.length-1;J>=0;J--)H.charCodeAt(J)===q&&he++;return he}e.count=I;function y(H,ne,he="\u2026"){return H.length<=ne?H:`${H.substr(0,ne)}${he}`}e.truncate=y;function n(H,ne=" "){const he=R(H,ne);return C(he,ne)}e.trim=n;function R(H,ne){if(!H||!ne)return H;const he=ne.length;if(he===0||H.length===0)return H;let q=0;for(;H.indexOf(ne,q)===q;)q=q+he;return H.substring(q)}e.ltrim=R;function C(H,ne){if(!H||!ne)return H;const he=ne.length,q=H.length;if(he===0||q===0)return H;let J=q,oe=-1;for(;oe=H.lastIndexOf(ne,J-1),!(oe===-1||oe+he!==J);){if(oe===0)return"";J=oe}return H.substring(0,J)}e.rtrim=C;function b(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=b;function f(H){return H.replace(/\*/g,"")}e.stripWildcards=f;function i(H,ne,he={}){if(!H)throw new Error("Cannot create regex from empty string");ne||(H=S(H)),he.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let q="";return he.global&&(q+="g"),he.matchCase||(q+="i"),he.multiline&&(q+="m"),he.unicode&&(q+="u"),new RegExp(H,q)}e.createRegExp=i;function s(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=s;function v(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=v;function h(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=h;function E(H){return H.split(/\r\n|\r|\n/)}e.splitLines=E;function g(H){for(let ne=0,he=H.length;ne<he;ne++){const q=H.charCodeAt(ne);if(q!==32&&q!==9)return ne}return-1}e.firstNonWhitespaceIndex=g;function a(H,ne=0,he=H.length){for(let q=ne;q<he;q++){const J=H.charCodeAt(q);if(J!==32&&J!==9)return H.substring(ne,q)}return H.substring(ne,he)}e.getLeadingWhitespace=a;function o(H,ne=H.length-1){for(let he=ne;he>=0;he--){const q=H.charCodeAt(he);if(q!==32&&q!==9)return he}return-1}e.lastNonWhitespaceIndex=o;function t(H,ne){return H<ne?-1:H>ne?1:0}e.compare=t;function r(H,ne,he=0,q=H.length,J=0,oe=ne.length){for(;he<q&&J<oe;he++,J++){let Be=H.charCodeAt(he),Ne=ne.charCodeAt(J);if(Be<Ne)return-1;if(Be>Ne)return 1}const fe=q-he,pe=oe-J;return fe<pe?-1:fe>pe?1:0}e.compareSubstring=r;function d(H,ne){return l(H,ne,0,H.length,0,ne.length)}e.compareIgnoreCase=d;function l(H,ne,he=0,q=H.length,J=0,oe=ne.length){for(;he<q&&J<oe;he++,J++){let Be=H.charCodeAt(he),Ne=ne.charCodeAt(J);if(Be!==Ne){const Ve=Be-Ne;if(!(Ve===32&&m(Ne))&&!(Ve===-32&&m(Be)))return u(Be)&&u(Ne)?Ve:r(H.toLowerCase(),ne.toLowerCase(),he,q,J,oe)}}const fe=q-he,pe=oe-J;return fe<pe?-1:fe>pe?1:0}e.compareSubstringIgnoreCase=l;function u(H){return H>=97&&H<=122}e.isLowerAsciiLetter=u;function m(H){return H>=65&&H<=90}e.isUpperAsciiLetter=m;function _(H){return u(H)||m(H)}function D(H,ne){return H.length===ne.length&&c(H,ne)}e.equalsIgnoreCase=D;function c(H,ne,he=H.length){for(let q=0;q<he;q++){const J=H.charCodeAt(q),oe=ne.charCodeAt(q);if(J!==oe){if(_(J)&&_(oe)){const fe=Math.abs(J-oe);if(fe!==0&&fe!==32)return!1}else if(String.fromCharCode(J).toLowerCase()!==String.fromCharCode(oe).toLowerCase())return!1}}return!0}function p(H,ne){const he=ne.length;return ne.length>H.length?!1:c(H,ne,he)}e.startsWithIgnoreCase=p;function P(H,ne){let he,q=Math.min(H.length,ne.length);for(he=0;he<q;he++)if(H.charCodeAt(he)!==ne.charCodeAt(he))return he;return q}e.commonPrefixLength=P;function F(H,ne){let he,q=Math.min(H.length,ne.length);const J=H.length-1,oe=ne.length-1;for(he=0;he<q;he++)if(H.charCodeAt(J-he)!==ne.charCodeAt(oe-he))return he;return q}e.commonSuffixLength=F;function z(H){return 55296<=H&&H<=56319}e.isHighSurrogate=z;function de(H){return 56320<=H&&H<=57343}e.isLowSurrogate=de;function B(H,ne){return(H-55296<<10)+(ne-56320)+65536}e.computeCodePoint=B;function W(H,ne,he){const q=H.charCodeAt(he);if(z(q)&&he+1<ne){const J=H.charCodeAt(he+1);if(de(J))return B(q,J)}return q}e.getNextCodePoint=W;function K(H,ne){const he=H.charCodeAt(ne-1);if(de(he)&&ne>1){const q=H.charCodeAt(ne-2);if(z(q))return B(q,he)}return he}function M(H,ne){const he=Oe.getInstance(),q=ne,J=H.length,oe=W(H,J,ne);ne+=oe>=65536?2:1;let fe=he.getGraphemeBreakType(oe);for(;ne<J;){const pe=W(H,J,ne),Be=he.getGraphemeBreakType(pe);if(Me(fe,Be))break;ne+=pe>=65536?2:1,fe=Be}return ne-q}e.nextCharLength=M;function U(H,ne){const he=Oe.getInstance(),q=ne,J=K(H,ne);ne-=J>=65536?2:1;let oe=he.getGraphemeBreakType(J);for(;ne>0;){const fe=K(H,ne),pe=he.getGraphemeBreakType(fe);if(Me(pe,oe))break;ne-=fe>=65536?2:1,oe=pe}return q-ne}e.prevCharLength=U;function x(H,ne){const he=Oe.getInstance(),q=H.length,J=ne,oe=W(H,q,ne),fe=he.getGraphemeBreakType(oe);ne+=oe>=65536?2:1;let pe=fe;for(;ne<q;){const Ne=W(H,q,ne),Ve=he.getGraphemeBreakType(Ne);if(Me(pe,Ve))break;ne+=Ne>=65536?2:1,pe=Ve}const Be=ne;for(ne=J,pe=fe;ne>0;){const Ne=K(H,ne),Ve=he.getGraphemeBreakType(Ne);if(Me(Ve,pe))break;ne-=Ne>=65536?2:1,pe=Ve}return[ne,Be]}function Q(H,ne){return ne>0&&de(H.charCodeAt(ne))?x(H,ne-1):x(H,ne)}e.getCharContainingOffset=Q;function $(H){const ne=H.length;let he=0,q=0;for(;q<ne;){const fe=W(H,ne,q);q+=fe>=65536?2:1,fe<128?he+=1:fe<2048?he+=2:fe<65536?he+=3:he+=4}const J=new Uint8Array(he);q=0;let oe=0;for(;q<ne;){const fe=W(H,ne,q);q+=fe>=65536?2:1,fe<128?J[oe++]=fe:fe<2048?(J[oe++]=192|(fe&1984)>>>6,J[oe++]=128|(fe&63)>>>0):fe<65536?(J[oe++]=224|(fe&61440)>>>12,J[oe++]=128|(fe&4032)>>>6,J[oe++]=128|(fe&63)>>>0):(J[oe++]=240|(fe&1835008)>>>18,J[oe++]=128|(fe&258048)>>>12,J[oe++]=128|(fe&4032)>>>6,J[oe++]=128|(fe&63)>>>0)}return J}e.encodeUTF8=$;function ee(H){const ne=H.byteLength,he=[];let q=0;for(;q<ne;){const J=H[q];let oe;if(J>=240&&q+3<ne?oe=(H[q++]&7)<<18>>>0|(H[q++]&63)<<12>>>0|(H[q++]&63)<<6>>>0|(H[q++]&63)<<0>>>0:J>=224&&q+2<ne?oe=(H[q++]&15)<<12>>>0|(H[q++]&63)<<6>>>0|(H[q++]&63)<<0>>>0:J>=192&&q+1<ne?oe=(H[q++]&31)<<6>>>0|(H[q++]&63)<<0>>>0:oe=H[q++],oe>=0&&oe<=55295||oe>=57344&&oe<=65535)he.push(String.fromCharCode(oe));else if(oe>=65536&&oe<=1114111){const fe=oe-65536,pe=55296+((fe&1047552)>>>10),Be=56320+((fe&1023)>>>0);he.push(String.fromCharCode(pe)),he.push(String.fromCharCode(Be))}else he.push(String.fromCharCode(65533))}return he.join("")}e.decodeUTF8=ee;const re=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function se(H){return re.test(H)}e.containsRTL=se;const ye=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Ie(H){return ye.test(H)}e.containsEmoji=Ie;const xe=/^[\t\n\r\x20-\x7E]*$/;function Fe(H){return xe.test(H)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ze(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=ze;function N(H){for(let ne=0,he=H.length;ne<he;ne++)if(G(H.charCodeAt(ne)))return!0;return!1}e.containsFullWidthCharacter=N;function G(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=G;function te(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=te;function ae(H,ne){if(H.length<ne)return H;const he=/\b/g;let q=0;for(;he.test(H)&&!(H.length-he.lastIndex<ne);)q=he.lastIndex,he.lastIndex+=1;return H.substring(q).replace(/^\s/,"")}e.lcut=ae;const me=/\x1B\x5B[12]?K/g,Se=/\x1b\[\d+m/g,Le=/\x1b\[0?m/g;function ge(H){return H&&(H=H.replace(me,""),H=H.replace(Se,""),H=H.replace(Le,"")),H}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Pe(H){return Ce(H)?H.substr(1):H}e.stripUTF8BOM=Pe;function $e(H,ne){if(!H||!ne||H.length<ne.length)return!1;const he=ne.length,q=H.toLowerCase();let J=0,oe=-1;for(;J<he;){const fe=q.indexOf(ne[J],oe+1);if(fe<0)return!1;oe=fe,J++}return!0}e.fuzzyContains=$e;function _e(H,ne=!1){return H?(ne&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=_e;function qe(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=qe;function V(H,ne=1){if(ne===0)return"";let he=-1;do he=H.indexOf(`
`,he+1),ne--;while(ne>0&&he>=0);return he===-1?H:(H[he-1]==="\r"&&he--,H.substr(0,he))}e.getNLines=V;function X(H){const ne=90-65+1;return H=H%(2*ne),H<ne?String.fromCharCode(97+H):String.fromCharCode(65+H-ne)}e.singleLetterHash=X;function ve(H){return Oe.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=ve;function Me(H,ne){return H===0?ne!==5&&ne!==7:H===2&&ne===3?!1:H===4||H===2||H===3||ne===4||ne===2||ne===3?!0:!(H===8&&(ne===8||ne===9||ne===11||ne===12)||(H===11||H===9)&&(ne===9||ne===10)||(H===12||H===10)&&ne===10||ne===5||ne===13||ne===7||H===1||H===13&&ne===14||H===6&&ne===6)}e.breakBetweenGraphemeBreakType=Me;var He;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Oe{constructor(){this._data=et()}static getInstance(){return Oe._INSTANCE||(Oe._INSTANCE=new Oe),Oe._INSTANCE}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const he=this._data,q=he.length/3;let J=1;for(;J<=q;)if(ne<he[3*J])J=2*J;else if(ne>he[3*J+1])J=2*J+1;else return he[3*J+2];return 0}}Oe._INSTANCE=null;function et(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(be[24],we([0,1,8,107]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",S=typeof TextDecoder!="undefined";let I,y;class n{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return A?new n(Buffer.allocUnsafe(u)):new n(new Uint8Array(u))}static wrap(u){return A&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new n(u)}static fromString(u,m){return!((m==null?void 0:m.dontUseNodeBuffer)||!1)&&A?new n(Buffer.from(u)):T?(I||(I=new TextEncoder),new n(I.encode(u))):new n(w.encodeUTF8(u))}static concat(u,m){if(typeof m=="undefined"){m=0;for(let c=0,p=u.length;c<p;c++)m+=u[c].byteLength}const _=n.alloc(m);let D=0;for(let c=0,p=u.length;c<p;c++){const P=u[c];_.set(P,D),D+=P.byteLength}return _}toString(){return A?this.buffer.toString():S?(y||(y=new TextDecoder),y.decode(this.buffer)):w.decodeUTF8(this.buffer)}slice(u,m){return new n(this.buffer.subarray(u,m))}set(u,m){u instanceof n?this.buffer.set(u.buffer,m):this.buffer.set(u,m)}readUInt32BE(u){return b(this.buffer,u)}writeUInt32BE(u,m){f(this.buffer,u,m)}readUInt32LE(u){return i(this.buffer,u)}writeUInt32LE(u,m){s(this.buffer,u,m)}readUInt8(u){return v(this.buffer,u)}writeUInt8(u,m){h(this.buffer,u,m)}}e.VSBuffer=n;function R(l,u){return l[u+0]<<0>>>0|l[u+1]<<8>>>0}e.readUInt16LE=R;function C(l,u,m){l[m+0]=u&255,u=u>>>8,l[m+1]=u&255}e.writeUInt16LE=C;function b(l,u){return l[u]*2**24+l[u+1]*2**16+l[u+2]*2**8+l[u+3]}e.readUInt32BE=b;function f(l,u,m){l[m+3]=u,u=u>>>8,l[m+2]=u,u=u>>>8,l[m+1]=u,u=u>>>8,l[m]=u}e.writeUInt32BE=f;function i(l,u){return l[u+0]<<0>>>0|l[u+1]<<8>>>0|l[u+2]<<16>>>0|l[u+3]<<24>>>0}e.readUInt32LE=i;function s(l,u,m){l[m+0]=u&255,u=u>>>8,l[m+1]=u&255,u=u>>>8,l[m+2]=u&255,u=u>>>8,l[m+3]=u&255}e.writeUInt32LE=s;function v(l,u){return l[u]}e.readUInt8=v;function h(l,u,m){l[m]=u}e.writeUInt8=h;function E(l){return k.consumeReadable(l,u=>n.concat(u))}e.readableToBuffer=E;function g(l){return k.toReadable(l)}e.bufferToReadable=g;function a(l){return k.consumeStream(l,u=>n.concat(u))}e.streamToBuffer=a;async function o(l){return l.ended?n.concat(l.buffer):n.concat([...l.buffer,await a(l.stream)])}e.bufferedStreamToBuffer=o;function t(l){return k.toStream(l,u=>n.concat(u))}e.bufferToStream=t;function r(l){return k.transform(l,{data:u=>typeof u=="string"?n.fromString(u):n.wrap(u)},u=>n.concat(u))}e.streamToBufferReadableStream=r;function d(l){return k.newWriteableStream(u=>n.concat(u),l)}e.newWriteableBufferStream=d}),define(be[56],we([0,1,8]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function k(h){return A(h,0)}e.hash=k;function A(h,E){switch(typeof h){case"object":return h===null?T(349,E):Array.isArray(h)?y(h,E):n(h,E);case"string":return I(h,E);case"boolean":return S(h,E);case"number":return T(h,E);case"undefined":return T(937,E);default:return T(617,E)}}e.doHash=A;function T(h,E){return(E<<5)-E+h|0}function S(h,E){return T(h?433:863,E)}function I(h,E){E=T(149417,E);for(let g=0,a=h.length;g<a;g++)E=T(h.charCodeAt(g),E);return E}e.stringHash=I;function y(h,E){return E=T(104579,E),h.reduce((g,a)=>A(a,g),E)}function n(h,E){return E=T(181387,E),Object.keys(h).sort().reduce((g,a)=>(g=I(a,g),A(h[a],g)),E)}class R{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=A(E,this._value),this._value}}e.Hasher=R;var C;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function b(h,E,g=32){const a=g-E,o=~((1<<a)-1);return(h<<E|(o&h)>>>a)>>>0}function f(h,E=0,g=h.byteLength,a=0){for(let o=0;o<g;o++)h[E+o]=a}function i(h,E,g="0"){for(;h.length<E;)h=g+h;return h}function s(h,E=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(g=>g.toString(16).padStart(2,"0")).join(""):i((h>>>0).toString(16),E/4)}e.toHexString=s;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const g=E.length;if(g!==0){const a=this._buff;let o=this._buffLen,t=this._leftoverHighSurrogate,r,d;for(t!==0?(r=t,d=-1,t=0):(r=E.charCodeAt(0),d=0);;){let l=r;if(w.isHighSurrogate(r))if(d+1<g){const u=E.charCodeAt(d+1);w.isLowSurrogate(u)?(d++,l=w.computeCodePoint(r,u)):l=65533}else{t=r;break}else w.isLowSurrogate(r)&&(l=65533);if(o=this._push(a,o,l),d++,d<g)r=E.charCodeAt(d);else break}this._buffLen=o,this._leftoverHighSurrogate=t}}_push(E,g,a){return a<128?E[g++]=a:a<2048?(E[g++]=192|(a&1984)>>>6,E[g++]=128|(a&63)>>>0):a<65536?(E[g++]=224|(a&61440)>>>12,E[g++]=128|(a&4032)>>>6,E[g++]=128|(a&63)>>>0):(E[g++]=240|(a&1835008)>>>18,E[g++]=128|(a&258048)>>>12,E[g++]=128|(a&4032)>>>6,E[g++]=128|(a&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),s(this._h0)+s(this._h1)+s(this._h2)+s(this._h3)+s(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=v._bigBlock32,g=this._buffDV;for(let _=0;_<64;_+=4)E.setUint32(_,g.getUint32(_,!1),!1);for(let _=64;_<320;_+=4)E.setUint32(_,b(E.getUint32(_-12,!1)^E.getUint32(_-32,!1)^E.getUint32(_-56,!1)^E.getUint32(_-64,!1),1),!1);let a=this._h0,o=this._h1,t=this._h2,r=this._h3,d=this._h4,l,u,m;for(let _=0;_<80;_++)_<20?(l=o&t|~o&r,u=1518500249):_<40?(l=o^t^r,u=1859775393):_<60?(l=o&t|o&r|t&r,u=2400959708):(l=o^t^r,u=3395469782),m=b(a,5)+l+d+u+E.getUint32(_*4,!1)&4294967295,d=r,r=t,t=b(o,30),o=a,a=m;this._h0=this._h0+a&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+d&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))}),define(be[46],we([0,1,8]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(k||(k={})),function(A){const T="error",S="warning",I="warn",y="info";function n(R){return R?w.equalsIgnoreCase(T,R)?A.Error:w.equalsIgnoreCase(S,R)||w.equalsIgnoreCase(I,R)?A.Warning:w.equalsIgnoreCase(y,R)?A.Info:A.Ignore:A.Ignore}A.fromValue=n}(k||(k={})),e.default=k}),define(be[12],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(m){return Array.isArray(m)}e.isArray=w;function k(m){return typeof m=="string"}e.isString=k;function A(m){return Array.isArray(m)&&m.every(_=>k(_))}e.isStringArray=A;function T(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=T;function S(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=S;function I(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=I;function y(m){return m===!0||m===!1}e.isBoolean=y;function n(m){return typeof m=="undefined"}e.isUndefined=n;function R(m){return!C(m)}e.isDefined=R;function C(m){return n(m)||m===null}e.isUndefinedOrNull=C;function b(m,_){if(!m)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}e.assertType=b;function f(m){if(C(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=f;function i(...m){const _=[];for(let D=0;D<m.length;D++){const c=m[D];if(C(c))throw new Error(`Assertion Failed: argument at index ${D} is undefined or null`);_.push(c)}return _}e.assertAllDefined=i;const s=Object.prototype.hasOwnProperty;function v(m){if(!T(m))return!1;for(let _ in m)if(s.call(m,_))return!1;return!0}e.isEmptyObject=v;function h(m){return typeof m=="function"}e.isFunction=h;function E(...m){return m.length>0&&m.every(h)}e.areFunctions=E;function g(m,_){const D=Math.min(m.length,_.length);for(let c=0;c<D;c++)a(m[c],_[c])}e.validateConstraints=g;function a(m,_){if(k(_)){if(typeof m!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(h(_)){try{if(m instanceof _)return}catch(D){}if(!C(m)&&m.constructor===_||_.length===1&&_.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function o(m){let _=[],D=Object.getPrototypeOf(m);for(;Object.prototype!==D;)_=_.concat(Object.getOwnPropertyNames(D)),D=Object.getPrototypeOf(D);return _}e.getAllPropertyNames=o;function t(m){const _=[];for(const D of o(m))typeof m[D]=="function"&&_.push(D);return _}e.getAllMethodNames=t;function r(m,_){const D=p=>function(){const P=Array.prototype.slice.call(arguments,0);return _(p,P)};let c={};for(const p of m)c[p]=D(p);return c}e.createProxyObject=r;function d(m){return m===null?void 0:m}e.withNullAsUndefined=d;function l(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=l;function u(m){return class{constructor(){return new Proxy({},{get(_,D){if(_[D])return _[D];throw new Error(`Not Implemented: ${m}->${String(D)}`)}})}}}e.NotImplementedProxy=u}),define(be[38],we([0,1,21,8,11,12]),function(ie,e,w,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function S(r){return r===47||r===92}e.isPathSeparator=S;function I(r){return r.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=I;function y(r,d=A.posix.sep){if(!r)return"";const l=r.length,u=r.charCodeAt(0);if(S(u)){if(S(r.charCodeAt(1))&&!S(r.charCodeAt(2))){let _=3;const D=_;for(;_<l&&!S(r.charCodeAt(_));_++);if(D!==_&&!S(r.charCodeAt(_+1))){for(_+=1;_<l;_++)if(S(r.charCodeAt(_)))return r.slice(0,_+1).replace(/[\\/]/g,d)}}return d}else if(v(u)&&r.charCodeAt(1)===58)return S(r.charCodeAt(2))?r.slice(0,2)+d:r.slice(0,2);let m=r.indexOf("://");if(m!==-1){for(m+=3;m<l;m++)if(S(r.charCodeAt(m)))return r.slice(0,m+1)}return""}e.getRoot=y;function n(r){if(!w.isWindows||!r||r.length<5)return!1;let d=r.charCodeAt(0);if(d!==92||(d=r.charCodeAt(1),d!==92))return!1;let l=2;const u=l;for(;l<r.length&&(d=r.charCodeAt(l),d!==92);l++);return!(u===l||(d=r.charCodeAt(l+1),isNaN(d)||d===92))}e.isUNC=n;const R=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,d=w.isWindows){const l=d?R:C;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||d&&b.test(r)||r==="."||r===".."||d&&r[r.length-1]==="."||d&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function i(r,d,l){const u=r===d;return!l||u?u:!r||!d?!1:(0,k.equalsIgnoreCase)(r,d)}e.isEqual=i;function s(r,d,l,u=A.sep){if(r===d)return!0;if(!r||!d||d.length>r.length)return!1;if(l){if(!(0,k.startsWithIgnoreCase)(r,d))return!1;if(d.length===r.length)return!0;let _=d.length;return d.charAt(d.length-1)===u&&_--,r.charAt(_)===u}return d.charAt(d.length-1)!==u&&(d+=u),r.indexOf(d)===0}e.isEqualOrParent=s;function v(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=v;function h(r,d){return w.isWindows&&r.endsWith(":")&&(r+=A.sep),(0,A.isAbsolute)(r)||(r=(0,A.join)(d,r)),r=(0,A.normalize)(r),w.isWindows?(r=(0,k.rtrim)(r,A.sep),r.endsWith(":")&&(r+=A.sep)):(r=(0,k.rtrim)(r,A.sep),r||(r=A.sep)),r}e.sanitizeFilePath=h;function E(r){const d=(0,A.normalize)(r);return w.isWindows?r.length>3?!1:g(d)&&(r.length===2||d.charCodeAt(2)===92):d===A.posix.sep}e.isRootOrDriveLetter=E;function g(r){return w.isWindows?v(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function a(r){return g(r)?r[0]:void 0}e.getDriveLetter=a;function o(r,d,l){return d.length>r.length?-1:r===d?0:(l&&(r=r.toLowerCase(),d=d.toLowerCase()),r.indexOf(d))}e.indexOfPath=o;function t(r){const d=r.split(":");let l,u,m;if(d.forEach(_=>{const D=Number(_);(0,T.isNumber)(D)?u===void 0?u=D:m===void 0&&(m=D):l=l?[l,_].join(":"):_}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:u!==void 0?u:void 0,column:m!==void 0?m:u!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(be[23],we([0,1,12]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(i){if(!i||typeof i!="object"||i instanceof RegExp)return i;const s=Array.isArray(i)?[]:{};return Object.keys(i).forEach(v=>{i[v]&&typeof i[v]=="object"?s[v]=k(i[v]):s[v]=i[v]}),s}e.deepClone=k;function A(i){if(!i||typeof i!="object")return i;const s=[i];for(;s.length>0;){const v=s.shift();Object.freeze(v);for(const h in v)if(T.call(v,h)){const E=v[h];typeof E=="object"&&!Object.isFrozen(E)&&s.push(E)}}return i}e.deepFreeze=A;const T=Object.prototype.hasOwnProperty;function S(i,s){return I(i,s,new Set)}e.cloneAndChange=S;function I(i,s,v){if((0,w.isUndefinedOrNull)(i))return i;const h=s(i);if(typeof h!="undefined")return h;if((0,w.isArray)(i)){const E=[];for(const g of i)E.push(I(g,s,v));return E}if((0,w.isObject)(i)){if(v.has(i))throw new Error("Cannot clone recursive data-structure");v.add(i);const E={};for(let g in i)T.call(i,g)&&(E[g]=I(i[g],s,v));return v.delete(i),E}return i}function y(i,s,v=!0){return(0,w.isObject)(i)?((0,w.isObject)(s)&&Object.keys(s).forEach(h=>{h in i?v&&((0,w.isObject)(i[h])&&(0,w.isObject)(s[h])?y(i[h],s[h],v):i[h]=s[h]):i[h]=s[h]}),i):s}e.mixin=y;function n(i,s){if(i===s)return!0;if(i==null||s===null||s===void 0||typeof i!=typeof s||typeof i!="object"||Array.isArray(i)!==Array.isArray(s))return!1;let v,h;if(Array.isArray(i)){if(i.length!==s.length)return!1;for(v=0;v<i.length;v++)if(!n(i[v],s[v]))return!1}else{const E=[];for(h in i)E.push(h);E.sort();const g=[];for(h in s)g.push(h);if(g.sort(),!n(E,g))return!1;for(v=0;v<E.length;v++)if(!n(i[E[v]],s[E[v]]))return!1}return!0}e.equals=n;function R(i){const s=new Set;return JSON.stringify(i,(v,h)=>{if((0,w.isObject)(h)||Array.isArray(h)){if(s.has(h))return"[Circular]";s.add(h)}return h})}e.safeStringify=R;function C(i,s,v){const h=s(i);return typeof h=="undefined"?v:h}e.getOrDefault=C;function b(i,s){const v=Object.create(null);return!i||!s||Object.keys(s).forEach(E=>{const g=i[E],a=s[E];n(g,a)||(v[E]=a)}),v}e.distinct=b;function f(i,s){const v=s.toLowerCase(),h=Object.keys(i).find(E=>E.toLowerCase()===v);return h?i[h]:i[s]}e.getCaseInsensitive=f}),define(be[79],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var w;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(w=e.Constants||(e.Constants={}));function k(T){return T<0?0:T>255?255:T|0}e.toUint8=k;function A(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=A}),define(be[2],we([0,1,21,11]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,T=/^\//,S=/^\/\//;function I(d,l){if(!d.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!A.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!T.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(d,l){return!d&&!l?"file":d}function n(d,l){switch(d){case"https":case"http":case"file":l?l[0]!==C&&(l=C+l):l=C;break}return l}const R="",C="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(l,u,m,_,D,c=!1){typeof l=="object"?(this.scheme=l.scheme||R,this.authority=l.authority||R,this.path=l.path||R,this.query=l.query||R,this.fragment=l.fragment||R):(this.scheme=y(l,c),this.authority=u||R,this.path=n(this.scheme,m||R),this.query=_||R,this.fragment=D||R,I(this,c))}static isUri(l){return l instanceof f?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}get fsPath(){return g(this,!1)}with(l){if(!l)return this;let{scheme:u,authority:m,path:_,query:D,fragment:c}=l;return u===void 0?u=this.scheme:u===null&&(u=R),m===void 0?m=this.authority:m===null&&(m=R),_===void 0?_=this.path:_===null&&(_=R),D===void 0?D=this.query:D===null&&(D=R),c===void 0?c=this.fragment:c===null&&(c=R),u===this.scheme&&m===this.authority&&_===this.path&&D===this.query&&c===this.fragment?this:new s(u,m,_,D,c)}static parse(l,u=!1){const m=b.exec(l);return m?new s(m[2]||R,r(m[4]||R),r(m[5]||R),r(m[7]||R),r(m[9]||R),u):new s(R,R,R,R,R)}static file(l){let u=R;if(w.isWindows&&(l=l.replace(/\\/g,C)),l[0]===C&&l[1]===C){const m=l.indexOf(C,2);m===-1?(u=l.substring(2),l=C):(u=l.substring(2,m),l=l.substring(m)||C)}return new s("file",u,l,R,R)}static from(l){return new s(l.scheme,l.authority,l.path,l.query,l.fragment)}static joinPath(l,...u){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return w.isWindows&&l.scheme==="file"?m=f.file(k.win32.join(g(l,!0),...u)).path:m=k.posix.join(l.path,...u),l.with({path:m})}toString(l=!1){return a(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof f)return l;{const u=new s(l);return u._formatted=l.external,u._fsPath=l._sep===i?l.fsPath:null,u}}else return l}}e.URI=f;const i=w.isWindows?1:void 0;class s extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(l=!1){return l?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=i),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(d,l){let u,m=-1;for(let _=0;_<d.length;_++){const D=d.charCodeAt(_);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||l&&D===47)m!==-1&&(u+=encodeURIComponent(d.substring(m,_)),m=-1),u!==void 0&&(u+=d.charAt(_));else{u===void 0&&(u=d.substr(0,_));const c=v[D];c!==void 0?(m!==-1&&(u+=encodeURIComponent(d.substring(m,_)),m=-1),u+=c):m===-1&&(m=_)}}return m!==-1&&(u+=encodeURIComponent(d.substring(m))),u!==void 0?u:d}function E(d){let l;for(let u=0;u<d.length;u++){const m=d.charCodeAt(u);m===35||m===63?(l===void 0&&(l=d.substr(0,u)),l+=v[m]):l!==void 0&&(l+=d[u])}return l!==void 0?l:d}function g(d,l){let u;return d.authority&&d.path.length>1&&d.scheme==="file"?u=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?l?u=d.path.substr(1):u=d.path[1].toLowerCase()+d.path.substr(2):u=d.path,w.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=g;function a(d,l){const u=l?E:h;let m="",{scheme:_,authority:D,path:c,query:p,fragment:P}=d;if(_&&(m+=_,m+=":"),(D||_==="file")&&(m+=C,m+=C),D){let F=D.indexOf("@");if(F!==-1){const z=D.substr(0,F);D=D.substr(F+1),F=z.indexOf(":"),F===-1?m+=u(z,!1):(m+=u(z.substr(0,F),!1),m+=":",m+=u(z.substr(F+1),!1)),m+="@"}D=D.toLowerCase(),F=D.indexOf(":"),F===-1?m+=u(D,!1):(m+=u(D.substr(0,F),!1),m+=D.substr(F))}if(c){if(c.length>=3&&c.charCodeAt(0)===47&&c.charCodeAt(2)===58){const F=c.charCodeAt(1);F>=65&&F<=90&&(c=`/${String.fromCharCode(F+32)}:${c.substr(3)}`)}else if(c.length>=2&&c.charCodeAt(1)===58){const F=c.charCodeAt(0);F>=65&&F<=90&&(c=`${String.fromCharCode(F+32)}:${c.substr(2)}`)}m+=u(c,!0)}return p&&(m+="?",m+=u(p,!1)),P&&(m+="#",m+=l?P:h(P,!1)),m}function o(d){try{return decodeURIComponent(d)}catch(l){return d.length>3?d.substr(0,3)+o(d.substr(3)):d}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(d){return d.match(t)?d.replace(t,l=>o(l)):d}}),define(be[22],we([0,1,2,8]),function(ie,e,w,k){"use strict";var A,T;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(a,o,t){let r=a.get(o);return r===void 0&&(r=t,a.set(o,r)),r}e.getOrSet=S;function I(a){const o=[];return a.forEach((t,r)=>{o.push(`${r} => ${t}`)}),`Map(${a.size}) {${o.join(", ")}}`}e.mapToString=I;function y(a){const o=[];return a.forEach(t=>{o.push(t)}),`Set(${a.size}) {${o.join(", ")}}`}e.setToString=y;class n{constructor(){this._value="",this._pos=0}reset(o){return this._value=o,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(o){const t=o.charCodeAt(0),r=this._value.charCodeAt(this._pos);return t-r}value(){return this._value[this._pos]}}e.StringIterator=n;class R{constructor(o=!0){this._caseSensitive=o}reset(o){return this._value=o,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(o)this._from++;else break;else o=!1;return this}cmp(o){return this._caseSensitive?(0,k.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class C{constructor(o=!0,t=!0){this._splitOnBackslash=o,this._caseSensitive=t}reset(o){return this._value=o.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(o)this._from++;else break;else o=!1}return this}cmp(o){return this._caseSensitive?(0,k.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=C;var b;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(b||(b={}));class f{constructor(o){this._ignorePathCasing=o,this._states=[],this._stateIdx=0}reset(o){return this._value=o,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new C(!1,!this._ignorePathCasing(o)),this._pathIterator.reset(o.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(o){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(o,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(o,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(o);if(this._states[this._stateIdx]===4)return(0,k.compare)(o,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(o,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class i{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class s{constructor(o){this._iter=o}static forUris(o=()=>!1){return new s(new f(o))}static forPaths(){return new s(new C)}static forStrings(){return new s(new n)}static forConfigKeys(){return new s(new R)}clear(){this._root=void 0}set(o,t){const r=this._iter.reset(o);let d;for(this._root||(this._root=new i,this._root.segment=r.value()),d=this._root;;){const u=r.cmp(d.segment);if(u>0)d.left||(d.left=new i,d.left.segment=r.value()),d=d.left;else if(u<0)d.right||(d.right=new i,d.right.segment=r.value()),d=d.right;else if(r.hasNext())r.next(),d.mid||(d.mid=new i,d.mid.segment=r.value()),d=d.mid;else break}const l=d.value;return d.value=t,d.key=o,l}get(o){var t;return(t=this._getNode(o))===null||t===void 0?void 0:t.value}_getNode(o){const t=this._iter.reset(o);let r=this._root;for(;r;){const d=t.cmp(r.segment);if(d>0)r=r.left;else if(d<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else break}return r}has(o){const t=this._getNode(o);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(o){return this._delete(o,!1)}deleteSuperstr(o){return this._delete(o,!0)}_delete(o,t){const r=this._iter.reset(o),d=[];let l=this._root;for(;l;){const u=r.cmp(l.segment);if(u>0)d.push([1,l]),l=l.left;else if(u<0)d.push([-1,l]),l=l.right;else if(r.hasNext())r.next(),d.push([0,l]),l=l.mid;else{for(t?(l.left=void 0,l.mid=void 0,l.right=void 0):l.value=void 0;d.length>0&&l.isEmpty();){let[m,_]=d.pop();switch(m){case 1:_.left=void 0;break;case 0:_.mid=void 0;break;case-1:_.right=void 0;break}l=_}break}}}findSubstr(o){const t=this._iter.reset(o);let r=this._root,d;for(;r;){const l=t.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(t.hasNext())t.next(),d=r.value||d,r=r.mid;else break}return r&&r.value||d}findSuperstr(o){const t=this._iter.reset(o);let r=this._root;for(;r;){const d=t.cmp(r.segment);if(d>0)r=r.left;else if(d<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(o){for(const[t,r]of this)o(r,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(o){o&&(yield*this._entries(o.left),o.value&&(yield[o.key,o.value]),yield*this._entries(o.mid),yield*this._entries(o.right))}}e.TernarySearchTree=s;class v{constructor(o,t){this[A]="ResourceMap",o instanceof v?(this.map=new Map(o.map),this.toKey=t!=null?t:v.defaultToKey):(this.map=new Map,this.toKey=o!=null?o:v.defaultToKey)}set(o,t){return this.map.set(this.toKey(o),t),this}get(o){return this.map.get(this.toKey(o))}has(o){return this.map.has(this.toKey(o))}get size(){return this.map.size}clear(){this.map.clear()}delete(o){return this.map.delete(this.toKey(o))}forEach(o,t){typeof t!="undefined"&&(o=o.bind(t));for(let[r,d]of this.map)o(d,w.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let o of this.map.keys())yield w.URI.parse(o)}*entries(){for(let o of this.map.entries())yield[w.URI.parse(o[0]),o[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let o of this.map)yield[w.URI.parse(o[0]),o[1]]}}e.ResourceMap=v,v.defaultToKey=a=>a.toString();var h;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class E{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var o;return(o=this._head)===null||o===void 0?void 0:o.value}get last(){var o;return(o=this._tail)===null||o===void 0?void 0:o.value}has(o){return this._map.has(o)}get(o,t=0){const r=this._map.get(o);if(!!r)return t!==0&&this.touch(r,t),r.value}set(o,t,r=0){let d=this._map.get(o);if(d)d.value=t,r!==0&&this.touch(d,r);else{switch(d={key:o,value:t,next:void 0,previous:void 0},r){case 0:this.addItemLast(d);break;case 1:this.addItemFirst(d);break;case 2:this.addItemLast(d);break;default:this.addItemLast(d);break}this._map.set(o,d),this._size++}return this}delete(o){return!!this.remove(o)}remove(o){const t=this._map.get(o);if(!!t)return this._map.delete(o),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const o=this._head;return this._map.delete(o.key),this.removeItem(o),this._size--,o.value}}forEach(o,t){const r=this._state;let d=this._head;for(;d;){if(t?o.bind(t)(d.value,d.key,this):o(d.value,d.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const o=this,t=this._state;let r=this._head;const d={[Symbol.iterator](){return d},next(){if(o._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const l={value:r.key,done:!1};return r=r.next,l}else return{value:void 0,done:!0}}};return d}values(){const o=this,t=this._state;let r=this._head;const d={[Symbol.iterator](){return d},next(){if(o._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const l={value:r.value,done:!1};return r=r.next,l}else return{value:void 0,done:!0}}};return d}entries(){const o=this,t=this._state;let r=this._head;const d={[Symbol.iterator](){return d},next(){if(o._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const l={value:[r.key,r.value],done:!1};return r=r.next,l}else return{value:void 0,done:!0}}};return d}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(o){if(!(o>=this.size)){if(o===0){this.clear();return}let t=this._head,r=this.size;for(;t&&r>o;)this._map.delete(t.key),t=t.next,r--;this._head=t,this._size=r,t&&(t.previous=void 0),this._state++}}addItemFirst(o){if(!this._head&&!this._tail)this._tail=o;else if(this._head)o.next=this._head,this._head.previous=o;else throw new Error("Invalid list");this._head=o,this._state++}addItemLast(o){if(!this._head&&!this._tail)this._head=o;else if(this._tail)o.previous=this._tail,this._tail.next=o;else throw new Error("Invalid list");this._tail=o,this._state++}removeItem(o){if(o===this._head&&o===this._tail)this._head=void 0,this._tail=void 0;else if(o===this._head){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this._head=o.next}else if(o===this._tail){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this._tail=o.previous}else{const t=o.next,r=o.previous;if(!t||!r)throw new Error("Invalid list");t.previous=r,r.next=t}o.next=void 0,o.previous=void 0,this._state++}touch(o,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(o===this._head)return;const r=o.next,d=o.previous;o===this._tail?(d.next=void 0,this._tail=d):(r.previous=d,d.next=r),o.previous=void 0,o.next=this._head,this._head.previous=o,this._head=o,this._state++}else if(t===2){if(o===this._tail)return;const r=o.next,d=o.previous;o===this._head?(r.previous=void 0,this._head=r):(r.previous=d,d.next=r),o.next=void 0,o.previous=this._tail,this._tail.next=o,this._tail=o,this._state++}}}toJSON(){const o=[];return this.forEach((t,r)=>{o.push([r,t])}),o}fromJSON(o){this.clear();for(const[t,r]of o)this.set(t,r)}}e.LinkedMap=E;class g extends E{constructor(o,t=1){super();this._limit=o,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(o){this._limit=o,this.checkTrim()}get ratio(){return this._ratio}set ratio(o){this._ratio=Math.min(Math.max(0,o),1),this.checkTrim()}get(o,t=2){return super.get(o,t)}peek(o){return super.get(o,0)}set(o,t){return super.set(o,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=g}),define(be[108],we([0,1,22,8]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function A(...ge){return function(Ce,Pe){for(let $e=0,_e=ge.length;$e<_e;$e++){const qe=ge[$e](Ce,Pe);if(qe)return qe}return null}}e.or=A,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(ge,Ce,Pe){if(!Pe||Pe.length<Ce.length)return null;let $e;return ge?$e=k.startsWithIgnoreCase(Pe,Ce):$e=Pe.indexOf(Ce)===0,$e?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function S(ge,Ce){const Pe=Ce.toLowerCase().indexOf(ge.toLowerCase());return Pe===-1?null:[{start:Pe,end:Pe+ge.length}]}e.matchesContiguousSubString=S;function I(ge,Ce){return y(ge.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=I;function y(ge,Ce,Pe,$e){if(Pe===ge.length)return[];if($e===Ce.length)return null;if(ge[Pe]===Ce[$e]){let _e=null;return(_e=y(ge,Ce,Pe+1,$e+1))?h({start:$e,end:$e+1},_e):null}return y(ge,Ce,Pe,$e+1)}function n(ge){return 97<=ge&&ge<=122}function R(ge){return 65<=ge&&ge<=90}e.isUpper=R;function C(ge){return 48<=ge&&ge<=57}function b(ge){return ge===32||ge===9||ge===10||ge===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(ge=>f.add(ge.charCodeAt(0)));function i(ge){return b(ge)||f.has(ge)}function s(ge,Ce){return ge===Ce||i(ge)&&i(Ce)}function v(ge){return n(ge)||R(ge)||C(ge)}function h(ge,Ce){return Ce.length===0?Ce=[ge]:ge.end===Ce[0].start?Ce[0].start=ge.start:Ce.unshift(ge),Ce}function E(ge,Ce){for(let Pe=Ce;Pe<ge.length;Pe++){const $e=ge.charCodeAt(Pe);if(R($e)||C($e)||Pe>0&&!v(ge.charCodeAt(Pe-1)))return Pe}return ge.length}function g(ge,Ce,Pe,$e){if(Pe===ge.length)return[];if($e===Ce.length)return null;if(ge[Pe]!==Ce[$e].toLowerCase())return null;{let _e=null,qe=$e+1;for(_e=g(ge,Ce,Pe+1,$e+1);!_e&&(qe=E(Ce,qe))<Ce.length;)_e=g(ge,Ce,Pe+1,qe),qe++;return _e===null?null:h({start:$e,end:$e+1},_e)}}function a(ge){let Ce=0,Pe=0,$e=0,_e=0,qe=0;for(let He=0;He<ge.length;He++)qe=ge.charCodeAt(He),R(qe)&&Ce++,n(qe)&&Pe++,v(qe)&&$e++,C(qe)&&_e++;const V=Ce/ge.length,X=Pe/ge.length,ve=$e/ge.length,Me=_e/ge.length;return{upperPercent:V,lowerPercent:X,alphaPercent:ve,numericPercent:Me}}function o(ge){const{upperPercent:Ce,lowerPercent:Pe}=ge;return Pe===0&&Ce>.6}function t(ge){const{upperPercent:Ce,lowerPercent:Pe,alphaPercent:$e,numericPercent:_e}=ge;return Pe>.2&&Ce<.8&&$e>.6&&_e<.2}function r(ge){let Ce=0,Pe=0,$e=0,_e=0;for(let qe=0;qe<ge.length;qe++)$e=ge.charCodeAt(qe),R($e)&&Ce++,n($e)&&Pe++,b($e)&&_e++;return(Ce===0||Pe===0)&&_e===0?ge.length<=30:Ce<=5}function d(ge,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!r(ge)||Ce.length>60)return null;const Pe=a(Ce);if(!t(Pe)){if(!o(Pe))return null;Ce=Ce.toLowerCase()}let $e=null,_e=0;for(ge=ge.toLowerCase();_e<Ce.length&&($e=g(ge,Ce,0,_e))===null;)_e=E(Ce,_e+1);return $e}e.matchesCamelCase=d;function l(ge,Ce,Pe=!1){if(!Ce||Ce.length===0)return null;let $e=null,_e=0;for(ge=ge.toLowerCase(),Ce=Ce.toLowerCase();_e<Ce.length&&($e=u(ge,Ce,0,_e,Pe))===null;)_e=m(Ce,_e+1);return $e}e.matchesWords=l;function u(ge,Ce,Pe,$e,_e){if(Pe===ge.length)return[];if($e===Ce.length)return null;if(s(ge.charCodeAt(Pe),Ce.charCodeAt($e))){let qe=null,V=$e+1;if(qe=u(ge,Ce,Pe+1,$e+1,_e),!_e)for(;!qe&&(V=m(Ce,V))<Ce.length;)qe=u(ge,Ce,Pe+1,V,_e),V++;return qe===null?null:h({start:$e,end:$e+1},qe)}else return null}function m(ge,Ce){for(let Pe=Ce;Pe<ge.length;Pe++)if(i(ge.charCodeAt(Pe))||Pe>0&&i(ge.charCodeAt(Pe-1)))return Pe;return ge.length}const _=A(e.matchesPrefix,d,S),D=A(e.matchesPrefix,d,I),c=new w.LRUCache(1e4);function p(ge,Ce,Pe=!1){if(typeof ge!="string"||typeof Ce!="string")return null;let $e=c.get(ge);$e||($e=new RegExp(k.convertSimple2RegExpPattern(ge),"i"),c.set(ge,$e));const _e=$e.exec(Ce);return _e?[{start:_e.index,end:_e.index+_e[0].length}]:Pe?D(ge,Ce):_(ge,Ce)}e.matchesFuzzy=p;function P(ge,Ce){const Pe=N(ge,ge.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Pe?z(Pe):null}e.matchesFuzzy2=P;function F(ge,Ce,Pe,$e,_e,qe){const V=Math.min(13,ge.length);for(;Pe<V;Pe++){const X=N(ge,Ce,Pe,$e,_e,qe,!1);if(X)return X}return[0,qe]}e.anyScore=F;function z(ge){if(typeof ge=="undefined")return[];const Ce=[],Pe=ge[1];for(let $e=ge.length-1;$e>1;$e--){const _e=ge[$e]+Pe,qe=Ce[Ce.length-1];qe&&qe.end===_e?qe.end=_e+1:Ce.push({start:_e,end:_e+1})}return Ce}e.createMatches=z;const de=128;function B(){const ge=[],Ce=[];for(let Pe=0;Pe<=de;Pe++)Ce[Pe]=0;for(let Pe=0;Pe<=de;Pe++)ge.push(Ce.slice(0));return ge}function W(ge){const Ce=[];for(let Pe=0;Pe<=ge;Pe++)Ce[Pe]=0;return Ce}const K=W(2*de),M=W(2*de),U=B(),x=B(),Q=B(),$=!1;function ee(ge,Ce,Pe,$e,_e){function qe(X,ve,Me=" "){for(;X.length<ve;)X=Me+X;return X}let V=` |   |${$e.split("").map(X=>qe(X,3)).join("|")}
`;for(let X=0;X<=Pe;X++)X===0?V+=" |":V+=`${Ce[X-1]}|`,V+=ge[X].slice(0,_e+1).map(ve=>qe(ve.toString(),3)).join("|")+`
`;return V}function re(ge,Ce,Pe,$e){ge=ge.substr(Ce),Pe=Pe.substr($e),console.log(ee(x,ge,ge.length,Pe,Pe.length)),console.log(ee(Q,ge,ge.length,Pe,Pe.length)),console.log(ee(U,ge,ge.length,Pe,Pe.length))}function se(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;const Pe=ge.codePointAt(Ce);switch(Pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(Pe)}}function ye(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;switch(ge.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Ie(ge,Ce,Pe){return Ce[ge]!==Pe[ge]}function xe(ge,Ce,Pe,$e,_e,qe,V=!1){for(;Ce<Pe&&_e<qe;)ge[Ce]===$e[_e]&&(V&&(K[Ce]=_e),Ce+=1),_e+=1;return Ce===Pe}e.isPatternInWord=xe;var Fe;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var ze;(function(ge){ge.Default=[-100,0];function Ce(Pe){return!Pe||Pe.length===2&&Pe[0]===-100&&Pe[1]===0}ge.isDefault=Ce})(ze=e.FuzzyScore||(e.FuzzyScore={}));function N(ge,Ce,Pe,$e,_e,qe,V){const X=ge.length>de?de:ge.length,ve=$e.length>de?de:$e.length;if(!(Pe>=X||qe>=ve||X-Pe>ve-qe)&&!!xe(Ce,Pe,X,_e,qe,ve,!0)){G(X,ve,Pe,qe,Ce,_e);let Me=1,He=1,Oe=Pe,et=qe;const H=[!1];for(Me=1,Oe=Pe;Oe<X;Me++,Oe++){const oe=K[Oe],fe=M[Oe],pe=Oe+1<X?M[Oe+1]:ve;for(He=oe-qe+1,et=oe;et<pe;He++,et++){let Be=Number.MIN_SAFE_INTEGER,Ne=!1;et<=fe&&(Be=te(ge,Ce,Oe,Pe,$e,_e,et,ve,qe,U[Me-1][He-1]===0,H));let Ve=0;Be!==Number.MAX_SAFE_INTEGER&&(Ne=!0,Ve=Be+x[Me-1][He-1]);const Xe=et>oe,Ze=Xe?x[Me][He-1]+(U[Me][He-1]>0?-5:0):0,ct=et>oe+1&&U[Me][He-1]>0,ot=ct?x[Me][He-2]+(U[Me][He-2]>0?-5:0):0;if(ct&&(!Xe||ot>=Ze)&&(!Ne||ot>=Ve))x[Me][He]=ot,Q[Me][He]=3,U[Me][He]=0;else if(Xe&&(!Ne||Ze>=Ve))x[Me][He]=Ze,Q[Me][He]=2,U[Me][He]=0;else if(Ne)x[Me][He]=Ve,Q[Me][He]=1,U[Me][He]=U[Me-1][He-1]+1;else throw new Error("not possible")}}if($&&re(ge,Pe,$e,qe),!(!H[0]&&!V)){Me--,He--;const ne=[x[Me][He],qe];let he=0,q=0;for(;Me>=1;){let oe=He;do{const fe=Q[Me][oe];if(fe===3)oe=oe-2;else if(fe===2)oe=oe-1;else break}while(oe>=1);he>1&&Ce[Pe+Me-1]===_e[qe+He-1]&&!Ie(oe+qe-1,$e,_e)&&he+1>U[Me][oe]&&(oe=He),oe===He?he++:he=1,q||(q=oe),Me--,He=oe-1,ne.push(He)}ve===X&&(ne[0]+=2);const J=q-X;return ne[0]-=J,ne}}}e.fuzzyScore=N;function G(ge,Ce,Pe,$e,_e,qe){let V=ge-1,X=Ce-1;for(;V>=Pe&&X>=$e;)_e[V]===qe[X]&&(M[V]=X,V--),X--}function te(ge,Ce,Pe,$e,_e,qe,V,X,ve,Me,He){if(Ce[Pe]!==qe[V])return Number.MIN_SAFE_INTEGER;let Oe=1,et=!1;return V===Pe-$e?Oe=ge[Pe]===_e[V]?7:5:Ie(V,_e,qe)&&(V===0||!Ie(V-1,_e,qe))?(Oe=ge[Pe]===_e[V]?7:5,et=!0):se(qe,V)&&(V===0||!se(qe,V-1))?Oe=5:(se(qe,V-1)||ye(qe,V-1))&&(Oe=5,et=!0),Oe>1&&Pe===$e&&(He[0]=!0),et||(et=Ie(V,_e,qe)||se(qe,V-1)||ye(qe,V-1)),Pe===$e?V>ve&&(Oe-=et?3:5):Me?Oe+=et?2:0:Oe+=et?0:1,V+1===X&&(Oe-=et?3:5),Oe}function ae(ge,Ce,Pe,$e,_e,qe,V){return Se(ge,Ce,Pe,$e,_e,qe,!0,V)}e.fuzzyScoreGracefulAggressive=ae;function me(ge,Ce,Pe,$e,_e,qe,V){return Se(ge,Ce,Pe,$e,_e,qe,!1,V)}e.fuzzyScoreGraceful=me;function Se(ge,Ce,Pe,$e,_e,qe,V,X){let ve=N(ge,Ce,Pe,$e,_e,qe,X);if(ve&&!V)return ve;if(ge.length>=3){const Me=Math.min(7,ge.length-1);for(let He=Pe+1;He<Me;He++){const Oe=Le(ge,He);if(Oe){const et=N(Oe,Oe.toLowerCase(),Pe,$e,_e,qe,X);et&&(et[0]-=3,(!ve||et[0]>ve[0])&&(ve=et))}}}return ve}function Le(ge,Ce){if(!(Ce+1>=ge.length)){const Pe=ge[Ce],$e=ge[Ce+1];if(Pe!==$e)return ge.slice(0,Ce)+$e+Pe+ge.slice(Ce+2)}}}),define(be[109],we([0,1,37,108,8]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${T.source}`,"g");function I(s){return s.replace(S,(v,h)=>h?v:`\\${v}`)}e.escapeIcons=I;const y=new RegExp(`\\\\${T.source}`,"g");function n(s){return s.replace(y,v=>`\\${v}`)}e.markdownEscapeEscapedIcons=n;const R=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function C(s){return s.indexOf(e.iconStartMarker)===-1?s:s.replace(R,(v,h,E,g)=>E?v:h||g||"")}e.stripIcons=C;function b(s){const v=s.indexOf(e.iconStartMarker);return v===-1?{text:s}:f(s,v)}e.parseLabelWithIcons=b;function f(s,v){const h=[];let E="";function g(m){if(m){E+=m;for(const _ of m)h.push(t)}}let a=-1,o="",t=0,r,d,l=v;const u=s.length;for(g(s.substr(0,v));l<u;)r=s[l],d=s[l+1],r===e.iconStartMarker[0]&&d===e.iconStartMarker[1]?(a=l,g(o),o=e.iconStartMarker,l++):r===")"&&a!==-1?(t+=l-a+1,a=-1,o=""):a!==-1?/^[a-z0-9\-]$/i.test(r)?o+=r:(g(o),a=-1,o=""):g(r),l++;return g(o),{text:E,iconOffsets:h}}function i(s,v,h=!1){const{text:E,iconOffsets:g}=v;if(!g||g.length===0)return(0,k.matchesFuzzy)(s,E,h);const a=(0,A.ltrim)(E," "),o=E.length-a.length,t=(0,k.matchesFuzzy)(s,a,h);if(t)for(const r of t){const d=g[r.start+o]+o;r.start+=d,r.end+=d}return t}e.matchesFuzzyIconAware=i}),define(be[80],we([0,1,15,109,10]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(i){i[i.Paragraph=0]="Paragraph",i[i.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(s="",v=!1){var h,E;if(this.value=s,typeof this.value!="string")throw(0,A.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1):(this.isTrusted=(h=v.isTrusted)!==null&&h!==void 0?h:void 0,this.supportThemeIcons=(E=v.supportThemeIcons)!==null&&E!==void 0?E:!1)}appendText(s,v=0){return this.value+=C(this.supportThemeIcons?(0,k.escapeIcons)(s):s).replace(/([ \t]+)/g,(h,E)=>"&nbsp;".repeat(E.length)).replace(/^>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,v){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}}e.MarkdownString=S;function I(i){return y(i)?!i.value:Array.isArray(i)?i.every(I):!0}e.isEmptyMarkdownString=I;function y(i){return i instanceof S?!0:i&&typeof i=="object"?typeof i.value=="string"&&(typeof i.isTrusted=="boolean"||i.isTrusted===void 0)&&(typeof i.supportThemeIcons=="boolean"||i.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function n(i,s){return!i&&!s?!0:!i||!s?!1:Array.isArray(i)&&Array.isArray(s)?(0,w.equals)(i,s,R):y(i)&&y(s)?R(i,s):!1}e.markedStringsEquals=n;function R(i,s){return i===s?!0:!i||!s?!1:i.value===s.value&&i.isTrusted===s.isTrusted&&i.supportThemeIcons===s.supportThemeIcons}function C(i){return i.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function b(i){return i&&i.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=b;function f(i){const s=[],v=i.split("|").map(E=>E.trim());i=v[0];const h=v[1];if(h){const E=/height=(\d+)/.exec(h),g=/width=(\d+)/.exec(h),a=E?E[1]:"",o=g?g[1]:"",t=isFinite(parseInt(o)),r=isFinite(parseInt(a));t&&s.push(`width="${o}"`),r&&s.push(`height="${a}"`)}return{href:i,dimensions:s}}e.parseHrefAndDimensions=f}),define(be[57],we([0,1,24,8,2]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(n){return JSON.stringify(n,I)}e.stringify=T;function S(n){let R=JSON.parse(n);return R=y(R),R}e.parse=S;function I(n,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,k.regExpFlags)(R)}:R}function y(n,R=0){if(!n||R>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return A.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof w.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let C=0;C<n.length;++C)n[C]=y(n[C],R+1);else for(const C in n)Object.hasOwnProperty.call(n,C)&&(n[C]=y(n[C],R+1))}return n}e.revive=y}),define(be[18],we([0,1,2,21]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.vscodeWebviewResource="vscode-webview-resource",I.extension="extension",I.vscodeFileResource="vscode-file"})(A=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,n,R){this._hosts[y]=n,this._ports[y]=R}setConnectionToken(y,n){this._connectionTokens[y]=n}rewrite(y){if(this._delegate)return this._delegate(y);const n=y.authority;let R=this._hosts[n];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const C=this._ports[n],b=this._connectionTokens[n];let f=`path=${encodeURIComponent(y.path)}`;return typeof b=="string"&&(f+=`&tkn=${encodeURIComponent(b)}`),w.URI.from({scheme:k.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${R}:${C}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new T;class S{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,n,R){const C=this.toUri(y,n);return C.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(C):k.isNative&&(R||k.isPreferringBrowserCodeLoad)&&C.scheme===A.file?C.with({scheme:A.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(y,n){const R=this.toUri(y,n);return R.scheme===A.vscodeFileResource?R.with({scheme:A.file,authority:R.authority!==this.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(y,n){return w.URI.isUri(y)?y:w.URI.parse(n.toUrl(y))}}e.FileAccess=new S}),define(be[25],we([0,1,38,11,2,8,18,21]),function(ie,e,w,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(f){return(0,A.uriToFsPath)(f,!0)}e.originalFSPath=y;class n{constructor(i){this._ignorePathCasing=i}compare(i,s,v=!1){return i===s?0:(0,T.compare)(this.getComparisonKey(i,v),this.getComparisonKey(s,v))}isEqual(i,s,v=!1){return i===s?!0:!i||!s?!1:this.getComparisonKey(i,v)===this.getComparisonKey(s,v)}getComparisonKey(i,s=!1){return i.with({path:this._ignorePathCasing(i)?i.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(i){return this._ignorePathCasing(i)}isEqualOrParent(i,s,v=!1){if(i.scheme===s.scheme){if(i.scheme===S.Schemas.file)return w.isEqualOrParent(y(i),y(s),this._ignorePathCasing(i))&&i.query===s.query&&(v||i.fragment===s.fragment);if((0,e.isEqualAuthority)(i.authority,s.authority))return w.isEqualOrParent(i.path,s.path,this._ignorePathCasing(i),"/")&&i.query===s.query&&(v||i.fragment===s.fragment)}return!1}joinPath(i,...s){return A.URI.joinPath(i,...s)}basenameOrAuthority(i){return(0,e.basename)(i)||i.authority}basename(i){return k.posix.basename(i.path)}extname(i){return k.posix.extname(i.path)}dirname(i){if(i.path.length===0)return i;let s;return i.scheme===S.Schemas.file?s=A.URI.file(k.dirname(y(i))).path:(s=k.posix.dirname(i.path),i.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${i.toString})) resulted in a relative path`),s="/")),i.with({path:s})}normalizePath(i){if(!i.path.length)return i;let s;return i.scheme===S.Schemas.file?s=A.URI.file(k.normalize(y(i))).path:s=k.posix.normalize(i.path),i.with({path:s})}relativePath(i,s){if(!(i.scheme!==s.scheme||!(0,e.isEqualAuthority)(i.authority,s.authority))){if(i.scheme===S.Schemas.file){const E=k.relative(y(i),y(s));return I.isWindows?w.toSlashes(E):E}let v=i.path||"/",h=s.path||"/";if(this._ignorePathCasing(i)){let E=0;for(const g=Math.min(v.length,h.length);E<g&&!(v.charCodeAt(E)!==h.charCodeAt(E)&&v.charAt(E).toLowerCase()!==h.charAt(E).toLowerCase());E++);v=h.substr(0,E)+v.substr(E)}return k.posix.relative(v,h)}}resolvePath(i,s){if(i.scheme===S.Schemas.file){const v=A.URI.file(k.resolve(y(i),s));return i.with({authority:v.authority,path:v.path})}return s.indexOf("/")===-1&&(s=w.toSlashes(s),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s)),i.with({path:k.posix.resolve(i.path,s)})}isAbsolutePath(i){return!!i.path&&i.path[0]==="/"}isEqualAuthority(i,s){return i===s||(0,T.equalsIgnoreCase)(i,s)}hasTrailingPathSeparator(i,s=k.sep){if(i.scheme===S.Schemas.file){const v=y(i);return v.length>w.getRoot(v).length&&v[v.length-1]===s}else{const v=i.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(i.fsPath)}}removeTrailingPathSeparator(i,s=k.sep){return(0,e.hasTrailingPathSeparator)(i,s)?i.with({path:i.path.substr(0,i.path.length-1)}):i}addTrailingPathSeparator(i,s=k.sep){let v=!1;if(i.scheme===S.Schemas.file){const h=y(i);v=h!==void 0&&h.length===w.getRoot(h).length&&h[h.length-1]===s}else{s="/";const h=i.path;v=h.length===1&&h.charCodeAt(h.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(i,s)?i.with({path:i.path+"/"}):i}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(f=>f.scheme===S.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new n(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(f,i){const s=[];for(let v=0;v<f.length;v++){const h=i(f[v]);f.some((E,g)=>g===v?!1:(0,e.isEqualOrParent)(h,i(E)))||s.push(f[v])}return s}e.distinctParents=R;var C;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function i(s){const v=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(g=>{const[a,o]=g.split(":");a&&o&&v.set(a,o)});const E=s.path.substring(0,s.path.indexOf(";"));return E&&v.set(f.META_DATA_MIME,E),v}f.parseMetaData=i})(C=e.DataUri||(e.DataUri={}));function b(f,i,s){if(i){let v=f.path;return v&&v[0]!==k.posix.sep&&(v=k.posix.sep+v),f.with({scheme:s,authority:i,path:v})}return f.with({scheme:s})}e.toLocalResource=b}),define(be[13],we([0,1,20,10,3,6,45,25]),function(ie,e,w,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(x){return!!x&&typeof x.then=="function"}e.isThenable=y;function n(x){const Q=new w.CancellationTokenSource,$=x(Q.token),ee=new Promise((re,se)=>{Q.token.onCancellationRequested(()=>{se((0,k.canceled)())}),Promise.resolve($).then(ye=>{Q.dispose(),re(ye)},ye=>{Q.dispose(),se(ye)})});return new class{cancel(){Q.cancel()}then(re,se){return ee.then(re,se)}catch(re){return this.then(void 0,re)}finally(re){return ee.finally(re)}}}e.createCancelablePromise=n;function R(x,Q,$){return Promise.race([x,new Promise(ee=>Q.onCancellationRequested(()=>ee($)))])}e.raceCancellation=R;async function C(x){let Q=-1;const $=x.map((re,se)=>re.then(ye=>(Q=se,ye))),ee=await Promise.race($);return x.forEach((re,se)=>{se!==Q&&re.cancel()}),ee}e.raceCancellablePromises=C;function b(x,Q,$){let ee;const re=setTimeout(()=>{ee==null||ee(void 0),$==null||$()},Q);return Promise.race([x.finally(()=>clearTimeout(re)),new Promise(se=>ee=se)])}e.raceTimeout=b;function f(x){return new Promise((Q,$)=>{const ee=x();y(ee)?ee.then(Q,$):Q(ee)})}e.asPromise=f;class i{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const ee=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ee};this.queuedPromise=new Promise(ee=>{this.activePromise.then($,$).then(ee)})}return new Promise(($,ee)=>{this.queuedPromise.then($,ee)})}return this.activePromise=Q(),new Promise(($,ee)=>{this.activePromise.then(re=>{this.activePromise=null,$(re)},re=>{this.activePromise=null,ee(re)})})}}e.Throttler=i;class s{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=s;class v{constructor(){this.promiseMap=new Map}queue(Q,$){var ee;const se=((ee=this.promiseMap.get(Q))!==null&&ee!==void 0?ee:Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(Q)===se&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,se),se}}e.SequencerByKey=v;class h{constructor(Q){this.defaultDelay=Q,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,$=this.defaultDelay){return this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ee,re)=>{this.doResolve=ee,this.doReject=re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ee=this.task;return this.task=null,ee()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},$),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,k.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=h;class E{constructor(Q){this.delayer=new h(Q),this.throttler=new i}trigger(Q,$){return this.delayer.trigger(()=>this.throttler.queue(Q),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class g{constructor(){this._isOpen=!1,this._promise=new Promise((Q,$)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=g;class a extends g{constructor(Q){super();this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function o(x,Q){return Q?new Promise(($,ee)=>{const re=setTimeout($,x);Q.onCancellationRequested(()=>{clearTimeout(re),ee((0,k.canceled)())})}):n($=>o(x,$))}e.timeout=o;function t(x,Q=0){const $=setTimeout(x,Q);return(0,T.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=t;function r(x){return x.then(void 0,Q=>{})}e.ignoreErrors=r;function d(x){const Q=[];let $=0;const ee=x.length;function re(){return $<ee?x[$++]():null}function se(ye){ye!=null&&Q.push(ye);const Ie=re();return Ie?Ie.then(se):Promise.resolve(Q)}return Promise.resolve(null).then(se)}e.sequence=d;function l(x,Q=ee=>!!ee,$=null){let ee=0;const re=x.length,se=()=>{if(ee>=re)return Promise.resolve($);const ye=x[ee++];return Promise.resolve(ye()).then(xe=>Q(xe)?Promise.resolve(xe):se())};return se()}e.first=l;function u(x,Q=ee=>!!ee,$=null){if(x.length===0)return Promise.resolve($);let ee=x.length;const re=()=>{var se,ye;ee=-1;for(const Ie of x)(ye=(se=Ie).cancel)===null||ye===void 0||ye.call(se)};return new Promise((se,ye)=>{for(const Ie of x)Ie.then(xe=>{--ee>=0&&Q(xe)?(re(),se(xe)):ee===0&&se($)}).catch(xe=>{--ee>=0&&(re(),ye(xe))})})}e.firstParallel=u;class m{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Q){return this._size++,new Promise(($,ee)=>{this.outstandingPromises.push({factory:Q,c:$,e:ee}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const $=Q.factory();$.then(Q.c,Q.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=m;class _ extends m{constructor(){super(1)}}e.Queue=_;class D{constructor(){this.queues=new Map}queueFor(Q,$=I.extUri){const ee=$.getComparisonKey(Q);let re=this.queues.get(ee);return re||(re=new _,A.Event.once(re.onFinished)(()=>{re==null||re.dispose(),this.queues.delete(ee)}),this.queues.set(ee,re)),re}dispose(){this.queues.forEach(Q=>Q.dispose()),this.queues.clear()}}e.ResourceQueue=D;class c{constructor(Q,$){this._token=-1,typeof Q=="function"&&typeof $=="number"&&this.setIfNotSet(Q,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},$)}setIfNotSet(Q,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},$))}}e.TimeoutTimer=c;class p{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,$){this.cancel(),this._token=setInterval(()=>{Q()},$)}}e.IntervalTimer=p;class P{constructor(Q,$){this.timeoutToken=-1,this.runner=Q,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class F extends P{constructor(Q,$){super(Q,$);this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner&&this.runner(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const x=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=Q=>{const $=setTimeout(()=>Q(x));let ee=!1;return{dispose(){ee||(ee=!0,clearTimeout($))}}}}else e.runWhenIdle=(x,Q)=>{const $=requestIdleCallback(x,typeof Q=="number"?{timeout:Q}:void 0);let ee=!1;return{dispose(){ee||(ee=!0,cancelIdleCallback($))}}}}();class z{constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=z;async function de(x,Q,$){let ee;for(let re=0;re<$;re++)try{return await x()}catch(se){ee=se,await o(Q)}throw ee}e.retry=de;class B{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var Q;(Q=this._pending)===null||Q===void 0||Q.cancel()}setPending(Q,$,ee){return this._pending={taskId:Q,cancel:()=>ee==null?void 0:ee(),promise:$},$.then(()=>this.donePending(Q),()=>this.donePending(Q)),$}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let $,ee;const re=new Promise((se,ye)=>{$=se,ee=ye});this._next={run:Q,promise:re,promiseResolve:$,promiseReject:ee}}return this._next.promise}}e.TaskSequentializer=B;class W{constructor(Q){this.interval=Q,this.lastIncrementTime=0,this.value=0}increment(){const Q=Date.now();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class K{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,$)=>{this.completeCallback=Q,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Q){return new Promise($=>{this.completeCallback(Q),this.resolved=!0,$()})}error(Q){return new Promise($=>{this.errorCallback(Q),this.rejected=!0,$()})}cancel(){new Promise(Q=>{this.errorCallback((0,k.canceled)()),this.rejected=!0,Q()})}}e.DeferredPromise=K;class M extends A.Emitter{async fireAsync(Q,$,ee){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const re of this._listeners)this._asyncDeliveryQueue.push([re,Q]);for(;this._asyncDeliveryQueue.size>0&&!$.isCancellationRequested;){const[re,se]=this._asyncDeliveryQueue.shift(),ye=[],Ie=Object.assign(Object.assign({},se),{waitUntil:xe=>{if(Object.isFrozen(ye))throw new Error("waitUntil can NOT be called asynchronous");ee&&(xe=ee(xe,typeof re=="function"?re:re[0])),ye.push(xe)}});try{typeof re=="function"?re.call(void 0,Ie):re[0].call(re[1],Ie)}catch(xe){(0,k.onUnexpectedError)(xe);continue}Object.freeze(ye),await U.settled(ye).catch(xe=>(0,k.onUnexpectedError)(xe))}}}}e.AsyncEmitter=M;var U;(function(x){async function Q(se){return typeof Promise.allSettled=="function"?$(se):ee(se)}x.allSettled=Q;async function $(se){return Promise.allSettled(se)}async function ee(se){return Promise.all(se.map(ye=>ye.then(Ie=>({status:"fulfilled",value:Ie}),Ie=>({status:"rejected",reason:Ie}))))}async function re(se){let ye;const Ie=await Promise.all(se.map(xe=>xe.then(Fe=>Fe,Fe=>{ye||(ye=Fe)})));if(typeof ye!="undefined")throw ye;return Ie}x.settled=re})(U=e.Promises||(e.Promises={}))}),define(be[110],we([0,1,11,13]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const A=new k.IdleValue(()=>{const a=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:a,collatorIsNumeric:a.resolvedOptions().numeric}}),T=new k.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new k.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(a,o,t=!1){const r=a||"",d=o||"",l=A.value.collator.compare(r,d);return A.value.collatorIsNumeric&&l===0&&r!==d?r<d?-1:1:l}e.compareFileNames=I;function y(a,o){const t=T.value.collator;return a=a||"",o=o||"",s(t,a,o)}e.compareFileNamesDefault=y;function n(a,o,t=!1){t||(a=a&&a.toLowerCase(),o=o&&o.toLowerCase());const[r,d]=f(a),[l,u]=f(o);return r!==l?r<l?-1:1:d===u?0:d<u?-1:1}e.noIntlCompareFileNames=n;function R(a,o){const[t,r]=f(a),[d,l]=f(o);let u=A.value.collator.compare(r,l);if(u===0){if(A.value.collatorIsNumeric&&r!==l)return r<l?-1:1;if(u=A.value.collator.compare(t,d),A.value.collatorIsNumeric&&u===0&&t!==d)return t<d?-1:1}return u}e.compareFileExtensions=R;function C(a,o){a=a||"",o=o||"";const t=i(a),r=i(o),d=T.value.collator,l=S.value.collator;let u;return u=s(l,t,r),u!==0?u:s(d,a,o)}e.compareFileExtensionsDefault=C;const b=/^(.*?)(\.([^.]*))?$/;function f(a,o=!1){const t=a?b.exec(a):[];let r=[t&&t[1]||"",t&&t[3]||""];return o&&(!r[0]&&r[1]||r[0]&&r[0].charAt(0)===".")&&(r=[r[0]+"."+r[1],""]),r}function i(a){const o=a?b.exec(a):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function s(a,o,t){let r=a.compare(o,t);return r!==0?r:o.length!==t.length?o.length<t.length?-1:1:0}function v(a,o,t=!1){return t||(a=a&&a.toLowerCase(),o=o&&o.toLowerCase()),a===o?0:a<o?-1:1}function h(a,o,t=!1){const r=a.split(w.sep),d=o.split(w.sep),l=r.length-1,u=d.length-1;let m,_;for(let D=0;;D++){if(m=l===D,_=u===D,m&&_)return I(r[D],d[D],t);if(m)return-1;if(_)return 1;const c=v(r[D],d[D],t);if(c!==0)return c}}e.comparePaths=h;function E(a,o,t){const r=a.toLowerCase(),d=o.toLowerCase(),l=g(a,o,t);if(l)return l;const u=r.endsWith(t),m=d.endsWith(t);if(u!==m)return u?-1:1;const _=I(r,d);return _!==0?_:r.localeCompare(d)}e.compareAnything=E;function g(a,o,t){const r=a.toLowerCase(),d=o.toLowerCase(),l=r.startsWith(t),u=d.startsWith(t);if(l!==u)return l?-1:1;if(l&&u){if(r.length<d.length)return-1;if(r.length>d.length)return 1}return 0}e.compareByPrefix=g}),define(be[28],we([0,1,8,38,11,22,13]),function(ie,e,w,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I;const y="**",n="/",R="[/\\\\]",C="[^/\\\\]",b=/\//g;function f($){switch($){case 0:return"";case 1:return`${C}*?`;default:return`(?:${R}|${C}+${R}|${R}${C}+)*?`}}function i($,ee){if(!$)return[];const re=[];let se=!1,ye=!1,Ie="";for(const xe of $){switch(xe){case ee:if(!se&&!ye){re.push(Ie),Ie="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":ye=!0;break;case"]":ye=!1;break}Ie+=xe}return Ie&&re.push(Ie),re}e.splitGlobAware=i;function s($){if(!$)return"";let ee="";const re=i($,n);if(re.every(se=>se===y))ee=".*";else{let se=!1;re.forEach((ye,Ie)=>{if(ye===y){se||(ee+=f(2),se=!0);return}let xe=!1,Fe="",ze=!1,N="";for(const G of ye){if(G!=="}"&&xe){Fe+=G;continue}if(ze&&(G!=="]"||!N)){let te;G==="-"?te=G:(G==="^"||G==="!")&&!N?te="^":G===n?te="":te=w.escapeRegExpCharacters(G),N+=te;continue}switch(G){case"{":xe=!0;continue;case"[":ze=!0;continue;case"}":ee+=`(?:${i(Fe,",").map(me=>s(me)).join("|")})`,xe=!1,Fe="";break;case"]":ee+="["+N+"]",ze=!1,N="";break;case"?":ee+=C;continue;case"*":ee+=f(1);continue;default:ee+=w.escapeRegExpCharacters(G)}}Ie<re.length-1&&(re[Ie+1]!==y||Ie+2<re.length)&&(ee+=R),se=!1})}return ee}const v=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),r=function(){return!1},d=function(){return null};function l($,ee){if(!$)return d;let re;typeof $!="string"?re=$.pattern:re=$,re=re.trim();const se=`${re}_${!!ee.trimForExclusions}`;let ye=t.get(se);if(ye)return u(ye,$);let Ie;if(v.test(re)){const xe=re.substr(4);ye=function(Fe,ze){return typeof Fe=="string"&&Fe.endsWith(xe)?re:null}}else(Ie=h.exec(m(re,ee)))?ye=_(Ie[1],re):(ee.trimForExclusions?g:E).test(re)?ye=D(re,ee):(Ie=a.exec(m(re,ee)))?ye=c(Ie[1].substr(1),re,!0):(Ie=o.exec(m(re,ee)))?ye=c(Ie[1],re,!1):ye=p(re);return t.set(se,ye),u(ye,$)}function u($,ee){return typeof ee=="string"?$:function(re,se){return k.isEqualOrParent(re,ee.base)?$(A.relative(ee.base,re),se):null}}function m($,ee){return ee.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function _($,ee){const re=`/${$}`,se=`\\${$}`,ye=function(xe,Fe){return typeof xe!="string"?null:Fe?Fe===$?ee:null:xe===$||xe.endsWith(re)||xe.endsWith(se)?ee:null},Ie=[$];return ye.basenames=Ie,ye.patterns=[ee],ye.allBasenames=Ie,ye}function D($,ee){const re=Q($.slice(1,-1).split(",").map(Fe=>l(Fe,ee)).filter(Fe=>Fe!==d),$),se=re.length;if(!se)return d;if(se===1)return re[0];const ye=function(Fe,ze){for(let N=0,G=re.length;N<G;N++)if(re[N](Fe,ze))return $;return null},Ie=re.find(Fe=>!!Fe.allBasenames);Ie&&(ye.allBasenames=Ie.allBasenames);const xe=re.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return xe.length&&(ye.allPaths=xe),ye}function c($,ee,re){const se=A.sep===A.posix.sep,ye=se?$:$.replace(b,A.sep),Ie=A.sep+ye,xe=A.posix.sep+$,Fe=re?function(ze,N){return typeof ze=="string"&&(ze===ye||ze.endsWith(Ie)||!se&&(ze===$||ze.endsWith(xe)))?ee:null}:function(ze,N){return typeof ze=="string"&&(ze===ye||!se&&ze===$)?ee:null};return Fe.allPaths=[(re?"*/":"./")+$],Fe}function p($){try{const ee=new RegExp(`^${s($)}$`);return function(re){return ee.lastIndex=0,typeof re=="string"&&ee.test(re)?$:null}}catch(ee){return d}}function P($,ee,re){return!$||typeof ee!="string"?!1:F($)(ee,void 0,re)}e.match=P;function F($,ee={}){if(!$)return r;if(typeof $=="string"||W($)){const re=l($,ee);if(re===d)return r;const se=function(ye,Ie){return!!re(ye,Ie)};return re.allBasenames&&(se.allBasenames=re.allBasenames),re.allPaths&&(se.allPaths=re.allPaths),se}return U($,ee)}e.parse=F;function z($){if(!!$){let ee;return re=>(ee||(ee=($()||Promise.resolve([])).then(se=>se?B(se):{})),ee.then(se=>!!se[re]))}}e.hasSiblingPromiseFn=z;function de($){if(!!$){let ee;return re=>{if(!ee){const se=$();ee=se?B(se):{}}return!!ee[re]}}}e.hasSiblingFn=de;function B($){const ee={};for(const re of $)ee[re]=!0;return ee}function W($){const ee=$;return ee&&typeof ee.base=="string"&&typeof ee.pattern=="string"}e.isRelativePattern=W;function K($){return $.allBasenames||[]}e.getBasenameTerms=K;function M($){return $.allPaths||[]}e.getPathTerms=M;function U($,ee){const re=Q(Object.getOwnPropertyNames($).map(Fe=>x(Fe,$[Fe],ee)).filter(Fe=>Fe!==d)),se=re.length;if(!se)return d;if(!re.some(Fe=>!!Fe.requiresSiblings)){if(se===1)return re[0];const Fe=function(G,te){for(let ae=0,me=re.length;ae<me;ae++){const Se=re[ae](G,te);if(Se)return Se}return null},ze=re.find(G=>!!G.allBasenames);ze&&(Fe.allBasenames=ze.allBasenames);const N=re.reduce((G,te)=>te.allPaths?G.concat(te.allPaths):G,[]);return N.length&&(Fe.allPaths=N),Fe}const ye=function(Fe,ze,N){let G;for(let te=0,ae=re.length;te<ae;te++){const me=re[te];me.requiresSiblings&&N&&(ze||(ze=A.basename(Fe)),G||(G=ze.substr(0,ze.length-A.extname(Fe).length)));const Se=me(Fe,ze,G,N);if(Se)return Se}return null},Ie=re.find(Fe=>!!Fe.allBasenames);Ie&&(ye.allBasenames=Ie.allBasenames);const xe=re.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return xe.length&&(ye.allPaths=xe),ye}function x($,ee,re){if(ee===!1)return d;const se=l($,re);if(se===d)return d;if(typeof ee=="boolean")return se;if(ee){const ye=ee.when;if(typeof ye=="string"){const Ie=(xe,Fe,ze,N)=>{if(!N||!se(xe,Fe))return null;const G=ye.replace("$(basename)",ze),te=N(G);return(0,S.isThenable)(te)?te.then(ae=>ae?$:null):te?$:null};return Ie.requiresSiblings=!0,Ie}}return se}function Q($,ee){const re=$.filter(Fe=>!!Fe.basenames);if(re.length<2)return $;const se=re.reduce((Fe,ze)=>{const N=ze.basenames;return N?Fe.concat(N):Fe},[]);let ye;if(ee){ye=[];for(let Fe=0,ze=se.length;Fe<ze;Fe++)ye.push(ee)}else ye=re.reduce((Fe,ze)=>{const N=ze.patterns;return N?Fe.concat(N):Fe},[]);const Ie=function(Fe,ze){if(typeof Fe!="string")return null;if(!ze){let G;for(G=Fe.length;G>0;G--){const te=Fe.charCodeAt(G-1);if(te===47||te===92)break}ze=Fe.substr(G)}const N=se.indexOf(ze);return N!==-1?ye[N]:null};Ie.basenames=se,Ie.patterns=ye,Ie.allBasenames=se;const xe=$.filter(Fe=>!Fe.basenames);return xe.push(Ie),xe}}),define(be[58],we([0,1,2,11,8,18,21,25,38]),function(ie,e,w,k,A,T,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(l,u,m){if(typeof l=="string"&&(l=w.URI.file(l)),m){const D=m.getWorkspaceFolder(l);if(D){const c=m.getWorkspace().folders.length>1;let p;if((0,I.isEqual)(D.uri,l)?p="":p=(0,I.relativePath)(D.uri,l),c){const P=D.name?D.name:(0,I.basename)(D.uri);p=p?P+" \u2022 "+p:P}return p}}if(l.scheme!==T.Schemas.file&&l.scheme!==T.Schemas.untitled)return l.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(l.fsPath))return(0,k.normalize)(C(l.fsPath));let _=(0,k.normalize)(l.fsPath);return!S.isWindows&&(u==null?void 0:u.userHome)&&(_=f(_,u.userHome.fsPath)),_}e.getPathLabel=n;function R(l){if(!!l){typeof l=="string"&&(l=w.URI.file(l));const u=(0,I.basename)(l)||(l.scheme===T.Schemas.file?l.fsPath:l.path);return S.isWindows&&(0,y.isRootOrDriveLetter)(u)?C(u):u}}e.getBaseLabel=R;function C(l){return(0,y.hasDriveLetter)(l)?l.charAt(0).toUpperCase()+l.slice(1):l}e.normalizeDriveLetter=C;let b=Object.create(null);function f(l,u){if(S.isWindows||!l||!u)return l;let m=b.original===u?b.normalized:void 0;return m||(m=`${(0,A.rtrim)(u,k.posix.sep)}${k.posix.sep}`,b={original:u,normalized:m}),(S.isLinux?l.startsWith(m):(0,A.startsWithIgnoreCase)(l,m))&&(l=`~/${l.substr(m.length)}`),l}e.tildify=f;function i(l,u){return l.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=i;const s="\u2026",v="\\\\",h="~";function E(l,u=k.sep){const m=new Array(l.length);let _=!1;for(let D=0;D<l.length;D++){let c=l[D];if(c===""){m[D]=`.${u}`;continue}if(!c){m[D]=c;continue}_=!0;let p="";c.indexOf(v)===0?(p=c.substr(0,c.indexOf(v)+v.length),c=c.substr(c.indexOf(v)+v.length)):c.indexOf(u)===0?(p=c.substr(0,c.indexOf(u)+u.length),c=c.substr(c.indexOf(u)+u.length)):c.indexOf(h)===0&&(p=c.substr(0,c.indexOf(h)+h.length),c=c.substr(c.indexOf(h)+h.length));const P=c.split(u);for(let F=1;_&&F<=P.length;F++)for(let z=P.length-F;_&&z>=0;z--){_=!1;let de=P.slice(z,z+F).join(u);for(let B=0;!_&&B<l.length;B++)if(B!==D&&l[B]&&l[B].indexOf(de)>-1){const W=z+F===P.length,K=z>0&&l[B].indexOf(u)>-1?u+de:de,M=l[B].endsWith(K);_=!W||M}if(!_){let B="";(P[0].endsWith(":")||p!=="")&&(z===1&&(z=0,F++,de=P[0]+u+de),z>0&&(B=P[0]+u),B=p+B),z>0&&(B=B+s+u),B=B+de,z+F<P.length&&(B=B+u+s),m[D]=B}}_&&(m[D]=c)}return m}e.shorten=E;var g;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function a(l,u=Object.create(null)){const m=[];let _=!1,D="";for(const c of l)if(c==="$"||_&&c==="{")D&&m.push({value:D,type:g.TEXT}),D="",_=!0;else if(c==="}"&&_){const p=u[D];if(typeof p=="string")p.length&&m.push({value:p,type:g.VARIABLE});else if(p){const P=m[m.length-1];(!P||P.type!==g.SEPARATOR)&&m.push({value:p.label,type:g.SEPARATOR})}D="",_=!1}else D+=c;return D&&!_&&m.push({value:D,type:g.TEXT}),m.filter((c,p)=>{if(c.type===g.SEPARATOR){const P=m[p-1],F=m[p+1];return[P,F].every(z=>z&&(z.type===g.VARIABLE||z.type===g.TEXT)&&z.value.length>0)}return!0}).map(c=>c.value).join("")}e.template=a;function o(l,u){return S.isMacintosh||u?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.isMacintosh?"&":"&&"):l.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=o;function t(l,u){return S.isMacintosh||u?l.replace(/\(&&\w\)|&&/g,""):S.isWindows?l.replace(/&&|&/g,m=>m==="&"?"&&":"&"):l.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(l){return l.replace(/&/g,"&&")}e.unmnemonicLabel=r;function d(l){const u=l.indexOf("/")!==-1?k.posix:k.win32,m=u.basename(l),_=u.dirname(l);return m.length?{name:m,parentPath:_}:{name:_,parentPath:""}}e.splitName=d}),define(be[111],we([0,1,2]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(R){return R.toJSON()}class A{constructor(C){this._uriTransformer=C}transformIncoming(C){const b=this._uriTransformer.transformIncoming(C);return b===C?C:k(w.URI.from(b))}transformOutgoing(C){const b=this._uriTransformer.transformOutgoing(C);return b===C?C:k(w.URI.from(b))}transformOutgoingURI(C){const b=this._uriTransformer.transformOutgoing(C);return b===C?C:w.URI.from(b)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function T(R,C,b){if(!R||b>200)return null;if(typeof R=="object"){if(R instanceof w.URI)return C.transformOutgoing(R);for(let f in R)if(Object.hasOwnProperty.call(R,f)){const i=T(R[f],C,b+1);i!==null&&(R[f]=i)}}return null}function S(R,C){const b=T(R,C,0);return b===null?R:b}e.transformOutgoingURIs=S;function I(R,C,b,f){if(!R||f>200)return null;if(typeof R=="object"){if(R.$mid===1)return b?w.URI.revive(C.transformIncoming(R)):C.transformIncoming(R);for(let i in R)if(Object.hasOwnProperty.call(R,i)){const s=I(R[i],C,b,f+1);s!==null&&(R[i]=s)}}return null}function y(R,C){const b=I(R,C,!1,0);return b===null?R:b}e.transformIncomingURIs=y;function n(R,C){const b=I(R,C,!0,0);return b===null?R:b}e.transformAndReviveIncomingURIs=n}),define(be[29],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(y){return w.test(y)}e.isUUID=k;const A=new Uint8Array(16),T=[];for(let y=0;y<256;y++)T.push(y.toString(16).padStart(2,"0"));let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(y){for(let n=0;n<y.length;n++)y[n]=Math.floor(Math.random()*256);return y};function I(){S(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let y=0,n="";return n+=T[A[y++]],n+=T[A[y++]],n+=T[A[y++]],n+=T[A[y++]],n+="-",n+=T[A[y++]],n+=T[A[y++]],n+="-",n+=T[A[y++]],n+=T[A[y++]],n+="-",n+=T[A[y++]],n+=T[A[y++]],n+="-",n+=T[A[y++]],n+=T[A[y++]],n+=T[A[y++]],n+=T[A[y++]],n+=T[A[y++]],n+=T[A[y++]],n}e.generateUuid=I}),define(be[81],we([0,1,79]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class k{constructor(I){let y=(0,w.toUint8)(I);this._defaultValue=y,this._asciiMap=k._createAsciiMap(y),this._map=new Map}static _createAsciiMap(I){let y=new Uint8Array(256);for(let n=0;n<256;n++)y[n]=I;return y}set(I,y){let n=(0,w.toUint8)(y);I>=0&&I<256?this._asciiMap[I]=n:this._map.set(I,n)}get(I){return I>=0&&I<256?this._asciiMap[I]:this._map.get(I)||this._defaultValue}}e.CharacterClassifier=k;var A;(function(S){S[S.False=0]="False",S[S.True=1]="True"})(A||(A={}));class T{constructor(){this._actual=new k(0)}add(I){this._actual.set(I,1)}has(I){return this._actual.get(I)===1}}e.CharacterSet=T}),define(be[112],we([0,1,81]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var k;(function(S){S[S.Regular=0]="Regular",S[S.Whitespace=1]="Whitespace",S[S.WordSeparator=2]="WordSeparator"})(k=e.WordCharacterClass||(e.WordCharacterClass={}));class A extends w.CharacterClassifier{constructor(I){super(0);for(let y=0,n=I.length;y<n;y++)this.set(I.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=A;function T(S){let I={};return y=>(I.hasOwnProperty(y)||(I[y]=S(y)),I[y])}e.getMapForWordSeparators=T(S=>new A(S))}),define(be[39],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class w{constructor(A,T){this.lineNumber=A,this.column=T}with(A=this.lineNumber,T=this.column){return A===this.lineNumber&&T===this.column?this:new w(A,T)}delta(A=0,T=0){return this.with(this.lineNumber+A,this.column+T)}equals(A){return w.equals(this,A)}static equals(A,T){return!A&&!T?!0:!!A&&!!T&&A.lineNumber===T.lineNumber&&A.column===T.column}isBefore(A){return w.isBefore(this,A)}static isBefore(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<T.column}isBeforeOrEqual(A){return w.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<=T.column}static compare(A,T){let S=A.lineNumber|0,I=T.lineNumber|0;if(S===I){let y=A.column|0,n=T.column|0;return y-n}return S-I}clone(){return new w(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new w(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}}e.Position=w}),define(be[33],we([0,1,39]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class k{constructor(T,S,I,y){T>I||T===I&&S>y?(this.startLineNumber=I,this.startColumn=y,this.endLineNumber=T,this.endColumn=S):(this.startLineNumber=T,this.startColumn=S,this.endLineNumber=I,this.endColumn=y)}isEmpty(){return k.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return k.containsPosition(this,T)}static containsPosition(T,S){return!(S.lineNumber<T.startLineNumber||S.lineNumber>T.endLineNumber||S.lineNumber===T.startLineNumber&&S.column<T.startColumn||S.lineNumber===T.endLineNumber&&S.column>T.endColumn)}containsRange(T){return k.containsRange(this,T)}static containsRange(T,S){return!(S.startLineNumber<T.startLineNumber||S.endLineNumber<T.startLineNumber||S.startLineNumber>T.endLineNumber||S.endLineNumber>T.endLineNumber||S.startLineNumber===T.startLineNumber&&S.startColumn<T.startColumn||S.endLineNumber===T.endLineNumber&&S.endColumn>T.endColumn)}strictContainsRange(T){return k.strictContainsRange(this,T)}static strictContainsRange(T,S){return!(S.startLineNumber<T.startLineNumber||S.endLineNumber<T.startLineNumber||S.startLineNumber>T.endLineNumber||S.endLineNumber>T.endLineNumber||S.startLineNumber===T.startLineNumber&&S.startColumn<=T.startColumn||S.endLineNumber===T.endLineNumber&&S.endColumn>=T.endColumn)}plusRange(T){return k.plusRange(this,T)}static plusRange(T,S){let I,y,n,R;return S.startLineNumber<T.startLineNumber?(I=S.startLineNumber,y=S.startColumn):S.startLineNumber===T.startLineNumber?(I=S.startLineNumber,y=Math.min(S.startColumn,T.startColumn)):(I=T.startLineNumber,y=T.startColumn),S.endLineNumber>T.endLineNumber?(n=S.endLineNumber,R=S.endColumn):S.endLineNumber===T.endLineNumber?(n=S.endLineNumber,R=Math.max(S.endColumn,T.endColumn)):(n=T.endLineNumber,R=T.endColumn),new k(I,y,n,R)}intersectRanges(T){return k.intersectRanges(this,T)}static intersectRanges(T,S){let I=T.startLineNumber,y=T.startColumn,n=T.endLineNumber,R=T.endColumn,C=S.startLineNumber,b=S.startColumn,f=S.endLineNumber,i=S.endColumn;return I<C?(I=C,y=b):I===C&&(y=Math.max(y,b)),n>f?(n=f,R=i):n===f&&(R=Math.min(R,i)),I>n||I===n&&y>R?null:new k(I,y,n,R)}equalsRange(T){return k.equalsRange(this,T)}static equalsRange(T,S){return!!T&&!!S&&T.startLineNumber===S.startLineNumber&&T.startColumn===S.startColumn&&T.endLineNumber===S.endLineNumber&&T.endColumn===S.endColumn}getEndPosition(){return k.getEndPosition(this)}static getEndPosition(T){return new w.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return k.getStartPosition(this)}static getStartPosition(T){return new w.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,S){return new k(this.startLineNumber,this.startColumn,T,S)}setStartPosition(T,S){return new k(T,S,this.endLineNumber,this.endColumn)}collapseToStart(){return k.collapseToStart(this)}static collapseToStart(T){return new k(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,S=T){return new k(T.lineNumber,T.column,S.lineNumber,S.column)}static lift(T){return T?new k(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,S){return!(T.endLineNumber<S.startLineNumber||T.endLineNumber===S.startLineNumber&&T.endColumn<S.startColumn||S.endLineNumber<T.startLineNumber||S.endLineNumber===T.startLineNumber&&S.endColumn<T.startColumn)}static areIntersecting(T,S){return!(T.endLineNumber<S.startLineNumber||T.endLineNumber===S.startLineNumber&&T.endColumn<=S.startColumn||S.endLineNumber<T.startLineNumber||S.endLineNumber===T.startLineNumber&&S.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,S){if(T&&S){const n=T.startLineNumber|0,R=S.startLineNumber|0;if(n===R){const C=T.startColumn|0,b=S.startColumn|0;if(C===b){const f=T.endLineNumber|0,i=S.endLineNumber|0;if(f===i){const s=T.endColumn|0,v=S.endColumn|0;return s-v}return f-i}return C-b}return n-R}return(T?1:0)-(S?1:0)}static compareRangesUsingEnds(T,S){return T.endLineNumber===S.endLineNumber?T.endColumn===S.endColumn?T.startLineNumber===S.startLineNumber?T.startColumn-S.startColumn:T.startLineNumber-S.startLineNumber:T.endColumn-S.endColumn:T.endLineNumber-S.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=k}),define(be[113],we([0,1,39,33]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var A;(function(S){S[S.LTR=0]="LTR",S[S.RTL=1]="RTL"})(A=e.SelectionDirection||(e.SelectionDirection={}));class T extends k.Range{constructor(I,y,n,R){super(I,y,n,R);this.selectionStartLineNumber=I,this.selectionStartColumn=y,this.positionLineNumber=n,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(I){return T.selectionsEqual(this,I)}static selectionsEqual(I,y){return I.selectionStartLineNumber===y.selectionStartLineNumber&&I.selectionStartColumn===y.selectionStartColumn&&I.positionLineNumber===y.positionLineNumber&&I.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(I,y){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,I,y):new T(I,y,this.startLineNumber,this.startColumn)}getPosition(){return new w.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(I,y){return this.getDirection()===0?new T(I,y,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,I,y)}static fromPositions(I,y=I){return new T(I.lineNumber,I.column,y.lineNumber,y.column)}static liftSelection(I){return new T(I.selectionStartLineNumber,I.selectionStartColumn,I.positionLineNumber,I.positionColumn)}static selectionsArrEqual(I,y){if(I&&!y||!I&&y)return!1;if(!I&&!y)return!0;if(I.length!==y.length)return!1;for(let n=0,R=I.length;n<R;n++)if(!this.selectionsEqual(I[n],y[n]))return!1;return!0}static isISelection(I){return I&&typeof I.selectionStartLineNumber=="number"&&typeof I.selectionStartColumn=="number"&&typeof I.positionLineNumber=="number"&&typeof I.positionColumn=="number"}static createWithDirection(I,y,n,R,C){return C===0?new T(I,y,n,R):new T(n,R,I,y)}}e.Selection=T}),define(be[82],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var w;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(w=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{constructor(i){this.tabSize=Math.max(1,i.tabSize|0),this.indentSize=i.tabSize|0,this.insertSpaces=Boolean(i.insertSpaces),this.defaultEOL=i.defaultEOL|0,this.trimAutoWhitespace=Boolean(i.trimAutoWhitespace)}equals(i){return this.tabSize===i.tabSize&&this.indentSize===i.indentSize&&this.insertSpaces===i.insertSpaces&&this.defaultEOL===i.defaultEOL&&this.trimAutoWhitespace===i.trimAutoWhitespace}createChangeEvent(i){return{tabSize:this.tabSize!==i.tabSize,indentSize:this.indentSize!==i.indentSize,insertSpaces:this.insertSpaces!==i.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==i.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class y{constructor(i,s){this.range=i,this.matches=s}}e.FindMatch=y;var n;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var R;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(R=e.ModelConstants||(e.ModelConstants={}));class C{constructor(i,s,v,h,E,g){this.identifier=i,this.range=s,this.text=v,this.forceMoveMarkers=h,this.isAutoWhitespaceEdit=E,this._isTracked=g}}e.ValidAnnotatedEditOperation=C;class b{constructor(i,s,v){this.reverseEdits=i,this.changes=s,this.trimAutoWhitespaceLineNumbers=v}}e.ApplyEditsResult=b}),define(be[114],we([0,1,8,112,39,33,82]),function(ie,e,w,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class y{constructor(g,a,o,t){this.searchString=g,this.isRegex=a,this.matchCase=o,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let g;this.isRegex?g=n(this.searchString):g=this.searchString.indexOf(`
`)>=0;let a=null;try{a=w.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:g,global:!0,unicode:!0})}catch(t){return null}if(!a)return null;let o=!this.isRegex&&!g;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new R(a,this.wordSeparators?(0,k.getMapForWordSeparators)(this.wordSeparators):null,o?this.searchString:null)}}e.SearchParams=y;function n(E){if(!E||E.length===0)return!1;for(let g=0,a=E.length;g<a;g++)if(E.charCodeAt(g)===92){if(g++,g>=a)break;const t=E.charCodeAt(g);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=n;class R{constructor(g,a,o){this.regex=g,this.wordSeparators=a,this.simpleSearch=o}}e.SearchData=R;function C(E,g,a){if(!a)return new S.FindMatch(E,null);let o=[];for(let t=0,r=g.length;t<r;t++)o[t]=g[t];return new S.FindMatch(E,o)}e.createFindMatch=C;class b{constructor(g){let a=[],o=0;for(let t=0,r=g.length;t<r;t++)g.charCodeAt(t)===10&&(a[o++]=t);this._lineFeedsOffsets=a}findLineFeedCountBeforeOffset(g){const a=this._lineFeedsOffsets;let o=0,t=a.length-1;if(t===-1||g<=a[0])return 0;for(;o<t;){const r=o+((t-o)/2>>0);a[r]>=g?t=r-1:a[r+1]>=g?(o=r,t=r):o=r+1}return o+1}}class f{static findMatches(g,a,o,t,r){const d=a.parseSearchRequest();return d?d.regex.multiline?this._doFindMatchesMultiline(g,o,new h(d.wordSeparators,d.regex),t,r):this._doFindMatchesLineByLine(g,o,d,t,r):[]}static _getMultilineMatchRange(g,a,o,t,r,d){let l,u=0;t?(u=t.findLineFeedCountBeforeOffset(r),l=a+r+u):l=a+r;let m;if(t){let p=t.findLineFeedCountBeforeOffset(r+d.length)-u;m=l+d.length+p}else m=l+d.length;const _=g.getPositionAt(l),D=g.getPositionAt(m);return new T.Range(_.lineNumber,_.column,D.lineNumber,D.column)}static _doFindMatchesMultiline(g,a,o,t,r){const d=g.getOffsetAt(a.getStartPosition()),l=g.getValueInRange(a,1),u=g.getEOL()===`\r
`?new b(l):null,m=[];let _=0,D;for(o.reset(0);D=o.next(l);)if(m[_++]=C(this._getMultilineMatchRange(g,d,l,u,D.index,D[0]),D,t),_>=r)return m;return m}static _doFindMatchesLineByLine(g,a,o,t,r){const d=[];let l=0;if(a.startLineNumber===a.endLineNumber){const m=g.getLineContent(a.startLineNumber).substring(a.startColumn-1,a.endColumn-1);return l=this._findMatchesInLine(o,m,a.startLineNumber,a.startColumn-1,l,d,t,r),d}const u=g.getLineContent(a.startLineNumber).substring(a.startColumn-1);l=this._findMatchesInLine(o,u,a.startLineNumber,a.startColumn-1,l,d,t,r);for(let m=a.startLineNumber+1;m<a.endLineNumber&&l<r;m++)l=this._findMatchesInLine(o,g.getLineContent(m),m,0,l,d,t,r);if(l<r){const m=g.getLineContent(a.endLineNumber).substring(0,a.endColumn-1);l=this._findMatchesInLine(o,m,a.endLineNumber,0,l,d,t,r)}return d}static _findMatchesInLine(g,a,o,t,r,d,l,u){const m=g.wordSeparators;if(!l&&g.simpleSearch){const c=g.simpleSearch,p=c.length,P=a.length;let F=-p;for(;(F=a.indexOf(c,F+p))!==-1;)if((!m||v(m,a,P,F,p))&&(d[r++]=new S.FindMatch(new T.Range(o,F+1+t,o,F+1+p+t),null),r>=u))return r;return r}const _=new h(g.wordSeparators,g.regex);let D;_.reset(0);do if(D=_.next(a),D&&(d[r++]=C(new T.Range(o,D.index+1+t,o,D.index+1+D[0].length+t),D,l),r>=u))return r;while(D);return r}static findNextMatch(g,a,o,t){const r=a.parseSearchRequest();if(!r)return null;const d=new h(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(g,o,d,t):this._doFindNextMatchLineByLine(g,o,d,t)}static _doFindNextMatchMultiline(g,a,o,t){const r=new A.Position(a.lineNumber,1),d=g.getOffsetAt(r),l=g.getLineCount(),u=g.getValueInRange(new T.Range(r.lineNumber,r.column,l,g.getLineMaxColumn(l)),1),m=g.getEOL()===`\r
`?new b(u):null;o.reset(a.column-1);let _=o.next(u);return _?C(this._getMultilineMatchRange(g,d,u,m,_.index,_[0]),_,t):a.lineNumber!==1||a.column!==1?this._doFindNextMatchMultiline(g,new A.Position(1,1),o,t):null}static _doFindNextMatchLineByLine(g,a,o,t){const r=g.getLineCount(),d=a.lineNumber,l=g.getLineContent(d),u=this._findFirstMatchInLine(o,l,d,a.column,t);if(u)return u;for(let m=1;m<=r;m++){const _=(d+m-1)%r,D=g.getLineContent(_+1),c=this._findFirstMatchInLine(o,D,_+1,1,t);if(c)return c}return null}static _findFirstMatchInLine(g,a,o,t,r){g.reset(t-1);const d=g.next(a);return d?C(new T.Range(o,d.index+1,o,d.index+1+d[0].length),d,r):null}static findPreviousMatch(g,a,o,t){const r=a.parseSearchRequest();if(!r)return null;const d=new h(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(g,o,d,t):this._doFindPreviousMatchLineByLine(g,o,d,t)}static _doFindPreviousMatchMultiline(g,a,o,t){const r=this._doFindMatchesMultiline(g,new T.Range(1,1,a.lineNumber,a.column),o,t,10*I);if(r.length>0)return r[r.length-1];const d=g.getLineCount();return a.lineNumber!==d||a.column!==g.getLineMaxColumn(d)?this._doFindPreviousMatchMultiline(g,new A.Position(d,g.getLineMaxColumn(d)),o,t):null}static _doFindPreviousMatchLineByLine(g,a,o,t){const r=g.getLineCount(),d=a.lineNumber,l=g.getLineContent(d).substring(0,a.column-1),u=this._findLastMatchInLine(o,l,d,t);if(u)return u;for(let m=1;m<=r;m++){const _=(r+d-m-1)%r,D=g.getLineContent(_+1),c=this._findLastMatchInLine(o,D,_+1,t);if(c)return c}return null}static _findLastMatchInLine(g,a,o,t){let r=null,d;for(g.reset(0);d=g.next(a);)r=C(new T.Range(o,d.index+1,o,d.index+1+d[0].length),d,t);return r}}e.TextModelSearch=f;function i(E,g,a,o,t){if(o===0)return!0;const r=g.charCodeAt(o-1);if(E.get(r)!==0||r===13||r===10)return!0;if(t>0){const d=g.charCodeAt(o);if(E.get(d)!==0)return!0}return!1}function s(E,g,a,o,t){if(o+t===a)return!0;const r=g.charCodeAt(o+t);if(E.get(r)!==0||r===13||r===10)return!0;if(t>0){const d=g.charCodeAt(o+t-1);if(E.get(d)!==0)return!0}return!1}function v(E,g,a,o,t){return i(E,g,a,o,t)&&s(E,g,a,o,t)}e.isValidMatch=v;class h{constructor(g,a){this._wordSeparators=g,this._searchRegex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(g){this._searchRegex.lastIndex=g,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(g){const a=g.length;let o;do{if(this._prevMatchStartIndex+this._prevMatchLength===a||(o=this._searchRegex.exec(g),!o))return null;const t=o.index,r=o[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){w.getNextCodePoint(g,a,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||v(this._wordSeparators,g,a,t,r))return o}while(o);return null}}e.Searcher=h}),define(be[83],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function w(I=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const n of e.USUAL_WORD_SEPARATORS)I.indexOf(n)>=0||(y+="\\"+n);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=w();function k(I){let y=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)y=I;else{let n="g";I.ignoreCase&&(n+="i"),I.multiline&&(n+="m"),I.unicode&&(n+="u"),y=new RegExp(I.source,n)}return y.lastIndex=0,y}e.ensureValidWordDefinition=k;const A={maxLen:1e3,windowSize:15,timeBudget:150};function T(I,y,n,R,C=A){if(n.length>C.maxLen){let v=I-C.maxLen/2;return v<0?v=0:R+=v,n=n.substring(v,I+C.maxLen/2),T(I,y,n,R,C)}const b=Date.now(),f=I-1-R;let i=-1,s=null;for(let v=1;!(Date.now()-b>=C.timeBudget);v++){const h=f-C.windowSize*v;y.lastIndex=Math.max(0,h);const E=S(y,n,f,i);if(!E&&s||(s=E,h<=0))break;i=h}if(s){let v={word:s[0],startColumn:R+1+s.index,endColumn:R+1+s.index+s[0].length};return y.lastIndex=0,v}return null}e.getWordAtText=T;function S(I,y,n,R){let C;for(;C=I.exec(y);){const b=C.index||0;if(b<=n&&I.lastIndex>=n)return C;if(R>0&&b>R)return null}return null}}),define(be[115],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var w;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(w=e.IndentAction||(e.IndentAction={}));class k{constructor(I){if(this.open=I.open,this.close=I.close,this._standardTokenMask=0,Array.isArray(I.notIn))for(let y=0,n=I.notIn.length;y<n;y++)switch(I.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(I){return(this._standardTokenMask&I)==0}}e.StandardAutoClosingPairConditional=k;class A{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of I)T(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),T(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),T(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),T(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&T(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=A;function T(S,I,y){S.has(I)?S.get(I).push(y):S.set(I,[y])}}),define(be[59],we([0,1,28,11]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function A(T,S,I,y){if(Array.isArray(T)){let n=0;for(const R of T){const C=A(R,S,I,y);if(C===10)return C;C>n&&(n=C)}return n}else{if(typeof T=="string")return y?T==="*"?5:T===I?10:0:0;if(T){const{language:n,pattern:R,scheme:C,hasAccessToAllModels:b}=T;if(!y&&!b)return 0;let f=0;if(C)if(C===S.scheme)f=10;else if(C==="*")f=5;else return 0;if(n)if(n===I)f=10;else if(n==="*")f=Math.max(f,5);else return 0;if(R){let i;if(typeof R=="string"?i=R:i=Object.assign(Object.assign({},R),{base:(0,k.normalize)(R.base)}),i===S.fsPath||(0,w.match)(i,S.fsPath))f=10;else return 0}return f}else return 0}}e.score=A}),define(be[116],we([0,1,81]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var k;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(k=e.State||(e.State={}));class A{constructor(i,s,v){const h=new Uint8Array(i*s);for(let E=0,g=i*s;E<g;E++)h[E]=v;this._data=h,this.rows=i,this.cols=s}get(i,s){return this._data[i*this.cols+s]}set(i,s,v){this._data[i*this.cols+s]=v}}e.Uint8Matrix=A;class T{constructor(i){let s=0,v=0;for(let E=0,g=i.length;E<g;E++){let[a,o,t]=i[E];o>s&&(s=o),a>v&&(v=a),t>v&&(v=t)}s++,v++;let h=new A(v,s,0);for(let E=0,g=i.length;E<g;E++){let[a,o,t]=i[E];h.set(a,o,t)}this._states=h,this._maxCharCode=s}nextState(i,s){return s<0||s>=this._maxCharCode?0:this._states.get(i,s)}}e.StateMachine=T;let S=null;function I(){return S===null&&(S=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),S}var y;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let n=null;function R(){if(n===null){n=new w.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let s=0;s<f.length;s++)n.set(f.charCodeAt(s),1);const i=".,;";for(let s=0;s<i.length;s++)n.set(i.charCodeAt(s),2)}return n}class C{static _createLink(i,s,v,h,E){let g=E-1;do{const a=s.charCodeAt(g);if(i.get(a)!==2)break;g--}while(g>h);if(h>0){const a=s.charCodeAt(h-1),o=s.charCodeAt(g);(a===40&&o===41||a===91&&o===93||a===123&&o===125)&&g--}return{range:{startLineNumber:v,startColumn:h+1,endLineNumber:v,endColumn:g+2},url:s.substring(h,g+1)}}static computeLinks(i,s=I()){const v=R();let h=[];for(let E=1,g=i.getLineCount();E<=g;E++){const a=i.getLineContent(E),o=a.length;let t=0,r=0,d=0,l=1,u=!1,m=!1,_=!1,D=!1;for(;t<o;){let c=!1;const p=a.charCodeAt(t);if(l===13){let P;switch(p){case 40:u=!0,P=0;break;case 41:P=u?0:1;break;case 91:_=!0,m=!0,P=0;break;case 93:_=!1,P=m?0:1;break;case 123:D=!0,P=0;break;case 125:P=D?0:1;break;case 39:P=d===34||d===96?0:1;break;case 34:P=d===39||d===96?0:1;break;case 96:P=d===39||d===34?0:1;break;case 42:P=d===42?1:0;break;case 124:P=d===124?1:0;break;case 32:P=_?0:1;break;default:P=v.get(p)}P===1&&(h.push(C._createLink(v,a,E,r,t)),c=!0)}else if(l===12){let P;p===91?(m=!0,P=0):P=v.get(p),P===1?c=!0:l=13}else l=s.nextState(l,p),l===0&&(c=!0);c&&(l=1,u=!1,m=!1,D=!1,r=t+1,d=p),t++}l===13&&h.push(C._createLink(v,a,E,r,o))}return h}}e.LinkComputer=C;function b(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:C.computeLinks(f)}e.computeLinks=b}),define(be[117],we([0,1,3,6]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class A{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new w.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(S){this._onDidChange.fire({changedLanguages:S,changedColorMap:!1})}register(S,I){return this._map.set(S,I),this.fire([S]),(0,k.toDisposable)(()=>{this._map.get(S)===I&&(this._map.delete(S),this.fire([S]))})}registerPromise(S,I){let y=null,n=!1;return this._promises.set(S,I.then(R=>{this._promises.delete(S),!(n||!R)&&(y=this.register(S,R))})),(0,k.toDisposable)(()=>{n=!0,y&&y.dispose()})}getPromise(S){const I=this.get(S);if(I)return Promise.resolve(I);const y=this._promises.get(S);return y?y.then(n=>this.get(S)):null}get(S){return this._map.get(S)||null}setColorMap(S){this._colorMap=S,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=A}),define(be[84],we([0,1,24,21]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var A;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(A||(A={}));function T(C){for(let b=0,f=C.length;b<f;b+=4){const i=C[b+0],s=C[b+1],v=C[b+2],h=C[b+3];C[b+0]=h,C[b+1]=v,C[b+2]=s,C[b+3]=i}}function S(C){const b=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return k.isLittleEndian()||T(b),w.VSBuffer.wrap(b)}function I(C){const b=C.buffer;if(k.isLittleEndian()||T(b),b.byteOffset%4==0)return new Uint32Array(b.buffer,b.byteOffset,b.length/4);{const f=new Uint8Array(b.byteLength);return f.set(b),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function y(C){const b=new Uint32Array(n(C));let f=0;if(b[f++]=C.id,C.type==="full")b[f++]=1,b[f++]=C.data.length,b.set(C.data,f),f+=C.data.length;else{b[f++]=2,b[f++]=C.deltas.length;for(const i of C.deltas)b[f++]=i.start,b[f++]=i.deleteCount,i.data?(b[f++]=i.data.length,b.set(i.data,f),f+=i.data.length):b[f++]=0}return S(b)}e.encodeSemanticTokensDto=y;function n(C){let b=0;if(b+=1+1,C.type==="full")b+=1+C.data.length;else{b+=1,b+=(1+1+1)*C.deltas.length;for(const f of C.deltas)f.data&&(b+=f.data.length)}return b}function R(C){const b=I(C);let f=0;const i=b[f++];if(b[f++]===1){const E=b[f++],g=b.subarray(f,f+E);return f+=E,{id:i,type:"full",data:g}}const v=b[f++];let h=[];for(let E=0;E<v;E++){const g=b[f++],a=b[f++],o=b[f++];let t;o>0&&(t=b.subarray(f,f+o),f+=o),h[E]={start:g,deleteCount:a,data:t}}return{id:i,type:"delta",deltas:h}}e.decodeSemanticTokensDto=R}),define(be[85],we([0,1,79]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class k{constructor(S,I){this.index=S,this.remainder=I}}e.PrefixSumIndexOfResult=k;class A{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,I){S=(0,w.toUint32)(S);const y=this.values,n=this.prefixSum,R=I.length;return R===0?!1:(this.values=new Uint32Array(y.length+R),this.values.set(y.subarray(0,S),0),this.values.set(y.subarray(S),S+R),this.values.set(I,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(S,I){return S=(0,w.toUint32)(S),I=(0,w.toUint32)(I),this.values[S]===I?!1:(this.values[S]=I,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,I){S=(0,w.toUint32)(S),I=(0,w.toUint32)(I);const y=this.values,n=this.prefixSum;if(S>=y.length)return!1;let R=y.length-S;return I>=R&&(I=R),I===0?!1:(this.values=new Uint32Array(y.length-I),this.values.set(y.subarray(0,S),0),this.values.set(y.subarray(S+I),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(S){return S<0?0:(S=(0,w.toUint32)(S),this._getAccumulatedValue(S))}_getAccumulatedValue(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),S>=this.values.length&&(S=this.values.length-1);for(let y=I;y<=S;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalValue();let I=0,y=this.values.length-1,n=0,R=0,C=0;for(;I<=y;)if(n=I+(y-I)/2|0,R=this.prefixSum[n],C=R-this.values[n],S<C)y=n-1;else if(S>=R)I=n+1;else break;return new k(n,S-C)}}e.PrefixSumComputer=A}),define(be[118],we([0,1,8,39,85]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(I,y,n,R){this._uri=I,this._lines=y,this._eol=n,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(I){I.eol&&I.eol!==this._eol&&(this._eol=I.eol,this._lineStarts=null);const y=I.changes;for(const n of y)this._acceptDeleteRange(n.range),this._acceptInsertText(new k.Position(n.range.startLineNumber,n.range.startColumn),n.text);this._versionId=I.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const I=this._eol.length,y=this._lines.length,n=new Uint32Array(y);for(let R=0;R<y;R++)n[R]=this._lines[R].length+I;this._lineStarts=new A.PrefixSumComputer(n)}}_setLineText(I,y){this._lines[I]=y,this._lineStarts&&this._lineStarts.changeValue(I,this._lines[I].length+this._eol.length)}_acceptDeleteRange(I){if(I.startLineNumber===I.endLineNumber){if(I.startColumn===I.endColumn)return;this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.startLineNumber-1].substring(I.endColumn-1));return}this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.endLineNumber-1].substring(I.endColumn-1)),this._lines.splice(I.startLineNumber,I.endLineNumber-I.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(I.startLineNumber,I.endLineNumber-I.startLineNumber)}_acceptInsertText(I,y){if(y.length!==0){let n=(0,w.splitLines)(y);if(n.length===1){this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+n[0]+this._lines[I.lineNumber-1].substring(I.column-1));return}n[n.length-1]+=this._lines[I.lineNumber-1].substring(I.column-1),this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+n[0]);let R=new Uint32Array(n.length-1);for(let C=1;C<n.length;C++)this._lines.splice(I.lineNumber+C-1,0,n[C]),R[C-1]=n[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(I.lineNumber,R)}}}e.MirrorTextModel=T}),define(be[119],we([16,17]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(be[60],we([0,1,119,12,15]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(n,R){return R&&(n.stack||n.stacktrace)?w.localize(0,null,I(n),S(n.stack)||S(n.stacktrace)):I(n)}function S(n){return Array.isArray(n)?n.join(`
`):n}function I(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?w.localize(1,null,n.message):n.message||w.localize(2,null)}function y(n=null,R=!1){if(!n)return w.localize(3,null);if(Array.isArray(n)){const C=A.coalesce(n),b=y(C[0],R);return C.length>1?w.localize(4,null,b,C.length):b}if(k.isString(n))return n;if(n.detail){const C=n.detail;if(C.error)return T(C.error,R);if(C.exception)return T(C.exception,R)}return n.stack?T(n,R):n.message?n.message:w.localize(5,null)}e.toErrorMessage=y}),define(be[120],we([16,17]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(be[121],we([0,1,120,21,83]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=S;class I{constructor(){this._values=[]}_read(X){return this._values[X]}get(X){return this._values[X]}_write(X,ve){this._values[X]=ve}}e.ValidatedEditorOptions=I;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class n{constructor(X,ve,Me,He){this.id=X,this.name=ve,this.defaultValue=Me,this.schema=He}compute(X,ve,Me){return Me}}class R{constructor(X,ve=null){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(X){return this.defaultValue}}class C{constructor(X,ve,Me,He){this.id=X,this.name=ve,this.defaultValue=Me,this.schema=He}validate(X){return typeof X=="undefined"?this.defaultValue:X}compute(X,ve,Me){return Me}}function b(V,X){return typeof V=="undefined"?X:V==="false"?!1:Boolean(V)}e.boolean=b;class f extends C{constructor(X,ve,Me,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Me),super(X,ve,Me,He)}validate(X){return b(X,this.defaultValue)}}class i extends C{constructor(X,ve,Me,He,Oe,et=void 0){typeof et!="undefined"&&(et.type="integer",et.default=Me,et.minimum=He,et.maximum=Oe),super(X,ve,Me,et),this.minimum=He,this.maximum=Oe}static clampedInt(X,ve,Me,He){if(typeof X=="undefined")return ve;let Oe=parseInt(X,10);return isNaN(Oe)?ve:(Oe=Math.max(Me,Oe),Oe=Math.min(He,Oe),Oe|0)}validate(X){return i.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class s extends C{constructor(X,ve,Me,He,Oe){typeof Oe!="undefined"&&(Oe.type="number",Oe.default=Me),super(X,ve,Me,Oe),this.validationFn=He}static clamp(X,ve,Me){return X<ve?ve:X>Me?Me:X}static float(X,ve){if(typeof X=="number")return X;if(typeof X=="undefined")return ve;const Me=parseFloat(X);return isNaN(Me)?ve:Me}validate(X){return this.validationFn(s.float(X,this.defaultValue))}}class v extends C{static string(X,ve){return typeof X!="string"?ve:X}constructor(X,ve,Me,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Me),super(X,ve,Me,He)}validate(X){return v.string(X,this.defaultValue)}}function h(V,X,ve){return typeof V!="string"||ve.indexOf(V)===-1?X:V}e.stringSet=h;class E extends C{constructor(X,ve,Me,He,Oe=void 0){typeof Oe!="undefined"&&(Oe.type="string",Oe.enum=He,Oe.default=Me),super(X,ve,Me,Oe),this._allowedValues=He}validate(X){return h(X,this.defaultValue,this._allowedValues)}}class g extends n{constructor(X,ve,Me,He,Oe,et,H=void 0){typeof H!="undefined"&&(H.type="string",H.enum=Oe,H.default=He),super(X,ve,Me,H),this._allowedValues=Oe,this._convert=et}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function a(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",description:w.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,ve,Me){return Me===0?X.accessibilitySupport:Me}}class t extends n{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:w.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{insertSpace:b(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:b(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function d(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(l=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function u(V){switch(V){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=u;function m(V){switch(V){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class _ extends R{constructor(){super(123,[62,31])}compute(X,ve,Me){const He=["monaco-editor"];return ve.get(31)&&He.push(ve.get(31)),X.extraEditorClassName&&He.push(X.extraEditorClassName),ve.get(62)==="default"?He.push("mouse-default"):ve.get(62)==="copy"&&He.push("mouse-copy"),ve.get(97)&&He.push("showUnused"),ve.get(121)&&He.push("showDeprecated"),He.join(" ")}}class D extends f{constructor(){super(30,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(X,ve,Me){return Me&&X.emptySelectionClipboard}}class c extends n{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:X.seedSearchStringFromSelection,description:w.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[w.localize(9,null),w.localize(10,null),w.localize(11,null)],description:w.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:w.localize(13,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:w.localize(14,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:w.localize(15,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{cursorMoveOnType:b(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:b(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":h(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:b(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:b(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:b(ve.loop,this.defaultValue.loop)}}}class p extends n{constructor(){super(41,"fontLigatures",p.OFF,{anyOf:[{type:"boolean",description:w.localize(16,null)},{type:"string",description:w.localize(17,null)}],description:w.localize(18,null),default:!1})}validate(X){return typeof X=="undefined"?this.defaultValue:typeof X=="string"?X==="false"?p.OFF:X==="true"?p.ON:X:Boolean(X)?p.ON:p.OFF}}e.EditorFontLigatures=p,p.OFF='"liga" off, "calt" off',p.ON='"liga" on, "calt" on';class P extends R{constructor(){super(40)}compute(X,ve,Me){return X.fontInfo}}class F extends C{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(19,null)})}validate(X){let ve=s.float(X,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(ve,6,100)}compute(X,ve,Me){return X.fontInfo.fontSize}}class z extends n{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:w.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(21,null)})}validate(X){return X==="normal"||X==="bold"?X:String(i.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class de extends n{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[w.localize(22,null),w.localize(23,null),w.localize(24,null)]};super(47,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:w.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:w.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:w.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:w.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:w.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,description:w.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,description:w.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,description:w.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,description:w.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,description:w.localize(35,null)}})}validate(X){var ve,Me,He,Oe,et;if(!X||typeof X!="object")return this.defaultValue;const H=X;return{multiple:h(H.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=H.multipleDefinitions)!==null&&ve!==void 0?ve:h(H.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Me=H.multipleTypeDefinitions)!==null&&Me!==void 0?Me:h(H.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(He=H.multipleDeclarations)!==null&&He!==void 0?He:h(H.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Oe=H.multipleImplementations)!==null&&Oe!==void 0?Oe:h(H.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(et=H.multipleReferences)!==null&&et!==void 0?et:h(H.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(H.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(H.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(H.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(H.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(H.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class B extends n{constructor(){const X={enabled:!0,delay:300,sticky:!0};super(50,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:w.localize(36,null)},"editor.hover.delay":{type:"number",default:X.delay,description:w.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:w.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:b(ve.enabled,this.defaultValue.enabled),delay:i.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:b(ve.sticky,this.defaultValue.sticky)}}}var W;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(W=e.RenderMinimap||(e.RenderMinimap={}));class K extends R{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(X,ve,Me){return K.computeLayout(ve,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const ve=X.height/X.lineHeight,Me=X.scrollBeyondLastLine?ve-1:0,He=(X.viewLineCount+Me)/(X.pixelRatio*X.height),Oe=Math.floor(X.viewLineCount/He);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Me,desiredRatio:He,minimapLineCount:Oe}}static _computeMinimapLayout(X,ve){const Me=X.outerWidth,He=X.outerHeight,Oe=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Oe*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const et=ve.stableMinimapLayoutInput,H=et&&X.outerHeight===et.outerHeight&&X.lineHeight===et.lineHeight&&X.typicalHalfwidthCharacterWidth===et.typicalHalfwidthCharacterWidth&&X.pixelRatio===et.pixelRatio&&X.scrollBeyondLastLine===et.scrollBeyondLastLine&&X.minimap.enabled===et.minimap.enabled&&X.minimap.side===et.minimap.side&&X.minimap.size===et.minimap.size&&X.minimap.showSlider===et.minimap.showSlider&&X.minimap.renderCharacters===et.minimap.renderCharacters&&X.minimap.maxColumn===et.minimap.maxColumn&&X.minimap.scale===et.minimap.scale&&X.verticalScrollbarWidth===et.verticalScrollbarWidth&&X.isViewportWrapping===et.isViewportWrapping,ne=X.lineHeight,he=X.typicalHalfwidthCharacterWidth,q=X.scrollBeyondLastLine,J=X.minimap.renderCharacters;let oe=Oe>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const fe=X.minimap.maxColumn,pe=X.minimap.size,Be=X.minimap.side,Ne=X.verticalScrollbarWidth,Ve=X.viewLineCount,Xe=X.remainingWidth,Ze=X.isViewportWrapping,ct=J?2:3;let ot=Math.floor(Oe*He);const nt=ot/Oe;let ue=!1,De=!1,le=ct*oe,j=oe/Oe,Ae=1;if(pe==="fill"||pe==="fit"){const{typicalViewportLineCount:ut,extraLinesBeyondLastLine:st,desiredRatio:gt,minimapLineCount:wt}=K.computeContainedMinimapLineCount({viewLineCount:Ve,scrollBeyondLastLine:q,height:He,lineHeight:ne,pixelRatio:Oe});if(Ve/wt>1)ue=!0,De=!0,oe=1,le=1,j=oe/Oe;else{let vt=!1,Et=oe+1;if(pe==="fit"){const pt=Math.ceil((Ve+st)*le);Ze&&H&&Xe<=ve.stableFitRemainingWidth?(vt=!0,Et=ve.stableFitMaxMinimapScale):(vt=pt>ot,Ze&&vt?(ve.stableMinimapLayoutInput=X,ve.stableFitRemainingWidth=Xe):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0))}if(pe==="fill"||vt){ue=!0;const pt=oe;le=Math.min(ne*Oe,Math.max(1,Math.floor(1/gt))),oe=Math.min(Et,Math.max(1,Math.floor(le/ct))),oe>pt&&(Ae=Math.min(2,oe/pt)),j=oe/Oe/Ae,ot=Math.ceil(Math.max(ut,Ve+st)*le),Ze&&vt&&(ve.stableFitMaxMinimapScale=oe)}}}const Te=Math.floor(fe*j),Ye=Math.min(Te,Math.max(0,Math.floor((Xe-Ne-2)*j/(he+j)))+e.MINIMAP_GUTTER_WIDTH);let Ge=Math.floor(Oe*Ye);const rt=Ge/Oe;Ge=Math.floor(Ge*Ae);const at=J?1:2,Qe=Be==="left"?0:Me-Ye-Ne;return{renderMinimap:at,minimapLeft:Qe,minimapWidth:Ye,minimapHeightIsEditorHeight:ue,minimapIsSampling:De,minimapScale:oe,minimapLineHeight:le,minimapCanvasInnerWidth:Ge,minimapCanvasInnerHeight:ot,minimapCanvasOuterWidth:rt,minimapCanvasOuterHeight:nt}}static computeLayout(X,ve){const Me=ve.outerWidth|0,He=ve.outerHeight|0,Oe=ve.lineHeight|0,et=ve.lineNumbersDigitCount|0,H=ve.typicalHalfwidthCharacterWidth,ne=ve.maxDigitWidth,he=ve.pixelRatio,q=ve.viewLineCount,J=X.get(118),oe=J==="inherit"?X.get(117):J,fe=oe==="inherit"?X.get(113):oe,pe=X.get(116),Be=X.get(2),Ne=ve.isDominatedByLongLines,Ve=X.get(46),Xe=X.get(56).renderType!==0,Ze=X.get(57),ct=X.get(91),ot=X.get(61),nt=X.get(89),ue=nt.verticalScrollbarSize,De=nt.verticalHasArrows,le=nt.arrowSize,j=nt.horizontalScrollbarSize,Ae=X.get(54),Te=X.get(35);let Ye;if(typeof Ae=="string"&&/^\d+(\.\d+)?ch$/.test(Ae)){const ft=parseFloat(Ae.substr(0,Ae.length-2));Ye=i.clampedInt(ft*H,0,0,1e3)}else Ye=i.clampedInt(Ae,0,0,1e3);Te&&(Ye+=16);let Ge=0;if(Xe){const ft=Math.max(et,Ze);Ge=Math.round(ft*ne)}let rt=0;Ve&&(rt=Oe);let at=0,Qe=at+rt,ut=Qe+Ge,st=ut+Ye;const gt=Me-rt-Ge-Ye;let wt=!1,St=!1,vt=-1;Be!==2&&(oe==="inherit"&&Ne?(wt=!0,St=!0):fe==="on"||fe==="bounded"?St=!0:fe==="wordWrapColumn"&&(vt=pe));const Et=K._computeMinimapLayout({outerWidth:Me,outerHeight:He,lineHeight:Oe,typicalHalfwidthCharacterWidth:H,pixelRatio:he,scrollBeyondLastLine:ct,minimap:ot,verticalScrollbarWidth:ue,viewLineCount:q,remainingWidth:gt,isViewportWrapping:St},ve.memory||new y);Et.renderMinimap!==0&&Et.minimapLeft===0&&(at+=Et.minimapWidth,Qe+=Et.minimapWidth,ut+=Et.minimapWidth,st+=Et.minimapWidth);const pt=gt-Et.minimapWidth,Rt=Math.max(1,Math.floor((pt-ue-2)/H)),Ft=De?le:0;return St&&(vt=Math.max(1,Rt),fe==="bounded"&&(vt=Math.min(vt,pe))),{width:Me,height:He,glyphMarginLeft:at,glyphMarginWidth:rt,lineNumbersLeft:Qe,lineNumbersWidth:Ge,decorationsLeft:ut,decorationsWidth:Ye,contentLeft:st,contentWidth:pt,minimap:Et,viewportColumn:Rt,isWordWrapMinified:wt,isViewportWrapping:St,wrappingColumn:vt,verticalScrollbarWidth:ue,horizontalScrollbarHeight:j,overviewRuler:{top:Ft,width:ue,height:He-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=K;class M extends n{constructor(){const X={enabled:!0};super(53,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:w.localize(39,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:b(X.enabled,this.defaultValue.enabled)}}}class U extends n{constructor(){const X={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",X,{"editor.inlineHints.enabled":{type:"boolean",default:X.enabled,description:w.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:X.fontSize,description:w.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:X.fontFamily,description:w.localize(42,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:b(ve.enabled,this.defaultValue.enabled),fontSize:i.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class x extends i{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:w.localize(43,null)})}compute(X,ve,Me){return X.fontInfo.lineHeight}}class Q extends n{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:w.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(45,null),w.localize(46,null),w.localize(47,null)],default:X.size,description:w.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:w.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:w.localize(50,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:w.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:w.localize(53,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:b(ve.enabled,this.defaultValue.enabled),size:h(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(ve.side,this.defaultValue.side,["right","left"]),showSlider:h(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:b(ve.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(ve.scale,1,1,3),maxColumn:i.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function $(V){return V==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ee extends n{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(55,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{top:i.clampedInt(ve.top,0,0,1e3),bottom:i.clampedInt(ve.bottom,0,0,1e3)}}}class re extends n{constructor(){const X={enabled:!0,cycle:!1};super(72,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:w.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:w.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:b(ve.enabled,this.defaultValue.enabled),cycle:b(ve.cycle,this.defaultValue.cycle)}}}class se extends R{constructor(){super(124)}compute(X,ve,Me){return X.pixelRatio}}class ye extends n{constructor(){const X={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",X,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:X.strings,description:w.localize(58,null)},comments:{type:"boolean",default:X.comments,description:w.localize(59,null)},other:{type:"boolean",default:X.other,description:w.localize(60,null)}}}],default:X,description:w.localize(61,null)});this.defaultValue=X}validate(X){if(typeof X=="boolean")return X;if(X&&typeof X=="object"){const ve=X,Me={other:b(ve.other,this.defaultValue.other),comments:b(ve.comments,this.defaultValue.comments),strings:b(ve.strings,this.defaultValue.strings)};return Me.other&&Me.comments&&Me.strings?!0:!Me.other&&!Me.comments&&!Me.strings?!1:Me}return this.defaultValue}}var Ie;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Ie=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class xe extends n{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(62,null),w.localize(63,null),w.localize(64,null),w.localize(65,null)],default:"on",description:w.localize(66,null)})}validate(X){let ve=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof X!="undefined"&&(typeof X=="function"?(ve=4,Me=X):X==="interval"?ve=3:X==="relative"?ve=2:X==="on"?ve=1:ve=0),{renderType:ve,renderFn:Me}}}function Fe(V){const X=V.get(84);return X==="editable"?V.get(77):X!=="on"}e.filterValidationDecorations=Fe;class ze extends n{constructor(){const X=[],ve={type:"number",description:w.localize(67,null)};super(88,"rulers",X,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:w.localize(68,null),format:"color-hex"}}}]},default:X,description:w.localize(69,null)})}validate(X){if(Array.isArray(X)){let ve=[];for(let Me of X)if(typeof Me=="number")ve.push({column:i.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const He=Me;ve.push({column:i.clampedInt(He.column,0,0,1e4),color:He.color})}return ve.sort((Me,He)=>Me.column-He.column),ve}return this.defaultValue}}function N(V,X){if(typeof V!="string")return X;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class G extends n{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X,Me=i.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=i.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(ve.vertical,this.defaultValue.vertical),horizontal:N(ve.horizontal,this.defaultValue.horizontal),useShadows:b(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:b(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:b(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:b(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:b(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:i.clampedInt(ve.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:He,verticalSliderSize:i.clampedInt(ve.verticalSliderSize,He,0,1e3),scrollByPage:b(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class te extends n{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(70,null),w.localize(71,null)],default:X.insertMode,description:w.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:w.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:w.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:w.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:w.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:w.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:w.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:w.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(109,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{insertMode:h(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:b(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:b(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:b(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:b(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:b(ve.showIcons,this.defaultValue.showIcons),showStatusBar:b(ve.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:b(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:b(ve.showMethods,this.defaultValue.showMethods),showFunctions:b(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:b(ve.showConstructors,this.defaultValue.showConstructors),showFields:b(ve.showFields,this.defaultValue.showFields),showVariables:b(ve.showVariables,this.defaultValue.showVariables),showClasses:b(ve.showClasses,this.defaultValue.showClasses),showStructs:b(ve.showStructs,this.defaultValue.showStructs),showInterfaces:b(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:b(ve.showModules,this.defaultValue.showModules),showProperties:b(ve.showProperties,this.defaultValue.showProperties),showEvents:b(ve.showEvents,this.defaultValue.showEvents),showOperators:b(ve.showOperators,this.defaultValue.showOperators),showUnits:b(ve.showUnits,this.defaultValue.showUnits),showValues:b(ve.showValues,this.defaultValue.showValues),showConstants:b(ve.showConstants,this.defaultValue.showConstants),showEnums:b(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:b(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:b(ve.showKeywords,this.defaultValue.showKeywords),showWords:b(ve.showWords,this.defaultValue.showWords),showColors:b(ve.showColors,this.defaultValue.showColors),showFiles:b(ve.showFiles,this.defaultValue.showFiles),showReferences:b(ve.showReferences,this.defaultValue.showReferences),showFolders:b(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:b(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:b(ve.showSnippets,this.defaultValue.showSnippets),showUsers:b(ve.showUsers,this.defaultValue.showUsers),showIssues:b(ve.showIssues,this.defaultValue.showIssues)}}}class ae extends n{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(110,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:b(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class me extends R{constructor(){super(125,[77])}compute(X,ve,Me){return ve.get(77)?!0:X.tabFocusMode}}var Se;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(Se=e.WrappingIndent||(e.WrappingIndent={}));function Le(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends R{constructor(){super(127,[126])}compute(X,ve,Me){const He=ve.get(126);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Pe="Menlo, Monaco, 'Courier New', monospace",$e="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?Pe:k.isLinux?$e:Ce,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function _e(V){return e.editorOptionsRegistry[V.id]=V,V}var qe;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.codeLens=12]="codeLens",V[V.codeLensFontFamily=13]="codeLensFontFamily",V[V.codeLensFontSize=14]="codeLensFontSize",V[V.colorDecorators=15]="colorDecorators",V[V.columnSelection=16]="columnSelection",V[V.comments=17]="comments",V[V.contextmenu=18]="contextmenu",V[V.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",V[V.cursorBlinking=20]="cursorBlinking",V[V.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",V[V.cursorStyle=22]="cursorStyle",V[V.cursorSurroundingLines=23]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",V[V.cursorWidth=25]="cursorWidth",V[V.disableLayerHinting=26]="disableLayerHinting",V[V.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",V[V.domReadOnly=28]="domReadOnly",V[V.dragAndDrop=29]="dragAndDrop",V[V.emptySelectionClipboard=30]="emptySelectionClipboard",V[V.extraEditorClassName=31]="extraEditorClassName",V[V.fastScrollSensitivity=32]="fastScrollSensitivity",V[V.find=33]="find",V[V.fixedOverflowWidgets=34]="fixedOverflowWidgets",V[V.folding=35]="folding",V[V.foldingStrategy=36]="foldingStrategy",V[V.foldingHighlight=37]="foldingHighlight",V[V.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=39]="fontFamily",V[V.fontInfo=40]="fontInfo",V[V.fontLigatures=41]="fontLigatures",V[V.fontSize=42]="fontSize",V[V.fontWeight=43]="fontWeight",V[V.formatOnPaste=44]="formatOnPaste",V[V.formatOnType=45]="formatOnType",V[V.glyphMargin=46]="glyphMargin",V[V.gotoLocation=47]="gotoLocation",V[V.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",V[V.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",V[V.hover=50]="hover",V[V.inDiffEditor=51]="inDiffEditor",V[V.letterSpacing=52]="letterSpacing",V[V.lightbulb=53]="lightbulb",V[V.lineDecorationsWidth=54]="lineDecorationsWidth",V[V.lineHeight=55]="lineHeight",V[V.lineNumbers=56]="lineNumbers",V[V.lineNumbersMinChars=57]="lineNumbersMinChars",V[V.linkedEditing=58]="linkedEditing",V[V.links=59]="links",V[V.matchBrackets=60]="matchBrackets",V[V.minimap=61]="minimap",V[V.mouseStyle=62]="mouseStyle",V[V.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=64]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",V[V.multiCursorModifier=66]="multiCursorModifier",V[V.multiCursorPaste=67]="multiCursorPaste",V[V.occurrencesHighlight=68]="occurrencesHighlight",V[V.overviewRulerBorder=69]="overviewRulerBorder",V[V.overviewRulerLanes=70]="overviewRulerLanes",V[V.padding=71]="padding",V[V.parameterHints=72]="parameterHints",V[V.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",V[V.quickSuggestions=75]="quickSuggestions",V[V.quickSuggestionsDelay=76]="quickSuggestionsDelay",V[V.readOnly=77]="readOnly",V[V.renameOnType=78]="renameOnType",V[V.renderControlCharacters=79]="renderControlCharacters",V[V.renderIndentGuides=80]="renderIndentGuides",V[V.renderFinalNewline=81]="renderFinalNewline",V[V.renderLineHighlight=82]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=84]="renderValidationDecorations",V[V.renderWhitespace=85]="renderWhitespace",V[V.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",V[V.roundedSelection=87]="roundedSelection",V[V.rulers=88]="rulers",V[V.scrollbar=89]="scrollbar",V[V.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=91]="scrollBeyondLastLine",V[V.scrollPredominantAxis=92]="scrollPredominantAxis",V[V.selectionClipboard=93]="selectionClipboard",V[V.selectionHighlight=94]="selectionHighlight",V[V.selectOnLineNumbers=95]="selectOnLineNumbers",V[V.showFoldingControls=96]="showFoldingControls",V[V.showUnused=97]="showUnused",V[V.snippetSuggestions=98]="snippetSuggestions",V[V.smartSelect=99]="smartSelect",V[V.smoothScrolling=100]="smoothScrolling",V[V.stickyTabStops=101]="stickyTabStops",V[V.stopRenderingLineAfter=102]="stopRenderingLineAfter",V[V.suggest=103]="suggest",V[V.suggestFontSize=104]="suggestFontSize",V[V.suggestLineHeight=105]="suggestLineHeight",V[V.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",V[V.suggestSelection=107]="suggestSelection",V[V.tabCompletion=108]="tabCompletion",V[V.tabIndex=109]="tabIndex",V[V.unusualLineTerminators=110]="unusualLineTerminators",V[V.useTabStops=111]="useTabStops",V[V.wordSeparators=112]="wordSeparators",V[V.wordWrap=113]="wordWrap",V[V.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=116]="wordWrapColumn",V[V.wordWrapOverride1=117]="wordWrapOverride1",V[V.wordWrapOverride2=118]="wordWrapOverride2",V[V.wrappingIndent=119]="wrappingIndent",V[V.wrappingStrategy=120]="wrappingStrategy",V[V.showDeprecated=121]="showDeprecated",V[V.inlineHints=122]="inlineHints",V[V.editorClassName=123]="editorClassName",V[V.pixelRatio=124]="pixelRatio",V[V.tabFocusMode=125]="tabFocusMode",V[V.layoutInfo=126]="layoutInfo",V[V.wrappingInfo=127]="wrappingInfo"})(qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(111,null)})),acceptSuggestionOnEnter:_e(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(112,null),""],markdownDescription:w.localize(113,null)})),accessibilitySupport:_e(new o),accessibilityPageSize:_e(new i(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(114,null),deprecationMessage:w.localize(115,null)})),ariaLabel:_e(new v(4,"ariaLabel",w.localize(116,null))),autoClosingBrackets:_e(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(117,null),w.localize(118,null),""],description:w.localize(119,null)})),autoClosingDelete:_e(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(120,null),""],description:w.localize(121,null)})),autoClosingOvertype:_e(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(122,null),""],description:w.localize(123,null)})),autoClosingQuotes:_e(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(124,null),w.localize(125,null),""],description:w.localize(126,null)})),autoIndent:_e(new g(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[w.localize(127,null),w.localize(128,null),w.localize(129,null),w.localize(130,null),w.localize(131,null)],description:w.localize(132,null)})),automaticLayout:_e(new f(10,"automaticLayout",!1)),autoSurround:_e(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(133,null),w.localize(134,null),w.localize(135,null),""],description:w.localize(136,null)})),stickyTabStops:_e(new f(101,"stickyTabStops",!1,{description:w.localize(137,null)})),codeLens:_e(new f(12,"codeLens",!0,{description:w.localize(138,null)})),codeLensFontFamily:_e(new v(13,"codeLensFontFamily","",{description:w.localize(139,null)})),codeLensFontSize:_e(new i(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:w.localize(140,null)})),colorDecorators:_e(new f(15,"colorDecorators",!0,{description:w.localize(141,null)})),columnSelection:_e(new f(16,"columnSelection",!1,{description:w.localize(142,null)})),comments:_e(new t),contextmenu:_e(new f(18,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new f(19,"copyWithSyntaxHighlighting",!0,{description:w.localize(143,null)})),cursorBlinking:_e(new g(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],d,{description:w.localize(144,null)})),cursorSmoothCaretAnimation:_e(new f(21,"cursorSmoothCaretAnimation",!1,{description:w.localize(145,null)})),cursorStyle:_e(new g(22,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],m,{description:w.localize(146,null)})),cursorSurroundingLines:_e(new i(23,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(147,null)})),cursorSurroundingLinesStyle:_e(new E(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(148,null),w.localize(149,null)],description:w.localize(150,null)})),cursorWidth:_e(new i(25,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(151,null)})),disableLayerHinting:_e(new f(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new f(27,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new f(28,"domReadOnly",!1)),dragAndDrop:_e(new f(29,"dragAndDrop",!0,{description:w.localize(152,null)})),emptySelectionClipboard:_e(new D),extraEditorClassName:_e(new v(31,"extraEditorClassName","")),fastScrollSensitivity:_e(new s(32,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:w.localize(153,null)})),find:_e(new c),fixedOverflowWidgets:_e(new f(34,"fixedOverflowWidgets",!1)),folding:_e(new f(35,"folding",!0,{description:w.localize(154,null)})),foldingStrategy:_e(new E(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(155,null),w.localize(156,null)],description:w.localize(157,null)})),foldingHighlight:_e(new f(37,"foldingHighlight",!0,{description:w.localize(158,null)})),unfoldOnClickAfterEndOfLine:_e(new f(38,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(159,null)})),fontFamily:_e(new v(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(160,null)})),fontInfo:_e(new P),fontLigatures2:_e(new p),fontSize:_e(new F),fontWeight:_e(new z),formatOnPaste:_e(new f(44,"formatOnPaste",!1,{description:w.localize(161,null)})),formatOnType:_e(new f(45,"formatOnType",!1,{description:w.localize(162,null)})),glyphMargin:_e(new f(46,"glyphMargin",!0,{description:w.localize(163,null)})),gotoLocation:_e(new de),hideCursorInOverviewRuler:_e(new f(48,"hideCursorInOverviewRuler",!1,{description:w.localize(164,null)})),highlightActiveIndentGuide:_e(new f(49,"highlightActiveIndentGuide",!0,{description:w.localize(165,null)})),hover:_e(new B),inDiffEditor:_e(new f(51,"inDiffEditor",!1)),letterSpacing:_e(new s(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>s.clamp(V,-5,20),{description:w.localize(166,null)})),lightbulb:_e(new M),lineDecorationsWidth:_e(new C(54,"lineDecorationsWidth",10)),lineHeight:_e(new x),lineNumbers:_e(new xe),lineNumbersMinChars:_e(new i(57,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new f(58,"linkedEditing",!1,{description:w.localize(167,null)})),links:_e(new f(59,"links",!0,{description:w.localize(168,null)})),matchBrackets:_e(new E(60,"matchBrackets","always",["always","near","never"],{description:w.localize(169,null)})),minimap:_e(new Q),mouseStyle:_e(new E(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new s(63,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:w.localize(170,null)})),mouseWheelZoom:_e(new f(64,"mouseWheelZoom",!1,{markdownDescription:w.localize(171,null)})),multiCursorMergeOverlapping:_e(new f(65,"multiCursorMergeOverlapping",!0,{description:w.localize(172,null)})),multiCursorModifier:_e(new g(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],$,{markdownEnumDescriptions:[w.localize(173,null),w.localize(174,null)],markdownDescription:w.localize(175,null)})),multiCursorPaste:_e(new E(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(176,null),w.localize(177,null)],markdownDescription:w.localize(178,null)})),occurrencesHighlight:_e(new f(68,"occurrencesHighlight",!0,{description:w.localize(179,null)})),overviewRulerBorder:_e(new f(69,"overviewRulerBorder",!0,{description:w.localize(180,null)})),overviewRulerLanes:_e(new i(70,"overviewRulerLanes",3,0,3)),padding:_e(new ee),parameterHints:_e(new re),peekWidgetDefaultFocus:_e(new E(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(181,null),w.localize(182,null)],description:w.localize(183,null)})),definitionLinkOpensInPeek:_e(new f(74,"definitionLinkOpensInPeek",!1,{description:w.localize(184,null)})),quickSuggestions:_e(new ye),quickSuggestionsDelay:_e(new i(76,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(185,null)})),readOnly:_e(new f(77,"readOnly",!1)),renameOnType:_e(new f(78,"renameOnType",!1,{description:w.localize(186,null),markdownDeprecationMessage:w.localize(187,null)})),renderControlCharacters:_e(new f(79,"renderControlCharacters",!1,{description:w.localize(188,null)})),renderIndentGuides:_e(new f(80,"renderIndentGuides",!0,{description:w.localize(189,null)})),renderFinalNewline:_e(new f(81,"renderFinalNewline",!0,{description:w.localize(190,null)})),renderLineHighlight:_e(new E(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(191,null)],description:w.localize(192,null)})),renderLineHighlightOnlyWhenFocus:_e(new f(83,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(193,null)})),renderValidationDecorations:_e(new E(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new E(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(194,null),w.localize(195,null),w.localize(196,null),""],description:w.localize(197,null)})),revealHorizontalRightPadding:_e(new i(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new f(87,"roundedSelection",!0,{description:w.localize(198,null)})),rulers:_e(new ze),scrollbar:_e(new G),scrollBeyondLastColumn:_e(new i(90,"scrollBeyondLastColumn",5,0,1073741824,{description:w.localize(199,null)})),scrollBeyondLastLine:_e(new f(91,"scrollBeyondLastLine",!0,{description:w.localize(200,null)})),scrollPredominantAxis:_e(new f(92,"scrollPredominantAxis",!0,{description:w.localize(201,null)})),selectionClipboard:_e(new f(93,"selectionClipboard",!0,{description:w.localize(202,null),included:k.isLinux})),selectionHighlight:_e(new f(94,"selectionHighlight",!0,{description:w.localize(203,null)})),selectOnLineNumbers:_e(new f(95,"selectOnLineNumbers",!0)),showFoldingControls:_e(new E(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[w.localize(204,null),w.localize(205,null)],description:w.localize(206,null)})),showUnused:_e(new f(97,"showUnused",!0,{description:w.localize(207,null)})),showDeprecated:_e(new f(121,"showDeprecated",!0,{description:w.localize(208,null)})),inlineHints:_e(new U),snippetSuggestions:_e(new E(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(209,null),w.localize(210,null),w.localize(211,null),w.localize(212,null)],description:w.localize(213,null)})),smartSelect:_e(new ae),smoothScrolling:_e(new f(100,"smoothScrolling",!1,{description:w.localize(214,null)})),stopRenderingLineAfter:_e(new i(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new te),suggestFontSize:_e(new i(104,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(215,null)})),suggestLineHeight:_e(new i(105,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(216,null)})),suggestOnTriggerCharacters:_e(new f(106,"suggestOnTriggerCharacters",!0,{description:w.localize(217,null)})),suggestSelection:_e(new E(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(218,null),w.localize(219,null),w.localize(220,null)],description:w.localize(221,null)})),tabCompletion:_e(new E(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(222,null),w.localize(223,null),w.localize(224,null)],description:w.localize(225,null)})),tabIndex:_e(new i(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new E(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(226,null),w.localize(227,null),w.localize(228,null)],description:w.localize(229,null)})),useTabStops:_e(new f(111,"useTabStops",!0,{description:w.localize(230,null)})),wordSeparators:_e(new v(112,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:w.localize(231,null)})),wordWrap:_e(new E(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(232,null),w.localize(233,null),w.localize(234,null),w.localize(235,null)],description:w.localize(236,null)})),wordWrapBreakAfterCharacters:_e(new v(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new v(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new i(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(237,null)})),wordWrapOverride1:_e(new E(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new E(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new g(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Le,{enumDescriptions:[w.localize(238,null),w.localize(239,null),w.localize(240,null),w.localize(241,null)],description:w.localize(242,null)})),wrappingStrategy:_e(new E(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[w.localize(243,null),w.localize(244,null)],description:w.localize(245,null)})),editorClassName:_e(new _),pixelRatio:_e(new se),tabFocusMode:_e(new me),layoutInfo:_e(new K),wrappingInfo:_e(new ge)}}),define(be[122],we([16,17]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[123],we([16,17]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[124],we([16,17]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(be[125],we([16,17]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(be[126],we([16,17]),function(ie,e){return ie.create("vs/platform/theme/common/iconRegistry",e)}),define(be[127],we([16,17]),function(ie,e){return ie.create("vs/platform/workspaces/common/workspaces",e)}),define(be[128],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHost.api.impl",e)}),define(be[129],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[130],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(be[131],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[132],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(be[133],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[134],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[135],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[136],we([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[137],we([16,17]),function(ie,e){return ie.create("vs/workbench/common/views",e)}),define(be[138],we([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[139],we([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[140],we([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[141],we([16,17]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[142],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var w;(function(S){S[S.ACTIVATE=0]="ACTIVATE",S[S.RESTORE=1]="RESTORE",S[S.PRESERVE=2]="PRESERVE"})(w=e.EditorActivation||(e.EditorActivation={}));var k;(function(S){S[S.PICK=1]="PICK",S[S.DISABLED=2]="DISABLED"})(k=e.EditorOverride||(e.EditorOverride={}));var A;(function(S){S[S.API=0]="API",S[S.USER=1]="USER"})(A=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(S){S[S.Center=0]="Center",S[S.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",S[S.NearTop=2]="NearTop",S[S.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[143],we([0,1,123]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function A(C){return C=C.trim(),C==="*"||k.test(C)}e.isValidVersionStr=A;function T(C){if(!A(C))return null;if(C=C.trim(),C==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=C.match(k);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=T;function S(C){if(!C)return null;let b=C.majorBase,f=C.majorMustEqual,i=C.minorBase,s=C.minorMustEqual,v=C.patchBase,h=C.patchMustEqual;return C.hasCaret&&(b===0||(s=!1),h=!1),{majorBase:b,majorMustEqual:f,minorBase:i,minorMustEqual:s,patchBase:v,patchMustEqual:h,isMinimum:C.hasGreaterEquals}}e.normalizeVersion=S;function I(C,b){let f;typeof C=="string"?f=S(T(C)):f=C;let i;if(typeof b=="string"?i=S(T(b)):i=b,!f||!i)return!1;let s=f.majorBase,v=f.minorBase,h=f.patchBase,E=i.majorBase,g=i.minorBase,a=i.patchBase,o=i.majorMustEqual,t=i.minorMustEqual,r=i.patchMustEqual;return i.isMinimum?s>E?!0:s<E?!1:v>g?!0:v<g?!1:h>=a:(s===1&&E===0&&(!o||!t||!r)&&(E=1,g=0,a=0,o=!0,t=!1,r=!1),s<E?!1:s>E?!o:v<g?!1:v>g?!t:h<a?!1:h>a?!r:!0)}e.isValidVersion=I;function y(C,b,f){return b.isBuiltin||typeof b.main=="undefined"?!0:R(C,b.engines.vscode,f)}e.isValidExtensionVersion=y;function n(C,b){return C==="*"||R(b,C)}e.isEngineValid=n;function R(C,b,f=[]){let i=S(T(b));if(!i)return f.push(w.localize(0,null,b)),!1;if(i.majorBase===0){if(!i.majorMustEqual||!i.minorMustEqual)return f.push(w.localize(1,null,b)),!1}else if(!i.majorMustEqual)return f.push(w.localize(2,null,b)),!1;return I(C,i)?!0:(f.push(w.localize(3,null,C,b)),!1)}e.isVersionValid=R}),define(be[86],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class w{constructor(T,S=[],I=!1){this.ctor=T,this.staticArguments=S,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=w;const k=(A,...T)=>new w(A,T);e.createSyncDescriptor=k}),define(be[61],we([0,1,86]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function A(S,I,y){I instanceof w.SyncDescriptor||(I=new w.SyncDescriptor(I,[],y)),k.push([S,I])}e.registerSingleton=A;function T(){return k}e.getSingletonServiceDescriptors=T}),define(be[144],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=w;class k{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let S of this._nodes.values())S.outgoing.size===0&&T.push(S);return T}insertEdge(T,S){const I=this.lookupOrInsertNode(T),y=this.lookupOrInsertNode(S);I.outgoing.set(this._hashFn(S),y),y.incoming.set(this._hashFn(T),I)}removeNode(T){const S=this._hashFn(T);this._nodes.delete(S);for(let I of this._nodes.values())I.outgoing.delete(S),I.incoming.delete(S)}lookupOrInsertNode(T){const S=this._hashFn(T);let I=this._nodes.get(S);return I||(I=new w(T),this._nodes.set(S,I)),I}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[S,I]of this._nodes)T.push(`${S}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return T.join(`
`)}}e.Graph=k}),define(be[4],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function y(n){return n[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=y})(w=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function k(I,y,n,R){y[w.DI_TARGET]===y?y[w.DI_DEPENDENCIES].push({id:I,index:n,optional:R}):(y[w.DI_DEPENDENCIES]=[{id:I,index:n,optional:R}],y[w.DI_TARGET]=y)}function A(I){if(w.serviceIds.has(I))return w.serviceIds.get(I);const y=function(n,R,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(y,n,C,!1)};return y.toString=()=>I,w.serviceIds.set(I,y),y}e.createDecorator=A;function T(I){return I}e.refineServiceDecorator=T;function S(I){return function(y,n,R){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");k(I,y,R,!0)}}e.optional=S}),define(be[145],we([0,1,4]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,w.createDecorator)("modelService");function k(A){return!A.isTooLargeForSyncing()&&!A.isForSimpleWidget}e.shouldSynchronizeModel=k}),define(be[146],we([0,1,3,56,6,22,78,59,145]),function(ie,e,w,k,A,T,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(b){return typeof b=="string"?!1:Array.isArray(b)?b.every(n):!!b.exclusive}class R{constructor(){this._clock=0,this._entries=[],this._onDidChange=new w.Emitter}get onDidChange(){return this._onDidChange.event}register(f,i){let s={selector:f,provider:i,_score:-1,_time:this._clock++};return this._entries.push(s),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,A.toDisposable)(()=>{if(s){let v=this._entries.indexOf(s);v>=0&&(this._entries.splice(v,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),s=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const i=[];for(let s of this._entries)s._score>0&&i.push(s.provider);return i}ordered(f){const i=[];return this._orderedForEach(f,s=>i.push(s.provider)),i}orderedGroups(f){const i=[];let s,v;return this._orderedForEach(f,h=>{s&&v===h._score?s.push(h.provider):(v=h._score,s=[h.provider],i.push(s))}),i}_orderedForEach(f,i){if(!!f){this._updateScores(f);for(const s of this._entries)s._score>0&&i(s)}}_updateScores(f){let i={uri:f.uri.toString(),language:f.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===i.language&&this._lastCandidate.uri===i.uri)){this._lastCandidate=i;for(let s of this._entries)if(s._score=(0,I.score)(s.selector,f.uri,f.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(f)),n(s.selector)&&s._score>0){for(let v of this._entries)v._score=0;s._score=1e3;break}this._entries.sort(R._compareByScoreAndTime)}}static _compareByScoreAndTime(f,i){return f._score<i._score?1:f._score>i._score?-1:f._time<i._time?1:f._time>i._time?-1:0}}e.LanguageFeatureRegistry=R;class C{constructor(f,i,s=Number.MAX_SAFE_INTEGER){this._registry=f,this.min=i,this.max=s,this._cache=new T.LRUCache(50,.7)}_key(f){return f.id+(0,k.hash)(this._registry.all(f))}_clamp(f){return f===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(f*1.3)))}get(f){const i=this._key(f),s=this._cache.get(i);return this._clamp(s==null?void 0:s.value)}update(f,i){const s=this._key(f);let v=this._cache.get(s);return v||(v=new S.MovingAverage,this._cache.set(s,v)),v.update(i),this.get(f)}}e.LanguageFeatureRequestDelays=C}),define(be[62],we([0,1,2,33,146,117,37]),function(ie,e,w,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var I;(function(c){c[c.Null=0]="Null",c[c.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));class y{constructor(p,P){this.language=p,this.id=P}}e.LanguageIdentifier=y;var n;(function(c){c[c.NotSet=-1]="NotSet",c[c.None=0]="None",c[c.Italic=1]="Italic",c[c.Bold=2]="Bold",c[c.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var R;(function(c){c[c.None=0]="None",c[c.DefaultForeground=1]="DefaultForeground",c[c.DefaultBackground=2]="DefaultBackground"})(R=e.ColorId||(e.ColorId={}));var C;(function(c){c[c.Other=0]="Other",c[c.Comment=1]="Comment",c[c.String=2]="String",c[c.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var b;(function(c){c[c.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",c[c.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",c[c.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",c[c.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",c[c.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",c[c.ITALIC_MASK=2048]="ITALIC_MASK",c[c.BOLD_MASK=4096]="BOLD_MASK",c[c.UNDERLINE_MASK=8192]="UNDERLINE_MASK",c[c.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",c[c.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",c[c.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",c[c.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",c[c.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",c[c.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",c[c.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",c[c.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",c[c.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",c[c.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(b=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(p){return(p&255)>>>0}static getTokenType(p){return(p&1792)>>>8}static getFontStyle(p){return(p&14336)>>>11}static getForeground(p){return(p&8372224)>>>14}static getBackground(p){return(p&4286578688)>>>23}static getClassNameFromMetadata(p){let P=this.getForeground(p),F="mtk"+P,z=this.getFontStyle(p);return z&1&&(F+=" mtki"),z&2&&(F+=" mtkb"),z&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(p,P){const F=this.getForeground(p),z=this.getFontStyle(p);let de=`color: ${P[F]};`;return z&1&&(de+="font-style: italic;"),z&2&&(de+="font-weight: bold;"),z&4&&(de+="text-decoration: underline;"),de}}e.TokenMetadata=f;var i;(function(c){c[c.Method=0]="Method",c[c.Function=1]="Function",c[c.Constructor=2]="Constructor",c[c.Field=3]="Field",c[c.Variable=4]="Variable",c[c.Class=5]="Class",c[c.Struct=6]="Struct",c[c.Interface=7]="Interface",c[c.Module=8]="Module",c[c.Property=9]="Property",c[c.Event=10]="Event",c[c.Operator=11]="Operator",c[c.Unit=12]="Unit",c[c.Value=13]="Value",c[c.Constant=14]="Constant",c[c.Enum=15]="Enum",c[c.EnumMember=16]="EnumMember",c[c.Keyword=17]="Keyword",c[c.Text=18]="Text",c[c.Color=19]="Color",c[c.File=20]="File",c[c.Reference=21]="Reference",c[c.Customcolor=22]="Customcolor",c[c.Folder=23]="Folder",c[c.TypeParameter=24]="TypeParameter",c[c.User=25]="User",c[c.Issue=26]="Issue",c[c.Snippet=27]="Snippet"})(i=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let c=Object.create(null);return c[0]="symbol-method",c[1]="symbol-function",c[2]="symbol-constructor",c[3]="symbol-field",c[4]="symbol-variable",c[5]="symbol-class",c[6]="symbol-struct",c[7]="symbol-interface",c[8]="symbol-module",c[9]="symbol-property",c[10]="symbol-event",c[11]="symbol-operator",c[12]="symbol-unit",c[13]="symbol-value",c[14]="symbol-constant",c[15]="symbol-enum",c[16]="symbol-enum-member",c[17]="symbol-keyword",c[27]="symbol-snippet",c[18]="symbol-text",c[19]="symbol-color",c[20]="symbol-file",c[21]="symbol-reference",c[22]="symbol-customcolor",c[23]="symbol-folder",c[24]="symbol-type-parameter",c[25]="account",c[26]="issues",function(p){const P=c[p];let F=P&&S.iconRegistry.get(P);return F||(console.info("No codicon found for CompletionItemKind "+p),F=S.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let c=Object.create(null);return c.method=0,c.function=1,c.constructor=2,c.field=3,c.variable=4,c.class=5,c.struct=6,c.interface=7,c.module=8,c.property=9,c.event=10,c.operator=11,c.unit=12,c.value=13,c.constant=14,c.enum=15,c["enum-member"]=16,c.enumMember=16,c.keyword=17,c.snippet=27,c.text=18,c.color=19,c.file=20,c.reference=21,c.customcolor=22,c.folder=23,c["type-parameter"]=24,c.typeParameter=24,c.account=25,c.issue=26,function(p,P){let F=c[p];return typeof F=="undefined"&&!P&&(F=9),F}}();var s;(function(c){c[c.Deprecated=1]="Deprecated"})(s=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(c){c[c.KeepWhitespace=1]="KeepWhitespace",c[c.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var h;(function(c){c[c.Invoke=0]="Invoke",c[c.TriggerCharacter=1]="TriggerCharacter",c[c.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(c){c[c.Invoke=1]="Invoke",c[c.Auto=2]="Auto"})(E=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var g;(function(c){c[c.Invoke=1]="Invoke",c[c.TriggerCharacter=2]="TriggerCharacter",c[c.ContentChange=3]="ContentChange"})(g=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var a;(function(c){c[c.Text=0]="Text",c[c.Read=1]="Read",c[c.Write=2]="Write"})(a=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function o(c){return c&&w.URI.isUri(c.uri)&&k.Range.isIRange(c.range)&&(k.Range.isIRange(c.originSelectionRange)||k.Range.isIRange(c.targetSelectionRange))}e.isLocationLink=o;var t;(function(c){c[c.File=0]="File",c[c.Module=1]="Module",c[c.Namespace=2]="Namespace",c[c.Package=3]="Package",c[c.Class=4]="Class",c[c.Method=5]="Method",c[c.Property=6]="Property",c[c.Field=7]="Field",c[c.Constructor=8]="Constructor",c[c.Enum=9]="Enum",c[c.Interface=10]="Interface",c[c.Function=11]="Function",c[c.Variable=12]="Variable",c[c.Constant=13]="Constant",c[c.String=14]="String",c[c.Number=15]="Number",c[c.Boolean=16]="Boolean",c[c.Array=17]="Array",c[c.Object=18]="Object",c[c.Key=19]="Key",c[c.Null=20]="Null",c[c.EnumMember=21]="EnumMember",c[c.Struct=22]="Struct",c[c.Event=23]="Event",c[c.Operator=24]="Operator",c[c.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var r;(function(c){c[c.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var d;(function(c){const p=new Map;p.set("file",0),p.set("module",1),p.set("namespace",2),p.set("package",3),p.set("class",4),p.set("method",5),p.set("property",6),p.set("field",7),p.set("constructor",8),p.set("enum",9),p.set("interface",10),p.set("function",11),p.set("variable",12),p.set("constant",13),p.set("string",14),p.set("number",15),p.set("boolean",16),p.set("array",17),p.set("object",18),p.set("key",19),p.set("null",20),p.set("enum-member",21),p.set("struct",22),p.set("event",23),p.set("operator",24),p.set("type-parameter",25);const P=new Map;P.set(0,"file"),P.set(1,"module"),P.set(2,"namespace"),P.set(3,"package"),P.set(4,"class"),P.set(5,"method"),P.set(6,"property"),P.set(7,"field"),P.set(8,"constructor"),P.set(9,"enum"),P.set(10,"interface"),P.set(11,"function"),P.set(12,"variable"),P.set(13,"constant"),P.set(14,"string"),P.set(15,"number"),P.set(16,"boolean"),P.set(17,"array"),P.set(18,"object"),P.set(19,"key"),P.set(20,"null"),P.set(21,"enum-member"),P.set(22,"struct"),P.set(23,"event"),P.set(24,"operator"),P.set(25,"type-parameter");function F(B){return p.get(B)}c.fromString=F;function z(B){return P.get(B)}c.toString=z;function de(B,W){const K=P.get(B);let M=K&&S.iconRegistry.get("symbol-"+K);return M||(console.info("No codicon found for SymbolKind "+B),M=S.Codicon.symbolProperty),`${W?"inline":"block"} ${M.classNames}`}c.toCssClassName=de})(d=e.SymbolKinds||(e.SymbolKinds={}));class l{constructor(p){this.value=p}}e.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var u;(function(c){c[c.Collapsed=0]="Collapsed",c[c.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(c){c[c.Editing=0]="Editing",c[c.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var _;(function(c){c[c.Other=0]="Other",c[c.Type=1]="Type",c[c.Parameter=2]="Parameter"})(_=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new A.LanguageFeatureRegistry,e.RenameProviderRegistry=new A.LanguageFeatureRegistry,e.CompletionProviderRegistry=new A.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new A.LanguageFeatureRegistry,e.HoverProviderRegistry=new A.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new A.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new A.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new A.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new A.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new A.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new A.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.LinkProviderRegistry=new A.LanguageFeatureRegistry,e.ColorProviderRegistry=new A.LanguageFeatureRegistry,e.SelectionRangeRegistry=new A.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var D;(function(c){c[c.None=0]="None",c[c.Option=1]="Option",c[c.Default=2]="Default",c[c.Preferred=3]="Preferred"})(D=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[147],we([0,1,6,12,4,3,45,54]),function(ie,e,w,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,A.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,n){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!n)throw new Error("invalid command");return this.registerCommand({id:y,handler:n})}if(y.description){const i=[];for(let v of y.description.args)i.push(v.constraint);const s=y.handler;y.handler=function(v,...h){return(0,k.validateConstraints)(h,i),s(v,...h)}}const{id:R}=y;let C=this._commands.get(R);C||(C=new S.LinkedList,this._commands.set(R,C));let b=C.unshift(y),f=(0,w.toDisposable)(()=>{b();const i=this._commands.get(R);(i==null?void 0:i.isEmpty())&&this._commands.delete(R)});return this._onDidRegisterCommand.fire(R),f}registerCommandAlias(y,n){return e.CommandsRegistry.registerCommand(y,(R,...C)=>R.get(e.ICommandService).executeCommand(n,...C))}getCommand(y){const n=this._commands.get(y);if(!(!n||n.isEmpty()))return I.Iterable.first(n)}getCommands(){const y=new Map;for(const n of this._commands.keys()){const R=this.getCommand(n);R&&y.set(n,R)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>w.Disposable.None,onDidExecuteCommand:()=>w.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(be[63],we([0,1,8,4,21]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=A.userAgent||"";const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",A.isMacintosh),S.set("isLinux",A.isLinux),S.set("isWindows",A.isWindows),S.set("isWeb",A.isWeb),S.set("isMacNative",A.isMacintosh&&!A.isWeb),S.set("isEdge",T.indexOf("Edg/")>=0),S.set("isFirefox",T.indexOf("Firefox")>=0),S.set("isChrome",T.indexOf("Chrome")>=0),S.set("isSafari",T.indexOf("Safari")>=0),S.set("isIPad",T.indexOf("iPad")>=0);const I=Object.prototype.hasOwnProperty;var y;(function(c){c[c.False=0]="False",c[c.True=1]="True",c[c.Defined=2]="Defined",c[c.Not=3]="Not",c[c.Equals=4]="Equals",c[c.NotEquals=5]="NotEquals",c[c.And=6]="And",c[c.Regex=7]="Regex",c[c.NotRegex=8]="NotRegex",c[c.Or=9]="Or",c[c.In=10]="In",c[c.NotIn=11]="NotIn",c[c.Greater=12]="Greater",c[c.GreaterEquals=13]="GreaterEquals",c[c.Smaller=14]="Smaller",c[c.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return C.INSTANCE}static true(){return b.INSTANCE}static has(p){return f.create(p)}static equals(p,P){return i.create(p,P)}static notEquals(p,P){return h.create(p,P)}static regex(p,P){return r.create(p,P)}static in(p,P){return s.create(p,P)}static not(p){return E.create(p)}static and(...p){return l.create(p)}static or(...p){return u.create(p)}static greater(p,P){return g.create(p,P)}static less(p,P){return o.create(p,P)}static deserialize(p,P=!1){if(!!p)return this._deserializeOrExpression(p,P)}static _deserializeOrExpression(p,P){let F=p.split("||");return u.create(F.map(z=>this._deserializeAndExpression(z,P)))}static _deserializeAndExpression(p,P){let F=p.split("&&");return l.create(F.map(z=>this._deserializeOne(z,P)))}static _deserializeOne(p,P){if(p=p.trim(),p.indexOf("!=")>=0){let F=p.split("!=");return h.create(F[0].trim(),this._deserializeValue(F[1],P))}if(p.indexOf("==")>=0){let F=p.split("==");return i.create(F[0].trim(),this._deserializeValue(F[1],P))}if(p.indexOf("=~")>=0){let F=p.split("=~");return r.create(F[0].trim(),this._deserializeRegexValue(F[1],P))}if(p.indexOf(" in ")>=0){let F=p.split(" in ");return s.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(p)){const F=p.split(">=");return a.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(p)){const F=p.split(">");return g.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(p)){const F=p.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(p)){const F=p.split("<");return o.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(p)?E.create(p.substr(1).trim()):f.create(p)}static _deserializeValue(p,P){if(p=p.trim(),p==="true")return!0;if(p==="false")return!1;let F=/^'([^']*)'$/.exec(p);return F?F[1].trim():p}static _deserializeRegexValue(p,P){if((0,w.isFalsyOrWhitespace)(p)){if(P)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=p.indexOf("/"),z=p.lastIndexOf("/");if(F===z||F<0){if(P)throw new Error(`bad regexp-value '${p}', missing /-enclosure`);return console.warn(`bad regexp-value '${p}', missing /-enclosure`),null}let de=p.slice(F+1,z),B=p[z+1]==="i"?"i":"";try{return new RegExp(de,B)}catch(W){if(P)throw new Error(`bad regexp-value '${p}', parse error: ${W}`);return console.warn(`bad regexp-value '${p}', parse error: ${W}`),null}}}e.ContextKeyExpr=n;function R(c,p){return c.cmp(p)}class C{constructor(){this.type=0}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}evaluate(p){return!1}serialize(){return"false"}keys(){return[]}map(p){return this}negate(){return b.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class b{constructor(){this.type=1}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}evaluate(p){return!0}serialize(){return"true"}keys(){return[]}map(p){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=b,b.INSTANCE=new b;class f{constructor(p){this.key=p,this.type=2}static create(p){const P=S.get(p);return typeof P=="boolean"?P?b.INSTANCE:C.INSTANCE:new f(p)}cmp(p){return p.type!==this.type?this.type-p.type:_(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}evaluate(p){return!!p.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(p){return p.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=f;class i{constructor(p,P){this.key=p,this.value=P,this.type=4}static create(p,P){if(typeof P=="boolean")return P?f.create(p):E.create(p);const F=S.get(p);return typeof F=="boolean"?P===(F?"true":"false")?b.INSTANCE:C.INSTANCE:new i(p,P)}cmp(p){return p.type!==this.type?this.type-p.type:D(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return p.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(p){return p.mapEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeyEqualsExpr=i;class s{constructor(p,P){this.key=p,this.valueKey=P,this.type=10}static create(p,P){return new s(p,P)}cmp(p){return p.type!==this.type?this.type-p.type:D(this.key,this.valueKey,p.key,p.valueKey)}equals(p){return p.type===this.type?this.key===p.key&&this.valueKey===p.valueKey:!1}evaluate(p){const P=p.getValue(this.valueKey),F=p.getValue(this.key);return Array.isArray(P)?P.indexOf(F)>=0:typeof F=="string"&&typeof P=="object"&&P!==null?I.call(P,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(p){return p.mapIn(this.key,this.valueKey)}negate(){return v.create(this)}}e.ContextKeyInExpr=s;class v{constructor(p){this._actual=p,this.type=11}static create(p){return new v(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new v(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class h{constructor(p,P){this.key=p,this.value=P,this.type=5}static create(p,P){if(typeof P=="boolean")return P?E.create(p):f.create(p);const F=S.get(p);return typeof F=="boolean"?P===(F?"true":"false")?C.INSTANCE:b.INSTANCE:new h(p,P)}cmp(p){return p.type!==this.type?this.type-p.type:D(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return p.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(p){return p.mapNotEquals(this.key,this.value)}negate(){return i.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=h;class E{constructor(p){this.key=p,this.type=3}static create(p){const P=S.get(p);return typeof P=="boolean"?P?C.INSTANCE:b.INSTANCE:new E(p)}cmp(p){return p.type!==this.type?this.type-p.type:_(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}evaluate(p){return!p.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(p){return p.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=E;class g{constructor(p,P){this.key=p,this.value=P,this.type=12}static create(p,P){return new g(p,P)}cmp(p){return p.type!==this.type?this.type-p.type:D(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=g;class a{constructor(p,P){this.key=p,this.value=P,this.type=13}static create(p,P){return new a(p,P)}cmp(p){return p.type!==this.type?this.type-p.type:D(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreaterEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=a;class o{constructor(p,P){this.key=p,this.value=P,this.type=14}static create(p,P){return new o(p,P)}cmp(p){return p.type!==this.type?this.type-p.type:D(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmaller(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeySmallerExpr=o;class t{constructor(p,P){this.key=p,this.value=P,this.type=15}static create(p,P){return new t(p,P)}cmp(p){return p.type!==this.type?this.type-p.type:D(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmallerEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(p,P){this.key=p,this.regexp=P,this.type=7}static create(p,P){return new r(p,P)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.key<p.key)return-1;if(this.key>p.key)return 1;const P=this.regexp?this.regexp.source:"",F=p.regexp?p.regexp.source:"";return P<F?-1:P>F?1:0}equals(p){if(p.type===this.type){const P=this.regexp?this.regexp.source:"",F=p.regexp?p.regexp.source:"";return this.key===p.key&&P===F}return!1}evaluate(p){let P=p.getValue(this.key);return this.regexp?this.regexp.test(P):!1}serialize(){const p=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${p}`}keys(){return[this.key]}map(p){return p.mapRegex(this.key,this.regexp)}negate(){return d.create(this)}}e.ContextKeyRegexExpr=r;class d{constructor(p){this._actual=p,this.type=8}static create(p){return new d(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new d(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=d;class l{constructor(p){this.expr=p,this.type=6}static create(p){return l._normalizeArr(p)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let P=0,F=this.expr.length;P<F;P++){const z=R(this.expr[P],p.expr[P]);if(z!==0)return z}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].equals(p.expr[P]))return!1;return!0}return!1}evaluate(p){for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].evaluate(p))return!1;return!0}static _normalizeArr(p){const P=[];let F=!1;for(const z of p)if(!!z){if(z.type===1){F=!0;continue}if(z.type===0)return C.INSTANCE;if(z.type===6){P.push(...z.expr);continue}P.push(z)}if(P.length===0&&F)return b.INSTANCE;if(P.length!==0){if(P.length===1)return P[0];for(P.sort(R);P.length>1;){const z=P[P.length-1];if(z.type!==9)break;P.pop();const de=P.pop(),B=u.create(z.expr.map(W=>l.create([W,de])));B&&(P.push(B),P.sort(R))}return P.length===1?P[0]:new l(P)}}serialize(){return this.expr.map(p=>p.serialize()).join(" && ")}keys(){const p=[];for(let P of this.expr)p.push(...P.keys());return p}map(p){return new l(this.expr.map(P=>P.map(p)))}negate(){let p=[];for(let P of this.expr)p.push(P.negate());return u.create(p)}}e.ContextKeyAndExpr=l;class u{constructor(p){this.expr=p,this.type=9}static create(p){const P=u._normalizeArr(p);if(P.length!==0)return P.length===1?P[0]:new u(P)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let P=0,F=this.expr.length;P<F;P++){const z=R(this.expr[P],p.expr[P]);if(z!==0)return z}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].equals(p.expr[P]))return!1;return!0}return!1}evaluate(p){for(let P=0,F=this.expr.length;P<F;P++)if(this.expr[P].evaluate(p))return!0;return!1}static _normalizeArr(p){let P=[],F=!1;if(p){for(let z=0,de=p.length;z<de;z++){const B=p[z];if(!!B){if(B.type===0){F=!0;continue}if(B.type===1)return[b.INSTANCE];if(B.type===9){P=P.concat(B.expr);continue}P.push(B)}}if(P.length===0&&F)return[C.INSTANCE];P.sort(R)}return P}serialize(){return this.expr.map(p=>p.serialize()).join(" || ")}keys(){const p=[];for(let P of this.expr)p.push(...P.keys());return p}map(p){return new u(this.expr.map(P=>P.map(p)))}negate(){let p=[];for(let F of this.expr)p.push(F.negate());const P=F=>F.type===9?F.expr:[F];for(;p.length>1;){const F=p.shift(),z=p.shift(),de=[];for(const B of P(F))for(const W of P(z))de.push(n.and(B,W));p.unshift(n.or(...de))}return p[0]}}e.ContextKeyOrExpr=u;class m extends f{constructor(p,P,F){super(p);this.key=p,this._defaultValue=P,typeof F=="object"?m._info.push(Object.assign(Object.assign({},F),{key:p})):F!==!0&&m._info.push({key:p,description:F,type:P!=null?typeof P:void 0})}static all(){return m._info.values()}bindTo(p){return p.createKey(this.key,this._defaultValue)}getValue(p){return p.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(p){return n.equals(this.key,p)}notEqualsTo(p){return n.notEquals(this.key,p)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function _(c,p){return c<p?-1:c>p?1:0}function D(c,p,P,F){return c<P?-1:c>P?1:p<F?-1:p>F?1:0}}),define(be[148],we([0,1,4]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(be[26],we([0,1,8,4]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.getExtensionWorkspaceTrustRequirement=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(R){return R&&typeof R=="object"&&typeof R.id=="string"&&(!R.uuid||typeof R.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(R){R[R.System=0]="System",R[R.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class S{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,b){if(typeof C=="undefined"||C===null)return typeof b=="undefined"||b===null;if(typeof b=="undefined"||b===null)return!1;if(typeof C=="string"||typeof b=="string"){let f=typeof C=="string"?C:C.value,i=typeof b=="string"?b:b.value;return w.equalsIgnoreCase(f,i)}return C._lower===b._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=S;function I(R){return R.contributes&&R.contributes.localizations?R.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function y(R){return R.contributes&&R.contributes.authentication?R.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y;function n(R){var C;return((C=R.workspaceTrust)===null||C===void 0?void 0:C.required)!==void 0?R.workspaceTrust.required:R.main?"onStart":!1}e.getExtensionWorkspaceTrustRequirement=n,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[149],we([0,1,8,26]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(f,i){return f.uuid&&i.uuid?f.uuid===i.uuid:f.id===i.id?!0:(0,w.compareIgnoreCase)(f.id,i.id)===0}e.areSameExtensions=A;class T{constructor(i,s){this.version=s,this.id=i.id,this.uuid=i.uuid}key(){return`${this.id}-${this.version}`}equals(i){return i instanceof T?A(this,i)&&this.version===i.version:!1}}e.ExtensionIdentifierWithVersion=T;function S(f,i){return`${f}.${i}`}e.getExtensionId=S;function I(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function y(f,i){return I(S(f,i))}e.getGalleryExtensionId=y;function n(f,i){const s=[],v=h=>{for(const E of s)if(E.some(g=>A(i(g),i(h))))return E;return null};for(const h of f){const E=v(h);E?E.push(h):s.push([h])}return s}e.groupByExtension=n;function R(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function C(f){return Object.assign({id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0)},f.telemetryData)}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function b(f){const i=new Set;for(const s of f)s.malicious&&i.add(s.id.id);return i}e.getMaliciousExtensionsSet=b}),define(be[64],we([0,1,124,11,2,4,8,12,22]),function(ie,e,w,k,A,T,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function n(B){return B.create===!0}e.isFileOpenForWriteOptions=n;var R;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var C;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=b;function f(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=f;function i(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=i;function s(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=s;var v;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(W,K){super(W);this.code=K}}e.FileSystemProviderError=h;function E(B,W){const K=new h(B.toString(),W);return a(K,W),K}e.createFileSystemProviderError=E;function g(B){return B||E((0,w.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=g;function a(B,W){return B.name=W?`${W} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=a;function o(B){if(!B)return v.Unknown;if(B instanceof h)return B.code;const W=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!W)return v.Unknown;switch(W[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=o;function t(B){if(B instanceof _)return B.fileOperationResult;switch(o(B)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var r;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class d{constructor(W,K,M){this.resource=W,this.operation=K,this.target=M}isOperation(W){return this.operation===W}}e.FileOperationEvent=d;var l;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class u{constructor(W,K){this.ignorePathCasing=K,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=W;for(const M of W)switch(M.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(M.resource,M);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(M.resource,M);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(M.resource,M);break}}contains(W,...K){return this.doContains(W,{includeChildren:!1},...K)}affects(W,...K){return this.doContains(W,{includeChildren:!0},...K)}doContains(W,K,...M){var U,x,Q,$,ee,re;if(!W)return!1;const se=M.length>0;return!!((!se||M.includes(1))&&(((U=this.added)===null||U===void 0?void 0:U.get(W))||K.includeChildren&&((x=this.added)===null||x===void 0?void 0:x.findSuperstr(W)))||(!se||M.includes(0))&&(((Q=this.updated)===null||Q===void 0?void 0:Q.get(W))||K.includeChildren&&(($=this.updated)===null||$===void 0?void 0:$.findSuperstr(W)))||(!se||M.includes(2))&&(((ee=this.deleted)===null||ee===void 0?void 0:ee.findSubstr(W))||K.includeChildren&&((re=this.deleted)===null||re===void 0?void 0:re.findSuperstr(W))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(W){const K=[],M=W===1?this.added:W===0?this.updated:this.deleted;if(M)for(const[,U]of M)K.push(U);return K}filter(W){return new u(this.changes.filter(K=>W(K)),this.ignorePathCasing)}}e.FileChangesEvent=u;function m(B,W,K){return!B||!W||B===W||W.length>B.length?!1:(W.charAt(W.length-1)!==k.sep&&(W+=k.sep),K?(0,S.startsWithIgnoreCase)(B,W):B.indexOf(W)===0)}e.isParent=m;class _ extends Error{constructor(W,K,M){super(W);this.fileOperationResult=K,this.options=M}static isFileOperationError(W){return W instanceof Error&&!(0,I.isUndefinedOrNull)(W.fileOperationResult)}}e.FileOperationError=_;var D;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(D=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var c;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(c=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function p(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=p;async function P(B,W){if(!W.canHandleResource(A.URI.from({scheme:B.scheme})))return new Promise(K=>{const M=W.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===B.scheme&&U.added&&(M.dispose(),K())})})}e.whenProviderRegistered=P,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(W){return(0,I.isNumber)(W)||(W=0),W<F.KB?(0,w.localize)(1,null,W.toFixed(0)):W<F.MB?(0,w.localize)(2,null,(W/F.KB).toFixed(2)):W<F.GB?(0,w.localize)(3,null,(W/F.MB).toFixed(2)):W<F.TB?(0,w.localize)(4,null,(W/F.GB).toFixed(2)):(0,w.localize)(5,null,(W/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var z;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function de(B){return{maxFileSize:B===0?300*F.MB:16*F.GB,maxHeapSize:B===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=de}),define(be[65],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...A){this._entries=new Map;for(let[T,S]of A)this.set(T,S)}set(A,T){const S=this._entries.get(A);return this._entries.set(A,T),S}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=w}),define(be[150],we([0,1,10,144,86,4,65,13]),function(ie,e,w,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class n extends Error{constructor(i){super("cyclic dependency between services");this.message=i.toString()}}class R{constructor(i=new S.ServiceCollection,s=!1,v){this._activeInstantiations=new Set,this._services=i,this._strict=s,this._parent=v,this._services.set(T.IInstantiationService,this)}createChild(i){return new R(i,this._strict,this)}invokeFunction(i,...s){let v=b.traceInvocation(i),h=!1;try{return i({get:(g,a)=>{if(h)throw(0,w.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(g,v);if(!o&&a!==T.optional)throw new Error(`[invokeFunction] unknown service '${g}'`);return o}},...s)}finally{h=!0,v.stop()}}createInstance(i,...s){let v,h;return i instanceof A.SyncDescriptor?(v=b.traceCreation(i.ctor),h=this._createInstance(i.ctor,i.staticArguments.concat(s),v)):(v=b.traceCreation(i),h=this._createInstance(i,s,v)),v.stop(),h}_createInstance(i,s=[],v){let h=T._util.getServiceDependencies(i).sort((a,o)=>a.index-o.index),E=[];for(const a of h){let o=this._getOrCreateServiceInstance(a.id,v);if(!o&&this._strict&&!a.optional)throw new Error(`[createInstance] ${i.name} depends on UNKNOWN service ${a.id}.`);E.push(o)}let g=h.length>0?h[0].index:s.length;if(s.length!==g){console.warn(`[createInstance] First service dependency of ${i.name} at position ${g+1} conflicts with ${s.length} static arguments`);let a=g-s.length;a>0?s=s.concat(new Array(a)):s=s.slice(0,g)}return new i(...[...s,...E])}_setServiceInstance(i,s){if(this._services.get(i)instanceof A.SyncDescriptor)this._services.set(i,s);else if(this._parent)this._parent._setServiceInstance(i,s);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(i){let s=this._services.get(i);return!s&&this._parent?this._parent._getServiceInstanceOrDescriptor(i):s}_getOrCreateServiceInstance(i,s){let v=this._getServiceInstanceOrDescriptor(i);return v instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(i,v,s.branch(i,!0)):(s.branch(i,!1),v)}_safeCreateAndCacheServiceInstance(i,s,v){if(this._activeInstantiations.has(i))throw new Error(`illegal state - RECURSIVELY instantiating service '${i}'`);this._activeInstantiations.add(i);try{return this._createAndCacheServiceInstance(i,s,v)}finally{this._activeInstantiations.delete(i)}}_createAndCacheServiceInstance(i,s,v){const h=new k.Graph(a=>a.id.toString());let E=0;const g=[{id:i,desc:s,_trace:v}];for(;g.length;){const a=g.pop();if(h.lookupOrInsertNode(a),E++>1e3)throw new n(h);for(let o of T._util.getServiceDependencies(a.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(o.id);if(!t&&!o.optional&&console.warn(`[createInstance] ${i} depends on ${o.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const r={id:o.id,desc:t,_trace:a._trace.branch(o.id,!0)};h.insertEdge(a,r),g.push(r)}}}for(;;){const a=h.roots();if(a.length===0){if(!h.isEmpty())throw new n(h);break}for(const{data:o}of a){if(this._getServiceInstanceOrDescriptor(o.id)instanceof A.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}h.removeNode(o)}}return this._getServiceInstanceOrDescriptor(i)}_createServiceInstanceWithOwner(i,s,v=[],h,E){if(this._services.get(i)instanceof A.SyncDescriptor)return this._createServiceInstance(s,v,h,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(i,s,v,h,E);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}_createServiceInstance(i,s=[],v,h){if(v){const E=new I.IdleValue(()=>this._createInstance(i,s,h));return new Proxy(Object.create(null),{get(g,a){if(a in g)return g[a];let o=E.value,t=o[a];return typeof t!="function"||(t=t.bind(o),g[a]=t),t},set(g,a,o){return E.value[a]=o,!0}})}else return this._createInstance(i,s,h)}}e.InstantiationService=R;var C;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(C||(C={}));class b{constructor(i,s){this.type=i,this.name=s,this._start=Date.now(),this._dep=[]}static traceInvocation(i){return y?new b(1,i.name||i.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(i){return y?new b(0,i.name):b._None}branch(i,s){let v=new b(2,i.toString());return this._dep.push([i,s,v]),v}stop(){let i=Date.now()-this._start;b._totals+=i;let s=!1;function v(E,g){let a=[],o=new Array(E+1).join("	");for(const[t,r,d]of g._dep)if(r&&d){s=!0,a.push(`${o}CREATES -> ${t}`);let l=v(E+1,d);l&&a.push(l)}else a.push(`${o}uses -> ${t}`);return a.join(`
`)}let h=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${i.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(i>2||s)&&console.log(h.join(`
`))}}b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(be[19],we([0,1,4,6,21,3,60]),function(ie,e,w,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function I(){return new Date().toISOString()}var y;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class n extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=n;class R extends n{constructor(o){super();this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...t){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([o,...t]))}debug(o,...t){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([o,...t]))}info(o,...t){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([o,...t]))}warn(o,...t){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([o,...t]))}error(o,...t){if(this.checkLogLevel(y.Error))if(o instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=o.stack,this.log(y.Error,this.format(r))}else this.log(y.Error,this.format([o,...t]))}critical(o,...t){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([o,...t]))}flush(){}format(o){let t="";for(let r=0;r<o.length;r++){let d=o[r];if(typeof d=="object")try{d=JSON.stringify(d)}catch(l){}t+=(r>0?" ":"")+d}return t}}e.AbstractMessageLogger=R;class C extends n{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o),this.useColors=!A.isWindows}trace(o,...t){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,o,...t):console.log(`[main ${I()}]`,o,...t))}debug(o,...t){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,o,...t):console.log(`[main ${I()}]`,o,...t))}info(o,...t){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,o,...t):console.log(`[main ${I()}]`,o,...t))}warn(o,...t){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,o,...t):console.warn(`[main ${I()}]`,o,...t))}error(o,...t){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,o,...t):console.error(`[main ${I()}]`,o,...t))}critical(o,...t){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,o,...t):console.error(`[main ${I()}]`,o,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class b extends n{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o)}trace(o,...t){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",o,...t)}debug(o,...t){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...t)}info(o,...t){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",o,...t)}warn(o,...t){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",o,...t)}error(o,...t){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",o,...t)}critical(o,...t){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...t)}dispose(){}flush(){}}e.ConsoleLogger=b;class f extends n{constructor(o,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=o,this.setLevel(t)}trace(o,...t){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(o),...t])}debug(o,...t){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(o),...t])}info(o,...t){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(o),...t])}warn(o,...t){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(o),...t])}error(o,...t){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(o),...t])}critical(o,...t){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(o),...t])}extractMessage(o){return typeof o=="string"?o:(0,S.toErrorMessage)(o,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class i extends n{constructor(o){super();this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const t of this.logServices)t.setLevel(o);super.setLevel(o)}trace(o,...t){for(const r of this.logServices)r.trace(o,...t)}debug(o,...t){for(const r of this.logServices)r.debug(o,...t)}info(o,...t){for(const r of this.logServices)r.info(o,...t)}warn(o,...t){for(const r of this.logServices)r.warn(o,...t)}error(o,...t){for(const r of this.logServices)r.error(o,...t)}critical(o,...t){for(const r of this.logServices)r.critical(o,...t)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=i;class s extends k.Disposable{constructor(o){super();this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...t){this.logger.trace(o,...t)}debug(o,...t){this.logger.debug(o,...t)}info(o,...t){this.logger.info(o,...t)}warn(o,...t){this.logger.warn(o,...t)}error(o,...t){this.logger.error(o,...t)}critical(o,...t){this.logger.critical(o,...t)}flush(){this.logger.flush()}}e.LogService=s;class v{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(o){}getLevel(){return y.Info}trace(o,...t){}debug(o,...t){}info(o,...t){}warn(o,...t){}error(o,...t){}critical(o,...t){}dispose(){}flush(){}}e.NullLogService=v;function h(a){if(a.verbose)return y.Trace;if(typeof a.logLevel=="string"){const o=E(a.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=h;function E(a){switch(a){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=E;function g(a){switch(a){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=g}),define(be[87],we([0,1,4,125,46]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var S;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function n(i,s){return s-i}y.compare=n;const R=Object.create(null);R[y.Error]=(0,k.localize)(0,null),R[y.Warning]=(0,k.localize)(1,null),R[y.Info]=(0,k.localize)(2,null);function C(i){return R[i]||""}y.toString=C;function b(i){switch(i){case A.default.Error:return y.Error;case A.default.Warning:return y.Warning;case A.default.Info:return y.Info;case A.default.Ignore:return y.Hint}}y.fromSeverity=b;function f(i){switch(i){case y.Error:return A.default.Error;case y.Warning:return A.default.Warning;case y.Info:return A.default.Info;case y.Hint:return A.default.Ignore}}y.toSeverity=f}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(y){const n="";function R(b){return C(b,!0)}y.makeKey=R;function C(b,f){let i=[n];return b.source?i.push(b.source.replace("\xA6","\\\xA6")):i.push(n),b.code?typeof b.code=="string"?i.push(b.code.replace("\xA6","\\\xA6")):i.push(b.code.value.replace("\xA6","\\\xA6")):i.push(n),b.severity!==void 0&&b.severity!==null?i.push(S.toString(b.severity)):i.push(n),b.message&&f?i.push(b.message.replace("\xA6","\\\xA6")):i.push(n),b.startLineNumber!==void 0&&b.startLineNumber!==null?i.push(b.startLineNumber.toString()):i.push(n),b.startColumn!==void 0&&b.startColumn!==null?i.push(b.startColumn.toString()):i.push(n),b.endLineNumber!==void 0&&b.endLineNumber!==null?i.push(b.endLineNumber.toString()):i.push(n),b.endColumn!==void 0&&b.endColumn!==null?i.push(b.endColumn.toString()):i.push(n),i.push(n),i.join("\xA6")}y.makeKeyOptionalMessage=C})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(be[151],we([0,1,46,4,3]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=w.default,e.INotificationService=(0,k.createDecorator)("notificationService");var T;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new y,this.onDidClose=A.Event.None,this.onDidChangeVisibility=A.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=I;class y{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=y});var je=this&&this.__decorate||function(ie,e,w,k){var A=arguments.length,T=A<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,w):k,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(ie,e,w,k);else for(var I=ie.length-1;I>=0;I--)(S=ie[I])&&(T=(A<3?S(T):A>3?S(e,w,T):S(e,w))||T);return A>3&&T&&Object.defineProperty(e,w,T),T},Ke=this&&this.__param||function(ie,e){return function(w,k){e(w,k,ie)}};define(be[152],we([0,1,4,20,6,13]),function(ie,e,w,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,w.createDecorator)("progressService");var S;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let y=class extends A.Disposable{constructor(C,b){super();this.deferred=new T.DeferredPromise,b.withProgress(C,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,A.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};y=je([Ke(1,e.IProgressService)],y),e.UnmanagedProgress=y;class n extends A.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new A.DisposableStore)}start(C){this.stop();const b=++this.currentOperationId,f=new k.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{b===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,A.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,A.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,A.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:b,token:f.token,stop:()=>this.doStop(b),isCurrent:()=>this.currentOperationId===b}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=n,e.IEditorProgressService=(0,w.createDecorator)("editorProgressService")}),define(be[30],we([0,1,12,43]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(S,I){k.ok(w.isString(S)),k.ok(w.isObject(I)),k.ok(!this.data.has(S),"There is already an extension with this id"),this.data.set(S,I)}knows(S){return this.data.has(S)}as(S){return this.data.get(S)||null}}e.Registry=new A}),define(be[88],we([0,1,30,3]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class T{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,n){this.schemasById[A(y)]=n,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const S=new T;w.Registry.add(e.Extensions.JSONContribution,S)}),define(be[66],we([0,1,122,3,30,12,88]),function(ie,e,w,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=A.Registry.as(S.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:w.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(h,E=!0){this.registerConfigurations([h],E)}registerConfigurations(h,E=!0){const g=[];h.forEach(a=>{g.push(...this.validateAndRegisterProperties(a,E)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(g)}deregisterConfigurations(h){const E=[],g=a=>{if(a.properties)for(const o in a.properties)E.push(o),delete this.configurationProperties[o],this.removeFromSchema(o,a.properties[o]);a.allOf&&a.allOf.forEach(o=>g(o))};for(const a of h){g(a);const o=this.configurationContributors.indexOf(a);o!==-1&&this.configurationContributors.splice(o,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}registerDefaultConfigurations(h){const E=[],g=[];for(const a of h)for(const o in a)if(E.push(o),e.OVERRIDE_PROPERTY_PATTERN.test(o)){this.defaultValues[o]=Object.assign(Object.assign({},this.defaultValues[o]||{}),a[o]);const t={type:"object",default:this.defaultValues[o],description:w.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId};g.push(C(o)),this.configurationProperties[o]=t,this.defaultLanguageConfigurationOverridesNode.properties[o]=t}else{this.defaultValues[o]=a[o];const t=this.configurationProperties[o];t&&(this.updatePropertyDefaultValue(o,t),this.updateSchema(o,t))}this.registerOverrideIdentifiers(g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}deregisterDefaultConfigurations(h){const E=[];for(const g of h)for(const a in g)if(E.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const o=this.configurationProperties[a];o&&(this.updatePropertyDefaultValue(a,o),this.updateSchema(a,o))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}notifyConfigurationSchemaUpdated(...h){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(h){for(const E of h)this.overrideIdentifiers.add(E);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(h,E=!0,g=3){g=T.isUndefinedOrNull(h.scope)?g:h.scope;let a=[],o=h.properties;if(o)for(let r in o){if(E&&i(r)){delete o[r];continue}const d=o[r];if(this.updatePropertyDefaultValue(r,d),e.OVERRIDE_PROPERTY_PATTERN.test(r)?d.scope=void 0:d.scope=T.isUndefinedOrNull(d.scope)?g:d.scope,o[r].hasOwnProperty("included")&&!o[r].included){this.excludedConfigurationProperties[r]=o[r],delete o[r];continue}else this.configurationProperties[r]=o[r];!o[r].deprecationMessage&&o[r].markdownDeprecationMessage&&(o[r].deprecationMessage=o[r].markdownDeprecationMessage),a.push(r)}let t=h.allOf;if(t)for(let r of t)a.push(...this.validateAndRegisterProperties(r,E,g));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(h){const E=g=>{let a=g.properties;if(a)for(const t in a)this.updateSchema(t,a[t]);let o=g.allOf;o&&o.forEach(E)};E(h)}updateSchema(h,E){switch(e.allSettings.properties[h]=E,E.scope){case 1:e.applicationSettings.properties[h]=E;break;case 2:e.machineSettings.properties[h]=E;break;case 6:e.machineOverridableSettings.properties[h]=E;break;case 3:e.windowSettings.properties[h]=E;break;case 4:e.resourceSettings.properties[h]=E;break;case 5:e.resourceSettings.properties[h]=E,this.resourceLanguageSettingsSchema.properties[h]=E;break}}removeFromSchema(h,E){switch(delete e.allSettings.properties[h],E.scope){case 1:delete e.applicationSettings.properties[h];break;case 2:delete e.machineSettings.properties[h];break;case 6:delete e.machineOverridableSettings.properties[h];break;case 3:delete e.windowSettings.properties[h];break;case 4:case 5:delete e.resourceSettings.properties[h];break}}updateOverridePropertyPatternKey(){for(const h of this.overrideIdentifiers.values()){const E=`[${h}]`,g={type:"object",description:w.localize(2,null),errorMessage:w.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(E,g),e.allSettings.properties[E]=g,e.applicationSettings.properties[E]=g,e.machineSettings.properties[E]=g,e.machineOverridableSettings.properties[E]=g,e.windowSettings.properties[E]=g,e.resourceSettings.properties[E]=g}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(h,E){let g=this.defaultValues[h];T.isUndefined(g)&&(g=E.default),T.isUndefined(g)&&(g=b(E.type)),E.default=g}}const R="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(R);function C(v){return v.substring(1,v.length-1)}e.overrideIdentifierFromKey=C;function b(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=b;const f=new n;A.Registry.add(e.Extensions.Configuration,f);function i(v){return v.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(v)?w.localize(5,null,v):f.getConfigurationProperties()[v]!==void 0?w.localize(6,null,v):null:w.localize(4,null)}e.validateProperty=i;function s(){const v=[],h=f.getConfigurationProperties();for(const E of Object.keys(h))v.push([E,h[E].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=s}),define(be[89],we([0,1,23,12,2,30,4,66]),function(ie,e,w,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function y(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof A.URI)}e.isConfigurationOverrides=y;var n;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function R(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=R;function C(r,d){const l=d?r?d.keys.filter(P=>r.keys.indexOf(P)===-1):[...d.keys]:[],u=r?d?r.keys.filter(P=>d.keys.indexOf(P)===-1):[...r.keys]:[],m=[];if(d&&r){for(const P of r.keys)if(d.keys.indexOf(P)!==-1){const F=h(r.contents,P),z=h(d.contents,P);w.equals(F,z)||m.push(P)}}const _=[],D=P=>{const F={};for(const z of P)for(const de of z.identifiers)F[o(de)]=z;return F},c=d?D(d.overrides):{},p=r?D(r.overrides):{};if(Object.keys(c).length)for(const P of l){const F=c[P];F&&_.push([(0,I.overrideIdentifierFromKey)(P),F.keys])}if(Object.keys(p).length)for(const P of u){const F=p[P];F&&_.push([(0,I.overrideIdentifierFromKey)(P),F.keys])}if(Object.keys(c).length&&Object.keys(p).length)for(const P of m){const F=p[P],z=c[P];if(F&&z){const de=C({contents:F.contents,keys:F.keys,overrides:[]},{contents:z.contents,keys:z.keys,overrides:[]});_.push([(0,I.overrideIdentifierFromKey)(P),[...de.added,...de.removed,...de.updated]])}}return{added:l,removed:u,updated:m,overrides:_}}e.compare=C;function b(r,d){const l=[];for(const u of Object.keys(r))if(I.OVERRIDE_PROPERTY_PATTERN.test(u)){const m={};for(const _ in r[u])m[_]=r[u][_];l.push({identifiers:[(0,I.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(m),contents:f(m,d)})}return l}e.toOverrides=b;function f(r,d){const l=Object.create(null);for(let u in r)i(l,u,r[u],d);return l}e.toValuesTree=f;function i(r,d,l,u){const m=d.split("."),_=m.pop();let D=r;for(let c=0;c<m.length;c++){let p=m[c],P=D[p];switch(typeof P){case"undefined":P=D[p]=Object.create(null);break;case"object":break;default:u(`Ignoring ${d} as ${m.slice(0,c+1).join(".")} is ${JSON.stringify(P)}`);return}D=P}if(typeof D=="object"&&D!==null)try{D[_]=l}catch(c){u(`Ignoring ${d} as ${m.join(".")} is ${JSON.stringify(D)}`)}else u(`Ignoring ${d} as ${m.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=i;function s(r,d){const l=d.split(".");v(r,l)}e.removeFromValueTree=s;function v(r,d){const l=d.shift();if(d.length===0){delete r[l];return}if(Object.keys(r).indexOf(l)!==-1){const u=r[l];typeof u=="object"&&!Array.isArray(u)&&(v(u,d),Object.keys(u).length===0&&delete r[l])}}function h(r,d,l){function u(D,c){let p=D;for(const P of c){if(typeof p!="object"||p===null)return;p=p[P]}return p}const m=d.split("."),_=u(r,m);return typeof _=="undefined"?l:_}e.getConfigurationValue=h;function E(r,d,l){Object.keys(d).forEach(u=>{u!=="__proto__"&&(u in r?k.isObject(r[u])&&k.isObject(d[u])?E(r[u],d[u],l):l&&(r[u]=d[u]):r[u]=d[u])})}e.merge=E;function g(){const r=T.Registry.as(I.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=g;function a(){const r=Object.create(null),d=T.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(let l in d){let u=d[l].default;i(r,l,u,m=>console.error(`Conflict in default settings: ${m}`))}return r}e.getDefaultValues=a;function o(r){return`[${r}]`}e.keyFromOverrideIdentifier=o;function t(r,d,l){const u=r.inspect(d),m=r.inspect(l);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:u.defaultValue}e.getMigratedSettingValue=t}),define(be[153],we([0,1,44,22,15,12,23,2,66,89,30,6,3]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},r=[],d=[]){this._contents=t,this._keys=r,this._overrides=d,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const d=this.getContentsForOverrideIdentifer(r);return d?t?(0,n.getConfigurationValue)(d,t):d:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let d={};for(const l of A.distinct([...Object.keys(this.contents),...Object.keys(r)])){let u=this.contents[l],m=r[l];m&&(typeof u=="object"&&typeof m=="object"?(u=S.deepClone(u),this.mergeContents(u,m)):u=m),d[l]=u}return new f(d,this.keys,this.overrides)}merge(...t){const r=S.deepClone(this.contents),d=S.deepClone(this.overrides),l=[...this.keys];for(const u of t){this.mergeContents(r,u.contents);for(const m of u.overrides){const[_]=d.filter(D=>A.equals(D.identifiers,m.identifiers));_?this.mergeContents(_.contents,m.contents):d.push(S.deepClone(m))}for(const m of u.keys)l.indexOf(m)===-1&&l.push(m)}return new f(r,l,d)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const d of Object.keys(r)){if(d in t&&T.isObject(t[d])&&T.isObject(r[d])){this.mergeContents(t[d],r[d]);continue}t[d]=S.deepClone(r[d])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?S.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,n.addToValueTree)(this.contents,t,r,d=>{throw new Error(d)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let d=0;d<r;d++)t.indexOf(this.keys[d])===0&&(r=d);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=f;class i extends f{constructor(){const t=(0,n.getDefaultValues)(),r=(0,n.getConfigurationKeys)(),d=[];for(const l of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(l)&&d.push({identifiers:[(0,y.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(t[l]),contents:(0,n.toValuesTree)(t[l],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,r,d)}}e.DefaultConfigurationModel=i;class s{constructor(t,r){this._name=t,this._scopes=r,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get errors(){return this._parseErrors}parseContent(t){if(!T.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r)}}parseRaw(t){this._raw=t;const r=this.doParseRaw(t);this._configurationModel=new f(r.contents,r.keys,r.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let r={},d=null,l=[],u=[],m=[];function _(c){Array.isArray(l)?l.push(c):d&&(l[d]=c)}let D={onObjectBegin:()=>{let c={};_(c),u.push(l),l=c,d=null},onObjectProperty:c=>{d=c},onObjectEnd:()=>{l=u.pop()},onArrayBegin:()=>{let c=[];_(c),u.push(l),l=c,d=null},onArrayEnd:()=>{l=u.pop()},onLiteralValue:_,onError:(c,p,P)=>{m.push({error:c,offset:p,length:P})}};if(t)try{w.visit(t,D),r=l[0]||{}}catch(c){console.error(`Error while parsing settings file ${this._name}: ${c}`),this._parseErrors=[c]}return r}doParseRaw(t){if(this._scopes){const u=R.Registry.as(y.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,u,!0,this._scopes)}const r=(0,n.toValuesTree)(t,u=>console.error(`Conflict in settings file ${this._name}: ${u}`)),d=Object.keys(t),l=(0,n.toOverrides)(t,u=>console.error(`Conflict in settings file ${this._name}: ${u}`));return{contents:r,keys:d,overrides:l}}filterByScope(t,r,d,l){const u={};for(let m in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(m)&&d)u[m]=this.filterByScope(t[m],r,!1,l);else{const _=this.getScope(m,r);(_===void 0||l.indexOf(_)!==-1)&&(u[m]=t[m])}return u}getScope(t,r){const d=r[t];return d?typeof d.scope!="undefined"?d.scope:3:void 0}}e.ConfigurationModelParser=s;class v extends C.Disposable{constructor(t,r,d,l){super();this.userSettingsResource=t,this.scopes=r,this.fileService=l,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new s(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(d.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(b.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new f}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=v;class h{constructor(t,r,d=new f,l=new f,u=new k.ResourceMap,m=new f,_=new k.ResourceMap,D=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=d,this._workspaceConfiguration=l,this._folderConfigurations=u,this._memoryConfiguration=m,this._memoryConfigurationByResource=_,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,r,d){return this.getConsolidateConfigurationModel(r,d).getValue(t)}updateValue(t,r,d={}){let l;d.resource?(l=this._memoryConfigurationByResource.get(d.resource),l||(l=new f,this._memoryConfigurationByResource.set(d.resource,l))):l=this._memoryConfiguration,r===void 0?l.removeValue(t):l.setValue(t,r),d.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,d){const l=this.getConsolidateConfigurationModel(r,d),u=this.getFolderConfigurationModelForResource(r.resource,d),m=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,_=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),D=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),c=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),p=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),P=d?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=u?r.overrideIdentifier?u.freeze().override(r.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,z=r.overrideIdentifier?m.override(r.overrideIdentifier).getValue(t):m.getValue(t),de=l.getValue(t),B=A.distinct(A.flatten(l.overrides.map(W=>W.identifiers))).filter(W=>l.getOverrideValue(t,W)!==void 0);return{defaultValue:_,userValue:D,userLocalValue:c,userRemoteValue:p,workspaceValue:P,workspaceFolderValue:F,memoryValue:z,value:de,default:_!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:c!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:p!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:P!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:u==null?void 0:u.freeze().getValue(t),override:r.overrideIdentifier?u==null?void 0:u.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:m.getValue(t),override:r.overrideIdentifier?m.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:B.length?B:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const d=r.filter(l=>y.OVERRIDE_PROPERTY_PATTERN.test(l)).map(l=>{const u=(0,y.overrideIdentifierFromKey)(l),m=this._defaultConfiguration.getKeysForOverrideIdentifier(u),_=t.getKeysForOverrideIdentifier(u),D=[..._.filter(c=>m.indexOf(c)===-1),...m.filter(c=>_.indexOf(c)===-1),...m.filter(c=>!S.equals(this._defaultConfiguration.override(u).getValue(c),t.override(u).getValue(c)))];return[u,D]});return this.updateDefaultConfiguration(t),{keys:r,overrides:d}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:d,removed:l,overrides:u}=(0,n.compare)(this.localUserConfiguration,t),m=[...r,...d,...l];return m.length&&this.updateLocalUserConfiguration(t),{keys:m,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:d,removed:l,overrides:u}=(0,n.compare)(this.remoteUserConfiguration,t);let m=[...r,...d,...l];return m.length&&this.updateRemoteUserConfiguration(t),{keys:m,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:d,removed:l,overrides:u}=(0,n.compare)(this.workspaceConfiguration,t);let m=[...r,...d,...l];return m.length&&this.updateWorkspaceConfiguration(t),{keys:m,overrides:u}}compareAndUpdateFolderConfiguration(t,r){const d=this.folderConfigurations.get(t),{added:l,updated:u,removed:m,overrides:_}=(0,n.compare)(d,r);let D=[...l,...u,...m];return(D.length||!d)&&this.updateFolderConfiguration(t,r),{keys:D,overrides:_}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:d,updated:l,removed:u,overrides:m}=(0,n.compare)(r,void 0);return{keys:[...d,...l,...u],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let d=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?d.override(t.overrideIdentifier):d}getConsolidatedConfigurationModelForResource({resource:t},r){let d=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const l=r.getFolder(t);l&&(d=this.getFolderConsolidatedConfiguration(l.uri)||d);const u=this._memoryConfigurationByResource.get(t);u&&(d=d.merge(u))}return d}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const d=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(t);l?(r=d.merge(l),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=d}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const d=r.getFolder(t);if(d)return this._folderConfigurations.get(d.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:d,overrides:l,keys:u}=this._folderConfigurations.get(r);return t.push([r,{contents:d,overrides:l,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(d=>t.add(d))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(d=>r.add(d)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(d=>r.add(d)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(d=>r.add(d)),this._folderConfigurations.forEach(d=>d.getKeysForOverrideIdentifier(t).forEach(l=>r.add(l))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),d=this.parseConfigurationModel(t.user),l=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((m,_)=>(m.set(I.URI.revive(_[0]),this.parseConfigurationModel(_[1])),m),new k.ResourceMap);return new h(r,d,new f,l,u,new f,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=h;function E(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,r=new Map;for(const l of o)l.keys.forEach(u=>t.add(u)),l.overrides.forEach(([u,m])=>{const _=(0,k.getOrSet)(r,u,new Set);m.forEach(D=>_.add(D))});const d=[];return r.forEach((l,u)=>d.push([u,[...l.values()]])),{keys:[...t.values()],overrides:d}}e.mergeChanges=E;class g{constructor(t,r,d,l){this.change=t,this.previous=r,this.currentConfiguraiton=d,this.currentWorkspace=l,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(_=>u.add(_)),t.overrides.forEach(([,_])=>_.forEach(D=>u.add(D))),this.affectedKeys=[...u.values()];const m=new f;this.affectedKeys.forEach(_=>m.setValue(_,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var d;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const l=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(d=this.previous)===null||d===void 0?void 0:d.workspace):void 0,u=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!S.equals(l,u)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let d=(0,n.toValuesTree)({[r]:!0},()=>{}),l;for(;typeof d=="object"&&(l=Object.keys(d)[0]);){if(t=t[l],!t)return!1;d=d[l]}return!0}}e.ConfigurationChangeEvent=g;class a extends g{constructor(t,r,d,l){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=d,this.sourceConfig=l}}e.AllKeysConfigurationChangeEvent=a}),define(be[90],we([0,1,4]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,w.createDecorator)("remoteAuthorityResolverService");var k;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends Error{constructor(S,I=k.Unknown,y){super(S);this._message=S,this._code=I,this._detail=y,this.isHandled=I===k.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(S){return S instanceof A&&S._code===k.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof A&&S._code===k.NoResolverFound}static isHandled(S){return S instanceof A&&S.isHandled}}e.RemoteAuthorityResolverError=A}),define(be[91],we([0,1,18]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function k(T){return T.scheme===w.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=k;function A(T){if(!!T){const S=T.indexOf("+");return S<0?T:T.substr(0,S)}}e.getRemoteName=A}),define(be[154],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class w{constructor(A){this._callback=A,this._terminalBufferMap=new Map}dispose(){for(const A of this._terminalBufferMap.values())A.dispose()}startBuffering(A,T,S=5){let I;return I=T(y=>{const n=typeof y=="string"?y:y.data;let R=this._terminalBufferMap.get(A);if(R){R.data.push(n);return}const C=setTimeout(()=>this.flushBuffer(A),S);R={data:[n],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(A),I.dispose()}},this._terminalBufferMap.set(A,R)}),I}stopBuffering(A){const T=this._terminalBufferMap.get(A);T&&T.dispose()}flushBuffer(A){const T=this._terminalBufferMap.get(A);T&&(this._terminalBufferMap.delete(A),this._callback(A,T.data.join("")))}}e.TerminalDataBufferer=w}),define(be[155],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(be[156],we([0,1,4,6,30,3,155,37]),function(ie,e,w,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,w.createDecorator)("themeService");var y;(function(v){function h(E){return E&&typeof E=="object"&&typeof E.id=="string"}v.isThemeColor=h})(y=e.ThemeColor||(e.ThemeColor={}));function n(v){return{id:v}}e.themeColorFromId=n;var R;(function(v){function h(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}v.isThemeIcon=h;const E=new RegExp(`^\\$\\((${I.CSSIcon.iconNameExpression}(?:${I.CSSIcon.iconModifierExpression})?)\\)$`);function g(t){const r=E.exec(t);if(!!r){let[,d]=r;return{id:d}}}v.fromString=g;function a(t,r){let d=t.id;const l=d.lastIndexOf("~");return l!==-1&&(d=d.substring(0,l)),r&&(d=`${d}~${r}`),{id:d}}v.modify=a;function o(t,r){var d,l;return t.id===r.id&&((d=t.color)===null||d===void 0?void 0:d.id)===((l=r.color)===null||l===void 0?void 0:l.id)}v.isEqual=o,v.asClassNameArray=I.CSSIcon.asClassNameArray,v.asClassName=I.CSSIcon.asClassName,v.asCSSSelector=I.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=I.Codicon.file,e.FolderThemeIcon=I.Codicon.folder;function C(v){switch(v){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(h){return this.themingParticipants.push(h),this.onThemingParticipantAddedEmitter.fire(h),(0,k.toDisposable)(()=>{const E=this.themingParticipants.indexOf(h);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new b;A.Registry.add(e.Extensions.ThemingContribution,f);function i(v){return f.onColorThemeChange(v)}e.registerThemingParticipant=i;class s extends k.Disposable{constructor(h){super();this.themeService=h,this.theme=h.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(h){this.theme=h,this.updateStyles()}updateStyles(){}getColor(h,E){let g=this.theme.getColor(h);return g&&E&&(g=E(g,this.theme)),g?g.toString():null}}e.Themable=s}),define(be[157],we([0,1,30,156,3,126,88,13,37]),function(ie,e,w,k,A,T,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class n{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(h,E,g,a){const o=this.iconsById[h];if(o){if(g&&!o.description){o.description=g,this.iconSchema.properties[h].markdownDescription=`${g} $(${h})`;const d=this.iconReferenceSchema.enum.indexOf(h);d!==-1&&(this.iconReferenceSchema.enumDescriptions[d]=g),this._onDidChange.fire()}return o}let t={id:h,description:g,defaults:E,deprecationMessage:a};this.iconsById[h]=t;let r={$ref:"#/definitions/icons"};return a&&(r.deprecationMessage=a),g&&(r.markdownDescription=`${g}: $(${h})`),this.iconSchema.properties[h]=r,this.iconReferenceSchema.enum.push(h),this.iconReferenceSchema.enumDescriptions.push(g||""),this._onDidChange.fire(),{id:h}}deregisterIcon(h){delete this.iconsById[h],delete this.iconSchema.properties[h];const E=this.iconReferenceSchema.enum.indexOf(h);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(h=>this.iconsById[h])}getIcon(h){return this.iconsById[h]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(h,E){const g=this.iconFontsById[h];if(g)return g;let a={id:h,definition:E};return this.iconFontsById[h]=a,this._onDidChange.fire(),a}deregisterIconFont(h){delete this.iconFontsById[h]}getIconFonts(){return Object.keys(this.iconFontsById).map(h=>this.iconFontsById[h])}getIconFont(h){return this.iconFontsById[h]}toString(){const h=(o,t)=>o.id.localeCompare(t.id),E=o=>{for(;k.ThemeIcon.isThemeIcon(o.defaults);)o=this.iconsById[o.defaults.id];return`codicon codicon-${o?o.id:""}`};let g=[];g.push("| preview     | identifier                        | default codicon ID                | description"),g.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.iconsById).map(o=>this.iconsById[o]);for(const o of a.filter(t=>!!t.description).sort(h))g.push(`|<i class="${E(o)}"></i>|${o.id}|${k.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);g.push("| preview     | identifier                        "),g.push("| ----------- | --------------------------------- |");for(const o of a.filter(t=>!k.ThemeIcon.isThemeIcon(t.defaults)).sort(h))g.push(`|<i class="${E(o)}"></i>|${o.id}|`);return g.join(`
`)}}const R=new n;w.Registry.add(e.Extensions.IconContribution,R);function C(v,h,E,g){return R.registerIcon(v,h,E,g)}e.registerIcon=C;function b(){return R}e.getIconRegistry=b;function f(){for(const v of y.iconRegistry.all)R.registerIcon(v.id,v.definition,v.description);y.iconRegistry.onDidRegister(v=>R.registerIcon(v.id,v.definition,v.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let i=w.Registry.as(S.Extensions.JSONContribution);i.registerSchema(e.iconsSchemaId,R.getIconSchema());const s=new I.RunOnceScheduler(()=>i.notifySchemaChanged(e.iconsSchemaId),200);R.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.widgetClose=C("widget-close",y.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",y.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",y.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=k.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(be[47],we([0,1,2,25,4,22]),function(ie,e,w,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var S;(function(b){b[b.EMPTY=1]="EMPTY",b[b.FOLDER=2]="FOLDER",b[b.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function I(b){const f=b;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=I;function y(b){const f=b;return!!(f&&typeof f=="object"&&w.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=y;class n{constructor(f,i,s,v){this._id=f,this._configuration=s,this._ignorePathCasing=v,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=i}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class R{constructor(f,i){this.raw=i,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,k.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function C(b){return new R({uri:b,index:0,name:(0,k.basenameOrAuthority)(b)},{uri:b.toString()})}e.toWorkspaceFolder=C}),define(be[158],we([0,1,4,127,47,2,21,11,25,105,44,18,58,38,91]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const s=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(K){return(typeof K=="string"?(0,I.extname)(K):(0,y.extname)(K))===s}e.hasWorkspaceFileExtension=v,e.IWorkspacesService=(0,w.createDecorator)("workspacesService");function h(K){return K.hasOwnProperty("workspace")}e.isRecentWorkspace=h;function E(K){return K.hasOwnProperty("folderUri")}e.isRecentFolder=E;function g(K){return K.hasOwnProperty("fileUri")}e.isRecentFile=g;function a(K){const M=K;return typeof(M==null?void 0:M.id)=="string"&&T.URI.isUri(M.uri)}e.isSingleFolderWorkspaceIdentifier=a;function o(K){if(K.configuration)return{id:K.id,configPath:K.configuration};if(K.folders.length===1)return{id:K.id,uri:K.folders[0].uri}}e.toWorkspaceIdentifier=o;function t(K){const M=K;return typeof(M==null?void 0:M.id)=="string"&&T.URI.isUri(M.configPath)}e.isWorkspaceIdentifier=t;function r(K){const M=K;if(M==null?void 0:M.uri)return{id:M.id,uri:T.URI.revive(M.uri)};const U=K;if(U==null?void 0:U.configPath)return{id:U.id,configPath:T.URI.revive(U.configPath)};if(K==null?void 0:K.id)return{id:K.id}}e.reviveIdentifier=r;function d(K,M){return y.extUriBiasedIgnorePathCase.isEqualOrParent(K,M.untitledWorkspacesHome)}e.isUntitledWorkspace=d;function l(K){return u(K)||m(K)}e.isStoredWorkspaceFolder=l;function u(K){const M=K;return typeof(M==null?void 0:M.path)=="string"&&(!M.name||typeof M.name=="string")}e.isRawFileWorkspaceFolder=u;function m(K){const M=K;return typeof(M==null?void 0:M.uri)=="string"&&(!M.name||typeof M.name=="string")}e.isRawUriWorkspaceFolder=m;function _(K,M,U,x,Q=!S.isWindows,$){if(K.scheme!==x.scheme)return{name:U,uri:K.toString(!0)};let ee=M?void 0:$.relativePath(x,K);if(ee!==void 0)ee.length===0?ee=".":S.isWindows&&K.scheme===C.Schemas.file&&!Q&&(ee=ee.replace(/\//g,"\\"));else if(K.scheme===C.Schemas.file)ee=K.fsPath,S.isWindows&&(ee=(0,b.normalizeDriveLetter)(ee),Q&&(ee=(0,f.toSlashes)(ee)));else{if(!$.isEqualAuthority(K.authority,x.authority))return{name:U,uri:K.toString(!0)};ee=K.path}return{name:U,path:ee}}e.getStoredWorkspaceFolder=_;function D(K,M,U){let x=[],Q=new Set;const $=U.dirname(M);for(let ee of K){let re=null;if(u(ee))ee.path&&(re=U.resolvePath($,ee.path));else if(m(ee))try{re=T.URI.parse(ee.uri),re.path[0]!=="/"&&(re=re.with({path:"/"+re.path}))}catch(se){console.warn(se)}if(re){let se=U.getComparisonKey(re);if(!Q.has(se)){Q.add(se);const ye=ee.name||U.basenameOrAuthority(re);x.push(new A.WorkspaceFolder({uri:re,name:ye,index:x.length},ee))}}}return x}e.toWorkspaceFolders=D;function c(K,M,U,x,Q){let $=p(M,K);const ee=Q.dirname(M),re=Q.dirname(x),se=[],ye=P($.folders);for(const ze of $.folders){const N=u(ze)?Q.resolvePath(ee,ze.path):T.URI.parse(ze.uri);let G;U?G=!1:G=!u(ze)||(0,I.isAbsolute)(ze.path),se.push(_(N,G,ze.name,re,ye,Q))}const Ie={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},xe=n.setProperty(K,["folders"],se,Ie);let Fe=n.applyEdits(K,xe);return $.remoteAuthority===(0,i.getRemoteAuthority)(x)&&(Fe=n.applyEdits(Fe,n.removeProperty(Fe,["remoteAuthority"],Ie))),Fe}e.rewriteWorkspaceFileForNewLocation=c;function p(K,M){let U=R.parse(M);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(x=>l(x));else throw new Error(`${K} looks like an invalid workspace file.`);return U}function P(K){return S.isWindows?K.some(M=>u(M)&&M.path.indexOf("/")>=0):!0}e.useSlashForPath=P;function F(K){return K.workspace&&typeof K.workspace=="object"&&typeof K.workspace.id=="string"&&typeof K.workspace.configPath=="string"}function z(K){return typeof K.folderUri=="string"}function de(K){return typeof K.fileUri=="string"}function B(K,M){const U={workspaces:[],files:[]};if(K){const x=function($,ee){for(let re=0;re<$.length;re++)try{ee($[re],re)}catch(se){M.warn(`Error restoring recent entry ${JSON.stringify($[re])}: ${se.toString()}. Skip entry.`)}},Q=K;if(Array.isArray(Q.entries))x(Q.entries,$=>{const ee=$.label,re=$.remoteAuthority;F($)?U.workspaces.push({label:ee,remoteAuthority:re,workspace:{id:$.workspace.id,configPath:T.URI.parse($.workspace.configPath)}}):z($)?U.workspaces.push({label:ee,remoteAuthority:re,folderUri:T.URI.parse($.folderUri)}):de($)&&U.files.push({label:ee,remoteAuthority:re,fileUri:T.URI.parse($.fileUri)})});else{const $=K;Array.isArray($.workspaces3)&&x($.workspaces3,(ee,re)=>{const se=Array.isArray($.workspaceLabels)&&$.workspaceLabels[re]||void 0;typeof ee=="object"&&typeof ee.id=="string"&&typeof ee.configURIPath=="string"?U.workspaces.push({label:se,workspace:{id:ee.id,configPath:T.URI.parse(ee.configURIPath)}}):typeof ee=="string"&&U.workspaces.push({label:se,folderUri:T.URI.parse(ee)})}),Array.isArray($.files2)&&x($.files2,(ee,re)=>{const se=Array.isArray($.fileLabels)&&$.fileLabels[re]||void 0;typeof ee=="string"&&U.files.push({label:se,fileUri:T.URI.parse(ee)})})}}return U}e.restoreRecentlyOpened=B;function W(K){const M={entries:[]};for(const U of K.workspaces)E(U)?M.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):M.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of K.files)M.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return M}e.toStoreData=W}),define(be[92],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class w{constructor(A){this.id=A,this._data=new Map,this._idPool=1}add(A){const T=this._idPool++;return this._data.set(T,A),this.logDebugInfo(),T}get(A,T){return this._data.has(A)?this._data.get(A)[T]:void 0}delete(A){this._data.delete(A),this.logDebugInfo()}logDebugInfo(){!w.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=w,w.enableDebugLogging=!1}),define(be[159],we([0,1,2,3]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class A{constructor(){this._onDidChangeTabs=new k.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(S){this._tabs=S.map(I=>({name:I.name,group:I.group,resource:w.URI.revive(I.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(be[48],we([0,1,18,4]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(w.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(S,I){I===null?this._providerInfo.delete(S):this._providerInfo.set(S,I)}isFreeScheme(S){return!this._providerInfo.has(S)&&!this._systemSchemes.has(S)}getCapabilities(S){return this._providerInfo.get(S)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(be[27],we([0,1,4]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,w.createDecorator)("IExtHostInitDataService")}),define(be[160],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class w{constructor(T,S,I){this._id=T,this._shared=S,this._storage=I,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)})}get whenReady(){return this._init}get(T,S){let I=this._value[T];return typeof I=="undefined"&&(I=S),I}update(T,S){return this._value[T]=S,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=w;class k extends w{constructor(T,S){super(T.identifier.value,!0,S);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=k}),define(be[14],we([0,1,4]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,w.createDecorator)("IExtHostRpcService");class k{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=k});var tt=this&&this.__classPrivateFieldSet||function(ie,e,w,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(ie,w):A?A.value=w:e.set(ie,w),w},Ue=this&&this.__classPrivateFieldGet||function(ie,e,w,k){if(w==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?k:w==="a"?k.call(ie):k?k.value:e.get(ie)};define(be[161],we([0,1,26,3]),function(ie,e,w,k){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(I,y){A.set(this,void 0),this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._id=w.ExtensionIdentifier.toKey(I.identifier),tt(this,A,y,"f"),Ue(this,A,"f").onDidChangePassword(n=>{n.extensionId===this._id&&this._onDidChange.fire({key:n.key})})}get(I){return Ue(this,A,"f").get(this._id,I)}store(I,y){return Ue(this,A,"f").store(this._id,I,y)}delete(I){return Ue(this,A,"f").delete(this._id,I)}}e.ExtensionSecrets=T,A=new WeakMap}),define(be[93],we([0,1,4,3]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class A{constructor(){this._onDidChangeTelemetryEnabled=new k.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(S){this._enabled=S}$onDidChangeTelemetryEnabled(S){this._enabled=S,this._onDidChangeTelemetryEnabled.fire(S)}}e.ExtHostTelemetry=A,e.IExtHostTelemetry=(0,w.createDecorator)("IExtHostTelemetry")}),define(be[67],we([0,1,4,3,14]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(I){function y(R){return{remoteAddress:R.remoteAddress,localAddress:R.localAddress,public:!!R.public}}I.fromApiTunnel=y;function n(R){return{remoteAddress:{host:R.tunnelRemoteHost,port:R.tunnelRemotePort},localAddress:R.localAddress,public:R.public}}I.fromServiceTunnel=n})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,w.createDecorator)("IExtHostTunnelService");let S=class{constructor(y){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,n){return{dispose:()=>{}}}async $providePortAttributes(y,n,R,C,b){return[]}async $forwardPort(y,n){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};S=je([Ke(0,A.IExtHostRpcService)],S),e.ExtHostTunnelService=S});var tt=this&&this.__classPrivateFieldSet||function(ie,e,w,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(ie,w):A?A.value=w:e.set(ie,w),w},Ue=this&&this.__classPrivateFieldGet||function(ie,e,w,k){if(w==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?k:w==="a"?k.call(ie):k?k.value:e.get(ie)};define(be[7],we([0,1,15,10,80,22,12,2,29,64,90]),function(ie,e,w,k,A,T,S,I,y,n,R){"use strict";var C,b,f,i,s,v,h,E,g,a,o,t,r,d,l,u,m,_;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItem=e.TestChildrenCollection=e.TestItemHookProperty=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function D(O){function L(){return Reflect.construct(O,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(O,"name")),Object.setPrototypeOf(L,O),Object.setPrototypeOf(L.prototype,O.prototype),L}let c=s=class{constructor(L){C.set(this,void 0),tt(this,C,L,"f")}static from(...L){let Z=L;return new s(function(){if(Z){for(const Ee of Z)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();Z=void 0}})}dispose(){typeof Ue(this,C,"f")=="function"&&(Ue(this,C,"f").call(this),tt(this,C,void 0,"f"))}};C=new WeakMap,c=s=je([D],c),e.Disposable=c;let p=v=class{constructor(L,Z){if(L<0)throw(0,k.illegalArgument)("line must be non-negative");if(Z<0)throw(0,k.illegalArgument)("character must be non-negative");this._line=L,this._character=Z}static Min(...L){if(L.length===0)throw new TypeError;let Z=L[0];for(let Ee=1;Ee<L.length;Ee++){const We=L[Ee];We.isBefore(Z)&&(Z=We)}return Z}static Max(...L){if(L.length===0)throw new TypeError;let Z=L[0];for(let Ee=1;Ee<L.length;Ee++){const We=L[Ee];We.isAfter(Z)&&(Z=We)}return Z}static isPosition(L){if(!L)return!1;if(L instanceof v)return!0;let{line:Z,character:Ee}=L;return typeof Z=="number"&&typeof Ee=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,Z=0){if(L===null||Z===null)throw(0,k.illegalArgument)();let Ee;return typeof L=="undefined"?Ee=0:typeof L=="number"?Ee=L:(Ee=typeof L.lineDelta=="number"?L.lineDelta:0,Z=typeof L.characterDelta=="number"?L.characterDelta:0),Ee===0&&Z===0?this:new v(this.line+Ee,this.character+Z)}with(L,Z=this.character){if(L===null||Z===null)throw(0,k.illegalArgument)();let Ee;return typeof L=="undefined"?Ee=this.line:typeof L=="number"?Ee=L:(Ee=typeof L.line=="number"?L.line:this.line,Z=typeof L.character=="number"?L.character:this.character),Ee===this.line&&Z===this.character?this:new v(Ee,Z)}toJSON(){return{line:this.line,character:this.character}}};p=v=je([D],p),e.Position=p;let P=h=class{constructor(L,Z,Ee,We){let Je,it;if(typeof L=="number"&&typeof Z=="number"&&typeof Ee=="number"&&typeof We=="number"?(Je=new p(L,Z),it=new p(Ee,We)):L instanceof p&&Z instanceof p&&(Je=L,it=Z),!Je||!it)throw new Error("Invalid arguments");Je.isBefore(it)?(this._start=Je,this._end=it):(this._start=it,this._end=Je)}static isRange(L){return L instanceof h?!0:L?p.isPosition(L.start)&&p.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof h?this.contains(L._start)&&this.contains(L._end):L instanceof p?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const Z=p.Max(L.start,this._start),Ee=p.Min(L.end,this._end);if(!Z.isAfter(Ee))return new h(Z,Ee)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const Z=p.Min(L.start,this._start),Ee=p.Max(L.end,this.end);return new h(Z,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,Z=this.end){if(L===null||Z===null)throw(0,k.illegalArgument)();let Ee;return L?p.isPosition(L)?Ee=L:(Ee=L.start||this.start,Z=L.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&Z.isEqual(this.end)?this:new h(Ee,Z)}toJSON(){return[this.start,this.end]}};P=h=je([D],P),e.Range=P;let F=E=class extends P{constructor(L,Z,Ee,We){let Je,it;if(typeof L=="number"&&typeof Z=="number"&&typeof Ee=="number"&&typeof We=="number"?(Je=new p(L,Z),it=new p(Ee,We)):L instanceof p&&Z instanceof p&&(Je=L,it=Z),!Je||!it)throw new Error("Invalid arguments");super(Je,it);this._anchor=Je,this._active=it}static isSelection(L){return L instanceof E?!0:L?P.isRange(L)&&p.isPosition(L.anchor)&&p.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};F=E=je([D],F),e.Selection=F;class z{constructor(L,Z,Ee){if(typeof L!="string"||L.length===0)throw(0,k.illegalArgument)("host");if(typeof Z!="number"||Z===0||Math.round(Z)!==Z)throw(0,k.illegalArgument)("port");if(typeof Ee!="undefined"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,k.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(Z),this.connectionToken=Ee}}e.ResolvedAuthority=z;class de extends Error{constructor(L,Z=R.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(L);this._message=L,this._code=Z,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,de.prototype)}static NotAvailable(L,Z){return new de(L,R.RemoteAuthorityResolverErrorCode.NotAvailable,Z)}static TemporarilyNotAvailable(L){return new de(L,R.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=de;var B;(function(O){O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(B=e.EndOfLine||(e.EndOfLine={}));var W;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let K=g=class{constructor(L,Z){this._range=L,this._newText=Z}static isTextEdit(L){return L instanceof g?!0:L?P.isRange(L)&&typeof L.newText=="string":!1}static replace(L,Z){return new g(L,Z)}static insert(L,Z){return g.replace(new P(L,L),Z)}static delete(L){return g.replace(L,"")}static setEndOfLine(L){const Z=new g(new P(new p(0,0),new p(0,0)),"");return Z.newEol=L,Z}get range(){return this._range}set range(L){if(L&&!P.isRange(L))throw(0,k.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,k.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,k.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};K=g=je([D],K),e.TextEdit=K;var M;(function(O){O[O.File=1]="File",O[O.Text=2]="Text",O[O.Cell=3]="Cell",O[O.CellOutput=4]="CellOutput",O[O.CellReplace=5]="CellReplace",O[O.CellOutputItem=6]="CellOutputItem"})(M=e.FileEditType||(e.FileEditType={}));let U=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,Z,Ee,We){this._edits.push({_type:1,from:L,to:Z,options:Ee,metadata:We})}createFile(L,Z,Ee){this._edits.push({_type:1,from:void 0,to:L,options:Z,metadata:Ee})}deleteFile(L,Z,Ee){this._edits.push({_type:1,from:L,to:void 0,options:Z,metadata:Ee})}replaceNotebookMetadata(L,Z,Ee){this._edits.push({_type:3,metadata:Ee,uri:L,edit:{editType:5,metadata:Z},notebookMetadata:Z})}replaceNotebookCells(L,Z,Ee,We,Je){(Z!==Ee||We.length>0)&&this._edits.push({_type:5,uri:L,index:Z,count:Ee-Z,cells:We,metadata:Je})}replaceNotebookCellOutput(L,Z,Ee,We){this._editNotebookCellOutput(L,Z,!1,Ee,We)}appendNotebookCellOutput(L,Z,Ee,We){this._editNotebookCellOutput(L,Z,!0,Ee,We)}replaceNotebookCellOutputItems(L,Z,Ee,We,Je){this._editNotebookCellOutputItems(L,Z,Ee,!1,We,Je)}appendNotebookCellOutputItems(L,Z,Ee,We,Je){this._editNotebookCellOutputItems(L,Z,Ee,!0,We,Je)}_editNotebookCellOutputItems(L,Z,Ee,We,Je,it){this._edits.push({_type:6,metadata:it,uri:L,index:Z,outputId:Ee,append:We,newOutputItems:Je})}_editNotebookCellOutput(L,Z,Ee,We,Je){this._edits.push({_type:4,metadata:Je,uri:L,index:Z,append:Ee,newOutputs:We,newMetadata:void 0})}replaceNotebookCellMetadata(L,Z,Ee,We){this._edits.push({_type:3,metadata:We,uri:L,edit:{editType:11,index:Z,metadata:Ee}})}replace(L,Z,Ee,We){this._edits.push({_type:2,uri:L,edit:new K(Z,Ee),metadata:We})}insert(L,Z,Ee,We){this.replace(L,new P(Z,Z),Ee,We)}delete(L,Z,Ee){this.replace(L,Z,"",Ee)}has(L){return this._edits.some(Z=>Z._type===2&&Z.uri.toString()===L.toString())}set(L,Z){if(Z)for(const Ee of Z)Ee&&this._edits.push({_type:2,uri:L,edit:Ee});else{for(let Ee=0;Ee<this._edits.length;Ee++){const We=this._edits[Ee];We._type===2&&We.uri.toString()===L.toString()&&(this._edits[Ee]=void 0)}(0,w.coalesceInPlace)(this._edits)}}get(L){const Z=[];for(let Ee of this._edits)Ee._type===2&&Ee.uri.toString()===L.toString()&&Z.push(Ee.edit);return Z}entries(){const L=new T.ResourceMap;for(let Z of this._edits)if(Z._type===2){let Ee=L.get(Z.uri);Ee||(Ee=[Z.uri,[]],L.set(Z.uri,Ee)),Ee[1].push(Z.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};U=je([D],U),e.WorkspaceEdit=U;let x=a=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof a?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=a._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,Z=this._tabstop++){if(typeof L=="function"){const Ee=new a;Ee._tabstop=this._tabstop,L(Ee),this._tabstop=Ee._tabstop,L=Ee.value}else L=a._escape(L);return this.value+="${",this.value+=Z,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,Z=this._tabstop++){const Ee=L.map(We=>We.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Z,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(L,Z){if(typeof Z=="function"){const Ee=new a;Ee._tabstop=this._tabstop,Z(Ee),this._tabstop=Ee._tabstop,Z=Ee.value}else typeof Z=="string"&&(Z=Z.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,Z&&(this.value+=":",this.value+=Z),this.value+="}",this}};x=a=je([D],x),e.SnippetString=x;var Q;(function(O){O[O.Unnecessary=1]="Unnecessary",O[O.Deprecated=2]="Deprecated"})(Q=e.DiagnosticTag||(e.DiagnosticTag={}));var $;(function(O){O[O.Hint=3]="Hint",O[O.Information=2]="Information",O[O.Warning=1]="Warning",O[O.Error=0]="Error"})($=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ee=o=class{constructor(L,Z){if(this.uri=L,Z)if(Z instanceof P)this.range=Z;else if(Z instanceof p)this.range=new P(Z,Z);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof o?!0:L?P.isRange(L.range)&&I.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ee=o=je([D],ee),e.Location=ee;let re=class{constructor(L,Z){this.location=L,this.message=Z}static is(L){return L?typeof L.message=="string"&&L.location&&P.isRange(L.location.range)&&I.URI.isUri(L.location.uri):!1}static isEqual(L,Z){return L===Z?!0:!L||!Z?!1:L.message===Z.message&&L.location.range.isEqual(Z.location.range)&&L.location.uri.toString()===Z.location.uri.toString()}};re=je([D],re),e.DiagnosticRelatedInformation=re;let se=class{constructor(L,Z,Ee=$.Error){if(!P.isRange(L))throw new TypeError("range must be set");if(!Z)throw new TypeError("message must be set");this.range=L,this.message=Z,this.severity=Ee}toJSON(){return{severity:$[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,Z){return L===Z?!0:!L||!Z?!1:L.message===Z.message&&L.severity===Z.severity&&L.code===Z.code&&L.severity===Z.severity&&L.source===Z.source&&L.range.isEqual(Z.range)&&(0,w.equals)(L.tags,Z.tags)&&(0,w.equals)(L.relatedInformation,Z.relatedInformation,re.isEqual)}};se=je([D],se),e.Diagnostic=se;let ye=class{constructor(L,Z){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:(0,A.isMarkdownString)(L)?this.contents=[L]:this.contents=[L],this.range=Z}};ye=je([D],ye),e.Hover=ye;var Ie;(function(O){O[O.Text=0]="Text",O[O.Read=1]="Read",O[O.Write=2]="Write"})(Ie=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let xe=class{constructor(L,Z=Ie.Text){this.range=L,this.kind=Z}toJSON(){return{range:this.range,kind:Ie[this.kind]}}};xe=je([D],xe),e.DocumentHighlight=xe;var Fe;(function(O){O[O.File=0]="File",O[O.Module=1]="Module",O[O.Namespace=2]="Namespace",O[O.Package=3]="Package",O[O.Class=4]="Class",O[O.Method=5]="Method",O[O.Property=6]="Property",O[O.Field=7]="Field",O[O.Constructor=8]="Constructor",O[O.Enum=9]="Enum",O[O.Interface=10]="Interface",O[O.Function=11]="Function",O[O.Variable=12]="Variable",O[O.Constant=13]="Constant",O[O.String=14]="String",O[O.Number=15]="Number",O[O.Boolean=16]="Boolean",O[O.Array=17]="Array",O[O.Object=18]="Object",O[O.Key=19]="Key",O[O.Null=20]="Null",O[O.EnumMember=21]="EnumMember",O[O.Struct=22]="Struct",O[O.Event=23]="Event",O[O.Operator=24]="Operator",O[O.TypeParameter=25]="TypeParameter"})(Fe=e.SymbolKind||(e.SymbolKind={}));var ze;(function(O){O[O.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let N=t=class{constructor(L,Z,Ee,We,Je){this.name=L,this.kind=Z,this.containerName=Je,typeof Ee=="string"&&(this.containerName=Ee),We instanceof ee?this.location=We:Ee instanceof P&&(this.location=new ee(We,Ee)),t.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Fe[this.kind],location:this.location,containerName:this.containerName}}};N=t=je([D],N),e.SymbolInformation=N;let G=r=class{constructor(L,Z,Ee,We,Je){this.name=L,this.detail=Z,this.kind=Ee,this.range=We,this.selectionRange=Je,this.children=[],r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(r.validate)}};G=r=je([D],G),e.DocumentSymbol=G;var te;(function(O){O[O.Invoke=1]="Invoke",O[O.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(L,Z){this.title=L,this.kind=Z}};ae=je([D],ae),e.CodeAction=ae;let me=d=class{constructor(L){this.value=L}append(L){return new d(this.value?this.value+d.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+d.sep)}};me.sep=".",me=d=je([D],me),e.CodeActionKind=me,me.Empty=new me(""),me.QuickFix=me.Empty.append("quickfix"),me.Refactor=me.Empty.append("refactor"),me.RefactorExtract=me.Refactor.append("extract"),me.RefactorInline=me.Refactor.append("inline"),me.RefactorRewrite=me.Refactor.append("rewrite"),me.Source=me.Empty.append("source"),me.SourceOrganizeImports=me.Source.append("organizeImports"),me.SourceFixAll=me.Source.append("fixAll");let Se=class{constructor(L,Z){if(this.range=L,this.parent=Z,Z&&!Z.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Se=je([D],Se),e.SelectionRange=Se;class Le{constructor(L,Z,Ee,We,Je,it){this.kind=L,this.name=Z,this.detail=Ee,this.uri=We,this.range=Je,this.selectionRange=it}}e.CallHierarchyItem=Le;class ge{constructor(L,Z){this.fromRanges=Z,this.from=L}}e.CallHierarchyIncomingCall=ge;class Ce{constructor(L,Z){this.fromRanges=Z,this.to=L}}e.CallHierarchyOutgoingCall=Ce;let Pe=class{constructor(L,Z){this.range=L,this.command=Z}get isResolved(){return!!this.command}};Pe=je([D],Pe),e.CodeLens=Pe;let $e=l=class{constructor(L,Z=!1){b.set(this,void 0),tt(this,b,new A.MarkdownString(L,{supportThemeIcons:Z}),"f")}static isMarkdownString(L){return L instanceof l?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Ue(this,b,"f").value}set value(L){Ue(this,b,"f").value=L}get isTrusted(){return Ue(this,b,"f").isTrusted}set isTrusted(L){Ue(this,b,"f").isTrusted=L}get supportThemeIcons(){return Ue(this,b,"f").supportThemeIcons}appendText(L){return Ue(this,b,"f").appendText(L),this}appendMarkdown(L){return Ue(this,b,"f").appendMarkdown(L),this}appendCodeblock(L,Z){return Ue(this,b,"f").appendCodeblock(Z!=null?Z:"",L),this}};b=new WeakMap,$e=l=je([D],$e),e.MarkdownString=$e;let _e=class{constructor(L,Z){this.label=L,this.documentation=Z}};_e=je([D],_e),e.ParameterInformation=_e;let qe=class{constructor(L,Z){this.label=L,this.documentation=Z,this.parameters=[]}};qe=je([D],qe),e.SignatureInformation=qe;let V=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};V=je([D],V),e.SignatureHelp=V;var X;(function(O){O[O.Invoke=1]="Invoke",O[O.TriggerCharacter=2]="TriggerCharacter",O[O.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ve;(function(O){O[O.Other=0]="Other",O[O.Type=1]="Type",O[O.Parameter=2]="Parameter"})(ve=e.InlineHintKind||(e.InlineHintKind={}));let Me=class{constructor(L,Z,Ee){this.text=L,this.range=Z,this.kind=Ee}};Me=je([D],Me),e.InlineHint=Me;var He;(function(O){O[O.Invoke=0]="Invoke",O[O.TriggerCharacter=1]="TriggerCharacter",O[O.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Oe;(function(O){O[O.Text=0]="Text",O[O.Method=1]="Method",O[O.Function=2]="Function",O[O.Constructor=3]="Constructor",O[O.Field=4]="Field",O[O.Variable=5]="Variable",O[O.Class=6]="Class",O[O.Interface=7]="Interface",O[O.Module=8]="Module",O[O.Property=9]="Property",O[O.Unit=10]="Unit",O[O.Value=11]="Value",O[O.Enum=12]="Enum",O[O.Keyword=13]="Keyword",O[O.Snippet=14]="Snippet",O[O.Color=15]="Color",O[O.File=16]="File",O[O.Reference=17]="Reference",O[O.Folder=18]="Folder",O[O.EnumMember=19]="EnumMember",O[O.Constant=20]="Constant",O[O.Struct=21]="Struct",O[O.Event=22]="Event",O[O.Operator=23]="Operator",O[O.TypeParameter=24]="TypeParameter",O[O.User=25]="User",O[O.Issue=26]="Issue"})(Oe=e.CompletionItemKind||(e.CompletionItemKind={}));var et;(function(O){O[O.Deprecated=1]="Deprecated"})(et=e.CompletionItemTag||(e.CompletionItemTag={}));let H=class{constructor(L,Z){this.label=L,this.kind=Z}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Oe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};H=je([D],H),e.CompletionItem=H;let ne=class{constructor(L=[],Z=!1){this.items=L,this.isIncomplete=Z}};ne=je([D],ne),e.CompletionList=ne;var he;(function(O){O[O.Active=-1]="Active",O[O.Beside=-2]="Beside",O[O.One=1]="One",O[O.Two=2]="Two",O[O.Three=3]="Three",O[O.Four=4]="Four",O[O.Five=5]="Five",O[O.Six=6]="Six",O[O.Seven=7]="Seven",O[O.Eight=8]="Eight",O[O.Nine=9]="Nine"})(he=e.ViewColumn||(e.ViewColumn={}));var q;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(q=e.StatusBarAlignment||(e.StatusBarAlignment={}));var J;(function(O){O[O.Off=0]="Off",O[O.On=1]="On",O[O.Relative=2]="Relative"})(J=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var oe;(function(O){O[O.Manual=1]="Manual",O[O.AfterDelay=2]="AfterDelay",O[O.FocusOut=3]="FocusOut"})(oe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var fe;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(fe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var pe;(function(O){O[O.Keyboard=1]="Keyboard",O[O.Mouse=2]="Mouse",O[O.Command=3]="Command"})(pe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Be;(function(O){O[O.OpenOpen=0]="OpenOpen",O[O.ClosedClosed=1]="ClosedClosed",O[O.OpenClosed=2]="OpenClosed",O[O.ClosedOpen=3]="ClosedOpen"})(Be=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(O){function L(Z){switch(Z){case"keyboard":return O.Keyboard;case"mouse":return O.Mouse;case"api":return O.Command}}O.fromValue=L}(pe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ne=class{constructor(L,Z){if(Z&&!I.URI.isUri(Z))throw(0,k.illegalArgument)("target");if(!P.isRange(L)||L.isEmpty)throw(0,k.illegalArgument)("range");this.range=L,this.target=Z}};Ne=je([D],Ne),e.DocumentLink=Ne;let Ve=class{constructor(L,Z,Ee,We){this.red=L,this.green=Z,this.blue=Ee,this.alpha=We}};Ve=je([D],Ve),e.Color=Ve;let Xe=class{constructor(L,Z){if(Z&&!(Z instanceof Ve))throw(0,k.illegalArgument)("color");if(!P.isRange(L)||L.isEmpty)throw(0,k.illegalArgument)("range");this.range=L,this.color=Z}};Xe=je([D],Xe),e.ColorInformation=Xe;let Ze=class{constructor(L){if(!L||typeof L!="string")throw(0,k.illegalArgument)("label");this.label=L}};Ze=je([D],Ze),e.ColorPresentation=Ze;var ct;(function(O){O[O.RGB=0]="RGB",O[O.HEX=1]="HEX",O[O.HSL=2]="HSL"})(ct=e.ColorFormat||(e.ColorFormat={}));var ot;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information"})(ot=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var nt;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(nt=e.TaskRevealKind||(e.TaskRevealKind={}));var ue;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(ue=e.TaskPanelKind||(e.TaskPanelKind={}));let De=u=class{constructor(L,Z){if(typeof L!="string"||typeof Z!="string")throw(0,k.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}get id(){return this._id}};De.Clean=new u("clean","Clean"),De.Build=new u("build","Build"),De.Rebuild=new u("rebuild","Rebuild"),De.Test=new u("test","Test"),De=u=je([D],De),e.TaskGroup=De;function le(O){let L="";for(let Z=0;Z<O.length;Z++)L+=O[Z].replace(/,/g,",,")+",";return L}let j=class{constructor(L,Z,Ee){if(typeof L!="string")throw(0,k.illegalArgument)("process");this._args=[],this._process=L,Z!==void 0&&(Array.isArray(Z)?(this._args=Z,this._options=Ee):this._options=Z)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,k.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let Z of this._args)L.push(Z);return le(L)}};j=je([D],j),e.ProcessExecution=j;let Ae=class{constructor(L,Z,Ee){if(this._args=[],Array.isArray(Z)){if(!L)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,k.illegalArgument)("command");this._command=L,this._args=Z,this._options=Ee}else{if(typeof L!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=L,this._options=Z}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,k.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let Z of this._args)L.push(typeof Z=="string"?Z:Z.value);return le(L)}};Ae=je([D],Ae),e.ShellExecution=Ae;var Te;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(Te=e.ShellQuoting||(e.ShellQuoting={}));var Ye;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace"})(Ye=e.TaskScope||(e.TaskScope={}));class Ge{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,y.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=Ge;let rt=m=class{constructor(L,Z,Ee,We,Je,it){this.__deprecated=!1,this._definition=this.definition=L;let dt;typeof Z=="string"?(this._name=this.name=Z,this._source=this.source=Ee,this.execution=We,dt=Je,this.__deprecated=!0):Z===Ye.Global||Z===Ye.Workspace?(this.target=Z,this._name=this.name=Ee,this._source=this.source=We,this.execution=Je,dt=it):(this.target=Z,this._name=this.name=Ee,this._source=this.source=We,this.execution=Je,dt=it),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof j?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ae?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof Ge?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,y.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,k.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const Z=this._definition.type;(m.EmptyType===Z||m.ProcessType===Z||m.ShellType===Z||m.ExtensionCallbackType===Z)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};rt.ExtensionCallbackType="customExecution",rt.ProcessType="process",rt.ShellType="shell",rt.EmptyType="$empty",rt=m=je([D],rt),e.Task=rt;var at;(function(O){O[O.SourceControl=1]="SourceControl",O[O.Window=10]="Window",O[O.Notification=15]="Notification"})(at=e.ProgressLocation||(e.ProgressLocation={}));let Qe=class{constructor(L,Z=ut.None){this.collapsibleState=Z,I.URI.isUri(L)?this.resourceUri=L:this.label=L}};Qe=je([D],Qe),e.TreeItem=Qe;var ut;(function(O){O[O.None=0]="None",O[O.Collapsed=1]="Collapsed",O[O.Expanded=2]="Expanded"})(ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let st=class{constructor(L,Z){this.id=L,this.color=Z}};st=je([D],st),e.ThemeIcon=st,st.File=new st("file"),st.Folder=new st("folder");let gt=class{constructor(L){this.id=L}};gt=je([D],gt),e.ThemeColor=gt;var wt;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.WorkspaceFolder=3]="WorkspaceFolder"})(wt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let St=class{constructor(L,Z){if(typeof L!="string"&&(!L||!I.URI.isUri(L)&&!I.URI.isUri(L.uri)))throw(0,k.illegalArgument)("base");if(typeof Z!="string")throw(0,k.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=I.URI.file(L),this.base=L):I.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=Z}};St=je([D],St),e.RelativePattern=St;let vt=class{constructor(L,Z,Ee,We){this.enabled=typeof L=="boolean"?L:!0,typeof Z=="string"&&(this.condition=Z),typeof Ee=="string"&&(this.hitCondition=Ee),typeof We=="string"&&(this.logMessage=We)}get id(){return this._id||(this._id=(0,y.generateUuid)()),this._id}};vt=je([D],vt),e.Breakpoint=vt;let Et=class extends vt{constructor(L,Z,Ee,We,Je){super(Z,Ee,We,Je);if(L===null)throw(0,k.illegalArgument)("location");this.location=L}};Et=je([D],Et),e.SourceBreakpoint=Et;let pt=class extends vt{constructor(L,Z,Ee,We,Je){super(Z,Ee,We,Je);this.functionName=L}};pt=je([D],pt),e.FunctionBreakpoint=pt;let Rt=class extends vt{constructor(L,Z,Ee,We,Je,it,dt){super(We,Je,it,dt);if(!Z)throw(0,k.illegalArgument)("dataId");this.label=L,this.dataId=Z,this.canPersist=Ee}};Rt=je([D],Rt),e.DataBreakpoint=Rt;let Ft=class{constructor(L,Z,Ee){this.command=L,this.args=Z||[],this.options=Ee}};Ft=je([D],Ft),e.DebugAdapterExecutable=Ft;let ft=class{constructor(L,Z){this.port=L,this.host=Z}};ft=je([D],ft),e.DebugAdapterServer=ft;let yt=class{constructor(L){this.path=L}};yt=je([D],yt),e.DebugAdapterNamedPipeServer=yt;let Wt=class{constructor(L){this.implementation=L}};Wt=je([D],Wt),e.DebugAdapterInlineImplementation=Wt;let qt=class{constructor(L,Z){this.range=L,this.expression=Z}};qt=je([D],qt),e.EvaluatableExpression=qt;let Mt=class{constructor(L,Z){this.range=L,this.text=Z}};Mt=je([D],Mt),e.InlineValueText=Mt;let ht=class{constructor(L,Z,Ee=!0){this.range=L,this.variableName=Z,this.caseSensitiveLookup=Ee}};ht=je([D],ht),e.InlineValueVariableLookup=ht;let Kt=class{constructor(L,Z){this.range=L,this.expression=Z}};Kt=je([D],Kt),e.InlineValueEvaluatableExpression=Kt;let Ct=class{constructor(L,Z){this.frameId=L,this.stoppedLocation=Z}};Ct=je([D],Ct),e.InlineValueContext=Ct;var Ot;(function(O){O[O.Changed=1]="Changed",O[O.Created=2]="Created",O[O.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Ht=_=class extends Error{constructor(L,Z=n.FileSystemProviderErrorCode.Unknown,Ee){var We;super(I.URI.isUri(L)?L.toString(!0):L);this.code=(We=Ee==null?void 0:Ee.name)!==null&&We!==void 0?We:"Unknown",(0,n.markAsFileSystemProviderError)(this,Z),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,_.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}static FileExists(L){return new _(L,n.FileSystemProviderErrorCode.FileExists,_.FileExists)}static FileNotFound(L){return new _(L,n.FileSystemProviderErrorCode.FileNotFound,_.FileNotFound)}static FileNotADirectory(L){return new _(L,n.FileSystemProviderErrorCode.FileNotADirectory,_.FileNotADirectory)}static FileIsADirectory(L){return new _(L,n.FileSystemProviderErrorCode.FileIsADirectory,_.FileIsADirectory)}static NoPermissions(L){return new _(L,n.FileSystemProviderErrorCode.NoPermissions,_.NoPermissions)}static Unavailable(L){return new _(L,n.FileSystemProviderErrorCode.Unavailable,_.Unavailable)}};Ht=_=je([D],Ht),e.FileSystemError=Ht;let Gt=class{constructor(L,Z,Ee){this.start=L,this.end=Z,this.kind=Ee}};Gt=je([D],Gt),e.FoldingRange=Gt;var en;(function(O){O[O.Comment=1]="Comment",O[O.Imports=2]="Imports",O[O.Region=3]="Region"})(en=e.FoldingRangeKind||(e.FoldingRangeKind={}));var dn;(function(O){O[O.Collapsed=0]="Collapsed",O[O.Expanded=1]="Expanded"})(dn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var tn;(function(O){O[O.Editing=0]="Editing",O[O.Preview=1]="Preview"})(tn=e.CommentMode||(e.CommentMode={}));class Lt{constructor(L,Z=[]){this.tokenTypes=L,this.tokenModifiers=Z}}e.SemanticTokensLegend=Lt;function hn(O){return typeof O=="undefined"||(0,S.isStringArray)(O)}class Nt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let Z=0,Ee=L.tokenTypes.length;Z<Ee;Z++)this._tokenTypeStrToInt.set(L.tokenTypes[Z],Z);for(let Z=0,Ee=L.tokenModifiers.length;Z<Ee;Z++)this._tokenModifierStrToInt.set(L.tokenModifiers[Z],Z)}}push(L,Z,Ee,We,Je){if(typeof L=="number"&&typeof Z=="number"&&typeof Ee=="number"&&typeof We=="number"&&(typeof Je=="number"||typeof Je=="undefined"))return typeof Je=="undefined"&&(Je=0),this._pushEncoded(L,Z,Ee,We,Je);if(P.isRange(L)&&typeof Z=="string"&&hn(Ee))return this._push(L,Z,Ee);throw(0,k.illegalArgument)()}_push(L,Z,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Z))throw new Error("`tokenType` is not in the provided legend");const We=L.start.line,Je=L.start.character,it=L.end.character-L.start.character,dt=this._tokenTypeStrToInt.get(Z);let bt=0;if(Ee)for(const Dt of Ee){if(!this._tokenModifierStrToInt.has(Dt))throw new Error("`tokenModifier` is not in the provided legend");const kt=this._tokenModifierStrToInt.get(Dt);bt|=1<<kt>>>0}this._pushEncoded(We,Je,it,dt,bt)}_pushEncoded(L,Z,Ee,We,Je){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&Z<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const bt=this._data.length/5|0;let Dt=0,kt=0;for(let It=0;It<bt;It++){let At=this._data[5*It],Xt=this._data[5*It+1];At===0?(At=Dt,Xt+=kt):At+=Dt,this._data[5*It]=At,this._data[5*It+1]=Xt,Dt=At,kt=Xt}}let it=L,dt=Z;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(it-=this._prevLine,it===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=it,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=We,this._data[this._dataLen++]=Je,this._prevLine=L,this._prevChar=Z}static _sortAndDeltaEncode(L){let Z=[];const Ee=L.length/5|0;for(let dt=0;dt<Ee;dt++)Z[dt]=dt;Z.sort((dt,bt)=>{const Dt=L[5*dt],kt=L[5*bt];if(Dt===kt){const It=L[5*dt+1],At=L[5*bt+1];return It-At}return Dt-kt});const We=new Uint32Array(L.length);let Je=0,it=0;for(let dt=0;dt<Ee;dt++){const bt=5*Z[dt],Dt=L[bt+0],kt=L[bt+1],It=L[bt+2],At=L[bt+3],Xt=L[bt+4],Cn=Dt-Je,An=Cn===0?kt-it:kt,Zt=5*dt;We[Zt+0]=Cn,We[Zt+1]=An,We[Zt+2]=It,We[Zt+3]=At,We[Zt+4]=Xt,Je=Dt,it=kt}return We}build(L){return this._dataIsSortedAndDeltaEncoded?new Ut(new Uint32Array(this._data),L):new Ut(Nt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=Nt;class Ut{constructor(L,Z){this.resultId=Z,this.data=L}}e.SemanticTokens=Ut;class fn{constructor(L,Z,Ee){this.start=L,this.deleteCount=Z,this.data=Ee}}e.SemanticTokensEdit=fn;class mn{constructor(L,Z){this.resultId=Z,this.edits=L}}e.SemanticTokensEdits=mn;var Pt;(function(O){O[O.Separate=0]="Separate",O[O.MergeWithParent=1]="MergeWithParent"})(Pt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var gn;(function(O){O[O.Initial=1]="Initial",O[O.Dynamic=2]="Dynamic"})(gn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let zt=class{constructor(){}};zt.Back={iconPath:new st("arrow-left")},zt=je([D],zt),e.QuickInputButtons=zt;var pn;(function(O){O[O.UI=1]="UI",O[O.Workspace=2]="Workspace"})(pn=e.ExtensionKind||(e.ExtensionKind={}));class vn{constructor(L,Z,Ee){this.badge=L,this.tooltip=Z,this.color=Ee}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=vn;let xt=class{constructor(L){this.kind=L}};xt=je([D],xt),e.ColorTheme=xt;var nn;(function(O){O[O.Light=1]="Light",O[O.Dark=2]="Dark",O[O.HighContrast=3]="HighContrast"})(nn=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor(L,Z){if(L<0)throw(0,k.illegalArgument)("start must be positive");if(Z<L)throw(0,k.illegalArgument)("end cannot be smaller than start");this._start=L,this._end=Z}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let Z=this._start,Ee=this._end;return L.start!==void 0&&(Z=L.start),L.end!==void 0&&(Ee=L.end),Z===this._start&&Ee===this._end?this:new Vt(Z,Ee)}}e.NotebookCellRange=Vt;class $t{constructor(L,Z,Ee,We,Je,it,dt){this.editable=L,this.breakpointMargin=Z,this.hasExecutionOrder=Ee,this.statusMessage=We,this.inputCollapsed=Je,this.outputCollapsed=it,this.custom=dt}with(L){let{editable:Z,breakpointMargin:Ee,hasExecutionOrder:We,statusMessage:Je,inputCollapsed:it,outputCollapsed:dt,custom:bt}=L;return Z===void 0?Z=this.editable:Z===null&&(Z=void 0),Ee===void 0?Ee=this.breakpointMargin:Ee===null&&(Ee=void 0),We===void 0?We=this.hasExecutionOrder:We===null&&(We=void 0),Je===void 0?Je=this.statusMessage:Je===null&&(Je=void 0),it===void 0?it=this.inputCollapsed:it===null&&(it=void 0),dt===void 0?dt=this.outputCollapsed:dt===null&&(dt=void 0),bt===void 0?bt=this.custom:bt===null&&(bt=void 0),Z===this.editable&&Ee===this.breakpointMargin&&We===this.hasExecutionOrder&&Je===this.statusMessage&&it===this.inputCollapsed&&dt===this.outputCollapsed&&bt===this.custom?this:new $t(Z,Ee,We,Je,it,dt,bt)}}e.NotebookCellMetadata=$t;class Re{constructor(L=!0,Z=!0,Ee=!0,We={},Je=!0){this.editable=L,this.cellEditable=Z,this.cellHasExecutionOrder=Ee,this.custom=We,this.trusted=Je}with(L){let{editable:Z,cellEditable:Ee,cellHasExecutionOrder:We,custom:Je,trusted:it}=L;return Z===void 0?Z=this.editable:Z===null&&(Z=void 0),Ee===void 0?Ee=this.cellEditable:Ee===null&&(Ee=void 0),We===void 0?We=this.cellHasExecutionOrder:We===null&&(We=void 0),Je===void 0?Je=this.custom:Je===null&&(Je=void 0),it===void 0?it=this.trusted:it===null&&(it=void 0),Z===this.editable&&Ee===this.cellEditable&&We===this.cellHasExecutionOrder&&Je===this.custom&&it===this.trusted?this:new Re(Z,Ee,We,Je,it)}}e.NotebookDocumentMetadata=Re;class Qt{constructor(L,Z,Ee,We,Je,it){this.kind=L,this.source=Z,this.language=Ee,this.outputs=We!=null?We:[],this.metadata=Je,this.latestExecutionSummary=it}}e.NotebookCellData=Qt;class Jt{constructor(L,Z){this.cells=L,this.metadata=Z!=null?Z:new Re}}e.NotebookData=Jt;class mt{constructor(L,Z,Ee){this.mime=L,this.value=Z,this.metadata=Ee}static isNotebookCellOutputItem(L){return L instanceof mt}}e.NotebookCellOutputItem=mt;class _n{constructor(L,Z,Ee){this.outputs=L,typeof Z=="string"?(this.id=Z,this.metadata=Ee):(this.id=(0,y.generateUuid)(),this.metadata=Z!=null?Z:Ee)}}e.NotebookCellOutput=_n;var bn;(function(O){O[O.Markdown=1]="Markdown",O[O.Code=2]="Code"})(bn=e.NotebookCellKind||(e.NotebookCellKind={}));var rn;(function(O){O[O.Idle=1]="Idle",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(rn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var sn;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(sn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var wn;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(wn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let Yt=class{constructor(L,Z){this.label=L,this.timestamp=Z}};Yt=je([D],Yt),e.TimelineItem=Yt;var En;(function(O){O[O.Production=1]="Production",O[O.Development=2]="Development",O[O.Test=3]="Test"})(En=e.ExtensionMode||(e.ExtensionMode={}));var yn;(function(O){O[O.Node=1]="Node",O[O.Webworker=2]="Webworker"})(yn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var on;(function(O){O[O.Other=0]="Other",O[O.Comment=1]="Comment",O[O.String=2]="String",O[O.RegEx=4]="RegEx"})(on=e.StandardTokenType||(e.StandardTokenType={}));class Sn{constructor(L,Z){this.ranges=L,this.wordPattern=Z}}e.LinkedEditingRanges=Sn;var Dn;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(Dn=e.TestResultState||(e.TestResultState={}));var an;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information",O[O.Hint=3]="Hint"})(an=e.TestMessageSeverity||(e.TestMessageSeverity={})),e.TestItemHookProperty=Symbol("TestItemHookProperty");const jt=(O,L,Z)=>{let Ee=Z;return{enumerable:!0,configurable:!1,get(){return Ee},set(We){var Je;(Je=O[e.TestItemHookProperty])===null||Je===void 0||Je.setProp(L,We),Ee=We}}};class ln{constructor(L){f.set(this,new Map),i.set(this,void 0),tt(this,i,L,"f")}get size(){return Ue(this,f,"f").size}add(L){const Z=Ue(this,f,"f"),Ee=Ue(this,i,"f").call(this),We=Z.get(L.id);We!==L&&(We&&(Ee==null||Ee.delete(L.id)),Z.set(L.id,L),Ee==null||Ee.created(L))}get(L){return Ue(this,f,"f").get(L)}clear(){for(const L of Ue(this,f,"f").keys())this.delete(L)}delete(L){var Z;const Ee=typeof L=="string"?L:L.id;Ue(this,f,"f").has(Ee)&&(Ue(this,f,"f").delete(Ee),(Z=Ue(this,i,"f").call(this))===null||Z===void 0||Z.delete(Ee))}toJSON(){return[...Ue(this,f,"f").values()]}[(f=new WeakMap,i=new WeakMap,Symbol.iterator)](){return Ue(this,f,"f").values()}}e.TestChildrenCollection=ln;class Y{constructor(L,Z,Ee,We){this.label=Z,this.expandable=We,Object.defineProperties(this,{id:{value:L,enumerable:!0,writable:!1},uri:{value:Ee,enumerable:!0,writable:!1},children:{value:new ln(()=>this[e.TestItemHookProperty]),enumerable:!0,writable:!1},[e.TestItemHookProperty]:{enumerable:!1,writable:!0,configurable:!1},range:jt(this,"range",void 0),description:jt(this,"description",void 0),runnable:jt(this,"runnable",!0),debuggable:jt(this,"debuggable",!0)})}invalidate(){var L;(L=this[e.TestItemHookProperty])===null||L===void 0||L.invalidate(this.id)}discoverChildren(L,Z){L.report({busy:!1})}}e.TestItem=Y;class ce{constructor(L){this.message=L,this.severity=an.Error}static diff(L,Z,Ee){const We=new ce(L);return We.expectedOutput=Z,We.actualOutput=Ee,We}}e.TestMessage=ce;var ke;(function(O){O[O.None=0]="None",O[O.Option=1]="Option",O[O.Default=2]="Default",O[O.Preferred=3]="Preferred"})(ke=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var lt;(function(O){O[O.Untrusted=0]="Untrusted",O[O.Trusted=1]="Trusted",O[O.Unspecified=2]="Unspecified"})(lt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var _t;(function(O){O[O.Notify=1]="Notify",O[O.OpenBrowser=2]="OpenBrowser",O[O.OpenPreview=3]="OpenPreview",O[O.Silent=4]="Silent",O[O.Ignore=5]="Ignore"})(_t=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(be[94],we([0,1,43,18,8,118,83,7,15]),function(ie,e,w,k,A,T,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const n=new Map;function R(i,s){s?n.set(i,s):n.delete(i)}e.setWordDefinitionFor=R;function C(i){return n.get(i)}e.getWordDefinitionFor=C;class b extends T.MirrorTextModel{constructor(s,v,h,E,g,a,o,t){super(v,h,E,g);this._proxy=s,this._languageId=a,this._isDirty=o,this._notebook=t,this._isDisposed=!1}dispose(){(0,w.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(s){return(0,y.equals)(this._lines,s)}get document(){if(!this._document){const s=this;this._document={get uri(){return s._uri},get fileName(){return s._uri.fsPath},get isUntitled(){return s._uri.scheme===k.Schemas.untitled},get languageId(){return s._languageId},get version(){return s._versionId},get isClosed(){return s._isDisposed},get isDirty(){return s._isDirty},get notebook(){return s._notebook},save(){return s._save()},getText(v){return v?s._getTextInRange(v):s.getText()},get eol(){return s._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return s._lines.length},lineAt(v){return s._lineAt(v)},offsetAt(v){return s._offsetAt(v)},positionAt(v){return s._positionAt(v)},validateRange(v){return s._validateRange(v)},validatePosition(v){return s._validatePosition(v)},getWordRangeAtPosition(v,h){return s._getWordRangeAtPosition(v,h)}}}return Object.freeze(this._document)}_acceptLanguageId(s){(0,w.ok)(!this._isDisposed),this._languageId=s}_acceptIsDirty(s){(0,w.ok)(!this._isDisposed),this._isDirty=s}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(s){const v=this._validateRange(s);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const h=this._eol,E=v.start.line,g=v.end.line,a=[];a.push(this._lines[E].substring(v.start.character));for(let o=E+1;o<g;o++)a.push(this._lines[o]);return a.push(this._lines[g].substring(0,v.end.character)),a.join(h)}_lineAt(s){let v;if(s instanceof I.Position?v=s.line:typeof s=="number"&&(v=s),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new f(v,this._lines[v],v===this._lines.length-1)}_offsetAt(s){return s=this._validatePosition(s),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(s.line-1)+s.character}_positionAt(s){s=Math.floor(s),s=Math.max(0,s),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(s),h=this._lines[v.index].length;return new I.Position(v.index,Math.min(v.remainder,h))}_validateRange(s){if(!(s instanceof I.Range))throw new Error("Invalid argument");const v=this._validatePosition(s.start),h=this._validatePosition(s.end);return v===s.start&&h===s.end?s:new I.Range(v.line,v.character,h.line,h.character)}_validatePosition(s){if(!(s instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return s.with(0,0);let{line:v,character:h}=s,E=!1;if(v<0)v=0,h=0,E=!0;else if(v>=this._lines.length)v=this._lines.length-1,h=this._lines[v].length,E=!0;else{const g=this._lines[v].length;h<0?(h=0,E=!0):h>g&&(h=g,E=!0)}return E?new I.Position(v,h):s}_getWordRangeAtPosition(s,v){const h=this._validatePosition(s);if(!v)v=C(this._languageId);else if((0,A.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const E=(0,S.getWordAtText)(h.character+1,(0,S.ensureValidWordDefinition)(v),this._lines[h.line],0);if(E)return new I.Range(h.line,E.startColumn-1,h.line,E.endColumn-1)}}e.ExtHostDocumentData=b;class f{constructor(s,v,h){this._line=s,this._text=v,this._isLastLine=h}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(be[162],we([0,1,7,3,85,6,59,22,2,29]),function(ie,e,w,k,A,T,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(b,f,i,s){this._notebook=i,this._selector=s,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,n.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(h=>{const E=this._cellUris.get(h.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=h=>{h===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(b.onDidChangeNotebookCells(h=>v(h.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const b=[],f=[];for(const i of this._notebook.cells)i.kind===w.NotebookCellKind.Code&&(!this._selector||(0,S.score)(this._selector,i.document.uri,i.document.languageId,!0))&&(this._cellUris.set(i.document.uri,this._cells.length),this._cells.push(i),b.push(i.document.getText().length+1),f.push(i.document.lineCount));this._cellLengths=new A.PrefixSumComputer(new Uint32Array(b)),this._cellLines=new A.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(b){var f,i;if(!b){let g="";for(const a of this._cells)g+=a.document.getText()+`
`;return g=g.slice(0,-1),g}if(b.isEmpty)return"";const s=this.locationAt(b.start),v=this.locationAt(b.end),h=this._cells[(f=this._cellUris.get(s.uri))!==null&&f!==void 0?f:-1],E=this._cells[(i=this._cellUris.get(v.uri))!==null&&i!==void 0?i:-1];if(!h||!E)return"";if(h===E)return h.document.getText(new w.Range(s.range.start,v.range.end));{const g=h.document.getText(new w.Range(s.range.start,new w.Position(h.document.lineCount,0))),a=E.document.getText(new w.Range(new w.Position(0,0),v.range.end));return g+`
`+a}}offsetAt(b){const f=this._cellLines.getIndexOf(b.line),i=this._cellLengths.getAccumulatedValue(f.index-1),s=this._cells[f.index].document.offsetAt(b.with(f.remainder));return i+s}positionAt(b){if(typeof b=="number"){const i=this._cellLengths.getIndexOf(b),s=this._cellLines.getAccumulatedValue(i.index-1);return this._cells[i.index].document.positionAt(i.remainder).translate(s)}const f=this._cellUris.get(b.uri);if(f!==void 0){const i=this._cellLines.getAccumulatedValue(f-1);return new w.Position(i+b.range.start.line,b.range.start.character)}return new w.Position(0,0)}locationAt(b){w.Range.isRange(b)||(b=new w.Range(b,b));const f=this._cellLines.getIndexOf(b.start.line);let i=f;b.isEmpty||(i=this._cellLines.getIndexOf(b.end.line));const s=new w.Position(f.remainder,b.start.character),v=new w.Position(i.remainder,b.end.character),h=new w.Range(s,v),E=this._cells[f.index];return new w.Location(E.document.uri,E.document.validateRange(h))}contains(b){return this._cellUris.has(b)}validateRange(b){const f=this.validatePosition(b.start),i=this.validatePosition(b.end);return b.with(f,i)}validatePosition(b){const f=this._cellLines.getIndexOf(b.line),i=new w.Position(f.remainder,b.character),s=this._cells[f.index].document.validatePosition(i),v=this._cellLines.getAccumulatedValue(f.index-1);return new w.Position(v+s.line,s.character)}}e.ExtHostNotebookConcatDocument=R}),define(be[163],we([0,1,7,14,3]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(I){this._actual=new w.ColorTheme(w.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new A.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let y=I==="light"?w.ColorThemeKind.Light:I==="dark"?w.ColorThemeKind.Dark:w.ColorThemeKind.HighContrast;this._actual=new w.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=je([Ke(0,k.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(be[68],we([0,1,4]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,w.createDecorator)("IURITransformerService");class k{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=k}),define(be[164],we([0,1,24]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class k{constructor(){this.buffers=[]}add(y){let n=this.buffers.indexOf(y);return n<0&&(n=this.buffers.length,this.buffers.push(y)),n}}function A(I,y){if(y){const n=new k,R=(f,i)=>{if(i instanceof ArrayBuffer){const s=n.add(i);return{$$vscode_array_buffer_reference$$:!0,index:s}}else if(ArrayBuffer.isView(i)){const s=T(i);if(s){const v=n.add(i.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:s,byteLength:i.byteLength,byteOffset:i.byteOffset}}}}return i},C=JSON.stringify(I,R),b=n.buffers.map(f=>{const i=new Uint8Array(f);return w.VSBuffer.wrap(i)});return{message:C,buffers:b}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=A;function T(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function S(I,y){const n=y.map(b=>{const f=new ArrayBuffer(b.byteLength);return new Uint8Array(f).set(b.buffer),f}),R=y.length?(b,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const i=f,{index:s}=i,v=n[s];if(i.view)switch(i.view.type){case 1:return new Int8Array(v,i.view.byteOffset,i.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,i.view.byteOffset,i.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,i.view.byteOffset,i.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,i.view.byteOffset,i.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,i.view.byteOffset,i.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,i.view.byteOffset,i.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,i.view.byteOffset,i.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,i.view.byteOffset,i.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,i.view.byteOffset,i.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,i.view.byteOffset,i.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,i.view.byteOffset,i.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return f}:void 0;return{message:JSON.parse(I,R),arrayBuffers:n}}e.deserializeWebviewMessage=S}),define(be[69],we([0,1,2]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function k(T,S,I){const y=T.webviewResourceRoot.replace("{{resource}}",I.scheme+A(I)).replace("{{uuid}}",S);return w.URI.parse(y)}e.asWebviewUri=k;function A(T){return T.toString().replace(/^\S+?:/,"")}}),define(be[165],we([0,1,3,6,69,29]),function(ie,e,w,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(y,n,R){this._proxy=y,this._editors=n,this._initData=R,this._handlePool=0,this._disposables=new k.DisposableStore,this._insets=new Map,this._disposables.add(n.onDidChangeVisibleTextEditors(()=>{const C=n.getVisibleTextEditors();for(const b of this._insets.values())C.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,n,R,C,b){let f;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===y){f=a;break}if(!f)throw new Error("not a visible editor");const i=this,s=this._handlePool++,v=new w.Emitter,h=new w.Emitter,E=new class{constructor(){this._uuid=(0,T.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,A.asWebviewUri)(i._initData,this._uuid,a)}get cspSource(){return i._initData.webviewCspSource}set options(a){this._options=a,i._proxy.$setOptions(s,a)}get options(){return this._options}set html(a){this._html=a,i._proxy.$setHtml(s,a)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(a){return i._proxy.$postMessage(s,a)}},g=new class{constructor(){this.editor=y,this.line=n,this.height=R,this.webview=E,this.onDidDispose=h.event}dispose(){i._insets.has(s)&&(i._insets.delete(s),i._proxy.$disposeEditorInset(s),h.fire(),h.dispose(),v.dispose())}};return this._proxy.$createEditorInset(s,f.id,f.value.document.uri,n+1,R,C||{},b.identifier,b.extensionLocation),this._insets.set(s,{editor:y,inset:g,onDidReceiveMessage:v}),g}$onDidDispose(y){const n=this._insets.get(y);n&&n.inset.dispose()}$onDidReceiveMessage(y,n){const R=this._insets.get(y);R&&R.onDidReceiveMessage.fire(n)}}e.ExtHostEditorInsets=S}),define(be[166],we([0,1,3,63,137,4,6,22,30,15,50,23,37,157]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",b.Codicon.window,(0,A.localize)(0,null));var i;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(i=e.Extensions||(e.Extensions={}));var s;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel"})(s=e.ViewContainerLocation||(e.ViewContainerLocation={}));function v(u){switch(u){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=v;function h(u){return`viewContainer.${u}.enabled`}e.getEnabledViewContainerContextKey=h;class E extends S.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new w.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new w.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,n.flatten)([...this.viewContainers.values()])}registerViewContainer(m,_,D){var c;const p=this.get(m.id);if(p)return p;const P=m;return P.openCommandActionDescriptor=(D==null?void 0:D.donotRegisterOpenCommand)?void 0:(c=P.openCommandActionDescriptor)!==null&&c!==void 0?c:{id:P.id},(0,I.getOrSet)(this.viewContainers,_,[]).push(P),(D==null?void 0:D.isDefault)&&this.defaultViewContainers.push(P),this._onDidRegister.fire({viewContainer:P,viewContainerLocation:_}),P}deregisterViewContainer(m){for(const _ of this.viewContainers.keys()){const D=this.viewContainers.get(_),c=D==null?void 0:D.indexOf(m);if(c!==-1){D==null||D.splice(c,1),D.length===0&&this.viewContainers.delete(_),this._onDidDeregister.fire({viewContainer:m,viewContainerLocation:_});return}}}get(m){return this.all.filter(_=>_.id===m)[0]}getViewContainers(m){return[...this.viewContainers.get(m)||[]]}getViewContainerLocation(m){return[...this.viewContainers.keys()].filter(_=>this.getViewContainers(_).filter(D=>(D==null?void 0:D.id)===m.id).length>0)[0]}getDefaultViewContainer(m){return this.defaultViewContainers.find(_=>this.getViewContainerLocation(_)===m)}}y.Registry.add(i.ViewContainersRegistry,new E);var g;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(g=e.ViewContentGroups||(e.ViewContentGroups={}));function a(u,m){var _,D,c,p;const P=(_=u.group)!==null&&_!==void 0?_:g.More,F=(D=m.group)!==null&&D!==void 0?D:g.More;return P!==F?P.localeCompare(F):((c=u.order)!==null&&c!==void 0?c:5)-((p=m.order)!==null&&p!==void 0?p:5)}class o extends S.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new w.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new w.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new w.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new w.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new R.SetMap}registerViews(m,_){this.registerViews2([{views:m,viewContainer:_}])}registerViews2(m){m.forEach(({views:_,viewContainer:D})=>this.addViews(_,D)),this._onViewsRegistered.fire(m)}deregisterViews(m,_){const D=this.removeViews(m,_);D.length&&this._onViewsDeregistered.fire({views:D,viewContainer:_})}moveViews(m,_){for(const D of this._views.keys())if(D!==_){const c=this.removeViews(m,D);c.length&&(this.addViews(c,_),this._onDidChangeContainer.fire({views:c,from:D,to:_}))}}getViews(m){return this._views.get(m)||[]}getView(m){for(const _ of this._viewContainers){const D=(this._views.get(_)||[]).filter(c=>c.id===m)[0];if(D)return D}return null}getViewContainer(m){for(const _ of this._viewContainers)if((this._views.get(_)||[]).filter(c=>c.id===m)[0])return _;return null}registerViewWelcomeContent(m,_){return this._viewWelcomeContents.add(m,_),this._onDidChangeViewWelcomeContent.fire(m),(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(m,_),this._onDidChangeViewWelcomeContent.fire(m)})}registerViewWelcomeContent2(m,_){const D=new Map;for(const[c,p]of _)this._viewWelcomeContents.add(m,p),D.set(c,(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(m,p),this._onDidChangeViewWelcomeContent.fire(m)}));return this._onDidChangeViewWelcomeContent.fire(m),D}getViewWelcomeContent(m){const _=[];return this._viewWelcomeContents.forEach(m,D=>_.push(D)),_.sort(a)}addViews(m,_){let D=this._views.get(_);D||(D=[],this._views.set(_,D),this._viewContainers.push(_));for(const c of m){if(this.getView(c.id)!==null)throw new Error((0,A.localize)(1,null,c.id));D.push(c)}}removeViews(m,_){const D=this._views.get(_);if(!D)return[];const c=[],p=[];for(const P of D)m.includes(P)?c.push(P):p.push(P);return c.length&&(p.length?this._views.set(_,p):(this._views.delete(_),this._viewContainers.splice(this._viewContainers.indexOf(_),1))),c}}y.Registry.add(i.ViewsRegistry,new o),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new k.RawContextKey("focusedView","",(0,A.localize)(2,null));function t(u){return`view.${u}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var r;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var d;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(d=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class l{constructor(m,_){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,m),this._hasResolve=!!_,this.resolve=async D=>{var c,p;if(_&&!this.resolved){const P=await _(D);P&&(this.tooltip=(c=this.tooltip)!==null&&c!==void 0?c:P.tooltip,this.command=(p=this.command)!==null&&p!==void 0?p:P.command)}D.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=l}),define(be[167],we([0,1,2,147,158,19,148,166]),function(ie,e,w,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(s){return(v,...h)=>s(v.get(k.ICommandService),...h)}class n{static execute(v,h){const E={forceReuseWindow:h&&h.reuseWindow,remoteAuthority:h&&h.remoteAuthority};return v.executeCommand("_files.newWindow",E)}}e.NewWindowAPICommand=n,n.ID="vscode.newWindow",k.CommandsRegistry.registerCommand({id:n.ID,handler:y(n.execute),description:{description:"Opens an new window",args:[]}}),k.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(s,v){return s.get(A.IWorkspacesService).removeRecentlyOpened([v])});class R{static execute(v,h){return typeof h=="string"?h=h.match(/^[^:/?#]+:\/\//)?w.URI.parse(h):w.URI.file(h):h=w.URI.revive(h),v.executeCommand("_workbench.removeFromRecentlyOpened",h)}}e.RemoveFromRecentlyOpenedAPICommand=R,R.ID="vscode.removeFromRecentlyOpened",k.CommandsRegistry.registerCommand(R.ID,y(R.execute));class C{static execute(v,h){const E=typeof h=="string"?{extensionId:h}:h;return v.executeCommand("workbench.action.openIssueReporter",E)}}e.OpenIssueReporter=C,C.ID="vscode.openIssueReporter",k.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(s,v){const h=s.get(A.IWorkspacesService);let E;const g=v.uri,a=v.label,o=v.remoteAuthority;return v.type==="workspace"?E={workspace:await h.getWorkspaceIdentifier(g),label:a,remoteAuthority:o}:v.type==="folder"?E={folderUri:g,label:a,remoteAuthority:o}:E={fileUri:g,label:a,remoteAuthority:o},h.addRecentlyOpened([E])}),k.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(s){return s.get(A.IWorkspacesService).getRecentlyOpened()}),k.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(s,v){const h=s.get(T.ILogService),E=s.get(S.IEnvironmentService);E.isExtensionDevelopment&&!!E.extensionTestsLocationURI&&h.setLevel(v)}),k.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(s){return s.get(T.ILogService).getLevel()}),k.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(s,v){const h=s.get(I.IViewDescriptorService),E=h.getViewContainerById(v.destinationId);if(!!E){for(const g of v.viewIds){const a=h.getViewDescriptorById(g);(a==null?void 0:a.canMoveView)&&h.moveViewsToContainer([a],E,I.ViewVisibilityState.Default)}await s.get(I.IViewsService).openViewContainer(E.id,!0)}});class b{static execute(v,h){return!Array.isArray(h==null?void 0:h.viewIds)||typeof(h==null?void 0:h.destinationId)!="string"?Promise.reject("Invalid arguments"):v.executeCommand("_workbench.action.moveViews",h)}}e.MoveViewsAPICommand=b,b.ID="vscode.moveViews",k.CommandsRegistry.registerCommand({id:b.ID,handler:y(b.execute),description:{description:"Move Views",args:[]}});class f{static execute(v,h){return v.executeCommand("_workbench.open",h)}}f.ID="vscode.open",k.CommandsRegistry.registerCommand(f.ID,y(f.execute));class i{static execute(v,h,E,g,a){return v.executeCommand("_workbench.diff",[h,E,g])}}i.ID="vscode.diff",k.CommandsRegistry.registerCommand(i.ID,y(i.execute))}),define(be[168],we([0,1,3,13,138]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new w.Emitter,this._onExit=new w.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,y,n,R){const C={command:I};if(y&&Object.keys(y).length>0&&(C.arguments=y),this.internalSend("request",C),typeof R=="number"){const b=setTimeout(()=>{clearTimeout(b);const f=this.pendingRequests.get(C.seq);if(f){this.pendingRequests.delete(C.seq);const i={type:"response",seq:0,request_seq:C.seq,success:!1,command:I,message:(0,A.localize)(0,null,R,I)};f(i)}},R)}return n&&this.pendingRequests.set(C.seq,n),C.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,y){return I.type!=="event"||y.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,k.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":const y=I,n=this.pendingRequests.get(y.request_seq);n&&(this.pendingRequests.delete(y.request_seq),n(y));break}}}internalSend(I,y){y.type=I,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((y,n)=>I.set(n,y)),await(0,k.timeout)(500),I.forEach((y,n)=>{y({type:"response",seq:0,request_seq:n,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(n)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(be[169],we([0,1,8,2,11,23,18]),function(ie,e,w,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function y(r,d,l){return r.replace(I,function(u,m){return d&&m.length>0&&m[0]!=="_"?u:l&&l.hasOwnProperty(m)?l[m]:u})}e.formatPII=y;function n(r){const d={};for(const l of Object.keys(r))l.startsWith("!")||(d[l]=r[l]);return d}e.filterExceptionsFromTelemetry=n;function R(r){return r.configuration.request==="attach"&&!C(r)}e.isSessionAttach=R;function C(r){let d=r.configuration.type;if(!!d)return d==="vslsShare"&&(d=r.configuration.adapterProxy.configuration.type),(0,w.equalsIgnoreCase)(d,"extensionhost")||(0,w.equalsIgnoreCase)(d,"pwa-extensionhost")?r:r.parentSession?C(r.parentSession):void 0}e.getExtensionHostDebugSession=C;function b(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=b;function f(r,d,l){let u,m=0,_=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,D=null;for(;D=_.exec(r);){let c=D.index+1,p=c+D[0].length;if(c<=d&&p>=l){u=D[0],m=c;break}}if(u){let c=/\w+/g,p=null;for(;(p=c.exec(u))&&!(p.index+1+m+p[0].length>=l););p&&(u=u.substring(0,c.lastIndex))}return u?{start:m,end:m+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function s(r){return!!(r&&r.match(i))}e.isUri=s;function v(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(s(r.path))return k.URI.parse(r.path);if((0,A.isAbsolute)(r.path))return k.URI.file(r.path)}return r.path}function h(r){if(typeof r.path=="object"){const d=k.URI.revive(r.path);if(d)return d.scheme===S.Schemas.file?d.fsPath:d.toString()}return r.path}function E(r,d){const l=d?v:h,u=(0,T.deepClone)(r);return a(u,(m,_)=>{m&&_&&(_.path=l(_))}),u}e.convertToDAPaths=E;function g(r,d){const l=d?v:h,u=(0,T.deepClone)(r);return a(u,(m,_)=>{!m&&_&&(_.path=l(_))}),u}e.convertToVSCPaths=g;function a(r,d){switch(r.type){case"event":const l=r;switch(l.event){case"output":d(!1,l.body.source);break;case"loadedSource":d(!1,l.body.source);break;case"breakpoint":d(!1,l.body.breakpoint.source);break;default:break}break;case"request":const u=r;switch(u.command){case"setBreakpoints":d(!0,u.arguments.source);break;case"breakpointLocations":d(!0,u.arguments.source);break;case"source":d(!0,u.arguments.source);break;case"gotoTargets":d(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(_=>d(!1,_));break;default:break}break;case"response":const m=r;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(_=>d(!1,_.source));break;case"loadedSources":m.body.sources.forEach(_=>d(!1,_));break;case"scopes":m.body.scopes.forEach(_=>d(!1,_.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(_=>d(!1,_.source));break;case"setBreakpoints":m.body.breakpoints.forEach(_=>d(!1,_.source));break;default:break}break}}function o(r){return r.filter(d=>{var l;return!((l=d.presentation)===null||l===void 0?void 0:l.hidden)}).sort((d,l)=>d.presentation?l.presentation?d.presentation.group?l.presentation.group?d.presentation.group!==l.presentation.group?d.presentation.group.localeCompare(l.presentation.group):t(d.presentation.order,l.presentation.order):-1:l.presentation.group?1:t(d.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.getVisibleAndSorted=o;function t(r,d){return typeof r!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:r-d}}),define(be[70],we([0,1,28,18,11,21,63]),function(ie,e,w,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var I;(function(P){P[P.Markdown=1]="Markdown",P[P.Code=2]="Code"})(I=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(P){P[P.Running=1]="Running",P[P.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,cellEditable:!0,cellHasExecutionOrder:!0,custom:{},trusted:!0};var n;(function(P){P[P.Idle=1]="Idle",P[P.Pending=2]="Pending",P[P.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var R;(function(P){P[P.ModelChange=1]="ModelChange",P[P.Move=2]="Move",P[P.CellClearOutput=3]="CellClearOutput",P[P.CellsClearOutput=4]="CellsClearOutput",P[P.ChangeLanguage=5]="ChangeLanguage",P[P.Initialize=6]="Initialize",P[P.ChangeCellMetadata=7]="ChangeCellMetadata",P[P.Output=8]="Output",P[P.OutputItem=9]="OutputItem",P[P.ChangeCellContent=10]="ChangeCellContent",P[P.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",P[P.Unknown=12]="Unknown"})(R=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var C;(function(P){P[P.Handle=0]="Handle",P[P.Index=1]="Index"})(C=e.SelectionStateType||(e.SelectionStateType={}));var b;(function(P){P[P.Replace=1]="Replace",P[P.Output=2]="Output",P[P.Metadata=3]="Metadata",P[P.CellLanguage=4]="CellLanguage",P[P.DocumentMetadata=5]="DocumentMetadata",P[P.OutputsSplice=6]="OutputsSplice",P[P.Move=7]="Move",P[P.Unknown=8]="Unknown",P[P.CellContent=9]="CellContent",P[P.OutputItems=10]="OutputItems",P[P.PartialMetadata=11]="PartialMetadata"})(b=e.CellEditType||(e.CellEditType={}));function f(P){const F=i.parse(P);return F?F.notebook.toString():P.toString()}e.getCellUndoRedoComparisonKey=f;var i;(function(P){P.scheme=k.Schemas.vscodeNotebookCell;const F=/^ch(\d{7,})/;function z(K,M){return K.with({scheme:P.scheme,fragment:`ch${M.toString().padStart(7,"0")}${K.scheme!==k.Schemas.file?K.scheme:""}`})}P.generate=z;function de(K){if(K.scheme===P.scheme){const M=F.exec(K.fragment);if(!!M)return{handle:Number(M[1]),notebook:K.with({scheme:K.fragment.substr(M[0].length)||k.Schemas.file,fragment:null})}}}P.parse=de;function B(K,M){return K.with({scheme:k.Schemas.vscodeNotebookCellMetadata,fragment:`ch${M.toString().padStart(7,"0")}${K.scheme!==k.Schemas.file?K.scheme:""}`})}P.generateCellMetadataUri=B;function W(K){if(K.scheme===k.Schemas.vscodeNotebookCellMetadata){const M=F.exec(K.fragment);if(!!M)return{handle:Number(M[1]),notebook:K.with({scheme:K.fragment.substr(M[0].length)||k.Schemas.file,fragment:null})}}}P.parseCellMetadataUri=W})(i=e.CellUri||(e.CellUri={}));const s=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function v(P){var F,z;return(z=(F=s.get(P))===null||F===void 0?void 0:F.alwaysSecure)!==null&&z!==void 0?z:!1}e.mimeTypeIsAlwaysSecure=v;function h(P){var F,z;return(z=(F=s.get(P))===null||F===void 0?void 0:F.supportedByCore)!==null&&z!==void 0?z:!1}e.mimeTypeSupportedByCore=h;function E(P){var F,z;return(z=(F=s.get(P))===null||F===void 0?void 0:F.mergeable)!==null&&z!==void 0?z:!1}e.mimeTypeIsMergeable=E;function g(P,F){return T.isWindows&&(P=P.replace(/\//g,"\\"),F=F.replace(/\//g,"\\")),w.match(P,F)}function a(P,F,z){let de=0;for(let B=0;B<F.length;B++){if(g(F[B],P))return de;de++}for(let B=0;B<z.length;B++){if(g(z[B],P))return de;de++}return de}function o(P,F,z){return P.sort((de,B)=>a(de,F,z)-a(B,F,z))}e.sortMimeTypes=o;function t(P,F,z,de=(B,W)=>B===W){const B=[];function W(U,x,Q){if(!(x===0&&Q.length===0)){const $=B[B.length-1];$&&$.start+$.deleteCount===U?($.deleteCount+=x,$.toInsert.push(...Q)):B.push({start:U,deleteCount:x,toInsert:Q})}}let K=0,M=0;for(;;){if(K===P.length){W(K,0,F.slice(M));break}if(M===F.length){W(K,P.length-K,[]);break}const U=P[K],x=F[M];if(de(U,x)){K+=1,M+=1;continue}z(x)?(W(K,1,[]),K+=1):(W(K,0,[x]),M+=1)}return B}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=new S.RawContextKey("notebookEditorCursorAtEditorBeginEnd",!1);var r;(function(P){P.default="default",P.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(P){const F=P;return!!((typeof F.include=="string"||w.isRelativePattern(F.include))&&(typeof F.exclude=="string"||w.isRelativePattern(F.exclude)))}e.isDocumentExcludePattern=d;function l(P,F,z){if(Array.isArray(P.viewType)&&P.viewType.indexOf(F)>=0||P.viewType===F)return!0;if(P.filenamePattern){let de=d(P.filenamePattern)?P.filenamePattern.include:P.filenamePattern,B=d(P.filenamePattern)?P.filenamePattern.exclude:void 0;if(w.match(de,(0,A.basename)(z.fsPath).toLowerCase()))return!(B&&w.match(B,(0,A.basename)(z.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class u{constructor(F){this.textModel=F}getElements(){const F=new Int32Array(this.textModel.cells.length);for(let z=0;z<this.textModel.cells.length;z++)F[z]=this.textModel.cells[z].getHashValue();return F}}e.CellSequence=u,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var m;(function(P){P[P.LEFT=0]="LEFT",P[P.RIGHT=1]="RIGHT"})(m=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function _(P){P.sort((z,de)=>z-de);const F=P.shift();return F===void 0?[]:P.reduce(function(z,de){return de<=z[0][1]?z[0][1]=de+1:z.unshift([de,de+1]),z},[[F,F+1]]).reverse().map(z=>({start:z[0],end:z[1]}))}e.cellIndexesToRanges=_;function D(P){return P.reduce((z,de)=>{for(let B=de.start;B<de.end;B++)z.push(B);return z},[])}e.cellRangesToIndexes=D;function c(P){const F=P.sort((de,B)=>de.start-B.start),z=F[0];return z?F.reduce((de,B)=>{const W=de[de.length-1];return W.end>=B.start?W.end=Math.max(W.end,B.end):de.push(B),de},[z]):[]}e.reduceRanges=c;function p(P,F){return F.start>=P.start&&F.end<=P.end}e.cellRangeContains=p}),define(be[170],we([0,1,140,4,63]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new A.RawContextKey("customExecutionSupported",!0,w.localize(0,null)),e.ShellExecutionSupportedContext=new A.RawContextKey("shellExecutionSupported",!1,w.localize(1,null)),e.ProcessExecutionSupportedContext=new A.RawContextKey("processExecutionSupported",!1,w.localize(2,null)),e.ITaskService=(0,k.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[171],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function w(A){return[...A.entries()]}e.serializeEnvironmentVariableCollection=w;function k(A){return new Map(A)}e.deserializeEnvironmentVariableCollection=k}),define(be[95],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var w;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));const k=(y,n)=>{n.expand!==void 0&&(y.expand=n.expand),n.item!==void 0&&Object.assign(y.item,n.item)};e.applyTestItemUpdate=k;var A;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.DeltaRootsComplete=3]="DeltaRootsComplete",y[y.Retire=4]="Retire"})(A=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(y,n)=>`${y}:${n.toString()}`;e.getTestSubscriptionKey=T;class S{add(n){}update(n){}remove(n,R){}complete(){}}e.IncrementalChangeCollector=S;class I{constructor(){this.items=new Map,this.roots=new Set,this.busyProviderCount=0,this.pendingRootCount=0}apply(n){const R=this.createChangeCollector();for(const C of n)switch(C[0]){case 0:{const b=C[1];if(b.parent){if(this.items.has(b.parent)){const f=this.items.get(b.parent);f.children.add(b.item.extId);const i=this.createItem(b,f);this.items.set(b.item.extId,i),R.add(i)}}else{this.roots.add(b.item.extId);const f=this.createItem(b);this.items.set(b.item.extId,f),R.add(f)}b.expand===2&&this.updateBusyProviders(1);break}case 1:{const b=C[1],f=this.items.get(b.extId);if(!f)break;(0,e.applyTestItemUpdate)(f,b),R.update(f),b.expand!==void 0&&f.expand===2&&b.expand!==2&&this.updateBusyProviders(-1);break}case 2:{const b=this.items.get(C[1]);if(!b)break;b.parent?this.items.get(b.parent).children.delete(b.item.extId):this.roots.delete(b.item.extId);const f=[[C[1]]];for(;f.length;)for(const i of f.pop()){const s=this.items.get(i);s&&(f.push(s.children),this.items.delete(i),R.remove(s,s!==b),s.expand===2&&this.updateBusyProviders(-1))}break}case 4:this.retireTest(C[1]);break;case 3:this.updatePendingRoots(C[1]);break}R.complete()}retireTest(n){}updateBusyProviders(n){this.busyProviderCount+=n}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new S}}e.AbstractIncrementalTestCollection=I}),define(be[172],we([0,1,11,32,12,23,21,58,141]),function(ie,e,w,k,A,T,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(C,b,f,i){if(this._contributedVariables=new Map,this._context=C,this._labelService=b,f)if(S.isWindows){const s=Object.create(null);this._envVariables=s,Object.keys(f).forEach(v=>{s[v.toLowerCase()]=f[v]})}else this._envVariables=f}async resolveAsync(C,b){return this.recursiveResolve(C?C.uri:void 0,b)}resolve(C,b){return this.recursiveResolve(C?C.uri:void 0,b)}resolveAnyBase(C,b,f,i){const s=T.deepClone(b);return S.isWindows&&s.windows?Object.keys(s.windows).forEach(v=>s[v]=s.windows[v]):S.isMacintosh&&s.osx?Object.keys(s.osx).forEach(v=>s[v]=s.osx[v]):S.isLinux&&s.linux&&Object.keys(s.linux).forEach(v=>s[v]=s.linux[v]),delete s.windows,delete s.osx,delete s.linux,this.recursiveResolve(C?C.uri:void 0,s,f,i)}resolveAny(C,b,f){return this.resolveAnyBase(C,b,f)}async resolveAnyAsync(C,b,f){return this.resolveAnyBase(C,b,f)}resolveAnyMap(C,b,f){const i=new Map;return{newConfig:this.resolveAnyBase(C,b,f,i),resolvedVariables:i}}resolveWithInteractionReplace(C,b,f,i){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,b,f,i){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,b){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,b)}recursiveResolve(C,b,f,i){if(A.isString(b))return this.resolveString(C,b,f,i);if(A.isArray(b))return b.map(s=>this.recursiveResolve(C,s,f,i));if(A.isObject(b)){let s=Object.create(null);return Object.keys(b).forEach(v=>{const h=this.resolveString(C,v,f,i);s[h]=this.recursiveResolve(C,b[v],f,i)}),s}return b}resolveString(C,b,f,i){return b.replace(n.VARIABLE_REGEXP,(v,h)=>{if(h.includes(n.VARIABLE_LHS))return v;let E=this.evaluateSingleVariable(v,h,C,f);return i&&i.set(h,E),E})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,b,f,i){let s;const v=b.split(":");v.length>1&&(b=v[0],s=v[1]);const h=()=>{const a=this._context.getFilePath();if(a)return a;throw new Error((0,y.localize)(0,null,C))},E=()=>{const a=h();if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return o}throw new Error((0,y.localize)(1,null,C,w.basename(a)))},g=()=>{if(s){const a=this._context.getFolderUri(s);if(a)return a;throw new Error((0,y.localize)(2,null,C,s))}if(f)return f;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,C)):new Error((0,y.localize)(4,null,C))};switch(b){case"env":if(s){if(this._envVariables){const a=this._envVariables[S.isWindows?s.toLowerCase():s];if(A.isString(a))return a}return""}throw new Error((0,y.localize)(5,null,C));case"config":if(s){const a=this._context.getConfigurationValue(f,s);if(A.isUndefinedOrNull(a))throw new Error((0,y.localize)(6,null,C,s));if(A.isObject(a))throw new Error((0,y.localize)(7,null,C,s));return a}throw new Error((0,y.localize)(8,null,C));case"command":return this.resolveFromMap(C,s,i,"command");case"input":return this.resolveFromMap(C,s,i,"input");default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(g()));case"cwd":return f||s?(0,I.normalizeDriveLetter)(this.fsPath(g())):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return w.basename(this.fsPath(g()));case"lineNumber":const a=this._context.getLineNumber();if(a)return a;throw new Error((0,y.localize)(9,null,C));case"selectedText":const o=this._context.getSelectedText();if(o)return o;throw new Error((0,y.localize)(10,null,C));case"file":return h();case"fileWorkspaceFolder":return E();case"relativeFile":return f||s?w.relative(this.fsPath(g()),h()):h();case"relativeFileDirname":const t=w.dirname(h());if(f||s){const u=w.relative(this.fsPath(g()),t);return u.length===0?".":u}return t;case"fileDirname":return w.dirname(h());case"fileExtname":return w.extname(h());case"fileBasename":return w.basename(h());case"fileBasenameNoExtension":const r=w.basename(h());return r.slice(0,r.length-w.extname(r).length);case"fileDirnameBasename":return w.basename(w.dirname(h()));case"execPath":const d=this._context.getExecPath();return d||C;case"execInstallFolder":const l=this._context.getAppRoot();return l||C;case"pathSeparator":return w.sep;default:try{const u=s?`${b}:${s}`:b;return this.resolveFromMap(C,u,i,void 0)}catch(u){return C}}}}resolveFromMap(C,b,f,i){if(b&&f){const s=i===void 0?f[b]:f[i+":"+b];if(typeof s=="string")return s;throw new Error((0,y.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[173],we([0,1,4]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,w.createDecorator)("editorGroupsService");var k;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var A;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var S;(function(b){b[b.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",b[b.EVEN=1]="EVEN",b[b.TOGGLE=2]="TOGGLE"})(S=e.GroupsArrangement||(e.GroupsArrangement={}));var I;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(I=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var n;(function(b){b[b.GROUP_ACTIVE=0]="GROUP_ACTIVE",b[b.GROUP_INDEX=1]="GROUP_INDEX",b[b.EDITOR_OPEN=2]="EDITOR_OPEN",b[b.EDITOR_CLOSE=3]="EDITOR_CLOSE",b[b.EDITOR_MOVE=4]="EDITOR_MOVE",b[b.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",b[b.EDITOR_LABEL=6]="EDITOR_LABEL",b[b.EDITOR_PIN=7]="EDITOR_PIN",b[b.EDITOR_STICKY=8]="EDITOR_STICKY",b[b.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(n=e.GroupChangeKind||(e.GroupChangeKind={}));var R;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(R=e.OpenEditorContext||(e.OpenEditorContext={}));function C(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(be[174],we([0,1,4]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,w.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(be[9],we([0,1,15,80,227,57,23,12,2,33,62,142,87,70,174,7]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookDocumentContentOptions=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var v;(function(ue){function De(j){const{selectionStartLineNumber:Ae,selectionStartColumn:Te,positionLineNumber:Ye,positionColumn:Ge}=j,rt=new s.Position(Ae-1,Te-1),at=new s.Position(Ye-1,Ge-1);return new s.Selection(rt,at)}ue.to=De;function le(j){const{anchor:Ae,active:Te}=j;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}ue.from=le})(v=e.Selection||(e.Selection={}));var h;(function(ue){function De(j){if(!!j){const{start:Ae,end:Te}=j;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}}ue.from=De;function le(j){if(!!j){const{startLineNumber:Ae,startColumn:Te,endLineNumber:Ye,endColumn:Ge}=j;return new s.Range(Ae-1,Te-1,Ye-1,Ge-1)}}ue.to=le})(h=e.Range||(e.Range={}));var E;(function(ue){function De(le){switch(le){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 4:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}ue.to=De})(E=e.TokenType||(e.TokenType={}));var g;(function(ue){function De(j){return new s.Position(j.lineNumber-1,j.column-1)}ue.to=De;function le(j){return{lineNumber:j.line+1,column:j.character+1}}ue.from=le})(g=e.Position||(e.Position={}));var a;(function(ue){function De(j){switch(j){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}ue.from=De;function le(j){switch(j){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}ue.to=le})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(ue){function De(j){let Ae;return j.code&&((0,I.isString)(j.code)||(0,I.isNumber)(j.code)?Ae=String(j.code):Ae={value:String(j.code.value),target:j.code.target}),Object.assign(Object.assign({},h.from(j.range)),{message:j.message,source:j.source,code:Ae,severity:r.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(t.from),tags:Array.isArray(j.tags)?(0,w.coalesce)(j.tags.map(a.from)):void 0})}ue.from=De;function le(j){var Ae;const Te=new s.Diagnostic(h.to(j),j.message,r.to(j.severity));return Te.source=j.source,Te.code=(0,I.isString)(j.code)?j.code:(Ae=j.code)===null||Ae===void 0?void 0:Ae.value,Te.relatedInformation=j.relatedInformation&&j.relatedInformation.map(t.to),Te.tags=j.tags&&(0,w.coalesce)(j.tags.map(a.to)),Te}ue.to=le})(o=e.Diagnostic||(e.Diagnostic={}));var t;(function(ue){function De(j){return Object.assign(Object.assign({},h.from(j.location.range)),{message:j.message,resource:j.location.uri})}ue.from=De;function le(j){return new s.DiagnosticRelatedInformation(new s.Location(j.resource,h.to(j)),j.message)}ue.to=le})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var r;(function(ue){function De(j){switch(j){case s.DiagnosticSeverity.Error:return b.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return b.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return b.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return b.MarkerSeverity.Hint}return b.MarkerSeverity.Error}ue.from=De;function le(j){switch(j){case b.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case b.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case b.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case b.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}ue.to=le})(r=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var d;(function(ue){function De(j){return typeof j=="number"&&j>=s.ViewColumn.One?j-1:j===s.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}ue.from=De;function le(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}ue.to=le})(d=e.ViewColumn||(e.ViewColumn={}));function l(ue){return typeof ue.range!="undefined"}function u(ue){return ue.length===0?!0:!!l(ue[0])}e.isDecorationOptionsArr=u;var m;(function(ue){function De(Ge){return Ge.map(ue.from)}ue.fromMany=De;function le(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function j(Ge){let rt;if(le(Ge)){const{language:st,value:gt}=Ge;rt={value:"```"+st+`
`+gt+"\n```\n"}}else s.MarkdownString.isMarkdownString(Ge)?rt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons}:typeof Ge=="string"?rt={value:Ge}:rt={value:""};const at=Object.create(null);rt.uris=at;const Qe=st=>{try{let gt=y.URI.parse(st,!0);gt=gt.with({query:Ae(gt.query,at)}),at[st]=gt}catch(gt){}return""},ut=new A.Renderer;return ut.link=Qe,ut.image=st=>Qe(k.parseHrefAndDimensions(st).href),A(rt.value,{renderer:ut}),rt}ue.from=j;function Ae(Ge,rt){if(!Ge)return Ge;let at;try{at=(0,T.parse)(Ge)}catch(ut){}if(!at)return Ge;let Qe=!1;return at=(0,S.cloneAndChange)(at,ut=>{if(y.URI.isUri(ut)){const st=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[st]=ut,Qe=!0,st}else return}),Qe?JSON.stringify(at):Ge}function Te(Ge){const rt=new s.MarkdownString(Ge.value,Ge.supportThemeIcons);return rt.isTrusted=Ge.isTrusted,rt}ue.to=Te;function Ye(Ge){if(!!Ge)return typeof Ge=="string"?Ge:ue.from(Ge)}ue.fromStrict=Ye})(m=e.MarkdownString||(e.MarkdownString={}));function _(ue){return u(ue)?ue.map(De=>({range:h.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?m.fromMany(De.hoverMessage):De.hoverMessage?m.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):ue.map(De=>({range:h.from(De)}))}e.fromRangeOrRangeWithMessage=_;function D(ue){return typeof ue=="undefined"?ue:typeof ue=="string"?y.URI.file(ue):ue}e.pathOrURIToURI=D;var c;(function(ue){function De(le){return typeof le=="undefined"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?D(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}ue.from=De})(c=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var p;(function(ue){function De(le){return typeof le=="undefined"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?D(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?c.from(le.before):void 0,after:le.after?c.from(le.after):void 0}}ue.from=De})(p=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var P;(function(ue){function De(le){if(typeof le=="undefined")return le;switch(le){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}ue.from=De})(P=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var F;(function(ue){function De(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?P.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?p.from(le.light):void 0,dark:le.dark?p.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?D(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?c.from(le.before):void 0,after:le.after?c.from(le.after):void 0}}ue.from=De})(F=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(ue){function De(j){return{text:j.newText,eol:j.newEol&&X.from(j.newEol),range:h.from(j.range)}}ue.from=De;function le(j){const Ae=new s.TextEdit(h.to(j.range),j.text);return Ae.newEol=typeof j.eol=="undefined"?void 0:X.to(j.eol),Ae}ue.to=le})(z=e.TextEdit||(e.TextEdit={}));var de;(function(ue){function De(j,Ae,Te){var Ye,Ge,rt;const at={edits:[]};if(j instanceof s.WorkspaceEdit)for(let Qe of j._allEntries())if(Qe._type===1)at.edits.push({_type:1,oldUri:Qe.from,newUri:Qe.to,options:Qe.options,metadata:Qe.metadata});else if(Qe._type===2){const ut=Ae==null?void 0:Ae.getDocument(Qe.uri);at.edits.push({_type:2,resource:Qe.uri,edit:z.from(Qe.edit),modelVersionId:ut==null?void 0:ut.version,metadata:Qe.metadata})}else Qe._type===3?at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:(Ye=Te==null?void 0:Te.lookupNotebookDocument(Qe.uri))===null||Ye===void 0?void 0:Ye.notebookDocument.version}):Qe._type===4?(Qe.newOutputs&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:2,index:Qe.index,append:Qe.append,outputs:Qe.newOutputs.map(Be.from)}}),Qe.newMetadata&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:11,index:Qe.index,metadata:Qe.newMetadata}})):Qe._type===5?at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:(Ge=Te==null?void 0:Te.lookupNotebookDocument(Qe.uri))===null||Ge===void 0?void 0:Ge.notebookDocument.version,edit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(fe.from)}}):Qe._type===6&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:10,outputId:Qe.outputId,items:((rt=Qe.newOutputItems)===null||rt===void 0?void 0:rt.map(pe.from))||[],append:Qe.append}});return at}ue.from=De;function le(j){const Ae=new s.WorkspaceEdit;for(const Te of j.edits)Te.edit?Ae.replace(y.URI.revive(Te.resource),h.to(Te.edit.range),Te.edit.text):Ae.renameFile(y.URI.revive(Te.oldUri),y.URI.revive(Te.newUri),Te.options);return Ae}ue.to=le})(de=e.WorkspaceEdit||(e.WorkspaceEdit={}));var B;(function(ue){const De=Object.create(null);De[s.SymbolKind.File]=0,De[s.SymbolKind.Module]=1,De[s.SymbolKind.Namespace]=2,De[s.SymbolKind.Package]=3,De[s.SymbolKind.Class]=4,De[s.SymbolKind.Method]=5,De[s.SymbolKind.Property]=6,De[s.SymbolKind.Field]=7,De[s.SymbolKind.Constructor]=8,De[s.SymbolKind.Enum]=9,De[s.SymbolKind.Interface]=10,De[s.SymbolKind.Function]=11,De[s.SymbolKind.Variable]=12,De[s.SymbolKind.Constant]=13,De[s.SymbolKind.String]=14,De[s.SymbolKind.Number]=15,De[s.SymbolKind.Boolean]=16,De[s.SymbolKind.Array]=17,De[s.SymbolKind.Object]=18,De[s.SymbolKind.Key]=19,De[s.SymbolKind.Null]=20,De[s.SymbolKind.EnumMember]=21,De[s.SymbolKind.Struct]=22,De[s.SymbolKind.Event]=23,De[s.SymbolKind.Operator]=24,De[s.SymbolKind.TypeParameter]=25;function le(Ae){return typeof De[Ae]=="number"?De[Ae]:6}ue.from=le;function j(Ae){for(const Te in De)if(De[Te]===Ae)return Number(Te);return s.SymbolKind.Property}ue.to=j})(B=e.SymbolKind||(e.SymbolKind={}));var W;(function(ue){function De(j){switch(j){case s.SymbolTag.Deprecated:return 1}}ue.from=De;function le(j){switch(j){case 1:return s.SymbolTag.Deprecated}}ue.to=le})(W=e.SymbolTag||(e.SymbolTag={}));var K;(function(ue){function De(j){return{name:j.name,kind:B.from(j.kind),tags:j.tags&&j.tags.map(W.from),containerName:j.containerName,location:$.from(j.location)}}ue.from=De;function le(j){const Ae=new s.SymbolInformation(j.name,B.to(j.kind),j.containerName,$.to(j.location));return Ae.tags=j.tags&&j.tags.map(W.to),Ae}ue.to=le})(K=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var M;(function(ue){function De(j){var Ae,Te;const Ye={name:j.name||"!!MISSING: name!!",detail:j.detail,range:h.from(j.range),selectionRange:h.from(j.selectionRange),kind:B.from(j.kind),tags:(Te=(Ae=j.tags)===null||Ae===void 0?void 0:Ae.map(W.from))!==null&&Te!==void 0?Te:[]};return j.children&&(Ye.children=j.children.map(De)),Ye}ue.from=De;function le(j){const Ae=new s.DocumentSymbol(j.name,j.detail,B.to(j.kind),h.to(j.range),h.to(j.selectionRange));return(0,w.isNonEmptyArray)(j.tags)&&(Ae.tags=j.tags.map(W.to)),j.children&&(Ae.children=j.children.map(le)),Ae}ue.to=le})(M=e.DocumentSymbol||(e.DocumentSymbol={}));var U;(function(ue){function De(le){const j=new s.CallHierarchyItem(B.to(le.kind),le.name,le.detail||"",y.URI.revive(le.uri),h.to(le.range),h.to(le.selectionRange));return j._sessionId=le._sessionId,j._itemId=le._itemId,j}ue.to=De})(U=e.CallHierarchyItem||(e.CallHierarchyItem={}));var x;(function(ue){function De(le){return new s.CallHierarchyIncomingCall(U.to(le.from),le.fromRanges.map(j=>h.to(j)))}ue.to=De})(x=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Q;(function(ue){function De(le){return new s.CallHierarchyOutgoingCall(U.to(le.to),le.fromRanges.map(j=>h.to(j)))}ue.to=De})(Q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var $;(function(ue){function De(j){return{range:j.range&&h.from(j.range),uri:j.uri}}ue.from=De;function le(j){return new s.Location(y.URI.revive(j.uri),h.to(j.range))}ue.to=le})($=e.location||(e.location={}));var ee;(function(ue){function De(j){const Ae=j,Te=j;return{originSelectionRange:Ae.originSelectionRange?h.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Te.uri,range:h.from(Ae.targetRange?Ae.targetRange:Te.range),targetSelectionRange:Ae.targetSelectionRange?h.from(Ae.targetSelectionRange):void 0}}ue.from=De;function le(j){return{targetUri:y.URI.revive(j.uri),targetRange:h.to(j.range),targetSelectionRange:j.targetSelectionRange?h.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?h.to(j.originSelectionRange):void 0}}ue.to=le})(ee=e.DefinitionLink||(e.DefinitionLink={}));var re;(function(ue){function De(j){return{range:h.from(j.range),contents:m.fromMany(j.contents)}}ue.from=De;function le(j){return new s.Hover(j.contents.map(m.to),h.to(j.range))}ue.to=le})(re=e.Hover||(e.Hover={}));var se;(function(ue){function De(j){return{range:h.from(j.range),expression:j.expression}}ue.from=De;function le(j){return new s.EvaluatableExpression(h.to(j.range),j.expression)}ue.to=le})(se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(ue){function De(j){if(j instanceof s.InlineValueText)return{type:"text",range:h.from(j.range),text:j.text};if(j instanceof s.InlineValueVariableLookup)return{type:"variable",range:h.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:h.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}ue.from=De;function le(j){switch(j.type){case"text":return{range:h.to(j.range),text:j.text};case"variable":return{range:h.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:h.to(j.range),expression:j.expression}}}ue.to=le})(ye=e.InlineValue||(e.InlineValue={}));var Ie;(function(ue){function De(j){return{frameId:j.frameId,stoppedLocation:h.from(j.stoppedLocation)}}ue.from=De;function le(j){return new s.InlineValueContext(j.frameId,h.to(j.stoppedLocation))}ue.to=le})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var xe;(function(ue){function De(j){return{range:h.from(j.range),kind:j.kind}}ue.from=De;function le(j){return new s.DocumentHighlight(h.to(j.range),j.kind)}ue.to=le})(xe=e.DocumentHighlight||(e.DocumentHighlight={}));var Fe;(function(ue){function De(le){switch(le){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}ue.to=De})(Fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ze;(function(ue){function De(le){return{triggerKind:Fe.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}ue.to=De})(ze=e.CompletionContext||(e.CompletionContext={}));var N;(function(ue){function De(j){switch(j){case s.CompletionItemTag.Deprecated:return 1}}ue.from=De;function le(j){switch(j){case 1:return s.CompletionItemTag.Deprecated}}ue.to=le})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var G;(function(ue){const De=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function le(Te){var Ye;return(Ye=De.get(Te))!==null&&Ye!==void 0?Ye:9}ue.from=le;const j=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Ae(Te){var Ye;return(Ye=j.get(Te))!==null&&Ye!==void 0?Ye:s.CompletionItemKind.Property}ue.to=Ae})(G=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(ue){function De(le,j){var Ae;const Te=new s.CompletionItem(typeof le.label=="string"?le.label:le.label.name);return typeof le.label!="string"&&(Te.label2=le.label),Te.insertText=le.insertText,Te.kind=G.to(le.kind),Te.tags=(Ae=le.tags)===null||Ae===void 0?void 0:Ae.map(N.to),Te.detail=le.detail,Te.documentation=k.isMarkdownString(le.documentation)?m.to(le.documentation):le.documentation,Te.sortText=le.sortText,Te.filterText=le.filterText,Te.preselect=le.preselect,Te.commitCharacters=le.commitCharacters,n.Range.isIRange(le.range)?Te.range=h.to(le.range):typeof le.range=="object"&&(Te.range={inserting:h.to(le.range.insert),replacing:h.to(le.range.replace)}),Te.keepWhitespace=typeof le.insertTextRules=="undefined"?!1:Boolean(le.insertTextRules&1),typeof le.insertTextRules!="undefined"&&le.insertTextRules&4?Te.insertText=new s.SnippetString(le.insertText):(Te.insertText=le.insertText,Te.textEdit=Te.range instanceof s.Range?new s.TextEdit(Te.range,Te.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Te.additionalTextEdits=le.additionalTextEdits.map(Ye=>z.to(Ye))),Te.command=j&&le.command?j.fromInternal(le.command):void 0,Te}ue.to=De})(te=e.CompletionItem||(e.CompletionItem={}));var ae;(function(ue){function De(j){return{label:j.label,documentation:j.documentation?m.fromStrict(j.documentation):void 0}}ue.from=De;function le(j){return{label:j.label,documentation:k.isMarkdownString(j.documentation)?m.to(j.documentation):j.documentation}}ue.to=le})(ae=e.ParameterInformation||(e.ParameterInformation={}));var me;(function(ue){function De(j){return{label:j.label,documentation:j.documentation?m.fromStrict(j.documentation):void 0,parameters:Array.isArray(j.parameters)?j.parameters.map(ae.from):[],activeParameter:j.activeParameter}}ue.from=De;function le(j){return{label:j.label,documentation:k.isMarkdownString(j.documentation)?m.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map(ae.to):[],activeParameter:j.activeParameter}}ue.to=le})(me=e.SignatureInformation||(e.SignatureInformation={}));var Se;(function(ue){function De(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(me.from):[]}}ue.from=De;function le(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(me.to):[]}}ue.to=le})(Se=e.SignatureHelp||(e.SignatureHelp={}));var Le;(function(ue){function De(j){var Ae;return{text:j.text,range:h.from(j.range),kind:ge.from((Ae=j.kind)!==null&&Ae!==void 0?Ae:s.InlineHintKind.Other),description:j.description&&m.fromStrict(j.description),whitespaceBefore:j.whitespaceBefore,whitespaceAfter:j.whitespaceAfter}}ue.from=De;function le(j){const Ae=new s.InlineHint(j.text,h.to(j.range),ge.to(j.kind));return Ae.whitespaceAfter=j.whitespaceAfter,Ae.whitespaceBefore=j.whitespaceBefore,Ae.description=k.isMarkdownString(j.description)?m.to(j.description):j.description,Ae}ue.to=le})(Le=e.InlineHint||(e.InlineHint={}));var ge;(function(ue){function De(j){return j}ue.from=De;function le(j){return j}ue.to=le})(ge=e.InlineHintKind||(e.InlineHintKind={}));var Ce;(function(ue){function De(j){return{range:h.from(j.range),url:j.target,tooltip:j.tooltip}}ue.from=De;function le(j){let Ae;if(j.url)try{Ae=typeof j.url=="string"?y.URI.parse(j.url,!0):y.URI.revive(j.url)}catch(Te){}return new s.DocumentLink(h.to(j.range),Ae)}ue.to=le})(Ce=e.DocumentLink||(e.DocumentLink={}));var Pe;(function(ue){function De(j){const Ae=new s.ColorPresentation(j.label);return j.textEdit&&(Ae.textEdit=z.to(j.textEdit)),j.additionalTextEdits&&(Ae.additionalTextEdits=j.additionalTextEdits.map(Te=>z.to(Te))),Ae}ue.to=De;function le(j){return{label:j.label,textEdit:j.textEdit?z.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(Ae=>z.from(Ae)):void 0}}ue.from=le})(Pe=e.ColorPresentation||(e.ColorPresentation={}));var $e;(function(ue){function De(j){return new s.Color(j[0],j[1],j[2],j[3])}ue.to=De;function le(j){return[j.red,j.green,j.blue,j.alpha]}ue.from=le})($e=e.Color||(e.Color={}));var _e;(function(ue){function De(j){return{range:h.from(j.range)}}ue.from=De;function le(j){return new s.SelectionRange(h.to(j.range))}ue.to=le})(_e=e.SelectionRange||(e.SelectionRange={}));var qe;(function(ue){function De(le){switch(le){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}ue.to=De})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var V;(function(ue){function De(j){switch(j){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}ue.from=De;function le(j){switch(j){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}ue.to=le})(V=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var X;(function(ue){function De(j){if(j===s.EndOfLine.CRLF)return 1;if(j===s.EndOfLine.LF)return 0}ue.from=De;function le(j){if(j===1)return s.EndOfLine.CRLF;if(j===0)return s.EndOfLine.LF}ue.to=le})(X=e.EndOfLine||(e.EndOfLine={}));var ve;(function(ue){function De(le){if(typeof le=="object")return le.viewId;switch(le){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ue.from=De})(ve=e.ProgressLocation||(e.ProgressLocation={}));var Me;(function(ue){function De(le){const j={start:le.start+1,end:le.end+1};return le.kind&&(j.kind=He.from(le.kind)),j}ue.from=De})(Me=e.FoldingRange||(e.FoldingRange={}));var He;(function(ue){function De(le){if(le)switch(le){case s.FoldingRangeKind.Comment:return R.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return R.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return R.FoldingRangeKind.Region}}ue.from=De})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Oe;(function(ue){function De(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?h.from(le.selection):void 0,override:typeof le.override=="boolean"?C.EditorOverride.DISABLED:void 0}}ue.from=De})(Oe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var et;(function(ue){function De(j){return j instanceof s.RelativePattern||typeof j=="string"?j:le(j)?new s.RelativePattern(j.base,j.pattern):j}ue.from=De;function le(j){const Ae=j;return Ae&&typeof Ae.base=="string"&&typeof Ae.pattern=="string"}})(et=e.GlobPattern||(e.GlobPattern={}));var H;(function(ue){function De(le){if(le){if(Array.isArray(le))return le.map(De);if(typeof le=="string")return le;{const j=le;return{language:j.language,scheme:j.scheme,pattern:typeof j.pattern=="undefined"?void 0:et.from(j.pattern),exclusive:j.exclusive}}}else return}ue.from=De})(H=e.LanguageSelector||(e.LanguageSelector={}));var ne;(function(ue){function De(j){return{start:j.start,end:j.end}}ue.from=De;function le(j){return new s.NotebookCellRange(j.start,j.end)}ue.to=le})(ne=e.NotebookCellRange||(e.NotebookCellRange={}));var he;(function(ue){function De(le){return new s.NotebookCellMetadata(le.editable,le.breakpointMargin,le.hasExecutionOrder,le.statusMessage,le.inputCollapsed,le.outputCollapsed,le.custom)}ue.to=De})(he=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var q;(function(ue){function De(j){return j}ue.from=De;function le(j){return new s.NotebookDocumentMetadata(j.editable,j.cellEditable,j.cellHasExecutionOrder,j.custom,j.trusted)}ue.to=le})(q=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var J;(function(ue){function De(j){return{duration:j.lastRunDuration,executionOrder:j.executionOrder,success:j.lastRunSuccess}}ue.to=De;function le(j){return{lastRunSuccess:j.success,lastRunDuration:j.duration,executionOrder:j.executionOrder}}ue.from=le})(J=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var oe;(function(ue){function De(j){switch(j){case s.NotebookCellKind.Markdown:return f.CellKind.Markdown;case s.NotebookCellKind.Code:default:return f.CellKind.Code}}ue.from=De;function le(j){switch(j){case f.CellKind.Markdown:return s.NotebookCellKind.Markdown;case f.CellKind.Code:default:return s.NotebookCellKind.Code}}ue.to=le})(oe=e.NotebookCellKind||(e.NotebookCellKind={}));var fe;(function(ue){function De(j){var Ae;return{cellKind:oe.from(j.kind),language:j.language,source:j.source,metadata:Object.assign(Object.assign({},j.metadata),J.from((Ae=j.latestExecutionSummary)!==null&&Ae!==void 0?Ae:{})),outputs:j.outputs?j.outputs.map(Be.from):[]}}ue.from=De;function le(j){return new s.NotebookCellData(oe.to(j.cellKind),j.source,j.language,j.outputs?j.outputs.map(Be.to):void 0,j.metadata?he.to(j.metadata):void 0)}ue.to=le})(fe=e.NotebookCellData||(e.NotebookCellData={}));var pe;(function(ue){function De(j){return{mime:j.mime,value:j.value,metadata:j.metadata}}ue.from=De;function le(j){return new s.NotebookCellOutputItem(j.mime,j.value,j.metadata)}ue.to=le})(pe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Be;(function(ue){function De(j){return{outputId:j.id,outputs:j.outputs.map(pe.from),metadata:j.metadata}}ue.from=De;function le(j){const Ae=j.outputs.map(pe.to);return new s.NotebookCellOutput(Ae,j.outputId,j.metadata)}ue.to=le})(Be=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ne;(function(ue){function De(Te){if(Te!=null){if(Te instanceof s.RelativePattern||typeof Te=="string")return Te;if(Ae(Te))return new s.RelativePattern(Te.base,Te.pattern);if(j(Te))return{include:et.from(Te.include)||void 0,exclude:et.from(Te.exclude)||void 0}}}ue.from=De;function le(Te){return typeof Te=="string"?Te:Ae(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}ue.to=le;function j(Te){const Ye=Te,Ge=et.from(Ye.include);if(!(Ge&&Ge instanceof s.RelativePattern||typeof Ge=="string"))return!1;const rt=et.from(Ye.exclude);return!!(rt&&rt instanceof s.RelativePattern||typeof rt=="string")}function Ae(Te){const Ye=Te;return Ye&&typeof Ye.base=="string"&&typeof Ye.pattern=="string"}})(Ne=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ve;(function(ue){function De(le){return{backgroundColor:le.backgroundColor,borderColor:le.borderColor,top:le.top?c.from(le.top):void 0}}ue.from=De})(Ve=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Xe;(function(ue){function De(le){var j;return{transientOutputs:le?le.transientOutputs:!1,transientMetadata:Object.assign(Object.assign({},(j=le==null?void 0:le.transientMetadata)!==null&&j!==void 0?j:{}),{executionOrder:!0,lastRunDuration:!0,runState:!0,runStartTime:!0,lastRunSuccess:!0})}}ue.from=De})(Xe=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ze;(function(ue){function De(j){return{message:m.fromStrict(j.message)||"",severity:j.severity,expectedOutput:j.expectedOutput,actualOutput:j.actualOutput,location:j.location?$.from(j.location):void 0}}ue.from=De;function le(j){const Ae=new s.TestMessage(typeof j.message=="string"?j.message:m.to(j.message));return Ae.severity=j.severity,Ae.actualOutput=j.actualOutput,Ae.expectedOutput=j.expectedOutput,Ae}ue.to=le})(Ze=e.TestMessage||(e.TestMessage={}));var ct;(function(ue){function De(Te){var Ye,Ge;return{extId:Te.id,label:Te.label,uri:Te.uri,range:h.from(Te.range),debuggable:(Ye=Te.debuggable)!==null&&Ye!==void 0?Ye:!1,description:Te.description,runnable:(Ge=Te.runnable)!==null&&Ge!==void 0?Ge:!0,expandable:Te.expandable}}ue.from=De;function le(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:h.from(Te.range),debuggable:!1,description:Te.description,runnable:!0,expandable:!0}}ue.fromResultSnapshot=le;function j(Te){return{id:Te.extId,label:Te.label,uri:y.URI.revive(Te.uri),range:h.to(Te.range),expandable:Te.expandable,debuggable:Te.debuggable,description:Te.description,runnable:Te.runnable}}ue.toPlain=j;function Ae(Te){const Ye=new s.TestItem(Te.extId,Te.label,y.URI.revive(Te.uri),Te.expandable);return Ye.range=h.to(Te.range),Ye.debuggable=Te.debuggable,Ye.description=Te.description,Ye.runnable=Te.runnable,Ye}ue.to=Ae})(ct=e.TestItem||(e.TestItem={}));var ot;(function(ue){function De(Ae,Te){var Ye,Ge,rt;const at={completedAt:Te.completedAt,id:Ae,items:[]},Qe=[[null,Te.results]];for(;Qe.length;){const[ut,st]=Qe.pop();for(const gt of st){const wt={children:(Ge=(Ye=gt.children)===null||Ye===void 0?void 0:Ye.map(St=>St.id))!==null&&Ge!==void 0?Ge:[],computedState:gt.state,item:ct.fromResultSnapshot(gt),state:{state:gt.state,duration:gt.duration,messages:gt.messages.map(Ze.from)},retired:void 0,expand:3,parent:(rt=ut==null?void 0:ut.item.extId)!==null&&rt!==void 0?rt:null,src:{provider:"",tree:-1},direct:!ut};at.items.push(wt),gt.children&&Qe.push([wt,gt.children])}}return at}ue.from=De;const le=(Ae,Te)=>Object.assign(Object.assign({},ct.toPlain(Ae.item)),{state:Ae.state.state,duration:Ae.state.duration,messages:Ae.state.messages.map(Ze.to),children:Ae.children.map(Ye=>Te.get(Ye)).filter(I.isDefined).map(Ye=>le(Ye,Te))});function j(Ae){const Te=[],Ye=new Map;for(const Ge of Ae.items)Ye.set(Ge.item.extId,Ge),Ge.direct&&Te.push(Ge);return{completedAt:Ae.completedAt,results:Te.map(Ge=>le(Ge,Ye))}}ue.to=j})(ot=e.TestResults||(e.TestResults={}));var nt;(function(ue){function De(le){switch(le){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}ue.to=De})(nt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(be[175],we([0,1,2,10,7,9,45]),function(ie,e,w,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(n,R,C,b={timeout:1500,errors:3}){this._logService=n,this._documents=R,this._mainThreadBulkEdits=C,this._thresholds=b,this._callbacks=new S.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(n){return(R,C,b)=>{const i={dispose:this._callbacks.push([R,C,n])};return Array.isArray(b)&&b.push(i),i}}async $participateInSave(n,R){const C=w.URI.revive(n);let b=!1;const f=setTimeout(()=>b=!0,this._thresholds.timeout),i=[];try{for(let s of[...this._callbacks]){if(b)break;const v=this._documents.getDocument(C),h=await this._deliverEventAsyncAndBlameBadListeners(s,{document:v,reason:T.TextDocumentSaveReason.to(R)});i.push(h)}}finally{clearTimeout(f)}return i}_deliverEventAsyncAndBlameBadListeners([n,R,C],b){const f=this._badListeners.get(n);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,n,R,b).then(()=>!0,i=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(i),!(i instanceof Error)||i.message!=="concurrent_edits"){const s=this._badListeners.get(n);this._badListeners.set(n,s?s+1:1),typeof s=="number"&&s>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(n,R,C,b){const f=[],i=Date.now(),{document:s,reason:v}=b,{version:h}=s,E=Object.freeze({document:s,reason:v,waitUntil(g){if(Object.isFrozen(f))throw(0,k.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(g))}});try{R.apply(C,[E])}catch(g){return Promise.reject(g)}return Object.freeze(f),new Promise((g,a)=>{const o=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${n.identifier.value}' finished after ${Date.now()-i}ms`),clearTimeout(o),g(t)}).catch(t=>{clearTimeout(o),a(t)})}).then(g=>{const a={edits:[]};for(const o of g)if(Array.isArray(o)&&o.every(t=>t instanceof A.TextEdit))for(const{newText:t,newEol:r,range:d}of o)a.edits.push({_type:2,resource:s.uri,edit:{range:d&&T.Range.from(d),text:t,eol:r&&T.EndOfLine.from(r)}});if(a.edits.length!==0)return h===s.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(be[176],we([0,1,3,13,28,2,9,7]),function(ie,e,w,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(C,b,f,i,s){this._onDidCreate=new w.Emitter,this._onDidChange=new w.Emitter,this._onDidDelete=new w.Emitter,this._config=0,f&&(this._config+=1),i&&(this._config+=2),s&&(this._config+=4);const v=(0,A.parse)(b),h=C(E=>{if(!f)for(let g of E.created){const a=T.URI.revive(g);v(a.fsPath)&&this._onDidCreate.fire(a)}if(!i)for(let g of E.changed){const a=T.URI.revive(g);v(a.fsPath)&&this._onDidChange.fire(a)}if(!s)for(let g of E.deleted){const a=T.URI.revive(g);v(a.fsPath)&&this._onDidDelete.fire(a)}});this._disposable=I.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,h)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class n{constructor(C,b,f){this._logService=b,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new w.Emitter,this._onDidRenameFile=new w.Emitter,this._onDidCreateFile=new w.Emitter,this._onDidDeleteFile=new w.Emitter,this._onWillRenameFile=new k.AsyncEmitter,this._onWillCreateFile=new k.AsyncEmitter,this._onWillDeleteFile=new k.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,b,f,i){return new y(this._onFileSystemEvent.event,C,b,f,i)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,b){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:b.map(f=>({oldUri:T.URI.revive(f.source),newUri:T.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:b.map(f=>T.URI.revive(f.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:b.map(f=>T.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,b){return(f,i,s)=>{const v=function(E){f.call(i,E)};return v.extension=C,b.event(v,void 0,s)}}async $onWillRunFileOperation(C,b,f,i){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:b.map(s=>({oldUri:T.URI.revive(s.source),newUri:T.URI.revive(s.target)}))},f,i);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:b.map(s=>T.URI.revive(s.target))},f,i);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:b.map(s=>T.URI.revive(s.target))},f,i)}}async _fireWillEvent(C,b,f,i){const s=new Set,v=[];if(await C.fireAsync(b,i,async(E,g)=>{var a;const o=Date.now(),t=await Promise.resolve(E);t instanceof I.WorkspaceEdit&&(v.push(t),s.add((a=g.extension.displayName)!==null&&a!==void 0?a:g.extension.identifier.value)),Date.now()-o>f&&this._logService.warn("SLOW file-participant",g.extension.identifier)}),!i.isCancellationRequested&&v.length!==0){const h={edits:[]};for(let E of v){let{edits:g}=S.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);h.edits=h.edits.concat(g)}return{edit:h,extensionNames:Array.from(s)}}}}e.ExtHostFileSystemEventService=n}),define(be[177],we([0,1,3,6,18,23,2,9,7,70]),function(ie,e,w,k,A,T,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(i,s,v,h){this.start=i,this.deletedCount=s,this.deletedItems=v,this.items=h}static asApiEvents(i){return i.map(s=>({start:s.start,deletedCount:s.deletedCount,deletedItems:s.deletedItems,items:s.items.map(v=>v.cell)}))}}class C{constructor(i,s,v){var h;this._notebook=i,this._extHostDocument=s,this._cellData=v,this._onDidDispose=new w.Emitter,this.onDidDispose=this._onDidDispose.event,this.handle=v.handle,this.uri=S.URI.revive(v.uri),this.cellKind=v.cellKind,this._outputs=v.outputs.map(I.NotebookCellOutput.to),this._internalMetadata=(h=v.metadata)!==null&&h!==void 0?h:{},this._metadata=I.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=I.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(i,s){return{EOL:s.eol,lines:s.source,modeId:s.language,uri:s.uri,isDirty:!1,versionId:1,notebook:i}}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const i=this,s=this._extHostDocument.getDocument(this.uri);if(!s)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return i._notebook.getCellIndex(i)},notebook:i._notebook.notebookDocument,kind:I.NotebookCellKind.to(this._cellData.cellKind),document:s.document,get outputs(){return i._outputs.slice(0)},get metadata(){return i._metadata},get latestExecutionSummary(){return i._previousResult}})}return this._cell}setOutputs(i){this._outputs=i.map(I.NotebookCellOutput.to)}setOutputItems(i,s,v){const h=v.map(I.NotebookCellOutputItem.to),E=this._outputs.find(g=>g.id===i);E&&(s||(E.outputs.length=0),E.outputs.push(...h))}setMetadata(i){this._internalMetadata=i,this._metadata=I.NotebookCellMetadata.to(i),this._previousResult=I.NotebookCellPreviousExecutionResult.to(i)}}e.ExtHostCell=C;class b extends k.Disposable{constructor(i,s,v,h,E,g,a){super();this._proxy=i,this._textDocumentsAndEditors=s,this._textDocuments=v,this._emitter=h,this._viewType=E,this._metadata=g,this.uri=a,this.handle=b._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0,super.dispose(),(0,k.dispose)(this._cellDisposableMapping.values())}get notebookDocument(){if(!this._notebook){const i=this;this._notebook=Object.freeze({get uri(){return i.uri},get version(){return i._versionId},get fileName(){return i.uri.fsPath},get viewType(){return i._viewType},get isDirty(){return i._isDirty},get isUntitled(){return i.uri.scheme===A.Schemas.untitled},get isClosed(){return i._disposed},get metadata(){return i._metadata},get cells(){return i._cells.map(s=>s.cell)},get cellCount(){return i._cells.length},cellAt(s){return s=i._validateIndex(s),i._cells[s].cell},getCells(s){return(s?i._getCells(s):i._cells).map(h=>h.cell)},save(){return i._save()}})}return this._notebook}updateBackup(i){var s;(s=this._backup)===null||s===void 0||s.delete(),this._backup=i}disposeBackup(){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(i){i.metadata&&(this._metadata=this._metadata.with(i.metadata))}acceptModelChanged(i,s){this._versionId=i.versionId,this._isDirty=s;for(const v of i.rawEvents)v.kind===n.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(v.changes,!0),v.kind===n.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(v.changes,!1):v.kind===n.NotebookCellsChangeType.Move?this._moveCell(v.index,v.newIdx):v.kind===n.NotebookCellsChangeType.Output?this._setCellOutputs(v.index,v.outputs):v.kind===n.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(v.index,v.outputId,v.append,v.outputItems):v.kind===n.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(v.index,v.language):v.kind===n.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(v.index,v.metadata)}_validateIndex(i){return i<0?0:i>=this._cells.length?this._cells.length-1:i}_validateRange(i){return i.start<0&&(i=i.with({start:0})),i.end>this._cells.length&&(i=i.with({end:this._cells.length})),i}_getCells(i){i=this._validateRange(i);const s=[];for(let v=i.start;v<i.end;v++)s.push(this._cells[v]);return s}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(i,s){if(!this._disposed){const v=[],h=[],E=[];i.reverse().forEach(g=>{var a;const t=g[2].map(l=>{const u=new C(this,this._textDocumentsAndEditors,l);if(s||h.push(C.asModelAddData(this.notebookDocument,l)),!this._cellDisposableMapping.has(u.handle)){const m=new k.DisposableStore;m.add(u),this._cellDisposableMapping.set(u.handle,m)}return u});for(let l=g[0];l<g[0]+g[1];l++)(a=this._cellDisposableMapping.get(this._cells[l].handle))===null||a===void 0||a.dispose(),this._cellDisposableMapping.delete(this._cells[l].handle);const r=new R(g[0],g[1],[],t),d=this._cells.splice(g[0],g[1],...t);for(let l of d)E.push(l.uri),r.deletedItems.push(l.cell);v.push(r)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:E}),s||this._emitter.emitModelChange((0,T.deepFreeze)({document:this.notebookDocument,changes:R.asApiEvents(v)}))}}_moveCell(i,s){const v=this._cells.splice(i,1);this._cells.splice(s,0,...v);const h=[new R(i,1,v.map(E=>E.cell),[]),new R(s,0,[],v)];this._emitter.emitModelChange((0,T.deepFreeze)({document:this.notebookDocument,changes:R.asApiEvents(h)}))}_setCellOutputs(i,s){const v=this._cells[i];v.setOutputs(s),this._emitter.emitCellOutputsChange((0,T.deepFreeze)({document:this.notebookDocument,cells:[v.cell]}))}_setCellOutputItems(i,s,v,h){const E=this._cells[i];E.setOutputItems(s,v,h),this._emitter.emitCellOutputsChange((0,T.deepFreeze)({document:this.notebookDocument,cells:[E.cell]}))}_changeCellLanguage(i,s){const v=this._cells[i];v.cell.document.languageId!==s&&this._textDocuments.$acceptModelModeChanged(v.uri,s)}_changeCellMetadata(i,s){var v;const h=this._cells[i],E=h.internalMetadata,g=h.cell.metadata;h.setMetadata(s);const a=h.cell.metadata;if((0,T.equals)(g,a)||this._emitter.emitCellMetadataChange((0,T.deepFreeze)({document:this.notebookDocument,cell:h.cell})),E.runState!==s.runState){const o=(v=s.runState)!==null&&v!==void 0?v:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,T.deepFreeze)({document:this.notebookDocument,cell:h.cell,executionState:o}))}}getCellFromIndex(i){return this._cells[i]}getCell(i){return this._cells.find(s=>s.handle===i)}getCellIndex(i){return this._cells.indexOf(i)}}e.ExtHostNotebookDocument=b,b._handlePool=0}),define(be[178],we([0,1,3,7,9]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,n){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:y,metadata:n})}replaceCellOutput(y,n){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:y,outputs:n.map(R=>A.NotebookCellOutput.from(R))})}replaceCells(y,n,R){this._throwIfFinalized(),!(y===n&&R.length===0)&&this._collectedEdits.push({editType:1,index:y,count:n-y,cells:R.map(A.NotebookCellData.from)})}}class S{constructor(y,n,R,C,b,f){this.id=y,this._proxy=n,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._onDidDispose=new w.Emitter,this.onDidDispose=this._onDidDispose.event,this._selections=b,this._visibleRanges=C,this._viewColumn=f}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get editor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.notebookDocument},get selection(){var n;const R=y._selections[0];return R&&((n=y.notebookData.getCellFromIndex(R.start))===null||n===void 0?void 0:n.cell)},get selections(){return y._selections},get visibleRanges(){return y._visibleRanges},revealRange(n,R){y._proxy.$tryRevealRange(y.id,A.NotebookCellRange.from(n),R!=null?R:k.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},get onDidDispose(){return y.onDidDispose},edit(n){const R=new T(this.document.version);return n(R),y._applyEdit(R.finalize())},get kernel(){return y._kernel},setDecorations(n,R){return y.setDecorations(n,R)}}}return this._editor}_acceptKernel(y){this._kernel=y}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const n=[];let R=-1;for(let C=0;C<y.cellEdits.length;C++){if(R<0){n.push(y.cellEdits[C]),R++;continue}const f=n[R],i=y.cellEdits[C];if(f.editType===1&&i.editType===1&&f.index===i.index){f.cells.push(...y.cellEdits[C].cells),f.count+=y.cellEdits[C].count;continue}n.push(y.cellEdits[C]),R++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,n)}setDecorations(y,n){if(!(n.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return n.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,A.NotebookCellRange.from(n),y.key)}}e.ExtHostNotebookEditor=S}),define(be[179],we([0,1,9,152,132,20,51]),function(ie,e,w,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class I{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,b,f){const i=this._handles++,{title:s,location:v,cancellable:h}=b,E={label:(0,A.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(i,{location:w.ProgressLocation.from(v),title:s,source:E,cancellable:h},C),this._withProgress(i,f,!!h)}_withProgress(C,b,f){let i;f&&(i=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,i));const s=h=>{this._proxy.$progressEnd(h),this._mapHandleToCancellationSource.delete(h),i&&i.dispose()};let v;try{v=b(new n(this._proxy,C),f&&i?i.token:T.CancellationToken.None)}catch(h){throw s(C),h}return v.then(h=>s(C),h=>s(C)),v}$acceptProgressCanceled(C){const b=this._mapHandleToCancellationSource.get(C);b&&(b.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=I;function y(R,C){return R.message=C.message,typeof C.increment=="number"&&(typeof R.increment=="number"?R.increment+=C.increment:R.increment=C.increment),R}class n extends k.Progress{constructor(C,b){super(f=>this.throttledReport(f));this._proxy=C,this._handle=b}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}je([(0,S.throttle)(100,(R,C)=>y(R,C),()=>Object.create(null))],n.prototype,"throttledReport",null)}),define(be[96],we([0,1,43,10,53,9,7]),function(ie,e,w,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(b,f){const i=I._Keys.nextId();b.$registerTextEditorDecorationType(i,T.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:i,dispose(){b.$removeTextEditorDecorationType(i)}})}}e.TextEditorDecorationType=I,I._Keys=new A.IdGenerator("TextEditorDecorationType");class y{constructor(b,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=b,this._documentVersionId=b.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(b,f){this._throwIfFinalized();let i=null;if(b instanceof S.Position)i=new S.Range(b,b);else if(b instanceof S.Range)i=b;else throw new Error("Unrecognized location");this._pushEdit(i,f,!1)}insert(b,f){this._throwIfFinalized(),this._pushEdit(new S.Range(b,b),f,!0)}delete(b){this._throwIfFinalized();let f=null;if(b instanceof S.Range)f=b;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(b,f,i){const s=this._document.validateRange(b);this._collectedEdits.push({range:s,text:f,forceMoveMarkers:i})}setEndOfLine(b){if(this._throwIfFinalized(),b!==S.EndOfLine.LF&&b!==S.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this._setEndOfLine=b}}e.TextEditorEdit=y;class n{constructor(b,f,i,s){this._proxy=b,this._id=f,this._accept(i),this._logService=s;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(h){v._setTabSize(h)},get insertSpaces(){return v._insertSpaces},set insertSpaces(h){v._setInsertSpaces(h)},get cursorStyle(){return v._cursorStyle},set cursorStyle(h){v._setCursorStyle(h)},get lineNumbers(){return v._lineNumbers},set lineNumbers(h){v._setLineNumbers(h)}}}_accept(b){this._tabSize=b.tabSize,this._insertSpaces=b.insertSpaces,this._cursorStyle=b.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(b.lineNumbers)}_validateTabSize(b){if(b==="auto")return"auto";if(typeof b=="number"){const f=Math.floor(b);return f>0?f:null}if(typeof b=="string"){const f=parseInt(b,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(b){const f=this._validateTabSize(b);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(b){return b==="auto"?"auto":b==="false"?!1:Boolean(b)}_setInsertSpaces(b){const f=this._validateInsertSpaces(b);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(b){this._cursorStyle!==b&&(this._cursorStyle=b,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:b})))}_setLineNumbers(b){this._lineNumbers!==b&&(this._lineNumbers=b,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(b)})))}assign(b){const f={};let i=!1;if(typeof b.tabSize!="undefined"){const s=this._validateTabSize(b.tabSize);s==="auto"?(i=!0,f.tabSize=s):typeof s=="number"&&this._tabSize!==s&&(this._tabSize=s,i=!0,f.tabSize=s)}if(typeof b.insertSpaces!="undefined"){const s=this._validateInsertSpaces(b.insertSpaces);s==="auto"?(i=!0,f.insertSpaces=s):this._insertSpaces!==s&&(this._insertSpaces=s,i=!0,f.insertSpaces=s)}typeof b.cursorStyle!="undefined"&&this._cursorStyle!==b.cursorStyle&&(this._cursorStyle=b.cursorStyle,i=!0,f.cursorStyle=b.cursorStyle),typeof b.lineNumbers!="undefined"&&this._lineNumbers!==b.lineNumbers&&(this._lineNumbers=b.lineNumbers,i=!0,f.lineNumbers=T.TextEditorLineNumbersStyle.from(b.lineNumbers)),i&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(b){b.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=n;class R{constructor(b,f,i,s,v,h,E,g){this.id=b,this._proxy=f,this._logService=i,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new n(this._proxy,this.id,h,i),this._visibleRanges=E,this._viewColumn=g;const a=this;this.value=Object.freeze({get document(){return s.getValue()},set document(o){throw(0,k.readonly)("document")},get selection(){return a._selections&&a._selections[0]},set selection(o){if(!(o instanceof S.Selection))throw(0,k.illegalArgument)("selection");a._selections=[o],a._trySetSelection()},get selections(){return a._selections},set selections(o){if(!Array.isArray(o)||o.some(t=>!(t instanceof S.Selection)))throw(0,k.illegalArgument)("selections");a._selections=o,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(o){throw(0,k.readonly)("visibleRanges")},get options(){return a._options.value},set options(o){a._disposed||a._options.assign(o)},get viewColumn(){return a._viewColumn},set viewColumn(o){throw(0,k.readonly)("viewColumn")},edit(o,t={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new y(s.getValue(),t);return o(r),a._applyEdit(r)},insertSnippet(o,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=a._selections.map(l=>T.Range.from(l));else if(t instanceof S.Position){const{lineNumber:l,column:u}=T.Position.from(t);d=[{startLineNumber:l,startColumn:u,endLineNumber:l,endColumn:u}]}else if(t instanceof S.Range)d=[T.Range.from(t)];else{d=[];for(const l of t)if(l instanceof S.Range)d.push(T.Range.from(l));else{const{lineNumber:u,column:m}=T.Position.from(l);d.push({startLineNumber:u,startColumn:m,endLineNumber:u,endColumn:m})}}return f.$tryInsertSnippet(b,o.value,d,r)},setDecorations(o,t){const r=t.length===0;r&&!a._hasDecorationsForKey.has(o.key)||(r?a._hasDecorationsForKey.delete(o.key):a._hasDecorationsForKey.add(o.key),a._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return f.$trySetDecorations(b,o.key,T.fromRangeOrRangeWithMessage(t));{const d=new Array(4*t.length);for(let l=0,u=t.length;l<u;l++){const m=t[l];d[4*l]=m.start.line+1,d[4*l+1]=m.start.character+1,d[4*l+2]=m.end.line+1,d[4*l+3]=m.end.character+1}return f.$trySetDecorationsFast(b,o.key,d)}}))},revealRange(o,t){a._runOnProxy(()=>f.$tryRevealRange(b,T.Range.from(o),t||S.TextEditorRevealType.Default))},show(o){f.$tryShowEditor(b,T.ViewColumn.from(o))},hide(){f.$tryHideEditor(b)}})}dispose(){(0,w.ok)(!this._disposed),this._disposed=!0}_acceptOptions(b){(0,w.ok)(!this._disposed),this._options._accept(b)}_acceptVisibleRanges(b){(0,w.ok)(!this._disposed),this._visibleRanges=b}_acceptViewColumn(b){(0,w.ok)(!this._disposed),this._viewColumn=b}_acceptSelections(b){(0,w.ok)(!this._disposed),this._selections=b}async _trySetSelection(){const b=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,b)),this.value}_applyEdit(b){const f=b.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const i=f.edits.map(v=>v.range);i.sort((v,h)=>v.end.line===h.end.line?v.end.character===h.end.character?v.start.line===h.start.line?v.start.character-h.start.character:v.start.line-h.start.line:v.end.character-h.end.character:v.end.line-h.end.line);for(let v=0,h=i.length-1;v<h;v++){const E=i[v].end;if(i[v+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=f.edits.map(v=>({range:T.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,s,{setEndOfLine:typeof f.setEndOfLine=="number"?T.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(b){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):b().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=R}),define(be[180],we([0,1,135,25,2,3,6,13,7,12,15,9,20]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(v,h){if((0,n.isString)(v))return{label:v};if(v&&typeof v=="object"&&typeof v.label=="string"){let E;return Array.isArray(v.highlights)&&(E=v.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),E=E.length?E:void 0),{label:v.label,highlights:E}}}class i{constructor(h,E,g){this._proxy=h,this.commands=E,this.logService=g,this.treeViews=new Map;function a(o){return o&&o.$treeViewId&&o.$treeItemHandle}E.registerArgumentProcessor({processArgument:o=>a(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(t=>a(t)?this.convertArgument(t):t):o})}registerTreeDataProvider(h,E,g){const a=this.createTreeView(h,{treeDataProvider:E},g);return{dispose:()=>a.dispose()}}createTreeView(h,E,g){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=this._proxy.$registerTreeViewDataProvider(h,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany}),o=this.createExtHostTreeView(h,E,g);return{get onDidCollapseElement(){return o.onDidCollapseElement},get onDidExpandElement(){return o.onDidExpandElement},get selection(){return o.selectedElements},get onDidChangeSelection(){return o.onDidChangeSelection},get visible(){return o.visible},get onDidChangeVisibility(){return o.onDidChangeVisibility},get message(){return o.message},set message(t){o.message=t},get title(){return o.title},set title(t){o.title=t},get description(){return o.description},set description(t){o.description=t},reveal:(t,r)=>o.reveal(t,r),dispose:async()=>{await a,this.treeViews.delete(h),o.dispose()}}}$getChildren(h,E){const g=this.treeViews.get(h);return g?g.getChildren(E):Promise.reject(new Error((0,w.localize)(0,null,h)))}async $hasResolve(h){const E=this.treeViews.get(h);if(!E)throw new Error((0,w.localize)(1,null,h));return E.hasResolve}$resolve(h,E,g){const a=this.treeViews.get(h);if(!a)throw new Error((0,w.localize)(2,null,h));return a.resolveTreeItem(E,g)}$setExpanded(h,E,g){const a=this.treeViews.get(h);if(!a)throw new Error((0,w.localize)(3,null,h));a.setExpanded(E,g)}$setSelection(h,E){const g=this.treeViews.get(h);if(!g)throw new Error((0,w.localize)(4,null,h));g.setSelection(E)}$setVisible(h,E){const g=this.treeViews.get(h);if(!g)throw new Error((0,w.localize)(5,null,h));g.setVisible(E)}createExtHostTreeView(h,E,g){const a=new s(h,E,this._proxy,this.commands.converter,this.logService,g);return this.treeViews.set(h,a),a}convertArgument(h){const E=this.treeViews.get(h.$treeViewId);return E?E.getExtensionElement(h.$treeItemHandle):null}}e.ExtHostTreeViews=i;class s extends S.Disposable{constructor(h,E,g,a,o,t){super();if(this.viewId=h,this.proxy=g,this.commands=a,this.logService=o,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new b.CancellationTokenSource,t.contributes&&t.contributes.views)for(const l in t.contributes.views)for(const u of t.contributes.views[l])u.id===h&&(this._title=u.name);this.dataProvider=E.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let r,d;this._register(T.Event.debounce(this._onDidChangeData.event,(l,u)=>(l||(l={message:!1,elements:[]}),u.element!==!1&&(r||(r=new Promise(m=>d=m),this.refreshPromise=this.refreshPromise.then(()=>r)),l.elements.push(u.element)),u.message&&(l.message=!0),l),200,!0)(({message:l,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=d;return r=null,this.refresh(u).then(()=>m())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(h=>this.getExtensionElement(h)).filter(h=>!(0,n.isUndefinedOrNull)(h))}getChildren(h){const E=h?this.getExtensionElement(h):void 0;if(h&&!E)return this.logService.error(`No tree item with id '${h}' found.`),Promise.resolve([]);const g=this.getChildrenNodes(h);return(g?Promise.resolve(g):this.fetchChildrenNodes(E)).then(a=>a.map(o=>o.item))}getExtensionElement(h){return this.elements.get(h)}reveal(h,E){E=E||{select:!0,focus:!1};const g=(0,n.isUndefinedOrNull)(E.select)?!0:E.select,a=(0,n.isUndefinedOrNull)(E.focus)?!1:E.focus,o=(0,n.isUndefinedOrNull)(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.refreshPromise.then(()=>this.resolveUnknownParentChain(h)).then(t=>this.resolveTreeNode(h,t[t.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:t.map(d=>d.item)},{select:g,focus:a,expand:o})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:g,focus:a,expand:o})}get message(){return this._message}set message(h){this._message=h,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(h){this._title=h,this.proxy.$setTitle(this.viewId,h,this._description)}get description(){return this._description}set description(h){this._description=h,this.proxy.$setTitle(this.viewId,this._title,h)}setExpanded(h,E){const g=this.getExtensionElement(h);g&&(E?this._onDidExpandElement.fire(Object.freeze({element:g})):this._onDidCollapseElement.fire(Object.freeze({element:g})))}setSelection(h){(0,R.equals)(this._selectedHandles,h)||(this._selectedHandles=h,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(h){h!==this._visible&&(this._visible=h,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(h,E){var g;if(!!this.dataProvider.resolveTreeItem){const a=this.elements.get(h);if(a){const o=this.nodes.get(a);if(o){const t=(g=await this.dataProvider.resolveTreeItem(o.extensionItem,a,E))!==null&&g!==void 0?g:o.extensionItem;return o.item.tooltip=this.getTooltip(t.tooltip),o.item.command=this.getCommand(o.disposableStore,t.command),o.item}}}}resolveUnknownParentChain(h){return this.resolveParent(h).then(E=>E?this.resolveUnknownParentChain(E).then(g=>this.resolveTreeNode(E,g[g.length-1]).then(a=>(g.push(a),g))):Promise.resolve([]))}resolveParent(h){const E=this.nodes.get(h);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):(0,I.asPromise)(()=>this.dataProvider.getParent(h))}resolveTreeNode(h,E){const g=this.nodes.get(h);return g?Promise.resolve(g):(0,I.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(a=>this.createHandle(h,a,E,!0)).then(a=>this.getChildren(E?E.item.handle:void 0).then(()=>{const o=this.getExtensionElement(a);if(o){const t=this.nodes.get(o);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${a}`)}))}getChildrenNodes(h){if(h){let E;if(typeof h=="string"){const g=this.getExtensionElement(h);E=g?this.nodes.get(g):void 0}else E=h;return E&&E.children||null}return this.roots}async fetchChildrenNodes(h){this.clearChildren(h);const E=new b.CancellationTokenSource(this._refreshCancellationSource.token);try{const g=h?this.nodes.get(h):void 0,a=await this.dataProvider.getChildren(h);if(E.token.isCancellationRequested)return[];const o=await Promise.all((0,R.coalesce)(a||[]).map(async t=>{const r=await this.dataProvider.getTreeItem(t);return r&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(t,r,g):null}));return E.token.isCancellationRequested?[]:(0,R.coalesce)(o)}finally{E.dispose()}}refresh(h){if(h.some(g=>!g))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new b.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const g=this.getHandlesToRefresh(h);if(g.length)return this.refreshHandles(g)}return Promise.resolve(void 0)}getHandlesToRefresh(h){const E=new Set,g=h.map(o=>this.nodes.get(o));for(const o of g)if(o&&!E.has(o.item.handle)){let t=o;for(;t&&t.parent&&g.findIndex(r=>t&&t.parent&&r&&r.item.handle===t.parent.item.handle)===-1;){const r=this.elements.get(t.parent.item.handle);t=r?this.nodes.get(r):void 0}t&&!t.parent&&E.add(o.item.handle)}const a=[];return E.forEach(o=>{const t=this.elements.get(o);if(t){const r=this.nodes.get(t);r&&(!r.parent||!E.has(r.parent.item.handle))&&a.push(o)}}),a}refreshHandles(h){const E={};return Promise.all(h.map(g=>this.refreshNode(g).then(a=>{a&&(E[g]=a.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(h){const E=this.getExtensionElement(h);if(E){const g=this.nodes.get(E);if(g)return this.clearChildren(E),(0,I.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(a=>{if(a){const o=this.createTreeNode(E,a,g.parent);return this.updateNodeCache(E,o,g,g.parent),g.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(h,E,g){const a=this.createTreeNode(h,E,g);if(E.id&&this.elements.has(a.item.handle))throw new Error((0,w.localize)(6,null,E.id));return this.addNodeToCache(h,a),this.addNodeToParentCache(a,g),a}getTooltip(h){return y.MarkdownString.isMarkdownString(h)?C.MarkdownString.from(h):h}getCommand(h,E){return E?this.commands.toInternal(E,h):void 0}createTreeNode(h,E,g){const a=new S.DisposableStore,o=this.createHandle(h,E,g),t=this.getLightIconPath(E);return{item:{handle:o,parentHandle:g?g.item.handle:void 0,label:f(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(a,E.command),contextValue:E.contextValue,icon:t,iconDark:this.getDarkIconPath(E)||t,themeIcon:this.getThemeIcon(E),collapsibleState:(0,n.isUndefinedOrNull)(E.collapsibleState)?y.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:g,children:void 0,disposableStore:a,dispose(){a.dispose()}}}getThemeIcon(h){return h.iconPath instanceof y.ThemeIcon?h.iconPath:void 0}createHandle(h,{id:E,label:g,resourceUri:a},o,t){if(E)return`${s.ID_HANDLE_PREFIX}/${E}`;const r=f(g,this.extension),d=o?o.item.handle:s.LABEL_HANDLE_PREFIX;let l=r?r.label:a?(0,k.basename)(a):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const u=this.nodes.has(h)?this.nodes.get(h).item.handle:void 0,m=this.getChildrenNodes(o)||[];let _,D=0;do{if(_=`${d}/${D}:${l}`,t||!this.elements.has(_)||u===_)break;D++}while(D<=m.length);return _}getLightIconPath(h){if(h.iconPath&&!(h.iconPath instanceof y.ThemeIcon))return typeof h.iconPath=="string"||A.URI.isUri(h.iconPath)?this.getIconPath(h.iconPath):this.getIconPath(h.iconPath.light)}getDarkIconPath(h){if(h.iconPath&&!(h.iconPath instanceof y.ThemeIcon)&&h.iconPath.dark)return this.getIconPath(h.iconPath.dark)}getIconPath(h){return A.URI.isUri(h)?h:A.URI.file(h)}addNodeToCache(h,E){this.elements.set(E.item.handle,h),this.nodes.set(h,E)}updateNodeCache(h,E,g,a){this.elements.delete(E.item.handle),this.nodes.delete(h),E.item.handle!==g.item.handle&&this.elements.delete(g.item.handle),this.addNodeToCache(h,E);const o=this.getChildrenNodes(a)||[],t=o.filter(r=>r.item.handle===g.item.handle)[0];t&&o.splice(o.indexOf(t),1,E)}addNodeToParentCache(h,E){E?(E.children||(E.children=[]),E.children.push(h)):(this.roots||(this.roots=[]),this.roots.push(h))}clearChildren(h){if(h){const E=this.nodes.get(h);if(E){if(E.children)for(const g of E.children){const a=this.elements.get(g.item.handle);a&&this.clear(a)}E.children=void 0}}else this.clearAll()}clear(h){const E=this.nodes.get(h);if(E){if(E.children)for(const g of E.children){const a=this.elements.get(g.item.handle);a&&this.clear(a)}this.nodes.delete(h),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(h=>h.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}s.LABEL_HANDLE_PREFIX="0",s.ID_HANDLE_PREFIX="1"}),define(be[181],we([0,1,15,13,20,9,7,95]),function(ie,e,w,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class y{constructor(){this.testIdsToInternal=new Map}getTestById(i,s){if(s!==void 0){const v=this.testIdsToInternal.get(s),h=v==null?void 0:v.get(i);if(h)return[v,h]}return(0,w.mapFind)(this.testIdsToInternal.values(),v=>{const h=v.get(i);return h&&[v,h]})}createForHierarchy(i=()=>{}){return new b(this.createIdMap(R++),i)}createIdMap(i){const s=new C(i);return this.testIdsToInternal.set(s.id,s),{object:s,dispose:()=>this.testIdsToInternal.delete(s.id)}}}e.OwnedTestCollection=y;var n;(function(f){f[f.Disconnected=0]="Disconnected",f[f.IsChild=1]="IsChild",f[f.IsParent=2]="IsParent",f[f.IsSame=3]="IsSame"})(n=e.TestPosition||(e.TestPosition={}));let R=0;class C{constructor(i){this.id=i,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(i){if(this.map.has(i.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${i.item.extId}`);this.map.set(i.item.extId,i),i.parent||this._roots.add(i)}has(i){return this.map.has(i)}delete(i){const s=this.map.get(i);return s?(this.map.delete(i),this._roots.delete(s),!0):!1}get(i){return this.map.get(i)}comparePositions(i,s){const v=typeof i=="string"?this.map.get(i):i,h=typeof s=="string"?this.map.get(s):s;if(!v||!h)return 0;if(v===h)return 3;for(let E=this.map.get(h.parent);E;E=this.map.get(E.parent))if(E===v)return 1;for(let E=this.map.get(v.parent);E;E=this.map.get(E.parent))if(E===h)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=C;class b{constructor(i,s){this.testIdToInternal=i,this.publishDiff=s,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new k.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(i,s){this.addItem(i,s,null)}getTestByReference(i){return this.testItemToInternal.get(i)}collectDiff(){const i=this.diff;return this.diff=[],i}pushDiff(i){const s=this.diff[this.diff.length-1];if(s&&i[0]===1){if(s[0]===1&&s[1].extId===i[1].extId){(0,I.applyTestItemUpdate)(s[1],i[1]);return}if(s[0]===0&&s[1].item.extId===i[1].extId){(0,I.applyTestItemUpdate)(s[1],i[1]);return}}this.diff.push(i),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(i,s){var v;const h=this.testIdToInternal.object.get(i);if(!!h){if((h.expandLevels===void 0||s>h.expandLevels)&&(h.expandLevels=s),h.expand===1){const E=this.refreshChildren(h);return E.isSettled?this.expandChildren(h,s-1):E.p.then(()=>this.expandChildren(h,s-1))}else if(h.expand===3)return((v=h.initialExpand)===null||v===void 0?void 0:v.isSettled)===!1?h.initialExpand.p.then(()=>this.expandChildren(h,s-1)):this.expandChildren(h,s-1)}}dispose(){var i;for(const s of this.testItemToInternal.values())(i=s.discoverCts)===null||i===void 0||i.dispose(!0),s.actual[S.TestItemHookProperty]=void 0;this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}addItem(i,s,v){if(!(i instanceof S.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${i.id} did not`);if(this.testItemToInternal.has(i))throw new Error(`Attempted to add a single TestItem ${i.id} multiple times to the tree`);if(this.testIdToInternal.object.has(i.id))throw new Error(`Attempted to insert a duplicate test item ID ${i.id}`);const h=v?v.item.extId:null,E=i.expandable?1:0,g=v==null?void 0:v.expandLevels,a={provider:s,tree:this.testIdToInternal.object.id},o={actual:i,parent:h,item:T.TestItem.from(i),expandLevels:g&&E===1?g-1:void 0,expand:E,src:a};this.testIdToInternal.object.add(o),this.testItemToInternal.set(i,o),this.pushDiff([0,{parent:h,src:a,expand:E,item:o.item}]),i[S.TestItemHookProperty]={created:t=>this.addItem(t,s,o),delete:t=>this.removeItembyId(t),invalidate:t=>this.pushDiff([4,t]),setProp:(t,r)=>this.pushDiff([1,{extId:i.id,item:{[t]:t==="range"?T.Range.from(r):r}}])};for(const t of i.children)this.addItem(t,s,o)}expandChildren(i,s){if(!(s<0)){const v=[...i.actual.children].map(h=>this.expand(h.id,s-1)).filter(k.isThenable);if(v.length)return Promise.all(v).then(()=>{})}}refreshChildren(i){i.discoverCts&&i.discoverCts.dispose(!0),i.expand=2,i.discoverCts=new A.CancellationTokenSource,this.pushExpandStateUpdate(i);const s=new k.DeferredPromise;return i.initialExpand=s,i.actual.discoverChildren({report:v=>{v.busy?(i.expand=2,this.pushExpandStateUpdate(i)):(i.expand=3,s.isSettled||s.complete(),this.pushExpandStateUpdate(i))}},i.discoverCts.token),s}pushExpandStateUpdate(i){this.pushDiff([1,{extId:i.actual.id,expand:i.expand}])}removeItembyId(i){var s;this.pushDiff([2,i]);const v=[this.testIdToInternal.object.get(i)];for(;v.length;){const h=v.pop();if(!!h){(s=h.discoverCts)===null||s===void 0||s.dispose(!0),this.testIdToInternal.object.delete(h.item.extId),this.testItemToInternal.delete(h.actual);for(const E of h.actual.children)v.push(this.testIdToInternal.object.get(E.id))}}}flushDiff(){const i=this.collectDiff();i.length&&this.publishDiff(i)}}e.SingleUseTestCollection=b}),define(be[182],we([0,1,26,3,11]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=T;class S{constructor(R){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(w.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(w.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let C of R.activationEvents)C==="onUri"&&(C=`onUri:${w.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(R)}}keepOnly(R){const C=new Set;R.forEach(b=>C.add(w.ExtensionIdentifier.toKey(b))),this._extensionDescriptions=this._extensionDescriptions.filter(b=>C.has(w.ExtensionIdentifier.toKey(b.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,C){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const b=S._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(b.map(f=>f.identifier)),C.length>0){const f=new Set;C.forEach(i=>f.add(w.ExtensionIdentifier.toKey(i))),this._extensionDescriptions=this._extensionDescriptions.filter(i=>!f.has(w.ExtensionIdentifier.toKey(i.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(b)}static _findLoopingExtensions(R){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,h){this.addNode(v),this.addNode(h),this._arcs.has(v)?this._arcs.get(v).push(h):this._arcs.set(v,[h])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,h){const E=C.getArcs(v);for(let g=0;g<E.length;g++)if(!h.has(E[g]))return!1;return!0}getNodes(){return this._nodesArr}};let b=new Map;for(let v of R){const h=w.ExtensionIdentifier.toKey(v.identifier);if(b.set(h,v),v.extensionDependencies)for(let E of v.extensionDependencies){const g=w.ExtensionIdentifier.toKey(E);C.addArc(h,g)}}let f=new Set;C.getNodes().filter(v=>C.getArcs(v).length===0).forEach(v=>f.add(v));let i=C.getNodes().filter(v=>!f.has(v)),s;do{s=!1;for(let v=0;v<i.length;v++){const h=i[v];C.hasOnlyGoodArcs(h,f)&&(i.splice(v,1),v--,f.add(h),s=!0)}}while(s);return i.map(v=>b.get(v))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(w.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const C=this._activationMap.get(R);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const C=this._extensionsMap.get(w.ExtensionIdentifier.toKey(R));return C||void 0}}e.ExtensionDescriptionRegistry=S;var I;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(I||(I={}));function y(n,R){const C=n.isBuiltin?0:n.isUnderDevelopment?2:1,b=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(C!==b)return C-b;const f=A.posix.basename(n.extensionLocation.path),i=A.posix.basename(R.extensionLocation.path);return f<i?-1:f>i?1:0}}),define(be[183],we([0,1,24]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var k;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(k=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function T(I){const y=w.VSBuffer.alloc(1);switch(I){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=T;function S(I,y){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=S}),define(be[34],we([0,1,3,2,4,26,149]),function(ie,e,w,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class I{constructor(E){this.dependency=E}}e.MissingDependencyError=I;var y;(function(h){h[h.LocalProcess=0]="LocalProcess",h[h.LocalWebWorker=1]="LocalWebWorker",h[h.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(E,g,a,o){this.codeLoadingTime=E,this.activateCallTime=g,this.activateResolvedTime=a,this.activationReason=o}}e.ActivationTimes=n;class R{constructor(E,g){this.description=E,this.value=g}}e.ExtensionPointContribution=R,e.ExtensionHostLogFileName="exthost";var C;(function(h){h[h.Normal=0]="Normal",h[h.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function b(h){h.enableProposedApi||f(h)}e.checkProposedApiEnabled=b;function f(h){throw new Error(`[${h.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${h.identifier.value}`)}e.throwProposedApiError=f;function i(h){return{type:h.isBuiltin?0:1,isBuiltin:h.isBuiltin||h.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(h.publisher,h.name),uuid:h.uuid},manifest:h,location:h.extensionLocation}}e.toExtension=i;function s(h){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(h.identifier.id),isBuiltin:h.type===0,isUserBuiltin:h.type===1&&h.isBuiltin,isUnderDevelopment:!1,extensionLocation:h.location},h.manifest),{uuid:h.identifier.uuid})}e.toExtensionDescription=s;class v{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None}activateByEvent(E){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(E){return Promise.resolve(0)}restartExtensionHost(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(E,g){}_activateById(E,g){return Promise.resolve()}_onWillActivateExtension(E){}_onDidActivateExtension(E,g,a,o,t){}_onExtensionRuntimeError(E,g){}_onExtensionHostExit(E){}}e.NullExtensionService=v}),define(be[184],we([0,1,130,26,34,19]),function(ie,e,w,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class I{constructor(s,v,h,E){this.startup=s,this.codeLoadingTime=v,this.activateCallTime=h,this.activateResolvedTime=E}}e.ExtensionActivationTimes=I,I.NONE=new I(!1,-1,-1,-1);class y{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,v){return s===-1||v===-1?-1:v-s}build(){return new I(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class n{constructor(s,v,h,E,g,a){this.activationFailed=s,this.activationFailedError=v,this.activationTimes=h,this.module=E,this.exports=g,this.subscriptions=a}}e.ActivatedExtension=n;class R extends n{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class C extends n{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class b extends n{constructor(s){super(!0,s,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=b;let f=class{constructor(s,v,h,E,g){this._logService=g,this._registry=s,this._resolvedExtensionsSet=new Set,v.forEach(a=>this._resolvedExtensionsSet.add(k.ExtensionIdentifier.toKey(a))),this._hostExtensionsMap=new Map,h.forEach(a=>this._hostExtensionsMap.set(k.ExtensionIdentifier.toKey(a),a)),this._host=E,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(s){const v=k.ExtensionIdentifier.toKey(s);return this._activatedExtensions.has(v)}getActivatedExtension(s){const v=k.ExtensionIdentifier.toKey(s),h=this._activatedExtensions.get(v);if(!h)throw new Error("Extension `"+s.value+"` is not known or not activated");return h}activateByEvent(s,v){if(this._alreadyActivatedEvents[s])return S;const h=this._registry.getExtensionDescriptionsForActivationEvent(s);return this._activateExtensions(h.map(E=>({id:E.identifier,reason:{startup:v,extensionId:E.identifier,activationEvent:s}}))).then(()=>{this._alreadyActivatedEvents[s]=!0})}activateById(s,v){const h=this._registry.getExtensionDescription(s);if(!h)throw new Error("Extension `"+s+"` is not known");return this._activateExtensions([{id:h.identifier,reason:v}])}_handleActivateRequest(s,v,h){if(this._hostExtensionsMap.has(k.ExtensionIdentifier.toKey(s.id))){v[k.ExtensionIdentifier.toKey(s.id)]=s;return}const E=this._registry.getExtensionDescription(s.id);if(!E){this._host.onExtensionActivationError(s.id,new A.MissingDependencyError(s.id.value));const o=new Error(`Unknown dependency '${s.id.value}'`);this._activatedExtensions.set(k.ExtensionIdentifier.toKey(s.id),new b(o));return}const g=typeof E.extensionDependencies=="undefined"?[]:E.extensionDependencies;let a=!0;for(let o=0,t=g.length;o<t;o++){const r=g[o];if(!this._resolvedExtensionsSet.has(k.ExtensionIdentifier.toKey(r))){const d=this._activatedExtensions.get(k.ExtensionIdentifier.toKey(r));if(!(d&&!d.activationFailed)){if(d&&d.activationFailed){this._host.onExtensionActivationError(E.identifier,w.localize(0,null,E.displayName||E.identifier.value,r));const m=new Error(`Dependency ${r} failed to activate`);m.detail=d.activationFailedError,this._activatedExtensions.set(k.ExtensionIdentifier.toKey(E.identifier),new b(m));return}if(this._hostExtensionsMap.has(k.ExtensionIdentifier.toKey(r))){a=!1,v[k.ExtensionIdentifier.toKey(r)]={id:this._hostExtensionsMap.get(k.ExtensionIdentifier.toKey(r)),reason:s.reason};continue}const l=this._registry.getExtensionDescription(r);if(l){a=!1,v[k.ExtensionIdentifier.toKey(r)]={id:l.identifier,reason:s.reason};continue}this._host.onExtensionActivationError(E.identifier,new A.MissingDependencyError(r));const u=new Error(`Unknown dependency '${r}'`);this._activatedExtensions.set(k.ExtensionIdentifier.toKey(E.identifier),new b(u));return}}}a?v[k.ExtensionIdentifier.toKey(E.identifier)]=s:h.push(s)}_activateExtensions(s){if(s.length===0||(s=s.filter(g=>!this._activatedExtensions.has(k.ExtensionIdentifier.toKey(g.id))),s.length===0))return Promise.resolve(void 0);const v=Object.create(null),h=[];for(let g=0,a=s.length;g<a;g++)this._handleActivateRequest(s[g],v,h);for(let g=0,a=h.length;g<a;g++){const o=k.ExtensionIdentifier.toKey(h[g].id);v[o]&&delete v[o]}const E=Object.keys(v).map(g=>v[g]);return h.length===0?Promise.all(E.map(g=>this._activateExtension(g.id,g.reason))).then(g=>{}):this._activateExtensions(E).then(g=>this._activateExtensions(h))}_activateExtension(s,v){const h=k.ExtensionIdentifier.toKey(s);if(this._activatedExtensions.has(h))return Promise.resolve(void 0);const E=this._activatingExtensions.get(h);if(E)return E;const g=this._host.actualActivateExtension(s,v).then(void 0,a=>(this._host.onExtensionActivationError(s,w.localize(1,null,s.value,a.message)),this._logService.error(`Activating extension ${s.value} failed due to an error:`),this._logService.error(a),new b(a))).then(a=>{this._activatedExtensions.set(h,a),this._activatingExtensions.delete(h)});return this._activatingExtensions.set(h,g),g}};f=je([Ke(4,T.ILogService)],f),e.ExtensionsActivator=f}),define(be[185],we([0,1,10]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class k{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,S)=>{this._actualOk=T,this._actualErr=S,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,w.onUnexpectedError)(T))}then(T,S){return this._ensureActual().then(T,S)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=k}),define(be[97],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class w{constructor(y,n){this.isMain=y,this.sid=n,this.nid=++w.count}}e.ProxyIdentifier=w,w.count=0;const k=[];function A(I){const y=new w(!0,I);return k[y.nid]=y,y}e.createMainContextProxyIdentifier=A;function T(I){const y=new w(!1,I);return k[y.nid]=y,y}e.createExtHostContextProxyIdentifier=T;function S(I){return k[I].sid}e.getStringIdentifierForProxy=S}),define(be[5],we([0,1,2,97,57]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var S;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(S=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var n;(function(a){a[a.Markdown=1]="Markdown",a[a.Code=2]="Code"})(n=e.CellKind||(e.CellKind={}));var R;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(R=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var b;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(b=e.CandidatePortSource||(e.CandidatePortSource={}));var f;(function(a){a.name="$ident";function o(r,d){return Object.defineProperty(r,a.name,{value:d,enumerable:!0}),r}a.mixin=o;function t(r){return r[a.name]}a.of=t})(f=e.ObjectIdentifier||(e.ObjectIdentifier={}));class i{static mixin(o){return o._id=i._n++,o}}e.IdObject=i,i._n=0;var s;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n",a.label2="o"})(s=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var h;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(h=e.WorkspaceEditType||(e.WorkspaceEditType={}));function E(a){if(a&&a.edits)for(const o of a.edits)typeof o.resource=="object"?o.resource=w.URI.revive(o.resource):(o.newUri=w.URI.revive(o.newUri),o.oldUri=w.URI.revive(o.oldUri)),o.metadata&&o.metadata.iconPath&&(o.metadata=(0,A.revive)(o.metadata));return a}e.reviveWorkspaceEditDto=E;var g;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(g=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,k.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[71],we([0,1,5,3,4]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(I){this._onDidChangePassword=new k.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(w.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,y){return this._proxy.$getPassword(I,y)}store(I,y,n){return this._proxy.$setPassword(I,y,n)}delete(I,y){return this._proxy.$deletePassword(I,y)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,A.createDecorator)("IExtHostSecretState")}),define(be[72],we([0,1,4,19,5,14]),function(ie,e,w,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,w.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(y,n){this._extHostLogService=n,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(A.MainContext.MainThreadTelemetry)}report(y,n,R){const C=this.getUsageKey(y,n);this._reportedUsages.has(C)||(this._reportedUsages.add(C),n.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:n.identifier.value,apiId:y}))}getUsageKey(y,n){return`${y}-${n.identifier.value}`}};S=je([Ke(0,T.IExtHostRpcService),Ke(1,k.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(I,y,n){}})}),define(be[186],we([0,1,3,5,7,26]),function(ie,e,w,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new w.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new w.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(k.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,n,R,C={}){const b=T.ExtensionIdentifier.toKey(y.identifier),f=this._inFlightRequests.get(b)||[],i=R.sort().join(" ");let s=f.find(v=>v.scopes===i);if(s)return s.result;{const v=this._getSession(y,b,n,R,C);s={scopes:i,result:v},f.push(s),this._inFlightRequests.set(b,f);try{await v}finally{const h=f.findIndex(E=>E.scopes===i);h>-1&&(f.splice(h),this._inFlightRequests.set(b,f))}return v}}async _getSession(y,n,R,C,b={}){await this._proxy.$ensureProvider(R);const f=y.displayName||y.name;return this._proxy.$getSession(R,C,n,f,b)}async removeSession(y,n){const R=this._authenticationProviders.get(y);return R?R.provider.removeSession(n):this._proxy.$removeSession(y,n)}registerAuthenticationProvider(y,n,R,C){var b;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:n,provider:R,options:C!=null?C:{supportsMultipleAccounts:!1}}),this._providers.find(i=>i.id===y)||this._providers.push({id:y,label:n});const f=R.onDidChangeSessions(i=>{var s,v,h;this._proxy.$sendDidChangeSessions(y,{added:(s=i.added)!==null&&s!==void 0?s:[],changed:(v=i.changed)!==null&&v!==void 0?v:[],removed:(h=i.removed)!==null&&h!==void 0?h:[]})});return this._proxy.$registerAuthenticationProvider(y,n,(b=C==null?void 0:C.supportsMultipleAccounts)!==null&&b!==void 0?b:!1),new A.Disposable(()=>{f.dispose(),this._authenticationProviders.delete(y);const i=this._providers.findIndex(s=>s.id===y);i>-1&&this._providers.splice(i),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,n){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.createSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,n){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.removeSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,n){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.getSessions(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,n){return this._onDidChangeSessions.fire({provider:{id:y,label:n}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,n){return y.forEach(R=>{this._providers.some(C=>C.id===R.id)||this._providers.push(R)}),n.forEach(R=>{const C=this._providers.findIndex(b=>b.id===R.id);C>-1&&this._providers.splice(C)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:n}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(be[187],we([0,1,5,14,9]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(I,y){this._extHostDocumentsAndEditors=y,this._proxy=I.getProxy(w.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const y=A.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};T=je([Ke(0,k.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(be[188],we([0,1,5]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(T){const S=T.getProxy(w.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(I){return S.$writeText(I)}})}}e.ExtHostClipboard=k}),define(be[73],we([0,1,12,7,9,23,5,15,19,57,33,39,2,6,4,14]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let v=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(S.MainContext.MainThreadCommands),this._logService=r,this.converter=new h(this,d=>{const l=this._apiCommands.get(d);return(l==null?void 0:l.result)===g.Void?l:void 0},r),this._argumentProcessors=[{processArgument(d){return(0,n.revive)(d)}},{processArgument(d){return(0,T.cloneAndChange)(d,function(l){if(R.Range.isIRange(l))return A.Range.to(l);if(C.Position.isIPosition(l))return A.Position.to(l);if(R.Range.isIRange(l.range)&&b.URI.isUri(l.uri))return A.location.to(l);if(!Array.isArray(l))return l})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...d)=>{const l=t.args.map((m,_)=>{if(!m.validate(d[_]))throw new Error(`Invalid argument '${m.name}' when running '${t.id}', received: ${d[_]}`);return m.convert(d[_])}),u=await this.executeCommand(t.internalId,...l);return t.result.convert(u,d,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new k.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,d,l,u){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:d,thisArg:l,description:u}),t&&this._proxy.$registerCommand(r),new k.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,d){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const l=(0,T.cloneAndChange)(r,function(u){if(u instanceof k.Position)return A.Position.from(u);if(u instanceof k.Range)return A.Range.from(u);if(u instanceof k.Location)return A.location.from(u);if(!Array.isArray(u))return u});try{const u=await this._proxy.$executeCommand(t,l,d);return(0,n.revive)(u)}catch(u){if(u instanceof Error&&u.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw u}}}async _executeContributedCommand(t,r){const d=this._commands.get(t);if(!d)throw new Error("Unknown command");let{callback:l,thisArg:u,description:m}=d;if(m)for(let _=0;_<m.args.length;_++)try{(0,w.validateConstraint)(r[_],m.args[_].constraint)}catch(D){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${m.args[_].name}' - ${m.args[_].description}`)}try{return await l.apply(u,r)}catch(_){if(t===this.converter.delegatingCommandId){const D=this.converter.getActualCommand(...r);D&&(t=D.command)}throw this._logService.error(_,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(d=>this._argumentProcessors.reduce((l,u)=>u.processArgument(l),d)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(d=>d[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,d]of this._commands){let{description:l}=d;l&&(t[r]=l)}return Promise.resolve(t)}};v=je([Ke(0,s.IExtHostRpcService),Ke(1,y.ILogService)],v),e.ExtHostCommands=v,e.IExtHostCommands=(0,i.createDecorator)("IExtHostCommands");class h{constructor(t,r,d){this._commands=t,this._lookupApiCommand=r,this._logService=d,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!!t){const d={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return d;const l=this._lookupApiCommand(t.command);if(l)d.id=l.internalId,d.arguments=l.args.map((u,m)=>u.convert(t.arguments&&t.arguments[m]));else if((0,I.isNonEmptyArray)(t.arguments)){const u=++this._cachIdPool;this._cache.set(u,t),r.add((0,f.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),d.$ident=u,d.id=this.delegatingCommandId,d.arguments=[u],this._logService.trace("CommandsConverter#CREATE",t.command,u)}return d}}fromInternal(t){const r=S.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=h;class E{constructor(t,r,d,l){this.name=t,this.description=r,this.validate=d,this.convert=l}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new E(t!=null?t:this.name,r!=null?r:this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",o=>b.URI.isUri(o),o=>o),E.Position=new E("position","A position in a text document",o=>k.Position.isPosition(o),A.Position.from),E.Range=new E("range","A range in a text document",o=>k.Range.isRange(o),A.Range.from),E.Selection=new E("selection","A selection in a text document",o=>k.Selection.isSelection(o),A.Selection.from),E.Number=new E("number","",o=>typeof o=="number",o=>o),E.String=new E("string","",o=>typeof o=="string",o=>o),E.CallHierarchyItem=new E("item","A call hierarchy item",o=>o instanceof k.CallHierarchyItem,A.CallHierarchyItem.to);class g{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=g,g.Void=new g("no result",o=>o);class a{constructor(t,r,d,l,u){this.id=t,this.internalId=r,this.description=d,this.args=l,this.result=u}}e.ApiCommand=a}),define(be[189],we([0,1,6,9,7,62,73,167,15,84]),function(ie,e,w,k,A,T,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const R=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",b(k.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(i,s)=>{if(!(0,y.isFalsyOrEmpty)(i)){class v extends A.SymbolInformation{static to(E){const g=new v(E.name,k.SymbolKind.to(E.kind),E.containerName||"",new A.Location(s[0],k.Range.to(E.range)));return g.detail=E.detail,g.range=g.location.range,g.selectionRange=k.Range.to(E.selectionRange),g.children=E.children?E.children.map(v.to):[],g}}return i.map(v.to)}})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",i=>typeof i=="string",i=>i),new S.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(k.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(k.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",i=>Array.isArray(i)&&i.every(s=>A.Position.isPosition(s)),i=>i.map(k.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",i=>i.map(s=>{let v;for(const h of s.reverse())v=new A.SelectionRange(k.Range.to(h),v);return v}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",i=>{const s=[];if(Array.isArray(i))for(let v of i)s.push(...v[1].map(k.WorkspaceSymbol.to));return s})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(k.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(k.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(k.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",i=>{if(!!i){if(i.rejectReason)throw new Error(i.rejectReason);return k.WorkspaceEdit.to(i)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(k.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new A.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!!i){const s=(0,n.decodeSemanticTokensDto)(i);if(s.type==="full")return new A.SemanticTokens(s.data,void 0)}})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new A.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!!i){const s=(0,n.decodeSemanticTokensDto)(i);if(s.type==="full")return new A.SemanticTokens(s.data,void 0)}})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(i,s,v)=>{if(!i)return new A.CompletionList([]);const h=i.suggestions.map(E=>k.CompletionItem.to(E,v));return new A.CompletionList(h,i.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",i=>{if(i)return k.SignatureHelp.to(i)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(i,s,v)=>b(h=>new A.CodeLens(k.Range.to(h.range),h.command&&v.fromInternal(h.command)))(i))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>A.Range.isRange(i),i=>A.Selection.isSelection(i)?k.Selection.from(i):k.Range.from(i)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(i,s,v)=>b(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return v.fromInternal(h.command)}else{const E=new A.CodeAction(h.title,h.kind?new A.CodeActionKind(h.kind):void 0);return h.edit&&(E.edit=k.WorkspaceEdit.to(h.edit)),h.command&&(E.command=v.fromInternal(h.command)),E.isPreferred=h.isPreferred,E}})(i))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(s=>new A.ColorInformation(k.Range.to(s.range),k.Color.to(s.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",i=>i instanceof A.Color,k.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:k.Range.from(i.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(k.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineHint objects",i=>i.map(k.InlineHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientMetadata:i.options.transientMetadata},filenamePattern:i.filenamePattern.map(s=>k.NotebookExclusiveDocumentPattern.to(s))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",i=>i.map(k.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[i,void 0]:[k.ViewColumn.from(i.viewColumn),k.TextEditorOpenOptions.from(i)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[i,void 0]:[k.ViewColumn.from(i.viewColumn),k.TextEditorOpenOptions.from(i)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[k.ViewColumn.from(i.viewColumn),k.TextEditorOpenOptions.from(i)]).optional()],S.ApiCommandResult.Void)];class C{constructor(s){this._disposables=new w.DisposableStore,this._commands=s}static register(s){return R.forEach(s.registerApiCommand,s),new C(s).registerCommands()}registerCommands(){const s=v=>(...h)=>v(this._commands,...h);this._register(I.RemoveFromRecentlyOpenedAPICommand.ID,s(I.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:v=>typeof v=="string"}]}),this._register(I.OpenIssueReporter.ID,s(I.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:v=>typeof v=="string"||typeof v=="object"&&typeof v.extensionId=="string"}]})}_register(s,v,h){const E=this._commands.registerCommand(!1,s,v,this,h);this._disposables.add(E)}}e.ExtHostApiCommands=C;function b(i){return s=>{if(Array.isArray(s))return s.map(i)}}function f(i){if(!!Array.isArray(i)){const s=[];for(const v of i)T.isLocationLink(v)?s.push(k.DefinitionLink.to(v)):s.push(k.location.to(v));return s}}}),define(be[190],we([0,1,13,51,3,6,2,62,26,9,7,5]),function(ie,e,w,k,A,T,S,I,y,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class b{constructor(a,o,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=a.getProxy(C.MainContext.MainThreadComments),o.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const d=this._commentControllers.get(r.handle);return d||r}else if(r&&r.$mid===7){const d=this._commentControllers.get(r.commentControlHandle);if(!d)return r;const l=d.getCommentThread(r.commentThreadHandle);return l||r}else if(r&&r.$mid===8){const d=this._commentControllers.get(r.thread.commentControlHandle);if(!d)return r;const l=d.getCommentThread(r.thread.commentThreadHandle);return l?{thread:l,text:r.text}:r}else if(r&&r.$mid===9){const d=this._commentControllers.get(r.thread.commentControlHandle);if(!d)return r;const l=d.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let u=r.commentUniqueId,m=l.getCommentByUniqueId(u);return m||r}else if(r&&r.$mid===10){const d=this._commentControllers.get(r.thread.commentControlHandle);if(!d)return r;const l=d.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let u=r.text,m=r.commentUniqueId,_=l.getCommentByUniqueId(m);return _?(_.body=u,_):r}return r}})}createCommentController(a,o,t){const r=b.handlePool++,d=new i(a,r,this._proxy,o,t);this._commentControllers.set(d.handle,d);const l=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(a.identifier))||[];return l.push(d),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(a.identifier),l),d}$createCommentThreadTemplate(a,o,t){const r=this._commentControllers.get(a);!r||r.$createCommentThreadTemplate(o,t)}async $updateCommentThreadTemplate(a,o,t){const r=this._commentControllers.get(a);!r||r.$updateCommentThreadTemplate(o,t)}$deleteCommentThread(a,o){const t=this._commentControllers.get(a);t&&t.$deleteCommentThread(o)}$provideCommentingRanges(a,o,t){const r=this._commentControllers.get(a);if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const d=this._documents.getDocument(S.URI.revive(o));return(0,w.asPromise)(()=>r.commentingRangeProvider.provideCommentingRanges(d,t)).then(l=>l?l.map(u=>n.Range.from(u)):void 0)}$toggleReaction(a,o,t,r,d){const l=this._commentControllers.get(a);return!l||!l.reactionHandler?Promise.resolve(void 0):(0,w.asPromise)(()=>{const u=l.getCommentThread(o);if(u){const m=u.getCommentByUniqueId(r.uniqueIdInThread);if(l!==void 0&&m&&l.reactionHandler)return l.reactionHandler(m,h(d))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=b,b.handlePool=0;class f{constructor(a,o,t,r,d,l,u){this._proxy=a,this._commentController=o,this._id=t,this._uri=r,this._range=d,this._comments=l,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new A.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${o.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,n.Range.from(this._range),u),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=l}set threadId(a){this._id=a}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(a){a.isEqual(this._range)||(this._range=a,this.modifications.range=a,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(a){this._canReply!==a&&(this._canReply=a,this.modifications.canReply=a,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(a){this._label=a,this.modifications.label=a,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(a){this._contextValue=a,this.modifications.contextValue=a,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(a){this._comments=a,this.modifications.comments=a,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(a){this._collapseState=a,this.modifications.collapsibleState=a,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const a=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),o={};a("range")&&(o.range=n.Range.from(this._range)),a("label")&&(o.label=this.label),a("contextValue")&&(o.contextValue=this.contextValue),a("comments")&&(o.comments=this._comments.map(t=>s(this,this._commentController,t,this._commentsMap))),a("collapsibleState")&&(o.collapseState=E(this._collapseState)),a("canReply")&&(o.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,o)}}getCommentByUniqueId(a){for(let o of this._commentsMap){let t=o[0],r=o[1];if(a===r)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(a=>a.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}f._handlePool=0,je([(0,k.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=f;class i{constructor(a,o,t,r,d){this._extension=a,this._handle=o,this._proxy=t,this._id=r,this._label=d,this._threads=new Map,this._proxy.$registerCommentController(this.handle,r,d)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(a){this._reactionHandler=a,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!a})}get options(){return this._options}set options(a){this._options=a,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(a,o,t,r){if(typeof a=="string"){const d=new f(this._proxy,this,a,o,t,r,this._extension.identifier);return this._threads.set(d.handle,d),d}else{const d=new f(this._proxy,this,void 0,a,o,t,this._extension.identifier);return this._threads.set(d.handle,d),d}}$createCommentThreadTemplate(a,o){const t=new f(this._proxy,this,void 0,S.URI.revive(a),n.Range.to(o),[],this._extension.identifier);return t.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(a,o){let t=this._threads.get(a);t&&(t.range=n.Range.to(o))}$deleteCommentThread(a){let o=this._threads.get(a);o&&o.dispose(),this._threads.delete(a)}getCommentThread(a){return this._threads.get(a)}dispose(){this._threads.forEach(a=>{a.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function s(g,a,o,t){let r=t.get(o);r||(r=++g.commentHandle,t.set(o,r));const d=o.author&&o.author.iconPath?o.author.iconPath.toString():void 0;return{mode:o.mode,contextValue:o.contextValue,uniqueIdInThread:r,body:n.MarkdownString.from(o.body),userName:o.author.name,userIconPath:d,label:o.label,commentReactions:o.reactions?o.reactions.map(l=>v(l)):void 0}}function v(g){return{label:g.label,iconPath:g.iconPath?n.pathOrURIToURI(g.iconPath):void 0,count:g.count,hasReacted:g.authorHasReacted}}function h(g){return{label:g.label||"",count:g.count||0,iconPath:g.iconPath?S.URI.revive(g.iconPath):"",authorHasReacted:g.hasReacted||!1}}function E(g){if(g!==void 0)switch(g){case R.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}}),define(be[98],we([0,1,2,5,7,4,14,19,15,8,11]),function(ie,e,w,k,A,T,S,I,y,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class un{constructor(f,i){this._logService=i,this._provider=new Map,this._proxy=f.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,i){const s=un._handlePool++;this._provider.set(s,{provider:f,extensionId:i}),this._proxy.$registerDecorationProvider(s,i.value);const v=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(h=>{if(!h){this._proxy.$onDidChange(s,null);return}let E=(0,y.asArray)(h);if(E.length<=un._maxEventSize){this._proxy.$onDidChange(s,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",i.value,E.length);const g=E.map(t=>({uri:t,rank:(0,n.count)(t.path,"/")})),a=(0,y.groupBy)(g,(t,r)=>t.rank-r.rank||(0,n.compare)(t.uri.path,r.uri.path));let o=[];e:for(let t of a){let r;for(let d of t){let l=(0,R.dirname)(d.uri.path);if(r!==l&&(r=l,o.push(d.uri)>=un._maxEventSize))break e}}this._proxy.$onDidChange(s,o)});return new A.Disposable(()=>{v==null||v.dispose(),this._proxy.$unregisterDecorationProvider(s),this._provider.delete(s)})}async $provideDecorations(f,i,s){if(!this._provider.has(f))return Object.create(null);const v=Object.create(null),{provider:h,extensionId:E}=this._provider.get(f);return await Promise.all(i.map(async g=>{try{const{uri:a,id:o}=g,t=await Promise.resolve(h.provideFileDecoration(w.URI.revive(a),s));if(!t)return;try{A.FileDecoration.validate(t),v[o]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${E.value}': ${r}`)}}catch(a){this._logService.error(a)}})),v}};C._handlePool=0,C._maxEventSize=250,C=je([Ke(0,S.IExtHostRpcService),Ke(1,I.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(be[191],we([0,1,129,87,2,5,7,9,3,19,22]),function(ie,e,w,k,A,T,S,I,y,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(i,s,v,h,E){this._name=i,this._owner=s,this._maxDiagnosticsPerFile=v,this._proxy=h,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new R.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(i,s){if(!i){this.clear();return}this._checkDisposed();let v=[];if(A.URI.isUri(i)){if(!s){this.delete(i);return}this._data.set(i,s.slice()),v=[i]}else if(Array.isArray(i)){v=[];let E;i=[...i].sort(C._compareIndexedTuplesByUri);for(const g of i){const[a,o]=g;if((!E||a.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=a,v.push(a),this._data.set(a,[])),o){const t=this._data.get(a);t&&t.push(...o)}else{const t=this._data.get(a);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(v),!!this._proxy){const h=[];for(let E of v){let g=[];const a=this._data.get(E);if(a)if(a.length>this._maxDiagnosticsPerFile){g=[];const o=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of a)if(r.severity===o[t]&&g.push(I.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;g.push({severity:k.MarkerSeverity.Info,message:(0,w.localize)(0,null,a.length-this._maxDiagnosticsPerFile),startLineNumber:g[g.length-1].startLineNumber,startColumn:g[g.length-1].startColumn,endLineNumber:g[g.length-1].endLineNumber,endColumn:g[g.length-1].endColumn})}else g=a.map(o=>I.Diagnostic.from(o));h.push([E,g])}this._proxy.$changeMany(this._owner,h)}}delete(i){this._checkDisposed(),this._onDidChangeDiagnostics.fire([i]),this._data.delete(i),this._proxy&&this._proxy.$changeMany(this._owner,[[i,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(i,s){this._checkDisposed();for(let v of this._data.keys())i.apply(s,[v,this.get(v),this])}get(i){this._checkDisposed();const s=this._data.get(i);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(i){return this._checkDisposed(),Array.isArray(this._data.get(i))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(i,s){return i[0].toString()<s[0].toString()?-1:i[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=C;let b=class Bt{constructor(i,s){this._logService=s,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,Bt._debouncer,50),Bt._mapper),this._proxy=i.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(i,s){return i?i.concat(s):s}static _mapper(i){const s=[],v=new Set;for(const h of i)typeof h=="string"?v.has(h)||(v.add(h),s.push(A.URI.parse(h))):v.has(h.toString())||(v.add(h.toString()),s.push(h));return Object.freeze(s),{uris:s}}createDiagnosticCollection(i,s){const{_collections:v,_proxy:h,_onDidChangeDiagnostics:E,_logService:g}=this,a=new class{$changeMany(r,d){h.$changeMany(r,d),g.trace("[DiagnosticCollection] change many (extension, owner, uris)",i.value,r,d.length===0?"CLEARING":d)}$clear(r){h.$clear(r),g.trace("[DiagnosticCollection] remove all (extension, owner)",i.value,r)}dispose(){h.dispose()}};let o;if(!s)s="_generated_diagnostic_collection_name_#"+Bt._idPool++,o=s;else if(!v.has(s))o=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do o=s+Bt._idPool++;while(v.has(o))}return new class extends C{constructor(){super(s,o,Bt._maxDiagnosticsPerFile,a,E);v.set(o,this)}dispose(){super.dispose(),v.delete(o)}}}getDiagnostics(i){if(i)return this._getDiagnostics(i);{const s=new Map,v=[];for(const h of this._collections.values())h.forEach((E,g)=>{let a=s.get(E.toString());typeof a=="undefined"&&(a=v.length,s.set(E.toString(),a),v.push([E,[]])),v[a][1]=v[a][1].concat(...g)});return v}}_getDiagnostics(i){let s=[];for(let v of this._collections.values())v.has(i)&&(s=s.concat(v.get(i)));return s}$acceptMarkersChange(i){if(!this._mirrorCollection){const s="_generated_mirror",v=new C(s,s,Bt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(s,v),this._mirrorCollection=v}for(const[s,v]of i)this._mirrorCollection.set(A.URI.revive(s),v.map(I.Diagnostic.to))}};b._idPool=0,b._maxDiagnosticsPerFile=1e3,b=je([Ke(1,n.ILogService)],b),e.ExtHostDiagnostics=b}),define(be[192],we([0,1,2,5]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(S){this._proxy=S.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(S){return this._proxy.$showOpenDialog(S).then(I=>I?I.map(y=>w.URI.revive(y)):void 0)}showSaveDialog(S){return this._proxy.$showSaveDialog(S).then(I=>I?w.URI.revive(I):void 0)}}e.ExtHostDialogs=A}),define(be[193],we([0,1,10,2,7,5,18,20,8]),function(ie,e,w,k,A,T,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class n{constructor(C,b,f){this._documentsAndEditors=b,this._logService=f,this._documentContentProviders=new Map,this._proxy=C.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,b){if(Object.keys(S.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const f=n._handlePool++;this._documentContentProviders.set(f,b),this._proxy.$registerTextContentProvider(f,C);let i;return typeof b.onDidChange=="function"&&(i=b.onDidChange(s=>{if(s.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(s)&&this.$provideTextDocumentContent(f,s).then(v=>{if(!(!v&&typeof v!="string")){const h=this._documentsAndEditors.getDocument(s);if(!!h){const E=(0,y.splitLines)(v);if(!h.equalLines(E))return this._proxy.$onVirtualDocumentChange(s,v)}}},w.onUnexpectedError)})),new A.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),i&&(i.dispose(),i=void 0)})}$provideTextDocumentContent(C,b){const f=this._documentContentProviders.get(C);return f?Promise.resolve(f.provideTextDocumentContent(k.URI.revive(b),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${b.scheme}`))}}e.ExtHostDocumentContentProvider=n,n._handlePool=0}),define(be[194],we([0,1,3,6,2,5,94,9,12,23]),function(ie,e,w,k,A,T,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class R{constructor(b,f){this._onDidAddDocument=new w.Emitter,this._onDidRemoveDocument=new w.Emitter,this._onDidChangeDocument=new w.Emitter,this._onDidSaveDocument=new w.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new k.DisposableStore,this._documentLoader=new Map,this._proxy=b.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(i=>{for(const s of i)this._onDidRemoveDocument.fire(s.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(i=>{for(const s of i)this._onDidAddDocument.fire(s.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(b){if(!!b){const f=this._documentsAndEditors.getDocument(b);if(f)return f}}getDocument(b){const f=this.getDocumentData(b);if(!(f==null?void 0:f.document))throw new Error(`Unable to retrieve document from URI '${b}'`);return f.document}ensureDocumentData(b){const f=this._documentsAndEditors.getDocument(b);if(f)return Promise.resolve(f);let i=this._documentLoader.get(b.toString());return i||(i=this._proxy.$tryOpenDocument(b).then(s=>{this._documentLoader.delete(b.toString());const v=A.URI.revive(s);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(v))},s=>(this._documentLoader.delete(b.toString()),Promise.reject(s))),this._documentLoader.set(b.toString(),i)),i}createDocumentData(b){return this._proxy.$tryCreateDocument(b).then(f=>A.URI.revive(f))}$acceptModelModeChanged(b,f){const i=A.URI.revive(b),s=this._documentsAndEditors.getDocument(i);if(!s)throw new Error("unknown document");this._onDidRemoveDocument.fire(s.document),s._acceptLanguageId(f),this._onDidAddDocument.fire(s.document)}$acceptModelSaved(b){const f=A.URI.revive(b),i=this._documentsAndEditors.getDocument(f);if(!i)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this._onDidSaveDocument.fire(i.document)}$acceptDirtyStateChanged(b,f){const i=A.URI.revive(b),s=this._documentsAndEditors.getDocument(i);if(!s)throw new Error("unknown document");s._acceptIsDirty(f),this._onDidChangeDocument.fire({document:s.document,contentChanges:[]})}$acceptModelChanged(b,f,i){const s=A.URI.revive(b),v=this._documentsAndEditors.getDocument(s);if(!v)throw new Error("unknown document");v._acceptIsDirty(i),v.onEvents(f),this._onDidChangeDocument.fire((0,n.deepFreeze)({document:v.document,contentChanges:f.changes.map(h=>({range:I.Range.to(h.range),rangeOffset:h.rangeOffset,rangeLength:h.rangeLength,text:h.text}))}))}setWordDefinitionFor(b,f){(0,S.setWordDefinitionFor)(b,f)}}e.ExtHostDocuments=R}),define(be[40],we([0,1,43,3,6,2,4,5,94,14,96,9,19,22,18,54,106]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b,f,i,s,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class h{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(a,o){this._extHostRpc=a,this._logService=o,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new k.Emitter,this._onDidRemoveDocuments=new k.Emitter,this._onDidChangeVisibleTextEditors=new k.Emitter,this._onDidChangeActiveTextEditor=new k.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const o=[],t=[],r=[];if(a.removedDocuments)for(const d of a.removedDocuments){const l=T.URI.revive(d),u=this._documents.get(l);(u==null?void 0:u.unref())&&(this._documents.delete(l),o.push(u.value))}if(a.addedDocuments)for(const d of a.addedDocuments){const l=T.URI.revive(d.uri);let u=this._documents.get(l);if(u&&l.scheme!==i.Schemas.vscodeNotebookCell)throw new Error(`document '${l} already exists!'`);u||(u=new h(new y.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.modeId,d.isDirty,d.notebook)),this._documents.set(l,u),t.push(u.value)),u.ref()}if(a.removedEditors)for(const d of a.removedEditors){const l=this._editors.get(d);this._editors.delete(d),l&&r.push(l)}if(a.addedEditors)for(const d of a.addedEditors){const l=T.URI.revive(d.documentUri);w.ok(this._documents.has(l),`document '${l}' does not exist`),w.ok(!this._editors.has(d.id),`editor '${d.id}' already exists!`);const u=this._documents.get(l).value,m=new R.ExtHostTextEditor(d.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>u.document),d.selections.map(C.Selection.to),d.options,d.visibleRanges.map(_=>C.Range.to(_)),typeof d.editorPosition=="number"?C.ViewColumn.to(d.editorPosition):void 0);this._editors.set(d.id,m)}a.newActiveEditor!==void 0&&(w.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,A.dispose)(o),(0,A.dispose)(r),a.removedDocuments&&this._onDidRemoveDocuments.fire(o),a.addedDocuments&&this._onDidAddDocuments.fire(t),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(d=>d.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){var o;return(o=this._documents.get(a))===null||o===void 0?void 0:o.value}allDocuments(){return s.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!!this._activeEditorId){const o=this._editors.get(this._activeEditorId);return a?o:o==null?void 0:o.value}}allEditors(){return[...this._editors.values()]}};E=je([Ke(0,n.IExtHostRpcService),Ke(1,b.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[195],we([0,1,2,5,6,7,9,116,8,24]),function(ie,e,w,k,A,T,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class R{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const i=this._schemes.indexOf(f);i>=0&&(this._schemes.splice(i,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),i=[];let s,v,h=14,E=14;for(const g of f){let a=s?(0,y.commonPrefixLength)(s,g):0;for(a===0?v=1:v=E;a<g.length;a++)a+1===g.length?(h=E,E=9):E+=1,i.push([v,g.toUpperCase().charCodeAt(a),E]),i.push([v,g.toLowerCase().charCodeAt(a),E]),v=E;s=g,E=h}i.push([9,58,10]),i.push([10,47,12]),this._stateMachine=new I.StateMachine(i)}}provideDocumentLinks(f){this._initStateMachine();const i=[],s=I.LinkComputer.computeLinks({getLineContent(v){return f.lineAt(v-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const v of s){const h=S.DocumentLink.to(v);h.target&&i.push(h)}return i}}class C{constructor(f,i){this._extHostLanguageFeatures=i,this._linkProvider=new R,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){var f;(f=this._linkProviderRegistration)===null||f===void 0||f.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,i,s,v={}){if(this._registeredSchemes.has(i))throw new Error(`a provider for the scheme '${i}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const h=this._handlePool++;this._linkProvider.add(i),this._registeredSchemes.add(i),this._fsProvider.set(h,s);let E=2;v.isCaseSensitive&&(E+=1024),v.isReadonly&&(E+=2048),typeof s.copy=="function"&&(E+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&(E+=4),this._proxy.$registerFileSystemProvider(h,i,E).catch(a=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${i}`),console.error(a)});const g=s.onDidChangeFile(a=>{const o=[];for(const t of a){let{uri:r,type:d}=t;if(r.scheme===i){let l;switch(d){case T.FileChangeType.Changed:l=0;break;case T.FileChangeType.Created:l=1;break;case T.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:r,type:l})}}this._proxy.$onFileSystemChange(h,o)});return(0,A.toDisposable)(()=>{g.dispose(),this._linkProvider.delete(i),this._registeredSchemes.delete(i),this._fsProvider.delete(h),this._proxy.$unregisterProvider(h)})}static _asIStat(f){const{type:i,ctime:s,mtime:v,size:h}=f;return{type:i,ctime:s,mtime:v,size:h}}$stat(f,i){return Promise.resolve(this._getFsProvider(f).stat(w.URI.revive(i))).then(C._asIStat)}$readdir(f,i){return Promise.resolve(this._getFsProvider(f).readDirectory(w.URI.revive(i)))}$readFile(f,i){return Promise.resolve(this._getFsProvider(f).readFile(w.URI.revive(i))).then(s=>n.VSBuffer.wrap(s))}$writeFile(f,i,s,v){return Promise.resolve(this._getFsProvider(f).writeFile(w.URI.revive(i),s.buffer,v))}$delete(f,i,s){return Promise.resolve(this._getFsProvider(f).delete(w.URI.revive(i),s))}$rename(f,i,s,v){return Promise.resolve(this._getFsProvider(f).rename(w.URI.revive(i),w.URI.revive(s),v))}$copy(f,i,s,v){const h=this._getFsProvider(f);if(!h.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(h.copy(w.URI.revive(i),w.URI.revive(s),v))}$mkdir(f,i){return Promise.resolve(this._getFsProvider(f).createDirectory(w.URI.revive(i)))}$watch(f,i,s,v){const h=this._getFsProvider(f).watch(w.URI.revive(s),v);this._watches.set(i,h)}$unwatch(f,i){const s=this._watches.get(i);s&&(s.dispose(),this._watches.delete(i))}$open(f,i,s){const v=this._getFsProvider(f);if(!v.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(v.open(w.URI.revive(i),s))}$close(f,i){const s=this._getFsProvider(f);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(i))}$read(f,i,s,v){const h=this._getFsProvider(f);if(!h.read)throw new Error('FileSystemProvider does not implement "read"');const E=n.VSBuffer.alloc(v);return Promise.resolve(h.read(i,s,E.buffer,0,v)).then(g=>E.slice(0,g))}$write(f,i,s,v){const h=this._getFsProvider(f);if(!h.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(h.write(i,s,v.buffer,0,v.byteLength))}_getFsProvider(f){const i=this._fsProvider.get(f);if(!i){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return i}}e.ExtHostFileSystem=C}),define(be[74],we([0,1,5,64,7,24,4,14,48]),function(ie,e,w,k,A,T,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let n=class Tt{constructor(C,b){const f=C.getProxy(w.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(i){return f.$stat(i).catch(Tt._handleError)},readDirectory(i){return f.$readdir(i).catch(Tt._handleError)},createDirectory(i){return f.$mkdir(i).catch(Tt._handleError)},async readFile(i){return f.$readFile(i).then(s=>s.buffer).catch(Tt._handleError)},writeFile(i,s){return f.$writeFile(i,T.VSBuffer.wrap(s)).catch(Tt._handleError)},delete(i,s){return f.$delete(i,Object.assign({recursive:!1,useTrash:!1},s)).catch(Tt._handleError)},rename(i,s,v){return f.$rename(i,s,Object.assign({overwrite:!1},v)).catch(Tt._handleError)},copy(i,s,v){return f.$copy(i,s,Object.assign({overwrite:!1},v)).catch(Tt._handleError)},isWritableFileSystem(i){const s=b.getCapabilities(i);if(typeof s=="number")return!(s&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new A.FileSystemError(String(C));if(C.name==="ENOPRO")throw A.FileSystemError.Unavailable(C.message);switch(C.name){case k.FileSystemProviderErrorCode.FileExists:throw A.FileSystemError.FileExists(C.message);case k.FileSystemProviderErrorCode.FileNotFound:throw A.FileSystemError.FileNotFound(C.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw A.FileSystemError.FileNotADirectory(C.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw A.FileSystemError.FileIsADirectory(C.message);case k.FileSystemProviderErrorCode.NoPermissions:throw A.FileSystemError.NoPermissions(C.message);case k.FileSystemProviderErrorCode.Unavailable:throw A.FileSystemError.Unavailable(C.message);default:throw new A.FileSystemError(C.message,C.name)}}};n=je([Ke(0,I.IExtHostRpcService),Ke(1,y.IExtHostFileSystemInfo)],n),e.ExtHostConsumerFileSystem=n,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(be[196],we([0,1,6,5]),function(ie,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class A{constructor(S){this._handlePool=0,this._proxy=S.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,S),(0,w.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=A}),define(be[197],we([0,1,2,23,9,7,13,5,8,33,15,12,113,6,84,53,92,55,10]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b,f,i,s,v,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class g{constructor(N,G){this._documents=N,this._provider=G}provideDocumentSymbols(N,G){const te=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideDocumentSymbols(te,G)).then(ae=>{if(!(0,R.isFalsyOrEmpty)(ae))return ae[0]instanceof T.DocumentSymbol?ae.map(A.DocumentSymbol.from):g._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(N){var G;N=N.slice(0).sort((me,Se)=>{let Le=me.location.range.start.compareTo(Se.location.range.start);return Le===0&&(Le=Se.location.range.end.compareTo(me.location.range.end)),Le});const te=[],ae=[];for(const me of N){const Se={name:me.name||"!!MISSING: name!!",kind:A.SymbolKind.from(me.kind),tags:((G=me.tags)===null||G===void 0?void 0:G.map(A.SymbolTag.from))||[],detail:"",containerName:me.containerName,range:A.Range.from(me.location.range),selectionRange:A.Range.from(me.location.range),children:[]};for(;;){if(ae.length===0){ae.push(Se),te.push(Se);break}const Le=ae[ae.length-1];if(n.Range.containsRange(Le.range,Se.range)&&!n.Range.equalsRange(Le.range,Se.range)){Le.children&&Le.children.push(Se),ae.push(Se);break}ae.pop()}}return te}}class a{constructor(N,G,te){this._documents=N,this._commands=G,this._provider=te,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(N,G){const te=this._documents.getDocument(N),ae=await this._provider.provideCodeLenses(te,G);if(!(!ae||G.isCancellationRequested)){const me=this._cache.add(ae),Se=new f.DisposableStore;this._disposables.set(me,Se);const Le={cacheId:me,lenses:[]};for(let ge=0;ge<ae.length;ge++)Le.lenses.push({cacheId:[me,ge],range:A.Range.from(ae[ge].range),command:this._commands.toInternal(ae[ge].command,Se)});return Le}}async resolveCodeLens(N,G){var te;const ae=N.cacheId&&this._cache.get(...N.cacheId);if(!!ae){let me;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?me=ae:me=await this._provider.resolveCodeLens(ae,G),me||(me=ae),!G.isCancellationRequested){const Se=N.cacheId&&this._disposables.get(N.cacheId[0]);if(!!Se)return N.command=this._commands.toInternal((te=me.command)!==null&&te!==void 0?te:a._badCmd,Se),N}}}releaseCodeLenses(N){var G;(G=this._disposables.get(N))===null||G===void 0||G.dispose(),this._disposables.delete(N),this._cache.delete(N)}}a._badCmd={command:"missing",title:"!!MISSING: command!!"};function o(ze){return Array.isArray(ze)?ze.map(A.DefinitionLink.from):ze?[A.DefinitionLink.from(ze)]:[]}class t{constructor(N,G){this._documents=N,this._provider=G}provideDefinition(N,G,te){const ae=this._documents.getDocument(N),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideDefinition(ae,me,te)).then(o)}}class r{constructor(N,G){this._documents=N,this._provider=G}provideDeclaration(N,G,te){const ae=this._documents.getDocument(N),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideDeclaration(ae,me,te)).then(o)}}class d{constructor(N,G){this._documents=N,this._provider=G}provideImplementation(N,G,te){const ae=this._documents.getDocument(N),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideImplementation(ae,me,te)).then(o)}}class l{constructor(N,G){this._documents=N,this._provider=G}provideTypeDefinition(N,G,te){const ae=this._documents.getDocument(N),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideTypeDefinition(ae,me,te)).then(o)}}class u{constructor(N,G){this._documents=N,this._provider=G}provideHover(N,G,te){const ae=this._documents.getDocument(N),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideHover(ae,me,te)).then(Se=>{if(!(!Se||(0,R.isFalsyOrEmpty)(Se.contents)))return Se.range||(Se.range=ae.getWordRangeAtPosition(me)),Se.range||(Se.range=new T.Range(me,me)),A.Hover.from(Se)})}}class m{constructor(N,G){this._documents=N,this._provider=G}provideEvaluatableExpression(N,G,te){const ae=this._documents.getDocument(N),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideEvaluatableExpression(ae,me,te)).then(Se=>{if(Se)return A.EvaluatableExpression.from(Se)})}}class _{constructor(N,G){this._documents=N,this._provider=G}provideInlineValues(N,G,te,ae){const me=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideInlineValues(me,A.Range.to(G),A.InlineValueContext.to(te),ae)).then(Se=>{if(Array.isArray(Se))return Se.map(Le=>A.InlineValue.from(Le))})}}class D{constructor(N,G){this._documents=N,this._provider=G}provideDocumentHighlights(N,G,te){const ae=this._documents.getDocument(N),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideDocumentHighlights(ae,me,te)).then(Se=>{if(Array.isArray(Se))return Se.map(A.DocumentHighlight.from)})}}class c{constructor(N,G){this._documents=N,this._provider=G}provideLinkedEditingRanges(N,G,te){const ae=this._documents.getDocument(N),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideLinkedEditingRanges(ae,me,te)).then(Se=>{if(Se&&Array.isArray(Se.ranges))return{ranges:(0,R.coalesce)(Se.ranges.map(A.Range.from)),wordPattern:Se.wordPattern}})}}class p{constructor(N,G){this._documents=N,this._provider=G}provideReferences(N,G,te,ae){const me=this._documents.getDocument(N),Se=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideReferences(me,Se,te,ae)).then(Le=>{if(Array.isArray(Le))return Le.map(A.location.from)})}}class P{constructor(N,G,te,ae,me,Se,Le){this._documents=N,this._commands=G,this._diagnostics=te,this._provider=ae,this._logService=me,this._extension=Se,this._apiDeprecation=Le,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(N,G,te,ae){const me=this._documents.getDocument(N),Se=b.Selection.isISelection(G)?A.Selection.to(G):A.Range.to(G),Le=[];for(const Ce of this._diagnostics.getDiagnostics(N))if(Se.intersection(Ce.range)&&Le.push(Ce)>P._maxCodeActionsPerFile)break;const ge={diagnostics:Le,only:te.only?new T.CodeActionKind(te.only):void 0,triggerKind:A.CodeActionTriggerKind.to(te.trigger)};return(0,S.asPromise)(()=>this._provider.provideCodeActions(me,Se,ge,ae)).then(Ce=>{var Pe;if(!(!(0,R.isNonEmptyArray)(Ce)||ae.isCancellationRequested)){const $e=this._cache.add(Ce),_e=new f.DisposableStore;this._disposables.set($e,_e);const qe=[];for(let V=0;V<Ce.length;V++){const X=Ce[V];!X||(P._isCommand(X)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:X.title,command:this._commands.toInternal(X,_e)})):(ge.only&&(X.kind?ge.only.contains(X.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${X.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[$e,V],title:X.title,command:X.command&&this._commands.toInternal(X.command,_e),diagnostics:X.diagnostics&&X.diagnostics.map(A.Diagnostic.from),edit:X.edit&&A.WorkspaceEdit.from(X.edit),kind:X.kind&&X.kind.value,isPreferred:X.isPreferred,disabled:(Pe=X.disabled)===null||Pe===void 0?void 0:Pe.reason})))}return{cacheId:$e,actions:qe}}})}async resolveCodeAction(N,G){var te;const[ae,me]=N,Se=this._cache.get(ae,me);if(!(!Se||P._isCommand(Se))&&!!this._provider.resolveCodeAction){const Le=(te=await this._provider.resolveCodeAction(Se,G))!==null&&te!==void 0?te:Se;return(Le==null?void 0:Le.edit)?A.WorkspaceEdit.from(Le.edit):void 0}}releaseCodeActions(N){var G;(G=this._disposables.get(N))===null||G===void 0||G.dispose(),this._disposables.delete(N),this._cache.delete(N)}static _isCommand(N){return typeof N.command=="string"&&typeof N.title=="string"}}P._maxCodeActionsPerFile=1e3;class F{constructor(N,G){this._documents=N,this._provider=G}provideDocumentFormattingEdits(N,G,te){const ae=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ae,G,te)).then(me=>{if(Array.isArray(me))return me.map(A.TextEdit.from)})}}class z{constructor(N,G){this._documents=N,this._provider=G}provideDocumentRangeFormattingEdits(N,G,te,ae){const me=this._documents.getDocument(N),Se=A.Range.to(G);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(me,Se,te,ae)).then(Le=>{if(Array.isArray(Le))return Le.map(A.TextEdit.from)})}}class de{constructor(N,G){this._documents=N,this._provider=G,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(N,G,te,ae,me){const Se=this._documents.getDocument(N),Le=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Se,Le,te,ae,me)).then(ge=>{if(Array.isArray(ge))return ge.map(A.TextEdit.from)})}}class B{constructor(N,G){this._provider=N,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(N,G){const te=I.IdObject.mixin({symbols:[]});return(0,S.asPromise)(()=>this._provider.provideWorkspaceSymbols(N,G)).then(ae=>{if((0,R.isNonEmptyArray)(ae)){for(const me of ae)if(!!me){if(!me.name){this._logService.warn("INVALID SymbolInformation, lacks name",me);continue}const Se=I.IdObject.mixin(A.WorkspaceSymbol.from(me));this._symbolCache.set(Se._id,me),te.symbols.push(Se)}}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol(N,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return N;const te=this._symbolCache.get(N._id);if(te){const ae=await(0,S.asPromise)(()=>this._provider.resolveWorkspaceSymbol(te,G));return ae&&(0,k.mixin)(N,A.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(N){const G=this._resultCache.get(N);if(G){for(let[te,ae]=G;te<=ae;te++)this._symbolCache.delete(te);this._resultCache.delete(N)}}}class W{constructor(N,G,te){this._documents=N,this._provider=G,this._logService=te}static supportsResolving(N){return typeof N.prepareRename=="function"}provideRenameEdits(N,G,te,ae){const me=this._documents.getDocument(N),Se=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideRenameEdits(me,Se,te,ae)).then(Le=>{if(!!Le)return A.WorkspaceEdit.from(Le)},Le=>{const ge=W._asMessage(Le);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(Le)})}resolveRenameLocation(N,G,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(N),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.prepareRename(ae,me,te)).then(Se=>{let Le,ge;if(T.Range.isRange(Se)?(Le=Se,ge=ae.getText(Se)):(0,C.isObject)(Se)&&(Le=Se.range,ge=Se.placeholder),!!Le){if(Le.start.line>me.line||Le.end.line<me.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:A.Range.from(Le),text:ge}}},Se=>{const Le=W._asMessage(Se);return Le?{rejectReason:Le,range:void 0,text:void 0}:Promise.reject(Se)})}static _asMessage(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class K{constructor(N,G){this.resultId=N,this.tokens=G}}class M{constructor(N,G){this._documents=N,this._provider=G,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(N,G,te){const ae=this._documents.getDocument(N),me=G!==0?this._previousResults.get(G):null;return(0,S.asPromise)(()=>me&&typeof me.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,me.resultId,te):this._provider.provideDocumentSemanticTokens(ae,te)).then(Se=>(me&&this._previousResults.delete(G),Se?(Se=M._fixProvidedSemanticTokens(Se),this._send(M._convertToEdits(me,Se),Se)):null))}async releaseDocumentSemanticColoring(N){this._previousResults.delete(N)}static _fixProvidedSemanticTokens(N){return M._isSemanticTokens(N)?M._isCorrectSemanticTokens(N)?N:new T.SemanticTokens(new Uint32Array(N.data),N.resultId):M._isSemanticTokensEdits(N)?M._isCorrectSemanticTokensEdits(N)?N:new T.SemanticTokensEdits(N.edits.map(G=>new T.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),N.resultId):N}static _isSemanticTokens(N){return N&&!!N.data}static _isCorrectSemanticTokens(N){return N.data instanceof Uint32Array}static _isSemanticTokensEdits(N){return N&&Array.isArray(N.edits)}static _isCorrectSemanticTokensEdits(N){for(const G of N.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(N,G){if(!M._isSemanticTokens(G)||!N||!N.tokens)return G;const te=N.tokens,ae=te.length,me=G.data,Se=me.length;let Le=0;const ge=Math.min(ae,Se);for(;Le<ge&&te[Le]===me[Le];)Le++;if(Le===ae&&Le===Se)return new T.SemanticTokensEdits([],G.resultId);let Ce=0;const Pe=ge-Le;for(;Ce<Pe&&te[ae-Ce-1]===me[Se-Ce-1];)Ce++;return new T.SemanticTokensEdits([{start:Le,deleteCount:ae-Le-Ce,data:me.subarray(Le,Se-Ce)}],G.resultId)}_send(N,G){if(M._isSemanticTokens(N)){const te=this._nextResultId++;return this._previousResults.set(te,new K(N.resultId,N.data)),(0,i.encodeSemanticTokensDto)({id:te,type:"full",data:N.data})}if(M._isSemanticTokensEdits(N)){const te=this._nextResultId++;return M._isSemanticTokens(G)?this._previousResults.set(te,new K(G.resultId,G.data)):this._previousResults.set(te,new K(N.resultId)),(0,i.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(N.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=M;class U{constructor(N,G){this._documents=N,this._provider=G}provideDocumentRangeSemanticTokens(N,G,te){const ae=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ae,A.Range.to(G),te)).then(me=>me?this._send(me):null)}_send(N){return(0,i.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}e.DocumentRangeSemanticTokensAdapter=U;class x{constructor(N,G,te,ae,me){this._documents=N,this._commands=G,this._provider=te,this._apiDeprecation=ae,this._extension=me,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}async provideCompletionItems(N,G,te,ae){const me=this._documents.getDocument(N),Se=A.Position.to(G),Le=me.getWordRangeAtPosition(Se)||new T.Range(Se,Se),ge=Le.with({end:Se}),Ce=new h.StopWatch(!0),Pe=await(0,S.asPromise)(()=>this._provider.provideCompletionItems(me,Se,ae,A.CompletionContext.to(te)));if(!!Pe&&!ae.isCancellationRequested){const $e=Array.isArray(Pe)?new T.CompletionList(Pe):Pe,_e=x.supportsResolving(this._provider)?this._cache.add($e.items):this._cache.add([]),qe=new f.DisposableStore;this._disposables.set(_e,qe);const V=[],X={x:_e,b:V,a:{replace:A.Range.from(Le),insert:A.Range.from(ge)},c:$e.isIncomplete||void 0,d:Ce.elapsed()};for(let ve=0;ve<$e.items.length;ve++){const Me=$e.items[ve],He=this._convertCompletionItem(Me,[_e,ve],ge,Le);V.push(He)}return X}}async resolveCompletionItem(N,G){if(typeof this._provider.resolveCompletionItem=="function"){const te=this._cache.get(...N);if(!!te){const ae=await(0,S.asPromise)(()=>this._provider.resolveCompletionItem(te,G));if(!!ae)return this._convertCompletionItem(ae,N)}}}releaseCompletionItems(N){var G;(G=this._disposables.get(N))===null||G===void 0||G.dispose(),this._disposables.delete(N),this._cache.delete(N)}_convertCompletionItem(N,G,te,ae){var me;const Se=this._disposables.get(G[0]);if(!Se)throw Error("DisposableStore is missing...");const Le={x:G,a:(me=N.label)!==null&&me!==void 0?me:"",o:N.label2,b:N.kind!==void 0?A.CompletionItemKind.from(N.kind):void 0,n:N.tags&&N.tags.map(A.CompletionItemTag.from),c:N.detail,d:typeof N.documentation=="undefined"?void 0:A.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters,l:N.additionalTextEdits&&N.additionalTextEdits.map(A.TextEdit.from),m:this._commands.toInternal(N.command,Se)};N.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Le.h=N.textEdit.newText):typeof N.insertText=="string"?Le.h=N.insertText:N.insertText instanceof T.SnippetString&&(Le.h=N.insertText.value,Le.i|=4);let ge;return N.textEdit?ge=N.textEdit.range:N.range&&(ge=N.range),T.Range.isRange(ge)?Le.j=A.Range.from(ge):ge&&(!(te==null?void 0:te.isEqual(ge.inserting))||!(ae==null?void 0:ae.isEqual(ge.replacing)))&&(Le.j={insert:A.Range.from(ge.inserting),replace:A.Range.from(ge.replacing)}),Le}}class Q{constructor(N,G){this._documents=N,this._provider=G,this._cache=new v.Cache("SignatureHelp")}provideSignatureHelp(N,G,te,ae){const me=this._documents.getDocument(N),Se=A.Position.to(G),Le=this.reviveContext(te);return(0,S.asPromise)(()=>this._provider.provideSignatureHelp(me,Se,ae,Le)).then(ge=>{if(ge){const Ce=this._cache.add([ge]);return Object.assign(Object.assign({},A.SignatureHelp.from(ge)),{id:Ce})}})}reviveContext(N){let G;if(N.activeSignatureHelp){const te=A.SignatureHelp.to(N.activeSignatureHelp),ae=this._cache.get(N.activeSignatureHelp.id,0);ae?(G=ae,G.activeSignature=te.activeSignature,G.activeParameter=te.activeParameter):G=te}return Object.assign(Object.assign({},N),{activeSignatureHelp:G})}releaseSignatureHelp(N){this._cache.delete(N)}}class ${constructor(N,G){this._documents=N,this._provider=G}provideInlineHints(N,G,te){const ae=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideInlineHints(ae,A.Range.to(G),te)).then(me=>me?{hints:me.map(A.InlineHint.from)}:void 0)}}class ee{constructor(N,G){this._documents=N,this._provider=G,this._cache=new v.Cache("DocumentLink")}provideLinks(N,G){const te=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideDocumentLinks(te,G)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(A.DocumentLink.from)};{const me=this._cache.add(ae),Se={links:[],id:me};for(let Le=0;Le<ae.length;Le++){const ge=A.DocumentLink.from(ae[Le]);ge.cacheId=[me,Le],Se.links.push(ge)}return Se}}})}resolveLink(N,G){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const te=this._cache.get(...N);return te?(0,S.asPromise)(()=>this._provider.resolveDocumentLink(te,G)).then(ae=>ae&&A.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(N){this._cache.delete(N)}}class re{constructor(N,G){this._documents=N,this._provider=G}provideColors(N,G){const te=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideDocumentColors(te,G)).then(ae=>Array.isArray(ae)?ae.map(Se=>({color:A.Color.from(Se.color),range:A.Range.from(Se.range)})):[])}provideColorPresentations(N,G,te){const ae=this._documents.getDocument(N),me=A.Range.to(G.range),Se=A.Color.to(G.color);return(0,S.asPromise)(()=>this._provider.provideColorPresentations(Se,{document:ae,range:me},te)).then(Le=>{if(!!Array.isArray(Le))return Le.map(A.ColorPresentation.from)})}}class se{constructor(N,G){this._documents=N,this._provider=G}provideFoldingRanges(N,G,te){const ae=this._documents.getDocument(N);return(0,S.asPromise)(()=>this._provider.provideFoldingRanges(ae,G,te)).then(me=>{if(!!Array.isArray(me))return me.map(A.FoldingRange.from)})}}class ye{constructor(N,G,te){this._documents=N,this._provider=G,this._logService=te}provideSelectionRanges(N,G,te){const ae=this._documents.getDocument(N),me=G.map(A.Position.to);return(0,S.asPromise)(()=>this._provider.provideSelectionRanges(ae,me,te)).then(Se=>{if(!(0,R.isNonEmptyArray)(Se))return[];if(Se.length!==me.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Le=[];for(let ge=0;ge<me.length;ge++){const Ce=[];Le.push(Ce);let Pe=me[ge],$e=Se[ge];for(;;){if(!$e.range.contains(Pe))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(A.SelectionRange.from($e)),!$e.parent)break;Pe=$e.range,$e=$e.parent}}return Le})}}class Ie{constructor(N,G){this._documents=N,this._provider=G,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(N,G,te){const ae=this._documents.getDocument(N),me=A.Position.to(G),Se=await this._provider.prepareCallHierarchy(ae,me,te);if(!!Se){const Le=this._idPool.nextId();return this._cache.set(Le,new Map),Array.isArray(Se)?Se.map(ge=>this._cacheAndConvertItem(Le,ge)):[this._cacheAndConvertItem(Le,Se)]}}async provideCallsTo(N,G,te){const ae=this._itemFromCache(N,G);if(!ae)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyIncomingCalls(ae,te);if(!!me)return me.map(Se=>({from:this._cacheAndConvertItem(N,Se.from),fromRanges:Se.fromRanges.map(Le=>A.Range.from(Le))}))}async provideCallsFrom(N,G,te){const ae=this._itemFromCache(N,G);if(!ae)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyOutgoingCalls(ae,te);if(!!me)return me.map(Se=>({to:this._cacheAndConvertItem(N,Se.to),fromRanges:Se.fromRanges.map(Le=>A.Range.from(Le))}))}releaseSession(N){this._cache.delete(N)}_cacheAndConvertItem(N,G){var te;const ae=this._cache.get(N),me={_sessionId:N,_itemId:ae.size.toString(36),name:G.name,detail:G.detail,kind:A.SymbolKind.from(G.kind),uri:G.uri,range:A.Range.from(G.range),selectionRange:A.Range.from(G.selectionRange),tags:(te=G.tags)===null||te===void 0?void 0:te.map(A.SymbolTag.from)};return ae.set(me._itemId,G),me}_itemFromCache(N,G){const te=this._cache.get(N);return te==null?void 0:te.get(G)}}class xe{constructor(N,G){this.adapter=N,this.extension=G}}class Fe{constructor(N,G,te,ae,me,Se,Le){this._adapter=new Map,this._uriTransformer=G,this._proxy=N.getProxy(I.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ae,this._diagnostics=me,this._logService=Se,this._apiDeprecation=Le}_transformDocumentSelector(N){return(0,R.coalesce)((0,R.asArray)(N).map(G=>this._doTransformDocumentSelector(G)))}_doTransformDocumentSelector(N){if(typeof N=="string")return{$serialized:!0,language:N};if(N)return{$serialized:!0,language:N.language,scheme:this._transformScheme(N.scheme),pattern:typeof N.pattern=="undefined"?void 0:A.GlobPattern.from(N.pattern),exclusive:N.exclusive}}_transformScheme(N){return this._uriTransformer&&typeof N=="string"?this._uriTransformer.transformOutgoingScheme(N):N}_createDisposable(N){return new T.Disposable(()=>{this._adapter.delete(N),this._proxy.$unregister(N)})}_nextHandle(){return Fe._handlePool++}_withAdapter(N,G,te,ae,me=!1){const Se=this._adapter.get(N);if(!Se)return Promise.resolve(ae);if(Se.adapter instanceof G){let Le;Se.extension&&(Le=Date.now(),this._logService.trace(`[${Se.extension.identifier.value}] INVOKE provider '${G.name}'`));const ge=te(Se.adapter,Se.extension),Ce=Se.extension;return Ce&&Promise.resolve(ge).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Le}ms`),Pe=>{me&&Pe instanceof E.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Pe))}),ge}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(N,G){const te=this._nextHandle();return this._adapter.set(te,new xe(N,G)),te}static _extLabel(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,G,te,ae){const me=this._addNewAdapter(new g(this._documents,te),N),Se=ae&&ae.label||Fe._extLabel(N);return this._proxy.$registerDocumentSymbolProvider(me,this._transformDocumentSelector(G),Se),this._createDisposable(me)}$provideDocumentSymbols(N,G,te){return this._withAdapter(N,g,ae=>ae.provideDocumentSymbols(w.URI.revive(G),te),void 0)}registerCodeLensProvider(N,G,te){const ae=this._nextHandle(),me=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new xe(new a(this._documents,this._commands.converter,te),N)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(G),me);let Se=this._createDisposable(ae);if(me!==void 0){const Le=te.onDidChangeCodeLenses(ge=>this._proxy.$emitCodeLensEvent(me));Se=T.Disposable.from(Se,Le)}return Se}$provideCodeLenses(N,G,te){return this._withAdapter(N,a,ae=>ae.provideCodeLenses(w.URI.revive(G),te),void 0)}$resolveCodeLens(N,G,te){return this._withAdapter(N,a,ae=>ae.resolveCodeLens(G,te),void 0)}$releaseCodeLenses(N,G){this._withAdapter(N,a,te=>Promise.resolve(te.releaseCodeLenses(G)),void 0)}registerDefinitionProvider(N,G,te){const ae=this._addNewAdapter(new t(this._documents,te),N);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDefinition(N,G,te,ae){return this._withAdapter(N,t,me=>me.provideDefinition(w.URI.revive(G),te,ae),[])}registerDeclarationProvider(N,G,te){const ae=this._addNewAdapter(new r(this._documents,te),N);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDeclaration(N,G,te,ae){return this._withAdapter(N,r,me=>me.provideDeclaration(w.URI.revive(G),te,ae),[])}registerImplementationProvider(N,G,te){const ae=this._addNewAdapter(new d(this._documents,te),N);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideImplementation(N,G,te,ae){return this._withAdapter(N,d,me=>me.provideImplementation(w.URI.revive(G),te,ae),[])}registerTypeDefinitionProvider(N,G,te){const ae=this._addNewAdapter(new l(this._documents,te),N);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideTypeDefinition(N,G,te,ae){return this._withAdapter(N,l,me=>me.provideTypeDefinition(w.URI.revive(G),te,ae),[])}registerHoverProvider(N,G,te,ae){const me=this._addNewAdapter(new u(this._documents,te),N);return this._proxy.$registerHoverProvider(me,this._transformDocumentSelector(G)),this._createDisposable(me)}$provideHover(N,G,te,ae){return this._withAdapter(N,u,me=>me.provideHover(w.URI.revive(G),te,ae),void 0)}registerEvaluatableExpressionProvider(N,G,te,ae){const me=this._addNewAdapter(new m(this._documents,te),N);return this._proxy.$registerEvaluatableExpressionProvider(me,this._transformDocumentSelector(G)),this._createDisposable(me)}$provideEvaluatableExpression(N,G,te,ae){return this._withAdapter(N,m,me=>me.provideEvaluatableExpression(w.URI.revive(G),te,ae),void 0)}registerInlineValuesProvider(N,G,te,ae){const me=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Se=this._addNewAdapter(new _(this._documents,te),N);this._proxy.$registerInlineValuesProvider(Se,this._transformDocumentSelector(G),me);let Le=this._createDisposable(Se);if(me!==void 0){const ge=te.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(me));Le=T.Disposable.from(Le,ge)}return Le}$provideInlineValues(N,G,te,ae,me){return this._withAdapter(N,_,Se=>Se.provideInlineValues(w.URI.revive(G),te,ae,me),void 0)}registerDocumentHighlightProvider(N,G,te){const ae=this._addNewAdapter(new D(this._documents,te),N);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDocumentHighlights(N,G,te,ae){return this._withAdapter(N,D,me=>me.provideDocumentHighlights(w.URI.revive(G),te,ae),void 0)}registerLinkedEditingRangeProvider(N,G,te){const ae=this._addNewAdapter(new c(this._documents,te),N);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideLinkedEditingRanges(N,G,te,ae){return this._withAdapter(N,c,async me=>{const Se=await me.provideLinkedEditingRanges(w.URI.revive(G),te,ae);if(Se)return{ranges:Se.ranges,wordPattern:Se.wordPattern?Fe._serializeRegExp(Se.wordPattern):void 0}},void 0)}registerReferenceProvider(N,G,te){const ae=this._addNewAdapter(new p(this._documents,te),N);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideReferences(N,G,te,ae,me){return this._withAdapter(N,p,Se=>Se.provideReferences(w.URI.revive(G),te,ae,me),void 0)}registerCodeActionProvider(N,G,te,ae){var me,Se;const Le=new f.DisposableStore,ge=this._addNewAdapter(new P(this._documents,this._commands.converter,this._diagnostics,te,this._logService,N,this._apiDeprecation),N);return this._proxy.$registerQuickFixSupport(ge,this._transformDocumentSelector(G),{providedKinds:(me=ae==null?void 0:ae.providedCodeActionKinds)===null||me===void 0?void 0:me.map(Ce=>Ce.value),documentation:(Se=ae==null?void 0:ae.documentation)===null||Se===void 0?void 0:Se.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Le)}))},Fe._extLabel(N),Boolean(te.resolveCodeAction)),Le.add(this._createDisposable(ge)),Le}$provideCodeActions(N,G,te,ae,me){return this._withAdapter(N,P,Se=>Se.provideCodeActions(w.URI.revive(G),te,ae,me),void 0)}$resolveCodeAction(N,G,te){return this._withAdapter(N,P,ae=>ae.resolveCodeAction(G,te),void 0)}$releaseCodeActions(N,G){this._withAdapter(N,P,te=>Promise.resolve(te.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider(N,G,te){const ae=this._addNewAdapter(new F(this._documents,te),N);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(G),N.identifier,N.displayName||N.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(N,G,te,ae){return this._withAdapter(N,F,me=>me.provideDocumentFormattingEdits(w.URI.revive(G),te,ae),void 0)}registerDocumentRangeFormattingEditProvider(N,G,te){const ae=this._addNewAdapter(new z(this._documents,te),N);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(G),N.identifier,N.displayName||N.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(N,G,te,ae,me){return this._withAdapter(N,z,Se=>Se.provideDocumentRangeFormattingEdits(w.URI.revive(G),te,ae,me),void 0)}registerOnTypeFormattingEditProvider(N,G,te,ae){const me=this._addNewAdapter(new de(this._documents,te),N);return this._proxy.$registerOnTypeFormattingSupport(me,this._transformDocumentSelector(G),ae,N.identifier),this._createDisposable(me)}$provideOnTypeFormattingEdits(N,G,te,ae,me,Se){return this._withAdapter(N,de,Le=>Le.provideOnTypeFormattingEdits(w.URI.revive(G),te,ae,me,Se),void 0)}registerWorkspaceSymbolProvider(N,G){const te=this._addNewAdapter(new B(G,this._logService),N);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(N,G,te){return this._withAdapter(N,B,ae=>ae.provideWorkspaceSymbols(G,te),{symbols:[]})}$resolveWorkspaceSymbol(N,G,te){return this._withAdapter(N,B,ae=>ae.resolveWorkspaceSymbol(G,te),void 0)}$releaseWorkspaceSymbols(N,G){this._withAdapter(N,B,te=>te.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider(N,G,te){const ae=this._addNewAdapter(new W(this._documents,te,this._logService),N);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(G),W.supportsResolving(te)),this._createDisposable(ae)}$provideRenameEdits(N,G,te,ae,me){return this._withAdapter(N,W,Se=>Se.provideRenameEdits(w.URI.revive(G),te,ae,me),void 0)}$resolveRenameLocation(N,G,te,ae){return this._withAdapter(N,W,me=>me.resolveRenameLocation(w.URI.revive(G),te,ae),void 0)}registerDocumentSemanticTokensProvider(N,G,te,ae){const me=this._nextHandle(),Se=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(me,new xe(new M(this._documents,te),N)),this._proxy.$registerDocumentSemanticTokensProvider(me,this._transformDocumentSelector(G),ae,Se);let Le=this._createDisposable(me);if(Se){const ge=te.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(Se));Le=T.Disposable.from(Le,ge)}return Le}$provideDocumentSemanticTokens(N,G,te,ae){return this._withAdapter(N,M,me=>me.provideDocumentSemanticTokens(w.URI.revive(G),te,ae),null,!0)}$releaseDocumentSemanticTokens(N,G){this._withAdapter(N,M,te=>te.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider(N,G,te,ae){const me=this._addNewAdapter(new U(this._documents,te),N);return this._proxy.$registerDocumentRangeSemanticTokensProvider(me,this._transformDocumentSelector(G),ae),this._createDisposable(me)}$provideDocumentRangeSemanticTokens(N,G,te,ae){return this._withAdapter(N,U,me=>me.provideDocumentRangeSemanticTokens(w.URI.revive(G),te,ae),null,!0)}registerCompletionItemProvider(N,G,te,ae){const me=this._addNewAdapter(new x(this._documents,this._commands.converter,te,this._apiDeprecation,N),N);return this._proxy.$registerSuggestSupport(me,this._transformDocumentSelector(G),ae,x.supportsResolving(te),`${N.identifier.value}(${ae.join("")})`),this._createDisposable(me)}$provideCompletionItems(N,G,te,ae,me){return this._withAdapter(N,x,Se=>Se.provideCompletionItems(w.URI.revive(G),te,ae,me),void 0)}$resolveCompletionItem(N,G,te){return this._withAdapter(N,x,ae=>ae.resolveCompletionItem(G,te),void 0)}$releaseCompletionItems(N,G){this._withAdapter(N,x,te=>te.releaseCompletionItems(G),void 0)}registerSignatureHelpProvider(N,G,te,ae){const me=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,Se=this._addNewAdapter(new Q(this._documents,te),N);return this._proxy.$registerSignatureHelpProvider(Se,this._transformDocumentSelector(G),me),this._createDisposable(Se)}$provideSignatureHelp(N,G,te,ae,me){return this._withAdapter(N,Q,Se=>Se.provideSignatureHelp(w.URI.revive(G),te,ae,me),void 0)}$releaseSignatureHelp(N,G){this._withAdapter(N,Q,te=>te.releaseSignatureHelp(G),void 0)}registerInlineHintsProvider(N,G,te){const ae=typeof te.onDidChangeInlineHints=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new $(this._documents,te),N);this._proxy.$registerInlineHintsProvider(me,this._transformDocumentSelector(G),ae);let Se=this._createDisposable(me);if(ae!==void 0){const Le=te.onDidChangeInlineHints(ge=>this._proxy.$emitInlineHintsEvent(ae));Se=T.Disposable.from(Se,Le)}return Se}$provideInlineHints(N,G,te,ae){return this._withAdapter(N,$,me=>me.provideInlineHints(w.URI.revive(G),te,ae),void 0)}registerDocumentLinkProvider(N,G,te){const ae=this._addNewAdapter(new ee(this._documents,te),N);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(G),typeof te.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(N,G,te){return this._withAdapter(N,ee,ae=>ae.provideLinks(w.URI.revive(G),te),void 0)}$resolveDocumentLink(N,G,te){return this._withAdapter(N,ee,ae=>ae.resolveLink(G,te),void 0)}$releaseDocumentLinks(N,G){this._withAdapter(N,ee,te=>te.releaseLinks(G),void 0)}registerColorProvider(N,G,te){const ae=this._addNewAdapter(new re(this._documents,te),N);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDocumentColors(N,G,te){return this._withAdapter(N,re,ae=>ae.provideColors(w.URI.revive(G),te),[])}$provideColorPresentations(N,G,te,ae){return this._withAdapter(N,re,me=>me.provideColorPresentations(w.URI.revive(G),te,ae),void 0)}registerFoldingRangeProvider(N,G,te){const ae=this._nextHandle(),me=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new xe(new se(this._documents,te),N)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(G),me);let Se=this._createDisposable(ae);if(me!==void 0){const Le=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(me));Se=T.Disposable.from(Se,Le)}return Se}$provideFoldingRanges(N,G,te,ae){return this._withAdapter(N,se,me=>me.provideFoldingRanges(w.URI.revive(G),te,ae),void 0)}registerSelectionRangeProvider(N,G,te){const ae=this._addNewAdapter(new ye(this._documents,te,this._logService),N);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideSelectionRanges(N,G,te,ae){return this._withAdapter(N,ye,me=>me.provideSelectionRanges(w.URI.revive(G),te,ae),[])}registerCallHierarchyProvider(N,G,te){const ae=this._addNewAdapter(new Ie(this._documents,te),N);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$prepareCallHierarchy(N,G,te,ae){return this._withAdapter(N,Ie,me=>Promise.resolve(me.prepareSession(w.URI.revive(G),te,ae)),void 0)}$provideCallHierarchyIncomingCalls(N,G,te,ae){return this._withAdapter(N,Ie,me=>me.provideCallsTo(G,te,ae),void 0)}$provideCallHierarchyOutgoingCalls(N,G,te,ae){return this._withAdapter(N,Ie,me=>me.provideCallsFrom(G,te,ae),void 0)}$releaseCallHierarchy(N,G){this._withAdapter(N,Ie,te=>Promise.resolve(te.releaseSession(G)),void 0)}static _serializeRegExp(N){return{pattern:N.source,flags:(0,y.regExpFlags)(N)}}static _serializeIndentationRule(N){return{decreaseIndentPattern:Fe._serializeRegExp(N.decreaseIndentPattern),increaseIndentPattern:Fe._serializeRegExp(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?Fe._serializeRegExp(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?Fe._serializeRegExp(N.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(N){return{beforeText:Fe._serializeRegExp(N.beforeText),afterText:N.afterText?Fe._serializeRegExp(N.afterText):void 0,previousLineText:N.previousLineText?Fe._serializeRegExp(N.previousLineText):void 0,action:N.action}}static _serializeOnEnterRules(N){return N.map(Fe._serializeOnEnterRule)}setLanguageConfiguration(N,G,te){let{wordPattern:ae}=te;if(ae&&(0,y.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(G,ae):this._documents.setWordDefinitionFor(G,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const me=this._nextHandle(),Se={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Fe._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Fe._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Fe._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(me,G,Se),this._createDisposable(me)}$setWordDefinitions(N){for(const G of N)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=Fe,Fe._handlePool=0}),define(be[198],we([0,1,5,9,7]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(I,y){this._proxy=I.getProxy(w.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(I,y){await this._proxy.$changeLanguage(I,y);const n=this._documents.getDocumentData(I);if(!n)throw new Error(`document '${I.toString}' NOT found`);return n.document}async tokenAtPosition(I,y){var n;const R=I.version,C=k.Position.from(y),b=await this._proxy.$tokensAtPosition(I.uri,C),f={type:A.StandardTokenType.Other,range:(n=I.getWordRangeAtPosition(y))!==null&&n!==void 0?n:new A.Range(y.line,y.character,y.line,y.character)};if(!b)return f;const i={range:k.Range.to(b.range),type:k.TokenType.to(b.type)};return!i.range.contains(y)||R!==I.version?f:i}}e.ExtHostLanguages=T}),define(be[199],we([0,1,5,19,34]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(I){return I&&I.title}let S=class{constructor(y,n){this._logService=n,this._proxy=y.getProxy(w.MainContext.MainThreadMessageService)}showMessage(y,n,R,C,b){const f={extension:y};let i;typeof C=="string"||T(C)?i=[C,...b]:(f.modal=C&&C.modal,f.useCustom=C&&C.useCustom,i=b),f.useCustom&&(0,A.checkProposedApiEnabled)(y);const s=[];for(let v=0;v<i.length;v++){const h=i[v];if(typeof h=="string")s.push({title:h,handle:v,isCloseAffordance:!1});else if(typeof h=="object"){let{title:E,isCloseAffordance:g}=h;s.push({title:E,isCloseAffordance:!!g,handle:v})}else this._logService.warn("Invalid message item:",h)}return this._proxy.$showMessage(n,R,f,s).then(v=>{if(typeof v=="number")return i[v]})}};S=je([Ke(1,k.ILogService)],S),e.ExtHostMessageService=S}),define(be[200],we([0,1,20,3,6,2,29,5,9,7,69,70,22,177,178,53,12,24,56]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b,f,i,s,v,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookCellStatusBarItemInternal=e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class g extends A.Disposable{constructor(_,D,c,p,P){super();this._editorId=_,this.uri=D,this._proxy=c,this._webviewInitData=p,this.document=P,this._onDidReceiveDocumentMessage=new k.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:F=>this._proxy.$postMessage(this._editorId,void 0,F),asWebviewUri:F=>this._asWebviewUri(F)}}onDidReceiveMessage(_,D){var c;this._onDidReceiveDocumentMessage.fire(D),_!==void 0&&((c=this._rendererIdToEmitters.get(_))===null||c===void 0||c.fire(D))}getRendererComm(_){const D=new k.Emitter;return this._rendererIdToEmitters.set(_,D),{editorId:this._editorId,onDidReceiveMessage:D.event,postMessage:c=>this._proxy.$postMessage(this._editorId,_,c),asWebviewUri:c=>this._asWebviewUri(c)}}_asWebviewUri(_){return(0,R.asWebviewUri)(this._webviewInitData,this._editorId,_)}}class a extends A.Disposable{constructor(_,D,c,p){super();this._proxy=_,this._handle=D,this._extension=c,this._provider=p,this._kernelToFriendlyId=new b.ResourceMap,this._friendlyIdToKernel=new b.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(P=>{const F=P==null?void 0:P.uri;this._proxy.$onNotebookKernelChange(this._handle,F)}))}async provideKernels(_,D){const c=await this._provider.provideKernels(_.notebookDocument,D)||[],p=new Map;let P=0;const F=new Set,z=this._kernelToFriendlyId.get(_.uri),de=c.map(W=>{let K=z==null?void 0:z.get(W);return K===void 0&&(W.id&&F.has(W.id)?K=`${this._extension.identifier.value}_${W.id}_${P++}`:K=`${this._extension.identifier.value}_${W.id||S.generateUuid()}`),p.set(W,K),{id:W.id,friendlyId:K,label:W.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:W.description,detail:W.detail,isPreferred:W.isPreferred,preloads:W.preloads,supportedLanguages:W.supportedLanguages,implementsInterrupt:!!W.interrupt}});this._kernelToFriendlyId.set(_.uri,p);const B=new Map;return p.forEach((W,K)=>{B.set(W,K)}),this._friendlyIdToKernel.set(_.uri,B),de}getKernelByFriendlyId(_,D){var c;return(c=this._friendlyIdToKernel.get(_))===null||c===void 0?void 0:c.get(D)}async resolveNotebook(_,D,c,p){var P;const F=(P=this._friendlyIdToKernel.get(D.uri))===null||P===void 0?void 0:P.get(_);if(F&&this._provider.resolveKernel)return this._provider.resolveKernel(F,D.notebookDocument,c,p)}async executeNotebook(_,D,c){var p;const P=(p=this._friendlyIdToKernel.get(D.uri))===null||p===void 0?void 0:p.get(_);if(!!P){const F=c.map(z=>y.NotebookCellRange.to(z));return P.executeCellsRequest(D.notebookDocument,F)}}async interruptNotebookExecution(_,D){var c;const p=(c=this._friendlyIdToKernel.get(D.uri))===null||c===void 0?void 0:c.get(_);if(!(!p||!p.interrupt))return p.interrupt(D.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=a;class o{constructor(_,D){const c=o._Keys.nextId();_.$registerNotebookEditorDecorationType(c,y.NotebookDecorationRenderOptions.from(D)),this.value={key:c,dispose(){_.$removeNotebookEditorDecorationType(c)}}}}e.NotebookEditorDecorationType=o,o._Keys=new s.IdGenerator("NotebookEditorDecorationType");class t{constructor(_,D,c,p,P,F,z){this._textDocumentsAndEditors=c,this._textDocuments=p,this._webviewInitData=P,this.logService=F,this._extensionStoragePaths=z,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._documents=new b.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new k.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new k.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new k.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new k.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new k.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new k.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new k.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new k.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new k.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new k.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new k.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new k.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new k.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new b.ResourceMap,this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=_.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=_.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=_.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=D.converter,D.registerArgumentProcessor({processArgument:de=>{var B;if(de&&de.$mid===12){const W=(B=de.notebookEditor)===null||B===void 0?void 0:B.notebookUri,K=de.cell.handle,M=this._documents.get(W),U=M==null?void 0:M.getCell(K);if(U)return U.cell}return de}})}get activeNotebookEditor(){var _;return(_=this._activeNotebookEditor)===null||_===void 0?void 0:_.editor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(_=>_.editor)}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(_){return this._documents.get(_)}_getNotebookDocument(_){const D=this._documents.get(_);if(!D)throw new Error(`NO notebook document for '${_}'`);return D}_getProviderData(_){const D=this._notebookContentProviders.get(_);if(!D)throw new Error(`NO provider for '${_}'`);return D}registerNotebookContentProvider(_,D,c,p){var P,F,z;if(this._notebookContentProviders.has(D))throw new Error(`Notebook provider for '${D}' already registered`);this._notebookContentProviders.set(D,{extension:_,provider:c});let de;c.onDidChangeNotebookContentOptions&&(de=c.onDidChangeNotebookContentOptions(()=>{const K=y.NotebookDocumentContentOptions.from(c.options);this._notebookProxy.$updateNotebookProviderOptions(D,K)}));const B=(P=p==null?void 0:p.viewOptions)===null||P===void 0?void 0:P.filenamePattern.map(K=>y.NotebookExclusiveDocumentPattern.from(K)).filter(K=>K!==void 0);((F=p==null?void 0:p.viewOptions)===null||F===void 0?void 0:F.filenamePattern)&&!B&&console.warn(`Notebook content provider view options file name pattern is invalid ${(z=p==null?void 0:p.viewOptions)===null||z===void 0?void 0:z.filenamePattern}`);const W=y.NotebookDocumentContentOptions.from(p);return this._notebookProxy.$registerNotebookProvider({id:_.identifier,location:_.extensionLocation,description:_.description},D,{transientOutputs:W.transientOutputs,transientMetadata:W.transientMetadata,viewOptions:(p==null?void 0:p.viewOptions)&&B?{displayName:p.viewOptions.displayName,filenamePattern:B,exclusive:p.viewOptions.exclusive||!1}:void 0}),new n.Disposable(()=>{de==null||de.dispose(),this._notebookContentProviders.delete(D),this._notebookProxy.$unregisterNotebookProvider(D)})}registerNotebookKernelProvider(_,D,c){const p=t._notebookKernelProviderHandlePool++,P=new a(this._notebookProxy,p,_,c);return this._notebookKernelProviders.set(p,P),this._notebookProxy.$registerNotebookKernelProvider({id:_.identifier,location:_.extensionLocation,description:_.description},p,{viewType:D.viewType,filenamePattern:D.filenamePattern?y.NotebookExclusiveDocumentPattern.from(D.filenamePattern):void 0}),new n.Disposable(()=>{P.dispose(),this._notebookKernelProviders.delete(p),this._notebookProxy.$unregisterNotebookKernelProvider(p)})}createNotebookEditorDecorationType(_){return new o(this._notebookEditorsProxy,_).value}async openNotebookDocument(_){const D=this._documents.get(_);if(D)return D.notebookDocument;const c=await this._notebookDocumentsProxy.$tryOpenDocument(_),p=this._documents.get(T.URI.revive(c));return(0,v.assertIsDefined)(p==null?void 0:p.notebookDocument)}_withAdapter(_,D,c){const p=this._documents.get(T.URI.revive(D));if(!p)return[];const P=this._notebookKernelProviders.get(_);return P?c(P,p):[]}async showNotebookDocument(_,D){var c;T.URI.isUri(_)&&(_=await this.openNotebookDocument(_));let p;typeof D=="object"?p={position:y.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:D.selection&&y.NotebookCellRange.from(D.selection),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:p={preserveFocus:!1};const P=await this._notebookEditorsProxy.$tryShowNotebookDocument(_.uri,_.viewType,p),F=P&&((c=this._editors.get(P))===null||c===void 0?void 0:c.editor);if(F)return F.editor;throw P?new Error(`Could NOT open editor for "${_.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${_.toString()}".`)}async $provideNotebookKernels(_,D,c){return this._withAdapter(_,D,(p,P)=>p.provideKernels(P,c))}async $resolveNotebookKernel(_,D,c,p,P){await this._withAdapter(_,c,async(F,z)=>{const de=this._webviewComm.get(D);de&&await F.resolveNotebook(p,z,de.contentProviderComm,P)})}async $resolveNotebookEditor(_,D,c){const p=this._notebookContentProviders.get(_),P=T.URI.revive(D),F=this._documents.get(P);if(!(!F||!p)){let z=this._webviewComm.get(c);z||(z=new g(c,P,this._notebookProxy,this._webviewInitData,F),this._webviewComm.set(c,z))}}async $executeNotebookKernelFromProvider(_,D,c,p){await this._withAdapter(_,D,async(P,F)=>P.executeNotebook(c,F,p))}registerNotebookSerializer(_,D,c,p){const P=this._handlePool++;this._notebookSerializer.set(P,c);const F=y.NotebookDocumentContentOptions.from(p);return this._notebookProxy.$registerNotebookSerializer(P,{id:_.identifier,location:_.extensionLocation,description:_.description},D,F),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(P)})}async $dataToNotebook(_,D){const c=this._notebookSerializer.get(_);if(!c)throw new Error("NO serializer found");const p=await c.dataToNotebook(D.buffer);return{metadata:y.NotebookDocumentMetadata.from(p.metadata),cells:p.cells.map(y.NotebookCellData.from)}}async $notebookToData(_,D){const c=this._notebookSerializer.get(_);if(!c)throw new Error("NO serializer found");const p=await c.notebookToData({metadata:y.NotebookDocumentMetadata.to(D.metadata),cells:D.cells.map(y.NotebookCellData.to)});return h.VSBuffer.wrap(p)}async $cancelNotebookCellExecution(_,D,c,p){await this._withAdapter(_,D,async(F,z)=>F.interruptNotebookExecution(c,z));const P=this._documents.get(T.URI.revive(D));if(!!P)for(let F of p)for(let z=F.start;z<F.end;z++){const de=P.getCellFromIndex(z);de&&this.cancelOneNotebookCellExecution(de)}}cancelOneNotebookCellExecution(_){const D=this._activeExecutions.get(_.uri);D==null||D.cancel()}async $openNotebook(_,D,c,p,P){const{provider:F}=this._getProviderData(_),z=await F.openNotebook(T.URI.revive(D),{backupId:c,untitledDocumentData:p==null?void 0:p.buffer},P);return{metadata:y.NotebookDocumentMetadata.from(z.metadata),cells:z.cells.map(y.NotebookCellData.from)}}async $saveNotebook(_,D,c){const p=this._getNotebookDocument(T.URI.revive(D)),{provider:P}=this._getProviderData(_);return await P.saveNotebook(p.notebookDocument,c),!0}async $saveNotebookAs(_,D,c,p){const P=this._getNotebookDocument(T.URI.revive(D)),{provider:F}=this._getProviderData(_);return await F.saveNotebookAs(T.URI.revive(c),P.notebookDocument,p),!0}async $backupNotebook(_,D,c){var p;const P=this._getNotebookDocument(T.URI.revive(D)),F=this._getProviderData(_),z=(p=this._extensionStoragePaths.workspaceValue(F.extension))!==null&&p!==void 0?p:this._extensionStoragePaths.globalValue(F.extension),de=String((0,E.hash)([P.uri.toString(),this._backupIdPool++])),B=T.URI.joinPath(z,de),W=await F.provider.backupNotebook(P.notebookDocument,{destination:B},c);return P.updateBackup(W),W.id}$acceptNotebookActiveKernelChange(_){_.providerHandle!==void 0&&this._withAdapter(_.providerHandle,_.uri,async(D,c)=>{const p=_.kernelFriendlyId?D.getKernelByFriendlyId(T.URI.revive(_.uri),_.kernelFriendlyId):void 0;this._editors.forEach(P=>{P.editor.notebookData===c&&P.editor._acceptKernel(p)}),this._onDidChangeActiveNotebookKernel.fire({document:c.notebookDocument,kernel:p})})}$onDidReceiveMessage(_,D,c){var p;(p=this._webviewComm.get(_))===null||p===void 0||p.onDidReceiveMessage(D,c)}$acceptModelChanged(_,D,c){this._getNotebookDocument(T.URI.revive(_)).acceptModelChanged(D,c)}$acceptDirtyStateChanged(_,D){const c=this._getNotebookDocument(T.URI.revive(_));c.acceptModelChanged({rawEvents:[],versionId:c.notebookDocument.version},D)}$acceptModelSaved(_){const D=this._getNotebookDocument(T.URI.revive(_));this._onDidSaveNotebookDocument.fire(D.notebookDocument)}$acceptEditorPropertiesChanged(_,D){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,D);const c=this._editors.get(_);if(!c)throw new Error(`unknown text editor: ${_}. known editors: ${[...this._editors.keys()]} `);D.visibleRanges&&c.editor._acceptVisibleRanges(D.visibleRanges.ranges.map(y.NotebookCellRange.to)),D.selections&&c.editor._acceptSelections(D.selections.selections.map(y.NotebookCellRange.to)),D.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:c.editor.editor,visibleRanges:c.editor.editor.visibleRanges}),D.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:c.editor.editor,selections:c.editor.editor.selections}))}$acceptEditorViewColumns(_){for(const D in _){const c=this._editors.get(D);if(!c)throw new Error(`unknown text editor: ${D}. known editors: ${[...this._editors.keys()]} `);c.editor._acceptViewColumn(y.ViewColumn.to(_[D]))}}$acceptDocumentPropertiesChanged(_,D){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",_.path,D);const c=this._getNotebookDocument(T.URI.revive(_));c.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:c.notebookDocument})}_createExtHostEditor(_,D,c){var p;const P=_.uri;let F=this._webviewComm.get(D);F||(F=new g(D,P,this._notebookProxy,this._webviewInitData,_),this._webviewComm.set(D,F));const z=new i.ExtHostNotebookEditor(D,this._notebookEditorsProxy,_,c.visibleRanges.map(y.NotebookCellRange.to),c.selections.map(y.NotebookCellRange.to),typeof c.viewColumn=="number"?y.ViewColumn.to(c.viewColumn):void 0);(p=this._editors.get(D))===null||p===void 0||p.editor.dispose(),this._editors.set(D,{editor:z})}$acceptDocumentAndEditorsDelta(_){var D,c,p,P;let F=!1;if(_.removedDocuments)for(const de of _.removedDocuments){const B=T.URI.revive(de),W=this._documents.get(B);W&&(W.dispose(),this._documents.delete(B),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:W.notebookDocument.cells.map(K=>K.document.uri)}),this._onDidCloseNotebookDocument.fire(W.notebookDocument));for(const K of this._editors.values())K.editor.notebookData.uri.toString()===B.toString()&&(K.editor.dispose(),this._editors.delete(K.editor.id),F=!0)}if(_.addedDocuments){const de=[];for(const B of _.addedDocuments){const W=T.URI.revive(B.uri),K=B.viewType;if(this._documents.has(W))throw new Error(`adding EXISTING notebook ${W} `);const M=this,U=new f.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(x){M._onDidChangeNotebookCells.fire(x)},emitCellOutputsChange(x){M._onDidChangeCellOutputs.fire(x)},emitCellMetadataChange(x){M._onDidChangeCellMetadata.fire(x)},emitCellExecutionStateChange(x){M._onDidChangeCellExecutionState.fire(x)}},K,B.metadata?y.NotebookDocumentMetadata.to(B.metadata):new n.NotebookDocumentMetadata,W);U.acceptModelChanged({versionId:B.versionId,rawEvents:[{kind:C.NotebookCellsChangeType.Initialize,changes:[[0,0,B.cells]]}]},!1),de.push(...B.cells.map(x=>f.ExtHostCell.asModelAddData(U.notebookDocument,x))),(D=this._documents.get(W))===null||D===void 0||D.dispose(),this._documents.set(W,U),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:de}),this._onDidOpenNotebookDocument.fire(U.notebookDocument)}}if(_.addedEditors)for(const de of _.addedEditors){if(this._editors.has(de.id))return;const B=T.URI.revive(de.documentUri),W=this._documents.get(B);W&&(this._createExtHostEditor(W,de.id,de),F=!0)}const z=[];if(_.removedEditors)for(const de of _.removedEditors){const B=this._editors.get(de);B&&(F=!0,this._editors.delete(de),((c=this._activeNotebookEditor)===null||c===void 0?void 0:c.id)===B.editor.id&&(this._activeNotebookEditor=void 0),z.push(B))}if(F&&z.forEach(de=>{de.editor.dispose()}),_.visibleEditors){this._visibleNotebookEditors=_.visibleEditors.map(B=>this._editors.get(B).editor).filter(B=>!!B);const de=new Set;this._visibleNotebookEditors.forEach(B=>de.add(B.id));for(const B of this._editors.values()){const W=de.has(B.editor.id);B.editor._acceptVisibility(W)}this._visibleNotebookEditors=[...this._editors.values()].map(B=>B.editor).filter(B=>B.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}_.newActiveEditor===null?this._activeNotebookEditor=void 0:_.newActiveEditor&&(this._activeNotebookEditor=(p=this._editors.get(_.newActiveEditor))===null||p===void 0?void 0:p.editor),_.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((P=this._activeNotebookEditor)===null||P===void 0?void 0:P.editor)}createNotebookCellStatusBarItemInternal(_,D,c){const p=new r(this._notebookProxy,this._commandsConverter,_,D,c),P=C.CellUri.parse(_.document.uri);if(P){const F=this._documents.get(P.notebook);if(F){const z=F.getCell(P.handle);z&&k.Event.once(z.onDidDispose)(()=>p.dispose())}}return p}createNotebookCellExecution(_,D,c){const p=this.lookupNotebookDocument(_);if(!p)throw new Error(`Invalid cell uri / index: ${_}, ${D} `);const P=p.getCellFromIndex(D);if(!P)throw new Error(`Invalid cell uri / index: ${_}, ${D} `);if(!this._activeExecutions.has(P.uri)){const F=new u(_,p,P,this._notebookDocumentsProxy);this._activeExecutions.set(P.uri,F);const z=F.onDidChangeState(()=>{F.state===l.Resolved&&(F.dispose(),z.dispose(),this._activeExecutions.delete(P.uri))});return F.asApiObject()}}}e.ExtHostNotebookController=t,t._notebookKernelProviderHandlePool=0;class r extends A.Disposable{constructor(_,D,c,p,P){super();this._proxy=_,this._commands=D,this._cell=c,this._priority=P,this._id=r.NEXT_ID++,this._isDisposed=!1,this._text="",this._visible=!1,this._internalCommandRegistration=this._register(new A.DisposableStore),this._alignment=p!=null?p:n.NotebookCellStatusBarAlignment.Left}get apiItem(){return this._apiItem||(this._apiItem=d(this)),this._apiItem}get cell(){return this._cell}get alignment(){return this._alignment}set alignment(_){this._alignment=_,this.update()}get priority(){return this._priority}set priority(_){this._priority=_,this.update()}get text(){return this._text}set text(_){this._text=_,this.update()}get tooltip(){return this._tooltip}set tooltip(_){this._tooltip=_,this.update()}get command(){var _;return(_=this._command)===null||_===void 0?void 0:_.fromApi}set command(_){var D;((D=this._command)===null||D===void 0?void 0:D.fromApi)!==_&&(this._internalCommandRegistration.clear(),typeof _=="string"?this._command={fromApi:_,internal:this._commands.toInternal({title:"",command:_},this._internalCommandRegistration)}:_?this._command={fromApi:_,internal:this._commands.toInternal(_,this._internalCommandRegistration)}:this._command=void 0,this.update())}get accessibilityInformation(){return this._accessibilityInformation}set accessibilityInformation(_){this._accessibilityInformation=_,this.update()}show(){this._visible=!0,this.update()}hide(){this._visible=!1,this.update()}dispose(){this.hide(),this._isDisposed=!0,this._internalCommandRegistration.dispose()}update(){var _;if(!this._isDisposed){const D={alignment:this.alignment===n.NotebookCellStatusBarAlignment.Left?0:1,cellResource:this.cell.document.uri,command:(_=this._command)===null||_===void 0?void 0:_.internal,text:this.text,tooltip:this.tooltip,accessibilityInformation:this.accessibilityInformation,priority:this.priority,visible:this._visible};this._proxy.$setStatusBarEntry(this._id,D)}}}e.NotebookCellStatusBarItemInternal=r,r.NEXT_ID=0;function d(m){return Object.freeze({cell:m.cell,get alignment(){return m.alignment},set alignment(_){m.alignment=_},get priority(){return m.priority},set priority(_){m.priority=_},get text(){return m.text},set text(_){m.text=_},get tooltip(){return m.tooltip},set tooltip(_){m.tooltip=_},get command(){return m.command},set command(_){m.command=_},get accessibilityInformation(){return m.accessibilityInformation},set accessibilityInformation(_){m.accessibilityInformation=_},show(){m.show()},hide(){m.hide()},dispose(){m.dispose()}})}var l;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(l||(l={}));class u extends A.Disposable{constructor(_,D,c,p){super();this._uri=_,this._document=D,this._cell=c,this._proxy=p,this._onDidChangeState=new k.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=l.Init,this._tokenSource=this._register(new w.CancellationTokenSource),this._executionOrder=c.internalMetadata.executionOrder,this.mixinMetadata({runState:C.NotebookCellExecutionState.Pending,lastRunDuration:null,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(_){return this._proxy.$applyEdits(this._uri,_,!1)}verifyStateForOutput(){if(this._state===l.Init)throw new Error("Must call start before modifying cell output");if(this._state===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(_){const D=[{editType:11,handle:this._cell.handle,metadata:_}];this.applyEdits(D)}cellIndexToHandle(_){const D=typeof _=="number"?this._document.getCellFromIndex(_):this._cell;if(!!D)return D.handle}asApiObject(){const _=this;return Object.freeze({get document(){return _._document.notebookDocument},get cell(){return _._cell.cell},get executionOrder(){return _._executionOrder},set executionOrder(D){_._executionOrder=D,_.mixinMetadata({executionOrder:D})},start(D){if(_._state===l.Resolved||_._state===l.Started)throw new Error("Cannot call start again");_._state=l.Started,_._onDidChangeState.fire(),_.mixinMetadata({runState:C.NotebookCellExecutionState.Executing,runStartTime:D==null?void 0:D.startTime})},end(D){var c,p;if(_._state===l.Resolved)throw new Error("Cannot call resolve twice");_._state=l.Resolved,_._onDidChangeState.fire(),_.mixinMetadata({runState:C.NotebookCellExecutionState.Idle,lastRunSuccess:(c=D==null?void 0:D.success)!==null&&c!==void 0?c:null,lastRunDuration:(p=D==null?void 0:D.duration)!==null&&p!==void 0?p:null})},clearOutput(D){return _.verifyStateForOutput(),this.replaceOutput([],D)},async appendOutput(D,c){_.verifyStateForOutput();const p=_.cellIndexToHandle(c);if(typeof p=="number")return D=Array.isArray(D)?D:[D],_.applyEdits([{editType:2,handle:p,append:!0,outputs:D.map(y.NotebookCellOutput.from)}])},async replaceOutput(D,c){_.verifyStateForOutput();const p=_.cellIndexToHandle(c);if(typeof p=="number")return D=Array.isArray(D)?D:[D],_.applyEdits([{editType:2,handle:p,outputs:D.map(y.NotebookCellOutput.from)}])},async appendOutputItems(D,c){return _.verifyStateForOutput(),D=Array.isArray(D)?D:[D],_.applyEdits([{editType:10,append:!0,items:D.map(y.NotebookCellOutputItem.from),outputId:c}])},async replaceOutputItems(D,c){return _.verifyStateForOutput(),D=Array.isArray(D)?D:[D],_.applyEdits([{editType:10,items:D.map(y.NotebookCellOutputItem.from),outputId:c}])},token:_._tokenSource.token})}}}),define(be[99],we([0,1,5,3,6,24,4,14]),function(ie,e,w,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends A.Disposable{constructor(i,s,v,h){super();this._onDidAppend=this._register(new k.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=i,this._proxy=h,this._id=h.$register(this.name,s,v),this._disposed=!1,this._offset=0}get name(){return this._name}append(i){this.validate(),this._offset+=i?T.VSBuffer.fromString(i).byteLength:0}update(){this._id.then(i=>this._proxy.$update(i))}appendLine(i){this.validate(),this.append(i+`
`)}clear(){this.validate();const i=this._offset;this._id.then(s=>this._proxy.$clear(s,i))}show(i,s){this.validate(),this._id.then(v=>this._proxy.$reveal(v,!!(typeof i=="boolean"?i:s)))}hide(){this.validate(),this._id.then(i=>this._proxy.$close(i))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(i=>this._proxy.$dispose(i)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class n extends y{constructor(i,s){super(i,!1,void 0,s)}append(i){super.append(i),this._id.then(s=>this._proxy.$append(s,i)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=n;class R extends y{constructor(i,s,v){super(i,!0,s,v)}append(i){throw new Error("Not supported")}}class C{constructor(i,s){this.name=i,this._channel=s}append(i){this._channel.then(s=>s.append(i))}appendLine(i){this._channel.then(s=>s.appendLine(i))}clear(){this._channel.then(i=>i.clear())}show(i,s){this._channel.then(v=>v.show(i,s))}hide(){this._channel.then(i=>i.hide())}dispose(){this._channel.then(i=>i.dispose())}}e.LazyOutputChannel=C;let b=class{constructor(i){this._proxy=i.getProxy(w.MainContext.MainThreadOutputService)}$setVisibleChannel(i){}createOutputChannel(i){if(i=i.trim(),!i)throw new Error("illegal argument `name`. must not be falsy");return new n(i,this._proxy)}createOutputChannelFromLogFile(i,s){if(i=i.trim(),!i)throw new Error("illegal argument `name`. must not be falsy");if(!s)throw new Error("illegal argument `file`. must not be falsy");return new R(i,s,this._proxy)}};b=je([Ke(0,I.IExtHostRpcService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,S.createDecorator)("IExtHostOutputService")}),define(be[201],we([0,1,13,20,3,6,5,2,7,10,15,46]),function(ie,e,w,k,A,T,S,I,y,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function b(f,i,s){const v=f.getProxy(S.MainContext.MainThreadQuickOpen);class h{constructor(l,u){this._sessions=new Map,this._instances=0,this._workspace=l,this._commands=u}showQuickPick(l,u,m,_=k.CancellationToken.None){this._onDidSelectItem=void 0;const D=Promise.resolve(l),c=++this._instances,p=v.$show(c,{title:m==null?void 0:m.title,placeHolder:m==null?void 0:m.placeHolder,matchOnDescription:m==null?void 0:m.matchOnDescription,matchOnDetail:m==null?void 0:m.matchOnDetail,ignoreFocusLost:m==null?void 0:m.ignoreFocusOut,canPickMany:m==null?void 0:m.canPickMany},_),P={},F=p.then(()=>P);return Promise.race([F,D]).then(z=>{if(z!==P)return D.then(de=>{const B=[];for(let W=0;W<de.length;W++){const K=de[W];let M,U,x,Q,$;typeof K=="string"?M=K:(M=K.label,U=K.description,x=K.detail,Q=K.picked,$=K.alwaysShow),B.push({label:M,description:U,handle:W,detail:x,picked:Q,alwaysShow:$})}return m&&typeof m.onDidSelectItem=="function"&&(this._onDidSelectItem=W=>{m.onDidSelectItem(de[W])}),v.$setItems(c,B),p.then(W=>{if(typeof W=="number")return de[W];if(Array.isArray(W))return W.map(K=>de[K])})})}).then(void 0,z=>{if(!(0,n.isPromiseCanceledError)(z))return v.$setError(c,z),Promise.reject(z)})}$onItemSelected(l){this._onDidSelectItem&&this._onDidSelectItem(l)}showInput(l,u=k.CancellationToken.None){return this._validateInput=l?l.validateInput:void 0,v.$input(l,typeof this._validateInput=="function",u).then(void 0,m=>{if(!(0,n.isPromiseCanceledError)(m))return Promise.reject(m)})}$validateInput(l){return this._validateInput?(0,w.asPromise)(()=>this._validateInput(l)):Promise.resolve(void 0)}async showWorkspaceFolderPick(l,u=k.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!!m){const _=await this._workspace.getWorkspaceFolders2();if(!!_)return _.find(D=>D.uri.toString()===m.uri.toString())}}createQuickPick(l,u){const m=new t(l,u,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}createInputBox(l){const u=new r(l,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(l,u){const m=this._sessions.get(l);m&&m._fireDidChangeValue(u)}$onDidAccept(l){const u=this._sessions.get(l);u&&u._fireDidAccept()}$onDidChangeActive(l,u){const m=this._sessions.get(l);m instanceof t&&m._fireDidChangeActive(u)}$onDidChangeSelection(l,u){const m=this._sessions.get(l);m instanceof t&&m._fireDidChangeSelection(u)}$onDidTriggerButton(l,u){const m=this._sessions.get(l);m&&m._fireDidTriggerButton(u)}$onDidHide(l){const u=this._sessions.get(l);u&&u._fireDidHide()}}class E{constructor(l,u){this._extensionId=l,this._onDidDispose=u,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new A.Emitter,this._onDidChangeValueEmitter=new A.Emitter,this._onDidTriggerButtonEmitter=new A.Emitter,this._onDidHideEmitter=new A.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(l){this._title=l,this.update({title:l})}get step(){return this._steps}set step(l){this._steps=l,this.update({step:l})}get totalSteps(){return this._totalSteps}set totalSteps(l){this._totalSteps=l,this.update({totalSteps:l})}get enabled(){return this._enabled}set enabled(l){this._enabled=l,this.update({enabled:l})}get busy(){return this._busy}set busy(l){this._busy=l,this.update({busy:l})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(l){this._ignoreFocusOut=l,this.update({ignoreFocusOut:l})}get value(){return this._value}set value(l){this._value=l,this.update({value:l})}get placeholder(){return this._placeholder}set placeholder(l){this._placeholder=l,this.update({placeholder:l})}get buttons(){return this._buttons}set buttons(l){this._buttons=l.slice(),this._handlesToButtons.clear(),l.forEach((u,m)=>{const _=u===y.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(_,u)}),this.update({buttons:l.map((u,m)=>({iconPath:g(u.iconPath),tooltip:u.tooltip,handle:u===y.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(l){this._value=l,this._onDidChangeValueEmitter.fire(l)}_fireDidTriggerButton(l){const u=this._handlesToButtons.get(l);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),v.$dispose(this._id))}update(l){if(!this._disposed){for(const u of Object.keys(l)){const m=l[u];this._pendingUpdate[u]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){v.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function g(d){if(d instanceof y.ThemeIcon)return{id:d.id};const l=o(d),u=a(d);return{dark:typeof l=="string"?I.URI.file(l):l,light:typeof u=="string"?I.URI.file(u):u}}function a(d){return typeof d=="object"&&"light"in d?d.light:d}function o(d){return typeof d=="object"&&"dark"in d?d.dark:d}class t extends E{constructor(l,u,m){super(l,m);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new A.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new A.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(l){this._items=l.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),l.forEach((u,m)=>{this._handlesToItems.set(m,u),this._itemsToHandles.set(u,m)}),this.update({items:l.map((u,m)=>({label:u.label,description:u.description,handle:m,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(l){this._canSelectMany=l,this.update({canSelectMany:l})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(l){this._matchOnDescription=l,this.update({matchOnDescription:l})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(l){this._matchOnDetail=l,this.update({matchOnDetail:l})}get sortByLabel(){return this._sortByLabel}set sortByLabel(l){this._sortByLabel=l,this.update({sortByLabel:l})}get activeItems(){return this._activeItems}set activeItems(l){this._activeItems=l.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(l){this._selectedItems=l.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(l){const u=(0,R.coalesce)(l.map(m=>this._handlesToItems.get(m)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(l){const u=(0,R.coalesce)(l.map(m=>this._handlesToItems.get(m)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}}class r extends E{constructor(l,u){super(l,u);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(l){this._password=l,this.update({password:l})}get prompt(){return this._prompt}set prompt(l){this._prompt=l,this.update({prompt:l})}get validationMessage(){return this._validationMessage}set validationMessage(l){this._validationMessage=l,this.update({validationMessage:l,severity:l?C.default.Error:C.default.Ignore})}}return new h(i,s)}e.createExtHostQuickOpen=b}),define(be[202],we([0,1,2,3,51,6,13,5,15,110,19,26,34]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(l){if(l)return typeof l.iconPath=="string"?w.URI.file(l.iconPath):l.iconPath}function i(l,u){if(!l.iconPath&&!u.iconPath)return 0;if(l.iconPath){if(!u.iconPath)return 1}else return-1;const m=typeof l.iconPath=="string"?l.iconPath:l.iconPath.fsPath,_=typeof u.iconPath=="string"?u.iconPath:u.iconPath.fsPath;return(0,n.comparePaths)(m,_)}function s(l,u){let m=0;if(l.strikeThrough!==u.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==u.faded)return l.faded?1:-1;if(l.tooltip!==u.tooltip)return(l.tooltip||"").localeCompare(u.tooltip||"");if(m=i(l,u),m!==0)return m;if(l.light&&u.light)m=i(l.light,u.light);else{if(l.light)return 1;if(u.light)return-1}if(m!==0)return m;if(l.dark&&u.dark)m=i(l.dark,u.dark);else{if(l.dark)return 1;if(u.dark)return-1}return m}function v(l,u){if(l.command!==u.command)return l.command<u.command?-1:1;if(l.title!==u.title)return l.title<u.title?-1:1;if(l.tooltip!==u.tooltip){if(l.tooltip!==void 0&&u.tooltip!==void 0)return l.tooltip<u.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(l.arguments===u.arguments)return 0;if(l.arguments)if(u.arguments){if(l.arguments.length!==u.arguments.length)return l.arguments.length-u.arguments.length}else return 1;else return-1;for(let m=0;m<l.arguments.length;m++){const _=l.arguments[m],D=u.arguments[m];if(_!==D)return _<D?-1:1}return 0}function h(l,u){let m=(0,n.comparePaths)(l.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(m!==0)return m;if(l.command&&u.command)m=v(l.command,u.command);else{if(l.command)return 1;if(u.command)return-1}if(m!==0)return m;if(l.decorations&&u.decorations)m=s(l.decorations,u.decorations);else{if(l.decorations)return 1;if(u.decorations)return-1}return m}function E(l,u){for(let m=0;m<l.length;m++)if(l[m]!==u[m])return!1;return!0}function g(l,u){return l.command===u.command&&l.title===u.title&&l.tooltip===u.tooltip&&(l.arguments&&u.arguments?E(l.arguments,u.arguments):l.arguments===u.arguments)}function a(l,u){return(0,y.equals)(l,u,g)}class o{constructor(u,m,_){this._extension=u,this._proxy=m,this._sourceControlHandle=_,this._value="",this._onDidChange=new k.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(u){this._proxy.$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return(0,b.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(u){if((0,b.checkProposedApiEnabled)(this._extension),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,u))}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=o;class t{constructor(u,m,_,D,c){this._proxy=u,this._commands=m,this._sourceControlHandle=_,this._id=D,this._label=c,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new k.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new k.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,m){const _=this._resourceStatesCommandsMap.get(u);return _?(0,S.asPromise)(()=>this._commands.executeCommand(_.command,..._.arguments||[],m)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var u;const m=[...this._resourceStates].sort(h),D=(0,y.sortedDiff)(this._resourceSnapshot,m,h).map(P=>{const F=P.toInsert.map(z=>{const de=this._resourceHandlePool++;this._resourceStatesMap.set(de,z);const B=z.resourceUri,W=f(z.decorations),K=z.decorations&&f(z.decorations.light)||W,M=z.decorations&&f(z.decorations.dark)||W,U=[];let x;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const ye=new T.DisposableStore;x=this._commands.converter.toInternal(z.command,ye),this._resourceStatesDisposablesMap.set(de,ye)}else this._resourceStatesCommandsMap.set(de,z.command);K&&U.push(K),M&&M.toString()!==(K==null?void 0:K.toString())&&U.push(M);const Q=z.decorations&&z.decorations.tooltip||"",$=z.decorations&&!!z.decorations.strikeThrough,ee=z.decorations&&!!z.decorations.faded,re=z.contextValue||"";return{rawResource:[de,B,U,Q,$,ee,re,x],handle:de}});return{start:P.start,deleteCount:P.deleteCount,toInsert:F}}),c=D.map(({start:P,deleteCount:F,toInsert:z})=>[P,F,z.map(de=>de.rawResource)]),p=D.reverse();for(const{start:P,deleteCount:F,toInsert:z}of p){const de=z.map(W=>W.handle),B=this._handlesSnapshot.splice(P,F,...de);for(const W of B)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),(u=this._resourceStatesDisposablesMap.get(W))===null||u===void 0||u.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=m,c}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class r{constructor(u,m,_,D,c,p){this._proxy=m,this._commands=_,this._id=D,this._label=c,this._rootUri=p,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new k.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new o(u,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,D,c,p)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,this._proxy.$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u})}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,this._proxy.$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=u;const m=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:m})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(!(this._statusBarCommands&&u&&a(this._statusBarCommands,u))){this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=u;const m=(u||[]).map(_=>this._commands.converter.toInternal(_,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:m})}}get selected(){return this._selected}createResourceGroup(u,m){const _=new t(this._proxy,this._commands,this.handle,u,m),D=k.Event.once(_.onDidDispose)(()=>this.createdResourceGroups.delete(_));return this.createdResourceGroups.set(_,D),this.eventuallyAddResourceGroups(),_}eventuallyAddResourceGroups(){const u=[],m=[];for(const[_,D]of this.createdResourceGroups){D.dispose();const c=_.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(_),this.eventuallyUpdateResourceStates()});k.Event.once(_.onDidDispose)(()=>{this.updatedResourceGroups.delete(_),c.dispose(),this._groups.delete(_.handle),this._proxy.$unregisterGroup(this.handle,_.handle)}),u.push([_.handle,_.id,_.label,_.features]);const p=_._takeResourceStateSnapshot();p.length>0&&m.push([_.handle,p]),this._groups.set(_.handle,_)}this._proxy.$registerGroups(this.handle,u,m),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(m=>{const _=m._takeResourceStateSnapshot();_.length!==0&&u.push([m.handle,_])}),u.length>0&&this._proxy.$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,je([(0,A.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),je([(0,A.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let d=class kn{constructor(u,m,_){this._commands=m,this.logService=_,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new k.Emitter,this._proxy=u.getProxy(I.MainContext.MainThreadSCM),this._telemetry=u.getProxy(I.MainContext.MainThreadTelemetry),m.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===3){const c=this._sourceControls.get(D.sourceControlHandle);if(!c)return D;const p=c.getResourceGroup(D.groupHandle);return p?p.getResourceState(D.handle):D}else if(D&&D.$mid===4){const c=this._sourceControls.get(D.sourceControlHandle);return c?c.getResourceGroup(D.groupHandle):D}else if(D&&D.$mid===5){const c=this._sourceControls.get(D.handle);return c||D}return D}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(u,m,_,D){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,m,_,D),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const c=kn._handlePool++,p=new r(u,this._proxy,this._commands,m,_,D);this._sourceControls.set(c,p);const P=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(u.identifier))||[];return P.push(p),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(u.identifier),P),p}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const m=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(u.identifier)),_=m&&m[m.length-1];return _&&_.inputBox}$provideOriginalResource(u,m,_){const D=w.URI.revive(m);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,D.toString());const c=this._sourceControls.get(u);return!c||!c.quickDiffProvider||!c.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>c.quickDiffProvider.provideOriginalResource(D,_)).then(p=>p||null)}$onInputBoxValueChange(u,m){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const _=this._sourceControls.get(u);return _&&_.inputBox.$onInputBoxValueChange(m),Promise.resolve(void 0)}$executeResourceCommand(u,m,_,D){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,m,_);const c=this._sourceControls.get(u);if(!c)return Promise.resolve(void 0);const p=c.getResourceGroup(m);return p?p.$executeResourceCommand(_,D):Promise.resolve(void 0)}$validateInput(u,m,_){this.logService.trace("ExtHostSCM#$validateInput",u);const D=this._sourceControls.get(u);return!D||!D.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>D.inputBox.validateInput(m,_)).then(c=>c?Promise.resolve([c.message,c.type]):Promise.resolve(void 0))}$setSelectedSourceControl(u){var m,_;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&((m=this._sourceControls.get(u))===null||m===void 0||m.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((_=this._sourceControls.get(this._selectedSourceControlHandle))===null||_===void 0||_.setSelectionState(!1)),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}};d._handlePool=0,d=je([Ke(2,R.ILogService)],d),e.ExtHostSCM=d});var tt=this&&this.__classPrivateFieldSet||function(ie,e,w,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(ie,w):A?A.value=w:e.set(ie,w),w},Ue=this&&this.__classPrivateFieldGet||function(ie,e,w,k){if(w==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?k:w==="a"?k.call(ie):k?k.value:e.get(ie)};define(be[203],we([0,1,7,5,133,6]),function(ie,e,w,k,A,T){"use strict";var S,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(b,f,i,s,v=w.StatusBarAlignment.Left,h,E){S.set(this,void 0),I.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,tt(this,S,b,"f"),tt(this,I,f,"f"),this._id=y.ID_GEN++,this._statusId=i,this._statusName=s,this._alignment=v,this._priority=h,this._accessibilityInformation=E}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var b;return(b=this._command)===null||b===void 0?void 0:b.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(b){this._text=b,this.update()}set tooltip(b){this._tooltip=b,this.update()}set color(b){this._color=b,this.update()}set backgroundColor(b){b&&!y.ALLOWED_BACKGROUND_COLORS.has(b.id)&&(b=void 0),this._backgroundColor=b,this.update()}set command(b){var f;((f=this._command)===null||f===void 0?void 0:f.fromApi)!==b&&(this._internalCommandRegistration.clear(),typeof b=="string"?this._command={fromApi:b,internal:Ue(this,I,"f").toInternal({title:"",command:b},this._internalCommandRegistration)}:b?this._command={fromApi:b,internal:Ue(this,I,"f").toInternal(b,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(b){this._accessibilityInformation=b,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,S,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var b;this._timeoutHandle=void 0;let f=this._color;this._backgroundColor&&(f=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Ue(this,S,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(b=this._command)===null||b===void 0?void 0:b.internal,f,this._backgroundColor,this._alignment===w.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,S=new WeakMap,I=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new w.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(b){this._messages=[],this._item=b.createStatusBarEntry("status.extensionMessage",(0,A.localize)(0,null),w.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(b){const f={message:b};return this._messages.unshift(f),this._update(),new w.Disposable(()=>{const i=this._messages.indexOf(f);i>=0&&(this._messages.splice(i,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class R{constructor(b,f){this._proxy=b.getProxy(k.MainContext.MainThreadStatusBar),this._commands=f,this._statusMessage=new n(this)}createStatusBarEntry(b,f,i,s,v){return new y(this._proxy,this._commands,b,f,i,s,v)}setStatusBarMessage(b,f){const i=this._statusMessage.setMessage(b);let s;return typeof f=="number"?s=setTimeout(()=>i.dispose(),f):typeof f!="undefined"&&f.then(()=>i.dispose(),()=>i.dispose()),new w.Disposable(()=>{i.dispose(),clearTimeout(s)})}}e.ExtHostStatusBar=R}),define(be[75],we([0,1,5,3,4]),function(ie,e,w,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(I){this._onDidChangeStorage=new k.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(w.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,y){this._proxy.$registerExtensionStorageKeysToSync(I,y)}getValue(I,y,n){return this._proxy.$getValue(I,y).then(R=>R||n)}setValue(I,y,n){return this._proxy.$setValue(I,y,n)}$acceptValue(I,y,n){this._onDidChangeStorage.fire({shared:I,key:y,value:n})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,A.createDecorator)("IExtHostStorage")}),define(be[76],we([0,1,4,27,19,74,2]),function(ie,e,w,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,w.createDecorator)("IExtensionStoragePaths");let I=class{constructor(n,R,C){var b;this._logService=R,this._extHostFileSystem=C,this._workspace=(b=n.workspace)!==null&&b!==void 0?b:void 0,this._environment=n.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(f=>this._value=f)}async _getOrCreateWorkspaceStoragePath(){var n;if(!this._workspace)return Promise.resolve(void 0);const R=this._workspace.id,C=S.URI.joinPath(this._environment.workspaceStorageHome,R);try{return await this._extHostFileSystem.value.stat(C),this._logService.trace("[ExtHostStorage] storage dir already exists",C),C}catch(b){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",C),await this._extHostFileSystem.value.createDirectory(C),await this._extHostFileSystem.value.writeFile(S.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(n=S.URI.revive(this._workspace.configuration))===null||n===void 0?void 0:n.toString(),name:this._workspace.name},void 0,2))),C}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(n){if(this._value)return S.URI.joinPath(this._value,n.identifier.value)}globalValue(n){return S.URI.joinPath(this._environment.globalStorageHome,n.identifier.value.toLowerCase())}};I=je([Ke(0,k.IExtHostInitDataService),Ke(1,A.ILogService),Ke(2,T.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(be[41],we([0,1,3,5,4,2,14,6,7,134,10,171,20,29,154]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,A.createDecorator)("IExtHostTerminalService");class s{constructor(t,r,d,l){this._proxy=t,this._id=r,this._creationOptions=d,this._name=l,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(m=>this._pidPromiseComplete=m);const u=this;this.value={get name(){return u._name||""},get processId(){return u._pidPromise},get creationOptions(){return u._creationOptions},get exitStatus(){return u._exitStatus},sendText(m,_=!0){u._checkDisposed(),u._proxy.$sendText(u._id,m,_)},show(m){u._checkDisposed(),u._proxy.$show(u._id,m)},hide(){u._checkDisposed(),u._proxy.$hide(u._id)},dispose(){u._disposed||(u._disposed=!0,u._proxy.$dispose(u._id))},get dimensions(){if(!(u._cols===void 0||u._rows===void 0))return{columns:u._cols,rows:u._rows}}}}async create(t,r,d,l,u,m,_,D,c,p,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:r,cwd:d,env:l,icon:u,initialText:m,waitOnExit:_,strictEnv:D,hideFromUser:c,isFeatureTerminal:p,isExtensionOwnedTerminal:P})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,r){return t===this._cols&&r===this._rows||t===0||r===0?!1:(this._cols=t,this._rows=r,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=s;class v{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new w.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new w.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new w.Emitter,this._onProcessTitleChanged=new w.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new w.Emitter,this._onProcessShellTypeChanged=new w.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,r){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:r})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose&&this._pty.onDidClose((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r&&{cols:r.columns,rows:r.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=v;let h=1,E=class extends I.Disposable{constructor(t,r){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new w.Emitter,this._onDidOpenTerminal=new w.Emitter,this._onDidChangeActiveTerminal=new w.Emitter,this._onDidChangeTerminalDimensions=new w.Emitter,this._proxy=r.getProxy(k.MainContext.MainThreadTerminalService),this._bufferer=new i.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new w.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[d,l]of this._terminalProcesses)l.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const r=new s(this._proxy,(0,f.generateUuid)(),t,t.name),d=new v(t.pty);return r.createExtensionTerminal().then(l=>{const u=this._setupExtHostProcessListeners(l,d);this._terminalProcessDisposables[l]=u}),this._terminals.push(r),r.value}attachPtyToTerminal(t,r){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const l=new v(r),u=this._setupExtHostProcessListeners(t,l);this._terminalProcessDisposables[t]=u}async $acceptActiveTerminalChanged(t){const r=this._activeTerminal;if(t===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const d=this._getTerminalById(t);d&&(this._activeTerminal=d,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,r){const d=this._getTerminalById(t);d&&this._onDidWriteTerminalData.fire({terminal:d.value,data:r})}async $acceptTerminalDimensions(t,r,d){const l=this._getTerminalById(t);l&&l.setDimensions(r,d)&&this._onDidChangeTerminalDimensions.fire({terminal:l.value,dimensions:l.value.dimensions})}async $acceptTerminalMaximumDimensions(t,r,d){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.resize(r,d)}async $acceptTerminalTitleChange(t,r){const d=this._getTerminalById(t);d&&(d.name=r)}async $acceptTerminalClosed(t,r){const d=this._getTerminalObjectIndexById(this._terminals,t);if(d!==null){const l=this._terminals.splice(d,1)[0];l.setExitCode(r),this._onDidCloseTerminal.fire(l.value)}}$acceptTerminalOpened(t,r,d,l){if(r){const _=this._getTerminalObjectIndexById(this._terminals,r);if(_!==null){this._terminals[_]._id=t,this._onDidOpenTerminal.fire(this.terminals[_]),this._terminals[_].isOpen=!0;return}}const u={name:l.name,shellPath:l.executable,shellArgs:l.args,cwd:typeof l.cwd=="string"?l.cwd:T.URI.revive(l.cwd),env:l.env,hideFromUser:l.hideFromUser},m=new s(this._proxy,t,u,d);this._terminals.push(m),this._onDidOpenTerminal.fire(m.value),m.isOpen=!0}async $acceptTerminalProcessId(t,r){const d=this._getTerminalById(t);d&&d._setProcessId(r)}async $startExtensionTerminal(t,r){const d=this._getTerminalById(t);if(!d)return{message:(0,n.localize)(0,null,t)};d.isOpen||await new Promise(u=>{const m=this.onDidOpenTerminal(async _=>{_===d.value&&(m.dispose(),u())})});const l=this._terminalProcesses.get(t);l?l.startSendingEvents(r):this._extensionTerminalAwaitingStart[t]={initialDimensions:r}}_setupExtHostProcessListeners(t,r){const d=new I.DisposableStore;d.add(r.onProcessReady(u=>this._proxy.$sendProcessReady(t,u.pid,u.cwd))),d.add(r.onProcessTitleChanged(u=>this._proxy.$sendProcessTitle(t,u))),this._bufferer.startBuffering(t,r.onProcessData),d.add(r.onProcessExit(u=>this._onProcessExit(t,u))),r.onProcessOverrideDimensions&&d.add(r.onProcessOverrideDimensions(u=>this._proxy.$sendOverrideDimensions(t,u))),this._terminalProcesses.set(t,r);const l=this._extensionTerminalAwaitingStart[t];return l&&r instanceof v&&(r.startSendingEvents(l.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),d}$acceptProcessAckDataEvent(t,r){var d;(d=this._terminalProcesses.get(t))===null||d===void 0||d.acknowledgeDataEvent(r)}$acceptProcessInput(t,r){var d;(d=this._terminalProcesses.get(t))===null||d===void 0||d.input(r)}$acceptProcessResize(t,r,d){var l;try{(l=this._terminalProcesses.get(t))===null||l===void 0||l.resize(r,d)}catch(u){if(u.code!=="EPIPE"&&u.code!=="ERR_IPC_CHANNEL_CLOSED")throw u}}$acceptProcessShutdown(t,r){var d;(d=this._terminalProcesses.get(t))===null||d===void 0||d.shutdown(r)}$acceptProcessRequestInitialCwd(t){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.getInitialCwd().then(d=>this._proxy.$sendProcessInitialCwd(t,d))}$acceptProcessRequestCwd(t){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.getCwd().then(d=>this._proxy.$sendProcessCwd(t,d))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,r){const d=this._getTerminalById(t);if(!d)return[];this._terminalLinkCache.delete(t);const l=this._terminalLinkCancellationSource.get(t);l&&l.dispose(!0);const u=new b.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,u);const m=[],_={terminal:d.value,line:r},D=[];for(const P of this._linkProviders)D.push(new Promise(async F=>{u.token.onCancellationRequested(()=>F({provider:P,links:[]}));const z=await P.provideTerminalLinks(_,u.token)||[];u.token.isCancellationRequested||F({provider:P,links:z})}));const c=await Promise.all(D);if(u.token.isCancellationRequested)return[];const p=new Map;for(const P of c)P&&P.links.length>0&&m.push(...P.links.map(F=>{const z={id:h++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return p.set(z.id,{provider:P.provider,link:F}),z}));return this._terminalLinkCache.set(t,p),m}$activateLink(t,r){var d;const l=(d=this._terminalLinkCache.get(t))===null||d===void 0?void 0:d.get(r);!l||l.provider.handleTerminalLink(l.link)}_onProcessExit(t,r){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const d=this._terminalProcessDisposables[t];d&&(d.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,r)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,r){const d=this._getTerminalObjectIndexById(t,r);return d!==null?t[d]:null}_getTerminalObjectIndexById(t,r){let d=null;return t.some((l,u)=>l._id===r?(d=u,!0):!1),d}getEnvironmentVariableCollection(t){let r=this._environmentVariableCollections.get(t.identifier.value);return r||(r=new g,this._setEnvironmentVariableCollection(t.identifier.value,r)),r}_syncEnvironmentVariableCollection(t,r){const d=(0,C.serializeEnvironmentVariableCollection)(r.map);this._proxy.$setEnvironmentVariableCollection(t,r.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(t){t.forEach(r=>{const d=r[0],l=new g(r[1]);this._setEnvironmentVariableCollection(d,l)})}_setEnvironmentVariableCollection(t,r){this._environmentVariableCollections.set(t,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,r)})}};E=je([Ke(1,S.IExtHostRpcService)],E),e.BaseExtHostTerminalService=E;class g{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new w.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,r){this._setIfDiffers(t,{value:r,type:y.EnvironmentVariableMutatorType.Replace})}append(t,r){this._setIfDiffers(t,{value:r,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,r){this._setIfDiffers(t,{value:r,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,r){const d=this.map.get(t);(!d||d.value!==r.value||d.type!==r.type)&&(this.map.set(t,r),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,r){this.map.forEach((d,l)=>t.call(r,l,d,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=g;let a=class extends E{constructor(t){super(!1,t)}createTerminal(t,r,d){throw new R.NotSupportedError}createTerminalFromOptions(t){throw new R.NotSupportedError}getDefaultShell(t,r){throw new R.NotSupportedError}getDefaultShellArgs(t,r){throw new R.NotSupportedError}$getAvailableProfiles(t){throw new R.NotSupportedError}async $getDefaultShellAndArgs(t){throw new R.NotSupportedError}$acceptWorkspacePermissionsChanged(t){throw new R.NotSupportedError}};a=je([Ke(0,S.IExtHostRpcService)],a),e.WorkerExtHostTerminalService=a}),define(be[204],we([0,1,3,15,5,96,9,7]),function(ie,e,w,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(R,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new w.Emitter,this._onDidChangeTextEditorOptions=new w.Emitter,this._onDidChangeTextEditorVisibleRanges=new w.Emitter,this._onDidChangeTextEditorViewColumn=new w.Emitter,this._onDidChangeActiveTextEditor=new w.Emitter,this._onDidChangeVisibleTextEditors=new w.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(A.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(b=>this._onDidChangeVisibleTextEditors.fire(b)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(b=>this._onDidChangeActiveTextEditor.fire(b))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const C=this._extHostDocumentsAndEditors.allEditors();return R?C:C.map(b=>b.value)}async showTextDocument(R,C,b){let f;typeof C=="number"?f={position:S.ViewColumn.from(C),preserveFocus:b}:typeof C=="object"?f={position:S.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?S.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:f={preserveFocus:!1};const i=await this._proxy.$tryShowTextDocument(R.uri,f),s=i&&this._extHostDocumentsAndEditors.getEditor(i);if(s)return s.value;throw i?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R){return new T.TextEditorDecorationType(this._proxy,R).value}$acceptEditorPropertiesChanged(R,C){const b=this._extHostDocumentsAndEditors.getEditor(R);if(!b)throw new Error("unknown text editor");if(C.options&&b._acceptOptions(C.options),C.selections){const f=C.selections.selections.map(S.Selection.to);b._acceptSelections(f)}if(C.visibleRanges){const f=k.coalesce(C.visibleRanges.map(S.Range.to));b._acceptVisibleRanges(f)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:b.value,options:Object.assign(Object.assign({},C.options),{lineNumbers:S.TextEditorLineNumbersStyle.to(C.options.lineNumbers)})}),C.selections){const f=I.TextEditorSelectionChangeKind.fromValue(C.selections.source),i=C.selections.selections.map(S.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:b.value,selections:i,kind:f})}if(C.visibleRanges){const f=k.coalesce(C.visibleRanges.map(S.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:b.value,visibleRanges:f})}}$acceptEditorPositionData(R){for(const C in R){const b=this._extHostDocumentsAndEditors.getEditor(C);if(!b)throw new Error("Unknown text editor");const f=S.ViewColumn.to(R[C]);b.value.viewColumn!==f&&(b._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:b.value,viewColumn:f}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=y});var cn=this&&this.__rest||function(ie,e){var w={};for(var k in ie)Object.prototype.hasOwnProperty.call(ie,k)&&e.indexOf(k)<0&&(w[k]=ie[k]);if(ie!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,k=Object.getOwnPropertySymbols(ie);A<k.length;A++)e.indexOf(k[A])<0&&Object.prototype.propertyIsEnumerable.call(ie,k[A])&&(w[k[A]]=ie[k[A]]);return w};define(be[205],we([0,1,2,4,5,6,7]),function(ie,e,w,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class I{constructor(R,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(A.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:b=>{var f,i;if(b&&b.$mid===11){const s=b.uri===void 0?void 0:w.URI.revive(b.uri);return(i=(f=this._itemsBySourceAndUriMap.get(b.source))===null||f===void 0?void 0:f.get(y(s)))===null||i===void 0?void 0:i.get(b.handle)}return b}})}async $getTimeline(R,C,b,f,i){const s=this._providers.get(R);return s==null?void 0:s.provideTimeline(w.URI.revive(C),b,f,i)}registerTimelineProvider(R,C,b,f){const i=new T.DisposableStore,s=this.convertTimelineItem(C.id,f,i).bind(this);let v;C.onDidChange&&(v=C.onDidChange(E=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},E),{id:C.id})),this));const h=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},C),{scheme:R,onDidChange:void 0,async provideTimeline(E,g,a,o){var t;(o==null?void 0:o.resetCache)&&(i.clear(),(t=h.get(C.id))===null||t===void 0||t.clear());const r=await C.provideTimeline(E,g,a);if(r!=null){const d=s(E,o);return Object.assign(Object.assign({},r),{source:C.id,items:r.items.map(d)})}},dispose(){var E;for(const g of h.values())(E=g.get(C.id))===null||E===void 0||E.clear();v==null||v.dispose(),i.dispose()}}))}convertTimelineItem(R,C,b){return(f,i)=>{let s;if(i==null?void 0:i.cacheResults){let v=this._itemsBySourceAndUriMap.get(R);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(R,v));const h=y(f);s=v.get(h),s===void 0&&(s=new Map,v.set(h,s))}return v=>{var h,E;const{iconPath:g}=v,a=cn(v,["iconPath"]),o=`${R}|${(h=v.id)!==null&&h!==void 0?h:v.timestamp}`;s==null||s.set(o,v);let t,r,d;return v.iconPath&&(g instanceof S.ThemeIcon?d={id:g.id}:w.URI.isUri(g)?(t=g,r=g):{light:t,dark:r}=g),Object.assign(Object.assign({},a),{id:(E=a.id)!==null&&E!==void 0?E:void 0,handle:o,source:R,command:v.command?C.toInternal(v.command,b):void 0,icon:t,iconDark:r,themeIcon:d,accessibilityInformation:v.accessibilityInformation})}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,T.toDisposable)(()=>{var b;for(const f of this._itemsBySourceAndUriMap.values())(b=f.get(R.id))===null||b===void 0||b.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=I;function y(n){return n==null?void 0:n.toString()}}),define(be[206],we([0,1,6,18,2,5]),function(ie,e,w,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(y){this._openers=new Map,this._proxy=y.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,n,R,C){if(this._openers.has(n))throw new Error(`Opener with id '${n}' already registered`);const b=C.schemes.find(f=>!S.supportedSchemes.has(f));if(b)throw new Error(`Scheme '${b}' is not supported. Only http and https are currently supported.`);return this._openers.set(n,R),this._proxy.$registerUriOpener(n,C.schemes,y,C.label),(0,w.toDisposable)(()=>{this._openers.delete(n),this._proxy.$unregisterUriOpener(n)})}async $canOpenUri(y,n,R){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener with id: ${y}`);const b=A.URI.revive(n);return C.canOpenExternalUri(b,R)}async $openUri(y,n,R){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener id: '${y}'`);return C.openExternalUri(A.URI.revive(n.resolvedUri),{sourceUri:A.URI.revive(n.sourceUri)},R)}}e.ExtHostUriOpeners=S,S.supportedSchemes=new Set([k.Schemas.http,k.Schemas.https])}),define(be[207],we([0,1,5,2,6,10,26]),function(ie,e,w,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(n){this.handles=new Set,this.handlers=new Map,this._proxy=n.getProxy(w.MainContext.MainThreadUrls)}registerUriHandler(n,R){if(this.handles.has(S.ExtensionIdentifier.toKey(n)))throw new Error(`Protocol handler already registered for extension ${n}`);const C=I.HandlePool++;return this.handles.add(S.ExtensionIdentifier.toKey(n)),this.handlers.set(C,R),this._proxy.$registerUriHandler(C,n),(0,A.toDisposable)(()=>{this.handles.delete(S.ExtensionIdentifier.toKey(n)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(n,R){const C=this.handlers.get(n);if(!C)return Promise.resolve(void 0);try{C.handleUri(k.URI.revive(R))}catch(b){(0,T.onUnexpectedError)(b)}return Promise.resolve(void 0)}async createAppUri(n){return k.URI.revive(await this._proxy.$createAppUri(n))}}e.ExtHostUrls=I,I.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(ie,e,w,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(ie,w):A?A.value=w:e.set(ie,w),w},Ue=this&&this.__classPrivateFieldGet||function(ie,e,w,k){if(w==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?k:w==="a"?k.call(ie):k?k.value:e.get(ie)};define(be[49],we([0,1,24,3,2,143,164,69,5]),function(ie,e,w,k,A,T,S,I,y){"use strict";var n,R,C,b,f,i,s,v,h,E,g,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(c,p,P,F,z,de,B){n.set(this,void 0),R.set(this,void 0),C.set(this,void 0),b.set(this,void 0),f.set(this,void 0),i.set(this,void 0),s.set(this,""),v.set(this,void 0),h.set(this,!1),E.set(this,!1),g.set(this,!1),this._onMessageEmitter=new k.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new k.Emitter),this._onDidDispose=Ue(this,a,"f").event,tt(this,n,c,"f"),tt(this,R,p,"f"),tt(this,v,P,"f"),tt(this,b,F,"f"),tt(this,f,z,"f"),tt(this,i,de,"f"),tt(this,g,t(de),"f"),tt(this,C,B,"f")}dispose(){tt(this,h,!0,"f"),Ue(this,a,"f").fire(),Ue(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return tt(this,E,!0,"f"),(0,I.asWebviewUri)(Ue(this,b,"f"),Ue(this,n,"f"),c)}get cspSource(){return Ue(this,b,"f").webviewCspSource.replace("{{uuid}}",Ue(this,n,"f"))}get html(){return this.assertNotDisposed(),Ue(this,s,"f")}set html(c){this.assertNotDisposed(),Ue(this,s,"f")!==c&&(tt(this,s,c,"f"),!Ue(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(tt(this,E,!0,"f"),Ue(this,C,"f").report("Webview vscode-resource: uris",Ue(this,i,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,R,"f").$setHtml(Ue(this,n,"f"),c))}get options(){return this.assertNotDisposed(),Ue(this,v,"f")}set options(c){this.assertNotDisposed(),Ue(this,R,"f").$setOptions(Ue(this,n,"f"),u(Ue(this,i,"f"),Ue(this,f,"f"),c)),tt(this,v,c,"f")}async postMessage(c){if(Ue(this,h,"f"))return!1;const p=r(c,{serializeBuffersForPostMessage:Ue(this,g,"f")});return Ue(this,R,"f").$postMessage(Ue(this,n,"f"),p.message,...p.buffers)}assertNotDisposed(){if(Ue(this,h,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=o,n=new WeakMap,R=new WeakMap,C=new WeakMap,b=new WeakMap,f=new WeakMap,i=new WeakMap,s=new WeakMap,v=new WeakMap,h=new WeakMap,E=new WeakMap,g=new WeakMap,a=new WeakMap;function t(D){if(!D.enableProposedApi)return!1;try{const c=(0,T.normalizeVersion)((0,T.parseVersion)(D.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=56}catch(c){return!1}}e.shouldSerializeBuffersForPostMessage=t;function r(D,c){if(c.serializeBuffersForPostMessage){const p=[],P=(z,de)=>{if(de&&de instanceof ArrayBuffer){let B=p.findIndex(W=>W.original===de);if(B===-1){const W=new Uint8Array(de),K=w.VSBuffer.wrap(W);B=p.length,p.push({original:de,vsBuffer:K})}return{$$vscode_array_buffer_reference$$:!0,index:B}}return de};return{message:JSON.stringify(D,P),buffers:p.map(z=>z.vsBuffer)}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeMessage=r;class d{constructor(c,p,P,F,z){this.initData=p,this.workspace=P,this._logService=F,this._deprecationService=z,this._webviews=new Map,this._webviewProxy=c.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(c,p,...P){const F=this.getWebview(c);if(F){const{message:z}=(0,S.deserializeWebviewMessage)(p,P);F._onMessageEmitter.fire(z)}}$onMissingCsp(c,p){this._logService.warn(`${p} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,p,P){const F=new o(c,this._webviewProxy,m(p),this.initData,this.workspace,P,this._deprecationService);return this._webviews.set(c,F),F._onDidDispose(()=>{this._webviews.delete(c)}),F}deleteWebview(c){this._webviews.delete(c)}getWebview(c){return this._webviews.get(c)}}e.ExtHostWebviews=d;function l(D){return{id:D.identifier,location:D.extensionLocation}}e.toExtensionData=l;function u(D,c,p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots||_(D,c)}}e.serializeWebviewOptions=u;function m(D){var c;return{enableCommandUris:D.enableCommandUris,enableScripts:D.enableScripts,portMapping:D.portMapping,localResourceRoots:(c=D.localResourceRoots)===null||c===void 0?void 0:c.map(p=>A.URI.from(p))}}e.reviveOptions=m;function _(D,c){return[...((c==null?void 0:c.getWorkspaceFolders())||[]).map(p=>p.uri),D.extensionLocation]}}),define(be[208],we([0,1,20,56,6,18,25,2,9,49,92,5,7]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=a(this.document.uri)+this._backupCounter++;return(0,S.joinPath)(this._storagePath,t)}updateBackup(t){var r;(r=this._backup)===null||r===void 0||r.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class i{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,d){const l=this.key(t,r.uri);if(this._documents.has(l))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const u=new f(r,d);return this._documents.set(l,u),u}delete(t,r){const d=this.key(t,r.uri);this._documents.delete(d)}key(t,r){return`${t}@@@${r}`}}var s;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(s||(s={}));class v{constructor(){this._providers=new Map}addTextProvider(t,r,d){return this.add(0,t,r,d)}addCustomProvider(t,r,d){return this.add(1,t,r,d)}get(t){return this._providers.get(t)}add(t,r,d,l){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:d,provider:l}),new b.Disposable(()=>this._providers.delete(r))}}class h{constructor(t,r,d,l,u){this._extHostDocuments=r,this._extensionStoragePaths=d,this._extHostWebview=l,this._extHostWebviewPanels=u,this._editorProviders=new v,this._documents=new i,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,d,l){const u=new A.DisposableStore;return E(d)?(u.add(this._editorProviders.addTextProvider(r,t,d)),this._proxy.$registerTextEditorProvider((0,n.toExtensionData)(t),r,l.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,n.shouldSerializeBuffersForPostMessage)(t))):(u.add(this._editorProviders.addCustomProvider(r,t,d)),this.supportEditing(d)&&u.add(d.onDidChangeCustomDocument(m=>{const _=this.getCustomDocumentEntry(r,m.document.uri);if(g(m)){const D=_.addEdit(m);this._proxy.$onDidEdit(m.document.uri,r,D,m.label)}else this._proxy.$onContentChange(m.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,n.toExtensionData)(t),r,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,n.shouldSerializeBuffersForPostMessage)(t))),b.Disposable.from(u,new b.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,d,l,u){var m;const _=this._editorProviders.get(r);if(!_)throw new Error(`No provider found for '${r}'`);if(_.type!==1)throw new Error(`Invalid provide type for '${r}'`);const D=I.URI.revive(t),c=await _.provider.openCustomDocument(D,{backupId:d,untitledDocumentData:l==null?void 0:l.buffer},u);let p;return this.supportEditing(_.provider)&&this._extensionStoragePaths&&(p=(m=this._extensionStoragePaths.workspaceValue(_.extension))!==null&&m!==void 0?m:this._extensionStoragePaths.globalValue(_.extension)),this._documents.add(r,c,p),{editable:this.supportEditing(_.provider)}}async $disposeCustomDocument(t,r){const d=this._editorProviders.get(r);if(!d)throw new Error(`No provider found for '${r}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${r}'`);const l=I.URI.revive(t),{document:u}=this.getCustomDocumentEntry(r,l);this._documents.delete(r,u),u.dispose()}async $resolveWebviewEditor(t,r,d,l,u,m){const _=this._editorProviders.get(d);if(!_)throw new Error(`No provider found for '${d}'`);const D=y.ViewColumn.to(u),c=this._extHostWebview.createNewWebview(r,l.webviewOptions,_.extension),p=this._extHostWebviewPanels.createNewWebviewPanel(r,d,l.title,D,l.panelOptions,c),P=I.URI.revive(t);switch(_.type){case 1:{const{document:F}=this.getCustomDocumentEntry(d,P);return _.provider.resolveCustomEditor(F,p,m)}case 0:{const F=this._extHostDocuments.getDocument(P);return _.provider.resolveCustomTextEditor(F,p,m)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,d){this.getCustomDocumentEntry(r,t).disposeEdits(d)}async $onMoveCustomEditor(t,r,d){const l=this._editorProviders.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const u=this._extHostWebviewPanels.getWebviewPanel(t);if(!u)throw new Error("No webview found");const m=I.URI.revive(r),_=this._extHostDocuments.getDocument(m);await l.provider.moveCustomTextEditor(_,u,w.CancellationToken.None)}async $undo(t,r,d,l){return this.getCustomDocumentEntry(r,t).undo(d,l)}async $redo(t,r,d,l){return this.getCustomDocumentEntry(r,t).redo(d,l)}async $revert(t,r,d){const l=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(l.document,d),l.disposeBackup()}async $onSave(t,r,d){const l=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(l.document,d),l.disposeBackup()}async $onSaveAs(t,r,d,l){const u=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(u.document,I.URI.revive(d),l)}async $backup(t,r,d){const l=this.getCustomDocumentEntry(r,t),m=await this.getCustomEditorProvider(r).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},d);return l.updateBackup(m),m.id}getCustomDocumentEntry(t,r){const d=this._documents.get(t,I.URI.revive(r));if(!d)throw new Error("No custom document found");return d}getCustomEditorProvider(t){const r=this._editorProviders.get(t),d=r==null?void 0:r.provider;if(!d||!this.supportEditing(d))throw new Error("Custom document is not editable");return d}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=h;function E(o){return typeof o.resolveCustomTextEditor=="function"}function g(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function a(o){const t=o.scheme===T.Schemas.file||o.scheme===T.Schemas.untitled?o.fsPath:o.toString();return(0,k.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(ie,e,w,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(ie,w):A?A.value=w:e.set(ie,w),w},Ue=this&&this.__classPrivateFieldGet||function(ie,e,w,k){if(w==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?k:w==="a"?k.call(ie):k?k.value:e.get(ie)};define(be[209],we([0,1,3,6,2,29,9,49,5,7]),function(ie,e,w,k,A,T,S,I,y,n){"use strict";var R,C,b,f,i,s,v,h,E,g,a,o,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends k.Disposable{constructor(m,_,D,c,p,P,F){super();R.set(this,void 0),C.set(this,void 0),b.set(this,void 0),f.set(this,void 0),i.set(this,void 0),s.set(this,void 0),v.set(this,void 0),h.set(this,void 0),E.set(this,!0),g.set(this,!0),a.set(this,!1),o.set(this,this._register(new w.Emitter)),this.onDidDispose=Ue(this,o,"f").event,t.set(this,this._register(new w.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,tt(this,R,m,"f"),tt(this,C,_,"f"),tt(this,b,D,"f"),tt(this,i,P,"f"),tt(this,h,p,"f"),tt(this,s,c,"f"),tt(this,f,F,"f")}dispose(){Ue(this,a,"f")||(tt(this,a,!0,"f"),Ue(this,o,"f").fire(),Ue(this,C,"f").$disposeWebview(Ue(this,R,"f")),Ue(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,f,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,b,"f")}get title(){return this.assertNotDisposed(),Ue(this,s,"f")}set title(m){this.assertNotDisposed(),Ue(this,s,"f")!==m&&(tt(this,s,m,"f"),Ue(this,C,"f").$setTitle(Ue(this,R,"f"),m))}get iconPath(){return this.assertNotDisposed(),Ue(this,v,"f")}set iconPath(m){this.assertNotDisposed(),Ue(this,v,"f")!==m&&(tt(this,v,m,"f"),Ue(this,C,"f").$setIconPath(Ue(this,R,"f"),A.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return Ue(this,i,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,h,"f")=="number"&&Ue(this,h,"f")<0))return Ue(this,h,"f")}get active(){return this.assertNotDisposed(),Ue(this,g,"f")}get visible(){return this.assertNotDisposed(),Ue(this,E,"f")}_updateViewState(m){Ue(this,a,"f")||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(tt(this,g,m.active,"f"),tt(this,E,m.visible,"f"),tt(this,h,m.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(m,_){this.assertNotDisposed(),Ue(this,C,"f").$reveal(Ue(this,R,"f"),{viewColumn:m?S.ViewColumn.from(m):void 0,preserveFocus:!!_})}assertNotDisposed(){if(Ue(this,a,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,C=new WeakMap,b=new WeakMap,f=new WeakMap,i=new WeakMap,s=new WeakMap,v=new WeakMap,h=new WeakMap,E=new WeakMap,g=new WeakMap,a=new WeakMap,o=new WeakMap,t=new WeakMap;class d{constructor(m,_,D){this.webviews=_,this.workspace=D,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=m.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(m,_,D,c,p={}){const P=typeof c=="object"?c.viewColumn:c,F={viewColumn:S.ViewColumn.from(P),preserveFocus:typeof c=="object"&&!!c.preserveFocus},z=(0,I.shouldSerializeBuffersForPostMessage)(m),de=d.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(m),de,_,{title:D,panelOptions:l(p),webviewOptions:(0,I.serializeWebviewOptions)(m,this.workspace,p),serializeBuffersForPostMessage:z},F);const B=this.webviews.createNewWebview(de,p,m);return this.createNewWebviewPanel(de,_,D,P,p,B)}$onDidChangeWebviewPanelViewStates(m){const _=Object.keys(m);_.sort((D,c)=>{const p=m[D],P=m[c];return p.active?1:P.active?-1:+p.visible-+P.visible});for(const D of _){const c=this.getWebviewPanel(D);if(!!c){const p=m[D];c._updateViewState({active:p.active,visible:p.visible,viewColumn:S.ViewColumn.to(p.position)})}}}async $onDidDisposeWebviewPanel(m){const _=this.getWebviewPanel(m);_==null||_.dispose(),this._webviewPanels.delete(m),this.webviews.deleteWebview(m)}registerWebviewPanelSerializer(m,_,D){if(this._serializers.has(_))throw new Error(`Serializer for '${_}' already registered`);return this._serializers.set(_,{serializer:D,extension:m}),this._proxy.$registerSerializer(_,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(m)}),new n.Disposable(()=>{this._serializers.delete(_),this._proxy.$unregisterSerializer(_)})}async $deserializeWebviewPanel(m,_,D,c){const p=this._serializers.get(_);if(!p)throw new Error(`No serializer found for '${_}'`);const{serializer:P,extension:F}=p,z=this.webviews.createNewWebview(m,D.webviewOptions,F),de=this.createNewWebviewPanel(m,_,D.title,c,D.panelOptions,z);await P.deserializeWebviewPanel(de,D.state)}createNewWebviewPanel(m,_,D,c,p,P){const F=new r(m,this._proxy,_,D,c,p,P);return this._webviewPanels.set(m,F),F}getWebviewPanel(m){return this._webviewPanels.get(m)}}e.ExtHostWebviewPanels=d;function l(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(ie,e,w,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(ie,w):A?A.value=w:e.set(ie,w),w},Ue=this&&this.__classPrivateFieldGet||function(ie,e,w,k){if(w==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?k:w==="a"?k.call(ie):k?k.value:e.get(ie)};define(be[210],we([0,1,3,6,49,5,7]),function(ie,e,w,k,A,T,S){"use strict";var I,y,n,R,C,b,f,i,s,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class h extends k.Disposable{constructor(a,o,t,r,d,l){super();I.set(this,void 0),y.set(this,void 0),n.set(this,void 0),R.set(this,void 0),C.set(this,!1),b.set(this,void 0),f.set(this,void 0),i.set(this,void 0),s.set(this,this._register(new w.Emitter)),this.onDidChangeVisibility=Ue(this,s,"f").event,v.set(this,this._register(new w.Emitter)),this.onDidDispose=Ue(this,v,"f").event,tt(this,n,t,"f"),tt(this,f,r,"f"),tt(this,I,a,"f"),tt(this,y,o,"f"),tt(this,R,d,"f"),tt(this,b,l,"f")}dispose(){Ue(this,C,"f")||(tt(this,C,!0,"f"),Ue(this,v,"f").fire(),Ue(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,f,"f")}set title(a){this.assertNotDisposed(),Ue(this,f,"f")!==a&&(tt(this,f,a,"f"),Ue(this,y,"f").$setWebviewViewTitle(Ue(this,I,"f"),a))}get description(){return this.assertNotDisposed(),Ue(this,i,"f")}set description(a){this.assertNotDisposed(),Ue(this,i,"f")!==a&&(tt(this,i,a,"f"),Ue(this,y,"f").$setWebviewViewDescription(Ue(this,I,"f"),a))}get visible(){return Ue(this,b,"f")}get webview(){return Ue(this,R,"f")}get viewType(){return Ue(this,n,"f")}_setVisible(a){a===Ue(this,b,"f")||Ue(this,C,"f")||(tt(this,b,a,"f"),Ue(this,s,"f").fire())}show(a){this.assertNotDisposed(),Ue(this,y,"f").$show(Ue(this,I,"f"),!!a)}assertNotDisposed(){if(Ue(this,C,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,y=new WeakMap,n=new WeakMap,R=new WeakMap,C=new WeakMap,b=new WeakMap,f=new WeakMap,i=new WeakMap,s=new WeakMap,v=new WeakMap;class E{constructor(a,o){this._extHostWebview=o,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=a.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(a,o,t,r){if(this._viewProviders.has(o))throw new Error(`View provider for '${o}' already registered`);return this._viewProviders.set(o,{provider:t,extension:a}),this._proxy.$registerWebviewViewProvider((0,A.toExtensionData)(a),o,{retainContextWhenHidden:r==null?void 0:r.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new S.Disposable(()=>{this._viewProviders.delete(o),this._proxy.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(a,o,t,r,d){const l=this._viewProviders.get(o);if(!l)throw new Error(`No view provider found for '${o}'`);const{provider:u,extension:m}=l,_=this._extHostWebview.createNewWebview(a,{},m),D=new h(a,this._proxy,o,t,_,!0);this._webviewViews.set(a,D),await u.resolveWebviewView(D,{state:r},d)}async $onDidChangeWebviewViewVisibility(a,o){this.getWebviewView(a)._setVisible(o)}async $disposeWebviewView(a){const o=this.getWebviewView(a);this._webviewViews.delete(a),o.dispose(),this._extHostWebview.deleteWebview(a)}getWebviewView(a){const o=this._webviewViews.get(a);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=E}),define(be[100],we([0,1,3,5,2,18,8,4,14]),function(ie,e,w,k,A,T,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let n=class In{constructor(C){this._onDidChangeWindowState=new w.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=In.InitialState,this._proxy=C.getProxy(k.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(b=>this.$onDidChangeWindowFocus(b))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:C}),this._onDidChangeWindowState.fire(this._state))}openUri(C,b){let f;if(typeof C=="string"){f=C;try{C=A.URI.parse(C)}catch(i){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,S.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,f,b)}async asExternalUri(C,b){if((0,S.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([T.Schemas.http,T.Schemas.https]).has(C.scheme))return Promise.reject(`Invalid scheme '${C.scheme}'`);const f=await this._proxy.$asExternalUri(C,b);return A.URI.from(f)}};n.InitialState={focused:!0},n=je([Ke(0,y.IExtHostRpcService)],n),e.ExtHostWindow=n,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(be[211],we([0,1,19,5,27,14]),function(ie,e,w,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let S=class extends w.AbstractLogger{constructor(y,n){super();this._proxy=y.getProxy(k.MainContext.MainThreadLog),this._logFile=n.logFile.toJSON(),this.setLevel(n.logLevel)}$setLevel(y){this.setLevel(y)}trace(y,...n){this.getLevel()<=w.LogLevel.Trace&&this._proxy.$log(this._logFile,w.LogLevel.Trace,Array.from(arguments))}debug(y,...n){this.getLevel()<=w.LogLevel.Debug&&this._proxy.$log(this._logFile,w.LogLevel.Debug,Array.from(arguments))}info(y,...n){this.getLevel()<=w.LogLevel.Info&&this._proxy.$log(this._logFile,w.LogLevel.Info,Array.from(arguments))}warn(y,...n){this.getLevel()<=w.LogLevel.Warning&&this._proxy.$log(this._logFile,w.LogLevel.Warning,Array.from(arguments))}error(y,...n){this.getLevel()<=w.LogLevel.Error&&this._proxy.$log(this._logFile,w.LogLevel.Error,Array.from(arguments))}critical(y,...n){this.getLevel()<=w.LogLevel.Critical&&this._proxy.$log(this._logFile,w.LogLevel.Critical,Array.from(arguments))}flush(){}};S=je([Ke(0,T.IExtHostRpcService),Ke(1,A.IExtHostInitDataService)],S),e.ExtHostLogService=S}),define(be[212],we([0,1,13,20,10,3,6,111,185,97,24]),function(ie,e,w,k,A,T,S,I,y,n,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function b(l,u){try{return JSON.stringify(l,u)}catch(m){return"null"}}function f(l,u){return JSON.stringify(l,u)}function i(l){return l?(u,m)=>m&&m.$mid===1?l.transformOutgoing(m):m:null}var s;(function(l){l[l.LocalSide=0]="LocalSide",l[l.OtherSide=1]="OtherSide"})(s=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(l){l[l.Responsive=0]="Responsive",l[l.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const h=()=>{},E=Symbol.for("rpcProtocol"),g=Symbol.for("rpcProxy");class a extends S.Disposable{constructor(u,m=null,_=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=u,this._logger=m,this._uriTransformer=_,this._uriReplacer=i(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let D=0,c=n.ProxyIdentifier.count;D<c;D++)this._locals[D]=null,this._proxies[D]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new w.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(D=>this._receiveOneMessage(D))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(u=>{this._pendingRPCReplies[u].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(u){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+a.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(u){this._unresponsiveTime=Date.now()+a.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(u){this._responsiveState!==u&&(this._responsiveState=u,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(u){return this._uriTransformer?(0,I.transformIncomingURIs)(u,this._uriTransformer):u}getProxy(u){const{nid:m,sid:_}=u;return this._proxies[m]||(this._proxies[m]=this._createProxy(m,_)),this._proxies[m]}_createProxy(u,m){let _={get:(D,c)=>(typeof c=="string"&&!D[c]&&c.charCodeAt(0)===36&&(D[c]=(...p)=>this._remoteCall(u,c,p)),c===g?m:D[c])};return new Proxy(Object.create(null),_)}set(u,m){return this._locals[u.nid]=m,m}assertRegistered(u){for(let m=0,_=u.length;m<_;m++){const D=u[m];if(!this._locals[D.nid])throw new Error(`Missing actor ${D.sid} (isMain: ${D.isMain})`)}}_receiveOneMessage(u){if(!this._isDisposed){const m=u.byteLength,_=o.read(u,0),D=_.readUInt8(),c=_.readUInt32();switch(D){case 1:case 2:{let{rpcId:p,method:P,args:F}=t.deserializeRequestJSONArgs(_);this._uriTransformer&&(F=(0,I.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(m,c,p,P,F,D===2);break}case 3:case 4:{let{rpcId:p,method:P,args:F}=t.deserializeRequestMixedArgs(_);this._uriTransformer&&(F=(0,I.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(m,c,p,P,F,D===4);break}case 5:{this._logger&&this._logger.logIncoming(m,c,0,"ack"),this._onDidReceiveAcknowledge(c);break}case 6:{this._receiveCancel(m,c);break}case 7:{this._receiveReply(m,c,void 0);break}case 9:{let p=t.deserializeReplyOKJSON(_);this._uriTransformer&&(p=(0,I.transformIncomingURIs)(p,this._uriTransformer)),this._receiveReply(m,c,p);break}case 8:{let p=t.deserializeReplyOKVSBuffer(_);this._receiveReply(m,c,p);break}case 10:{let p=t.deserializeReplyErrError(_);this._uriTransformer&&(p=(0,I.transformIncomingURIs)(p,this._uriTransformer)),this._receiveReplyErr(m,c,p);break}case 11:{this._receiveReplyErr(m,c,void 0);break}default:console.error("received unexpected message"),console.error(u)}}}_receiveRequest(u,m,_,D,c,p){this._logger&&this._logger.logIncoming(u,m,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(_)}.${D}(`,c);const P=String(m);let F,z;if(p){const B=new k.CancellationTokenSource;c.push(B.token),F=this._invokeHandler(_,D,c),z=()=>B.cancel()}else F=this._invokeHandler(_,D,c),z=h;this._cancelInvokedHandlers[P]=z;const de=t.serializeAcknowledged(m);this._logger&&this._logger.logOutgoing(de.byteLength,m,1,"ack"),this._protocol.send(de),F.then(B=>{delete this._cancelInvokedHandlers[P];const W=t.serializeReplyOK(m,B,this._uriReplacer);this._logger&&this._logger.logOutgoing(W.byteLength,m,1,"reply:",B),this._protocol.send(W)},B=>{delete this._cancelInvokedHandlers[P];const W=t.serializeReplyErr(m,B);this._logger&&this._logger.logOutgoing(W.byteLength,m,1,"replyErr:",B),this._protocol.send(W)})}_receiveCancel(u,m){this._logger&&this._logger.logIncoming(u,m,1,"receiveCancel");const _=String(m);this._cancelInvokedHandlers[_]&&this._cancelInvokedHandlers[_]()}_receiveReply(u,m,_){this._logger&&this._logger.logIncoming(u,m,0,"receiveReply:",_);const D=String(m);if(!!this._pendingRPCReplies.hasOwnProperty(D)){const c=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D],c.resolveOk(_)}}_receiveReplyErr(u,m,_){this._logger&&this._logger.logIncoming(u,m,0,"receiveReplyErr:",_);const D=String(m);if(!!this._pendingRPCReplies.hasOwnProperty(D)){const c=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D];let p;_&&(_.$isError?(p=new Error,p.name=_.name,p.message=_.message,p.stack=_.stack):p=_),c.resolveErr(p)}}_invokeHandler(u,m,_){try{return Promise.resolve(this._doInvokeHandler(u,m,_))}catch(D){return Promise.reject(D)}}_doInvokeHandler(u,m,_){const D=this._locals[u];if(!D)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(u));let c=D[m];if(typeof c!="function")throw new Error("Unknown method "+m+" on actor "+(0,n.getStringIdentifierForProxy)(u));return c.apply(D,_)}_remoteCall(u,m,_){if(this._isDisposed)return Promise.reject(A.canceled());let D=null;if(_.length>0&&k.CancellationToken.isCancellationToken(_[_.length-1])&&(D=_.pop()),D&&D.isCancellationRequested)return Promise.reject(A.canceled());const c=t.serializeRequestArguments(_,this._uriReplacer),p=++this._lastMessageId,P=String(p),F=new y.LazyPromise;D&&D.onCancellationRequested(()=>{const de=t.serializeCancel(p);this._logger&&this._logger.logOutgoing(de.byteLength,p,0,"cancel"),this._protocol.send(t.serializeCancel(p))}),this._pendingRPCReplies[P]=F,this._onWillSendRequest(p);const z=t.serializeRequest(p,u,m,c,!!D);return this._logger&&this._logger.logOutgoing(z.byteLength,p,0,`request: ${(0,n.getStringIdentifierForProxy)(u)}.${m}(`,_),this._protocol.send(z),F}}e.RPCProtocol=a,C=E,a.UNRESPONSIVE_TIME=3*1e3;class o{constructor(u,m){this._buff=u,this._offset=m}static alloc(u,m,_){let D=new o(R.VSBuffer.alloc(_+1+4),0);return D.writeUInt8(u),D.writeUInt32(m),D}static read(u,m){return new o(u,m)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(u){this._buff.writeUInt8(u,this._offset),this._offset+=1}readUInt8(){const u=this._buff.readUInt8(this._offset);return this._offset+=1,u}writeUInt32(u){this._buff.writeUInt32BE(u,this._offset),this._offset+=4}readUInt32(){const u=this._buff.readUInt32BE(this._offset);return this._offset+=4,u}static sizeShortString(u){return 1+u.byteLength}writeShortString(u){this._buff.writeUInt8(u.byteLength,this._offset),this._offset+=1,this._buff.set(u,this._offset),this._offset+=u.byteLength}readShortString(){const u=this._buff.readUInt8(this._offset);this._offset+=1;const _=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,_}static sizeLongString(u){return 4+u.byteLength}writeLongString(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readLongString(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const _=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,_}writeBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}static sizeVSBuffer(u){return 4+u.byteLength}writeVSBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readVSBuffer(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+u);return this._offset+=u,m}static sizeMixedArray(u,m){let _=0;_+=1;for(let D=0,c=u.length;D<c;D++){const p=u[D],P=m[D];switch(_+=1,P){case 1:_+=this.sizeLongString(p);break;case 2:_+=this.sizeVSBuffer(p);break;case 3:break}}return _}writeMixedArray(u,m){this._buff.writeUInt8(u.length,this._offset),this._offset+=1;for(let _=0,D=u.length;_<D;_++){const c=u[_];switch(m[_]){case 1:this.writeUInt8(1),this.writeLongString(c);break;case 2:this.writeUInt8(2),this.writeVSBuffer(c);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const u=this._buff.readUInt8(this._offset);this._offset+=1;let m=new Array(u);for(let _=0;_<u;_++)switch(this.readUInt8()){case 1:m[_]=this.readLongString();break;case 2:m[_]=this.readVSBuffer();break;case 3:m[_]=void 0;break}return m}}class t{static _arrayContainsBufferOrUndefined(u){for(let m=0,_=u.length;m<_;m++)if(u[m]instanceof R.VSBuffer||typeof u[m]=="undefined")return!0;return!1}static serializeRequestArguments(u,m){if(this._arrayContainsBufferOrUndefined(u)){let _=[],D=[];for(let c=0,p=u.length;c<p;c++){const P=u[c];P instanceof R.VSBuffer?(_[c]=P,D[c]=2):typeof P=="undefined"?(_[c]=R.VSBuffer.alloc(0),D[c]=3):(_[c]=R.VSBuffer.fromString(f(P,m)),D[c]=1)}return{type:"mixed",args:_,argsType:D}}return{type:"simple",args:f(u,m)}}static serializeRequest(u,m,_,D,c){return D.type==="mixed"?this._requestMixedArgs(u,m,_,D.args,D.argsType,c):this._requestJSONArgs(u,m,_,D.args,c)}static _requestJSONArgs(u,m,_,D,c){const p=R.VSBuffer.fromString(_),P=R.VSBuffer.fromString(D);let F=0;F+=o.sizeUInt8(),F+=o.sizeShortString(p),F+=o.sizeLongString(P);let z=o.alloc(c?2:1,u,F);return z.writeUInt8(m),z.writeShortString(p),z.writeLongString(P),z.buffer}static deserializeRequestJSONArgs(u){const m=u.readUInt8(),_=u.readShortString(),D=u.readLongString();return{rpcId:m,method:_,args:JSON.parse(D)}}static _requestMixedArgs(u,m,_,D,c,p){const P=R.VSBuffer.fromString(_);let F=0;F+=o.sizeUInt8(),F+=o.sizeShortString(P),F+=o.sizeMixedArray(D,c);let z=o.alloc(p?4:3,u,F);return z.writeUInt8(m),z.writeShortString(P),z.writeMixedArray(D,c),z.buffer}static deserializeRequestMixedArgs(u){const m=u.readUInt8(),_=u.readShortString(),D=u.readMixedArray(),c=new Array(D.length);for(let p=0,P=D.length;p<P;p++){const F=D[p];typeof F=="string"?c[p]=JSON.parse(F):c[p]=F}return{rpcId:m,method:_,args:c}}static serializeAcknowledged(u){return o.alloc(5,u,0).buffer}static serializeCancel(u){return o.alloc(6,u,0).buffer}static serializeReplyOK(u,m,_){return typeof m=="undefined"?this._serializeReplyOKEmpty(u):m instanceof R.VSBuffer?this._serializeReplyOKVSBuffer(u,m):this._serializeReplyOKJSON(u,b(m,_))}static _serializeReplyOKEmpty(u){return o.alloc(7,u,0).buffer}static _serializeReplyOKVSBuffer(u,m){let _=0;_+=o.sizeVSBuffer(m);let D=o.alloc(8,u,_);return D.writeVSBuffer(m),D.buffer}static deserializeReplyOKVSBuffer(u){return u.readVSBuffer()}static _serializeReplyOKJSON(u,m){const _=R.VSBuffer.fromString(m);let D=0;D+=o.sizeLongString(_);let c=o.alloc(9,u,D);return c.writeLongString(_),c.buffer}static deserializeReplyOKJSON(u){const m=u.readLongString();return JSON.parse(m)}static serializeReplyErr(u,m){return m?this._serializeReplyErrEror(u,m):this._serializeReplyErrEmpty(u)}static _serializeReplyErrEror(u,m){const _=R.VSBuffer.fromString(b(A.transformErrorForSerialization(m),null));let D=0;D+=o.sizeLongString(_);let c=o.alloc(10,u,D);return c.writeLongString(_),c.buffer}static deserializeReplyErrError(u){const m=u.readLongString();return JSON.parse(m)}static _serializeReplyErrEmpty(u){return o.alloc(11,u,0).buffer}}var r;(function(l){l[l.RequestJSONArgs=1]="RequestJSONArgs",l[l.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",l[l.RequestMixedArgs=3]="RequestMixedArgs",l[l.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",l[l.Acknowledged=5]="Acknowledged",l[l.Cancel=6]="Cancel",l[l.ReplyOKEmpty=7]="ReplyOKEmpty",l[l.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",l[l.ReplyOKJSON=9]="ReplyOKJSON",l[l.ReplyErrError=10]="ReplyErrError",l[l.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var d;(function(l){l[l.String=1]="String",l[l.VSBuffer=2]="VSBuffer",l[l.Undefined=3]="Undefined"})(d||(d={}))}),define(be[213],we([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const w=function(T){const S=I=>{self.removeEventListener("message",S);const y=I.data;Object.defineProperties(self,{postMessage:{value(n,R){y.postMessage(n,R)}},onmessage:{get(){return y.onmessage},set(n){y.onmessage=n}}}),y.addEventListener("message",n=>{self.dispatchEvent(new MessageEvent("message",{data:n.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",S)}.toString();class k extends EventTarget{constructor(T,S,I){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${w})('${S}'))`,n=new Blob([y],{type:"application/javascript"}),R=URL.createObjectURL(n),C=new MessageChannel,b=R,f={type:"_newWorker",id:b,port:C.port2,url:R,options:I};T(f,[C.port2]),this.postMessage=C.port1.postMessage.bind(C.port1),this.terminate=()=>{const i={type:"_terminateWorker",id:b};C.port1.postMessage(i),URL.revokeObjectURL(R),C.port1.close(),C.port2.close()},Object.defineProperties(this,{onmessage:{get(){return C.port1.onmessage},set(i){C.port1.onmessage=i}},onmessageerror:{get(){return C.port1.onmessageerror},set(i){C.port1.onmessageerror=i}}}),C.port1.addEventListener("messageerror",i=>{const s=new MessageEvent("messageerror",{data:i.data});this.dispatchEvent(s)}),C.port1.addEventListener("message",i=>{const s=new MessageEvent("message",{data:i.data});this.dispatchEvent(s)}),C.port1.start()}}e.NestedWorker=k}),define(be[214],we([0,1,4]),function(ie,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,w.createDecorator)("remoteAgentService")}),define(be[215],we([0,1,18,11,21,2,4,214]),function(ie,e,w,k,A,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let y=class{constructor(R,C){this.localUserHome=R,this.remoteAgentService=C,this.resolveOS=(async()=>{const b=await this.remoteAgentService.getEnvironment();return(b==null?void 0:b.os)||A.OS})(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(b==null?void 0:b.userHome)||R})()}async userHome(R){return(R==null?void 0:R.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(R=>R===1?k.win32:k.posix)}async fileURI(R){let C="";if(await this.resolveOS===1&&(R=R.replace(/\\/g,"/")),R[0]==="/"&&R[1]==="/"){const f=R.indexOf("/",2);f===-1?(C=R.substring(2),R="/"):(C=R.substring(2,f),R=R.substring(f)||"/")}return T.URI.from({scheme:w.Schemas.file,authority:C,path:R,query:"",fragment:""})}};y=je([Ke(1,I.IRemoteAgentService)],y),e.AbstractPathService=y}),define(be[42],we([0,1,15,28,23,38,8,4,11,10]),function(ie,e,w,k,A,T,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const R="\u27EA ",C=" characters skipped \u27EB",b=(R.length+C.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var f;(function(M){M[M.file=0]="file",M[M.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var i;(function(M){M[M.File=1]="File",M[M.Text=2]="Text"})(i=e.QueryType||(e.QueryType={}));function s(M){return!!M.preview}e.resultIsMatch=s;function v(M){return!!M.resource}e.isFileMatch=v;function h(M){return!!M.message}e.isProgressMessage=h;var E;(function(M){M[M.Normal=0]="Normal",M[M.NewSearchStarted=1]="NewSearchStarted"})(E=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(U){this.resource=U,this.results=[]}}e.FileMatch=g;class a{constructor(U,x,Q){this.ranges=x;const $=Array.isArray(x)?x:[x];if(Q&&Q.matchLines===1&&o($)){U=(0,S.getNLines)(U,Q.matchLines);let ee="",re=0,se=0;const ye=Math.floor(Q.charsPerLine/5),Ie=[];for(const xe of $){const Fe=Math.max(xe.startColumn-ye,0),ze=xe.startColumn+Q.charsPerLine;if(Fe>se+ye+b){const N=R+(Fe-se)+C;ee+=N+U.slice(Fe,ze),re+=Fe-(se+N.length)}else ee+=U.slice(se,ze);Ie.push(new r(0,xe.startColumn-re,xe.endColumn-re)),se=ze}this.preview={text:ee,matches:Array.isArray(this.ranges)?Ie:Ie[0]}}else{const ee=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber;this.preview={text:U,matches:(0,w.mapArrayOrNot)(x,re=>new t(re.startLineNumber-ee,re.startColumn,re.endLineNumber-ee,re.endColumn))}}}}e.TextSearchMatch=a;function o(M){const U=M[0].startLineNumber;for(const x of M)if(x.startLineNumber!==U||x.endLineNumber!==U)return!1;return!0}class t{constructor(U,x,Q,$){this.startLineNumber=U,this.startColumn=x,this.endLineNumber=Q,this.endColumn=$}}e.SearchRange=t;class r extends t{constructor(U,x,Q){super(U,x,U,Q)}}e.OneLineRange=r;var d;(function(M){M.Default="default",M.FileNames="fileNames",M.Type="type",M.Modified="modified",M.CountDescending="countDescending",M.CountAscending="countAscending"})(d=e.SearchSortOrder||(e.SearchSortOrder={}));function l(M,U=!0){const x=M&&M.files&&M.files.exclude,Q=U&&M&&M.search&&M.search.exclude;if(!(!x&&!Q)){if(!x||!Q)return x||Q;let $=Object.create(null);return $=A.mixin($,A.deepClone(x)),$=A.mixin($,A.deepClone(Q),!0),$}}e.getExcludes=l;function u(M,U){return M.excludePattern&&k.match(M.excludePattern,U)?!1:M.includePattern||M.usingSearchPaths?M.includePattern&&k.match(M.includePattern,U)?!0:M.usingSearchPaths?!!M.folderQueries&&M.folderQueries.some(x=>{const Q=x.folder.fsPath;if(T.isEqualOrParent(U,Q)){const $=y.relative(Q,U);return!x.includePattern||!!k.match(x.includePattern,$)}else return!1}):!1:!0}e.pathIncludedInQuery=u;var m;(function(M){M[M.unknownEncoding=1]="unknownEncoding",M[M.regexParseError=2]="regexParseError",M[M.globParseError=3]="globParseError",M[M.invalidLiteral=4]="invalidLiteral",M[M.rgProcessError=5]="rgProcessError",M[M.other=6]="other",M[M.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(U,x){super(U);this.code=x}}e.SearchError=_;function D(M){const U=M.message;if((0,n.isPromiseCanceledError)(M))return new _(U,m.canceled);try{const x=JSON.parse(U);return new _(x.message,x.code)}catch(x){return new _(U,m.other)}}e.deserializeSearchError=D;function c(M){const U={message:M.message,code:M.code};return new Error(JSON.stringify(U))}e.serializeSearchError=c;function p(M){return M.type==="error"?!0:M.type==="success"}e.isSerializedSearchComplete=p;function P(M){return M.type==="success"}e.isSerializedSearchSuccess=P;function F(M){return!!M.path}e.isSerializedFileMatch=F;function z(M,U){const x=M.searchPath?M.searchPath:M.relativePath;return(0,S.fuzzyContains)(x,U)}e.isFilePatternMatch=z;class de{constructor(U){this.path=U,this.results=[]}addMatch(U){this.results.push(U)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=de;function B(M,U){const x=Object.assign(Object.assign({},M||{}),U||{});return Object.keys(x).filter(Q=>{const $=x[Q];return typeof $=="boolean"&&$})}e.resolvePatternsForProvider=B;class W{constructor(U,x){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},U.excludePattern||{}),x.excludePattern||{}),this._parsedExcludeExpression=k.parse(this._excludeExpression);let Q=U.includePattern;x.includePattern&&(Q?Q=Object.assign(Object.assign({},Q),x.includePattern):Q=x.includePattern),Q&&(this._parsedIncludeExpression=k.parse(Q))}includedInQuerySync(U,x,Q){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(U,x,Q)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(U,x,Q))}includedInQuery(U,x,Q){return Promise.resolve(this._parsedExcludeExpression(U,x,Q)).then(ee=>!!ee).then(ee=>ee?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(U,x,Q)).then(re=>!!re):Promise.resolve(!0)).then(ee=>ee)}hasSiblingExcludeClauses(){return K(this._excludeExpression)}}e.QueryGlobTester=W;function K(M){for(const U in M)if(typeof M[U]!="boolean")return!0;return!1}}),define(be[31],we([0,1,15,13,20,3,22,18,78,25,8,12,2,136,4,19,151,47,48,27,14,7,42,5]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b,f,i,s,v,h,E,g,a,o,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function d(P,F,z){return new n.ExtUri(de=>_(de,z)).isEqual(P,F)}function l(P,F,z){return d(P.uri,F.uri,z)?0:(0,R.compare)(P.uri.toString(),F.uri.toString())}function u(P,F,z){return P.index!==F.index?P.index<F.index?-1:1:d(P.uri,F.uri,z)?(0,R.compare)(P.name,F.name):(0,R.compare)(P.uri.toString(),F.uri.toString())}function m(P,F,z,de){const B=P.slice(0).sort((K,M)=>z(K,M,de)),W=F.slice(0).sort((K,M)=>z(K,M,de));return(0,w.delta)(B,W,(K,M)=>z(K,M,de))}function _(P,F){const z=F.getCapabilities(P.scheme);return!(z&&z&1024)}class D extends h.Workspace{constructor(F,z,de,B,W,K){super(F,de.map(M=>new h.WorkspaceFolder(M)),B,K);this._name=z,this._isUntitled=W,this._workspaceFolders=[],this._structure=S.TernarySearchTree.forUris(K),de.forEach(M=>{this._workspaceFolders.push(M),this._structure.set(M.uri,M)})}static toExtHostWorkspace(F,z,de,B){if(!F)return{workspace:null,added:[],removed:[]};const{id:W,name:K,folders:M,configuration:U,isUntitled:x}=F,Q=[],$=z;z?M.forEach((ye,Ie)=>{const xe=b.URI.revive(ye.uri),Fe=D._findFolder(de||z,xe,B);Fe?(Fe.name=ye.name,Fe.index=ye.index,Q.push(Fe)):Q.push({uri:xe,name:ye.name,index:Ie})}):Q.push(...M.map(({uri:ye,name:Ie,index:xe})=>({uri:b.URI.revive(ye),name:Ie,index:xe}))),Q.sort((ye,Ie)=>ye.index<Ie.index?-1:1);const ee=new D(W,K,Q,U?b.URI.revive(U):null,!!x,ye=>_(ye,B)),{added:re,removed:se}=m($?$.workspaceFolders:[],ee.workspaceFolders,l,B);return{workspace:ee,added:re,removed:se}}static _findFolder(F,z,de){for(let B=0;B<F.folders.length;B++){const W=F.workspaceFolders[B];if(d(W.uri,z,de))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,z){return z&&this._structure.get(F)&&(F=(0,n.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let c=class{constructor(F,z,de,B){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidChangeWorkspaceTrustState=new T.Emitter,this.onDidChangeWorkspaceTrustState=this._onDidChangeWorkspaceTrustState.event,this._activeSearchCallbacks=[],this._workspaceTrustState=o.WorkspaceTrustState.Unspecified,this._logService=B,this._extHostFileSystemInfo=de,this._requestIdProvider=new y.Counter,this._barrier=new k.Barrier,this._proxy=F.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(r.MainContext.MainThreadMessageService);const W=z.workspace;this._confirmedWorkspace=W?new D(W.id,W.name,[],W.configuration?b.URI.revive(W.configuration):null,!!W.isUntitled,K=>_(K,de)):void 0}$initializeWorkspace(F,z){this._workspaceTrustState=z,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?b.URI.from({scheme:I.Schemas.untitled,path:(0,n.basename)((0,n.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,z,de,...B){const W=[];if(Array.isArray(B)&&B.forEach(Q=>{b.URI.isUri(Q.uri)&&!W.some($=>d($.uri,Q.uri,this._extHostFileSystemInfo))&&W.push({uri:Q.uri,name:Q.name||(0,n.basenameOrAuthority)(Q.uri)})}),this._unconfirmedWorkspace||[z,de].some(Q=>typeof Q!="number"||Q<0)||de===0&&W.length===0)return!1;const K=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(z+de>K.length)return!1;const M=K.slice(0);M.splice(z,de,...W.map(Q=>({uri:Q.uri,name:Q.name||(0,n.basenameOrAuthority)(Q.uri),index:void 0})));for(let Q=0;Q<M.length;Q++){const $=M[Q];if(M.some((ee,re)=>re!==Q&&d($.uri,ee.uri,this._extHostFileSystemInfo)))return!1}M.forEach((Q,$)=>Q.index=$);const{added:U,removed:x}=m(K,M,u,this._extHostFileSystemInfo);if(U.length===0&&x.length===0)return!1;if(this._proxy){const Q=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(Q,z,de,W).then(void 0,$=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(v.Severity.Error,(0,f.localize)(0,null,Q,$.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(M),!0}getWorkspaceFolder(F,z){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,z)}async getWorkspaceFolder2(F,z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,z)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!!this._actualWorkspace){const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}}getRelativePath(F,z){let de,B="";if(typeof F=="string"?(de=b.URI.file(F),B=F):typeof F!="undefined"&&(de=F,B=F.fsPath),!de)return B;const W=this.getWorkspaceFolder(de,!0);if(!W)return B;typeof z=="undefined"&&this._actualWorkspace&&(z=this._actualWorkspace.folders.length>1);let K=(0,n.relativePath)(W.uri,de);return z&&W.name&&(K=`${W.name}/${K}`),K}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=D.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:z,added:de,removed:B}=D.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=z||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:de,removed:B}))}findFiles(F,z,de,B,W=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let K;if(z===null?K=!1:z&&(typeof z=="string"?K=z:K=z.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:M,folder:U}=p(F);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(M),(0,C.withUndefinedAsNull)(U),(0,C.withUndefinedAsNull)(K),(0,C.withUndefinedAsNull)(de),W).then(x=>Array.isArray(x)?x.map(Q=>b.URI.revive(Q)):[])}async findTextInFiles(F,z,de,B,W=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const K=this._requestIdProvider.getNext(),M=typeof z.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:U,folder:x}=p(z.include),Q=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,$={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:M,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:U,excludePattern:Q},ee=!1;if(this._activeSearchCallbacks[K]=re=>{if(!ee){const se=b.URI.revive(re.resource);re.results.forEach(ye=>{(0,t.resultIsMatch)(ye)?de({uri:se,preview:{text:ye.preview.text,matches:(0,w.mapArrayOrNot)(ye.preview.matches,Ie=>new o.Range(Ie.startLineNumber,Ie.startColumn,Ie.endLineNumber,Ie.endColumn))},ranges:(0,w.mapArrayOrNot)(ye.ranges,Ie=>new o.Range(Ie.startLineNumber,Ie.startColumn,Ie.endLineNumber,Ie.endColumn))}):de({uri:se,text:ye.text,lineNumber:ye.lineNumber})})}},W.isCancellationRequested)return{};try{const re=await this._proxy.$startTextSearch(F,(0,C.withUndefinedAsNull)(x),$,K,W);return delete this._activeSearchCallbacks[K],re||{}}catch(re){throw delete this._activeSearchCallbacks[K],re}}$handleTextSearchResult(F,z){this._activeSearchCallbacks[z]&&this._activeSearchCallbacks[z](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trustState(){return this._workspaceTrustState}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidChangeWorkspaceTrustState(F){this._workspaceTrustState=F.currentTrustState,this._onDidChangeWorkspaceTrustState.fire(Object.freeze({newTrustState:F.currentTrustState}))}};c=je([Ke(0,a.IExtHostRpcService),Ke(1,g.IExtHostInitDataService),Ke(2,E.IExtHostFileSystemInfo),Ke(3,s.ILogService)],c),e.ExtHostWorkspace=c,e.IExtHostWorkspace=(0,i.createDecorator)("IExtHostWorkspace");function p(P){let F,z;return P&&(typeof P=="string"?F=P:(F=P.pattern,z=P.baseFolder||b.URI.file(P.base))),{includePattern:F,folder:z}}}),define(be[35],we([0,1,23,3,31,5,7,153,66,12,13,4,14,19,2]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function s(r,d){if(d){const l=d.split(".");let u=r;for(let m=0;u&&m<l.length;m++)u=u[l[m]];return u}}function v(r){return r instanceof i.URI}function h(r){return r&&r.uri instanceof i.URI&&r.languageId&&typeof r.languageId=="string"}function E(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function g(r){return r&&r.uri instanceof i.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function a(r){if(v(r))return{resource:r};if(h(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(E(r))return{overrideIdentifier:r.languageId};if(g(r))return{resource:r.uri};if(r===null)return{resource:null}}let o=class{constructor(d,l,u){this._proxy=d.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=l,this._logService=u,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(d=>this._actual)}$initializeConfiguration(d){this._actual=new t(this._proxy,this._extHostWorkspace,d,this._logService),this._barrier.open()}$acceptConfigurationChanged(d,l){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(d,l))}};o=je([Ke(0,b.IExtHostRpcService),Ke(1,A.IExtHostWorkspace),Ke(2,f.ILogService)],o),e.ExtHostConfiguration=o;class t{constructor(d,l,u,m){this._onDidChangeConfiguration=new k.Emitter,this._proxy=d,this._logService=m,this._extHostWorkspace=l,this._configuration=I.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(d,l){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(d),this._configurationScopes=this._toMap(d.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(l,u))}getConfiguration(d,l,u){const m=a(l)||{},_=this._toReadonlyValue(d?s(this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace),d):this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace));d&&this._validateConfigurationAccess(d,m,u==null?void 0:u.identifier);function D(p){if(p==null)return null;if(typeof p=="boolean")return p?1:4;switch(p){case S.ConfigurationTarget.Global:return 1;case S.ConfigurationTarget.Workspace:return 4;case S.ConfigurationTarget.WorkspaceFolder:return 5}}const c={has(p){return typeof s(_,p)!="undefined"},get:(p,P)=>{this._validateConfigurationAccess(d?`${d}.${p}`:p,m,u==null?void 0:u.identifier);let F=s(_,p);if(typeof F=="undefined")F=P;else{let z;const de=(B,W)=>{let K;const M=()=>{z=z||(0,w.deepClone)(_),K=K||s(z,W)};return(0,n.isObject)(B)?new Proxy(B,{get:(U,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return M(),()=>K;if(z)return K=K||s(z,W),K[x];const Q=U[x];return typeof x=="string"?de(Q,`${W}.${x}`):Q},set:(U,x,Q)=>(M(),K&&(K[x]=Q),!0),deleteProperty:(U,x)=>(M(),K&&delete K[x],!0),defineProperty:(U,x,Q)=>(M(),K&&Object.defineProperty(K,x,Q),!0)}):B};F=de(F,p)}return F},update:(p,P,F,z)=>{p=d?`${d}.${p}`:p;const de=D(F);return P!==void 0?this._proxy.$updateConfigurationOption(de,p,P,m,z):this._proxy.$removeConfigurationOption(de,p,m,z)},inspect:p=>{var P,F,z,de,B,W,K,M;p=d?`${d}.${p}`:p;const U=(0,w.deepClone)(this._configuration.inspect(p,m,this._extHostWorkspace.workspace));if(U)return{key:p,defaultValue:(P=U.default)===null||P===void 0?void 0:P.value,globalValue:(F=U.user)===null||F===void 0?void 0:F.value,workspaceValue:(z=U.workspace)===null||z===void 0?void 0:z.value,workspaceFolderValue:(de=U.workspaceFolder)===null||de===void 0?void 0:de.value,defaultLanguageValue:(B=U.default)===null||B===void 0?void 0:B.override,globalLanguageValue:(W=U.user)===null||W===void 0?void 0:W.override,workspaceLanguageValue:(K=U.workspace)===null||K===void 0?void 0:K.override,workspaceFolderLanguageValue:(M=U.workspaceFolder)===null||M===void 0?void 0:M.override,languageIds:U.overrideIdentifiers}}};return typeof _=="object"&&(0,w.mixin)(c,_,!1),Object.freeze(c)}_toReadonlyValue(d){const l=u=>(0,n.isObject)(u)?new Proxy(u,{get:(m,_)=>l(m[_]),set:(m,_,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(_)}' of object`)},deleteProperty:(m,_)=>{throw new Error(`TypeError: Cannot delete read only property '${String(_)}' of object`)},defineProperty:(m,_)=>{throw new Error(`TypeError: Cannot define property '${String(_)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return l(d)}_validateConfigurationAccess(d,l,u){const m=y.OVERRIDE_PROPERTY_PATTERN.test(d)?4:this._configurationScopes.get(d),_=u?`[${u.value}] `:"";if(m===4){typeof(l==null?void 0:l.resource)=="undefined"&&this._logService.warn(`${_}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){(l==null?void 0:l.resource)&&this._logService.warn(`${_}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(d,l){const u=new I.ConfigurationChangeEvent(d,l,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(m,_)=>u.affectsConfiguration(m,a(_))})}_toMap(d){return d.reduce((l,u)=>(l.set(u[0],u[1]),l),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(ie,e,w,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(ie,w):A?A.value=w:e.set(ie,w),w},Ue=this&&this.__classPrivateFieldGet||function(ie,e,w,k){if(w==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?k:w==="a"?k.call(ie):k?k.value:e.get(ie)};define(be[101],we([0,1,2,13,3,5,7,31,40,35,20,41,14,27,4,18,21,19,72,170,10]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b,f,i,s,v,h,E,g,a){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(B){function W(M){if(M!=null)return M}B.from=W;function K(M){if(M!=null)return M}B.to=K})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var r;(function(B){function W(M){if(M!=null)return M}B.from=W;function K(M){if(M!=null)return M}B.to=K})(r=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var d;(function(B){function W(M){if(M!=null)return M}B.from=W;function K(M){if(M!=null)return M}B.to=K})(d=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var l;(function(B){function W(U){if(U){const x=U;return x&&!!x.process}else return!1}B.is=W;function K(U){if(U!=null){const x={process:U.process,args:U.args};return U.options&&(x.options=d.from(U.options)),x}}B.from=K;function M(U){if(U!=null)return new S.ProcessExecution(U.process,U.args,U.options)}B.to=M})(l=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function(B){function W(M){if(M!=null)return M}B.from=W;function K(M){if(M!=null)return M}B.to=K})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var m;(function(B){function W(U){if(U){const x=U;return x&&(!!x.commandLine||!!x.command)}else return!1}B.is=W;function K(U){if(U!=null){const x={};return U.commandLine!==void 0?x.commandLine=U.commandLine:(x.command=U.command,x.args=U.args),U.options&&(x.options=u.from(U.options)),x}}B.from=K;function M(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new S.ShellExecution(U.commandLine,U.options):new S.ShellExecution(U.command,U.args?U.args:[],U.options)}B.to=M})(m=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var _;(function(B){function W(U){if(U){let x=U;return x&&x.customExecution==="customExecution"}else return!1}B.is=W;function K(U){return{customExecution:"customExecution"}}B.from=K;function M(U,x){return x.get(U)}B.to=M})(_=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var D;(function(B){function W(K,M){let U;return K.scope!==void 0&&typeof K.scope!="number"?U=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===S.TaskScope.Workspace&&M&&M.workspaceFile?U=M.workspaceFile:U=g.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:U}}B.from=W})(D=e.TaskHandleDTO||(e.TaskHandleDTO={}));var c;(function(B){function W(U,x){if(U==null)return[];const Q=[];for(let $ of U){const ee=K($,x);ee&&Q.push(ee)}return Q}B.fromMany=W;function K(U,x){if(U!=null){let Q;U.execution instanceof S.ProcessExecution?Q=l.from(U.execution):U.execution instanceof S.ShellExecution?Q=m.from(U.execution):U.execution&&U.execution instanceof S.CustomExecution&&(Q=_.from(U.execution));const $=t.from(U.definition);let ee;if(U.scope?typeof U.scope=="number"?ee=U.scope:ee=U.scope.uri:ee=S.TaskScope.Workspace,!(!$||!ee)){const re=U.group?U.group.id:void 0;return{_id:U._id,definition:$,name:U.name,source:{extensionId:x.identifier.value,label:U.source,scope:ee},execution:Q,isBackground:U.isBackground,group:re,presentationOptions:r.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}}}B.from=K;async function M(U,x,Q){if(U!=null){let $;l.is(U.execution)?$=l.to(U.execution):m.is(U.execution)?$=m.to(U.execution):_.is(U.execution)&&($=_.to(U._id,Q));const ee=t.to(U.definition);let re;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?re=U.source.scope:re=await x.resolveWorkspaceFolder(w.URI.revive(U.source.scope)):re=S.TaskScope.Workspace),!(!ee||!re)){const se=new S.Task(ee,re,U.name,U.source.label,$,U.problemMatchers);return U.isBackground!==void 0&&(se.isBackground=U.isBackground),U.group!==void 0&&(se.group=S.TaskGroup.from(U.group)),U.presentationOptions&&(se.presentationOptions=r.to(U.presentationOptions)),U._id&&(se._id=U._id),U.detail&&(se.detail=U.detail),se}}}B.to=M})(c=e.TaskDTO||(e.TaskDTO={}));var p;(function(B){function W(M){return M}B.from=W;function K(M){if(!!M)return Object.assign(Object.create(null),M)}B.to=K})(p=e.TaskFilterDTO||(e.TaskFilterDTO={}));class P{constructor(W,K,M){this._id=K,this._task=M,o.set(this,void 0),tt(this,o,W,"f")}get task(){return this._task}terminate(){Ue(this,o,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}o=new WeakMap;var F;(function(B){function W(K){return{id:K._id,task:void 0}}B.from=W})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let z=class{constructor(W,K,M,U,x,Q,$,ee){this._onDidExecuteTask=new A.Emitter,this._onDidTerminateTask=new A.Emitter,this._onDidTaskProcessStarted=new A.Emitter,this._onDidTaskProcessEnded=new A.Emitter,this._proxy=W.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=M,this._editorService=U,this._configurationService=x,this._terminalService=Q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=$,this._deprecationService=ee,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,K,M){if(!M)return new S.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:K,provider:M,extension:W}),this._proxy.$registerTaskProvider(U,K),new S.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(W,K){this._proxy.$registerTaskSystem(W,K)}fetchTasks(W){return this._proxy.$fetchTasks(p.from(W)).then(async K=>{const M=[];for(let U of K){const x=await c.to(U,this._workspaceProvider,this._providedCustomExecutions2);x&&M.push(x)}return M})}get taskExecutions(){const W=[];return this._taskExecutions.forEach(K=>W.push(K)),W}terminateTask(W){if(!(W instanceof P))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,K,M){const U=this._providedCustomExecutions2.get(W.id);if(U){if(this._activeCustomExecutions2.get(W.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(W.id,U),this._terminalService.attachPtyToTerminal(K,await U.callback(M))}this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){const K=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const K=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:K,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const K=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:W.exitCode})}$provideTasks(W,K){const M=this._handlers.get(W);if(!M)return Promise.reject(new Error("no handler found"));const U=[],x=(0,k.asPromise)(()=>M.provider.provideTasks(R.CancellationToken.None)).then(Q=>this.provideTasksInternal(K,U,M,Q));return new Promise(Q=>{x.then($=>{Promise.all(U).then(()=>{Q($)})})})}async $resolveTask(W,K){const M=this._handlers.get(W);if(!M)return Promise.reject(new Error("no handler found"));if(K.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${M.type}].`);const U=await c.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const x=await M.provider.resolveTask(U,R.CancellationToken.None);if(!!x){this.checkDeprecation(x,M);const Q=c.from(x,M.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return _.is(Q.execution)&&await this.addCustomExecution(Q,x,!0),await this.resolveTaskInternal(Q)}}nextHandle(){return this._handleCounter++}async addCustomExecution(W,K,M){const U=await this._proxy.$createTaskId(W);!M&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,K.execution)}async getTaskExecution(W,K){if(typeof W=="string"){const x=this._taskExecutionPromises.get(W);if(!x)throw new Error("Unexpected: The specified task is missing an execution");return x}let M=this._taskExecutionPromises.get(W.id);if(M)return M;const U=new Promise(async(x,Q)=>{const $=K||await c.to(W.task,this._workspaceProvider,this._providedCustomExecutions2);$?x(new P(this,W.id,$)):Q("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(W.id,U),U.then(x=>(this._taskExecutions.set(W.id,x),x),x=>Promise.reject(x))}checkDeprecation(W,K){W._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));let M=this._notProvidedCustomExecutions.values(),U=M.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=M.next()}};z=je([Ke(0,b.IExtHostRpcService),Ke(1,f.IExtHostInitDataService),Ke(2,I.IExtHostWorkspace),Ke(3,y.IExtHostDocumentsAndEditors),Ke(4,n.IExtHostConfiguration),Ke(5,C.IExtHostTerminalService),Ke(6,h.ILogService),Ke(7,E.IExtHostApiDeprecationService)],z),e.ExtHostTaskBase=z;let de=class extends z{constructor(W,K,M,U,x,Q,$,ee){super(W,K,M,U,x,Q,$,ee);this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(W,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const M=c.from(K,W);if(M===void 0)throw new Error("Task is not valid");if(_.is(M.execution))await this.addCustomExecution(M,K,!1);else throw new a.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(M),K);return this._proxy.$executeTask(M).catch(x=>{throw new Error(x)}),U}provideTasksInternal(W,K,M,U){const x=[];if(U)for(let Q of U){this.checkDeprecation(Q,M),(!Q.definition||!W[Q.definition.type])&&this._logService.warn(`The task [${Q.source}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`);const $=c.from(Q,M.extension);$&&_.is($.execution)?(x.push($),K.push(this.addCustomExecution($,Q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:M.extension}}async resolveTaskInternal(W){if(_.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,K){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(W,K,M){}};de=je([Ke(0,b.IExtHostRpcService),Ke(1,f.IExtHostInitDataService),Ke(2,I.IExtHostWorkspace),Ke(3,y.IExtHostDocumentsAndEditors),Ke(4,n.IExtHostConfiguration),Ke(5,C.IExtHostTerminalService),Ke(6,h.ILogService),Ke(7,E.IExtHostApiDeprecationService)],de),e.WorkerExtHostTask=de,e.IExtHostTask=(0,i.createDecorator)("IExtHostTask")});var cn=this&&this.__rest||function(ie,e){var w={};for(var k in ie)Object.prototype.hasOwnProperty.call(ie,k)&&e.indexOf(k)<0&&(w[k]=ie[k]);if(ie!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,k=Object.getOwnPropertySymbols(ie);A<k.length;A++)e.indexOf(k[A])<0&&Object.prototype.propertyIsEnumerable.call(ie,k[A])&&(w[k[A]]=ie[k[A]]);return w};define(be[216],we([0,1,15,13,20,3,52,6,23,12,2,29,5,40,14,9,7,31,181,95]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b,f,i,s,v,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const a=(D,c)=>`${D}:${c.toString()}`;let o=class{constructor(c,p,P){this.documents=p,this.workspace=P,this.resultsChangedEmitter=new T.Emitter,this.providers=new Map,this.ownedTests=new E.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=c.getProxy(b.MainContext.MainThreadTesting),this.workspaceObservers=new m(this.proxy),this.textDocumentObservers=new _(this.proxy,p)}registerTestProvider(c){const p=(0,C.generateUuid)();this.providers.set(p,c),this.proxy.$registerTestProvider(p);const P=[...this.testSubscriptions.keys()];return setTimeout(()=>{var F;for(const z of P)(F=this.testSubscriptions.get(z))===null||F===void 0||F.subscribeFn(p,c)},0),new v.Disposable(()=>{this.providers.delete(p),this.proxy.$unregisterTestProvider(p)})}createTextDocumentTestObserver(c){return this.textDocumentObservers.checkout(c.uri)}createWorkspaceTestObserver(c){return this.workspaceObservers.checkout(c.uri)}async runTests(c,p=A.CancellationToken.None){const P=F=>F.map(this.getInternalTestForReference,this).filter(n.isDefined).map(z=>({src:z.src,testId:z.item.extId}));await this.proxy.$runTests({exclude:c.exclude?P(c.exclude).map(F=>F.testId):void 0,tests:P(c.tests),debug:c.debug},p)}publishExtensionProvidedResults(c,p){this.proxy.$publishExtensionProvidedResults(s.TestResults.from((0,C.generateUuid)(),c),p)}$publishTestResults(c){this.results=Object.freeze(c.map(p=>(0,y.deepFreeze)(s.TestResults.to(p))).concat(this.results).sort((p,P)=>P.completedAt-p.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(c,p){const P=R.URI.revive(p),F=a(c,P);if(!this.testSubscriptions.has(F)){const z=new A.CancellationTokenSource;let de;if(c===1){let M=this.documents.getDocument(P);if(!M){const U=new I.DisposableStore;M=await new Promise(x=>{U.add((0,k.disposableTimeout)(()=>x(void 0),5e3)),U.add(this.documents.onDidAddDocuments(Q=>{const $=Q.find(ee=>ee.document.uri.toString()===P.toString());$&&x($)}))}).finally(()=>U.dispose())}if(M){const U=await this.workspace.getWorkspaceFolder2(P,!1);de=x=>x.provideDocumentTestRoot?x.provideDocumentTestRoot(M.document,z.token):(0,e.createDefaultDocumentTestRoot)(x,M.document,U,z.token)}}else{const M=await this.workspace.getWorkspaceFolder2(P,!1);M&&(de=U=>U.provideWorkspaceTestRoot(M,z.token))}if(!!de){const B=async(M,U)=>{try{const x=await de(U);x&&K.addRoot(x,M)}catch(x){console.error(x)}},W=new I.DisposableStore,K=W.add(this.ownedTests.createForHierarchy(M=>this.proxy.$publishDiff(c,p,M)));W.add((0,I.toDisposable)(()=>z.dispose(!0)));for(const[M,U]of this.providers)B(M,U);K.pushDiff([3,-1]),this.testSubscriptions.set(F,{store:W,collection:K,subscribeFn:B})}}}async $expandTest(c,p){const P=(0,w.mapFind)(this.testSubscriptions.values(),F=>F.collection.treeId===c.src.tree?F:void 0);await(P==null?void 0:P.collection.expand(c.testId,p<0?Infinity:p)),this.flushCollectionDiffs()}$unsubscribeFromTests(c,p){var P;const F=R.URI.revive(p),z=a(c,F);(P=this.testSubscriptions.get(z))===null||P===void 0||P.store.dispose(),this.testSubscriptions.delete(z)}$acceptDiff(c,p,P){c===1?this.textDocumentObservers.acceptDiff(R.URI.revive(p),P):this.workspaceObservers.acceptDiff(R.URI.revive(p),P)}async $runTestsForProvider(c,p){const P=this.providers.get(c.tests[0].src.provider);if(!!P){const F=c.tests.map(({testId:B,src:W})=>this.ownedTests.getTestById(B,W.tree)).filter(n.isDefined).map(([B,W])=>W),z=c.excludeExtIds.map(B=>this.ownedTests.getTestById(B)).filter(n.isDefined).filter(([B,W])=>F.some(K=>B.comparePositions(K,W)===1));if(!!F.length){const de=B=>{for(const[W,K]of z){const M=W.comparePositions(K,B.id);if(M===1||M===3)return!0}return!1};try{await P.runTests({appendOutput(){},appendMessage:(B,W)=>{de(B)||(this.flushCollectionDiffs(),this.proxy.$appendTestMessageInRun(c.runId,B.id,s.TestMessage.from(W)))},setState:(B,W,K)=>{de(B)||(this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(c.runId,B.id,W,K))},tests:F.map(B=>r.unwrap(B.actual)),exclude:z.map(([,B])=>r.unwrap(B.actual)),debug:c.debug},p);for(const{collection:B}of this.testSubscriptions.values())B.flushDiff();return}catch(B){throw console.error(B),B}}}}$lookupTest(c){const p=this.ownedTests.getTestById(c.testId);if(!p)return Promise.resolve(void 0);const P=p[1],{actual:F,discoverCts:z,expandLevels:de}=P,B=cn(P,["actual","discoverCts","expandLevels"]);return Promise.resolve(B)}flushCollectionDiffs(){for(const{collection:c}of this.testSubscriptions.values())c.flushDiff()}getInternalTestForReference(c){var p,P;return(P=(p=this.workspaceObservers.getMirroredTestDataByReference(c))!==null&&p!==void 0?p:(0,w.mapFind)(this.testSubscriptions.values(),F=>F.collection.getTestByReference(c)))!==null&&P!==void 0?P:this.textDocumentObservers.getMirroredTestDataByReference(c)}};o=je([Ke(0,i.IExtHostRpcService),Ke(1,f.IExtHostDocumentsAndEditors),Ke(2,h.IExtHostWorkspace)],o),e.ExtHostTesting=o;const t=async(D,c,p,P)=>{if(!!p){const F=await D.provideWorkspaceTestRoot(p,P);if(!!F)return P.onCancellationRequested(()=>{r.removeFilter(c)}),r.getWrapperForTestItem(F,c)}};e.createDefaultDocumentTestRoot=t;class r extends v.TestItem{constructor(c,p,P){super(c.id,c.label,c.uri,c.expandable);if(this.actual=c,this.filterDocument=p,this.parent=P,!(c instanceof v.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${c.id} did not`);c[v.TestItemHookProperty]={setProp:(F,z)=>this[F]=z,created:F=>r.getWrapperForTestItem(F,this.filterDocument,this).refreshMatch(),invalidate:()=>this.invalidate(),delete:F=>this.children.delete(F)}}static removeFilter(c){this.wrapperMap.delete(c)}static getWrapperForTestItem(c,p,P){let F=this.wrapperMap.get(p);if(F==null?void 0:F.has(c))return F.get(c);F||(F=new WeakMap,this.wrapperMap.set(p,F));const z=new r(c,p,P);return F.set(c,z),z}static unwrap(c){return c instanceof r?c.actual:c}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var c;const p=this._cachedMatchesFilter;for(const F of this.actual.children){const z=r.getWrapperForTestItem(F,this.filterDocument,this);z.hasNodeMatchingFilter?this.children.add(z):this.children.delete(z)}const P=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=P,P!==p&&((c=this.parent)===null||c===void 0||c.refreshMatch()),this._cachedMatchesFilter}}e.TestItemFilteredWrapper=r,r.wrapperMap=new WeakMap;class d extends g.IncrementalChangeCollector{constructor(c){super();this.emitter=c,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(c){this.added.add(c)}update(c){Object.assign(c.revived,s.TestItem.toPlain(c.item)),this.added.has(c)||this.updated.add(c)}remove(c){if(this.added.has(c)){this.added.delete(c);return}if(this.updated.delete(c),c.parent&&this.alreadyRemoved.has(c.parent)){this.alreadyRemoved.add(c.item.extId);return}this.removed.add(c)}getChangeEvent(){const{added:c,updated:p,removed:P}=this;return{get added(){return[...c].map(F=>F.revived)},get updated(){return[...p].map(F=>F.revived)},get removed(){return[...P].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends g.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(c){let p=[];for(const P of c){const F=this.items.get(P);F&&p.push(F.revived)}return p}getMirroredTestDataById(c){return this.items.get(c)}getMirroredTestDataByReference(c){return this.items.get(c.id)}createItem(c,p){return Object.assign(Object.assign({},c),{revived:s.TestItem.toPlain(c.item),depth:p?p.depth+1:0,children:new Set})}createChangeCollector(){return new d(this.changeEmitter)}}e.MirroredTestCollection=l;class u{constructor(){this.resources=new Map}checkout(c){var p,P;const F=c.toString(),z=(p=this.resources.get(F))!==null&&p!==void 0?p:this.createObserverData(c);return(P=z.pendingDeletion)===null||P===void 0||P.dispose(),z.observers++,{onDidChangeTest:z.tests.onDidChangeTests,onDidDiscoverInitialTests:new T.Emitter().event,get tests(){return z.tests.rootTestItems},dispose:(0,S.once)(()=>{--z.observers||(z.pendingDeletion=this.eventuallyDispose(c))})}}getMirroredTestDataByReference(c){for(const{tests:p}of this.resources.values()){const P=p.getMirroredTestDataByReference(c);if(P)return P}}eventuallyDispose(c){return(0,k.disposableTimeout)(()=>this.unlisten(c),10*1e3)}createObserverData(c){const p=new l,P=this.listen(c,z=>p.apply(z)),F={observers:0,tests:p,listener:P};return this.resources.set(c.toString(),F),F}unlisten(c){var p;const P=c.toString(),F=this.resources.get(P);F&&(F.observers=-1,(p=F.pendingDeletion)===null||p===void 0||p.dispose(),F.listener.dispose(),this.resources.delete(P))}}class m extends u{constructor(c){super();this.proxy=c,this.diffListeners=new Map}acceptDiff(c,p){var P;(P=this.diffListeners.get(c.toString()))===null||P===void 0||P(p)}listen(c,p){this.proxy.$subscribeToDiffs(0,c);const P=c.toString();return this.diffListeners.set(P,p),new v.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,c),this.diffListeners.delete(P)})}}class _ extends u{constructor(c,p){super();this.proxy=c,this.documents=p,this.diffListeners=new Map}acceptDiff(c,p){var P;(P=this.diffListeners.get(c.toString()))===null||P===void 0||P(p)}listen(c,p){if(!this.documents.getDocument(c))return new v.Disposable(()=>{});const F=c.toString();return this.diffListeners.set(F,p),this.proxy.$subscribeToDiffs(1,c),new v.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,c),this.diffListeners.delete(F)})}}}),define(be[217],we([0,1,15,50,28,58,22,18,11,25,8,12,2,114,139,89,47,173,215,42]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b,f,i,s,v,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let a=class{constructor(D,c,p,P){this.configurationService=D,this.workspaceContextService=c,this.editorGroupsService=p,this.pathService=P}text(D,c,p={}){D=this.getContentPattern(D,p);const P=this.configurationService.getValue(),F=c&&c.some(de=>!this.configurationService.getValue({resource:de}).search.useRipgrep),z=this.commonQuery(c==null?void 0:c.map(v.toWorkspaceFolder),p);return Object.assign(Object.assign({},z),{type:2,contentPattern:D,previewOptions:p.previewOptions,maxFileSize:p.maxFileSize,usePCRE2:P.search.usePCRE2||F||!1,beforeContext:p.beforeContext,afterContext:p.afterContext,userDisabledExcludesAndIgnoreFiles:p.disregardExcludeSettings&&p.disregardIgnoreFiles})}getContentPattern(D,c){const p=this.configurationService.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const P=Object.assign(Object.assign({},D),{wordSeparators:p.editor.wordSeparators});return this.isCaseSensitive(D,c)&&(P.isCaseSensitive=!0),this.isMultiline(D)&&(P.isMultiline=!0),P}file(D,c={}){const p=this.commonQuery(D,c);return Object.assign(Object.assign({},p),{type:1,filePattern:c.filePattern?c.filePattern.trim():c.filePattern,exists:c.exists,sortByScore:c.sortByScore,cacheKey:c.cacheKey})}handleIncludeExclude(D,c){return D?(D=Array.isArray(D)?D.map(l):l(D),c?this.parseSearchPaths(D):{pattern:t(...Array.isArray(D)?D:[D])}):{}}commonQuery(D=[],c={}){const p=this.handleIncludeExclude(c.includePattern,c.expandPatterns),P=this.handleIncludeExclude(c.excludePattern,c.expandPatterns),F=D.length>1,z=(p.searchPaths&&p.searchPaths.length?p.searchPaths.map(W=>this.getFolderQueryForSearchPath(W,c,P)):D.map(W=>this.getFolderQueryForRoot(W,c,P,F))).filter(W=>!!W),de={_reason:c._reason,folderQueries:z,usingSearchPaths:!!(p.searchPaths&&p.searchPaths.length),extraFileResources:c.extraFileResources,excludePattern:P.pattern,includePattern:p.pattern,onlyOpenEditors:c.onlyOpenEditors,maxResults:c.maxResults};if(c.onlyOpenEditors){const K=w.coalesce(w.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(x=>x.resource)))).filter(U=>(0,g.pathIncludedInQuery)(de,U.fsPath)),M=this.commonQueryFromFileList(K);return Object.assign(Object.assign({},de),M)}const B=c.extraFileResources&&c.extraFileResources.filter(W=>(0,g.pathIncludedInQuery)(de,W.fsPath));return de.extraFileResources=B&&B.length?B:void 0,de}commonQueryFromFileList(D){const c=[],p=new S.ResourceMap,P={};let F=!1;return D.forEach(z=>{var de,B;if(z.scheme!==I.Schemas.walkThrough)if((0,n.isAbsolutePath)(z)){const K=(B=(de=this.workspaceContextService.getWorkspaceFolder(z))===null||de===void 0?void 0:de.uri)!==null&&B!==void 0?B:z.with({path:y.dirname(z.fsPath)});let M=p.get(K);M||(F=!0,M={folder:K,includePattern:{}},c.push(M),p.set(K,M));const U=y.relative(K.fsPath,z.fsPath);(0,C.assertIsDefined)(M.includePattern)[U.replace(/\\/g,"/")]=!0}else z.fsPath&&(F=!0,P[z.fsPath]=!0)}),{folderQueries:c,includePattern:P,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(D,c){if(c.isSmartCase){if(D.isRegExp){if(R.containsUppercaseCharacter(D.pattern,!0))return!0}else if(R.containsUppercaseCharacter(D.pattern))return!0}return!!D.isCaseSensitive}isMultiline(D){return D.isMultiline||D.isRegExp&&(0,f.isMultilineRegexSource)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const c=M=>y.isAbsolute(M)||/^\.\.?([\/\\]|$)/.test(M),P=(Array.isArray(D)?D:r(D)).map(M=>{const U=this.pathService.resolvedUserHome;return U?(0,T.untildify)(M,U.scheme===I.Schemas.file?U.fsPath:U.path):M}),F=k.groupBy(P,M=>c(M)?"searchPaths":"exprSegments"),z=(F.exprSegments||[]).map(M=>R.rtrim(M,"/")).map(M=>R.rtrim(M,"\\")).map(M=>(M[0]==="."&&(M="*"+M),d(M))),de={},B=this.expandSearchPathPatterns(F.searchPaths||[]);B&&B.length&&(de.searchPaths=B);const W=w.flatten(z),K=t(...W);return K&&(de.pattern=K),de}getExcludesForFolder(D,c){return c.disregardExcludeSettings?void 0:(0,g.getExcludes)(D,!c.disregardSearchExcludeSettings)}expandSearchPathPatterns(D){if(!D||!D.length)return[];const c=w.flatten(D.map(P=>{let{pathPortion:F,globPortion:z}=o(P);z&&(z=u(z));const de=this.expandOneSearchPath(F);return w.flatten(de.map(B=>this.resolveOneSearchPathPattern(B,z)))})),p=new Map;return c.forEach(P=>{const F=P.searchPath.toString(),z=p.get(F);z?P.pattern&&(z.pattern=z.pattern||{},z.pattern[P.pattern]=!0):p.set(F,{searchPath:P.searchPath,pattern:P.pattern?t(P.pattern):void 0})}),Array.from(p.values())}expandOneSearchPath(D){if(y.isAbsolute(D)){const c=this.workspaceContextService.getWorkspace().folders;return c[0]&&c[0].uri.scheme!==I.Schemas.file?[{searchPath:c[0].uri.with({path:D})}]:[{searchPath:b.URI.file(y.normalize(D))}]}if(this.workspaceContextService.getWorkbenchState()===2){const c=this.workspaceContextService.getWorkspace().folders[0].uri;if(D=l(D),D.startsWith("../")||D===".."){const P=y.posix.resolve(c.path,D);return[{searchPath:c.with({path:P})}]}const p=u(D);return[{searchPath:c,pattern:p}]}else{if(D==="./"||D===".\\")return[];{const c=D.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(c){const p=c[1],P=this.workspaceContextService.getWorkspace().folders.filter(F=>F.name===p);if(P.length)return P.map(F=>{const z=c[2];return{searchPath:F.uri,pattern:z&&u(z)}});{const F=i.localize(0,null,p);throw new Error(F)}}}}return[]}resolveOneSearchPathPattern(D,c){const p=D.pattern&&c?`${D.pattern}/${c}`:D.pattern||c,P=[{searchPath:D.searchPath,pattern:p}];return p&&!p.endsWith("**")&&P.push({searchPath:D.searchPath,pattern:p+"/**"}),P}getFolderQueryForSearchPath(D,c,p){const P=this.getFolderQueryForRoot((0,v.toWorkspaceFolder)(D.searchPath),c,p,!1);return P?Object.assign(Object.assign({},P),{includePattern:D.pattern}):null}getFolderQueryForRoot(D,c,p,P){let F;const z=b.URI.isUri(D)?D:D.uri;if(p.searchPaths){const M=p.searchPaths.filter(U=>(0,n.isEqual)(U.searchPath,z))[0];if(M&&!M.pattern)return null;M&&(F=M.pattern)}const de=this.configurationService.getValue({resource:z}),B=this.getExcludesForFolder(de,c),W=Object.assign(Object.assign({},B||{}),F||{}),K=b.URI.isUri(D)?(0,n.basename)(D):D.name;return{folder:z,folderName:P?K:void 0,excludePattern:Object.keys(W).length>0?W:void 0,fileEncoding:de.files&&de.files.encoding,disregardIgnoreFiles:typeof c.disregardIgnoreFiles=="boolean"?c.disregardIgnoreFiles:!de.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof c.disregardGlobalIgnoreFiles=="boolean"?c.disregardGlobalIgnoreFiles:!de.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof c.ignoreSymlinks=="boolean"?c.ignoreSymlinks:!de.search.followSymlinks}}};a=je([Ke(0,s.IConfigurationService),Ke(1,v.IWorkspaceContextService),Ke(2,h.IEditorGroupsService),Ke(3,E.IPathService)],a),e.QueryBuilder=a;function o(_){const D=_.match(/[\*\{\}\(\)\[\]\?]/);if(D){const c=D.index,p=_.substr(0,c).match(/[/|\\][^/\\]*$/);if(p){let P=_.substr(0,p.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:_.substr((p.index||0)+1)}}}return{pathPortion:_}}function t(..._){return _.length?_.reduce((D,c)=>(D[c]=!0,D),Object.create(null)):void 0}function r(_){return A.splitGlobAware(_,",").map(D=>D.trim()).filter(D=>!!D.length)}function d(_){return[`**/${_}/**`,`**/${_}`].map(c=>c.replace(/\*\*\/\*\*/g,"**"))}function l(_){return _.replace(/\\/g,"/")}function u(_){return l(_).replace(/^\.\//,"").replace(/\/+$/g,"")}function m(_,D){_=w.distinct(_,P=>P.toString());const c=[],p=D.getWorkspace();return _&&_.forEach(P=>{let F;if(D.getWorkbenchState()===2)F=(0,n.relativePath)(p.folders[0].uri,P),F&&F!=="."&&(F="./"+F);else{const z=D.getWorkspaceFolder(P);if(z){const de=z.name;if(p.folders.filter(W=>W.name===de).length===1){const W=(0,n.relativePath)(z.uri,P);W===""?F=`./${z.name}`:F=`./${z.name}/${W}`}else F=P.fsPath}}F&&c.push(F)}),c}e.resolveResourcesForSearchIncludes=m}),define(be[218],we([0,1,25,2,20,10,4,217,42,47]),function(ie,e,w,k,A,T,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function C(s,v){const h=v.activationEvents;if(!h)return Promise.resolve(void 0);const E=[],g=[];for(const l of h)if(/^workspaceContains:/.test(l)){const u=l.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||s.forceUsingSearch?g.push(u):E.push(u)}if(E.length===0&&g.length===0)return Promise.resolve(void 0);let a;const o=new Promise((l,u)=>{a=l}),t=l=>a({activationEvent:l}),r=Promise.all(E.map(l=>b(s,l,t))).then(()=>{}),d=f(s,v.identifier,g,t);return Promise.all([r,d]).then(()=>{a(void 0)}),o}e.checkActivateWorkspaceContainsExtension=C;async function b(s,v,h){for(const E of s.folders)if(await s.exists(w.joinPath(k.URI.revive(E),v))){h(`workspaceContains:${v}`);return}}async function f(s,v,h,E){if(h.length===0)return Promise.resolve(void 0);const g=new A.CancellationTokenSource,a=s.checkExists(s.folders,h,g.token),o=setTimeout(async()=>{g.cancel(),E(`workspaceContainsTimeout:${h.join(",")}`)},R);let t=!1;try{t=await a}catch(r){T.isPromiseCanceledError(r)||T.onUnexpectedError(r)}g.dispose(),clearTimeout(o),t&&E(`workspaceContains:${h.join(",")}`)}function i(s,v,h,E){const g=s.get(S.IInstantiationService),a=s.get(y.ISearchService),t=g.createInstance(I.QueryBuilder).file(v.map(r=>(0,n.toWorkspaceFolder)(k.URI.revive(r))),{_reason:"checkExists",includePattern:h,exists:!0});return a.fileSearch(t,E).then(r=>!!r.limitHit,r=>T.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=i});var tt=this&&this.__classPrivateFieldSet||function(ie,e,w,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!A:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(ie,w):A?A.value=w:e.set(ie,w),w},Ue=this&&this.__classPrivateFieldGet||function(ie,e,w,k){if(w==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?k:w==="a"?k.call(ie):k?k.value:e.get(ie)};define(be[36],we([0,1,131,11,77,25,13,6,22,2,19,5,35,184,75,31,34,182,10,26,18,24,160,7,90,4,27,76,14,65,67,41,3,218,71,161]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b,f,i,s,v,h,E,g,a,o,t,r,d,l,u,m,_,D,c,p,P,F,z,de){"use strict";var B,W,K;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,l.createDecorator)("IHostUtils");let M=class Pn extends I.Disposable{constructor($,ee,re,se,ye,Ie,xe,Fe,ze,N){super();this._onDidChangeRemoteConnectionData=this._register(new P.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ee,this._extHostContext=re,this._initData=xe,this._extHostWorkspace=se,this._extHostConfiguration=ye,this._logService=Ie,this._extHostTunnelService=ze,this._extHostTerminalService=N,this._disposables=new I.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new S.Barrier,this._readyToStartExtensionHost=new S.Barrier,this._readyToRunExtensions=new S.Barrier,this._eagerExtensionsActivated=new S.Barrier,this._registry=new h.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new i.ExtHostStorage(this._extHostContext),this._secretState=new z.ExtHostSecretState(this._extHostContext),this._storagePath=Fe,this._instaService=$.createChild(new D.ServiceCollection([i.IExtHostStorage,this._storage],[z.IExtHostSecretState,this._secretState]));const G=new Set;this._initData.hostExtensions.forEach(te=>G.add(g.ExtensionIdentifier.toKey(te))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(te,ae)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(te,ae)},actualActivateExtension:async(te,ae)=>{if(G.has(g.ExtensionIdentifier.toKey(te)))return await this._mainThreadExtensionsProxy.$activateExtension(te,ae),new f.HostExtension;const me=this._registry.getExtensionDescription(te);return this._activateExtension(me,ae)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),A.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch($){E.onUnexpectedError($)}}async deactivateAll(){let $=[];try{$=this._registry.getAllExtensionDescriptions().map(ye=>ye.identifier).filter(ye=>this.isActivated(ye)).map(ye=>this._deactivate(ye))}catch(ee){}await Promise.all($)}isActivated($){return this._readyToRunExtensions.isOpen()?this._activator.isActivated($):!1}_activateByEvent($,ee){return this._activator.activateByEvent($,ee)}_activateById($,ee){return this._activator.activateById($,ee)}activateByIdWithErrors($,ee){return this._activateById($,ee).then(()=>{const re=this._activator.getActivatedExtension($);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then($=>this._registry)}getExtensionExports($){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension($).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const $=y.TernarySearchTree.forPaths(),ee=this._registry.getAllExtensionDescriptions().map(re=>{if(!!this._getEntryPoint(re))return this._hostUtils.realpath(re.extensionLocation.fsPath).then(se=>$.set(n.URI.file(se).fsPath,re))});this._extensionPathIndex=Promise.all(ee).then(()=>$)}return this._extensionPathIndex}_deactivate($){let ee=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated($))return ee;const re=this._activator.getActivatedExtension($);if(!re)return ee;try{typeof re.module.deactivate=="function"&&(ee=Promise.resolve(re.module.deactivate()).then(void 0,se=>Promise.resolve(void 0)))}catch(se){}try{(0,I.dispose)(re.subscriptions)}catch(se){}return ee}async _activateExtension($,ee){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension($.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension($.identifier),this._doActivateExtension($,ee).then(re=>{const se=re.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension($.identifier,se.codeLoadingTime,se.activateCallTime,se.activateResolvedTime,ee),this._logExtensionActivationTimes($,ee,"success",se),re},re=>{throw this._logExtensionActivationTimes($,ee,"failure"),re})}_logExtensionActivationTimes($,ee,re,se){const ye=U($,ee);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},ye),se||{}),{outcome:re}))}_doActivateExtension($,ee){const re=U($,ee);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",re);const se=this._getEntryPoint($);if(!se)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${$.identifier.value} ${JSON.stringify(ee)}`),this._logService.flush();const ye=new f.ExtensionActivationTimesBuilder(ee.startup);return Promise.all([this._loadCommonJSModule($.identifier,(0,T.joinPath)($.extensionLocation,se),ye),this._loadExtensionContext($)]).then(Ie=>(A.mark(`code/extHost/willActivateExtension/${$.identifier.value}`),Pn._callActivate(this._logService,$.identifier,Ie[0],Ie[1],ye))).then(Ie=>(A.mark(`code/extHost/didActivateExtension/${$.identifier.value}`),Ie))}_loadExtensionContext($){const ee=new t.ExtensionGlobalMemento($,this._storage),re=new t.ExtensionMemento($.identifier.value,!1,this._storage),se=new de.ExtensionSecrets($,this._secretState),ye=$.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Ie=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${$.identifier.value}`),Promise.all([ee.whenReady,re.whenReady,this._storagePath.whenReady]).then(()=>{const xe=this;let Fe;return Object.freeze({globalState:ee,workspaceState:re,secrets:se,subscriptions:[],get extensionUri(){return $.extensionLocation},get extensionPath(){return $.extensionLocation.fsPath},asAbsolutePath(ze){return k.join($.extensionLocation.fsPath,ze)},get storagePath(){var ze;return(ze=xe._storagePath.workspaceValue($))===null||ze===void 0?void 0:ze.fsPath},get globalStoragePath(){return xe._storagePath.globalValue($).fsPath},get logPath(){return k.join(xe._initData.logsLocation.fsPath,$.identifier.value)},get logUri(){return n.URI.joinPath(xe._initData.logsLocation,$.identifier.value)},get storageUri(){return xe._storagePath.workspaceValue($)},get globalStorageUri(){return xe._storagePath.globalValue($)},get extensionMode(){return ye},get extension(){return Fe===void 0&&(Fe=new x(xe,$.identifier,$,Ie)),Fe},get extensionRuntime(){return(0,v.checkProposedApiEnabled)($),xe.extensionRuntime},get environmentVariableCollection(){return xe._extHostTerminalService.getEnvironmentVariableCollection($)}})})}static _callActivate($,ee,re,se,ye){return re=re||{activate:void 0,deactivate:void 0},this._callActivateOptional($,ee,re,se,ye).then(Ie=>new f.ActivatedExtension(!1,null,ye.build(),re,Ie,se.subscriptions))}static _callActivateOptional($,ee,re,se,ye){if(typeof re.activate=="function")try{ye.activateCallStart(),$.trace(`ExtensionService#_callActivateOptional ${ee.value}`);const Ie=typeof global=="object"?global:self,xe=re.activate.apply(Ie,[se]);return ye.activateCallStop(),ye.activateResolveStart(),Promise.resolve(xe).then(Fe=>(ye.activateResolveStop(),Fe))}catch(Ie){return Promise.reject(Ie)}else return Promise.resolve(re)}_activateOneStartupFinished($,ee){this._activateById($.identifier,{startup:!1,extensionId:$.identifier,activationEvent:ee}).then(void 0,re=>{this._logService.error(re)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(A.getMarks());for(const $ of this._registry.getAllExtensionDescriptions())if($.activationEvents)for(const ee of $.activationEvents)ee==="onStartupFinished"&&this._activateOneStartupFinished($,ee)}_handleEagerExtensions(){const $=this._activateByEvent("*",!0).then(void 0,ye=>{this._logService.error(ye)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ye=>this._handleWorkspaceContainsEagerExtensions(ye.added)));const ee=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],re=this._handleWorkspaceContainsEagerExtensions(ee),se=Promise.all([$,re]).then(()=>{});return Promise.race([se,(0,S.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),se}_handleWorkspaceContainsEagerExtensions($){return $.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ee=>this._handleWorkspaceContainsEagerExtension($,ee))).then(()=>{})}async _handleWorkspaceContainsEagerExtension($,ee){if(!this.isActivated(ee.identifier)){const re=!this._initData.remote.isRemote&&!!this._initData.remote.authority,se={folders:$.map(Ie=>Ie.uri),forceUsingSearch:re,exists:Ie=>this._hostUtils.exists(Ie.fsPath),checkExists:(Ie,xe,Fe)=>this._mainThreadWorkspaceProxy.$checkExists(Ie,xe,Fe)},ye=await(0,F.checkActivateWorkspaceContainsExtension)(se,ee);if(!!ye)return this._activateById(ee.identifier,{startup:!0,extensionId:ee.identifier,activationEvent:ye.activationEvent}).then(void 0,Ie=>this._logService.error(Ie))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch($){throw console.error($),$}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:$,extensionTestsLocationURI:ee}=this._initData.environment;if(!$||!ee||ee.scheme!==a.Schemas.file)throw new Error(w.localize(0,null));const re=(0,T.originalFSPath)(ee),se=await this._loadCommonJSModule(null,ee,new f.ExtensionActivationTimesBuilder(!1));if(!se||typeof se.run!="function")throw new Error(w.localize(1,null,re));return new Promise((ye,Ie)=>{const xe=(ze,N)=>{ze?Ie(ze):ye(typeof N=="number"&&N>0?1:0)},Fe=se.run(re,xe);Fe&&Fe.then&&Fe.then(()=>{ye(0)}).catch(ze=>{Ie(ze.toString())})})}async $extensionTestsExit($){this._logService.info(`extension host terminating: test runner requested exit with code ${$}`),this._logService.info(`exiting with code ${$}`),this._logService.flush(),this._hostUtils.exit($)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver($,ee){return this._resolvers[$]=ee,(0,I.toDisposable)(()=>{delete this._resolvers[$]})}async $resolveAuthority($,ee){const re=$.indexOf("+");if(re===-1)throw new Error("Not an authority that can be resolved!");const se=$.substr(0,re);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${se}`,!1);const ye=this._resolvers[se];if(!ye)return{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${se}.`,detail:void 0}};try{A.mark(`code/extHost/willResolveAuthority/${se}`);const Ie=await ye.resolve($,{resolveAttempt:ee});A.mark(`code/extHost/didResolveAuthorityOK/${se}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(ye));const xe={authority:$,host:Ie.host,port:Ie.port,connectionToken:Ie.connectionToken},Fe={extensionHostEnv:Ie.extensionHostEnv};return{type:"ok",value:{authority:xe,options:Fe,tunnelInformation:{environmentTunnels:Ie.environmentTunnels}}}}catch(Ie){if(A.mark(`code/extHost/didResolveAuthorityError/${se}`),Ie instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:Ie._code,message:Ie._message,detail:Ie._detail}};throw Ie}}$startExtensionHost($){return this._registry.keepOnly($),this._startExtensionHost()}$activateByEvent($,ee){return ee===1?this._activateByEvent($,!1):this._readyToRunExtensions.wait().then(re=>this._activateByEvent($,!1))}async $activate($,ee){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription($)?(await this._activateById($,ee),!0):!1}async $deltaExtensions($,ee){$.forEach(se=>se.extensionLocation=n.URI.revive(se.extensionLocation));const re=await this.getExtensionPathIndex();return await Promise.all(ee.map(async se=>{const ye=this._registry.getExtensionDescription(se);if(!!ye){const Ie=await this._hostUtils.realpath(ye.extensionLocation.fsPath);re.delete(n.URI.file(Ie).fsPath)}})),await Promise.all($.map(async se=>{const ye=await this._hostUtils.realpath(se.extensionLocation.fsPath);re.set(n.URI.file(ye).fsPath,se)})),this._registry.deltaExtensions($,ee),Promise.resolve(void 0)}async $test_latency($){return $}async $test_up($){return $.byteLength}async $test_down($){let ee=o.VSBuffer.alloc($),re=Math.random()%256;for(let se=0;se<$;se++)ee.writeUInt8(re,se);return ee}async $updateRemoteConnectionData($){this._remoteConnectionData=$,this._onDidChangeRemoteConnectionData.fire()}};M=je([Ke(0,l.IInstantiationService),Ke(1,e.IHostUtils),Ke(2,_.IExtHostRpcService),Ke(3,s.IExtHostWorkspace),Ke(4,b.IExtHostConfiguration),Ke(5,R.ILogService),Ke(6,u.IExtHostInitDataService),Ke(7,m.IExtensionStoragePaths),Ke(8,c.IExtHostTunnelService),Ke(9,p.IExtHostTerminalService)],M),e.AbstractExtHostExtensionService=M;function U(Q,$){return{id:Q.identifier.value,name:Q.name,extensionVersion:Q.version,publisherDisplayName:Q.publisher,activationEvents:Q.activationEvents?Q.activationEvents.join(","):null,isBuiltin:Q.isBuiltin,reason:$.activationEvent,reasonId:$.extensionId.value}}e.IExtHostExtensionService=(0,l.createDecorator)("IExtHostExtensionService");class x{constructor($,ee,re,se){B.set(this,void 0),W.set(this,void 0),K.set(this,void 0),tt(this,B,$,"f"),tt(this,W,ee,"f"),tt(this,K,re.identifier,"f"),this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=k.normalize((0,T.originalFSPath)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=se}get isActive(){return Ue(this,B,"f").isActivated(Ue(this,K,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,B,"f").getExtensionExports(Ue(this,K,"f"))}activate(){return Ue(this,B,"f").activateByIdWithErrors(Ue(this,K,"f"),{startup:!1,extensionId:Ue(this,W,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=x,B=new WeakMap,W=new WeakMap,K=new WeakMap}),define(be[102],we([0,1,11,2,3,13,5,7,168,31,36,40,172,35,169,14,4,12,32]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b,f,i,s,v,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let g=class{constructor(m,_,D,c,p){this._workspaceService=_,this._extensionService=D,this._editorsService=c,this._configurationService=p,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new A.Emitter,this._onDidTerminateDebugSession=new A.Emitter,this._onDidChangeActiveDebugSession=new A.Emitter,this._onDidReceiveDebugSessionCustomEvent=new A.Emitter,this._debugServiceProxy=m.getProxy(S.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new A.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new o(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(P=>{P.onDidChange(F=>{this.registerAllDebugTypes(P)}),this.registerAllDebugTypes(P)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(m,_){const D=m;if(typeof D.sourceReference=="number"&&D.sourceReference>0){let c=`debug:${encodeURIComponent(D.path||"")}`,p="?";return _&&(c+=`${p}session=${encodeURIComponent(_.id)}`,p="&"),c+=`${p}ref=${D.sourceReference}`,k.URI.parse(c)}else{if(D.path)return k.URI.file(D.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(m){const _=[];for(const D of m.getAllExtensionDescriptions())if(D.contributes){const c=D.contributes.debuggers;if(c&&c.length>0)for(const p of c)(0,i.isDebuggerMainContribution)(p)&&_.push(p.type)}this._debugServiceProxy.$registerDebugTypes(_)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const m=[];return this._breakpoints.forEach(_=>m.push(_)),m}addBreakpoints(m){this.startBreakpoints();const _=m.filter(p=>{const P=p.id;return this._breakpoints.has(P)?!1:(this._breakpoints.set(P,p),!0)});this.fireBreakpointChanges(_,[],[]);const D=[],c=new Map;for(const p of _)if(p instanceof I.SourceBreakpoint){let P=c.get(p.location.uri.toString());P||(P={type:"sourceMulti",uri:p.location.uri,lines:[]},c.set(p.location.uri.toString(),P),D.push(P)),P.lines.push({id:p.id,enabled:p.enabled,condition:p.condition,hitCondition:p.hitCondition,logMessage:p.logMessage,line:p.location.range.start.line,character:p.location.range.start.character})}else p instanceof I.FunctionBreakpoint&&D.push({type:"function",id:p.id,enabled:p.enabled,hitCondition:p.hitCondition,logMessage:p.logMessage,condition:p.condition,functionName:p.functionName});return this._debugServiceProxy.$registerBreakpoints(D)}removeBreakpoints(m){this.startBreakpoints();const _=m.filter(P=>this._breakpoints.delete(P.id));this.fireBreakpointChanges([],_,[]);const D=_.filter(P=>P instanceof I.SourceBreakpoint).map(P=>P.id),c=_.filter(P=>P instanceof I.FunctionBreakpoint).map(P=>P.id),p=_.filter(P=>P instanceof I.DataBreakpoint).map(P=>P.id);return this._debugServiceProxy.$unregisterBreakpoints(D,c,p)}startDebugging(m,_,D){return this._debugServiceProxy.$startDebugging(m?m.uri:void 0,_,{parentSessionID:D.parentSession?D.parentSession.id:void 0,repl:D.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:D.noDebug,compact:D.compact})}stopDebugging(m){return this._debugServiceProxy.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,_,D){if(!_)return new I.Disposable(()=>{});const c=this._configProviderHandleCounter++;return this._configProviders.push({type:m,handle:c,provider:_}),this._debugServiceProxy.$registerDebugConfigurationProvider(m,D,!!_.provideDebugConfigurations,!!_.resolveDebugConfiguration,!!_.resolveDebugConfigurationWithSubstitutedVariables,c),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(p=>p.provider!==_),this._debugServiceProxy.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(m,_,D){if(!D)return new I.Disposable(()=>{});if(!this.definesDebugType(m,_))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${_}' debugger.`);if(this.getAdapterDescriptorFactoryByType(_))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:_,handle:c,factory:D}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(_,c),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(p=>p.factory!==D),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(m,_){if(!_)return new I.Disposable(()=>{});const D=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:m,handle:D,factory:_}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(c=>c.factory!==_)})}async $runInTerminal(m,_){return Promise.resolve(void 0)}async $substituteVariables(m,_){if(!this._variableResolver){const[p,P]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(p||[],this._editorsService,P)}let D;const c=await this.getFolder(m);return c&&(D={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(D,_)}createDebugAdapter(m,_){if(m.type==="implementation")return new d(m.implementation)}createSignService(){}async $startDASession(m,_){const D=this,c=await this.getSession(_);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(c.type),c).then(p=>{if(!p)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const P=this.convertToDto(p),F=this.createDebugAdapter(P,c);if(!F)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const z=F;return this._debugAdapters.set(m,z),this.getDebugAdapterTrackers(c).then(de=>(de&&this._debugAdaptersTrackers.set(m,de),z.onMessage(async B=>{if(B.type==="request"&&B.command==="handshake"){const W=B,K={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(W.arguments.value);K.body={signature:M},z.sendResponse(K)}else throw new Error("no signer")}catch(M){K.success=!1,K.message=M.message,z.sendResponse(K)}}else de&&de.onDidSendMessage&&de.onDidSendMessage(B),B=(0,i.convertToVSCPaths)(B,!0),D._debugServiceProxy.$acceptDAMessage(m,B)}),z.onError(B=>{de&&de.onError&&de.onError(B),this._debugServiceProxy.$acceptDAError(m,B.name,B.message,B.stack)}),z.onExit(B=>{de&&de.onExit&&de.onExit((0,h.withNullAsUndefined)(B),void 0),this._debugServiceProxy.$acceptDAExit(m,(0,h.withNullAsUndefined)(B),void 0)}),de&&de.onWillStartSession&&de.onWillStartSession(),z.startSession()))})}$sendDAMessage(m,_){_=(0,i.convertToDAPaths)(_,!1);const D=this._debugAdaptersTrackers.get(m);D&&D.onWillReceiveMessage&&D.onWillReceiveMessage(_);const c=this._debugAdapters.get(m);c&&c.sendMessage(_)}$stopDASession(m){const _=this._debugAdaptersTrackers.get(m);this._debugAdaptersTrackers.delete(m),_&&_.onWillStopSession&&_.onWillStopSession();const D=this._debugAdapters.get(m);return this._debugAdapters.delete(m),D?D.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const _=[],D=[],c=[];if(m.added)for(const p of m.added){const P=p.id;if(P&&!this._breakpoints.has(P)){let F;if(p.type==="function")F=new I.FunctionBreakpoint(p.functionName,p.enabled,p.condition,p.hitCondition,p.logMessage);else if(p.type==="data")F=new I.DataBreakpoint(p.label,p.dataId,p.canPersist,p.enabled,p.hitCondition,p.condition,p.logMessage);else{const z=k.URI.revive(p.uri);F=new I.SourceBreakpoint(new I.Location(z,new I.Position(p.line,p.character)),p.enabled,p.condition,p.hitCondition,p.logMessage)}F._id=P,this._breakpoints.set(P,F),_.push(F)}}if(m.removed)for(const p of m.removed){const P=this._breakpoints.get(p);P&&(this._breakpoints.delete(p),D.push(P))}if(m.changed){for(const p of m.changed)if(p.id){const P=this._breakpoints.get(p.id);if(P){if(P instanceof I.FunctionBreakpoint&&p.type==="function"){const F=P;F.enabled=p.enabled,F.condition=p.condition,F.hitCondition=p.hitCondition,F.logMessage=p.logMessage,F.functionName=p.functionName}else if(P instanceof I.SourceBreakpoint&&p.type==="source"){const F=P;F.enabled=p.enabled,F.condition=p.condition,F.hitCondition=p.hitCondition,F.logMessage=p.logMessage,F.location=new I.Location(k.URI.revive(p.uri),new I.Position(p.line,p.character))}c.push(P)}}}this.fireBreakpointChanges(_,D,c)}$provideDebugConfigurations(m,_,D){return(0,T.asPromise)(async()=>{const c=this.getConfigProviderByHandle(m);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const p=await this.getFolder(_);return c.provideDebugConfigurations(p,D)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(m,_,D,c){return(0,T.asPromise)(async()=>{const p=this.getConfigProviderByHandle(m);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.getFolder(_);return p.resolveDebugConfiguration(P,D,c)})}$resolveDebugConfigurationWithSubstitutedVariables(m,_,D,c){return(0,T.asPromise)(async()=>{const p=this.getConfigProviderByHandle(m);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.getFolder(_);return p.resolveDebugConfigurationWithSubstitutedVariables(P,D,c)})}async $provideDebugAdapter(m,_){const D=this.getAdapterDescriptorFactoryByHandle(m);if(!D)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.getSession(_);return this.getAdapterDescriptor(D,c).then(p=>{if(!p)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.convertToDto(p)})}async $acceptDebugSessionStarted(m){const _=await this.getSession(m);this._onDidStartDebugSession.fire(_)}async $acceptDebugSessionTerminated(m){const _=await this.getSession(m);_&&(this._onDidTerminateDebugSession.fire(_),this._debugSessions.delete(_.id))}async $acceptDebugSessionActiveChanged(m){this._activeDebugSession=m?await this.getSession(m):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(m,_){const D=await this.getSession(m);D&&D._acceptNameChanged(_)}async $acceptDebugSessionCustomEvent(m,_){const c={session:await this.getSession(m),event:_.event,body:_.body};this._onDidReceiveDebugSessionCustomEvent.fire(c)}convertToDto(m){if(m instanceof I.DebugAdapterExecutable)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof I.DebugAdapterServer)return{type:"server",port:m.port,host:m.host};if(m instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:m.path};if(m instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(m){const _=this._adapterFactories.filter(D=>D.type===m);if(_.length>0)return _[0].factory}getAdapterDescriptorFactoryByHandle(m){const _=this._adapterFactories.filter(D=>D.handle===m);if(_.length>0)return _[0].factory}getConfigProviderByHandle(m){const _=this._configProviders.filter(D=>D.handle===m);if(_.length>0)return _[0].provider}definesDebugType(m,_){if(m.contributes){const D=m.contributes.debuggers;if(D&&D.length>0){for(const c of D)if(c.label&&c.type&&c.type===_)return!0}}return!1}getDebugAdapterTrackers(m){const D=m.configuration.type,c=this._trackerFactories.filter(p=>p.type===D||p.type==="*").map(p=>(0,T.asPromise)(()=>p.factory.createDebugAdapterTracker(m)).then(P=>P,P=>null));return Promise.race([Promise.all(c).then(p=>{const P=p.filter(F=>!!F);if(P.length>0)return new r(P)}),new Promise((p,P)=>{const F=setTimeout(()=>{clearTimeout(F),P(new Error("timeout"))},1e3)})]).catch(p=>{})}async getAdapterDescriptor(m,_){const D=_.configuration.debugServer;if(typeof D=="number")return Promise.resolve(new I.DebugAdapterServer(D));if(m){const p=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>m.createDebugAdapterDescriptor(_,this.daExecutableFromPackage(_,p))).then(P=>{if(P)return P})}const c=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(_,c))}daExecutableFromPackage(m,_){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(m,_,D){(m.length>0||_.length>0||D.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:m,removed:_,changed:D}))}async getSession(m){if(m)if(typeof m=="string"){const _=this._debugSessions.get(m);if(_)return _}else{let _=this._debugSessions.get(m.id);if(!_){const D=await this.getFolder(m.folderUri);_=new a(this._debugServiceProxy,m.id,m.type,m.name,D,m.configuration),this._debugSessions.set(_.id,_),this._debugServiceProxy.$sessionCached(_.id)}return _}throw new Error("cannot find session")}getFolder(m){if(m){const _=k.URI.revive(m);return this._workspaceService.resolveWorkspaceFolder(_)}return Promise.resolve(void 0)}};g=je([Ke(0,s.IExtHostRpcService),Ke(1,n.IExtHostWorkspace),Ke(2,R.IExtHostExtensionService),Ke(3,C.IExtHostDocumentsAndEditors),Ke(4,f.IExtHostConfiguration)],g),e.ExtHostDebugServiceBase=g;class a{constructor(m,_,D,c,p,P){this._debugServiceProxy=m,this._id=_,this._type=D,this._name=c,this._workspaceFolder=p,this._configuration=P}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(m){this._name=m,this._debugServiceProxy.$setDebugSessionName(this._id,m)}_acceptNameChanged(m){this._name=m}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(m,_){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,m,_)}getDebugProtocolBreakpoint(m){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,m.id)}}e.ExtHostDebugSession=a;class o{constructor(m){this.value=Object.freeze({append(_){m.$appendDebugConsole(_)},appendLine(_){this.append(_+`
`)}})}}e.ExtHostDebugConsole=o;class t extends b.AbstractVariableResolverService{constructor(m,_,D,c){super({getFolderUri:p=>{const P=m.filter(F=>F.name===p);if(P&&P.length>0)return P[0].uri},getWorkspaceFolderCount:()=>m.length,getConfigurationValue:(p,P)=>D.getConfiguration(void 0,p).get(P),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(_){const p=_.activeEditor();if(p)return w.normalize(p.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(_&&c){const p=_.activeEditor();if(p){const P=c.getWorkspaceFolder(p.document.uri);if(P)return w.normalize(P.uri.fsPath)}}},getSelectedText:()=>{if(_){const p=_.activeEditor();if(p&&!p.selection.isEmpty)return p.document.getText(p.selection)}},getLineNumber:()=>{if(_){const p=_.activeEditor();if(p)return String(p.selection.end.line+1)}}},void 0,E.env)}}e.ExtHostVariableResolverService=t;class r{constructor(m){this.trackers=m}onWillStartSession(){this.trackers.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.trackers.forEach(_=>_.onWillReceiveMessage?_.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.trackers.forEach(_=>_.onDidSendMessage?_.onDidSendMessage(m):void 0)}onWillStopSession(){this.trackers.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.trackers.forEach(_=>_.onError?_.onError(m):void 0)}onExit(m,_){this.trackers.forEach(D=>D.onExit?D.onExit(m,_):void 0)}}class d extends y.AbstractDebugAdapter{constructor(m){super();this.implementation=m,m.onDidSendMessage(_=>{this.acceptMessage(_)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.implementation.handleMessage(m)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let l=class extends g{constructor(m,_,D,c,p){super(m,_,D,c,p)}createVariableResolver(m,_,D){return new t(m,_,D)}};l=je([Ke(0,s.IExtHostRpcService),Ke(1,n.IExtHostWorkspace),Ke(2,R.IExtHostExtensionService),Ke(3,C.IExtHostDocumentsAndEditors),Ke(4,f.IExtHostConfiguration)],l),e.WorkerExtHostDebugService=l}),define(be[219],we([0,1,77,2,5,35,34,26,14,27,4,36,32,19]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let i=class{constructor(g,a,o,t,r,d,l){this._apiFactory=g,this._extensionRegistry=a,this._instaService=o,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=d,this._logService=l,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),w.mark("code/extHost/willWaitForConfig");const g=await this._extHostConfiguration.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new s(this._apiFactory,a,this._extensionRegistry,g,this._logService)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(h,a,this._initData.environment.appUriScheme))}register(g){if(Array.isArray(g.nodeModuleName))for(let a of g.nodeModuleName)this._factories.set(a,g);else this._factories.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this._alternatives.push(a=>g.alternativeModuleName(a))}};i=je([Ke(2,R.IInstantiationService),Ke(3,T.IExtHostConfiguration),Ke(4,C.IExtHostExtensionService),Ke(5,n.IExtHostInitDataService),Ke(6,f.ILogService)],i),e.RequireInterceptor=i;class s{constructor(g,a,o,t,r){this._apiFactory=g,this._extensionPaths=a,this._extensionRegistry=o,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(g,a){const o=this._extensionPaths.findSubstr(a.fsPath);if(o){let t=this._extApiImpl.get(I.ExtensionIdentifier.toKey(o.identifier));return t||(t=this._apiFactory(o,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(o.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,d)=>t+=`	${d} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(S.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(g,a){this.nodeModuleName="keytar";const{environment:o}=a,t=g.getProxy(A.MainContext.MainThreadKeytar);if(o.appRoot){let r=o.appRoot.fsPath;b.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,d)=>t.$getPassword(r,d),setPassword:(r,d,l)=>t.$setPassword(r,d,l),deletePassword:(r,d)=>t.$deletePassword(r,d),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(g,a){return this._impl}alternativeModuleName(g){const a=g.length;if(!(a<=7||!this.alternativeNames)){const o=a-7;if((g.charAt(o)==="/"||g.charAt(o)==="\\")&&g.endsWith("keytar")&&(g=g.replace(/\\/g,"/"),this.alternativeNames.has(g)))return"keytar"}}};v=je([Ke(0,y.IExtHostRpcService),Ke(1,n.IExtHostInitDataService)],v);let h=class{constructor(g,a,o){this._extensionPaths=g,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=o.getProxy(A.MainContext.MainThreadTelemetry);const t=o.getProxy(A.MainContext.MainThreadWindow);this._impl=(r,d)=>{const l=k.URI.parse(r);return d?this.callOriginal(r,d):l.scheme==="http"||l.scheme==="https"?t.$openUri(l,r,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this._appUriScheme?t.$openUri(l,r,{}):this.callOriginal(r,d)}}load(g,a,o){const t=this._extensionPaths.findSubstr(a.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=o(g),this._impl}callOriginal(g,a){return this.sendNoForwardTelemetry(),this._original(g,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};h=je([Ke(2,y.IExtHostRpcService)],h)}),define(be[220],we([0,1,13,10,77,6,2,5,212,19,61,65,27,150,14,68,36,41]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b,f,i,s,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(a,o,t,r){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const d=new y.RPCProtocol(a,null,r);o=E._transform(o,d);const l=new C.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());l.set(b.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},o)),l.set(i.IExtHostRpcService,new i.ExtHostRpcService(d)),l.set(s.IURITransformerService,new s.URITransformerService(r)),l.set(v.IHostUtils,t);const u=new f.InstantiationService(l,!0),m=u.invokeFunction(p=>p.get(h.IExtHostTerminalService));this._disposables.add(m),this._logService=u.invokeFunction(p=>p.get(n.ILogService)),A.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",o),this._extensionService=u.invokeFunction(p=>p.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const _=new WeakMap;this._extensionService.getExtensionPathIndex().then(p=>{Error.prepareStackTrace=(P,F)=>{let z="",de,B;for(const W of F)z+=`
	at ${W.toString()}`,B=W.getFileName(),!de&&B&&(de=p.findSubstr(B));return _.set(P,de),`${P.name||"Error"}: ${P.message||""}${z}`}});const D=d.getProxy(I.MainContext.MainThreadExtensionService),c=d.getProxy(I.MainContext.MainThreadErrors);k.setUnexpectedErrorHandler(p=>{const P=k.transformErrorForSerialization(p),F=_.get(p);F?D.$onExtensionRuntimeError(F.identifier,P):c.$onUnexpectedError(P)})}terminate(a){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${a}`),this._logService.flush(),this._disposables.dispose(),k.setUnexpectedErrorHandler(t=>{});const o=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,w.timeout)(4e3),o]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(a,o){a.extensions.forEach(r=>r.extensionLocation=S.URI.revive(o.transformIncomingURIs(r.extensionLocation))),a.environment.appRoot=S.URI.revive(o.transformIncomingURIs(a.environment.appRoot));const t=a.environment.extensionDevelopmentLocationURI;return t&&(a.environment.extensionDevelopmentLocationURI=t.map(r=>S.URI.revive(o.transformIncomingURIs(r)))),a.environment.extensionTestsLocationURI=S.URI.revive(o.transformIncomingURIs(a.environment.extensionTestsLocationURI)),a.environment.globalStorageHome=S.URI.revive(o.transformIncomingURIs(a.environment.globalStorageHome)),a.environment.workspaceStorageHome=S.URI.revive(o.transformIncomingURIs(a.environment.workspaceStorageHome)),a.logsLocation=S.URI.revive(o.transformIncomingURIs(a.logsLocation)),a.logFile=S.URI.revive(o.transformIncomingURIs(a.logFile)),a.workspace=o.transformIncomingURIs(a.workspace),a}}e.ExtensionHostMain=E}),define(be[221],we([0,1,11,20,60,28,25,55,42,32]),function(ie,e,w,k,A,T,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class R{constructor(f,i,s){this.config=f,this.provider=i,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=f.filePattern,this.includePattern=f.includePattern&&T.parse(f.includePattern),this.maxResults=f.maxResults||void 0,this.exists=f.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=f.excludePattern&&T.parse(f.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(f=>f.cancel()),this.activeCancellationTokens=new Set}search(f){const i=this.config.folderQueries||[];return new Promise((s,v)=>{const h=E=>{this.resultCount++,f(E)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(E=>{const g=E.toString(),a=w.basename(g);this.globalExcludePattern&&this.globalExcludePattern(g,a)||this.matchFile(h,{base:E,basename:a})}),Promise.all(i.map(E=>this.searchInFolder(E,h))).then(E=>{s({limitHit:this.isLimitHit,stats:E[0]||void 0})},E=>{v(new Error((0,A.toErrorMessage)(E)))})})}searchInFolder(f,i){const s=new k.CancellationTokenSource;return new Promise((v,h)=>{const E=this.getSearchOptionsForFolder(f),g=this.initDirectoryTree(),a=new y.QueryGlobTester(this.config,f),o=!a.hasSiblingExcludeClauses();let t;new Promise(r=>(0,n.nextTick)(r)).then(()=>(this.activeCancellationTokens.add(s),t=I.StopWatch.create(),this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},E,s.token))).then(r=>{const d=t.elapsed(),l=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(u=>{const m=w.posix.relative(f.folder.path,u.path);if(o){const _=w.basename(u.path);this.matchFile(i,{base:f.folder,relativePath:m,basename:_});return}this.addDirectoryEntries(g,f.folder,m,i)}),this.activeCancellationTokens.delete(s),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(g,a,i),{providerTime:d,postProcessTime:l.elapsed()})}).then(r=>{s.dispose(),v(r)},r=>{s.dispose(),h(r)})})}getSearchOptionsForFolder(f){const i=(0,y.resolvePatternsForProvider)(this.config.includePattern,f.includePattern),s=(0,y.resolvePatternsForProvider)(this.config.excludePattern,f.excludePattern);return{folder:f.folder,excludes:s,includes:i,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}addDirectoryEntries({pathToEntries:f},i,s,v){if(s===this.filePattern){const E=w.basename(this.filePattern);this.matchFile(v,{base:i,relativePath:this.filePattern,basename:E})}function h(E){const g=w.basename(E),a=w.dirname(E);let o=f[a];o||(o=f[a]=[],h(a)),o.push({base:i,relativePath:E,basename:g})}h(s)}matchDirectoryTree({rootEntries:f,pathToEntries:i},s,v){const h=this,E=this.filePattern;function g(a){const o=T.hasSiblingFn(()=>a.map(t=>t.basename));for(let t=0,r=a.length;t<r;t++){const d=a[t],{relativePath:l,basename:u}=d;if(!!s.includedInQuerySync(l,u,E!==u?o:void 0)){const m=i[l];if(m)g(m);else{if(l===E)continue;h.matchFile(v,d)}if(h.isLimitHit)break}}}g(f)}matchFile(f,i){(!this.includePattern||i.relativePath&&this.includePattern(i.relativePath,i.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||f(i))}}class C{constructor(){this.sessions=new Map}fileSearch(f,i,s,v){const h=this.getSessionTokenSource(f.cacheKey),E=new R(f,i,h&&h.token);let g=0;const a=o=>{g+=o.length,s(o.map(t=>this.rawMatchToSearchItem(t)))};return this.doSearch(E,C.BATCH_SIZE,a,v).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:o.stats}}))}clearCache(f){const i=this.getSessionTokenSource(f);i&&i.cancel()}getSessionTokenSource(f){if(!!f)return this.sessions.has(f)||this.sessions.set(f,new k.CancellationTokenSource),this.sessions.get(f)}rawMatchToSearchItem(f){return f.relativePath?{resource:S.joinPath(f.base,f.relativePath)}:{resource:f.base}}doSearch(f,i,s,v){v.onCancellationRequested(()=>{f.cancel()});const h=g=>{g&&(E.push(g),i>0&&E.length>=i&&(s(E),E=[]))};let E=[];return f.search(h).then(g=>(E.length&&s(E),g),g=>(E.length&&s(E),Promise.reject(g)))}}e.FileSearchManager=C,C.BATCH_SIZE=512}),define(be[222],we([0,1,11,15,20,60,25,28,2,42,32,18]),function(ie,e,w,k,A,T,S,I,y,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class b{constructor(g,a,o){this.query=g,this.provider=a,this.fileUtils=o,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(g,a){const o=this.query.folderQueries||[],t=new A.CancellationTokenSource;return a.onCancellationRequested(()=>t.cancel()),new Promise((r,d)=>{this.collector=new i(g);let l=!1;const u=(m,_)=>{if(!l&&!this.isLimitHit){const D=this.resultSize(m);v(m)&&typeof this.query.maxResults=="number"&&this.resultCount+D>this.query.maxResults&&(this.isLimitHit=!0,l=!0,t.cancel(),m=this.trimResultToSize(m,this.query.maxResults-this.resultCount));const c=this.resultSize(m);this.resultCount+=c,(c>0||!v(m))&&this.collector.add(m,_)}};Promise.all(o.map((m,_)=>this.searchInFolder(m,D=>u(D,_),t.token))).then(m=>{t.dispose(),this.collector.flush();const _=m.some(D=>!!D&&!!D.limitHit);r({limitHit:this.isLimitHit||_,stats:{type:"textSearchProvider"}})},m=>{t.dispose();const _=(0,T.toErrorMessage)(m);d(new Error(_))})})}resultSize(g){return v(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}trimResultToSize(g,a){const o=Array.isArray(g.ranges)?g.ranges:[g.ranges],t=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:o.slice(0,a),preview:{matches:t.slice(0,a),text:g.preview.text},uri:g.uri}}searchInFolder(g,a,o){const t=new n.QueryGlobTester(this.query,g),r=[],d={report:u=>{if(!!this.validateProviderResult(u)){const m=g.folder.scheme===C.Schemas.file?I.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(u.uri))):void 0,_=S.relativePath(g.folder,u.uri);_&&r.push(t.includedInQuery(_,w.basename(_),m).then(D=>{D&&a(u)}))}}},l=this.getSearchOptionsForFolder(g);return new Promise(u=>(0,R.nextTick)(u)).then(()=>this.provider.provideTextSearchResults(f(this.query.contentPattern),l,d,o)).then(u=>Promise.all(r).then(()=>u))}validateProviderResult(g){if(v(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(g){const a=(0,n.resolvePatternsForProvider)(this.query.includePattern,g.includePattern),o=(0,n.resolvePatternsForProvider)(this.query.excludePattern,g.excludePattern),t={folder:y.URI.from(g.folder),excludes:o,includes:a,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.fileUtils.toCanonicalName(g.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=b;function f(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class i{constructor(g){this._onResult=g,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new h(512,a=>this.sendItems(a))}add(g,a){this._currentFileMatch&&(this._currentFolderIdx!==a||!S.isEqual(this._currentUri,g.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=a,this._currentFileMatch={resource:g.uri,results:[]}),this._currentFileMatch.results.push(s(g))}pushToCollector(){const g=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,g)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(g){this._onResult(g)}}e.TextSearchResultsCollector=i;function s(E){return v(E)?{preview:{matches:(0,k.mapArrayOrNot)(E.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:E.preview.text},ranges:(0,k.mapArrayOrNot)(E.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function v(E){return!!E.preview}e.extensionResultIsMatch=v;class h{constructor(g,a){this.maxBatchSize=g,this.cb=a,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(g,a){!g||this.addItemToBatch(g,a)}addItems(g,a){!g||this.addItemsToBatch(g,a)}addItemToBatch(g,a){this.batch.push(g),this.batchSize+=a,this.onUpdate()}addItemsToBatch(g,a){this.batch=this.batch.concat(g),this.batchSize+=a,this.onUpdate()}onUpdate(){this.totalNumberCompleted<h.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},h.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=h,h.TIMEOUT=4e3,h.START_BATCH_AFTER_COUNT=50}),define(be[103],we([0,1,6,5,4,221,14,68,19,2,222]),function(ie,e,w,k,A,T,S,I,y,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,A.createDecorator)("IExtHostSearch");let C=class{constructor(s,v,h){this.extHostRpc=s,this._uriTransformer=v,this._logService=h,this._proxy=this.extHostRpc.getProxy(k.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(s){return this._uriTransformer.transformOutgoingScheme(s)}registerTextSearchProvider(s,v){if(this._textSearchUsedSchemes.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this._textSearchUsedSchemes.add(s);const h=this._handlePool++;return this._textSearchProvider.set(h,v),this._proxy.$registerTextSearchProvider(h,this._transformScheme(s)),(0,w.toDisposable)(()=>{this._textSearchUsedSchemes.delete(s),this._textSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}registerFileSearchProvider(s,v){if(this._fileSearchUsedSchemes.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this._fileSearchUsedSchemes.add(s);const h=this._handlePool++;return this._fileSearchProvider.set(h,v),this._proxy.$registerFileSearchProvider(h,this._transformScheme(s)),(0,w.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(s),this._fileSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}$provideFileSearchResults(s,v,h,E){const g=b(h),a=this._fileSearchProvider.get(s);if(a)return this._fileSearchManager.fileSearch(g,a,o=>{this._proxy.$handleFileMatch(s,v,o.map(t=>t.resource))},E);throw new Error("unknown provider: "+s)}$clearCache(s){return this._fileSearchManager.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,v,h,E){const g=this._textSearchProvider.get(s);if(!g||!g.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const a=b(h);return this.createTextSearchManager(a,g).search(t=>this._proxy.$handleTextMatch(s,v,t),E)}createTextSearchManager(s,v){return new R.TextSearchManager(s,v,{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h})}};C=je([Ke(0,S.IExtHostRpcService),Ke(1,I.IURITransformerService),Ke(2,y.ILogService)],C),e.ExtHostSearch=C;function b(i){return Object.assign(Object.assign({},i),{folderQueries:i.folderQueries&&i.folderQueries.map(f),extraFileResources:i.extraFileResources&&i.extraFileResources.map(s=>n.URI.revive(s))})}e.reviveQuery=b;function f(i){return Object.assign(Object.assign({},i),{folder:n.URI.revive(i.folder)})}}),define(be[223],we([0,1,128,20,10,3,46,2,121,82,115,59,64,5,189,188,73,190,35,191,192,193,175,194,40,36,195,176,197,198,199,99,179,201,202,203,75,41,204,180,9,7,207,49,100,31,34,50,165,196,91,98,101,102,103,19,68,14,27,200,163,67,72,186,205,162,76,74,210,208,209,187,48,216,206,71,159,93]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b,f,i,s,v,h,E,g,a,o,t,r,d,l,u,m,_,D,c,p,P,F,z,de,B,W,K,M,U,x,Q,$,ee,re,se,ye,Ie,xe,Fe,ze,N,G,te,ae,me,Se,Le,ge,Ce,Pe,$e,_e,qe,V,X,ve,Me,He,Oe,et,H,ne,he,q,J,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function fe(pe){const Be=pe.get(Le.IExtHostInitDataService),Ne=pe.get(H.IExtHostFileSystemInfo),Ve=pe.get(ve.IExtHostConsumerFileSystem),Xe=pe.get(l.IExtHostExtensionService),Ze=pe.get(re.IExtHostWorkspace),ct=pe.get(oe.IExtHostTelemetry),ot=pe.get(E.IExtHostConfiguration),nt=pe.get(me.IURITransformerService),ue=pe.get(Se.IExtHostRpcService),De=pe.get(B.IExtHostStorage),le=pe.get(X.IExtensionStoragePaths),j=pe.get(ae.ILogService),Ae=pe.get(Pe.IExtHostTunnelService),Te=pe.get($e.IExtHostApiDeprecationService),Ye=pe.get(ee.IExtHostWindow),Ge=pe.get(q.IExtHostSecretState);ue.set(f.ExtHostContext.ExtHostFileSystemInfo,Ne),ue.set(f.ExtHostContext.ExtHostLogService,j),ue.set(f.ExtHostContext.ExtHostWorkspace,Ze),ue.set(f.ExtHostContext.ExtHostConfiguration,ot),ue.set(f.ExtHostContext.ExtHostExtensionService,Xe),ue.set(f.ExtHostContext.ExtHostStorage,De),ue.set(f.ExtHostContext.ExtHostTunnelService,Ae),ue.set(f.ExtHostContext.ExtHostWindow,Ye),ue.set(f.ExtHostContext.ExtHostSecretState,Ge),ue.set(f.ExtHostContext.ExtHostTelemetry,ct);const rt=ue.set(f.ExtHostContext.ExtHostDecorations,pe.get(ze.IExtHostDecorations)),at=ue.set(f.ExtHostContext.ExtHostDocumentsAndEditors,pe.get(d.IExtHostDocumentsAndEditors)),Qe=ue.set(f.ExtHostContext.ExtHostCommands,pe.get(v.IExtHostCommands)),ut=ue.set(f.ExtHostContext.ExtHostTerminalService,pe.get(W.IExtHostTerminalService)),st=ue.set(f.ExtHostContext.ExtHostDebugService,pe.get(G.IExtHostDebugService)),gt=ue.set(f.ExtHostContext.ExtHostSearch,pe.get(te.IExtHostSearch)),wt=ue.set(f.ExtHostContext.ExtHostTask,pe.get(N.IExtHostTask)),St=ue.set(f.ExtHostContext.ExtHostOutputService,pe.get(p.IExtHostOutputService)),vt=ue.set(f.ExtHostContext.ExtHostEditorTabs,new J.ExtHostEditorTabs),Et=ue.set(f.ExtHostContext.ExtHostUrls,new Q.ExtHostUrls(ue)),pt=ue.set(f.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(ue,at)),Rt=ue.set(f.ExtHostContext.ExtHostDocumentContentProviders,new o.ExtHostDocumentContentProvider(ue,at,j)),Ft=ue.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(j,pt,ue.getProxy(f.MainContext.MainThreadBulkEdits))),ft=ue.set(f.ExtHostContext.ExtHostNotebook,new ge.ExtHostNotebookController(ue,Qe,at,pt,Be.environment,j,le)),yt=ue.set(f.ExtHostContext.ExtHostEditors,new K.ExtHostEditors(ue,at)),Wt=ue.set(f.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(ue.getProxy(f.MainContext.MainThreadTreeViews),Qe,j)),qt=ue.set(f.ExtHostContext.ExtHostEditorInsets,new Ie.ExtHostEditorInsets(ue.getProxy(f.MainContext.MainThreadEditorInsets),yt,Be.environment)),Mt=ue.set(f.ExtHostContext.ExtHostDiagnostics,new g.ExtHostDiagnostics(ue,j)),ht=ue.set(f.ExtHostContext.ExtHostLanguageFeatures,new _.ExtHostLanguageFeatures(ue,nt,pt,Qe,Mt,j,Te)),Kt=ue.set(f.ExtHostContext.ExtHostFileSystem,new u.ExtHostFileSystem(ue,ht)),Ct=ue.set(f.ExtHostContext.ExtHostFileSystemEventService,new m.ExtHostFileSystemEventService(ue,j,at)),Ot=ue.set(f.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(ue,Ze,Qe)),Ht=ue.set(f.ExtHostContext.ExtHostSCM,new z.ExtHostSCM(ue,Qe,j)),Gt=ue.set(f.ExtHostContext.ExtHostComments,new h.ExtHostComments(ue,Qe,pt)),en=ue.set(f.ExtHostContext.ExtHostProgress,new P.ExtHostProgress(ue.getProxy(f.MainContext.MainThreadProgress))),dn=ue.set(f.ExtHostContext.ExtHosLabelService,new xe.ExtHostLabelService(ue)),tn=ue.set(f.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(ue)),Lt=ue.set(f.ExtHostContext.ExtHostAuthentication,new _e.ExtHostAuthentication(ue)),hn=ue.set(f.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(ue,Qe)),Nt=ue.set(f.ExtHostContext.ExtHostWebviews,new $.ExtHostWebviews(ue,Be.environment,Ze,j,Te)),Ut=ue.set(f.ExtHostContext.ExtHostWebviewPanels,new Oe.ExtHostWebviewPanels(ue,Nt,Ze)),fn=ue.set(f.ExtHostContext.ExtHostCustomEditors,new He.ExtHostCustomEditors(ue,pt,le,Nt,Ut)),mn=ue.set(f.ExtHostContext.ExtHostWebviewViews,new Me.ExtHostWebviewViews(ue,Nt)),Pt=ue.set(f.ExtHostContext.ExtHostTesting,new ne.ExtHostTesting(ue,at,Ze)),gn=ue.set(f.ExtHostContext.ExtHostUriOpeners,new he.ExtHostUriOpeners(ue)),zt=(0,ye.values)(f.ExtHostContext);ue.assertRegistered(zt);const pn=new et.ExtHostBulkEdits(ue,at),vn=new s.ExtHostClipboard(ue),xt=new c.ExtHostMessageService(ue,j),nn=new a.ExtHostDialogs(ue),Vt=new de.ExtHostStatusBar(ue,Qe.converter),$t=new D.ExtHostLanguages(ue,pt);return i.ExtHostApiCommands.register(Qe),function(Re,Qt,Jt){const mt=function(){let Y=!Re.isUnderDevelopment;function ce(ke){Y||(j.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function ke(lt){if(Array.isArray(lt))lt.forEach(ke);else if(typeof lt=="string")ce(lt);else{const _t=lt;typeof _t.scheme=="undefined"&&ce(lt),!Re.enableProposedApi&&typeof _t.exclusive=="boolean"&&(0,se.throwProposedApiError)(Re)}return lt}}(),_n={getSession(Y,ce,ke){return Lt.getSession(Re,Y,ce,ke)},get onDidChangeSessions(){return Lt.onDidChangeSessions},registerAuthenticationProvider(Y,ce,ke,lt){return Lt.registerAuthenticationProvider(Y,ce,ke,lt)},get onDidChangeAuthenticationProviders(){return(0,se.checkProposedApiEnabled)(Re),Lt.onDidChangeAuthenticationProviders},get providers(){return(0,se.checkProposedApiEnabled)(Re),Lt.providers},logout(Y,ce){return(0,se.checkProposedApiEnabled)(Re),Lt.removeSession(Y,ce)}},bn={registerCommand(Y,ce,ke){return Qe.registerCommand(!0,Y,ce,ke)},registerTextEditorCommand(Y,ce,ke){return Qe.registerCommand(!0,Y,(...lt)=>{const _t=yt.getActiveTextEditor();if(!_t){j.warn("Cannot execute "+Y+" because there is no active text editor.");return}return _t.edit(O=>{ce.apply(ke,[_t,O,...lt])}).then(O=>{O||j.warn("Edits from command "+Y+" were not applied.")},O=>{j.warn("An error occurred while running command "+Y,O)})})},registerDiffInformationCommand:(Y,ce,ke)=>((0,se.checkProposedApiEnabled)(Re),Qe.registerCommand(!0,Y,async(...lt)=>{const _t=at.activeEditor(!0);if(!_t){j.warn("Cannot execute "+Y+" because there is no active text editor.");return}const O=await yt.getDiffInformation(_t.id);ce.apply(ke,[O,...lt])})),executeCommand(Y,...ce){return Qe.executeCommand(Y,...ce)},getCommands(Y=!1){return Qe.getCommands(Y)}},rn={get machineId(){return Be.telemetryInfo.machineId},get sessionId(){return Be.telemetryInfo.sessionId},get language(){return Be.environment.appLanguage},get appName(){return Be.environment.appName},get appRoot(){var Y,ce;return(ce=(Y=Be.environment.appRoot)===null||Y===void 0?void 0:Y.fsPath)!==null&&ce!==void 0?ce:""},get uriScheme(){return Be.environment.appUriScheme},get clipboard(){return vn.value},get shell(){return ut.getDefaultShell(!1,Jt)},get isTelemetryEnabled(){return ct.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ct.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(Be.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,ce){return Ye.openUri(Y,{allowTunneling:!!Be.remote.authority,allowContributedOpeners:ce==null?void 0:ce.allowContributedOpeners})},asExternalUri(Y){return Y.scheme===Be.environment.appUriScheme?Et.createAppUri(Y):Ye.asExternalUri(Y,{allowTunneling:!!Be.remote.authority})},get remoteName(){return(0,Fe.getRemoteName)(Be.remote.authority)},get uiKind(){return Be.uiKind}};Be.environment.extensionTestsLocationURI||Object.freeze(rn);const sn=Be.remote.isRemote?x.ExtensionKind.Workspace:x.ExtensionKind.UI,wn={registerTestProvider(Y){return(0,se.checkProposedApiEnabled)(Re),Pt.registerTestProvider(Y)},createDocumentTestObserver(Y){return(0,se.checkProposedApiEnabled)(Re),Pt.createTextDocumentTestObserver(Y)},createWorkspaceTestObserver(Y){return(0,se.checkProposedApiEnabled)(Re),Pt.createWorkspaceTestObserver(Y)},runTests(Y){return(0,se.checkProposedApiEnabled)(Re),Pt.runTests(Y)},publishTestResult(Y,ce=!0){return(0,se.checkProposedApiEnabled)(Re),Pt.publishExtensionProvidedResults(Y,ce)},get onDidChangeTestResults(){return(0,se.checkProposedApiEnabled)(Re),Pt.onResultsChanged},get testResults(){return(0,se.checkProposedApiEnabled)(Re),Pt.results}},Yt={getExtension(Y){const ce=Qt.getExtensionDescription(Y);if(ce)return new l.Extension(Xe,Re.identifier,ce,sn)},get all(){return Qt.getAllExtensionDescriptions().map(Y=>new l.Extension(Xe,Re.identifier,Y,sn))},get onDidChange(){return Qt.onDidChange}},En={createDiagnosticCollection(Y){return Mt.createDiagnosticCollection(Re.identifier,Y)},get onDidChangeDiagnostics(){return Mt.onDidChangeDiagnostics},getDiagnostics:Y=>Mt.getDiagnostics(Y),getLanguages(){return $t.getLanguages()},setTextDocumentLanguage(Y,ce){return $t.changeLanguage(Y.uri,ce)},match(Y,ce){return(0,C.score)(U.LanguageSelector.from(Y),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(Y,ce,ke){return ht.registerCodeActionProvider(Re,mt(Y),ce,ke)},registerCodeLensProvider(Y,ce){return ht.registerCodeLensProvider(Re,mt(Y),ce)},registerDefinitionProvider(Y,ce){return ht.registerDefinitionProvider(Re,mt(Y),ce)},registerDeclarationProvider(Y,ce){return ht.registerDeclarationProvider(Re,mt(Y),ce)},registerImplementationProvider(Y,ce){return ht.registerImplementationProvider(Re,mt(Y),ce)},registerTypeDefinitionProvider(Y,ce){return ht.registerTypeDefinitionProvider(Re,mt(Y),ce)},registerHoverProvider(Y,ce){return ht.registerHoverProvider(Re,mt(Y),ce,Re.identifier)},registerEvaluatableExpressionProvider(Y,ce){return ht.registerEvaluatableExpressionProvider(Re,mt(Y),ce,Re.identifier)},registerInlineValuesProvider(Y,ce){return ht.registerInlineValuesProvider(Re,mt(Y),ce,Re.identifier)},registerDocumentHighlightProvider(Y,ce){return ht.registerDocumentHighlightProvider(Re,mt(Y),ce)},registerLinkedEditingRangeProvider(Y,ce){return ht.registerLinkedEditingRangeProvider(Re,mt(Y),ce)},registerReferenceProvider(Y,ce){return ht.registerReferenceProvider(Re,mt(Y),ce)},registerRenameProvider(Y,ce){return ht.registerRenameProvider(Re,mt(Y),ce)},registerDocumentSymbolProvider(Y,ce,ke){return ht.registerDocumentSymbolProvider(Re,mt(Y),ce,ke)},registerWorkspaceSymbolProvider(Y){return ht.registerWorkspaceSymbolProvider(Re,Y)},registerDocumentFormattingEditProvider(Y,ce){return ht.registerDocumentFormattingEditProvider(Re,mt(Y),ce)},registerDocumentRangeFormattingEditProvider(Y,ce){return ht.registerDocumentRangeFormattingEditProvider(Re,mt(Y),ce)},registerOnTypeFormattingEditProvider(Y,ce,ke,...lt){return ht.registerOnTypeFormattingEditProvider(Re,mt(Y),ce,[ke].concat(lt))},registerDocumentSemanticTokensProvider(Y,ce,ke){return ht.registerDocumentSemanticTokensProvider(Re,mt(Y),ce,ke)},registerDocumentRangeSemanticTokensProvider(Y,ce,ke){return ht.registerDocumentRangeSemanticTokensProvider(Re,mt(Y),ce,ke)},registerSignatureHelpProvider(Y,ce,ke,...lt){return typeof ke=="object"?ht.registerSignatureHelpProvider(Re,mt(Y),ce,ke):ht.registerSignatureHelpProvider(Re,mt(Y),ce,typeof ke=="undefined"?[]:[ke,...lt])},registerCompletionItemProvider(Y,ce,...ke){return ht.registerCompletionItemProvider(Re,mt(Y),ce,ke)},registerDocumentLinkProvider(Y,ce){return ht.registerDocumentLinkProvider(Re,mt(Y),ce)},registerColorProvider(Y,ce){return ht.registerColorProvider(Re,mt(Y),ce)},registerFoldingRangeProvider(Y,ce){return ht.registerFoldingRangeProvider(Re,mt(Y),ce)},registerSelectionRangeProvider(Y,ce){return ht.registerSelectionRangeProvider(Re,Y,ce)},registerCallHierarchyProvider(Y,ce){return ht.registerCallHierarchyProvider(Re,Y,ce)},setLanguageConfiguration:(Y,ce)=>ht.setLanguageConfiguration(Re,Y,ce),getTokenInformationAtPosition(Y,ce){return(0,se.checkProposedApiEnabled)(Re),$t.tokenAtPosition(Y,ce)},registerInlineHintsProvider(Y,ce){return(0,se.checkProposedApiEnabled)(Re),ht.registerInlineHintsProvider(Re,Y,ce)}},yn={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return ut.activeTerminal},get terminals(){return ut.terminals},async showTextDocument(Y,ce,ke){const lt=await(I.URI.isUri(Y)?Promise.resolve(on.openTextDocument(Y)):Promise.resolve(Y));return yt.showTextDocument(lt,ce,ke)},createTextEditorDecorationType(Y){return yt.createTextEditorDecorationType(Y)},onDidChangeActiveTextEditor(Y,ce,ke){return yt.onDidChangeActiveTextEditor(Y,ce,ke)},onDidChangeVisibleTextEditors(Y,ce,ke){return yt.onDidChangeVisibleTextEditors(Y,ce,ke)},onDidChangeTextEditorSelection(Y,ce,ke){return yt.onDidChangeTextEditorSelection(Y,ce,ke)},onDidChangeTextEditorOptions(Y,ce,ke){return yt.onDidChangeTextEditorOptions(Y,ce,ke)},onDidChangeTextEditorVisibleRanges(Y,ce,ke){return yt.onDidChangeTextEditorVisibleRanges(Y,ce,ke)},onDidChangeTextEditorViewColumn(Y,ce,ke){return yt.onDidChangeTextEditorViewColumn(Y,ce,ke)},onDidCloseTerminal(Y,ce,ke){return ut.onDidCloseTerminal(Y,ce,ke)},onDidOpenTerminal(Y,ce,ke){return ut.onDidOpenTerminal(Y,ce,ke)},onDidChangeActiveTerminal(Y,ce,ke){return ut.onDidChangeActiveTerminal(Y,ce,ke)},onDidChangeTerminalDimensions(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ut.onDidChangeTerminalDimensions(Y,ce,ke)},onDidWriteTerminalData(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ut.onDidWriteTerminalData(Y,ce,ke)},get state(){return Ye.state},onDidChangeWindowState(Y,ce,ke){return Ye.onDidChangeWindowState(Y,ce,ke)},showInformationMessage(Y,...ce){return xt.showMessage(Re,S.default.Info,Y,ce[0],ce.slice(1))},showWarningMessage(Y,...ce){return xt.showMessage(Re,S.default.Warning,Y,ce[0],ce.slice(1))},showErrorMessage(Y,...ce){return xt.showMessage(Re,S.default.Error,Y,ce[0],ce.slice(1))},showQuickPick(Y,ce,ke){return Ot.showQuickPick(Y,!!Re.enableProposedApi,ce,ke)},showWorkspaceFolderPick(Y){return Ot.showWorkspaceFolderPick(Y)},showInputBox(Y,ce){return Ot.showInput(Y,ce)},showOpenDialog(Y){return nn.showOpenDialog(Y)},showSaveDialog(Y){return nn.showSaveDialog(Y)},createStatusBarItem(Y,ce){let ke,lt,_t,O;return Y&&typeof Y!="number"?(ke=Y.id,lt=Y.name,_t=Y.alignment,ce=Y.priority,O=Y.accessibilityInformation):(ke=Re.identifier.value,lt=w.localize(0,null,Re.displayName||Re.name),_t=Y),Vt.createStatusBarEntry(ke,lt,_t,ce,O)},setStatusBarMessage(Y,ce){return Vt.setStatusBarMessage(Y,ce)},withScmProgress(Y){return Te.report("window.withScmProgress",Re,"Use 'withProgress' instead."),en.withProgress(Re,{location:x.ProgressLocation.SourceControl},(ce,ke)=>Y({report(lt){}}))},withProgress(Y,ce){return en.withProgress(Re,Y,ce)},createOutputChannel(Y){return St.createOutputChannel(Y)},createWebviewPanel(Y,ce,ke,lt){return Ut.createWebviewPanel(Re,Y,ce,ke,lt)},createWebviewTextEditorInset(Y,ce,ke,lt){return(0,se.checkProposedApiEnabled)(Re),qt.createWebviewEditorInset(Y,ce,ke,lt,Re)},createTerminal(Y,ce,ke){return typeof Y=="object"?"pty"in Y?ut.createExtensionTerminal(Y):(Y.initialText&&(0,se.checkProposedApiEnabled)(Re),Y.icon&&(0,se.checkProposedApiEnabled)(Re),ut.createTerminalFromOptions(Y)):ut.createTerminal(Y,ce,ke)},registerTerminalLinkProvider(Y){return ut.registerLinkProvider(Y)},registerTreeDataProvider(Y,ce){return Wt.registerTreeDataProvider(Y,ce,Re)},createTreeView(Y,ce){return Wt.createTreeView(Y,ce,Re)},registerWebviewPanelSerializer:(Y,ce)=>Ut.registerWebviewPanelSerializer(Re,Y,ce),registerCustomEditorProvider:(Y,ce,ke={})=>fn.registerCustomEditorProvider(Re,Y,ce,ke),registerFileDecorationProvider(Y){return rt.registerFileDecorationProvider(Y,Re.identifier)},registerUriHandler(Y){return Et.registerUriHandler(Re.identifier,Y)},createQuickPick(){return Ot.createQuickPick(Re.identifier,!!Re.enableProposedApi)},createInputBox(){return Ot.createInputBox(Re.identifier)},get activeColorTheme(){return tn.activeColorTheme},onDidChangeActiveColorTheme(Y,ce,ke){return tn.onDidChangeActiveColorTheme(Y,ce,ke)},registerWebviewViewProvider(Y,ce,ke){return mn.registerWebviewViewProvider(Re,Y,ce,ke==null?void 0:ke.webviewOptions)},get activeNotebookEditor(){return(0,se.checkProposedApiEnabled)(Re),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeActiveNotebookEditor(Y,ce,ke)},get visibleNotebookEditors(){return(0,se.checkProposedApiEnabled)(Re),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookEditorSelection(Y,ce,ke)},onDidChangeNotebookEditorVisibleRanges(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookEditorVisibleRanges(Y,ce,ke)},showNotebookDocument(Y,ce){return(0,se.checkProposedApiEnabled)(Re),ft.showNotebookDocument(Y,ce)},registerExternalUriOpener(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),gn.registerExternalUriOpener(Re.identifier,Y,ce,ke)},get openEditors(){return(0,se.checkProposedApiEnabled)(Re),vt.tabs},get onDidChangeOpenEditors(){return(0,se.checkProposedApiEnabled)(Re),vt.onDidChangeTabs}},on={get rootPath(){return Te.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ze.getPath()},set rootPath(Y){throw A.readonly()},getWorkspaceFolder(Y){return Ze.getWorkspaceFolder(Y)},get workspaceFolders(){return Ze.getWorkspaceFolders()},get name(){return Ze.name},set name(Y){throw A.readonly()},get workspaceFile(){return Ze.workspaceFile},set workspaceFile(Y){throw A.readonly()},updateWorkspaceFolders:(Y,ce,...ke)=>Ze.updateWorkspaceFolders(Re,Y,ce||0,...ke),onDidChangeWorkspaceFolders:function(Y,ce,ke){return Ze.onDidChangeWorkspace(Y,ce,ke)},asRelativePath:(Y,ce)=>Ze.getRelativePath(Y,ce),findFiles:(Y,ce,ke,lt)=>Ze.findFiles(U.GlobPattern.from(Y),U.GlobPattern.from(ce),ke,Re.identifier,lt),findTextInFiles:(Y,ce,ke,lt)=>{let _t,O;return typeof ce=="object"?(_t=ce,O=ke):(_t={},O=ce,lt=ke),Ze.findTextInFiles(Y,_t||{},O,Re.identifier,lt)},saveAll:Y=>Ze.saveAll(Y),applyEdit(Y){return pn.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,ce,ke,lt)=>Ct.createFileSystemWatcher(U.GlobPattern.from(Y),ce,ke,lt),get textDocuments(){return pt.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw A.readonly()},openTextDocument(Y){let ce;const ke=Y;if(typeof Y=="string")ce=Promise.resolve(I.URI.file(Y));else if(I.URI.isUri(Y))ce=Promise.resolve(Y);else if(!ke||typeof ke=="object")ce=pt.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(lt=>pt.ensureDocumentData(lt).then(_t=>_t.document))},onDidOpenTextDocument:(Y,ce,ke)=>pt.onDidAddDocument(Y,ce,ke),onDidCloseTextDocument:(Y,ce,ke)=>pt.onDidRemoveDocument(Y,ce,ke),onDidChangeTextDocument:(Y,ce,ke)=>pt.onDidChangeDocument(Y,ce,ke),onDidSaveTextDocument:(Y,ce,ke)=>pt.onDidSaveDocument(Y,ce,ke),onWillSaveTextDocument:(Y,ce,ke)=>Ft.getOnWillSaveTextDocumentEvent(Re)(Y,ce,ke),onDidChangeConfiguration:(Y,ce,ke)=>Jt.onDidChangeConfiguration(Y,ce,ke),getConfiguration(Y,ce){return ce=arguments.length===1?void 0:ce,Jt.getConfiguration(Y,ce,Re)},registerTextDocumentContentProvider(Y,ce){return Rt.registerTextDocumentContentProvider(Y,ce)},registerTaskProvider:(Y,ce)=>(Te.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),wt.registerTaskProvider(Re,Y,ce)),registerFileSystemProvider(Y,ce,ke){return Kt.registerFileSystemProvider(Re.identifier,Y,ce,ke)},get fs(){return Ve.value},registerFileSearchProvider:(Y,ce)=>((0,se.checkProposedApiEnabled)(Re),gt.registerFileSearchProvider(Y,ce)),registerTextSearchProvider:(Y,ce)=>((0,se.checkProposedApiEnabled)(Re),gt.registerTextSearchProvider(Y,ce)),registerRemoteAuthorityResolver:(Y,ce)=>((0,se.checkProposedApiEnabled)(Re),Xe.registerRemoteAuthorityResolver(Y,ce)),registerResourceLabelFormatter:Y=>((0,se.checkProposedApiEnabled)(Re),dn.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,ce,ke)=>Ct.onDidCreateFile(Y,ce,ke),onDidDeleteFiles:(Y,ce,ke)=>Ct.onDidDeleteFile(Y,ce,ke),onDidRenameFiles:(Y,ce,ke)=>Ct.onDidRenameFile(Y,ce,ke),onWillCreateFiles:(Y,ce,ke)=>Ct.getOnWillCreateFileEvent(Re)(Y,ce,ke),onWillDeleteFiles:(Y,ce,ke)=>Ct.getOnWillDeleteFileEvent(Re)(Y,ce,ke),onWillRenameFiles:(Y,ce,ke)=>Ct.getOnWillRenameFileEvent(Re)(Y,ce,ke),openTunnel:Y=>((0,se.checkProposedApiEnabled)(Re),Ae.openTunnel(Re,Y).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,se.checkProposedApiEnabled)(Re),Ae.getTunnels()},onDidChangeTunnels:(Y,ce,ke)=>((0,se.checkProposedApiEnabled)(Re),Ae.onDidChangeTunnels(Y,ce,ke)),registerPortAttributesProvider:(Y,ce)=>((0,se.checkProposedApiEnabled)(Re),Ae.registerPortsAttributesProvider(Y,ce)),registerTimelineProvider:(Y,ce)=>((0,se.checkProposedApiEnabled)(Re),hn.registerTimelineProvider(Y,ce,Re.identifier,Qe.converter)),get trustState(){return(0,se.checkProposedApiEnabled)(Re),Ze.trustState},requestWorkspaceTrust:Y=>((0,se.checkProposedApiEnabled)(Re),Ze.requestWorkspaceTrust(Y)),onDidChangeWorkspaceTrustState:(Y,ce,ke)=>Ze.onDidChangeWorkspaceTrustState(Y,ce,ke)},Sn={get inputBox(){return Te.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),Ht.getLastInputBox(Re)},createSourceControl(Y,ce,ke){return Ht.createSourceControl(Re,Y,ce,ke)}},Dn={createCommentController(Y,ce){return Gt.createCommentController(Re,Y,ce)}},an={get activeDebugSession(){return st.activeDebugSession},get activeDebugConsole(){return st.activeDebugConsole},get breakpoints(){return st.breakpoints},onDidStartDebugSession(Y,ce,ke){return st.onDidStartDebugSession(Y,ce,ke)},onDidTerminateDebugSession(Y,ce,ke){return st.onDidTerminateDebugSession(Y,ce,ke)},onDidChangeActiveDebugSession(Y,ce,ke){return st.onDidChangeActiveDebugSession(Y,ce,ke)},onDidReceiveDebugSessionCustomEvent(Y,ce,ke){return st.onDidReceiveDebugSessionCustomEvent(Y,ce,ke)},onDidChangeBreakpoints(Y,ce,ke){return st.onDidChangeBreakpoints(Y,ce,ke)},registerDebugConfigurationProvider(Y,ce,ke){return st.registerDebugConfigurationProvider(Y,ce,ke||x.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,ce){return st.registerDebugAdapterDescriptorFactory(Re,Y,ce)},registerDebugAdapterTrackerFactory(Y,ce){return st.registerDebugAdapterTrackerFactory(Y,ce)},startDebugging(Y,ce,ke){return!ke||typeof ke=="object"&&"configuration"in ke?st.startDebugging(Y,ce,{parentSession:ke}):st.startDebugging(Y,ce,ke||{})},stopDebugging(Y){return st.stopDebugging(Y)},addBreakpoints(Y){return st.addBreakpoints(Y)},removeBreakpoints(Y){return st.removeBreakpoints(Y)},asDebugSourceUri(Y,ce){return st.asDebugSourceUri(Y,ce)}},jt={registerTaskProvider:(Y,ce)=>wt.registerTaskProvider(Re,Y,ce),fetchTasks:Y=>wt.fetchTasks(Y),executeTask:Y=>wt.executeTask(Re,Y),get taskExecutions(){return wt.taskExecutions},onDidStartTask:(Y,ce,ke)=>wt.onDidStartTask(Y,ce,ke),onDidEndTask:(Y,ce,ke)=>wt.onDidEndTask(Y,ce,ke),onDidStartTaskProcess:(Y,ce,ke)=>wt.onDidStartTaskProcess(Y,ce,ke),onDidEndTaskProcess:(Y,ce,ke)=>wt.onDidEndTaskProcess(Y,ce,ke)},ln={openNotebookDocument:Y=>((0,se.checkProposedApiEnabled)(Re),ft.openNotebookDocument(Y)),get onDidOpenNotebookDocument(){return(0,se.checkProposedApiEnabled)(Re),ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,se.checkProposedApiEnabled)(Re),ft.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,se.checkProposedApiEnabled)(Re),ft.onDidSaveNotebookDocument},get notebookDocuments(){return(0,se.checkProposedApiEnabled)(Re),ft.notebookDocuments.map(Y=>Y.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeActiveNotebookKernel},registerNotebookSerializer(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.registerNotebookSerializer(Re,Y,ce,ke)},registerNotebookContentProvider:(Y,ce,ke)=>((0,se.checkProposedApiEnabled)(Re),ft.registerNotebookContentProvider(Re,Y,ce,ke)),registerNotebookKernelProvider:(Y,ce)=>((0,se.checkProposedApiEnabled)(Re),ft.registerNotebookKernelProvider(Re,Y,ce)),createNotebookEditorDecorationType(Y){return(0,se.checkProposedApiEnabled)(Re),ft.createNotebookEditorDecorationType(Y)},onDidChangeNotebookDocumentMetadata(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookDocumentMetadata(Y,ce,ke)},onDidChangeNotebookCells(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookCells(Y,ce,ke)},onDidChangeCellExecutionState(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookCellExecutionState(Y,ce,ke)},onDidChangeCellOutputs(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeCellOutputs(Y,ce,ke)},onDidChangeCellMetadata(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.onDidChangeCellMetadata(Y,ce,ke)},createConcatTextDocument(Y,ce){return(0,se.checkProposedApiEnabled)(Re),new V.ExtHostNotebookConcatDocument(ft,pt,Y,ce)},createCellStatusBarItem(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.createNotebookCellStatusBarItemInternal(Y,ce,ke)},createNotebookCellExecutionTask(Y,ce,ke){return(0,se.checkProposedApiEnabled)(Re),ft.createNotebookCellExecution(Y,ce,ke)}};return{version:Be.version,authentication:_n,commands:bn,comments:Dn,debug:an,env:rn,extensions:Yt,languages:En,notebook:ln,scm:Sn,tasks:jt,test:wn,window:yn,workspace:on,Breakpoint:x.Breakpoint,CallHierarchyIncomingCall:x.CallHierarchyIncomingCall,CallHierarchyItem:x.CallHierarchyItem,CallHierarchyOutgoingCall:x.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:k.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:x.CodeAction,CodeActionKind:x.CodeActionKind,CodeActionTriggerKind:x.CodeActionTriggerKind,CodeLens:x.CodeLens,Color:x.Color,ColorInformation:x.ColorInformation,ColorPresentation:x.ColorPresentation,ColorThemeKind:x.ColorThemeKind,CommentMode:x.CommentMode,CommentThreadCollapsibleState:x.CommentThreadCollapsibleState,CompletionItem:x.CompletionItem,CompletionItemKind:x.CompletionItemKind,CompletionItemTag:x.CompletionItemTag,CompletionList:x.CompletionList,CompletionTriggerKind:x.CompletionTriggerKind,ConfigurationTarget:x.ConfigurationTarget,CustomExecution:x.CustomExecution,DebugAdapterExecutable:x.DebugAdapterExecutable,DebugAdapterInlineImplementation:x.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:x.DebugAdapterNamedPipeServer,DebugAdapterServer:x.DebugAdapterServer,DebugConfigurationProviderTriggerKind:x.DebugConfigurationProviderTriggerKind,DebugConsoleMode:x.DebugConsoleMode,DecorationRangeBehavior:x.DecorationRangeBehavior,Diagnostic:x.Diagnostic,DiagnosticRelatedInformation:x.DiagnosticRelatedInformation,DiagnosticSeverity:x.DiagnosticSeverity,DiagnosticTag:x.DiagnosticTag,Disposable:x.Disposable,DocumentHighlight:x.DocumentHighlight,DocumentHighlightKind:x.DocumentHighlightKind,DocumentLink:x.DocumentLink,DocumentSymbol:x.DocumentSymbol,EndOfLine:x.EndOfLine,EnvironmentVariableMutatorType:x.EnvironmentVariableMutatorType,EvaluatableExpression:x.EvaluatableExpression,InlineValueText:x.InlineValueText,InlineValueVariableLookup:x.InlineValueVariableLookup,InlineValueEvaluatableExpression:x.InlineValueEvaluatableExpression,EventEmitter:T.Emitter,ExtensionKind:x.ExtensionKind,ExtensionMode:x.ExtensionMode,ExternalUriOpenerPriority:x.ExternalUriOpenerPriority,FileChangeType:x.FileChangeType,FileDecoration:x.FileDecoration,FileSystemError:x.FileSystemError,FileType:b.FileType,FoldingRange:x.FoldingRange,FoldingRangeKind:x.FoldingRangeKind,FunctionBreakpoint:x.FunctionBreakpoint,Hover:x.Hover,IndentAction:R.IndentAction,Location:x.Location,MarkdownString:x.MarkdownString,OverviewRulerLane:n.OverviewRulerLane,ParameterInformation:x.ParameterInformation,PortAutoForwardAction:x.PortAutoForwardAction,Position:x.Position,ProcessExecution:x.ProcessExecution,ProgressLocation:x.ProgressLocation,QuickInputButtons:x.QuickInputButtons,Range:x.Range,RelativePattern:x.RelativePattern,Selection:x.Selection,SelectionRange:x.SelectionRange,SemanticTokens:x.SemanticTokens,SemanticTokensBuilder:x.SemanticTokensBuilder,SemanticTokensEdit:x.SemanticTokensEdit,SemanticTokensEdits:x.SemanticTokensEdits,SemanticTokensLegend:x.SemanticTokensLegend,ShellExecution:x.ShellExecution,ShellQuoting:x.ShellQuoting,SignatureHelp:x.SignatureHelp,SignatureHelpTriggerKind:x.SignatureHelpTriggerKind,SignatureInformation:x.SignatureInformation,SnippetString:x.SnippetString,SourceBreakpoint:x.SourceBreakpoint,StandardTokenType:x.StandardTokenType,StatusBarAlignment:x.StatusBarAlignment,SymbolInformation:x.SymbolInformation,SymbolKind:x.SymbolKind,SymbolTag:x.SymbolTag,Task:x.Task,TaskGroup:x.TaskGroup,TaskPanelKind:x.TaskPanelKind,TaskRevealKind:x.TaskRevealKind,TaskScope:x.TaskScope,TextDocumentSaveReason:x.TextDocumentSaveReason,TextEdit:x.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:x.TextEditorLineNumbersStyle,TextEditorRevealType:x.TextEditorRevealType,TextEditorSelectionChangeKind:x.TextEditorSelectionChangeKind,ThemeColor:x.ThemeColor,ThemeIcon:x.ThemeIcon,TreeItem:x.TreeItem,TreeItemCollapsibleState:x.TreeItemCollapsibleState,UIKind:f.UIKind,Uri:I.URI,ViewColumn:x.ViewColumn,WorkspaceEdit:x.WorkspaceEdit,InlineHint:x.InlineHint,InlineHintKind:x.InlineHintKind,RemoteAuthorityResolverError:x.RemoteAuthorityResolverError,ResolvedAuthority:x.ResolvedAuthority,SourceControlInputBoxValidationType:x.SourceControlInputBoxValidationType,ExtensionRuntime:x.ExtensionRuntime,TimelineItem:x.TimelineItem,NotebookCellRange:x.NotebookCellRange,NotebookCellKind:x.NotebookCellKind,NotebookCellExecutionState:x.NotebookCellExecutionState,NotebookDocumentMetadata:x.NotebookDocumentMetadata,NotebookCellMetadata:x.NotebookCellMetadata,NotebookCellData:x.NotebookCellData,NotebookData:x.NotebookData,NotebookCellStatusBarAlignment:x.NotebookCellStatusBarAlignment,NotebookEditorRevealType:x.NotebookEditorRevealType,NotebookCellOutput:x.NotebookCellOutput,NotebookCellOutputItem:x.NotebookCellOutputItem,LinkedEditingRanges:x.LinkedEditingRanges,TestItem:x.TestItem,TestResultState:x.TestResultState,TestMessage:x.TestMessage,TestMessageSeverity:x.TestMessageSeverity,WorkspaceTrustState:x.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=fe}),define(be[224],we([0,1,61,99,31,98,35,73,40,41,101,102,103,76,75,67,72,100,74,48,71,93]),function(ie,e,w,k,A,T,S,I,y,n,R,C,b,f,i,s,v,h,E,g,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(f.IExtensionStoragePaths,f.ExtensionStoragePaths),(0,w.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,w.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,w.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration),(0,w.registerSingleton)(E.IExtHostConsumerFileSystem,E.ExtHostConsumerFileSystem),(0,w.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,w.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,w.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,w.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo),(0,w.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService),(0,w.registerSingleton)(b.IExtHostSearch,b.ExtHostSearch),(0,w.registerSingleton)(i.IExtHostStorage,i.ExtHostStorage),(0,w.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,w.registerSingleton)(n.IExtHostTerminalService,n.WorkerExtHostTerminalService),(0,w.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,w.registerSingleton)(h.IExtHostWindow,h.ExtHostWindow),(0,w.registerSingleton)(A.IExtHostWorkspace,A.ExtHostWorkspace),(0,w.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,w.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry)}),define(be[225],we([0,1,223,36,219,7,13,5]),function(ie,e,w,k,A,T,S,I){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var n;(function(i){var s;const v=(s=self.trustedTypes)===null||s===void 0?void 0:s.createPolicy("TrustedFunctionWorkaround",{createScript:(E,...g)=>{g.forEach(r=>{var d;if(!((d=self.trustedTypes)===null||d===void 0?void 0:d.isScript(r)))throw new Error("TrustedScripts only, please")});const a=g.slice(0,-1).join(","),o=g.pop().toString();return`(function anonymous(${a}) {
${o}
})`}});function h(...E){return v?self.eval(v.createScript("",...E)):new Function(...E)}i.create=h})(n||(n={}));class R extends A.RequireInterceptor{_installInterceptor(){}getModule(s,v){for(let h of this._alternatives){let E=h(s);if(E){s=E;break}}if(this._factories.has(s))return this._factories.get(s).load(s,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class C extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const s=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);f(s,this._initData.environment.isExtensionDevelopmentDebug);const v=this._instaService.invokeFunction(w.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(R,v,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(s){return s.browser}async _loadCommonJSModule(s,v,h){var E,g,a,o,t,r,d,l;v=v.with({path:b(v.path,".js")}),s&&performance.mark(`code/extHost/willFetchExtensionCode/${s.value}`);const u=await fetch(v.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s.value}`),u.status!==200)throw new Error(u.statusText);const m=await u.text(),_=`${v.toString(!0)}#vscode-extension`,D=`${m}
//# sourceURL=${_}`;let c;try{c=n.create((g=(E=C._ttpExtensionScripts)===null||E===void 0?void 0:E.createScript("module"))!==null&&g!==void 0?g:"module",(o=(a=C._ttpExtensionScripts)===null||a===void 0?void 0:a.createScript("exports"))!==null&&o!==void 0?o:"exports",(r=(t=C._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&r!==void 0?r:"require",(l=(d=C._ttpExtensionScripts)===null||d===void 0?void 0:d.createScript(D))!==null&&l!==void 0?l:D)}catch(z){throw s?console.error(`Loading code for extension ${s.value} failed: ${z.message}`):console.error(`Loading code failed: ${z.message}`),console.error(`${v.toString(!0)}${typeof z.line=="number"?` line ${z.line}`:""}${typeof z.column=="number"?` column ${z.column}`:""}`),console.error(z),z}const p={},P={exports:p},F=z=>{const de=this._fakeModules.getModule(z,v);if(de===void 0)throw new Error(`Cannot load module '${z}'`);return de};try{return h.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s.value}`),c(P,p,F),P.exports!==p?P.exports:p}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s.value}`),h.codeLoadingStop()}}async $setRemoteEnvironment(s){throw new Error("Not supported")}async _waitForDebuggerAttachment(s=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const v=Date.now()+s;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,S.timeout)(10)}}}e.ExtHostExtensionService=C,C._ttpExtensionScripts=(y=self.trustedTypes)===null||y===void 0?void 0:y.createPolicy("ExtensionScripts",{createScript:i=>i});function b(i,s){return i.endsWith(s)?i:i+s}function f(i,s){v("info","log"),v("log","log"),v("warn","warn"),v("error","error");function v(g,a){const o=console[g];console[g]=function(){i.$logExtensionHostMessage({type:"__$console",severity:a,arguments:E(arguments)}),s&&o.apply(console,arguments)}}const h=1e5;function E(g){const a=[],o=[];if(g.length)for(let t=0;t<g.length;t++){if(typeof g[t]=="undefined")g[t]="undefined";else if(g[t]instanceof Error){const r=g[t];r.stack?g[t]=r.stack:g[t]=r.toString()}o.push(g[t])}try{const t=JSON.stringify(o,function(r,d){if(d&&typeof d=="object"){if(a.indexOf(d)!==-1)return"[Circular]";a.push(d)}return d});return t.length>h?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(be[226],we([0,1,61,19,36,225,211]),function(ie,e,w,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(A.IExtHostExtensionService,T.ExtHostExtensionService),(0,w.registerSingleton)(k.ILogService,S.ExtHostLogService)}),define(be[228],we([0,1,24,3,183,220,213,11,77,224,226]),function(ie,e,w,k,A,T,S,I,y){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0});const R=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const C=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const v=(n=self.trustedTypes)===null||n===void 0?void 0:n.createPolicy("extensionHostWorker",{createScriptURL:E=>E}),h=self.Worker;Worker=function(E,g){const a=`importScripts('${E}');`;g=g||{},g.name=g.name||I.basename(E.toString());const o=new Blob([a],{type:"application/javascript"}),t=URL.createObjectURL(o);return new h(v?v.createScriptURL(t):t,g)}}else self.Worker=class extends S.NestedWorker{constructor(v,h){super(C,v,Object.assign({name:I.basename(v.toString())},h))}};const b=new class{exit(v){R()}async exists(v){return!0}async realpath(v){return v}};class f{constructor(){const h=new MessageChannel,E=new k.Emitter;let g=!1;C(h.port2,[h.port2]),h.port1.onmessage=a=>{const{data:o}=a;if(!(o instanceof ArrayBuffer)){console.warn("UNKNOWN data received",o);return}const t=w.VSBuffer.wrap(new Uint8Array(o,0,o.byteLength));if((0,A.isMessageOfType)(t,2)){g=!0,s("received terminate message from renderer");return}E.fire(t)},this.protocol={onMessage:E.event,send:a=>{if(!g){const o=a.buffer.buffer.slice(a.buffer.byteOffset,a.buffer.byteOffset+a.buffer.byteLength);h.port1.postMessage(o,[o])}}}}}function i(v){return new Promise(h=>{const E=v.onMessage(g=>{E.dispose();const a=JSON.parse(g.toString());v.send((0,A.createMessageOfType)(0)),h({protocol:v,initData:a})});v.send((0,A.createMessageOfType)(1))})}let s=v=>R();(function(){const h=new f;y.mark("code/extHost/willConnectToRenderer"),i(h.protocol).then(E=>{y.mark("code/extHost/didWaitForInitData");const g=new T.ExtensionHostMain(E.protocol,E.initData,b,null);s=a=>g.terminate(a)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/58186680eb97fe979e1d986bcfa983ab0a6228e4/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
